/* 
 * Created by veer.singh 17th Jan15

 * Modified by r.k.pandey 31th Jan15
 * Dependent Files : template.js
 */
/* -------FRAME INFO OBJECT---------*/
'use strict';
var frameInfo=function(x, y, w, h, bMain){
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.id="";
    this.xOffset = 0;
    this.yOffset = 0;
    this.scale = 1;
    this.element = [];    
    this.activeEleIndex = 0;
    this.controlPoints = [];
    this.ctrlPtCount = 0;
    this.table = null;
    this.active=false;
    this.transitionEffect="None";
    this.bSlideshow=false;
    this.isEditable=true;
    this.rotation=0;
    this.duration=5;
    this.common = {
        scaleFactor:0,
        prevPt:null,
        hammerObj:null,
    };
};
/*-------TABLE INFO OBJECT--------*/
var tableInfo=function(x,y,w,h){
    this.headerElement=null;
    this.headerMargin = 0;
    this.col = [];
    this.initRowCount = 0;
    this.separator = null;
    this.separatorCP = null;
    this.minWidth = 0;
    this.minHeight = 0;
    this.x=x;
    this.y=y;
    this.h=h;
    this.w=w;
    this.pSeparator=[];
};
/* -------ELEMENT INFO OBJECT---------*/
var elementInfo=function(w, h, imgSrc, type){
    this.orgW = w;
    this.orgH = h;
    this.scale = 1;
    this.slotType=0;
    this.smallSizeImg=imgSrc;
    this.imageSrc = "";
    this.thumbPath="";    
    this.OriginalPath = "";
    this.elementType = type;
    this.fileName="";
    this.thumbSepImg="";
    this.assetsPath="";
    this.timeStamp=getTimeWithMiliSec();
    this.x = 0;
    this.y = 0;
    this.w = 0;
    this.h = 0;
    this.minW=0;
    this.minH=0;
    this.xOffset = 0;
    this.yOffset = 0;
    this.rotation = 0;
    this.opacity=100;
    this.margin={t:0,r:0,b:0,l:0};
    this.initXOffset = 0;
    this.initYOffset = 0;
    this.textElms=[];
    this.elmLyrArr=[];
    this.actvTxtElmIndx=0;    
    this.duration=0;     
};

/* -------ELEMENT INFO OBJECT---------*/
var textInfo=function(x,y,w,h){   
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.minW=0;
    this.minH=0;
    this.text="";
    this.textImageSrc = "";
    this.textImageName = "";
    this.textHTML = "";
    this.elmType=0;
    this.fontSize=40;
    this.fontColor="rgb(0,0,0)";
    this.bgColor="rgb(0,0,0)";
    this.bgAlpha=0;
    this.alpha=100;
    this.fontFamily="NotoSans-Regular";
    this.hAlign="center";
    this.vAlign="middle";
    this.fontItalic=false;  
    this.fontBold = false;
    this.fontUnderLine = false;
    this.bTextSlide = false;
    this.slideType = 2;
    this.slideSpeed = 10;
    this.bMenuOrPrice=false;
   
};
/* -------FRAME CONTROL POINT OBJECT---------*/
var controlPoint=function(x, y, direction, side){
    this.x = x;
    this.y = y;
    this.direction = direction;
    this.side = side;
};
/*---------MAIN FRAME DIVIDING LINES ---------*/
var gridLine=function(pt1, pt2, type){
    this.pt1 = pt1;
    this.pt2 = pt2;
    this.affectedFrameIds = [];
    this.type = type;
};

var gridLineRange=function(xRange, yRange){
    this.xRange = xRange;
    this.yRange = yRange;
};
/*----------TABLE SEPARATOR LINE OBJECT-------*/
var tableSeparator=function(x,y,w,h){
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.controlPoint = null;
};

var cropInfo=function(frameId, xOffset, yOffset, scale, rotation){
    this.id = frameId;
    this.xOffset = xOffset;
    this.yOffset = yOffset;
    this.scale = scale;
    this.rotation = rotation;
};

cropInfo.prototype.setCropInfo=function(frameId, xOffset, yOffset, scale, rotation){
    this.id = frameId;
    this.xOffset = xOffset;
    this.yOffset = yOffset;
    this.scale = scale;
    this.rotation = rotation;
};

cropInfo.prototype.clearCropInfo=function(){
    this.id = "";
    this.xOffset = 0;
    this.yOffset = 0;
    this.scale = 1;
    this.rotation = 0;
};
var stickerCopyInfo=function(direction, x, y){
    this.direction = direction;
    this.x = x;
    this.y = y;
};

stickerCopyInfo.prototype.setStickerCopyInfo=function(direction, x, y){
    this.direction = direction;
    this.x = x;
    this.y = y;
};

stickerCopyInfo.prototype.clearStickerCopyInfo=function(){
    this.direction = TStickerCopyDir.NONE;
    this.x = 0;
    this.y = 0;
};

frameInfo.prototype.setElement = function(element){
    this.element.push(element);
};

frameInfo.prototype.getActiveElement = function(){
    if(this.activeEleIndex!=DEFAULT_VALUE)
    {
    	return this.element[this.activeEleIndex];
    }
    else
    {
    	return null;
    }
};

frameInfo.prototype.addControlPoint = function(id, cp){
    this.controlPoints.push(cp);
    this.ctrlPtCount++;
    console.log("control pt :: "+cp.x+" "+cp.y+" "+cp.direction+" "+cp.side);
};

frameInfo.prototype.getCntlPtForSide = function(side){
    var cp = null;
    for(var count =0; count<this.ctrlPtCount;count++){
        cp = this.controlPoints[count];
        if(cp.side == side){
            break;
        }
    }
    return cp;
};

function getMergedLine(pt1, pt2, line){
    if((pt1.x == line.pt2.x) && (pt1.y == line.pt2.y)){
        return {pt1:line.pt1,pt2:pt2};
    }else if((pt2.x == line.pt1.x) && (pt2.y == line.pt1.y)){
        return {pt1:pt1,pt2:line.pt2};
    }else{
        return line;
    }
}

function isPointsOnLine(pt1, pt2, line, type){
    if((pt1.x == line.pt1.x) && (pt2.x == line.pt2.x)  && (((pt1.y>= line.pt1.y) && (pt1.y<= line.pt2.y)) || ((pt2.y>= line.pt1.y) && (pt2.y<= line.pt2.y))) && (type == VERTICAL)){
        return true;/*vertical line*/
    }else if((pt1.y == line.pt1.y) && (pt2.y == line.pt2.y) && (((pt1.x>= line.pt1.x) && (pt1.x<= line.pt2.x)) || ((pt2.x>= line.pt1.x) && (pt2.x<= line.pt2.x))) && (type == HORIZONTAL)){
        return true;/*Horizontal line*/
    }else{
        return false;
    }
}

function isPointOnLine(pt, line){
    if((pt.x == line.pt1.x) && (pt.y>line.pt1.y) && (pt.y<line.pt2.y)){
        return true;/*vertical line*/
    }else if((pt.y == line.pt1.y) && (pt.x>line.pt1.x) && (pt.x<line.pt2.x)){
        return true;/*Horizontal line*/
    }else{
        return false;
    }
}

function isPointApproxOnLine(pt, line){
    if((Math.round(pt.x) == Math.round(line.pt1.x)) && (Math.round(pt.y)>Math.round(line.pt1.y)) && (Math.round(pt.y)<Math.round(line.pt2.y))){
        return true;/*vertical line*/
    }else if((Math.round(pt.y) == Math.round(line.pt1.y)) && (Math.round(pt.x)>Math.round(line.pt1.x)) && (Math.round(pt.x)<Math.round(line.pt2.x))){
        return true;/*Horizontal line*/
    }else{
        return false;
    }
}

function isLinesOverlap(line1, line2, type){
    if((((line1.pt1.y == line2.pt1.y) && (line1.pt2.y == line2.pt2.y)) ||
        ((line1.pt1.y<=line2.pt1.y) && (line1.pt2.y > line2.pt1.y)) ||
        ((line1.pt1.y>=line2.pt1.y) && (line1.pt1.y < line2.pt2.y)) ||
        ((line1.pt1.y>line2.pt1.y) && (line1.pt1.y < line2.pt2.y) && (line1.pt2.y>line2.pt1.y) && (line1.pt2.y < line2.pt2.y)) ||
        ((line1.pt1.y<line2.pt1.y) && (line1.pt1.y < line2.pt2.y) && (line1.pt2.y>line2.pt1.y) && (line1.pt2.y > line2.pt2.y))
        ) && (type == VERTICAL)){
        return true;/*vertical line*/
    }else if((((line1.pt1.x == line2.pt1.x) && (line1.pt2.x == line2.pt2.x)) ||
              ((line1.pt1.x<=line2.pt1.x) && (line1.pt2.x > line2.pt1.x)) ||
              ((line1.pt1.x>=line2.pt1.x) && (line1.pt1.x < line2.pt2.x)) ||
              ((line1.pt1.x>line2.pt1.x) && (line1.pt1.x < line2.pt2.x) && (line1.pt2.x>line2.pt1.x) && (line1.pt2.x < line2.pt2.x)) ||
              ((line1.pt1.x<line2.pt1.x) && (line1.pt1.x < line2.pt2.x) && (line1.pt2.x>line2.pt1.x) && (line1.pt2.x > line2.pt2.x))
              ) && (type == HORIZONTAL)){
        return true;/*Horizontal line*/
    }else{
        return false;
    }
}

function isRectIntersect(a, b){
    return (a.x <= (b.x + b.w) &&
            b.x <= (a.x + a.w) &&
            a.y <= (b.y + b.h) &&
            b.y <= (a.y + a.h));
}

function isRectIntersectExceptBoundary(a, b){
    return (a.x < (b.x + b.w) &&
            b.x < (a.x + a.w) &&
            a.y < (b.y + b.h) &&
            b.y < (a.y + a.h));
}

function isPointsOnRect(pt1, pt2, rect, side){
    if(side == LEFT_SIDE){
        if((pt1.x == rect.x) && (pt2.x == rect.x)){
            return true;
        }
    }else if(side == TOP_SIDE){
        if((pt1.y == rect.y) && (pt2.y == rect.y)){
            return true;
        }
    }else if(side == BOTTOM_SIDE){
        if((pt1.y == (rect.y+rect.h)) && (pt2.y == (rect.y+rect.h))){
            return true;
        }
    }else if(side == RIGHT_SIDE){
        if((pt1.x == (rect.x+rect.w)) && (pt2.x == (rect.x+rect.w))){
            return true;
        }
    }else{
        console.log("ERROR:: SIDE PARAMETER INCORRECT!!");
    }
    
    return false;
}

function isRelPointsOnRect(pt1, pt2, rect, side){
    var x1 = pt1.x + rect.x;
    var x2 = pt2.x + rect.x;
    var y1 = pt1.y + rect.y;
    var y2 = pt2.y + rect.y;
    if(side == LEFT_SIDE){
        if((x1 == rect.x) && (x2 == rect.x)){
            return true;
        }
    }else if(side == TOP_SIDE){
        if((y1 == rect.y) && (y2 == rect.y)){
            return true;
        }
    }else if(side == BOTTOM_SIDE){
        if((y1  == (rect.y+rect.h)) && (y2 == (rect.y+rect.h))){
            return true;
        }
    }else if(side == RIGHT_SIDE){
        if((x1 == (rect.x+rect.w)) && (x2 == (rect.x+rect.w))){
            return true;
        }
    }else{
        console.log("ERROR:: SIDE PARAMETER INCORRECT!!");
    }
    
    return false;
}

function isPointInsideRect(pt, rect){
    return pt.x>=rect.x && pt.x <= (rect.x+rect.w) && pt.y>=rect.y && pt.y <= (rect.y+rect.h);
}

function getCtrlPtForLine(pt1, pt2, side){
    if(pt1.x == pt2.x){
        return new controlPoint(pt1.x, Math.round((pt2.y + pt1.y)/2), DIRECTION_HORIZONTAL, side);
    }else if(pt1.y == pt2.y){
        return new controlPoint(Math.round((pt2.x + pt1.x)/2), pt1.y, DIRECTION_VERTICAL, side);
    }else{
        console.log("ERROR::LINE POINTS NOT ON VERTICAL OR HORIZONTAL STRAIGHT LINE");
    }
}

var pointerEventToXY = function(e){
      var out = {x:0, y:0};
      if(e.type == 'touchstart' || e.type == 'touchmove' || e.type == 'touchend' || e.type == 'touchcancel'){
        var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
        out.x = touch.pageX;
        out.y = touch.pageY;
      } else if (e.type == 'mousedown' || e.type == 'mouseup' || e.type == 'mousemove' || e.type == 'mouseover'|| e.type=='mouseout' || e.type=='mouseenter' || e.type=='mouseleave') {
        out.x = e.pageX;
        out.y = e.pageY;
      }
      return out;
};

function getCoordinatesAfterRotation(rect, angle){
/*This function is not working as per requiremnt Try using getBoundingClientRect()*/
    log.debug("STARTED","getCoordinatesAfterRotation");
    var sinAngle=Math.sin(angle);
    var cosAngle=Math.cos(angle);
    var x1 = Math.round((rect.x * cosAngle) - (rect.y * sinAngle));
    var y1 = Math.round((rect.x * sinAngle) + (rect.y * cosAngle));
    var x2 = Math.round(((rect.x+rect.w)*cosAngle) - ((rect.y + rect.h) * sinAngle));
    var y2 = Math.round(((rect.x+rect.w)*sinAngle) + ((rect.y + rect.h) * cosAngle));
    var x3 = Math.round((rect.x * cosAngle) - ((rect.y + rect.h) * sinAngle));
    var y3 = Math.round((rect.x * sinAngle) + ((rect.y + rect.h) * cosAngle));
    var x4 = Math.round(((rect.x + rect.w)* cosAngle) - (rect.y * sinAngle));
    var y4 = Math.round(((rect.x + rect.w) * sinAngle) + (rect.y * cosAngle));
    var xCordArr = [x1, x2,x3,x4];
    xCordArr.sort(function(a,b){return a-b;});
    var yCordArr = [y1, y2,y3,y4];
    yCordArr.sort(function(a,b){return a-b;});
    log.debug("INPUT RECT = "+rect.x+" rect.y = "+rect.y+" rect.w = "+rect.w+" rect.h = "+rect.h +" angle = "+angle,"getCoordinatesAfterRotation");
    log.debug("Rotated RECT = "+xCordArr[0]+" y1 = "+yCordArr[0]+" x2 = "+xCordArr[3]+" y2 = "+yCordArr[3] ,"getCoordinatesAfterRotation");
    return {x1:xCordArr[0],y1:yCordArr[0],x2:xCordArr[3],y2:yCordArr[3]};
}

function getRotationDegrees(obj) {
    var matrix = obj.css("-webkit-transform") ||
    obj.css("-moz-transform")    ||
    obj.css("-ms-transform")     ||
    obj.css("-o-transform")      ||
    obj.css("transform");
    if(matrix !== 'none') {
        var values = matrix.split('(')[1].split(')')[0].split(',');
        var a = values[0];
        var b = values[1];
        var angle = Math.round(Math.atan2(b, a) * (180/Math.PI));
    } else { var angle = 0; }

    if(angle < 0) angle +=360;
    return angle;
}
function getRGBColorInRGBA(rgbColor,alpha)
{   
    if(typeof(alpha) == "undefined")
    {
        alpha=100;        
    }
    alpha=getParseIntInDec(alpha);
    if(rgbColor.indexOf("#")==-1)
    {
        if(rgbColor.indexOf("rgba(")==-1)
        {
            rgbColor=$.trim(rgbColor.replace("rgb(","").replace(")",""));        
            if(rgbColor!="")
            {
                rgbColor="rgba("+rgbColor+","+opctyToPrsntNvisVrsa(alpha,true)+")";
            }        
            else
            {
                rgbColor="rgba(0,0,0,0)";
            }
        }
    }        
    return rgbColor;
};
function getRgbaClrInRgbnAlpha(rgbaColor)
{     
     var rgbColor=$.trim(rgbaColor.replace("rgba","").replace("(","").replace(")",""));
     log.debug("1rgbColor:" +rgbColor);
     rgbColor=rgbColor.split(",");
     var i=0;
     var len=rgbColor.length;
     for(i=0;i<len;i++)
     {
         rgbColor[i]=getParseIntInDec($.trim(rgbColor[i]));
     }
     var colorObj={};
     colorObj.rgb="rgb("+rgbColor[0]+","+rgbColor[1]+","+rgbColor[2]+")";
     colorObj.alpha=rgbColor[3];
     log.debug("3rgbColor:" +JSON.stringify(colorObj));
     return colorObj;
}
function resetMenuPos()
{
  try
  {
     $.resetMenuPosition();
  }
  catch(ex)
  {
    log.debug("Unable to reset menu!");    
  }  
}
var curAuthorMenuId = "";
function closeAuthorMenu()
{    
    try
    {
        curAuthorMenuId = ""; 
        menuObj.hideEditMenu();        
    }
    catch(ex)
    {
        log.debug("Unable to close menu!");
    }  
}

function showAuthorMenu(id){
    log.debug("For ID: "+id,"showAuthorMenu");
    hideBottomMenu();    
    if(id.indexOf("frameCover-") != -1){
        var frame = templateObj.getInnerFrameForId(id.replace("frameCover-", ""));
        if(frame.table != null){
            log.debug("TABLE FRAME HAS NO MENU", "showAuthorMenu");
            return;
        }
    }
    /*if(curAuthorMenuId == id){
        log.debug("ALREADY OPEN MENU FOR ID = "+id, "showAuthorMenu");
        return;
    }*/
    closeAuthorMenu();
    setTimeout(function(){
        if(id.indexOf("frameCover-") != -1){
            templateObj.showAuthorMenuForFrame(id);
        }else if(id.indexOf("-elm_") != -1){
            templateObj.showAuthorMenuForMnFrmElm(id);
        }else{
            /*No author menu*/
        }
        curAuthorMenuId = id;
    },80);
}
var getAuthorMenuBoundingRect=function(){
    var x = 0;
    var y = 0;
    var w = 0;
    var h = 0;
    if(templateObj.bListViewVisible){
        x = screenWidth * (0.0875 + 0.248);
    }else{
        x = screenWidth * 0.0875;
    }
    w = screenWidth - x;
    y = screenHeight * 0.0925;
    h = screenHeight * 0.74;
    return {x:x,y:y,w:w,h:h};
};

var getCurrentStageScale=function(){
    return templateObj.mainFrame.scale;
};

function updateTime(val) {
    var currentTimeVal=val;
    templateObj.isEdited=true;
    $("#durTxtSecId").text(currentTimeVal);
    templateObj.getActiveFrame().duration=currentTimeVal;
}

function getMnFrmElmDvId(elmID)
{
    return elmID.replace("ElmCover-","");
}
function opctyToPrsntNvisVrsa(iVal,flag)
{
    if(flag)
    {
        return getParseIntInDec(iVal)/100;
    }
    else
    {
        return parseFloat(iVal)*100;
    }
}
function getSlidSpdFrMarq(iVal)
{
    var spd=10;
    switch(iVal.toLowerCase())
    {
        case "fast":
            spd=200;
        break;
        case "slow":
            spd=10;
        break;
        case "normal":
            spd=100;
        break;
        default:
        break;
    }
    return spd;
}
function getSlidTypFrMarq(iVal)
{
    var type="none";
    switch(getParseIntInDec(iVal))
    {
        case 1:
            type="right";
        break;
        case 2:
            type="left";
        break;
        case 3:
            type="down";
        break;
        case 4:
            type="up";
        break;
        default:
            type="none";
        break;        
    }
    return type;
}