﻿'use strict';
var fontListArr = [];
var isTmpltDownloaded = Utils.isTemplateDownloaded();
var goToHomeFlag = false;
var goToStep1Flag = false;
var prevClickObj = null;
var templatePath;
var updateTemplateName = null;
var isBgGalleryOpen=false;
var saveAsFlag = false;
var drop = $('#tplGalleyDropArea');
var currModel = 0;
var LIVE_TV_PORTRAIT_IMG=2;
var ipSrcFlag=false;
var templateObj=null;
var systemRootPath = "";
var TAPHOLD = false;
var tapholdTimeout = null;
var box, cloneWidth, cloneHeight;
var mouse_init_x = 0;
var mouse_init_y = 0;
var mouse_move_x = 0;
var mouse_move_y = 0;

$(document).ready(function() {    
    $(document).keydown("div[contenteditable=true]", function(e) {
        /*trap the return key being pressed*/
        if (e.keyCode == 13) {
            /* insert 2 br tags (if only one br tag is inserted the cursor won't go to the second line)*/
            document.execCommand('insertHTML', false, '<br>&nbsp;');           
            /*prevent the default behaviour of return key pressed*/
            return false;            
        }
    });   
});
/*-------Ready Closed---------*/
function handleDragEvent(elem, elemType){	
	 $(document).off('touchstart',"."+elem).on('touchstart', '.'+elem, function(event) {
	 	 var widgetId = $(this).attr("widget-id");
	 	 var localElemType = widgetId!=undefined ? widgetId : elemType;
         event.stopPropagation();
         clearTimeout(tapholdTimeout);
         tapholdTimeout = null;
         if($('.clonedCls').length == 0){
        	leftElementDragStart(event, $(this), localElemType); 	
         }
    }).off('touchmove',"."+elem).on('touchmove', '.'+elem, function(e) {
        if(TAPHOLD)
        {
            e.stopPropagation();
            e.preventDefault();
        }
       	var widgetId = $(this).attr("widget-id");
	 	var localElemType = widgetId!=undefined ? widgetId : elemType;
        leftElementDragMove(e, $(this), localElemType);
    }).off('touchend',"."+elem).on('touchend', '.'+elem, function(e) {
        leftElementDragEnd(e, $(this));
    });
}
function leftElementDragStart(event, currElem, elemType) {
    $('.clonedCls').remove();
    var mouse_x = pointerEventToXY(event).x;
    var mouse_y = pointerEventToXY(event).y;
    mouse_init_x = mouse_x;
    mouse_init_y = mouse_y;    
    tapholdTimeout = setTimeout(function(e){
                TAPHOLD = true;
                hideBottomMenu();                
                createDraggableClone(currElem, mouse_x, mouse_y, elemType);
            }, TAPHOLDTIME);       
}
function leftElementDragMove(event, currElem, elemType) {
        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
         if(TAPHOLD)
        {
             event.preventDefault();
            mouse_move_x = pointerEventToXY(event).x;
            mouse_move_y = pointerEventToXY(event).y;
            var absX = Math.abs(mouse_move_x - mouse_init_x);
            var absY = Math.abs(mouse_move_y - mouse_init_y);     
            $('#draggableClone').css({
                'top' : (mouse_move_y - (cloneHeight / 2)) + 'px',
                'left' : (mouse_move_x - (cloneWidth / 2)) + 'px'
            });           
        } 
}
function leftElementDragEnd(event, currElem) {
    
    if (tapholdTimeout != null) {
        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
    }
    var type = $('#draggableClone').attr('clone-type');
    if (TAPHOLD) {
        event.stopPropagation();
        event.preventDefault();
        if (templateObj != null) {
            var top = getParseIntInDec($('#draggableClone').css("top"));
            var left = getParseIntInDec($('#draggableClone').css("left"));            
            templateObj.addElmToTemplate(currElem, top, left, type);
        }
        else
        {
            revertDragElementPos();
        }
    }
    $('#draggableClone').remove();
    TAPHOLD = false;
}
function createDraggableClone(currElem, mouse_x, mouse_y, elemType, elTop, elLeft)
{
    if(elTop==undefined)
    {
        elTop = (cloneHeight / 2);
    }
    if(elLeft==undefined)
    {
        elLeft = (cloneWidth / 2);
    }
    if(elemType==undefined)
    {
        elemType = "";
    }
    if($('#draggableClone').length==0)
    {
        var angle = 0;
        if(elemType!="text")
        {
            angle = '-15deg';
        }
        var clone = currElem.clone();
        cloneWidth = (elemType==TEXT?currElem.width()/2:currElem.width());
        cloneHeight = currElem.height();
        var bgcolor = currElem.css('background-color');
        if (elemType == STICKER) {
            bgcolor = '';
        }              
        clone.css({
            "width" : cloneWidth + 'px',
            "height" : cloneHeight + 'px',
            "z-index" : "999999999",
            "-webkit-transform" : "rotate("+angle+")",
            'top' : (mouse_y - elTop) + 'px',
            'left' : (mouse_x - elLeft) + 'px',
            'position' : 'absolute',
            'margin':'0',
            'background-color' : bgcolor
        }).attr('id', 'draggableClone').attr('clone-type', elemType).attr('org-id', currElem.attr('id'));
        clone.addClass('clonedCls');        
           if(elemType==TEXT)
           {
               clone.css({'border-color':'#3196ff'});
           }
        clone.appendTo('body');
        box = '#draggableClone';       
    }
}
function revertDragElementPos()
{
    /*Revert the clone place to its initial position as the clone has been dropped to wrong position*/
    $('#draggableClone').animate({left:(mouse_init_x-50), top:(mouse_init_y-50)}, 500, function(){
        $('#draggableClone').remove();
    });
}