/**
 * @filename Constants.js
 * @date 31 JAN 2015 </br> </br>
 *  modified rishu.yadav 31 jan 2015 for protocol integartion
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */

var Constants = {

};

Constants.init = function() {

};

// NETWORK EXCUTION CALL TYPE
var CONNECTION_TYPE_ON_OFF_TIMER_UPDATE = 1001;
var CONNECTION_TYPE_SCHEDULE_UPLOAD = 1002;
var CONNECTION_TYPE_FIRMWARE_UPGRADE = 1003;
var CONNECTION_TYPE_RSITE_DOWNLOAD = 1004;

// PROTOCOL ERROR CODES
var DISK_SPACE_ERROR = "0X6001";
var TIME_STAMP_ERROR = "0X6002";
var CHECK_SUM_ERROR = "0X6003";
var FIRMWARE_VERSION_MISMATCH = "0X6004";
var DEVICE_ALREADY_CONNECTED = "0X6005";
var BAD_REQUEST = "0X6006";
var UNKNOWN_ERROR = "0X6007";
var UNSUPPORTED_FILE_FORMATE = "0X6008";
var USB_NOT_CONNECTED = "0X6009";
var FILE_UPLOAD_ERROR = "0X6010";
var WRONG_PLAY_PATH = "0X6011";
var CLOCK_SET_FAIL = "0X6012";
var TIMER_SET_FAIL = "0X6013";
var HOLIDAY_SET_FAIL = "0X6014";

var INTERNAL_MEMORY_FULL = "0x6015";
var USB_MEMORY_FULL = "0x6016";
var SDCARD_MEMORY_FULL = "0x6017";
var WRONG_PIN_CODE = "0X6023";
var DEVICE_BLOCKED = "0X6024";




// CUSTOM ERROR CODES
var NO_CONTENT_FOUND = "0X6021";
var DOWNLOAD_LOCATION_CHANGE = "0X6023";
var NO_SPACE_AVAILABLE_ON_MOBILE = "0X6024";
var USB_REMOVED_FROM_DEVICE = "0X6025";

// WIFI
var WIFI_ENABLED = 1;
var WIFI_DISABLED = 0;
var SCHEDULE_CONTENT = 1;
var NETWORK_TYPE_WIFI_NORMAL = '0';
var NETWORK_TYPE_WIFI_DIRECT = '1';
var RMD_DEVICE = '0X01';
var D_SERIES_DEVICE = '0X03';
var RHE_DEVICE = '0X04';
var TIZEN_DEVICE = '0X05';
var STRETCH_DEVICE = '0x05';
var TIZEN_S5_DEVICE = '0x06';
var TIZEN_S6_DEVICE = '0X07';


// NATIVE PLUGIN NAME
var NETWORK_MANAGER_PLUGIN = "NetworkManagerPlugin";
var UTILITY_MANAGER_PLUGIN = "UtilityManagerPlugin";
var TAOST_MANAGER_PLUGIN = "ToastPlugin";
var AD_CLIP_MANAGER_PLUGIN = "ADClipPlugin";

//NETWORK PLUGINS INVOKE COMMAND
var START_DISCOVERY_SERVICE = "7001";
var STOP_DISCOVERY_SERVICE = "7002";
var MANUAL_DEVICE_CONNECTION = "7003";
var STOP_CONNECTION_SERVICE = "7004";
var START_SCHEDULE_UPLOADING = "7005";
var CANCEL_EXCUTING_TASK = "7006";
var GET_DEVICE_FIRMWARE_INFO = "7007";
var START_FIRMWARE_DOWNLOAD = "7008";
var START_FIRMWARE_UPLOAD = "7009";
var SET_ON_OFF_TIMER_INFO = "7010";
var GET_SERVER_FIRM_VERSION = "7011";
var OPEN_WIFI_SETTINGS = "7012";
var CANCEL_FIRM_UPGRADE_TASK = "7013";
var WIFI_STATE_CHANGE_RECEIVER = "7014";
var REGISTER_KEYBOARD_OBSERVER = "7015";
var VERIFY_MANUAL_ENTERED_IP = "7016";
var RSITE_DOWNLOAD_DESIGN_ELEM = "7017";
var RSITE_DELETE_DESIGN_ELEM = "7018";
var REGISTER_SHOW_TOAST_MSG = "7019";
var REGISTER_PLAYER_TYPE = "7020";
var CHECK_FOR_UPDATE = "7021";
var ACTIVITY_STATUS = "7022";
var DO_POST_REQUEST = "7023";
var APP_RES_LIST_ITEMS = "7025";
var FILE_OR_DIR_EXIST = "7024";
var DEVICE_MANUFACTURER = "7026";
var HIDE_KEYBOARD_FORCE = "7027";
var VERIFY_TLS_PIN_INFO = "7028";
var TLS_HANDSHAKING = "7029";

// ADCLIP INVOKE CAMMAND FROM JS TO NATIVE
var ADCLIP_START_SUMMARIZER = "7031";
var ADCLIP_CANCEL_SUMMARIZER = "7032";
var ADCLIP_INTERFACE_TEST = "7033";
var ADCLIP_ADD_VIDEO_CAMERA = "7034";
var ADCLIP_GET_THEME_LIMIT_INFO = "7035";
var ADCLIP_GET_ESTIMATED_TIME_SEC = "7036";
var ADCLIP_START = "7037";
var ADCLIP_GET_PROGRESS_VALUE = "7038";
var ADCLIP_GET_THEME_CONTEXT = "7039";
var ADCLIP_UPDATE_SLOT = "7040";
var ADCLIP_GET_REPLACED_SLOT = "7041";
var ADCLIP_CREATE = "7042";
var ADCLIP_CANCEL_ENCODING = "7043";
var ADCLIP_GET_FIRST_SLOT_IMAGE = "7044";
var ADCLIP_SAVE = "7045";
var ADCLIP_CREATE_TEXT_IMAGE = "7046";
var ADCLIP_PLAY = "7047";
var ADCLIP_STEP_INFO = "7048";
var ADCLIP_IMAGE_CROP = "7049";

// CONNECTION & DICOVERY RESPONSE CODE NATIVE TO JS
var NO_DEVICE_FOUND = "8001";
var DEVICE_CONNECTION_SUCCESS = "8002";
var DEVICE_CONNECTION_FAIL = "8003";
var CONNECTED_WITH_OTHERS = "8004";
var DEVICE_DISCONNECTION_SUCCESS = "8005";
var UPLOAD_FILES_SUCCESS = "8006";
var UPLOAD_FILES_FAIL = "8007";
var UPLOAD_FILES_PROGRESS = "8008";
var ON_OFF_TIMER_UPDATE_SUCCESS = "8009";
var ON_OFF_TIMER_UPDATE_FAIL = "8010";
var FIRMWARE_DOWNLOAD_SUCCESS = "8011";
var FIRMWARE_DOWNLOAD_FAIL = "8012";
var FIRMWARE_UPDATE_NOT_FOUND = "8013";
var NO_NEW_FIRMWARE_UPDATE_AVAILABLE = "8014";
var GET_FIRMWARE_INFO_FAIL = "8015";
var NEW_FIRMWARE_UPDATE_FOUND = "8016";
var FIRMWARE_ALREADY_DOWNLOADED = "8017";
var CANCLE_EXECUTING_TASK_SUCCESS = "8018";
var RSITE_DOWNLOAD_SUCCESS = "8019";
var RSITE_DOWNLOAD_FAIL = "8020";
var DOWNLOAD_UNZIP_SUCCESS = "8021";
var DOWNLOAD_UNZIP_FAIL = "8022";
var INCONSISTENT_UPLOAD_INFO = "8023";
var MEMORY_LOW_IN_MOBILE_CLIENT = "8024";
var HTTP_REQUEST_SUCCESS = "8025";
var HTTP_REQUEST_FAIL = "8026";
var WI_FI_TURNED_OFF = "8027";
var DEVICE_STATUS_BLOCKED = "8028";
var HANDSHAKE_SUCCESS = "8029";
var HANDSHAKE_FAIL = "8030";


// ADCLIP RESPONSE CODE FROM NATIVE TO JS
var ADCLIP_SUMMARIZERING_SUCCESS = "8031";
var ADCLIP_SUMMARIZERING_FAILED = "8032";

// TEMPLATE CATEGORY
var Category = {
	CUSTOM : "C",
	MENUBOARD : "M",
	MENUBOARD_T : "MT",
	LIVETV : "L",
	INFORMATION : "I",
	INFORMATION_T : "IT",
	PROMOTION : "P",
	SLIDESHOW : "S"
};
var digiClokType={
    HM12_AMPM:0,
    HM12_AMPM_DOW:1,
    HM24:2,
    HM24_DOW:3,
    HMS24_DOW:4,
    YR_MNTH_DAY_HYFN:5,
    MNTH_DAY_YR_HYFN:6,    
    DAY_MNTH_YR_HYFN:7,
    YR_MNTH_DAY_BKSLSH:8,
    MNTH_Day_YR_BKSLSH:9,    
    DAY_MNTH_YR_BKSLSH:10,
    MNTH_DAY_BKSLSH:11
};
var weatherDateType = {
	HM12_AMPM : 0,
	HM24 : 1,
	HM24_DOW : 2,
	YR_MNTH_DAY_HYFN : 3,
	MNTH_DAY_YR_HYFN : 4,
	DAY_MNTH_YR_HYFN : 5,
	YR_MNTH_DAY_BKSLSH : 6,
	MNTH_Day_YR_BKSLSH : 7,
	DAY_MNTH_YR_BKSLSH : 8,
	MNTH_DAY_BKSLSH : 9
};
var unitType={
    CELSIUS:0,
    FARHENEIT:1
};

var WEATHER_DEFAULT_CITY = "Abilene";
var WEATHER_DEFAULT_COUNTRY = "United States";
var WEATHER_DEFAULT_CITY_ID = 331108;
var WEATHER_REAL_FEEL_STR = "RealFeel";
var LANDSCAPE = 1000;
var PORTRAIT = 9999;
var themes={
    MODERN:0,
    SPORTY:1,
    VIVID:2    
};
var REGION_OTHERS = "Others";
var REGION_US = "United States";
var REGION_CANADA = "Canada";
var REGION_MEXICO = "Mexico";
var REGION_KOREA = "Korea";

// Save Template
var SAVE_TEMPLATE = "SAVE_TEMPLATE";
var SAVE_AND_SCHEDULE_TEMPLATE = "SAVE_AND_SCHEDULE_TEMPLATE";
var UPLOAD_TEMPLATE = "UPLOAD_TEMPLATE";
var TEMPLATE_DEFAULT_DURATION = 600;
//10 mins

var EXITFLAG_ADD_NEW_TEMPLATE_CLICK = "EXITFLAG_ADD_NEW_TEMPLATE_CLICK";
var EXITFLAG_HOME_CLICK = "EXITFLAG_HOME_CLICK";
var EXITFLAG_PREV_CLICK = "EXITFLAG_PREV_CLICK";
var EXITFLAG_CUSTOM_TEMP_CLICK = "EXITFLAG_CUSTOM_TEMP_CLICK";
var EXITFLAG_WEATHER = "EXITFLAG_WEATHER";
var WEATHER_IMG_URL = "http://displaysolutions.samsung.com/static/resources/smartSignage/weather_Image.zip"; 
var WEATHER_IMG_PATH = ".ETabletAuthor/WeatherImage";
//var KEY_IS_SAMSUNG_DEVICE = "isSamsungDevice";


// Gallery from step

var GALLERY_STEP1 = 1;
var GALLERY_STEP2 = 2;
var GALLERY_STEP_BG = 3;

// current progress status
var INITIALIZE = 1;
var CONNECTED = 2;
var DISCONNTED = 3;
var PROGRESS = 4;
var DONE = 5;
var FAIL = 6;
var CANCEL = 7;

//WIFI State
var WIFI_DISABLED = 0;
var WIFI_ENABLED = 1;

// Storage Type
var INTERNAL = 0X01;
var USB = 0X02;
var SDCARD = 0X03;

var USB_CONN_RES_CODE = 'USB';
var INTERNAL_CONN_RES_CODE = 'INTERNAL';
var SDCARD_CONN_RES_CODE = 'SDCARD';

var RHE_MODEL_CODE_US = 'T-GSRHEAKUC';
var RHE_MODEL_CODE_EU = 'T-GSRHEDEUC';
var RHE_PRODUCT_CODE = '010FER';
var TIZEN_S4_MODEL_CODE = 'T-HKMLAKUC';
var TIZEN_S4_PRODUCT_CODE = '010FFP';
var TIZEN_S5_MODEL_CODE = 'T-KTMLAKUC';
var TIZEN_S5_PRODUCT_CODE = '010FHQ';
var TIZEN_S6_MODEL_CODE = 'T-KTM2ELAKUC';

// R-Site Base URL
var R_SITE_BASE_URL = "http://displaysolutions.samsung.com/static/resources/smartSignage/";
var FREE_TEMPLT_ZIP_NAME = "SMART_Signage_TV_Template_2.zip";

// v2.5
var R_SITE_BASE_URL_2 = "https://www.samsungsmartsignagetv.com/me2/";
var WEATHER_IMAGE_ZIP_NAME = 'weather_Image.zip';
var KOREAN_FONT_URL = "font_Korean.zip";
var CHINESE_FONT_URL = "font_SCN.zip";
var KOREAN_FONT_PATH = ".ETabletAuthor/Fonts/Downloads/korean";
var CHINESE_FONT_PATH = ".ETabletAuthor/Fonts/Downloads/chinese";


// PLAYER TYPE
var RMD_MODEL = 1;
var RHE_MODEL = 2;
var STRETCH_MODEL = 3;
var TIZEN_MODEL = 4;
var TIZEN_S5 = 5;
var TIZEN_S6 = 6;

var EXT_TIZEN_S6 = "_S6";
var EXT_TIZEN_S5 = "_S5";
var EXT_TIZEN = "_S4";
var EXT_STRETCH = "_S3";
var EXT_RHE = "_S3";
var EXT_RMD = "_E";

// App android package Name
var APP_ANDROID_PACKAGE_NAME = 'com.samsung.etablet.contentcreator';
// iOS bundle id.
var APP_iOS_PACKAGE_NAME = 'com.samsung.TExpress2';
// To update from older to higher version
var UPGRADE_REQUIRED_CHK = 1000.8;

// Manual connection STATE
var STATE_INIT = 1;
var STATE_SUPPORTED = 2;
var STATE_UNSUPPORTED = 3;
var STATE_UPDATE_REQ = 4;
var STATE_FAIL_CONNECTION = 5;
var STATE_REFRESHING = 6;

var WEATHER_IMG_LIST_IDX = 5;

var ON_RESUME = 1;
var ON_PAUSE = 2;

//App Resources
var FONT_RES_ITEMS = "www/font";
var BG_RES_ITEMS = "BG";
var FREE_TEMPLATES_RES_ITEMS = "FreeTemplates";
var FONT_IMAGES_PATH = "../resource/img/font_images/";
var WEATHER_IMG_LIST_IDX = 5;

//template constants
var STEP_ONE = "1";
var STEP_TWO = "2";
var UP = "UP";
var DOWN = "DOWN";

//Background Constants
var BG_ORIGINAL = "bg_orginal";
var BG_GALLERY = "bg_gallery";
var BG_CLASSIC = "bg_classic";
var BG_MODERN = "bg_modern";
var BG_VINTAGE = "bg_vintage";

// Wifi status
var CONNECTION_UNKNOWN = 1;
var CONNECTION_ETHERNET = 2;
var CONNECTION_WIFI = 3;
var CONNECTION_CELL_2G = 4;
var CONNECTION_CELL_3G = 5;
var CONNECTION_CELL_4G = 6;
var CONNECTION_CELL = 7;
var CONNECTION_NONE = 8;

var ENGLISH_FONT_PATH = ".ETabletAuthor/Fonts/Downloads/english";
var KOREAN_FONT_PATH = ".ETabletAuthor/Fonts/Downloads/korean";
var CHINESE_FONT_PATH = ".ETabletAuthor/Fonts/Downloads/chinese";

var SHAPE=500;       
var shapeInfo = {
	CIRCLE : 400,
	RECT : 401,
	TRI : 402,
	ARC : 403,
	DIAMOND : 404,
	FRAME : 405,
	DONUT : 406,
	CROSS : 408,
	LINE:411,
	HEART:412,
	STAR:413,
	ONESDEARROW:414,
	TWOSDEARROW:415,
	FOLDEDCOR:416,
	PARLGRM:417,
	TRPZOID:418,
	PENTGN:419,
	HEXAGN:420,
	OCTAGN:421,
	STAR24P:422,
	WAVE:423,
	RECTCAL:424,
	LEFTBRACE:425,
	RIGHTBRACE:426,
	SUN:427
};

var shapeInfoMapping = {};
shapeInfoMapping[shapeInfo.RECT]={"typeName":"Figure Rect","Id":"Rectangle","yellowPoint":true};
shapeInfoMapping[shapeInfo.CIRCLE]={"typeName":"Figure Ellipse","Id":"Circle","yellowPoint":false};
shapeInfoMapping[shapeInfo.DIAMOND]={"typeName":"Figure Diamond","Id":"Diamond","yellowPoint":false};
shapeInfoMapping[shapeInfo.TRI]={"typeName":"Figure Triangle","Id":"Triangle","yellowPoint":true};
shapeInfoMapping[shapeInfo.CROSS]={"typeName":"Figure Cross","Id":"Cross","yellowPoint":true};
shapeInfoMapping[shapeInfo.PENTGN]={"typeName":"Figure RegularPolygon","Id":"Polygons", "elementName":0,"yellowPoint":false};
shapeInfoMapping[shapeInfo.HEXAGN]={"typeName":"Figure RegularPolygon","Id":"Polygons", "elementName":1,"yellowPoint":true};
shapeInfoMapping[shapeInfo.OCTAGN]={"typeName":"Figure RegularPolygon","Id":"Polygons", "elementName":3,"yellowPoint":true};

shapeInfoMapping[shapeInfo.FRAME]={"typeName":"Figure Frame","Id":"Frame","yellowPoint":true};
shapeInfoMapping[shapeInfo.DONUT]={"typeName":"Figure Donut","Id":"Donut","yellowPoint":true};
shapeInfoMapping[shapeInfo.TRPZOID]={"typeName":"Figure Trapezoid","Id":"Trapezoid","yellowPoint":true};
shapeInfoMapping[shapeInfo.PARLGRM]={"typeName":"Figure Parallelogram","Id":"ParallGram","yellowPoint":true};
shapeInfoMapping[shapeInfo.LINE]={"typeName":"Figure Line","Id":"Line","yellowPoint":false};
shapeInfoMapping[shapeInfo.HEART]={"typeName":"Figure Heart","Id":"Heart","yellowPoint":false};
shapeInfoMapping[shapeInfo.STAR]={"typeName":"Figure Star","Id":"Star","elementName":1,"yellowPoint":true};
shapeInfoMapping[shapeInfo.STAR24P]={"typeName":"Figure Star","Id":"Star","elementName":4,"yellowPoint":true};
shapeInfoMapping[shapeInfo.ONESDEARROW]={"typeName":"Figure Block Arrow","Id":"Arrow","elementName":0,"yellowPoint":true};
shapeInfoMapping[shapeInfo.TWOSDEARROW]={"typeName":"Figure Block Arrow","Id":"Arrow","elementName":4,"yellowPoint":true};
shapeInfoMapping[shapeInfo.FOLDEDCOR]={"typeName":"Figure FoldedCorner","Id":"FoldedCorner","yellowPoint":true};
shapeInfoMapping[shapeInfo.SUN]={"typeName":"Figure Sun","Id":"Sun","yellowPoint":true};
shapeInfoMapping[shapeInfo.ARC]={"typeName":"Figure Arc","Id":"Arc","yellowPoint":true};
shapeInfoMapping[shapeInfo.WAVE]={"typeName":"Figure Wave","Id":"Wave","elementName":0,"yellowPoint":true};
shapeInfoMapping[shapeInfo.LEFTBRACE]={"typeName":"Figure Brace","Id":"Brace","elementName":1,"yellowPoint":true};
shapeInfoMapping[shapeInfo.RIGHTBRACE]={"typeName":"Figure Brace","Id":"Brace","elementName":0,"yellowPoint":true};
shapeInfoMapping[shapeInfo.RECTCAL]={"typeName":"Figure RectangularCallout","Id":"RectangularCallout","yellowPoint":true};

var LFDShapeTypeTemplateShapeTypeMapping = {"Figure Rect":shapeInfo.RECT,"Figure Ellipse":shapeInfo.CIRCLE,"Figure Parallelogram":shapeInfo.PARLGRM,"Figure Trapezoid":shapeInfo.TRPZOID,
											"Figure RegularPolygon":shapeInfo.PENTGN + "-" + shapeInfo.HEXAGN + "-" + shapeInfo.OCTAGN,"Figure Triangle":shapeInfo.TRI,"Figure Frame":shapeInfo.FRAME,
											"Figure Block Arrow":shapeInfo.ONESDEARROW + "-" + shapeInfo.TWOSDEARROW,"Figure FoldedCorner":shapeInfo.FOLDEDCOR,"Figure Line":shapeInfo.LINE
											,"Figure Star":shapeInfo.STAR + "-" + shapeInfo.STAR24P,"Figure Heart":shapeInfo.HEART,"Figure Donut":shapeInfo.DONUT,"Figure Diamond":shapeInfo.DIAMOND
											,"Figure Block Arrow":shapeInfo.ONESDEARROW + "-" + shapeInfo.TWOSDEARROW,"Figure Cross":shapeInfo.CROSS,"Figure Sun":shapeInfo.SUN
											,"Figure Arc":shapeInfo.ARC,"Figure Wave":shapeInfo.WAVE,"Figure Brace":shapeInfo.LEFTBRACE + "-" + shapeInfo.RIGHTBRACE,"Figure RectangularCallout":shapeInfo.RECTCAL
											};

var globlePlayerType;
var digitalClockLanguage = [{'name':'Chinese','id':'zh', 'index':0}, {'name':'English','id':'en', 'index':1},{'name':'French','id':'fr', 'index':2},{'name':'German','id':'de', 'index':3},{'name':'Italian','id':'it', 'index':4},{'name':'Korean','id':'ko', 'index':6},{'name':'Portuguese','id':'pt', 'index':7},{'name':'Russian','id':'ru', 'index':8},{'name':'Spanish','id':'es', 'index':9},{'name':'Swedish','id':'sv', 'index':10}, {'name':'Turkish','id':'tr', 'index':12}];