/**
 * @filename FileOperation.js
 *
 *  created by k.chainani
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */

var root;
var funCallBack = null;
var srcDir;
var dstDir;
var counterErr=0;
var templateOrScheduleFlag;

function copyFolder(srcPath,dstPath,copyFlag,copyCallBack) {
    srcDir = srcPath;
    dstDir = dstPath;
    templateOrScheduleFlag = copyFlag;
    funCallBack = copyCallBack;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
        root = fileSystem.root;
        // get the directory we want to get within the root directory
       // var srcDir = 'Pictures';
        root.getDirectory(srcDir, {
            create : false
        }, getDirectoryWin, getDirectoryFail);
    });

}
function deleteFolder(srcPath,copyCallBack){
    srcDir=srcPath;
    funCallBack = copyCallBack;
    ClearDirectory();
}

 function ClearDirectory() {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, fail);
        function fail() {
             if(funCallBack != undefined)
               funCallBack.apply(this,[false]);
        }
        function onFileSystemSuccess(fileSystem) {
            fileSystem.root.getDirectory(
                 srcDir,
                {create : false, exclusive : false},
                function(entry) {
                entry.removeRecursively(function() {
                	if(funCallBack != undefined)
                     funCallBack.apply(this,[true]);
                    //alert("Remove Recursively Succeeded");
                }, fail);
            }, fail);
        }
    }

function getDirectoryWin(directory) {
    directory.copyTo(root, dstDir, copyWin, copyFail);
}

function getDirectoryFail() {
if(funCallBack != undefined)	
   funCallBack.apply(this,[false]);
}

function copyWin() {
	if(templateOrScheduleFlag == "COPY_TEMPLATE"){
		// template copy case
		console.log("&&&&& copyWin ");
		renameTemplate();
	}else{
		// schedule copy case
		if(funCallBack != undefined){
			console.log("&&&&& copyWin ");	
    funCallBack.apply(this,[true]);
		}	
	}	
}

function copyFail() {
if(funCallBack != undefined)	
  funCallBack.apply(this,[false]);
}
function renameFile(currentName, currentDir, newName, successFunction) {
	var path="";
	if(currentDir.charAt(currentDir.length-1) == "/"){
		path = currentDir + currentName;
	}else{
		path = currentDir + "/" + currentName;
	}
    funCallBack =successFunction;
    counterErr=0; // temp
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {

        fileSystem.root.getFile(path, null, function(fileEntry) {
            fileSystem.root.getDirectory(currentDir, {
                create : true
            }, function(dirEntry) {
                parentEntry = new DirectoryEntry(currentName, currentDir + currentName);

                fileEntry.moveTo(dirEntry, newName, renameSuccess, renameFail);
            }, renameFail);
        }, renameFail);

    }, renameFail);
}

function renameSuccess() {
	if(funCallBack != undefined)
     funCallBack.apply(this,[true]);
}

//and the sample fail function
function renameFail() {
    if(counterErr==0){
    	
    	if(funCallBack != undefined)
         funCallBack.apply(this,[false]);
         counterErr++;
    }
}

function subFolders(parentDir,callBack){
	
	  funCallBack = callBack;
	  var subList = [];
	  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,function(fileSystem)
	     {
      	  fileSystem.root.getDirectory(parentDir, {	create : false }, function(dirEntry)
		      {
			   var directoryReader = dirEntry.createReader();
			   directoryReader.readEntries(function(entries)
			   	{
			   		console.log("Entries Count:"+entries.length);	
		     	    if (entries.length > 0)
		     		{
			   		  for (var i = 0; i < entries.length; i++)
			   		  {
						if (entries[i].isDirectory) 
						{
                         
                         subList.push(entries[i].name);  		           
					    }
					  }
					  
					  funCallBack.apply(this,[subList]);
					 } // entries if end
		    	
	     		 }, fail);	
	 		   } , fail);
  	     }	, fail);    
		 
	  function fail() {
	  	if(funCallBack != undefined)
    	  funCallBack.apply(this,[null]);
      }   
}		    
