/**
 * @filename GenericNumericKeyboard.js
 *
 *
 * @author - r.yadav1
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */


var genericNumericKeyboard = (function() {

    var containerID = "genericNumericKeyboardID";
    var isKeyboardVisible = false;
    var callBackFun;

    var renderKeyboard = function(parentID, callback) {

        callBackFun = callback;
        var parentElement = $('#' + parentID);
        var totalWidth = parentElement.width();
        var totalHeight = parentElement.height();
        console.log("totalWidth: " + totalWidth + ", totalHeight: " + totalHeight);

        var keyboardButtonWidth = totalWidth / 3;
        var keyboardButtonHeight = totalHeight / 4;
        console.log("keyboardButtonWidth: " + keyboardButtonWidth + ", keyboardButtonHeight: " + keyboardButtonHeight);

        var fontSize = (keyboardButtonHeight * 0.305);

        $('#' + containerID).remove();

        var containerHTMLStr = '<div id="' + containerID + '" class="keyboardContainerCls" >';
        for (var id = 1; id <= 9; id++) {
            containerHTMLStr += '<div id="keyboardBtn_' + id + '" class="genericBtnCls keyboardBtnCls" value="' + id + '">' + id + '</div>';
        }
        containerHTMLStr += '<div id="keyboardBtn_Cancel" class="genericBtnCls keyboardBtnCls" value="Cancel">' + COM_SID_CANCEL + '</div>';
        containerHTMLStr += '<div id="keyboardBtn_0" class="genericBtnCls keyboardBtnCls" value="0">0</div>';
        containerHTMLStr += '<div id="keyboardBtn_Delete" class="keyboardBtn_Delete_Cls genericBtnCls keyboardBtnCls" value="Delete"></div>';
        containerHTMLStr += '</div>';


        parentElement.html(containerHTMLStr);
        isKeyboardVisible = true;

        $('.keyboardBtnCls').addClass('vAlignmiddle hAligncenter').css({
            'width': keyboardButtonWidth + 'px',
            'height': keyboardButtonHeight + 'px',
            'font-size': /*'100%'*/fontSize + 'px'
        });

        bindEventForButtons();

    };

    var bindEventForButtons = function() {

        $('.keyboardBtnCls').on('tap', function(e) {
            //e.stopPropagation();
            e.preventDefault();
            var element = $(this);
            var value = element.attr('value');
            if (element.hasClass('icon-disabled')) {
                return false;
            }
            console.log("Button Pressed: " + value);

            callBackFun(value);

            return false;
        });

        $('.keyboardBtnCls').authorActiveClass();

        $('.keyboardBtn_Delete_Cls').authorActiveClass();
    };

    var hideKeyboard = function() {
        if (!isKeyboardVisible) {
            return;
        }
        isKeyboardVisible = false;
        $('#' + containerID).hide();
    };

    var isKeyboardOpen = function() {
        return (isKeyboardVisible);
    }

    return {
        showGenericNumericKeyboard: renderKeyboard,
        hideGenericNumericKeyboard: hideKeyboard,
        isPinVerificationPageOpen: isKeyboardOpen
    };

})();

$(document).ready(function() {
    //genericNumericKeyboard.showGenericNumericKeyboard("genericNumericKeyboardContainer", callback);
    //setTimeout(genericNumericKeyboard.hideGenericNumericKeyboard, 5000);
});