/**
 * @filename Utils.js
 * @date 2 JAN 2014
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */

/**Modification date : 30/01/2015 author :sonia.b*/
var Utils = {

};

Utils.init = function() {

};
Utils.currStep = STEP_ONE;
Utils.isGalleryOpen = false;
Utils.isHandwritingOpen = false;
Utils.rootPath = ".ETabletAuthor";
var localeArraay = ["de", "en", "es", "fr", "it", "ko", "pl", "pt", "ru", "sv", "th", "tr", "zh"];
//Software version
var SOFT_VER = "3.1 1008.2";
var CURRENT_APP_VER = "1008.2";
var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";

var coachmarkPositionX;
var coachmarkPositionY;
var coachmarkWidth;
var coachmarkHeight;
var LINEGAP = 3;
var funCallBack;
var DRAGTHRESHOLD = 10;
var _STEPS = 1;
var langObj = {};
var FonttimerValFrNote_5;
var popupTopPos="30%";
var countryxmlObject="";
var countryjsonObject="";
var firstCityInfo = {name:'', id:''};
// TYPE, Title, Description, X, Y, W, H, Align ( 1 : right )
var coachMarkData = new Array(8);
var WIN_INNER_H = window.innerHeight;
var WIN_INNER_W = window.innerWidth;
var fontListIsDownloadedFlags = {};
var currPinBox;

function initCoachmarkData() {
    for (var i = 0; i < 23; i++) {
        coachMarkData[i] = new Array(8);
        for (var j = 0; j < 3; j++) {
            coachMarkData[i][j] = new Array(8);
        }
    }
    // 1: QS - Select Content
    coachMarkData[0][0] = new Array("QS_STEP1", langObj.CoachMark.MIA_TEMPLATE_ORIENTATION, langObj.CoachMark.MIA_SID_3SELECT_ORIENTATION_DIGITAL_SIGNAGE, "3.7%", 6.5, "43.5%", "10%", 1);
    coachMarkData[0][1] = new Array("QS_STEP1", langObj.CoachMark.MIA_SID_SELECTED_CONTENT, langObj.CoachMark.MIA_SID_DRAG_THUMBNAIL_OUTSIDE_AREA_REMOVE, "18.7%", 29.5, "65%", "10%");
    coachMarkData[0][2] = new Array("QS_STEP1", langObj.CoachMark.MIA_SID_CONTENT_BROWSER, langObj.CoachMark.MIA_SID_TAP_HERE_OPEN_CONTENT_BROWSER + " " + langObj.CoachMark.MIA_SID_SELECT_CONTENT_ADD_TO_TEMPALTE, "20%", 73, "70%", "10%");

    // 2: QS - Edit Template (shuffle)
    coachMarkData[1][0] = new Array("QS_STEP2", langObj.CoachMark.COM_SID_AUDIO_KR_KOR, langObj.CoachMark.MIA_SID_CHOOSE_AUDIO_TRACK_BACKGROUND, "20%", 17, "58.3%", "20%");
    coachMarkData[1][1] = new Array("QS_STEP2", langObj.CoachMark.COM_SID_SHUFFLE_KR_SUFFLE, langObj.CoachMark.MIA_SID_JUMP_START_SIGNAGE_SELECTING_DESIGNED, "37%", 36, "54%", "20%");
    coachMarkData[1][2] = new Array("QS_STEP2", langObj.CoachMark.IDS_DOCKINGPANE_MENU, langObj.CoachMark.MIA_SID_TAP_OPEN_CONTENT_BROWER, "37%", 72.5, "34%", "20%", 1);
    coachMarkData[1][3] = new Array("QS_STEP2", langObj.CoachMark.COM_SID_PREVIEW, langObj.CoachMark.MIA_SID_VIEW_RESULT_DESIGNED_TEMPLATE, "39%", 56.5, "41%", "20%", 1);

    // 3: QS - Edit Template (source browser)
    coachMarkData[2][0] = new Array("QS_STEP3", langObj.CoachMark.COM_SID_ZOOM_KR_DIFF, langObj.CoachMark.MIA_SID_SPREAD_FINGERS_APART_ZOOM_IN + " " + langObj.CoachMark.MIA_SID_DOUBLE_TAP_SCREEN_RETURN_ORIGINAL, "5%", 20, "90%", "20%");
    coachMarkData[2][1] = new Array("QS_STEP3", langObj.CoachMark.MIA_SID_CONTENT_BROWSER, langObj.CoachMark.MIA_SID_6BUILD_UPON_TEMPLATE_DRAGGING_DESIGN + " " + langObj.CoachMark.MIA_SID_TAP_HOLD_DRAG_ITEM, "20%", 73, "70%", "20%");

    // 4: QS - Edit Template (Text menu option)
    coachMarkData[3][0] = new Array("QS_STEP4", langObj.CoachMark.COM_SID_OPTIONS, langObj.CoachMark.MIA_SID_EDIT_TEMPALTE_ELEMENTS_CHANGING + " " + langObj.CoachMark.MIA_SID_TAP_EACH_BUTTON_EXPAND_COLLAPSE_MENUS, "15%", 18, "45%", "20%");

    // 5: QS -  Schedule (basic)
    //coachMarkData[4][1] = new Array("QS_STEP5", langObj.CoachMark.COM_SID_ZOOM_KR_DIFF, langObj.CoachMark.MIA_SID_SPREAD_FINGERS_APART_ZOOM_IN, "10%", 26, "40%", "20%");
    coachMarkData[4][0] = new Array("QS_STEP5", langObj.CoachMark.MIA_SID_ADD_A_TIME_BAR, langObj.CoachMark.MIA_SID_TAP_OPEN_TEMPLATE_PLAYLIST, "45%", 78, "40%", "40%", 1);

    // 6: QS - Schedule (time bar select)
    coachMarkData[5][0] = new Array("QS_STEP6", langObj.CoachMark.COM_IDS_EDIT_COPY, langObj.CoachMark.MIA_SID_SELECT_ICON_DUCPLICATE_HIGHLIGHTED, "22.6%", 81.5, "70%", "13%");
    coachMarkData[5][1] = new Array("QS_STEP6", langObj.CoachMark.MIA_SID_TIME_BARS, langObj.CoachMark.MIA_SID_EDIT_SCHEDULE_TIME_BAR, "28.7%", 27.5, "68%", "13%");

    // 7: QS - Schedule (Template&PlayList button select state)
    coachMarkData[6][0] = new Array("QS_STEP7", langObj.CoachMark.MIA_SID_CREATE_PLAYLIST, langObj.CoachMark.MIA_SID_MULTIPLE_TEMPLATE_PLAYLIST_REPEATELDY, "17%", 13, "60%", "13%");
    coachMarkData[6][1] = new Array("QS_STEP7", langObj.CoachMark.MIA_SID_TEMPATE_AND_PLAYLIST, langObj.CoachMark.MIA_SID_TAP_HOLD_TEMPALTE_PLAYLIST_SCREEN_EDIT_SCHEDULE, "39%", 36, "50%", "13%", 1);

    // 8: QS - Send
    coachMarkData[7][0] = new Array("QS_STEP8", langObj.CoachMark.MIA_SID_SIGNAGE_LIST, langObj.CoachMark.MIA_SID_SMART_SIGNAGE_SAME_WIFI_NETWORK_PHONE_SELECT_DISPLAY_TARGETS, "28%", 23.5, "55%", "13%", 1);
    coachMarkData[7][1] = new Array("QS_STEP8", langObj.CoachMark.COM_SID_SEND, langObj.CoachMark.MIA_SID_TRANSFER_WORK_CHOSEN_TARGETS_SEND, "18.7%", 71, "40%", "12%");

    // 9 : CD - Edit Template (basic)
    coachMarkData[8][0] = new Array("CD_STEP9", langObj.CoachMark.COM_BUTTON_SAVE, langObj.CoachMark.MIA_SID_SAVE_TEMPLATE_PHONE, "18.5%", 1, "50%", "13%");
    coachMarkData[8][1] = new Array("CD_STEP9", langObj.CoachMark.IDS_TABLE_TYPE_SCHEDULE, langObj.CoachMark.MIA_SID_CRATE_EDIT_SCHEDULE_TEMPALTE_OR_PLAYLIST, "48.5%", 17, "39%", "12%");
    coachMarkData[8][2] = new Array("CD_STEP9", langObj.CoachMark.COM_SID_NEW_KR_ADD, langObj.CoachMark.MIA_SID_CREATE_NEW_TEMPLATE, "51%", 33, "30%", "13%", 1);
    coachMarkData[8][3] = new Array("CD_STEP9", langObj.CoachMark.COM_SID_AUDIO_KR_KOR, langObj.CoachMark.MIA_SID_CHOOSE_AUDIO_TRACK_BACKGROUND, "19.5%", 45.5, "55%", "12%");
    coachMarkData[8][4] = new Array("CD_STEP9", langObj.CoachMark.IDS_DOCKINGPANE_MENU, langObj.CoachMark.MIA_SID_TAP_OPEN_CONTENT_BROWER, "25.5%", 80.5, "40%", "12%", 1);
    coachMarkData[8][5] = new Array("CD_STEP9", langObj.CoachMark.COM_SID_PREVIEW, langObj.CoachMark.MIA_SID_VIEW_RESULT_DESIGNED_TEMPLATE, "42%", 66.5, "40%", "12%", 1);
    
    // 10 : CD - Edit Template (source browser)
    coachMarkData[9][0] = new Array("CD_STEP10", langObj.CoachMark.COM_SID_ZOOM_KR_DIFF, langObj.CoachMark.MIA_SID_SPREAD_FINGERS_APART_ZOOM_IN + " " + langObj.CoachMark.MIA_SID_DOUBLE_TAP_SCREEN_RETURN_ORIGINAL, "5%", 25, "90%", "20%");
    coachMarkData[9][1] = new Array("CD_STEP10", langObj.CoachMark.COM_TEXT_TEMPLATE_P, langObj.CoachMark.MIA_SID_SELECT_TEMPALTE_START_USE_PROVIDED_DESIGNS, "19%", 73, "50%", "12%");

    // 11 : CD - Edit Template (Text menu option)
    coachMarkData[10][0] = new Array("CD_STEP11", langObj.CoachMark.COM_SID_OPTIONS, langObj.CoachMark.MIA_SID_EDIT_TEMPALTE_ELEMENTS_CHANGING + " " + langObj.CoachMark.MIA_SID_TAP_EACH_BUTTON_EXPAND_COLLAPSE_MENUS, "14%", 18.5, "45%", "20%");

    // 12 : CD - Schedule
    coachMarkData[11][0] = new Array("CD_STEP12", langObj.CoachMark.COM_SID_SEND, langObj.CoachMark.MIA_SID_SEND_YOUR_EDITED_SCHEDULE, "48.5%", 3.5, "50%", "13%");
    coachMarkData[11][1] = new Array("CD_STEP12", langObj.CoachMark.COM_TV_SID_SCHEDULE_LIST_KR_SCHEDULE, langObj.CoachMark.MIA_SID_EDIT_PREVIOUSLY_CREATED_SCHEDULE_NEW, "19%", 63.5, "60%", "40%");
    coachMarkData[11][2] = new Array("CD_STEP12", langObj.CoachMark.MIA_SID_ADD_A_TIME_BAR, langObj.CoachMark.MIA_SID_TAP_OPEN_TEMPLATE_PLAYLIST, "40%", 78, "45%", "40%", 1);

    // 13 : CD - Send
    coachMarkData[12][0] = new Array("CD_STEP13", langObj.CoachMark.MIA_SID_SIGNAGE_LIST, langObj.CoachMark.MIA_SID_SMART_SIGNAGE_SAME_WIFI_NETWORK_PHONE_SELECT_DISPLAY_TARGETS, "15%", 15.5, "45%", "13%", 1);
    coachMarkData[12][1] = new Array("CD_STEP13", langObj.CoachMark.COM_SID_SEND, langObj.CoachMark.MIA_SID_TRANSFER_WORK_CHOSEN_TARGETS_SEND, "38%", 71, "40%", "12%");

    // 14 :QS -  Edit Template (basic) / RMD
    coachMarkData[13][0] = new Array("QS_STEP14", langObj.CoachMark.COM_SID_SHUFFLE_KR_SUFFLE, langObj.CoachMark.MIA_SID_JUMP_START_SIGNAGE_SELECTING_DESIGNED, "23%", 36, "54%", "20%");
    coachMarkData[13][1] = new Array("QS_STEP14", langObj.CoachMark.IDS_DOCKINGPANE_MENU, langObj.CoachMark.MIA_SID_TAP_OPEN_CONTENT_BROWER, "37%", 72.5, "34%", "20%", 1);
    coachMarkData[13][2] = new Array("QS_STEP14", langObj.CoachMark.COM_SID_PREVIEW, langObj.CoachMark.MIA_SID_VIEW_RESULT_DESIGNED_TEMPLATE, "39%", 56.5, "41%", "20%", 1);

    // 15 : QS - Edit Template (Text menu option)/ RMD //
    coachMarkData[14][0] = new Array("QS_STEP15", langObj.CoachMark.COM_SID_OPTIONS, langObj.CoachMark.MIA_SID_EDIT_TEMPALTE_ELEMENTS_CHANGING + " " + langObj.CoachMark.MIA_SID_TAP_EACH_BUTTON_EXPAND_COLLAPSE_MENUS, "15%", 18, "45%", "20%");

    // 16 :CD -  Edit Template (basic) / RMD 
    coachMarkData[15][0] = new Array("CD_STEP16", langObj.CoachMark.COM_BUTTON_SAVE, langObj.CoachMark.MIA_SID_SAVE_TEMPLATE_PHONE, "19%", 1, "50%", "13%");
    coachMarkData[15][1] = new Array("CD_STEP16", langObj.CoachMark.IDS_TABLE_TYPE_SCHEDULE, langObj.CoachMark.MIA_SID_CRATE_EDIT_SCHEDULE_TEMPALTE_OR_PLAYLIST, "48.5%", 17.5, "39%", "12%");
    coachMarkData[15][2] = new Array("CD_STEP16", langObj.CoachMark.COM_SID_NEW_KR_ADD, langObj.CoachMark.MIA_SID_CREATE_NEW_TEMPLATE, "50.5%", 33, "30%", "13%", 1);
    coachMarkData[15][3] = new Array("CD_STEP16", langObj.CoachMark.IDS_DOCKINGPANE_MENU, langObj.CoachMark.MIA_SID_TAP_OPEN_CONTENT_BROWER, "25%", 80.5, "40%", "12%", 1);
    coachMarkData[15][4] = new Array("CD_STEP16", langObj.CoachMark.COM_SID_PREVIEW, langObj.CoachMark.MIA_SID_VIEW_RESULT_DESIGNED_TEMPLATE, "42%", 66.5, "40%", "12%", 1);
    
    // 17 : CD - Edit Template (Text menu option)/ RMD //
    coachMarkData[16][0] = new Array("CD_STEP17", langObj.CoachMark.COM_SID_OPTIONS, langObj.CoachMark.MIA_SID_EDIT_TEMPALTE_ELEMENTS_CHANGING + " " + langObj.CoachMark.MIA_SID_TAP_EACH_BUTTON_EXPAND_COLLAPSE_MENUS, "14%", 18.5, "45%", "20%");
    
    var supportNum;
    if( isIOS() )
    {
        supportNum = " 1920 * 1080 / 1280 * 720 ";
    }else
    {
        supportNum = " 1280 * 720 ";
    };
    
    
    // 18 : AD - Step2
    coachMarkData[17][0] = new Array("AD_STEP2", langObj.CoachMark.MIA_SID_AD_CLIP_DURATION, langObj.CoachMark.MIA_SID_APPROXIMATE_DURATION_DISPLAYED_BASED_ON, "17%", 29.5, "72%", "11%", 1);
    coachMarkData[17][1] = new Array("AD_STEP2", langObj.CoachMark.MIA_SID_MIX_SELECTED_CONTENT.replace("(<<A>> / <<B>>)","") + " (" + langObj.template.COM_TV_SID_IMAGE + " / " + langObj.CoachMark.COM_SID_VIDEO + ")", langObj.CoachMark.MIA_SID_INFORMATION_CONTENT_IMAGE_VIDEO, "22%", 49, "70%", "30%");
    coachMarkData[17][2] = new Array("AD_STEP2", langObj.CoachMark.MIA_SID_CONTENT_BROWSER, langObj.CoachMark.MIA_SID_CONTENT_SELECT_ADDED_AD_CLIP + '\r\n' + langObj.CoachMark.MIA_SID_MIX_SUPPORTED_VIDEO_RESOLUTION_COLON + supportNum, "20%", 80.5, "60%", "30%");
    
    // 19 : AD - Step3 (basic)
    coachMarkData[18][0] = new Array("AD_STEP3_1", langObj.CoachMark.MIA_SID_TEXT_FIELD, langObj.CoachMark.MIA_SID_ENTER_MESSAGE_REQUIRED_ADD_MORE, "41%", 23, "35%", "18%");
    coachMarkData[18][1] = new Array("AD_STEP3_1", langObj.CoachMark.MIA_SID_TIMELINE, langObj.CoachMark.MIA_SID_TAP_HERE_OPEN_LIST_ALL_SCREEN, "20%", 69.5, "45%", "20%");
    coachMarkData[18][2] = new Array("AD_STEP3_1", langObj.CoachMark.IDS_DOCKINGPANE_MENU, langObj.CoachMark.MIA_SID_TAP_OPEN_CONTENT_BROWER, "27.5%", 83, "45%", "20%", 1);
    
    // 20 : AD - Step3 (click TimeLine)
    coachMarkData[19][0] = new Array("AD_STEP3_2", langObj.CoachMark.MIA_SID_TEXT_FIELD, langObj.CoachMark.MIA_SID_ENTER_MESSAGE_REQUIRED_ADD_MORE, "41%", 23, "35%", "18%");
    coachMarkData[19][1] = new Array("AD_STEP3_2", langObj.CoachMark.MIA_SID_TIMELINE, langObj.CoachMark.MIA_SID_SWAP_IMAGE_POSITION_DESIGN_PAGE, "18.5%", 59, "45%", "20%");
    
    // 21 : AD - Step3 (click menu)
    coachMarkData[20][0] = new Array("AD_STEP3_3", langObj.CoachMark.MIA_SID_CONTENT_BROWSER, langObj.CoachMark.MIA_SID_DRAG_CONTENT_ITEM_CANVAS_ADD_IMAGE_TEXT , "19.5%", 69.5, "60%", "15%");
    
    // 22 : AD - Step4 (create)
    coachMarkData[21][0] = new Array("AD_STEP4_1", langObj.CoachMark.COM_TV_SID_OPEN_HOME, langObj.CoachMark.MIA_SID_TAP_HERE_EXIT_WITHOUT_SVING, "15.5%", 13.5, "55%", "18%");
    coachMarkData[21][1] = new Array("AD_STEP4_1", langObj.CoachMark.COM_TEXT_CREATE_P_KR_MIS20, langObj.CoachMark.MIA_SID_TAP_HERE_START_ENCODING_AD_CLIP , "39.5%", 71, "45%", "20%");
        
    // 23 : AD - Step4 (save)
    coachMarkData[22][0] = new Array("AD_STEP4_2", langObj.CoachMark.COM_TV_SID_OPEN_HOME, langObj.CoachMark.MIA_SID_TAP_HERE_EXIT_WITHOUT_SVING, "15.5%", 13, "55%", "18%");
    coachMarkData[22][1] = new Array("AD_STEP4_2", langObj.CoachMark.COM_SID_PREVIEW, langObj.CoachMark.MIA_SID_TAP_HERE_VIEW_AD_CLIP_BACK_STEP , "27%", 29, "45%", "20%");
    coachMarkData[22][2] = new Array("AD_STEP4_2", langObj.CoachMark.COM_BUTTON_SAVE, langObj.CoachMark.MIA_SID_TAP_SAVE_AD_CLIP_VIDEO_FILE_FIND_MY_CONTENT , "39%", 71, "45%", "20%");
}

// Text,X(Left),Y(Top),W,H,Color,font Family,font Size,align( 1 : right / 2 : left / 0 : center)
var coachMarkBGData = new Array(7);

function initCoachmarkBGData() {
    for (var i = 0; i < 23; i++) {
        coachMarkBGData[i] = new Array(7);
        for (var j = 0; j < 3; j++) {
            coachMarkBGData[i][j] = new Array(7);
        }
    }

    var storageInfo1 = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace("<<A>>", langObj.Send.MIA_SID_INTERNAL).replace("<<B>>", "1.0GB").replace("<<C>>", "1.9GB");
    var storageInfo2 = langObj.Send.MIA_SID_MIX_STORAGE_A_B_C.replace("<<A>>", langObj.Send.MIA_SID_EXTERNAL).replace("<<B>>", "1.0GB").replace("<<C>>", "1.9GB");

    // 1: QS - Select Content
    coachMarkBGData[0][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[0][1] = new Array(langObj.template.COM_MY_CONTENT, "1%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[0][2] = new Array(langObj.template.COM_TV_SID_CAMERA, "21%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[0][3] = new Array(langObj.template.MIA_SID_CHOOSE_ORIENTAITON_TEMPLATE, "10%", "52%", "80%", "10%", "#d4d4d4", "NotoSans-Regular", "12px");

    // 2: QS - Edit Template (shuffle)
    coachMarkBGData[1][0] = new Array(langObj.template.COM_SID_SHUFFLE_KR_SUFFLE, "10%", "91%", "80%", "9%", "#ffffff", "NotoSans-Regular", "18px");
    coachMarkBGData[1][1] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "25%", "2%", "50%", "10%", "#000000", "NotoSans-Regular", "19px");

    // 3: QS - Edit Template (source browser)
    coachMarkBGData[2][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[2][1] = new Array(langObj.template.COM_MY_CONTENT, "1%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[2][2] = new Array(langObj.template.COM_TV_SID_CAMERA, "21%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[2][3] = new Array(langObj.template.COM_IDS_ELEM_TEXT, "40%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[2][4] = new Array(langObj.template.COM_STICKERS, "59%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");

    // 4: QS - Edit Template (Text menu option)
    coachMarkBGData[3][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "25%", "2%", "50%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[3][1] = new Array(langObj.Settings.IDS_FONT_TEXT, "5%", "57%", "20%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[3][2] = new Array(langObj.template.COM_PROPERDLG_FONTSIZE, "5%", "66%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[3][3] = new Array(langObj.template.COM_PROPERDLG_FONTCLR, "5%", "76%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[3][4] = new Array(langObj.template.MIA_SID_BACKGROUND_COLOR, "5%", "86%", "80%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[3][5] = new Array('NotoSans...', "60%", "57%", "30%", "5%", "#3a3a3d", "NotoSans-Regular", "15px");

    // 5: QS -  Schedule (basic)
    coachMarkBGData[4][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[4][1] = new Array('v ' + langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 01', "10%", "18%", "80%", "12%", "#1a1a1c", "NotoSans-Regular", "20px");
    coachMarkBGData[4][2] = new Array(langObj.Schedule.COM_IDS_SUN, "19%", "23.5%", "5%", "12%", "#3c0000", "NotoSans-Regular", "14px");
    coachMarkBGData[4][3] = new Array(langObj.Schedule.COM_IDS_MON, "29.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[4][4] = new Array(langObj.Schedule.COM_IDS_TUE, "42%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[4][5] = new Array(langObj.Schedule.COM_IDS_WED, "53.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[4][6] = new Array(langObj.Schedule.COM_IDS_THU, "65.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[4][7] = new Array(langObj.Schedule.COM_IDS_FRI, "78%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[4][8] = new Array(langObj.Schedule.COM_IDS_SAT, "89%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    
    // 6: QS - Schedule (time bar select)
    coachMarkBGData[5][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[5][1] = new Array('v ' + langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 01', "10%", "18%", "80%", "12%", "#1a1a1c", "NotoSans-Regular", "20px");
    coachMarkBGData[5][2] = new Array(langObj.Schedule.COM_IDS_SUN, "19%", "23.5%", "5%", "12%", "#3c0000", "NotoSans-Regular", "14px");
    coachMarkBGData[5][3] = new Array(langObj.Schedule.COM_IDS_MON, "29.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[5][4] = new Array(langObj.Schedule.COM_IDS_TUE, "42%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[5][5] = new Array(langObj.Schedule.COM_IDS_WED, "53.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[5][6] = new Array(langObj.Schedule.COM_IDS_THU, "65.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[5][7] = new Array(langObj.Schedule.COM_IDS_FRI, "78%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[5][8] = new Array(langObj.Schedule.COM_IDS_SAT, "89%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");

    // 7: QS - Schedule (Template&PlayList button select state)
    coachMarkBGData[6][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[6][1] = new Array('v ' + langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 01', "25%", "18%", "50%", "12%", "#1a1a1c", "NotoSans-Regular", "20px");
    coachMarkBGData[6][2] = new Array(langObj.CoachMark.MIA_SID_TEMPATE_AND_PLAYLIST, "2%", "57%", "70%", "5%", "#131314", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[6][3] = new Array('+ ' + langObj.Schedule.COM_SID_PLAYLIST, "2%", "65.3%", "80%", "50%", "#e2e2e2", "NotoSans-Regular", "18px");
    coachMarkBGData[6][4] = new Array(langObj.template.COM_TEXT_TEMPLATE_P + ' 01', "4%", "88.5%", "30%", "5%", "#010101", "NotoSans-Regular", "15px");
    coachMarkBGData[6][5] = new Array(langObj.Schedule.COM_IDS_SUN, "19%", "23.5%", "5%", "12%", "#3c0000", "NotoSans-Regular", "14px");
    coachMarkBGData[6][6] = new Array(langObj.Schedule.COM_IDS_MON, "29.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[6][7] = new Array(langObj.Schedule.COM_IDS_TUE, "42%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[6][8] = new Array(langObj.Schedule.COM_IDS_WED, "53.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[6][9] = new Array(langObj.Schedule.COM_IDS_THU, "65.5%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[6][10] = new Array(langObj.Schedule.COM_IDS_FRI, "78%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");
    coachMarkBGData[6][11] = new Array(langObj.Schedule.COM_IDS_SAT, "89%", "23.5%", "5%", "12%", "#1c1c1c", "NotoSans-Regular", "14px");

    // 8: QS - Send
    coachMarkBGData[7][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[7][1] = new Array(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE, "3%", "23%", "80%", "10%", "#000000", "NotoSans-Regular", "18px", 2);
    coachMarkBGData[7][2] = new Array("[Signage] Display 01", "3%", "36%", "45%", "5%", "#131314", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[7][3] = new Array(storageInfo1, "3%", "39.5%", "70%", "5%", "#303030", "NotoSans-Regular", "13px", 2);
    coachMarkBGData[7][4] = new Array("[Signage] Display 02", "3%", "46%", "45%", "5%", "#131314", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[7][5] = new Array(storageInfo2, "3%", "49.5%", "70%", "5%", "#303030", "NotoSans-Regular", "13px", 2);
    coachMarkBGData[7][6] = new Array("[Signage] Display 03", "3%", "56%", "45%", "5%", "#3b3b3b", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[7][7] = new Array(langObj.Settings.MIS_SID_NOT_SUPOORT, "3%", "59.5%", "45%", "5%", "#3b3b3b", "NotoSans-Regular", "13px", 2);
    coachMarkBGData[7][8] = new Array("+ " + langObj.Send.MIA_SID_ADD_SIGNAGE_TV, "10%", "66.5%", "80%", "5%", "#131314", "NotoSans-Regular", "18px");
    coachMarkBGData[7][9] = new Array(langObj.Send.COM_COMMONCTRL_SEND, "10%", "90%", "80%", "5%", "#ffffff", "NotoSans-Regular", "20px");

    // 9 : CD - Edit Template (basic)
    coachMarkBGData[8][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");

    // 10 : CD - Edit Template (source browser)
    coachMarkBGData[9][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[9][1] = new Array(langObj.template.COM_LFD_SID_TEMPLATES_KR_TEMPLATE, "1%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[9][2] = new Array(langObj.template.COM_MY_CONTENT, "21%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[9][3] = new Array(langObj.template.COM_TV_SID_CAMERA, "40%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[9][4] = new Array(langObj.template.COM_IDS_ELEM_TEXT, "59%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");

    // 11 : CD - Edit Template (Text menu option)
    coachMarkBGData[10][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[10][1] = new Array(langObj.Settings.IDS_FONT_TEXT, "5%", "57%", "20%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[10][2] = new Array(langObj.template.COM_PROPERDLG_FONTSIZE, "5%", "66%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[10][3] = new Array(langObj.template.COM_PROPERDLG_FONTCLR, "5%", "76%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[10][4] = new Array(langObj.template.MIA_SID_BACKGROUND_COLOR, "5%", "86%", "80%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[10][5] = new Array('NotoSans...', "60%", "57%", "30%", "5%", "#3a3a3d", "NotoSans-Regular", "15px");

    // 12 : CD - Schedule
    coachMarkBGData[11][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[11][1] = new Array('^ ' + langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 01', "10%", "16%", "80%", "12%", "#000000", "NotoSans-Regular", "20px");
    coachMarkBGData[11][2] = new Array(langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 01', "10%", "28%", "80%", "12%", "#000000", "NotoSans-Regular", "20px");
    coachMarkBGData[11][3] = new Array(langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 02', "10%", "35%", "80%", "12%", "#b8b8b8", "NotoSans-Regular", "20px");
    coachMarkBGData[11][4] = new Array(langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ' 03', "10%", "42%", "80%", "12%", "#b8b8b8", "NotoSans-Regular", "20px");
    coachMarkBGData[11][5] = new Array('+ ' + langObj.Schedule.COM_TV_CREATE_NEW, "25%", "51%", "53%", "12%", "#3a3a3d", "NotoSans-Regular", "20px");

    // 13 : CD - Send
    coachMarkBGData[12][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[12][1] = new Array(langObj.Send.MIA_SID_SELECT_SIGNAGE_SEND_SCHEDULE, "3%", "15%", "80%", "10%", "#000000", "NotoSans-Regular", "18px", 2);
    coachMarkBGData[12][2] = new Array("[Signage] Display 01", "3%", "28%", "45%", "5%", "#131314", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[12][3] = new Array(storageInfo1, "3%", "31.5%", "70%", "5%", "#303030", "NotoSans-Regular", "13px", 2);
    coachMarkBGData[12][4] = new Array("[Signage] Display 02", "3%", "38%", "45%", "5%", "#131314", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[12][5] = new Array(storageInfo2, "3%", "41.5%", "70%", "5%", "#303030", "NotoSans-Regular", "13px", 2);
    coachMarkBGData[12][6] = new Array("[Signage] Display 03", "3%", "48%", "45%", "5%", "#3b3b3b", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[12][7] = new Array(langObj.Settings.MIS_SID_NOT_SUPOORT, "3%", "51.5%", "45%", "5%", "#3b3b3b", "NotoSans-Regular", "13px", 2);
    coachMarkBGData[12][8] = new Array("+ " + langObj.Send.MIA_SID_ADD_SIGNAGE_TV, "10%", "58.5%", "80%", "5%", "#131314", "NotoSans-Regular", "18px");
    coachMarkBGData[12][9] = new Array(langObj.Send.COM_COMMONCTRL_SEND, "10%", "90%", "80%", "5%", "#ffffff", "NotoSans-Regular", "20px");

    // 14 :QS -  Edit Template (basic) / RMD
    coachMarkBGData[13][0] = new Array(langObj.template.COM_SID_SHUFFLE_KR_SUFFLE, "10%", "91%", "80%", "9%", "#ffffff", "NotoSans-Regular", "18px");
    coachMarkBGData[13][1] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "25%", "2%", "50%", "10%", "#000000", "NotoSans-Regular", "19px");

    // 15 : QS - Edit Template (Text menu option)/ RMD
    coachMarkBGData[14][0] = new Array(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START, "25%", "2%", "50%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[14][1] = new Array(langObj.Settings.IDS_FONT_TEXT, "5%", "57%", "20%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[14][2] = new Array(langObj.template.COM_PROPERDLG_FONTSIZE, "5%", "66%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[14][3] = new Array(langObj.template.COM_PROPERDLG_FONTCLR, "5%", "76%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[14][4] = new Array(langObj.template.MIA_SID_BACKGROUND_COLOR, "5%", "86%", "80%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[14][5] = new Array('NotoSans...', "60%", "57%", "30%", "5%", "#3a3a3d", "NotoSans-Regular", "15px");
    
    // 16 :CD -  Edit Template (basic) / RMD
    coachMarkBGData[15][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");

    // 17 : CD - Edit Template (Text menu option)/ RMD
    coachMarkBGData[16][0] = new Array(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[16][1] = new Array(langObj.Settings.IDS_FONT_TEXT, "5%", "57%", "20%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[16][2] = new Array(langObj.template.COM_PROPERDLG_FONTSIZE, "5%", "66%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[16][3] = new Array(langObj.template.COM_PROPERDLG_FONTCLR, "5%", "76%", "40%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[16][4] = new Array(langObj.template.MIA_SID_BACKGROUND_COLOR, "5%", "86%", "80%", "5%", "#3a3a3d", "NotoSans-Regular", "15px", 2);
    coachMarkBGData[16][5] = new Array('NotoSans...', "60%", "57%", "30%", "5%", "#3a3a3d", "NotoSans-Regular", "15px");

    // 18 : AD - Step2
    coachMarkBGData[17][0] = new Array(langObj.Adclip.MIA_SID_CREATE_AD_CLIP, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[17][1] = new Array('0' + langObj.template.COM_SID_SEC, "83%", "73.5%", "7%", "5%", "#131314", "NotoSans-Regular", "10px");
    coachMarkBGData[17][2] = new Array('5', "14%", "73.5%", "5%", "5%", "#131314", "NotoSans-Regular", "10px");
    coachMarkBGData[17][3] = new Array('0' + langObj.template.COM_SID_SEC, "45%", "73.5%", "15%", "5%", "#131314", "NotoSans-Regular", "10px");
    coachMarkBGData[17][4] = new Array(langObj.template.COM_MY_CONTENT, "1%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[17][5] = new Array(langObj.template.COM_TV_SID_CAMERA, "21%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[17][6] = new Array(langObj.CoachMark.COM_SID_VIDEO, "40%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    
    // 19 : AD - Step3 (basic)
    coachMarkBGData[18][0] = new Array(langObj.Adclip.MIA_SID_CREATE_AD_CLIP, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[18][1] = new Array(langObj.template.MIA_SID_ENTER_TEXT, "10%", "50%", "80%", "5%", "#FFFFFF", "NotoSans-Regular", "15px");
    
    // 20 : AD - Step3 (click TimeLine)
    coachMarkBGData[19][0] = new Array(langObj.Adclip.MIA_SID_CREATE_AD_CLIP, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[19][1] = new Array(langObj.template.MIA_SID_ENTER_TEXT, "10%", "50%", "80%", "5%", "#FFFFFF", "NotoSans-Regular", "15px");
    coachMarkBGData[19][2] = new Array(langObj.template.COM_SID_PLAY_TIME + '  30 ' + langObj.template.COM_SID_SEC, "4%", "76%", "60%", "5%", "#000000", "NotoSans-Regular", "17px", 2);    
    
    // 21 : AD - Step3 (click menu)
    coachMarkBGData[20][0] = new Array(langObj.Adclip.MIA_SID_CREATE_AD_CLIP, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[20][1] = new Array(langObj.template.COM_MY_CONTENT, "1%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[20][2] = new Array(langObj.template.COM_TV_SID_CAMERA, "21%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[20][3] = new Array(langObj.template.COM_IDS_ELEM_TEXT, "40%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    coachMarkBGData[20][4] = new Array(langObj.template.COM_STICKERS, "60%", "97%", "20%", "2%", "#a3a3a3", "NotoSans-Regular", "7px");
    
    // 22 : AD - Step4 (create)
    coachMarkBGData[21][0] = new Array(langObj.Adclip.MIA_SID_CREATE_AD_CLIP, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[21][1] = new Array(langObj.CoachMark.COM_TEXT_CREATE_P_KR_MIS20, "10%", "90%", "80%", "5%", "#FFFFFF", "NotoSans-Regular", "19px");
    
    // 23 : AD - Step4 (save)
    coachMarkBGData[22][0] = new Array(langObj.Adclip.MIA_SID_CREATE_AD_CLIP, "10%", "2%", "80%", "10%", "#000000", "NotoSans-Regular", "19px");
    coachMarkBGData[22][1] = new Array(langObj.Schedule.COM_BUTTON_SAVE, "10%", "90%", "80%", "5%", "#FFFFFF", "NotoSans-Regular", "19px");

}
// ========= LOCAL STORAGE SETTER/GETTER ===================

Utils.setLocalStorageValue = function(key,value){
	localStorage.setItem(key,value);
};

Utils.getLocalStorageValue = function(key){
	var storageVal = localStorage.getItem(key);
	if((storageVal!=null || storageVal!=undefined) && storageVal.length>0){
             return storageVal;
       }else{
             return "";
    }
};

// ============== SESSION STORAGE SETTER/GETTER ============

Utils.setSessionStorageValue = function(key,value){
	sessionStorage.setItem(key,value);
};

Utils.getSessionStorageValue = function(key){
	var sessionVal = ""+sessionStorage.getItem(key);
	if(sessionVal=="null" || sessionVal=="undefined")
	 {
        return "";
     }
     return sessionVal;
};

Utils.setSessionStorageValue("locale","en");
Utils.setSessionStorageValue("weatherLocale","en-us");

Utils.getLocaleSessionValue=function()
{
    var val=Utils.getSessionStorageValue("locale");
    if(val=="")
    {
        val="en";
    }
    return val;
};
Utils.getWeatherLangSessionValue=function()
{
    var val=Utils.getSessionStorageValue("weatherLocale");
    if(val=="")
    {
        val="en-us";
    }
    return val;
};

/*Utils.getLatestVersion = function() {
return SOFT_VER;
};
*/

   Utils.hideKeyboardForcely = function(){
         if(isIOS()){
           return;
         }     
         var success = function(result){
           console.log("Hide keyboard forcely..");
         };
         var error = function(message){
          console.log("Unable to hide keyboard forcely..");
         };
         mUtilityManager.hideKeyboardForcely(success,error);
    };



// Keyboard show/hide notification
Utils.registerKeyboardObserver = function() {
    console.log("@registerKeyboardObserver:" + deviceType);

    if (Utils.isIOSDvice()) {
        return;
    }
    var success = function(result) {
        var loc = window.location.href;
        var pageName = loc.split('?')[0].split('/').pop().split('.')[0];
        //Converting the file name to upper case to avoid any kind of conflict regarding case sensitivity
        pageName = pageName.toUpperCase();
        if (result == true) {
            switch(pageName) {
            case 'SEND':
                $('#listContainerId').hide();
                break;
            case 'SETTINGS':
                $('.userpar').hide();
                break;
            case 'SCHEDULE':
                shiftRenamePopUp(true);
                break;
            case 'TEMPLATE':
            case 'ADCLIP':
                shiftRenamePopUp(true);
                break;
            default:
                break;
            }

        } else if (result == false) {
            switch(pageName) {
            case 'SEND':
                $('#listContainerId').show();
                break;
            case 'SETTINGS':
                $('.userpar').show();
                break;
            case 'TEMPLATE':
                callTemplateFunc(constForTmpl.KEYBOARDCLOSE);
                shiftRenamePopUp(false);
                break;
            case 'SCHEDULE':
            case 'ADCLIP':
                shiftRenamePopUp(false);
                break;
            case 'INDEX' :
                $('#Initial_setup_animation .illustration-container svg').css({
                    'margin-top' : '0%'
                });
                $('#Initial_setup_bottom').css({
                    'margin-top' : '0%'
                });
                break;
            default:
                break;
            }
        }
    };
    var error = function(message) {
        console.log("Unable to register keyboard notification");
    };

    mUtilityManager.registerKeyboardObserver(success, error);
};

// Weather image
 Utils.isWeatherImgDownloaded = function() {
     var WeatherImg = localStorage.getItem('WeatherImg');
     if(WeatherImg!=null && (WeatherImg == true || WeatherImg == 'true')){
         return true;
     }else{
         return false;
     }
};


Utils.setWeatherImgDownloaded = function(mWeatherImg) {
   localStorage.setItem('WeatherImg',mWeatherImg);
};

Utils.findAssetsDirItems = function(path) {
    
    var success = function(result){
         console.log(result);
    };
    var error = function(message){
        console.log("Error" + message);
    };
    mUtilityManager.getAppResourceList(success,error,path);
};

Utils.getUpgradeVersion = function() {
    var upgradeVersion = localStorage.getItem('upgradeVersion');
    if ((upgradeVersion != null || upgradeVersion != undefined) && upgradeVersion.length > 0) {
        return upgradeVersion;
    } else {
        return 0;
    }
};

Utils.setUpgradeVersion = function(upgradeVersion) {
    localStorage.setItem('upgradeVersion', upgradeVersion);
};

Utils.isInitialLaunch = function() {
    var isInit = localStorage.getItem('isInit');
    if ((isInit != null || isInit != undefined) && isInit == 'true' || isInit == true) {
        return true;
    } else {
        return false;
    }
};

Utils.setInitialLaunch = function(isInit) {
    localStorage.setItem('isInit', isInit);
};

/**
 * To set player type provide
 * following value only
 *      RMD_MODEL = 1
 *          or
 *      RHE_MODEL = 2
 *           or 
 *      TIZEN_MODEL=3
 */
Utils.setActivePlayerType = function(playerType) {
    var success = function(result) {
	        localStorage.setItem('player_type', playerType);
	        var folderName="";
	        switch(playerType){
			    	case RHE_MODEL:
			    		folderName="RHE";    	   
			    	   break;
			    	case RMD_MODEL:
			    		folderName="RMD";    	   
			    	   break;
			    	case TIZEN_MODEL:
			    		folderName="TIZEN";     	   
			     	   break;
			    	case STRETCH_MODEL:
			    		folderName="RHE_STRETCH";
			    		break;
			       case TIZEN_S5:
                   		folderName="TIZEN_S5";
                        break;
                   case TIZEN_S6:
                        folderName="TIZEN_S6";
                        break;
                   default:
			    	    break;
	        }
	        if(folderName!="")
	    	{
	    		window.localStorage.setItem("CONTENTS_ROOT",".ETabletAuthor/"+folderName);
	    	}	    
        getTemplateInfo(function(bStatus) {
            window.location.href = "../quickstart/QuickStart.html";
            console.log("Templateinfo updated");
        });
        // Update template list according to player type.
    };
    var error = function(message) {
        localStorage.setItem('player_type', null);
    };
    mUtilityManager.setPlayerType(success, error, playerType);
};

/**
 * Player type return
 *       RMD_MODEL = 1
 *          or
 *      RHE_MODEL = 2
 *          or 
 *      TIZEN_MODEL=3
 * 
 *  if no player set then, it will be null
 */
Utils.getActivePlayerType = function() {
    var currPlayer = localStorage.getItem('player_type');
    if (currPlayer != null) {
        currPlayer = getParseIntInDec(currPlayer);
    } else {
        currPlayer = RHE_MODEL;
    }
    return currPlayer;
};

Utils.getUnSupportedPlayerType = function() {
    var currPlayer = localStorage.getItem('player_type');
    console.log("@:getUnSupportedPlayerType: " + currPlayer);
    if (currPlayer == RHE_MODEL) {
        return RMD_MODEL;
    } else {
        return RHE_MODEL;
    }
};

Utils.getPlayerName = function(playerType) {
    playerType = getParseIntInDec(playerType);
    switch(playerType) {
    case RMD_MODEL:
        return langObj.index.MIA_SID_STANDARD_MODEL;
    case RHE_MODEL:
        return langObj.index.MIA_SID_PREMIUM_MODEL;
    case TIZEN_MODEL:
        return langObj.index.MIA_SID_TIZEN;
    case STRETCH_MODEL:
        return "stretchmodel";
    case TIZEN_S5:
        return langObj.index.MIA_SID_S5;
    case TIZEN_S6:
        return langObj.index.MIA_SID_S6;
               
    default:
        return langObj.index.MIA_SID_STANDARD_MODEL;
    }
};
Utils.getContentsRootPath = function() {
    return window.localStorage.getItem("CONTENTS_ROOT");
};

Utils.getPlayerTypeWithModelCode = function(modelCode) {
    console.log("modelCode: " + modelCode);
	modelCode = modelCode.toLowerCase();
	var rheDevice = RHE_DEVICE.toLowerCase();
	var rmdDevice = RMD_DEVICE.toLowerCase();
	var tizenDevice = TIZEN_DEVICE.toLowerCase();
	var strechDevice = STRETCH_DEVICE.toLowerCase();
	var tizen_S5_Device = TIZEN_S5_DEVICE.toLowerCase();
    var tizen_S6_Device = TIZEN_S6_DEVICE.toLowerCase();
	switch(modelCode) {
		case rmdDevice:
			return RMD_MODEL;
		case rheDevice:
			return RHE_MODEL;
		case tizenDevice:
			return TIZEN_MODEL;
		case strechDevice:
			return STRETCH_MODEL;
		case tizen_S5_Device:
			return TIZEN_S5;
        case tizen_S6_Device:
            return TIZEN_S6;
		default:
			return RHE_MODEL;
	}
};

// Method to extract KeyFrame values from the CDATA element
Utils.getCdataKeyFrameValue = function(xmlStr) {
    var cdataText = $(xmlStr).find('KeyFrame').html();
    var pattern = /<!\-\-\[CDATA\[(.*)\]\]\-\->/;
    var result;
    if (pattern.exec(cdataText)) {
        var resultpatten = pattern.exec(cdataText);
        result = resultpatten[1];
    } else {
        result = $(xmlStr).find('KeyFrame').text();
    }
    return result;
};
// Get CDATA value
Utils.getCdataValue = function(xmlStr) {
    var cdataText = xmlStr;
    var pattern = /<!\-\-\[CDATA\[(.*)\]\]\-\->/;
    var result;
    if (pattern.exec(cdataText)) {
        var resultpatten = pattern.exec(cdataText);
        result = resultpatten[1];
    } else {
        result = $(xmlStr).html();
    }
    return result;
};
//To get QueryParams from URL
Utils.getUrlVars = function() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for (var i = 0; i < hashes.length; i++) {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
};
Utils.setCurrStep = function(iStep) {
    //localStorage.setItem("currStep",iStep);
    Utils.currStep = iStep;
};
Utils.getCurrStep = function() {
    return Utils.currStep;
};
/* ---- Code related to generic pop up : Start -------------*/
var genericPopUpObj = null;
var coachmarkPopUpObj = null;
$(document).ready(function() {
    //Load language file
    genericPopUpObj = popUp.intIt();
    coachmarkPopUpObj = coachmarkPopUp.intIt();
});

var popUp = (function(){
   var popUpInstance; //private variable to hold the 
                     //only instance of pop up that will exits.
   var initPopUp = function(){
     var containerID="_genericPopUpId";
    var isPopUpVsble=false;
    var callBackFunArr=[];
    var popUpType;
    var popUpIdenty="";    
    var renderPopUp = function(headerTxt,iType,iIdenty){
        callBackFunArr=[];
        popUpType=iType;
        if(typeof(iIdenty)=="undefined")
        {
            popUpIdenty="";
        }
        else
        {
            popUpIdenty=iIdenty;
        }
        $("#"+containerID).remove(); 
        $("body").append('<div id="'+containerID+'" class="popUpParentCls" >'                             
                             +'<div class="popUpMainInnerCls">'
                                 +'<div class="popUpMainContCls">'            
                                    +'<div class="popUpContentCls">'
                                        +'<table class="popUpInnerTableCls" cellpadding="0" cellspacing="0" border="0">'
                                             +'<tr>'
                                                 +'<td>'
                                                     +'<div id="_popUpContDivId" class="popUpContInnerCls wrapTxtAll"></div>'
                                                 +'</td>'
                                             +'</tr>'
                                         +'</table>'                                        
                                    +'</div>'
                                    +'<div class="popUpFooterCls" id="_popUpFooterDivId">'
                                    +'</div>'                            
                                +'</div>'
                            +'</div>'                                                     
                        +'</div>');
        $("#"+containerID).on("show",function(){
            var btnCount=$("#_popUpFooterDivId").children().length;
            calPopUpDim(popUpIdenty,popUpType,btnCount);
            $("#"+containerID).css("visibility","visible");            
             $("#"+containerID).disableSelection();
        });
        //alert("in creatempop");                                  
     };
     var showPopUp = function(){         
           isPopUpVsble=true;
           $("#"+containerID).show();   
           
           if(Utils.isGalleryOpen==true){
               mUiHandler.addOverLay(true);
           }                    
     };
     var hidePopUp = function(){
           isPopUpVsble=false;
           $("#"+containerID).hide(); 
           if(Utils.isGalleryOpen==true){
              mUiHandler.addOverLay(false);
           }
     };                                                
     var addButtons=function(btnArray){
         var length=btnArray.length;
         $("#_popUpFooterDivId").html('');
         
         for(var i=0;i<length;i++)
         {                         
            callBackFunArr.push(btnArray[i].callback);
            $("#_popUpFooterDivId").append('<div id="PopUpBtn_'+i+'" index="'+i+'"  class="genericBtnCls popUpBtnCls">'+btnArray[i].btntxt+'</div>');
             $("#PopUpBtn_"+i).on("tap",function(e){
                 e.stopPropagation();
                 if($(this).hasClass("icon-disabled"))
                 {
                    return false;
                 }
                 hidePopUp();                 
                 var inx=$(this).attr("index");
                 setTimeout(function(){
                     if(callBackFunArr[inx]!="")
                     {                 
                         if(typeof(window[callBackFunArr[inx]])=="function")
                         {
                             window[callBackFunArr[inx]]();
                         }
                         else
                         {
                             callBackFunArr[inx]();
                         }
                     }  
                 },50);                                                             
                 return false;                             
             });
             $("#PopUpBtn_"+i).on("touchstart",function(e){
                 if(!$(this).hasClass("icon-disabled"))
                 {
                    $(this).addClass("genericBtnCls-active");
                 }
             }).on("touchmove touchend touchcancel",function(e){
                 if(!$(this).hasClass("icon-disabled"))
                 {
                    $(this).removeClass("genericBtnCls-active");
                 }
             });             
         }      
         //alert("add buttons");                                  
     };
     var checkPopUpVisible=function(){
         return isPopUpVsble;
     };
     var appendHTML=function(strHTML){
             var length=strHTML.length;
             $("#_popUpContDivId").html('');
             for(var i=0;i<length;i++)
             {
                 if((length-1)==i)
                 {
                     $("#_popUpContDivId").append(strHTML[i]);    
                 }
                 else
                 {
                     $("#_popUpContDivId").append(strHTML[i]+'<br/>');
                 }
            }  
          //  alert(strHTML);                   
        };
             return {
                    createPopUp: renderPopUp,
                    showPopUp: showPopUp,
                    hidePopUp:hidePopUp,
                    isPopUpVisible:checkPopUpVisible,
                    appendHTMLData:appendHTML,
                    addFooterBtns:addButtons                        
             };
  };
 
  return {
        intIt: function(){
              if(!popUpInstance){                        
                  popUpInstance = initPopUp(); 
              }                  
              return popUpInstance; 
        }
  };
})();


function numericKeyboardButtonPressed(value) {

    console.log("Value Entered:" + value);
    if (value == "Cancel") {
        $('.pintext').text("");
        genericNumericKeyboard.hideGenericNumericKeyboard();
        hidePINVerficationPage();
        cancelPinPopUpButtonPressed();
        return;
    }
    var id = currPinBox.split("pinbox")[1];

    if (id == 4) {
        return;
    }

    if (value == "Delete") {
        if (id == 0) {
            return;
        }
        $("#" + currPinBox).removeClass("pintext-active");
        id--;
        currPinBox = "pinbox" + id;
        $('#' + currPinBox).text("");
        $("#" + currPinBox).addClass("pintext-active");
        return;
    }

    $('#' + currPinBox).text(value);
    $('#' + currPinBox).removeClass("pintext-active");
    if (id == 3) { // 4 digit pin-entered, check for verification
        var pinCode = "";
        $('.pintext').each(function() {
            pinCode += $(this).text();
        });
        currPinBox = "pinbox4";

        // pin verification code goes here

        doPinVerificationProcess(pinCode);

        return;
    }
    id++;
    currPinBox = "pinbox" + id;
    $("#" + currPinBox).addClass("pintext-active");
}

// not required as of now
/*function isPinNotEmpty() {
    var pinValue = "";
    for (var id = 0; id < 4; id++) {
        var val = $('#pinbox' + id).text();
        if (val == "") {
            return pinValue;
        }
        pinValue += val;
    }
    return pinValue;
}*/

function showGenericKeyboard(pinHeaderStr)  {
    var parentID = 'genericNumericKeyboardContainer';
    var mainHeaderHeight = $('#pin_main_header_id').height();
    console.log("mainHeaderHeight: " + mainHeaderHeight);

    WIN_INNER_H -= mainHeaderHeight;

    console.log("WIN_INNER_W: " + WIN_INNER_W);
    console.log("WIN_INNER_H: " + WIN_INNER_H);

    var h_pinContainer = Math.round(WIN_INNER_H * 0.5221);
    console.log("h_pinContainer: " + h_pinContainer);

    var padding_pinHeaderText = Math.round(WIN_INNER_H * 0.0883);
    console.log("padding_pinHeaderText: " + padding_pinHeaderText);

    var lrpadding_pinHeaderText = Math.round(WIN_INNER_W * 0.0608);
    console.log("lrpadding_pinHeaderText: " + lrpadding_pinHeaderText);

    var wh_pinbox = Math.round(WIN_INNER_W * 0.103982);
    console.log("wh_pinbox: " + wh_pinbox);

    var margin_left = Math.round(WIN_INNER_W * 0.0763);
    console.log("margin_left: " + margin_left);

    var h_pinContentWrapper = Math.round(WIN_INNER_H * 0.19);
    console.log("h_pinContentWrapper: " + h_pinContentWrapper);

    var margin_pintext = Math.round((h_pinContentWrapper - wh_pinbox) / 2);
    console.log("margin_pintext: " + margin_pintext);

    var w_header = Math.round(WIN_INNER_W * 0.8783);
    console.log("w_header: " + w_header);

    var h_header = Math.round(WIN_INNER_H * 0.20);
    console.log("h_header: " + h_header);

    var margin_pinwrapper = Math.round(WIN_INNER_W * 0.08628);
    console.log("margin_pinwrapper: " + margin_pinwrapper);

    $('#pinHeaderText').text(pinHeaderStr);
    $("#pin_verification_page_Id #headerTitlea").text(langObj.Send.MIA_SID_PIN);

    var pinHeaderObj = $('#pinHeaderText');
    var pinHeaderFontSize = Utils.getRightFontSize(pinHeaderObj);

    pinHeaderFontSize = Math.max(20, pinHeaderFontSize);

    $('#pinHeaderText').css({
        'width': w_header + 'px',
        'height': h_header + 'px',
        'padding-top': padding_pinHeaderText + 'px',
        'padding-left': lrpadding_pinHeaderText + 'px',
        'padding-right': lrpadding_pinHeaderText + 'px',
        'font-size': pinHeaderFontSize + 'px'
    });

    $('#pinContentWrapper').css({
        'height': h_pinContentWrapper + 'px'
    });

    $('.pintext').css({
        'width': wh_pinbox + 'px',
        'height': wh_pinbox + 'px',
        'line-height': wh_pinbox + 'px',
        'margin-top': margin_pintext + 'px',
        'margin-bottom': margin_pintext + 'px'
    });

    $('.pintext').css({
        'margin-left': margin_pinwrapper + 'px'
    });

    $('.pintext').first().css({
        'margin-left': (margin_left + margin_pinwrapper) + 'px'
    });

    $('#numericKeyBoardParent,#' + parentID).css({
        'height': h_pinContainer + 'px'
    });

    $('.pintext').text("");
    $(".pintext-active").removeClass("pintext-active");
    currPinBox = "pinbox0";
    $("#" + currPinBox).addClass("pintext-active");

    WIN_INNER_H += mainHeaderHeight;

    genericNumericKeyboard.showGenericNumericKeyboard(parentID, numericKeyboardButtonPressed);
}


function calPopUpDim(iIdentifier,iType,iBtnCount)
{   
    var popUpHeight;
    var popUpWidth;    
    var footerHeight;
    var popUpCntntHight,popUpCntntMaxHight;
    var btnWidth;
    var paddingTB=Math.round(WIN_INNER_H*0.04);   
    popUpWidth=Math.round(WIN_INNER_W*0.86);
    footerHeight=Math.round(WIN_INNER_H*0.082);
    popUpCntntHight=Math.round(WIN_INNER_H*0.22);
    popUpCntntMaxHight=Math.round(WIN_INNER_H*0.80);
    
    $(".popUpFooterCls").css({
        'width':popUpWidth+'px'
    });
    
    switch(iBtnCount)
    {
        case 1:
            btnWidth=popUpWidth;
            $("#PopUpBtn_0").width(btnWidth);
        break;
        case 2:
            btnWidth=Math.floor((popUpWidth-2)/2);    
            if(popUpWidth%2!=0)
            {
                $("#PopUpBtn_0").css({
                    'width':(btnWidth+1)+'px'                        
                });                    
            }
            else
            {
                $(".popUpBtnCls").css({
                        'width':btnWidth+'px'
                    });
            }
            $("#PopUpBtn_1").css({
                'width':btnWidth+'px'                                        
            }).addClass("popUpBtnBrdrCls");
        break;
        case 3:            
            btnWidth=Math.floor((popUpWidth-4)/3);
            if(((3*btnWidth)+4)!=popUpWidth)
            {
                $(".popUpBtnCls").css({
                        'width':btnWidth+'px'
                });
                if(popUpWidth-(((3*btnWidth)+4))==1)
                {                    
                    $("#PopUpBtn_0").css({
                        'width':(btnWidth+1)+'px'
                    });                        
                }
                else
                {                    
                    $("#PopUpBtn_0,#PopUpBtn_1").css({
                        'width':(btnWidth+1)+'px'
                    });
                }            
            }
            else
            {
                $(".popUpBtnCls").css({
                        'width':btnWidth+'px'
                    });            
            }
            $("#PopUpBtn_1,#PopUpBtn_2").addClass("popUpBtnBrdrCls");
        break;
        default:
        break;
    }    
    var btnHeight=footerHeight-2;    
    var btnFontSize=Math.round(btnHeight*0.40);
    $(".popUpMainContCls,.popUpMainInnerCls").css({        
        'width':popUpWidth+'px'
    });
    $(".popUpContInnerCls").css({
        'font-size':btnFontSize+'px'
        ,'padding-top':paddingTB+'px'
        ,'padding-bottom':paddingTB+'px'    
    });  
    $(".popUpFooterCls").css({
        'height':btnHeight+'px'
    });
    var paddingTB=Math.round((btnHeight-btnFontSize)/2);   
    $(".popUpBtnCls").css({
        'height':(btnHeight-paddingTB)+'px'        
        ,'font-size':btnFontSize+'px'
        ,'line-height':btnFontSize+'px'        
        ,'float':'left'
        ,'padding-top':paddingTB+'px'        
    });
    /*  WRITE CODE IN THESE CASES IF WANT TO HANDLE SOMETHING FOR PARTICULAR POPUP*/
    var loc=sessionStorage.getItem('locale');
    switch(iIdentifier)
    {   
        case "Location":                    
             Utils.attchLocaPopEvents(btnFontSize);
             break;
         case "country":      
             Utils.attchLocaPopEvents(btnFontSize, iIdentifier);
             break;
         case "city":                    
             Utils.attchLocaPopEvents(btnFontSize, iIdentifier);  
        break;
        case "Wi-Fi":
                btnFontSize=Math.round(btnFontSize*0.87);
                $("#PopUpBtn_0").css({
                   'font-size':btnFontSize+'px'
                   ,'line-height':(btnFontSize*1.2)+'px'
                }).addClass("hAligncenter");
        break;         
        case "renameProj":                    
            $('#tmpltInputId,#inputSchName').focus(function(e) {
                $('#renameProjInputId').addClass('highlighBox');
            }).blur(function(e) {
                $('#renameProjInputId').removeClass('highlighBox');
                Utils.validateFileName("", 2,$(this).attr("id"));                
            }).keyup(function(e){
                if(e.keyCode==13)
                {
                    handleGoBtnEvent($(this));
                    e.preventDefault();
                }                
            });
            $('#tmpltInputId,#inputSchName').on('input', function() {                
                 Utils.validateInputBox(1,$(this).attr("id"),false);
            });   
             $('#tmpltInputId,#inputSchName').off('tap').on('tap', function() {
                if($('#renameProjInputId').hasClass("highlighBox"))
                {
                    Utils.validateFileName("", 2,$(this).attr("id"));                                        
                }
                else
                {
                    $('#'+$(this).attr("id")).focus();
                } 
                $(this).removeClass('disableCopy');      
            });                              
            //attachInputFocusEvnt("tmpltInputCls","popUpMainInnerCls");                        
        break;
        case "EditableStickerText":
            $('#inputSchName').focus(function(e) {
                $('#renameProjInputId').addClass('highlighBox');
            }).blur(function(e) {
                $('#renameProjInputId').removeClass('highlighBox');                
            }).keyup(function(e){
                if(e.keyCode==13)
                {
                    handleGoBtnEvent($(this));
                    e.preventDefault();
                }
                
            });
        break;   
        case "renameSchedule":
            $('#inputSchName').focus(function(e) {
                $('#renameProjInputId').addClass('highlighBox');
            }).blur(function(e) {
                $('#renameProjInputId').removeClass('highlighBox');
                Utils.validateFileName("", 2,$(this).attr("id")); 
            }).keyup(function(e){
                if(e.keyCode==13)
                {
                    
                    $(this).blur();
                    e.preventDefault();
                }
                
            });
            $('#inputSchName').on('input', function() {
                Utils.validateInputBox(1,$(this).attr("id"),false);
            });                        
            $('#inputSchName').off('tap').on('tap', function() {
               if($('#renameProjInputId').hasClass("highlighBox"))
                {
                    Utils.validateFileName("", 2,$(this).attr("id"));                                        
                }
                else
                {
                    $('#'+$(this).attr("id")).focus();
                }    
                $(this).removeClass('disableCopy');                          
            });                               
            //attachInputFocusEvnt("schInputCls","popUpMainInnerCls");  
            break;
            case "addElmInFrmPop":
            	if((loc=="ru"|| loc=="de" || loc=="pt") && $("#PopUpBtn_1").html()==IDS_BTN_ADD)
            	{
	            	btnFontSize=Math.round(btnFontSize*0.87);
	                $(".popUpBtnCls").css({
	                   'font-size':btnFontSize+'px'
	                   ,'line-height':(btnFontSize*1.2)+'px'
	                });
               }
            break;  
            case "Notification":  
		            var loc1 = window.location.href;
			        var pageName1 = loc.split('?')[0].split('/').pop().split('.')[0];
			        //Converting the file name to upper case to avoid any kind of conflict regarding case sensitivity
			        pageName1 = pageName1.toUpperCase();                
	             	if(pageName1 == 'SEND'){
	             		$('.del_icon').removeClass('icon-disabled');
               }
            break;   
        default:                        
        break;
    }
   var calHeight=$(".popUpContInnerCls").outerHeight(true);      
   if(calHeight>popUpCntntHight)
   {       
       if(calHeight>popUpCntntMaxHight)
       {
           calHeight=popUpCntntMaxHight;            
       }
   }
   else
   {
       calHeight=popUpCntntHight;
   }   
   popUpHeight=calHeight+footerHeight;
   $(".popUpContentCls").css({
       'height':calHeight+'px'                   
   });   
   $(".popUpMainContCls,.popUpMainInnerCls").css({
       'height':popUpHeight+'px'
   });
   if(!Utils.isGalleryOpen)
    {
        $(".popUpMainInnerCls").css({
            'top':Math.round((WIN_INNER_H-popUpHeight)/2)+'px'
            ,'left':Math.round((WIN_INNER_W-popUpWidth)/2)+'px'
        });
    }
    else
    {
        $(".popUpMainInnerCls").css({
            'top':Math.round(((WIN_INNER_H*0.55)-popUpHeight)/2)+'px'
            ,'left':Math.round((WIN_INNER_W-popUpWidth)/2)+'px'
        });
    }
    popupTopPos=$(".popUpMainInnerCls").css('top');     
}
function genericOkPopUP(iType,hrdMsg,btnTxt,msgArray)
{        
    genericPopUpObj.createPopUp(hrdMsg,iType);
    genericPopUpObj.appendHTMLData(msgArray);
    genericPopUpObj.addFooterBtns([{"btntxt":btnTxt,"callback":"closeGenericPopUp"}]);
    genericPopUpObj.showPopUp(); 
}
function closeGenericPopUp()
{    
    genericPopUpObj.hidePopUp();    
}

Utils.getRightFontSize=function(txtDivObj)
{
	//var txtDivObj=$("#"+iDivID);
	var maxH=txtDivObj.height();
	var maxW=txtDivObj.width();
	var maxFontSize=getParseIntInDec(txtDivObj.css('font-size'));
	var divHTML=txtDivObj.html();
	var fontFamily=txtDivObj.css('font-family');
	if(fontFamily==undefined || fontFamily=="")
	{
		fontFamily="NotoSans-Regular";
	}	
    $("body").append('<div class="fontDummyDivCls" style="width:10px;height:10px;">'
                        +'<div id="fontDummyDivId" style="font-family:'+fontFamily+';width:'+maxW+'px;border:1px solid red;display:block;" class="wrapTxtAll">'+divHTML+'</div>'
                     +'</div>');
    var divObj=$("#fontDummyDivId");
    divObj.css({
        'font-size':maxFontSize+'px'
    });
    var cntnH=divObj.outerHeight(true); 
  // console.log("Utils.getRightFontSize:: cntnH:"+cntnH+",maxFontSize:"+maxFontSize);
    while(cntnH>maxH && maxFontSize>0)
    {
       maxFontSize--;
       divObj.css({
        'font-size':maxFontSize+'px'
       });
       cntnH=divObj.outerHeight(true);               
    }    
    $(".fontDummyDivCls").remove();    
   //console.log("Utils.getRightFontSize:: 2maxFontSize: "+maxFontSize);
    return maxFontSize<5?5:maxFontSize;
};

Utils.isIOSDvice=function()
{
  if(deviceType.toLowerCase()=="ipad" || deviceType.toLowerCase()=="iphone")
  {
    return true;
  }
  else
  {
      return false;
  }
      
};

var coachmarkPopUp = (function() {
    var isReopenGallery = false;
    var isPopUpVsble = false;
    var popUpInstance;
    //private variable to hold the
    //only instance of pop up that will exits.
    var initPopup = function() {
        var containerID = "_coachmarkpopUpId";
        var renderPopup = function(type, coachmarkCount) {
            if (Utils.isGalleryOpen) {
                isAnimNeeded = false;
                /* Change by sailender.s for DF160725-00079*/
                mUiHandler.hideGallery();
                //galleryContentSel.addGallery(false, _STEPS);
                // Gallery Steps
                isReopenGallery = true;
            } else {
                isReopenGallery = false;
            }

            $("#" + containerID).remove();
            $("body").append('<div id="' + containerID + '" class="coachmarkpopUpParentCls" >' + '<div id="coachmarkpopUpMainInnerId" class="coachmarkpopUpMainInnerCls">' + '<div id="closeBtnID" class="closeBtnCls" >' + '</div>' + '</div>' + '</div>');

            $(".coachmarkpopUpParentCls").off("tap").on("tap", function(e) {
                e.preventDefault();
                e.stopPropagation();
                coachmarkPopUpObj.hidePopUp();
                return false;
            });

            // type            
            if (type < 10)
                var bgUrl = "url(../resource/img/coach_mark/coachmark_bg_0" + type + ".png)";
            else
                var bgUrl = "url(../resource/img/coach_mark/coachmark_bg_" + type + ".png)";

            document.getElementById("coachmarkpopUpMainInnerId").style.backgroundImage = bgUrl;

            var TYPE = type - 1;
            var COUNT = coachmarkCount;

            var BGTextCnt = 0;
			
			switch(TYPE)
			{
				case 0:
					BGTextCnt = 4;
				break;
				case 1:
				case 13:
				case 18:
				case 21:
				case 22:
					BGTextCnt = 2;
				break;
				case 2:
				case 9:
				case 20:
					BGTextCnt = 5;
				break;
				case 3:
				case 10:
				case 11:
				case 14:
				case 16:	
					BGTextCnt = 6;
				break;
				case 4:
				case 5:
					BGTextCnt = 9;
				break;
				case 6:
					BGTextCnt = 12;
				break;
				case 7:
				case 12:
					BGTextCnt = 10;
				break;
				case 8:
				case 15:
					BGTextCnt = 1;
				break;
				case 17:
					BGTextCnt = 7;
				break;
				case 19:
					BGTextCnt = 3;
				break;
				default:
				break;
			}
            
                
            var loc = sessionStorage.getItem('locale');

            for (var i = 0; i < BGTextCnt; i++) {

                var BackgroundTextID = "coachmarkBG_" + i;

                var CoachmarkDiv = $("<div>");

                CoachmarkDiv.attr("id", BackgroundTextID).text(coachMarkBGData[TYPE][i][0]);
                CoachmarkDiv.appendTo($("#coachmarkpopUpMainInnerId"));
                var BackgroundTextElementStyle = document.getElementById(BackgroundTextID).style;

                BackgroundTextElementStyle.position = "absolute";
                BackgroundTextElementStyle.opacity = "0.6";

                document.getElementById(BackgroundTextID).classList.add("coachmarkBGDescriptionCls");
                BackgroundTextElementStyle.left = coachMarkBGData[TYPE][i][1];
                BackgroundTextElementStyle.top = coachMarkBGData[TYPE][i][2];
                BackgroundTextElementStyle.width = coachMarkBGData[TYPE][i][3];
                BackgroundTextElementStyle.height = coachMarkBGData[TYPE][i][4];
                BackgroundTextElementStyle.color = coachMarkBGData[TYPE][i][5];
                BackgroundTextElementStyle.fontFamily = coachMarkBGData[TYPE][i][6];
                BackgroundTextElementStyle.fontSize = coachMarkBGData[TYPE][i][7];

                if (TYPE == "1" && i == 8 && loc == "de" && (isIOS())) {
                    BackgroundTextElementStyle.fontSize = "28px";
                } 
				
				// align
				if( coachMarkBGData[TYPE][i][8] == 1) 
                {
                    BackgroundTextElementStyle.textAlign = "right";
                }
				else if( coachMarkBGData[TYPE][i][8] == 2) 
				{
					BackgroundTextElementStyle.textAlign = "left";
				}else
				{
					BackgroundTextElementStyle.textAlign = "center";
				}
				
            }



            for (var i = 0; i < COUNT; i++) {
                var headlineID = "coachmarkHeadline_" + i;

                var CoachmarkDiv = $("<div>");
                CoachmarkDiv.attr("id", headlineID).text(coachMarkData[TYPE][i][1]);
                CoachmarkDiv.appendTo($("#coachmarkpopUpMainInnerId"));
                var headlineElementStyle = document.getElementById(headlineID).style;
                document.getElementById(headlineID).classList.add("coachmarkHeadlineCls");

                var headlineTop = coachMarkData[TYPE][i][4];
                headlineTop += "%";
                headlineElementStyle.left = coachMarkData[TYPE][i][3];
                headlineElementStyle.top = headlineTop;
                headlineElementStyle.width = coachMarkData[TYPE][i][5];
                headlineElementStyle.height = coachMarkData[TYPE][i][6];
                headlineElementStyle.fontSize = '12px';
                
                if (deviceType == 'iPhone')    headlineElementStyle.fontSize = '11px';

                var descriptionID = "coachmarkDescription_" + i;
                var CoachmarkDiv = $("<div>");
                CoachmarkDiv.attr("id", descriptionID).text(coachMarkData[TYPE][i][2]);
                CoachmarkDiv.appendTo($("#coachmarkpopUpMainInnerId"));
                document.getElementById(descriptionID).classList.add("coachmarkDescriptionCls");
				var descriptionElementStyle = document.getElementById(descriptionID).style;
                var descriptionTop = coachMarkData[TYPE][i][4] + LINEGAP;
                descriptionTop += "%";
                descriptionElementStyle.left = coachMarkData[TYPE][i][3];
                descriptionElementStyle.top = descriptionTop;
                descriptionElementStyle.width = coachMarkData[TYPE][i][5];
                descriptionElementStyle.height = coachMarkData[TYPE][i][6];
                descriptionElementStyle.fontSize = '10px';
                
                if (deviceType == 'iPhone')    descriptionElementStyle.fontSize = '9px';
                
                if( coachMarkData[TYPE][i][7] == 1) 
                {
                    headlineElementStyle.textAlign  = "right";
                    descriptionElementStyle.textAlign  = "right";
                }
            }

        };
        var showPopUp = function() {
            isPopUpVsble = true;
            $("#" + containerID).show();

            if (Utils.isGalleryOpen == true) {
                mUiHandler.addOverLay(true);
            }
        };
        var hidePopUp = function() {
            isPopUpVsble = false;
            $("#" + containerID).hide();

            if (isReopenGallery == true) {
                isAnimNeeded = false;
                galleryContentSel.addGallery(true, _STEPS, DEFAULT_VALUE);
                //_STEPS
                mUiHandler.addOverLay(false);
            }
        };

        return {
            createPopUp : renderPopup,
            showPopUp : showPopUp,
            hidePopUp : hidePopUp
        };
    };

    return {
        intIt : function() {
            if (!popUpInstance) {
                popUpInstance = initPopup();
            }
            return popUpInstance;
        }
    };
})();

/* this method change by sailender.s for DF160725-00079 */
function HelpPopUp(pageType, funCall) {
    initCoachmarkData();
    initCoachmarkBGData();
    funCallBack = funCall;
    var Type;
    var Count;
    _STEPS = GALLERY_STEP1;
    switch(pageType) {
    // 1: QS - Select Content
    case "QS_STEP1":
        Type = 1;
        Count = 3;
        break;

    // 2: QS - Edit Template (shuffle)
    case "QS_STEP2":
        Type = 2;
        Count = 4;
        _STEPS = GALLERY_STEP2;
        break;

    // 3: QS - Edit Template (source browser)
    case "QS_STEP3":
        Type = 3;
        Count = 2;
        _STEPS = GALLERY_STEP2;
        break;

    // 4: QS - Edit Template (Text menu option)
    case "QS_STEP4":
        Type = 4;
        Count = 1;
        _STEPS = GALLERY_STEP2;
        break;

    // 5: QS -  Schedule (basic)
    case "QS_STEP5":
        Type = 5;
        Count = 1;
        break;

    // 6: QS - Schedule (time bar select)
    case "QS_STEP6":
        Type = 6;
        Count = 2;
        break;

    // 7: QS - Schedule (Template&PlayList button select state)
    case "QS_STEP7":
        Type = 7;
        Count = 2;
        break;

    // 8: QS - Send
    case "QS_STEP8":
        Type = 8;
        Count = 2;
        break;

    // 9 : CD - Edit Template (basic)
    case "CD_STEP9":
        Type = 9;
        Count = 6;
        _STEPS = GALLERY_STEP2;
        break;

    // 10 : CD - Edit Template (source browser)
    case "CD_STEP10":
        Type = 10;
        Count = 2;
        _STEPS = GALLERY_STEP2;
        break;

    // 11 : CD - Edit Template (Text menu option)
    case "CD_STEP11":
        Type = 11;
        Count = 1;
        _STEPS = GALLERY_STEP2;
        break;

    // 12 : CD - Schedule
    case "CD_STEP12":
        Type = 12;
        Count = 3;
        break;

    // 13 : CD - Send
    case "CD_STEP13":
        Type = 13;
        Count = 2;
        break;

    // 14 :QS -  Edit Template (basic) / RMD
    case "QS_STEP14":
        Type = 14;
        Count = 3;
        _STEPS = GALLERY_STEP2;
        break;
    
    // 15 : QS - Edit Template (Text menu option)/ RMD
    case "QS_STEP15":
        Type = 15;
        Count = 1;
        _STEPS = GALLERY_STEP2;
        break;
        
    // 16 :CD -  Edit Template (basic) / RMD
    case "CD_STEP16":
        Type = 16;
        Count = 5;
        _STEPS = GALLERY_STEP2;
        break;
    
    // 17 : CD - Edit Template (Text menu option)/ RMD
    case "CD_STEP17":
        Type = 17;
        Count = 1;
        _STEPS = GALLERY_STEP2;
        break;
        
    // 18 : AD - Step2
    case "AD_STEP2":
        Type = 18;
        Count = 3;
        break;
        
    // 19 : AD - Step3 (basic)
    case "AD_STEP3_1":
        Type = 19;
        Count = 3;
        _STEPS = GALLERY_STEP2;
        break;
        
    // 20 : AD - Step3 (click TimeLine)
    case "AD_STEP3_2":
        Type = 20;
        Count = 2;
        _STEPS = GALLERY_STEP2;
        break;
    
    // 21 : AD - Step3 (click menu)
    case "AD_STEP3_3":
        Type = 21;
        Count = 1;
        _STEPS = GALLERY_STEP2;
        break;
        
    // 22 : AD - Step4 (create)
    case "AD_STEP4_1":
        Type = 22;
        Count = 2;
        break;
        
    // 23 : AD - Step4 (save)
    case "AD_STEP4_2":
        Type = 23;
        Count = 3;
        break;
        
    }
    
    coachmarkPopUpObj.createPopUp(Type, Count);
    coachmarkPopUpObj.showPopUp();
}

function closeCoachmarkGenericPopUp() {
    $("#closeBtnID").tap();
}

function isIOS()
{
  if(deviceType=="iPad" || deviceType=="iPhone")
  {
    return true;
  }
  else
  {
      return false;
  }
      
}
function refreshScreen(intrvl) {
    if ($("#refreshDiv").length == 0) {
        $("body").append('<div id="refreshDiv"' + 'style="position: fixed; width: 100%; height: 100%; top: 0px;left: 0px;z-index:999999999;">' + '</div>');
    }
    $("#refreshDiv").show();
    if(intrvl == undefined){
        intrvl = 40;
    }
    setTimeout(function(){
        $("#refreshDiv").hide();        
    },intrvl);    
}
function shiftRenamePopUp(iFlag) {
    if (iFlag) {
        $('.popUpMainInnerCls').css({
            'top' : '5%'
        });

    } else {
        $('.popUpMainInnerCls').css({
            'top' : popupTopPos
        });

    }
}
/*
function attachInputFocusEvnt(inputClsName, parentClsName) {
    var currFocus = false;
    var iFlag = false;
    var popupTopPos = 0;
    if (!Utils.isIOSDvice()) {
        $("." + inputClsName).on('focus', function() {
            if (!iFlag) {
                popupTopPos = $('.' + parentClsName).css('top');
                iFlag = true;
            }
            currFocus = true;
            setTimeout(function() {
                $('.' + parentClsName).css({
                    'top' : '5%'
                });
            }, 100);
        });

        $("." + inputClsName).on('blur', function() {
            currFocus = false;
            setTimeout(function() {
                //alert("currFocus: "+currFocus);
                if (!currFocus) {
                    $('.' + parentClsName).css({
                        'top' : popupTopPos
                    });

                }
            }, 100);
        });
    }
}
*/
/*Jquery plugin to capture show and hide events*/
(function($) {
    $.each(['show', 'hide'], function(i, ev) {
        var el = $.fn[ev];
        $.fn[ev] = function() {
            this.trigger(ev);
            return el.apply(this, arguments);
        };
    });
})(jQuery);
/*function to capture show and hide events*/
/* ---- Code related to generic pop up : End -------------*/

Utils.showToast = function(message) {
    var success = function(result) {
        console.log("result: " + result);
    };
    var error = function(message) {
        console.log("Message: " + message);
    };
    mUtilityManager.showToast(success, error, message);
};

Utils.getCurrentSystemTime = function() {
    var today = new Date();
    var hours = today.getHours();
    var minutes = today.getMinutes();
    var ampm = hours >= 12 ? 'pm' : 'am';
    hours = hours % 12;
    hours = hours ? hours : 12;
    // the hour '0' should be '12'
    minutes = minutes < 10 ? '0' + minutes : minutes;
    var timeFormat = hours + ':' + minutes + ';' + ampm;
    var dd = today.getDate();
    var mm = today.getMonth() + 1;
    //January is 0!
    var yyyy = today.getFullYear();
    if (dd < 10) {
        dd = '0' + dd;
    }
    if (mm < 10) {
        mm = '0' + mm;
    }
    var dateFarmat = yyyy + ':' + mm + ':' + dd;
    var sytemTimeVal = dateFarmat + ';' + timeFormat;
    return sytemTimeVal;
};

/**
 * Function to get Category constant
 * param : category name
 * returns category constant e.g Utils.getCategory('Menu Board') will return Category.MENUBOARD(001)
 */
Utils.getCategory = function(categoryStr) {
    if (categoryStr == null) {
        return null;
    }
    categoryStr = categoryStr.toUpperCase();
    if ((categoryStr.indexOf('MENU') >= 0) && (categoryStr.indexOf('BOARD') >= 0)) {
        return Category.MENUBOARD;
    } else if ((categoryStr.indexOf('INFORMATION') >= 0)) {
        return Category.INFORMATION;
    } else if ((categoryStr.indexOf('SLIDE') >= 0) && (categoryStr.indexOf('SHOW') >= 0)) {
        return Category.SLIDESHOW;
    } else if ((categoryStr.indexOf('LIVE') >= 0) && (categoryStr.indexOf('TV') >= 0)) {
        return Category.LIVETV;
    } else if ((categoryStr.indexOf('PROMOTION') >= 0)) {
        return Category.PROMOTION;
    } else {
        return null;
    }
};

/* Storing array and object in localstorage
 * Added by p.pathak
 */
Storage.prototype.setObj = function(key, obj) {
    return this.setItem(key, JSON.stringify(obj));
};
Storage.prototype.getObj = function(key) {
    return JSON.parse(this.getItem(key));
};

Utils.checkConnection = function() {
    var networkState = navigator.connection.type;
    var states = {};
    states[Connection.UNKNOWN] = 1;
    //'Unknown connection';
    states[Connection.ETHERNET] = 2;
    //'Ethernet connection';
    states[Connection.WIFI] = 3;
    //'WiFi connection';
    states[Connection.CELL_2G] = 4;
    //'Cell 2G connection';
    states[Connection.CELL_3G] = 5;
    //'Cell 3G connection';
    states[Connection.CELL_4G] = 6;
    //'Cell 4G connection';
    states[Connection.CELL] = 7;
    //'Cell generic connection';
    states[Connection.NONE] = 8;
    //'No network connection';
    return states[networkState];
};

Utils.checkIP = function(IPText) {
    var splittedIp = IPText.split(":");
    if(splittedIp.length > 1){
        return Utils.checkIPv6(IPText);
    }else{
        return Utils.checkIPv4(IPText);
    }
};
Utils.checkIPv4 = function(IPText) {
        var ValidIP = true;
        var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
        var ipArray = IPText.match(ipPattern);
        if (IPText == "0.0.0.0") {
            ValidIP = false;
        } else if ((IPText == "255.255.255.255") || ((IPText == "127.0.0.1"))) {
            ValidIP = false;
        }
        if (ipArray == null) {
            ValidIP = false;
        } else {
            for (i = 1; i <= 4; i++) {
                thisSegment = ipArray[i];
                if (thisSegment > 255) {
                    ValidIP = false;
                }
                if ((i == 1)
                        && ((thisSegment > 223) || (thisSegment == 0) || (thisSegment == 127))) {
                    ValidIP = false;
                }
                if ((i == 4) && (thisSegment == 0)) {
                    ValidIP = false;
                }
            }
        }
        return ValidIP;
 };
Utils.checkIPv6 = function(IPText) {
        var ValidIP = true;
        var ipPattern = /(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe;80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))/;

        var ipArray = IPText.match(ipPattern);
        if (ipArray == null) {
            ValidIP = false;
        }
        var splittedIp = IPText.split("::");
        if(splittedIp.length > 2){
            ValidIP = false;
        }
        return ValidIP;
 };
Utils.removeZeros=function(ipText){
    var ipTextArr = ipText.split(":");
    var ipTextArrLen = ipTextArr.length;
    var finalIp = "";

    for(var i = 0; i < ipTextArrLen; i++){
        if(ipTextArr[i] != null && ipTextArr[i] != ""){
            ipTextArr[i] = ipTextArr[i].split(".").map(function(j) {
                if(isNaN(j)){
                    return j;
                }else{
                    return parseInt(j);
                }
            }).join(".");
        }
        finalIp += ipTextArr[i];
        if(i < ipTextArrLen - 1){
            finalIp = finalIp + ":";
        }
    }
    return finalIp;
};
Utils.checkLatestVersion = function() {
    var mURL = "";
    if (Utils.isIOSDvice()) {
        mURL = 'https://itunes.apple.com/lookup?bundleId=' + APP_iOS_PACKAGE_NAME;
    } else {
        mURL = 'https://androidquery.appspot.com/api/market?app=' + APP_ANDROID_PACKAGE_NAME;
    }
    $.ajax({
        type : 'GET',
        url : mURL,
        dataType : 'json',
        timeOut : 10000,
        cache : false,
        success : function(data) {
            var appVersion = "";
            if (Utils.isIOSDvice()) {
                appVersion = data['results'][0]['version'];
            } else {
                appVersion = data['version'];
            }

            console.log("App version: " + appVersion);

            localStorage.setItem('appVersion', appVersion);
        },
        error : function(request, status, err) {
            console.log("App version: - Error: " + err);
            //localStorage.setItem('appVersion',CURRENT_APP_VER);
        }
    });
};

Utils.getLatestVersion = function() {
    var appVersion = localStorage.getItem('appVersion');
    if ((appVersion != null || appVersion != undefined) && appVersion.length > 0) {
        return appVersion;
    } else {
        return CURRENT_APP_VER;
    }
};

Utils.isDownloaded = function(str) {
    var isDownloaded = localStorage.getItem(str);
    if (isDownloaded == '1' || isDownloaded == 1) {
        return true;
    } else {
        return false;
    }
};

Utils.isTemplateDownloaded = function() {
    return this.isDownloaded("isTmpltDownloaded");
};

Utils.isClassicBGDownloaded = function() {
     return this.isDownloaded("isBGClassic");
};

Utils.isModernBGDownloaded = function() {
	return this.isDownloaded("isBGModern");
};

Utils.isVintageBGDownloaded = function() {
    return this.isDownloaded("isBGVintage");
};
//======================== X END X =========================

// ============= MAC Address Info ===========================

Utils.setMacPinValue = function(key,value){
    // TODO: encypted pin will stored only
	localStorage.setItem(key,value);
};

Utils.getMacPinValue = function(key){
	var storageVal = localStorage.getItem(key);
	if((storageVal!=null || storageVal!=undefined) && storageVal.length>0){
             return storageVal;
       }else{
             return "";
    }
};
//========================== END ================================


/**
 * To get downloaded font use this method as below
 *
 * Font File Name -> mEnglishFontList[i].mFontFileName
 * Full Font Url -> mEnglishFontList[i].mFontFileUrl
 * Font Type   ->   mEnglishFontList[i].mFontFileType
 */
Utils.formatFontName=function(fontName)
{
    return fontName.split("_").join(" ") ;
};
Utils.getDownloadedFont = function() {
    var fontPathList = "";
    var engFont = localStorage.getItem("EnglisDownalodedFont_INFO");
    var korFont = localStorage.getItem("KoreanDownalodedFont_INFO");
    var chiFont = localStorage.getItem("ChineseDownalodedFont_INFO");
    
    var langFontArr = [engFont,korFont,chiFont];
    var i,langFontArrLen = langFontArr.length;
    for(i=0;i<langFontArrLen;i++)
    {
    	 if(langFontArr[i] != null && langFontArr[i].length>4){
	        langFontArr[i] = langFontArr[i].substring(1);
	        fontPathList = fontPathList +","+ langFontArr[i];
	    }
	    
    }
    if (fontPathList != null && fontPathList != undefined && fontPathList.length>0) {
        fontPathList = fontPathList.substring(1);
        return fontPathList;
    } else {
        return null;
    }
};


Utils.setActiveStore = function(storeName, id) {
    localStorage.setItem('active_store', storeName);
    localStorage.setItem('active_store_id', id);
};

Utils.getActiveStoreName = function() {
    return localStorage.getItem('active_store');
};

Utils.getActiveStoreId = function() {
    return localStorage.getItem('active_store_id');
};

Utils.getActiveStoreInfo = function() {
    var myStoreInfoJson = {};
    var myStoreInfoArr = [];
    myStoreInfoJson.myStoreInfoArrs = myStoreInfoArr;
    var storeNameVal = localStorage.getItem('active_store');
    var myStoreInfoJson = JSON.parse(sessionStorage.getItem("STORE_INFO"));
    var mStoreInfo;
    var myStoreInfoArrLen = myStoreInfoJson.myStoreInfoArrs.length;
    for (var i = 0; i < myStoreInfoArrLen; i++) {
        if (storeNameVal == myStoreInfoJson.myStoreInfoArrs[i].StoreName) {
            mStoreInfo = myStoreInfoJson.myStoreInfoArrs[i];
            break;
        }
    }
    return mStoreInfo;
};


Utils.createFontListIsDownloadedFlags = function(fontItemsList, flag){
	var fontName;
	if(fontItemsList == undefined || fontItemsList == null){
		return;
	}
	var fontItemsArr = fontItemsList.split(",");
	var len = fontItemsArr.length;
	for(var j=0;j < len;j++){   
   		fontName = Utils.retrieveFileName(fontItemsArr[j]);
   		if(fontName != undefined && fontName != ""){
   			fontListIsDownloadedFlags[fontName] = flag;	
   		}
	}
};

Utils.addFontListOnPage = function() {
try {
        var fontList = "";
        var downFontItems = Utils.getDownloadedFont();
	    var otherFontItems = Utils.getLocalStorageValue('fontList');
	    
        if(downFontItems !=null && downFontItems !="" && downFontItems.length>4){
                fontList = otherFontItems +","+ downFontItems;
        }else{
                fontList = otherFontItems;
        }
	Utils.createFontListIsDownloadedFlags(downFontItems,true);
	Utils.createFontListIsDownloadedFlags(otherFontItems,false);
      
       	var chr = fontList.substring(0,1); 
       	if(chr == ","){
        	fontList = fontList.substring(1); 
       	}
       var dFontListArry = fontList.split(",");
     
       if(dFontListArry!=null)
       {
             fontListArr=[];
            var length = dFontListArry.length;
            $("#allFontListStylID").remove();            
            var tempStr="";
            var fontFileName="";
            var strToken="";
            for(var i=0;i<length;i++)
            {
                fontFileName = Utils.retrieveFileName(dFontListArry[i]);
                fontFileName= fontFileName.substring(0, fontFileName.lastIndexOf('.'));// remove ".ttf""                
                 if(dFontListArry[i].indexOfInsensitive(".EtabletAuthor")!=-1)
                 {                     
                     strToken=Utils.getSystemRootPath();
                     strToken=strToken.substring(0,strToken.length-1);
                 }
                 else
                 {
                     strToken=isIOS()?"":"../../";
                 }
               //tempStr+= "@font-face {font-family: " + fontFileName + ";  src: url("+strToken + dFontListArry[i] + ");}";
               
               if (isIOS() && dFontListArry[i].indexOf("ContentCreator.app")!=-1) {
	                var tempArr = dFontListArry[i].split("www/font");
	                var tempPath = getPhoneGapPathTemplatePage() + 'www/font' + tempArr[1];
	                tempStr+= "@font-face {font-family: " + fontFileName + ";  src: url("+strToken + tempPath + ");}";
	            } else {
	                tempStr+= "@font-face {font-family: " + fontFileName + ";  src: url("+strToken + dFontListArry[i] + ");}";
	          }
			 fontListArr.push(fontFileName);
            } 
            Utils.addCSSStrInPage(tempStr,"allFontListStylID");              
            
           // Utils.uploadAllFontsToMemory(fontListArr);
           
            
            fontListArr.sort(Comparator);
       }
       Utils.uploadAllFontsToMemory(["SamsungSVDMedium_Latin","NotoSans-Regular"]);
   }
   catch(ex)
   {
      console.log("Error: in addFontListOnPage::"+ex.message); 
   }
   /*finally
   {
      Utils.updateFontArrForLan();  
   }*/
};

function getPhoneGapPathTemplatePage() {
    var path = window.location.pathname;
   	path = path.substring(0,path.indexOf("www/template"));
    return path;
}

function Comparator(a, b) {
   if (a.toLowerCase() < b.toLowerCase()) return -1;
   if (a.toLowerCase() > b.toLowerCase()) return 1;
   return 0;
 }

String.prototype.indexOfInsensitive = function (s) {
    return this.toLowerCase().indexOf(s.toLowerCase());
};
Utils.uploadAllFontsToMemory=function(fontListArrTemp)
{
    var length=fontListArrTemp.length;
    var clsStr="";
    $("#dummyTextLoadDivId").remove();
    for (var j = 0; j < length; j++) {
        clsStr += '<div class="textMenuDivP alignCV"><div id="textMenuDiv_' + j + '" style="font-size:10px;font-family:' + fontListArrTemp[j] + '">'
                    + fontListArrTemp[j]
                +'</div></div>';
    }
    $('body').append('<div id="dummyTextLoadDivId" style="visibility:hidden;position:fixed;top:0px;left:0px;height:1px;width:1;overflow:hidden;">'+clsStr+'</div>');
    //console.log("1dummyTextLoadDivId: "+$("#dummyTextLoadDivId").html());
    setTimeout(function(){
        $("#dummyTextLoadDivId").remove();
    },1000);
};
//Get file name from path
Utils.retrieveFileName=function(path) {
    var temp;
    if(path!=undefined && path!=""){
        temp = path.substring(path.lastIndexOf('/') + 1);
        return temp;
    }else{
        return path;
    }    
};

Utils.updateFontArrForLan = function() {
     var currLangCode=sessionStorage.getItem('locale');    
    if(currLangCode!=null && currLangCode!=undefined && currLangCode.toLowerCase()=="zh")
    {
       var fontLen=fontListArr.length;       
       for(var i=0;i<fontLen;i++)
       {
           if(fontListArr[i].indexOfInsensitive("Samsung_SVD_Light_S_CN")!=-1)
           {               
               fontListArr.splice(i,1);
               break;
           }
       }      
       fontListArr.unshift("Samsung_SVD_Light_S_CN");      
    } 
};

Utils.encodeData = function(s) {
    return encodeURIComponent(s).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27").replace(/\(/g, "%28").replace(/\)/g, "%29");
};

Utils.decodeData = function(s) {
    try {
        return decodeURIComponent(s.replace(/\%2D/g, "-").replace(/\%5F/g, "_").replace(/\%2E/g, ".").replace(/\%21/g, "!").replace(/\%7E/g, "~").replace(/\%2A/g, "*").replace(/\%27/g, "'").replace(/\%28/g, "(").replace(/\%29/g, ")"));
    } catch (e) {
    }
    return "";
};

Utils.formatBytes = function(bytes) {
    if (bytes < 1024)
        return bytes + " Bytes";
    else if (bytes < 1048576)
        return (bytes / 1024).toFixed(1) + " KB";
    else if (bytes < 1073741824)
        return (bytes / 1048576).toFixed(1) + " MB";
    else
        return (bytes / 1073741824).toFixed(1) + " GB";
};

Utils.getStorageType = function(mStorage) {
    switch(mStorage) {
    case INTERNAL:
        return langObj.Send.MIA_SID_INTERNAL;
    case USB:
        return langObj.Send.MIA_SID_EXTERNAL;
    case SDCARD:
        return langObj.Send.MIA_SID_EXTERNAL;
    }
};

Utils.getStorageValue = function(mStorage) {
    if (mStorage == 'INTERNAL') {
        return langObj.Send.MIA_SID_INTERNAL;
    } else {
        return langObj.Send.MIA_SID_EXTERNAL;
    }
};
Utils.convertStorageType = function(mStorage) {
    if (mStorage == USB_CONN_RES_CODE) {
        return USB;
    } else if (mStorage == INTERNAL_CONN_RES_CODE) {
        return INTERNAL;
    } else if (mStorage == SDCARD_CONN_RES_CODE) {
        return SDCARD;
    }
};

Utils.isAndroidDevice = function() {
    if (deviceType == 'Android') {
        return true;
    } else {
        return false;
    }
};
Utils.ConvertSecToHHMMSS = function(sec) {
    sec = getParseIntInDec(sec);
    var hr = Math.floor(sec / 3600);
    var min = Math.floor((sec - (hr * 3600)) / 60);
    var remainSec = sec - (hr * 3600) - (min * 60);
    var finalTime = Utils.convertToDblDigit(hr) + ':' + Utils.convertToDblDigit(min) + ':' + Utils.convertToDblDigit(remainSec);
    return finalTime;
};

Utils.convertToDblDigit = function(value) {
    value = getParseIntInDec(value);
    var str = value;

    if (value > 0) {
        if (value <= 9) {
            str = '0' + value;
        }
    } else {
        str = "00";
    }

    return str;
};

Utils.refreshScrollbar = function(scrollObj) {
    if (scrollObj != undefined || scrollObj != null) {
        setTimeout(function() {
            scrollObj.refresh();
        }, 200);
    }
};

Utils.setSystemRootPath = function(rootPath) {
    console.log("SET ROOT PATH " + rootPath);
    sessionStorage.setItem("ROOT_PATH", rootPath);
};
                                                                                                                                                                             
Utils.getUpdatedFilePath = function(currentPath) {
   var updatedSystemPath = Utils.getSystemRootPath();

   if(currentPath!=null && currentPath!=undefined && currentPath.length>0 && currentPath.indexOf("/var/mobile/Containers/Data/Application") != -1 && currentPath.indexOf("Documents/.ETabletAuthor") != -1)
    {
       var updatedFilePath=currentPath.substring(currentPath.indexOf(".ETabletAuthor"),currentPath.length);
       updatedFilePath = updatedSystemPath+updatedFilePath;
       return updatedFilePath;
    }

   return currentPath;
                                                                                                                                                                             
};
                                                                                                                                                                             
Utils.getSystemRootPath = function() {
    var retVal = false;
    var rootPath = sessionStorage.getItem("ROOT_PATH");
    if (rootPath != null) {
        retVal = rootPath;
    } else {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
            var path;
            rootPath = fileSystem.root.toURL().replace("file://", "");
            console.log("retVal " + rootPath + " GET PATH" + Utils.getSystemRootPath());
            retVal = rootPath;
            sessionStorage.setItem("ROOT_PATH", retVal);
            // if(path.localeCompare(Utils.getSystemRootPath())!=0)
            // if(Utils.getSystemRootPath()==null)
            Utils.setSystemRootPath(rootPath);
        }, function() {
            console.log("Error in file system");
        });

    }
    return retVal;
};
Utils.addCSSStrInPage=function(iHTML,id) {
    var special_font = document.createElement("style");
    special_font.type = "text/css";
    special_font.id=id;
    special_font.innerHTML = iHTML;
    document.getElementsByTagName('head')[0].appendChild(special_font);
};
//IOS need to merge in android
$(document).on('blur', 'input, textarea, div[contenteditable="true"]', function() {
    if (Utils.isIOSDvice()) {
        setTimeout(function() {
            window.scrollTo(document.body.scrollLeft, document.body.scrollTop);
        }, 0);
    }
});

//IOS need to merge in android
/*encode the file src in case of special characters*/
Utils.encodeThumbPath = function(ThumbPath) {
    
    return ThumbPath;
    
    if (ThumbPath == undefined || ThumbPath == '') {
        return;
    }
    var filename = ThumbPath.substring(ThumbPath.lastIndexOf("/"), ThumbPath.length);
    var filePath = ThumbPath.substring(0, ThumbPath.lastIndexOf("/"));
    filename = encodeURIComponent(filename);
    while (filename.indexOf("'") != -1) {
        filename = filename.replace("'", "%27");
    }
    while (filename.indexOf("(") != -1) {
        filename = filename.replace("(", "%28");
    }
    while (filename.indexOf(")") != -1) {
        filename = filename.replace(")", "%29");
    }
    var encodedThumbpath = filePath + filename;
    return encodedThumbpath;
    
};

Utils.decodeThumbPath = function(ThumbPath) {
    if (ThumbPath == undefined || ThumbPath == '') {
        return;
    }
    var filename = ThumbPath.substring(ThumbPath.indexOf("%2F"), ThumbPath.length);
    var filePath = ThumbPath.substring(0, ThumbPath.indexOf("%2F"));
    filename = decodeURIComponent(filename);
    var decodedThumbpath = filePath + filename;
    return decodedThumbpath;

};

Utils.isAddTemplateAllowed = function() {
    var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
    var templateLength = 0;
    if (templateInfo != null && templateInfo != "" && typeof templateInfo != "undefined") {
        templateLength = templateInfo.myTemplateInfoArrs.length;
    }
    console.log("--2--Current template Count---: " + templateLength);
    if (templateLength < 30) {
        return true;
    } else {
        $('div.tplActionCls').css({
            'visibility' : 'hidden'
        });
        $('.listDivInfoCls').removeClass('tempDelCopyModeCls');
        $('.hideDelCopy').addClass('tplSchEditCls').removeClass('hideDelCopy');
        Utils.showToast(MIA_SID_MIX_SAVE_UP_TEMPLATES);
        return false;
    }
};

/*
 *  Below function checks for the language selected in ipad/tab and
 *  Loads the language file from javascript
 */

Utils.loadLocale = function() {
    var userLang = navigator.language || navigator.userLanguage;
    var localeNameArr = userLang.split('-');
    var localeName = (localeNameArr[0].split('_')[0]).toLowerCase();
    var loc = window.location.href;
    var output;

    if (deviceType == "iPad") {

        output = (loc.split(".")[1]).split('/').pop();

    } else {

        output = loc.split('/').pop().split('.')[0];
    }

    if (localeArraay.indexOf(localeName) == -1) {
        localeName = "en";
    }
    if (output == 'index') {
        resourcePath = "./resource/lang/";
    } else {
        resourcePath = "../resource/lang/";
    }
    //localeName = "ru";
    sessionStorage.setItem('locale', localeName);
    Utils.setLanguageForWeatherWidget(userLang);
    $.ajax({
        url : resourcePath + localeName + ".js",
        dataType : "script",
        async : false,
        cache : true,
        success : function() {
                           
        } ,
        error: function(jqXHR, textStatus, errorThrown) {               
                console.log('jqXHR:'+jqXHR+",textStatus:"+textStatus+",errorThrown:"+errorThrown);                
            }
    });
};
Utils.setLanguageForWeatherWidget=function(browserLangauge)
{
    browserLangauge = browserLangauge.toLowerCase();
    var localLang=Utils.getLocaleSessionValue();
    var weatherLocale="en-us";
    var index=-1;
    var validLangArr=["ar-eg", "zh-cn", "it-it", "zh-tw", "cs-cz", "en-us", "en-gb", "fi-fi", "fr-fr", "fr-ca", "de-de", "el-gr", "he-il", "ko-kr", "hu-hu", "ru-ru", "sk-sk", "es-es", "es-mx", "sv-se", "tr-tr", "pl-pl", "pt-pt", "pt-br"];
    var tempArray=[];
    var langVal;
    for(var eachLang in validLangArr)
    {
        langVal=validLangArr[eachLang];
        if(langVal.substring(0, 2)== localLang)
        {
            tempArray.push(langVal);
        }
    }
    if(tempArray.length>0)
    {
        weatherLocale=tempArray[0];
        /*uncomment the below code only when you have country/city files for all the code mentioned in "AccLangaugeInfo.JSON" file and then comment the above line*/
        /*index=tempArray.indexOf(browserLangauge);
        if(index!=-1)
        {
            weatherLocale=tempArray[index];
        }
        else
        {
            weatherLocale=tempArray[0];
        }*/
    }
    Utils.setSessionStorageValue("weatherLocale",weatherLocale);
};


//Initialize scrollbars in case its not visible on load

Utils.initializeScrollbar = function(divObj) {

    if (!divObj) {
        var divObj = $(document);
    }
    //Remove Dummy Class which is used to initialize the scrollbar.
    $('.listContainer').append('<div style="height:1500px;width:800px" id="dummyID"></div>');
    setTimeout(function() {
        $('#dummyID').remove();
    }, 1000);
};
Utils.removeSpecialCharacter = function(iTxt) {
    var spclSyblArr = ["%F0", "%E2", "%EF%BF%A6", "%E3%8A%99", "%E3%8A%97", "%E3%80%B0", "%E3%80%BD"];
    var len = spclSyblArr.length;
    var pos = -1;
    var validateTxt = encodeURIComponent(iTxt);
    for (var i = 0; i < len; i++) {
        pos = validateTxt.indexOf(spclSyblArr[i]);
        if (pos != -1) {
           validateTxt = validateTxt.substring(0, pos);
        }
    }                                                                                                                                                                             
    validateTxt = decodeURIComponent(validateTxt);
    return validateTxt;
};
var updtInputIntrvlId;
Utils.validateInputBox=function(iToken,inputBoxId,isDiffSet)
{
    var txtName = $("#"+inputBoxId).val();
    var inputlength = $.trim(txtName).length;
    if(isDiffSet==undefined)
    {
        Utils.trimToCharLimit(inputBoxId,25);
    }
    if(inputlength == 0) {
       clearInterval(updtInputIntrvlId);
       updtInputIntrvlId = null;
    } else {
        Utils.validateFileName(txtName, iToken,inputBoxId,isDiffSet);
    }
    Utils.enableDisableSavebtn(inputBoxId);
};
Utils.enableDisableSavebtn=function(inputBoxId){
	var inputlength = $.trim($("#"+inputBoxId).val()).length;
	console.log("inputlength ****** "+inputlength);
	if(inputlength == 0){
		$("#PopUpBtn_1").addClass("icon-disabled");		
	}else{
		$("#PopUpBtn_1").removeClass("icon-disabled");
    }
};
Utils.validateFileName=function(fileName, iToken,inputBoxId,isDiffSet)
{
    var prevsName="";
    var specialChars="";
    if (iToken == 1 && updtInputIntrvlId != null) {
        window.clearInterval(updtInputIntrvlId);
        updtInputIntrvlId = null;
    }
    if (iToken == 1) {       
       if(isDiffSet)
       {
           specialChars = 'â–ªâ—‹â—�â–¡â– â™¤â™¡â™¢â™§â˜†âŠ™Â°â€¢Â¤ã€Šã€‹Â¡â€¹â€ºâ‚¹';
       }
       else
       {
        specialChars = '*\"\\/:?|+Ã·*ã€Šã€‹Ã—<>+Ã—Ã·=%â‚¬Â£Â¥â‚©@#$^&()\';!,.`~{}[]â–ªâ—‹â—�â–¡â– â™¤â™¡â™¢â™§â˜†âŠ™Â°â€¢Â¤ã€Šã€‹Â¡â€¹â€ºâ‚¹Â¿';
       }
       Utils.f1(fileName, inputBoxId, specialChars, prevsName,isDiffSet); 
        updtInputIntrvlId = setInterval(function() {
            Utils.f1(fileName, inputBoxId, specialChars, prevsName,isDiffSet);                   
       }, 100);
    } else if (iToken == 2) {
        window.clearInterval(updtInputIntrvlId);
        updtInputIntrvlId = null;
    }
};
Utils.f1=function(fileName, inputBoxId, specialChars, prevsName,isDiffSet){
	if(!isDiffSet)
    {
	    var regex;
	    var urlChars = '*\"\\/:?|+.';
	    regex = new RegExp("["+urlChars+"]","g");
	    fileName = fileName.replace(regex, '');
    }
    var specialCharsLen = specialChars.length;
    for (var i = 0; i < specialCharsLen; i++) {
        if (fileName.indexOf(specialChars[i]) > -1) {
            fileName = fileName.replace(specialChars[i], '');
        }
    }
    $("#"+inputBoxId).val(fileName);
    prevsName=fileName;        
    fileName=Utils.removeSpecialCharacter(fileName);           
    if(prevsName!=fileName)
    {
        $("#"+inputBoxId).val(fileName);                  
    }
};

Utils.trimToCharLimit=function(inputBoxId,limitCount)
{
  var inputObj=$("#"+inputBoxId);
  if (inputObj.val().length >= limitCount ){
        var checkSpace = inputObj.val().slice(0,limitCount);
        inputObj.val(checkSpace);
    }
};
Utils.getUniqueArray=function(iArray)
{	
	    var unique = [];
	    var len=iArray.length;
	    for (var i = 0; i < len; i++) {
	        if (unique.indexOf(iArray[i]) == -1) {
	            unique.push(iArray[i]);
	        }
	    }
	    return unique;
};
Utils.setDimXYWH=function(id,x,y,w,h)
{
	$("#"+id).css({
     	'left':x+'px'
     	,'top':y+'px'
     	,'width':w+'px'
     	,'height':h+'px'
     });
};

Utils.hideGallery = function(step,isRef,isAnim) {
    if (Utils.isGalleryOpen) {
        isRefreshNeeded = isRef;
        isAnimNeeded = isAnim;
        addGallery(false, step, DEFAULT_VALUE);
        return true;
    }    
    return false;    
};
Utils.attchLocaPopEvents= function(btnFontSize, locType){
	       if(countryjsonObject==""){
           	  countryjsonObject=Utils.getCountryJSONObj();
           }


           if(locType=='country'){
                Utils.appendListToDropDwn('country',countryxmlObject);
           }else if(locType=='city'){
               Utils.appendListToDropDwn('city',countryxmlObject);
           }
           
           //Country Tap handle
           $('.locationContainer').on('tap', '.radio', function(){
                   $('.radio.selected').removeClass('selected');
                   $(this).addClass('selected');
                   if(locType=='country'){
                    var CityObj = jsonPath(countryjsonObject, '$..Country[?(@.Name == "' + $(".radio.selected").text() +'")]')[0];
                    var cityCodeval = "";
                    var CityFirstObj = CityObj['City'][0];//for first city of country;
                    firstCityInfo.name = CityFirstObj['Name'];
                    firstCityInfo.id = CityFirstObj['Code'].split(":")[1];
                }else if(locType=='city'){
                       firstCityInfo.name = $(this).text();
                    firstCityInfo.id = $(this).attr('CityCode');
                   }
                   else{
                   	console.log("error tap radio button");
                   }
                   
           });
};


function validateLanguageForWeatherWidget(language)
{
 language = language.toLowerCase();
 var validLangArr=["ar-eg", "zh-cn", "it-it", "zh-tw", "cs-cz", "en-us", "en-gb", "fi-fi", "fr-fr", "fr-ca", "de-de", "el-gr", "he-il", "ko-kr", "hu-hu", "ru-ru", "sk-sk", "es-es", "es-mx", "sv-se", "tr-tr", "pl-pl", "pt-pt", "pt-br"];

 if (language.indexOf('-') == -1){
    validLangArr=["en", "de", "es", "fr", "it", "ko", "pl", "pt", "ru", "sv", "th", "tr", "zh"];
 }
 for(var eachLang in validLangArr)
 {
    if(validLangArr[eachLang] == language)
        return true;
 }
 return false;
}


Utils.getCountryJSONObj=function (){
  log.debug("Getting data from JOSN ","getCountryJSONObj");
  var countryjsonObj=null;
  var lang = "en"; //loading english for all language, use following code if want to load file according to user selected language//Utils.getLocaleSessionValue();
  var urlVal = "../resource/JSON/AccuCityInfo/AccuCityInfo_"+lang+".json";
  
   printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","Country xml ajax call");
  $.ajax({
        type: "GET",
        url: urlVal,
        dataType: "json",
        async:true,
        success: function(json) {
           printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","Country json ajax call Success Method");
           countryjsonObject =json;
           log.debug("Data loaded","countryjsonObj");
           loadXml=true;
           printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Country json ajax call Success Method");
        },
        error:function(jqXHR, textStatus, errorThrown)
        {
            log.debug(textStatus + " :: "+ errorThrown,"countryJSONObj");
        }
    });
    printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Country json ajax call");
    return countryjsonObj;
};



var COUNTRY_LIST="";
var CITY_LIST="";
var PREV_COUNTRY="";
Utils.appendListToDropDwn=function(appendTxtBox,countryxmlObject)
{
	var calcHeight = WIN_INNER_H * 33 / 100;
	var calcWidth = $('#' + appendTxtBox).width();
	var liItem = "";
	var countryxmlObject = countryxmlObject;
	//clear every thing before create
	$('.UlContainerCls').remove();
	$('.ul_locCls').html('');
	$('.PopUpTxtBoxCls').removeClass('selectedBox');
	var ListCon = "<div class='UlContainerCls'><ul class='ul_locCls'></ul></div>";
	$('.locationContainer').append(ListCon);
	$('.UlContainerCls').css({
		'height' : calcHeight + 'px',
		'width' : calcWidth + 'px'
	});
	var countryElmObj = "";
	if (appendTxtBox == "country") {
		var selCountry =  $('#countryVal').text();
		if(COUNTRY_LIST==""){
		var cityId=$('#cityVal').data('citycodeatr');
        var nameObj=Utils.getCountryAndCityNameFromCityId(cityId);
        if(nameObj!=null)
        {
            selCountry=nameObj.country;
            $('#countryVal').text(selCountry);
            $('#cityVal').text(nameObj.city);
        }
		countryElmObj = jsonPath(countryjsonObject, "$..Country")[0];
		var showSelected = "";
        $.each(countryElmObj, function(index, obj) {
				var countryName = $(this)[0]['Name'];
				if(selCountry==countryName){
					showSelected = "selected";
				}else{
					showSelected = "";
				}
				COUNTRY_LIST += '<li type=' + appendTxtBox + ' countr-id="'+index+'" country="'+countryName+'" class="liItemCls radio '+showSelected+'"><div class="liItemTxtCls alignV">' + countryName + '</div><li>';
        });
		}
		$('.ul_locCls').append(COUNTRY_LIST);
		if(countryElmObj==""){
			$('.ul_locCls li.selected').removeClass('selected');
			$('.ul_locCls li[country="'+selCountry+'"]').addClass('selected');
		}
	} else if (appendTxtBox == "city") {
		
		var selCity = $('#cityVal').text();
		var showSelected = "";
		var CityObj="";
		if(CITY_LIST=="" || (PREV_COUNTRY!=$('#countryVal').text())){
		    var cityId=$('#cityVal').data('citycodeatr');
            var nameObj=Utils.getCountryAndCityNameFromCityId(cityId);
            var CountrySel=$('#countryVal').text();
		    if(nameObj!=null)
            {
		        selCity = nameObj.city;
			    CountrySel = nameObj.country;
			    $('#countryVal').text(CountrySel);
			    $('#cityVal').text(selCity);
			}
			PREV_COUNTRY = CountrySel;

        CityObj = jsonPath(countryjsonObject, '$..Country[?(@.Name == "' + CountrySel + '")]')[0];
        CityObj = CityObj.City;
        CITY_LIST = "";
        $.each(CityObj, function() {
            var cityName = $(this)[0]['Name'];
            if(selCity==cityName){
                showSelected = "selected";
            }else{
                showSelected = "";
            }
            CITY_LIST += '<li type=' + appendTxtBox + ' city="'+cityName+'"  CityCode=' + $(this)[0]['Code'].split(":")[1] + ' class="liItemCls radio '+showSelected+'"><div class="liItemTxtCls alignV">' + cityName + '</div><li>';
        });
		}
		$('.ul_locCls').append(CITY_LIST);
		if(CityObj==""){
			$('.ul_locCls li.selected').removeClass('selected');
			$('.ul_locCls li[city="'+selCity+'"]').addClass('selected');
		}
	}
	

    var calheight = $('.ul_locCls').height() * 0.20;
    $('.liItemCls').css('height', calheight + 'px'); 
	if($('.radio.selected').length>0){
		$('.ul_locCls').scrollTo($('.radio.selected'), 0);	
	}
   
     
};

Utils.getCountryAndCityNameFromCityId = function(cityId){
	var nameObj=null;
	try{
	    cityId+="";
        if(countryjsonObject!="" && typeof(countryjsonObject)=="object"){
            nameObj={country:'',city:''};
            var country = jsonPath(countryjsonObject, "$..Country")[0];
            var countryName = null;
            if(cityId.indexOf(":")!=-1)
            {
                cityId=cityId.split(":")[1];
            }
            var city=null;
            $.each(country, function() {
                nameObj.country = this.Name;
                city=jsonPath(this, "$..City[?(@.Code == 'cityId:" + cityId +"')]");
                if(city!='' && city!=null && city!=false)
                {
                    nameObj.city=city[0]['Name'];
                    return false;
                }
            });
        }
        else
        {
            nameObj=null;
        }
	}
	catch(ex)
	{
        nameObj=null;
	}
	return nameObj;
};

(function($, undefined) {
    $.fn.getCursorPosition = function() {
        var el = $(this).get(0);
        var pos = 0;
        if ('selectionStart' in el) {
            pos = el.selectionStart;
        } else if ('selection' in document) {
            el.focus();
            var Sel = document.selection.createRange();
            var SelLength = document.selection.createRange().text.length;
            Sel.moveStart('character', -el.value.length);
            pos = Sel.text.length - SelLength;
        }
        return pos;
    };
})(jQuery);

$.fn.setCursorPosition = function(pos) {
    this.each(function(index, elem) {
        if (elem.setSelectionRange) {
            elem.setSelectionRange(pos, pos);
        } else if (elem.createTextRange) {
            var range = elem.createTextRange();
            range.collapse(true);
            range.moveEnd('character', pos);
            range.moveStart('character', pos);
            range.select();
        }
    });
    return this;
};
function getParseIntInDec(iValue) {
    return parseInt(iValue, 10);
}

//Below function loops through Timer name and renames it with Timer1, Timer2 etc...
Utils.renameTimerText = function() {
    $('.MIA_SID_MIX_TIMER').each(function(index, obj) {
        if ($(this).text().indexOf('<<A>>') != -1) {
            $(this).text($(this).text().replace('<<A>>', (index + 1)));
        }

    });
};
Utils.getPageToken=function()
{
   var loc = window.location.href;
    var output = loc.split('?')[0].split('/').pop().split('.')[0];
    if(output=="adClip")
    {
        output="template";
    }
    return output; 
};
Utils.updateHTMLforLocale=function()
{  
    document.addEventListener('deviceready', onDeviceReadyUS, false);
};

function onDeviceReadyUS() {
    var output = Utils.getPageToken();
    if (langObj[output] != undefined) {
        $.each(langObj[output], function(k, v) {
            if (v.indexOf('<<') != -1) {
                $('.' + k).text(v);
            } else {
                $('.' + k).html(v);
            }
        });
                weekDays = [langObj.index.COM_SID_SUNDAY, langObj.index.COM_SID_MONDAY, langObj.index.COM_SID_TUESDAY, langObj.index.COM_SID_WEDNESDAY, langObj.index.COM_SID_THURSDAY, langObj.index.COM_SID_FRIDAY, langObj.index.COM_SID_SATURDAY];
        // initial_Setup 1
        $(".MIA_SID_WHAT_STORE_NAME").text(langObj.index.MIA_SID_WHAT_STORE_NAME);
        $(".MIA_SID_AD_CLIP").text(langObj.QuickStart.MIA_SID_AD_CLIP);
        $("#Store_name_input_box").attr("placeholder",langObj.index.MIA_SID_ENTER_STORE_NAME);
        $(".MIA_SID_ADD_STORE").text(langObj.index.MIA_SID_ADD_STORE);
        $(".VC_IDC_START_TEXT").text(langObj.index.VC_IDC_START_TEXT);
        $(".COM_VC_IDC_END_TEXT").text(langObj.index.COM_VC_IDC_END_TEXT);
        $(".COM_TV_SID_SET_TIME").text(langObj.index.COM_TV_SID_SET_TIME);
        $(".COM_SID_CANCEL").text(langObj.Schedule.COM_SID_CANCEL);
        $(".COM_SID_OK").text(langObj.Schedule.COM_SID_OK);
        $(".MIA_SID_BUSINESS_HOURS").text(langObj.index.MIA_SID_BUSINESS_HOURS);
        $(".MIA_SID_SELELCT_MODEL_TYPE").text(langObj.index.MIA_SID_SELELCT_MODEL_TYPE);  
        $(".MIA_SID_ENTER_STORE_NAME").text(langObj.index.MIA_SID_ENTER_STORE_NAME);
        $(".MIA_SID_YOU_CAN_ENTER_UP_TO_40_CHARACTERS").text(langObj.index.MIA_SID_YOU_CAN_ENTER_UP_TO_40_CHARACTERS);
        $(".MIA_SID_STORE_NAME_ALREADY_USE").text(langObj.index.MIA_SID_STORE_NAME_ALREADY_USE);
        $(".COM_EBD_SPECIAL_CHAR_NOTALLOW_KR_2").text(langObj.index.MIS_SID_MIX_ONLY_FLOOWING_SPECIAL_CHAR);
        // initial_Setup 2
        $(".MIA_SID_WHEN_YOU_OPEN").text(langObj.index.MIA_SID_WHEN_YOU_OPEN);
        $(".MIA_SID_SELECT_BUISNESS_DAYS").text(langObj.index.MIA_SID_SELECT_BUISNESS_DAYS);
        $(".COM_IDS_SUN").text(langObj.index.COM_IDS_SUN);
        $(".COM_IDS_MON").text(langObj.index.COM_IDS_MON);
        $(".COM_IDS_TUE").text(langObj.index.COM_IDS_TUE);
        $(".COM_IDS_WED").text(langObj.index.COM_IDS_WED);
        $(".COM_IDS_THU").text(langObj.index.COM_IDS_THU);
        $(".COM_IDS_FRI").text(langObj.index.COM_IDS_FRI);
        $(".COM_IDS_SAT").text(langObj.index.COM_IDS_SAT);
        $(".MIA_SID_ENTER_BUSINESS_HOURS_SELECTED_DAY").text(langObj.index.MIA_SID_ENTER_BUSINESS_HOURS_SELECTED_DAY);
        $(".COM_IDS_STR_24_HOURS").text(langObj.index.COM_IDS_STR_24_HOURS);
        // initial_Setup 3
        $(".COM_SID_DONE").text(langObj.index.COM_SID_DONE);
        $(".ID_CONTEXT_TABLE_EDIT").text(langObj.index.ID_CONTEXT_TABLE_EDIT);
        $('.COM_TV_MODEL').text(langObj.Settings.COM_TV_MODEL);
        /* =========================*/
        /*       Quick start        */
        /* =========================*/
        if(output.toLowerCase()==='quickstart')
        
        {    
      if(Utils.getActivePlayerType()==STRETCH_MODEL){//Stretch Model
	        $("#QuickStartTxtDescricptionId").append(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN_LET_MAKE_DESIGN_EDITING);  
          }
          else{
          	 $("#QuickStartTxtDescricptionId").append(langObj.QuickStart.MIA_SID_QUICK_START_DESIGN_WIZRD + "<br><br>" + langObj.QuickStart.MIA_SID_CUSTOM_DESIGN_LET_MAKE_DESIGN_EDITING);
          }
            $(".COM_BDP_SID_QUICK_START_TEXT_KR_START").text(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START);
            $(".MIA_SID_CUSTOM_DESIGN").text(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN);
            $(".COM_TV_SID_TUTORIAL").text(langObj.QuickStart.COM_TV_SID_TUTORIAL);
            $(".COM_SID_SETTINGS").text(langObj.QuickStart.COM_SID_SETTINGS);
            $(".COM_MIS_TEXT_EDIT_TEMPLATE_P").text(langObj.QuickStart.COM_MIS_TEXT_EDIT_TEMPLATE_P);
            $(".COM_EDIT_SCHEDULE").text(langObj.QuickStart.COM_EDIT_SCHEDULE);
            //Tutorial
            $(".MIA_SID_TIPS_FOR_BEGINNERS").text(langObj.QuickStart.MIA_SID_TIPS_FOR_BEGINNERS);
            $(".MIA_SID_DESIGN_FOR_INTERMEDIATE_USERS").text(langObj.QuickStart.MIA_SID_DESIGN_FOR_INTERMEDIATE_USERS);
            $(".COM_TEXT_SELECT_CONTENT_P").text("1. " + langObj.QuickStart.COM_TEXT_SELECT_CONTENT_P);
            $(".MIA_SID_SELECT_TEMPLATES").text("2. " + langObj.QuickStart.MIA_SID_SELECT_TEMPLATES);
            $(".MIA_SID_EDIT_SCHEDULES").text("3. " + langObj.QuickStart.MIA_SID_EDIT_SCHEDULES);
            $(".MIA_SID_COMPLETE_YOUR_WORK").text("4. " + langObj.QuickStart.MIA_SID_COMPLETE_YOUR_WORK);
            $(".MIA_SID_EDIT_PLAYLISTS").text("4. " + langObj.QuickStart.MIA_SID_EDIT_PLAYLISTS);
            $(".MIA_SID_DESIGN_ELEMENTS").text("5. " + langObj.QuickStart.MIA_SID_DESIGN_ELEMENTS);
            $(".MIA_SID_CREATE_AD_CLIP").text("6. " + langObj.Adclip.MIA_SID_CREATE_AD_CLIP);
            //Select category
            $(".MIA_SID_WHAT_WANT_CREATE").text(langObj.QuickStart.MIA_SID_WHAT_WANT_CREATE);
            $(".COM_LFD_SID_MENU_BOARD").text(langObj.QuickStart.COM_LFD_SID_MENU_BOARD);
            $(".MIA_SID_LIVE_TV_VIDEOS").text(langObj.QuickStart.MIA_SID_LIVE_TV_VIDEOS);
            $(".COM_SID_SLIDESHOW").text(langObj.QuickStart.COM_SID_SLIDESHOW);
            $(".MIA_SID_PROMOTION").text(langObj.QuickStart.MIA_SID_PROMOTION);
            $(".COM_IDS_MODE_INFORMATION").text(langObj.QuickStart.COM_IDS_MODE_INFORMATION);
            $('.MIA_SID_CREATE_YOUR_OWN_ADS').html(langObj.QuickStart.MIA_SID_CREATE_YOUR_OWN_ADS);
            $('.MIA_SID_QUICK_START_DESIGN_WIZRD').html(langObj.QuickStart.MIA_SID_QUICK_START_DESIGN_WIZRD);
            $('.MIA_SID_CUSTOM_DESIGN_LET_MAKE_DESIGN_EDITING').html(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN_LET_MAKE_DESIGN_EDITING);
        }

        $('.MIA_SID_ABOUT_FONT_LICENSE').text(langObj.Settings.MIA_SID_ABOUT_FONT_LICENSE);
        $('.COM_SOFTWARE_UPDATE').text(langObj.Settings.COM_SOFTWARE_UPDATE);
        $('.MIA_SID_ABOUT_SOFTWARE').text(langObj.Settings.MIA_SID_ABOUT_SOFTWARE);
        $(".MIA_SID_CURRENT_MODEL").text(langObj.index.MIA_SID_CURRENT_MODEL);
        $(".MIA_SID_MENUS_CHANGED_FOR_TYPE").text(langObj.index.MIA_SID_MENUS_CHANGED_FOR_TYPE);
        $(".MIS_SID_SELELCT_ISGNAGE_MODEL").text(langObj.index.MIS_SID_SELELCT_ISGNAGE_MODEL);
        $(".MIS_SID_HOW_CEHCK_SIGNAGE_MODEL").text(langObj.index.MIS_SID_HOW_CEHCK_SIGNAGE_MODEL);
        $(".MIS_SID_TURN_ON_SIGNAGE_HOME_KEY").text(langObj.index.MIS_SID_TURN_ON_SIGNAGE_HOME_KEY);
        $(".MIS_SID_SEE_TOP_LEFT_AREA_HOME_MENU").text(langObj.index.MIS_SID_SEE_TOP_LEFT_AREA_HOME_MENU);
        $(".MIS_SID_HOME_MENU_DISPLAYED_NOT_TV_AGAIN").text(langObj.index.MIS_SID_HOME_MENU_DISPLAYED_NOT_TV_AGAIN);
        $(".MIA_SID_STANDARD_MODEL").text(langObj.index.MIA_SID_STANDARD_MODEL);
        $(".MIA_SID_PREMIUM_MODEL").text(langObj.index.MIA_SID_PREMIUM_MODEL);
        $('.COM_PROPERDLG_FONTSIZE').text(langObj.template.COM_PROPERDLG_FONTSIZE);
        $('.COM_PROPERDLG_FONTCLR').text(langObj.template.COM_PROPERDLG_FONTCLR);
        $('.COM_IDS_FONT_TEXT').text(langObj.template.COM_IDS_FONT_TEXT);
        $('.MIA_SID_BACKGROUND_COLOR').text(langObj.template.MIA_SID_BACKGROUND_COLOR);
        $('.COM_SID_GMT').text(langObj.template.COM_SID_GMT);
        $('.COM_DID_ADMIN_DEVICE_FBASIC_DST').text(langObj.template.COM_DID_ADMIN_DEVICE_FBASIC_DST);
        $('.MIA_SID_REFRESH_INTERVAL_KR_REFRESH').text(langObj.template.MIA_SID_REFRESH_INTERVAL_KR_REFRESH);
        $('.MIA_SID_SLIDE_EIRECTION').text(langObj.template.MIA_SID_SLIDE_EIRECTION);
        $('.MIA_SID_SLIDE_TEXT').text(langObj.template.MIA_SID_SLIDE_TEXT);
        $('.MIA_SID_FLIP').text(langObj.template.MIA_SID_FLIP);
        $('.MIA_SID_SLIDE').text(langObj.template.MIA_SID_SLIDE);
        $('.MIA_SID_TEXT_BACKGROUND_COLOR').text(langObj.template.MIA_SID_TEXT_BACKGROUND_COLOR);
        $('.TxtAnimationId').text(langObj.template.TxtAnimationId);
        $('.FormatId').text(langObj.template.FormatId);
        $('.COM_SID_UNITED_STATES').text(langObj.template.COM_SID_UNITED_STATES);
        $('.MIA_SID_CITY_IMAGE').text(langObj.template.MIA_SID_CITY_IMAGE);
        $('.IDS_WEATHER_IMAGE').text(langObj.template.IDS_WEATHER_IMAGE);
        var addHoliday = "+&nbsp;"+langObj.Settings.COM_LFD_ADD_HOLIDAY;
        $('.COM_LFD_ADD_HOLIDAY').html(addHoliday);
    } else {
        console.log("Failed to load language file");
    }
    //Call rename timer function to show timer as Timer 1, Timer2 etc.
    Utils.renameTimerText();
}

Utils.loadLocale();

jQuery.fn.scrollTo = function(elem, speed, anim) {
    if (anim == undefined) {
        anim = true;
    }
    if (anim) {

        $(this).animate({
            scrollTop : $(this).scrollTop() - $(this).offset().top + $(elem).offset().top
        }, speed == undefined ? 1000 : speed);
    } else {
        $(this).scrollTop($(this).scrollTop() - $(this).offset().top + $(elem).offset().top);
    }
    return this;
};

//CSS animation
(function($) {

    $.fn.cssAnimation = function(options) {
        var settings = $.extend({}, {
            x : 0,
            y : 0,
            duration : '0.5s',
            easing : 'ease',
            onComplete : function() {

            }
        }, options);

        return this.each(function() {
            $(this).css({

                '-webkit-transform' : 'translate(' + settings.x + ', ' + settings.y + ')',
                '-webkit-transition' : 'all ' + settings.duration + ' ' + settings.easing,
                'transform' : 'translate(' + settings.x + ', ' + settings.y + ')',
                'transition' : 'all ' + settings.duration + ' ' + settings.easing
            });

            $(this).one('transitionend webkitTransitionEnd oTransitionEnd otransitionend MSTransitionEnd', function() {
                settings.onComplete.call($(this));
            });

        });
        // end for each

    };
    // end of functions

})(jQuery);
// font to resize for multilang
(function($) {
    $.fn.autoFontSize = function(options) {
        var fontSize = options.maxFontPixels;
        var lineHeight = options.maxFontPixels;
        var minfontSize = options.minFontPixels;
        var textDiv = $(this).find('div:first-child');
        var parentDivMaxHeight = $(this).height();
        var parentDivMaxWidth = $(this).width();
        var txtHeight;
        var txtWidth;
        do {
            textDiv.css('font-size', fontSize + 'px');
            txtHeight = textDiv.height();
            txtWidth = textDiv.width();
            console.log(" autoFontSize parentDivMaxWidth" + parentDivMaxWidth + "txtWidth" + txtWidth);
            fontSize = fontSize - 1;
        } while ((txtHeight > parentDivMaxHeight || txtWidth > parentDivMaxWidth) && fontSize > minfontSize);

        return this;
    };
})(jQuery);

function getTransformValues(obj) {
    if (obj.length == 0) {
        return {
            'x' : null,
            'y' : null
        };
    }
    var obj = obj;
    var transformMatrix = obj.css("-webkit-transform") || obj.css("-moz-transform") || obj.css("-ms-transform") || obj.css("-o-transform") || obj.css("transform");
    var matrix = transformMatrix.replace(/[^0-9\-.,]/g, '').split(',');
    var x = matrix[12] || matrix[4];
    //translate x
    var y = matrix[13] || matrix[5];
    //translate y
    return {
        'x' : x,
        'y' : y
    };
}

function handleMenuOnBack() {
    //In case popup is open
    if (genericPopUpObj.isPopUpVisible()) {
        genericPopUpObj.hidePopUp();
        return false;
    }
	if($('#frameImagesDivId').is(':visible')){
		$('#frameImagesDivId').hide();
		$('#imgEditSubmenu_SlideShow').removeClass('selected');
		return false;
	}
    if ($('#tmpltIcnsParID').hasClass('animateContentMenu')) {
        $('#tmpltIcnsParID').removeClass('animateContentMenu');
        callTemplateFunc(constForTmpl.SHIFTFORMENU, DOWN);
        return false;
    }else if($('.textEnterCls').is(':visible')){
        $('.textInputCls').trigger('blur');
        $('.textEnterCls').hide();
        return false;
    }

    var menuOpen = false;
    var returnVal = true;
    var editMenu = false;
    var commonMenuOpen = false;
    $('.common-menu').each(function() {
        if ($(this).css('display') == 'block') {
            commonMenuOpen = true;
            switch($(this).attr('type')) {
            case 'text':
                if ($('.animateTextList').length > 0) {
                	if($('#imgEditSubmenu_Text').hasClass('selected')){
               			$('.txtEditSubmenu').addClass('animate'); 		
                	}else if($('.shadowOutlineCls').hasClass('selected')){
                		$('.bottom-low').removeClass('bottom-low');
                	}
                    $('.animateTextList').removeClass('animateTextList');
                    
                } else {
                    checkAnimationDiv('text');
                }
                returnVal = false;
                break;
            case 'image':
                if ($('#imgEditSubmenu_SlideShow').hasClass('selected')) {
                    $('#imgEditSubmenu_SlideShow').trigger('tap');
                } else if ($('.imgEditSubmenu_ArrangeCls').hasClass('selected') || $('.opacityCls').hasClass('selected')) {
                    checkAnimationDiv();
                } else {
                    callTemplateFunc(constForTmpl.OUTSIDETAP);
                    menuObj.hideEditMenu();
                }
                returnVal = false;
                break;
            case 'handwriting':
                checkAnimationDiv();
                returnVal = false;
                break;
            case 'video':
                if ($('#videoEditMenu').hasClass('selected')) {
                    $('#videoEditMenu').trigger('tap');
                } else {

                    menuObj.hideEditMenu();
                    callTemplateFunc(constForTmpl.OUTSIDETAP);
                }
                returnVal = false;
                break;
            case 'sticker':
                checkAnimationDiv();
                returnVal = false;
                break;
            case 'source':
                if ($('.imgEditSubmenu_SourceHrList').css('display') == 'block') {
                    $('.imgEditSubmenu_SourceHrList').hide();
                    $('.selected').removeClass('selected');
                } else {
                    callTemplateFunc(constForTmpl.OUTSIDETAP);
                    menuObj.hideEditMenu();
                }

                returnVal = false;
                break;
            case 'clock':
            case 'widget':
             case 'shape':
            case 'web':
            case 'rss':
                if ($('.animateTextList').length > 0) {
                    $('.animateTextList').removeClass('animateTextList');
                } else {
                    checkAnimationDiv('text');
                }
                returnVal = false;
            break;
            case 'doc':
            	$('.PptEditSubmenu').hide();
            	menuObj.hideEditMenu();
                callTemplateFunc(constForTmpl.OUTSIDETAP);
            	returnVal = false;
            break;
            default:
                callTemplateFunc(constForTmpl.OUTSIDETAP);
                menuObj.hideEditMenu();
                break;
            }
        }
    });
    if (!commonMenuOpen) {
        if ($('.imgEditSubmenu_CropBar').css('display') == 'block') {
            $('#cropUndoiconId').trigger('tap');
            return;
        } else if($('.setting-slider').is(':visible')){
            $('.cropUndoicon:visible').trigger('tap');
            return;
        }else {
            $('.animateContentMenu').each(function() {
                if (getTransformValues($(this)).y == '0') {
                    $('.animateContentMenu').removeClass('animateContentMenu');
                    returnVal = false;
                }
            });

            if (returnVal) {
                if (Utils.currStep == STEP_TWO) {
                    if ($('.parentDiv').css('display') == 'block') {
                        $('.shuffleDownCls').trigger('tap');
                        callTemplateFunc(constForTmpl.OUTSIDETAP);
                        return false;
                    }
                }
                if (Utils.currStep == STEP_TWO && (templateObj != null) && ((templateObj.isEdited == true) || (( typeof templatePathFrmUrl == 'undefined') && (tplCategory != Category.CUSTOM)))) {
                    var tplCategory = Utils.getUrlVars()["category"];
                    if(tplCategory!=undefined && tplCategory=='C'){
                        // Its Custom design
                        $('#homeBtnId').trigger('tap');
                        
                    }else{
                       if(!$("#frameImagesDivId").is(':visible'))
                        $('#tmpltPrevBtnId').trigger('tap');    
                    }
                    
                    return false;
                }

            }
        }
    }

    return returnVal;
}

function checkAnimationDiv(type) {
    var editMenu = false;
    $('.editMenu').each(function() {
        var trVal = getTransformValues($(this));
        if (trVal.y == '0' && trVal.x=='0')  {
            $('.animate').removeClass('animate');
            $('.selected').removeClass('selected');
            editMenu = true;
        }
    });
    if (editMenu==false) {
        if($('.setting-slider').is(':visible')){
            $('.cropUndoicon:visible').trigger('tap');
        }else{
            menuObj.hideEditMenu();
            callTemplateFunc(constForTmpl.OUTSIDETAP);    
        }
        
    } else {
        if (type == "text") {
            callTemplateFunc(constForTmpl.SHIFTFORTEXT, DOWN);
        }
        callTemplateFunc(constForTmpl.SHOW_HIDE_ELEMENT_CONTROLS, true);
    }

}

function createTimePickers(type) {
    $('#TimePicker').remove();
    //note5
    var viewportWidth = $(window).width();
    var viewportHeight = $(window).height();
    var headerTitle="";
    headerTitle=langObj.Settings.COM_TV_SID_SET_TIME;
    FonttimerValFrNote_5 = 40;
    if (Utils.isIOSDvice()) {
        FonttimerValFrNote_5 = 36;
    } else {
        if (viewportWidth == 412 &&  (705 <= viewportHeight && viewportHeight <= 709)) {
            FonttimerValFrNote_5 = 50;
        } 
    }
    var UIfrtypes = "";
    switch(type) {
    case 1:
        UIfrtypes = "<div class='secTxtTimer'>" + langObj.Schedule.COM_SID_SEC + "</div>";
        break;
    case 2:
        UIfrtypes = "<div class='minTxtTyp2'>" + langObj.template.COM_TV_SID_MIN + "</div><div class='commonColonCls colonfrTyp2'>:</div><div class='secTxtTyp2'>" + langObj.Schedule.COM_SID_SEC + "</div>";
        break;
    case 3:
        UIfrtypes = "<div class='commonColonCls colonfrTyp3_1'>:</div>";
        break;
    case 4:
        UIfrtypes = "<div class='commonColonCls colonfrTyp2'>/</div>";
        headerTitle=langObj.Settings.COM_SID_SET_DATE;
        break;
    case 6:
        UIfrtypes = "<div class='secTxtTimer webRefreshHr webRefClr'>h</div><div class='commonColonCls colonfrTyp3_1'>:</div><div class='secTxtTimer webRefreshMin webRefClr'>m</div><div class='commonColonCls colonfrTyp3_2'>:</div><div class='secTxtTimer webRefreshSec webRefClr'>s</div>";
        headerTitle = langObj.template.MIA_SID_REFRESH_INTERVAL_KR_REFRESH;
        break;
    default:
        break;
    }
    var createTimePicker = "<div class='bodyCls'><div class='containerCls'>"
                                +"<div class='headerClsTi'>" + headerTitle + "</div>"
                                +"<div  class='TimePickerConCls'>"
                                    +"<div class='TimePickerSubConCls'><div id='TimePicker'></div></div>"
                                    +"<div class='highlight1'></div>"
                                    +"<div class='highlight2'></div>"
                                    + UIfrtypes
                                +"</div>"
                                +"<div class='buttonClsTi'>" + langObj.Schedule.COM_SID_OK + "</div>"
                                +"</div><div>";
    $('body').append(createTimePicker);
    $('.bodyCls').removeClass('Can_Not_Selected');
    $('.buttonClsTi').authorActiveClass();
    if (Utils.isIOSDvice()) {
            
            $('#TimePicker').addClass('addFontIosCls');
            $('.TimePickerSubConCls').addClass('addMarTopIosCls');
            
        }

};
function closeTimePicker() {
    $("#TimePicker").remove();
    $('.bodyCls').remove();
}
/*
 * Get current time/date
 *  second argument in below function is optional
 *  To get time/date of any other timezone, just pass the timezone string in the second argument in below function
 *  i.e. getDateTime(1, '(GMT+05:30) Chennai, Kolkata, Mumbai, New Delhi')
 */
function getDateTime(format, elemType, timeWithTimeZone, displayLang)
{
    var dayArray = [langObj.index.COM_SID_SUN, langObj.index.COM_SID_MON, langObj.index.COM_SID_TUE, langObj.index.COM_SID_WED, langObj.index.COM_SID_THU, langObj.index.COM_SID_FRI, langObj.index.COM_SID_SAT];
    var timeInfo = "";
    var dateObj;
    if(timeWithTimeZone){
        var timestamp;
        var offset = getOffsetFromGMT(timeWithTimeZone);
        offset = getHourMinFraction(offset);
        timestamp = getTimeWithTimeZone(offset);
        console.log(timeWithTimeZone);

        dateObj = new Date(timestamp);
    }else{
         dateObj = new Date();
    }
    console.log("dateObj "+dateObj);
    var year = dateObj.getFullYear();
    var month = dateObj.getMonth();
    var date = dateObj.getDate();
    var day = dateObj.getDay();
    var hr = dateObj.getHours();
    var min = dateObj.getMinutes();
    var sec = dateObj.getSeconds();
    var ampm = hr >= 12 ? langObj.Schedule.COM_BDP_SID_PM_TEXT : langObj.Schedule.COM_BDP_SID_AM_TEXT;
    var formatObj;
    if(elemType == widgetInfo.WEATHER_HOUR || elemType == widgetInfo.WEATHER_TODAY || elemType == widgetInfo.WEATHER_WEEK){
        formatObj = weatherDateType;
    }else{
        formatObj = digiClokType;
    }
    switch(format){
        case formatObj.HM12_AMPM:
            //Time in 12 hour format with AM/PM
            hr = hr%12;
            if(hr==0 && ampm=='PM'){
                hr = 12;
            }
            timeInfo = hr + ":" + Utils.convertToDblDigit(min) + " " + ampm;
        break;
        case formatObj.HM12_AMPM_DOW:
            //Time in 12 hour format with AM/PM and Day
            hr = hr%12;
            if(hr==0 && ampm=='PM'){
                hr = 12;
            }
            timeInfo = hr + ":" + Utils.convertToDblDigit(min) + " " + ampm +" "+dayArray[day];
        break;
        case formatObj.HM24:
            //Time in 24 hour format
            timeInfo = hr + ":" + Utils.convertToDblDigit(min);
    
        break;
        case formatObj.HM24_DOW:
            //Time in 24 hour format with Day of week
            timeInfo = hr + ":" + Utils.convertToDblDigit(min) + " " + dayArray[day];
    
        break;
        case formatObj.HMS24_DOW:
            //Time in 24 hour format with sec and Day of week
            timeInfo = hr + ":" + Utils.convertToDblDigit(min) +":"+Utils.convertToDblDigit(sec)+ " " + dayArray[day];
    
        break;
        case formatObj.YR_MNTH_DAY_HYFN:
            //YYYY-MM-DD
            timeInfo = year +"-"+ Utils.convertToDblDigit(month+1) +"-"+ Utils.convertToDblDigit(date);
        break;
        case formatObj.MNTH_DAY_YR_HYFN:
            //MM-DD-YYYY
            timeInfo =  Utils.convertToDblDigit(month+1) +"-"+ Utils.convertToDblDigit(date) +"-"+ year;
        break;
        case formatObj.DAY_MNTH_YR_HYFN:
            //DD-MM-YYYY
            timeInfo =  Utils.convertToDblDigit(date) +"-"+ Utils.convertToDblDigit(month+1) +"-"+ year;
    
        break;
        case formatObj.YR_MNTH_DAY_BKSLSH:
            //YYYY/MM/DD
            timeInfo = year +"/"+ Utils.convertToDblDigit(month+1) +"/"+ Utils.convertToDblDigit(date);
    
        break;
        case formatObj.MNTH_Day_YR_BKSLSH:
            //MM/DD/YYYY
            timeInfo = Utils.convertToDblDigit(month+1) +"/"+ Utils.convertToDblDigit(date) +"/"+ year;
        break;
        case formatObj.DAY_MNTH_YR_BKSLSH:
            //DD-MM-YYYY
            timeInfo =  Utils.convertToDblDigit(date) +"/"+ Utils.convertToDblDigit(month+1) +"/"+ year;
    
        break;
        case formatObj.MNTH_DAY_BKSLSH:
            //MM/DD
            timeInfo = Utils.convertToDblDigit(month+1) +"/"+ Utils.convertToDblDigit(date);
    
        break;
        default:
        //Left blank intentionally
        break;
    }
    if(formatObj == digiClokType && displayLang!= 1 && format < 5){
        timeInfo = TemplateUtils.processDigClkJSONFillData(displayLang, format, timeInfo);
    }
    return timeInfo;
}

function getTimeWithTimeZone(offset){
        
        var d = new Date();
        localTime = d.getTime();
        localOffset = d.getTimezoneOffset() * 60000;

        // obtain UTC time in msec
        utc = localTime + localOffset;
        // create new Date object for different city
        // using supplied offset
        var nd = new Date(utc + (3600000*offset));
        //nd = 3600000 + nd;
        //utc = new Date(utc);
        // return time as a string
        //console.log(nd.toLocaleString()+" "+utc.toLocaleString()+" "+nd);
        return utc + (3600000*offset);
       
}

function getOffsetFromGMT(gmt){
    if(gmt){
        var regExp = /\(([^)]+)\)/;
        var matches = regExp.exec(gmt)[1];
        var offsetVal;
        if(matches.indexOf('GMT')!=-1){
            offsetVal = matches.replace('GMT', '');
            return offsetVal;
        }

    }
    
}
function getHourMinFraction(hourmin){
    //Changes 05:30 to 5.5
    var retVal="0.0";
    if(hourmin && hourmin.indexOf(':')!=-1){
        hourmin = hourmin.split(':');
        var hr = hourmin[0];
        var min = hourmin[1];
        retVal = hr +'.'+ (min*10/6);
    }
    return retVal;
}

(function($) {
  $.fn.outerHTML = function() {
    return $(this).clone().wrap('<div></div>').parent().html();
  };
})(jQuery);

function getGMTTimeZoneList(fontSize,offset){
    var timezoneJSON =[{"offset":"","offsetMinute":"-12:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000000,"daylight":false},{"offset":"","offsetMinute":"-11:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000001,"daylight":false},{"offset":"","offsetMinute":"-10:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000002,"daylight":false},{"offset":"","offsetMinute":"-09:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000003,"daylight":false},{"offset":"","offsetMinute":"-08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000045,"daylight":false},{"offset":"","offsetMinute":"-08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000004,"daylight":false},{"offset":"","offsetMinute":"-07:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000044,"daylight":false},{"offset":"","offsetMinute":"-07:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000000D,"daylight":false},{"offset":"","offsetMinute":"-07:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000000F,"daylight":false},{"offset":"","offsetMinute":"-07:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000000A,"daylight":false},{"offset":"","offsetMinute":"-06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000021,"daylight":false},{"offset":"","offsetMinute":"-06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000014,"daylight":false},{"offset":"","offsetMinute":"-06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000019,"daylight":false},{"offset":"","offsetMinute":"-06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000043,"daylight":false},{"offset":"","offsetMinute":"-06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000001E,"daylight":false},{"offset":"","offsetMinute":"-05:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000028,"daylight":false},{"offset":"","offsetMinute":"-05:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000002D,"daylight":false},{"offset":"","offsetMinute":"-05:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000023,"daylight":false},{"offset":"","offsetMinute":"-04:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_8000004B,"daylight":false},{"offset":"","offsetMinute":"-04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000038,"daylight":false},{"offset":"","offsetMinute":"-04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000048,"daylight":false},{"offset":"","offsetMinute":"-04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000037,"daylight":false},{"offset":"","offsetMinute":"-04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000032,"daylight":false},{"offset":"","offsetMinute":"-03:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000003C,"daylight":false},{"offset":"","offsetMinute":"-03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000041,"daylight":false},{"offset":"","offsetMinute":"-03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000046,"daylight":false},{"offset":"","offsetMinute":"-03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000049,"daylight":false},{"offset":"","offsetMinute":"-03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000049,"daylight":false},{"offset":"","offsetMinute":"-02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000004B,"daylight":false},{"offset":"","offsetMinute":"-01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000050,"daylight":false},{"offset":"","offsetMinute":"-01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000053,"daylight":false},{"offset":"","offsetMinute":"","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000055,"daylight":false},{"offset":"","offsetMinute":"",
    "timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000005A,"daylight":false},{"offset":"","offsetMinute":"+01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000005F,"daylight":false},
    {"offset":"","offsetMinute":"+01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000069,"daylight":false},{"offset":"","offsetMinute":"+01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000064,"daylight":false},{"offset":"","offsetMinute":"+01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000071,"daylight":false},{"offset":"","offsetMinute":"+01:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000006E,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000073,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000041,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000082,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000042,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000087,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000078,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000008C,"daylight":false},{"offset":"","offsetMinute":"+02:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000007D,"daylight":false},{"offset":"","offsetMinute":"+03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000009B,"daylight":false},{"offset":"","offsetMinute":"+03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000091,"daylight":false},{"offset":"","offsetMinute":"+03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000009E,"daylight":false},{"offset":"","offsetMinute":"+03:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000096,"daylight":false},{"offset":"","offsetMinute":"+03:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000A0,"daylight":false},{"offset":"","offsetMinute":"+04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_80000040,"daylight":false},{"offset":"","offsetMinute":"+04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000A5,"daylight":false},{"offset":"","offsetMinute":"+04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_8000004A,"daylight":false},{"offset":"","offsetMinute":"+04:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000AA,"daylight":false},{"offset":"","offsetMinute":"+04:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000AF,"daylight":false},{"offset":"","offsetMinute":"+05:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000B4,"daylight":false},{"offset":"","offsetMinute":"+05:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000B9,"daylight":false},{"offset":"","offsetMinute":"+05:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000C8,"daylight":false},{"offset":"","offsetMinute":"+05:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000BE,"daylight":false},{"offset":"","offsetMinute":"+05:45","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000C1,"daylight":false},{"offset":"","offsetMinute":"+06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000C3,"daylight":false},{"offset":"","offsetMinute":"+06:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000C9,"daylight":false},{"offset":"","offsetMinute":"+06:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000CB,"daylight":false},{"offset":"","offsetMinute":"+07:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000CD,"daylight":false},{"offset":"","offsetMinute":"+07:00",
    "timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000CF,"daylight":false},{"offset":"","offsetMinute":"+08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000D2,"daylight":false},{"offset":"","offsetMinute":"+08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000E3,"daylight":false},{"offset":"","offsetMinute":"+08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000D7,"daylight":false},{"offset":"","offsetMinute":"+08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000DC,"daylight":false},{"offset":"","offsetMinute":"+08:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000E1,"daylight":false},{"offset":"","offsetMinute":"+09:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000E6,"daylight":false},{"offset":"","offsetMinute":"+09:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000F0,"daylight":false},{"offset":"","offsetMinute":"+09:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000EB,"daylight":false},{"offset":"","offsetMinute":"+09:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000F5,"daylight":false},{"offset":"","offsetMinute":"+09:30","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000FA,"daylight":false},{"offset":"","offsetMinute":"+10:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000113,"daylight":false},{"offset":"","offsetMinute":"+10:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000104,"daylight":false},{"offset":"","offsetMinute":"+10:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000010E,"daylight":false},{"offset":"","offsetMinute":"+10:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_000000FF,"daylight":false},{"offset":"","offsetMinute":"+10:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000109,"daylight":false},{"offset":"","offsetMinute":"+11:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000118,"daylight":false},{"offset":"","offsetMinute":"+12:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000011D,"daylight":false},{"offset":"","offsetMinute":"+12:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_00000122,"daylight":false},{"offset":"","offsetMinute":"+13:00","timezone":langObj.TimeZone.DID_ADMIN_DEVICE_FBASIC_TIMEZONE_0000012C,"daylight":false}];
    var fontSize = fontSize || '';
    var timeZoneStr = "";
    if(offset){
    	for(var i=0;i<timezoneJSON.length;i++){
    		if(offset==timezoneJSON[i].offsetMinute){
        		return timezoneJSON[i].timezone;
            	}
        }
	}else{
		for(var i=0;i<timezoneJSON.length;i++){
	        	timeZoneStr += "<li class='menu-li menu-list' data-name='timezone' style='width:160%;' data-val='"+timezoneJSON[i].offsetMinute+"'><div class='textEllipsis' style='font-size:"+fontSize+"px'>"+timezoneJSON[i].timezone+"</div></li>";
		    }
		    return timeZoneStr;
    }
}
function getTimeZoneOffsetHrMin() {
    var offset = new Date().getTimezoneOffset(), o = Math.abs(offset);
    return (offset < 0 ? "+" : "-") + ("00" + Math.floor(o / 60)).slice(-2) + ":" + ("00" + (o % 60)).slice(-2);
};

String.prototype.capitalize = function() {

    return this.charAt(0).toUpperCase() + this.slice(1).toLowerCase();
};
function handleGoBtnEvent($this)
{
    
    var str = $this.val();
    var index = $this.getCursorPosition();
    var isSch = $this.attr("isSchedule");
    if ($.trim(str.charAt(index - 1)) === "" && isSch != "true") {
        var newStr = (index <= $.trim(str).length) ? str.replaceWithOriginal(index) : $.trim(str);
        $this.val(newStr);
    }

    $this.blur();
            
}
// go btn ading 2spaces in input box handling
String.prototype.replaceWithOriginal = function(index) {
  return this.substring(0,index-2)+this.substring(index);
};

function setBGaddStokeIfBgWhite(divID,bgColor)
{    
   //console.log("new code---v---");
    var divObj=$("#"+divID);    
    var boxShadow="";
   if ((bgColor.match(/255/g)|| []).length==3)
   {
      boxShadow="0px 0px 0px 1px #C3C3C3";       
   }   
  divObj.css({
      'background-color':bgColor
        ,'box-shadow':boxShadow
    });
}

function rgbToRgba(rgbval, alpha){
	var alphaVal = alpha == undefined ?1:alpha;
	var new_col;
	if(rgbval.indexOf('rgba')==-1){
		var new_col = rgbval.replace(/rgb/i, "rgba");
		new_col = new_col.replace(/\)/i,','+alphaVal+')');
	}else{
		new_col = rgbval;
		new_col = new_col.replace(/[\d\.]+\)$/g,alphaVal+')');
	}
	 
	return new_col;
}
Utils.getDirectoryPathUptoWww=function()
{
   	
   	if(isIOS())
   	{
		var loc = window.location.pathname;
   		return loc.substring(0,loc.indexOf('www/'));
   	}
   	else
   	 	return '';
};
var escapeCharArr=[{code:"&lt;",char:"<"},{code:"&gt;",char:">"}];
Utils.convertCharToEscapeCode=function(str)
{
    /*Inserting "&" code at the start of escape array*/
   escapeCharArr.splice(0,0,{code:"&amp;",char:"&"});
    var len=escapeCharArr.length;
    var arrData;
    for(var i=0;i<len;i++)
    {
        arrData=escapeCharArr[i];
        str=Utils.getReplacedString(str,arrData.char,arrData.code);
    }
    escapeCharArr.splice(0,1);
    return str;
};
Utils.convertEscapeCodeToChar=function(str)
{
    /* Inserting "&" code at the end of escape array*/
    escapeCharArr.splice(escapeCharArr.length,0,{code:"&amp;",char:"&"});
    var len=escapeCharArr.length;
    var arrData;
    for(var i=0;i<len;i++)
    {
        arrData=escapeCharArr[i];
        str=Utils.getReplacedString(str,arrData.code,arrData.char);
    }
    escapeCharArr.splice(len-1,1);
    return str;
};
Utils.isHighEndModel=function(model)
{
    if (model != RHE_MODEL && model != RMD_MODEL && model != STRETCH_MODEL)
    {
        return true;
    }
    return false;
}
Utils.getReplacedString=function(str,searchStr,replaceStr)
{
    var regex=new RegExp(searchStr, "ig");
    str=str.replace(regex,replaceStr);
    return str;
};
//Loading Language File
function loadjscssfile(filename, filetype){
    
    var fileref;
    if (filetype=="js"){ //if filename is a external JavaScript file
     fileref=document.createElement('script');
     fileref.setAttribute("type","text/javascript");
     fileref.setAttribute("charset", "utf-8");
     fileref.setAttribute("src", filename);
     
    }
    else if (filetype=="css"){ //if filename is an external CSS file
     fileref=document.createElement("link");
     fileref.setAttribute("rel", "stylesheet");
     fileref.setAttribute("charset", "utf-8");
     fileref.setAttribute("type", "text/css");
     fileref.setAttribute("href", filename);
     
    }
    if (typeof fileref!="undefined"){
     document.getElementsByTagName("head")[0].appendChild(fileref);
    }
    
}
function returnToHome(){
    document.location.href = "../quickstart/QuickStart.html";
}
Utils.getHMSFrmTime = function(time){
    var time = time +"";
    var timeToUpdate = {};
    var splitTime = time.split(':');
    timeToUpdate.hr = splitTime[0];
    timeToUpdate.min = splitTime[1];
    timeToUpdate.sec = splitTime[2];
    return timeToUpdate;
};

function isNull(x) {
    return (x == undefined || x == null);
}
Utils.ascii_to_hexa= function(str, privateKey){
	var arr1 = [];
	var l = str.length;
	var hex;
    for (var n = 0; n < l; n ++)
    {
        hex = Number(str.charCodeAt(n)).toString(16);
        arr1.push(hex);
    }
    return arr1.join(privateKey);
};
Utils.hex_to_ascii= function(str1, privateKey){
	var hex  = str1.split(privateKey);
	var l = hex.length;
    var str = '';
    for (var n = 0; n < l; n++) {
        str += String.fromCharCode(parseInt(hex[n], 16));
    }
    return str;
};
Utils.replaceLastBrOfText= function(text){
      try
      {
          var textLength=text.length;
          var last4Char=text.slice(-4);
          while(last4Char.toLowerCase()=="<br>" && textLength>0)
          {
              text=$.trim(text.substr(0, textLength-4));
              textLength=text.length;
              last4Char=text.slice(-4);
          }
      }
      catch(ex)
      {
          log.debug("Error: "+ex,"replaceLastBrOfText");
      }
      return text;
};