/*
 how to use.
 1. Include file in html page
 2. call  fontUtils.initFont(); // call after ready only
 3. call fontUtils.isFontLoaded('font name') to check. Will return true or false.
 */

 var fontLoadedInHtml = {};
 var fontUtils = {
 	dfltFont:{fontFmly:"sans-serif",H:0,W:0},
 	dfltStr:"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",
 	fontSize:"90px",
 	headElm:null,
 	isInitialized:false,
 	spanElm:document.createElement("span")
 };
 fontUtils.getRenderedFontDimensions=function(fontFamilyString)
 {
    var dim={W:0,H:0};
  	this.spanElm.style.fontFamily = fontFamilyString;
  	this.headElm.appendChild(this.spanElm);
  	dim.W = this.spanElm.offsetWidth;
  	dim.H = this.spanElm.offsetHeight;
  	this.headElm.removeChild(this.spanElm);
  	console.log("--font--1,"+fontFamilyString+"-H:"+dim.H+",W:"+dim.W);
  	return dim;
 };
 fontUtils.initFont=function()
 {
 	this.headElm=document.getElementsByTagName("body")[0];
 	this.spanElm.style.fontSize = this.fontSize;
    this.spanElm.innerHTML = this.dfltStr;
    this.dfltFont.fontFmly=Utils.isIOSDvice()?"RibeyeMarrow-Regular":"sans-serif";
    var dim=this.getRenderedFontDimensions(this.dfltFont.fontFmly);
 	this.dfltFont.W = dim.W;
 	this.dfltFont.H = dim.H;
 	this.isInitialized = true;
 };
 fontUtils.isFontLoaded=function(fontName)
 {
     if(!this.isInitialized){
         this.initFont();
     }
 	if(fontName!=this.dfltFont.fontFmly)
 	{
 		var isDetected = false;
 		var match=false;
 		// name of the font along with the base font for fallback.
 		var dim=this.getRenderedFontDimensions(fontName + ',' + this.dfltFont.fontFmly);
 		match = (dim.W != this.dfltFont.W || dim.H != this.dfltFont.H);
 		isDetected = isDetected || match;
 		if(isDetected){
 		    fontLoadedInHtml[fontName] = true;
 		}
 		return isDetected;
 	}
 	return true;
 };
 fontUtils.isFontLoadedInMemory=function(fontName,callback)
 {
     if(this.isFontLoadedInHtml(fontName)){
         callback.apply();
         return;
     }
 	printGetTimeWithMiliSecTemp("CUSTOM DESIGN--x--","CUSTOM DESIGN","START with font-"+fontName,"isFontLoadedInMemory");
 	var fontFlag,timeOut,totalTime=0;

 	fontFlag=fontUtils.isFontLoaded(fontName);
 	if(!fontFlag)
 	{
 		    fontFlag=fontUtils.isFontLoaded(fontName);
 		    if(!fontFlag && totalTime<2001)
 		    {
 		    	timeOut=setInterval(function(){
 		    		totalTime+=50;
 		    		fontFlag=fontUtils.isFontLoaded(fontName);
 		    		if(fontFlag || totalTime>2001)
 		    		{
 		    			clearInterval(timeOut);
 		    			callback.apply();
 		    		}
 		    	},50);
 		    }
 		    else
 		    {
 		    	callback.apply();
 		    }
 	}
 	else
 	{
 		callback.apply();
 	}
 };
 fontUtils.checkFontLoadForList=function(fontList,callback)
 {
 	    printGetTimeWithMiliSecTemp("CUSTOM DESIGN--x--","CUSTOM DESIGN","START","checkTimeForFontLoad");
 		var length=fontList.length;
 		var counter=0;
 		if(length!=0)
 		{
 			var timeOut;
 			var totalTime=0;
 			fontList=Utils.getUniqueArray(fontList);
 			length=fontList.length;
 			var fontFlag=[];
 			var i=0;
 			for(i=0;i<length;i++)
 			{
 				fontFlag[i]=this.isFontLoadedInHtml(fontList[i]);
 				if(fontFlag[i])
                 {
                     counter++;
                 }
 			}
 			counter = fontUtils.checkFontLoadForListFirstTime(fontFlag,fontList,counter);
 			if(counter < length){
                 timeOut=setInterval(function(){
                     totalTime=totalTime+300;
                     printGetTimeWithMiliSecTemp("CUSTOM DESIGN--x--","CUSTOM DESIGN","SetInterval"+ counter+",length:"+ length+",totalTime:"+totalTime,"checkTimeForFontLoad");
                     if(counter!=length && totalTime<5001)
                     {
                         counter = fontUtils.checkFontLoadForListFirstTime(fontFlag,fontList,counter);
                     }
                     else
                     {
                         clearInterval(timeOut);
                         if(typeof callback=='function')
                         {
                             callback.apply();
                         }
                     }
                 },300);
 			}else{
 			    if(typeof callback=='function')
                 {
                     callback.apply();
                 }
 			}
 		}
 		else
 		{
 			if(typeof callback=='function')
 			{
 				callback.apply();
 			}
 		}
 };
 fontUtils.checkFontLoadForListFirstTime=function(fontFlag,fontList,counter){
     var length = fontList.length;
     for(var i=0;i<length;i++)
     {
         if(!fontFlag[i])
         {
             fontFlag[i]=fontUtils.isFontLoaded(fontList[i]);
             if(fontFlag[i])
             {
                 counter++;
             }
         }
     }
     return counter;
 };

 fontUtils.isFontLoadedInHtml=function(fontName){
       console.log("isFontLoadedInHtml fontLoadedInHtml[fontName] = " + fontLoadedInHtml[fontName]);
       if(fontLoadedInHtml[fontName]){
           return true;
       }
       return false;
 };