/**
 * @filename ScheduleDB.js
 * @author r.k.pandey
 * @date   21 Jan 2015
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */


var db;
var dbCreated = false;
var mScheduleName = "";
var mScheduleFilePath = "";
var mScheuleThumbNailPath = "";
var mScheuleSentStatus = false;
var mTimeStamp = "";
var isQuickStart = false;
var funCallBackSch;
var tempContentRoothPAth=".ETabletAuthor/RHE/";
var SCH_DEBUG_TAG = "MySchedule::  ";
var scheduleDB = {
scheduleInfoList:[],	
};
var myScheduleInfoJson = {};
var myScheduleInfoArr = [];
var mScheduleColorIndex= [];

myScheduleInfoJson.myScheduleInfoArrs = myScheduleInfoArr;

/***
 * To insert Schedule info in MySchedule DB 
 * 
 * @param 
 *      ScheduleName -> Schedule Name
 *      scheduleFilePath ->  schedule File Path
 */
function insertScheduleInfo(ScheduleName, scheduleFilePath,scheuleThumbNailPath,scheuleSentStatus) {
	
    console.log(SCH_DEBUG_TAG+"@insertScheduleInfo: " + "ScheduleName: " + ScheduleName
            + " ,scheduleFilePath: " + scheduleFilePath);

    mScheduleName = ScheduleName;
    mScheduleFilePath = scheduleFilePath;
    mScheuleThumbNailPath= scheuleThumbNailPath;
    mScheuleSentStatus=scheuleSentStatus;
    mTimeStamp = new Date().getTime();
   
    db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
    console.log(SCH_DEBUG_TAG+"@insertScheduleInfo: open db success - ScheduleDB");
    db.transaction(populateScheduleDB, ScheduleDBError);
}
function copyScheduleData(){
	  db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
      console.log(DB_DEBUG_TAG+"@copyScheduleData: open db success - TabletAuthorDB");
      
      db.transaction(copyToScheduleDB, ScheduleDBError);
}

function copyToScheduleDB(tx) {

	 var sql = "CREATE TABLE IF NOT EXISTS schedule_Info ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "ScheduleName VARCHAR(100), " + "ScheduleFilePath VARCHAR(350), "
              + "ScheduleThumbNailPath VARCHAR(350), "
              + "ScheduleSentStatus VARCHAR(100), "
              + "orientation VARCHAR(100), "
              + "colorindex VARCHAR(100), "
               + "playerType VARCHAR(100), "
              + "TimeStamp VARCHAR(50))";
	console.log(SCH_DEBUG_TAG + sql);
	tx.executeSql(sql);
	var scheduledata = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
	var scheduleArr = [];
	scheduleArr = scheduledata.myScheduleInfoArrs;
	//alert("scheduleArr" + scheduledata.myScheduleInfoArrs.length);
	if (scheduleArr.length > 0) {
		var playerType = 2;

		for (var i = 0; i < scheduleArr.length; i++) {

			var thumbPath = scheduleArr[i].scheuleThumbNailPath;
			var filePath = scheduleArr[i].scheuleFilePath;
			console.log("scheduleee thumbPath"+thumbPath);
			console.log("scheduleee filePath"+filePath);
			thumbPath = tempContentRoothPAth + thumbPath.substring(thumbPath.indexOf("MySchedule"));
			filePath = tempContentRoothPAth + filePath.substring(filePath.indexOf("MySchedule"));
			console.log("mScheduleName" + scheduleArr[i].scheduleName);
			console.log("mScheduleFilePath" + filePath);
			console.log("mScheuleThumbNailPath" + thumbPath);
			console.log("mScheuleSentStatus" + scheduleArr[i].scheuleSentStatus);
			console.log("orientation" + scheduleArr[i].orientation);
			console.log("playerType" + playerType);
			console.log("colorval" + scheduleArr[i].colorindx);
			console.log("timeStamp" + scheduleArr[i].timeStamp);

			tx.executeSql("INSERT INTO schedule_Info (ScheduleName,ScheduleFilePath,ScheduleThumbNailPath,ScheduleSentStatus,orientation,colorindex,playerType,TimeStamp) VALUES (" 
			+ "'" + scheduleArr[i].scheduleName + "'" 
			+ "," + "'" + filePath + "'" + "," + "'" 
			+ thumbPath + "'" + "," + "'"
			+ scheduleArr[i].scheuleSentStatus + "'" + "," + "'" 
			+ scheduleArr[i].orientation + "'" + "," + "'" 
			+ scheduleArr[i].colorindx + "'" + "," + "'" 
			+ playerType + "'" + "," + "'" 
			+ scheduleArr[i].timeStamp + "'" 
			+ ")");

			//  getScheduleInfo(false);
			console.log(SCH_DEBUG_TAG + "Inserted one item success");
		}
	}
}

/***
 * To delete a Schedule info from MySchedule DB by Name
 * 
 * @param 
 *      ScheduleName -> Schedule Name
 */
function deleteScheduleFromDBByName(scheduleName) {
	
    console.log(SCH_DEBUG_TAG+"@deleteScheduleInfo: " + "scheduleName: " + scheduleName
            );
    db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
    console.log(SCH_DEBUG_TAG+"@deleteScheduleInfo: open db success - ScheduleDB");
    db.transaction(function(tx) {
        tx.executeSql("DELETE FROM schedule_Info " 
                + "WHERE schedule_Info.ScheduleName = '"
                +scheduleName + "'" + "AND PlayerType='"+Utils.getActivePlayerType()+"' ");
        console.log(SCH_DEBUG_TAG+" Deleted schedule item successfully");
       
    });
}


/***
 * To delete a Schedule info from MySchedule DB 
 * 
 * @param 
 *      ScheduleID -> Schedule ID
 */
function deleteScheduleFromDBByID(schId) {
	
    console.log(SCH_DEBUG_TAG+"@deleteScheduleInfo: " + "id: " + schId
            );

    db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
    console.log(SCH_DEBUG_TAG+"@deleteScheduleInfo: open db success - ScheduleDB");
    db.transaction(function(tx) {
        tx.executeSql("DELETE FROM schedule_Info WHERE schedule_Info.id = ?",[schId],
                     function(tx, result) { 
                     	 getScheduleInfo(true);
                     	 console.log(SCH_DEBUG_TAG+" Deleted schedule item successfully "+result);
                     	 }, onError);
    });
    
   
}


function dropScheduleTableForcely(callback) {
    console.log("drop StoreTable");
    var db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
    db.transaction(function(tx) {
        tx.executeSql("DROP TABLE schedule_Info");
        console.log(STORE_DB_TAB + "DROP TABLE schedule_Info");
        if(typeof callback == 'function')
        {
        	 callback.apply(this,[true]);
        }
    });
}


function onError(tx, error) {
   console.log ("Delete Error: " +error.message);
}



/**
 * To updateScheduleFromDB according to specified attribute 
 * @param ScheduleName
 */
function updateScheduleFromDB(scheduleName, scheduleFilePath,scheuleThumbNailPath,scheduleSentStatus) {
    console.log(SCH_DEBUG_TAG+"@updateScheduleFromDB"+scheduleSentStatus);
    deleteScheduleFromDBByName(scheduleName);
    setTimeout(function() {
		insertScheduleInfo(scheduleName,scheduleFilePath,scheuleThumbNailPath,scheduleSentStatus);
		getScheduleInfo(false);
      }, 100);
}


function populateScheduleDB(tx) {
	   
	
	var playerType=Utils.getActivePlayerType();
	
    console.log(SCH_DEBUG_TAG+"@getScheduleInfo populateScheduleDB for Insert Operation");
  
   var colorval="";
   if(isScheduleCopy==true){
   	
   	colorval=schedulecolorindx;
   }
   else{
   	var colorvalue=sessionStorage.getItem("colorvalue");
   	colorval=colorvalue;
   }
   isScheduleCopy=false;
    var orientation=sessionStorage.getItem('orientationType');
    var sql = "CREATE TABLE IF NOT EXISTS schedule_Info ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "ScheduleName VARCHAR(100), " + "ScheduleFilePath VARCHAR(350), "
              + "ScheduleThumbNailPath VARCHAR(350), "
              + "ScheduleSentStatus VARCHAR(100), "
              + "orientation VARCHAR(100), "
              + "colorindex VARCHAR(100), "
               + "playerType VARCHAR(100), "
              + "TimeStamp VARCHAR(50))";
     console.log(SCH_DEBUG_TAG+sql);
     tx.executeSql(sql);
     tx.executeSql("INSERT INTO schedule_Info (ScheduleName,ScheduleFilePath,ScheduleThumbNailPath,ScheduleSentStatus,orientation,colorindex,playerType,TimeStamp) VALUES ("
                    + "'" + mScheduleName+ "'" + ","
                    + "'" + mScheduleFilePath+ "'" + ","
                    + "'" + mScheuleThumbNailPath+ "'" + ","
                    + "'" + mScheuleSentStatus+ "'" + ","
                    + "'" + orientation+ "'" + ","
                     + "'" + colorval+ "'" + ","
                        + "'" + playerType+ "'" + ","
                    + "'" + mTimeStamp+ "'" + ")");
     getScheduleInfo(false);
     console.log(SCH_DEBUG_TAG+"Inserted one item success");
 }


/**
 * To get the Schedule information list
 */
function getScheduleInfo(isTempQuickStart, callback) {
    isQuickStart = isTempQuickStart;
    if(typeof callback == "function"){
        funCallBackSch = callback;
    }
    console.log(SCH_DEBUG_TAG+"@getScheduleInfo");
    
    db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
    db.transaction(readScheduleDB, ScheduleDBError, populateScheduleDBOnSuccess);
 }

/**
 * To populate readScheduleDB
 * @param tx
 */
function readScheduleDB(tx) {
    console.log(SCH_DEBUG_TAG+"@readScheduleDB");
    var sql = "CREATE TABLE IF NOT EXISTS schedule_Info ( "
        + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
        + "ScheduleName VARCHAR(100), " + "ScheduleFilePath VARCHAR(350), "
        + "ScheduleThumbNailPath VARCHAR(350), "
        + "ScheduleSentStatus VARCHAR(100), "
         + "orientation VARCHAR(100), "
         + "colorindex VARCHAR(100), "
          + "playerType VARCHAR(100), "
        + "TimeStamp VARCHAR(50))";
    
    console.log(SCH_DEBUG_TAG+"SqlQuery: "+sql);
    tx.executeSql(sql);
}

function ScheduleDBError(tx, error) {
    //alert("Database Error: " + error);
    if(typeof funCallBackSch == "function"){
      funCallBackSch.apply(this,[false]);
    }
    //console.log("@transaction_error: ScheduleDBError");
}

function populateScheduleDBOnSuccess() {
    console.log(SCH_DEBUG_TAG+"@populateDB_success");
    db.transaction(excuteScheduleQuery, ScheduleDBError);
}
/**
 * To excute Schedule query for fetching db list
 * @param tx
 */
function excuteScheduleQuery(tx) {
    console.log(SCH_DEBUG_TAG+"@excuteScheduleQuery");
    var  sql = "";
    var playerType=Utils.getActivePlayerType();
    if(isQuickStart)
    {
        sql = "select * from  schedule_Info  WHERE schedule_Info.playerType = '"+ playerType + "' order by TimeStamp desc";
    }
    else
    {
        sql = "select * from  schedule_Info  WHERE schedule_Info.playerType = '"+ playerType + "' order by id desc";
    }
    console.log(SCH_DEBUG_TAG+"@excuteQuery: "+sql);
    tx.executeSql(sql, [], fetchScheduleItemList);
}

/**
 * To show list of Schedule item list
 * here user can populate using html components
 */ 
function fetchScheduleItemList(tx, results) {


	if(isQuickStart)
    {
		myScheduleInfoJson.myScheduleInfoArrs=[];
		mScheduleColorIndex=[];
    }
	else
	{
		scheduleDB.scheduleInfoList=[];
	}
    
     var i;
	 for ( i = 0; i < results.rows.length; i++) {
         var myScheduleRows = results.rows.item(i);
         //This json data for Quick start Page
        if(isQuickStart)
        {
                  
            var myScheduleInfo = {};
            myScheduleInfo.scheduleId= myScheduleRows.id;
	  		myScheduleInfo.scheduleName = myScheduleRows.ScheduleName;
	  		myScheduleInfo.scheuleFilePath = myScheduleRows.ScheduleFilePath;
	  		myScheduleInfo.scheuleThumbNailPath = myScheduleRows.ScheduleThumbNailPath;
	  		myScheduleInfo.scheuleSentStatus = myScheduleRows.ScheduleSentStatus;
	  		myScheduleInfo.orientation = myScheduleRows.orientation;
	  		myScheduleInfo.timeStamp = myScheduleRows.TimeStamp;
	  		myScheduleInfo.colorindx = myScheduleRows.colorindex;
	  		myScheduleInfo.playerType = myScheduleRows.playerType;
	  		myScheduleInfoJson.myScheduleInfoArrs.push(myScheduleInfo);
	  		mScheduleColorIndex.push(myScheduleRows.colorindex);
        }	
        else
        {
        	if(($.inArray(myScheduleRows.ScheduleName, scheduleDB.scheduleInfoList) < 0))
	 		{
        	 scheduleDB.scheduleInfoList.push(myScheduleRows.ScheduleName);
	 		}
        }	
     
     }
   //setting values for quick start page
    if(i == results.rows.length)
    {
        if(isQuickStart)
        {
            createScheduleSessionJsonList();
            if(typeof funCallBackSch == "function"){
                funCallBackSch.apply(this,[true]);
                funCallBackSch = null;
            }
        }
        else
        {
            getScheduleInfo(true);
        }
    }
}

function createScheduleSessionJsonList(){
    // Put the object into session storage
    //alert("array "+myScheduleInfoJson.myScheduleInfoArrs.length);
 
    sessionStorage.setItem("SCHEDULE_INFO", JSON.stringify(myScheduleInfoJson));
    sessionStorage.setItem("SCHEDULECOLOR_INFO", JSON.stringify(mScheduleColorIndex));
    
    
}

function getScheduleByOrientation(orientation) {
	
	var playerType=Utils.getActivePlayerType();
    var schname;
    db = window.openDatabase("ScheduleDB", "1.0", "MagicInfo",200000);
    var sql="";
   
     if(orientation==1000){
     	sql="select * from  schedule_Info  WHERE schedule_Info.orientation = 1000 AND playerType='"+playerType+"' order by TimeStamp desc";
     	
     }
     else{
     	
     	sql="select * from  schedule_Info  WHERE schedule_Info.orientation = 9999 AND playerType='"+playerType+"' order by TimeStamp desc";
     }
    db.transaction(function(tx) {
        tx.executeSql(sql,[],
                     function(tx, result) { 
                     	if(result.rows.length > 0){
                     		  var myScheduleRows = result.rows.item(0);
                              var schname=myScheduleRows.ScheduleName;
                              var schpath=myScheduleRows.ScheduleFilePath;
                     
                              redirectToSchedule(schname,schpath);
                     		
                     	}
                     	 else{
                     	
                     	 	redirectToSchedule("","");
                     	 	
                     	 }
          
                     	 }, onError);
    }); 
}
function redirectToSchedule(schName,schPath){
	
	setTimeout(function(){			
	window.location.href = "../schedule/Schedule.html?category=" + tplCategory + "&schedulePath=" + schPath + "&scheduleName=" + schName + "&isNewSchedule=" + SaveTemplate.isNewSchedule + "&navigateFromTemplate=true";
	},200);
	
}

