var mNetworkManager;
var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : "null";

if (deviceType == "iPhone" || deviceType == "iPad") {
    
    mNetworkManager = {
        
        startAutoDiscService : function (successCallback, errorCallback) {
            console.log("@ **** startAutoDiscService ***** ");
            return cordova.exec(successCallback, errorCallback, "LFDAutoDiscoveryPlugin", "initialize", []);
        },
        stopAutoDiscSrvc : function (successCallback, errorCallback) {
            console.log("@ **** stopAutoDiscSrvc ***** ");
            cordova.exec(successCallback, errorCallback, "LFDAutoDiscoveryPlugin", "stopAutoDiscSrvc", []);
        },
        manualConnect : function (successCallback, errorCallback, deviceInfo) {
            console.log("@ **** manualConnect ***** ");
            return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "createConnection", [deviceInfo]);
        },
        verifyManualyAddedIp : function (successCallback, errorCallback, ipAddr) {
            console.log("@ **** verifyManualyAddedIp ***** ");
            return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "verifyManualyAddedIP", [ipAddr]);
        },
        verifyPIN : function(successCallback, errorCallback, pinInfo) {
            console.log("@ **** verifyPIN ***** ");
            cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "performPINVerification", [pinInfo]);
        },
        startHandshaking : function(successCallback, errorCallback, ipAddr) {
            console.log("@ **** startHandshaking ***** ");
            cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "isTLSEnabledDevice", [ipAddr]);
        },
        stopNetworkService : function (successCallback, errorCallback) {
            console.log("@ ******* Network service closed ******* ");
            return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "closeConnection", []);
        },
        updateConnectionStatus : function (successCallback, errorCallback, ipAddr) {
            console.log("@ ******* updateConnectionStatus ******* ");
            return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "updateConnectionStatus", [ipAddr]);
        },
        cancelExcutingTask : function (successCallback, errorCallback, action) {
            console.log("@ ******* cancelExcutingTask ******* ");
            if (action == CONNECTION_TYPE_SCHEDULE_UPLOAD) {
                console.log("@ ******* cancelUploadTask ******* ");
                return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "cancelUploadTask", [action]);
            } else if (action == CONNECTION_TYPE_FIRMWARE_UPGRADE || action == CONNECTION_TYPE_RSITE_DOWNLOAD) {
                console.log("@ ******* cancelFirmwareActivity or Cancel RSite Activity ******* ");
                return cordova.exec(successCallback, errorCallback, "DownloadPlugin", "cancelFirmwareActivity", [action]);
            } else if (action == CONNECTION_TYPE_ON_OFF_TIMER_UPDATE) {
                console.log("@ ******* cancelOnOffTimerUpdate ******* ");
                return cordova.exec(successCallback, errorCallback, "UpdateOnOffTimerPlugin", "cancelOnOffTimerUpdate", [action]);
            }
        },
        getFirmwareInfo : function (successCallback, errorCallback) {
            console.log("@ ******* getFirmwareInfo ******* ");
            return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "getFirmwareInfo", []);
        },
        getSLMServerFirmwareVersion : function (successCallback, errorCallback, mFirmwareInfo) {
            console.log("@ ******* getSLMServerFirmwareVersion ******* ");
            return cordova.exec(successCallback, errorCallback, "DownloadPlugin", "getSLMServerFirmwareVersion", [mFirmwareInfo]);
        },
        startFirmwareDownload : function (successCallback, errorCallback) {
            console.log("@ ******* startFirmwareDownload ******* ");
            return cordova.exec(successCallback, errorCallback, "DownloadPlugin", "startFirmwareDownload", []);
        },
        downloadRSiteElements : function (successCallback, errorCallback, mMsg) {
            console.log("@ ******* downloadRSiteElements ******* ");
            return cordova.exec(successCallback, errorCallback, "DownloadPlugin", "downloadRSiteElements", [mMsg]);
        },
        deleteRSiteElements : function (successCallback, errorCallback, mMsg) {
            console.log("@ ******* deleteRSiteElements ******* ");
            return cordova.exec(successCallback, errorCallback, "DownloadPlugin", "deleteRSiteElements", [mMsg]);
        },
        startFirmwareUpload : function (successCallback, errorCallback) {
            console.log("@ ******* startFirmwareUpload ******* ");
            return cordova.exec(successCallback, errorCallback, "FirmwareUploadPlugin", "startFirmwareUpload", []);
        },
        startUploading : function (successCallback, errorCallback, mdata) {
            console.log("@ ******* startUploading Schedule ******* ");
            return cordova.exec(successCallback, errorCallback, "ScheduleUploadPlugin", "startScheduleUpload", [mdata]);
        },
        updateOnOffTimerInfo : function (successCallback, errorCallback, mMsg) {
            console.log("@ ******* UpdateOnOffTimer Schedule ******* ");
            return cordova.exec(successCallback, errorCallback, "UpdateOnOffTimerPlugin", "updateOnOffTimerInfo", [mMsg]);
        },
        setDeviceStorageOption : function (successCallback, errorCallback) {
            console.log("@ ******* setDeviceStorageOption ******* ");
            return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "setDeviceStorageOption", []);
        }
    };
    
} else {
    
    mNetworkManager = {
        
        //TODO Same Need to update for iOS
        
        startAutoDiscService : function(successCallback, errorCallback) {
            console.log("@plugin: startAutoDiscService()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         START_DISCOVERY_SERVICE, "");
        },
        stopAutoDiscSrvc : function(successCallback, errorCallback) {
            console.log("@plugin: stopAutoDiscSrvc()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         STOP_DISCOVERY_SERVICE, "");
        },
        manualConnect : function(successCallback, errorCallback, conInfo) {
            console.log("@plugin: manualConnect()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         MANUAL_DEVICE_CONNECTION, conInfo);
        },
        verifyManualyAddedIp : function(successCallback, errorCallback, conInfo) {
            console.log("@plugin: verifyManualyAddedIp()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         VERIFY_MANUAL_ENTERED_IP, conInfo);
        },
        verifyPIN : function(successCallback, errorCallback, pinInfo) {
            console.log("@plugin: verifyPIN(): "+pinInfo);
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         VERIFY_TLS_PIN_INFO, pinInfo);
        },
        startHandshaking : function(successCallback, errorCallback, ip) {
             console.log("@plugin: startHandshaking(): "+ip);
             cordova.exec(successCallback,
                          errorCallback,
                          NETWORK_MANAGER_PLUGIN,
                          TLS_HANDSHAKING, ip);
        },
        stopNetworkService : function(successCallback, errorCallback) {
            console.log("@plugin: stopNetworkService()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         STOP_CONNECTION_SERVICE, "");
        },
        startUploading : function(successCallback, errorCallback, mdata) {
            console.log("@plugin: startUploading()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         START_SCHEDULE_UPLOADING, mdata);
        },
        cancelExcutingTask : function(successCallback, errorCallback,action) {
            console.log("@plugin: cancelExcutingTask()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         CANCEL_EXCUTING_TASK,action);
        },
        getFirmwareInfo : function(successCallback, errorCallback) {
            console.log("@plugin: getFirmwareInfo()");
            cordova.exec(successCallback,
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN,
                         GET_DEVICE_FIRMWARE_INFO, "");
        },
        startFirmwareDownload : function(successCallback, errorCallback) {
            console.log("@plugin: startFirmwareDownload()");
            cordova.exec(successCallback, 
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN, 
                         START_FIRMWARE_DOWNLOAD, "");
        },
        startFirmwareUpload : function(successCallback, errorCallback) {
            console.log("@plugin: startFirmwareUpload()");
            cordova.exec(successCallback, 
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN, 
                         START_FIRMWARE_UPLOAD, "");
        },
        updateOnOffTimerInfo : function(successCallback, errorCallback,mMsg) {
            console.log("@plugin: updateOnOffTimerInfo()");
            cordova.exec(successCallback, 
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN, 
                         SET_ON_OFF_TIMER_INFO, mMsg);
        },
        getSLMServerFirmwareVersion : function(successCallback, errorCallback,mMsg) {
            console.log("@plugin: getSLMServerFirmwareVersion()");
            cordova.exec(successCallback, 
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN, 
                         GET_SERVER_FIRM_VERSION, mMsg);
        },
        downloadRSiteElements : function(successCallback, errorCallback,mMsg) {
            console.log("@plugin: downloadRSiteElements()");
            cordova.exec(successCallback, 
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN, 
                         RSITE_DOWNLOAD_DESIGN_ELEM, mMsg);
        },
        deleteRSiteElements : function(successCallback, errorCallback,mPath) {
            console.log("@plugin: deleteRSiteElements()");
            cordova.exec(successCallback, 
                         errorCallback,
                         NETWORK_MANAGER_PLUGIN, 
                         RSITE_DELETE_DESIGN_ELEM, mPath);
        }
        
    };
}