/**
 *  author k.chainani
 * Modified k.chainani 29th Jan
 */
var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";

var mUiHandler;

if (deviceType == "iPhone" || deviceType == "iPad") {

	mUiHandler = {

		DragDrop : function(successCallback, errorCallback) {
			return cordova.exec(successCallback, errorCallback, "UiHandler", "dragDropAction", []);

		},
		addGallery : function(flagShow, galleryStep, arrJson, successCallback, errorCallback,iMode) {

			Utils.isGalleryOpen = flagShow;
			return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "showGallery", [flagShow, galleryStep, orientationMode + "", isAnimNeeded, srcCounter, arrJson, backgroundUIObj.getBackGroundContentSize(),iMode]);

		},
        hideGallery : function(successCallback, errorCallback) {
            var errorCallback = function(message) {
                //TODO
            };
            var successCallback = function(message) {
                //TODO
            };
            return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "hideGallery", []);
        },
		addSelection : function(flagAddSelection, selectPath, successCallback, errorCallback) {
			return cordova.exec(successCallback, errorCallback, "UiHandler", "addSelection", [flagAddSelection, selectPath]);
		},
		createCopyThumbnail : function(jsonContentObj, successCallback, errorCallback) {
			Utils.isGalleryOpen = false;
			return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "createCopyThumbnail", [jsonContentObj]);
		},
		addCamera : function() {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			// below arguments are respect to [quality, destinationType, sourceType, targetWidth, targetHeight, encodingType, mediaType, allowEdit, correctOrientation, saveToPhotoAlbum, popoverOptions, cameraDirection]
			return cordova.exec(successCallback, errorCallback, "Camera", "takePicture", [50, 1, 1, -1, -1, 1, 0, true, true, true, "", 0]);

		},
		addOverLay : function(flagShow) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, errorCallback, "UiHandler", "addOverLay", [flagShow]);
		},
		selectCategory : function(categoryType, successCallback, errorCallback) {
			return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "selectCategory", [categoryType]);
		},
		setSourceCounter : function(maxCounter) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "setSourceCounter", [maxCounter]);
		},
		openYouTubeVideo : function(strPromo, StrUrl) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "openYouTubeVideo", [strPromo, StrUrl]);
		},
		restorePreviousState : function(flagShow, arrJson, successCallback, errorCallback) {

			return cordova.exec(successCallback, errorCallback, "UiHandler", "restorePreviousState", [flagShow, arrJson]);
		},
		setOrientation : function(orientation) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, errorCallback, "GalleryHandlerPlugin", "setOrientationType", [orientation + ""]);
		},
        showHighlitedFrame : function (successCallback, errorCallback, mTemplateFrameInfo) {
            console.log("@ ******* showHighlitedFrame iOS ******* ");
            return cordova.exec(successCallback, errorCallback, "HighlightTemplateFramePlugin", "updateTemplateFramesInfo", [mTemplateFrameInfo]);
		}
	};

} else {

	mUiHandler = {

		DragDrop : function(successCallback, errorCallback) {
			console.log("@plugin: Downloadfile()");

			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"DragDropAction", []);
		},

		addGallery : function(flagShow, galleryStep, arrJson, successCallback, errorCallback,iMode) {
			Utils.isGalleryOpen = flagShow;
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"addGallery", [flagShow, galleryStep, orientationMode + "", isAnimNeeded, srcCounter, arrJson,backgroundUIObj.getBackGroundContentSize(),iMode]);
		},
		addSelection : function(flagAddSelection, selectPath, successCallback, errorCallback) {
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"addSelection", [flagAddSelection, selectPath]);
		},
		createCopyThumbnail : function(jsonContentObj, successCallback, errorCallback) {
			Utils.isGalleryOpen = false;
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"createCopyThumbnail", jsonContentObj);
		},
		addOverLay : function(flagShow) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"addOverLay", [flagShow]);
		},
		addHandwriting : function(path, successCallback, errorCallback) {
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"addHandwriting", [path]);
		},
		addCamera : function() {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"addCamera", []);
		},
		selectCategory : function(categoryType, successCallback, errorCallback) {
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"selectCategory", [categoryType]);
		},
		setSourceCounter : function(maxCounter) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"setSourceCounter", [maxCounter]);
		},
		openYouTubeVideo : function(strPromo, StrUrl) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"openYouTubeVideo", [strPromo, StrUrl]);
		},
		restorePreviousState : function(flagShow, arrJson, successCallback, errorCallback) {

			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"restorePreviousState", [flagShow, arrJson]);
		},
		setOrientation : function(orientation) {
			var errorCallback = function(message) {
			};
			var successCallback = function(message) {
			};
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"UiHandler", // mapped to our native Java class called
			"setOrientation", [orientation + ""]);
		},
		showHighlitedFrame : function(successCallback, errorCallback, mTemplateFrameInfo) {
			console.log("@ ******* showHighlitedFrame ******* ");
			return cordova.exec(successCallback, // success callback function
			errorCallback, // error callback function
			"TemplateFramePlugin", // mapped to our native Java class called
			"showHighlitedFrame", [mTemplateFrameInfo]);
		},
		hideGallery : function(successCallback, errorCallback) {
			console.log("@ ******* hideGallery ******* ");
			var errorCallback = function(message) {
				//TODO
			};
			var successCallback = function(message) {
				//TODO
			};
			return cordova.exec(successCallback, errorCallback, "UiHandler", "hideGallery", []);
		}
	};
}
