var mUtilityManager;
var deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : "null";

if (deviceType == "iPhone" || deviceType == "iPad") {
    
	mUtilityManager = {
		
		changeOrientation : function(orientationStr, successCallback, errorCallback) {
			// console.log("@ **** screenOrientation change ***** "+str);
			return cordova.exec(successCallback, errorCallback, "Orientation", "setOrientation", [orientationStr]);
		},
        registerStateChangeReceiver : function(successCallback, errorCallback) {
			 console.log("@ **** NetworkStateChangeReceiver ios ***** ");
			return cordova.exec(successCallback, errorCallback, "NetworkStateChangeReceiver", "networkStateChangeReceiver", []);
		},
        openWiFiSettings : function(successCallback, errorCallback) {
            console.log("@ **** openWiFiSettings ios ***** ");
			return cordova.exec(successCallback, errorCallback, "SocketConnectionPlugin", "openWifiSettings", []);
		},
        cancelButtonTappedInUI : function(successCallback, errorCallback) {
            console.log("@ **** cancelButtonTappedInUI ios ***** ");
            return cordova.exec(successCallback, errorCallback, "ScheduleUploadPlugin", "cancelButtonTappedInUI", []);
        },
        showToast : function(successCallback, errorCallback,mMsg) {
            console.log("@plugin: showToast()");
            cordova.exec(successCallback,errorCallback,"ToastManagerPlugin","registerShowToastMessage", [mMsg]);
        },
        setPlayerType : function(successCallback, errorCallback, playerType) {
            console.log("@ **** setPlayerType ios ***** ");
            return cordova.exec(successCallback, errorCallback, "LFDAutoDiscoveryPlugin", "setDevicePlayerType", [playerType]);
        },
        openAppStore : function(successCallback, errorCallback) {
            console.log("@ **** openAppStore ios ***** ");
            return cordova.exec(successCallback, errorCallback, "LFDAutoDiscoveryPlugin", "openAppStore", []);
        },
        imageRotate : function(rotateJsonString,successCallback, errorCallback) {
            console.log("imageRotate iOS");
            return cordova.exec(successCallback, errorCallback, "ImageManipulationPlugin", "saveRotation", [rotateJsonString]);
        },
        imageCrop : function(cropJsonString,successCallback, errorCallback) {
            console.log("imageCrop iOS");
            cordova.exec(successCallback, errorCallback, "ImageManipulationPlugin", "saveCrop", [cropJsonString]);
        },
        showPreview : function(successCallback, errorCallback, lfdJson) {
            console.log("showPreview iOS");
            cordova.exec(successCallback,errorCallback,"LFDPreviewPlugin","lfdPreviewObject", [lfdJson]);
        },
        isFileOrDirExist : function(successCallback, errorCallback, path) {
            console.log("isFileOrDirExist iOS");
            cordova.exec(successCallback,errorCallback,"DownloadPlugin","checkWeatherDirExistense", [path]);
        },
        getAppResourceList : function(successCallback, errorCallback, path) {
            console.log("getAppResourceList iOS");
            cordova.exec(successCallback,errorCallback,"DownloadPlugin","getDirectoryContentsList", [path]);
        },
        doEncryption : function(successCallback, errorCallback, data) {
            console.log("@ **** encrypt ios ***** ");
            return cordova.exec(successCallback, errorCallback, "CryptoPlugin", "doEncryption", [data]);
        },
        doDecryption : function(successCallback, errorCallback, data) {
            console.log("@ **** decrypt ios ***** ");
            return cordova.exec(successCallback, errorCallback, "CryptoPlugin", "doDecryption", [data]);
        }        
	};
}else{
    
     mUtilityManager = {
         
         openWiFiSettings : function(successCallback, errorCallback) {
         console.log("@plugin: openWiFiSettings()");
         cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       OPEN_WIFI_SETTINGS, "");
           },
           registerStateChangeReceiver : function(successCallback, errorCallback) {
           console.log("@plugin: registerStateChangeReceiver()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       WIFI_STATE_CHANGE_RECEIVER, "");
           },
           registerKeyboardObserver : function(successCallback, errorCallback) {
           console.log("@plugin: registerKeyboardObserver()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       REGISTER_KEYBOARD_OBSERVER, "");
           },
           showToast : function(successCallback, errorCallback,mMsg) {
           console.log("@plugin: showToast()");
           cordova.exec(successCallback,
                       errorCallback,
                       TAOST_MANAGER_PLUGIN,
                       REGISTER_SHOW_TOAST_MSG, mMsg);
           },
           setPlayerType : function(successCallback, errorCallback,playerType) {
           console.log("@plugin: setPlayerType()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       REGISTER_PLAYER_TYPE, playerType);
           },
           openAppStore : function(successCallback, errorCallback) {
           console.log("@plugin: openAppStore()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       CHECK_FOR_UPDATE,"");
           },
           /*
           imageRotate : function(angle,path,destinationPath ,successCallback, errorCallback) {
                            console.log("@ **** imageRotate  ***** "+destinationPath);
                            //alert(angle +" "+ path + " d "+ destinationPath);
                           return cordova.exec(successCallback, errorCallback, "ImageManipulationPlugin", "saveRotation", [angle,path,destinationPath]);
                      },*/
           
           imageRotate : function(rotateJsonString ,successCallback, errorCallback) {
				 //console.log("@ **** imageRotate  ***** "+destinationPath);
				 //alert("cropJsonString "+rotateJsonString);
	             //alert(angle +" "+ path + " d "+ destinationPath);
				return cordova.exec(successCallback, errorCallback, "ImageManipulationPlugin", "saveRotation", rotateJsonString);
           },
	       /*imageCrop : function(x,y,w,h,angle,path,destinationPath,successCallback, errorCallback) {
	    	     console.log("@ **** imageCrop ***** x y w h  "+x+" "+y+" "+w+" "+h+" angle "+angle);
		         cordova.exec(successCallback, errorCallback, "ImageManipulationPlugin", "saveCrop", [x,y,w,h,angle,path,destinationPath]);
           },*/
          
           imageCrop : function(cropJsonString,successCallback, errorCallback) {
           		//alert("cropJsonString "+cropJsonString);
	    	     //console.log("@ **** imageCrop ***** x y w h  "+x+" "+y+" "+w+" "+h+" angle "+angle);
		         cordova.exec(successCallback, errorCallback, "ImageManipulationPlugin", "saveCrop", cropJsonString);
           },
           registerActivityStatus : function(successCallback, errorCallback) {
           console.log("@plugin: registerActivityStatus()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       ACTIVITY_STATUS,"");
           },
           isFileOrDirExist : function(successCallback, errorCallback,path) {
           console.log("@plugin: isFileOrDirExist()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       FILE_OR_DIR_EXIST,path);
           },
           getAppResourceList : function(successCallback, errorCallback,path) {
           console.log("@plugin: getAppResourceList()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       APP_RES_LIST_ITEMS,path);
           },
           hideKeyboardForcely : function(successCallback, errorCallback) {
           console.log("@plugin: hideKeyboardForcely()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       HIDE_KEYBOARD_FORCE,"");
           },
           getDeviceManufacturer : function(successCallback, errorCallback) {
           console.log("@plugin: getDeviceManufacturer()");
           cordova.exec(successCallback,
                       errorCallback,
                       UTILITY_MANAGER_PLUGIN,
                       DEVICE_MANUFACTURER,"");
           },
           showPreview : function(successCallback, errorCallback, lfdJson) {
           console.log("@plugin: showPreview()");
           cordova.exec(successCallback,
                         errorCallback,
                         "LFDPreviewPlugin",
                         "lfdPreviewObject", [lfdJson]);
           },
            doEncryption : function(successCallback, errorCallback, data) {
            console.log("@plugin: doEncryption()");
            cordova.exec(successCallback,
                        errorCallback,
                        "CryptoPlugin",
                        "doEncryption", [data]);
            },
            doDecryption : function(successCallback, errorCallback, data) {
            console.log("@plugin: doDecryption()");
            cordova.exec(successCallback,
                       errorCallback,
                       "CryptoPlugin",
                       "doDecryption", [data]);
           }
      };
}
