/* =====================
updated 10.09.2015
=======================*/
(function( $ ) {
    $.fn.timeSpinner = function(options) {
        var defaults = {
            type : '3',    // 1 : second  / 2 : min & sec / 3 : hour & min & ampm  / 4 : date  /  5 : slide show duration (sec)
            width: '100%',
            height: '150',
            fontSize: '30',
            fontBoldSize: '35',
            fontPadding: '0',
            fontHeight: '50',
            display:  '3',
            MinSecSuffix: false,
            rangeSec:{st:0,ed:60},
            time1 : {
                        sec : '0' 
                    },
            time2 : {
                        min : '10',
                        sec : '0',
                    },
            time3 : {
                        hour : '8',
                        min : '0',
                        ampm : 'am',
                    },
            time4 : {
                        month: '1',
                        day : '1',
                    },
            time5: {
                        sec : '5',
                    },
            time6 : {
                    hour : '0',
                    min : '1',
                    sec : '0',
                },
            onTimeSet : function() {
                /*===============================
                    - callbacks -
                    type 1 : seconds
                    type 2 : minutes : seconds
                    type 3 : hours : minutes AM/PM
                    type 4 : month day
                    type 5: slide show duration (sec 05~60)
                ================================*/
            }
        };
        
        
        var setting = $.extend( {}, defaults, options);
        setting.fontHeight = Math.round(window.innerHeight*.0672);
            this.css("width", setting.width)
                .css("height", setting.height)
                .css("overflow", "hidden");
        setting.fontSize=Math.round(setting.fontHeight*0.48);
        setting.fontBoldSize=Math.round(setting.fontHeight*0.53);

        return this.each(function() {

            //Hours line
            if( setting.type == 3  || setting.type == 6){
                var liClass = '<div id=hoursArea class=timeArea> <ul id="ul-hours-list" class="ul-list">';
                var startHr = 1;
                var endHr = 13;
                if(setting.type == 6){
                    startHr = 0;
                    endHr = 24
                }
                for(var i = 0 ; i < 5 ; i++)
                {
                    for(var j = startHr ; j < endHr ; j++)
                    {
                  
                         liClass += '<li class="hours'+ j + ' hourSec' + i + '">' + (j<10?'0':'') + j +'</li>';
                       
                    }
                }
                
                liClass += '<ul> </div>';
                
                $(this).append( liClass );

            }
            
            //Min line
            if( setting.type == 3 || setting.type == 2  || setting.type == 6){
                var liClass ='<div id=minArea class=timeArea> <ul id="ul-min-list" class="ul-list">';
                
                for(var i = 0 ; i < 3 ; i++)
                {
                    for(var j = 0 ; j < 60 ; j++)
                    {
                         liClass += '<li class="min'+ j + ' minSec' + i + '">' + (j<10?'0':'') + j +'</li>';
                        
                    }
                }
                
                liClass += '<ul> </div>';
                
                $(this).append( liClass );
                
            }
            
            //AM,PM line        
            if( setting.type == 3 ) {
                $(this).append('<div id=ampmArea class=timeArea>'+
                                '<ul id="ul-ampm-list" class="ul-list">' +  
                                    '<li ></li>' +
                                    '<li ></li>' +
                                    '<li class="ampm1">AM</li>' +
                                    '<li class="ampm2">PM</li>' +
                                    '<li ></li>' +
                                    '<li ></li>' +
                                '<ul>' +
                            '</div>'
                );
            }
            
            //Sec line
            if( setting.type == 2 || setting.type == 1  || setting.type == 6){
                var liClass ='<div id=secArea class=timeArea> <ul id="ul-sec-list" class="ul-list">';
                var jClsIndx;
                for(var i = 0 ; i < 3 ; i++)
                {
                    for(var j = setting.rangeSec.st ; j < setting.rangeSec.ed ; j++)
                    {
                        jClsIndx=j-setting.rangeSec.st;
                        
                         liClass += '<li class="sec'+ jClsIndx + ' secSec' + i + '">' + (j<10?'0':'') + j +'</li>';
                    }
                }
                
                liClass += '<ul> </div>';
                
                $(this).append( liClass );                
            }
            
            // slide show duration (sec 05~60)  line
            if( setting.type == 5 ){
                var liClass ='<div id=ssdArea class=timeArea> <ul id="ul-ssd-list" class="ul-list">';
                
                for(var i = 0 ; i < 3 ; i++)
                {
                    for(var j = 5 ; j < 61 ; j++)
                    {
                         liClass += '<li class="ssd'+ j + ' ssdSec' + i + '">' + (j<10?'0':'') + j +'</li>';
                       
                    }
                }
                
                liClass += '<ul> </div>';
                
                $(this).append( liClass );
            
            }
            
            
            // Date Picker
            if( setting.type == 4 ){
                //month line
                var liClass1 = '<div id=monthArea class=timeArea> <ul id="ul-month-list" class="ul-list">';
                
                for(var i = 0 ; i < 5 ; i++)
                {
                    for(var j = 1 ; j < 13 ; j++)
                    {
                         liClass1 += '<li class="month'+ j + ' monthSec' + i + '">' + (j<10?'0':'') + j +'</li>';
                       
                    }
                }
                
                liClass1 += '<ul> </div>';
                
                $(this).append( liClass1 );
                
                
                //day line
                
                var liClass2 = '<div id=dayArea class=timeArea> <ul id="ul-day-list" class="ul-list">';
                
                for(var i = 0 ; i < 3 ; i++)
                {
                    for(var j = 1 ; j < 32 ; j++)
                    {
                         liClass2 += '<li class="day'+ j + ' daySec' + i + '">' + (j<10?'0':'') + j +'</li>';
                    }
                }
                
                liClass2 += '<ul> </div>';
                
                $(this).append( liClass2 );
                
            }

            if( setting.type == 3  || setting.type == 6)
            {
                $('.timeArea').css({'width': '33%'});
            }
            else if ( setting.type == 2 || setting.type == 4 )
            {
                $('.timeArea').css({'width': '50%'});
            }
            else
            {
                $('.timeArea').css({'width': '100%'});
            }
                                
            //Time spinner design
                
            $('.timeArea').css(
                {
                    'float':'left',
                    'height': '100%',
                }
            );
    
            
            $('.ul-list').css(
                {
                    'list-style':'none',
                    'margin':'0',
                    'padding':'0'
                }
            );
        
            $('.ul-list li,.commonColonCls').css(
                {
                    'text-align':'center',
                    'font-size': setting.fontSize+"px",
                    'opacity': '0.7',
                    'height':  setting.fontHeight+"px",
                    'line-height':setting.fontHeight+"px"
                }
            );
        var topBottomHeight=Math.round(setting.fontHeight*1.3);
        var middlePartHeight=setting.fontHeight*3;
        $(".containerCls").css({'height':((topBottomHeight*2)+middlePartHeight)+'px'});
        $(".headerClsTi,.buttonClsTi").css({'height':topBottomHeight+'px','line-height':topBottomHeight+'px','font-size':setting.fontSize+'px'});
        $(".TimePickerConCls").css({'position':'relative','height':middlePartHeight+'px'});
        $("#TimePicker,.TimePickerSubConCls").css({'height':middlePartHeight+'px'});

        $(".highlight1").css({"top":setting.fontHeight+'px'});
        $(".highlight2").css({"top":(setting.fontHeight*2)+'px'});
        $(".commonColonCls").css({"top":setting.fontHeight+'px','opacity':'1'});

        $(".secTxtTimer,.secTxtTyp2,.minTxtTyp2").css({
                        "top":setting.fontHeight+'px'
                        ,"height":setting.fontHeight+'px'
                        ,'line-height':setting.fontHeight+'px'
                        ,'font-size':Math.round(setting.fontHeight*0.40)+'px'
                      });


            var d = new Date();
            var y = d.getFullYear();
            
            // font size + font padding size
            var fontLineHeight = (parseInt(setting.fontHeight) + 2*(parseInt(setting.fontPadding)));

            /************** Hour ****************/
            if( setting.type == 3  || setting.type == 6){
                var currentHour;
                var checkHour;
                if (setting.type == 6){
                    currentHour = $('.hours' + parseInt(setting.time6.hour, 10)).text().substring(0,2);
                    checkHour = ".hours" + parseInt(setting.time6.hour, 10);
                }else{
                    currentHour = $('.hours' + setting.time3.hour).text().substring(0,2);
                    checkHour = ".hours" + parseInt(setting.time3.hour, 10);
                }
                var setStartPosition;
                $(checkHour).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                $(checkHour).addClass('selected-hr');
                if(setting.display == "3" )
                {
                    if(setting.type == 6){
                        setStartPosition = - (((setting.time6.hour - 1) * fontLineHeight ) + fontLineHeight*48 );
                    }else{
                        setStartPosition = - (((setting.time3.hour - 2) * fontLineHeight ) + fontLineHeight*24 );
                    }
                }
                else if( setting.display == "5")
                {
                    setStartPosition = - (((setting.time3.hour - 3) * fontLineHeight ) + fontLineHeight*24 );
                }
                var hourScroll = new IScroll('#hoursArea', {
                    bounce: false,
                    //start position ( fontLineHeight*24 > hourSec2 )
                    startY : setStartPosition, 
                    lineHeight: fontLineHeight ,
                    disablePointer: true,
					disableTouch: false
                });
                
                var HourID;            
                
                hourScroll.on("scrollStart", function() {
                    $('#hoursArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                    $('.selected-hr').removeClass('selected-hr');
                });
                
                hourScroll.on("scrollEnd", function() {
                    // matrix(1,0,0,1,0,-500) > -500) > -500
                    var Relocation = $('#ul-hours-list').css('transform').slice(22).split(")")[0];
                    Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                    
                    // for not swipe
                    hourScroll.scrollTo(0, Relocation,500); 

                    setTimeout( function() {
                        // move to hourSec2

                        if(setting.type == 6){
                            Relocation = Relocation % (fontLineHeight*24) - fontLineHeight*48;
                        }else{
                            Relocation = Relocation % (fontLineHeight*12) - fontLineHeight*24;
                        }
                        hourScroll.scrollTo(0, Relocation); // scroll position set
                            
                        if( setting.display == "3" )
                        {                    
                            if(setting.type == 6){
                                HourID = Math.abs((Relocation + fontLineHeight*48) / fontLineHeight ) + 1;
                                if( HourID == 24 ) HourID = 0;
                            }else{
                                HourID = Math.abs((Relocation + fontLineHeight*24) / fontLineHeight ) + 2;
                                if( HourID == 13 ) HourID = 1;
                            }
                        }
                        else if(setting.display == "5")
                        {
                            HourID = Math.abs((Relocation + fontLineHeight*24) / fontLineHeight ) + 3;
                            if( HourID == 13 ) HourID = 1;
                        }
                        
                        HourID = ".hours" + parseInt(HourID, 10);
                        $(HourID).css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,
                            }
                        );
                        $(HourID).addClass('selected-hr');
                        currentHour = $(HourID).text().substring(0,2);

                        if(setting.type == 6){
                            setting.onTimeSet.call(this, currentHour + ':' + currentMin + ':' + currentSec);
                        }else{
                            setting.onTimeSet.call(this, currentHour + ':' + currentMin + ' ' + currentAmPm );
                        }
                    },5);
                });
            }
            
            /************** Min ****************/
            if( setting.type == 3 || setting.type == 2  || setting.type == 6){
                var settingTime;
                
                if (setting.type == 3){
                    settingTime = setting.time3.min;
                }else  if (setting.type == 6){
                    settingTime = setting.time6.min;
                }else{
                    settingTime = setting.time2.min;
                }
                
                var currentMin = $('.min' + parseInt(settingTime,10)).text().substring(0,2);
                var checkMin = '.min' + parseInt(settingTime, 10);
                var setStartPosition;
                
                $(checkMin).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                if(setting.MinSecSuffix)
                {
                    $(checkMin).addClass('selected-min');
                }
                
                if( setting.display == "3" )
                {
                    setStartPosition = - (((settingTime -1) * fontLineHeight ) + fontLineHeight*60);
                }
                else if( setting.display == "5")
                {
                    setStartPosition = - (((settingTime -2) * fontLineHeight ) + fontLineHeight*60);
                }
                
                var minScroll = new IScroll('#minArea', {
                    bounce: false,
                    //start position
                    startY : setStartPosition, 
                    lineHeight: fontLineHeight ,
                    disablePointer: true,
					disableTouch: false
                });
                
                var MinID;    
                
                minScroll.on("scrollStart", function() {
                
                    $('#minArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                    $('.selected-min').removeClass('selected-min');
                   
                });
                
                
                minScroll.on("scrollEnd", function() {
                    var Relocation = $('#ul-min-list').css('transform').slice(22).split(")")[0];
                    Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                    
                    // scroll position set
                    minScroll.scrollTo(0, Relocation,500); 
                    
                    setTimeout( function() {
                        // move to minSec1
                        Relocation = Relocation % (fontLineHeight*60) - fontLineHeight*60;
                        minScroll.scrollTo(0, Relocation); // scroll position set
                                                
                        if( setting.display == "3" )
                        {                    
                            MinID = Math.abs((Relocation + fontLineHeight*60)/fontLineHeight) + 1;
                            if( MinID >= 60 ) MinID = 0;
                        }
                        else if(setting.display == "5")
                        {
                            MinID = Math.abs((Relocation + fontLineHeight*60)/fontLineHeight) + 2;
                            if( MinID >= 60 ) MinID = MinID-60;
                        }
                        
                        MinID = '.min' + MinID;
                        $(MinID).css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,                        
                            }
                        );
                        
                        currentMin = $(MinID).text().substring(0,2);
                        console.log("Minute value==="+$(MinID).text()+" "+currentMin);
                        
                        if (setting.type == 3){
                            setting.onTimeSet.call(this, currentHour + ':' + currentMin + ' ' + currentAmPm );
                        }else if (setting.type == 6){
                            setting.onTimeSet.call(this, currentHour + ':' + currentMin + ':' + currentSec);
                        }else{
                            setting.onTimeSet.call(this, currentMin + ':' + currentSec );
                        }    
                        
                        if(setting.MinSecSuffix)
                        {
                            $(MinID).addClass('selected-min');    
                        }
                        
                    },5);
                });
            }    
            
            
            /************ AM PM **********/
            if( setting.type == 3 ){
                var currentAmPm = setting.time3.ampm;
                var ampmNum;
                
                if( setting.time3.ampm == 'am')
                {
                    ampmNum = 1;
                }else
                {
                    ampmNum = 2;
                }
                
                var AmPmID;
                
                var checkAmPm = '.ampm' + ampmNum;
                var setStartPosition;
                
                $(checkAmPm).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                
                if( setting.display == "3" )
                {
                    setStartPosition = - ((ampmNum) * fontLineHeight );
                }
                else if( setting.display == "5")
                {
                    setStartPosition = - ((ampmNum-1) * fontLineHeight );
                }
                
                var ampmScroll = new IScroll('#ampmArea', {
                    bounce: false,
                    startY : setStartPosition, //start position
                    disablePointer: true,
					disableTouch: false
                });

                ampmScroll.on("scrollStart", function() {
                    
                    $('#ampmArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                    
                });

                ampmScroll.on("scrollEnd", function() {
                    var Relocation = $('#ul-ampm-list').css('transform').slice(22).split(")")[0];
                    
                    if( setting.display == "3" )
                    {        
                        Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                        
                        if( Relocation < - 2*fontLineHeight )
                            Relocation = - 2*fontLineHeight;
                        else if( Relocation > -fontLineHeight )
                            Relocation = -fontLineHeight;
                            
                        AmPmID = Math.abs(Relocation/fontLineHeight);
                    }
                    else if (setting.display == "5")
                    {
                        Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                        AmPmID = Math.abs(Relocation/fontLineHeight) + 1 ;
                    }
                    
                    //console.log(Relocation)
                    ampmScroll.scrollTo(0, Relocation); // scroll position set
                    
                    
                    AmPmID = '.ampm' + AmPmID;
                    
                    $(AmPmID).css(
                        {
                            'font-weight':'bold',
                            'font-size': setting.fontBoldSize,
                        }
                    );
                    currentAmPm = $(AmPmID).text().toLowerCase();
                    setting.onTimeSet.call(this, currentHour + ':' + currentMin + ' ' + currentAmPm );    
                });
            }
            
            
            /************** Sec ****************/
            if( setting.type == 2 || setting.type == 1  || setting.type == 6){
                var settingTime;
                
                if (setting.type == 2){
                    settingTime = getParseIntInDec(setting.time2.sec)-setting.rangeSec.st;
                }else if(setting.type == 6){
                    settingTime = getParseIntInDec(setting.time6.sec)-setting.rangeSec.st;
                }else{
                    settingTime = getParseIntInDec(setting.time1.sec)-setting.rangeSec.st;
                }
                 var ttlItm=setting.rangeSec.ed-setting.rangeSec.st;
                var currentSec = $('.sec' + settingTime).text().substring(0,2);
                var checkSec = '.sec' + settingTime;
                var setStartPosition;
                
                $(checkSec).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                if(setting.MinSecSuffix)
                {
                    $(checkSec).addClass('selected-second');
                }
                
                if( setting.display == "3" )
                {
                    setStartPosition = - (((settingTime -1) * fontLineHeight ) + fontLineHeight*ttlItm);
                }
                else if( setting.display == "5")
                {
                    setStartPosition = - (((settingTime -2) * fontLineHeight ) + fontLineHeight*ttlItm);
                }
                
                var secScroll = new IScroll('#secArea', {
                    bounce: false,
                    //start position
                    startY : setStartPosition, 
                    lineHeight: fontLineHeight ,
                    disablePointer: true,
					disableTouch: false
                });
                
                var SecID;    
                
                secScroll.on("scrollStart", function() {
                
                    $('#secArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                    $('.selected-second').removeClass('selected-second');
                    
                });
                
                
                secScroll.on("scrollEnd", function() {
                    var Relocation = $('#ul-sec-list').css('transform').slice(22).split(")")[0];
                    Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                    
                    // for not swipe
                    secScroll.scrollTo(0, Relocation,500); 

                    setTimeout( function() {
                        // move to secSec1
                        
                        Relocation = Relocation % (fontLineHeight*ttlItm) - (fontLineHeight*ttlItm);
                        secScroll.scrollTo(0, Relocation); // scroll position set
                        
                        if( setting.display == "3" )
                        {                    
                            SecID = Math.abs((Relocation + fontLineHeight*ttlItm)/fontLineHeight) + 1;
                            if( SecID >= ttlItm ) SecID = 0;
                        }
                        else if(setting.display == "5")
                        {
                            SecID = Math.abs((Relocation + fontLineHeight*ttlItm)/fontLineHeight) + 2;
                            if( SecID >= ttlItm ) SecID = SecID-ttlItm;
                        }
                        
                        SecID = '.sec' + SecID;
                        $(SecID).css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,                        
                            }
                        );
                        
                        currentSec = $(SecID).text().substring(0,2);
                        
                        if (setting.type == 2){
                            setting.onTimeSet.call(this, currentMin + ':' + currentSec );
                        }else if(setting.type == 6){
                            setting.onTimeSet.call(this, currentHour + ':' + currentMin + ':' + currentSec);
                        }else{
                            setting.onTimeSet.call(this, currentSec);
                        }
                        if(setting.MinSecSuffix)
                        {
                            $(SecID).addClass('selected-second');
                        }
                    },5);
                });
            }    
            
            
            /************** Side show duration (sec 05~60)  ****************/
            if( setting.type == 5 ){
                var currentSsd = $('.ssd' + setting.time5.sec).text().substring(0,2);
                var checkSsd = '.ssd' + parseInt(setting.time5.sec,10);
                var setStartPosition;
                
                $(checkSsd).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                                
                setStartPosition = - (((setting.time5.sec -2) * fontLineHeight ) + fontLineHeight*52);
                
                var ssdScroll = new IScroll('#ssdArea', {
                    bounce: false,
                    //start position
                    startY : setStartPosition, 
                    lineHeight: fontLineHeight ,
                    disablePointer: true,
					disableTouch: false
                });
                
                var SsdID;    
                
                ssdScroll.on("scrollStart", function() {
                
                    $('#ssdArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                });
                
                ssdScroll.on("scrollEnd", function() {
                    var Relocation = $('#ul-ssd-list').css('transform').slice(22).split(")")[0];
                    Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                    
                    // for not swipe
                    ssdScroll.scrollTo(0, Relocation,500); 

                    setTimeout( function() {
                        // move to ssdSec1
                        //console.log( ' 1 : ' + Relocation);
                        
                        Relocation = Relocation % (fontLineHeight*56) - fontLineHeight*56;
                        ssdScroll.scrollTo(0, Relocation); // scroll position set
                        
                        //console.log( ' 2 : ' + Relocation);
                        
                        SsdID = Math.abs((Relocation + fontLineHeight*55)/fontLineHeight) +5;
                        if( SsdID == 61 ) SsdID = 5;
                        
                        SsdID = '.ssd' + SsdID;
                        
                        console.log(SsdID);
                        
                        $(SsdID).css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,                        
                            }
                        );
                        
                        currentSsd = $(SsdID).text().substring(0,2);
                        
                        setting.onTimeSet.call(this, currentSsd );    

                    },5);
                });
            }    
            
            /************** Month ****************/
            if( setting.type == 4 ){
                var currentMonth = $('.month' + setting.time4.month).text().substring(0,2);
                var checkMonth = ".month" + setting.time4.month;

                SetDay(currentMonth);
                
                $(checkMonth).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                
                var MonthScroll = new IScroll('#monthArea', {
                    bounce: false,
                    //start position
                    startY : - (((setting.time4.month - 2) * fontLineHeight ) + fontLineHeight*24 ), 
                    lineHeight: fontLineHeight ,
                    disablePointer: true,
					disableTouch: false
                });
                
                var MonthID;            
                
                MonthScroll.on("scrollStart", function() {
                    $('#monthArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                    
                });
                
                MonthScroll.on("scrollEnd", function() {
                    // matrix(1,0,0,1,0,-500) > -500) > -500
                    var Relocation = $('#ul-month-list').css('transform').slice(22).split(")")[0];
                    Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                    
                    // for not swipe
                    MonthScroll.scrollTo(0, Relocation,500); 

                    setTimeout( function() {
                        // move to monthSec2
                        Relocation = Relocation % (fontLineHeight*12) - fontLineHeight*24;
                        MonthScroll.scrollTo(0, Relocation); // scroll position set
                                        
                        MonthID = Math.abs((Relocation + fontLineHeight*24) / fontLineHeight ) + 2;
                        if( MonthID == 13 ) MonthID = 1;
                        
                        MonthID = ".month" + MonthID;
                        $(MonthID).css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,
                            }
                        );

                        currentMonth = $(MonthID).text().substring(0,2);
                        
                        SetDay(currentMonth);
                        RelocateDay();
                        
                        setting.onTimeSet.call(this, currentMonth + ' ' + currentDay );    
                    },5);
                });
            }
            
            
            /************** day ****************/
            if( setting.type == 4 ){
                var dayNum;
                var currentDay = $('.day' + setting.time4.day).text().substring(0,2);
                var checkDay = '.day' + setting.time4.day;
                
                $(checkDay).css(
                    {
                        'font-weight':'bold',
                        'font-size': setting.fontBoldSize,
                    }
                );
                
                                
                var dayScroll = new IScroll('#dayArea', {
                    bounce: false,
                    //start position
                    startY : - (((setting.time4.day -2) * fontLineHeight ) + fontLineHeight*dayNum), 
                    lineHeight: fontLineHeight ,
                    disablePointer: true,
					disableTouch: false
                });
                
                var DayID;    
                
                dayScroll.on("scrollStart", function() {
                
                    $('#dayArea li').css(
                        {
                            'font-weight':'normal',
                            'font-size': setting.fontSize,
                        }
                    );
                    
                });
                
                dayScroll.on("scrollEnd", function() {
                    var Relocation = $('#ul-day-list').css('transform').slice(22).split(")")[0];
                    Relocation = Math.round(Relocation/ fontLineHeight) * fontLineHeight;
                    
                    // for not swipe
                    dayScroll.scrollTo(0, Relocation,500);

                    setTimeout( function() {
                        // move to daySec2    
                        Relocation = Relocation % (fontLineHeight*dayNum) - fontLineHeight*dayNum;
                        dayScroll.scrollTo(0, Relocation); // scroll position set
                        
                        DayID = Math.abs((Relocation + fontLineHeight*dayNum)/fontLineHeight) + 2;
                        
                        if( currentMonth == 4 || currentMonth == 6 || currentMonth == 9 || currentMonth == 11 )
                        {
                            if( DayID == 31 ) DayID = 1;                    
                        }else if( currentMonth == 2 )
                        {
                            if ((y%4 == 0) && ((y%100 !=0)|| (y%400 ==0)))
                            {
                                if( DayID == 30 ) DayID = 1;                    
                            }
                            else
                            {
                                if( DayID == 29 ) DayID = 1;
                            }        
                        }else
                        {
                            if( DayID == 32 ) DayID = 1;            
                        }        
                        
                        DayID = '.day' + DayID;
                        $(DayID).css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,                        
                            }
                        );
                        
                        currentDay = $(DayID).text().substring(0,2);
                        setting.onTimeSet.call(this, currentMonth + ' ' + currentDay );    
                        
                    },5);
                });
            }                

            function SetDay(val)
            {
                var currentMonth = val;
                
                if( currentMonth == 4 || currentMonth == 6 || currentMonth == 9 || currentMonth == 11 )
                {
                    $('.day31').css({'display':'none'});
                    $('.day30').css({'display':'block'}); 
                    $('.day29').css({'display':'block'});
                    
                    dayNum = 30;
                    
                }else if( currentMonth == 2 )
                {                
                    if ((y%4 == 0) && ((y%100 !=0)|| (y%400 ==0)))
                    {
                        $('.day31').css({'display':'none'});
                        $('.day30').css({'display':'none'}); 
                        
                        dayNum = 29;                    
                    }
                    else
                    {
                        $('.day31').css({'display':'none'});
                        $('.day30').css({'display':'none'}); 
                        $('.day29').css({'display':'none'});
                        
                        dayNum = 28;    
                    }    
        
                }else
                {
                    $('.day31').css({'display':'block'});
                    $('.day30').css({'display':'block'}); 
                    $('.day29').css({'display':'block'});
                    
                    dayNum = 31;                
                }
            }    
            
            function RelocateDay()
            {

                if( currentMonth == 4 || currentMonth == 6 || currentMonth == 9 || currentMonth == 11 )
                {
                    if(currentDay > 30)
                    {
                        $('#dayArea li').css(
                            {
                                'font-weight':'normal',
                                'font-size': setting.fontSize,
                            }
                        );
                        
                        currentDay = 30;
                        
                        $('.day30').css(
                            {
                                'font-weight':'bold',
                                'font-size': setting.fontBoldSize,                        
                            }
                        );
                    }
                    dayScroll.scrollTo(0, - (((currentDay -2) * fontLineHeight ) + fontLineHeight*dayNum));
                    
                }else if( currentMonth == 2 )
                {
                
                    if ((y%4 == 0) && ((y%100 !=0)|| (y%400 ==0)))
                    {
                        if(currentDay > 29)
                        {
                            $('#dayArea li').css(
                                {
                                    'font-weight':'normal',
                                    'font-size': setting.fontSize,
                                }
                            );
                        
                            currentDay = 29;
                            $('.day29').css(
                                {
                                    'font-weight':'bold',
                                    'font-size': setting.fontBoldSize,                        
                                }
                            );
                        }                    
                    }
                    else
                    {
                        if(currentDay > 28)
                        {
                            $('#dayArea li').css(
                                {
                                    'font-weight':'normal',
                                    'font-size': setting.fontSize,
                                }
                            );
                        
                            currentDay = 28;
                            $('.day28').css(
                                {
                                    'font-weight':'bold',
                                    'font-size': setting.fontBoldSize,                        
                                }
                            );
                        }        
                    }
                    
                    dayScroll.scrollTo(0, - (((currentDay -2) * fontLineHeight ) + fontLineHeight*dayNum));
                    
                }else
                {
                    dayScroll.scrollTo(0, - (((currentDay -2) * fontLineHeight ) + fontLineHeight*dayNum));
                }
            }
		 	
        });
    };
})(jQuery);  