/**
 * @filename quickstart.js
 * 
 *  modified by p.pathak date 9th feb 2015 added template rendering
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */

var isAppSyced = false;
var log = null;

var app = {
    // Application Constructor
    initialize : function() {
        this.bindEvents();
        getStoreInfo();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady : function() {
        app.receivedEvent('deviceready');
        
        var rootPath = sessionStorage.getItem("ROOT_PATH");
        console.log("rootPath::"+rootPath);
    	if (rootPath != null && rootPath != "" && rootPath != undefined && rootPath!="undefined") {        	
        	quickStartObj.uploadListOnQuickStart();
        }
        else
        {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
         var path;
         path = fileSystem.root.toURL().replace("file://","");
         console.log("ROOT PATH "+ path + " GET PATH"+ Utils.getSystemRootPath());
         
         
         if(path.localeCompare(Utils.getSystemRootPath())!=0)
            Utils.setSystemRootPath(path); 
              
             
	        	quickStartObj.uploadListOnQuickStart();
        
         },function(){
             
         console.log("Error in file system");
        });
        }
		  /*if (deviceType == "iPhone") {
		 	  $('#QuickStartTxtDescricptionId').css('font-size','14px');
		 }*/
       setTimeout(function() {
           /* var loc = sessionStorage.getItem('locale');
            //alert("height"+screen.availHeight+"width"+screen.availWidth);
            var deviceHeight = screen.availHeight;
            var deviceWidth = screen.availWidth;

            if (loc == "ru") {
                $('#QuickStartTxtTitleId').autoFontSize({
                    maxFontPixels : 26,
                    minFontPixels : 17
                });
            } else {
                $('#QuickStartTxtTitleId').autoFontSize({
                    maxFontPixels : 26,
                    minFontPixels : 12
                });
            }*/
            updateThemeFontSize($("#QuickStartTxtTitleId"),"quickStartTitleTxt",true);
            updateThemeFontSize($("#QuickStartTxtDescricptionId"),"quickStartDescTxt",true);
           /* if (loc != "en") {
                //for iphone 5 and 5s
                if (deviceType == "iPhone") {

                    if (deviceHeight == 568 && deviceWidth == 320) {

                        if (loc == "ko" || loc == "es" || loc == "th" || loc == "zh") {
                            $('#QuickStartTxtDescricptionId').autoFontSize({
                                maxFontPixels : 18,
                                minFontPixels : 17
                            });
                        } else {
                            if (loc == "fr" )
                            {
                                $('#QuickStartTxtDescricptionId').autoFontSize({
                                maxFontPixels : 18,
                                minFontPixels : 12
                                });
                            }
                            else{
                                
                                $('#QuickStartTxtDescricptionId').autoFontSize({
                                maxFontPixels : 18,
                                minFontPixels : 14
                                });
                            }
                            
                        }

                    }

                } else {
                    $('#QuickStartTxtDescricptionId').autoFontSize({
                        maxFontPixels : 18,
                        minFontPixels : 10
                    });
                }

            }*/

           // $('#QuickStartTxtTitleId,#QuickStartTxtDescricptionId').css('visibility', 'visible');
        }, 350);

        //localStorage.setObj(KEY_IS_SAMSUNG_DEVICE, 'false');
        /*if(device.platform == "iOS") {
            localStorage.setObj(KEY_IS_SAMSUNG_DEVICE, 'false');
        } else {
            //removed handwriting feature
            var error = function(result) {
                
            };
            var success = function(result) {
                localStorage.setObj(KEY_IS_SAMSUNG_DEVICE, result);
            };
           // mUtilityManager.getDeviceManufacturer(success, error);
        }*/
         
        //prepare font & bg list
         if(Utils.getLocalStorageValue('fontList') == null || Utils.getLocalStorageValue('fontList').length == 0 ){
                   console.log("PERFORMANCE LOG::SETTINGS::HOME::START:: @quickstart initial start= " + new Date().getTime());
                       showAnimationLoader('');
                       isAppSyced = true;
                       mUtilityManager.getAppResourceList(function(result){
                       	    Utils.setLocalStorageValue('fontList',result); // Font
                       	          console.log("PERFORMANCE LOG::SETTINGS::HOME::START:: @quickstart initial font= " + new Date().getTime());
                                          resetLoader('');
                         },resetLoader,FONT_RES_ITEMS);
                      }
       
        //Handle App back button
        document.addEventListener("backbutton", onBackKeyDown, false);
    },
    // Update DOM on a Received Event
    receivedEvent : function(id) {
        console.log('Received Event: ' + id);
    },
    
};


function resetLoader(message){
	console.log("Error Found: "+message);
   isAppSyced = false;
   loaderObj.hideLoader();
}

//Handle back key
function onBackKeyDown(e){	
	var exitTimer;
	if (genericPopUpObj.isPopUpVisible()) {
		genericPopUpObj.hidePopUp();
		return false;
	}
	else if(isTutOpen==true){
		isTutOpen=false;
		$('#tutorialBack').trigger("tap");
	}
	else if($('#categoryContainerId').is(":visible")){
        $('#view-home').hide();
        $('#selectOrientation').hide();
        $('#categoryContainerId').removeClass('zoomEffect');
    }else if($('#addclipcontainer').is(':visible')){
    	$('#adclose').trigger('tap');
    	return false;
    }else if($('#selectOrientation').is(":visible")){
        $('#view-home').show();
        $('#categoryContainerId').show();
        $('#selectOrientation').hide();
    }else if(getTransformValues($('#templateListPage')).y=='0' || getTransformValues($('#scheduleListPage')).y == '0'){
        $('.backHandle').trigger('tap');
    }else if($('#Tutorial').is(":visible")){
        $.mobile.navigate("#QuickStartPage");    
    }else{
        if(exitCounter==0){
            Utils.showToast(langObj.index.COM_MIA_SID_PRESS_AGAIN_TO_EXIT_THIS_APPLICATION);
            exitCounter++;
	        exitTimer = setTimeout(function(){
	         	exitCounter = 0;
	        }, 3000);   
        }
        else{
        	clearTimeout(exitTimer);
            navigator.app.exitApp();
        }
    }
    
    
};


var exitCounter=0;
var isTutOpen=false;
var tutorialScroll = null;
var tplScroll = null;
var schScroll = null;
var iscopy=false;
var isScheduleCopy=false;
var schedulecolorindx="";
var category='';
var scheduleName='';
var schedulePath='';
var newSchedule='';
var templateName = '';
var newTemplateName = '';
var newTemplateFolderPath = '';


/* 
 * Variables below added for Mobile Version  
 */
var ORIENTATION_SELECTED = LANDSCAPE;
var CATEGORY_SELECTED = "C";
//Ready starts
$(function() {
  	log = new logger();
  	globlePlayerType = Utils.getActivePlayerType();
  	
	if(globlePlayerType==STRETCH_MODEL){//Stretch Model
	$('#QuickstrtBtnParentId').hide();
    }
    else{
    	$('#QuickstrtBtnParentId').show();
    }
    Utils.initializeScrollbar();
    var queryString = Utils.getUrlVars();
    var showOption=queryString['showOption']? queryString['showOption'] : "";
    ORIENTATION_SELECTED = queryString['orientation'] ? queryString['orientation'] : LANDSCAPE;
    CATEGORY_SELECTED = queryString['category'] ? queryString['category'] : "";
    if(showOption=='true' || (queryString['category'] && queryString['orientation']))
    {
        
        $("#view-home").show();        
        $('#categoryContainerId').show();
        $('#categoryContainerId').addClass('zoomEffect');
          
    }
    else
    {
        loaderObj.showLoader({'size':75,'interval':200});
    }
    /*
     * Written by Pradeep on 4Jun2015 for Mobile version
     */
    //Adjust the pixel calculation from percentage to pixel on Page load 
    applyPixelCalculation();
    
    $('.homeBtnCls').on('tap', function(e){
        e.stopPropagation();
        quickStartObj.closeBtnClick();
        return false;
    });
    
     /*
      * Animation for Settings Panel
      */
     $('.default-icon').on('tap', function(e){
         window.location.href = '../settings/Settings.html';         
      });  
     
     $('#closePanel').on('tap', function(e){
         quickStartObj.closePanel();
     });
   /*click the quick start button*/
    $('#QuickstrtBtnId').on('tap', function(e) {
        //isAddTemplateAllowed is check template count
        if(Utils.isAddTemplateAllowed()){
                quickStartObj.quickstartBtnClick(e,$(this));
        }
    });
    $('#customDesignBtnId').on('tap', function(e) {
        //isAddTemplateAllowed is check template count
        if(Utils.isAddTemplateAllowed()){           
          quickStartObj.gotoTemplatePage(Category.CUSTOM);
        }
         
    });  
    $('#AdclipBtnId').on('tap', function(e) {
        
       showadClipPage();
    
       selThemeChoice("Choice1");
         
    });       
    //Category List Click event goes here
    $('li.category-list').on('tap', function(e){
        e.stopPropagation();
        e.preventDefault();
        quickStartObj.selectCategoryType($(this));
    });
    
    // Next Button handle for Quickstart page
    $('.orientationNextCls').on('tap', function(e){
        //Show toast
        Utils.showToast(langObj.template.MIA_SID_CHOOSE_TEMPLATE_ORIENTATION_FIRST);
    });
    
    // Orientation Select event
    $('.select-orientation').on('tap', function(e){
        var orientID = $(this).attr('id');
        
        if(orientID=='portraitID')
        {
            ORIENTATION_SELECTED = PORTRAIT;    
        }
        else if(orientID=='landscapeID')
        {
            ORIENTATION_SELECTED = LANDSCAPE;
        }
        localStorage.setItem("orientationType",ORIENTATION_SELECTED);
        quickStartObj.gotoTemplatePage(CATEGORY_SELECTED,ORIENTATION_SELECTED,"");
    });
    
    //Template/Schedule List click handle
    $('.tplSchListHolder').on('tap', function(e){
        e.stopPropagation();
        exitCounter = 0;
        if($(this).attr('id')==='showTplList'){
            if($('#tplListDiv').find('.tplWrapper').length==0)
            {
                return false;
            }
            //$('#templateListPage').show().css({'transform':'translate(0px, 0px)'});
            $('#templateListPage').show().cssAnimation({
                x    : '0',
                y    : '0',
                onComplete: function() {
                
                }
            });
        }else if($(this).attr('id')==='showSchList'){
            
            if($('#schListDiv').find('.tplWrapper').length==0)
            {
                return false;
            }
            //$('#scheduleListPage').show().css({'transform':'translate(0px, 0px)'});
            $('#scheduleListPage').show().cssAnimation({
                x    : '0',
                y    : '0',
                onComplete: function() {
                
                }
            });
            
        }
        return false;
    }); 
    $('.editContent').on('tap', function(e){
        e.stopPropagation();
        if($(this).attr('id')==='editTplList' || $(this).attr('id')==='editTplList2'){
            if(!Utils.isAddTemplateAllowed()){
            	    if(!isAppSyced){
                      loaderObj.hideLoader();
                    }
                        return false;
                } 
            quickStartObj.gotoTemplatePage(Category.CUSTOM);
        }else if($(this).attr('id')==='editSchList' || $(this).attr('id')==='editSchList2'){
        
            var myScheduleInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
            if (myScheduleInfo != null && myScheduleInfo.myScheduleInfoArrs != null && myScheduleInfo.myScheduleInfoArrs.length > 29) {
                if(!isAppSyced){
                      loaderObj.hideLoader();
                    }
                Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
                return false;
            } else {
                quickStartObj.gotoSchedulePage(Category.CUSTOM,{isNewSchedule:"true"});
            }
    
        }
        return false;
    });
    ///Back button handle for template and schedule  
     $('.backHandle').on('tap', function(e){
         e.preventDefault();
         /*
         $('#templateListPage').hide();
         $('#scheduleListPage').hide();
         */
         //$('#templateListPage').css({'transform':'translate(0,100%)'});
         //$('#scheduleListPage').css({'transform':'translate(0,100%)'});
         
         $('#templateListPage, #scheduleListPage').cssAnimation({
                x    : '0',
                y    : '100%',
                onComplete: function() {
                    $('div.tplActionCls').css({'visibility':'hidden'});
                    $('.listDivInfoCls').removeClass('tempDelCopyModeCls');
                    $('.hideDelCopy').addClass('tplSchEditCls').removeClass('hideDelCopy');
                }
            });
         
         
     });
    
   
    
    var showCategory=queryString["showOption"];
    var isadclipback = queryString["isadClip"];
     category = queryString["category"];
     scheduleName = queryString["scheduleName"];
     schedulePath = queryString["schedulePath"];
     newSchedule = queryString["isNewSchedule"];
    if(showCategory =='true' || showCategory ==true)
    {
        $('#view-home').show();
    }
    if (isadclipback == 'true') {
    	$('#QuickStartPage').hide();
    	showadClipPage();
	}
    $(document).on('touchmove', '.popUpParentCls', function(e){
        e.preventDefault();
        e.stopPropagation();
    });
    
    //Set Quick Start Button Width Dyamically based on device width
    //$('#newconection,#customDesignLink').width($(window).width()*0.27);
    
    //Handle Template list icon click 
     $('#tplListDiv').on('tap', '.tplSchEditCls', function(e){
        e.preventDefault();
        e.stopPropagation();
        $('#tplListDiv').find('div.hideDelCopy').removeClass('hideDelCopy').addClass('tplSchEditCls');
        $('#tplListDiv').find('.listDivInfoCls').removeClass('tempDelCopyModeCls');
        $('#tplListDiv').find('.tplActionCls').css({'visibility':'hidden'});
        
        var liObj = $(this).closest('div.tplWrapper');
        liObj.find('div.tplActionCls').css({'visibility':'visible'});
        //liObj.find('.listDivInfoCls').addClass('tempDelCopyModeCls');
        $(this).addClass('hideDelCopy').removeClass('tplSchEditCls');
        
    });
     $('#tplListDiv').on('tap', '.hideDelCopy', function(e){
        e.preventDefault();
        e.stopPropagation();
        var liObj = $(this).closest('div.tplWrapper');
        liObj.find('div.tplActionCls').css({'visibility':'hidden'});
        //liObj.find('.listDivInfoCls').removeClass('tempDelCopyModeCls');
        $(this).addClass('tplSchEditCls').removeClass('hideDelCopy');
        
    });
    
    //Handle Schedule list icon click 
    $('#schListDiv').on('tap', '.tplSchEditCls', function(e){
        e.preventDefault();
        e.stopPropagation();
        $('#schListDiv').find('div.hideDelCopy').removeClass('hideDelCopy').addClass('tplSchEditCls');
        $('#schListDiv').find('.listDivInfoCls').removeClass('tempDelCopyModeCls');
        $('#schListDiv').find('.tplActionCls').css({'visibility':'hidden'});
        
        var liObj = $(this).closest('div.tplWrapper');
        liObj.find('div.tplActionCls').css({'visibility':'visible'});
        //liObj.find('.listDivInfoCls').addClass('tempDelCopyModeCls');
        $(this).addClass('hideDelCopy').removeClass('tplSchEditCls');
        
    });
     $('#schListDiv').on('tap', '.hideDelCopy', function(e){
        e.preventDefault();
        e.stopPropagation();
        var liObj = $(this).closest('div.tplWrapper');
        liObj.find('div.tplActionCls').css({'visibility':'hidden'});
        //liObj.find('.listDivInfoCls').removeClass('tempDelCopyModeCls');
        $(this).addClass('tplSchEditCls').removeClass('hideDelCopy');
        
    });
    
    /*  Highlighting the  visited tutorial Youtube videos 
     *  Added by p.pathak
     */

    var vistedVideos = localStorage.getObj('tutorialVisited');
    if(vistedVideos)
    {
        $('.youtubeLink').each(function(i,val){
            //Show visited class if this video has been visited
             if(jQuery.inArray($(this).data('token'), vistedVideos)!=-1)
             {
                 $(this).find('.Sub_name_text').addClass('youtubelink-visited');
             }
             else
             {
                 $(this).find('.Sub_name_text').removeClass('youtubelink-visited');
             }
        });
    }
    
    //Handle copy click 
     $('#tplListDiv').on('tap', '.copyTplCls', function(e){
        e.preventDefault();
        e.stopPropagation();
        
       // loaderObj.showLoader({imgarr:['../resource/img/ic_btn_loading_01.png','../resource/img/ic_btn_loading_02.png','../resource/img/ic_btn_loading_03.png','../resource/img/ic_btn_loading_04.png'],'text':'Loading...','size':75,'interval':200});
    
        if(!Utils.isAddTemplateAllowed())
        {
            if(!isAppSyced){
              loaderObj.hideLoader();
            }
            return false;
        }         
        var liObj = $(this).closest('div.tplWrapper');
        var templateID = liObj.attr('data-templateId');
        var templatePath = liObj.attr('data-path');
        var category = liObj.attr('data-category');
        var orientation = liObj.attr('data-orientation');        
        var templateDuration = $(this).parent().parent().parent().attr('data-duration'); 
        var templateFolderPath = templatePath.substring(0, templatePath.lastIndexOf('/'));        
        templateName = templateFolderPath.substring(templateFolderPath.lastIndexOf('/')+1);    
        newTemplateFolderPath = getNewTemplatePath(templateFolderPath);        
        newTemplateName = newTemplateFolderPath.substring(newTemplateFolderPath.lastIndexOf('/')+1);
        var newTemplatePath = newTemplateFolderPath + "/" +newTemplateName+".LFD";
        var newTemplateThumbPath = /*systemRootPath +*/ newTemplatePath + ".PNG";
        copyFolder(templateFolderPath,newTemplateFolderPath,"COPY_TEMPLATE", function(bStatus){
            console.log("Template Folder copied "+bStatus);
        });
        
        insertTemplateInfo(newTemplateName+".LFD", newTemplatePath, newTemplateThumbPath, category, orientation,globlePlayerType,templateDuration);
        liObj.find('div.tplActionCls').css({'visibility':'hidden'});
        liObj.find('.listDivInfoCls').addClass('tempDelCopyModeCls');
        liObj.find('hideDelCopy').addClass('tplSchEditCls').removeClass('hideDelCopy');
        
        setTimeout(function(){
            
                var copyTemplateInfoObj = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
                var copyTplInfo = copyTemplateInfoObj.myTemplateInfoArrs[0];
                
                
                var tplInfoObj = {};
                tplInfoObj.orientationCls = copyTplInfo.orientationType+'Mode';
                tplInfoObj.templatePath = copyTplInfo.tempPath;
                tplInfoObj.categoryName = copyTplInfo.categoryName;
                tplInfoObj.orientation = copyTplInfo.orientationType;
                tplInfoObj.duration = copyTplInfo.duration;
                tplInfoObj.templateId = copyTplInfo.templateId;
                tplInfoObj.templateThumbPath = Utils.getSystemRootPath() + copyTplInfo.thumbPath +"?timestamp=" + new Date().getTime();
                tplInfoObj.templateName = copyTplInfo.templateName;    
                
                 if(typeof(tplInfoObj.templateName)!='undefined')
                {
                    tplInfoObj.templateName=tplInfoObj.templateName.replace(".LFD",""); // temp    
                }
                quickStartObj.showSavedTemplateList();
            //$(quickStartObj.createTemplateInfo(tplInfoObj)).hide().prependTo('#tplListDiv').fadeIn();
                
           },500);  
     });
     $('#tplListDiv').on('tap', '.delTplCls', function(e){
         e.preventDefault();
         e.stopPropagation();
         var currObj=$(this);
         genericPopUpObj.createPopUp("","Type1");
         genericPopUpObj.appendHTMLData([MIA_SID_SCHEDULE_USING_SELECTED_TEMPLATE_CONTINUE]);
         genericPopUpObj.addFooterBtns([{"btntxt":COM_TV_SID_NO,"callback":function(){
                 
        $('div.tplActionCls').css({'visibility':'hidden'});
        $('.listDivInfoCls').removeClass('tempDelCopyModeCls');
        $('.hideDelCopy').addClass('tplSchEditCls').removeClass('hideDelCopy');
        
                 closeGenericPopUp();
             }}
         ,{"btntxt":COM_TV_SID_YES,"callback":function(){   
                         
                         
                          //currObj.closest('div.tplWrapper').remove();
                         
                          
                          var templateID = currObj.parent().parent().parent().attr('data-templateId');
                          var templatePath = currObj.parent().parent().parent().attr('data-path');
                          var templateFolderPath = templatePath.substring(0, templatePath.lastIndexOf('/'));
                          deleteFolder(templateFolderPath,function(bStatus){
                            console.log("Template Folder deleted "+bStatus);
                           });
                     deleteTemplateFromDB(templateID);
                     setTimeout(function(){
                         quickStartObj.showSavedTemplateList();
                     }, 200);
                     
                     
                }}
            ]);
        genericPopUpObj.showPopUp();
         
     });
     $('#schListDiv').on('tap', '.copyTplCls', function(e){
         e.preventDefault();
         e.stopPropagation();
          isScheduleCopy=true;
         
         //loaderObj.showLoader({imgarr:['../resource/img/ic_btn_loading_01.png','../resource/img/ic_btn_loading_02.png','../resource/img/ic_btn_loading_03.png','../resource/img/ic_btn_loading_04.png'],'text':'Loading...','size':75,'interval':200});
        
          var myScheduleInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
          if(myScheduleInfo!=null && myScheduleInfo.myScheduleInfoArrs!=null && myScheduleInfo.myScheduleInfoArrs.length >29)
             {
                 $('div.tplActionCls').css({'visibility':'hidden'});
                $('.listDivInfoCls').removeClass('tempDelCopyModeCls');
                  $('.hideDelCopy').addClass('tplSchEditCls').removeClass('hideDelCopy');
                  if(!isAppSyced){
                      loaderObj.hideLoader();
                    }
                  Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
                  return false;
              }    
        var liParent = $(this).closest('div.tplWrapper');
        var schPath = liParent.data('schpath');
        ScheduleUtils.clean();
        ScheduleUtils.schName = liParent.data('schname');
        ScheduleUtils.schId =  liParent.data('schid');
        schedulecolorindx=liParent.data('colorindex');
        
        var schFolderPath = schPath.substring(0, schPath.indexOf(ScheduleUtils.schName)) + ScheduleUtils.schName;
        
        var schDirectory = schPath.substring(0, schPath.indexOf(ScheduleUtils.schName));
        var schFolderPath = schDirectory + ScheduleUtils.schName;
        var playlistFolderPath = Utils.rootPath + "/Playlist/"+ ScheduleUtils.schName;
     
        // Create new schedule name
        ScheduleUtils.createSchName(schDirectory,ScheduleUtils.schName, function(newCpyName){
            
            ScheduleUtils.newSchName = schDirectory + newCpyName;
            var newPlaylistFolderPath = Utils.rootPath + "/Playlist/" + newCpyName;  
            ScheduleUtils.newSchPath = schPath.substring(0, schPath.lastIndexOf('/')).replace(ScheduleUtils.schName,newCpyName);
    		
              copyFolder(schFolderPath, ScheduleUtils.newSchName,"COPY_SCHEDULE", function(bStatus){
                 console.log("Schedule folder copied "+ bStatus);
                 if(Boolean(bStatus)){
                   // Copy play-list folder if exist. 
                   copyFolder(playlistFolderPath, newPlaylistFolderPath,"COPY_SCHEDULE", function(playlistStatus){
	                   console.log("Playlist folder copied "+ playlistStatus);	  
	                   //DF160122-00129 fixed
	                   funCallBack = null;    
	                   ScheduleUtils.modifySchDirectory();              
                    });                          
                  }
             });
             
              setTimeout(function(){
                       /*  var myScheduleInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
                         var copiedSchInfo = myScheduleInfo.myScheduleInfoArrs[0];
                         schInfoObj = {};
                      schInfoObj.orientationCls = "landscapeMode";
                      schInfoObj.scheduleName = copiedSchInfo.scheduleName;
                      schInfoObj.scheduleId = copiedSchInfo.scheduleId;
                      schInfoObj.colorindx = copiedSchInfo.colorindx;
                      schInfoObj.scheuleFilePath = copiedSchInfo.scheuleFilePath;
                      schInfoObj.scheuleThumbNailPath = Utils.getSystemRootPath() + copiedSchInfo.scheuleThumbNailPath + "?timestamp=" + new Date().getTime();
                      schInfoObj.errorIconShow = false;
                      alert(JSON.stringify(schInfoObj));
                      console.log(JSON.stringify(schInfoObj));
                      $(quickStartObj.createScheduleInfo(schInfoObj)).hide().prependTo('#schListDiv').fadeIn();
                      */
                         getScheduleInfo(true, function(bStatus){
                            quickStartObj.showSavedScheduleList();
                          }); 
                        
                        
                        
                      },500);  
         
         });
     });
     $('#schListDiv').on('tap', '.delTplCls', function(e){
         e.preventDefault();
         e.stopPropagation();
         var liParent = $(this).closest('div.tplWrapper');
         var currObj=$(this);
         genericPopUpObj.createPopUp("","Type1");
         genericPopUpObj.appendHTMLData([MIA_SID_DELETE_SELECTED_SCHEDULE]);
         genericPopUpObj.addFooterBtns([{"btntxt":COM_TV_SID_NO,"callback":function(){
         $('div.tplActionCls').css({'visibility':'hidden'});
         $('.listDivInfoCls').removeClass('tempDelCopyModeCls');
         $('.hideDelCopy').addClass('tplSchEditCls').removeClass('hideDelCopy');
        
                 closeGenericPopUp();
         }}
        ,{"btntxt":COM_TV_SID_YES,"callback":function(){ 
        
              var schPath = liParent.data('schpath');
              var name = liParent.data('schname');
              var id = liParent.data('schid');
              
              
              currObj.closest('div.tplWrapper').remove();  
              //Enable '+' icon of Schedule
              $('#editSchList').removeClass('icon-disabled');
                  
              var schFolderPath = schPath.substring(0, schPath.indexOf(name)) + name;
              deleteFolder(schFolderPath,function(bStatus){
                  
                console.log("Schedule folder deleted "+ bStatus);
                if(Boolean(bStatus)){
                  var playlistFolderPath = Utils.rootPath + "/Playlist/"+ name;   
                  deleteFolder(playlistFolderPath);
                  console.log(playlistFolderPath +" Playlist folder deleted ");     
                  deleteScheduleFromDBByID(id);
                 
              
            
                  
                  
                  //reset quick start page and set initial page 
                  if($('#schListDiv').find('div.tplWrapper').length == 0)
                    {
                        var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
                        var templateLength = templateInfo.myTemplateInfoArrs.length;
                        if(templateLength == 0){
                        	quickStartObj.disableSchTplDisplay();	
                        }
                        $('#schHeaderID').addClass('icon-disabled');
				    }
                    else
                    {
                    	$('#schHeaderID').removeClass('icon-disabled');
                    }
                    
                  
                }
            });
                          
            }}
          ]);
        genericPopUpObj.showPopUp();
        
        
         
     });
     
     //Go to Template edit page
     $('#tplListDiv').on('tap','div.tplWrapper', function() {
       var templatePath=$(this).data('path');
       var orientation=($(this).data('orientation') == 'portrait') ? PORTRAIT : LANDSCAPE;
       quickStartObj.gotoTemplatePage(Category.CUSTOM,orientation,templatePath);
	    return false;
    });
      
      //Go to Schedule edit page
     $('#schListDiv').on('tap','div.tplWrapper', function() {
        var liParent = $(this).closest('div.tplWrapper');
        var schPath = liParent.data('schpath');
        ScheduleUtils.clean();
        ScheduleUtils.schName = liParent.data('schname');
        quickStartObj.gotoSchedulePage(Category.CUSTOM,{schedulePath:schPath,scheduleName:ScheduleUtils.schName,isNewSchedule:"false",navigateFromTemplate:"false"});
		return false;
    });
    $('.SettingsIconId').on('tap', function() {
        window.location.href = '../settings/Settings.html';
    });
   /*
    * Tutorial Icon click page animation
    * Added by Pradeep
    */
   $('#tutorialID').off('tap').on('tap', function(e){
	   e.preventDefault();
  		e.stopPropagation();
        exitCounter = 0;
        isTutOpen=true;      
        $('#addclipcontainer').hide('fast',function(){});
        $('#QuickStartPage').hide();
        $("#Tutorial").fadeIn();        
        return false;
   });
    
    $('#tutorialBack').off('tap').on('tap', function(e){
    	 e.preventDefault();
    	e.stopPropagation();
        isTutOpen=false;
        $('#QuickStartPage').fadeIn();
        $("#Tutorial").hide();
        return false;
   });
    
    /* Added by Pradeep on 21Feb */
    $('#TutorialIconId_new').on('click',function(){
        
        $('#LeftQuickStartBtmIcons>#TutorialIconId>.Iconcls').trigger('tap');
         $("#view-home").hide();
         $('#LeftQuickStartBtmIcons').show();
    });
    
    $('#Exit_tutorial_btn').on('tap', function closeSelectCategory() {
        isTutOpen=false;
        if($('#RightQuickStartbg').css('display')=='block')
        {
            $('#LeftQuickStartPageId').animate({'width':'49.5%'});
        }
        else
        {
            $('#LeftQuickStartPageId').animate({'width':'38%'});    
        }
        
        $('#QuickStartPage').animate({
            'left' : '0%'
        });
        $('#Tutorial').css({
            'visibility' : 'visible'
        });
        $('#Tutorial').animate({
            'left' : '-61%'
        });

        $("#view-home").css('background-image',"url('../resource/img/bg_category.png')");
        $('#Exit_tutorial_btn').attr('src' , "../resource/img/ss_tutorial_btn_close_s.png" );
    });
    

    /*Go to YOUTUBE*/
    
    //Open Youtube link
    //Added by p.pathak
    
    $('.youtubeLink_1').on('tap', function(e){
    	  var thisVal = $(this);
          openYoutubePlayer(thisVal);
    });
    
     $('.youtubeLink_2').on('tap', function(e){
     	 var thisVal = $(this);
         openYoutubePlayer(thisVal);
    });

    $('.Link_btn').on('tap', function() {
        $(this).css('background-image', 'url("../resource/img/ss_icon_video_play_l_s.png")');
        setTimeout(function() {
            $('.Link_btn').css('background-image', 'url("../resource/img/ss_icon_video_play_l_n.png")');
        }, 200);
    });
    
    
    // Tips for beginners
    $('#Quick_start_btn').on('tap', function() {   
        $('#Quick_check').attr("src", "../resource/img/ss_icon_check_s.png");
        
        $('#Tutorial_view').show();
        
    });
    
    $('#Design_your_ads_btn').on('tap', function() {   

       
        $('#Design_check').attr("src", "../resource/img/ss_icon_check_s.png");
    });
    
    $('#Schedule_btn').on('tap', function() {   

       
        $('#Schedule_check').attr("src", "../resource/img/ss_icon_check_s.png");
    });
    
    $('#Complete_your_work_btn').on('tap', function() {   

       
        $('#Complete_check').attr("src", "../resource/img/ss_icon_check_s.png");
    });

    $('#view-home >.closeBtn').on('tap', function(e) {
        $("#view-home").hide();
        $('#LeftQuickStartBtmIcons').show();
        e.preventDefault();
        e.stopPropagation();
    });


    /////////////////////////////////////////////////////////////////////////////////
  
    

  /*  var quickStartObj = new QuickStart();         
    var tInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
    var sInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
      
    
    if(( tInfo != undefined && tInfo.myTemplateInfoArrs.length > 0) ||
               (sInfo != undefined && sInfo.myScheduleInfoArrs.length > 0)){
       
       setTimeout(function(){    
       getScheduleInfo(true, function(bStatus){
          getTemplateInfo( function(bStatus){
                quickStartObj.showSavedTemplateList();
                quickStartObj.showSavedScheduleList();
             });
          }); 
        },500);       
                   
     }else{
         
         var len = 0;
        var str  = document.location.search.substr(1).split("=");
        if(str[1] != undefined)
         len = parseInt(str[1]);
        if(len > 0)        
          quickStartObj.enableSchTplDisplay();        
        setTimeout(function(){
        getScheduleInfo(true, function(bStatus){
          getTemplateInfo( function(bStatus){
                quickStartObj.showSavedTemplateList();
                quickStartObj.showSavedScheduleList();
                 
             });
          });       
        },500);         
         
     } 
*/


$('#designTitleId').css({'font-size':parseInt($(window).width()*0.032)+'px'});
$('#LeftQuickStartCreatedTxtId').css({'font-size':parseInt($(window).width()*0.015)+'px'});

});//Ready closed

var QuickStart = function(){
    
};
QuickStart.prototype.uploadListOnQuickStart=function()
{
	var quickStartObj = this;         
    var tInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
    var sInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));      
    if(( tInfo != undefined && tInfo.myTemplateInfoArrs.length > 0) ||
               (sInfo != undefined && sInfo.myScheduleInfoArrs.length > 0)){
       //setTimeout(function(){  
       	console.log("getTemplateInfo 1");  
       getScheduleInfo(true, function(bStatus){
       	console.log("getTemplateInfo 2");  
          getTemplateInfo( function(bStatus){
                quickStartObj.showSavedTemplateList();
                quickStartObj.showSavedScheduleList();
             });
          }); 
        //},500);       
     }else{
         var len = 0;
        var str  = document.location.search.substr(1).split("=");
        if(str[1] != undefined)
         len = parseInt(str[1]);
        if(len > 0)        
          quickStartObj.enableSchTplDisplay();        
        //setTimeout(function(){
        	console.log("getTemplateInfo 3111");  
        getScheduleInfo(true, function(bStatus){
        	console.log("getTemplateInfo 4111");  
          getTemplateInfo( function(bStatus){
                quickStartObj.showSavedTemplateList();
                quickStartObj.showSavedScheduleList();
             });
          });       
       // },500);         
     } 	
};
QuickStart.prototype.showSavedTemplateList = function(){
    var tplList = "";
    var templateLength = 0;
    var templateArr;
    var templateInfo = JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
    if(templateInfo)
    {
        templateLength=templateInfo.myTemplateInfoArrs.length;
        templateArr=templateInfo.myTemplateInfoArrs;    
    }    
   // Get Schedule length
    var myScheduleInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
    //Show Template list area when there is at least one template
    if(templateLength > 0 || myScheduleInfo.myScheduleInfoArrs.length > 0)
    {
    	
    	this.enableSchTplDisplay();
    	if(templateLength>0){
    		$('#tplHeaderID').removeClass('icon-disabled');
    	}else{
    		$('#tplHeaderID').addClass('icon-disabled');
    	}
    	
    	if(templateLength>=30){
    		$('#editTplList').addClass("icon-disabled");	
    	}else{
    		$('#editTplList').removeClass("icon-disabled");
    	}
       if(myScheduleInfo.myScheduleInfoArrs.length >=30){
       		$('#editSchList').addClass("icon-disabled");
       }else{
       		$('#editSchList').removeClass("icon-disabled");
       }
       //icon-disabled
       
    }
    else
    {
       this.disableSchTplDisplay();    
    }  
    $('.innerList').html(""); 
    var botMarginVal = Math.round($(window).width()*0.026);
    var landTplHeight = Math.round($(window).outerHeight()*0.208);
    var portTplHeight = Math.round(landTplHeight*2+botMarginVal)+2;
    var mActivePlayerType = globlePlayerType;
    for (var i=0; i<templateLength; i++) {
       if(!LOWER_PLAYER_TYPE_SUPPORT || templateInfo.myTemplateInfoArrs[i].playerType == mActivePlayerType){
            var templateId = templateArr[i].templateId;
            var templateName=templateArr[i].templateName;
            if(typeof(templateName)!='undefined')
            {
                templateName=templateName.replace(".LFD",""); // temp
            }

           // var templateThumbPath="../resource/img/tpl1.png";
            var templatePath=templateArr[i].tempPath;
            var templateThumbPath= Utils.getSystemRootPath() + templateArr[i].thumbPath +"?timestamp=" + new Date().getTime();
            var categoryName=templateArr[i].categoryName;
            var orientation=templateArr[i].orientationType;
            var duration = templateArr[i].duration;
            var orientationCls = "";

            if(orientation=='portrait')
             {
                   orientationCls = "portraitMode";
             }
             else
             {
                 orientationCls = "landscapeMode";
             }

            var tplInfoObj = {};
            tplInfoObj.orientationCls = orientationCls;
            tplInfoObj.templatePath = templatePath;
            tplInfoObj.categoryName = categoryName;
            tplInfoObj.orientation = orientation;
            tplInfoObj.duration = duration;
            tplInfoObj.templateId = templateId;
            tplInfoObj.templateThumbPath = templateThumbPath;
            tplInfoObj.templateName = templateName;
            tplInfoObj.botMarginVal = botMarginVal;
            tplInfoObj.landTplHeight = landTplHeight;
            tplInfoObj.portTplHeight = portTplHeight;

               //tplList +=quickStartObj.createTemplateInfo(tplInfoObj);
            //console.log($('#tplList-one').height()+" > "+$('#tplList-two').height());
            if($('#tplList-one').height()==0 || ($('#tplList-one').height() <= $('#tplList-two').height()))
            {
                $('#tplList-one').append(quickStartObj.createTemplateInfo(tplInfoObj));
            }
            else if($('#tplList-one').height() > $('#tplList-two').height())
            {
                $('#tplList-two').append(quickStartObj.createTemplateInfo(tplInfoObj));
            }
      }
     }   
    
     //
     //$('#tplList-one').append(tplList);
     //$('#tplListDiv').append(tplList);
     $('.tplSchEditCls').authorActiveClass();
     $('.delTplCls').authorActiveClass();
     $('.copyTplCls').authorActiveClass();
     
     if(!isAppSyced){
      loaderObj.hideLoader();
      var choice=localStorage.getItem("choice"); 
      selThemeChoice(choice);
    }
           
                 
};
function showadClipPage(){
	  isAddClip=true;  
       localStorage.setItem("isAddClip", true);
       $('#QuickStartPage').hide();
       $('#addclipcontainer').show();
       $('#addclipcontainer').css("visibility","visible");       
       $('#addclipcontainer').height(window.innerHeight);
	   $('#addclipcontainer').width(window.innerWidth);
	   
   	  var txtDivObj=$("#textdiv");
   	   updateThemeFontSize(txtDivObj,"adClipThemeSelFont",true);
   	   updateAllThemesTxtFont();
   	   
}
function updateAllThemesTxtFont()
{
	var minV=999;
	   var calF=0;
	   for(var i=1;i<4;i++)
	  {
		   calF=updateThemeTxtFontSize(i);
		   if(calF<minV)
		  {
			   minV=calF;
		  }		  
	  }
	   console.log("updateAllThemesTxtFont :: minV:"+minV);
	 $(".ChooseThemeTxt").css({'font-size':minV+'px','visibility':'visible'});
}
function updateThemeTxtFontSize(themeNo)
{
	var itmSsName='Choice'+themeNo+'TxtFont';
	var txtDivObj=$("#Choice"+themeNo+"Txt");
	return updateThemeFontSize(txtDivObj,itmSsName,false);	
}
function updateThemeFontSize(txtDivObj,ssString,isShow)
{
	var selThemeTxtFntS= sessionStorage.getItem(ssString);	
    if(selThemeTxtFntS==null || selThemeTxtFntS=="null")
	{	    		
    	txtDivObj.css({'visibility':'hidden'});
    	selThemeTxtFntS=Utils.getRightFontSize(txtDivObj);
		sessionStorage.setItem(ssString,selThemeTxtFntS);
	}
    if(isShow)
    {
    	txtDivObj.css({'font-size':selThemeTxtFntS+'px','visibility':'visible'});
    }
    return selThemeTxtFntS;
}
QuickStart.prototype.showSavedScheduleList = function(){
     
    var myScheduleInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
    
   var schList = "";
   $('#schListDiv').html("");
   if(myScheduleInfo.myScheduleInfoArrs.length > 0){
        $('#schHeaderID').removeClass('icon-disabled');
    }else{
        $('#schHeaderID').addClass('icon-disabled');
    }

   if(myScheduleInfo.myScheduleInfoArrs.length>=30){
        $('#editSchList').addClass('icon-disabled');
   }else{
        $('#editSchList').removeClass('icon-disabled');
   }
   //Show Template list area when there is at least one template
   if(myScheduleInfo!=null && myScheduleInfo.myScheduleInfoArrs!=null && myScheduleInfo.myScheduleInfoArrs.length > 0)
   {
   quickStartObj.enableSchTplDisplay();
   var rootPath = Utils.getSystemRootPath();
   $.each(myScheduleInfo.myScheduleInfoArrs, function(index, value) {
          var scheuleThumbNailPath = rootPath + value.scheuleThumbNailPath + "?timestamp=" + new Date().getTime();
          var errorIconShow = "display:none;";
          if(value.scheuleSentStatus=="false")
          {
              errorIconShow = "display:block;";
          }
          else
          {
             errorIconShow = "display:none;";
          }


          var schInfoObj = {};
          schInfoObj.orientationCls = "landscapeMode";
          schInfoObj.scheduleName = value.scheduleName;
          schInfoObj.scheduleId = value.scheduleId;
          schInfoObj.colorindx = value.colorindx;
          schInfoObj.scheuleFilePath = value.scheuleFilePath;
          schInfoObj.scheuleThumbNailPath = value.scheuleThumbNailPath;
          schInfoObj.scheuleThumbNailPath = scheuleThumbNailPath;
          schInfoObj.scheduleName = value.scheduleName;
          schInfoObj.errorIconShow = errorIconShow;
          schList+= quickStartObj.createScheduleInfo(schInfoObj);
          });
       $('#schListDiv').append(schList);
       $('.tplSchEditCls').authorActiveClass();
       $('.delTplCls').authorActiveClass();
      $('.copyTplCls').authorActiveClass();

        setTimeout(function(){
            if(!isAppSyced){
              loaderObj.hideLoader();
               var choice=localStorage.getItem("choice");
                selThemeChoice(choice);
            }
        }, 2000);

    }
    
};
QuickStart.prototype.createTemplateInfo = function(tplInfoObj){
    var elementHeight = tplInfoObj.landTplHeight;
    if(tplInfoObj.orientationCls == 'portraitMode')
    {
        elementHeight = tplInfoObj.portTplHeight;
    }
    var fontSize = "";
    var loc = sessionStorage.getItem('locale');
    if(loc=='ru'){
        fontSize = '10px';
    }
     var tplInfo ='<div  class="'+tplInfoObj.orientationCls+' tplWrapper" style="height:'+elementHeight+'px; margin:0 '+tplInfoObj.botMarginVal+'px '+tplInfoObj.botMarginVal+'px 0;" data-path="'+tplInfoObj.templatePath+'" data-category="'+tplInfoObj.categoryName+'" data-orientation="'+tplInfoObj.orientation+'" data-duration="'+tplInfoObj.duration+'" data-templateId="'+tplInfoObj.templateId+'">'
                +'<div class="listTpltDivCls" style="background-image:url(\''+tplInfoObj.templateThumbPath+'\')">'
                +'<div class="tplActionCls">'
                  +'<div class="copyTplCls" style="font-size:'+fontSize+'">'+langObj.QuickStart.COM_IDS_EDIT_COPY+'</div>'
                  +'<div class="delTplCls" style="font-size:'+fontSize+'">'+langObj.QuickStart.IDS_BTN_DELETE+'</div>'
                +'</div>'
                +'</div>'
                +'<div class="listDivInfoCls">'
                   +' <div class="tplSchNameCls">'
                     +tplInfoObj.templateName
                   +' </div>'
                    +'<div class="tplSchEditCls">'
                   +' </div>'
                +'</div>'
            +'</div>';
   return tplInfo;
};
QuickStart.prototype.createScheduleInfo = function(schInfoObj){
    var fontSize = "";
    var loc = sessionStorage.getItem('locale');
    if(loc=='ru'){
        fontSize = '10px';
    }
    var schInfo ='<div  class="'+schInfoObj.orientationCls+' tplWrapper" data-schname="'+schInfoObj.scheduleName+'"  data-schid="'+schInfoObj.scheduleId+'" data-colorindex="'+schInfoObj.colorindx+'" data-schpath="'+schInfoObj.scheuleFilePath+'" data-thumbnail="'+schInfoObj.scheuleThumbNailPath+'" >'
                     +'<div class="iconError" style="'+schInfoObj.errorIconShow+'"></div>'
                      +'<div class="listSchDivCls" style="background-image:url(\''+schInfoObj.scheuleThumbNailPath+'\')">'
                       +'<div class="tplActionCls">'
                          +'<div class="copyTplCls" style="font-size:'+fontSize+'">'+langObj.QuickStart.COM_IDS_EDIT_COPY+'</div>'
                          +'<div class="delTplCls" style="font-size:'+fontSize+'">'+langObj.QuickStart.IDS_BTN_DELETE+'</div>'
                        +'</div>'
                      +'</div>'
                      +'<div class="listDivInfoCls borderTopSchName">'
                      +'<div class="tplSchNameCls schnameCls">'
                      +schInfoObj.scheduleName
                      +'</div>'
                      +'<div class="tplSchEditCls">'
                      +'</div>'
                      +'</div>'
                      +'</div>';
                  
           return schInfo;
};
function renameTemplate(){
    renameFile(templateName+".LFD", newTemplateFolderPath, newTemplateName+".LFD",function(bStatusLfd){
           console.log("LFD file renamed "+bStatusLfd);
           if(bStatusLfd){
                   renameFile(templateName+".LFD.PNG", newTemplateFolderPath, newTemplateName+".LFD.PNG",function(bStatusThumb){
                      console.log("LFD thumbnail renamed "+bStatusThumb);
                   });
           }
   });
}
/*
 * Click Events Section goes here
 */

QuickStart.prototype.enableSchTplDisplay = function(){
    
    $('#quickstart-logo').hide();
    $('#noContentId').addClass('changeBackground');
    $('#TemplateScheduleList').show();
};

QuickStart.prototype.disableSchTplDisplay = function(){
    
    $('#quickstart-logo').show();
    $('#TemplateScheduleList').hide();
    $('#noContentId').removeClass('changeBackground');
};

//Method to handle animation for settings panel
QuickStart.prototype.animateSettingsPanel = function(){
    if($('#LeftQuickStartPageId').hasClass('page-animate'))
     {
         $('.settings-panel').removeClass('panel-animate');
         $('#LeftQuickStartPageId').removeClass('page-animate');
     }
     else
     {
         $('.settings-panel').addClass('panel-animate');
         $('#LeftQuickStartPageId').addClass('page-animate');
     }
};
//Close Settings Panel
QuickStart.prototype.closePanel = function(){
    $('#LeftQuickStartPageId').removeClass('page-animate');
    $('.settings-panel').removeClass('panel-animate');
};

//Category Click event handle
QuickStart.prototype.selectCategoryType = function($this){
    var categoryID = $this.attr('id');
    switch(categoryID){
        case 'menuBoardId':
            CATEGORY_SELECTED = "M";
        break;
        case 'liveTVvideoId':
            CATEGORY_SELECTED = "L";
        break;
        case 'slideshowId':
            CATEGORY_SELECTED = "S";
        break;
        case 'promotionId':
            CATEGORY_SELECTED = "P";
        break;
        case 'informationId':
            CATEGORY_SELECTED = "I";
        break;
        default:
        break;
    }
    
    var selectedOrientation = localStorage.getItem("orientationType");
    if(selectedOrientation){
        //Directly goto template page
        quickStartObj.gotoTemplatePage(CATEGORY_SELECTED,selectedOrientation,"");
    }
    else{
        $('#categoryContainerId').hide();
        $('#selectOrientation').show();    
    }
};
//Quick Start Btn Click event handle
QuickStart.prototype.quickstartBtnClick = function(e, $this){
        e.stopPropagation();
        e.preventDefault();
        $("#view-home").show();
         if(!Utils.isAddTemplateAllowed())
        {
            loaderObj.hideLoader();
            return false;
        }       
        exitCounter = 0;
        $('.quickstartCategory').hide();
        $('#categoryContainerId').show();
        setTimeout(function(){
            $('#categoryContainerId').addClass('zoomEffect');
        },50);
        
};
//Close button click event
QuickStart.prototype.closeBtnClick = function(){
    $('#view-home').hide();
    $('#selectOrientation').hide();
    $('#categoryContainerId').removeClass('zoomEffect');
    
    /*
     *Clear these variables on close button click
     * And initialize its initial values 
     */
    ORIENTATION_SELECTED = LANDSCAPE;
    CATEGORY_SELECTED = "C";
};
QuickStart.prototype.gotoSchedulePage=function(category,queryString)
{
    var urlPath="../schedule/Schedule.html?category=" + category;
    for (x in queryString) {
        urlPath += "&"+x+"="+queryString[x];
    }
    this.navigateToUrl(category,urlPath);
};
QuickStart.prototype.gotoTemplatePage=function(category,orientation,templatePath)
{
    if(category==undefined || $.trim(category)=="")
    {
        category=Category.CUSTOM;
    }
    var urlPath="../template/template.html?category="+category;
    if(orientation!=undefined && orientation!="")
    {
        urlPath=urlPath+"&orientation="+orientation;
    }
    if(templatePath!=undefined && templatePath!="")
    {
        urlPath=urlPath+"&templatePath="+templatePath;
    }
    this.navigateToUrl(category,urlPath);
};
QuickStart.prototype.navigateToUrl=function(category,urlPath)
{
    mUiHandler.selectCategory(category,function(){
         window.location.href = urlPath;
    },function(){
        console.log("error in setting category");
    });
};
    var quickStartObj = new QuickStart();


/** 
 *  Function body will be written here
 * /
 */
function applyPixelCalculation()
{
    $('.youtubeLink_1, .youtubeLink_2').css({'height':$(window).height()*0.43+'px'});
}

function openYoutubePlayer(thisVal){
     var token = thisVal.data('token'); 
     var youtubelink = thisVal.data('youtubelink'); 
     thisVal.find('.Sub_name_text').addClass('youtubelink-visited');
     if(!localStorage.getObj('tutorialVisited'))
     {
         var visitedArr = new Array();
         localStorage.setObj('tutorialVisited', visitedArr);
     }
     else
     {
        var visitedArr = localStorage.getObj('tutorialVisited');
     }
     if(jQuery.inArray(token, visitedArr)==-1)
     {
        visitedArr.push(token);
        localStorage.setObj('tutorialVisited', visitedArr);
     }
     mUiHandler.openYouTubeVideo(token,youtubelink);      
}
