/**
 * @filename PlaylistDB.js
 * @author r.k.pandey
 * @date   21 Jan 2015
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */


var db;
var dbCreated = false;
var mPlaylistName = "";
var mPlaylistFilePath = "";
var mTimeStamp = "";
var PLAYLIST_DEBUG_TAG = "PlayList::  ";
var funCallBack;
var playlistDB = {
playlistInfoList:[],	
};
var myPlayListInfoJson = {};
var myPlayListInfoArr = [];
myPlayListInfoJson.myPlayListInfoArrs = myPlayListInfoArr;
var tempContentRoothPAth=".ETabletAuthor/RHE/";

/***
 * To insert PlaylistInfo info in Playlist DB 
 * 
 * @param 
 *      playlistName -> playlistName
 *      playlistFilePath ->  playlist File Path
 */
function insertPlaylistInfo(playlistName, playlistFilePath) {
	
    console.log(PLAYLIST_DEBUG_TAG+"@insertPlayListInfo: " + "PlaylistName: " + playlistName
            + " ,playlistFilePath: " + playlistFilePath);

    mPlaylistName = playlistName;
    mPlaylistFilePath = playlistFilePath;
    mTimeStamp = new Date().getTime();
   
    db = window.openDatabase("PlaylistDB", "1.0", "MagicInfo",200000);
    console.log(PLAYLIST_DEBUG_TAG+"@insertPlaylistInfo: open db success - playlistDB");
    db.transaction(populatePlaylistDB, playlistDBError);
}
function copyPlayListData(){
	  db = window.openDatabase("PlaylistDB", "1.0", "MagicInfo",200000);
      console.log(DB_DEBUG_TAG+"@copyPlayListData: open db success - TabletAuthorDB");
      db.transaction(copyToPlayListDB, playlistDBError);
}


function copyToPlayListDB(tx) {
    console.log(DB_DEBUG_TAG+"@copyToPlayListDB insertPLaylistDB for Insert Operation");
    var sql = "CREATE TABLE IF NOT EXISTS playlist_Info ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "PlaylistName VARCHAR(100), " + "PlaylistFilePath VARCHAR(350), "
              + "TimeStamp VARCHAR(50))";
     console.log(PLAYLIST_DEBUG_TAG+sql);
     tx.executeSql(sql);
      var playlistdata = JSON.parse(sessionStorage.getItem("PLAYLIST_INFO"));
      var playListArr=[];
	      playListArr= playlistdata.myPlayListInfoArrs;
      // alert("playlistdata"+ playListArr.length);
      if(playListArr.length > 0)
	    {
	    	var playerType=2;
	    	
	    	for(var i=0;i<playListArr.length;i++)
	        {
	        var thumbPath=playListArr[i].playlistFilePath;
	        thumbPath=tempContentRoothPAth+ thumbPath.substring(thumbPath.indexOf("MyPlayList"));
	      
	        console.log("playlistName"+playListArr[i].playlistName);
	    	console.log("mPlaylistFilePath"+thumbPath);
	      	console.log("mTimeStamp"+playListArr[i].timeStamp);
	       	 tx.executeSql("INSERT INTO playlist_Info (PlaylistName,PlaylistFilePath,TimeStamp) VALUES ("
                    + "'" +playListArr[i].playlistName+ "'" + ","
                    + "'" + thumbPath+ "'" + ","
                    + "'" + playListArr[i].timeStamp+ "'" + ")");
	    	 console.log(DB_DEBUG_TAG+"Inserted one item success");
	    }
  
 }
}
/**
 * To updatePlaylistFromDB according to specified attribute 
 * @param playlistName
 */
function updatePlaylistFromDB(playlistName, playlistFilePath) {
    console.log(PLAYLIST_DEBUG_TAG+"@updatePlaylistFromDB");
    var db = window.openDatabase("PlaylistDB", "1.0", "MagicInfo",200000);
    db.transaction(function(tx) {
        tx.executeSql("UPDATE FROM playlist_Info SET " 
                + "PlaylistName='"+playlistName+"',"
                + "PlaylistFilePath='"+playlistFilePath+"',"
        		+ "WHERE playlist_Info.PlaylistName = '"
                + playlistName + "'");
        console.log(PLAYLIST_DEBUG_TAG+" Updated one item success");
    });
    
}


function populatePlaylistDB(tx) {
    console.log(PLAYLIST_DEBUG_TAG+"@getPlaylistInfo populateplaylistDB for Insert Operation");
    var sql = "CREATE TABLE IF NOT EXISTS playlist_Info ( "
              + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
              + "PlaylistName VARCHAR(100), " + "PlaylistFilePath VARCHAR(350), "
              + "TimeStamp VARCHAR(50))";
     console.log(PLAYLIST_DEBUG_TAG+sql);
     tx.executeSql(sql);
     tx.executeSql("INSERT INTO playlist_Info (PlaylistName,PlaylistFilePath,TimeStamp) VALUES ("
                    + "'" + mPlaylistName+ "'" + ","
                    + "'" + mPlaylistFilePath+ "'" + ","
                    + "'" + mTimeStamp+ "'" + ")");
     getPlaylistInfo();
     console.log(PLAYLIST_DEBUG_TAG+"Inserted one item success");
 }
/**
 * To drop playlistinfo table
 */

function dropPlaylistTableForcely(callback) {
    console.log("drop Playlist table");
    var db = window.openDatabase("PlaylistDB", "1.0", "MagicInfo",200000);
    db.transaction(function(tx) {
        tx.executeSql("DROP TABLE playlist_Info");
        console.log(STORE_DB_TAB + "DROP TABLE playlist_Info");
         if(typeof callback === 'function')
        {
        	callback.call();
        }
    });
}

/**
 * To get the Playlist information list
 */
function getPlaylistInfo(callBack) {
    console.log(PLAYLIST_DEBUG_TAG+"@getPlaylistInfo");
    if(callBack != undefined)
	  funCallBack = callBack;
    db = window.openDatabase("PlaylistDB", "1.0", "MagicInfo",200000);
    db.transaction(readPlaylistDB, playlistDBError, populatePlaylistDBOnSuccess);
 }

/**
 * To populate readplaylistDB
 * @param tx
 */
function readPlaylistDB(tx) {
    console.log(PLAYLIST_DEBUG_TAG+"@readplaylistDB");
    var sql = "CREATE TABLE IF NOT EXISTS playlist_Info ( "
        + "id INTEGER PRIMARY KEY AUTOINCREMENT, "
        + "PlaylistName VARCHAR(100), " + "PlaylistFilePath VARCHAR(350), "
        + "TimeStamp VARCHAR(50))";
    
    console.log(PLAYLIST_DEBUG_TAG+"SqlQuery: "+sql);
    tx.executeSql(sql);
}

function playlistDBError(tx, error) {
    //alert("Database Error: " + error);
    console.log(PLAYLIST_DEBUG_TAG+"@transaction_error");
}

function populatePlaylistDBOnSuccess() {
    console.log(PLAYLIST_DEBUG_TAG+"@populateDB_success");
    db.transaction(excutePlaylistQuery, playlistDBError);
}
/**
 * To excute Playlist query for fetching db list
 * @param tx
 */
function excutePlaylistQuery(tx) {
    console.log(PLAYLIST_DEBUG_TAG+"@excutePlaylistQuery");
    //var sql = "select id from  playlist_Info order by id desc";
    var  sql = "select * from  playlist_Info order by id desc";
    console.log(PLAYLIST_DEBUG_TAG+"@excuteQuery: "+sql);
    tx.executeSql(sql, [], fetchPlaylistItemList);
}

/**
 * To show list of Playlist item list
 * here user can populate using html components
 */ 
function fetchPlaylistItemList(tx, results) {
	console.log(PLAYLIST_DEBUG_TAG+"@fetchPlaylistItemList");
	playlistDB.playlistInfoList=[];
	myPlayListInfoJson.myPlayListInfoArrs=[];
	
	 for ( var i = 0; i < results.rows.length; i++) {
         var myPlaylistRows = results.rows.item(i);
      	var myPlaylistInfo = {};
		myPlaylistInfo.playlistId = myPlaylistRows.id;
		myPlaylistInfo.playlistName = myPlaylistRows.PlaylistName;
    	myPlaylistInfo.playlistFilePath = myPlaylistRows.PlaylistFilePath;
    	myPlaylistInfo.timeStamp = myPlaylistRows.TimeStamp;
    	    	myPlayListInfoJson.myPlayListInfoArrs.push(myPlaylistInfo);
    //	alert("myPlaylistRows.PlaylistName"+myPlaylistRows.PlaylistName);
         if(($.inArray(myPlaylistRows.PlaylistName, playlistDB.playlistInfoList) < 0))
	 		{
        	 playlistDB.playlistInfoList.push(myPlaylistRows.PlaylistName);
	 		}
     }
     createPlayListSessionJsonList();
}
function createPlayListSessionJsonList(){
	// Put the object into session storage
//	alert("array "+myPlayListInfoJson.myPlayListInfoArrs.length);
	sessionStorage.setItem("PLAYLIST_INFO", JSON.stringify(myPlayListInfoJson));
	
	 if(typeof funCallBack =='function')
	 {
	 	funCallBack.apply(this,[true]);
	 }
        
	
}
