	/**
 * @filename ScheduleGenerator.js
 * @author r.k.pandey
 * @date modified on 31st Jan 2015
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */
var schGenerator = {
		schFolder:null,
		targetScheduleFolder:null,
		countIndex:0,
		schFile:null,
		templatePathList:[],
		isTempSchCreated:false,
		sdcardFullPath:null,
		deletedTemplateArray:[],
		deletedWeeekDayArray:[],
		isNext:false,
		schedulePath:null,
		scheduleName:null,
		navigateFromSch:null,
		navigateFromTemp:null,
		templateCatogerySch:null,
		
	// Save XML Data
	saveXMLData : function(targetSchFolder,deletedTempArray,weekdaydeletedArray,schpath,schName,navigateFromSchedule,navigateFromTemplate,templateCatogery) {
			this.templatePathList=[];
			this.deletedTemplateArray=[];
			this.deletedWeeekDayArray=[];
			this.targetScheduleFolder=targetSchFolder;
			this.deletedTemplateArray=deletedTempArray;
			this.deletedWeeekDayArray=weekdaydeletedArray;
			this.schedulePath=schpath;
			this.scheduleName=schName;
			this.navigateFromSch=navigateFromSchedule;
			this.navigateFromTemp=navigateFromTemplate;
			this.templateCatogerySch=templateCatogery;
			this.createSchduleFolder();
	},
	createSchduleFolder:function()
	{
		//alert("countIndex  "+schGenerator.countIndex);
		schGenerator.countIndex++;
		
		if(schGenerator.countIndex ==1)
		{
			schGenerator.schFolder=schGenerator.targetScheduleFolder;
			createFolder();
		}
		else if(schGenerator.countIndex ==2)
		{
			schGenerator.schFolder=schGenerator.targetScheduleFolder+"/temp";
			createFolder();
		}
		else if(schGenerator.countIndex ==3)
		{
			isTempSchCreated=true;
			schGenerator.schFile=schGenerator.targetScheduleFolder+"/temp/localsch.sch";
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, createFS, failWriter);
		}
		else if(schGenerator.countIndex ==4)
		{
			schGenerator.schFolder=schGenerator.targetScheduleFolder+"/Schedules";
			createFolder();
			
		}	
		else if(schGenerator.countIndex ==5)
		{
			schGenerator.schFolder=schGenerator.targetScheduleFolder+"/Schedules/"+SchObj.Program[0].Program_Id;
			createFolder();
		}
		else if(schGenerator.countIndex ==6)
		{
			schGenerator.schFolder=schGenerator.targetScheduleFolder+"/Contents";
			createFolder();
		}	
		else if(schGenerator.countIndex ==7)
		{
			//alert("inside "+countIndex);
			schGenerator.countIndex=0;
			schGenerator.schFile=schGenerator.targetScheduleFolder+"/Schedules/"+SchObj.Program[0].Program_Id+"/localsch.sch";
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, createFS, failWriter);
		}	
		
		
	}
};

function createFolder()
{
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, createMySchdule, failMySchedule);
	
}

function createMySchdule(fileSystem) {
	fileSystem.root.getDirectory(schGenerator.schFolder, {create: true, exclusive: false}, schGenerator.createSchduleFolder, failDir);

}

function failMySchedule(error) {
	//alert("fail in mySchedule");
	console.log(error.code);
}

function failDir(error) {
	//alert("fail in failDir");
	console.log(error.code);
}



//This is existing to write Schedule file for imported schedule
function createFS(fileSystem) {
	
	schGenerator.sdcardFullPath = fileSystem.root.toURL().replace("file://",""); 
	 window.localStorage.setItem("sdCardPath", JSON.stringify(schGenerator.sdcardFullPath));	
	//alert("schGenerator.schFile  "+schGenerator.schFile);
	fileSystem.root.getFile(schGenerator.schFile, {
		create : true,
		exclusive : false
	}, gotSCHFileEntry, failWriter);
}

function gotSCHFileEntry(fileEntry) {
	//alert("fileEntry  "+fileEntry);
	fileEntry.createWriter(gotSCHFileWriter, failWriter);
}

function gotSCHFileWriter(writer) {
	var returnType = createXML();
	if (returnType) {
		writer.write(program);
	}
	//This check is added for creation of schedule file with original path
    if(deviceType == "iPad" || deviceType == "iPhone") {
        document.activeElement.blur();
    }
	if(!isTempSchCreated)
	{
		    window.localStorage.setItem("subFolder", JSON.stringify(schGenerator.targetScheduleFolder+"/temp/"));
			window.sessionStorage.setItem("subFolder", JSON.stringify(schGenerator.targetScheduleFolder+"/temp/"));
		    window.sessionStorage.setItem("templatePathList", JSON.stringify(schGenerator.templatePathList));
		    window.localStorage.setItem("templatePathList", JSON.stringify(schGenerator.templatePathList));
		    var destSch=schGenerator.sdcardFullPath+schGenerator.targetScheduleFolder+"/Schedules/"+SchObj.Program[0].Program_Id+"/"+SchObj.Program[0].ScheduleName+".PNG";
		    setTimeout(function(){
		    loaderObj.hideLoader();
		    }, 200);

		    Utils.showToast(langObj.Schedule.COM_MIV_SCHEDULE_SUCCESS_SAVE);
		setTimeout(function(){  
		    $('.toast-container').fadeOut(200).remove();
		}, 600);    
		setTimeout(function(){
			//window.location.href = '../send/Send.html';
			var offSet=$(".timelinebarAreaCls").offset();
			var width=$(".timelinebarAreaCls").width();
			var height=$(".timelinebarAreaCls").height();
			saveScreenShot(destSch,"ScheduleImage",offSet,width,height);
		}, 900);
	}
	else
	{
		isTempSchCreated=false;
		schGenerator.createSchduleFolder();
	}	
}

function failWriter(error) {
	//alert("fail in export");
	console.log(error.code);
}

function createXML() {
	schGenerator.templatePathList=[];
	var schFileForUpload="Schedules" + "|" + SchObj.Program[0].Program_Id + "|" +schGenerator.sdcardFullPath+schGenerator.targetScheduleFolder+"/temp/localsch.sch";
	schGenerator.templatePathList.push(schFileForUpload);
	program = SchObj.Program;
	for (var i = 0,plen=program.length; i <plen ; i++) {
		var xmlTag = '<?xml version="1.0" encoding="utf-8"?>';
		var programId = ScheduleUtils.writeElement('program_id', program[i].Program_Id);
		var programName = ScheduleUtils.writeElement('program_name', program[i].Program_Name);
		var version = ScheduleUtils.writeElement('version', program[i].Version);
		var scheduleName = ScheduleUtils.writeElement('scheduleName', program[i].ScheduleName);
		var playlistCounter = ScheduleUtils.writeElement('playlistCounter', program[i].PlaylistCounter);
		var atts = {
			"xmlns:xsi" : "http://www.w3.org/2001/XMLSchema",
			"xsi:noNamespaceSchemaLocation" : "scheduleV2.0.xsd"
		};
		
		var screenTag = createScreenTag(SchObj.Program[i].Screen);
			var templateorientation=sessionStorage.getItem('orientationType');
		    var templateOrientation = ScheduleUtils.writeElement('templateOrientation', templateorientation);
		if(isTempSchCreated)
		{
			program = xmlTag + ScheduleUtils.writeElement('program', '' + programId + programName + version + screenTag, atts);
		}
		else
		{
			program = xmlTag + ScheduleUtils.writeElement('program', '' + programId + programName + version + scheduleName +playlistCounter+templateOrientation  + screenTag, atts);
		}	
		
		
		return true;
	}

}

function createScreenTag(screen) {
	var screenTag;
	for (var j = 0 ,slen=screen.length; j <slen ; j++) {
		var screenIndex = ScheduleUtils.writeElement('screen_index', screen[j].Screen_Index);
		var frameXML = createFrameTag(screen[j].Frame);
		screenTag = ScheduleUtils.writeElement('screen', '' + screenIndex + frameXML);

	}
	return screenTag;
}

function createFrameTag(frame) {
	var frameTag;
	for (var k = 0,len=frame.length; k < len; k++) {
		var frameIndex = ScheduleUtils.writeElement('frame_index', frame[k].Frame_Index);
		var frameName = ScheduleUtils.writeElement('frame_name', frame[k].Frame_Name);
		var version = ScheduleUtils.writeElement('version', frame[k].Version);
		var x = ScheduleUtils.writeElement('X', frame[k].X);
		var y = ScheduleUtils.writeElement('Y', frame[k].Y);
		var width = ScheduleUtils.writeElement('Width', frame[k].Width);
		var height = ScheduleUtils.writeElement('Height', frame[k].Height);
		var defaultContent = createDefaultContentTag(frame[k].Default_Content);
		//adding attribute
		var atts = {
			is_main_frame : frame[k].Frame_Is_Main_Frame
		};
		var frameSche = createFrameschedule(frame[k].Frame_Schedule);
		frameTag = ScheduleUtils.writeElement('frame', '' + frameIndex + frameName + version + x + y + width + height + defaultContent + frameSche, atts);

	}
	return frameTag;
}

function createDefaultContentTag(default_content) {
	var default_content_tag;
	for (var m = 0,dlen=default_content.length ;m <dlen ; m++) {
		var dfContentId = ScheduleUtils.writeElement('content_id', default_content[m].Content_Id);
		var duration = ScheduleUtils.writeElement('duration', default_content[m].Duration);
		var file = createFile(default_content[m].File);
		default_content_tag = ScheduleUtils.writeElement('default_content', '' + dfContentId + duration + file);
	}
	return default_content_tag;
}

function createFile(file) {
	for (var p = 0,flen=file.length; p <flen ; p++) {
		var Id = ScheduleUtils.writeElement('id', file[p].Id);
		var text = file[p].Name;
		if(text.indexOf(".LFD") == -1){
		   text=text+".LFD"; 
		}
		var appedText = "<![CDATA[" + text + "]]>";
		var name = ScheduleUtils.writeElement('name', appedText);
		var path = file[p].Path;
		var actualPath = file[p].actualPath;
		if(file[p].actualPath!=undefined)
		{
			actualPath = file[p].actualPath.trim();
		}	
		var thumbPath = file[p].thumnailPath;
		var size = ScheduleUtils.writeElement('size', "0");
		var hash = ScheduleUtils.writeElement('hash', "0");
		var filetype = getFileType(file[p].Name);
		//For creating directory for new Content
		var appedPath = "<![CDATA[" + actualPath + "]]>";
		var path = ScheduleUtils.writeElement('actualPath', appedPath);
		var thumbPath = ScheduleUtils.writeElement('thumbPath', "<![CDATA[" + thumbPath + "]]>");
		var templateId = ScheduleUtils.writeElement('templateId', file[p].TemplateId);
		
		var file;
		//This check added for schedule file need to send LFD without actual path
		if(isTempSchCreated)
		{
			file = ScheduleUtils.writeElement('file', ' ' + Id + name + size + hash);
		}	
		else
		{
			if(actualPath!=null && actualPath!=undefined && actualPath!='')
			{
				if(($.inArray("Contents|"+file[p].Id+"|"+schGenerator.sdcardFullPath+actualPath, schGenerator.templatePathList) < 0))
				{
					schGenerator.templatePathList.push("Contents|"+file[p].Id+"|"+schGenerator.sdcardFullPath+actualPath);
				}	
				
			}
			file = ScheduleUtils.writeElement('file', ' ' + Id + name + path + thumbPath+size + hash +templateId);
		}	
		
		
		return file;
	}

}

function createFrameschedule(frame_schedule) {
	
	var frameTabIndex=0;
	var frame_schedule_Tag = '';
	var firstIndex=getnewIndex(frame_schedule[0].Color);
	window.sessionStorage.setItem("colorvalue", firstIndex);
	colorvalue=firstIndex;
	var initialArr=[];
	var sorted=[];
	for (var n = 0,frameLen=frame_schedule.length; n < frameLen; n++) {
	
		var val=$("#ts_slider_container_"+n).attr("data-zIndex");
			initialArr[n]=val;
			sorted[n]=val;
			
		}
		
		 sorted.sort(function(a, b){return a-b;});
		 
	for (var m = 0,slen=sorted.length; m<slen; m++) {
		 var index;
		   for(var j=0,ilen=initialArr.length;j<ilen;j++)
		   {
		   	if(sorted[m]== initialArr[j])
		   	{
		   		index=j;
		   		initialArr[j]=-1;
		   		break;
		   	}
		   }
		    var n=index;
		// For restricting deleted time line(frame schedule) in final SCH file
		if(($.inArray(getParseIntInDec(n), schGenerator.deletedTemplateArray) < 0))
		{
			var startDate = ScheduleUtils.writeElement('start_date', frame_schedule[n].Start_Date);
			var stopDate = ScheduleUtils.writeElement('stop_date', frame_schedule[n].Stop_Date);
			var repeat=createRepeat(frame_schedule[n].Repeat);
			var startTime = ScheduleUtils.writeElement('start_time', frame_schedule[n].Start_Time);
			var duration = ScheduleUtils.writeElement('duration', frame_schedule[n].Duration);
			var link = ScheduleUtils.writeElement('link', ""+frame_schedule[n].Frame_Sch_link);
			var linkday = ScheduleUtils.writeElement('linkday', frame_schedule[n].Frame_Sch_linkday);
			
			var color = ScheduleUtils.writeElement('color', frame_schedule[n].Color);
			var schFrameTag = ScheduleUtils.writeElement('frameIndex',""+ frame_schedule[n].Frame_Sch_index);
			var Priority=frame_schedule[n].Priority;
			if(Priority ==""){
				Priority="0";
			}
			var priority = ScheduleUtils.writeElement('priority', Priority);
			var playList = createPlaylist(frame_schedule[n].Playlist);
			
		
			if(($.inArray(frame_schedule[n].Repeat[0].WeekDay, schGenerator.deletedWeeekDayArray) < 0))
			{
				var att = {
			tab : frameTabIndex.toString()
		};
				if(isTempSchCreated)
				{
					frame_schedule_Tag = frame_schedule_Tag + ScheduleUtils.writeElement('frame_schedule', '' + startDate+ stopDate + repeat + startTime + duration + priority + playList,att);
					frameTabIndex++;
				}	
				else
				{
					frame_schedule_Tag = frame_schedule_Tag + ScheduleUtils.writeElement('frame_schedule', '' +schFrameTag + link + linkday + startDate + stopDate + repeat + startTime + duration + color + priority + playList,att);
					frameTabIndex++;
				}
			}	
				
		}	
	}
	return frame_schedule_Tag;
}

function createRepeat(repeatList) {
	var repeat='';
	for (var index_repeat = 0,reLen=repeatList.length; index_repeat < reLen; index_repeat++) {
		//adding attribute
		var atts = {
			type : repeatList[index_repeat].Repeat_Type
		};
		var weekday = ScheduleUtils.writeElement('weekday', repeatList[index_repeat].WeekDay);
		repeat=repeat + ScheduleUtils.writeElement('repeat', '' + weekday, atts);
	}
	
	return repeat;
}

function createPlaylist(playList) {
	var playList_Tag = '';
	for (var q = 0,plen=playList.length; q <plen ; q++) {
		var shuffle = ScheduleUtils.writeElement('shuffle', playList[q].Shuffle);
		//adding attribute
		var atts = {
			id : playList[q].Playlist_ID,
			name : playList[q].Playlist_Name,
			timestamp:"'"+playList[q].TimeStamp+"'",
			playlistImage:"'"+playList[q].Playlist_Image+"'"
		};

		var content = createContent(playList[q].Content);
		playList_Tag = playList_Tag + ScheduleUtils.writeElement('playlist', '' + shuffle + content, atts);
	}
	return playList_Tag;
}


function populateTemplateList(){
schGenerator.templatePathList=[];
var targetFolder=scheduleRender.mySchedule+"/"+scheduleRender.projectName;
var sdCardFullPath=JSON.parse(window.localStorage.getItem("sdCardPath"));
	var schFileForUpload="Schedules" + "|" + SchObj.Program[0].Program_Id + "|" +sdCardFullPath+targetFolder+"/temp/localsch.sch";
	schGenerator.templatePathList.push(schFileForUpload);
	
	program = SchObj.Program;
	var contentArrVal;
	var frameScheduleArr;
for (var i = 0; i < program.length; i++) {
   for(var j=0; j < program[i].Screen.length; j++ ){
    for(var k=0; k < program[i].Screen[j].Frame.length; k++){
	   frameScheduleArr = program[i].Screen[j].Frame[k].Frame_Schedule;
	   for(var m=0; m < frameScheduleArr.length; m++){
	   	for(var n=0; n < frameScheduleArr[m].Playlist.length; n++){
	    	for(var p=0; p < frameScheduleArr[m].Playlist[n].Content.length; p++){
	    		contentArrVal=frameScheduleArr[m].Playlist[n].Content[p].File[0];
	    		  var actualPath = contentArrVal.actualPath;
		               if(actualPath!=undefined)
		                {
			            actualPath = actualPath.trim();
		                }	
			           	if(actualPath!=null && actualPath!=undefined && actualPath!='')
			            {
							if(($.inArray("Contents|"+contentArrVal.Id+"|"+sdCardFullPath+actualPath, schGenerator.templatePathList) < 0))
						        {
									schGenerator.templatePathList.push("Contents|"+contentArrVal.Id+"|"+sdCardFullPath+actualPath);
						        }					
			         }
	    	}
		
		}
	   	   
	   }
		
	}
   
   }  

}	

            window.localStorage.setItem("subFolder", JSON.stringify(targetFolder+"/temp/"));
			window.sessionStorage.setItem("subFolder", JSON.stringify(targetFolder+"/temp/"));
		    window.sessionStorage.setItem("templatePathList", JSON.stringify(schGenerator.templatePathList));
		    window.localStorage.setItem("templatePathList", JSON.stringify(schGenerator.templatePathList));	
}

function createContent(content) {
	var contentTag = '';
	for (var a = 0,conlen=content.length; a < conlen; a++) {
		var contentId = ScheduleUtils.writeElement('content_id', content[a].Content_Id);
		var duration = ScheduleUtils.writeElement('duration', content[a].Duration);
		var localFile = createFile(content[a].File);
		contentTag = contentTag + ScheduleUtils.writeElement('content', '' + contentId + duration + localFile);
	}
	return contentTag;
}

function getFileType(fileName) {
    //  alert("get fileName  " + fileName);
      var videoExtArray = new Array('avi', 'mkv', 'asf', 'wmv', 'mp4', 'mov', '3gp', 'vro', 'mpg', 'mpeg', 'ts', 'tp', 'trp', 'mov', 'flv', 'vob', 'svi', 'm2ts', 'mts', 'divx', 'webm', 'rmvb');
      var ext = fileName.substring(fileName.lastIndexOf(".") + 1);
      ext=ext.trim().toLowerCase();
      if (/.lfd$/i.test(fileName)) {
          return "LFD";
      }
      else if (ext == ("jpg") || ext == ("jpeg") || ext == ("png") ||
             ext == ("gif") || ext == ("bmp")) {
          return "IMAGE";
      } else if ($.inArray(ext, videoExtArray) > -1) {
          return "VIDEO";
      } else {
          return "UNSUPPORTED FILE";
      }
  }