	/**
 * @filename ScheduleParser.js
 * @author r.k.pandey
 * @date 
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */

function response() {
	this.Program = new Array();
}

function Array_Program() { 
    Program_Id:null; 
    Program_Name:null; 
    Version :null; 
    Background_Music:null ; 
    ScheduleId :null; 
    ScheduleName :null;
    PlaylistCounter:0;
	TemplateOrientation :null;
	this.Screen = new Array();
}

function Array_Screen() { 
    Screen_Index :null;
	this.Frame = new Array();
}

function Array_Frame() { 
    Frame_Index:null; 
    Frame_Name:null; 
    Version:null; 
    X:null; 
    Y:null; 
    Width:null; 
    Height:null;
	Frame_Is_Main_Frame:null;
	this.Default_Content = new Array();
	this.Frame_Schedule = new Array();
}

function Array_Default_Content() { 
    Content_Id:null; 
    Duration:null;
	this.File = new Array();
}

function Array_Frame_Schedule() { 
    Tab:null; 
    Start_Date:null; 
    Stop_Date:null; 
    this.Repeat= new Array();
	Frame_Sch_link:null;
	Frame_Sch_linkday:null;
	Frame_Sch_index:null;
	Start_Time:null; 
	Duration:null; 
	Priority:null;
	Color:null;
	isFrameScheduleDeleted:false;
	this.Playlist = new Array();
}

function Array_Repeat()
{
    Repeat_Type:null; 
    WeekDay:null;	
}

function Array_Playlist() { 
    Shuffle:null; 
    isPlaylist:null;
	isDeleted:false;
	Playlist_ID:null; 
	Playlist_Name:null;
	TimeStamp:null;
	Playlist_Image:null;
	this.Content = new Array();
}

function Array_Content() { 
    Content_Id:null; 
    Duration:null;
	this.File = new Array();
}

function Day_StartTime() {
	day:null;
	this.TimeArray = new Array();
}

function Array_File() { 
    Id:null; 
    Name:null; 
    Path:null; 
    Size:null; 
    Hash:null; 
    thumnailPath:null;
    actualPath:null;
    TemplateId:null;
    isFileDeleted:false;
    isDeleted:false;
}

var SchObj = new response();

var SchPar = {
		
    playListArray:[],
    templateColorScheduleArray:[],
    tempTemplateArray:[],
    init : function(textXML) {
        isOnOff = false;
        SchObj = new response();
        SchPar.playListArray = [];
        SchPar.templateColorScheduleArray = [];
        SchPar.tempTemplateArray = [];
        var tempPlaylistArray = [];
        var xmlDoc = new DOMParser().parseFromString(textXML, 'text/xml');
        var program = $(xmlDoc).find("program");
        //alert("program "+program.length);
        var program1 = null;
        var con = null;
        var fram = null;
        var dfCont = null;
        var dfCont_file = null;
        var frSchedule = null;
        var playListArr = null;
        for ( index = 0; index < program.length; index++) {
            //Insert a new schedule
            program1 = new Array_Program();
            SchObj.Program[index] = program1;
            program1.Program_Id = $(program).find("program_id").text();
            program1.Program_Name = $(program).find("program_name").text();
            program1.Version = $(program).find("version").text();
            program1.Background_Music = $(program).find("background_music").text();
            program1.ScheduleId = $(program).find("scheduleid").text();
            program1.ScheduleName = $(program).find("schedulename").text();
            program1.TemplateOrientation = $(program).find("templateOrientation").text();
            program1.PlaylistCounter = $(program).find("playlistCounter").text();
            //Set Orientation Type according to Template saved in schedule file
            window.sessionStorage.setItem('orientationType', $(program).find("templateOrientation").text());
            var screen = $(program).find("screen");
            for ( index_scr = 0; index_scr < screen.length; index_scr++) {
                con = new Array_Screen();
                program1.Screen[index_scr] = con;
                con.Screen_Index = $(screen).find("screen_index").text();
                var frame = $(screen).find("frame");
                for ( index_frame = 0; index_frame < frame.length; index_frame++) {
                    fram = new Array_Frame();
                    con.Frame[index_frame] = fram;
                    fram.Frame_Is_Main_Frame = $(frame).attr('is_main_frame');
                    fram.Frame_Index = $(frame).find("frame_index").text();
                    fram.Frame_Name = $(frame).find("frame_name").text();
                    fram.Version = $(frame).children("version").text();
                    fram.X = $(frame).find("X").text();
                    fram.Y = $(frame).find("Y").text();
                    fram.Width = $(frame).find("Width").text();
                    fram.Height = $(frame).find("Height").text();
                    var default_content = $(frame).find("default_content");
                    for ( index_dc = 0; index_dc < default_content.length; index_dc++) {
                        dfCont = new Array_Default_Content();
                        fram.Default_Content[index_dc] = dfCont;
                        dfCont.Content_Id = $(default_content).find("content_id").text();
                        dfCont.Duration = $(default_content).find("duration").text();
                        var default_content_file = $(default_content).find("file");
                        for ( index_dc_f = 0; index_dc_f < default_content_file.length; index_dc_f++) {
                            dfCont_file = new Array_File();
                            dfCont.File[index_dc_f] = dfCont_file;
                            dfCont_file.Id = $(default_content_file).find("id").text();
                            dfCont_file.Name = $(default_content_file).find("name").text();
                            dfCont_file.Path = $(default_content_file).find("path").text();
                            dfCont_file.Size = $(default_content_file).find("size").text();
                            dfCont_file.Hash = $(default_content_file).find("hash").text();
                        }
                    }

                    var frame_schedule = $(frame).find("frame_schedule");
                    for ( index_fr_sc = 0; index_fr_sc < frame_schedule.length; index_fr_sc++) {
                        frSchedule = new Array_Frame_Schedule();
                        fram.Frame_Schedule[index_fr_sc] = frSchedule;
                        var repeatType = $(frame_schedule[index_fr_sc]).find("repeat");
                        for ( index_repeatType = 0; index_repeatType < repeatType.length; index_repeatType++) {
                            var repeatArr = new Array_Repeat();
                            frSchedule.Repeat.push(repeatArr);
                            frSchedule.Repeat[index_repeatType].Repeat_Type = $(frame_schedule[index_fr_sc]).find("repeat").attr('type');
                            frSchedule.Repeat[index_repeatType].WeekDay = $(repeatType[index_repeatType]).find("weekday").text();
                        }
                        frSchedule.Start_Time = $(frame_schedule[index_fr_sc]).find("start_time").text();
                        frSchedule.Start_Time = (frSchedule.Start_Time).substring(0, 5);

                        frSchedule.Start_Date = $(frame_schedule[index_fr_sc]).find("start_date").text();
                        frSchedule.Stop_Date = $(frame_schedule[index_fr_sc]).find("stop_date").text();
                        frSchedule.Duration = $(frame_schedule[index_fr_sc]).children("duration").text();
                        frSchedule.Priority = $(frame_schedule[index_fr_sc]).find("priority").text();
                        frSchedule.Frame_Sch_link = $(frame_schedule[index_fr_sc]).children("link").text();
                        frSchedule.Frame_Sch_index = $(frame_schedule[index_fr_sc]).children("frameIndex").text();
                        frSchedule.Frame_Sch_linkday = $(frame_schedule[index_fr_sc]).find("linkday").text();
                        frSchedule.Color = $(frame_schedule[index_fr_sc]).find("color").text();
                        var playlist = $(frame_schedule[index_fr_sc]).find("playlist");
                        for ( index_playlist = 0; index_playlist < playlist.length; index_playlist++) {
                            playListArr = new Array_Playlist();
                            frSchedule.Playlist[index_playlist] = playListArr;
                            playListArr.Playlist_ID = $(frame_schedule[index_fr_sc]).find("playlist").attr('id');

                            playListArr.Playlist_Name = $(frame_schedule[index_fr_sc]).find("playlist").attr('name');

                            playListArr.TimeStamp = $(frame_schedule[index_fr_sc]).find("playlist").attr('timestamp');

                            playListArr.Playlist_Image = $(frame_schedule[index_fr_sc]).find("playlist").attr('playlistImage');
                            //alert(" playListArr.Playlist_Image"+ playListArr.Playlist_Image);
			    playListArr.Playlist_Image = playListPar.setDefaultPath(playListArr.Playlist_Image);
                           
                            var isPlaylistExist = false;
                            if ($(frame_schedule[index_fr_sc]).find("playlist").attr('name') != '') {
                                if (($.inArray($(frame_schedule[index_fr_sc]).find("playlist").attr('name'), tempPlaylistArray) < 0)) {
                                    tempPlaylistArray.push($(frame_schedule[index_fr_sc]).find("playlist").attr('name'));
                                    SchPar.playListArray.push({
                                        key : $(frame_schedule[index_fr_sc]).find("playlist").attr('timestamp'),
                                        value : $(frame_schedule[index_fr_sc]).find("playlist").attr('name'),
                                        image : playListArr.Playlist_Image,
                                        color : SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[index_fr_sc].Color
                                    });
                                    colorIndex++;
                                } else {
                                    var indx = getParseIntInDec($.inArray($(frame_schedule[index_fr_sc]).find("playlist").attr('name'), tempPlaylistArray));
                                    SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[index_fr_sc].Color = SchPar.playListArray[indx].color;
                                }
                                isPlaylistExist = true;
                            }
                            playListArr.Shuffle = $(playlist[index_playlist]).find("shuffle").text();
                            playListArr.isPlaylist = true;
                            var content = $(playlist[index_playlist]).find("content");
                            SchPar.parsePlaylist(0, content, index_fr_sc, isPlaylistExist);

                        }
                    }
                }
            }
        }
        return true;

    }, parsePlaylist : function(index_content,content,index_fr_sc,isPlaylistExist) {
        if (index_content < content.length) {
            SchPar.parseContent(index_fr_sc, SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[index_fr_sc].Playlist[0], content[index_content], index_content, isPlaylistExist);
            index_content++;
            SchPar.parsePlaylist(index_content, content, index_fr_sc, isPlaylistExist);
        } else {
            SchPar.deleteContent(index_fr_sc, 0);
        }
    }, parseContent : function(index_fr_sc, playListLocal, contentLocal, index_content, isPlaylistExist) {
        var contentArr = new Array_Content();
        playListLocal.Content.push(contentArr);
        playListLocal.Content[index_content].Content_Id = $(contentLocal).find("content_id").text();
        playListLocal.Content[index_content].Duration = $(contentLocal).find("duration").text();
        var file = $(contentLocal).find("file");
        var FileArr = null;
        for ( index_file = 0; index_file < file.length; index_file++) {
            FileArr = new Array_File();
            playListLocal.Content[index_content].File[index_file] = FileArr;
            FileArr.Id = $(file[index_file]).find("id").text();
            FileArr.Name = $(file[index_file]).find("name").text();
            FileArr.Path = "";
            FileArr.actualPath = $(file[index_file]).find("actualPath").text();
            FileArr.thumnailPath = $(file[index_file]).find("thumbPath").text();
            FileArr.Size = $(file[index_file]).find("size").text();
            FileArr.Hash = $(file[index_file]).find("hash").text();
            FileArr.TemplateId = $(file[index_file]).find("templateId").text();
        }
        var vFileArr = playListLocal.Content[index_content].File[0];
        var vFrSch = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[index_fr_sc];
        if (($.inArray(getParseIntInDec(vFileArr.TemplateId), templateIDArray) < 0)) {
            vFileArr.isFileDeleted = true;
        } else {
            vFileArr.isFileDeleted = false;
            templateContentLength++;
            if (!isPlaylistExist) {
                if (($.inArray(getParseIntInDec(vFileArr.TemplateId), SchPar.tempTemplateArray) < 0)) {
                    SchPar.tempTemplateArray.push(getParseIntInDec(vFileArr.TemplateId));
                    SchPar.templateColorScheduleArray.push(vFrSch.Color);
                    usedColorIndex.push(vFrSch.Color);
                    colorIndex++;
                } else {
                    var indx = getParseIntInDec($.inArray(getParseIntInDec(vFileArr.TemplateId), SchPar.tempTemplateArray));
                    vFrSch.Color = SchPar.templateColorScheduleArray[indx];
                }
            }

        }
    }, deleteFrameSchedule:function(count) {
        var vFrSch = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule;
        if (count < vFrSch.length) {
            if (vFrSch[count].Playlist[0].Content.length == 0) {
                vFrSch.splice(count, 1);
                count = 0;
            } else {
                count++;
            }
            SchPar.deleteFrameSchedule(count);
        }
    }, deleteContent:function(frameSchIndex,contentIndex) {
        var vContent = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[frameSchIndex].Playlist[0].Content;
        if (contentIndex < vContent.length) {
            if (vContent[contentIndex].File[0].isFileDeleted) {
                vContent.splice(contentIndex, 1);
                contentIndex = 0;
            } else {
                contentIndex++;
            }
            SchPar.deleteContent(frameSchIndex, contentIndex);
        }
    }
};