﻿/**
 * @filename ScheduleRender.js
 * @author samarendra.j
 * @date 13/02/2015
 * Modified : by Riten
 * added: added next day for copypaste .
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */    
var lists = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29];
var colorList = ["#27ae61", "#f39c11", "#3598db", "#90b86f", "#e8d457", "#e98698", "#0da491", "#d25400", "#8d44ad", "#856b46", "#78939a", "#6ea1bc", "#297fb8", "#e84c3d", "#477050", "#0065d3", "#c29552", "#ae7ac4", "#0dcdc0", "#c1392b", "#fe9458", "#358c74", "#d2555b", "#5a57d0", "#8ba3c2", "#f1c40f", "#70a8ff", "#a7d163", "#c19473", "#785b6c"];
var colorIndex = 0;
var colorvalue = 0;
var log;
var currentTime;
var temp_timer;
var isHomeClicked = false;
var usedColorIndex = [];
var contentClicked = false;
var templateContentLength=0;
var extraMargin=10;
var isScheduleCopy = false;
var templateClicked = false;
var nxt_buttonClicked = false;
var newTemplateClicked = false;
var validateSaveAsTxt = null;
var saveCounter=0;
var saveNxtFlag=false;
var tempUrl;
var backpressed = false;
var playLstScroll = null;
var currOrient = "";
var srTchEvent = null;
var evntSeq = "";
var updateSceduleName = null;
var box;
var TAPHOLDTIME = 500;
var newSchedule = false;

var orientationTypeNum = 0;
var checkedNum = 0;

var $min,$sec;
var tempMin;
var tempSec;

var scheduleRender = {
    schFullPath : null,
    entrySch : null,
    schFile : null,
    isNewSchedule : true,
    updatedSchNamesArr : [],
    projectCounter : null,
    weekDayList : [],
    editNextClicked : false,
    mySchedule : Utils.getContentsRootPath() + "/MySchedule",
    playList : Utils.getContentsRootPath() + "/Playlist",
    projectName : null,
    sortableMode : false,
    timerIndex : null,
    istimeBar : "false",
    isNewPlayList : true,
    startTime : null,
    endTime : null,
    isPlayList : false,
    playListFile : null,
    playlistName : null,
    playlistTimeStamp : null,
    isPlayListSorted : false,
    startIndexSwpping : null,
    endIndexSwpping : null,
    isClickCreateNew : false,
    isCopyFlag : "false",
    tempdeletedArray : [],
    arrayOfremovedPlayList : [],
    isPlayListCopied : false,
    isSavedSch : "false",
    schedulePathFromTemp : null,
    globalCounter : 0,
    localCounter : 0,
    isDraggablePlaylist : false,
    isPlaylistAdded : false,
    isTemplatedeleted : false,
    isPlaylistdeleted : false,
    deleteColorIndex : 0,
    deletedColorList : [],
    isFirstTimeSchedule : false,
    orientationType : null,
    isItemdeleted : false,
    weekdays : ['sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat'],
    emptyPlaylistMessage : langObj.Schedule.MIA_SID_EMPTY_PLAYLIST_NOT_ADDED,
    navigateFromTemplate : null,
    navigateFromSchedule : null,
    ulrVarsArr:[],
    templateCatogerySch : null,
    initialize : function() {
        this.bindEvents();
    },
    bindEvents : function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    onDeviceReady : function() {
        document.addEventListener("backbutton", onBackkeyDown, false);
        loadingScheduleLoader();
        window.setTimeout(scheduleRender.renderSchedule, 500);
        if (deviceType != "iPhone" && deviceType != "iPad") {
            Utils.registerKeyboardObserver();
            extraMargin=15;
        }
    },
    renderSchedule : function() {
        clearTimerBars();
        ScheduleUtils.getLFDInfo();
        $('#saveOnlyBtn,#saveAsBtn').addClass("icon-disabled");
        $("#saveBtn").addClass("btn_disabledCls");
        scheduleRender.tempdeletedArray = [];
        scheduleRender.weekdaydeletedArray = [];
        scheduleRender.arrayOfremovedPlayList = [];
        SchPar.tempTemplateArray = [];
        SchPar.templateColorScheduleArray = [];
        if (scheduleRender.isNewSchedule) {
            newSchedule = true;
            colorIndex = 0;    
            scheduleRender.deleteColorIndex = 0;
            createNewSchedule();
        } else if (scheduleRender.schedulePathFromTemp != null && scheduleRender.schedulePathFromTemp != '') {
            scheduleRender.schFile = scheduleRender.schedulePathFromTemp;
            scheduleRender.schedulePathFromTemp = null;
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, scheduleRender.gotFS, scheduleRender.fail);
        } else {
            colorIndex = 0;
            scheduleRender.deleteColorIndex = 0;
            window.setTimeout(scheduleRender.loadXMLData, 500);
        }
    },

    loadXMLData : function() {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, scheduleRender.gotDS, scheduleRender.fail);
    },

    gotDS : function(fileSystem) {
        fileSystem.root.getDirectory(scheduleRender.entrySch, {
            create : true,
            exclusive : false
        }, scheduleRender.onGetDirectoryWin, scheduleRender.onGetDirectoryFail);
        scheduleRender.schFullPath = fileSystem.root.fullPath;
    },

    onGetDirectoryWin : function(directoryEntry) {
        var directoryReader = directoryEntry.createReader();
        directoryReader.readEntries(scheduleRender.gotDirectoryEntry, scheduleRender.fail);
    },

    onGetDirectoryFail : function(directoryEntry) {
        console.log("Fail Directory");
        returnToHome();
    },

    gotDirectoryEntry : function(entries) {
        if (entries.length > 0) {
            var entriesLen = entries.length;
            for (var i = 0; i < entriesLen; i++) {
                if (entries[i].isDirectory) {
                    scheduleRender.entrySch = scheduleRender.entrySch + "/" + entries[i].name;
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, scheduleRender.gotDS, scheduleRender.fail);
                } else {
                    /*This check is added to fetch localsch file*/
                    if (entries[i].name.localeCompare("localsch.sch") == 0) {
                        scheduleRender.schFile = scheduleRender.entrySch + "/" + entries[i].name;
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, scheduleRender.gotFS, scheduleRender.fail);
                        return;
                    }
                }
            }
        }

    },

    gotFS : function(fileSystem) {
        var targetXmlFile = null;
        if (scheduleRender.isPlayList) {
            targetXmlFile = scheduleRender.playListFile;
        } else {
            targetXmlFile = scheduleRender.schFile;
        }
        fileSystem.root.getFile(targetXmlFile, null, scheduleRender.gotFileEntry, scheduleRender.fail);
        if (!scheduleRender.isPlayList) {
            scheduleRender.schFullPath = fileSystem.root.fullPath;
        }

    },

    gotFileEntry : function(fileEntry) {
        fileEntry.file(scheduleRender.gotFile, scheduleRender.fail);
    },

    gotFile : function(file) {
        scheduleRender.readAsText(file);
    },

    readAsText : function(file) {
        var reader = new FileReader();
        reader.onloadend = function(evt) {
            var textXML = evt.target.result;
            if (scheduleRender.isPlayList) {
                playListPar.init(textXML, scheduleRender.isDraggablePlaylist);
                if (!scheduleRender.isDraggablePlaylist) {
                    playListPar.deletePlaylistContent(0);
                }
                if (playListPar.isPlaylistFromSch) {
                    savePlaylistContent();
                }
                scheduleRender.isPlayList = false;
            } else {
                if (SchPar.init(textXML)) {
                    SchPar.deleteFrameSchedule(0);
                    SchPar.playListArray.sort(function(a, b) {

                        return getParseIntInDec(getParseIntInDec(a.key) - getParseIntInDec(b.key));

                    });
                    scheduleRender.globalCounter = SchObj.Program[0].PlaylistCounter;
                     getScheduleInfo(false, function(bStatus) {
                   	var templateOrientation = ScheduleUtils.getTemplateOrientation();
                   
                        scheduleTitlePosition();
                        
                        createEditSchedule(false, null, null, null, null);
                        renderTemplate(templateOrientation, false);
                        scheduleRender.isSavedSch = "false";
                          if(templateContentLength==0){
                          $("#landScape_Div_Id").removeClass("icon-disabled");
            
                          }
                    });

                }
            }

        };
        reader.readAsText(file);
    },

    fail : function(error) {
        console.log("fail files in import  " + error.code);
		loaderObj.hideLoader();
		returnToHome();
    },

    loadPlayListData : function() {
		var deferred = $.Deferred();
		var failP = function(error) {
			console.log("fail loadPlayListData PROMISE files in import  " + error.code);
			loaderObj.hideLoader();
		};
		var readAsText1 = function(file) {
			var reader = new FileReader();
			reader.onloadend = function(evt) {
				var textXML = evt.target.result;
				if (scheduleRender.isPlayList) {
					playListPar.init(textXML, scheduleRender.isDraggablePlaylist);
					if (!scheduleRender.isDraggablePlaylist) {
						playListPar.deletePlaylistContent(0);
					}
					if (playListPar.isPlaylistFromSch) {
						savePlaylistContent().done(function(){
							deferred.resolve();
						});
					}else{
						deferred.resolve();
					}
					scheduleRender.isPlayList = false;
				} else {
					if (SchPar.init(textXML)) {
						SchPar.deleteFrameSchedule(0);
						SchPar.playListArray.sort(function(a, b) {
							return getParseIntInDec(getParseIntInDec(a.key) - getParseIntInDec(b.key));
						});
						scheduleRender.globalCounter = SchObj.Program[0].PlaylistCounter;
						getScheduleInfo(false, function(bStatus) {
						var templateOrientation = ScheduleUtils.getTemplateOrientation();
						
							scheduleTitlePosition();
							createEditSchedule(false, null, null, null, null);
							renderTemplate(templateOrientation, false);
							scheduleRender.isSavedSch = "false";
							if (templateContentLength == 0) {
								$("#landScape_Div_Id").removeClass("icon-disabled");
							}
						});
					}
					deferred.resolve();
				}	
			};
			reader.readAsText(file);
		};
		var gotFile1 = function(file) {
			readAsText1(file);
		};
		var gotFileEntry1 = function(fileEntry) {
			fileEntry.file(gotFile1, failP);
	 	};
		var gotFS1 = function(fileSystem) {
			var targetXmlFile = null;
			if (scheduleRender.isPlayList) {
				targetXmlFile = scheduleRender.playListFile;
			} else {
				targetXmlFile = scheduleRender.schFile;
			}
			fileSystem.root.getFile(targetXmlFile, null, gotFileEntry1, failP);
			if (!scheduleRender.isPlayList) {
				scheduleRender.schFullPath = fileSystem.root.fullPath;
			}	
		};		
        ScheduleUtils.getLFDInfo();
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS1, failP);
		return deferred.promise();		
    },

    clearDirectory : function(directoryPath) {
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, fail);
        function fail(evt) {
            console.log("FILE SYSTEM FAILURE" + evt.code);
        }

        function onFileSystemSuccess(fileSystem) {
            fileSystem.root.getDirectory(directoryPath, {
                create : true,
                exclusive : false
            }, function(entry) {
                entry.removeRecursively(function() {
                    console.log("Remove Recursively Succeeded");
                }, fail);
            }, fail);
        }

    }
};

$(document).ready(function() {
    log = new logger();
    globlePlayerType = Utils.getActivePlayerType();
    log.setDebug(true);
    $('#playListContainerId').on('tap', function() {
        $("#timePickerContainer").remove();
    });

    /*  Create Time bar when drag template & PlayList */

    $('#Template_Area_Templates_Id').on("touchstart", 'li', function(e) {
        event.stopPropagation();

        if( $(this).attr('data-type') == 'addButton' || $(this).find('.sortCopyIconDragCls').hasClass('close_Icon_Cls') ) 
            return;    
        
        var $this = $(this);
        
        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
        if($('#draggableClone').length == 0){
            leftElementDragStart(e, $this);
        }
        
        
    }).on('touchmove', 'li', function(e) {        
        if(TAPHOLD)
        {
            e.stopPropagation();
            e.preventDefault();
        }
        leftElementDragMove(e, $(this));

    }).on('touchend', 'li', function(e) {
        leftElementDragEnd(e, $(this));
    });
    
    
    
	scheduleRender.ulrVarsArr = Utils.getUrlVars();
    var schedulePath = Utils.decodeThumbPath(scheduleRender.ulrVarsArr["schedulePath"]);
    var scheduleName = Utils.decodeThumbPath(scheduleRender.ulrVarsArr["scheduleName"]);    
    var isNewSchedule = scheduleRender.ulrVarsArr["isNewSchedule"];
    scheduleRender.navigateFromTemplate = scheduleRender.ulrVarsArr["navigateFromTemplate"];
    var navigateFromSch = scheduleRender.ulrVarsArr["navigateFromSchedule"];
    scheduleRender.templateCatogerySch = scheduleRender.ulrVarsArr["category"];
    if(navigateFromSch == 'true')
    {
        scheduleRender.navigateFromSchedule = 'true';
    }
    if (scheduleRender.templateCatogerySch == 'C' ) {        
        $('.stepHeaderCls').hide();        
        $('.customDesignCls').show();
        $('#custom_TextId').text(langObj.QuickStart.MIA_SID_CUSTOM_DESIGN);

    } else {
        $('.customDesignCls').hide();
        $('.stepHeaderCls').show();
        $('#custom_TextId').text(langObj.QuickStart.COM_BDP_SID_QUICK_START_TEXT_KR_START);
    }

    $('#customTextId').autoFontSize({ maxFontPixels: 18,minFontPixels:12});

    $('.schNameAreacls').show();

    if (schedulePath != null && schedulePath != '' && schedulePath != undefined && schedulePath != 'undefined') {
        scheduleRender.navigateFromSchedule = 'true';
        scheduleRender.isNewSchedule = false;
        scheduleRender.schedulePathFromTemp = schedulePath.replace(/%20/g, ' ');
        scheduleRender.projectName = scheduleName.replace(/%20/g, ' ');
    } else {
        scheduleRender.schedulePathFromTemp = null;
    }
    if (isNewSchedule == 'true') {
        scheduleRender.navigateFromSchedule = 'true';
        scheduleRender.isNewSchedule = true;
        scheduleRender.isClickCreateNew = true;
        if (window.sessionStorage.getItem('orientationType') == null || window.sessionStorage.getItem('orientationType') == '' || window.sessionStorage.getItem('orientationType') == undefined) {
            window.sessionStorage.setItem('orientationType', '1000');
        }
        $("#landScape_Div_Id").removeClass("icon-disabled");
        $('.stepHeaderCls').hide();
        /*$("#newSchedule").css("margin-top", "4%");*/
        $('.customDesignCls').show();
    }
    scheduleRender.initialize();
    addTimeScale();
    calcPageElemDimn();
    registerEvents();
    registerSortableEvents();
});

var TAPHOLD = false;
var tapholdTimeout = null;
var cloneWidth;
var cloneHeight;
var mouse_init_x = 0;
var mouse_init_y = 0;
var mouse_move_x = 0;
var mouse_move_y = 0;

function leftElementDragStart(event, currElem) {
    $('#draggableClone').remove();
  
    if( $('#Create_Playlist_Area_Id').css('display') == 'block') {
        if( currElem.attr('data-text') == $('.Create_Playlist_Title_Txt_Cls').text() )
            return;        
    }    
    
    var mouse_x = pointerEventToXY(event).x;
    var mouse_y = pointerEventToXY(event).y;
    mouse_init_x = mouse_x;
    mouse_init_y = mouse_y;
    
    tapholdTimeout = setTimeout(function(e){            
                TAPHOLD = true;
                hideTemplatePlayListMenu();
                currElem.removeClass('template_List_Cls-active');
                currElem.removeClass('playListCls-active');
                
                createTplCloneForDrag(currElem, mouse_x, mouse_y);
            }, TAPHOLDTIME);       
}

function leftElementDragMove(event, currElem) {

        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
         if(TAPHOLD)
        {
            event.preventDefault();
            mouse_move_x = pointerEventToXY(event).x;
            mouse_move_y = pointerEventToXY(event).y;
            var absX = Math.abs(mouse_move_x - mouse_init_x);
            var absY = Math.abs(mouse_move_y - mouse_init_y);  
       
            $('#draggableClone').css({
                'top' : (mouse_move_y - (cloneHeight / 2)) + 'px',
                'left' : (mouse_move_x - (cloneWidth / 2)) + 'px'
            });
            /*
            if($('#Create_Playlist_Area_Id').css('display') == 'block' ){
                var winHeight = $( window ).height();
                scrollPos = $("#Create_Playlist_List_Id").scrollTop();
                
                if(mouse_move_y > winHeight*0.9)
                {
                    if(myVar) return;
                    myVar = setInterval(function(){ $("#Create_Playlist_List_Id").scrollTop(scrollPos+5); }, 5);
                    
                }else if (mouse_move_y < winHeight*0.1)
                {
                    if(myVar) return;
                    myVar = setInterval(function(){ $("#Create_Playlist_List_Id").scrollTop(scrollPos-5); }, 5);
                }else
                {
                    clearInterval(myVar);
                    myVar = "";
                }
            }*/
        } 
}

function leftElementDragEnd(event, currElem) {    
    if (tapholdTimeout != null) {
        clearTimeout(tapholdTimeout);
        tapholdTimeout = null;
    }
    var type = $('#draggableClone').attr('clone-type');
    if (TAPHOLD) {
            var drop = $('.timerContainerCls');            
            event.stopPropagation();
            event.preventDefault();
            var collides = drop.overlaps(box);
            
            if( $('#SchedulePagehome').css('display') == 'block' && $(collides.targets).hasClass('timerContainerCls')) {
                    /*Goto Weekly schedule  Create TimeBar!*/
                    onWeekDayDrop($('#draggableClone').find('li'), $(collides.targets));
                    $('#draggableClone').remove();
            }else if( $('#Create_Playlist_Area_Id').css('display') == 'block' ){
                createPlaylistAfterDrop($('#draggableClone').find('li'));
            }
        }        
        $('#draggableClone').remove();
        TAPHOLD = false;
}

function hideTemplatePlayListMenu()
{
    $('.Template_Area_Cls').animate(
        {
            'top':'100%'
        },
        {
            complete: function()
            {
                $('.Template_Area_Cls').css({'display':'none'});
            }
        }
    );
}

function createNewSchedule() {
    log.debug("START  ", "createNewSchedule");
    getScheduleInfo(false, function(bStatus) {
    var templateOrientation = ScheduleUtils.getTemplateOrientation();
    
        createScheduleName();
        createNewWeekSchedule(templateOrientation, scheduleRender.isClickCreateNew);
        createEditSchedule(false, null, null, null, null);
        renderTemplate(templateOrientation, false);
    });
    log.debug("COMPLETE  ", "createNewSchedule");
}

function clearTimerBars() {
    $(".timelineSchTimerContainerCls > .timerContainerCls > .ts_slider_containerCls").remove();
}

function createNewWeekSchedule(templateOrientation, isClickCreateNew) {
    log.debug("START  templateOrientation=" + templateOrientation + "::isClickCreateNew=" + isClickCreateNew, "createNewWeekSchedule");
    SchObj = new response();
    var orientationVal = setOrientation(templateOrientation);
    sessionStorage.setItem('orientationType', orientationVal);

    var program1 = new Array_Program();
    program1.Program_Id = ScheduleUtils.getFolderID();
    program1.Program_Name = "localsch";
    program1.Version = "1";
    program1.ScheduleName = scheduleRender.projectName;
    program1.TemplateOrientation = orientationVal;
    var screen = new Array_Screen();
    screen.Screen_Index = "0";
    var frame = new Array_Frame();
    frame.Frame_Is_Main_Frame = "true";
    frame.Frame_Index = "0";
    frame.Frame_Name = "";
    frame.Version = "0";
    frame.X = "0";
    frame.Y = "0";
    frame.Width = "100";
    frame.Height = "100";
    var dfCont = new Array_Default_Content();
    dfCont.Content_Id = ScheduleUtils.getFolderID();
    dfCont.Duration = "0";
    var dfCont_file = new Array_File();
    dfCont_file.Id = ScheduleUtils.getFolderID();
    dfCont_file.Name = "";
    dfCont_file.Path = "";
    dfCont_file.Size = "0";
    dfCont_file.Hash = "";

    dfCont.File[0] = dfCont_file;
    frame.Default_Content[0] = dfCont;
    screen.Frame[0] = frame;
    program1.Screen[0] = screen;
    SchObj.Program[0] = program1;

    scheduleRender.weekDayList = ['sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat'];
    var storeWeekDayList = [];
    var startTimeEndTimeArray = [];
    var isOpenFullDay=[];
    var myStoreInfoJson = Utils.getActiveStoreInfo();
    storeWeekDayList = myStoreInfoJson.StoreOpenDay.split("||");
    startTimeEndTimeArray = myStoreInfoJson.StoreOpenTime.split("||");
    isOpenFullDay=myStoreInfoJson.isOpenFullDay.split("||");
    /*This if condition when click on createNewSchedule from DropDown*/
    if (scheduleRender.isClickCreateNew) {
        colorIndex = -1;
        scheduleRender.deleteColorIndex = 0;
        $(".timerTextCls").removeClass("timerTextClsActive");
    } else {
	var storeWeekDayListLen = storeWeekDayList.length;
        for (var j = 0; j < storeWeekDayListLen; j++) {
            var startEndTimeArray = startTimeEndTimeArray[j].split("-");
            var startTime = '';
            var duration = '';
            if (startEndTimeArray[0] != '' && startEndTimeArray[1] != undefined) {
                startTime = ScheduleUtils.Converttimeformat(startEndTimeArray[0]);
                duration = ScheduleUtils.getDurationInSeconds(ScheduleUtils.ConvertEndtimeformat(startEndTimeArray[1])) - ScheduleUtils.getDurationInSeconds(startTime);
            }
            var day = storeWeekDayList[j];
            /*if condition for when user select end time equal or less than start time from store*/
            if (getParseIntInDec(duration) <= 0) {
                var nextDayVal = '';
                var existingDayIndex = getParseIntInDec(scheduleRender.weekDayList.indexOf(day));
                if(existingDayIndex == 6)
                {
                       nextDayVal = scheduleRender.weekDayList[0];
                }
                else{
                       nextDayVal = scheduleRender.weekDayList[existingDayIndex + 1];
                }
             
                var existingDayEndTime = '12:00 am';
                duration = ScheduleUtils.getDurationInSeconds(ScheduleUtils.ConvertEndtimeformat(existingDayEndTime)) - ScheduleUtils.getDurationInSeconds(startTime);
                var value = getNewValue();
                createFrameSchedule(null, day, startTime, duration, colorList[value], 1, false, true, false, nextDayVal, 1);
                var nextDayStartTime = ScheduleUtils.Converttimeformat('12:00 am');
                var nextDayDuration = ScheduleUtils.getDurationInSeconds(ScheduleUtils.ConvertEndtimeformat(startEndTimeArray[1]));
                createFrameSchedule(null, nextDayVal, nextDayStartTime, nextDayDuration, colorList[value], 1, false, true, false, day, -1);
            } else {
                var value = getNewValue();
                 if(isOpenFullDay[j]== "true" )
                	{
                	startTime="00:00";
                	duration=86400;
                	}
                /*This else condition when navigating from Template to schedule*/
                createFrameSchedule(null, day, startTime, duration, colorList[value], 1, false, true, false);
            }
        }
    }
    log.debug("COMPLETE", "createNewWeekSchedule");
}

function setOrientation(templateOrientation) {
    log.debug("START  templateOrientation=" + templateOrientation, "setOrientation");
    var orientationVal = '';
    if (templateOrientation == 'landscape') {
        orientationVal = '1000';
    } else if (templateOrientation == 'portrait') {
        orientationVal = '9999';
    }
    log.debug("COMPLETE", "setOrientation");
    return orientationVal;
}

function createFrameSchedule(newIndex, weekDay, startTime, duration, color, templateIndex, isPlaylist, isTemplateScreen, isCopyAction, linkDay, linkCount) {
    log.debug("START  newIndex=" + newIndex + ":weekDay=" + weekDay + ":startTime=" + startTime + ":duration=" + duration + ":color=" + color + ":templateIndex=" + templateIndex + ":isPlaylist=" + isPlaylist, "createFrameSchedule");
    var frameObj = SchObj.Program[0].Screen[0].Frame[0];
    var newTagPoistion = frameObj.Frame_Schedule == undefined ? 0 : frameObj.Frame_Schedule.length;
    scheduleRender.timerIndex = newTagPoistion;
    var frSchedule = new Array_Frame_Schedule();
    var repeatArr = new Array_Repeat();
    frSchedule.Start_Time = startTime;
    frSchedule.Duration = duration;
    frSchedule.Color = color;
    frSchedule.Repeat.push(repeatArr);
    frSchedule.Repeat[0].Repeat_Type = "day_of_week";
    frSchedule.Repeat[0].WeekDay = newIndex == null ? weekDay : scheduleRender.weekDayList[newIndex];
    frSchedule.Start_Date = '1000-01-01';
    frSchedule.Stop_Date = '2999-12-31';
    frSchedule.Priority = '0';
    frSchedule.Frame_Sch_index = newTagPoistion;
    frSchedule.isFrameScheduleDeleted = false;
    /*if condition when user select end time equal or less than start time from store to handle looping*/
    if (linkDay != undefined && linkDay != null && linkDay != '') {
        frSchedule.Frame_Sch_linkday = linkDay;
        frSchedule.Frame_Sch_link = newTagPoistion + linkCount;
    }
    var playListArr = new Array_Playlist();
    var contentIdforNewNode = ScheduleUtils.getFolderID();
    playListArr.Playlist_ID = contentIdforNewNode;
    if (isPlaylist) {
        var customPlaylist=playListObj.CustomPlaylist[0];
        playListArr.Playlist_Name = customPlaylist.Name;
        playListArr.TimeStamp = customPlaylist.TimeStamp;
        playListArr.isDeleted = false;
        if (customPlaylist.CustomContent.length != 0) {
            playListArr.Playlist_Image = customPlaylist.CustomContent[0].Path;
        }
    } else {
        playListArr.Playlist_Name = '';
    }

    playListArr.Shuffle = "false";
    /*Adding Template and Playlist in schedule object*/
    frSchedule.Playlist[0] = playListArr;
    frameObj.Frame_Schedule.push(frSchedule);
    if (templateIndex != null) {
        createCustomPlaylist(newTagPoistion, templateIndex, isPlaylist, isTemplateScreen, isCopyAction);
    }
    log.debug("COMPLETE", "createFrameSchedule");
}

function createCustomPlaylist(newTagPoistion, templateIndex, isPlaylist, isTemplateScreen, isCopyAction) {
    var schFrameObj = SchObj.Program[0].Screen[0].Frame[0];
    var frameScheduleObj = schFrameObj.Frame_Schedule[newTagPoistion];
    log.debug("START newTagPoistion=" + newTagPoistion + ":templateIndex=" + templateIndex + ":isPlaylist=" + isPlaylist + "isTemplateScreen=" + isTemplateScreen + ":isCopyAction=" + isCopyAction, "createCustomPlaylist");
    var playlistLen = frameScheduleObj.Playlist.length;
    var playListCustomContLen;
    var playListCustomCont;
    var plyListCntnObj;
    var plyListCntnObjLen;
    var fileObj;
    for (var q = 0; q < playlistLen; q++) {
        /*This condition drag a playlist into schedule Timeline*/
        if (isPlaylist) {
            playListCustomContLen  = playListObj.CustomPlaylist[0].CustomContent.length;
            for (var i = 0; i < playListCustomContLen; i++) {
                playListCustomCont = playListObj.CustomPlaylist[0].CustomContent[i];
                createCustomContent(newTagPoistion, q, playListCustomCont.Name, playListCustomCont.ActualPath, playListCustomCont.Path, playListCustomCont.TemplateId, playListCustomCont.Duration);
            }
        } else if (isCopyAction) {
            /*This condition when we copy and paste original frame schedule to new frame schedule*/
            plyListCntnObj = schFrameObj.Frame_Schedule[templateIndex].Playlist[0].Content;
            plyListCntnObjLen = plyListCntnObj.length;            
            for (var j = 0; j < plyListCntnObjLen; j++) {
                fileObj = plyListCntnObj[j].File[0];
                createCustomContent(newTagPoistion, q, fileObj.Name, fileObj.actualPath, fileObj.thumnailPath, fileObj.TemplateId, plyListCntnObj[j].Duration);
            }
            return;
        } else {
            var templateJsonArray = ScheduleUtils.getLFDInfo();

            var tempVarObj = templateJsonArray.myTemplateInfoArrs[getParseIntInDec(templateIndex)];/*This else condition drag a template into schedule Timeline*/
            if (isTemplateScreen) {
                /*This condition when we are navigating from template to schedule screen*/
                tempVarObj = templateJsonArray.myTemplateInfoArrs[getParseIntInDec(0)];
            }
            createCustomContent(newTagPoistion, q, tempVarObj.templateName, tempVarObj.tempPath, tempVarObj.thumbPath, tempVarObj.templateId, frameScheduleObj.Duration);
        }
    }
    log.debug("COMPLETE", "createCustomPlaylist");
}

function createCustomContent(newTagPoistion, q, templateName, templatePath, templateThumbpath, templateId, templateDuration) {
  
	log.debug("START", "createCustomContent");
	var contentId = ScheduleUtils.getFolderID();
	var content = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[newTagPoistion].Playlist[q].Content;
	var contentArr;
	contentArr = new Array_Content();
	contentArr.Content_Id = contentId;
	contentArr.Duration = templateDuration;
	content.push(contentArr);
	createCustomFileObj(newTagPoistion, q, templateName, templatePath, templateThumbpath, templateId);

	log.debug("COMPLETE", "createCustomContent"); 

}

function createCustomFileObj(newTagPoistion, q, templateName, templatePath, templateThumbpath, templateId) {
    log.debug("START", "createCustomFileObj");
    var existingFileID = createEditSchedule(false, null, templateName, null, null);
    var fileId = existingFileID == null ? ScheduleUtils.getFolderID() : existingFileID;
    var content = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[newTagPoistion].Playlist[q].Content;
    var newContentIndex = content.length;
    content = content[newContentIndex - 1];
    var FileArr = new Array_File();
    FileArr.Id = fileId;
    FileArr.Name = templateName;
    FileArr.Path = templatePath;
    FileArr.Size = '';
    FileArr.Hash = '';
    FileArr.actualPath = templatePath;
    FileArr.thumnailPath = templateThumbpath;
    FileArr.TemplateId = templateId;
    FileArr.isDeleted = false;
    content.File[0] = FileArr;
    log.debug("COMPLETE", "createCustomFileObj");
}

function createScheduleName() {
    log.debug("START", "createScheduleName");
    var idx = 1;
    do {
        scheduleRender.projectName = langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ((idx < 10) ? ' 0' : ' ') + idx;
        idx++;
    } while (scheduleDB.scheduleInfoList != null && scheduleDB.scheduleInfoList.indexOf(scheduleRender.projectName) != -1);
    
    scheduleTitlePosition();    
    scheduleDB.scheduleInfoList.push(scheduleRender.projectName);       
    scheduleRender.isFirstTimeSchedule = true;
    /*Remove Existing schedule Folder from Playlist folder*/
    scheduleRender.clearDirectory(scheduleRender.playList + "/" + scheduleRender.projectName);
    log.debug("COMPLETE", "createScheduleName");
}

function createNxtScheduleName(){
   log.debug("START", "createScheduleName");
    var idx = 1;
    saveNxtFlag=true;
    do {
        scheduleRender.projectName = langObj.Schedule.IDS_TABLE_TYPE_SCHEDULE + ((idx < 10) ? ' 0' : ' ') + idx;

        idx++;
    } while (scheduleDB.scheduleInfoList != null && scheduleDB.scheduleInfoList.indexOf(scheduleRender.projectName) != -1);

    scheduleRender.clearDirectory(scheduleRender.playList + "/" + scheduleRender.projectName);
    log.debug("COMPLETE", "createScheduleName");
}

function createEditSchedule(isEdit, playlistName, templateName, targetType, targetName) {
    log.debug("START isEdit=" + isEdit + ":playlistName=" + playlistName + ":templateName=" + templateName + ":targetType=" + targetType + ":targetName=" + targetName, "createEditSchedule");
    var itemFoundCount = 0;
    var folderID = null;
    var frame_schedule = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule;
    var frame_schedule_Len = frame_schedule.length;
    var playListCustomContentLen;
    var playListCustomContent;
    var playlistContFile;
    for (var n = 0; n < frame_schedule_Len; n++) {
        var playlist = frame_schedule[n].Playlist;
        for (var q = 0; q < playlist.length; q++) {
            var type = playlist[q].Playlist_Name != '' ? 'playlist' : '';
            if (isEdit) {
                if (playlist[q].Playlist_Name == playListObj.CustomPlaylist[0].Name) {
                    playlist[q].Content.length = 0;
                    /*This if condition to set image in schedule object*/
                    if (playListObj.CustomPlaylist[0].CustomContent.length != 0) {
                        playlist[0].Playlist_Image = playListObj.CustomPlaylist[0].CustomContent[0].Path;
                    }
                    playListCustomContentLen = playListObj.CustomPlaylist[0].CustomContent.length;
                    for ( contentIndex = 0; contentIndex < playListCustomContentLen; contentIndex++) {
                        playListCustomContent = playListObj.CustomPlaylist[0].CustomContent[contentIndex];
                        scheduleRender.isSavedSch = "true";
                        playlist[0].TimeStamp = playListObj.CustomPlaylist[0].TimeStamp;
                        createCustomContent(n, q, playListCustomContent.Name, playListCustomContent.ActualPath, playListCustomContent.Path, playListCustomContent.TemplateId, playListCustomContent.Duration);
                    }
                }
            } else if (playlistName != null) {
                /*This check for deleted playlist index from schedule*/
                if (!frame_schedule[n].isFrameScheduleDeleted && playlist[q].Playlist_Name == playlistName) {
                    scheduleRender.isPlaylistAdded = true;
                    itemFoundCount++;
                    if (scheduleRender.isPlaylistdeleted) {
                        if (playlist[q].Content.length == 0) {
                            frame_schedule[n].isFrameScheduleDeleted = true;
                            frame_schedule[n].Playlist[0].isDeleted = true;
                        }
                        deleteFrameScheduleIndex(n, playlistName, true);
                    }

                } else if (itemFoundCount == 0) {
                    scheduleRender.isPlaylistAdded = false;
                }
            } else if (templateName != null) {
                if (scheduleRender.isTemplatedeleted) {
                    deleteContentFromSch(n, 0, type, templateName);
                } else {
                    /*This check for fetch folder ID for same template name*/
                    folderID = fetchFolderID(n, q, templateName);

                    if (folderID != null) {
                        return folderID;
                    } else if (n == frame_schedule.length - 1) {
                        return folderID;
                    }
                }
            } else if (targetType != null && targetName != null) {
                if (targetType == 'Playlist') {
                    if (playlist[q].Playlist_Name == targetName && !playlist[q].isDeleted) {
                        itemFoundCount++;
                    }
                } else {
                    playlistContFile = playlist[0].Content[0].File[0];
                    if (playlist[0].Playlist_Name == '' && getParseIntInDec(playlistContFile.TemplateId) == getParseIntInDec(targetName) && !playlistContFile.isDeleted) {
                        itemFoundCount++;
                    }
                }
                if (n == frame_schedule.length - 1) {
                    if (itemFoundCount == 0) {
                        targetType == 'Playlist' ? changePlaylistBGColor('', targetName,false) : changeTemplateBGColor('', getParseIntInDec(targetName));
                        return 0;
                    }
                }
            } else {
                if (scheduleRender.isClickCreateNew == false) {
                    var endTime = ScheduleUtils.setScheduleTime(frame_schedule[n].Start_Time, frame_schedule[n].Duration);
                    if (frame_schedule[n].Frame_Sch_linkday != undefined && frame_schedule[n].Frame_Sch_linkday != '') {
                        setSchLink(frame_schedule[n].Repeat[0].WeekDay, n, frame_schedule[n].Color);
                    }
                    else if(frame_schedule[n].Frame_Sch_linkday == undefined || frame_schedule[n].Frame_Sch_linkday == ''){
                    	frame_schedule[n].Frame_Sch_index=n;
                    	frame_schedule[n].Frame_Sch_link='';
                    }
                    if (type == 'playlist') {
                        var duration = ScheduleUtils.getDuration(frame_schedule[n].Start_Time, endTime);
                        createUpdateTimeLine(frame_schedule[n].Repeat[0].WeekDay, frame_schedule[n].Start_Time, endTime, frame_schedule[n].Color, n, type, frame_schedule[n].Frame_Sch_link, frame_schedule[n].Frame_Sch_linkday, null, frame_schedule[n].Playlist[q].Playlist_Name, false, duration);
                        playListObj = new playListResponse();

                        var playListArr = new Array_CustomPlaylist();
                        playListObj.CustomPlaylist.push(playListArr);
                        playListObj.CustomPlaylist[0].Name = frame_schedule[n].Playlist[q].Playlist_Name; 
                    } else {
                        var duration = ScheduleUtils.getDuration(frame_schedule[n].Start_Time, endTime);
                        createUpdateTimeLine(frame_schedule[n].Repeat[0].WeekDay, frame_schedule[n].Start_Time, endTime, frame_schedule[n].Color, n, type, frame_schedule[n].Frame_Sch_link, frame_schedule[n].Frame_Sch_linkday, playlist[0].Content[0].File[0].TemplateId, null, false, duration);
                    }
                }
            }
        }
    }
    scheduleRender.isTemplatedeleted = false;
    scheduleRender.isPlaylistdeleted = false;
    log.debug("COMPLETE", "createEditSchedule");
    return folderID;

}
 
function setSchLink(weekDay, n, color) {
    log.debug("START", "setSchLink");
    var frame_schedule = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule;
    var frameLength = frame_schedule.length;
     
    var frameLinkIndex=frame_schedule[n].Frame_Sch_link;
    for (var k = 0; k < frameLength; k++) {
     if (frame_schedule[k].Frame_Sch_linkday != undefined &&  frame_schedule[k].Frame_Sch_linkday != '' && weekDay == frame_schedule[k].Frame_Sch_linkday && color == frame_schedule[k].Color && frameLinkIndex==frame_schedule[k].Frame_Sch_index) {
         frame_schedule[n].Frame_Sch_link = k;
          frame_schedule[k].Frame_Sch_link = n;
         frame_schedule[n].Frame_Sch_index=n;
       break;
       }
    }
    log.debug("COMPLETE", "setSchLink");
}

function deleteContentFromSch(n, contIndex, type, templateName) {
    log.debug("START ", "deleteContentFromSch");
    var vPlayListObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[n].Playlist[0];
    if (contIndex < vPlayListObj.Content.length) {
        if (vPlayListObj.Content[contIndex].File[0].Name == templateName) {
            if ( type = 'playlist') {
                vPlayListObj.Content.splice(contIndex, 1);
                contIndex = 0;
                deleteContentFromSch(n, contIndex, type, templateName);
            } else {
                deleteFrameScheduleIndex(n, templateName, false);
            }
        } else {
            contIndex++;
            deleteContentFromSch(n, contIndex, type, templateName);
        }

    } else {
        if (vPlayListObj.Content.length == 0 && type == 'playlist') {
            SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[n].isFrameScheduleDeleted = true;
            deleteFrameScheduleIndex(n, vPlayListObj.Playlist_Name, false);
        }
    }

    log.debug("COMPLETE ", "deleteContentFromSch");
}

function createUpdateTimeLine(weeday, start_Time, endTime, color, n, type, link, linkday, templateId, playlist, isDragCopy, duration) {
    log.debug("START weeday=" + weeday + ":start_Time=" + start_Time + ":endTime=" + endTime + ":color=" + color + ":type=" + type + ":link=" + link + ":linkday=" + linkday + ":templateId=" + templateId + ":playlist=" + playlist + ":duration=" + duration, "createUpdateTimeLine");
    timeSpinnerChanged = false;

    $("#timertext_" + weeday).addClass("timerTextClsActive");
    $("#timer_" + weeday).timeSlider({
        index : n,
        startTime : start_Time,
        endTime : endTime,
        day : weeday,
        minduration : 10,
        type : type == '' ? "template" : type,
        color : color == '' ? "#27ae61" : color,
          zIndex : 0,
        link : link,
        linkday : linkday,
        templateId : templateId,
        playlist : playlist,
        duration : duration,
        onTimeChange : function(changedStartTime, changedEndTime, color, day, index, type, link, linkday, templateId, playlist) {
            scheduleRender.isSavedSch = "true";
            newSchedule = false;
            modifyStartEndTime(changedStartTime, changedEndTime, color, day, index, link, linkday);
            isDragCopy = false;
            n = index;
            setFramePriorty(day, changedStartTime, changedEndTime, n);
        },
        onCreate : function(isCreated, frameIndex, color) {
            scheduleRender.isSavedSch = "true";
            $('#saveOnlyBtn').removeClass("icon-disabled");
            $('#saveAsBtn').removeClass("icon-disabled");
            $("#saveBtn").removeClass("btn_disabledCls");
            if (playlist != null) {
                changePlaylistBGColor(color, playlist,false);
            } else if (templateId != null) {
                changeTemplateBGColor(color, templateId);
            }

        },
        onCopy : function(container, event, obj, orginalSliderHeight) {
            newSchedule = false;
            var isCreateNew = checkTimeBarLength(container);
            if (isCreateNew == "true") {
                scheduleRender.isSavedSch = "true";
                copyTimebar(container, event, obj, orginalSliderHeight);
            }
        },    
        onDelete : function(index, color) {
            newSchedule = false;
            index = getParseIntInDec(index);
            scheduleRender.isSavedSch = "true";
            scheduleRender.tempdeletedArray.push(index);
            var targetName = '';
            var targetType = '';
            var templateId = null;
            var vPlayListObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[index].Playlist[0];
            if (vPlayListObj.Playlist_Name != '') {
                targetName = vPlayListObj.Playlist_Name;
                targetType = "Playlist";
                vPlayListObj.isDeleted = true;
                deleteLoopedFrame(index, targetType);

            } else {
                targetType = "Template";
                vPlayListObj.Content[0].File[0].isDeleted = true;
                targetName = vPlayListObj.Content[0].File[0].TemplateId;
                deleteLoopedFrame(index, targetType);
            }            
            
            var count = getParseIntInDec(createEditSchedule(false, null, null, targetType, targetName));
            if (count == 0) {
                scheduleRender.deletedColorList.push(color);
            }
            
            /* If no time bar, can change orientation*/
            if( !$(".timelineSchTimerContainerCls").children().find(".ts_contentArea").attr('class') )
            {
                $("#landScape_Div_Id").removeClass("icon-disabled");
            }
        }
    });

    if (isDragCopy) {
        newSchedule = false;
        setFramePriorty(weeday, start_Time, endTime, n);
    }
    log.debug("COMPLETE", "createUpdateTimeLine");
}

function deleteLoopedFrame(index, targetType) {
    log.debug("START", "deleteLoopedFrame");
    var currObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[getParseIntInDec(index)];
    if (currObj.Frame_Sch_link != '' && currObj.Frame_Sch_link != undefined && currObj.Frame_Sch_linkday != '' && currObj.Frame_Sch_linkday != undefined) {
        var loopedFrameIdx = getParseIntInDec(currObj.Frame_Sch_link);
        var vPlayListObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[loopedFrameIdx].Playlist[0];
        if (targetType == 'Playlist') {
            vPlayListObj.isDeleted = true;
        } else {
            vPlayListObj.Content[0].File[0].isDeleted = true;
        }

    }
    log.debug("COMPLETE", "deleteLoopedFrame");
}

function setFramePriorty(weeday, start_Time, endTime, frameIndex) {
    log.debug("START  weeday=" + weeday + ":start_Time=" + start_Time + ":endTime=" + endTime + ":frameIndex=" + frameIndex, "setFramePriorty");
    var priority = 0;
    var frame_schedule = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule;
    var frameSchLen = frame_schedule.length;
    for (var n = 0; n < frameSchLen; n++) {
        if (frame_schedule[frameIndex].Repeat[0].WeekDay == frame_schedule[n].Repeat[0].WeekDay && frameIndex != n) {
            var targetEndTime = ScheduleUtils.setScheduleTime(frame_schedule[n].Start_Time, frame_schedule[n].Duration);
            var targetEndDuration = ScheduleUtils.getDurationInSeconds(targetEndTime);
            var targetStartDuration = ScheduleUtils.getDurationInSeconds(frame_schedule[n].Start_Time);
            var sourceEndDuration = ScheduleUtils.getDurationInSeconds(endTime);
            var sourceStartDuration = ScheduleUtils.getDurationInSeconds(start_Time);
            if ((targetStartDuration == sourceStartDuration) || (sourceStartDuration < targetEndDuration && sourceStartDuration > targetStartDuration) || (sourceStartDuration < targetStartDuration && sourceEndDuration > targetEndDuration) || (sourceStartDuration < targetStartDuration && sourceEndDuration > targetStartDuration)) {
                if (getParseIntInDec(priority) <= getParseIntInDec(frame_schedule[n].Priority)) {
                    priority = getParseIntInDec(frame_schedule[n].Priority);
                    priority++;
                }
            }
        }
        if (n == frame_schedule.length - 1) {
            frame_schedule[frameIndex].Priority = priority;
        }
    }
    log.debug("COMPLETE", "setFramePriorty");
}

function modifyStartEndTime(changedStartTime, changedEndTime, color, day, frameScheduleIndex, link, linkday) {
    log.debug("START changedStartTime=" + changedStartTime + ":changedEndTime=" + changedEndTime + ":frameScheduleIndex=" + frameScheduleIndex, "modifyStartEndTime");
    var frameSchObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[frameScheduleIndex];
    frameSchObj.Start_Time = changedStartTime;
    frameSchObj.Duration = Math.abs(ScheduleUtils.getDurationInSeconds(changedEndTime) - ScheduleUtils.getDurationInSeconds(changedStartTime));
    frameSchObj.Color = color;
    frameSchObj.Repeat[0].WeekDay = day;
    frameSchObj.Frame_Sch_link = link;
    frameSchObj.Frame_Sch_linkday = linkday;
    log.debug("COMPLETE ", "modifyStartEndTime");
}

function updateSchNameList(updatedSchNamesArr) {
    log.debug("START", "updateSchNameList");
    var schListlength = updatedSchNamesArr.length;

    var schTextName = Utils.decodeThumbPath($(".schNameLableCls  div").text().trim());
    var schProjNamelist = '<div class="schDropdownDiv1Cls" > </div><div class="schname-container"><ul id="schNameListId" class="schNameListCls">';
    $.each(updatedSchNamesArr, function(index, schProjName) {
        if (schTextName == schProjName) {
            schProjNamelist += '<li><div class="newSchFontCls" style="color:#000000"><div style="display: block; width: 80%; margin-left: 10%; margin-right: 10%;" class="textEllipsis">' + schProjName + '</div></div></li>';
        } else {
            schProjNamelist += '<li><div class="newSchFontCls"><div style="display: block; width: 80%; margin-left: 10%; margin-right: 10%;" class="textEllipsis">' + schProjName + '</div></div></li>';
        }
    });
    schProjNamelist += '</ul></div><div id="createNewSch" class="createnewSchCls"><div class="upborderCls"></div><div class="schcreateNewCls"><div class="addbtnSchCls"></div><div class="createNewSchFontCls"> <div> ' + langObj.Schedule.COM_TV_CREATE_NEW +  '</div></div></div><div class="schDropdownDiv2Cls" ></div> </div>';
    $('.schTextNameCls').html(schProjNamelist).show();
    
    $('.createNewSchFontCls  div').css("position", "absolute");
                        
    var textRatio = ($('.createNewSchFontCls  div').width()) / ($('.schTextNameCls').width());

    if( textRatio < 0.1)
    {
        $('.addbtnSchCls').css("margin-left", "42.5%");
        $('.createNewSchFontCls ').css("width", "10%");
    }
    else if( textRatio < 0.2)
    {
        $('.addbtnSchCls').css("margin-left", "37.5%");
        $('.createNewSchFontCls ').css("width", "20%");
    }
    else if(textRatio < 0.3)
    {
        $('.addbtnSchCls').css("margin-left", "32.5%");
        $('.createNewSchFontCls ').css("width", "30%");
    }
    else if(textRatio < 0.4)
    {
        $('.addbtnSchCls').css("margin-left", "27.5%");
        $('.createNewSchFontCls ').css("width", "40%");
    }
    else if(textRatio < 0.5)
    {
        $('.addbtnSchCls').css("margin-left", "22.5%");
        $('.createNewSchFontCls ').css("width", "50%");
    }
    else if(textRatio < 0.6)
    {
        $('.addbtnSchCls').css("margin-left", "17.5%");
        $('.createNewSchFontCls ').css("width", "60%");
    }
    else if(textRatio < 0.7)
    {
        $('.addbtnSchCls').css("margin-left", "12.5%");
        $('.createNewSchFontCls ').css("width", "70%");
    }
    else 
    {
        $('.addbtnSchCls').css("margin-left", "7.5%");
        $('.createNewSchFontCls ').css("width", "80%");
        $('.createNewSchFontCls  div').css({
            'position' : 'relative'
        });
    }
    
    $('.createNewSchFontCls').authorActiveClass();
    var liheight = ($("#schTextName").height())*2.5;
    var maxUlhght = liheight * 6;
    var ulheight = (schListlength == 0 ? 0 : (liheight * schListlength));
    if (maxUlhght > ulheight) {
        $("#schTextName").find('ul#schNameListId').height(ulheight);
    } else {
        $("#schTextName").find('ul#schNameListId').height(maxUlhght);
    }
    $("#schTextName").find('ul#schNameListId li').height(liheight);
    refreshScreen();
    log.debug("COMPLETE", "updateSchNameList");
}

function calcPageElemDimn() {
    log.debug("START", "calcPageElemDimn");
    var timerContainerCls = $(".schScaleTimeCls").height();
    var hhinPX = timerContainerCls / 24;
    var newScheduleWdth = $("#newSchedule").width();
    var newScheduleHgth = $("#newSchedule").height();

    $(".schtimelineScaleCls").height(hhinPX*2);
    log.debug("COMPLETE", "calcPageElemDimn");
}

function addTimeScale() {
    log.debug("START", "addTimeScale");
    var scalediv = "";
    var value;
    var spanID = "";
    for (var k = 0; k <= 24; k += 2) {
        switch(k) {
            case 0:
                value = "12";
                spanID = "AM";
                break;
            case 12:
                value = "12";
                spanID = "PM";
                break;
            case 24:
                value = "12";
                spanID = "AM";
                break;
            default:
            spanID="";
                if (k < 10) {
                    value = Utils.convertToDblDigit(k);
                } else if ((k >= 10 && k < 12 )) {
                    value = k;
                } else {
                    value = Utils.convertToDblDigit(k - 12);
                }
                break;
        }
        scalediv += "<div class='schtimelineScaleCls'><span class='scaleAMPM'>"+spanID+"</span>" + "<span class='ScaleTime'>" + value + "</span></div>";
    }
    $(".schScaleTimeCls").html(scalediv);
    log.debug("COMPLETE", "addTimeScale");

}

/**********************************
create PlayList Name function start
**********************************/

function createPlayListName() {
    log.debug("START", "createPlayListName");
    scheduleRender.localCounter = 0;
    createRandomName(langObj.Schedule.MIS_SID_MIX_PLAYLIST);
    /*Remove Existing Playlist*/
    scheduleRender.clearDirectory(scheduleRender.playList + "/" + scheduleRender.projectName + "/" + scheduleRender.playlistName);
    log.debug("COMPLETE", "createPlayListName");

}

function createRandomName(label) {
    log.debug("START", "createRandomName");
    if (scheduleRender.localCounter < scheduleRender.globalCounter && scheduleRender.globalCounter > getParseIntInDec(SchPar.playListArray.length) + 1) {
        scheduleRender.localCounter++;
        checkNameExits(scheduleRender.localCounter, label);
    } else {
        scheduleRender.globalCounter = SchPar.playListArray.length + 1;
        checkNameExits(scheduleRender.globalCounter, label);
    }
    log.debug("COMPLETE", "createRandomName");
}

function checkNameExits(index, label) {
    log.debug("START", "checkNameExits");

    var name = null;
    if (index < 10) {
        name = label + " 0" + index;
    } else {
        name = label  +""+index;
    }
    var index = fetchPlaylistIndex(name);
    if (getParseIntInDec(index) < 0) {
        scheduleRender.playlistName = name;
        scheduleRender.playlistTimeStamp = new Date().getTime();
        SchPar.playListArray.push({
            key : new Date().getTime(),
            value : name
        });
        if (scheduleRender.globalCounter < SchPar.playListArray.length + 1) {
            scheduleRender.globalCounter = SchPar.playListArray.length + 1;
        }

    } else {
        createRandomName(label);
    }
    log.debug("COMPLETE", "checkNameExits");
}

/*********************************
create PlayList Name function end
*********************************/

function registerEvents() {
    log.debug("START", "registerEvents");
    /* timebar area*/
    var $timebarArea = $("#timelineScheduleAreaId > .timelineScheduleContentCls").find(".timelineSchTimerTextCls");
    var $templateList = $("#Template_Area_Templates_Id");
    var $currList;
    var currSortableItemW;
    var currSortableItemH;
    
    /* PlayList copy & delete*/
    var $delPlayListBtn = '#Template_Area_Templates_Id > li.playListCls > div.thumbnain_And_Text_Area_Cls > div.copy_Delete_Box_Area_Cls > div.del_Box_Area_Cls';
    var $copyPlayListBtn = '#Template_Area_Templates_Id > li.playListCls > div.thumbnain_And_Text_Area_Cls > div.copy_Delete_Box_Area_Cls > div.copy_Box_Area_Cls';
    var cloneList;
    var touchEvent;
  
    $(".timelineAreaCls").on("tap", function(e) {
        $("#timePickerContainer").remove();
        if ($("#templatePlaylistId").css("display") == "block") {
            closePlayList();
            createEditSchedule(false, scheduleRender.playlistName, null, null, null);
            setTimeout(function() {
                validatedPlaylist();
            }, 500);
        }
    });

    $timebarArea.on('tap', '.timerTextCls', function() {
        /*
        $("#timePickerContainer").remove();
        if ($(".schTextNameCls").css("display") == "block") {
            $("#sch_dwndropdownId").trigger("tap");
        }

        if ($("#templatePlaylistId").css("display") != "block") {
            var id = $(this).attr("id");
            var container = id.split("_");
            var day = container[1];

            if ($(this).hasClass("timerTextClsActive")) {
                scheduleRender.isSavedSch = "true";
                scheduleRender.weekdaydeletedArray.push(day);
                $(this).removeClass("timerTextClsActive");
                $("#timer_" + day).removeClass("timerContainerCls-active");
                disableTimeBar(day);
            } else {
                $(this).addClass("timerTextClsActive");
                scheduleRender.isSavedSch = "true";
                enableTimeBar(day);
                $("#timer_" + day).find(".ts_contentArea").removeClass("ts_slider_container_highlight dragActive");
                $("#timer_" + day).find(".ts_contentArea").siblings(".ts_dragbtn").css("display", "none");
                $("#timer_" + day).find(".ts_contentArea").siblings(".ts_schcontrollerTimeCls").css("display", "none");
            }
            if (($(".ts_disabled").length == $(".ts_slider_containerCls").length) || ($(".ts_slider_containerCls").length < 1)) {
                $("#sch_nxtBtnId").addClass("btn_disabledCls");
                $('#saveOnlyBtn').addClass("icon-disabled");
                $('#saveAsBtn').addClass("icon-disabled");
                $("#saveBtn").addClass("btn_disabledCls");
                hideSaveAndSaveAsBtn();
            } else {
                $("#sch_nxtBtnId").removeClass("btn_disabledCls");
                $('#saveOnlyBtn').removeClass("icon-disabled");
                $('#saveAsBtn').removeClass("icon-disabled");
                $("#saveBtn").removeClass("btn_disabledCls");
            }

        }
        */
    });

    $("#schTextName").on('tap', '#createNewSch', function(e) {
        if (scheduleDB.scheduleInfoList.length > 29) {

            Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
            return false;
        }
        newTemplateClicked = true;
        $("#timePickerContainer").remove();
        $(".schTextNameCls").hide();
        hideOpenMenus();
        var timebarLength = $(".ts_slider_containerCls").length;
        if ((scheduleRender.isSavedSch == "true") &&(timebarLength > 0)) {
            genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1");
            genericPopUpObj.appendHTMLData([langObj.Schedule.MSG_WARN_PAGE_MOVE]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : langObj.Schedule.COM_SID_CANCEL,
                  "callback" : function(){
                $("#sch_dwndropdownId").addClass("schDwnDropdownCls").removeClass("schUpDropdownCls");

                    
                }
            }, {
                "btntxt" : langObj.Schedule.COM_TV_SID_NO,
                "callback" : function() {
                $("#landScape_Div_Id").removeClass("icon-disabled");
                    loadingScheduleLoader();
                    loadingSchFromCreateNew();
                }
            }, {
                "btntxt" : langObj.Schedule.COM_TV_SID_YES,
                "callback" : function() {
                      $("#landScape_Div_Id").removeClass("icon-disabled");
                    $("#inputSchName").val(scheduleRender.projectName);                    
                    saveSchedule();
                }
            }]);
            genericPopUpObj.showPopUp();

        } else {
            loadingScheduleLoader();
            loadingSchFromCreateNew();
        }
        e.preventDefault();
        e.stopPropagation();

        hideTemplatePlayListMenu();

    });

    $("#sch_dwndropdownId").on('tap', function(e) {
    
        console.log('111111*********** check the width : ' + $('.schNameLableCls ').width() );
        console.log('222222*********** check the div width : ' + $('.schNameLableCls  div').width() );
        console.log('333333*********** check the newSchedule width : ' + $('#newSchedule').width() );
        
        $("#timePickerContainer").remove();
        deActivateSlider();
        if ($("#templatePlaylistId").hasClass("isPlayListOpen")) {
            $("#timePickerContainer").remove();
            closePlayList();
            createEditSchedule(false, scheduleRender.playlistName, null, null, null);
            setTimeout(function() {
                validatedPlaylist();
            }, 500);
        }

        if ($(this).hasClass("schUpDropdownCls")) {
            $(".schTextNameCls").hide();
            $(this).addClass("schDwnDropdownCls").removeClass("schUpDropdownCls");
        } else {
            updateSchNameList(scheduleDB.scheduleInfoList);
            $(this).addClass("schUpDropdownCls").removeClass("schDwnDropdownCls");
        }
        e.preventDefault();
        e.stopPropagation();
        
        hideTemplatePlayListMenu();
        $('.addtemplateBtn').show();
    });

    $("#schTextName").on('tap', 'ul#schNameListId li', function(e) {
        $("#timePickerContainer").remove();
        scheduleRender.isClickCreateNew = false;
        $(".schTextNameCls").hide();
        var selectedSchName = $(this).text();
        if (scheduleRender.isSavedSch == "true") {
            genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1");
            genericPopUpObj.appendHTMLData([langObj.Schedule.MSG_WARN_PAGE_MOVE]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : COM_SID_CANCEL,
                "callback" : "closeGenericPopUp"
            }, {
                "btntxt" : langObj.Schedule.COM_TV_SID_NO,
                "callback" : function() {
                    loadingScheduleLoader();
                    if (scheduleRender.isFirstTimeSchedule && selectedSchName == scheduleRender.projectName) {
                        loadingSchFromCreateNew();
                    } else {
                        loadingSchFromDropDown(selectedSchName);
                    }
                }
            }, {
                "btntxt" : langObj.Schedule.COM_TV_SID_YES,
                "callback" : function() {
                    SchObj.Program[0].ScheduleName = scheduleRender.projectName;
                    savingScheduleLoader();
                    saveScheduleInfo();
                    var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
                    var schName = scheduleRender.projectName;
                    deActivateSlider();
                    schGenerator.saveXMLData(scheduleRender.mySchedule + "/" + scheduleRender.projectName, scheduleRender.tempdeletedArray, scheduleRender.weekdaydeletedArray, schpath, schName, scheduleRender.navigateFromSchedule, scheduleRender.navigateFromTemplate, scheduleRender.templateCatogerySch);
                    clearData();
                    if (selectedSchName != schName) {
                        loadingSchFromDropDown(selectedSchName);
                    } else {
                        scheduleRender.isSavedSch = 'false';
                    }

                }
            }]);
            genericPopUpObj.showPopUp();
        } else {
            loadingScheduleLoader();
            if (scheduleRender.isFirstTimeSchedule && selectedSchName == scheduleRender.projectName) {
                loadingSchFromCreateNew();
            } else {
                loadingSchFromDropDown(selectedSchName);
            }
        }

        e.preventDefault();
        e.stopPropagation();
        
        hideTemplatePlayListMenu();

    });
    
    $("#sch_prevBtnId").on('tap', function(e) {       
        hideOpenMenus();
        var urlStr = setTemplateURL();
        navigateFromSchedule(urlStr);
        e.preventDefault();
        e.stopPropagation();
    });

    $("#sch_nxtBtnId").on('tap', function(e) {
        if($("#sch_nxtBtnId").hasClass("btn_disabledCls")){
             return;
        }
    	newTemplateClicked = false;
        $("#timePickerContainer").remove();
        hideOpenMenus();
        deActivateSlider();
     
        if ($("#templatePlaylistId").css("display") != "block") {

            var timebarLength = $(".ts_slider_containerCls").length;
            if (timebarLength > 0) {
                schGenerator.isNext = true;
                nxt_buttonClicked = true;
                SchObj.Program[0].ScheduleName = scheduleRender.projectName;
                $("#inputSchName").val(scheduleRender.projectName);                
                saveAndSaveAsSchedule();

            }
        }
        e.preventDefault();
        e.stopPropagation();
    });


    $(document).on("tap", '#templateAreaTemplatesId > li.templateListCls', function(e) {
        e.stopPropagation();
        e.preventDefault();
        
        $("#timePickerContainer").remove();
        if ($("#templatePlaylistId").hasClass("isPlayListOpen")) {

            closePlayList();
        }

        if (scheduleRender.playlistName != '' && scheduleRender.playlistName != null && scheduleRender.playlistName != undefined) {
            createEditSchedule(false, scheduleRender.playlistName, null, null, null);
            setTimeout(function() {
                validatedPlaylist();
            }, 500);
        }
        var categoryName = $(this).attr("data-categoryName");
        var orientation = $(this).attr("data-orientation");
        var templatePath = $(this).attr("data-templatePath");
        var urlStr = "../template/template.html?category=C" + "&orientation=" + orientation + "&templatePath=" + templatePath;
             var timebarLength = $(".ts_slider_containerCls").length;   
        if(timebarLength==0 || $(".ts_disabled").length == timebarLength){
             window.location.href = urlStr;
            
        }
        else{
        navigateFromSchedule(urlStr);
            
        }
       
        return false;

    });
    function clearDatas($this){
        
        var $copyDeleteBoxArea = $this.parent().parent().find(".copy_Delete_Box_Area_Cls");
        $("#timePickerContainer").remove();
        $(".copy_Delete_Box_Area_Cls").not(this).hide();
        $(".sortCopyIconDragCls").not(this).addClass("sort_Copy_Icon_Cls").removeClass("close_Icon_Cls");        
        if(!$this.hasClass('sort_Copy_Icon_Cls'))
        {
        	$copyDeleteBoxArea.hide();
            $this.addClass("sort_Copy_Icon_Cls").removeClass("close_Icon_Cls");
        }      
        var gallImgheight = $('.templateAreaTemplatesCls').find('li.playListCls').find('div.upperImgCls').height();
        $copyDeleteBoxArea.css({
            'margin-top' : '-' + gallImgheight + 'px'
        });
    }
    
    $(document).on('click', 'div.sortCopyIconDragCls', function(e) {
        
        if( $('#Create_Playlist_Area_Id').css('display') == 'block' ) return;
        
        var $copyDeleteBoxArea = $(this).parent().parent().find(".copy_Delete_Box_Area_Cls");
        $(".copy_Delete_Box_Area_Cls").not(this).hide();
         $(".sortCopyIconDragCls").not(this).addClass("sort_Copy_Icon_Cls").removeClass("close_Icon_Cls");
        
        if($(this).hasClass('sort_Copy_Icon_Cls'))
        {
            $copyDeleteBoxArea.show();  
           $(this).addClass("close_Icon_Cls").removeClass("sort_Copy_Icon_Cls");    
        }
        else
        {
            $copyDeleteBoxArea.hide();
            $(this).addClass("sort_Copy_Icon_Cls").removeClass("close_Icon_Cls");
        }
        if (!scheduleRender.isPlaylistdeleted) {
            scheduleRender.playlistName = $(this).parent().parent().parent().attr('data-text');
            scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + scheduleRender.playlistName + "/" + scheduleRender.playlistName + ".xml";
            scheduleRender.isPlayList = true;
            scheduleRender.isDraggablePlaylist = false;
            scheduleRender.loadPlayListData();
        }
        if ($("#templatePlaylistId").hasClass("isPlayListOpen")) {
            $("#timePickerContainer").remove();
            closePlayList();
        }
        createEditSchedule(false, scheduleRender.playlistName, null, null, null);
        setTimeout(function() {
            validatedPlaylist();
        }, 500);
      
        var gallImgheight = $('.templateAreaTemplatesCls').find('li.playListCls').find('div.upperImgCls').height();
        $copyDeleteBoxArea.css({
            'margin-top' : '-' + gallImgheight + 'px'
        });
        e.preventDefault();
        e.stopPropagation();

    });    

    /*PlayList delete & copy*/
    $(document).on("tap", $delPlayListBtn, function(e) {

        deletePlayListPopUp($(this));
        e.preventDefault();
        e.stopPropagation();
    });
    
    $(document).on("tap", $copyPlayListBtn, function(e) {
        var parentDiv=$(this).parent().parent();
        clearDatas(parentDiv.find('.sortCopyIconDragCls'));
        cloneList = parentDiv.parent().clone();
        scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + $(cloneList).attr("data-text") + "/" + $(cloneList).attr("data-text") + ".xml";
        scheduleRender.isPlayList = true;
        scheduleRender.isDraggablePlaylist = false;
        scheduleRender.loadPlayListData();
        scheduleRender.isPlayListCopied = true;
        copyPlaylist(cloneList);
        e.preventDefault();
        e.stopPropagation();
        $('.playListCls').authorActiveClass();
        clearDatas(parentDiv.find('.sortCopyIconDragCls'));
    });
    

    
    $(".timerContainerCls").droppable({
        accept : "#Template_Area_Templates_Id >li ,.ts_slider_containerCls ",
        drop : function(event, ui) {
            initDraggable();
            $('div#landScape_Div_Id').addClass("icon-disabled");
            $("#sch_nxtBtnId").removeClass("btn_disabledCls");
            
            var curr = $(this);
            var elem = $(ui.draggable);
            if (scheduleRender.istimeBar == "true") {
                createdNewDraggedTimeBar(curr, elem);
            }
        }
    });
    
    /* show the Template & PlayList popup */
    $('.addtemplateBtn').on("tap", function(e) {
        e.preventDefault();
        e.stopPropagation();
        hideOpenMenus();
        $('.Template_Area_Cls').css({'display':'block'});    
        $('.Template_Area_Cls').animate({'top':'60%'});
        
        calULHieght();
    });
    
    
    $('.schContentCls').on("tap",function() {
        if( $('.Template_Area_Cls').css('display') == 'block')
            $('.Template_Area_Cls').animate(
                {
                    'top':'100%'
                },
                {
                    complete: function()
                    {
                        $('.Template_Area_Cls').css({'display':'none'});
                    }
                }
            );
    });
    /*change to orientation*/
    $('#landScape_Div_Id').on('tap', function() {
        if (!$(this).hasClass("icon-disabled")) {
            scheduleRender.isClickCreateNew = true;
            closePlayList();
            SchPar.playListArray = [];
            if ($(this).hasClass('landScape_Cls')) {
                $(this).addClass('portrait_Cls').removeClass('landScape_Cls');
                scheduleRender.orientationType = 'portrait';
                sessionStorage.setItem('orientationType', 9999);
                renderTemplate('portrait', false, true);

            } else {
                $(this).addClass('landScape_Cls').removeClass('portrait_Cls');
                scheduleRender.orientationType = 'landscape';
                sessionStorage.setItem('orientationType', 1000);
                renderTemplate('landscape', false, true);
            }
            scheduleRender.clearDirectory(scheduleRender.playList + "/" + scheduleRender.projectName);
            calULHieght();
        }
    });
    
    /* Add Tempalte > go to template page */
    $('#Template_Area_Templates_Id').on("click", 'li', function(e) {    
        if( $(this).attr('data-type') != 'addButton') return;
        
        $('.add_Template_button_Icon').css('background-image','url("../resource/img/ss_btn_add_template_l_s.png")');
        setTimeout(function () {
            $('.add_Template_button_Icon').css('background-image','url("../resource/img/ss_btn_add_template_l_n.png")');
            createNewTemplate();
        },300);

        e.preventDefault();
        e.stopPropagation();
    });
    
    $('.Empty_Add_Template_button').on("tap", function(e) {
        $('.Empty_Add_Template_button').css('background-image','url("../resource/img/btn_add_cont_s.png")');
        setTimeout(function () {
            $('.Empty_Add_Template_button').css('background-image','url("../resource/img/btn_add_cont_n.png")');
            createNewTemplate();
        },300);
        
        e.preventDefault();
        e.stopPropagation();
    });

     /*Click the PlayList > addClass 'Highlight' and open PlayList screen*/

    var checkClickPlaylist = false;
    $(document).on("tap", '.Template_Area_Templates_Cls > li.playListCls > div.thumbnain_And_Text_Area_Cls > div.thumbnail_Area_Cls', function(e) {
        e.preventDefault();
        e.stopPropagation();
        loaderObj.showLoader();
        if( $('#Create_Playlist_Area_Id').css('display') == 'block' || checkClickPlaylist == true)
        {
            loaderObj.hideLoader();
            return;
        }
        checkClickPlaylist = true;
        $('#SchedulePagehome').animate(
            {
                'opacity':'0'
            },
            {
                complete: function()
                {
                    $('#SchedulePagehome').css(
                        {
                            'display':'none',
                            'opacity':'1'
                        }
                    );
                    $('#Create_Playlist_Area_Id').css({'display':'block'});
                    $('.Playlist_Template_Container_Cls').css({'visibility':'hidden', 'height':'5%'});
                    $('.Templates_List_Area_Cls').css({'height':'75%'}); 
                }
            }
        );
        $('.Template_Area_Cls').animate(
            {
                'opacity':'0'
            },
            {
                complete : function()
                {
                    $('.Template_Area_Cls').animate({'opacity':'1'});
                }
            }            
        );
        
        scheduleRender.playlistName = $(this).parent().parent().attr("data-text");
        
        $('#Create_Playlist_List_Id>li').remove();
        $('.Create_Playlist_Title_Txt_Cls').text(scheduleRender.playlistName);
        
        createEditSchedule(false, scheduleRender.playlistName, null, null, null);
       
        $(this).parent().parent().addClass('template_container_Highlight');
        
        scheduleRender.isNewPlayList = false;
        
        scheduleRender.sortableMode = false;
        scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + $(this).parent().parent().attr("data-text") + "/" + $(this).parent().parent().attr("data-text") + ".xml";
        scheduleRender.isPlayList = true;
        scheduleRender.isDraggablePlaylist = false;
        scheduleRender.loadPlayListData();/* load select the Playlist!*/
        
        setTimeout(function() {
            renderPlayList();
            scheduleRender.playlistName = playListObj.CustomPlaylist[0].Name;
            scheduleRender.playlistTimeStamp = playListObj.CustomPlaylist[0].TimeStamp;
            checkClickPlaylist = false;
            $('#Content_number').text( $('#Create_Playlist_List_Id li').length + " / 99");
            loaderObj.hideLoader();
        }, 1000);
    
        $('#Template_Area_Templates_Id>li').each(function(index, obj) {
            if( $(obj).attr('data-type') == 'addButton' ) $(obj).css('display','none');
        });
    
    });

    /*Create PlayList Screen*/
    $('#Create_PlayList_Btn_Id').on('tap', function(e) {
        
        e.preventDefault();
        e.stopPropagation();
        
        if ($('#Create_PlayList_Btn_Id').hasClass('icon-disabled')) {
            return false;
        }
        
        var maxPlayList = getParseIntInDec(SchPar.playListArray.length) + 1;
        if (maxPlayList <= 30) 
        {      
            $('#Content_number').text("0 / 99");
            /* Create Empty PlayList!*/
            var tempOrientationType = $('.Template_Area_Templates_Cls > li:last').data('orientation');
            currOrient = tempOrientationType.replace(' class=','');
            playListObj = new playListResponse();
            
            createPlayListName();
            
            var playListArr = new Array_CustomPlaylist();
            playListObj.CustomPlaylist.push(playListArr);
            playListObj.CustomPlaylist[0].Name = scheduleRender.playlistName;
            
            $('.Create_Playlist_Title_Txt_Cls').text( playListObj.CustomPlaylist[0].Name );        
			savePlaylistContent().done(function() {
            
				addPlayListToTemplateList(tempOrientationType);
				/* Playlist add in template & Playlist container!*/
                scheduleRender.isNewPlayList = true;
                scheduleRender.sortableMode = false;
            
                $('.Template_Area_Templates_Cls > li:eq(-2) > div.thumbnain_And_Text_Area_Cls > div.thumbnail_Area_Cls').tap();
            
				$('.Template_Area_Templates_Cls > li:eq(-2)').css({
					'display' : 'none'
				});
                $('.Template_Area_Templates_Cls > li:eq(-2)').addClass('new_PlayList');
			});
        
        } else {
            Utils.showToast(langObj.Schedule.MIA_SID_MIX_PLAYLIST_CREATE_UP_SCHEDULE);
        }
        
    });
       

     /*Edit PlayList Item*/

    
    /*PlayList Item add and go to add template screen*/
    $('#Add_Template_Btn_Id').on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        
        $('#Add_Template_Btn_Id').addClass('click_Add_Btn');

        $('.Template_Area_Cls').css({'display':'block'}); 
        $('.empty_PlayList_Txt').css({'top':'20%'});        
        $('.Template_Area_Cls').animate({'top':'60%'});
        
        
    });
    
    $('#Create_Playlist_Area_Id').on('tap', function(e) {
        $('.empty_PlayList_Txt').css({'top':'40%'});    
        $('.Template_Area_Cls').animate(
            {
                'top':'100%'
            },
            {
                complete: function()
                {
                    $('.Template_Area_Cls').css({'display':'none'});
                }
            }
        );
    });
    
    
    /*PlayList thumbnail touch and move*/
    $("#Create_Playlist_List_Id").sortable({
        scroll : true,
        items : "li",
        handle : ".thumbnain_And_Text_Area_PlayList_Cls",
        axis: "y",
        scrollSpeed : 40,
        scrollSensitivity : 30,
        update: function( event, ui ) { updatePlayListImage(); }
    });
    
    $(document).on("touchstart", '#Create_Playlist_Area_Id li.playList_Li_Cls div.thumbnain_And_Text_Area_PlayList_Cls', function(e) {    
        $(this).parent().addClass('playList_Li_Cls_active');
        
        hideTemplatePlayListMenu();
    });    

    
    $(document).on("touchend", '#Create_Playlist_Area_Id li.playList_Li_Cls div.thumbnain_And_Text_Area_PlayList_Cls', function(e) {
        $(this).parent().removeClass('playList_Li_Cls_active');    
    });
    
    /*PlayList Item time setting*/
    $(document).on("tap", '#Create_Playlist_Area_Id li.playList_Li_Cls div.duration_Area_Cls div.Num_Container_Cls', function(e) {
        e.stopPropagation();
        e.preventDefault();
    
        $min = $(this).find('#template_min_Num_Id');
        $sec = $(this).find('#template_sec_Num_Id');
        
        tempMin = parseInt($min.text());
        tempSec = parseInt($sec.text());        
        createTimePickers(2);
        var CurrentTimePicker = $('body').find('#TimePicker');
        //$('.commonColonCls').addClass('topadjCls');
        CurrentTimePicker.timeSpinner(
            {
                type: '2',
                fontHeight: FonttimerValFrNote_5,
                fontpadding: '0',
                time2 : {
                            min : tempMin,
                            sec : tempSec
                        },
        
                onTimeSet:function(val)
                {
                    var min = val.substring(0,2);
                    var sec = val.substring(3,5);
                    if(parseInt(min)==0 && parseInt(sec)<5)
                    {
                        min="00";sec="05";
                    }
                    $min.text(min);
                    $sec.text(sec);
                }
            }
        );
        
    });
    $(document).on('touchstart',".headerClsTi", function(e) {    
        console.log('headerClsTi');
        e.stopPropagation();
        e.preventDefault();
    });
    
    $(document).on('touchstart',".TimePickerConCls", function(e) {  
        console.log('TimePickerConCls');
        e.stopPropagation();
        e.preventDefault();
    });
	$('.buttonClsTi,.bodyCls').off('tap');
	$(document).on('tap', ".buttonClsTi", function(e) {
        e.stopPropagation();
        e.preventDefault();
        console.log('buttonClsTi');
        
		$('.buttonClsTi').css({
                'background-color':'#3196ff',
                'color':'#ffffff',
		});

        
        setTimeout ( function (){
            closeTimePicker();
			$('.buttonClsTi').css({
                    'background-color':'#e6e6e6',
                    'color':'#242424',
			});
        },20);
		return false;
    });
    
	$(document).on('tap', ".bodyCls ", function(e) {
        if( $('#TimePicker').css('display') == 'block' ){
            console.log(' documnet' );
            e.stopPropagation();
            e.preventDefault();
            closeTimePicker();
        }
		return false;
    });
    
    /*PlayList Item delete*/
    $(document).on("tap", '#Create_Playlist_Area_Id li.playList_Li_Cls div.template_Delete_Icon_Cls', function(e) {  
        if( $('#Create_Playlist_List_Id > li').length == 1 )
        {
            deleteTemplateInPlayListPopUp($(this).parent());
        }else{
            $(this).parent().remove();
            $('#Content_number').text( $('#Create_Playlist_List_Id li').length + " / 99");
        }
        
        updatePlayListImage();
        
        e.stopPropagation();
        e.preventDefault();
    });
    
    /* Complete to create PlayList!! */
    $('#Create_Playlist_Done_Btn_Id').on('tap', function(e) {
        e.preventDefault();
        e.stopPropagation();
        
        console.log( " $('#Create_Playlist_Done_Btn_Id').hasClass('Create_Playlist_Done_Btn_NOT') : " + $('#Create_Playlist_Done_Btn_Id').hasClass('Create_Playlist_Done_Btn_NOT') );
        
        if( $('#Create_Playlist_Done_Btn_Id').hasClass('Create_Playlist_Done_Btn_NOT') ) return;
        
        closeCreatePlayList();

        /*Initialization before save*/
        var contentIndex = playListObj.CustomPlaylist[0].CustomContent.length;
        playListObj.CustomPlaylist[0].CustomContent.splice(0, contentIndex);        
        savePlaylistContent();

        /*Find the selected Templates*/
        $('#Create_Playlist_List_Id>li').each(function(index, obj) {
            var text = $(obj).find('.thumnail_Title_Text_Cls').text();
            var tempDuration = parseInt($(obj).find('#template_min_Num_Id').text()) * 60 + parseInt($(obj).find('#template_sec_Num_Id').text());
            
            $('#Template_Area_Templates_Id>li').each(function(index, obj) {
                var name = $(obj).attr("data-text");
                if( name == text )
                {
                    var durationColor = $(obj).attr("data-color");
                    var thumbPath = $(obj).attr("data-image");
                    var templateActualPath = $(obj).attr("data-templatePath");
                    var templateOrentation = $(obj).attr("data-orientation");
                    var templateId = $(obj).attr("data-templateId");
                    
                    var contentIndex = createPlayListObj(name, thumbPath, templateActualPath, templateId, tempDuration,false);
                }
            });
        });
        savePlaylistContent();
        removeHighlight();
        
        $('.Template_Area_Templates_Cls > li:eq(-2)').css({'display':'block'}); 
        $('.Template_Area_Templates_Cls > li:eq(-2)').removeClass('new_PlayList');
        
        $('#Template_Area_Templates_Id>li').each(function(index, obj) {
            if( $(obj).attr('data-type') == 'addButton' ) $(obj).css('display','block');
        });

        /* If playList have no template, added time bar is deleted.*/
        if( $('#Create_Playlist_List_Id>li').length == 0 )
        {
            var playListName = $('.Create_Playlist_Title_Txt_Cls').text();
            scheduleRender.isPlaylistdeleted = true;
            
            createEditSchedule(false, playListName, null, null, null);
            changePlaylistBGColor("",scheduleRender.playlistName,true);
        };
    });

    $('#Create_Playlist_Cancel_Btn_Id').on('tap', function(e) {
        closeCreatePlayList();
    });
    
    $(document).on('tap', 'div.addContentAreaCls', function(e) {
        e.preventDefault();
        e.stopPropagation();
        if (!Utils.isAddTemplateAllowed()) {
            return false;
        }
        $("#timePickerContainer").remove();
        if ($("#templatePlaylistId").hasClass("isPlayListOpen")) {
            
            closePlayList();
        }

        var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
        var schName = scheduleRender.projectName;
        var isNewSchedule = false;
        if (scheduleRender.isClickCreateNew) {
            schpath = '';
            schName = '';
            isNewSchedule = true;
        }
        contentClicked = true;
        var urlStr = setNavigateURL(scheduleRender.templateCatogerySch, schName, schpath);
        var timebarLength = $(".ts_slider_containerCls").length;   
        if(timebarLength==0 || $(".ts_disabled").length == timebarLength){
             window.location.href = urlStr;
            
        }
        else{
        navigateFromSchedule(urlStr, true, isNewSchedule, scheduleRender.templateCatogerySch, schName, schpath);    
            
        }
        
        e.preventDefault();
        e.stopPropagation();
    });
    $(".homeBtnCls").on("tap", function(e) {
        isHomeClicked = true;        
        hideOpenMenus();
        var timebarLength = $(".ts_slider_containerCls").length;
        var urlStr = "../quickstart/QuickStart.html";
        if(timebarLength==0 || $(".ts_disabled").length == timebarLength){
             window.location.href = urlStr;
            
        }
        else{
             navigateFromSchedule(urlStr);
        }
       
        e.preventDefault();
        e.stopPropagation();

    });

   $(".helpBtnCls").on("tap", function(e) {

        var cntnAreaObj = $(".timelineSchTimerContainerCls").children().find(".ts_contentArea");

        if (scheduleRender.templateCatogerySch == 'C') {

            HelpPopUp("CD_STEP12");
        } 
        else 
        {
            /* when template & playlist is opened*/
            if( $('.Template_Area_Cls').css('display') == 'block')
            {
                HelpPopUp("QS_STEP7");
            }
            /* when a time bar is selected*/
            else if( $("#copydelbtnId").css('display') == 'block')
            {
                HelpPopUp("QS_STEP6");
            }
            else
            {
                HelpPopUp("QS_STEP5");
            }
        }

        e.preventDefault();
        e.stopPropagation();

    });
    
    $('#sendBtn').on('tap', function(e) {
        if($('#sendBtn').hasClass("btn_disabledCls")) {
         return;
        }
        $("#timePickerContainer").remove();
        $('.addtemplateBtn').show();
        nxt_buttonClicked = true;
        hideSaveAndSaveAsBtn();
        hideOpenMenus();
		newTemplateClicked = false;

        var timebarLength = $(".ts_slider_containerCls").length;
        if (timebarLength == 0 || $(".ts_disabled").length == $(".ts_slider_containerCls").length) {
            emptySchErrorPopUp();
        } else {
            schGenerator.isNext = true;
            if (scheduleRender.isFirstTimeSchedule) {
                $('#sendBtn').addClass("btn_disabledCls");
                $("#inputSchName").val(scheduleRender.projectName);                
                saveAndSaveAsSchedule();
            } else {
                 scheduleRender.editNextClicked = true;
                 var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
                 var schName = scheduleRender.projectName;
                 populateTemplateList();
                 setTimeout(function(){
                    if (scheduleRender.isSavedSch == "true") {
                        $('#sendBtn').addClass("btn_disabledCls");
                        url = "../send/Send.html?schedulePath=" + schpath + "&scheduleName=" + schName + "&navigateFromSchedule=" + scheduleRender.navigateFromSchedule + "&navigateFromTemplate=" + scheduleRender.navigateFromTemplate + "&category=" + scheduleRender.templateCatogerySch;
                        navigateFromSchedule(url);
                    } else {
                        window.location.href = "../send/Send.html?schedulePath=" + schpath + "&scheduleName=" + schName + "&navigateFromSchedule=" + scheduleRender.navigateFromSchedule + "&navigateFromTemplate=" + scheduleRender.navigateFromTemplate + "&category=" + scheduleRender.templateCatogerySch;
                    }
                 },500);
            }
        }

        e.preventDefault();
        e.stopPropagation();
    });
    $('#saveOnlyBtn').on('tap', function(e) {
        hideOpenMenus();
        checkTimebar=0;
        newTemplateClicked=false;
        if ($(".ts_slider_containerCls").length >= 1 &&  !($("#saveBtn").hasClass("btn_disabledCls"))) {
            $("#timePickerContainer").remove();
            $(".saveOnlyAndSaveAs").hide();
            $(".saveSaveAsTxt").hide();
            $('.save').removeClass('save-selected');   
            $('.addtemplateBtn').show();          
            schGenerator.isNext = false;
            if(scheduleRender.isFirstTimeSchedule == true){
              $("#timePickerContainer").remove();
            $(".saveOnlyAndSaveAs").hide();
    
            $(".saveSaveAsTxt").hide();
            $('.save').removeClass('save-selected');
            $("#inputSchName").val(scheduleRender.projectName);            
            saveSchedule();
            e.preventDefault();
            e.stopPropagation();
                
            }
            else{
                
               scheduleRender.isFirstTimeSchedule = false;
               scheduleRender.isSavedSch = "true";
               saveAndSend();
               
               e.preventDefault();
               e.stopPropagation();
            }
         }
    });
    $('#saveAsBtn').on('tap', function(e) {    
    	newTemplateClicked=false;     
        hideOpenMenus();
        checkTimebar=0;
        $('.addtemplateBtn').show();
        if (scheduleDB.scheduleInfoList.length > 29) {

            Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
            return false;
        }
        if ($(".ts_slider_containerCls").length >= 1 &&  !($("#saveBtn").hasClass("btn_disabledCls"))) {
            $("#timePickerContainer").remove();
            $(".saveOnlyAndSaveAs").hide();
    
            $(".saveSaveAsTxt").hide();
            $('.save').removeClass('save-selected');
            if(scheduleRender.isFirstTimeSchedule==false){
            createNxtScheduleName();
                
            }
            $("#inputSchName").val(scheduleRender.projectName);            
            saveSchedule();
            e.preventDefault();
            e.stopPropagation();
        }
    });
    log.debug("COMPLETE", "registerEvents");

}

function overWriteSchName(scheduleName) {
    log.debug("START scheduleName=" + scheduleName, "overWriteSchName");
    $("#sch_nxtBtnId").addClass("btn_disabledCls");
    $('#sendBtn').addClass("btn_disabledCls");
    setTimeout(function() {
        genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1");
        genericPopUpObj.appendHTMLData([langObj.Schedule.MIA_SID_NAME_ALREAY_USE_OVERWRITE]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : langObj.Schedule.COM_TV_SID_NO,
            "callback" : function(){
                  saveSchedule();
            }
        }, {
            "btntxt" : langObj.Schedule.COM_TV_SID_YES,
            "callback" : function() {
                scheduleRender.projectName = scheduleName;
                var schedulePath = scheduleRender.mySchedule + "/" + scheduleRender.projectName;
                scheduleRender.clearDirectory(scheduleRender.mySchedule + "/" + scheduleRender.projectName);
                setTimeout(function() {
                    scheduleRender.isSavedSch = "true";
                    saveAs(scheduleName);
                }, 100);
            }
        }]);
        genericPopUpObj.showPopUp();
    }, 100);
    log.debug("COMPLETE", "overWriteSchName");
}

function saveAs(scheduleName) {
    log.debug("START scheduleName=" + scheduleName, "saveAs");
    $("#sch_nxtBtnId").addClass("btn_disabledCls");
    $('#sendBtn').addClass("btn_disabledCls");
    savingScheduleLoader();
    var existingSchName = '';
   if (scheduleRender.projectName != scheduleName) {
       existingSchName = scheduleRender.projectName;
    }

    scheduleRender.projectName = scheduleName;
    $("#inputSchName").val(scheduleRender.projectName);
    scheduleTitlePosition();
    
    SchObj.Program[0].ScheduleName = scheduleRender.projectName;
    var folderid = ScheduleUtils.getFolderID();
    saveScheduleInfo(existingSchName);
    saveNxtFlag=false;
    var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
    var schName = scheduleRender.projectName;
    deActivateSlider();
    schGenerator.saveXMLData(scheduleRender.mySchedule + "/" + scheduleRender.projectName, scheduleRender.tempdeletedArray, scheduleRender.weekdaydeletedArray, schpath, schName, scheduleRender.navigateFromSchedule, scheduleRender.navigateFromTemplate, scheduleRender.templateCatogerySch);
    clearData();
    saveCounter++;
    setTimeout(function() {
        scheduleRender.isSavedSch = "false";
        scheduleRender.isFirstTimeSchedule = false;
        if ((isHomeClicked == true) && (scheduleRender.isNewSchedule == true)) {
            isHomeClicked = false;
            var urlStr = "../quickstart/QuickStart.html";
            window.location.href = urlStr;
        } else if ((contentClicked == true) && (scheduleRender.isNewSchedule == true)) {
            contentClicked = false;
            var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
            var schName = scheduleRender.projectName;
            var urlStr = setNavigateURL(scheduleRender.templateCatogerySch, schName, schpath);
            window.location.href = urlStr;           

        } else if ((backpressed == true) && (scheduleRender.isNewSchedule == true)) {
            backpressed = false;
            window.location.href = tempUrl;
        } else if (newTemplateClicked == true) {
            newTemplateClicked = false;
            savingScheduleLoader();
            SchObj.Program[0].ScheduleName = scheduleRender.projectName;
            saveScheduleInfo();
            schGenerator.isNext = false;
            var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
            var schName = scheduleRender.projectName;
            deActivateSlider();
            schGenerator.saveXMLData(scheduleRender.mySchedule + "/" + scheduleRender.projectName, scheduleRender.tempdeletedArray, scheduleRender.weekdaydeletedArray, schpath, schName, scheduleRender.navigateFromSchedule, scheduleRender.navigateFromTemplate, scheduleRender.templateCatogerySch);
            clearData();
            setTimeout(function() {
                loadingSchFromCreateNew();
            }, 1200);

        } else if ((templateClicked == true) && (scheduleRender.isNewSchedule == true)) {
            templateClicked = false;
            var categoryName = $(this).attr("data-categoryName");
            var orientation = $(this).attr("data-orientation");
            var templatePath = $(this).attr("data-templatePath");
            var urlStr = "../template/template.html?category=C" + "&orientation=" + orientation + "&templatePath=" + templatePath;
            window.location.href = urlStr;
        }
       $("#sch_nxtBtnId").removeClass("btn_disabledCls");
       $('#sendBtn').removeClass("btn_disabledCls");

    }, 1500);
    log.debug("COMPLETE", "saveAs");
}

function setNavigateURL(templateCategory, schName, schpath) {
    log.debug("START", "setNavigateURL");
    var tempURLStr = '';
    if (templateCategory == 'C') {
        tempURLStr = "../template/template.html?category=" + templateCategory + "&scheduleName=" + schName + "&schedulePath=" + schpath;
    } else {
       tempURLStr = "../quickstart/QuickStart.html?category=" + templateCategory+"&showOption=true"+"&orientation="+localStorage.getItem("orientationType");
    }
    log.debug("COMPLETE", "setNavigateURL");
    return tempURLStr;
}

function resetPlayListParent(iFlag) {
    log.debug("START", "resetPlayListParent");
    var totalW = Math.round(window.innerWidth * 0.69);
    $("#playListContainerId").sortable("disable");
    if (!iFlag) {
        $("#playListContainerId").sortable("enable");
    }

    $("#templatePlaylistId").css({
        'width' : totalW + 'px'
    });

    if (iFlag) {
        onOffScrollOnPlayList(true);
    }
    log.debug("COMPLETE", "resetPlayListParent");
}

function resetPlayListDim(liLength) {
    log.debug("START", "resetPlayListDim");
    var childLength = liLength;
    var itemWidth = $(".playListLiCls").outerWidth(true);
    $('.playListContainerCls,.horizontalLine').css({
        'width' : (childLength * itemWidth) + 'px',
        'min-width' : Math.round(window.innerWidth * 0.69 * 0.972) + 'px'
    });
    refreshScreen();
    log.debug("COMPLETE", "resetPlayListDim");
};

function saveSchedule() {
    
    genericPopUpObj.createPopUp("","Type2","renameSchedule");
    genericPopUpObj.appendHTMLData(['<div id="tmpltTitle">'+langObj.Schedule.IDS_BTN_SAVEAS+'</div>'                            
                                +'<div>'+langObj.template.MIA_SID_TENTER_FILE_NAME_SAVE_FILE+'</div><br/>'
                                +'<div id="renameProjInputId" class="renamePrjInputCls">'
                                    +'<input type="text" maxlength="25" name="ScheduleName" isSchedule="true" class="schInputCls disableCopy" value="Schedule 01" id="inputSchName" />'
                                +'</div>']);
    genericPopUpObj.addFooterBtns([{"btntxt":COM_SID_CANCEL,"callback":function(){
                                      $("#sch_nxtBtnId").removeClass("btn_disabledCls");
                                      $('#sendBtn').removeClass("btn_disabledCls");
                                       $("#inputSchName").blur();
                                       Utils.hideKeyboardForcely();
                                    }}
                                   ,{"btntxt":langObj.Schedule.COM_BUTTON_SAVE,"callback":function(){

                                            var scheduleName = $("#inputSchName").val();
                                            $("#inputSchName").blur();                                    
                                            scheduleName = scheduleName.slice(0,25);
                                            if (scheduleRender.projectName != scheduleName && scheduleDB.scheduleInfoList != null && scheduleDB.scheduleInfoList.indexOf(scheduleName) != -1) {
                                                overWriteSchName(scheduleName);
                                            } else {
                                                   if (scheduleRender.projectName == scheduleName && !scheduleRender.isFirstTimeSchedule && saveNxtFlag==false) {
                                                       overWriteSchName(scheduleName);
                                                    } else {
                                                        saveAs(scheduleName);
                                                    }
                                            } 
                                            scheduleDB.scheduleInfoList.push(scheduleName);                                            

                                        Utils.hideKeyboardForcely();
                                   }}]);
    genericPopUpObj.showPopUp();
    $("#inputSchName").val(scheduleRender.projectName).focus();     
}


function saveAndSaveAsSchedule() {
    
    if (scheduleRender.projectName == "" ) {
        scheduleRender.projectName = createNewSchedule();
    }
    
    genericPopUpObj.createPopUp("","Type2","renameSchedule");
    genericPopUpObj.appendHTMLData(['<div id="tmpltTitle">'+langObj.Schedule.IDS_BTN_SAVEAS+'</div>'                            
                                +'<div>'+langObj.template.MIA_SID_TENTER_FILE_NAME_SAVE_FILE+'</div><br/>'
                                +'<div id="renameProjInputId" class="renamePrjInputCls">'
                                    +'<input type="text" maxlength="25" name="ScheduleName" class="schInputCls" value="Schedule 01"  data-role="none" id="inputSchName" />'
                                +'</div>']);
    genericPopUpObj.addFooterBtns([{"btntxt":COM_SID_CANCEL,"callback":function(){
                                   
                                      $("#sch_nxtBtnId").removeClass("btn_disabledCls");
                                      $('#sendBtn').removeClass("btn_disabledCls");
                                            $("#inputSchName").blur();
                                    }
                                   }
                                   ,{"btntxt":langObj.Schedule.COM_BUTTON_SAVE,"callback":function(){

                                            var scheduleName = $("#inputSchName").val();
                                            $("#inputSchName").blur();        
                                            scheduleName = scheduleName.slice(0,25);
                                            if (scheduleRender.projectName != scheduleName && scheduleDB.scheduleInfoList != null && scheduleDB.scheduleInfoList.indexOf(scheduleName) != -1) {
                                               overWriteSchName(scheduleName);
                                            } else {
                                                   if (scheduleRender.projectName == scheduleName && !scheduleRender.isFirstTimeSchedule && saveNxtFlag==false) {
                                                       overWriteSchName(scheduleName);
                                                    } else {
                                                        saveAs(scheduleName);
                                                    }
                                            } 
                                            scheduleDB.scheduleInfoList.push(scheduleRender.projectName);
                                   }}]);
    genericPopUpObj.showPopUp();
    $("#inputSchName").val(scheduleRender.projectName).focus();    
}


/**************************
Add to Template to Playlist
**************************/

function addTmpltToPlayLst(tmpltList) {
    log.debug("START", "addTmpltToPlayLst");
    $('#Create_Playlist_List_Id').append(tmpltList);
    
    $('.Create_Playlist_List_Cls>li').each(function(index, obj) {
    
        var $thisBgImageObj = $(obj).find('.thumbnail_Area_Cls');
        var bgImage = $thisBgImageObj.css('background-image');
        var bg = bgImage.replace('url(','').replace(')','');
        
        $("<img src='"+bg+"'>").load(function(){
            $thisBgImageObj.fadeTo( "slow" , 1.0);
        }).error(function(){
            /*High Quality thumbnail does not exist. Load Low quality thumbnail.*/
            bgImage = bgImage.replace('.PNG.PNG?','.PNG?');
            $thisBgImageObj.css('background-image', bgImage).fadeTo( "slow" , 1.0);
            
        });
    });
    
    setTimeout(function() 
    {
        updatePlayListImage();
    }, 100);

    log.debug("COMPLETE", "addTmpltToPlayLst");
};

function onOffScrollOnPlayList(iFlag) {
    log.debug("START", "onOffScrollOnPlayList");
    try {
        if (playLstScroll == null) {
            playLstScroll = new IScroll('#templatePlaylistId', {
                scrollX : true,
                scrollY : false,
                interactiveScrollbars : true,
                shrinkScrollbars : 'scale',
                fadeScrollbars : true,
                scrollbars : true
            });
            playLstScroll.refresh();
        }

        var currX = playLstScroll.x * -1;
        playLstScroll.scrollTo(0, 0, 0);
        if (iFlag) {
            $("#templatePlaylistId").scrollLeft(0);
            playLstScroll.enable();
            Utils.refreshScrollbar(playLstScroll);
        } else {
            playLstScroll.destroy();
            playLstScroll = null;
            $("#templatePlaylistId").scrollLeft(currX);
        }

    } catch(ex) {
        console.log("Error" + ex, "onOffScrollOnPlayList");
    }
    log.debug("COMPLETE", "onOffScrollOnPlayList");
};

function navigateFromSchedule(urlStr, isAddTemplate, isNewSchedule, templateCategory, schName, schpath) {
    log.debug("START urlStr=" + urlStr + ":isAddTemplate=" + isAddTemplate + ":isNewSchedule=" + isNewSchedule + ":templateCategory=" + templateCategory + ":schName=" + schName + ":schpath=" + schpath, "navigateFromSchedule");
    $("#timePickerContainer").remove();
    if( newSchedule == true ) scheduleRender.isSavedSch = false;

    if (scheduleRender.isSavedSch == "true")
    {
        genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1");
        genericPopUpObj.appendHTMLData([langObj.Schedule.MSG_WARN_PAGE_MOVE]);
        genericPopUpObj.addFooterBtns([{
            "btntxt" : COM_SID_CANCEL,
            "callback" : function() {
              $('#sendBtn').removeClass("btn_disabledCls");

           }
        }, {
            "btntxt" : langObj.Schedule.COM_TV_SID_NO,
            "callback" : function() {
                setNavigateData(isAddTemplate, templateCategory, schName, schpath, urlStr, isNewSchedule);
            }
        }, {
            "btntxt" : langObj.Schedule.COM_TV_SID_YES,
            "callback" : function() {

                if ((isHomeClicked == true) && (scheduleRender.isNewSchedule == true)) {
                    $("#inputSchName").val(scheduleRender.projectName);                    
                    saveSchedule();
                } else if (scheduleRender.editNextClicked == true) {
                    scheduleRender.editNextClicked = false;
                    saveAndSend();

                }                
                else if ((contentClicked == true) && (scheduleRender.isNewSchedule == true)) {
                    $("#inputSchName").val(scheduleRender.projectName);                    
                    saveSchedule();
                } else if ((backpressed == true) && (scheduleRender.isNewSchedule == true)) {
                    $("#inputSchName").val(scheduleRender.projectName);                    
                    saveSchedule();
                } else if ((templateClicked == true) && (scheduleRender.isNewSchedule == true)) {
                    $("#inputSchName").val(scheduleRender.projectName);                    
                    saveSchedule();
                } else {

                    savingScheduleLoader();
                    SchObj.Program[0].ScheduleName = scheduleRender.projectName;
                    saveScheduleInfo();
                    schGenerator.isNext = false;
                    var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
                    var schName = scheduleRender.projectName;
                    deActivateSlider();
                    schGenerator.saveXMLData(scheduleRender.mySchedule + "/" + scheduleRender.projectName, scheduleRender.tempdeletedArray, scheduleRender.weekdaydeletedArray, schpath, schName, scheduleRender.navigateFromSchedule, scheduleRender.navigateFromTemplate, scheduleRender.templateCatogerySch);
                    clearData();
                    setTimeout(function() {
                        if (isAddTemplate) {

                            if (scheduleRender.orientationType != null) {
                                var orinentationVal = setOrientation(scheduleRender.orientationType);
                                window.sessionStorage.setItem('orientationType', orinentationVal);
                            }
                            urlStr = urlStr + "&isNewSchedule=" + false;

                        }
                        window.location.href = urlStr;
                    }, 1500);
                }

            }
        }]);
        genericPopUpObj.showPopUp();

    } else {
        setNavigateData(isAddTemplate, templateCategory, schName, schpath, urlStr, isNewSchedule);
    }
    log.debug("COMPLETE", "navigateFromSchedule");
}

function setNavigateData(isAddTemplate, templateCategory, schName, schpath, urlStr, isNewSchedule) {
    log.debug("START", "setNavigateData");
    if (isAddTemplate) {
        if (scheduleRender.isFirstTimeSchedule) {
            schName = '';
            schpath = '';
            urlStr = setNavigateURL(templateCategory, schName, schpath);
        }
        urlStr = urlStr + "&isNewSchedule=" + isNewSchedule;
        if (scheduleRender.orientationType != null) {
            var orinentationVal = setOrientation(scheduleRender.orientationType);
            window.sessionStorage.setItem('orientationType', orinentationVal);
        }
    }
    window.location.href = urlStr;

    log.debug("COMPLETE", "setNavigateData");
}

function saveAndSend() {
    log.debug("START", "saveAndSend");
    savingScheduleLoader();
    saveCounter++;
    
    SchObj.Program[0].ScheduleName = scheduleRender.projectName;
    saveScheduleInfo();
    var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
    var schName = scheduleRender.projectName;
    deActivateSlider();

    schGenerator.saveXMLData(scheduleRender.mySchedule + "/" + scheduleRender.projectName, scheduleRender.tempdeletedArray, scheduleRender.weekdaydeletedArray, schpath, schName, scheduleRender.navigateFromSchedule, scheduleRender.navigateFromTemplate, scheduleRender.templateCatogerySch);
    clearData();
    setTimeout(function() {
        scheduleRender.isSavedSch = "false";
    }, 500);
    log.debug("COMPLETE", "saveAndSend");
}

function deleteExistingSchedule(existingSchName) {
    log.debug("START", "deleteExistingSchedule");
    deleteScheduleFromDBByName(existingSchName);
    scheduleRender.clearDirectory(schGenerator.sdcardFullPath + scheduleRender.mySchedule + "/" + existingSchName);
    log.debug("COMPLETE", "deleteExistingSchedule");
}

function copyPlaylist(cloneList) {
    log.debug("START cloneList=" + cloneList, "copyPlaylist");
    if (scheduleRender.isPlayListCopied) {
        var maxPlayList = getParseIntInDec(SchPar.playListArray.length) + 1;
        if (maxPlayList <= 30) {
            createPlayListName();
            $(cloneList).attr("data-text", scheduleRender.playlistName);
            $(cloneList).attr("data-index", SchPar.playListArray.length - 1);
            $(cloneList).find(".thumnail_Title_Text_Cls").html(scheduleRender.playlistName);
            $(cloneList).find(".thumnail_Title_Text_Cls").css({'color':'#010101'});
            $(cloneList).find(".text_Area_Cls").css({
                'background-color' : ''
            });
            $(cloneList).attr("data-color", '');
            $(cloneList).find("div.sortCopyIconDragCls").addClass("sort_Copy_Icon_Cls").removeClass("close_Icon_Cls");
            $(cloneList).find(".copy_Delete_Box_Area_Cls").hide();
                    
            $('.Template_Area_Templates_Cls > li:last').remove();
            
            $('.Template_Area_Templates_Cls').append((cloneList));

            if (($('.Template_Area_Templates_Cls > li').length) < 2) {
                $('#createPlayListBtnId').addClass('icon-disabled');
            } else {
                $('#createPlayListBtnId').removeClass('icon-disabled');
            }
            
            initDraggable();
            playListObj.CustomPlaylist[0].Name = scheduleRender.playlistName;
            playListObj.CustomPlaylist[0].TimeStamp = scheduleRender.playlistTimeStamp;
            playListGenerator.savePlayListXMLData(scheduleRender.playlistName, scheduleRender.playList + "/" + scheduleRender.projectName, true, true);
            scheduleRender.isPlayListCopied = false;
            
            var addTemplate = "";
        
            addTemplate='<li data-type="addButton" data-orientation="' + $('.Template_Area_Templates_Cls > li:first').data('orientation') + ' class="template_List_Cls addButton" >' +
                            '<div class="add_Template_button_Icon" id="add_Template_button_Icon">' + 
                            '</div>' +
                        '</li>';
                
            $('.Template_Area_Templates_Cls').append(addTemplate);   
            
            calULHieght();            
            return false;
        } else {

            Utils.showToast(langObj.Schedule.MIA_SID_MIX_PLAYLIST_CREATE_UP_SCHEDULE);

        }
    }
    log.debug("COMPLETE", "copyPlaylist");
}

function loadingSchFromCreateNew() {
    log.debug("START", "loadingSchFromCreateNew");
    $("#sch_dwndropdownId").addClass("schDwnDropdownCls").removeClass("schUpDropdownCls");
    SchPar.playListArray = [];
    scheduleRender.isNewSchedule = true;
    scheduleRender.isClickCreateNew = true;
    scheduleRender.renderSchedule();
    schGenerator.isNext = false;
    scheduleRender.isSavedSch = "false";
    if ($('#saveBtn').hasClass('save-selected')) {
        $('.saveOnlyAndSaveAs').hide();
        $('.saveSaveAsTxt').hide();
        $('#saveBtn').removeClass('save-selected');
    }
    var timebarLength = $(".ts_slider_containerCls").length;
    if(timebarLength==0)
    {
         $('div#landScape_Div_Id').removeClass("icon-disabled");
    }
    log.debug("COMPLETE", "loadingSchFromCreateNew");
}

function loadingSchFromDropDown(selectedSchName) {
    log.debug("START", "loadingSchFromDropDown");
    $("#sch_dwndropdownId").addClass("schDwnDropdownCls").removeClass("schUpDropdownCls");
    
    scheduleTitlePosition();
    
    scheduleRender.isNewSchedule = false;
    scheduleRender.isFirstTimeSchedule = false;
    schGenerator.isNext = false;
    scheduleRender.projectName = selectedSchName;
    scheduleRender.entrySch = scheduleRender.mySchedule + "/" + selectedSchName + "/Schedules";
    scheduleRender.renderSchedule();
    scheduleRender.isSavedSch = "false";
    log.debug("COMPLETE", "loadingSchFromDropDown");
}

function scheduleTitlePosition()
{
   // $('.schNameLableCls  div').css("position", "absolute");
    $(".schNameLableCls  div").text(scheduleRender.projectName);
                        
    var titleRatio = ($('.schNameLableCls  div').width()) / ($('#newSchedule').width());

    
    if( titleRatio < 0.1)
    {
        $('.schDwnDropdownCls').css("margin-left", "40%");
        $('.schNameLableCls ').css("width", "10%");
    }
    else if( titleRatio < 0.2)
    {
        $('.schDwnDropdownCls').css("margin-left", "35%");
        $('.schNameLableCls ').css("width", "20%");
    }
    else if(titleRatio < 0.3)
    {
        $('.schDwnDropdownCls').css("margin-left", "30%");
        $('.schNameLableCls ').css("width", "30%");
    }
    else if(titleRatio < 0.4)
    {
        $('.schDwnDropdownCls').css("margin-left", "25%");
        $('.schNameLableCls ').css("width", "40%");
    }
    else 
    {
        $('.schDwnDropdownCls').css("margin-left", "20%");
        $('.schNameLableCls ').css("width", "50%");
        $('.schNameLableCls  div').css({
            'position' : 'relative',
            'text-overflow' : 'ellipsis !important',
            'overflow' : 'hidden !important'
        });
    }
}


function loadingScheduleLoader() {
    var imgarr = ['../resource/img/'];
    loaderObj.showLoader({
        'size' : 120,
        'interval' : 150,
        'color' : '#000000',
        'alpha' : '0.4'
    });
}

function savingScheduleLoader() {
    var imgarr = ['../resource/img/'];
    loaderObj.showLoader({
        'text' : langObj.Schedule.COM_TV_SID_SAVING,
        'size' : 120,
        'interval' : 150,
        'color' : '#000000',
        'alpha' : '0.4'
    });
}

function cancelPlaylist() {
    log.debug("START", "cancelPlaylist");
    setTimeout(function() {
        if (scheduleRender.isNewPlayList) {
            SchPar.playListArray.pop();
        }
        if (playListObj.CustomPlaylist[0] != undefined) {

            scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + playListObj.CustomPlaylist[0].Name + "/" + playListObj.CustomPlaylist[0].Name + ".xml";
            scheduleRender.isPlayList = true;
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, scheduleRender.gotFS, scheduleRender.fail);
        }

    }, 100);
    log.debug("COMPLETE", "cancelPlaylist");
}

function savePlaylistContent() {
	/* Deferred used to fix DF170228-00990*/
	var deferred = $.Deferred();
    log.debug("START", "savePlaylistContent");
    playListObj.CustomPlaylist[0].TimeStamp = new Date().getTime();
	playListGenerator.savePlayListXMLData(playListObj.CustomPlaylist[0].Name, scheduleRender.playList + "/" + scheduleRender.projectName, playListPar.isPlaylistFromSch, false).done(function() {
    createEditSchedule(true, null, null, null, null);
    scheduleRender.isPlayListSorted = false;
    log.debug("COMPLETE", "savePlaylistContent");
		deferred.resolve();
	});
	return deferred.promise();
}

function registerSortableEvents() {
    log.debug("START", "registerSortableEvents");
    $(document).on("taphold", ".playListLiCls", function() {
        if (!scheduleRender.sortableMode && evntSeq != "tapHold->tchStart->tchEnd") {
            evntSeq = "tapHold->";
            $("#timePickerContainer").remove();
            scheduleRender.sortableMode = true;
            var tempOrientationType = $('.templateAreaTemplatesCls > li:last').data('orientation');
            if (tempOrientationType == 'portrait') {
                $('#recycleDivId').addClass('recycleDiv-portrait').removeClass('recycleDivCls');
            } else {
                $('#recycleDivId').addClass('recycleDivCls').removeClass('recycleDiv-portrait');
            }
            $("#recycleDivId").show();
            onOffScrollOnPlayList(false);
            resetPlayListParent(false);
            $(this).trigger(srTchEvent);
        } else {
            evntSeq = "";
        }
        return false;
    });


    
    
   $(".doneBtnContainerCls").authorActiveClass();
   $(document).on("tap","#TimePicker_PLDuration",function(e){
    
        e.preventDefault();
        e.stopPropagation();
         $("#timePickerContainer").remove();
        return false;
    });

    $(document).on("tap", ".inputTimeBox", function(e) {
        e.preventDefault();
        e.stopPropagation();
        
        var temp_timer = $(this);
        var index = temp_timer.closest('li').index();
        var inputTime = temp_timer.val();
        var mm_inputTime = inputTime.split(":")[0];
        var ss_inputTime = inputTime.split(":")[1];
        mm_inputTime = mm_inputTime.replace('m', '');
        ss_inputTime = ss_inputTime.replace('s', '');
        var Inputval = ss_inputTime;
        Inputval = getParseIntInDec(Inputval);
        Inputval = Inputval < 10 ? "0" + Inputval : Inputval;
        var MinInputval = mm_inputTime;
        MinInputval = getParseIntInDec(MinInputval);
        MinInputval = MinInputval < 10 ? "0" + MinInputval : MinInputval; 
        var spinnerContainerWidth = Math.round(window.innerWidth * 0.1078);
        var cntrlHeight = Math.round(window.innerHeight * 0.2833);
        $('#timePickerContainer').remove();
        
        var timerWrappper = '<div id="timePickerContainer" class="timePickerClass">'+
                                '<div id="TimePicker_PLDuration"></div>'+
                                '<div class="highlight1"></div>'+
                                '<div class="highlight2"></div>'+
                                '<div class="show-min">'+langObj.Schedule.COM_IDS_MIN+'</div>'+
                                '<div class="show-sec">'+langObj.Schedule.MIA_SID_S_SECOND+'</div>'+
                            '</div>';
        $('body').append(timerWrappper);
        $('#TimePicker_PLDuration').timeSpinner({
            type : '2',
            height : '240',
            fontPadding : '0',
            width: '150',
            display:'5',
            MinSecSuffix:true,
            time2 : 
            {
                min : MinInputval,
                sec : Inputval        
            },
            onTimeSet : function(val) {
                updateTime(index, val);
            }
        }); 
        
        $("#timePickerContainer").css({
            'height':(cntrlHeight+25)+'px',
            'width' : (spinnerContainerWidth+10) + 'px',
            
            'background-color':'#FFFFFF',
            'position':'absolute'
        });
        

        $('.highlight1').css({'top':(cntrlHeight/2 - 10)+'px'});
        $('.highlight2').css({'top':(cntrlHeight/2 + 32)+'px'});
        $('.inputTimeBox').removeClass('activeTimeSpinner');
        temp_timer.addClass('activeTimeSpinner');
        var thisOffset = temp_timer.offset();
        var paddVal = 0;
        if(deviceType == "iPad")
        {
          paddVal = 8;
        }
        var left = getParseIntInDec(thisOffset.left) + paddVal - ($("#timePickerContainer").width()/2 - temp_timer.width()/2);
        var top = getParseIntInDec(thisOffset.top) + temp_timer.height()/2 - 120;
        $("#timePickerContainer").css({
            'left' : left + 'px',
            'top' : top + 'px',
        }); 
    
    });

    log.debug("COMPLETE", "registerSortableEvents");
}

/**************************************
information of template put in Playlist
***************************************/

function createPlayListObj(imageName, imagePath, templateActualPath, templateId, tempDuration,doSave) {
    log.debug("START", "createPlayListObj");
    playListObj.CustomPlaylist[0].TimeStamp = scheduleRender.playlistTimeStamp;

    var contentList = new Array_CustomContent();
    var contentIndex = playListObj.CustomPlaylist[0].CustomContent.length;

    playListObj.CustomPlaylist[0].CustomContent[contentIndex] = contentList;
    contentList.Name = imageName;
    contentList.Path = imagePath;
    contentList.ActualPath = templateActualPath;
    contentList.TemplateId = templateId;
    
    if( tempDuration )
    {
        contentList.Duration = tempDuration;
    }else
    {
        contentList.Duration = getTemplateDurationFrmTemplateId(templateId);      
    }
    if(doSave)
    {
        savePlaylistContent();
    }
    return contentIndex;
}

function getNewValue() {
    log.debug("START", "getNewValue");
    var schInfo = JSON.parse(sessionStorage.getItem("SCHEDULECOLOR_INFO"));
    if(schInfo!= null){
      
        schInfo = schInfo.toString();
        var temp = new Array();
        temp = schInfo.split(",");
        if (temp.length > 0) {
            var usedArr = [];
            var tempLen = temp.length - 1;
            for (var k = 0; k <= tempLen; k++) {
                if (temp[k] != "") {
                    usedArr.push(getParseIntInDec(temp[k]));
                }
            }
            var i = 0;
            while (i <= 30) {
                if ($.inArray(i, usedArr) == -1) {
                    return i;
                }
                i++;
            }
        }
   }
    else {
        return 0;
    }
    log.debug("COMPLETE", "getNewValue");
}

function getnewIndex(colorcode) {
    log.debug("START colorcode=" + colorcode, "getnewIndex");
    var arrr = [];

    arrr.push(colorcode);
    var i = 0;
    while (i < 30) {

        if ($.inArray(colorList[i], arrr) > -1) {
            return i;
        }
        i++;
    }
    log.debug("COMPLETE", "getnewIndex");
}

function saveScheduleInfo(existingSchName, folderid) {
    log.debug("START existingSchName=" + existingSchName + ":folderid=" + folderid, "saveScheduleInfo");
    SchObj.Program[0].PlaylistCounter = scheduleRender.globalCounter;

    getScheduleInfo(false, function(bStatus) {
    var scheduleName = SchObj.Program[0].ScheduleName;
    var scheduleFolderId = SchObj.Program[0].Program_Id;
    
        /*in case of rename*/
        if (existingSchName != undefined && existingSchName != '' && existingSchName != null) {

            var playlistFolderPath = Utils.getContentsRootPath() + "/Playlist/" + existingSchName;

            var newPlaylistFolderPath = Utils.getContentsRootPath() + "/Playlist/" + scheduleName;

            copyFolder(playlistFolderPath, newPlaylistFolderPath, "COPY_SCHEDULE", function(playlistStatus) {
                console.log("Playlist folder copied " + playlistStatus);
                ScheduleUtils.modifySchDirectory();

            });

        }
        if (scheduleName != null && scheduleName != undefined && scheduleName != '') {
            var scheduleFilePath = scheduleRender.mySchedule + "/" + scheduleName + "/Schedules/" + scheduleFolderId + "/localsch.sch";
            var scheduleThumbnailPath = /*schGenerator.sdcardFullPath+*/
            scheduleRender.mySchedule + "/" + scheduleName + "/Schedules/" + scheduleFolderId + "/" + scheduleName + ".PNG";
            if (($.inArray(scheduleName, scheduleDB.scheduleInfoList) < 0)) {
                insertScheduleInfo(scheduleName, scheduleFilePath, scheduleThumbnailPath, false);
            } else {
                if (scheduleRender.isSavedSch == "true") {
                    updateScheduleFromDB(scheduleName, scheduleFilePath, scheduleThumbnailPath, false);
                   scheduleRender.isSavedSch = "false";
                }
            }
        }

    });
    log.debug("COMPLETE", "saveScheduleInfo");
}

function getColorCode(templateId) {
    log.debug("START templateId=" + templateId, "getColorCode");
    var isTimelineExist = $(".ts_slider_containerCls").length > 0 ? true : false;
    var indx = getParseIntInDec($.inArray(templateId, SchPar.tempTemplateArray));
    if (indx > -1 && isTimelineExist == true) {
        return SchPar.templateColorScheduleArray[indx];
    }
    log.debug("COMPLETE", "getColorCode");
    return '';
}

/*Render Template / Playlist Jquery*/

function renderTemplate(templateOrientation, isCopy, isOrientation) {
    log.debug("START templateOrientation=" + templateOrientation + ":isCopy=" + isCopy + ":isOrientation=" + isOrientation, "renderTemplate");
    var templateInfo = ScheduleUtils.getLFDInfo();
    var templateLength = templateInfo.myTemplateInfoArrs.length > 29 ? 30 : templateInfo.myTemplateInfoArrs.length;
    var playListLength = SchPar.playListArray.length;
    var templateItem = "";
    var orientationType = templateOrientation;
    var playListItem = "";

    if (orientationType == 'portrait') {
        if (scheduleRender.isClickCreateNew == false) {

            $('div#landScape_Div_Id').addClass('portrait_Cls').addClass("icon-disabled").removeClass('landScape_Cls');
        }
        if (scheduleRender.isClickCreateNew == true && scheduleRender.isNewSchedule == true) {
            $('div#landScape_Div_Id').addClass('portrait_Cls').removeClass('landScape_Cls');
        }
    } else {
        if (scheduleRender.isClickCreateNew == false) {
            $('div#landScape_Div_Id').addClass('landScape_Cls').addClass("icon-disabled").removeClass('portrait_Cls');
        }
        if (scheduleRender.isClickCreateNew == true && scheduleRender.isNewSchedule == true) {
            $('div#landScape_Div_Id').addClass('landScape_Cls').removeClass('portrait_Cls');
        }
    }
    for (var i = 0; i < templateLength; i++) {

        var templateName = templateInfo.myTemplateInfoArrs[i].templateName;
        var templatePath = templateInfo.myTemplateInfoArrs[i].tempPath;
        var templateThumbPath = Utils.getSystemRootPath() + templateInfo.myTemplateInfoArrs[i].thumbPath;
        var templateThumbPathBackground = templateThumbPath + '.PNG?timestamp=' + new Date().getTime();
       
        var categoryName = templateInfo.myTemplateInfoArrs[i].categoryName;
        var orientation = templateInfo.myTemplateInfoArrs[i].orientationType;
        var templateId = templateInfo.myTemplateInfoArrs[i].templateId;
        var color = '';
        if (scheduleRender.isNewSchedule == true && i == 0 && colorIndex != -1 && !isCopy && isOrientation != true) {

            var schlenght = getTotalSchListLength();

            var valuess = getNewValue();

            colorIndex = valuess;

            color = colorList[colorIndex];

            colorIndex++;
        } else {

            color = getColorCode(templateId);
        }

        if (orientationType == orientation) {

            if (orientationType == 'portrait') {

                if (scheduleRender.isClickCreateNew == false) {

                    $('div#landScape_Div_Id').addClass('portrait_Cls').addClass("icon-disabled").removeClass('landScape_Cls');
                }

            } else {
                if (scheduleRender.isClickCreateNew == false) {
                    $('div#landScape_Div_Id').addClass('landScape_Cls').addClass("icon-disabled").removeClass('portrait_Cls');
                }
            }
            var genTemplateList = generateTemplate(orientationType, templateName, templateThumbPath, templateThumbPathBackground, color, i, templatePath, categoryName, templateId);
            templateItem += genTemplateList;
        }

    }
    var playListImg;
    var playListArrObj;
    for (var playListIndex = (playListLength - 1); playListIndex >= 0; playListIndex--) {
        playListArrObj = SchPar.playListArray[playListIndex];
        if (playListArrObj.image == undefined) {
            playListImg = "../resource/img/ss_default_playlist.png";
        } else {
            playListImg = playListArrObj.image;
        }
        playListItem += generatePlayList(playListArrObj.value, playListImg, playListArrObj.color, playListIndex, orientationType);
    }
    var listItem = playListItem + templateItem;
    $('.Template_Area_Templates_Cls').html(listItem);
    $('.Template_Area_Templates_Cls li').authorActiveClass();
    /*load thumbnail image .....*/
    $('#Template_Area_Templates_Id>li').each(function(index, obj) {
        
        var $thisBgImageObj = $(obj).find('.thumbnail_Area_Cls');
        var bgImage = $thisBgImageObj.css('background-image');
        var bg = bgImage.replace('url(','').replace(')','');
        
        $("<img src='"+bg+"'>").load(function(){
            $thisBgImageObj.fadeTo( "slow" , 1.0);
        }).error(function(){
            /*High Quality thumbnail does not exist. Load Low quality thumbnail.*/
            bgImage = bgImage.replace('.PNG.PNG?','.PNG?');
            $thisBgImageObj.css('background-image', bgImage).fadeTo( "slow" , 1.0);
            
        });
        
        if ( $(obj).attr("data-color") != "") {
            $(obj).find('.thumnail_Title_Text_Cls').css({
                'color' : '#ffffff'
            });
            $(obj).find(".text_Area_Cls #sortCopyIconId").addClass("sort_Copy_Icon_Cls_Selected").removeClass("sort_Copy_Icon_Cls");
        }

        if( $(obj).attr('data-type') == 'playlist') addUpperImg( $(obj) );

    });

    $('.template_List_Cls').authorActiveClass();
    initDraggable();
    
    if (($('.Template_Area_Templates_Cls>li').length) < 2) 
    {
        $('#Create_PlayList_Btn_Id').addClass('icon-disabled');
    } else 
    {

        $('#Create_PlayList_Btn_Id').removeClass('icon-disabled');
    }
    
    if (($('.Template_Area_Templates_Cls>li').length) == 0) 
    {
        $('.Empty_TemplateList_Txt_Cls').show();
        $('.Empty_Add_Template_button').show();

    } else {
        $('.Empty_TemplateList_Txt_Cls').hide();
        $('.Empty_Add_Template_button').hide();
        
        var addTemplate = "";
        
        addTemplate='<li data-type="addButton" data-orientation="' + orientationType + ' class="template_List_Cls addButton" >' +
                        '<div class="add_Template_button_Icon" id="add_Template_button_Icon">' + 
                        '</div>' +
                    '</li>';
            
        $('.Template_Area_Templates_Cls').append(addTemplate);        
    }
    
    loaderObj.hideLoader();
    $('.addtemplateBtn').css('display','block');
    log.debug("COMPLETE", "renderTemplate");
}

function addPlayListToTemplateList(tempOrientationType) {
    log.debug("START", "addPlayListToTemplateList");

    $('.Template_Area_Templates_Cls > li:last').remove();
    
    var playListImg = "../resource/img/ss_default_playlist.png";
    playListName = SchPar.playListArray[SchPar.playListArray.length - 1].value;
    var playList = generatePlayList(playListName, playListImg, '', SchPar.playListArray.length - 1, tempOrientationType);
    
    $(playList).appendTo('.Template_Area_Templates_Cls');
    
    var $li = $('.Template_Area_Templates_Cls > li:last');
    
    addUpperImg($li);
    
    $li.find('div.thumbnail_Area_Cls').addClass('empty_ImgSize');

    $('.Template_Area_Templates_Cls > li.playListCls').find('.sort_Copy_Icon_Cls').authorActiveClass();
    $('.Template_Area_Templates_Cls > li.playListCls').find('.copy_Box_Area_Cls').authorActiveClass();
    $('.Template_Area_Templates_Cls > li.playListCls').find('.del_Box_Area_Cls').authorActiveClass();
    
    initDraggable();
    $('.playListCls').authorActiveClass();
    
    var addTemplate = "";
        
    addTemplate='<li data-type="addButton" data-orientation="' + tempOrientationType + ' class="template_List_Cls addButton" >' +
                    '<div class="add_Template_button_Icon" id="add_Template_button_Icon">' + 
                    '</div>' +
                '</li>';
        
    $('.Template_Area_Templates_Cls').append(addTemplate);
    
    log.debug("COMPLETE", "addPlayListToTemplateList");
}

function clearData() {
    var len = scheduleRender.arrayOfremovedPlayList.length;
    for (var index = 0; index < len; index++) {
        scheduleRender.clearDirectory(scheduleRender.playList + "/" + scheduleRender.projectName + "/" + scheduleRender.arrayOfremovedPlayList[index]);
    }
}

function createdNewDraggedTimeBar(curr, elem) {
    log.debug("START curr=" + curr + ":elem=" + elem, "createdNewDraggedTimeBar");
    bTSMoveAllowed = true;
    scheduleRender.istimeBar = "false";
    var color = elem.attr("data-color");
    var sttime = elem.attr("data-sttime");
    var frameIndex = elem.attr("data-frameIndex");
    var elemday = elem.attr("data-day");
    var type = elem.attr("data-type");
    var sliderLink = elem.attr("data-sliderlink");
    var timeDuration = elem.attr("data-duration");
    var droppedContainer = curr.attr("id");
    var containerday = droppedContainer.split("_");
    var day = containerday[1];
    var startTime = convertTo24Format(sttime, 24);
    var endTime = getEndTime(startTime, timeDuration);
    var sch_endTime = endTime.split(":");
    var hh_endTime = sch_endTime[0];
    var mm_endTime = sch_endTime[1];
    var islooped = getParseIntInDec(hh_endTime) > getParseIntInDec(24) || (getParseIntInDec(hh_endTime) == 24 && getParseIntInDec(mm_endTime) > 0) ? "true" : "false";
    var newEndTime = ScheduleUtils.getDuration("24:00", endTime);
    var loopedDay = ScheduleUtils.getNextDay(day);
    var isPlaylist = type == 'template' ? false : true;
    var templateId = getParseIntInDec(elem.attr("data-templateId"));
    var playlistName = (elem.attr("data-playlist"));
    
    $(".ts_schcopydelbtnCls").hide();
    
    if (isPlaylist) {
        templateId = null;
    }

    if (islooped == "true" && sliderLink != undefined) {

        removeWeekDay(day);

        createUpdateTimeLine(day, startTime, "24:00", color, frameIndex, type, sliderLink, loopedDay, templateId, playlistName, true, timeDuration);
        modifyStartEndTime(startTime, "24:00", color, day, frameIndex, sliderLink, loopedDay);

        removeWeekDay(loopedDay);
        createUpdateTimeLine(loopedDay, "00:00", newEndTime, color, sliderLink, type, frameIndex, day, templateId, playlistName, true, timeDuration);
        modifyStartEndTime("00:00", newEndTime, color, loopedDay, sliderLink, frameIndex, day);

    } else {
        if (sliderLink != "" && sliderLink != undefined && type != undefined) {
            var plyListObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[getParseIntInDec(sliderLink)].Playlist[0];
            if (type != "template") {
                plyListObj.isDeleted = true;
            } else {
                plyListObj.Content[0].File[0].isDeleted = true;
            }
        }
        scheduleRender.tempdeletedArray.push(getParseIntInDec(sliderLink));
        removeWeekDay(day);
        createUpdateTimeLine(day, startTime, endTime, color, frameIndex, type, '', '', templateId, playlistName, true, timeDuration);
        modifyStartEndTime(startTime, endTime, color, day, frameIndex, "", "");
    }
    enableTimeBar(day);
    var isTimebarExist = $("#timer_" + day + ' > #ts_slider_container_' + frameIndex).length;
    if (isTimebarExist <= 1)
        $("#timer_" + elemday + ' > #ts_slider_container_' + frameIndex).remove();
    else
        elem.remove();    

    $('.addtemplateBtn').show();
    log.debug("COMPLETE", "createdNewDraggedTimeBar");

}

/**************
Create Time bar
**************/
function createNewTimeBar(curr, elem) {
    log.debug("START curr=" + curr + ":elem=" + elem, "createNewTimeBar");
    bTSMoveAllowed = true;
    scheduleRender.isClickCreateNew = false;
    var text = elem.attr("data-text");
    var image = elem.attr("data-image");
    var color = '';
    if(colorIndex > 29){
        colorIndex=0;
    }
    
    
    if (elem.data("color") != '') {
        color = elem.data("color");
    } 
    else 
    {
        if (colorIndex == -1){
            colorIndex = getTotalSchListLength();
        }
        if (colorIndex == colorList.length - 1) {
             if(scheduleRender.deletedColorList.length > 0){
                 color = scheduleRender.deletedColorList[getParseIntInDec(scheduleRender.deleteColorIndex)];
                usedColorIndex.push(scheduleRender.deletedColorList[getParseIntInDec(scheduleRender.deleteColorIndex)]);
                scheduleRender.deleteColorIndex++;
             }
             else{
                 colorIndex=0;
                  color = colorList[getParseIntInDec(colorIndex)];
                  usedColorIndex.push(colorList[getParseIntInDec(colorIndex)]);
             }
            
        } else {
            
            color = colorList[getParseIntInDec(colorIndex)];
            usedColorIndex.push(colorList[getParseIntInDec(colorIndex)]);

            $("#Template_Area_Templates_Id > li").each(function(i) {
                if ($(this).attr("data-color") == color) {
                    while (true) {
                        if ($.inArray(colorList[getParseIntInDec(colorIndex)], usedColorIndex) == -1) {
                            if (colorIndex == colorList.length - 1) {
                                colorIndex = 0;
                            }
                            usedColorIndex.push(colorList[getParseIntInDec(colorIndex)]);
                            color = colorList[getParseIntInDec(colorIndex)];
                            break;
                        } else {
                            colorIndex++;
                        }
                    }
                }
            });

        }
    }
    var type = elem.attr("data-type");
    var templateId = elem.attr("data-templateId");
    var templateIndex = getParseIntInDec($.inArray(getParseIntInDec(templateId), templateIDArray));
    var droppedContainer = curr.attr("id");
    var containerday = droppedContainer.split("_");
    var day = containerday[1];
    var length = $(".ts_slider_containerCls").length;
    var elemTopPos = elem.offset().top;
    var containerHeight = curr.outerHeight();
    var hh_interval = (containerHeight / 24);
    var containerTop = curr.offset().top;
    if (elemTopPos < containerTop) {
        elemTopPos = containerTop;
    }
    var elemBtmPos = elemTopPos + (hh_interval * 3);

    var range = getTimeSlider_Range(curr, elemTopPos, elemBtmPos);
    var timeRange = range.split("-");
    var startTime = timeRange[0];
    var endTime = timeRange[1];
    var sliderDuration = ScheduleUtils.getDuration(startTime, endTime);
    var duration = ScheduleUtils.getDurationInSeconds(endTime) - ScheduleUtils.getDurationInSeconds(startTime);
    var isPlaylist = type == 'template' ? false : true;
    enableTimeBar(day);
    if (isPlaylist) {
        scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + text + "/" + text + ".xml";
        scheduleRender.isPlayList = true;
        scheduleRender.isPlaylistAdded = true;
        scheduleRender.isDraggablePlaylist = false;
        scheduleRender.loadPlayListData();
    }
    scheduleRender.istimeBar = "false";
    setTimeout(function() {
        if (isPlaylist) {
            removeWeekDay(day);
            if (playListObj.CustomPlaylist[0].CustomContent.length != 0) {
                var index = getParseIntInDec($.inArray(text, scheduleRender.arrayOfremovedPlayList));
                if (index > -1) {
                    scheduleRender.arrayOfremovedPlayList.splice(index, 1);
                }

                createFrameSchedule(null, day, startTime, duration, color, templateIndex, isPlaylist, false, false);
                createUpdateTimeLine(day, startTime, endTime, color, scheduleRender.timerIndex, type, '', '', null, text, true, sliderDuration);
            } else {
                draggedPlayListOKPopUp(scheduleRender.emptyPlaylistMessage);
            }
        } else {
            var templateId = getParseIntInDec(elem.attr("data-templateId"));
            createFrameSchedule(null, day, startTime, duration, color, templateIndex, isPlaylist, false, false);
            createUpdateTimeLine(day, startTime, endTime, color, scheduleRender.timerIndex, type, '', '', templateId, null, true, sliderDuration);
        }
    }, 500);
    log.debug("COMPLETE", "createNewTimeBar");
}

/*******************************
change Template & PlayList color
*******************************/
function changeTemplateBGColor(color, templateId) {
    $("#Template_Area_Templates_Id > li.template_List_Cls").each(function() {
        if (templateId == getParseIntInDec($(this).attr("data-templateId"))) {
            $(this).attr('data-color', color);
            $(this).find('.text_Area_Cls').css({
                'background-color' : color
            });
            if (color == '') {
                $(this).find('.thumnail_Title_Text_Cls').css({
                    'color' : '#010101'
                });
                $(this).find(".text_Area_Cls > #sortCopyIconId").addClass("sort_Copy_Icon_Cls").removeClass("sort_Copy_Icon_Cls_Selected");
            } else {
                $(this).find('.thumnail_Title_Text_Cls').css({
                    'color' : '#ffffff'
                });
                $(this).find(".text_Area_Cls #sortCopyIconId").addClass("sort_Copy_Icon_Cls_Selected").removeClass("sort_Copy_Icon_Cls");
            }
        }

    });
}

function changePlaylistBGColor(color, playlist, bgDelFlag) {
    $("#Template_Area_Templates_Id > li.playListCls").each(function() {
        if (playlist == $(this).attr("data-text")) {
            $(this).attr('data-color', color);
            $(this).find('.text_Area_Cls').css({
                'background-color' : color
            });
            if (color == '') {
                $(this).find('.thumnail_Title_Text_Cls').css({
                    'color' : '#010101'
                });

            } else {
                $(this).find('.thumnail_Title_Text_Cls').css({
                    'color' : '#ffffff'
                });
            }
            
            if(bgDelFlag==true){
                var tempOrientationType = $('.templateAreaTemplatesCls > li:last').data('orientation');
                var playListImg = "../resource/img/ss_default_playlist.png";
                addUpperImg($(this));
                
                if (tempOrientationType == 'portrait') {
                    if (!($(this).find('div.thumbnailAreaCls').hasClass('emptyImgSize-portrait'))) {
                       $(this).find('div.thumbnailAreaCls').removeClass('emptyImgSize').addClass('emptyImgSize-portrait');
                    }
                } else {
                    if (!($(this).find('div.thumbnailAreaCls').hasClass('emptyImgSize'))) {
                       $(this).find('div.thumbnailAreaCls').removeClass('emptyImgSize-portrait').addClass('emptyImgSize');
                    }
                }
         
                $(this).find('div.thumbnailAreaCls').css({
                    'backgroundImage' : 'url("' + playListImg + '")'
                });
            }
        }
    });
}
/*
function highlightTemplate(templateId) {
    $("#templateAreaTemplatesId > li.templateListCls").each(function() {
        if (templateId == getParseIntInDec($(this).attr("data-templateId"))) {
            $("li").removeClass('templatePlaylist_container_Highlight');
            $(this).addClass('templatePlaylist_container_Highlight');
            $(this).insertBefore(".templateAreaTemplatesCls > li.templateListCls:eq(0)");
            calULHieght();
        }
    });
}

function highlightPlaylist(playlist) {
    $("#templateAreaTemplatesId > li.playListCls").each(function() {
        if (playlist == $(this).attr("data-text")) {
            $("li").removeClass('templatePlaylist_container_Highlight');
            $(this).addClass('templatePlaylist_container_Highlight');
            $(".templateAreaTemplatesCls").prepend($(this));
            calULHieght();
        }
    });
}*/

function getTimeSlider_Range(currObj, currsliderTop, currsliderBtm) {
    log.debug("START currObj=" + currObj + ":currsliderTop=" + currsliderTop, "getTimeSlider_Range");
    var activeObj = currObj;
    var containerHeight = activeObj.outerHeight();
    var containerWidth = activeObj.width();
    var containerOffset = activeObj.offset();
    var containerTopPosY = getParseIntInDec(containerOffset.top);
    var containerBtmPosY = containerTopPosY + containerHeight;
    var sliderTop = currsliderTop;
    var sliderBtm = currsliderBtm;
    var hh_interval = (containerHeight / 24);
    var mm_interval = (hh_interval / 60);
    var st_hh_time = Math.floor((sliderTop - containerTopPosY) / hh_interval);
    var st_mm_time = Math.round((((sliderTop - containerTopPosY) % hh_interval)) / (mm_interval));
    var end_hh_time = Math.floor((sliderBtm - containerTopPosY) / hh_interval);
    var end_mm_time = Math.round(((sliderBtm - containerTopPosY) % hh_interval) / mm_interval);
    st_mm_time = Math.round(getParseIntInDec(st_mm_time) / 10) * 10;
    end_mm_time = Math.round(getParseIntInDec(end_mm_time) / 10) * 10;
    if (end_mm_time < 0 || st_mm_time < 0) {

        end_mm_time = 0;
        st_mm_time = 0;
    }
    if (end_mm_time == 60) {
        end_hh_time = end_hh_time + 1;
        end_mm_time = 0;
    }
    if (st_mm_time == 60) {
        st_hh_time = st_hh_time + 1;
        st_mm_time = 0;
    }

    st_hh_time = (st_hh_time < 10 ? "0" : "") + st_hh_time;
    st_mm_time = (st_mm_time < 10 ? "0" : "") + st_mm_time;
    end_hh_time = (end_hh_time < 10 ? "0" : "") + end_hh_time;
    end_mm_time = (end_mm_time < 10 ? "0" : "") + end_mm_time;
    var startTime = st_hh_time + ":" + st_mm_time;
    var endTime = end_hh_time + ":" + end_mm_time;
    var range = startTime + "-" + endTime;
    log.debug("COMPLETE", "getTimeSlider_Range");
    return range;

}

function deActivateSlider() {
    log.debug("START", "deActivateSlider");
    deActivateTimer();
    log.debug("COMPLETE", "deActivateSlider");
}

function deActivateTimer() {
    log.debug("START", "deActivateTimer");
    var cntnAreaObj = $(".timelineSchTimerContainerCls").children().find(".ts_contentArea");
    cntnAreaObj.removeClass("ts_slider_container_highlight dragActive");
    cntnAreaObj.siblings(".ts_dragbtn").hide();
    cntnAreaObj.siblings(".ts_schcontrollerTimeCls").hide();
    cntnAreaObj.siblings(".ts_schcopydelbtnCls").hide();
    $(".ts_globalschcontrollerTimeCls").hide();
    $(".ts_contentArea").removeClass("ts_gstStartTimeDragCls ts_gstEndTimeDragCls");
    $("#ScheduleTimePicker").remove();
    log.debug("COMPLETE", "deActivateTimer");

}


/*Drag to schedule area from Template&PlayList area*/
function initDraggable() {
    log.debug("START", "initDraggable");
    $("#Template_Area_Templates_Id > li").draggable({
        helper : "clone",
        zIndex : 999999999,
        distance : 99999999999,
        scroll : false,
        cursorAt : {
            top : 50,
            left : 50
        },
        create : function(event, ui) {
            $(this).draggable("disable");
            $(this).removeClass("ui-state-disabled ui-draggable-disabled ");
        },
        start : function(event, ui) {
            var helperWidth = $(ui.helper).width();
            var width = helperWidth * 0.50;
            $(ui.helper).find(".thumnailTitleTextCls").css("font-size", "50%");
            $(ui.helper).css({
                "width" : width,
                "height" : width,
                "z-index" : "999999999",
                "-webkit-transform" : "rotate(-15deg)",
                "box-shadow" : "6px 6px 3px 0px rgba(0,0,0,0.2)",
            });
            scheduleRender.istimeBar = "false";
        },
        stop : function(event, ui) {
            $(this).draggable("disable");
            $(this).removeClass("ui-state-disabled ui-draggable-disabled ");
        },
        revert : function(event, ui) {
            $(".timerContainerCls").droppable("enable");
            refreshScreen();
            initDraggable();
        }
    });
    $('#Template_Area_Templates_Id > li').on("taphold", function(e) {
        $(this).draggable("enable");
        $(this).draggable("option", "distance", 10);
        $(this).trigger(touchEvent);

    });
    
    $('#Template_Area_Templates_Id > li').on("touchstart", function(e) {

        $(this).css({
            'border-color' : "1px solid red"
        });
        touchEvent = e;
    });
    log.debug("COMPLETE", "initDraggable");
}
function renderPlayList() {
    log.debug("START", "renderPlayList");
    var durationColor = "#f39c11";
    var noOfTemplates = playListObj.CustomPlaylist[0].CustomContent.length;
    var templateList = "";
    currOrient = $('.Template_Area_Templates_Cls > li:last').data('orientation');
    if (noOfTemplates == 0) {
        $(".empty_PlayList_Txt").css("display", "-webkit-box");
    } else {
        $(".empty_PlayList_Txt").css("display", "none");
        var cstmCntnObj = null;
        var defaultDurationMin = 0, defaultDurationSec = 0;
        var genTemplateList = "";
        for (var index = 0; index < noOfTemplates; index++) {
            cstmCntnObj = playListObj.CustomPlaylist[0].CustomContent[index];
            defaultDurationMin = calDefaultDurationMin(cstmCntnObj.Duration);
            defaultDurationSec = calDefaultDurationSec(cstmCntnObj.Duration);
            genTemplateList = generateTemplateListForPlayList(durationColor, cstmCntnObj.Path, cstmCntnObj.Name, cstmCntnObj.TemplateId, defaultDurationMin, defaultDurationSec);
            templateList += genTemplateList;
        }
        addTmpltToPlayLst(templateList);
    }
    log.debug("COMPLETE", "renderPlayList");
}

function reOrder(startIndex, endIndex) {
    log.debug("START startIndex=" + startIndex + ":endIndex=" + endIndex, "renderPlayList");
    var customPlaylist = playListObj.CustomPlaylist[0];
    var playListCount =customPlaylist.CustomContent.length;
    customPlaylist.CustomContent.push(customPlaylist.CustomContent[startIndex]);
    var noOfShiftings = (endIndex > startIndex) ? (endIndex - startIndex) : (startIndex - endIndex);
    for (var index = 0; index < noOfShiftings; index++) {
        if (endIndex > startIndex) {
            customPlaylist.CustomContent[startIndex] = customPlaylist.CustomContent[++startIndex];
        } else {
            customPlaylist.CustomContent[startIndex] = customPlaylist.CustomContent[--startIndex];
        }
    }
    customPlaylist.CustomContent[startIndex] = customPlaylist.CustomContent[playListCount];
    customPlaylist.CustomContent.pop();
    savePlaylistContent();
    log.debug("COMPLETE", "renderPlayList");
}
function generateTemplateListForPlayList(durationColor, imagePath, templateName, templateId, defaultDurationMin, defaultDurationSec) {
    log.debug("START", "generateTemplateListForPlayList");
    durationColor = "#ffffff";
    var genTemplateList = "";
    var tempTimestamp = new Date().getTime();
    var orientationType=window.sessionStorage.getItem("orientationType");
    var thumbOrientationClass = "";
    var orientationClass = "";
    if( orientationType == '9999' )
    {
        orientationClass = 'thumbnain_And_Text_Area_PlayList_Cls-portrait';
    }

    
    templateName = templateName.replace(".LFD", "");
    
    imagePath = imagePath+'.PNG' + '?tempTimestamp=' + tempTimestamp;

    genTemplateList='<li class="playList_Li_Cls" data-text="' + templateName + '">'+ 
                        '<div class="thumbnain_And_Text_Area_PlayList_Cls ' + orientationClass + '" >' + 
                            '<div class="thumbnail_Area_Cls " style="background-image:url(\'' + imagePath + '\');opacity:0;"></div>' + 
                            '<div class="text_Area_Cls " style="background-color: white;">' +
                                '<div class="thumbnail_Title_Cls">' + 
                                    '<div class="thumnail_Title_Text_Cls textEllipsis" style="width:100%">' + templateName +
                                    '</div>' +
                                '</div>' + 
                            '</div>' + 
                        '</div>' +
                        '<div class="duration_Area_Cls">' +
                            '<div class="min_sec_Container_Cls"> ' +
                                '<div id="template_min_Id" class="template_min_sec_Cls">' + langObj.template.COM_TV_SID_MIN + '</div> ' +
                                '<div id="template_sec_Id" class="template_min_sec_Cls">' + langObj.Schedule.COM_SID_SEC + '</div> ' +
                            '</div>' +
                            '<div class="Num_Container_Cls">' +
                                '<div id="template_min_Num_Id" class="template_Num_Cls">' + defaultDurationMin + '</div>' +
                                '<div id="template_semicolon_Id"> : </div> ' +
                                '<div id="template_sec_Num_Id" class="template_Num_Cls">' + defaultDurationSec + '</div>' +
                            '</div>' +
                        '</div>' +
                        '<div class="template_Delete_Icon_Cls"> </div>' +
                    '</li>';

    return genTemplateList;

}

function generateTemplate(orientationType, templateName, templateThumbPath, templateThumbPathBackground, color, i, templatePath, categoryName, templateId, playlistCheck) {
    var genTemplateList = "";
    var orientationClass = "";
    var thumbOrientationClass = "";
    templateName = templateName.replace(".LFD", "");
    if (orientationType == 'portrait') {
        orientationClass = "portrait_Tpl";
        thumbOrientationClass = "thumbnail_Portrait";
    }
    genTemplateList='<li  data-type="template" data-orientation="' + orientationType + '"data-text="' + templateName + '" data-image="' + templateThumbPath + '" data-color="' + color + '" data-index="' + i + ' " data-templatePath="' + templatePath + ' " data-categoryName="' + categoryName + ' " data-templateId="' + templateId + ' "  class="template_List_Cls">' + 
                        '<div class="thumbnain_And_Text_Area_Cls">' + 
                            '<div class="thumbnail_Area_Cls ' + thumbOrientationClass + '" style="background-image:url(\'' + templateThumbPathBackground + '\');opacity:0;"></div>' + 
                            '<div class="text_Area_Cls ' + orientationClass + '" style="background-color:' + color + ';">' +
                                '<div class="thumbnail_Title_Cls">' + 
                                    '<div class="thumnail_Title_Text_Cls textEllipsis" style="width:100%">' + templateName +
                                    '</div>' +
                                '</div>' + 
                            '</div>' + 
                        '</div>' +
                    '</li>';
    
    return genTemplateList;
}

function generatePlayList(playListName, playListImg, color, playlistIndex, tempOrientationType) {
    var genPlayList = "";
    var orientationClass = "";
    var thumbOrientationClass = "";
    var copyDeleteBoxOrientationClass = "";
    var copyTextIconOrientationClass = "";
    var copyTextOrientationClass = "";
    var delTextIconOrientationClass = "";
    var deleteTextOrientationClass = "";
    var orientation = tempOrientationType.replace(' class=','');
    
    if (orientation == 'portrait') {
        orientationClass = "portrait_Tpl";
        thumbOrientationClass = "thumbnail_Portrait";
        copyDeleteBoxOrientationClass = "copy_Delete_Box_Area_Cls-portrait";
        copyTextIconOrientationClass = "copy_Text_Icon_Area_Cls-portrait";
        copyTextOrientationClass = "copyText-portrait";
        delTextIconOrientationClass = "del_Text_Icon_Area_Cls-portrait";
        deleteTextOrientationClass = "deleteText-portrait";
    }

    genPlayList='<li data-type="playlist" data-orientation="' + tempOrientationType + '" data-color="' + color + '" data-text="' + playListName + '" data-index="' + playlistIndex + '" class="playListCls">' + 
                    '<div class="thumbnain_And_Text_Area_Cls">' + 
                        '<div class="copy_Delete_Box_Area_Cls ' + copyDeleteBoxOrientationClass + '">' + 
                            '<div class="copy_Box_Area_Cls">' + 
                                '<div class="copy_Text_Icon_Area_Cls ' + copyTextIconOrientationClass + '">' + 
                                    '<div class="copy_Icon_Container_Cls">' + 
                                        '<div class="copy_Icon_Cls">' + 
                                        '</div>' + 
                                    '</div>' + 
                                    '<div class="copy_Text_Cls ' + copyTextOrientationClass + '">' + langObj.QuickStart.COM_IDS_EDIT_COPY + 
                                    '</div>' + 
                                '</div>' + 
                            '</div>' + 
                            '<div class="del_Box_Area_Cls">' + 
                                '<div class="del_Text_Icon_Area_Cls ' + delTextIconOrientationClass + '">' +
                                    '<div class="del_Icon_Container_Cls">' + 
                                        '<div class="del_Icon_Cls">' + 
                                        '</div>' + 
                                    '</div>' + 
                                    '<div class="delete_Text_Cls ' + deleteTextOrientationClass + '">' + langObj.QuickStart.IDS_BTN_DELETE + 
                                    '</div>' + 
                                '</div>' + 
                            '</div>' + 
                        '</div>' + 
                        '<div class="thumbnail_Area_Cls ' + thumbOrientationClass + '" style="background-image:url(\'' + playListImg + '\');"></div>' +
                        '<div class="text_Area_Cls ' + orientationClass + '"style="background-color:' + color + ';">' + 
                            '<div class="thumbnail_Title_Cls">' + 
                                '<div class="thumnail_Title_Text_Cls textEllipsis">' + playListName + 
                                '</div>' + 
                            '</div>' + 
                            '<div id="sortPlaylistCopyIconId" class="sortCopyIconDragCls sort_Copy_Icon_Cls">' + 
                            '</div>' + 
                        '</div>' + 
                    '</div>' + 
                '</li>';

    return genPlayList;
}
function emptySchErrorPopUp() {
    genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1");
    genericPopUpObj.appendHTMLData([langObj.Schedule.MIA_SID_EMPTY_SCHEDULE_NOT_SENT +langObj.Schedule.MIA_SID_QUIT_EDITING_RETURN_HOME]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Schedule.COM_TV_SID_NO,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : langObj.Schedule.COM_TV_SID_YES,
        "callback" : function() {

            document.location.href = '../quickstart/QuickStart.html';
        }
    }]);
    genericPopUpObj.showPopUp();
}

function setTemplateURL() {
    var urlStr = '';
    var templateInfo = ScheduleUtils.getLFDInfo();
    var templatePath = templateInfo.myTemplateInfoArrs[0].tempPath;
    var orientation = templateInfo.myTemplateInfoArrs[0].orientationType;
    urlStr = "../template/template.html?category=" + scheduleRender.templateCatogerySch + "&orientation=" + orientation + "&templatePath=" + templatePath;
    return urlStr;
}

function onBackkeyDown() {
    log.debug("START", "onBackkeyDown");
    
    var urlStr = '';
    /* coach mark is opened*/
    var el = document.getElementById("_coachmarkpopUpId");
    if (el != null && el.style.display == "block") {
        closeCoachmarkGenericPopUp();
        return;
    }
    /* When time bar is selected*/
    if(checkTimebar == 1)
    {
        $('.timerContainerCls').tap();
        checkTimebar=0;
        return;
    }
    /* TimePicker , Template&PlayList is opened*/
    if( $('#TimePicker').css('display') == 'block' ) 
    {
        $('.buttonClsTi').touchstart();
        closeTimePicker();
        return;
    }else if ( $('.Template_Area_Cls').css('display') == 'block' )
    {
        hideTemplatePlayListMenu();
        return;
    }
    
    /* Create & edit PlayList screen is opened*/
    if( $('#Create_Playlist_Area_Id').css('display') == 'block' )
    {
        $('#Create_Playlist_Done_Btn_Id').tap();
        return;
    }
    
    backpressed = true;
    
    if (scheduleRender.navigateFromTemplate == 'true') {
        tempUrl = setTemplateURL();
    } else {
        tempUrl = '../quickstart/QuickStart.html';
    }
    var timebarLength = $(".ts_slider_containerCls").length;

    if ($('#renamePrjPopUp').is(':visible')) {
        $("#renamePrjPopUp").hide();
    } else if (genericPopUpObj.isPopUpVisible()) {
        genericPopUpObj.hidePopUp();
    } else if (scheduleRender.isSavedSch == "true" && !(timebarLength == 0 || $(".ts_disabled").length == timebarLength)) {
        navigateFromSchedule(tempUrl);
    } else {
        document.location.href = tempUrl;
    }
    log.debug("COMPLETE", "onBackkeyDown");
}

function copyTimebar(container, event, obj, orginalSliderHeight) {
    log.debug("START container=" + container + ":event=" + event + ":obj=" + obj + ":orginalSliderHeight=" + orginalSliderHeight, "copyTimebar");
    bTSMoveAllowed = true;
    var slider = obj.attr("id");
    var type = obj.attr("data-type");
    var color = obj.attr("data-color");
    var frameIndex = obj.attr("data-frameIndex");
    var templateId = getParseIntInDec(obj.attr("data-templateId"));
    var playlistName = obj.attr("data-playlist");
    var timeduration = obj.attr("data-duration");  
    var sliderTopPosY = getParseIntInDec(event.clientY);
    var sliderHeight = 0;
    if (orginalSliderHeight != 0) {
        sliderHeight = orginalSliderHeight;
    } else {
        sliderHeight = getParseIntInDec(obj.outerHeight());
    }

    var sliderBtmPosY = sliderTopPosY + sliderHeight;
    var curr = container;
    var droppedContainer = curr.attr("id");
    var containerday = droppedContainer.split("_");
    var day = containerday[1];
    var range = getTimeSlider_Range(curr, sliderTopPosY, sliderBtmPosY);
    var timeRange = range.split("-");
    var startTime = timeRange[0];
    var endTime = getEndTime(startTime, timeduration);
    var duration;
    var sch_endTime = endTime.split(":");
    var hh_endTime = sch_endTime[0];
    var mm_endTime = sch_endTime[1];
    var islooped = getParseIntInDec(hh_endTime) > getParseIntInDec(24) || (getParseIntInDec(hh_endTime) == 24 && getParseIntInDec(mm_endTime) > 0) ? "true" : "false";
    var newEndTime = ScheduleUtils.getDuration("24:00", endTime);
    var loopedDay = ScheduleUtils.getNextDay(day);
    var isPlaylist = type == 'template' ? false : true;
    var sliderduration = ScheduleUtils.getDuration(startTime, "24:00");
    var linkduration = ScheduleUtils.getDuration("00:00", newEndTime);
    var totalduration = getEndTime(sliderduration, linkduration);
	if (isPlaylist) {		
		scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + playlistName + "/" + playlistName + ".xml";
		scheduleRender.isPlayList = true;
		scheduleRender.isPlaylistAdded = true;
		scheduleRender.isDraggablePlaylist = false;
		scheduleRender.loadPlayListData().done(function(){
			createFrameData();
		});
	}else{
		createFrameData();
	}
	function createFrameData(){
    if (islooped == "true") {
        duration = ScheduleUtils.getDurationInSeconds("24:00") - ScheduleUtils.getDurationInSeconds(startTime);
        createFrameSchedule(null, day, startTime, duration, color, frameIndex, isPlaylist, false, true, loopedDay, (1));
        createUpdateTimeLine(day, startTime, "24:00", color, scheduleRender.timerIndex, type, (scheduleRender.timerIndex + 1), loopedDay, templateId, playlistName, true, totalduration);
        duration = ScheduleUtils.getDurationInSeconds(newEndTime) - ScheduleUtils.getDurationInSeconds("00:00");
        createFrameSchedule(null, loopedDay, "00:00", duration, color, frameIndex, isPlaylist, false, true, day, ( -1));
        createUpdateTimeLine(loopedDay, "00:00", newEndTime, color, scheduleRender.timerIndex, type, (scheduleRender.timerIndex - 1), day, templateId, playlistName, true, totalduration);
    } else {
        duration = ScheduleUtils.getDurationInSeconds(endTime) - ScheduleUtils.getDurationInSeconds(startTime);
        createFrameSchedule(null, day, startTime, duration, color, frameIndex, isPlaylist, false, true, '', '');
        createUpdateTimeLine(day, startTime, endTime, color, scheduleRender.timerIndex, type, '', '', templateId, playlistName, true, timeduration);
		}
    }
    log.debug("COMPLETE", "copyTimebar");
}

function deletePlayListPopUp(currentObj) {
    log.debug("START", "deletePlayListPopUp");
    genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1","DeletePlayList");
    genericPopUpObj.appendHTMLData([langObj.Schedule.MIA_SID_SCHEDULE_USING_PLAYLIST_CONTINUE + '<br>' + currentObj.parent().parent().parent().attr("data-text") ]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Schedule.COM_TV_SID_NO,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : langObj.Schedule.COM_TV_SID_YES,
        "callback" : function() {
            var playListName = currentObj.parent().parent().parent().attr("data-text");
            scheduleRender.isPlaylistdeleted = true;
            createEditSchedule(false, playListName, null, null, null);
            var index = fetchPlaylistIndex(playListName);
            SchPar.playListArray.splice(index, 1);
            if (SchPar.playListArray.length == 0) {
                scheduleRender.globalCounter = 0;
            }
           
            currentObj.parent().parent().parent().remove();
            calULHieght();

        }
    }]);
    genericPopUpObj.showPopUp();
    log.debug("COMPLETE", "deletePlayListPopUp");
}


function deleteTemplateInPlayListPopUp(currentObj) {
    log.debug("START", "deleteTemplateInPlayListPopUp");
    genericPopUpObj.createPopUp(langObj.Schedule.IDS_BTN_DELETE, "Type1","DeletePlayList");
    genericPopUpObj.appendHTMLData([langObj.Schedule.MIA_SID_SCHEDULE_USING_PLAYLIST_CONTINUE + '<br>' + currentObj.attr('data-text')]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Schedule.COM_TV_SID_NO,
        "callback" : "closeGenericPopUp"
    }, {
        "btntxt" : langObj.Schedule.COM_TV_SID_YES,
        "callback" : function() {
            currentObj.remove();
            $(".empty_PlayList_Txt").css("display", "-webkit-box");
            updatePlayListImage();
            $('#Content_number').text("0 / 99");
        }
    }]);
    genericPopUpObj.showPopUp();
    log.debug("COMPLETE", "deletePlayListPopUp");
}

function fetchPlaylistIndex(playListName) {
    var playListArrLen = SchPar.playListArray.length;
    for (var j = 0; j < playListArrLen; j++) {
        if (playListName == SchPar.playListArray[j].value) {
            return j;
        }
    }
    return -1;
}

function deleteFrameScheduleIndex(frameSchIndex, playlistName, isPlaylist) {
    log.debug("START frameSchIndex=" + frameSchIndex + ":playlistName=" + playlistName + ":isPlaylist=" + isPlaylist, "deleteFrameScheduleIndex");
    $(".timelineSchTimerContainerCls").find("#ts_slider_container_" + frameSchIndex).remove();
    if (($.inArray(getParseIntInDec(frameSchIndex), scheduleRender.tempdeletedArray) < 0)) {
        scheduleRender.tempdeletedArray.push(getParseIntInDec(frameSchIndex));
    }
    if (isPlaylist && ($.inArray(playlistName, scheduleRender.arrayOfremovedPlayList) < 0)) {
        scheduleRender.arrayOfremovedPlayList.push(playlistName);
    }
    scheduleRender.isSavedSch = "true";
    var timebarLength = $(".ts_slider_containerCls").length;
    if (timebarLength == 0 || $(".ts_disabled").length == $(".ts_slider_containerCls").length) {
        $("#sch_nxtBtnId").addClass("btn_disabledCls");
        if ($('#saveBtn').hasClass('save-selected')) {
            $('.saveOnlyAndSaveAs').hide();
            $('.saveSaveAsTxt').hide();
            $('#saveBtn').removeClass('save-selected');
        } else {
        }
        $('div#landScape_Div_Id').removeClass("icon-disabled");
    }
    log.debug("COMPLETE", "deleteFrameScheduleIndex");
}

function fetchFolderID(frameSchIndex, PlaylisIndex, templateName) {
    var folderID = null;
    var contentObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[frameSchIndex].Playlist[PlaylisIndex].Content;
    var contentObjLen = contentObj.length;
    for (var contIndex = 0; contIndex < contentObjLen; contIndex++) {
        if (contentObj[contIndex].File.length != 0) {
            if (contentObj[contIndex].File[0].Name == templateName) {
                folderID = contentObj[contIndex].File[0].Id;
                return folderID;
            }
        }
    }

    return folderID;
}

function updatePlayListImage() {
    var tempOrientationType = $('.Template_Area_Templates_Cls > li:last').data('orientation');    
    addUpperImg($('.Template_Area_Templates_Cls').find('li.template_container_Highlight'));
    
    $('.Template_Area_Templates_Cls > li.template_container_Highlight').find('div.thumbnail_Area_Cls').addClass('empty_ImgSize');
    
    var playListImg;
    if ( $('.Create_Playlist_List_Cls li').length == 0) {
        playListImg = "../resource/img/ss_default_playlist.png";
        $('.Template_Area_Templates_Cls > li.template_container_Highlight').find('.thumbnail_Area_Cls').removeClass('thumbnail_Area_Cls_notDefault');
    } else {
        var $thisBgImageObj = $('.Create_Playlist_List_Cls > li:first').find('.thumbnail_Area_Cls');
        var bgImage = $thisBgImageObj.css('background-image');
        playListImg = bgImage.replace('url(','').replace(')','');
        $('.Template_Area_Templates_Cls > li.template_container_Highlight').find('.thumbnail_Area_Cls').addClass('thumbnail_Area_Cls_notDefault');
    }    
    if(playListImg.charAt(0)=="\"")
    {
        playListImg=playListImg.replace(/"/ig,"");
    }
    var thumbObj=$('.Template_Area_Templates_Cls > li.template_container_Highlight').find('.thumbnail_Area_Cls');
    $("<img src='"+playListImg+"'>").load(function(){
          thumbObj.css({'background-image' : 'url("' + playListImg + '")'});
    }).error(function(){
        /*High Quality thumbnail does not exist. Load Low quality thumbnail.*/
        playListImg = playListImg.replace('.PNG.PNG?','.PNG?');
        thumbObj.css({'background-image' : 'url("' + playListImg + '")'});

    });
    /*$('.Template_Area_Templates_Cls > li.template_container_Highlight').find('.thumbnail_Area_Cls').css({
        'background-image' : 'url("' + playListImg + '")'
    });*/

    $('#Create_Playlist_Done_Btn_Id').removeClass('Create_Playlist_Done_Btn_NOT');    
}

function closePlayList() {
    $("#ScheduleTimePicker").remove();
    $("#timePickerContainer").remove();
    $(".templatePlaylistCls").hide();
    $("#recycleDivId").hide();

    $('.templateAreaTemplatesCls').find('li.template_container_Highlight').removeClass('template_container_Highlight');
}

function validatedPlaylist() {
    if (scheduleRender.isPlaylistAdded && playListObj.CustomPlaylist[0].CustomContent.length == 0) {
        draggedPlayListOKPopUp(scheduleRender.emptyPlaylistMessage);
        scheduleRender.isPlaylistAdded = false;
    }
}

/*Reset the layout for each orientation.*/

function calULHieght() {
    
    log.debug("START", "calULHieght");
    
    var tempOrientationType = $('.Template_Area_Templates_Cls > li:first').data('orientation');
    tempOrientationType = tempOrientationType.replace(' class=','');

    var bottomHeight = parseFloat($('.Template_Area_Templates_Cls > li').css('margin-bottom'));
    var liheight, liwidth;
    if (tempOrientationType == 'portrait' ) 
    {
        liheight = $("#Templates_List_Area_Id").height() * 0.77;
        liwidth =  $("#Templates_List_Area_Id").width() * 0.29;
    } 
    else 
    {    
        liheight = $("#Templates_List_Area_Id").height() * 0.76;
        liwidth =  $("#Templates_List_Area_Id").width() * 0.44;
    }
    
    $(".Template_Area_Templates_Cls>li").height(liheight);
    $(".Template_Area_Templates_Cls>li").width(liwidth);
    $(".Add_To_Playlist_List_Cls>li").height(liheight);
    $(".Add_To_Playlist_List_Cls>li").width(liwidth);
    
    log.debug("COMPLETE", "calULHieght"); 
}

function draggedPlayListOKPopUp(playlistMessage) {
    genericPopUpObj.createPopUp("", "Type1");
    genericPopUpObj.appendHTMLData([playlistMessage]);
    genericPopUpObj.addFooterBtns([{
        "btntxt" : langObj.Schedule.COM_SID_OK,
        "callback" : "closeGenericPopUp"
    }]);
    genericPopUpObj.showPopUp();
}

function replaceUrlFromPath(path) {
    var temp = path.replace('url(', '').replace(')', '');
    return temp;
}

function retrieveFileName(path) {
    var temp = path.substring(path.lastIndexOf('/') + 1);
    var tempTimestamp = new Date().getTime();
    return temp + '?tempTimestamp=' + tempTimestamp;
}

function removeWeekDay(day) {
    var index = getParseIntInDec($.inArray(day, scheduleRender.weekdaydeletedArray));
    scheduleRender.weekdaydeletedArray.splice(index, 1);
}

function calWidthWithScrollbar() {
    if ($('#templateAreaTemplatesId').hasScrollBar()) {
        $('.templateAreaContainerCls').addClass('templateAreaContainerScrollCls');
        $('.templateAreaTemplatesCls').addClass('templateAreaTemplatesScrollCls');
    } else {
        $('.templateAreaContainerCls').removeClass('templateAreaContainerScrollCls');
        $('.templateAreaTemplatesCls').removeClass('templateAreaTemplatesScrollCls');

    }
    refreshScreen();
}

/********** Time calculation **********/

function calDefaultDurationMin(defaultDuration) {
    var dafaultDurationMin = '';
    if (getParseIntInDec(defaultDuration) < 60 || defaultDuration == '') {
        dafaultDurationMin = "00";        
    } else {
        dafaultDurationMin = getParseIntInDec(getParseIntInDec(defaultDuration) / 60);
        if (dafaultDurationMin < 10) dafaultDurationMin = "0" + dafaultDurationMin;
    }
    return dafaultDurationMin;
}

function calDefaultDurationSec(defaultDuration) {
    var dafaultDurationSec = '';
    if (defaultDuration != '') {
        var dafaultDurationSec = getParseIntInDec(defaultDuration) % 60;
        if (dafaultDurationSec < 10) {
            dafaultDurationSec = "0" + dafaultDurationSec;
        }
    } else {
        dafaultDurationSec = '00';
    }
    return dafaultDurationSec;
}



function updateRecycleArea(iFlag) {
    if (iFlag) {

        $('#recycleDivId').addClass('recycleDivSelCls');
        $('#recycleDivId > div.recycleBinIcon').addClass('recycleBinIconSel').removeClass('recycleBinIcon');
        $('#recycleDivId').css({
            'background-color' : '#3196ff !important'
        });
        $('#recycleDivId > div.dropToDelText').show();
    } else {

        $('#recycleDivId').removeClass('recycleDivSelCls');
        $('#recycleDivId > div.recycleBinIconSel').addClass('recycleBinIcon').removeClass('recycleBinIconSel');
        $('#recycleDivId').css({
            'background-color' : '#ffffff'
        });
        $('#recycleDivId > div.dropToDelText').hide();
    }
}

function checkTimeBarLength(container) {
    log.debug("START", "checkTimeBarLength");
    var droppedContainer = container.attr("id");
    var containerday = droppedContainer.split("_");
    var day = containerday[1];
    var noOfdayTimeBar = $("#timer_" + day).find(".ts_slider_containerCls").length;
    var noOfWeekTimeBar = $(".timelineSchTimerContainerCls").find(".ts_slider_containerCls").length;
    var totalTimeBar = noOfWeekTimeBar;
    if (totalTimeBar < 28) {
        if (noOfdayTimeBar >= 9) {
            draggedPlayListOKPopUp(MIA_SID_MIX_CAN_ADD_UP_TO_KR_2.replace("<<A>>",9));
            return "false";
        } else {
            return "true";
        }

    } else {
        draggedPlayListOKPopUp(langObj.Schedule.MIA_SID_UP_TO_MIX_TEMPLATE_PLAYLIST);
        return "false";
    }
    log.debug("COMPLETE", "checkTimeBarLength");
}

function updateTime(index,currentTime) {
    
    var timeVal = currentTime.split(":");    
    var tempm = timeVal[0] + langObj.Schedule.COM_IDS_MIN;
    var temps = timeVal[1] + langObj.Schedule.MIA_SID_S_SECOND;
    
    currentTime = tempm + ":" + temps;
    
    timeVal[0]=getParseIntInDec(timeVal[0]);
    timeVal[1]=getParseIntInDec(timeVal[1]);
    
    if (timeVal[0] == 0 && timeVal[1] < 5) {
        timeVal[0]=0;
        timeVal[1]=5;
        currentTime = "00"+langObj.Schedule.COM_IDS_MIN+":05"+langObj.Schedule.MIA_SID_S_SECOND;

    }
    $('.activeTimeSpinner').val(currentTime);
    var duration = timeVal[0] * 60 + timeVal[1];
    /*To save playlist and schedule object*/
    playListObj.CustomPlaylist[0].CustomContent[index].Duration = duration;
    savePlaylistContent();

}

function registerEvents_MStimer(index) {
    log.debug("START", "registerEvents_MStimer");
    var el1 = $("#m_minuteSpin");

    var initialY1;
    el1[0].addEventListener("touchstart", function(event) {
        event.preventDefault();
        initialY1 = event.targetTouches[0].pageY;
    }, false);

    el1[0].addEventListener("touchmove", function(event) {
        if (event.targetTouches[0].pageY > initialY1 + 30) {
            initialY1 = event.targetTouches[0].pageY;
            if (getParseIntInDec($("#m_minuteZero").text()) > 0) {
                var newValue = getParseIntInDec($("#m_minuteZero").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteZero").text(newValue);
            } else if (getParseIntInDec($("#m_minuteZero").text()) == 0) {
                $("#m_minuteZero").text("99");
            }
            if (getParseIntInDec($("#m_minuteOne").text()) > 0) {
                var newValue = getParseIntInDec($("#m_minuteOne").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteOne").text(newValue);
            } else if (getParseIntInDec($("#m_minuteOne").text()) == 0) {
                $("#m_minuteOne").text("99");
            }
            if (getParseIntInDec($("#m_minuteTwo").text()) > 0) {
                var newValue = getParseIntInDec($("#m_minuteTwo").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteTwo").text(newValue);
                currentTime = newValue + ":" + $("#secondTwo").text();
                updateTime(index);
            } else if (getParseIntInDec($("#m_minuteTwo").text()) == 0) {
                $("#m_minuteTwo").text("99");
                currentTime = "99" + ":" + $("#secondTwo").text();
                updateTime(index);
            }
            if (getParseIntInDec($("#m_minuteThree").text()) > 0) {
                var newValue = getParseIntInDec($("#m_minuteThree").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteThree").text(newValue);
            } else if (getParseIntInDec($("#m_minuteThree").text()) == 0) {
                $("#m_minuteThree").text("99");
            }
            if (getParseIntInDec($("#m_minuteFour").text()) > 0) {
                var newValue = getParseIntInDec($("#m_minuteFour").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteFour").text(newValue);
            } else if (getParseIntInDec($("#m_minuteFour").text()) == 0) {
                $("#m_minuteFour").text("99");
            }
        }
        if (event.targetTouches[0].pageY < initialY1 - 30) {
            initialY1 = event.targetTouches[0].pageY;
            if (getParseIntInDec($("#m_minuteZero").text()) < 99) {
                var newValue = getParseIntInDec($("#m_minuteZero").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteZero").text(newValue);
            } else if (getParseIntInDec($("#m_minuteZero").text()) == 99) {
                $("#m_minuteZero").text("00");
            }
            if (getParseIntInDec($("#m_minuteOne").text()) < 99) {
                var newValue = getParseIntInDec($("#m_minuteOne").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteOne").text(newValue);
            } else if (getParseIntInDec($("#m_minuteOne").text()) == 99) {
                $("#m_minuteOne").text("00");
            }
            if (getParseIntInDec($("#m_minuteTwo").text()) < 99) {
                var newValue = getParseIntInDec($("#m_minuteTwo").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteTwo").text(newValue);
                currentTime = newValue + ":" + $("#secondTwo").text();
                updateTime(index);
            } else if (getParseIntInDec($("#m_minuteTwo").text()) == 99) {
                $("#m_minuteTwo").text("00");
                currentTime = "00" + ":" + $("#secondTwo").text();
                updateTime(index);
            }
            if (getParseIntInDec($("#m_minuteThree").text()) < 99) {
                var newValue = getParseIntInDec($("#m_minuteThree").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteThree").text(newValue);
            } else if (getParseIntInDec($("#m_minuteThree").text()) == 99) {
                $("#m_minuteThree").text("00");
            }
            if (getParseIntInDec($("#m_minuteFour").text()) < 99) {
                var newValue = getParseIntInDec($("#m_minuteFour").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#m_minuteFour").text(newValue);
            } else if (getParseIntInDec($("#m_minuteFour").text()) == 99) {
                $("#m_minuteFour").text("00");
            }

        }
    }, false);
    var el = $("#secondSpin");

    var initialY1;
    el[0].addEventListener("touchstart", function(event) {
        event.preventDefault();
        initialY1 = event.targetTouches[0].pageY;
    }, false);

    el[0].addEventListener("touchmove", function(event) {
        if (event.targetTouches[0].pageY > initialY1 + 30) {
            initialY1 = event.targetTouches[0].pageY;
            if (getParseIntInDec($("#secondZero").text()) > 0) {
                var newValue = getParseIntInDec($("#secondZero").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondZero").text(newValue);
            } else if (getParseIntInDec($("#secondZero").text()) == 0) {
                $("#secondZero").text("59");
            }
            if (getParseIntInDec($("#secondOne").text()) > 0) {
                var newValue = getParseIntInDec($("#secondOne").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondOne").text(newValue);
            } else if (getParseIntInDec($("#secondOne").text()) == 0) {
                $("#secondOne").text("59");
            }
            if (getParseIntInDec($("#secondTwo").text()) > 0) {
                var newValue = getParseIntInDec($("#secondTwo").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondTwo").text(newValue);
                currentTime = $("#m_minuteTwo").text() + ":" + newValue;
                updateTime(index);
            } else if (getParseIntInDec($("#secondTwo").text()) == 0) {
                $("#secondTwo").text("59");
                currentTime = $("#m_minuteTwo").text() + ":" + "59";
                updateTime(index);
            }
            if (getParseIntInDec($("#secondThree").text()) > 0) {
                var newValue = getParseIntInDec($("#secondThree").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondThree").text(newValue);
            } else if (getParseIntInDec($("#secondThree").text()) == 0) {
                $("#secondThree").text("59");
            }
            if (getParseIntInDec($("#secondFour").text()) > 0) {
                var newValue = getParseIntInDec($("#secondFour").text()) - 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondFour").text(newValue);
            } else if (getParseIntInDec($("#secondFour").text()) == 0) {
                $("#secondFour").text("59");
            }
        }
        if (event.targetTouches[0].pageY < initialY1 - 30) {
            initialY1 = event.targetTouches[0].pageY;
            if (getParseIntInDec($("#secondZero").text()) < 59) {
                var newValue = getParseIntInDec($("#secondZero").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondZero").text(newValue);
            } else if (getParseIntInDec($("#secondZero").text()) == 59) {
                $("#secondZero").text("00");
            }
            if (getParseIntInDec($("#secondOne").text()) < 59) {
                var newValue = getParseIntInDec($("#secondOne").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondOne").text(newValue);
            } else if (getParseIntInDec($("#secondOne").text()) == 59) {
                $("#secondOne").text("00");
            }
            if (getParseIntInDec($("#secondTwo").text()) < 59) {
                var newValue = getParseIntInDec($("#secondTwo").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondTwo").text(newValue);
                currentTime = $("#m_minuteTwo").text() + ":" + newValue;
                updateTime(index);
            } else if (getParseIntInDec($("#secondTwo").text()) == 59) {
                $("#secondTwo").text("00");
                currentTime = $("#m_minuteTwo").text() + ":" + "00";
                updateTime(index);
            }
            if (getParseIntInDec($("#secondThree").text()) < 59) {
                var newValue = getParseIntInDec($("#secondThree").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondThree").text(newValue);
            } else if (getParseIntInDec($("#secondThree").text()) == 59) {
                $("#secondThree").text("00");
            }
            if (getParseIntInDec($("#secondFour").text()) < 59) {
                var newValue = getParseIntInDec($("#secondFour").text()) + 1;
                if (newValue < 10) {
                    newValue = "0" + newValue;
                }
                $("#secondFour").text(newValue);
            } else if (getParseIntInDec($("#secondFour").text()) == 59) {
                $("#secondFour").text("00");
            }

        }
    }, false);

    log.debug("COMPLETE", "registerEvents_MStimer");

}

/**********************
Playlist upper img add
**********************/

function addUpperImg($li) {
    $li.find('.upperImg_Cls').remove();
    $li.find('div.thumbnail_Area_Cls').addClass('playlist_Active');
    
    $li.prepend('<div class="upperImg_Cls"></div>');
}
function disableTimeBar($this) {
    deActivateSlider();
    $("#timer_" + $this).find(".ts_slider_containerCls").each(function() {

        $(this).addClass("ts_disabled");
        if ($(this).attr("data-link") != "") {
            var link = $(this).attr("data-link");
            var linkday = $(this).attr("data-linkday");
            $("#timer_" + linkday).find("#ts_slider_container_" + link).addClass("ts_disabled");
            scheduleRender.tempdeletedArray.push(getParseIntInDec(link));
        }

    });

}

function enableTimeBar($this) {
    $("#timer_" + $this).find(".ts_slider_containerCls ").each(function() {
        if ($(this).hasClass("ts_disabled")) {
            $(this).removeClass("ts_disabled");
            var index = $(this).attr("data-frameIndex");
            $("#timertext_" + $this).addClass("timerTextClsActive");
            scheduleRender.tempdeletedArray.splice(getParseIntInDec(index));
            if ($(this).attr("data-link") != "") {
                var linkIndex = $(this).attr("data-link");
                var linkday = $(this).attr("data-linkday");
                $("#timertext_" + linkday).addClass("timerTextClsActive");
                $("#timer_" + linkday).find("#ts_slider_container_" + linkIndex).removeClass("ts_disabled");
                scheduleRender.tempdeletedArray.splice(getParseIntInDec(linkIndex));
                removeWeekDay(linkday);
            }
        }
    });
    removeWeekDay($this);
}

function hideSaveAndSaveAsBtn() {
    if ($('#saveBtn').hasClass('save-selected')) {
        $('.saveOnlyAndSaveAs').hide();
        $('.saveSaveAsTxt').hide();
        $('#saveBtn').removeClass('save-selected');
    }
}
function getEndTime(startTime, duration) {

    var t1 = startTime.split(":");
    var t2 = duration.split(":");
    if (getParseIntInDec(t2[0]) >= 24) {
        t2[0] = 24;
        t2[1] = 0;
    }
    var hh = getParseIntInDec(t1[0]) + getParseIntInDec(t2[0]);
    var mm = getParseIntInDec(t1[1]) + getParseIntInDec(t2[1]);
    mm = Math.round(getParseIntInDec(mm) / 10) * 10;
    if (getParseIntInDec(mm) >= 60) {
        mm = mm - 60;
        hh = hh + 1;
    }
    hh = Utils.convertToDblDigit(getParseIntInDec(hh));
    mm = Utils.convertToDblDigit(getParseIntInDec(mm));

    return hh + ":" + mm;

}

(function($) {
    $.fn.hasScrollBar = function() {

    };
})(jQuery);

var pointerEventToXY = function(e) {
    var out = {
        x : 0,
        y : 0
    };
    if (e.type == 'touchstart' || e.type == 'touchmove' || e.type == 'touchend' || e.type == 'touchcancel') {
        var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
        out.x = touch.pageX;
        out.y = touch.pageY;
    } else if (e.type == 'mousedown' || e.type == 'mouseup' || e.type == 'mousemove' || e.type == 'mouseover' || e.type == 'mouseout' || e.type == 'mouseenter' || e.type == 'mouseleave') {
        out.x = e.pageX;
        out.y = e.pageY;
    }
    return out;
};

/***
 *  Function created to build playlist after our custom drag-grop
 *
 * @param {Object} cloneElem
 */
function createPlaylistAfterDrop(cloneElem) {
    log.debug("START cloneElem=" + cloneElem, "createPlaylistAfterDrop");

    /*check the empty playList!!*/
    var draggedPlayListImg = cloneElem.find('div.thumbnail_Area_Cls').css('backgroundImage');
    draggedPlayListImg = replaceUrlFromPath(draggedPlayListImg);
    draggedPlayListImg = retrieveFileName(draggedPlayListImg);
    var emptyPlayListImg = retrieveFileName("../resource/img/ss_default_playlist.png");
    var draggedPlayListName = cloneElem.find('div.thumnail_Title_Text_Cls').text();
    
    if (draggedPlayListImg == emptyPlayListImg || ((draggedPlayListImg == emptyPlayListImg) && (scheduleRender.playlistName == draggedPlayListName))) {
        draggedPlayListOKPopUp(langObj.Schedule.MIA_SID_PLAYLIST_IS_EMPTY);
        return;
    }

    /* check the same playList*/
    if (scheduleRender.playlistName == draggedPlayListName) {
        return;
    }
        
    var playListItemsLength = $('#Create_Playlist_List_Id li').length;
    
    var dataType = cloneElem.attr("data-type");
    var text = cloneElem.attr("data-text");
    var durationColor = cloneElem.attr("data-color");
    var thumbPath = cloneElem.attr("data-image");
    var templateActualPath = cloneElem.attr("data-templatePath");
    var templateOrentation = cloneElem.attr("data-orientation");
    var templateId = cloneElem.attr("data-templateId");

    if (dataType == 'playlist') {
        scheduleRender.playListFile = scheduleRender.playList + "/" + scheduleRender.projectName + "/" + text + "/" + text + ".xml";
        scheduleRender.isPlayList = true;
        scheduleRender.isDraggablePlaylist = true;
        scheduleRender.loadPlayListData();
        $('#Create_Playlist_Done_Btn_Id').addClass('Create_Playlist_Done_Btn_NOT');
        setTimeout(function() {
            var noOfTemplates = playListObjForDrag.CustomPlaylist[0].CustomContent.length;
            var templateList = "";
            console.log( '*************** noOfTemplates : ' + noOfTemplates );
            try {
                if (noOfTemplates > 0) {
                    $(".empty_PlayList_Txt").css("display", "none");
                    var templateCounts = playListItemsLength + noOfTemplates;
                    if (templateCounts > 99) {
                        draggedPlayListOKPopUp(langObj.Schedule.MIA_SID_MIX_ADD_UP_TEMPLATES_PLAYLIST);
                        $('#Create_Playlist_Done_Btn_Id').removeClass('Create_Playlist_Done_Btn_NOT');
                        return;
                    } else {
                        var cstmCntnObj=null;
                        var defaultDurationMin=0,defaultDurationSec=0;
                        var genTemplateList="";
                        for (var index = 0; index < noOfTemplates; index++) {
                            cstmCntnObj=playListObjForDrag.CustomPlaylist[0].CustomContent[index];                        
                            defaultDurationMin = calDefaultDurationMin(cstmCntnObj.Duration);
                            defaultDurationSec = calDefaultDurationSec(cstmCntnObj.Duration);
                            if( defaultDurationMin >= 60 ) 
                            {
                                defaultDurationMin = 59; 
                                defaultDurationSec = 59;
                            }
                            genTemplateList = generateTemplateListForPlayList(durationColor, cstmCntnObj.Path, cstmCntnObj.Name, cstmCntnObj.TemplateId, defaultDurationMin, defaultDurationSec);
                            templateList += genTemplateList;
                            createPlayListObj(cstmCntnObj.Name, cstmCntnObj.Path, cstmCntnObj.ActualPath, cstmCntnObj.TemplateId,false,false);
                        }
                        savePlaylistContent();
                        addTmpltToPlayLst(templateList);
                        $('#Content_number').text( templateCounts + " / 99");
                    }
                
                } else if (noOfTemplates == 0) {
                    draggedPlayListOKPopUp(langObj.Schedule.MIA_SID_PLAYLIST_IS_EMPTY);
                    $('#Create_Playlist_Done_Btn_Id').removeClass('Create_Playlist_Done_Btn_NOT');
                }

            } catch(ex) {
                console.log('******** Error ' + noOfTemplates , "createPlaylistAfterDrop");
            }
        }, 500);

    } else {
        $(".empty_PlayList_Txt").css("display", "none");
        if (playListItemsLength >= 99) {
            draggedPlayListOKPopUp(langObj.Schedule.MIA_SID_MIX_ADD_UP_TEMPLATES_PLAYLIST);
            return;
        } else {
            $('#Create_Playlist_Done_Btn_Id').addClass('Create_Playlist_Done_Btn_NOT');
            
            var contentIndex = createPlayListObj(text, thumbPath, templateActualPath, templateId,false,true);
	        var  playListCustomContent = playListObj.CustomPlaylist[0].CustomContent[contentIndex];
            var defaultDurationMin = calDefaultDurationMin(playListCustomContent.Duration);
            var defaultDurationSec = calDefaultDurationSec(playListCustomContent.Duration);
            if( defaultDurationMin >= 60 ) 
            {
                defaultDurationMin = 59; 
                defaultDurationSec = 59;
            }
            
            var droppedItem = generateTemplateListForPlayList(durationColor, thumbPath, text, templateId, defaultDurationMin, defaultDurationSec);
            
            addTmpltToPlayLst(droppedItem);
            $('#Content_number').text( (playListItemsLength+1) + " / 99");
        }
    }
    
    $('#draggableClone').remove();
    log.debug("COMPLETE", "createPlaylistAfterDrop");
}

/*On weekday drop*/
function onWeekDayDrop(elem, curr) {
    $('div#landScape_Div_Id').addClass("icon-disabled");
    $("#sch_nxtBtnId").removeClass("btn_disabledCls");

    if (scheduleRender.istimeBar == "true") {
    } else {
        var isCreateTimeBar = checkTimeBarLength(curr);
        if (isCreateTimeBar == "true") {
            deActivateSlider();
            createNewTimeBar(curr, elem);
        }
    }
    scheduleRender.istimeBar = "false";
}

function convertTo24Format(time, format) {

    var timeStr = time.split("::");
    var AmPm = timeStr[1].toLowerCase();
    var time = timeStr[0].split(":");
    var hh_time = time[0];
    var end_time = time[1];
    if (AmPm == "pm" && getParseIntInDec(hh_time) != 12 && getParseIntInDec(format) == 24) {
        hh_time = getParseIntInDec(hh_time) + 12;
    }
    if ((AmPm == "am" && getParseIntInDec(hh_time) == 12 ) && getParseIntInDec(format) == 24) {
        hh_time = getParseIntInDec(hh_time) - 12;
    }

    hh_time = Utils.convertToDblDigit(getParseIntInDec(hh_time));
    end_time = Utils.convertToDblDigit(getParseIntInDec(end_time));

    return hh_time + ":" + end_time;

}

function resetPlayListToNormalMode() {
    scheduleRender.sortableMode = false;
    startIndexSwpping = null;
    endIndexSwpping = null;
    $("#playListContainerId").sortable("disable");
    $("#recycleDivId").hide();
}

function getTotalSchListLength() {
    var schInfo = JSON.parse(sessionStorage.getItem("SCHEDULE_INFO"));
    var schLength = schInfo.myScheduleInfoArrs.length;
    return schLength;
}

function removeHighlight() {
    $('.Template_Area_Templates_Cls > li').removeClass('template_container_Highlight');
}

function createTplCloneForDrag($this, mouse_x, mouse_y)
{
        if($('#draggableClone').length==0)
        {
            
          /*Make clone*/
            var clone = $this.clone();
            cloneWidth = $this.width() * 0.50;
            cloneHeight = cloneWidth;
            var cloneTop = $this.offset().top + 30;
            var cloneLeft = $this.offset().left + 30;
            var width = cloneWidth * 0.50;
            clone.css({
                "width" : cloneWidth + 'px',
                "height" : cloneHeight + 'px',
                "z-index" : "999999999",
                "-webkit-transform" : "rotate(-15deg)",
                "box-shadow" : "6px 6px 3px 0px rgba(0,0,0,0.2)",
                'position' : 'absolute'
            });
            $("<div id='dragCenter'></div>").css({
                'width' : '10px',
                'height' : '10px',
                'position' : 'absolute',
                'left' : '40%',
                'top' : '40%'
            }).appendTo(clone);
    
            $('<ul class="foo" id="draggableClone"></ul>').css({
                'top' : (mouse_y - 50) + 'px',
                'left' : (mouse_x - 50) + 'px',
                'position' : 'absolute',
                'width' : cloneWidth + 'px',
                'height' : cloneHeight + 'px',
                'list-style-type' : 'none',
                'margin' : '0px',
                'padding' : '0px',
                'font-size':'10px'
            }).html(clone).appendTo('body');
            box = '#dragCenter';
        }
}

function createNewTemplate()
{
    if (!Utils.isAddTemplateAllowed()) {
    return false;
    }
        
    var schpath = scheduleRender.mySchedule + "/" + scheduleRender.projectName + "/Schedules/" + SchObj.Program[0].Program_Id + "/localsch.sch";
    var schName = scheduleRender.projectName;
    

    
    var isNewSchedule = false;
    if (scheduleRender.isClickCreateNew) {
        schpath = '';
        schName = '';
        isNewSchedule = true;
    }
    
    contentClicked = true;
    var urlStr = setNavigateURL(scheduleRender.templateCatogerySch, schName, schpath);
    
    var timebarLength = $(".ts_slider_containerCls").length;   
    
    console.log( '******1 check  isSavedSch  *** ::: ' + scheduleRender.isSavedSch );
    
    if(timebarLength==0 || $(".ts_disabled").length == timebarLength){
         window.location.href = urlStr;
    }
    else{
        navigateFromSchedule(urlStr, true, isNewSchedule, scheduleRender.templateCatogerySch, schName, schpath);    
    }
}

function closeCreatePlayList()
{
    $('#Create_Playlist_Area_Id').animate(
        {
            'opacity':'0'
        },
        {
            complete: function()
            {
                $('#Create_Playlist_Area_Id').css(
                    {
                        'display':'none',
                        'opacity':'1'
                    }
                );
                $('#SchedulePagehome').css({'display':'block'});
            }
        }
    );    
    
    $('.Template_Area_Cls').animate(
        {
            'opacity':'0'
        },
        {
            complete:function()
            {
                $('.Playlist_Template_Container_Cls').css({'visibility':'visible', 'height':'15%'}); 
                $('.Templates_List_Area_Cls').css({'height':'65%'}); 
                $('.Template_Area_Cls').css({'opacity':'1','display':'block', 'top': $(window).height()*0.6});
                calULHieght();
            }
        }
    );

    removeHighlight();

}
function hideOpenMenus()
{
    log.debug("START", "hideOpenMenus");
    
    if ($('.Template_Area_Cls').css('display') == 'block' && $('#Create_Playlist_Area_Id').css('display') == 'none') {
        hideTemplatePlayListMenu();
    }
    if ($("#sch_dwndropdownId").hasClass("schUpDropdownCls")) {
        $(".schTextNameCls").hide();
        $("#sch_dwndropdownId").addClass("schDwnDropdownCls").removeClass("schUpDropdownCls");
    } 
    log.debug("END All open Items closed", "hideOpenMenus");
}
