	/**
 * @filename ScheduleUtils.js
 * @author r.k.pandey
 * @date :13/02/2015
 * Modified : by Riten
 * added: added get prev and next day  method
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */
var ScheduleUtils = { 
	schId 	   : null,
	schName    : null,
	newSchName : null,
	newSchPath : null,
	newSchFile : null,
	textXML    : null,
	LANDSCAPE:'1000',
	PORTRAIT:'9999',
	getTemplateOrientation : function() {
				var orientationType=window.sessionStorage.getItem('orientationType');				 
    			 var templateOrientation='';
 				switch(orientationType){
 					case this.LANDSCAPE:
 							templateOrientation='landscape';
 							break;
 				    case this.PORTRAIT:
 							templateOrientation='portrait';
 							break;
 				}
 				return templateOrientation;
	}
};
var templateIDArray=[];
var apos_Str = "'";
var quote_Str = '"';
var escaped_Quote_Str = {  };
escaped_Quote_Str[quote_Str] = '&quot;';
escaped_Quote_Str[apos_Str] = '&apos;';

//This is existing to write playList file 

ScheduleUtils.writeElement=function(contentName, contentValue, attributesList) {
	log.debug("Start", "writeElement");
	var xmlStr;
	var node_Attribute_value = '';
	if (attributesList) {// tests false if this arg is missing!
		node_Attribute_value = formatAttributes(attributesList);
	}
	if (!contentValue) {
		xmlStr = '<' + contentName + node_Attribute_value + '>' + '</' + contentName + '>' + "\r\n";
	} else {
		xmlStr = '<' + contentName + node_Attribute_value + '>' + contentValue + '</' + contentName + '>' + "\r\n";
	}
	log.debug("COMPLETE", "writeElement");
	return xmlStr;
};

function formatAttributes(attributesList) {
	var resultStr = '';
	var att_Str_Val;
	var regExpVal;
	var apos_position, quot_position;
	var use_quote_Str, escape_Character;
	var node_Attribute_value;
	
	for (var att in attributesList) {
		node_Attribute_value = attributesList[att];

		// Find first quote marks if any
		apos_position = node_Attribute_value.indexOf(apos_Str);
		quot_position = node_Attribute_value.indexOf(quote_Str);

		// Determine which quote type to use around
		// the attribute value
		if (apos_position == -1 && quot_position == -1) {
			att_Str_Val = ' ' + att + "='" + node_Attribute_value + "'";
			resultStr += att_Str_Val;
			continue;
		}

		// Prefer the single quote unless forced to use double
		if (quot_position != -1 && quot_position < apos_position) {
			use_quote_Str = apos_Str;
		} else {
			use_quote_Str = quote_Str;
		}

		// Figure out which kind of quote to escape
		// Use nice dictionary instead of yucky if-else nests
		escape_Character = escaped_Quote_Str[use_quote_Str];

		// Escape only the right kind of quote
		regExpVal = new RegExp(use_quote_Str, 'g');
		att_Str_Val = ' ' + att + '=' + use_quote_Str + node_Attribute_value.replace(regExpVal, escape_Character) + use_quote_Str;
		resultStr += att_Str_Val;
	}
	resultStr=resultStr.replace(/"/g, '');
	return resultStr.replace(/'/g, '"');

}


ScheduleUtils.addtime=function(start_time, end_time) {
	 log.debug("START  start_time== "+start_time+":end_time:"+end_time, "addtime");
    var startArr = start_time.split(':');
    var endArr = end_time.split(':');

    var d = new Date();
    startArr[0] = (startArr[0]) ? getParseIntInDec(startArr[0]) : 0;
    startArr[1] = (startArr[1]) ? getParseIntInDec(startArr[1]) : 0;
    startArr[2] = (startArr[2]) ? getParseIntInDec(startArr[2]) : 0;
    endArr[0] = (endArr[0]) ? getParseIntInDec(endArr[0]) : 0;
    endArr[1] = (endArr[1]) ? getParseIntInDec(endArr[1]) : 0;
    endArr[2] = (endArr[2]) ? getParseIntInDec(endArr[2]) : 0;

    var totalHour=(getParseIntInDec(startArr[0]) + getParseIntInDec(endArr[0]));
    var totalMin=(getParseIntInDec(startArr[1]) + getParseIntInDec(endArr[1]));
    
    if((getParseIntInDec(startArr[1]) + getParseIntInDec(endArr[1])) == 60)
    {
        totalHour=getParseIntInDec(totalHour)+1;
        totalMin=00;
    }   
    else if((getParseIntInDec(startArr[1]) + getParseIntInDec(endArr[1])) >60)
    {
        totalHour=getParseIntInDec(totalHour)+1;
        totalMin=(getParseIntInDec(startArr[1]) + getParseIntInDec(endArr[1])) -60;
    }
     totalHour=(getParseIntInDec(totalHour) < 10 ? "0" : "") + totalHour;
     totalMin=(getParseIntInDec(totalMin) < 10 ? "0" : "") + totalMin;
     log.debug("COMPLETE", "addtime");
   // console.log("totalMin>>>>>>>>"+totalMin);
    return totalHour + ':' + totalMin + ':' + (getParseIntInDec(startArr[2]) + getParseIntInDec(endArr[2]));
};

ScheduleUtils.setScheduleTime=function(startTime, duration) {
	 log.debug("START  startTime== "+startTime+":duration:"+duration, "setScheduleTime");
	var endTime='';
	if(getParseIntInDec(duration)==86400)
	{
		endTime=getParseIntInDec("24")+":00"+":00";
	}	
	else
	{
		var scheduleEndTime = duration;
		var hours = getParseIntInDec(scheduleEndTime / 3600) % 24;
		var minutes = getParseIntInDec(scheduleEndTime / 60) % 60;
		var seconds = scheduleEndTime % 60;
		endTime = hours + ":" + minutes + ":" + seconds;
	}	
	//console.log("endTime "+endTime);
	var finalEndTime = ScheduleUtils.addtime(startTime, endTime);
     log.debug("COMPLETE", "setScheduleTime");
	return finalEndTime;
};

ScheduleUtils.getDurationInSeconds=function(changedTime) {
     //log.debug("START  changedTime== "+changedTime, "getDurationInSeconds");
    var startArr = changedTime.split(':');
    

    var d = new Date();
    startArr[0] = (startArr[0]) ? getParseIntInDec(startArr[0]) : 0;

    startArr[1] = (startArr[1]) ? getParseIntInDec(startArr[1]) : 0;
    startArr[2] = (startArr[2]) ? getParseIntInDec(startArr[2]) : 0;
    
    var hours;
    var minutes;
    var seconds;
    //This condition for end time comes as 24:00:00 
    if(startArr[0] == 24)
    {
        hours=getParseIntInDec(startArr[0]);
        minutes=0;
        seconds=0;
    }   
    else
    {
        d.setHours(startArr[0]);
        d.setMinutes(startArr[1]);
        d.setSeconds(startArr[2]);
        hours = d.getHours();
        minutes = d.getMinutes();
        seconds = d.getSeconds();
    }
     //log.debug("COMPLETE ", "getDurationInSeconds");
    return hours * 60 * 60 + minutes * 60 + seconds;
} ;

ScheduleUtils.createFolderID=function() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
};

ScheduleUtils.getFolderID=function()
{
	return (ScheduleUtils.createFolderID() + ScheduleUtils.createFolderID() + "-" + ScheduleUtils.createFolderID() + "-4" + ScheduleUtils.createFolderID().substr(0, 3) + "-" + ScheduleUtils.createFolderID() + "-" + ScheduleUtils.createFolderID() + ScheduleUtils.createFolderID() + ScheduleUtils.createFolderID()).toLowerCase();
};

ScheduleUtils.getLFDInfo=function()
{
	templateIDArray=[];
	var currMyTemplateInfoJson=JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
	var playerType=Utils.getActivePlayerType();
	for (var i=0;i< currMyTemplateInfoJson.myTemplateInfoArrs.length;i++) {
        if(playerType == currMyTemplateInfoJson.myTemplateInfoArrs[i].playerType){
            templateIDArray.push(getParseIntInDec(currMyTemplateInfoJson.myTemplateInfoArrs[i].templateId));
        }
	}
	return JSON.parse(sessionStorage.getItem("TEMPLATE_INFO"));
};

ScheduleUtils.getDuration = function(start, end) {
	//log.debug("START  start== "+start+"::end:"+end, "getDuration");
            start = start.split(":");
            end = end.split(":");
            var startDate = new Date(0, 0, 0, start[0], start[1], 0);
            var endDate = new Date(0, 0, 0, end[0], end[1], 0);
            var diff = endDate.getTime() - startDate.getTime();
            var hours = Math.floor(diff / 1000 / 60 / 60);
            diff -= hours * 1000 * 60 * 60;
            var minutes = Math.floor(diff / 1000 / 60);
            //minutes = Math.round(minutes / 10) * 10
           
           // if(hours > 0 || (hours == 0 && minutes >=10) ){
           	
           	 var returnTime = (hours <= 9 ? "0" : "") + hours + ":" + (minutes < 9 ? "0" : "") + minutes;
           //	 console.log("Calculation start: "+start+", end: "+end+" minutes:"+minutes+" "+returnTime);
           	 //log.debug("COMPLETE", "getDuration");
             return returnTime;
           // }
            
    };
ScheduleUtils.Converttimeformat=function(time) {
	   var hrs = Number(time.match(/^(\d+)/)[1]);
	   var mnts = Number(time.match(/:(\d+)/)[1]);
	   var format = time.match(/\s(.*)$/)[1];
	   if ((format == "PM" || format == "pm") && hrs < 12)
	       hrs = hrs + 12;
	   if ((format == "AM" || format == "am") && hrs == 12 )
	       hrs = 12 - hrs;
	   
	   var hours = hrs.toString();
	   var minutes = mnts.toString();
	   if (hrs < 10)
	       hours = "0" + hours;
	   if (mnts < 10)
	       minutes = "0" + minutes;
	   return hours + ":" + minutes;
};
ScheduleUtils.ConvertEndtimeformat=function(time) {
	   var hrs = Number(time.match(/^(\d+)/)[1]);
	   var mnts = Number(time.match(/:(\d+)/)[1]);
	   var format = time.match(/\s(.*)$/)[1];
	   if ((format == "PM" || format == "pm") && hrs < 12)
	       hrs = hrs + 12;
	   if ((format == "AM" || format == "am")  && hrs == 12 && mnts == 0)
	       hrs = 12 + hrs;
	   else if((format == "AM" || format == "am")  && hrs == 0 && mnts == 0)
		   hrs = 24;
	   else if((format == "AM" || format == "am") && hrs == 12)
	       hrs = 12 - hrs;
	   
	   var hours = hrs.toString();
	   var minutes = mnts.toString();
	   if (hrs < 10)
	       hours = "0" + hours;
	   if (mnts < 10)
	       minutes = "0" + minutes;
	   return hours + ":" + minutes;
};
 ScheduleUtils.getNextDay = function(day){
                var loopedday="";
                
                 for(var k=0,len=scheduleRender.weekdays.length;k<len ;k++)
                 {
                      if(k< scheduleRender.weekdays.length-1)
                      {
                               if(day == scheduleRender.weekdays[k]){
                                   loopedday=scheduleRender.weekdays[k+1];
                                
                                   return loopedday;
                               }
                       }
                       else
                       {
                           loopedday="sun";
                           return loopedday;
                       }
                   }
        };
 ScheduleUtils.getPrevDay = function(day){
                var loopedday="";
              
                 for(var k=0,len=scheduleRender.weekdays.length;k<len ;k++)
                 {
                      if(day != "sun")
                      {
                               if(day == scheduleRender.weekdays[k]){
                                   loopedday=scheduleRender.weekdays[k-1];
                                   return loopedday;
                               }
                       }
                       else
                       {
                           loopedday="sat";
                           return loopedday;
                       }
                   }
        };

// Schedule Copy and delete  functionality

ScheduleUtils.modifySchDirectory = function(){
   	
	 // Iterate copied schedule directory path
	  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, ScheduleUtils.gotDS, modifyFail);
	  
	  function modifyFail(evt) {
        console.log( "Error: FILE SYSTEM FAILURE" + evt.target.error.code);
        }
	  
    };
    
ScheduleUtils.gotDS = function(fileSystem) {
		//alert("gotDS "+ app.entrySch);
		fileSystem.root.getDirectory(ScheduleUtils.newSchPath, {create : false}, 
			                  ScheduleUtils.onGetDirectoryWin, onGetDirectoryFail);
	    function onGetDirectoryFail (evt) {
		 //alert("onGetDirectoryFail");
		 //alert("FILE SYSTEM FAILURE" + evt.target.error.code);
    	 console.log( "Error: FILE SYSTEM FAILURE" + evt.target.error.code);
    	
    	}

	};

ScheduleUtils.onGetDirectoryWin = function(directoryEntry) {
		//alert("onGetDirectoryWin");
		var directoryReader = directoryEntry.createReader();
		directoryReader.readEntries(ScheduleUtils.gotDirectoryEntry, readEntriesFail);
		
		function readEntriesFail(evt) {
          //alert("FILE SYSTEM FAILURE" + evt.target.error.code);
          console.log( "Error: FILE SYSTEM FAILURE" + evt.target.error.code);
        }
};

    
ScheduleUtils.gotDirectoryEntry = function(entries) {
		// alert("entries.length "+entries.length);
		if (entries.length > 0) {
			
			ScheduleUtils.renameFiles(entries,0);
		/*
		for (var i = 0; i < entries.length; i++) {
					if (entries[i].isFile) {
						
						
					}
				 }*/
		
		 } 
			
	};

ScheduleUtils.renameFiles=function(entries,i) {
	
	entryToRename = entries[i];
	
	if(entryToRename.name.localeCompare("localsch.sch")==0)
	{
		 ScheduleUtils.newSchFile = entryToRename.name;
		 window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, ScheduleUtils.gotFS, ScheduleUtils.fail);
		 i++;
	     if(i<entries.length){
	       ScheduleUtils.renameFiles(entries,i);
	     }
	}
    else{
    	var srcPngFile;
      // Rename schedule PNG file with new schedule name 
      if(entryToRename.name.indexOf(".PNG.PNG")!=-1){
      		srcPngFile = ScheduleUtils.newSchName.split('/').pop()+".PNG.PNG";
      }else{
      		srcPngFile = ScheduleUtils.newSchName.split('/').pop()+".PNG";
      }
      var targetPngFile = null;
      targetPngFile = entryToRename.name;
       
      console.log('PNG file :'+ targetPngFile);
      console.log('Get PNG file path '+ ScheduleUtils.newSchPath);
      window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
         fileSystem.root.getDirectory(ScheduleUtils.newSchPath, {create : false}, function (dirEntry){
           	dirEntry.getFile(targetPngFile, {create : false}, function(fileEntry) {                           		
           		fileEntry.moveTo(dirEntry, srcPngFile, function(){	           			
	           	    	console.log("PNG file rename successfully!");
	           	    	i++;
	           	    	if(i<entries.length){
	           	    		setTimeout(function(){
	           	    		ScheduleUtils.renameFiles(entries,i);	
	           	    		},100);
	           	    	}	           	    	
           	    	}, ScheduleUtils.fail);	                       	    	
      		}, ScheduleUtils.fail);
      	}, ScheduleUtils.fail);
      }, ScheduleUtils.fail);
    }
};
ScheduleUtils.gotFS = function(fileSystem) {

		var targetXmlFile = null;
		targetXmlFile = ScheduleUtils.newSchFile;//app.newSchFile.split('/').pop();
		console.log("Get sch File  :"+ ScheduleUtils.newSchFile);
		fileSystem.root.getDirectory(ScheduleUtils.newSchPath, {create : false}, function (dirEntry){
		dirEntry.getFile(targetXmlFile, null, ScheduleUtils.gotFileEntry, ScheduleUtils.fail);
        }, ScheduleUtils.fail); 
};

ScheduleUtils.gotFileEntry = function(fileEntry) {
		
		fileEntry.file(ScheduleUtils.gotFile, ScheduleUtils.fail);
};

ScheduleUtils.gotFile = function(file) {
		
		ScheduleUtils.readAsText(file);
};
    
    
ScheduleUtils.readAsText = function(file) {
	//alert("readAsText");
	var reader = new FileReader();
	reader.onloadend = function(evt) {
		ScheduleUtils.textXML = evt.target.result;
		// Edit schedule name by tag 
		var oldName = "<scheduleName>"+ScheduleUtils.schName+"</scheduleName>";
		var newName = "<scheduleName>"+ScheduleUtils.newSchName.split('/').pop()+"</scheduleName>";
		ScheduleUtils.textXML = ScheduleUtils.textXML.replace(oldName,newName);
		ScheduleUtils.writeAsText();
   	  };
    reader.readAsText(file);
   };
    
    
ScheduleUtils.writeAsText = function(){
       
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
			var targetXmlFile = null;
			targetXmlFile = ScheduleUtils.newSchFile;
            // var sdcardFullPath = fileSystem.root.toURL().replace("file://","");
  			console.log("New sch filename  "+ ScheduleUtils.newSchFile);
			fileSystem.root.getDirectory(ScheduleUtils.newSchPath, {create : false}, function (dirEntry){
			dirEntry.getFile(targetXmlFile, null, function(fileEntry) {
			
			fileEntry.createWriter(function win(writer) {
 			   writer.onwrite = function(evt) {
 			   	
 			   	
 			   	var scheduleName = ScheduleUtils.newSchName.split('/').pop();
 			   	var scheduleFilePath = ScheduleUtils.newSchPath +"/"+ ScheduleUtils.newSchFile;
 			   	var scheduleThumbnailPath = /* sdcardFullPath + */ScheduleUtils.newSchPath +"/"+ ScheduleUtils.newSchName.split('/').pop() +".PNG";
 			   	insertScheduleInfo(scheduleName, scheduleFilePath,scheduleThumbnailPath,false);
 			   	//DF160122-00129 fixed
 			   	//ScheduleUtils.clean();
        	    console.log("written successfully!");
              };
               writer.write(ScheduleUtils.textXML);
              }, ScheduleUtils.fail);
			 }, ScheduleUtils.fail);
	        }, ScheduleUtils.fail); 
	     }, ScheduleUtils.fail);
 };
    
ScheduleUtils.getDirectoryFail = function() {
    console.log( "Error: Fail to get directory" );
   };
    
ScheduleUtils.fail = function(evt){
    console.log("Error: Operation failed " + evt.target.error.code);	
   };
    
ScheduleUtils.clean = function(){
    	ScheduleUtils.schId = null;
    	ScheduleUtils.schName = null;
		ScheduleUtils.newSchName = null;
		ScheduleUtils.newSchPath = null;
		ScheduleUtils.newSchFile = null;
		ScheduleUtils.textXML    = null;
   };
    
ScheduleUtils.createSchName = function(parentDir,fileName, callback){
      
      var name =  null;
      var dirArr = null;
      var idx = 1;
 
      subFolders(parentDir,function(dirArr){
        console.log("Sub folder list: "+ dirArr.toString());      	
      	do{
        	name = fileName + ((idx < 10)? '_0' : '_') + idx;
      		idx++;
      	}
      	while (dirArr != null && dirArr.indexOf(name) != -1);
       	 console.log("Created new filename is : "+ name);
       	callback.apply(this,[name]);
    	
      }); 	
    	
   };
   
 (function($) {
 	//new FastClick(document.querySelector(".ts_slider_containerCls"));
   // new FastClick(document.body);
    $.fn.doubleTap = function(doubleTapCallback) {
         return this.each(function(){
            var element = this;
            
            var lastTapp = 0;
            $(element).bind('vclick', function (e) {
                          
                                var now = (new Date()).valueOf();
                var diff = (now - lastTapp);
                                lastTapp = now ;
                                if (diff < 350) {
                             console.log("-----------------");   	
                          //  if($.isFunction( doubleTapCallback ))
                            //{
                               doubleTapCallback.call(element,e);
                           // }
                                }      
            });
         });
    };
})(jQuery);

