/** 
 * @filename TimeSlider.js
 * @author riten.bag
 * @date 13/2/2015
 * Modified : by Riten
 * added:  weekdaylist change
 *
 *
 * Copyright 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 */
var currentTime = "";
var temp;
var isInvalidTime = "false";
var savedTime;
var prevsliderHght = 0;
var isDurationChange = true;
var nxtsliderHght = 0;
var linksliderHght = 0;
var lastTapp = 0;
var sliderHeight = 0;
var revertedDuration = 0;
var linksliderTop;
var isFullDay = "false";
var bStopTouchend = false;
var touchendObj = null;
var touchendTimeOut = null;
var timeSpinnerChanged = false;
var containerHeight;
var containerWidth;
var containerTopPosY;
var HHInt;
var MMInt;
var isStartMoving;
var isStartMoving2;
var curLastPosY = 0;
var maxDuration;
var offset;
var bRegisterTimerTap = false;
var bTSMoveAllowed = true;
var bMoveEventActive = false;
var direction = "";
var lastPosYMove = 0;
var currPositionY=0;
var isGstLink=false;
var gtHeight=0;
var isTimebarCreated=false;
var checkTimebar = 0;
log = new logger();
var nCountOfMoving = 0;
var isOpenSchList = false;
var z_Index=1;
var maxIndex=-1;

    
(function($) {

    $.fn.timeSlider = function(options) {

        var params = $.extend({
            index : 0,
            startTime : "00:00",
            endTime : "24:00",
            day : "Sun",
            minduration : 10,
            type : "template",
            color : "#FF6633",
            zIndex : 0,
            link : "",
            linkday : "",
            templateId : "",
            playlist : "",
            duration : "",
            isFirst : "true",
            isTimebarCreated:"true",
            onTimeChange : function() {
            },
            onCreate : function() {
            },
            onCopy : function() {
            },
            onDelete : function() {
            }
        }, options);
        var END_TIME = "24:00";
        var START_TIME = "00:00";
        var TwelveHRFRMT = "12:00";
        var isGlobalTimeBar = "false";

        function calculateTimerDimension($curr) {
            containerHeight = $curr.height();
            containerWidth = $curr.width();
            containerOffset = $curr.offset();
            containerTopPosY = (containerOffset.top);
            
            var timerWidth = containerWidth * 0.76;
            var timerPos = containerWidth * 0.12;
            var startTime = params.startTime;
            var endTime = params.endTime;
            var duratn = ScheduleUtils.getDuration(startTime, endTime);
            var schStartTime = startTime.split(":");
            var schEndTime = duratn.split(":");
            var hh_duration = getParseIntInDec(schEndTime[0]);
            var mm_duration = getParseIntInDec(schEndTime[1]);
            HHInt = (containerHeight / 24);
            MMInt = (HHInt / 60);
            var durationinMin = getParseIntInDec(((hh_duration) * HHInt) + ((mm_duration) * MMInt));
            var durtnInPx = ((schStartTime[0] * HHInt) + (schStartTime[1] * MMInt));
            var startPosY = (containerTopPosY + (durtnInPx));
            var drgbtnPosX = timerWidth * (-0.15);
            var drgbtndmn = timerWidth * 1.2;
            var schTimePinWidth = containerWidth + (containerWidth * .5);
            var schTimePinHght = timerWidth;
            var schTimePinLeftPos = Math.round(schTimePinWidth - 4);
            var schTimePinTopPos = Math.round(schTimePinHght - 5);
            var drgbtnPosY = Math.round(drgbtndmn / 2);
            var schTimePindurWdth = schTimePinWidth * 0.4;
            var schTimePindurhgth = schTimePinHght * 0.5;
            var schTimePindurtop = Math.round((schTimePindurhgth / 2));
            var schTimeglobalcontrollerLeft = Math.round(schTimePinWidth * (-0.05));
            var schTimePindurleft = Math.round(schTimePinWidth * 0.1);
            var schTimePinAMPMWdth = schTimePinWidth * 0.16;
            var schTimePinAMPMhgth = schTimePinHght * 0.4;
            var schTimePinAMPMtop = Math.round((schTimePindurhgth / 2));
            var schTimePinAMPMleft = Math.round(schTimePinWidth * 0.55);
            var schCopydelBtnWdth = timerWidth;
            var schCopydelBtHghth = containerHeight * 0.23;
            var schCopyHghtbtn = schCopydelBtHghth * 0.28;
            var schDelHghtbtn = schCopydelBtHghth * 0.28;
            var schDelbtnMargin = containerHeight * 0.14;
            var schtimelineAreaOffset = $(".timelineScaleArea").offset();
            var schGlobalTimePinWdth = timerWidth + timerWidth * 0.40;
            var schGlobalTimePinHght = timerWidth * 0.40;
            var schGlobalTimePinTopPos = Math.round(schGlobalTimePinHght / 2);
            var schGlobalTimePinleftPos = Math.round((containerOffset.left) - (schtimelineAreaOffset.left) - 70);
            var schGlobalTimePindurWdth = schGlobalTimePinWdth * 0.5;
            var schGlobalTimePindurhgth = schGlobalTimePinHght * 0.6;
            var schGlobalTimePinAMPMWdth = schGlobalTimePinWdth * 0.4;
            var schGlobalTimePinAMPMhgth = schGlobalTimePinHght * 0.6;
            var schGlobalTimePinUpBarWdth = $("#timelineScheduleAreaId").width();
            var schGlobalTimePinUpBarLeftPos = schGlobalTimePinWdth;
            var schGlobalTimePinUpBarTopPos = schGlobalTimePinHght;
            var schglobaldraggerWidth = ((schtimelineAreaOffset.left + schGlobalTimePinUpBarWdth) - containerOffset.left);

            var timerColor = params.color;
            z_Index++;
            $("#timer_" + params.day + " > #ts_slider_container_" + params.index).css({
                'width' : timerWidth + 'px',
                'margin-left' : timerPos + 'px',
                'height' : durationinMin + 'px',
                'top' : startPosY + 'px',
                'position' : 'absolute',
                'z-index' : z_Index

            });
            $("#timer_" + params.day + " > #ts_slider_container_" + params.index).attr({
                "data-frameIndex" : params.index,
                "data-color" : params.color,
                "data-day" : params.day,
                "data-type" : params.type,
                "data-link" : params.link,
                "data-zIndex" : z_Index,
                "data-linkday" : params.linkday,
                "data-templateId" : params.templateId,
                "data-playlist" : params.playlist,
                "data-duration" : params.duration,
                "data-isFirst" : params.isFirst,
                "data-isTimebarCreated": params.isTimebarCreated
            });

            $curr.find("#ts_slider_container_" + params.index + " > .ts_contentArea").css({
                'background-color' : timerColor
            });

            $curr.find("#ts_slider_container_" + params.index + " > .ts_schcopydelbtnCls").css({
                'top' : '92.5%',
                'left' : '0px',
                'width' : '100%',
                'height' : '7.5%',
                'position' : 'fixed'
                                
            });
            $curr.find("#ts_slider_container_" + params.index + "> .ts_schcopydelbtnCls > .ts_undobtnCls").css({
                'display' : 'none'
            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_dragbtn").css({
                'margin-top' : '-' + drgbtnPosY + 'px',
                'margin-left' : drgbtnPosX + 'px',
                'width' : drgbtndmn + 'px',
                'height' : drgbtndmn + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > #startTimePinAreaId").css({
                'margin-left' : '-' + (schTimePinLeftPos-10) + 'px',
                'margin-top' : '-' + (schTimePinTopPos + 8) + 'px',
                'width' : schTimePinWidth + 'px',
                'height' : schTimePinHght + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > #endTimePinAreaId").css({
                'margin-left' : '-' + (schTimePinLeftPos-13) + 'px',
                'margin-top' : '-' + (schTimePinTopPos-25) + 'px',
                'width' : schTimePinWidth + 'px',
                'height' : schTimePinHght + 'px'

            });

            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls > .ts_controllerTimeCls").css({
                'margin-left' : schTimePindurleft + 'px',
                'margin-top' : schTimePindurtop + 'px',
                'width' : schGlobalTimePindurWdth + 'px',
                'height' : schGlobalTimePindurhgth + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls > .ts_controllerAMPMCls").css({
                'margin-left' : schTimePinAMPMleft + 'px',
                'margin-top' : schTimePinAMPMtop + 'px',
                'width' : schGlobalTimePinAMPMWdth + 'px',
                'height' : schGlobalTimePinAMPMhgth + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls > .ts_upControllerBar").css({

                "width" : (schGlobalTimePinUpBarWdth -30 ) + "px",
                "height" : "5px",
                "margin-left" : "-" + (schGlobalTimePinleftPos + 20) + "px",
                "margin-top" : "-5px"
            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls > .ts_upControllerBar_arrow").css({

                "width" : "22px",
                "height" : "5px",
                "margin-left" : "-" + (schGlobalTimePinleftPos + 40) + "px",
                "margin-top" : "-5px"
            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls > .ts_dwnControllerBar").css({

                "width" : (schGlobalTimePinUpBarWdth -30 ) + "px",
                "height" : "5px",
                "margin-left" : "-" + (schGlobalTimePinleftPos + 20) + "px"
            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls > .ts_dwnControllerBar_arrow").css({

                "width" : "22px",
                "height" : "5px",
                "margin-left" : "-" + (schGlobalTimePinleftPos + 40) + "px"
            });
            $curr.find("#ts_slider_container_" + params.index + " > .ts_globalschcontrollerTimeCls >  .ts_gstdragger").css({
                "margin-left" : "-" + (schGlobalTimePinleftPos + 70) + "px",
                "margin-top" : "-18px",
                'left' : '0px',
                'width' : drgbtndmn + 'px',
                'height' : drgbtndmn + 'px'
            });
            $curr.find("#ts_slider_container_" + params.index + " > #startTimePinAreaId" + " > .ts_controllerAMPMCls").css({
                'margin-left' : schTimePinAMPMleft-4 + 'px',
                //'margin-top' : schTimePinAMPMtop+'px',
                'margin-top' : '13%',
                'width' : schTimePinAMPMWdth + 'px',
                'height' : schTimePinAMPMhgth + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > #endTimePinAreaId" + "> .ts_controllerAMPMCls").css({
                'margin-left' : schTimePinAMPMleft-4 + 'px',
                //'margin-top' : (schTimePinAMPMtop + 9) + 'px',
                'margin-top' : '34%',
                'width' : schTimePinAMPMWdth + 'px',
                'height' : schTimePinAMPMhgth + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > #startTimePinAreaId" + " > .ts_controllerTimeCls").css({
                'margin-left' : schTimePindurleft-4 + 'px',
                //'margin-top' : schTimePinAMPMtop + 'px',
                'margin-top' : '11%',
                'width' : schTimePindurWdth + 'px',
                'height' : schTimePindurhgth + 'px'

            });
            $curr.find("#ts_slider_container_" + params.index + " > #endTimePinAreaId" + "> .ts_controllerTimeCls").css({
                'margin-left' : schTimePindurleft-4 + 'px',
                //'margin-top' : (schTimePinAMPMtop + 10) + 'px',
                'margin-top' : '32%',
                'width' : schTimePindurWdth + 'px',
                'height' : schTimePindurhgth + 'px'

            });

            addEventsToTimer($curr);

        };

        function setTimeRange(currObj, startTime, endTime) {

            var containerHeight = currObj.parent().height();
            var containerWidth = currObj.parent().width();
            var containerOffset = currObj.parent().offset();
            var containerTopPosY = (containerOffset.top);
            var st_time = startTime.split("::");
            var end_time = endTime.split("::");
            var st_hh_time = st_time[0].split(":")[0];
            var st_mm_time = st_time[0].split(":")[1];
            var end_hh_time = end_time[0].split(":")[0];
            var end_mm_time = end_time[0].split(":")[1];
            var st_timeAmPm = st_time[1];
            var end_timeAmPm = end_time[1];
            var invalidTime = "false";
            var link = currObj.attr("data-link");
            var frameIndex = currObj.attr("data-frameIndex");
            var linkstartTime = $('#ts_slider_container_' + link + ' > #startTimePinAreaId > .ts_controllerTimeCls').html();
            var linkstartTimeAmPm = $('#ts_slider_container_' + link + ' > #startTimePinAreaId > .ts_controllerAMPMCls').html();
            var linkendTime = $('#ts_slider_container_' + link + ' > #endTimePinAreaId > .ts_controllerTimeCls').html();
            var linkendTimeAmPm = $('#ts_slider_container_' + link + ' > #endTimePinAreaId > .ts_controllerAMPMCls').html();

            var totalduratn;
            if (link != "") {
                var hh_lst_time = linkstartTime.split(":")[0];
                var mm_lst_time = linkstartTime.split(":")[1];
                var hh_lend_time = linkendTime.split(":")[0];
                var mm_lend_time = linkendTime.split(":")[1];

                if (linkstartTimeAmPm == "am" && getParseIntInDec(hh_lst_time) == 12) {

                    hh_lst_time = "00";
                    linkstartTime = hh_lst_time + ":" + mm_lst_time;
                }
                if (linkendTimeAmPm == "am" && getParseIntInDec(hh_lend_time) == 12) {

                    if (getParseIntInDec(mm_lend_time) == 0) {
                        hh_lend_time = "24";
                        linkendTime = END_TIME;
                    } else {
                        hh_lend_time = "00";
                        linkendTime = hh_lend_time + ":" + mm_lend_time;
                    }

                }
                if (linkstartTimeAmPm == "pm" && getParseIntInDec(hh_lst_time) != 12) {
                    linkstartTime = convertTimePinFormat(linkstartTime + "::pm", 24);
                }
                if (linkendTimeAmPm == "pm" && getParseIntInDec(hh_lend_time) != 12) {
                    linkendTime = convertTimePinFormat(linkendTime + "::pm", 24);
                }
            }
            if (st_timeAmPm == "pm" && getParseIntInDec(st_hh_time) != 12) {
                st_hh_time = getParseIntInDec(st_hh_time) + 12;
            }
            if (st_timeAmPm == "am" && getParseIntInDec(st_hh_time) == 12) {
                st_hh_time = "00";
            }
            if (end_timeAmPm == "pm" && getParseIntInDec(end_hh_time) < 12) {
                end_hh_time = getParseIntInDec(end_hh_time) + 12;
            }

            if (end_timeAmPm == "am" && getParseIntInDec(end_hh_time) == 0) {
                end_hh_time = getParseIntInDec(end_hh_time) + 12;
            }

            if (getParseIntInDec(end_hh_time) == 12 && end_timeAmPm == "am") {
                end_hh_time = 24;
            }

            if (getParseIntInDec(end_hh_time) == 24 && end_timeAmPm == "am") {
                if (getParseIntInDec(end_mm_time) > 0) {
                    end_hh_time = "00";
                    invalidTime = "false";
                } else {
                    end_hh_time = "24";
                    invalidTime = "false";
                 
                }
            }

            var t_startTime = st_hh_time + ":" + st_mm_time;
            var t_endTime = end_hh_time + ":" + end_mm_time;
            log.debug("t_startTime"+t_startTime+"t_endTime"+t_endTime);
           
            if (link != "") {
                var day = currObj.attr("data-day");
                var mlinkedday = currObj.attr("data-linkday");
                var dayIndex = getDayIndex(day);
                var linkeddayIndex = getDayIndex(mlinkedday);
                
        if(dayIndex == 6 && linkeddayIndex == 0)
                {
                    t_endTime = "24:00";
                    linkstartTime = "00:00";
                }
                else if(dayIndex == 0 && linkeddayIndex == 6)
                {
                    linkendTime = "24:00";
                    t_startTime = "00:00";
                }
        else
        {
            if(dayIndex > linkeddayIndex)
            {
                linkendTime = "24:00";
                t_startTime = "00:00";
            }
            else
            {
                t_endTime = "24:00";
                linkstartTime = "00:00";
            }
        }
                
             }
            var duratn = ScheduleUtils.getDuration(t_startTime, t_endTime);
            if (link != "") {
                var duratn_st = ScheduleUtils.getDuration(t_startTime, t_endTime);
                var duratn_end = ScheduleUtils.getDuration(linkstartTime, linkendTime);
                totalduratn = addEndTime(duratn_st, duratn_end);

            }
            
            var schStartTime = t_startTime.split(":");
            var schEndTime = duratn.split(":");
            var hh_st_duration=getParseIntInDec(schStartTime[0]);
            var hh_end_duration=getParseIntInDec(t_endTime.split(":")[0]);
            log.debug("hh_st_duration"+hh_st_duration+"hh_end_duration"+hh_end_duration);
            var hh_duration = getParseIntInDec(schEndTime[0]);
            var mm_duration = getParseIntInDec(schEndTime[1]);
            var HHInt = (containerHeight / 24);
            var MMInt = (HHInt / 60);
            var durationinMin = getParseIntInDec(((hh_duration) * HHInt) + ((mm_duration) * MMInt));
            var durtnInPx = ((schStartTime[0] * HHInt) + (schStartTime[1] * MMInt));
            var startPosY = (containerTopPosY + (durtnInPx));
            var minDuration = 10;
            var maxDuration = containerHeight;
            if(getParseIntInDec(hh_st_duration) >  getParseIntInDec(hh_end_duration))
            {
                duratn = "invalidTime";
            }
            if(totalduratn!= undefined)
            {
                var totalTime = totalduratn.split(":");
                if(getParseIntInDec(totalTime[0])> 24 )
                {
                    duratn = "invalidTime";
                }
                 if(getParseIntInDec(totalTime[0])== 24 && getParseIntInDec(totalTime[1])>0)
                {
                    duratn = "invalidTime";
                }
            }

            if(hh_duration == 0  && mm_duration < 10)
            {
                duratn = "invalidTime";
            }

            if (invalidTime == "false" && duratn != "invalidTime") {

                currObj.css({
                    'top' : startPosY + 'px',
                    'height' : durationinMin + 'px'

                });

                return "true";

            } else {
                return "false";
            }
        }


        function resetTimebar($this)
        {
            
            
            var link = $this.attr("data-link");
            var isLinkNextDay = checkNextDay($this);
            if (link != "") {

                if (isLinkNextDay == "true") {
                    var endTime = $("#ts_slider_container_" + link).find('#endTimePinAreaId > .ts_controllerTimeCls').html();
                    var endTimeAmPm = $("#ts_slider_container_" + link).find('#endTimePinAreaId > .ts_controllerAMPMCls').html();
                    endTime = endTime + endTimeAmPm;
                    log.debug(" resettimer"+endTime);

                    if (endTime == "12:00am") {
                        $("#ts_slider_container_" + link).remove();

                        scheduleRender.tempdeletedArray.push(link);

                        $this.find('#endTimePinAreaId > .ts_controllerTimeCls').html("12:00");
                        $this.find('#endTimePinAreaId > .ts_controllerAMPMCls').html("am");
                        $this.attr("data-link", "");
                        $this.attr("data-linkday", "");
                        $this.find('#endTimePinAreaId').show();

                        // activateFullDay($this);
                    }

                }
                else{

                    var startTime = $("#ts_slider_container_" + link).find('#startTimePinAreaId > .ts_controllerTimeCls').html();
                    var startTimeAmPm = $("#ts_slider_container_" + link).find('#startTimePinAreaId > .ts_controllerAMPMCls').html();
                    startTime = startTime + startTimeAmPm;
                    log.debug(" resettimer"+startTime);

                    if (startTime == "12:00am") {
                        //activateFullDay($this);
                        $("#ts_slider_container_" + link).remove();
                        scheduleRender.tempdeletedArray.push(link);

                        $this.find('#startTimePinAreaId > .ts_controllerTimeCls').html("12:00");
                        $this.find('#startTimePinAreaId > .ts_controllerAMPMCls').html("am");
                        $this.find('#startTimePinAreaId').show();
                        $this.attr("data-link", "");
                        $this.attr("data-linkday", "");

                    }
                }
            }
        }


        function touchendCall(e){

            var  $this = touchendObj;

            log.debug("touchendCall touchendCall touchendCall touchendCall " + nCountOfMoving);

            if ( nCountOfMoving > 10 )
            {
                deActivateTimeBar();
                nCountOfMoving = 0;
            }

            saveTimeRange($this, "true");
        
         }

          function showControlBtn($this) {
           // if ($(".Template_Area_Cls").css("display") != "block") {
                var mday = $this.attr("data-day");
                var mlinkedday = $this.attr("data-linkday");
                var mlink = $this.attr("data-link");
                var curr = $this.find("#ts_sliderContentArea");
                var isLinkNextDay = checkNextDay($this);
                //$this.find(".ts_dragbtn").addClass("ts_dragbtn_ud").removeClass("ts_dragbtn_sel ts_dragbtn_up ts_dragbtn_down");
                addControlBtn(mlink, mlinkedday, curr, isLinkNextDay);
            //}
        }

        function showCopyDelBtns($this) {
            $('.Template_Area_Cls').animate(
                {
                    'top':'100%'
                },
                {
                    complete: function()
                    {
                        $('.Template_Area_Cls').css({'display':'none'});
                    }
                }
            );
            
            
            $this.find(".ts_schcopydelbtnCls").css({
                "display" : "block"
            }); 
            

            checkTimebar = 1;
        }
      
        $(".helpBtnCls").on("tap", function(e) {
            var templateCategory = Utils.getUrlVars()["category"];
            if( checkTimebar != 1 || templateCategory == 'C') return;
            
            HelpPopUp("QS_STEP6");
        });

        function addEventsToTimer($curr) {
            log.debug("$curr:"+$curr.attr("id"),"addEventsToTimer");
            new FastClick(document.querySelector(".ts_slider_containerCls"));
            $curr.off('touchend touchcancel', '#ts_slider_container_' + params.index);
            $curr.on('touchend touchcancel', '#ts_slider_container_' + params.index, function(e) {
                log.debug("Inside touch end: ",$(this).attr("id"));
                if ($(".Template_Area_Cls").css("display") != "block")
                {
                    if ( isOpenSchList == false )
                    {
                        $(".ts_schcopydelbtnCls").hide();
                        if ( nCountOfMoving < 10 )
                        {
                            showCopyDelBtns($(this));
                            nCountOfMoving = 0;
                        }
                        var timebarLength = $(".ts_slider_containerCls").length;
                        if (timebarLength > 1) {
                            addGlobalTimeController($(this),"true");
                        }
                    }
                    else
                    {
						showCopyDelBtns($(this));
                        isOpenSchList = false;
                    }
                    offset = "";
                    direction = "";
                    bTSMoveAllowed = true;
                    bMoveEventActive = false;
                    touchendObj=$(this);
                    showControlBtn(touchendObj);
                    var eventObj = e;
                    var now = (new Date()).valueOf();
                    var diff = (now - lastTapp);
                    lastTapp = now;
                    log.debug("lastTap::"+lastTapp+"::diff:"+diff);

                    lastTapp = now ;

                    if ((diff < 350) && (diff > 100)) {
                        clearTimeout(touchendTimeOut);
                        activateFullDay($(this));
                        touchendCall(eventObj);
                    }

                    if ( diff >= 350 )
                    {
                        touchendTimeOut = setTimeout(function(){
                            touchendCall(eventObj);
                        }, 400);
                    }
                } else {
                        $(".ts_schcopydelbtnCls").hide();
                        $(".addtemplateBtn").show();
                        closePlayList();
                    }
            });

            $curr.find(".ts_slider_containerCls").draggable({
                containment : ".timelineSchTimerContainerCls",
                handle : ".ts_contentArea",
                revert : "invalid",
                zIndex : "999999999",
                distance : 9999999,
                start : function(event, ui) {
                    timeSpinnerChanged = false;
                    isDurationChange = false;
                    deactivateGlobaltimerbar();
                    scheduleRender.istimeBar = "true";
                    $(this).find(".ts_schcontrollerTimeCls").css("display", "block");
                    $(this).find(".ts_dragbtn").css("display", "none");
                    $(this).find("#copydelbtnId").css("display", "none");

                    if ($(this).attr("data-link") != "") {
                        var link = $(this).attr("data-link");
                        var linkday = $(this).attr("data-linkday");
                        var linkdayHght = $("#timer_" + linkday).find("#ts_slider_container_" + link).outerHeight();
                        var originalTimerHght = $(this).outerHeight();
                        originalTimerHght = originalTimerHght + linkdayHght;
                        $(this).attr("data-sliderlink", link);
                        $(this).height(originalTimerHght);
                        $("#timer_" + linkday).find("#ts_slider_container_" + link).remove();
                        linksliderHght = 0;

                    }
                },
                drag: function (event,ui)
                {
                    $(this).find(".ts_schcontrollerTimeCls").show();
                    var starttime = $(this).find('#startTimePinAreaId > .ts_controllerTimeCls').html();
                    var Ampm = $(this).find('#startTimePinAreaId > .ts_controllerAMPMCls').html();
                    var time = starttime + "::" + Ampm;
                    $(this).attr("data-sttime", time);
                },
                revert : function(event, ui) {
                    log.debug("inside Revert");
                    var curr = $curr;
                    var elem = $(this);

                    createdNewDraggedTimeBar(curr, elem);
                }
            });

            if (!bRegisterTimerTap) {
                bRegisterTimerTap = true;

                $(document).on('tap',"#SchedulePagehome", function(e) {
                    e.stopPropagation();
                    e.preventDefault();
                    log.debug("START ", "paste3");
                    $(".ts_contentArea").removeClass("dragActive");
                    if ($(".schTextNameCls").css("display") == "block") {
                        isOpenSchList = true;                        
                        $("#sch_dwndropdownId").trigger("tap");
                    }
                    if ($("#sch_copyMessgId").css("display") == "-webkit-box") {
                        deActivateTimeBar();
                        $(".ts_slider_containerCls").removeClass("copyObj");
                        scheduleRender.isCopyFlag = "false";
                        $("#sch_copyMessgId").css("display", "none");
                         $(".ts_copybtnCls").show();
                        $(".ts_delbtnCls").show();
                        $(".ts_undobtnCls").hide();
                        
                    }
                    log.debug("COMPLETE ", "paste");
                    return false;
                });

                $('.timerContainerCls').on('tap', function(e) {
                    log.debug("tap event1", "timerContainerCls");
                    e.preventDefault();
                    e.stopPropagation();
                    $("#templateAreaTemplatesId > li ").removeClass('templatePlaylist_container_Highlight');
                    //clearTimePinTimeout();
                  
                    if ($("#ScheduleTimePicker").css("display") == "block") {
                        setTimePinValue();
                    }
                      deActivateTimeBar();
                    var orginalSliderHeight = 0;
                    
                    var posY = e.clientY;
                    var winY = window.innerHeight;
                    
                    
                    if (scheduleRender.isCopyFlag == "true" && (posY/winY) < 0.92) {
                        var container = $(this);
                        var posY = e.clientY;
                        var clone = $(this).parent().find(".copyObj");
                        var link = $(clone).attr("data-link");
                        var sliderHeight = $(clone).outerHeight();
                        $(clone).removeClass("copyObj");
                        $(".ts_schcopydelbtnCls").hide();
                        checkTimebar = 0;
                        scheduleRender.isCopyFlag = "false";
                        $("#sch_copyMessgId").hide();
                        $(".ts_copybtnCls").show();
                        $(".ts_delbtnCls").show();
                        $(".ts_undobtnCls").hide();
                        if (link != "") {
                            var linkSliderHeight = $("#ts_slider_container_" + link).outerHeight();
                            orginalSliderHeight = sliderHeight + linkSliderHeight;
                            //   $(clone).height(orginalSliderHeight);
                        }
                        params.onCopy.call(this, container, e, clone, orginalSliderHeight);
                    }
                    if ($(".schTextNameCls").css("display") == "block") {
                        $("#sch_dwndropdownId").trigger("tap");
                        isOpenSchList = true;
                    }
                    $(".timelineAreaCls").trigger("tap");
                    return false;
                });
            }

            $curr.on('touchstart touchend touchcancel', '#ts_slider_container_' + params.index + ' #copybtnId');
            $curr.on('touchend touchcancel', '#ts_slider_container_' + params.index + ' #copybtnId', function(e) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            });
            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' #copybtnId', function(e) {
                log.debug("START1 ", "copy");
                e.preventDefault();
                e.stopPropagation();
                $(this).parent().parent().addClass("copyObj");
                scheduleRender.isCopyFlag = "true";
                $("#sch_copyMessgId").css("display", "-webkit-box");
                if( langObj.Schedule.MIA_SID_SELECT_A_PASTE_LOCATION.length > 24)
                {
                    $('.sch_copyMessgCls').css({'height':'10%'});
                }
                deActivateTimeBar();
                $('.addtemplateBtn').hide();
                $(".ts_schcopydelbtnCls").show();
                $(".ts_copybtnCls").hide();
                $(".ts_delbtnCls").hide();
                $(".ts_undobtnCls").show();
                log.debug("COMPLETE ", "copy");
                return false;
            });
            $curr.off('touchstart touchend touchcancel', '#ts_slider_container_' + params.index + ' #delbtnId');
            $curr.on('touchend touchcancel', '#ts_slider_container_' + params.index + ' #delbtnId', function(e) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            });
            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' #delbtnId', function(e) {
                log.debug("START delete timeSlider", "DELETE");
                var delObj = $(this).parent().parent();
                var delObjIndex = delObj.attr("data-frameIndex");
                var day = delObj.attr("data-day");
                $("#templateAreaTemplatesId > li ").removeClass('templatePlaylist_container_Highlight');
                if (delObj.attr("data-link") != "") {
                    var linkday = delObj.attr("data-linkday");
                    var link = delObj.attr("data-link");
                    $("#timer_" + linkday).find("#ts_slider_container_" + link).remove();
                    delObj.attr("data-link", "");
                    delObj.attr("data-linkday", "");
                    params.onDelete.call(this, link, params.color);
                }

                log.debug("frameindex of deleted obj=" + delObjIndex, "addEventsToTimer");
                delObj.remove();
                var timebarLength = $(".ts_slider_containerCls").length;
                if (timebarLength == 0 || $(".ts_disabled").length == timebarLength) {
                    $("#sch_nxtBtnId").addClass("btn_disabledCls");
                    $("#saveBtn").addClass("btn_disabledCls");
                    $('div#landScapeDivId').removeClass("icon-disabled");
                }
                params.onDelete.call(this, delObjIndex, params.color);
                log.debug("COMPLETE delete timeSlider", "DELETE");
                $('.addtemplateBtn').show();

                if ($(".ts_slider_containerCls").length == 0){
                    $('#saveOnlyBtn').addClass("icon-disabled");
                    $('#saveAsBtn').addClass("icon-disabled");
                }
            });
            $curr.off('touchstart touchcancel touchend', '.ts_undobtnCls');
            $curr.on('touchend touchcancel', '.ts_undobtnCls', function(e) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            });
            $curr.on('touchstart', '.ts_undobtnCls', function(e) {
                e.preventDefault();
                e.stopPropagation();
                deActivateTimeBar();
                $(".ts_slider_containerCls").removeClass("copyObj");
                scheduleRender.isCopyFlag = "false";
                $("#sch_copyMessgId").css("display", "none");
         
                $('.addtemplateBtn').hide();
                $(".ts_schcopydelbtnCls").show();
                $(".ts_copybtnCls").show();
                $(".ts_delbtnCls").show();
                $(".ts_undobtnCls").hide();
                showControlBtn(touchendObj);
                var timebarLength = $(".ts_slider_containerCls").length;
                if (timebarLength > 1) {
                    addGlobalTimeController(touchendObj,"true");
                }
                return false;
            });
            $curr.off('touchmove touchend touchcancel', '#ts_slider_container_' + params.index + ' > #startTimePinAreaId,#endTimePinAreaId');
            $curr.on('touchmove touchend touchcancel', '#ts_slider_container_' + params.index + ' > #startTimePinAreaId,#endTimePinAreaId',function(e){
                e.stopPropagation();
                e.preventDefault();
                return false;
            });

            $curr.off('touchstart', '#ts_slider_container_' + params.index + ' > #startTimePinAreaId');
            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' > #startTimePinAreaId', function(e) {
                e.preventDefault();
                e.stopPropagation();
                temp = $(this);
                checkTimebar = 0;
                createSpinDiv(temp);
                return false;
            });
            $curr.off('touchstart', '#ts_slider_container_' + params.index + ' > #endTimePinAreaId');
            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' > #endTimePinAreaId', function(e) {
                e.preventDefault();
                e.stopPropagation();
                temp = $(this);
                checkTimebar = 0;
                createSpinDiv(temp);
                return false;
            });
    
            $(".ts_dragbtn").doubleTap(function(e) {
                activateFullDay($(this).parent());
                deactivateGlobaltimerbar();
            });
            $(".ts_slider_containerCls").droppable({
                over : function(event, ui) {

                    if (!$(this).hasClass("ts_disabled") && !(ui.draggable[0].className == "playListLiCls ui-sortable-helper")) {
                        $(this).css("opacity", "0.4");
                    }

                },
                out : function(event, ui) {

                    if (!$(this).hasClass("ts_disabled")) {
                        $(this).css("opacity", "1");
                    }

                },
                drop : function(event, ui) {
                    $(this).css("opacity", "1");
                }
            });

            $curr.on('touchmove', function(e) {
                log.debug("curr onmove" + bTSMoveAllowed + " isGlobalTimeBar = " + isGlobalTimeBar);
                if (!bTSMoveAllowed) {
                    return;
                }
                var curX = e.originalEvent.touches[0].clientX;
                var $currleft = $curr.offset().left;
                var $currWidth = $curr.width();
                var $currRight = $currleft + $currWidth;
                var sliderHeight = $curr.find("#ts_slider_container_" + params.index).outerHeight();
                var link = $curr.find("#ts_slider_container_" + params.index).attr("data-link");
                var linkday = $curr.find("#ts_slider_container_" + params.index).attr("data-linkday");
                var orginalSliderHeight = 0;

                if (getParseIntInDec(curX) < getParseIntInDec($currleft) || getParseIntInDec(curX) > getParseIntInDec($currRight)) {
                    if (isGlobalTimeBar == "false") {
                        log.debug("Inside condition" + bTSMoveAllowed);
                        //$curr.find("#ts_slider_container_" + params.index).draggable("option", "distance", 10);

                        $(".ts_slider_containerCls").draggable("option", "distance", 10);
                        bTSMoveAllowed = false;
                        bMoveEventActive = false;
                    }
                    $curr.parent().children().removeClass("timerContainerCls-active");
                }

            });
            $('.timerContainerCls').on('tap', function(e) {
                
                if ($("#spinDiv").css("display") == "block") {
                    setTimePinValue();
                }
                var orginalSliderHeight = 0;
                if (scheduleRender.isCopyFlag == "true") {
                    var container = $(this);
                    var posY = e.clientY;
                    var clone = $(this).parent().find(".copyObj");
                    var link = $(clone).attr("data-link");
                    var sliderHeight = $(clone).outerHeight();
                    $(clone).removeClass("copyObj");
                    $(this).parent().find(".ts_schcopydelbtnCls").css("display", "none");
                    scheduleRender.isCopyFlag = "false";
                    $("#sch_copyMessgId").css("display", "none");
                    if (link != "") {
                        var linkSliderHeight = $("#ts_slider_container_" + link).outerHeight();
                        orginalSliderHeight = sliderHeight + linkSliderHeight;
                        //   $(clone).height(orginalSliderHeight);
                    }
                    log.debug("orginalSliderHeight:::"+orginalSliderHeight);
                    ////log.debug("container" + container + "posY" + posY + "clone" + clone);
                    params.onCopy.call(this, container, e, clone, orginalSliderHeight);
                }
                if ($(".schTextNameCls").css("display") == "block") {
                    $("#sch_dwndropdownId").trigger("tap");
                    isOpenSchList = true;
                }
            });
          
        }

        function setTimePinValue() {
            $("#spinDiv").remove();
            if (isInvalidTime == "true") {
                var changedTime = savedTime.split("::");
                var startTime = changedTime[0];
                var startTimeAmPm = changedTime[1];
                var slider = temp.parent().attr("id");
                var sliderDay = $("#" + slider).attr("data-day");
                var timePinId = temp.attr("id");

                $("#timer_" + sliderDay).find("#" + slider + " > #" + timePinId + " > .ts_controllerTimeCls").html(startTime).css({
                    "text-decoration" : " none"
                });
                $("#timer_" + sliderDay).find("#" + slider + " > #" + timePinId + " > .ts_controllerAMPMCls").html(startTimeAmPm).css({
                    "text-decoration" : " none"
                });
                isInvalidTime = "false";

            }
            currentTime = "";
        }

        function activateFullDay($this) {
            var $thisElem = $this;
            var $link = $thisElem.attr("data-link");
            var $linkday = $thisElem.attr("data-linkday");
            isDurationChange = true;
            
            if ($link != "") {
                try
                {
                    var vPlayListObj = SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[getParseIntInDec($link)].Playlist[0];
                    if (vPlayListObj.Playlist_Name != '') {
                        vPlayListObj.isDeleted=true;
                    }
                    else
                    {
                        vPlayListObj.Content[0].File[0].isDeleted = true;
                    }
                }
                catch(ex)
                {
                    log.debug("error in setting delete flag"+ex.message,"activateFullDay");
                }
                $("#timer_" + $linkday).find("#ts_slider_container_" + $link).remove();
                $thisElem.attr("data-link", "");
                $thisElem.attr("data-linkday", "");
                scheduleRender.tempdeletedArray.push(getParseIntInDec($link));
            }
            
            var startTime = "00:00::am";
            var endTime = "00:00::am";
            setTimeRange($thisElem, startTime, endTime);
            $thisElem.find('#startTimePinAreaId > .ts_controllerTimeCls').html("12:00");
            $thisElem.find('#startTimePinAreaId > .ts_controllerAMPMCls').html("am");
            $thisElem.find('#endTimePinAreaId > .ts_controllerTimeCls').html("12:00");
            $thisElem.find('#endTimePinAreaId > .ts_controllerAMPMCls').html("am");
            isFullDay = "true";
            $thisElem.attr("data-duration", "24:00");
            $('#ts_slider_container_' + $link).attr("data-duration", "24:00");

            $thisElem.find('#startTimePinAreaId').show();
            $thisElem.find('#endTimePinAreaId').show();            

            deactivateGlobaltimerbar();
            resetHeight();
        }

        function deActivateTimeBar() {

            log.debug("deActivateTimeBar");
            
            $('.addtemplateBtn').show();            

            $(".ts_contentArea").removeClass("ts_slider_container_highlight dragActive");
            $(".ts_dragbtn").css("display", "none");
            $(".ts_schcontrollerTimeCls").css("display", "none");
            $(".ts_schcopydelbtnCls").css("display", "none");
            if (scheduleRender.isCopyFlag == "false")
            {
                checkTimebar=0;
            }
            
            deactivateGlobaltimerbar();

        }


        function getTimeBarDuration($this) {

            var $link = $this.attr("data-link");

            var minuteOfStartTime = getMinuteFromPin($this,"start");
            var minuteOfEndTime = getMinuteFromPin($this,"end");

            var minuteOfLinkedStartTime = 0;
            var minuteOfLinkedEndTime = 0;

            var durationTime;
            var minuteOfDurationTime;

            log.debug("$link : " + $link);
            
            if ( $link != "" )
            {
                minuteOfLinkedStartTime = getMinuteFromPin($('#ts_slider_container_' + $link ),"start");
                minuteOfLinkedEndTime = getMinuteFromPin($('#ts_slider_container_' + $link ),"end");

                if ( isNextDay($this) == "true" )
                {
                    minuteOfEndTime = 1440;
                    minuteOfLinkedStartTime = 0;
                }
                else
                {
                    minuteOfStartTime = 0;
                    minuteOfLinkedEndTime = 1440;                    
                }
            }

            if ( minuteOfStartTime < 0 )
                minuteOfStartTime = 0;

            if ( minuteOfEndTime > 1440 )
                minuteOfEndTime = 1440;

            if ( minuteOfLinkedStartTime < 0 )
                minuteOfLinkedStartTime = 0;

            if ( minuteOfLinkedEndTime > 1440 )
                minuteOfLinkedEndTime = 1440;


            minuteOfDurationTime = (minuteOfEndTime - minuteOfStartTime) + (minuteOfLinkedEndTime - minuteOfLinkedStartTime);
            durationTime = minuteToTime(minuteOfDurationTime);

            return durationTime;

        }

        function checkMaxDuration(currObj, $this) {
            var duration = getTimeBarDuration($this);
            var durtn_tt = duration.split(":");
            var duratn_hh = durtn_tt[0];
            var duratn_mm = durtn_tt[1];
            var totalMin = (getParseIntInDec(duratn_hh) * 60) + getParseIntInDec(duratn_mm);
            if (getParseIntInDec(totalMin) >= 1440) {
                isFullDay = "true";
                return "true";
            } else {
                isFullDay = "false";
                return "false";
            }

        }

        function addEndTime(duratn, endTime) {
            var t1 = duratn.split(":");
            var t2 = endTime.split(":");
            var hh = getParseIntInDec(t1[0]) + getParseIntInDec(t2[0]);
            var mm = getParseIntInDec(t1[1]) + getParseIntInDec(t2[1]);
            if (getParseIntInDec(mm) >= 60) {
                mm = mm - 60;
                hh = hh + 1;
            }

            mm = (mm < 10 ? "0" : "") + mm;

            return hh + ":" + mm;
        }
        

        function addTwoTimes(firstTime, secondTime) {
            
            var t1 = firstTime.split(":");
            var t2 = secondTime.split(":");

            var hh = getParseIntInDec(t1[0]) + getParseIntInDec(t2[0]);
            var mm = getParseIntInDec(t1[1]) + getParseIntInDec(t2[1]);
            
            if (getParseIntInDec(mm) >= 60) {
                mm = mm - 60;
                hh = hh + 1;
            }
            else if (getParseIntInDec(mm) < 0) {
                mm = mm + 60;
                hh = hh - 1;
            } 

            hh = ((hh >= 0 && hh < 10) ? "0" : "") + hh;
            mm = (mm < 10 ? "0" : "") + mm;
                
            return hh + ":" + mm;
        }


        function isNextDay(currObj) {
            
            var mday = $(currObj).attr("data-day");
            var mlinkedday = $(currObj).attr("data-linkday");
            
            var dayIndex = getDayIndex(mday);
            var linkeddayIndex = getDayIndex(mlinkedday);

            var sliderDiff;
            var isNextDay = getParseIntInDec(dayIndex) < getParseIntInDec(linkeddayIndex) ? "true" : "false";
            
            if(mday=="sat" && mlinkedday == "sun")
            {
                isNextDay="true";
            }
            if(mday=="sun" && mlinkedday == "sat")
            {
                isNextDay="false";
            }
            
            log.debug("isNextDay::"+isNextDay);
            
            return isNextDay;
        }                    
        



        function displayPinTime(currObj,index,startTime,endTime,direction)
        {

            if (direction == "up")
            {
                currObj.find('#ts_slider_container_' + index + ' > #startTimePinAreaId > .ts_controllerTimeCls').html(time24ToTime12(startTime)).css({
                    "text-decoration" : " none"
                });
                currObj.find('#ts_slider_container_' + index + '> #startTimePinAreaId > .ts_controllerAMPMCls').html(amOrPmFromTime24(startTime)).css({
                    "text-decoration" : " none"
                });
            }
            else if (direction == "down")
            {
                currObj.find('#ts_slider_container_' + index + ' > #endTimePinAreaId > .ts_controllerTimeCls').html(time24ToTime12(endTime)).css({
                    "text-decoration" : " none"
                });
                currObj.find('#ts_slider_container_' + index + '> #endTimePinAreaId > .ts_controllerAMPMCls').html(amOrPmFromTime24(endTime)).css({
                    "text-decoration" : " none"
                });
            }
            else
            {
                currObj.find('#ts_slider_container_' + index + ' > #startTimePinAreaId > .ts_controllerTimeCls').html(time24ToTime12(startTime)).css({
                    "text-decoration" : " none"
                });
                currObj.find('#ts_slider_container_' + index + '> #startTimePinAreaId > .ts_controllerAMPMCls').html(amOrPmFromTime24(startTime)).css({
                    "text-decoration" : " none"
                });                
                currObj.find('#ts_slider_container_' + index + ' > #endTimePinAreaId > .ts_controllerTimeCls').html(time24ToTime12(endTime)).css({
                    "text-decoration" : " none"
                });
                currObj.find('#ts_slider_container_' + index + '> #endTimePinAreaId > .ts_controllerAMPMCls').html(amOrPmFromTime24(endTime)).css({
                    "text-decoration" : " none"
                });
            }                
        }



        function calculateFinalTime($this,timeduration){
            
            if(timeSpinnerChanged==true)
            {
                return;
            }

            log.debug("In Calculate Final time : "+timeduration);
            
            var $link = $this.attr("data-link");
            var isLinkNextday = checkNextDay($this);
            var $timeDuration = timeduration;
            
            var containerHeight = $this.parent().outerHeight();
            
            var hh_time;
            
            if($timeDuration!= undefined)
                hh_time=$timeDuration.split(":")[0];
            
            if(getParseIntInDec(hh_time) < 24)
            {
                isFullDay="false";
            }
            else{
                isFullDay="true";
            }

            if (isFullDay == 'true' && $link == "") {

                activateFullDay($this);
            }

            
            if(isFullDay == 'false' && $link =="")
            {            
                var startTime = $this.find('#startTimePinAreaId > .ts_controllerTimeCls').html();
                var startTimeAmPm = $this.find('#startTimePinAreaId > .ts_controllerAMPMCls').html();
                var endTime = $this.find('#endTimePinAreaId > .ts_controllerTimeCls').html();
                var endTimeAmPm = $this.find('#endTimePinAreaId > .ts_controllerAMPMCls').html();
                var endTimeArray=endTime.split(":");
                var hh_end_time= endTimeArray[0];
                var mm_end_time= endTimeArray[1];
                mm_end_time = Math.round(getParseIntInDec(mm_end_time) / 10) * 10;

                if (mm_end_time == 60) {
                    hh_end_time = hh_end_time + 1;
                    mm_end_time = 0;
                }
                
                mm_end_time=Utils.convertToDblDigit(getParseIntInDec(mm_end_time));
                hh_end_time=Utils.convertToDblDigit(getParseIntInDec(hh_end_time));
                endTime=hh_end_time+":"+mm_end_time;

                $this.find('#endTimePinAreaId > .ts_controllerTimeCls').html(endTime);
                $this.find('#endTimePinAreaId > .ts_controllerAMPMCls').html(endTimeAmPm);

                /*setTimeRange($this, (startTime + "::" + startTimeAmPm), (endTime + "::" + endTimeAmPm));*/

            }

            log.debug("$timeDuration"+$timeDuration+"::isfull::"+isFullDay+"isDurationChange::"+isDurationChange);

            if (($link != "") ) {
                
                var isLinkNextDay = checkNextDay($this);

                if ((isLinkNextDay == "true") && (isDurationChange == false)) {
                    
                    log.debug("inside dssds");
                    var startTime = $this.find('#startTimePinAreaId > .ts_controllerTimeCls').html();
                    var startTimeAmPm = $this.find('#startTimePinAreaId > .ts_controllerAMPMCls').html();
                    var hh_st_time = startTime.split(":")[0];
                    var mm_st_time = startTime.split(":")[1];
                    if (startTimeAmPm == "pm" && getParseIntInDec(hh_st_time) != 12) {
                    startTime = convertTimePinFormat(startTime + "::pm", 24);
                    }
                    var sliderduratn = ScheduleUtils.getDuration(startTime, "24:00");
                    var linksliderDuration = ScheduleUtils.getDuration(sliderduratn, $timeDuration);
                    var hh_stlink_time = linksliderDuration.split(":")[0];
                    var endTime;
                    var endTimeAmPm;

                    if (getParseIntInDec(hh_stlink_time) > 12) {
                    endTime = convertTimePinFormat(linksliderDuration + "::pm", 12);
                    endTimeAmPm = "pm";
                    } else {
                    endTime = linksliderDuration;
                    endTimeAmPm = "am";

                    }
                    var endTimeArray=endTime.split(":");
                    var hh_end_time= endTimeArray[0];
                    var mm_end_time= endTimeArray[1];
                    mm_end_time = Math.round(getParseIntInDec(mm_end_time) / 10) * 10;

                    if (mm_end_time == 60) {
                    hh_end_time = hh_end_time + 1;
                    mm_end_time = 0;
                    }
                    mm_end_time=Utils.convertToDblDigit(getParseIntInDec(mm_end_time));
                    hh_end_time=Utils.convertToDblDigit(getParseIntInDec(hh_end_time));
                    endTime=hh_end_time+":"+mm_end_time;
                    setTimeRange($("#ts_slider_container_" + $link), "00:00::am" , (endTime + "::" + endTimeAmPm));
                    $("#ts_slider_container_" + $link).find('#endTimePinAreaId > .ts_controllerTimeCls').html(endTime);
                    $("#ts_slider_container_" + $link).find('#endTimePinAreaId > .ts_controllerAMPMCls').html(endTimeAmPm);
                    resetTimebar($this);
                    
                } else {
                
                    
                    var endTime = $this.find('#endTimePinAreaId > .ts_controllerTimeCls').html();
                    var endTimeAmPm = $this.find('#endTimePinAreaId > .ts_controllerAMPMCls').html();
                    
                    var hh_end_time = endTime.split(":")[0];
                    var mm_end_time = endTime.split(":")[1];
                    
                    if (endTimeAmPm == "pm" && getParseIntInDec(hh_end_time) != 12) {
                        endTime = convertTimePinFormat(endTime + "::pm", 24);
                    }

                    
                    var sliderduratn = ScheduleUtils.getDuration("00:00", endTime);

                    var linksliderDuration = ScheduleUtils.getDuration(sliderduratn, $timeDuration);
                    linksliderDuration = ScheduleUtils.getDuration(linksliderDuration, "24:00");
                    var hh_stlink_time = linksliderDuration.split(":")[0];

                    var startTime;
                    var startTimeAmPm;

                    if (getParseIntInDec(hh_stlink_time) > 12) {

                        startTime = convertTimePinFormat(linksliderDuration + "::pm", 12);
                        startTimeAmPm = "pm";
                    } else {
                        startTime = linksliderDuration;
                        startTimeAmPm = "am";

                    }
                    
                    var startTimeArray=startTime.split(":");
                    var hh_start_time= startTimeArray[0];
                    var mm_start_time= startTimeArray[1];
                    mm_start_time = Math.round(getParseIntInDec(mm_start_time) / 10) * 10;

                    if (mm_start_time == 60) {
                        hh_start_time = hh_start_time + 1;
                        mm_start_time = 0;
                    }
                    
                    hh_start_time=Utils.convertToDblDigit(getParseIntInDec(hh_start_time));
                    mm_start_time=Utils.convertToDblDigit(getParseIntInDec(mm_start_time));
                    
                    log.debug("hh_start_time============="+hh_start_time+" mm_start_time:"+mm_start_time);
                    startTime=hh_start_time+":"+mm_start_time;
                    setTimeRange($("#ts_slider_container_" + $link), (startTime + "::" + startTimeAmPm),"00:00::am");
                    $("#ts_slider_container_" + $link).find('#startTimePinAreaId > .ts_controllerTimeCls').html(startTime);
                    $("#ts_slider_container_" + $link).find('#startTimePinAreaId > .ts_controllerAMPMCls').html(startTimeAmPm);
                    resetTimebar($this);
                    
                    
                }


            }
            
            setTimeout(function() {
                saveTimeRange($this, "true");
            }, 200); 

        }
        function rgb2hex(rgb) {
        var hexDigits = ["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];
        rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
        function hex(x) {
        return isNaN(x) ? "00" : hexDigits[(x - x % 16) / 16] + hexDigits[x % 16];
        }
        return "#" + hex(rgb[1]) + hex(rgb[2]) + hex(rgb[3]);
        }

        function saveTimeRange(currObj, isMultiple) {

            log.debug("saveTimeRange saveTimeRange saveTimeRange ");

            var minuteOfStartTime = getMinuteFromPin(currObj, "start");
            var startTime = minuteToTime(minuteOfStartTime);
            var minuteOfEndTime = getMinuteFromPin(currObj, "end");
            var endTime = minuteToTime(minuteOfEndTime);
            var colorCode = currObj.find('#ts_sliderContentArea').css("background-color");
            if (colorCode != "") {
                colorCode = rgb2hex(colorCode);
            }
            var type = currObj.attr("data-type");
            var index = currObj.attr("data-frameIndex");
            var sliderlink = currObj.attr("data-link");
            var sliderlinkday = currObj.attr("data-linkday");
            var day = currObj.attr("data-day");
            var templatedId = currObj.attr("data-templateId");
            var playlistName = currObj.attr("data-playlist");
            var minuteOfDurationTime = minuteOfEndTime - minuteOfStartTime;
            var durationTime = minuteToTime(minuteOfDurationTime);

            log.debug("durationTime : " + $(currObj).attr("data-duration"));
            log.debug("startTime : " + startTime);
            log.debug("endTime : " + endTime);
            log.debug("sliderlink : " + sliderlink);
            log.debug("sliderlinkday : " + sliderlinkday);
            log.debug("day : " + day);
            log.debug("getDayIndex(day) : " + getDayIndex(day));
            log.debug("getDayIndex(sliderlinkday) : " + getDayIndex(sliderlinkday));

            if (startTime == "00:00" && endTime == "24:00") {
                sliderlink = "";
                sliderlinkday = "";
            }

            if (sliderlinkday != "" && (getDayIndex(day) < getDayIndex(sliderlinkday) || getDayIndex(day) == 6 )) {
                endTime = "24:00";
            } else if (sliderlinkday != "" && (getDayIndex(day) > getDayIndex(sliderlinkday) || getDayIndex(day) == 0 )) {
                startTime = "00:00";
                minuteOfStartTime = minuteOfEndTime - 1440;
                log.debug("minuteOfStartTime : " + minuteOfStartTime);
            }

            log.debug("durationTime : " + durationTime);
            $(currObj).attr("data-duration", durationTime);
            params.onTimeChange.call(this, startTime, endTime, colorCode, day, index, type, sliderlink, sliderlinkday, templatedId, playlistName);

            var minuteOfLinkedStartTime = 0;
            var linkedStartTime;

            var minuteOfLinkedEndTime = 0;
            var linkedEndTime;

            log.debug("scheduleRender.istimeBar : " + scheduleRender.istimeBar);

        
            if (sliderlink != "" && isMultiple != "false") {

                minuteOfLinkedStartTime = getMinuteFromPin($('#ts_slider_container_' + sliderlink), "start");
                linkedStartTime = minuteToTime(minuteOfLinkedStartTime);

                minuteOfLinkedEndTime = getMinuteFromPin($('#ts_slider_container_' + sliderlink), "end");
                linkedEndTime = minuteToTime(minuteOfLinkedEndTime);

                var colorCode = $('#ts_slider_container_' + sliderlink + ' > #ts_sliderContentArea').css("background-color");
                if (colorCode != "") {
                    colorCode = rgb2hex(colorCode);
                }
                var type = $('#ts_slider_container_' + sliderlink).attr("data-type");
                var index = $('#ts_slider_container_' + sliderlink).attr("data-frameIndex");
                var slink = $('#ts_slider_container_' + sliderlink).attr("data-link");
                var slinkday = $('#ts_slider_container_' + sliderlink).attr("data-linkday");
                var templatedId = currObj.attr("data-templateId");
                var playlistName = currObj.attr("data-playlist");
                if (isNextDay(currObj) == "false") {
                    log.debug("minuteOfEndTime : " + minuteOfEndTime);
                    log.debug("minuteOfLinkedStartTime : " + minuteOfLinkedStartTime);
                    minuteOfDurationTime = minuteOfEndTime + (1440 - minuteOfLinkedStartTime);
                    linkedEndTime = "24:00";
                } else {
                    log.debug("minuteOfStartTime : " + minuteOfStartTime);
                    log.debug("minuteOfLinkedEndTime : " + minuteOfLinkedEndTime);
                    minuteOfDurationTime = (1440 - minuteOfStartTime) + minuteOfLinkedEndTime;
                    linkedStartTime = "00:00";
                }

                durationTime = minuteToTime(minuteOfDurationTime);

                $(currObj).attr("data-duration", durationTime);
                $('#ts_slider_container_' + sliderlink).attr("data-duration", durationTime);

                log.debug("minuteOfDurationTime : " + minuteOfDurationTime);
                log.debug("durationTime : " + durationTime);
                log.debug("linkedStartTime : " + linkedStartTime);
                log.debug("linkedEndTime : " + linkedEndTime);

                params.onTimeChange.call(this, linkedStartTime, linkedEndTime, colorCode, sliderlinkday, index, type, slink, slinkday, templatedId, playlistName);

            }

        }




        function get24TimeFromPosition(currsliderTop) {

            var hh_time;
            var mm_time;
                
            if ( currsliderTop >= containerTopPosY )
            {
                hh_time = Math.floor((currsliderTop - containerTopPosY) / HHInt);
                mm_time = Math.round((((currsliderTop - containerTopPosY) % HHInt)) / (MMInt) / 10 ) * 10;
            }
            else
            {
                hh_time = Math.floor((containerTopPosY - currsliderTop) / HHInt);
                mm_time = Math.round((((containerTopPosY - currsliderTop) % HHInt)) / (MMInt) / 10 ) * 10;    
            }

            if (mm_time == 60) {
                hh_time = hh_time + 1;
                mm_time = 0;
            }


            hh_time = (hh_time < 10 && hh_time >= 0 ? "0" : "") + hh_time;
            mm_time = (mm_time < 10 && mm_time >= 0 ? "0" : "") + mm_time;


            
            var range;

            if ( currsliderTop >= containerTopPosY ||(hh_time == "00" && mm_time == "00"))
            {
                range = hh_time + ":" + mm_time;
            }            
            else
            {                
                range = "-"+hh_time + ":-" + mm_time;
            }                
            
            log.debug("get24TimeFromPosition range : " + range);
            
            return range;
            
        }

        function time24ToTime12(inputTime) {

            var hh_time = inputTime.split(":")[0];
            var mm_time = inputTime.split(":")[1];

            if ( getParseIntInDec(hh_time) >= 12 )
            {
                hh_time = hh_time - 12;
                hh_time = (hh_time < 10 && hh_time >= 0 ? "0" : "") + hh_time;
            }
            
            if ( hh_time == "00" )
                hh_time = "12";            

            return hh_time + ":" + mm_time;
            
        }
        

        function amOrPmFromTime24(inputTime) {

            var hh_time = inputTime.split(":")[0];

            if ( getParseIntInDec(hh_time) >= 12 && getParseIntInDec(hh_time) != 24 )
                return "pm";

            return "am";
            
        }

        
        function timeToMinute(inputTime) {

            var hh_inputTime = inputTime.split(":")[0];
            var mm_inputTime = inputTime.split(":")[1];

            return getParseIntInDec(hh_inputTime*60) + getParseIntInDec(mm_inputTime);
        }


        function minuteToTime(input) {

            var hh_time = Math.floor(input / 60);
            var mm_time = input % 60;

            hh_time = (hh_time < 10 && hh_time >= 0 ? "0" : "") + hh_time;
            mm_time = (mm_time < 10 && mm_time >= 0 ? "0" : "") + mm_time;
            
            
            return hh_time + ":" + mm_time;
        }


        function minuteToPos(input) {
                    
            return input*MMInt;
        }
        

        function getMinuteFromPin(curr,IsStartTimeOrEndTime)
        {
            var time;
            var timeAmPm;
            
            if ( IsStartTimeOrEndTime == "start" )
            {
                time = curr.find("#startTimePinAreaId > .ts_controllerTimeCls").text().trim();
                timeAmPm = curr.find("#startTimePinAreaId > .ts_controllerAMPMCls").text();
            }
            else
            {            
                time = curr.find("#endTimePinAreaId > .ts_controllerTimeCls").text();
                timeAmPm = curr.find("#endTimePinAreaId > .ts_controllerAMPMCls").text();
            }

            if ( time == undefined || time == "" )
            {
                if ( IsStartTimeOrEndTime == "start" )
                    return 1440;
                 else
                     return 0;
            }
            
            var ret = timeToMinute(time);

            log.debug("time " + time);

            if ( timeAmPm == "am" && ret >= 720 )
                ret = ret - 720;

            if ( ret < 720 && timeAmPm == "pm" )
                ret = ret + 720;

            if ( ret > 1440 )
                ret = 1440;

            if ( ret == 0 && IsStartTimeOrEndTime == "end" )
                ret = 1440;

            log.debug("ret " + ret);
            
            return ret;
            
        }


        function createNxtTimeBar(curr, duration) {

            var day = curr.attr("data-day");
            var color = curr.attr("data-color");
            var frameIndex = curr.attr("data-frameIndex");
            var type = curr.attr("data-type");
            var templateIndex = curr.attr("data-templateId");
            var playlistname = curr.attr("data-playlist");
            var mlinkedday = curr.attr("data-linkday");
            var mlink = curr.attr("data-link");

            log.debug("createNxtTimeBar mlinkedday : " + mlinkedday);
            log.debug("createNxtTimeBar data-link : " + curr.attr("data-link"));

            if (curr.attr("data-link") != ""){

                var linkContainer = $('#ts_slider_container_' + curr.attr("data-link") );
                
                $(linkContainer).attr("data-link", "");
                $(linkContainer).attr("data-linkday", "");
                $(linkContainer).remove();
                setDeleteFrameFlag(type, mlink);
                scheduleRender.tempdeletedArray.push(getParseIntInDec(mlink));
                curr.attr("data-link","");
                curr.attr("data-linkday", "");

                mlink = "";
                log.debug("createNxtTimeBar remove");
            }

            
            if (mlink == "") {
                var loopedDay = ScheduleUtils.getNextDay(day);
                                
                var totalDuration= curr.attr("data-duration");
                
                createFrameSchedule(null, loopedDay, "00:00", duration, color, frameIndex, false, false, true);
                createUpdateTimeLine(loopedDay, "00:00", "00:00", color, scheduleRender.timerIndex, type, frameIndex, day, templateIndex, playlistname, true,totalDuration);

                curr.attr("data-linkday", loopedDay);
                curr.attr("data-link", scheduleRender.timerIndex);
                
                link = curr.attr("data-link");
                linkday = curr.attr("data-linkday");

                $("#timer_" + linkday).find("#ts_slider_container_" + link+" > .ts_contentArea").addClass("ts_slider_container_highlight");
            }

            
            link = curr.attr("data-link");
            linkday = curr.attr("data-linkday");
            enableDisabledTimeBar($("#timer_" + linkday), curr);
            var zIndex = curr.css("z-index");
            $("#timer_" + linkday).find("#ts_slider_container_" + link).css("z-index", zIndex);
             $("#timer_" + linkday).find("#ts_slider_container_" + link).attr("data-zIndex", zIndex);
            $("#timer_" + linkday).find("#ts_slider_container_" + link).find('#endTimePinAreaId').show();
             $("#timer_" + linkday).find("#ts_slider_container_" + link).css({
                'height' : getParseIntInDec(minuteToPos(duration)) + 'px',

            });
            var linkContainer = $("#timer_" + linkday);
        
            // currlinkSliderBtm = ((conTopPos) + $("#ts_slider_container_" + link).outerHeight() );

            var endTime = minuteToTime(duration);

            displayPinTime(linkContainer,link,"00:00",endTime,"move");

        }

        

        function createPrevTimeBar(curr, duration) {

            var day = curr.attr("data-day");
            var color = curr.attr("data-color");
            var frameIndex = curr.attr("data-frameIndex");
            var type = curr.attr("data-type");
            var templateIndex = curr.attr("data-templateId");
            var playlistname = curr.attr("data-playlist");
            var mlinkedday = curr.attr("data-linkday");
            var mlink = curr.attr("data-link");


            log.debug("createPrevTimeBar mlinkedday : " + mlinkedday);
            log.debug("createPrevTimeBar data-link : " + curr.attr("data-link"));
            log.debug("createPrevTimeBar duration : " + duration);

            // in case timebar is 24h, if time bar is moved, it happen error. So it needs to delete & create timebar.
            if (curr.attr("data-link") != "" ) {

                var linkContainer = $('#ts_slider_container_' + curr.attr("data-link") );
                
                $(linkContainer).attr("data-link", "");
                $(linkContainer).attr("data-linkday", "");
                $(linkContainer).remove();
                 setDeleteFrameFlag(type, mlink);
                 scheduleRender.tempdeletedArray.push(getParseIntInDec(mlink));
                curr.attr("data-link","");
                curr.attr("data-linkday", "");

                mlink = "";
                log.debug("createPrevTimeBar remove");
            }
                                    
            
            if (mlink == "") {
                var loopedDay = ScheduleUtils.getPrevDay(day);

                log.debug("createPrevTimeBar loopedDay : " + loopedDay);
                
                var totalDuration= curr.attr("data-duration");
                createFrameSchedule(null, loopedDay, "24:00", duration, color, frameIndex, false, false, true);
                createUpdateTimeLine(loopedDay, "24:00", "24:00", color, scheduleRender.timerIndex, type, frameIndex, day, templateIndex, playlistname, true,totalDuration);

                curr.attr("data-linkday", loopedDay);
                curr.attr("data-link", scheduleRender.timerIndex);

                link = curr.attr("data-link");
                linkday = curr.attr("data-linkday");

                log.debug("createPrevTimeBar 1 link : " + link);
                log.debug("createPrevTimeBar 1 linkday : " + linkday);
       
                 $("#timer_" + linkday).find("#ts_slider_container_" + link+" > .ts_contentArea").addClass("ts_slider_container_highlight");
            }
            
            link = curr.attr("data-link");
            linkday = curr.attr("data-linkday"); 

            log.debug("createPrevTimeBar 2 link : " + link);
            log.debug("createPrevTimeBar 2 linkday : " + linkday);
            
            enableDisabledTimeBar($("#timer_" + linkday), curr);

            var zIndex = curr.css("z-index");
            $("#timer_" + linkday).find("#ts_slider_container_" + link).css("z-index", zIndex);
             $("#timer_" + linkday).find("#ts_slider_container_" + link).attr("data-zIndex", zIndex);
            $("#timer_" + linkday).find("#ts_slider_container_" + link).find('#startTimePinAreaId').show();
            //log.debug("prevlink" + link + "linkday" + linkday + "linksliderHght" + prevsliderHght + "--" + getParseIntInDec(prevsliderHght + getParseIntInDec(conTopPos - msliderTopPos)) + "linksliderTop" + linksliderTop + "top" + getParseIntInDec(linksliderTop - getParseIntInDec(conTopPos - msliderTopPos)));

            var topPos = getParseIntInDec(containerTopPosY+containerHeight) - minuteToPos(duration);
            log.debug("createPrevTimeBar topPos : " + topPos);
            
            $("#timer_" + linkday).find("#ts_slider_container_" + link).css({
                'top' : getParseIntInDec(topPos) + 'px',
                'height' : getParseIntInDec(minuteToPos(duration)) + 'px'
            });
        
            var startTime = minuteToTime(1440-duration);
            var linkContainer = $("#timer_" + linkday);
            displayPinTime(linkContainer,link,startTime,"24:00","move");

        }

        function getDayIndex(day) {
           
            var index;
            $.each(scheduleRender.weekdays, function(i, value) {

                if (day == value) {
                
                    index = i;

                }
            });
            
            return index;
        }



        function addGlobalTimeController(currTimeBar, isFirst) {

            log.debug("addGlobalTimeController  isFirst " + isFirst );
            
            if ( isFirst == "true" )
                deactivateGlobaltimerbar();

            var minuteOfStartTime = getMinuteFromPin(currTimeBar,"start");
            var minuteOfEndTime = getMinuteFromPin(currTimeBar,"end");
            var durationTime = currTimeBar.attr("data-duration");

            log.debug("addGlobalTimeController  minuteOfStartTime " + minuteOfStartTime );
            log.debug("addGlobalTimeController  minuteOfEndTime " + minuteOfEndTime );

            var $msliderLink = currTimeBar.attr("data-link");
            log.debug("addGlobalTimeController  msliderLink " + $msliderLink );

            var st_count = 1;
            var end_count = 1;

            if ( $msliderLink == "" || ( $msliderLink != "" && minuteOfEndTime == 1440 ) )
            {
            $(".ts_slider_containerCls > #startTimePinAreaId > .ts_controllerTimeCls").each(function(i) {

                var parent = $(this).parent().parent();
                var isLinkNextDay = isNextDay(parent);
                var link = parent.attr("data-link");
                   
                log.debug("addGlobalTimeController  isLinkNextDay " + isLinkNextDay );
                    log.debug("addGlobalTimeController  link " + link );

                    if(link=="" || ( link!="" && minuteOfStartTime != 0 ))
                {                    
                    var minuteOfTempStartTime = getMinuteFromPin(parent,"start");
                    
                        log.debug("addGlobalTimeController  minuteOfTempStartTime " + minuteOfTempStartTime );

                        
                    if ( minuteOfStartTime == minuteOfTempStartTime )
                    {
                            log.debug("addGlobalTimeController  st_count " + st_count );
                        st_count++;
                        $(this).parent().parent().find(".ts_contentArea").addClass("ts_gstStartTimeDragCls");
                    }
                }
            });
            }

            if (st_count > 2) {
                currTimeBar.find("#globalstartTimePinAreaId").show();
            }

        
            if ( $msliderLink == "" || ( $msliderLink != "" && minuteOfStartTime == 0 ) )
            {
            $(".ts_slider_containerCls > #endTimePinAreaId > .ts_controllerTimeCls").each(function() {

                var parent = $(this).parent().parent();
                var isLinkNextDay=isNextDay(parent);
                    var link = parent.attr("data-link");
                    log.debug("addGlobalTimeController  link " + link );
                  
                    if(link=="" || ( link!="" && minuteOfEndTime != 1440 ))
                {
                    var minuteOfTempEndTime = getMinuteFromPin(parent,"end");

                        log.debug("addGlobalTimeController  minuteOfTempEndTime " + minuteOfTempEndTime );

                        
                    if ( minuteOfEndTime == minuteOfTempEndTime )
                    {
                            log.debug("addGlobalTimeController  end_count " + end_count );
                        end_count++;
                        $(this).parent().parent().find(".ts_contentArea").addClass("ts_gstEndTimeDragCls");
                    }
                }
            });
            }

            if (end_count > 2) {
                currTimeBar.find("#globalEndTimePinAreaId").show();
            }

            if ( $msliderLink != "" && isFirst == "true" && durationTime != "24:00" )
                addGlobalTimeController($('#ts_slider_container_' + $msliderLink ), "false");
        }


        function deactivateGlobaltimerbar()
        {
            $(".ts_globalschcontrollerTimeCls").hide();
            $(".ts_contentArea").removeClass("ts_gstStartTimeDragCls");
            $(".ts_contentArea").removeClass("ts_gstEndTimeDragCls");
        }


        function createSpinDiv(temp) {
            timeSpinnerChanged = true;
            temp.parent().attr( "data-isTimebarCreated","false");
             //isTimebarCreated=false;
            var id = temp.attr("id");
            var inputTime = temp.find(".ts_controllerTimeCls").text();
            var inputTimeAmPm = temp.find(".ts_controllerAMPMCls").text().toUpperCase();
            savedTime = inputTime + "::" + inputTimeAmPm.toLowerCase();
            var inputamPmTwo = inputTimeAmPm;
            //var inputamPmOne = inputTimeAmPm == "PM" ? "AM" : "PM";
            var hh_inputTime = inputTime.split(":")[0];
            var mm_inputTime = inputTime.split(":")[1];
            var Inputval = hh_inputTime;
            Inputval = Number(Inputval);
            Inputval = Inputval < 10 ? "0" + Inputval : Inputval;

            var MinInputval = mm_inputTime;
            MinInputval = Number(MinInputval);
            MinInputval = MinInputval < 10 ? "0" + MinInputval : MinInputval;            
            $("#ok-popup").text(langObj.Schedule.COM_SID_OK);


            createTimePickers(3);
            var CurrentTimePicker = $('body').find('#TimePicker');
            //$('.commonColonCls').addClass('topadjCls');
            CurrentTimePicker.timeSpinner(
            {
                type: '3',
                fontPadding : '0',
                fontHeight: FonttimerValFrNote_5,
                time3 : {
                    hour : getParseIntInDec(Inputval),
                    min : MinInputval,
                    ampm : inputamPmTwo.toLowerCase(),
                },
                onTimeSet:function(val)
                {
                    log.debug("onTimeSet : " + val);
                    updateTimePinController(val.replace(' ','::'));
                }
            }); 
        }
      
        function setDeleteFrameFlag(type, index) {
            log.debug("START" + type + "type" + index + "index", "setDeleteFrameFlag");

            if (index != "" && index != undefined && type != undefined) {
                if (type != "template") {
                    SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[getParseIntInDec(index)].Playlist[0].isDeleted = true;

                } else {
                    SchObj.Program[0].Screen[0].Frame[0].Frame_Schedule[getParseIntInDec(index)].Playlist[0].Content[0].File[0].isDeleted = true;
                }
            }
            log.debug("COMPLETE", "setDeleteFrameFlag");
        }

        function updateTimePinController(currentTime) {
            log.debug('updateTimePinController : '+currentTime+" / temp : "+temp+" "+temp.html());
            log.debug("START", "updateTimePinController");
            log.debug('updateTimePinController : '+currentTime);

            if (currentTime != "") {
                var idval = temp.attr('id');
                var timeBar = temp.parent();
                var link = timeBar.attr("data-link");
                var AmPm = currentTime.split("::")[1];
                AmPm = AmPm.toLowerCase();
                var startTime = timeBar.find("#startTimePinAreaId > .ts_controllerTimeCls").text();
                var startTimeAmPm = timeBar.find("#startTimePinAreaId > .ts_controllerAMPMCls").text();
                var endTime = timeBar.find("#endTimePinAreaId > .ts_controllerTimeCls").text();
                var endTimeAmPm = timeBar.find("#endTimePinAreaId > .ts_controllerAMPMCls").text();
                var changedTime = convertTimePinFormat(currentTime, 24);
                var tp_st_time = startTime.split(":");
                var tp_end_time = endTime.split(":");
                var tp_st_hh = tp_st_time[0];
                var tp_st_mm = tp_st_time[1];
                var tp_end_hh = tp_end_time[0];
                var tp_end_mm = tp_end_time[1];
                if (getParseIntInDec(tp_st_hh) == 12 && startTimeAmPm == "am") {
                    tp_st_hh = "00";
                    startTime = tp_st_hh + ":" + tp_st_mm;
                }
                if (getParseIntInDec(tp_end_hh) == 12 && endTimeAmPm == "am") {
                    tp_end_hh = "00";
                    endTime = tp_end_hh + ":" + tp_end_mm;
                }

                var st_time = changedTime.split(":");
                var st_hh_time = st_time[0];
                st_hh_time = (getParseIntInDec(st_hh_time) == 12 && AmPm == "am") ? "00" : (st_hh_time);
                var st_mm_time = st_time[1];

                if (getParseIntInDec(st_hh_time) > 12) {
                    st_hh_time = getParseIntInDec(st_hh_time) - 12;
                }

                if (st_hh_time.toString().length < 2) {
                    st_hh_time = "0" + st_hh_time;

                }

                changedTime = st_hh_time + ":" + st_mm_time;
                log.debug("currenttime" + currentTime + "changedTime" + changedTime);
                log.debug('idval : '+idval);
                if (idval == "startTimePinAreaId") {
                    var isChangeTime = setTimeRange(timeBar, (changedTime + "::" + AmPm), (endTime + "::" + endTimeAmPm));

                    if (getParseIntInDec(st_hh_time) == 0 && AmPm == "am") {
                        st_hh_time = "12";
                        changedTime = st_hh_time + ":" + st_mm_time;
                    }

                    log.debug("isChangeTime " + isChangeTime );
                    if (isChangeTime == "true") {

                        savedTime = changedTime + "::" + AmPm;
                        timeBar.find("#startTimePinAreaId > .ts_controllerTimeCls").html(changedTime).css({
                            "text-decoration" : " none"
                        });
                        timeBar.find("#startTimePinAreaId > .ts_controllerAMPMCls").html(AmPm).css({
                            "text-decoration" : " none"
                        });

                        log.debug("changedTime " + changedTime );
                        
                        timeBar.find("#startTimePinAreaId").show();
                        if (link == "") {
                            timeBar.find("#endTimePinAreaId").show();
                        }

                        isInvalidTime = "false";
                        //log.debug("dragger touch btm called");
                        var link = timeBar.attr("data-link");
                        var timeduration = getTimeBarDuration(timeBar);
                        log.debug("timeduration " + timeduration );
                        
                        timeBar.attr("data-duration", timeduration);
                        if (link != "")
                        {
                            $('#ts_slider_container_' + link).attr("data-duration", timeduration);
                        }
                        saveTimeRange(timeBar, "false");
                    }
                } else {
                    var isChangeTime = setTimeRange(timeBar, (startTime + "::" + startTimeAmPm), (changedTime + "::" + AmPm));

                    if (getParseIntInDec(st_hh_time) == 0 && AmPm == "am") {
                        st_hh_time = "12";
                        changedTime = st_hh_time + ":" + st_mm_time;
                    }

                    if (isChangeTime == "true") {
                        savedTime = changedTime + "::" + AmPm;
                        timeBar.find("#endTimePinAreaId > .ts_controllerTimeCls").html(changedTime).css({
                            "text-decoration" : " none"
                        });
                        timeBar.find("#endTimePinAreaId > .ts_controllerAMPMCls").html(AmPm).css({
                            "text-decoration" : " none"
                        });
                        if (link == "") {
                            timeBar.find("#startTimePinAreaId").show();
                        }
                        timeBar.find("#endTimePinAreaId").show();
                        isInvalidTime = "false";

                        var link = timeBar.attr("data-link");
                        var timeduration = getTimeBarDuration(timeBar);
                        timeBar.attr("data-duration", timeduration);
                        if (link != "")
                        {
                            $('#ts_slider_container_' + link).attr("data-duration", timeduration);
                        }
                        saveTimeRange(timeBar, "false");
                    }
                }
            }
            log.debug("COMPLETE", "updateTimePinController");
            if(isChangeTime == "false")
                return "false";
        }

        //provide timein HH:MM::AM/PM
        function convertTimePinFormat(time, format) {
            log.debug("START time=" + time + ":format=" + format, "convertTimePinFormat");
            var timeStr = time.split("::");
            var AmPm = timeStr[1].toLowerCase();
            var time = timeStr[0].split(":");
            var hh_time = time[0];
            var end_time = time[1];

            if (AmPm == "pm" && getParseIntInDec(format) == 24) {
                hh_time = getParseIntInDec(hh_time) + 12;
            }
            if ((AmPm == "pm" && getParseIntInDec(hh_time) != 12 ) && getParseIntInDec(format) == 12) {
                hh_time = getParseIntInDec(hh_time) - 12;
            }
            if ((AmPm == "am" && getParseIntInDec(hh_time) == 12 ) && getParseIntInDec(format) == 12) {
                hh_time = getParseIntInDec(hh_time) - 12;
            }

            hh_time = Utils.convertToDblDigit(hh_time);
            end_time = Utils.convertToDblDigit(end_time);
            log.debug("COMPLETE", "convertTimePinFormat");
            return hh_time + ":" + end_time;

        }

        function addControlBtn(mlink, mlinkedday, $this, isLinkNextDay) {

            $this.addClass("ts_slider_container_highlight");
            checkTimebar = 1;
            $('.addtemplateBtn').hide();
            if (mlink != "") {

                $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find(".ts_contentArea").addClass("ts_slider_container_highlight");

                if (isLinkNextDay == "true") {

                        $this.siblings("#ts_slidertopdragger").css("display", "block");
                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find("#startTimePinAreaId").css("display", "none");

                        $this.siblings("#startTimePinAreaId").css("display", "block");
                        $this.siblings("#endTimePinAreaId").css("display", "none");
                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find("#endTimePinAreaId").css("display", "block");

                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find("#ts_sliderbttmdragger").css("display", "block");

                } else {

                        $this.siblings("#ts_sliderbttmdragger").css("display", "block");
                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find("#endTimePinAreaId").css("display", "none");

                        $this.siblings("#startTimePinAreaId").css("display", "none");
                        $this.siblings("#endTimePinAreaId").css("display", "block");
                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find("#startTimePinAreaId").css("display", "block");

                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).find("#ts_slidertopdragger").css("display", "block");
                }

            } else {

                $this.siblings(".ts_dragbtn").css("display", "block");
                
                $this.siblings(".ts_schcontrollerTimeCls").css("display", "block");
                
                $this.addClass("ts_slider_container_highlight");
            }
        }

        function enableDisabledTimeBar($this, slider) {
            var id = $this.attr("id");
            var container = id.split("_");
            var day = container[1];
            // //log.debug("slider"+slider.hasClass("ts_disabled"));
            //  if(slider.hasClass("ts_disabled"))
            enableTimeBar(day);
            // $("#timertext_" + day).addClass("timerTextClsActive");
            //    removeWeekDay(day);
        }

        function saveChangedTime() {
/*            
            if ($("#spinDiv").css("display") == "block") {

                updateTimePinController();
                setTimePinValue();
            }
*/            
        }

        function closeSchDropDown() {
            if ($(".schTextNameCls").css("display") == "block") {
                $("#sch_dwndropdownId").trigger('tap');
                isOpenSchList = true;
            }
        }

        function resetHeight() {
            prevsliderHght = 0;
            nxtsliderHght = 0;
            linksliderHght = 0;
        }

        function checkNextDay($this)
        {
            var day = $this.attr("data-day");
            var mlinkedday = $this.attr("data-linkday");
            var mlink = $this.attr("data-link");
            var dayIndex = getDayIndex(day);
            var linkeddayIndex = getDayIndex(mlinkedday);
            var isLinkNextDay = getParseIntInDec(dayIndex) < getParseIntInDec(linkeddayIndex) ? "true" : "false";
            if (day == "sat" && mlinkedday == "sun") {
                isLinkNextDay = "true";
            }
            if (day == "sun" && mlinkedday == "sat") {
                isLinkNextDay = "false";
            }

            return isLinkNextDay;
        }

        this.each(function() {
            var $curr = $(this);
            var dragActive = false;
            var lastPosY = 0;
            var currHeight = 0;
            isDurationChange = true;
            var currTop = 0;
            var diff = 0;
            var sliderBtmPosY = 0;
            var sliderContainerOffset = $curr.offset();
            var sliderContainerHeight = $curr.outerHeight();
            var sliderContainerWidth = $curr.width();
            var conTopPos = getParseIntInDec(sliderContainerOffset.top);
            var conBtmPos = getParseIntInDec(conTopPos + sliderContainerHeight);
            var containerHeight;
            var currSliderTop = 0;
            var currSliderBtm = 0;
            var currlinkSliderTop = 0;
            var currlinkSliderBtm = 0;
            var offset;
            var direction = "up";
            
            var link = "";

            var linkday = "";
            linksliderTop = conBtmPos;
            var contHeight;


            var contMinuteOfStartTime;
            var minuteOfMinStartTime;
            var minuteOfMaxStartTime;
            
            var contMinuteOfEndTime;
            var minuteOfMinEndTime;
            var minuteOfMaxEndTime;

            var minuteOfMaxEndTimeOfLinked;
            var minuteOfMinStartTimeOfLinked;

            
            var tp_startTime = params.startTime;
            tp_startTime = tp_startTime.substring(0, 5);
            var tp_endTime = params.endTime;
            tp_endTime = tp_endTime.substring(0, 5);
            var tp_hh_stTime = tp_startTime.split(":")[0];
            var tp_mm_stTime = tp_startTime.split(":")[1];
            var tp_hh_endTime = tp_endTime.split(":")[0];
            var tp_mm_endTime = tp_endTime.split(":")[1];
            if (getParseIntInDec(tp_hh_endTime) >= getParseIntInDec(24)) {

                tp_hh_endTime = "00";
                tp_endTime = "00:00";

            }
            var tp_stTime_AmPm = ((tp_hh_stTime >= 12 && tp_hh_stTime < 24) ? "pm" : "am");
            var tp_endTime_AmPm = ((tp_hh_endTime >= 12 && tp_hh_endTime < 24) ? "pm": "am");
            var hh_interval = sliderContainerHeight / 24;
            var mm_interval = hh_interval / 60;
            var minDuration = mm_interval * params.minduration;
            var maxDuration = sliderContainerHeight;
            tp_startTime = convertTimePinFormat(tp_startTime + "::" + tp_stTime_AmPm, 12);
            tp_endTime = convertTimePinFormat(tp_endTime + "::" + tp_endTime_AmPm, 12);

            if (getParseIntInDec(tp_hh_stTime) == 0) {
                tp_hh_stTime = "12";
                tp_startTime = tp_hh_stTime + ":" + tp_mm_stTime;
            }
            if (getParseIntInDec(tp_hh_endTime) == 0) {

                if (getParseIntInDec(tp_mm_endTime) > 0) {
                    tp_hh_endTime = "12";
                    tp_endTime = tp_hh_endTime + ":" + tp_mm_endTime;
                } else {
                    tp_endTime = "12:00";
                }

            }
            if(tp_startTime == END_TIME)
            {
                tp_startTime = TwelveHRFRMT;
            }

            
            $curr.on('tap touchstart', '#ts_slider_container_' + params.index + ' > #ts_slidertopdragger', function(e) {

                if ($("#templatePlaylistId").css("display") != "block") {
                    var slider = $(this).parent();
                    enableDisabledTimeBar($curr, slider);
                    var mday = $(this).parent().attr("data-day");
                    var mlinkedday = $(this).parent().attr("data-linkday");
                    var mlink = $(this).parent().attr("data-link");
                    var dayIndex = getDayIndex(mday);
                    var linkeddayIndex = getDayIndex(mlinkedday);
                    var mlinkHght = $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).outerHeight();
                    linksliderHght = mlinkHght;
                    var isLinkNextDay = getParseIntInDec(dayIndex) < getParseIntInDec(linkeddayIndex) ? "true" : "false";
                    if (mday == "sat" && mlinkedday == "sun") {
                        isLinkNextDay = "true";
                    }
                    if (mday == "sun" && mlinkedday == "sat") {
                        isLinkNextDay = "false";
                    }
                        direction = "up";
                    lastPosY = e.originalEvent.touches[0].clientY;
                    log.debug("lastPosY : " + lastPosY);
                    containerHeight = $curr.find("#ts_slider_container_" + params.index).outerHeight();
                    offset = $curr.find("#ts_slider_container_" + params.index).offset();
                    var currTop = offset.top;
                    var marginTop = lastPosY - currTop;
                    //log.debug("isNextDay top" + isLinkNextDay);
                    
                    if (mlink == "") {
                        $(this).siblings(".ts_contentArea").addClass("dragActive");
                    } else {
                        if (isLinkNextDay == "true") {
                            $(this).siblings(".ts_contentArea").addClass("dragActive");
                        }
                    }

                    $(this).parent().find("#globalstartTimePinAreaId").hide();
                    $(".ts_slider_containerCls").removeClass("ts_gstStartTimeDragCls");
                    $(".ts_schcopydelbtnCls").hide();
                    checkTimebar = 0;
                    $('.addtemplateBtn').hide();
                    saveChangedTime();

                }

            });


            
            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' > .ts_globalschcontrollerTimeCls > #ts_gstTopdragger', function(e) {

                $(".ts_schcopydelbtnCls").css("display", "none");
                
                lastPosY = e.originalEvent.touches[0].clientY;
                log.debug("lastPosY : " + lastPosY);
                
                containerHeight = $curr.find("#ts_slider_container_" + params.index).outerHeight();
                offset = $curr.find("#ts_slider_container_" + params.index).offset();
                isGlobalTimeBar = "true";
                contHeight = [];
                contMinuteOfEndTime = [];

                minuteOfMaxEndTime = 0;
                minuteOfMinEndTime = 1440;
                minuteOfMaxEndTimeOfLinked = 0;
                   
                $(".ts_slider_containerCls").find(".ts_gstStartTimeDragCls").parent().each(function(i) {

                    contHeight.push($(this).outerHeight());

                    var msliderTopPos = offset.top + diff;
                    var startTime = get24TimeFromPosition(msliderTopPos);
                    var minuteOfStartTime = timeToMinute(startTime);
                    log.debug("ts_gstTopdragger minuteOfStartTime : " + minuteOfStartTime);                    
                
                    var durationTime=$(this).attr("data-duration");
                    var minuteOfDurationTime = timeToMinute(durationTime);
                    log.debug("ts_gstTopdragger durationTime : " + durationTime);
                    log.debug("ts_gstTopdragger minuteOfDurationTime : " + minuteOfDurationTime);                    
                    
                    var minuteOfTempEndTime = getMinuteFromPin($(this),"end");                    
                    
                    var msliderLink = $(this).attr("data-link");
                    if ( msliderLink != "" )
                    {
                        minuteOfTempEndTime = 1440;
                        
                        minuteOfEndTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"end");
                        log.debug("minuteOfEndTime2***********" + minuteOfEndTime2);

                        if ( minuteOfMaxEndTimeOfLinked < minuteOfEndTime2 )
                            minuteOfMaxEndTimeOfLinked = minuteOfEndTime2;
                    }

                    contMinuteOfEndTime.push(minuteOfTempEndTime);
                    log.debug("ts_gstTopdragger minuteOfTempEndTime : " + minuteOfTempEndTime);
                    
                    if ( minuteOfMaxEndTime < minuteOfTempEndTime )
                        minuteOfMaxEndTime = minuteOfTempEndTime;
                
                    if ( minuteOfMinEndTime > minuteOfTempEndTime )
                        minuteOfMinEndTime = minuteOfTempEndTime;
                });

                log.debug("minuteOfMinEndTime : " + minuteOfMinEndTime);

            });

            
            $curr.on('touchmove', '#ts_slider_container_' + params.index + ' > .ts_globalschcontrollerTimeCls > #ts_gstTopdragger', function(e) {

                if ($(this).parent().parent().find(".ts_schcopydelbtnCls:visible")) {
                    $(".ts_schcopydelbtnCls").hide();
                    checkTimebar = 0;
                }
                
                $(this).addClass("ts_gstdragbtn_ud").removeClass("ts_gstdragbtn_sel");
                
                $('.addtemplateBtn').hide();
                var currPosY = e.originalEvent.touches[0].clientY;
                diff = currPosY - lastPosY;
              
                var msliderTopPos = offset.top + diff;
                var startTime = get24TimeFromPosition(msliderTopPos);
                var minuteOfStartTime = timeToMinute(startTime);
                
                log.debug("ts_gstTopdragger starmsliderTopPosmsliderTopPostTime : " + msliderTopPos);
                log.debug("ts_gstTopdragger startTime : " + startTime);
                log.debug("ts_gstTopdragger minuteOfStartTime : " + minuteOfStartTime);

                if ( minuteOfMaxEndTime - minuteOfStartTime >= 1440 )
                    minuteOfStartTime = minuteOfMaxEndTime - 1440;

                if ( minuteOfStartTime + 10 > minuteOfMinEndTime )
                    minuteOfStartTime = minuteOfMinEndTime - 10;         
                
                if (minuteOfStartTime < 0 )
                    minuteOfStartTime = 0;

                if ( minuteOfMaxEndTimeOfLinked > minuteOfStartTime )
                    minuteOfStartTime = minuteOfMaxEndTimeOfLinked

                var msliderLink = $('#ts_slider_container_' + params.index ).attr("data-link");
                if ( msliderLink != "" )
                {
                    minuteOfEndTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"end");
                    log.debug("minuteOfEndTime2***********" + minuteOfEndTime2);

                    if ( minuteOfStartTime < minuteOfEndTime2 )
                        minuteOfStartTime = minuteOfEndTime2;
                }

                startTime = minuteToTime(minuteOfStartTime);
                        
                $(".ts_slider_containerCls").find(".ts_gstStartTimeDragCls").parent().each(function(i) {
                    
                    if ( contMinuteOfEndTime[i] > 1440 )
                    {
                        contMinuteOfEndTime[i] = 1440;
                    }
                    log.debug("ts_gstTopdragger minuteToTime(contMinuteOfEndTime[i]) : " + minuteToTime(contMinuteOfEndTime[i]));

                    $(this).css({
                        'top': conTopPos + minuteToPos(minuteOfStartTime) + 'px',
                        'height' : minuteToPos(contMinuteOfEndTime[i]-minuteOfStartTime) + 'px'
                    });


                    var index = $(this).attr("data-frameIndex");                    
                    var endTime = minuteToTime(contMinuteOfEndTime[i]);
                    log.debug("endTime : " + contMinuteOfEndTime[i]);

                    displayPinTime($(this).parent(),index,startTime,endTime,"up");
                                
                    var durationTime;
                    var msliderLink = $(this).attr("data-link");
                    if ( msliderLink != "" )
                    {

                        var minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");                 
                        durationTime = minuteToTime((1440 - minuteOfStartTime) + minuteOfStartTime2);
                        
                        $(this).attr("data-duration",durationTime);
                        $('#ts_slider_container_' + msliderLink ).attr("data-duration",durationTime);
                    }
                    else
                    {
                        durationTime = minuteToTime(contMinuteOfEndTime[i]-minuteOfStartTime);
                        $(this).attr("data-duration",durationTime);
                    }                                
                });

                e.preventDefault();
                e.stopPropagation();
            });

            $curr.on('touchend', '#ts_slider_container_' + params.index + ' > .ts_globalschcontrollerTimeCls > #ts_gstTopdragger', function(e) {

            isGlobalTimeBar = "false";

                $(".ts_slider_containerCls").find(".ts_gstStartTimeDragCls").parent().each(function() {

                    saveTimeRange($(this),"true");
                });
                $(this).addClass("ts_gstdragbtn_sel").removeClass("ts_gstdragbtn_ud");
                $('#ts_slider_container_' + params.index).trigger("touchend");
            });


            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' > .ts_globalschcontrollerTimeCls > #ts_gstBtmdragger', function(e) {

                $(".ts_schcopydelbtnCls").css("display", "none");
                 
                lastPosY = e.originalEvent.touches[0].clientY;
                log.debug("ts_gstBtmdragger lastPosY : " + lastPosY);
                log.debug("ts_gstBtmdragger params.index : " + params.index);
                
                
                containerHeight = $curr.find("#ts_slider_container_" + params.index).outerHeight();
                log.debug("ts_gstBtmdragger containerHeight : " + containerHeight);

                
                offset = $curr.find("#ts_slider_container_" + params.index).offset();
                isGlobalTimeBar = "true";
                contHeight = [];
                contMinuteOfStartTime = [];

                minuteOfMaxStartTime = 0;
                minuteOfMinStartTime = 1440;
                minuteOfMinStartTimeOfLinked = 10000;

                $(".ts_slider_containerCls").find(".ts_gstEndTimeDragCls").parent().each(function(i) {

                    contHeight.push($(this).outerHeight());

                    var minuteOfTempStartTime;
                        
                    var msliderLink = $(this).attr("data-link");
                    if ( msliderLink != "" )
                    {
                        minuteOfTempStartTime = 0;
                        
                        minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");
                        log.debug("minuteOfStartTime2***********" + minuteOfStartTime2);

                        if ( minuteOfMinStartTimeOfLinked > minuteOfStartTime2 )
                            minuteOfMinStartTimeOfLinked = minuteOfStartTime2;
                    }
                    else
                    {
                        minuteOfTempStartTime = getMinuteFromPin($(this),"start");
                    }

                    contMinuteOfStartTime.push(minuteOfTempStartTime);
                    log.debug("ts_gstBtmdragger contMinuteOfStartTime.push : " + minuteOfTempStartTime);
                    
                    var durationTime=$(this).attr("data-duration");
                    log.debug("ts_gstBtmdragger durationTime : " + durationTime);

                    if ( minuteOfMaxStartTime < minuteOfTempStartTime )
                        minuteOfMaxStartTime = minuteOfTempStartTime;

                    if ( minuteOfMinStartTime > minuteOfTempStartTime )
                        minuteOfMinStartTime = minuteOfTempStartTime;

                    var msliderLink = $(this).attr("data-link");
                    if ( msliderLink != "" )
                    {
                        minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");
                        log.debug("minuteOfStartTime2***********" + minuteOfStartTime2);

                        if ( minuteOfMinStartTimeOfLinked > minuteOfStartTime2 )
                            minuteOfMinStartTimeOfLinked = minuteOfStartTime2;
                    }

                    log.debug("ts_gstBtmdragger minuteOfMinStartTimeOfLinked : " + minuteOfMinStartTimeOfLinked); 

                    
                });

                log.debug("ts_gstBtmdragger minuteOfMaxStartTime : " + minuteOfMaxStartTime);
                log.debug("ts_gstBtmdragger minuteOfMinStartTime : " + minuteOfMinStartTime);          

            });

            
             
            $curr.on('touchmove', '#ts_slider_container_' + params.index + ' > .ts_globalschcontrollerTimeCls > #ts_gstBtmdragger', function(e) {

                if ($(this).parent().parent().find(".ts_schcopydelbtnCls:visible")) {
                    $(".ts_schcopydelbtnCls").hide();
                    checkTimebar = 0;
                }
                $(this).addClass("ts_gstdragbtn_ud").removeClass("ts_gstdragbtn_sel");
                
                $('.addtemplateBtn').hide();
                var currPosY = e.originalEvent.touches[0].clientY;
                diff = currPosY - lastPosY;

                var msliderBtmTopPos = offset.top + containerHeight + diff;
                var endTime = get24TimeFromPosition(msliderBtmTopPos);
                var minuteOfEndTime = timeToMinute(endTime);

                log.debug("ts_gstTopdragger msliderBtmTopPos : " + msliderBtmTopPos);
                log.debug("ts_gstTopdragger endTime : " + endTime);
                log.debug("ts_gstTopdragger minuteOfEndTime : " + minuteOfEndTime);

                if ( minuteOfEndTime - minuteOfMinStartTime >= 1440 )
                    minuteOfEndTime = minuteOfMinStartTime + 1440;
                           
                if ( minuteOfEndTime < minuteOfMaxStartTime + 10 )
                    minuteOfEndTime = minuteOfMaxStartTime + 10;         

                if ( minuteOfMinStartTimeOfLinked <= 1440 && minuteOfMinStartTimeOfLinked < minuteOfEndTime )
                    minuteOfEndTime = minuteOfMinStartTimeOfLinked;

                var msliderLink = $('#ts_slider_container_' + params.index ).attr("data-link"); 
                if ( msliderLink != "" )
                {
                    var minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");
                    log.debug("minuteOfStartTime2***********" + minuteOfStartTime2);

                    if ( minuteOfEndTime > minuteOfStartTime2 )
                        minuteOfEndTime = minuteOfStartTime2;
                }

                if (minuteOfEndTime > 1440 )
                    minuteOfEndTime = 1440;

                endTime = minuteToTime(minuteOfEndTime);                                
                log.debug("ts_gstTopdragger endTime : " + endTime);                

                $(".ts_slider_containerCls").find(".ts_gstEndTimeDragCls").parent().each(function(i) {

                    var index=$(this).attr("data-frameIndex");

                    if ( contMinuteOfStartTime[i] < 0 )
                        contMinuteOfStartTime[i] = 0;

                    log.debug("ts_gstBtmdragger minuteToTime(contMinuteOfStartTime[i] : " + minuteToTime(contMinuteOfStartTime[i]));

                    $(this).css({
                            'top': conTopPos + minuteToPos(contMinuteOfStartTime[i]) + 'px',
                            'height' : minuteToPos(minuteOfEndTime-contMinuteOfStartTime[i]) + 'px'
                    });

                    displayPinTime($(this).parent(),index,minuteToTime(contMinuteOfStartTime[i]),endTime,"down");

                    var durationTime;
                    var msliderLink = $(this).attr("data-link");
                    if ( msliderLink != "" )
                    {
                        var minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");
                        log.debug("minuteOfStartTime2***********" + minuteOfStartTime2);

                        durationTime = minuteToTime(minuteOfEndTime+(1440-minuteOfStartTime2));

                        $(this).attr("data-duration",durationTime);
                        $('#ts_slider_container_' + msliderLink ).attr("data-duration",durationTime);
                    }
                    else
                    {
                        durationTime = minuteToTime(minuteOfEndTime-contMinuteOfStartTime[i]);
                        $(this).attr("data-duration",durationTime);
                    }                    
                
                });

                e.preventDefault();
                e.stopPropagation();                

            });
            

            $curr.on('touchend', '#ts_slider_container_' + params.index + ' > .ts_globalschcontrollerTimeCls > #ts_gstBtmdragger', function(e) {

                isGlobalTimeBar = "false";
                
                $(".ts_slider_containerCls").find(".ts_gstEndTimeDragCls").parent().each(function() {
                     
                    saveTimeRange($(this), "true");
                });
                $(this).addClass("ts_gstdragbtn_sel").removeClass("ts_gstdragbtn_ud");
                $('#ts_slider_container_' + params.index).trigger("touchend");
               
            });

           
            $curr.on('touchend', '#ts_slider_container_' + params.index + '> #ts_sliderbttmdragger', function(e) {

                isGlobalTimeBar = "false";
                $(this).addClass("ts_dragbtn_sel").removeClass("ts_dragbtn_ud");

                $(".ts_slider_containerCls").find(".ts_gstStartTimeDragCls").parent().each(function() {

                    saveTimeRange($(this),"true");
                }); 

            });


             $curr.on('touchend', '#ts_slider_container_' + params.index + '> #ts_slidertopdragger', function(e) {
                // isDurationChange=true;
                log.debug("dragger touch top called");
                $(this).addClass("ts_dragbtn_sel").removeClass("ts_dragbtn_ud");
                
                var link = $(this).parent().attr("data-link");
                var timeduration = getTimeBarDuration($(this).parent());
                log.debug("timeduration : " + timeduration);
                $(this).parent().attr("data-duration", timeduration);
                if (link != "")
                    $('#ts_slider_container_' + link).attr("data-duration", timeduration);
                  
            });
             
            $curr.on('tap touchstart', '#ts_slider_container_' + params.index + '> #ts_sliderbttmdragger', function(e) {

                if ($("#templatePlaylistId").css("display") != "block") {
                    var slider = $(this).parent();
                    enableDisabledTimeBar($curr, slider);
                    var mday = $(this).parent().attr("data-day");
                    var mlinkedday = $(this).parent().attr("data-linkday");
                    var mlink = $(this).parent().attr("data-link");
                    var mlinkHght = $("#timer_" + mlinkedday).find("#ts_slider_container_" + mlink).outerHeight();
                    linksliderHght = mlinkHght;
                    var dayIndex = getDayIndex(mday);
                    var linkeddayIndex = getDayIndex(mlinkedday);
                    var isLinkNextDay = getParseIntInDec(dayIndex) < getParseIntInDec(linkeddayIndex) ? "true" : "false";
                    if (mday == "sat" && mlinkedday == "sun") {
                        isLinkNextDay = "true";
                    }
                    if (mday == "sun" && mlinkedday == "sat") {
                        isLinkNextDay = "false";
                    }
                    $(this).parent().find("#globalEndTimePinAreaId").hide();
                    $(".ts_slider_containerCls").removeClass("ts_gstStartTimeDragCls");
                    lastPosY = e.originalEvent.touches[0].clientY;
                    log.debug("lastPosY : " + lastPosY);
                    direction = "down";
                    currHeight = $curr.find("#ts_slider_container_" + params.index).outerHeight();
                    if (mlink == "") {
                        $(this).siblings(".ts_contentArea").addClass("dragActive");
                    } else {
                        if (isLinkNextDay == "false") {
                            $(this).siblings(".ts_contentArea").addClass("dragActive");
                        }
                    }

                    offset = $curr.find("#ts_slider_container_" + params.index).offset();

                    $(".ts_schcopydelbtnCls").hide();
                    checkTimebar = 0;
                    $('.addtemplateBtn').hide();
                    saveChangedTime();
                }
                //  e.preventDefault();
                //  e.stopPropagation();

            });

     
            $curr.on('touchstart', '#ts_slider_container_' + params.index + ' > #ts_sliderContentArea', function(e) {
            
                if (scheduleRender.isCopyFlag == "true") {
                    log.debug("=========================================");
                    var container = $(this);
                        var posY = e.clientY;
                        var clone = $(this).parent().find(".copyObj");
                        var link = $(clone).attr("data-link");
                        var sliderHeight = $(clone).outerHeight();
                        $(clone).removeClass("copyObj");
                        $(".ts_schcopydelbtnCls").hide();
                        checkTimebar = 0;
                        //scheduleRender.isCopyFlag = "false"; // Fixed issue related to copy paste time bar over already existing time bar
                        $("#sch_copyMessgId").hide();
                        $(".ts_copybtnCls").show();
                        $(".ts_delbtnCls").show();
                        $(".ts_undobtnCls").hide();
                        if (link != "") {
                            var linkSliderHeight = $("#ts_slider_container_" + link).outerHeight();
                            orginalSliderHeight = sliderHeight + linkSliderHeight;
                            //   $(clone).height(orginalSliderHeight);
                        }
                        params.onCopy.call(this, container, e, clone, orginalSliderHeight);
                }
                else{

                    $('.addtemplateBtn').hide();
                    log.debug("tap touchstart tap touchstart tap touchstart");
    
    
                    if ($(".Template_Area_Cls").css("display") != "block") {
    
                       
                        log.debug("tap clicked::"+(e.type));
                        nCountOfMoving = 0;
                        
                        var slider = $(this).parent();
                        
                        resetHeight();
                        isFullDay = checkMaxDuration($curr, $(this).parent());
    
                        log.debug("isFullDay : " + isFullDay);
                        
                        //  log.debug("isFullDay"+isFullDay);
                        var mday = $(this).parent().attr("data-day");
                        var mlinkedday = $(this).parent().attr("data-linkday");
                        var mlink = $(this).parent().attr("data-link");
                        var frameIndex=$(this).parent().attr("data-frameIndex");
                        
                        if(mlink!=""){
                            
                            var sliderDuration= $(this).parent().attr("data-duration");
                            var isFirst=$(this).parent().attr("data-isFirst");
                            var linksliderDuration= $('#ts_slider_container_' + mlink ).attr("data-duration");
                            
                            if((sliderDuration!=linksliderDuration) &&(isFirst =="true")){
                                
                                var $duration=addEndTime(sliderDuration,linksliderDuration);
                                
                                log.debug("opened duration::"+$duration);
                                $(this).parent().attr("data-isFirst","false");
                                $('#ts_slider_container_' + mlink ).attr("data-isFirst","false");
                                $(this).parent().attr("data-duration",$duration);
                                $('#ts_slider_container_' + mlink ).attr("data-duration",$duration);
                                
                            }
                        }    
                        
                        var dayIndex = getDayIndex(mday);
                        var linkeddayIndex = getDayIndex(mlinkedday);
                        var isLinkNextDay = getParseIntInDec(dayIndex) < getParseIntInDec(linkeddayIndex) ? "true" : "false";
                        if (mday == "sat" && mlinkedday == "sun") {
                            isLinkNextDay = "true";
                        }
                        if (mday == "sun" && mlinkedday == "sat") {
                            isLinkNextDay = "false";
                        }
    
    
                        log.debug("isLinkNextDay : " + isLinkNextDay);
    
                        direction = "move";
                        isGlobalTimeBar = "false";
                        var touch;
                        if (e.originalEvent) {
                            if (e.originalEvent.touches && e.originalEvent.touches.length) {
                                touch = e.originalEvent.touches;
                                log.debug("touch : " + touch);
                            } else if (e.originalEvent.changedTouches && e.originalEvent.changedTouches.length) {
                                touch = e.originalEvent.changedTouches;
                                log.debug("touch : " + touch);
                            }
                            lastPosY = touch[0].clientY;
                            log.debug("lastPosY : " + lastPosY);
                        } else {
                            lastPosY = e.targetTouches[0].pageY;
                            log.debug("lastPosY : " + lastPosY);
                        }
    
                        isStartMoving = "true";
                        isStartMoving2 = "true";
                        curLastPosY = 0;
    
                        offset = $curr.find("#ts_slider_container_" + params.index).offset();
                        currTop = offset.top;
    
                        log.debug("**************currTop : " + currTop + " params.index " + params.index + " lastPosY " + lastPosY);
                        
                        
                        sliderHeight = $curr.find("#ts_slider_container_" + params.index).outerHeight();
                        // log.debug("+++++++++++++SliderHeight"+sliderHeight);
                        sliderBtmPosY = currTop + sliderHeight;
                        var marginTop = lastPosY - currTop;
    
                        $curr.siblings(".timerContainerCls").removeClass("timerContainerCls-active");
                        $curr.parent().children().find(".ts_contentArea").removeClass("ts_slider_container_highlight dragActive");
                        $curr.parent().children().find(".ts_contentArea").siblings(".ts_dragbtn").css("display", "none");
                        $curr.parent().children().find(".ts_contentArea").siblings(".ts_schcontrollerTimeCls").css("display", "none");
                        $curr.addClass("timerContainerCls-active");
                        $(this).addClass("dragActive ts_slider_container_highlight");
                        
    
                        var containerHeight = $curr.height();
                        var containerOffset = $curr.offset();
                        var containerTopPosY = (containerOffset.top);
                        var schCopydelBtHghth = containerHeight * 0.23;
                        
                        if(maxIndex!= getParseIntInDec(frameIndex))
                        {
                        z_Index++;
                        $(this).parent().attr("data-zIndex", z_Index);
                        $(this).parent().css("z-index", z_Index);
                        maxIndex=frameIndex;
                        } 
                        
    
                        if (mlink != "") {
                            
                            link = mlink;
                            linkday = mlinkedday;
                            
                            linksliderTop = $("#timer_" + linkday).find("#ts_slider_container_" + link).offset().top;
                            linksliderHght = $("#timer_" + linkday).find("#ts_slider_container_" + link).outerHeight();
                            
                            $("#timer_" + linkday).find("#ts_slider_container_" + link).css("z-index", z_Index);
                             $("#timer_" + linkday).find("#ts_slider_container_" + link).attr("data-zIndex", z_Index);
                             $("#ts_slider_container_" + link+" > .ts_contentArea").addClass("ts_slider_container_highlight");
    
                            log.debug("linksliderTop : " + linksliderTop);
                            log.debug("linksliderHght : " + linksliderHght);                        
                        }

                        closeSchDropDown();
                        saveChangedTime();
                        e.preventDefault();
                        e.stopPropagation();
                    }
                }

            });




        $curr.on('touchmove', '#ts_slider_container_' + params.index, function(e) {
                
            e.preventDefault();
            timeSpinnerChanged = false;
            //e.stopPropagation();

            if ($(".Template_Area_Cls").css("display") != "block") {
                
                var slider = $(this).find('#ts_sliderContentArea');
                var currPosY = e.originalEvent.touches[0].clientY;

                log.debug("currPosY::"+currPosY);
                log.debug("dragactive::;"+slider.hasClass("dragActive"));
              
                if (slider.hasClass("dragActive")) {

                    $(this).find(".ts_schcopydelbtnCls").css("display", "none");

                    diff = currPosY - lastPosY;

                    var containerHeight = $curr.height();
                    var n = containerHeight / 144;
                    diff = diff - (diff % n);

                    if ( diff != 0 )
                    {                    
                        deactivateGlobaltimerbar();
                    }

                    log.debug("diff::"+diff + " lastPosY : " + lastPosY);

                    log.debug("*************** direction::"+direction);
                    
                     switch(direction) {
                        
                        case "up":
                            
                            log.debug("*******up***********");
                            $(this).find('#ts_slidertopdragger').addClass("ts_dragbtn_ud").removeClass("ts_dragbtn_sel ts_dragbtn_up ts_dragbtn_down");

                            var dheight = offset.top + diff;
                            var minuteOfStartTime2 = 1440;

                            var startTime = get24TimeFromPosition(dheight);
                            var minuteOfStartTime = timeToMinute(startTime);

                            log.debug("minuteOfstartTime***********" + minuteOfStartTime);


                            var minuteOfEndTime2;
                            
                            var durationTime=$(this).attr("data-duration");                            
                            var minuteOfDurationTime = timeToMinute(durationTime);

                            var msliderLink = $(this).attr("data-link");                                                                                            

                            if ( msliderLink != "" )
                            {
                                minuteOfEndTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"end");
                            }

                            var minuteOfEndTime = getMinuteFromPin($('#ts_slider_container_' + params.index ),"end");
                            log.debug("minuteOfEndTime***********" + minuteOfEndTime);
                            
                            var endTime = minuteToTime(minuteOfEndTime);                            
                            
                            log.debug("minuteOfEndTime***********" + minuteOfEndTime);
                            log.debug("minuteOfstartTime***********" + minuteOfStartTime);
                            log.debug("startTime***********" + startTime);                            

                            log.debug("diff  minuteOfStartTime  " + minuteOfStartTime);
                            log.debug("diff down***********" + diff + " dheight  " + dheight);
                            
                            if ( minuteOfStartTime < 1440 && minuteOfStartTime - minuteOfEndTime2 > 0 && msliderLink != "" )
                            {

                                $(this).css({
                                    'top': conTopPos+minuteToPos(minuteOfStartTime) + 'px',
                                    'height' : minuteToPos(1440-minuteOfStartTime) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,minuteToTime(minuteOfStartTime2),direction);

                                log.debug("1 ");
                            }
                            else if ( minuteOfStartTime - minuteOfEndTime2 <= 0 && msliderLink != "" )
                            {
                                minuteOfStartTime = minuteOfEndTime2;
                                startTime = minuteToTime(minuteOfStartTime);
                                
                                $(this).css({
                                    'top': conTopPos+minuteToPos(minuteOfStartTime) + 'px',
                                    'height' : minuteToPos(1440-minuteOfStartTime) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,minuteToTime(minuteOfStartTime2),direction);

                                log.debug("1 ");
                            }
                            else if ( minuteOfStartTime <= 0 )
                            {

                                minuteOfStartTime = 0;
                                startTime = minuteToTime(minuteOfStartTime);
                                
                                $(this).css({
                                    'top': conTopPos + 'px',
                                    'height' : minuteToPos(minuteOfEndTime) + 'px'
                                });

                                displayPinTime($curr,params.index,"00:00","24:00",direction);

                                log.debug("2 ");
                            }
                            else if ( (minuteOfEndTime - minuteOfStartTime) <= 10 && msliderLink == "" )
                            {
                                minuteOfStartTime = minuteOfEndTime - 10;
                                startTime = minuteToTime(minuteOfStartTime);

                                $(this).css({
                                    'top': conTopPos + minuteToPos(minuteOfStartTime) + 'px',
                                    'height' : minuteToPos(10) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,minuteToTime(minuteOfStartTime+10),direction);

                                log.debug("3 ");
                            }
                            else if ( minuteOfStartTime >= 1440 && msliderLink != "" )
                            {
                                var linkContainer = $('#ts_slider_container_' + msliderLink );
                                        
                                $(linkContainer).attr("data-link", "");
                                $(linkContainer).attr("data-linkday", "");

                                var minuteOfEndTime2 = getMinuteFromPin($(linkContainer),"end");
                                log.debug("minuteOfEndTime2 " + minuteOfEndTime2);
                                displayPinTime($curr,msliderLink,"00:00",minuteToTime(minuteOfEndTime2),"");

                                var durationTime = minuteToTime(minuteOfEndTime2);                                
                                $(linkContainer).attr("data-duration",durationTime);

                                $(linkContainer).find(".ts_schcontrollerTimeCls").show();
                                $(linkContainer).find(".ts_dragbtn").show();
                                saveTimeRange(linkContainer,"false");
                                var index=$(this).attr("data-frameIndex");
                                var type = $(this).attr("data-type");                                
                                $(this).remove();
                                setDeleteFrameFlag(type, index);
                                scheduleRender.tempdeletedArray.push(getParseIntInDec(index));
                                
                                log.debug("3-1 ");

                                return;
                            }
                            else
                            {
                                $(this).css({
                                    'top': conTopPos + minuteToPos(minuteOfStartTime) + 'px',
                                    'height' : minuteToPos(minuteOfEndTime-minuteOfStartTime) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,endTime,direction);

                                log.debug("4 ");
                            }

                            if ( msliderLink != "" )
                            {
                                minuteOfDurationTime = 1440-minuteOfStartTime+minuteOfEndTime2;

                                if ( minuteOfDurationTime > 1440 )
                                    minuteOfDurationTime = 1440;
                            
                                durationTime = minuteToTime(minuteOfDurationTime);
                                    
                                $(this).attr("data-duration",durationTime);
                                $('#ts_slider_container_' + msliderLink).attr("data-duration",durationTime);

                                log.debug("4 duration" + durationTime);
                                log.debug("4 minuteOfDurationTime" + minuteOfDurationTime);
                                log.debug("4 " + $(this).attr("data-duration"));                                
                            }
                            else
                            {
                                durationTime = minuteToTime(minuteOfEndTime-minuteOfStartTime);
                                $(this).attr("data-duration",durationTime);
                            }

                            break;
                            
                        case "down":
                            
                            log.debug("*******down***********");
                            $(this).find('#ts_sliderbttmdragger').addClass("ts_dragbtn_ud").removeClass("ts_dragbtn_sel ts_dragbtn_up ts_dragbtn_down");

                            var dheight = currHeight + diff;
                            var minuteOfStartTime2 = 1440;

                            var minuteOfStartTime = getMinuteFromPin($('#ts_slider_container_' + params.index ),"start");
                            var startTime = minuteToTime(minuteOfStartTime);

                            log.debug("startTime***********" + startTime);
                            log.debug("minuteOfStartTime***********" + minuteOfStartTime);
                            
                            var durationTime=$(this).attr("data-duration");
                            var minuteOfDurationTime = timeToMinute(durationTime);    
                            

                            var msliderLink = $(this).attr("data-link");                                                                                            
                            if (msliderLink != "") {                                    

                                minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");
                                    
                            }

                            var endTime = get24TimeFromPosition(offset.top+dheight);
                            var minuteOfEndTime = timeToMinute(endTime);
                            
                            log.debug("minuteOfEndTime***********" + minuteOfEndTime);
                            log.debug("minuteOfstartTime***********" + minuteOfStartTime);
                            log.debug("startTime***********" + startTime);
                            log.debug("endTime " + endTime);                        

                            log.debug("diff  minuteOfStartTime2  " + minuteOfStartTime2);
                            log.debug("diff down***********" + diff + " dheight  " + dheight);
                            
                            if ( minuteOfEndTime + ( 1440 - minuteOfStartTime2 ) > 1440 && msliderLink != "" )
                            {

                                $(this).css({
                                    'height' : minuteToTime(minuteOfStartTime2) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,minuteToTime(minuteOfStartTime2),direction);

                                log.debug("1 ");
                            }
                            else if ( minuteOfEndTime >= 1440 )
                            {

                                $(this).css({
                                    'height' : minuteToPos(1440-minuteOfStartTime) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,"24:00",direction);

                                log.debug("2 ");
                            }
                            else if ( (minuteOfEndTime - minuteOfStartTime) <= 10 && msliderLink == "" )
                            {

                                $(this).css({
                                    'height' : minuteToPos(10) + 'px'
                                });

                                displayPinTime($curr,params.index,startTime,minuteToTime(minuteOfStartTime+10),direction);

                                log.debug("3 ");
                            }
                            else if ( minuteOfEndTime <= 0 && msliderLink != "" )
                            {

                                var linkContainer = $('#ts_slider_container_' + msliderLink );
                                        
                                $(linkContainer).attr("data-link", "");
                                $(linkContainer).attr("data-linkday", "");

                                var minuteOfStartTime2 = getMinuteFromPin($(linkContainer),"start");
                                log.debug("minuteOfStartTime2 " + minuteOfStartTime2);
                                displayPinTime($curr,msliderLink,minuteToTime(minuteOfStartTime2),"24:00","");
                                

                                var durationTime = minuteToTime(1440-minuteOfStartTime2);                                
                                $(linkContainer).attr("data-duration",durationTime);

                                $(linkContainer).find(".ts_schcontrollerTimeCls").show();
                                $(linkContainer).find(".ts_dragbtn").show();
                                saveTimeRange(linkContainer,"false");
                                var index=$(this).attr("data-frameIndex");
                                var type = $(this).attr("data-type");                                
                                $(this).remove();
                                setDeleteFrameFlag(type, index);
                                scheduleRender.tempdeletedArray.push(getParseIntInDec(index));
                                
                                log.debug("3-1 ");

                                return;
                            }
                            else
                            {
                                $(this).css({
                                    'height' : (dheight) + 'px'
                                });                                
                                
                                displayPinTime($curr,params.index,startTime,endTime,direction);

                                log.debug("4 ");
                            }

                            if ( msliderLink != "" )
                            {
                                minuteOfDurationTime = minuteOfEndTime+1440-minuteOfStartTime2;

                                if ( minuteOfDurationTime > 1440 )
                                    minuteOfDurationTime = 1440;
                            
                                durationTime = minuteToTime(minuteOfDurationTime);
                                    
                                $(this).attr("data-duration",durationTime);
                                $('#ts_slider_container_' + msliderLink).attr("data-duration",durationTime);

                                log.debug("4 duration " + durationTime);
                                log.debug("4 " + $(this).attr("data-duration"));                                
                            }
                            else
                            {
                                if ( minuteOfEndTime > 1440 )
                                    minuteOfEndTime = 1440;

                                if ( minuteOfEndTime-minuteOfStartTime  < 10 )
                                    minuteOfEndTime = minuteOfStartTime + 10;
                                
                                durationTime = minuteToTime(minuteOfEndTime-minuteOfStartTime);                                
                                
                                $(this).attr("data-duration",durationTime);

                                log.debug("4 1 duration " + durationTime);
                            }

                            break;
                            
                        case "move":

                            log.debug("------------------------move : nCountOfMoving : " + nCountOfMoving);

                            nCountOfMoving++;
                            if ( nCountOfMoving < 5 )
                                break;
                                

                            var msliderLink = $(this).attr("data-link");
                            $(this).find(".ts_schcontrollerTimeCls").show();

                            log.debug("lastPosY : " + lastPosY);

                            if ( msliderLink != "" && ( isStartMoving == "true" || curLastPosY != lastPosY) )
                            {                                
                                if ( isNextDay(this) == "false" )
                                {
                                    var minuteOfStartTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"start");  

                                    log.debug("lastPosY : " + lastPosY);
                                    
                                    lastPosY = lastPosY + minuteToPos(1440-minuteOfStartTime2);

                                    log.debug("minuteOfStartTime2 : " + minuteOfStartTime2);
                                    log.debug("lastPosY : " + lastPosY);
                                }
                                else
                                {
                                    var minuteOfEndTime2 = getMinuteFromPin($('#ts_slider_container_' + msliderLink ),"end"); 
                                }

                                curLastPosY = lastPosY;                                
                                isStartMoving = "false";
                                
                                return;
                            }

                            
                            log.debug("------------------------lastPosY : " + lastPosY);

                        
                            var msliderTopPos = offset.top + diff;
                            log.debug("starmsliderTopPosmsliderTopPostTime : " + msliderTopPos);

                                                      
                            var sliderdiff;
                            isDurationChange=false;

                            if ( diff != 0 )
                            {                    
                                $(".ts_dragbtn").css("display", "none");
                            }

                            var startTime = get24TimeFromPosition(msliderTopPos);

                            log.debug("startTime : " + startTime);
                            
                            var durationTime=$(this).attr("data-duration");
                            var minuteOfDurationTime = timeToMinute(durationTime);


                            var endTime = addTwoTimes(startTime,durationTime);
                            var minuteOfEndTime = timeToMinute(endTime);
                                                

                            log.debug("msliderTopPos : " + msliderTopPos + "move params.index : " + params.index + " lastPosY " + lastPosY);
                            log.debug("durationTime : " + durationTime);
                            log.debug("endTime : " + endTime);
                            log.debug("minuteOfDurationTime : " + minuteOfDurationTime + "  minuteOfEndTime : " + minuteOfEndTime);
                            log.debug("containerTopPosY : " + containerTopPosY);                        
                            log.debug("linksliderTop : " + linksliderTop);
                            log.debug("linksliderHght : " + linksliderHght);    

                            log.debug("scheduleRender.istimeBar : " + scheduleRender.istimeBar);

                            
                            if ( ( containerTopPosY < msliderTopPos && minuteOfEndTime <= 1440 ) || minuteOfEndTime == minuteOfDurationTime ) {

                                log.debug("========= condition of non looping =========");

                                var durationinMin;
                                
                                                                
                                if (msliderLink != "") {

                                    log.debug("startTime : " + startTime);

                                    linksliderHght = $("#ts_slider_container_" + msliderLink).outerHeight();
                                    log.debug("linksliderHght : " + linksliderHght + " diff " + diff);
                                    log.debug("minuteOfDurationTime : " + minuteOfDurationTime + "  minuteOfEndTime : " + minuteOfEndTime);
                                    
                                    if ( linksliderHght == 0||(((linksliderHght - diff < 5) || ( timeToMinute(startTime) >= 0 && isStartMoving == "false" )) && isNextDay(this) == "false" )||( minuteOfEndTime <= 1440 && isNextDay(this) == "true" ) )
                                    {
                                        
                                       log.debug("m inside delete loop");
                                        var mday = $(this).attr("data-day");
                                        var mlinkedday = $(this).attr("data-linkday");
                                        var dayIndex = getDayIndex(mday);
                                        var linkeddayIndex = getDayIndex(mlinkedday);                                   
                                         var type = $("#ts_slider_container_" + msliderLink).attr("data-type");
                                        $("#timer_" + mlinkedday).find("#ts_slider_container_" + msliderLink).remove();
                                          setDeleteFrameFlag(type, msliderLink);
                                        if (scheduleRender.istimeBar != "true") {
                                               scheduleRender.tempdeletedArray.push(getParseIntInDec(msliderLink));
                                        }
                                        
                                        $(this).attr("data-link", "");
                                        $(this).attr("data-linkday", "");

                                        durationTime=$(this).attr("data-duration");

                                        $(this).find(".ts_schcontrollerTimeCls").show();
                                    }
                                    else 
                                    {
                                        return;                                    
                                    }                                    
                                }
                                

                                var schEndTime = durationTime.split(":");
                                var hh_duration = getParseIntInDec(schEndTime[0]);
                                var mm_duration = getParseIntInDec(schEndTime[1]);
                                var durationinMin = getParseIntInDec(((hh_duration) * HHInt) + ((mm_duration) * MMInt));

                                $(this).css({
                                    'top' : getParseIntInDec(msliderTopPos) + 'px',
                                    'height' : durationinMin + "px"
                                });


                                displayPinTime($curr,params.index,startTime,endTime,direction);                                
                                

                            } else if ( minuteOfEndTime > 1440) {
                            
                                log.debug("========= condition of bottom looping =========");

                                $(this).find(".ts_schcontrollerTimeCls").show();

                                if (scheduleRender.istimeBar != "true") {

                                    log.debug("bottom : ");
                                    
                                    $(this).find('#endTimePinAreaId').hide();                                

                                    createNxtTimeBar($(this), minuteOfEndTime - 1440);

                                    containerHeight = $curr.height();                                

                                    $(this).css({
                                        'top' : getParseIntInDec(msliderTopPos) + 'px',
                                        'height' : (getParseIntInDec(containerTopPosY+containerHeight) - getParseIntInDec(msliderTopPos)) + 'px',
                                    });

                                    displayPinTime($curr,params.index,startTime,"24:00",direction);


                                    if ( timeToMinute(startTime) >= 1440 )
                                    {
                                        var msliderLink = $(this).attr("data-link");
                                        var linkContainer = $('#ts_slider_container_' + msliderLink );
                                        
                                        $(linkContainer).attr("data-link", "");
                                        $(linkContainer).attr("data-linkday", "");

                                        displayPinTime($curr,msliderLink,"00:00",minuteToTime(minuteOfEndTime-1440),"");
                                        
                                        $(linkContainer).find(".ts_schcontrollerTimeCls").show();
                                        $(linkContainer).find(".ts_dragbtn").show();
                                        saveTimeRange(linkContainer,"false");
                                        var index=$(this).attr("data-frameIndex");
                                        var type = $(this).attr("data-type");                                
                                        $(this).remove();
                                        setDeleteFrameFlag(type, index);
                                        scheduleRender.tempdeletedArray.push(getParseIntInDec(index));

                                        log.debug("removed!!");
                                    }                                    
                                }
                                else
                                {
                                    $(this).css({
                                        'top': conTopPos+(1440-minuteOfDurationTime)*MMInt + 'px',
                                        'height' : (minuteOfDurationTime*MMInt) + "px"
                                    });

                                    displayPinTime($curr,params.index,minuteToTime(1440-minuteOfDurationTime),"24:00",direction);
                                    
                                }
                                                                
                                
                            } else {
                            
                                log.debug("========= condition of top looping =========");

                                $(this).find(".ts_schcontrollerTimeCls").show();

                                if (scheduleRender.istimeBar != "true") {

                                    $($curr).find('#startTimePinAreaId').hide();
                                    

                                    startTime = minuteToTime(minuteOfDurationTime-minuteOfEndTime);
                                    log.debug("startTime : " + startTime);

                                    if ( minuteOfEndTime < 0 )
                                        minuteOfEndTime = 0;
                                    
                                    createPrevTimeBar($(this), (minuteOfDurationTime-minuteOfEndTime));
                                    
                                    $(this).css({
                                        'top':conTopPos+'px',
                                        'height' : getParseIntInDec(minuteToPos(minuteOfEndTime)) + 'px',
                                    });
                                    
                                    displayPinTime($curr,params.index,"00:00",endTime,direction);

                                    log.debug("minuteOfEndTime : " + minuteOfEndTime);

                                    if ( minuteOfEndTime == 0 )
                                    {
                                        var msliderLink = $(this).attr("data-link");
                                        var linkContainer = $('#ts_slider_container_' + msliderLink );
                                        
                                        $(linkContainer).attr("data-link", "");
                                        $(linkContainer).attr("data-linkday", "");
                                        
                                        displayPinTime($curr,msliderLink,minuteToTime(1440-minuteOfDurationTime),"24:00","");
                                        
                                        $(linkContainer).find(".ts_schcontrollerTimeCls").show();
                                        $(linkContainer).find(".ts_dragbtn").show();
                                        saveTimeRange(linkContainer,"false");    
                                        var index=$(this).attr("data-frameIndex");
                                        var type = $(this).attr("data-type");                                
                                        $(this).remove();
                                        setDeleteFrameFlag(type, index);
                                        scheduleRender.tempdeletedArray.push(getParseIntInDec(index));

                                        log.debug("removed!!");
                                    }
                                }
                                else
                                {
                                    $(this).css({
                                        'top':conTopPos+'px',
                                        'height' : (minuteOfDurationTime*MMInt) + "px"
                                    });

                                    displayPinTime($curr,params.index,"00:00",durationTime,direction);                                    
                                }
                            }

                            break;

                        default:
                            break;
    
                        }
                    }
                }
            });

            var sliderdiv = "<div id='ts_slider_container_" + params.index + "' class='ts_slider_containerCls'>" + 
                                "<div id='globalstartTimePinAreaId' class='ts_globalschcontrollerTimeCls'>" + 
                                    "<div id='ts_gstTopdragger' class='ts_gstdragbtn_sel ts_gstdragger'></div>" + 
                                    "<div class='ts_upControllerBar_arrow'></div>" + 
                                    "<div class='ts_upControllerBar'></div>" + 
                                "</div>" + 
                                "<div id='copydelbtnId' class='ts_schcopydelbtnCls'>" + 
                                    "<div id='copybtnId' class='ts_copybtnCls'></div>" + 
                                    "<div id='delbtnId' class='ts_delbtnCls'></div>" + 
                                    "<div id='undobtnId' class='ts_undobtnCls'></div>" + 
                                "</div>" + 
                                "<div id='startTimePinAreaId' class='ts_schcontrollerTimeCls'>" + 
                                    "<div class='ts_controllerTimeCls' ></div>" + 
                                    "<div class='ts_controllerAMPMCls'>PM</div>" + 
                                "</div>" + 
                                "<div id='ts_slidertopdragger' class='ts_dragbtn ts_dragbtn_sel'></div>" + 
                                "<div id='ts_sliderContentArea' class='ts_contentArea'></div>" + 
                                "<div id='ts_sliderbttmdragger' class='ts_dragbtn ts_dragbtn_sel'></div>" + 
                                "<div id='endTimePinAreaId' class='ts_schcontrollerTimeCls'>" + 
                                    "<div class='ts_controllerTimeCls' ></div>" + 
                                    "<div class='ts_controllerAMPMCls'>PM</div>" + 
                                "</div>" + 
                                "<div id='globalEndTimePinAreaId' class='ts_globalschcontrollerTimeCls'>" + 
                                "<div id='ts_gstBtmdragger' class='ts_gstdragbtn_sel ts_gstdragger'></div>" + 
                                "<div class='ts_dwnControllerBar_arrow'></div>" + 
                                "<div class='ts_dwnControllerBar'></div>" + 
                                "</div>" + 
                            "</div>";

            $curr.append(sliderdiv).show();
            $curr.find('#ts_slider_container_' + params.index + ' > #startTimePinAreaId > .ts_controllerTimeCls').html(tp_startTime);
            $curr.find('#ts_slider_container_' + params.index + ' > #startTimePinAreaId > .ts_controllerAMPMCls').html(tp_stTime_AmPm);
            $curr.find('#ts_slider_container_' + params.index + ' > #endTimePinAreaId > .ts_controllerTimeCls').html(tp_endTime);
            $curr.find('#ts_slider_container_' + params.index + ' > #endTimePinAreaId > .ts_controllerAMPMCls').html(tp_endTime_AmPm);
            calculateTimerDimension($curr);
            var $timeSlider = $('#ts_slider_container_' + params.index);

        });
        params.onCreate.call(this, true, params.index, params.color);
        return this;
    };

})(jQuery);
