var designElementDbObj;
var dbCreated = false;
var mDesignElementsName = "";
var mDesignElementsUrl = "";
var mDesignElementsPath = "";
var mDesignElementsStatus = "";
var mDesignElementsType = "";
var mTimeStamp = "";
var DesignElements_DB_TAB = "DesignElements:: ";

var myDesignElementsInfoJson = {};
var myDesignElementsInfoArr = [];
myDesignElementsInfoJson.myDesignElementsInfoArr = myDesignElementsInfoArr;

var myFontElementsInfoJson = {};
var myFontElementsInfoArr = [];
myFontElementsInfoJson.myFontElementsInfoArr = myFontElementsInfoArr;

/***
 * To insert DesignElements info in DB
 *
 * @param
 *      mDesignElementsName -> Design Elements Name
 *      mDesignElementsUrl -> Design Elements URL
 *      mDesignElementsPath -> SD Card Path
 *      mDesignElementsStatus -> Download status (1 - downloaded , 0-Not downloaded)
 *      mDesignElementsType -> Design Elements Type
 *
 */
function insertDesignElementsInfo(mDesignElementsName, mDesignElementsUrl, mDesignElementsPath,mDesignElementsStatus, mDesignElementsType) {
    console.log(DesignElements_DB_TAB + "@insertDesignElementsInfo: " + "DesignElementsName: " + mDesignElementsName + " ,mDesignElementsUrl: " + mDesignElementsUrl + ", mDesignElementsPath: "
     + mDesignElementsPath + "mDesignElementsStatus: " + mDesignElementsStatus +"mDesignElementsType: "+mDesignElementsType);
    this.mDesignElementsName = Utils.encodeData(mDesignElementsName);
    this.mDesignElementsUrl = mDesignElementsUrl;
    this.mDesignElementsPath = mDesignElementsPath;
    this.mDesignElementsStatus = mDesignElementsStatus;
    this.mDesignElementsType = mDesignElementsType;
    this.mTimeStamp = new Date().getTime();

    designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
    console.log(DesignElements_DB_TAB + "@insertDesignElementsInfo: open db success - DesignElementsDB");
    designElementDbObj.transaction(populateDesignElementsDB, DesignElementsDBError);
}


/**
 * To get the DesignElements information list
 */
function getDesignElementsInfo() {
    console.log(DesignElements_DB_TAB + "--x--@getDesignElementsInfo");
    designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
    designElementDbObj.transaction(readDesignElementsDB, DesignElementsDBError, populateDesignElementsDBOnSuccess);
}


/**
 * To deleteDesignElementsFromDB according to specified attribute
 * @param DesignElementsName
 */
function deleteDesignElementsFromDB(id) {
    console.log(DesignElements_DB_TAB + "@deleteDesignElementsFromDB");
    var designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
    designElementDbObj.transaction(function(tx) {
    tx.executeSql("DELETE FROM tbl_DesignElements WHERE tbl_DesignElements.id = '"+id+"'");
    console.log(DesignElements_DB_TAB + " Delete one item success" + id);
    });
    if(id == WEATHER_IMG_LIST_IDX){ //  5 is for weather image index in settings
    	Utils.setWeatherImgDownloaded(false);
    }
    getDesignElementsInfo();
}


function updateDesignElementsStatusWithId(id, DesignElementsStatus){
    console.log(DesignElements_DB_TAB + "--x--@updateDesignElementsFromDB, with ID:"+id);
    var designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
    var whr = "WHERE tbl_DesignElements.id = '"+id+"'";
    var sql = "UPDATE tbl_DesignElements SET " + " DesignElementsStatus='" + DesignElementsStatus +"' "+whr;
    console.log(DesignElements_DB_TAB + sql);
    designElementDbObj.transaction(function(tx) {
    tx.executeSql(sql);
        console.log(DesignElements_DB_TAB + " Updated one item success");
    });
    if(id == WEATHER_IMG_LIST_IDX){ //  WEATHER_IMG_LIST_IDX is for weather image index in settings
    	if(DesignElementsStatus == '1'){
    	  Utils.setWeatherImgDownloaded(true);
    	}else{
    	  Utils.setWeatherImgDownloaded(false);
    	}
    }
}

/**
 * To deleteDesignElementsFromDB according to specified attribute
 * @param DesignElementsName
 */
function updateDesignElementsFromDB(id, DesignElementsStatus) {
    updateDesignElementsStatusWithId(id, DesignElementsStatus);
    getDesignElementsInfo();
}


function populateDesignElementsDB(tx) {
   console.log(DesignElements_DB_TAB + "@populateDesignElementsDB for Insert Operation");
   var sql = "CREATE TABLE IF NOT EXISTS tbl_DesignElements ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "DesignElementsName VARCHAR(150), " + "DesignElementsUrl VARCHAR(350), " +"DesignElementsPath VARCHAR(200)," +"DesignElementsStatus VARCHAR(200) , " + "DesignElementsType VARCHAR(200) ," + "TimeStamp VARCHAR(20))";
   console.log(DesignElements_DB_TAB + sql);
   tx.executeSql(sql);
    var mDesignElementsNameArr = new Array();
	var mDesignElementsUrlArr = new Array();
	var mDesignElementsPathArr = new Array();
	var mDesignElementsTypeArr = new Array();
	// Inserting Design Elements
	mDesignElementsNameArr = ['Templates', 'Background Images (Classic)', 'Background Images (Modern)', 'Background Images (Vintage)', 'Weather Images', 'English Fonts', 'Korean Fonts', 'Chinese Fonts'];
	mDesignElementsUrlArr =  [FREE_TEMPLT_ZIP_NAME, 'SMART_Signage_TV_Background_Classic.zip', 'SMART_Signage_TV_Background_Modern.zip', 'SMART_Signage_TV_Background_Vintage.zip', 'weather_Image.zip', 'SMART_Signage_TV_Font_Eng.zip', 'font_Korean.zip', 'font_SCN.zip'];
	mDesignElementsPathArr = ['.ETabletAuthor/FreeTemplates/Download', '.ETabletAuthor/BG/bg_custom/bg_classic/actual' , '.ETabletAuthor/BG/bg_custom/bg_modern/actual', '.ETabletAuthor/BG/bg_custom/bg_vintage/actual', '.ETabletAuthor/WeatherImage', '.ETabletAuthor/Fonts/Downloads/english', '.ETabletAuthor/Fonts/Downloads/korean', '.ETabletAuthor/Fonts/Downloads/chinese'];
	mDesignElementsTypeArr = ['TEMPLATE', 'BG_CLASSIC', 'BG_MODERN', 'BG_VINTAGE', 'WEATHER_IMAGE', 'FONT', 'FONT', 'FONT'];
	for (var i = 0; i < mDesignElementsNameArr.length; i++) {
		   tx.executeSql("INSERT INTO tbl_DesignElements (DesignElementsName,DesignElementsUrl,DesignElementsPath,DesignElementsStatus,DesignElementsType,TimeStamp) VALUES (" + 
	       "'" + Utils.encodeData(mDesignElementsNameArr[i]) + "'" + "," + 
	       "'" + mDesignElementsUrlArr[i] + "'" + "," + 
	       "'" + mDesignElementsPathArr[i] + "'" +"," + 
	       "'" + mDesignElementsStatus + "'" +"," + 
	       "'" + mDesignElementsTypeArr[i] + "'" +"," + 
	       "'" + mTimeStamp + "'" + ")");
	    console.log(DesignElements_DB_TAB + "Inserted one item success");
	}
  localStorage.setItem("DesignElements_INFO", "");
  localStorage.setItem("FontElements_INFO", "");
  getDesignElementsInfo(); 
}



/**
 * To populate readDesignElementsDB
 * @param tx
 */
function readDesignElementsDB(tx) {
    console.log(DesignElements_DB_TAB + "@readDesignElementsDB");
    var sql = "CREATE TABLE IF NOT EXISTS tbl_DesignElements ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "DesignElementsName VARCHAR(150), " + "DesignElementsUrl VARCHAR(350), " +"DesignElementsPath VARCHAR(200)," +"DesignElementsStatus VARCHAR(200) , " + "DesignElementsType VARCHAR(200) ," + "TimeStamp VARCHAR(20))";
    console.log(DesignElements_DB_TAB + "SqlQuery: " + sql);
    tx.executeSql(sql);
    //alert("excute read success");
}

function DesignElementsDBError(tx, error) {
    //alert("Database Error: " + error);
    console.log(DesignElements_DB_TAB + "@transaction_error");
}

function populateDesignElementsDBOnSuccess() {
    console.log(DesignElements_DB_TAB + "@populateDB_success");
    designElementDbObj.transaction(excuteDesignElementsQuery, DesignElementsDBError);
}

/**
 * To excute DesignElements query for fetching db list
 * @param tx
 */
function excuteDesignElementsQuery(tx) {
    console.log(DesignElements_DB_TAB + "@excuteDesignElementsQuery");
   // var sql = "select id from  tbl_DesignElements order by id desc";
    var sql = "select * from  tbl_DesignElements order by id asc";
    console.log(DesignElements_DB_TAB + "@excuteQuery: " + sql);
    tx.executeSql(sql, [], fetchDesignElementsItemList);
}

/**
 * To show list of DesignElements item list
 * here user can populate using html components
 */
function fetchDesignElementsItemList(tx, results) {
    myDesignElementsInfoJson = {};
    myDesignElementsInfoArr = [];
    myDesignElementsInfoJson.myDesignElementsInfoArr = myDesignElementsInfoArr;
   
    myFontElementsInfoJson = {};
    myFontElementsInfoArr = [];
    myFontElementsInfoJson.myFontElementsInfoArr = myFontElementsInfoArr;
   
    var len = results.rows.length;
    if(len < 1){
    	insertDesignElementsInfo("", "", "",0, 'BG'); 
    }else{
       for (var i = 0; i < len; i++) {
	        var myDesignElementsRows = results.rows.item(i);
	        var myDesignElementsInfo = {};
	        
	        if(myDesignElementsRows.DesignElementsType == 'FONT'){
	        	myDesignElementsInfo.id = myDesignElementsRows.id;
		        myDesignElementsInfo.DesignElementsName = Utils.decodeData(myDesignElementsRows.DesignElementsName);
		        myDesignElementsInfo.DesignElementsUrl = myDesignElementsRows.DesignElementsUrl;
		        myDesignElementsInfo.DesignElementsPath = myDesignElementsRows.DesignElementsPath;
		        myDesignElementsInfo.DesignElementsStatus = myDesignElementsRows.DesignElementsStatus;
		        myDesignElementsInfo.DesignElementsType = myDesignElementsRows.DesignElementsType;
		        myFontElementsInfoJson.myFontElementsInfoArr.push(myDesignElementsInfo);
	        }else{
		        myDesignElementsInfo.id = myDesignElementsRows.id;
		        myDesignElementsInfo.DesignElementsName = Utils.decodeData(myDesignElementsRows.DesignElementsName);
		        myDesignElementsInfo.DesignElementsUrl = myDesignElementsRows.DesignElementsUrl;
		        myDesignElementsInfo.DesignElementsPath = myDesignElementsRows.DesignElementsPath;
		        myDesignElementsInfo.DesignElementsStatus = myDesignElementsRows.DesignElementsStatus;
		        myDesignElementsInfo.DesignElementsType = myDesignElementsRows.DesignElementsType;
		        myDesignElementsInfoJson.myDesignElementsInfoArr.push(myDesignElementsInfo);
		       
		        switch(myDesignElementsRows.DesignElementsType) {
				case 'TEMPLATE':
					localStorage.setItem('isTmpltDownloaded', myDesignElementsRows.DesignElementsStatus);
					break;
				case 'BG_CLASSIC':
					localStorage.setItem('isBGClassic', myDesignElementsRows.DesignElementsStatus);
					break;
				case 'BG_MODERN':
					localStorage.setItem('isBGModern', myDesignElementsRows.DesignElementsStatus);
					break;
				case 'BG_VINTAGE':
					localStorage.setItem('isBGVintage', myDesignElementsRows.DesignElementsStatus);
					break;
				case 'WEATHER_IMAGE':
					localStorage.setItem('isWeatherImage', myDesignElementsRows.DesignElementsStatus);
					break;
				default:
					console.log("No design element matched..");
				}
	        }
	     
       }
      createDesignElementsSessionJsonList(myDesignElementsInfoJson ,myFontElementsInfoJson);
    }
 }

function createDesignElementsSessionJsonList(myDesignElementsInfoJson,myFontElementsInfoJson){
    // Put the object into session storage
    console.log("Design Elements Json: "+JSON.stringify(myDesignElementsInfoJson));
    console.log("Font Elements Json: "+JSON.stringify(myFontElementsInfoJson));
    //alert(JSON.stringify(myDesignElementsInfoJson));
    //alert(JSON.stringify(myFontElementsInfoJson));
    localStorage.setItem("DesignElements_INFO", JSON.stringify(myDesignElementsInfoJson));
    localStorage.setItem("FontElements_INFO", JSON.stringify(myFontElementsInfoJson));
}

function checkRecord() {
    var sql = "select id from  tbl_DesignElements order by id desc";
    var designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
    designElementDbObj.transaction(function(tx) {
        tx.executeSql(sql, [], dropDesignElementsTable);
    });

}

function dropDesignElementsTable(tx, results) {

    //alert("results.rows.length  "+results.rows.length);
    if (results.rows.length == 0) {
        var designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
        designElementDbObj.transaction(function(tx) {
            tx.executeSql("DROP  TABLE  tbl_DesignElements");
            console.log(DesignElements_DB_TAB + " Updated one item success");
            projectCounter = 0;
        });
    }

}

function dropDesignElementsTableForcely() {

    console.log("drop DesignElementsTable");
    var designElementDbObj = window.openDatabase("DesignElementsDB", "1.0", "MagicInfo", 200000);
    designElementDbObj.transaction(function(tx) {
        tx.executeSql("DROP TABLE tbl_DesignElements");
        console.log(DesignElements_DB_TAB + "DROP TABLE tbl_DesignElements");
        projectCounter = 0;
    });
   
}
