var db;
var dbCreated = false;
var mDeviceName = "";
var mDeviceIP = "";
var mStorageType = "";
var mTotalSpace = "";
var mAvailableSpace = "";
var mVersion = "";
var mConnectionStatus = "";
var mDeviceState = "";
var mPlayerType = "";
var mTLSRequired= "";
var mMacAddress = "";
var mPin = "";
var mTimeStamp = "";

var Device_DB_TAB = "DeviceListDB:: ";
var myDeviceInfoJson = {};
var myDeviceInfoArr = [];
myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;

/***
 * To insert Device info in DB
 *
 * @param
 *      mDeviceName -> Device Name
 *      mDeviceIP -> 1.2.3.4
 *      mStorageType -> USB/Internal
 *      mTotalSpace -> 324234234
 *      mAvailableSpace -> 54353453
 *      mVersion ->  firmware version
 *      mConnectionStatus - > true / false
 * 
 *      mDeviceState ->  STATE_INIT, STATE_SUPPORTED, STATE_UNSUPPORTED, STATE_UPDATE_REQ, STATE_FAIL_CONNECTION;
 */


function insertDeviceInfo(deviceName, deviceIP, connectionStatus, storageType, totalSpace, availableSpace, version, playerType,deviceState,macAddr,tls,pin) {
	console.log(Device_DB_TAB + "@insertDeviceInfo: " + "DeviceName: " + deviceName + " ,mDeviceIP: " + deviceIP + ", mConnectionStatus: " + connectionStatus + "  mStorageType: " + storageType + "mTotalSpace: " + totalSpace + "mAvailableSpace: " + availableSpace + "mVersion: " + version + "PlayerType: "+playerType+ "mDeviceState: " + deviceState);

	mDeviceName = encodeData(deviceName);
	//mDeviceIP = encodeData(deviceIP);
	mDeviceIP =  deviceIP;
	mConnectionStatus = connectionStatus;
	mStorageType = storageType;
	mTotalSpace = totalSpace;
	mAvailableSpace = availableSpace;
	mVersion = version;
	mPlayerType = playerType;
	mDeviceState = deviceState;
	mMacAddress = macAddr;
	mTLSRequired = tls;
	mPin = pin;
	mTimeStamp = new Date().getTime();
    
  //  alert(Device_DB_TAB + "@insertDeviceInfo: " + "DeviceName: " + deviceName + " ,mDeviceIP: " + deviceIP + ", mConnectionStatus: " + connectionStatus + "  mStorageType: " + storageType + "mTotalSpace: " + totalSpace + "mAvailableSpace: " + availableSpace + "mVersion: " + version + "mDeviceState: " + deviceState);
	db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
	console.log(Device_DB_TAB + "@insertDeviceInfo: DB Open Successfully...");
	db.transaction(populateDeviceListDB, DeviceListDBError);
}

/**
 * To get the Device information list
 */
function getDeviceInfo() {
	console.log(Device_DB_TAB + "@getDeviceInfo");
	db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
	db.transaction(readDeviceListDB, DeviceListDBError, populateDeviceListDBOnSuccess);
}

/**
 * To deleteDeviceFromDB according to specified attribute
 * @param DeviceName
 */
function deleteDeviceFromDB(mDeviceIP) {
	console.log(Device_DB_TAB + "@deleteDeviceFromDB");
	//mDeviceIP = encodeData(mDeviceIP);
	var db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
	db.transaction(function(tx) {
        var sql = "DELETE FROM tbl_Devices WHERE tbl_Devices.DeviceIP = '" + mDeviceIP + "'";
        console.log("@@@@@@ sql query: "+sql);
		tx.executeSql(sql);
		console.log(Device_DB_TAB + " Delete one item success" + mDeviceIP);
	});
	sessionStorage.setItem("Device_INFO", "");
	getDeviceInfo();
}

/**
 * 
 *update device list DB as wll as  update getDeviceInfo() in session
 *
 * @param DeviceName
 */
function updateDeviceFromDB(deviceName, deviceIP, connectionStatus, storageType, totalSpace, availableSpace, version,playerType , deviceState,macAddr,tls,pin) {
	console.log(Device_DB_TAB + "@@@@@@@ updateDeviceFromDB @@@@@@@@@:  " + "DeviceName: " + deviceName + " ,mDeviceIP: " + deviceIP + ", mConnectionStatus: " + connectionStatus + "  mStorageType: " + storageType + "mTotalSpace: " + totalSpace + "mAvailableSpace: " + availableSpace + "mVersion: " + version + "PlayerType: "+playerType+ "mDeviceState: " + deviceState);
	deviceName = encodeData(deviceName);
	var db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
	var whr = " WHERE tbl_Devices.DeviceIP = '" + deviceIP + "'";
	var sql = "UPDATE tbl_Devices SET " + " DeviceName='" + deviceName + "'," + "ConnectionStatus='" + connectionStatus + "'," + "StorageType='" + storageType + "'," + "TotalSpace='" + totalSpace + "'," + "AvailableSpace='" + availableSpace + "'," 
	+ "Version='" + version + "'," + "PlayerType='" + playerType + "'," + "DeviceState='" + deviceState +  "',"  + "MacAddress='" + macAddr + "'," + "TLSReq='" + tls +  "'," + "Pin='" + pin +  "'" + whr;
	console.log(Device_DB_TAB + sql);
	
	db.transaction(function(tx) {
		tx.executeSql(sql);
		console.log(Device_DB_TAB + " Updated one item successfully:  "+deviceIP +" , DeviceName: "+deviceName);
		sessionStorage.setItem("Device_INFO", "");
		console.log(Device_DB_TAB + " Reseting updated device list: "+deviceIP+" , DeviceName: "+deviceName);
	    getDeviceInfo();
	});
}


/**
 * 
 *update device list DB as wll as  update updateDeviceState() in session
 *
 * @param DeviceName
 */
function updateDeviceState(deviceIP, connectionStatus,deviceState) {
	var db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
	var whr = "WHERE tbl_Devices.DeviceIP = '" + deviceIP + "'";
	var sql = "UPDATE tbl_Devices SET " + "ConnectionStatus='" + connectionStatus + "'," + "DeviceState='" + deviceState + "' " + whr;
	console.log(Device_DB_TAB + sql);
	
	db.transaction(function(tx) {
		tx.executeSql(sql);
		console.log(Device_DB_TAB + "device status updated");
	});
}




function populateDeviceListDB(tx) {
	console.log(Device_DB_TAB + "@getDeviceInfo populateDeviceListDB for Insert Operation");
	var sql = "CREATE TABLE IF NOT EXISTS tbl_Devices ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "DeviceName VARCHAR(256), " + "DeviceIP VARCHAR(50), " + "ConnectionStatus VARCHAR(50), " + "StorageType VARCHAR(50)," + "TotalSpace VARCHAR(150) , " + "AvailableSpace VARCHAR(150) , " + "Version VARCHAR(100) , " + "PlayerType VARCHAR(50) , "+ "DeviceState VARCHAR(50)," + "MacAddress VARCHAR(50)," + "TLSReq VARCHAR(10)," + "Pin VARCHAR(10),"+ "TimeStamp VARCHAR(50))";
	console.log(Device_DB_TAB + sql);
	tx.executeSql(sql);
	tx.executeSql("INSERT INTO tbl_Devices (DeviceName,DeviceIP,ConnectionStatus,StorageType,TotalSpace,AvailableSpace,Version,PlayerType,DeviceState,MacAddress,TLSReq,Pin,TimeStamp) VALUES ("
	+ "'" + mDeviceName + "'"  + "," 
	+ "'" + mDeviceIP + "'" + "," 
	+ "'" + mConnectionStatus + "'" + "," 
	+ "'" + mStorageType + "'" + "," 
	+ "'" + mTotalSpace + "'" + "," 
	+ "'" + mAvailableSpace + "'" + "," 
	+ "'" + mVersion + "'" + "," 
	+ "'" + mPlayerType + "'" + "," 
	+ "'" + mDeviceState + "'" + ","
	+ "'" + mMacAddress + "'" + ","
    + "'" + mTLSRequired + "'" + ","
    + "'" + mPin + "'" + ","
	+ "'" + mTimeStamp + "'" + ")");
	
	//alert( "'" + mDeviceIP + "'" + "," + "'" + mConnectionStatus + "'" + "," + "'" + mStorageType + "'" + "," + "'" + mTotalSpace + "'" + "," + "'" + mAvailableSpace + "'" + "," + "'" + mVersion + "'" + "," + "'" + mDeviceState + "'" + "," + "'" + mTimeStamp + "'");
	//alert("Inserted success");
	console.log(Device_DB_TAB + "Inserted one item success");
	sessionStorage.setItem("Device_INFO", "");
	getDeviceInfo();
}

/**
 * To populate readDeviceListDB
 * @param tx
 */
function readDeviceListDB(tx) {
	console.log(Device_DB_TAB + "@readDeviceListDB");
	var sql = "CREATE TABLE IF NOT EXISTS tbl_Devices ( " + "id INTEGER PRIMARY KEY AUTOINCREMENT, " + "DeviceName VARCHAR(256), " + "DeviceIP VARCHAR(50), " + "ConnectionStatus VARCHAR(50), " + "StorageType VARCHAR(50)," + "TotalSpace VARCHAR(150) , " + "AvailableSpace VARCHAR(150) , " + "Version VARCHAR(100) ," + "PlayerType VARCHAR(50) , "+ "DeviceState VARCHAR(50)," + "MacAddress VARCHAR(50)," + "TLSReq VARCHAR(10)," + "Pin VARCHAR(10),"+ "TimeStamp VARCHAR(50))";
	console.log(Device_DB_TAB + "SqlQuery: " + sql);
	tx.executeSql(sql);
	console.log("execute read success");
}

function DeviceListDBError(tx, error) {
	console.log("Database Error: " + error);
	console.log(Device_DB_TAB + "@transaction_error");
}

function populateDeviceListDBOnSuccess() {
	console.log(Device_DB_TAB + "@populateDB_success");
	db.transaction(excuteDeviceQuery, DeviceListDBError);
}

/**
 * To excute Device query for fetching db list
 * @param tx
 */
function excuteDeviceQuery(tx) {
	console.log(Device_DB_TAB + "@excuteDeviceQuery");
	var sql = "select * from  tbl_Devices group by DeviceIP order by id desc";
	console.log(Device_DB_TAB + "@excuteQuery: " + sql);
	tx.executeSql(sql, [], fetchDeviceItemList);
}

/**
 * To show list of Device item list
 * here user can populate using html components
 */
function fetchDeviceItemList(tx, results) {
	myDeviceInfoJson = {};
	myDeviceInfoArr = [];
	myDeviceInfoJson.myDeviceInfoArrs = myDeviceInfoArr;
	var len = results.rows.length;
    console.log("Device DB Length: "+len);
	for (var i = 0; i < len; i++) {
		var myDeviceRows = results.rows.item(i);
		var myDeviceInfo = {};
		
		myDeviceInfo.id = myDeviceRows.id;
		myDeviceInfo.DeviceName = decodeData(myDeviceRows.DeviceName);
		myDeviceInfo.DeviceIP = myDeviceRows.DeviceIP;
		myDeviceInfo.ConnectionStatus = myDeviceRows.ConnectionStatus;
		myDeviceInfo.StorageType = myDeviceRows.StorageType;
		myDeviceInfo.TotalSpace = myDeviceRows.TotalSpace;
		myDeviceInfo.AvailableSpace = myDeviceRows.AvailableSpace;
		myDeviceInfo.Version = myDeviceRows.Version;
		myDeviceInfo.PlayerType = myDeviceRows.PlayerType;
		myDeviceInfo.DeviceState = myDeviceRows.DeviceState;
		myDeviceInfo.MacAddress = myDeviceRows.MacAddress;
		myDeviceInfo.TLSReq = myDeviceRows.TLSReq;
		myDeviceInfo.Pin = myDeviceRows.Pin;
		myDeviceInfo.TimeStamp = myDeviceRows.TimeStamp;
		myDeviceInfoJson.myDeviceInfoArrs.push(myDeviceInfo);
	}
	createDeviceSessionJsonList();
}

function createDeviceSessionJsonList() {
	sessionStorage.setItem("Device_INFO", JSON.stringify(myDeviceInfoJson));
	console.log(JSON.stringify(myDeviceInfoJson));
	//alert(JSON.stringify(myDeviceInfoJson));
}

function checkRecord() {
	var sql = "select id from  tbl_Devices order by id asc";
	var db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
	db.transaction(function(tx) {
		tx.executeSql(sql, [], dropDeviceTable);
	});
}

function dropDeviceTable(tx, results) {
	if (results.rows.length == 0) {
		var db = window.openDatabase("DeviceListDB", "1.0", "MagicInfo", 200000);
		db.transaction(function(tx) {
			tx.executeSql("DROP TABLE  tbl_Devices");
			console.log(Device_DB_TAB + " Updated one item success");
			projectCounter = 0;
		});
	}
}

function encodeData(s) {
	return encodeURIComponent(s).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27").replace(/\(/g, "%28").replace(/\)/g, "%29");
}

function decodeData(s) {
	try {
		return decodeURIComponent(s.replace(/\%2D/g, "-").replace(/\%5F/g, "_").replace(/\%2E/g, ".").replace(/\%21/g, "!").replace(/\%7E/g, "~").replace(/\%2A/g, "*").replace(/\%27/g, "'").replace(/\%28/g, "(").replace(/\%29/g, ")"));
	} catch (e) {
	}
	return "";
}