/* 
 * Created by amber.m 02-03-2015 for blank template rendering and handling
 *
 * Dependent Files : template.js
 */


template.prototype.getNewInnerFrameDim = function(dropX, dropY, orgW, orgH){
    var w = 0;
    var h = 0;
    if(orgW <= 0 || orgH <= 0){
        log.debug("ZERO/NEGATIVE HEIGHT/WIDTH NOT ALLOWED ", "getNewInnerFrameDim");
        return null;
    }
    var ptX = (dropX - this.mainFrame.x + (this.mainFrame.w * this.mainFrame.scale - this.mainFrame.w)/2 - this.mainFrame.xOffset)/this.mainFrame.scale;
    var ptY = (dropY - this.mainFrame.y + (this.mainFrame.h * this.mainFrame.scale - this.mainFrame.h)/2 - this.mainFrame.yOffset)/this.mainFrame.scale;
//    if(this.modelType == RHE_MODEL){
//        if(orgW >= this.lfdSize.w && orgH >= this.lfdSize.h){
//            return {x:0,y:0,w:this.mainFrame.w,h:this.mainFrame.h};
//        }
//    }else if(this.modelType == RMD_MODEL){
        if(orgW >= 1080 && orgH >= 1080){
            if(this.orientation == LANDSCAPE){
                return this.calculateFrameRect(ptX, ptY, this.mainFrame.h, this.mainFrame.h);
            }else{
                return this.calculateFrameRect(ptX, ptY, this.mainFrame.w, this.mainFrame.w);
            }
        }
//    }
    var ratio = orgW/orgH;
    if(this.modelType==STRETCH_MODEL)
    {
    	var MainFrmLfdRatio = this.mainFrame.w/this.lfdSize.w;
		orgW *=MainFrmLfdRatio;
		orgH=orgW/ratio;
		w=Math.round(orgW);
		h =Math.round(orgH);
		
    }
    else
    {
	    if(orgW > orgH){
	        if(orgW < this.mainFrame.w/2){
	            w = orgW;
	        }else{
	            w = Math.round(this.mainFrame.w/2);
	        }
	        h = Math.round(w/ratio);
	    }else{
	        if(orgH < this.mainFrame.h/2){
	            h = orgH;
	        }else{
	            h = Math.round(this.mainFrame.h/2);
	        }
	        w = Math.round(h*ratio);
	    }
    }
    
    log.debug("RELATIVE DROP POINT x= "+ptX+" y = "+ptY,"getNewInnerFrameDim");
    var rect = this.calculateFrameRect(ptX, ptY, w, h);
    log.debug("FRAME RECT x = "+rect.x+" y = "+rect.y+" w = "+rect.w+" h = "+rect.h, "getNewInnerFrameDim");
    return rect;
};
template.prototype.createNewInnerFrame = function(rect){
    var innerframe = new frameInfo(rect.x, rect.y, rect.w, rect.h,false);
    this.addInnerFrame(innerframe);
    var id = FRAME_ID_PREFIX+(this.frameCount - 1);
    return this.getInnerFrameForId(id);
};
template.prototype.calculateFrameRect = function(cenX, cenY, w, h){
    var x = cenX - w/2;
    var y = cenY - h/2;
    x=x<=0?0:x;
    y=y<=0?0:y;
    if(x+w > this.mainFrame.w){
        x = this.mainFrame.w - w>0?this.mainFrame.w - w:0;
        w = this.mainFrame.w - w>=0?w:this.mainFrame.w;
    }
    if(y+h > this.mainFrame.h){
        y = this.mainFrame.h - h>0?this.mainFrame.h - h:0;
        h = this.mainFrame.h - h>=0?h:this.mainFrame.h;
    }
    return {x:Math.round(x),y:Math.round(y),w:Math.round(w),h:Math.round(h)};
};

template.prototype.renderBlankLayoutFrame = function(frame){
    log.debug("frame id = "+frame.id+" frame.rotation = "+frame.rotation,"renderBlankLayoutFrame");
    this.addFrameToMainDiv(frame);
     if(FREE_ROTATION_ALLOWED && !frame.bSlideshow && Utils.isHighEndModel(globlePlayerType))
     {
    	this.setAngleForFrameHtml(frame.id,frame.rotation); 	
     }
    this.reorderZIndexBlkFrames();
    log.debug("COMPLETED","renderBlankLayoutFrame");    
};

template.prototype.addElementToBlkFrm=function(frame,elm)
{
	frame.setElement(elm);
	this.renderActvElmOfFrame(frame.id);
	this.reorderZIndexBlkFrames();

    //If before dropping element other frame is active then 
    // after reordering making it active again
    var currActvFrame=this.getActiveFrame();
    if(currActvFrame.id.indexOf("Main")==-1)
    {
        this.onTapEvent(currActvFrame.id);
    }
};

template.prototype.hideBlankLayoutFrameCP=function()
{    
	log.debug("START,this.multiSelectMode = " + this.multiSelectMode,"hideBlankLayoutFrameCP");
    //Deactivating main frame elements
    $('.rotateHandlerCls').hide();
	$(".blkFrmRotCpCls,.resolDivCls").hide();
	$(".innerFrameElmCpCLs,.mnFrmElmRotCpCls,.mainFrameElmCpCLs").remove();	
	$(".mainFrameElmSelCls,.coverDivCls").css({
        'box-shadow': '0px 0px 0px 0px #3196ff'
        ,'-webkit-box-shadow':  '0px 0px 0px 0px #3196ff'
    });
	$(".mainFrameElmCoverCls").removeClass("mainFrameElmSelCls");
	$(".coverDivSelCls").removeClass("coverDivSelCls");
	this.mainFrame.activeEleIndex=DEFAULT_VALUE;	  
    this.reorderZIndexBlkFrames();
    this.bCanvasAnyElmSel = false;
};

template.prototype.hideFrameCp=function(divId)
{
	$("#frameCover-"+divId+" > .blkFrmRotCpCls").hide();
	$("#frameCover-"+divId+" > .innerFrameElmCpCLs").remove();
	$("#frameCover-"+divId+" > .coverDivSelCls").removeClass("coverDivSelCls");
	$("#frameCover-"+divId).css({
        'box-shadow': '0px 0px 0px 0px #3196ff'
        ,'-webkit-box-shadow':  '0px 0px 0px 0px #3196ff'
    });
	$("#frameCover-"+divId+" > .resolDivCls").hide();
};

template.prototype.showBlankLayoutFrameCP=function(frameId)
{	
	log.debug("START,frameId:"+frameId + " this.multiSelectMode = " + this.multiSelectMode,"showBlankLayoutFrameCP");
	if(!this.multiSelectMode)
	{
		this.hideMainFrameAllElmCp();
		this.hideBlankLayoutFrameCP();
		if(GROUPING_ALLOWED && this.getInnerFrameForId(frameId).groupId==null)
		{
			group.removeAllGroupDivs();
		}
	}
    var frame = this.getInnerFrameForId(frameId);    
    this.curSelFrameIndx=frameId.split("_")[1];	
	for(var j=0;j<this.mainCpCount;j++)
	{
		$("#frameCover-"+frameId).append('<div id="'+frameId+'-CP_'+j+'" class="innerFrameElmCpCLs '+frameId+'CtrlPtCls"></div>');
		$("#"+frameId+'-CP_'+j).css({
			'-webkit-transform':'rotate('+cpRotationAngle[j]+'deg)',
    		'transform':'rotate('+cpRotationAngle[j]+'deg)'	
    	});
	}	
    this.showFrameCover(frame.id,true);
    this.showHideFrameRotateHandler(frame);
    this.resetRotateHandler(frameId);    
    this.resetZIndexMnFrmElm();
    this.setSelFrameCoverZIndex(frameId);
    this.updateInnerFrameCPPosition(frameId);    
    this.bCanvasAnyElmSel = true;
};

template.prototype.updateInnerFrameCPPosition=function(iDivId)
{
	//var zmObj=this.getZmdHWofCpBdr();	 
    var boxBdrHlfW=this.zoomObj.border/2;           
    $(".innerFrameElmCpCLs").css({
        'height':this.zoomObj.hw+'px'
        ,'width':this.zoomObj.hw+'px'
    });	
	var rectW=$("#"+iDivId).width();
	var rectH=$("#"+iDivId).height();
	var hlfCpHW=this.zoomObj.hw/2;	
	var hlfRectH=Math.round(rectH/2);
	var hlfRectW=Math.round(rectW/2);
	
	var cpArray=[[0-hlfCpHW-boxBdrHlfW,0-hlfCpHW-boxBdrHlfW]
                 ,[hlfRectW-hlfCpHW,0-hlfCpHW-boxBdrHlfW]
                 ,[rectW-hlfCpHW+boxBdrHlfW,0-hlfCpHW-boxBdrHlfW]
                 ,[rectW-hlfCpHW+boxBdrHlfW,hlfRectH-hlfCpHW]
                 ,[rectW-hlfCpHW+boxBdrHlfW,rectH-hlfCpHW+boxBdrHlfW]
                 ,[hlfRectW-hlfCpHW,rectH-hlfCpHW+boxBdrHlfW]
                 ,[0-hlfCpHW-boxBdrHlfW,rectH-hlfCpHW+boxBdrHlfW]
                 ,[0-hlfCpHW-boxBdrHlfW,hlfRectH-hlfCpHW]
                 ];
	var i;
	for(i=0;i<this.mainCpCount;i++)
	{
		$("#"+iDivId+"-CP_"+i).css({
           'left':cpArray[i][0]+'px'
           ,'top':cpArray[i][1]+'px'
        });
	}
	var iCpHW=Math.round(ROTATE_HANDLER_HW/this.mainFrame.scale);
	if(FREE_ROTATION_ALLOWED)
	{
		this.setDimXYWH(iDivId+"-IRotHandler",Math.round((rectW-iCpHW)/2), -iCpHW, iCpHW,iCpHW);
	}
};
    
template.prototype.onBlankFrameDrag = function(e){
    //log.debug("START this.mainElmDragBtnID = "+this.mainElmDragBtnID, "onBlankFrameDrag");
    var frame = null;
    if(this.mainElmDragBtnID.indexOf("frameCover-")!=-1){
        var frameId = this.mainElmDragBtnID.split("-")[1];
        frame = this.getInnerFrameForId(frameId);    
        var touches = e.originalEvent.changedTouches;
        var deltaX = (touches[0].clientX - this.cpDragStartPt.x)/this.mainFrame.scale;
        var deltaY = (touches[0].clientY- this.cpDragStartPt.y)/this.mainFrame.scale;
        this.cpDragStartPt.x = touches[0].clientX;
        this.cpDragStartPt.y = touches[0].clientY;
        if(!this.multiSelectMode)
        {
        	var currLeft=frame.x+deltaX;
            var currTop=frame.y+deltaY;
            var currWidth=frame.w;
            var currHeight=frame.h;
    		templateObj.mainFrameSelElmObj = templateObj.getInnerFrameForId(frameId);
            var curElmObjPoints ={mainFrameSelElmObj:{x:currLeft,y:currTop,w:currWidth,h:currHeight,rotation:templateObj.mainFrameSelElmObj.rotation},
    	    						mainFrame:templateObj.mainFrame};
    		if(TemplateUtils.isElmInsideMainFrame(curElmObjPoints))
    		{
    			this.updateBlkFrameOrigin(frameId, currLeft, currTop);    
    		}
        }
        else
        {
        	var frameId = this.mainElmDragBtnID.split("-")[1];
        	this.multiSelMainFrameDragTouchMove(deltaX, deltaY, frameId);
        }
        
    }

};

template.prototype.multiSelDragBlkLayoutFrame=function(elmObj,deltaX,deltaY,elmID)
{
	var orgObj = elmObj;
	var elmObj = elmObj.ref;
	var currLeft=orgObj.leftpos+deltaX;
	orgObj.leftpos = orgObj.leftpos+deltaX;
	var currTop=orgObj.toppos+deltaY;
	orgObj.toppos = orgObj.toppos+deltaY;
	var currWidth=elmObj.w;
	var currHeight=elmObj.h;	
	var frame = this.getInnerFrameForId(elmID);
	var id = frame.id;	
	var curElmObjPoints ={mainFrameSelElmObj:{x:currLeft,y:currTop,w:currWidth,h:currHeight,rotation:elmObj.rotation},mainFrame:this.mainFrame};
	if(TemplateUtils.isElmInsideMainFrame(curElmObjPoints))
	{
	    elmObj.x = currLeft;
        elmObj.y = currTop;
	}

	this.updateBlkFrameOrigin(elmID, elmObj.x, elmObj.y);
};

template.prototype.updateBlkFrameOrigin=function(frameId, x, y){
    var frame = this.getInnerFrameForId(frameId);
    var pX = frame.x;
    var pY = frame.y;
    frame.x = x;
    frame.y = y;
    if(!this.multiSelectMode)
    {
    	var temp = TemplateUtils.createBoundingRectangle(frame);
    	this.findMagnetPointForObj(temp, MAGNET_PRIORITY_NONE, MAGNET_PRIORITY_NONE);
        this.repositionObjAccToMagnetPt(frame);
    }
//    $("#frameCover-"+frameId).css({
//        'left':frame.x+'px'
//        ,'top':frame.y+'px'
//    });
//    $("#"+frameId).css({
//        'left':frame.x+'px'
//        ,'top':frame.y+'px'
//    });

    this.resetMnFrmElementPos(frameId,frame);

    //log.debug("frame btm ="+(frame.y+frame.h)+" mn frm height = "+this.mainFrame.h,"updateBlkFrameOrigin");
    //log.debug("frame rgt ="+(frame.x+frame.w)+" mn frm width = "+this.mainFrame.w,"updateBlkFrameOrigin");
    //Reset linked text x & y
    /*if(frame.element.length > 0){
        if(frame.element[0].elementType == GROUP){
            for(var eleIndex in frame.element){
                var ele = frame.element[eleIndex];
                for(var teIndex in ele.textElms){
                    var textEle = ele.textElms[teIndex];
                    //Calculation need changes magnetic point update***AMBER***
                    textEle.x += -pX + x;
                    textEle.y += -pY + y;
                }
            }
        }
    }*/
    
};
                
template.prototype.updateBlkFrameDimention=function(frameId, x, y, w, h){
    var frame = this.getInnerFrameForId(frameId);
    //Resize blk frame linked text elements
    //this.resizeBlkFrmLinkedTxtElms(frame, {x:x,y:y,w:w,h:h});
    //END
    frame.x = x;
    frame.y = y;
    frame.w = w;
    frame.h = h;
    this.setDimXYWH(frameId,x,y,w,h);
    this.updateInnerFrameCPPosition(frameId);
    var coverID="frameCover-"+frame.id;
    this.setDimXYWH(coverID,frame.x,frame.y,frame.w,frame.h);
    this.updateCurrAreaDim(frame);
    this.resetRotateHandler(frame.id);
    this.aspectFillFrame(frame.id);
    this.showElmTypeIconOnFrame(frame.id);
};
template.prototype.isReorderingReq=function(){
    var bReq = false;
    var countObj = this.getAllTypeFrmCount(null);
    var countV_IS_Doc = countObj.videoFrmCnt + countObj.inptSrcFrmCount + countObj.docFrmCnt+countObj.pdfFrmCnt+countObj.webFrmCnt;
    if(Utils.isHighEndModel(this.modelType))
    {
    	countV_IS_Doc = countObj.inptSrcFrmCount;
    }    
    var innerFrameGrpZorderArr = this.getInnerFrameGroupZorderArray();
    var iImgCount = innerFrameGrpZorderArr.length-1-countV_IS_Doc;    
    var frameIndex,frameId,frame,type;
    for(var index=iImgCount;index>=0;index--){
        frameIndex = innerFrameGrpZorderArr[index];
        frameId = FRAME_ID_PREFIX+frameIndex;
        frame = this.getInnerFrameForId(frameId);
        type = this.getFrameType(frame.id);
      //if(this.isVideoTypeElm(type))
        if(this.checkVideoTypeAsPerModel(type))        
        {
            bReq = true;
            break;
        }
    }
    if(bReq){
        log.debug("1isReorderingReq == "+bReq,"isReorderingReq");
    }
    return bReq;
};
template.prototype.checkVideoTypeAsPerModel=function(type)
{
    var isHighEnd = Utils.isHighEndModel(this.modelType);
    	if((!isHighEnd && this.isVideoTypeElm(type)) || (isHighEnd && type == INPUT_SOURCE))
	{
		return true;
	}
	return false;
};
template.prototype.reorderZIndexBlkFrames=function(){

    if(this.frameLayout != BLANK_LAYOUT)
    {
        /*If this method is called in case when blank layout is not there nothing should happen*/
        return;
    }
    var frameId,zIndexCover;
    //REORDERING IF THERE IS ANY VIDEO OR INPUTSOURCE FRAME	
    if(this.isReorderingReq()){
        var addedAtEnd = 0;
        var frameIndex,type;
        for(var index=this.innerFrameZOrderArr.length-1;index>=0;index--){
            frameIndex = this.innerFrameZOrderArr[index];
            type=this.getInnerFrameElementTypeFromGroupIdOrIndx(frameIndex);
            if(this.checkVideoTypeAsPerModel(type))
            {
                log.debug("RESETTING THE ZORDER FOR VIDEO\INPUT_SOURCE frameIndex = "+frameIndex,"reorderZIndexBlkFrames");
                var tempValue=frameIndex;
                this.innerFrameZOrderArr.splice(index,1);
                this.innerFrameZOrderArr.splice(this.innerFrameZOrderArr.length-addedAtEnd,0,tempValue);
                addedAtEnd++;
            }
        }
    }

    var innerFrameGrpZorderArr = this.getInnerFrameGroupZorderArray();
    for(var index in innerFrameGrpZorderArr){
        frameId = FRAME_ID_PREFIX+innerFrameGrpZorderArr[index];
        zIndexCover = MIN_COVER_FRAME_ZINDEX + (5 * getParseIntInDec(index));
        $("#"+frameId).css({
            'z-index':(zIndexCover-2)
        });
        $('#frameCover-'+frameId).css('z-index',zIndexCover);
    }
    log.debug("COMPLETED ","reorderZIndexBlkFrames");
};

template.prototype.getCurrZPosOfFrm=function(frameId){
	var elmLength=this.innerFrameZOrderArr.length;
	if(!TemplateUtils.isElementTypeGroup(frameId))
	{
		frameId=TemplateUtils.getIndexOfInnerFrameFromID(frameId);
	}
	for(var i=0;i<elmLength;i++)
	{		
		if(this.innerFrameZOrderArr[i]==frameId)
		{
			return i;
		}
	}    
    return -1;
};

template.prototype.sendToBackBlkFrm=function(frameId)
{
    log.debug("frameId = "+frameId, "sendToBackBlkFrm");
	var indexVal=this.getCurrZPosOfFrm(frameId);
	if(indexVal>0)
	{
		var tempValue=	this.innerFrameZOrderArr[indexVal];
		this.innerFrameZOrderArr.splice(indexVal,1);
		this.innerFrameZOrderArr.splice(0,0,tempValue);
		this.reorderZIndexBlkFrames();
	}
    log.debug("COMPLETED", "sendToBackBlkFrm");
};
template.prototype.sendBackwardBlkFrm=function(frameId)
{
    log.debug("frameId = "+frameId, "sendBackwardBlkFrm");
	var indexVal=this.getCurrZPosOfFrm(frameId);
	//console.log("---------- layer------------- index: "+  indexVal);
	if(indexVal>0)
	{
		var tempValue=	this.innerFrameZOrderArr[indexVal];
		this.innerFrameZOrderArr[indexVal]=this.innerFrameZOrderArr[indexVal-1];
		this.innerFrameZOrderArr[indexVal-1]=tempValue;
		this.reorderZIndexBlkFrames();
	}
    log.debug("COMPLETED", "sendBackwardBlkFrm");
};
template.prototype.sendToFrontBlkFrm=function(frameId)
{
    log.debug("frameId = "+frameId, "sendToFrontBlkFrm");
	var indexVal=this.getCurrZPosOfFrm(frameId);
	if(indexVal<(this.innerFrameZOrderArr.length-1))
	{
		var tempValue=	this.innerFrameZOrderArr[indexVal];
		this.innerFrameZOrderArr.splice(indexVal,1);
		this.innerFrameZOrderArr.splice(this.innerFrameZOrderArr.length,0,tempValue);
		this.reorderZIndexBlkFrames();
	}
    log.debug("COMPLETED", "sendToFrontBlkFrm");
};
template.prototype.sendForwardBlkFrm=function(frameId)
{
    log.debug("frameId = "+frameId, "sendForwardBlkFrm");
	var indexVal=this.getCurrZPosOfFrm(frameId);
	if(indexVal<(this.innerFrameZOrderArr.length-1))
	{
		var tempValue=	this.innerFrameZOrderArr[indexVal];
		this.innerFrameZOrderArr[indexVal]=this.innerFrameZOrderArr[indexVal+1];
		this.innerFrameZOrderArr[indexVal+1]=tempValue;
		this.reorderZIndexBlkFrames();
	}
    log.debug("COMPLETED", "sendForwardBlkFrm");
};

template.prototype.deleteBlkFrame=function(frameId){
    var frameIndex = getParseIntInDec(frameId.split("_")[1]);
    log.debug("frameIndex = "+frameIndex,"deleteBlkFrame");
    
    //delete related HTML and remove event listners
    $("#"+frameId).remove();
    $("#frameCover-"+frameId).remove();
    this.curSelFrameIndx=-1;
    delete this.innerFrames[frameId];
    //remove entry from this.innerFrameZOrderArr array
    for(var index=this.innerFrameZOrderArr.length-1;index>=0;index--){
        var tempIndex = this.innerFrameZOrderArr[index];
        if(frameIndex == tempIndex){
            log.debug("REMOVED ITEM FROM innerFrameZOrderArr at index = "+index,"deleteBlkFrame");
            this.innerFrameZOrderArr.splice(index,1);
        }
    }
    if(!this.multiSelectMode)
    {
    	$("#tplMainContainer").trigger("tap");
    }

    log.debug("COMPLETED","deleteBlkFrame");
};
template.prototype.resetBlankFrameRotation=function(frame,flag)
{	        
	   frame.bSlideshow = flag;        
        frame.rotation=0;
        var elm= frame.element[0];
        elm.rotation = 0;
        elm.scale=1;
        elm.xOffset = 0;
        elm.yOffset = 0;                
        elm.margin={t:0,r:0,b:0,l:0};
        elm.initXOffset = 0;
        elm.initYOffset = 0;
};
template.prototype.updateFrameForBlankTemplate=function(frame,flag)
{
	if(!FREE_ROTATION_ALLOWED)
	{
	    return;
	}
	if(Utils.isHighEndModel(this.modelType) &&  this.frameLayout==BLANK_LAYOUT && this.isNotNullOrUndefined(frame.element[0]) && this.isImgOrGroup(frame.element[0].elementType))
	{
		if(frame.element.length==1)
		{
			this.resetBlankFrameRotation(frame,false);
			$("#"+frame.id+"-IRotHandler").show();
			$('#'+frame.id+'_rotateHandler').hide();
			this.setRotationForElm(frame.id+"-IRotHandler",0);
			this.setAngleForFrameHtml(frame.id,0);
		}
		else
		{
			$("#"+frame.id+"-IRotHandler").hide();
			if(frame.element.length==2 && flag)
			{
			    this.setRotationForElm(frame.id+"_rotateHandler",0);
			    this.resetBlankFrameRotation(frame,true);
				this.renderActvElmOfFrame(frame.id);
				this.setAngleForFrameHtml(frame.id,0);
			}
		}
	}
};
template.prototype.setAngleForFrameHtml=function(frameId,degree)
{
	 this.setRotationForElm(frameId,degree);
	  var coverID="frameCover-"+frameId;
	  this.setRotationForElm(coverID,degree);
	  $("#"+coverID).attr("angle",degree);
};
template.prototype.setBlnkTmpltFrameForCrop=function(frame,token)
{
	if(FREE_ROTATION_ALLOWED && Utils.isHighEndModel(this.modelType) &&  this.frameLayout==BLANK_LAYOUT && this.isNotNullOrUndefined(frame.element[0]) && this.isImgOrGroup(frame.element[0].elementType) && frame.element.length==1)
	{		
		if(token)
		{
			this.setAngleForFrameHtml(frame.id,0);
		}
		else
		{
			this.setAngleForFrameHtml(frame.id,frame.rotation);
		}
    }	
};
template.prototype.rotateBlkFrmFreeAngle=function(e){    
    var mouse=pointerEventToXY(e);     
    var degree=TemplateUtils.getRotationAngle(this.cpDragStartPt.y,this.cpDragStartPt.x,  mouse.y,mouse.x);
    var frameId=this.mainElmDragBtnID.split("-")[0];
    log.debug("this.dragElmFrame.rotation:"+this.dragElmFrame.rotation+",degree:"+degree + " this.multiSelectMode = " + this.multiSelectMode,"rotateBlkFrmFreeAngle");
    var diff = degree - this.dragElmFrame.rotation;
    if(this.multiSelectMode)
    {
    	this.multiSelSetRotationAngle(diff);
    }
    else
    {
    	this.setAngleForFrameHtml(frameId,degree);  
    }
};
template.prototype.resizeBlkFrmLinkedTxtElms=function(frame, newFrmRect){
    var perX = 1 + (newFrmRect.w - frame.w)/frame.w;
    var perY = 1 + (newFrmRect.h - frame.h)/frame.h;
    if(frame.element.length > 0){
        if(frame.element[0].elementType == GROUP){
            for(var eleIndex in frame.element){
                var ele = frame.element[eleIndex];
                for(var teIndex in ele.textElms){
                    var textEle = ele.textElms[teIndex];
                    var x = textEle.x - frame.x;
                    textEle.x = newFrmRect.x + x*perX;
                    var y = textEle.y - frame.y;
                    textEle.y = newFrmRect.y + y*perY;
                    textEle.w = textEle.w * perX;
                    textEle.h = textEle.h * perY;
                }
            }
            
            //Reposition active frame elemts
            var ele = frame.element[frame.activeEleIndex];
            for(var teIndex in ele.textElms){
                var txtEle = ele.textElms[teIndex];
                var divID=frame.id+"-elm_"+frame.activeEleIndex+"_"+teIndex;
                this.setDimXYWH(divID,txtEle.x-frame.x,txtEle.y-frame.y,txtEle.w,txtEle.h);
            }
        }
    }
};
template.prototype.setSelFrameCoverZIndex=function(frameId){
    $("#frameCover-"+frameId).css('z-index',MAX_COVER_DIV_Z_INDEX);
};

template.prototype.createBlkFrameForAddElm=function(dropPt, eleType, elmObj){
    var frame = null;
    log.debug("CALLED", "createBlkFrameForAddElm");
    if(this.isPointInsideMainFrame(dropPt))
    {
        log.debug("MAIN FRAME WITH BLANK LAYOUT", "createBlkFrameForAddElm");
        if(this.isWithinMaxLimit())
        {
            //if(!this.isAddElmPossible(null, eleType)){
              //  log.debug("ADD ELEMENT LIMIT EXCEED!!","createBlkFrameForAddElm");
                //this.addElmErrorPopup(eleType,"");
              //  return frame;
           // }         
            if(this.isHeavyElementLimitExceeded(null, eleType)){
                Utils.showToast(MIA_SID_ADD_UP_10_DESIGN_ELEMENTS_TEXT_BOX);
                return frame;
            }
        }
        else
        {
            this.addElmErrorPopup("","");
            return frame;
        }
        if(elmObj.orgW==0 || elmObj.orgH==0)
        {
        	var elemntDimenRatio=0.60;
        	if(this.modelType==STRETCH_MODEL)
        	{
        		if(this.orientation==PORTRAIT)
        			{elemntDimenRatio*=2;}
        		else
        			{elemntDimenRatio/=2;}
        	}
        	elmObj.orgW=Math.round(this.lfdSize.w*elemntDimenRatio);
            elmObj.orgH=Math.round(elmObj.orgW/(1.778*(this.modelType==STRETCH_MODEL?2:1)));
            
        }
        var rect =  this.getNewInnerFrameDim(dropPt.x, dropPt.y, elmObj.orgW, elmObj.orgH);
        rect.element = [];
        rect.element.push({elementType:eleType});
        if(this.modelType == RMD_MODEL){
            rect = this.getRectAtDropPtForElement(dropPt, eleType, rect);
            if(rect == null){
                Utils.showToast(MIA_SID_NOT_ENOUTH_SPACE+" "+MIA_SID_ELEMENTS_CANNOT_OVERLAPPED);
            }
            log.debug("BEST RECT = "+JSON.stringify(rect), "createBlkFrameForAddElm");
        }
        
        
        if(rect != null){
        	switch(this.modelType) {
			    case RHE_MODEL:
			    case TIZEN_MODEL:
			    case STRETCH_MODEL:
			    case TIZEN_S5:
			    case TIZEN_S6:
			        if(this.isVideoTypeElm(eleType)){
	                    if(this.isFloatingElmOverFrameExist(rect,eleType)){
	                        Utils.showToast(MIA_SID_ELEMENTS_CANNOT_OVERLAPPED);
	                        return frame;
	                    }
	                    if(this.isV_IS_DocFrameExistOverFrame(rect)){
	                        Utils.showToast(MIA_SID_ELEMENTS_CANNOT_OVERLAPPED);
	                        return frame;
	                    }
              		  }      
			        break;
			    case RMD_MODEL:
			    	 //overlapNotAllowedRMD
			        if(this.checkOverlapConditionRMD(rect, eleType)){
                   		 return frame;
               		 }
			        break;
			    default:
				     log.error("INCORRECT MODEL TYPE","createBlkFrameForAddElm");
	                 return frame;
			        break;
			    }
            frame = this.createNewInnerFrame(rect);
            
            if(frame!=null)
            {
                this.renderBlankLayoutFrame(frame);
            }
        }
    }
    else
    {
        Utils.showToast(MIA_SID_DESIGN_ELEMENTS_ADDED_INSID_CANVAS);
        return frame;
    }
    return frame;
};
template.prototype.getRectAtDropPtForElement=function(dropPt, eleType, elmRect){
    log.debug("STARTED","getRectAtDropPtForElement");
    if(elmRect.w >this.mainFrame.h){
        elmRect.w = this.mainFrame.h;
    }
    if(elmRect.h >this.mainFrame.h){
        elmRect.h = this.mainFrame.h;
    }
    var aspectRatio = elmRect.w/elmRect.h;
    var rectAR = 0.0;
    this.loadTemplateAreaObj();
    this.loadEndPointArray();
    this.loadAreaMatrix();
    
    var centX = (dropPt.x - this.mainFrame.x + (this.mainFrame.w * this.mainFrame.scale - this.mainFrame.w)/2 - this.mainFrame.xOffset)/this.mainFrame.scale;
    var centY = (dropPt.y - this.mainFrame.y + (this.mainFrame.h * this.mainFrame.scale - this.mainFrame.h)/2 - this.mainFrame.yOffset)/this.mainFrame.scale;

    log.debug("DROP POINT x= "+centX+" y = "+centY,"getRectAtDropPtForElement");
    this.templateAreaRMD.toString();
    var rectArr = this.findEmptyRects(centX, centY);
    var rect = null;
    var bestRect = null;
    var bestRectAspectR = null;
    var rectAspectR = null;
    for(var i=0;i<rectArr.length;i++){
        rect = rectArr[i];
        rectAR = (rect.w/rect.h);
        if(bestRect == null){
            bestRect = rect;
        }else{
            if(eleType == TEXT){
                if(rect.h >= elmRect.h && rect.w>=elmRect.w){
                    bestRect = rect;
                    break;
                }else if(rect.h>bestRect.h && rect.w>bestRect.w){
                    bestRect = rect;
                }else if((bestRect.w*bestRect.h)<(rect.w*rect.h)){
                    bestRect = rect;
                }
            }else{
                bestRectAspectR = bestRect.w/bestRect.h;
                rectAspectR = rect.w/rect.h;
                if(rect.h >= elmRect.h && rect.w>=elmRect.w){
                    bestRect = rect;
                    break;
                }else if(this.getPositiveDiff(1,rectAspectR)<this.getPositiveDiff(1, bestRectAspectR)){
                    bestRect = rect;
                }
            }
        }
    }
    if(bestRect != null){
        
        var lt = {x:elmRect.x,y:elmRect.y};
        var rb = {x:(elmRect.x+elmRect.w),y:(elmRect.y+elmRect.h)};
        if(bestRect.h >= elmRect.h && bestRect.w>=elmRect.w){
            if(isPointInsideRect(lt, bestRect) && isPointInsideRect(rb, bestRect))
            {
                return elmRect;
            }else{
                if(eleType == TEXT){
                    if((elmRect.x+elmRect.w)>=(bestRect.x+bestRect.w)){
                        elmRect.x = bestRect.x+bestRect.w-elmRect.w;
                    }else if(elmRect.x<bestRect.x){
                        elmRect.x=bestRect.x;
                    }
                    if((elmRect.y+elmRect.h)>=(bestRect.y+bestRect.h)){
                        elmRect.y = bestRect.y+bestRect.h-elmRect.h;
                    }else if(elmRect.y<bestRect.y){
                        elmRect.y=bestRect.y;
                    }
                }else{
                    elmRect.x = bestRect.x;
                    elmRect.y = bestRect.y;
                }
                return elmRect;
            }
        }else{
            
            var widthRatio = this.mainFrame.w/this.lfdSize.w;
            var heightRatio = this.mainFrame.h/this.lfdSize.h;
            var wMin = widthRatio*100;
            var hMin = heightRatio*100;
            log.debug("min H = "+hMin+" min W = "+wMin,"getRectAtDropPtForElement");
            if(bestRect.h<hMin || bestRect.w<wMin){
                return null;
            }
            if(eleType == TEXT || eleType == HANDWRITING){
                if(bestRect.h > elmRect.h){
                    if((elmRect.y+elmRect.h)<=(bestRect.y+bestRect.h)){
                        bestRect.y = elmRect.y;
                    }
                    bestRect.h = elmRect.h;
                }
                if(bestRect.w > elmRect.w){
                    if((elmRect.x+elmRect.w)<=(bestRect.x+bestRect.w)){
                        bestRect.x = elmRect.x;
                    }
                    bestRect.w = elmRect.w;
                }
            }
            return bestRect;
        }
    }
    return bestRect;
    
};