/**
 * @filename ConvertTextToImage.js
 * 
 * Modified by p.menaria 22-01-2015 added method createUpdatedImage.
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */
var createImgProp=function(){
 	this.text='';
 	this.mobDivH=0;
 	this.mobDivW=0; 	
 	this.mobFontSize=0;
 	this.lfdTextH=0;
 	this.lfdDivW=0; 	
 	this.lfdFontSize=0;
 	this.fontWeight='';
 	this.hAlign='left';
 	this.vAlign='top';
 	this.fontDecoration='';
 	this.fontColor='#000000';
 	this.fontStyle='';
 	this.fontFamily='Arial';
 	this.posX=0;
 	this.posY=0;
 	this.bgColor="";
 	this.bgAlpha=100;
 	this.paddingLR=0;
 	 	
 };
var canvas2;
var txtLinesArr=[];

$(document).ready(function(){
	canvas2 = document.getElementById("initCanvasId");
});

function rmvHtmlFromStr(html)
{
    var tmpDiv = document.createElement("DIV");
    html=html.replace(/<br>/ig,"#VX#VEY#VXXR#");    
    tmpDiv.innerHTML = html;
    var txtStr=tmpDiv.textContent || tmpDiv.innerText;
    //log.debug("txtStr::"+ txtStr,"createUpdatedImage");
    return txtStr.replace(/#VX#VEY#VXXR#/g,"<br>");
}
function createUpdatedImage(textElemObj)
{	 
	templateObj.isEdited = true; 
	var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
	var widthRatio = templateObj.mainFrame.w / templateObj.lfdSize.w;
	var textLines,txtArrLen,finalTextStr;	
	var createImgObj=new createImgProp();	
	var calTextSize=textElemObj.fontSize;	
	var text= $.trim(textElemObj.text.replace(/&nbsp;/ig,""));
	//log.debug("Before 1strip - text::"+ text,"createUpdatedImage");
	//text=rmvHtmlFromStr(text); commented as now we are not removing html tags written by user.
	text=Utils.convertEscapeCodeToChar(text);
	text=Utils.replaceLastBrOfText(text);
	textLines=text.split("<br>");	
	txtArrLen=textLines.length;
	finalTextStr='';
	for(var i=0;i<txtArrLen;i++)
	{
		finalTextStr+='<p align="'+textElemObj.hAlign+'">'+textLines[i];				
	}	
	
	finalTextStr = '<font face="'+textElemObj.fontFamily+'" color="'+textElemObj.fontColor+'" size="'+ calTextSize+'">'+finalTextStr+'</font>';
		
	textElemObj.textHTML=finalTextStr;
	
	createImgObj.mobFontSize=calTextSize;
	createImgObj.mobDivH=textElemObj.h;
	createImgObj.mobDivW=textElemObj.w;
	createImgObj.lfdTextH = Math.round(textElemObj.h/heightRatio);
	createImgObj.text=text;//.replace(/<div>/ig,"<br>");		
	createImgObj.lfdDivW = Math.round(textElemObj.w/widthRatio);
	createImgObj.lfdFontSize=calTextSize;//Math.round(calTextSize/heightRatio);
	createImgObj.hAlign=textElemObj.hAlign;
	createImgObj.vAlign=textElemObj.vAlign;
	createImgObj.fontColor=textElemObj.fontColor;
	createImgObj.fontFamily=textElemObj.fontFamily;
	createImgObj.bgColor=textElemObj.bgColor;
    createImgObj.bgAlpha=textElemObj.bgAlpha;	
	createImgObj.paddingLR= Math.round(createImgObj.lfdDivW*0.02);
	createImgObj.alpha=textElemObj.alpha;
	if(calTextSize<=120 && createImgObj.paddingLR<6)
	{
	    createImgObj.paddingLR=6;
	}
	else if(calTextSize>120 && createImgObj.paddingLR<12)
	{
	    createImgObj.paddingLR=12;
	}
	
	if(textElemObj.fontBold)
	{
		createImgObj.fontWeight="bold";
	}
	else
	{
		createImgObj.fontWeight="";
	}
	if(textElemObj.fontItalic)
	{
		createImgObj.fontStyle="italic";
	}
	else
	{
		createImgObj.fontStyle="";
	}	
	if(textElemObj.fontUnderLine)
	{
		createImgObj.fontDecoration="underline";
	}
	else
	{
		createImgObj.fontDecoration="";
	}	
	createImgObj.posX=textElemObj.x;
	createImgObj.posY=textElemObj.y;
	
	textElemObj.textImageSrc = createImageForText(canvas2,createImgObj); 
}
function createImageForText(iCanvas,iPropObj)
{		
	var lfdFont=Math.round(iPropObj.lfdFontSize);
	var hRect=getCalTxtHight(iPropObj.fontFamily,lfdFont,iPropObj.text);    
    var oneLineH=Math.round(hRect.height);        	
	createArrayOfLines(iCanvas,iPropObj);						
	var x,y=0;	
	switch(iPropObj.hAlign)
	{
		case "left":
			x=iPropObj.paddingLR;			
		break;
		case "right":			
			x=iPropObj.lfdDivW-iPropObj.paddingLR;
		break;
		case "center":			
			x=iPropObj.lfdDivW/2;
		break;
		default:
			x=iPropObj.paddingLR;			
		break;
	}
	var scaleFac = 1;	
	iCanvas.width  = iPropObj.lfdDivW*scaleFac;
	iCanvas.height = iPropObj.lfdTextH*scaleFac;		
	var tempCtx=iCanvas.getContext("2d");
	tempCtx.font=iPropObj.fontWeight+' '+iPropObj.fontStyle +' '+(lfdFont*scaleFac)+'px '+ iPropObj.fontFamily;	 
    tempCtx.textAlign = iPropObj.hAlign;
	tempCtx.textBaseline = 'top';
    tempCtx.fillStyle = iPropObj.fontColor;    
    //tempCtx.shadowColor = iPropObj.fontColor;  
    var posY=0;      
    var paddingTB=(oneLineH-lfdFont)/2;
    if(paddingTB<1)
    {
    	paddingTB=1;
    }          
    var txtLinesArrLen=txtLinesArr.length;
    var totalHeight=txtLinesArrLen*oneLineH;    
    if(iPropObj.vAlign=="middle")
    {       
       y=(((iCanvas.height/scaleFac)-totalHeight)/2);
    }
    else if(iPropObj.vAlign=="bottom")
    {
       y=(iCanvas.height/scaleFac)-totalHeight-paddingTB;              
    }
    else
    {
        y=paddingTB;
    }
       
    //log.debug("--x--4oneLineH:"+oneLineH+"totalHeight: "+totalHeight +",lfdFont:"+lfdFont+",iCanvas.height:"+iCanvas.height + ",y:"+y+",paddingTB:"+paddingTB);  
   
    x=x*scaleFac;
    
    for(var i=0;i<txtLinesArrLen;i++)
    {    		
    	if(i!=0)
    	{
    		posY=posY+lfdFont+ paddingTB*2;
    	}
    	else
    	{
    		posY=y;
    	}    
    	posY=posY*scaleFac;
    	//tempCtx.fillStyle = "rgba("+iPropObj.fontColor.substring(4, iPropObj.fontColor.length-1) +","+ iPropObj.alpha/100 + ")";
		tempCtx.fillText($.trim(txtLinesArr[i]),x,posY);
    	if(iPropObj.fontDecoration=="underline")
    	{    		
    		textUnderline(tempCtx,$.trim(txtLinesArr[i]),x,posY+(lfdFont*scaleFac),iPropObj.fontColor,lfdFont*scaleFac,iPropObj.hAlign);
    	}
    }
   	
   /*--Code to create image with background color: start---*/   
    //store the current globalCompositeOperation
    var compsitOper = tempCtx.globalCompositeOperation; 
    //set to draw behind current content
    tempCtx.globalCompositeOperation = "destination-over";
    tempCtx.fillStyle =getRGBColorInRGBA(iPropObj.bgColor,iPropObj.bgAlpha);
    tempCtx.fillRect(0, 0, iCanvas.width,iCanvas.height);
    var imageData = iCanvas.toDataURL("image/png");
    tempCtx.clearRect (0,0,iCanvas.width,iCanvas.height);
    //reset the globalCompositeOperation to what it was
    tempCtx.globalCompositeOperation = compsitOper;
    /*--Code to create image with background color: END---*/
	return imageData;	
}
function createArrayOfLines(iCanvas,iPropObj)
{    
	txtLinesArr=[];
	iCanvas.width  = iPropObj.lfdDivW;
	iCanvas.height = iPropObj.lfdTextH;
	var tempCtx=iCanvas.getContext("2d");
	tempCtx.font=iPropObj.fontWeight+' '+iPropObj.fontStyle +' '+iPropObj.lfdFontSize+'px '+ iPropObj.fontFamily;	
    tempCtx.textAlign = iPropObj.hAlign;
	tempCtx.textBaseline = 'top';
    tempCtx.fillStyle = iPropObj.fontColor;        
	wrapText(tempCtx,iPropObj.text,iCanvas.width-(2*iPropObj.paddingLR));	
}

function wrapText(iContext, text, iWidth) {
            
    var totalLines=text.split("<br>");      
    var words,wordsLength;    
    var line = '';       
    var ttlLineArrLen=totalLines.length;
    var testLine,metrics,testWidth;
    for(var j=0;j<ttlLineArrLen;j++)
    {           
        line = '';
        words=totalLines[j].split(' ');     
        wordsLength=words.length;
        for(var i = 0; i < wordsLength; i++) 
        {                       
            testLine = line + words[i] + ' ';
            metrics = iContext.measureText(testLine);
            testWidth = metrics.width;
                        
            if(testWidth > iWidth)
            {           
                testLine = testLine.substring(0,testLine.length-1);         
                metrics = iContext.measureText(testLine);
                testWidth = metrics.width;          
            }           
            if (testWidth > iWidth && i > 0) {
                txtLinesArr.push(line);                        
                line = words[i] + ' ';                           
            }
            else {
                line = testLine;
            }           
        }
        txtLinesArr.push(line);
    }        
}

function textUnderline(iContext,text,x,y,color,textSize,align)
{  
      var txtWidth =iContext.measureText(text).width;
      var startX = 0;
      var startY = y+(getParseIntInDec(textSize)/15);
      var endX = 0;
      var endY = startY;
      var undrlinHt = getParseIntInDec(textSize)/15;
         
      if(align == "center"){
        startX = x - (txtWidth/2);
        endX = x + (txtWidth/2);
      }else if(align == "right"){
        startX = x-txtWidth;
        endX = x;
      }else{
        startX = x;
        endX = x + txtWidth;
      }
      
      if(undrlinHt < 1){
        undrlinHt = 1;
      }
      
      iContext.beginPath();
      iContext.strokeStyle = color;
      iContext.lineWidth = undrlinHt;
      iContext.moveTo(startX,startY);
      iContext.lineTo(endX,endY);  
      iContext.stroke();
}
function getCalTxtHight(font,fontSize,iText) {

  iText=iText.replace(/<br>/ig,"").replace(" ","");    
  var text = $('<span>'+iText+'</span>').css({ 'font-family': font,'font-size':fontSize,'width':'10000000px'});
  var block = $('<div style="display: inline-block; width: 1px; height: 0px;"></div>');
  var rndrDiv = $('<div style="width:10000000px"></div>');
  rndrDiv.append(text, block);
  
  $('body').append(rndrDiv);
  var resultRect = {height:0,ascent:0,descent:0};
  try {
    block.css({ verticalAlign: 'baseline' });
    resultRect.ascent = block.offset().top - text.offset().top;

    block.css({ verticalAlign: 'bottom' });
    resultRect.height = block.offset().top - text.offset().top;

    resultRect.descent = resultRect.height - resultRect.ascent;
  } 
  catch(ex) {
    rndrDiv.remove();
  }
  rndrDiv.remove();
  return resultRect;
};
function getTextWidth(iTxt,iFontSize,iFontFamily)
{       
    var ctx = canvas2.getContext("2d");
    ctx.font = "normal normal "+iFontSize+"px "+iFontFamily;       
    var textWidth=Math.round(ctx.measureText("X"+iTxt+"X").width);
    textWidth=Math.round(textWidth*1.08);
    ctx.clearRect(0,0,canvas2.width,canvas2.height);          
    return textWidth;    
};
function getEditableStickerImageWithText(imageSrc, TextObjArr)
{
	var context = canvas2.getContext('2d');
    var imageObj = new Image();	
    imageObj.src = imageSrc;
    
	canvas2.width = imageObj.width;
	canvas2.height = imageObj.height;
	context.drawImage(imageObj, 0, 0,imageObj.width,imageObj.height);
	var totalText = TextObjArr.length;
	var i=0;
	
	for(;i<totalText;i++)
	{
		 var stickerTextObj = TextObjArr[i];
		 var limitedText = getAcceptableTextForEditableSticker(stickerTextObj.text,i,stickerTextObj.fontFamily,stickerTextObj.fontSize,stickerTextObj.w);
		 var xoffset = stickerTextObj.x +(stickerTextObj.w/2);
		 var yoffset = stickerTextObj.y +(stickerTextObj.h/2);
		 context.font =(stickerTextObj.fontItalic?"italic ":"")+(stickerTextObj.fontBold?"bold ":"")+stickerTextObj.fontSize + "px " + stickerTextObj.fontFamily;
		 context.textAlign = "center";
		 context.textBaseline = 'middle';
		 if(stickerTextObj.shdwOpc!=0 && stickerTextObj.shdwOpc!=undefined)
		 {
		 	context.fillStyle = "rgba("+stickerTextObj.shdwClr.substring(4, stickerTextObj.fontColor.length-1) +","+ stickerTextObj.shdwOpc/100 + ")";	
		 	context.fillText(limitedText,xoffset + stickerTextObj.shdwDpt,yoffset +stickerTextObj.shdwDpt,stickerTextObj.w);
		 }
		 if(stickerTextObj.strkOpc!=0 && stickerTextObj.strkOpc!=undefined)
		 {
		 	context.strokeStyle = stickerTextObj.strkClr;
		    context.lineWidth = stickerTextObj.strkDpt;
		    context.strokeText(limitedText,xoffset,yoffset ,stickerTextObj.w);
		 }
		
	     context.fillStyle = "rgba("+stickerTextObj.fontColor.substring(4, stickerTextObj.fontColor.length-1) +","+ stickerTextObj.alpha/100 + ")";	
		 context.fillText(limitedText,xoffset,yoffset ,stickerTextObj.w);
	 }
	 
	  return canvas2.toDataURL("image/png"); 
	 
};