/* 
 * Created by amber.m 08-11-2016 for element group object creation and its function
 *
 * Dependant Files Template.js
 */

'use strict';
var Group = function(){
	this.id = "";
	this.parentId = "";
	this.elements = [];//array containing element, frame or group ids in increasing order of z index
	this.x = 0;
	this.y = 0;
	this.w = 0;
	this.h = 0;
	this.rotation = 0;
	this.elementType = DEFAULT_VALUE;
	this.childElementType=DEFAULT_VALUE;
	this.isRotationSupported=true;
};

var group = new Group();

/* event handling for group. The following events are handled
 1. Group rotation(groupRotCpCls) 2. Group control points(groupCpCLs) 3. Group drag(groupDivCls) 4. MultiselectMode(taphold-groupDivCls) */
Group.prototype.addEventForGroupDivAndCtrlPoints=function()
{
	var currObj=templateObj;
	var groupObj=this;
	currObj.unbindEvent('.groupDivCls',"tap touchstart touchcancel touchend taphold");
	$(document).on("touchstart",".groupDivCls",function(e){
		e.preventDefault();
//		e.stopPropagation();
		var grpId=$(this).attr("id");
        groupObj.resetGroupUiAndAuthorMenu(grpId);
        var chngdTouches = e.originalEvent.changedTouches[0];
		currObj.cpDragStartPt = {x:chngdTouches.clientX,y:chngdTouches.clientY};
		log.debug("abhinavMishra START touchstart-groupDivCls x = " + currObj.cpDragStartPt.x + " y = " + currObj.cpDragStartPt.y + " currObj.multiSelectMode = " + currObj.multiSelectMode,"groupDivCls");
		var divID = currObj.getMainElmOrFrameElmExistOnPoint(currObj.cpDragStartPt);
		if(divID == grpId)
		{
			currObj.dragLocation=GROUP_DIV_DRAG;
			currObj.mainElmDragBtnID=grpId;
			currObj.setDragElmFrame(grpId);
			if(!currObj.multiSelectMode)
			{
				groupHandler.selGrpElmList = [];
				log.debug("abhinavMishra populate group elements list","groupDivCls");
				groupHandler.getGroupElements(grpId, groupHandler.selGrpElmList);
			}
			var group = groupHandler.groupMap[grpId];
			currObj.initMagneticPointsForGroup(group, MAGNET_RANGE_FOR_RESIZE);
		}
		else
		{
			log.debug("abhinavMishra UNEXPECTED Case","groupDivCls");
		}
	})
	.on("touchend touchcancel",".groupDivCls",function(e){
		e.preventDefault();
		log.debug("abhinavMishra START touchend-groupDivCls","groupDivCls");
		if(currObj.dragLocation == GROUP_DIV_DRAG)
		{
			currObj.dragLocation=DEFAULT_VALUE;
			if(!currObj.multiSelectMode)
			{
				var elmID=currObj.mainElmDragBtnID;	           
				if(groupHandler.isGroupElementMovementValid(0,0,true,false))
				{
					groupHandler.updateGrpElmObj(0, true);
				}
				else
				{
					groupHandler.updateGrpElmObj(0, false);
					var group = groupHandler.groupMap[elmID];
					currObj.updateObjXYHWFromObj(group, currObj.currMnFrmObjProp);
					currObj.setDimXYWH(elmID,group.x-GROUP_OFFSET,group.y-GROUP_OFFSET,group.w+2*GROUP_OFFSET,group.h+2*GROUP_OFFSET);		        	
				}
				currObj.mainElmDragBtnID="";
				// remove magnetic point if any
				currObj.hideMagnetLines();
				groupHandler.selGrpElmList=[];
			}
			else
			{
				//currObj.multiSelMainFrameDragTouchEnd();
				currObj.multiSelectElementsTouchendEvent(false);
			}
		}

	});
	/*$(document).on("taphold",".groupDivCls",function(e){
		e.preventDefault();
		  e.stopPropagation();
		  log.debug("abhinavMishra START taphold-groupDivCls","groupDivCls");
		  var elmSel=currObj.getMainElmOrFrameElmExistOnPoint(currObj.cpDragStartPt);
		  log.debug("abhinavMishra START taphold-groupDivCls elmSel = " + elmSel,"groupDivCls");
	        if(elmSel!=null)
	        {        	
	        	currObj.enableMultiSelect(true);        	
	        	currObj.pushAndSelGroupOrElmOnMultiSelect(elmSel);
	        	Utils.showToast(MIA_SID_20_MULTIPLE_SELECTION_MODE);
	        	showAuthorMenu(elmSel);
	        }		  
		  return false;		
	});*/
	$(document).on("tap",".groupDivCls",function(e){
		e.preventDefault();
		e.stopPropagation();
		log.debug("abhinavMishra START tap-groupDivCls multiSelectMode = " + currObj.multiSelectMode,"groupDivCls");
		if(currObj.multiSelectMode)
		{
			currObj.multiSelMainFrameCoverTapEvent();
		}
		else
		{
			currObj.onMainFrameTap();
		}
		return false;
	});
	currObj.unbindEvent('.groupRotCpCls',"touchstart touchcancel touchend");
	$(document).on("touchstart",".groupRotCpCls",function(e){
		e.preventDefault();
		e.stopPropagation();
		currObj.mainElmDragBtnID=$(this).attr("id");
		var tapDivID=currObj.mainElmDragBtnID.split("-CP_")[0];
		groupObj.resetGroupUiAndAuthorMenu(tapDivID);
		currObj.dragLocation=GROUP_DIV_ROT_DRAG;
		$(this).addClass("groupRotCpCls-active");
		var group = groupHandler.groupMap[tapDivID];
		var scale = currObj.mainFrame.scale;
		var mainFrmOffset=$("#"+FRAME_ID_PREFIX+"Main").offset();
		var x = mainFrmOffset.left + group.x;
		var y = mainFrmOffset.top + group.y;
		var groupCenter = {
				x: x + group.w/2,
				y: y + group.h/2
		};
		currObj.cpDragStartPt.x=groupCenter.x;
		currObj.cpDragStartPt.y=groupCenter.y;
		currObj.setDragElmFrame(tapDivID);
		if(!currObj.multiSelectMode)
		{
			groupHandler.selGrpElmList = [];
			log.debug("abhinavMishra Populate group elements","groupRotCpCls");
			groupHandler.getGroupElements(tapDivID, groupHandler.selGrpElmList);
		}

	})
	.on("touchend touchcancel",".groupRotCpCls",function(e){
		e.preventDefault();
		e.stopPropagation();
		log.debug("abhinavMishra START touchend-groupRotCpCls","groupRotCpCls");
		currObj.dragLocation=DEFAULT_VALUE;
		$(this).removeClass("groupRotCpCls-active");
		var elmID=currObj.mainElmDragBtnID.split("-CP_")[0];	           
		var rotation=getParseIntInDec($("#"+elmID).attr("angle"));	
		var preRotation = currObj.mainFrameSelElmObj.rotation;
		log.debug("touchend-groupRotCpCls rotation = " + rotation + " preRotation = " + preRotation,"groupRotCpCls");
		var angleDiff = rotation - preRotation;
		if(currObj.multiSelectMode)
		{
			currObj.multiSelRotationTchEnd();
		}
		else
		{
			group.updateGroupAfterRotation(elmID, rotation, preRotation, angleDiff);
		}

	});
	currObj.unbindEvent('.groupCpCLs',"touchstart touchcancel touchend");
	$(document).on("touchstart",".groupCpCLs",function(e){
		e.preventDefault();
		e.stopPropagation();
		currObj.mainElmDragBtnID=$(this).attr("id");
		var tapDivID=currObj.mainElmDragBtnID.split("-CP_")[0];
		groupObj.resetGroupUiAndAuthorMenu(tapDivID);
		currObj.dragLocation=GROUP_DIV_CP_DRAG;
		$(this).addClass("groupCpSelCLs");
		currObj.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX,y:e.originalEvent.changedTouches[0].clientY};
		calculateTranformedPoint = true;
		currObj.setDragElmFrame(tapDivID);
		if(!currObj.multiSelectMode)
		{
			groupHandler.selGrpElmList = [];
			log.debug("abhinavMishra Populate group elements","groupCpCLs");
			groupHandler.getGroupElements(tapDivID, groupHandler.selGrpElmList);
		}
		var group = groupHandler.groupMap[tapDivID];
		currObj.initMagneticPointsForGroup(group, MAGNET_RANGE_FOR_RESIZE);
	})
	.on("touchend touchcancel",".groupCpCLs",function(e){
		e.preventDefault();
		e.stopPropagation();
		log.debug("abhinavMishra ON touchend EVENT  GROUP_DIV_CP_DRAG",".groupCpCLs");
		currObj.dragLocation=DEFAULT_VALUE;
		$(this).removeClass("groupCpSelCLs"); 
		calculateTranformedPoint = false;
		if(!currObj.multiSelectMode)
		{   
			if(groupHandler.isGroupElementMovementValid(0,0,true,true))
			{
				groupHandler.updateGrpElmObj(0, true);
			}
			else
			{
				var elmID=currObj.mainElmDragBtnID.split("-CP_")[0];
				groupHandler.updateGrpElmObj(0, false);
				var group = groupHandler.groupMap[elmID];
				currObj.updateObjXYHWFromObj(group, currObj.currMnFrmObjProp);
				group.setAndUpdateGroupPosition(elmID, group);
			}
		}
		else
		{        	
			currObj.multiSelectElementsTouchendEvent(true);
		}        
		// remove magnetic point if any
		currObj.hideMagnetLines();        
		currObj.mainElmDragBtnID="";
		groupHandler.selGrpElmList=[];
	});
};

/*update group elements after multiselect touch end event*/
Group.prototype.multiSelUpdateGroupElms=function(elmID, shapeObjArr)
{
	log.debug("elmID = " + elmID,"multiSelUpdateGroupElms");
	groupHandler.multiSelectUpdateGrpElmObj(elmID, 0, true, shapeObjArr);
	groupHandler.drag=[];
};
/* Function will reset UI (remove cropmode or selection of group element) and close authormenu related to selected element.
Show author menu of group and reset group UI*/
Group.prototype.resetGroupUiAndAuthorMenu=function(groupId)
{
    if(!templateObj.multiSelectMode)
    {
        if(curAuthorMenuId!=groupId)
        {
            TemplateUtils.hideCntrPointOfActiveFrameForCropping();
            templateObj.hideMainFrameAllElmCp();
            templateObj.hideBlankLayoutFrameCP();
            templateObj.hideItemList(true);
            showAuthorMenu(groupId);
            this.setColorToGroupDiv(true,groupId);
        }
    }
};
/*update group and its elements after groupRotCpCls rotation touch end event. If the group elements are going out of main frame boundary then the group and its elements are reverted back to previous position*/
Group.prototype.updateGroupAfterRotation=function(elmID, rotation, preRotation, angleDiff)
{
	var result = groupHandler.chkGrpElmRotForMnFrmBoundary(elmID, angleDiff);
	log.debug("ROTATION elmID = " + elmID + " rotation = " + rotation + " preRotation = " + preRotation + " angleDiff = " + angleDiff + " result = " + result,"updateGroupAfterRotation");
	if(result)
	{
		groupHandler.updateGrpElmObj(angleDiff, true);
		groupHandler.groupMap[elmID].rotation = rotation;
		this.updateChildGroupsAfterRotation(groupHandler.groupMap[elmID], angleDiff);
	}
	else
	{
		log.debug("Reset position for group and its elements" + angleDiff,"updateGroupAfterRotation");
		groupHandler.groupMap[elmID].rotation = preRotation;
		templateObj.setRotationForElm(elmID,preRotation);
		groupHandler.updateGrpElmObj(angleDiff, false);
	}
	groupHandler.selGrpElmList=[];
};

/*update group and its elements after multiselect touch end event. If the group elements are going out of main frame boundary then the group and its elements are reverted back to previous position
 This function is called from multiSelRotationTchEnd*/
Group.prototype.multiSelectUpdateGroupAfterRotation=function(elmID, rotation, preRotation, angleDiff)
{
	var result = groupHandler.multiSelectChkGrpElmRotForMnFrmBoundary(elmID, elmID, angleDiff);
	log.debug("ROTATION elmID = " + elmID + " rotation = " + rotation + " preRotation = " + preRotation + " angleDiff = " + angleDiff + " result = " + result,"multiSelectUpdateGroupAfterRotation");
	if(result)
	{
		groupHandler.multiSelectUpdateGrpElmObj(elmID, angleDiff, true);
		groupHandler.groupMap[elmID].rotation = rotation;
		this.updateChildGroupsAfterRotation(groupHandler.groupMap[elmID], angleDiff);
	}
	else
	{
		log.debug("Reset position for group and its elements" + angleDiff,"multiSelectUpdateGroupAfterRotation");
		groupHandler.groupMap[elmID].rotation = preRotation;
		templateObj.setRotationForElm(elmID,preRotation);
		groupHandler.multiSelectUpdateGrpElmObj(elmID, angleDiff, false);
	}
	groupHandler.selGrpElmList=[];
};

/*create a div for the group*/
Group.prototype.createGroupDiv=function(grpId)
{	
	grpId=groupHandler.findRoot(grpId);
	if(!templateObj.multiSelectMode)
	{
		this.removeAllGroupDivs();
		templateObj.hideMainFrameAllElmCp();
		templateObj.hideBlankLayoutFrameCP();
		templateObj.bCanvasAnyElmSel = true;
	}
	var groupRef=groupHandler.groupMap[grpId];
	log.debug("createGroupDiv grpId:"+grpId,"createGroupDiv");
	$("#"+templateObj.mainFrame.id).append('<div id="'+grpId+'" class="groupDivCls" type="'+GROUP_ELEMENTS+'" childElementType="'+groupRef.childElementType+'"></div>');
	templateObj.setDimXYWH(grpId,groupRef.x -GROUP_OFFSET,groupRef.y - GROUP_OFFSET ,groupRef.w + 2*GROUP_OFFSET,groupRef.h + 2*GROUP_OFFSET);
	this.addCptoGroupDiv(grpId);
	templateObj.hideMainFrame();
	if(!templateObj.multiSelectMode)
    {
        showAuthorMenu(grpId);
    }
};

/*remove all group divs*/
Group.prototype.removeAllGroupDivs=function()
{
	$(".groupDivCls").remove();
};
/*hide group div*/
Group.prototype.hideGroupDiv=function(groupId)
{
	if(groupId!=null && groupId!="")
	{
        var id = groupHandler.findRoot(groupId);
        log.debug("groupId = " + groupId + ",parentID:" + id,"hideGroupDiv");
        $("#"+id).hide();
	}
};

/*show group div*/
Group.prototype.showGroupDiv=function(divID)
{
	var id = groupHandler.findRoot(divID);
	log.debug("divID = " + divID + " id = " + id,"showGroupDiv");
	$("#"+id).show();
};

/*remove group div*/
Group.prototype.removeGroupDiv=function(divID)
{
	log.debug("divID = " + divID,"removeGroupDiv");
	$("#"+divID).remove();
};
/*Show/Hide group rotation handler, considered only single level grouping*/
Group.prototype.updateRotationHandlerForGroupById=function(groupId)
{
    if(groupId!=null)
    {
        var group = groupHandler.groupMap[groupId];
        var grpElmLen = group.elements.length;
        var elmId,elmObj,elmType,rotationFlag=true,isMainFrame;
        for (var i = 0; i < grpElmLen; i++) {
            elmObj=group.elements[i];
            elmId = elmObj.id;
            elmType=templateObj.getElementTypeFromId(elmId);
            isMainFrame=TemplateUtils.isElementTypeMainFrame(elmId);
            rotationFlag=templateObj.isRotationSupportedForElement(elmType,elmObj.ref,isMainFrame);
            if(!rotationFlag)
            {
                break;
            }
        }
        group.isRotationSupported=rotationFlag;
        var groupRotationHandler=$("#"+groupId+'-CP_'+templateObj.mainCpCount);
        if(group.isRotationSupported)
        {
            groupRotationHandler.show();
        }
        else
        {
            groupRotationHandler.hide();
        }
    }
};
/*Adding control points to the group div*/
Group.prototype.addCptoGroupDiv=function(divID)
{
	log.debug("START logs divID:"+divID,"addCptoGroupDiv");	
	var grpDivObj=$("#"+divID);
	grpDivObj.addClass("groupDivSelCls");
    var groupRef=groupHandler.groupMap[divID];
    grpDivObj.append('<div id="'+divID+'-CP_'+templateObj.mainCpCount+'" class="groupRotCpCls"></div>');
	if(!groupRef.isRotationSupported)
	{
		$("#"+divID+'-CP_'+templateObj.mainCpCount).hide();
	}	
	for(var j=0;j<templateObj.mainCpCount;j++)
	{
		grpDivObj.append('<div id="'+divID+'-CP_'+j+'" class="groupCpCLs"></div>');
		$("#"+divID+'-CP_'+j).css({
			'-webkit-transform':'rotate('+cpRotationAngle[j]+'deg)',
			'transform':'rotate('+cpRotationAngle[j]+'deg)'	
		});
	}
	grpDivObj.css({
		'z-index':MAX_COVER_DIV_Z_INDEX
	});
	templateObj.setRotationForElm(divID,groupRef.rotation);
	this.setColorToGroupDiv(true,divID);
	templateObj.updateMainFrameCpPosition(divID);
	templateObj.hidMnFrmCpByElmType(groupRef.childElementType,divID);
	log.debug("COMPLETED logs divID:"+divID,"addCptoGroupDiv");	
};

/*set color to group div, if group is selected it will be blue color, if the group element is selected it will be yellow color*/
Group.prototype.setColorToGroupDiv=function(isActive,grpId)
{
	var color="#3196ff";
	var zIndx=MAX_COVER_DIV_Z_INDEX;
	if(!isActive)
	{
		color="#ffc000";
		zIndx=INITZINDEX;

	}
	$("#"+grpId).css({
		'box-shadow': '0px 0px 0px '+templateObj.zoomObj.border+'px '+color,
		'-webkit-box-shadow':  '0px 0px 0px '+templateObj.zoomObj.border+'px '+color,
		'z-index':zIndx
	});
};

/*iterate over all the groups and sub groups and calculate an outer rect for the group. This function returns the rect having minX, MaxX, minY and MaxY for a given group*/
Group.prototype.calculateOuterRectForAllGroupElements=function(group, rect)
{
	var elmLen=group.elements.length;
	for (var i = 0; i < elmLen; i++) {
		var id =  group.elements[i].id;
		if(TemplateUtils.isElementTypeGroup(id))
		{
			this.calculateOuterRectForAllGroupElements(groupHandler.groupMap[id], rect);
		}
		else
		{
			var groupElementRef = group.elements[i].ref;
			if(rect.minX > groupElementRef.x)
			{
				rect.minX = groupElementRef.x;
			}

			if(rect.minY > groupElementRef.y)
			{
				rect.minY = groupElementRef.y;
			}

			if(rect.maxX < (groupElementRef.x + groupElementRef.w))
			{
				rect.maxX = groupElementRef.x + groupElementRef.w;
			}

			if(rect.maxY < (groupElementRef.y + groupElementRef.h))
			{
				rect.maxY = groupElementRef.y + groupElementRef.h;
			}
		}
	}
};

/*iterate over all the groups and sub groups and calculate an outer rect for the group for magnetic line calculation. It handles the rotation case too. This function returns the rect having minX, MaxX, minY and MaxY for a given group*/
Group.prototype.calculateOuterRectForMagneticPointForAllGroupElements=function(group, rect)
{
	var elmLen=group.elements.length;
	for (var i = 0; i < elmLen; i++) {
		var id =  group.elements[i].id;
		if(TemplateUtils.isElementTypeGroup(id))
		{
			this.calculateOuterRectForAllGroupElements(groupHandler.groupMap[id], rect);
		}
		else
		{
			var groupElementRef = group.elements[i].ref;
			// adding rotation criteria
			if(groupElementRef.rotation != 0){
				groupElementRef = TemplateUtils.createBoundingRectangle(groupElementRef);
			}
			if(rect.minX > groupElementRef.x)
			{
				rect.minX = groupElementRef.x;
			}

			if(rect.minY > groupElementRef.y)
			{
				rect.minY = groupElementRef.y;
			}

			if(rect.maxX < (groupElementRef.x + groupElementRef.w))
			{
				rect.maxX = groupElementRef.x + groupElementRef.w;
			}

			if(rect.maxY < (groupElementRef.y + groupElementRef.h))
			{
				rect.maxY = groupElementRef.y + groupElementRef.h;
			}
		}
	}
};


/*This function calculates the outer rect for the group and update the group position properties that is x, y, w, h.*/
Group.prototype.calOuterRect=function(group){
	var rect ={minX:Number.MAX_VALUE, 
			minY:Number.MAX_VALUE, 
			maxX:Number.MIN_VALUE, 
			maxY:Number.MIN_VALUE};
	this.calculateOuterRectForAllGroupElements(group, rect);
	log.debug("calOuterRect rect :: " +JSON.stringify(rect));
	group.x=rect.minX;
	group.y=rect.minY;
	group.w=rect.maxX - rect.minX;
	group.h=rect.maxY - rect.minY;		
};

/*This function creates the group using the elements in the multiSelElmArr. Iterate through the multiSelElmArr which holds all the selected elements. 
Sorts the elements based on their index in mainFrameLayer.Then removes all the sorted elements from the mainFramelayer except the last sorted element
having the highest z index. Replace the element having highest z index with the groupId in mainFrameLayer. 
The mainFrameLayer hold the index of elements in z order.*/
Group.prototype.createGroup=function(isCallForLFDRendering,groupLfdObj){
	log.debug("createGroup mainFrmElmLayer :: BEFORE Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer));
	log.debug("createGroup innerFrameZOrderArr :: BEFORE Group Modifications:" +JSON.stringify(templateObj.innerFrameZOrderArr));
	var isMultiLevelRestricted = true;
	var group = new Group();
	group.id = "grp_" + groupHandler.groupIdCounter;

	var groupTobeCombined = [];
	var length = templateObj.multiSelElmArr.length;
	var storeElementAndZIndex = [];
	var zIndex,elmIndx,elmID;
	var isInnerFrameElmGroup = false;
	var elmobj, childGroup;
	for(var i=0; i<length; i++)
	{
		elmobj = templateObj.multiSelElmArr[i];
		elmID = elmobj.id;
		log.debug("createGroup elmID = " + elmID + " group.id = " + group.id, " createGroup");
		if(TemplateUtils.isElementTypeGroup(elmID))
		{
			childGroup = groupHandler.groupMap[elmID];
			childGroup.parentId = group.id;
			elmIndx=elmID;
			if(childGroup.elementType == MAIN_FRAME_ELM)
			{
				zIndex = templateObj.getMnFrmLayerArrIndex(elmIndx);
			}
			else
			{
				zIndex = templateObj.getInnerFrmLayerArrIndex(elmIndx);
			}
			if(group.elementType==DEFAULT_VALUE)
			{
			    group.elementType=childGroup.elementType;
			    group.childElementType=childGroup.childElementType;
			}
			if(group.isRotationSupported)
			{
			    group.isRotationSupported=childGroup.isRotationSupported;
			}
		}
		else if(TemplateUtils.isElementTypeMainFrame(elmID))
		{
			elmobj.ref.groupId = group.id;
			elmIndx = TemplateUtils.getIndexOfMainFrameElementFromID(elmID);
			zIndex = templateObj.getMnFrmLayerArrIndex(elmIndx);
			if(group.elementType==DEFAULT_VALUE)
            {
			    group.elementType=MAIN_FRAME_ELM;
			    group.childElementType=getParseIntInDec($("#"+elmID).attr("type"));
			}
			if(group.isRotationSupported)
            {
                group.isRotationSupported=templateObj.isRotationSupportedForElement(group.childElementType,elmobj.ref,true);
            }
		}
		else 
		{
			elmobj.ref.groupId = group.id;
			elmIndx = TemplateUtils.getIndexOfInnerFrameFromID(elmID);
			zIndex = templateObj.getInnerFrmLayerArrIndex(elmIndx);
			if(group.elementType==DEFAULT_VALUE)
            {
			    group.elementType=BLANK_INNER_FRAME;
			    group.childElementType=templateObj.getFrameType(elmID);
			}
			if(group.isRotationSupported)
            {
                group.isRotationSupported=templateObj.isRotationSupportedForElement(group.childElementType,elmobj.ref,false);
            }
		}

		log.debug("createGroup elmID = " + elmID + " group.id = " + group.id + " zIndex:" + zIndex + " elmIndx = " + elmIndx, "createGroup");

		storeElementAndZIndex.push({
			element: elmobj,
			elementIndex: zIndex
		});
	}
	log.debug("createGroup BEFORE storeElementAndZIndex :: " +JSON.stringify(storeElementAndZIndex));

	//sort elements based on z index in increasing order
	storeElementAndZIndex.sort(function(a, b) {
		return a.elementIndex - b.elementIndex;
	});

	log.debug("createGroup AFTER storeElementAndZIndex :: " +JSON.stringify(storeElementAndZIndex));


	var elementObj;
	//push elements to group based on increasing z index
	for (var i = 0; i < storeElementAndZIndex.length; i++) 
	{
		elementObj = storeElementAndZIndex[i].element;
		if(isMultiLevelRestricted && TemplateUtils.isElementTypeGroup(elementObj.id))
		{
			var childElement;
			groupTobeCombined.push(elementObj.id);
			for (var j = 0; j < elementObj.ref.elements.length; j++) 
			{
				childElement = elementObj.ref.elements[j];
				childElement.ref.groupId = group.id;
				group.elements.push(childElement);
			}
		}
		else
		{
			group.elements.push(elementObj);
		}
	}

	//replace the max z order element with new group id
	var maxZindex = storeElementAndZIndex[storeElementAndZIndex.length-1].elementIndex;
	if(group.elementType == BLANK_INNER_FRAME)
	{
		templateObj.innerFrameZOrderArr[maxZindex] = group.id;
		//remove lesser z order elements from main frame layer which are part of this new group
		for (var i = 0; i < storeElementAndZIndex.length-1; i++) 
		{
			templateObj.innerFrameZOrderArr.splice(storeElementAndZIndex[i].elementIndex-i,1);
		}
	}
	else
	{
		templateObj.mainFrmElmLayer[maxZindex] = group.id;
		//remove lesser z order elements from main frame layer which are part of this new group
		for (var i = 0; i < storeElementAndZIndex.length-1; i++) 
		{
			templateObj.mainFrmElmLayer.splice(storeElementAndZIndex[i].elementIndex-i,1);
		}
	}


	if(isCallForLFDRendering)
	{
		group.x = groupLfdObj.x;
		group.y = groupLfdObj.y;
		group.w = groupLfdObj.w;
		group.h = groupLfdObj.h;
		group.rotation = groupLfdObj.rotation;
	}
	else
	{
		this.calOuterRect(group);
	}

	/*delete previous groups which are combined*/
	var elmLen=groupTobeCombined.length;
	for (var i = 0; i < elmLen; i++)
	{
		delete groupHandler.groupMap[groupTobeCombined[i]];
	}
	group.parentId = "";
	groupHandler.groupMap[group.id] = group;
	groupHandler.groupIdCounter++;
	templateObj.multiSelectMode=false;	
	if(!isCallForLFDRendering) //in case of lfd Rendering we first build elements and then render them all at once 
	{
		this.createGroupDiv(group.id);
	}
};

/*This function rotates the group and all its elements. The element list for this group is populated in touch start event of groupRotCpCls if multi select mode is disabled.
If multiselect mode is enabled then it passes the angle difference to multiSelSetRotationAngle() which internally calls multiSelectRotateGroup() function if any of the other group is part of multiSelElmArr*/
Group.prototype.rotateGroup=function(e)
{
	var mouse=pointerEventToXY(e);
	var degree=TemplateUtils.getRotationAngle(templateObj.cpDragStartPt.y,templateObj.cpDragStartPt.x,  mouse.y,mouse.x);
	var angleDiff = degree-templateObj.mainFrameSelElmObj.rotation;
	var divID=templateObj.mainElmDragBtnID.split("-CP_")[0];
	log.debug("divID = " + divID + " angleDiff = " + angleDiff + " degree = " + degree + " multiSelectMode = " + templateObj.multiSelectMode,"rotateGroup");
	if (!templateObj.multiSelectMode) 
	{
		degree = groupHandler.groupMap[divID].rotation + angleDiff;
		if (TemplateUtils.isElementTypeMainFrame(groupHandler.groupMap[divID].elements[0].id)) 
		{
			templateObj.setMainFrmElmAngle(divID, degree);
			groupHandler.rotateGroupElm(divID, angleDiff);
			templateObj.hideMainFrameAllElmCp();
		}
		else
		{
			templateObj.setAngleForFrameHtml(divID, degree);
			// this is required as "angle" attr is checked at the later stage to verify the rotation is ok.
			$("#" + divID).attr("angle", degree);
			groupHandler.rotateGroupElm(divID, angleDiff);
			templateObj.hideBlankLayoutFrameCP();
		}
		this.setColorToGroupDiv(true, divID);
		this.setAndUpdateGroupPosition(divID, groupHandler.groupMap[divID]);
	}
	else
	{
		templateObj.multiSelSetRotationAngle(angleDiff);
	}
};

/*This function rotates the group and all its elements. It iterates recursively over sub groups and its elements and update the position and rotation angle for all the elements.
This function is invoked when multiselect mode is enabled*/
Group.prototype.multiSelectRotateGroup=function(divID,angleDiff)
{
	var group = groupHandler.groupMap[divID];
	var degree = group.rotation + angleDiff;
	if(degree < 0)
	{
		degree = degree + 360;
	}
	else if(degree > 0)
	{
		degree = degree % 360;
	}
	log.debug("divID = " + divID + " angleDiff = " + angleDiff + " group rotation = " + group.rotation + " totalAngle = " + degree,"multiSelectRotateGroup");
	templateObj.setMainFrmElmAngle(divID,degree);
	groupHandler.multiSelectRotateGrpElm(divID,divID,angleDiff);
};

/*This function iterates recursively and updates the rotation angle for all the sub groups with in a given group (parentGroup). So that the correct angle is reflected when the group is unGrouped.*/
Group.prototype.updateChildGroupsAfterRotation=function(parentGroup, angleDiff)
{
	var elmLen=parentGroup.elements.length;
	var elmId,elementGroup,tempRotation;
	for (var i = 0; i < elmLen; i++)
	{
		elmId = parentGroup.elements[i].id;
		if(TemplateUtils.isElementTypeGroup(elmId))
		{
			elementGroup = groupHandler.groupMap[elmId];
			elementGroup.rotation = elementGroup.rotation + angleDiff;
			tempRotation = elementGroup.rotation;
			if(elementGroup.rotation < 0)
			{
				elementGroup.rotation = elementGroup.rotation + 360;
			}
			else if(elementGroup.rotation > 0)
			{
				elementGroup.rotation = elementGroup.rotation % 360;
			}
			this.updateChildGroupsAfterRotation(groupHandler.groupMap[elmId], angleDiff);
		}
	}
};

/*This function drags the group and all its elements. The element list for this group is populated in touch start event of groupDivCls if multi select mode is disabled.
If multiselect mode is enabled then it passes the change in X that is deltaX and change in Y that is deltaY difference to multiSelMainFrameDragTouchMove() which internally 
calls multiSelectDragGroup() function if any of the other group is part of multiSelElmArr*/
Group.prototype.dragGroup=function(e)
{
	var touches = e.originalEvent.changedTouches;
	var deltaX = (touches[0].clientX - templateObj.cpDragStartPt.x)/templateObj.mainFrame.scale;
	var deltaY = (touches[0].clientY- templateObj.cpDragStartPt.y)/templateObj.mainFrame.scale;
	templateObj.cpDragStartPt.x = touches[0].clientX;
	templateObj.cpDragStartPt.y = touches[0].clientY;
	var grpId = templateObj.mainElmDragBtnID;
	log.debug("deltaX = " + deltaX + " deltaY = " + deltaY + " grpId = " + grpId + " multiSelMode = " + templateObj.multiSelectMode,"dragGroup");
	if(templateObj.multiSelectMode)
	{
		templateObj.multiSelMainFrameDragTouchMove(deltaX, deltaY);
	}
	else
	{
		var group = groupHandler.groupMap[grpId];
		if(groupHandler.isGroupElementMovementValid(deltaX,deltaY,false,false))
		{
			groupHandler.dragGrpElm(deltaX,deltaY);
			group.x = group.x + deltaX;
			group.y = group.y + deltaY;
			this.setAndUpdateGroupPosition(grpId, group);
			// add magnetic lines for group
			var temp =  groupHandler.boundingRectForGroup(group);
			templateObj.findMagnetPointForObj(temp, MAGNET_PRIORITY_NONE, MAGNET_PRIORITY_NONE);
			templateObj.repositionGroupAccToMagnetPt(group);
			this.setAndUpdateGroupPosition(grpId, group);
		}
	}
};

/*This function drags the group and all its elements. It iterates recursively over sub groups and its elements and update the change in X and Y that is deltaX and deltaY for all the elements.
This function is invoked when multiselect mode is enabled*/
Group.prototype.multiSelectDragGroup=function(deltaX, deltaY, groupObj)
{
	var orgObj = groupObj;
	var elmObj = groupObj.ref;
	var currLeft=orgObj.leftpos+deltaX;
	orgObj.leftpos = orgObj.leftpos+deltaX;
	var currTop=orgObj.toppos+deltaY;
	orgObj.toppos = orgObj.toppos+deltaY;
	var elmId = orgObj.id;
	var obj = groupHandler.drag[elmId];
	if(obj != undefined)
	{
		obj.x = obj.x + deltaX;
		obj.y = obj.y + deltaY;
	}
	else
	{
		obj = {
				x:deltaX,
				y:deltaY
		};
		groupHandler.drag[elmId] = obj;
	}
	var isGrpElmInside = groupHandler.multiSelectChkGrpElmDragForMnFrmBoundary(elmId, obj.x,obj.y);
	log.debug("elmId = " + elmId + " isGrpElmInside = " + isGrpElmInside + " deltaX = " + deltaX + " deltaY = " + deltaY + " currLeft = " + currLeft + " leftpos = "  + orgObj.leftpos + " currTop = " + currTop + " toppos = " + orgObj.toppos,"multiSelectDragGroup");
	if(isGrpElmInside)
	{
		groupHandler.multiSelectDragGrpElm(elmId, obj.x,obj.y, true, true);
		elmObj.x = currLeft;
		elmObj.y = currTop;
		templateObj.setDimXYWH(elmId,elmObj.x-GROUP_OFFSET,elmObj.y-GROUP_OFFSET,elmObj.w+2*GROUP_OFFSET,elmObj.h+2*GROUP_OFFSET);
	}
};

/*This function proportionally resizes the group and its control points when the element of the group is resized*/
Group.prototype.resizeGroupElement=function(groupId)
{
	log.debug("groupId = "+groupId ,"resizeGroupElement");
	if(groupId!=null && groupId!="")
	{
        if (!templateObj.isCroppedMode) {
            groupHandler.resizeGrpOnElmResize(groupId);
        }
        var groupRef=groupHandler.groupMap[groupId];
        this.setAndUpdateGroupPosition(groupId, groupRef);
        this.showGroupDiv(groupId);
	}
};

/*This function resizes the group and proportionally resizes all the elements inside the group. If the multiselect mode is enabled then the percentage change in group width and height
due to resizing is passed multiSelMainFrameCpTouchMove() which internally calls multiSelectResizeGroup() if any of the other group is part of multiSelElmArr.*/
Group.prototype.resizeGroup=function(e)
{
	var groupId = templateObj.mainElmDragBtnID.split("-CP_")[0];
	var group = groupHandler.groupMap[groupId];
	var evtElmIndex=getParseIntInDec(templateObj.mainElmDragBtnID.split("-CP_")[1]);
	var touches = e.originalEvent.changedTouches;
	log.debug("groupId = " + groupId + " x = " + templateObj.mainFrameSelElmObj.x + " y = " + templateObj.mainFrameSelElmObj.y + " w = " + templateObj.mainFrameSelElmObj.w + " h = " + templateObj.mainFrameSelElmObj.h, "resizeGroup");
	var rect = templateObj.resizeMainFrameElementAfterRotation(templateObj.mainFrameSelElmObj,touches,evtElmIndex);
	log.debug("rect groupId = " + groupId + " x = " + rect.x + " y = " + rect.y + " w = " + rect.w + " h = " + rect.h, "resizeGroup");
	if(!templateObj.multiSelectMode && groupHandler.checkElmMnFrmBoundaryForGroupResize(templateObj.currMnFrmObjProp, rect, group.rotation))
	{
		groupHandler.resizeGrpElm(templateObj.currMnFrmObjProp, rect, group.rotation);
		this.setAndUpdateGroupPosition(groupId, rect);
		templateObj.updateObjXYHWFromObj(group, rect);
		var temp =  groupHandler.boundingRectForGroup(group);

		templateObj.findMagnetPointForObj(temp, MAGNET_PRIORITY_NONE, MAGNET_PRIORITY_NONE);
		var diff = templateObj.resizeGroupAccToMagnetPointsOnTouchEnd(group);
		var touch_duplicate = [{ clientX: touches[0].clientX+ diff.delX , clientY : touches[0].clientY + diff.delY }];

		rect = templateObj.resizeMainFrameElementAfterRotation(templateObj.mainFrameSelElmObj,touch_duplicate,evtElmIndex);
		groupHandler.resizeGrpElm(templateObj.currMnFrmObjProp, rect, group.rotation);
		this.setAndUpdateGroupPosition(groupId, rect);

		if (TemplateUtils.isElementTypeMainFrame(group.elements[0].id)) // only similar element can be grouped so checking from first element
		{
			templateObj.hideMainFrameAllElmCp();
		} 
		else 
		{
			templateObj.hideBlankLayoutFrameCP();
		}
		this.setColorToGroupDiv(true, groupId);
	}
	else if(templateObj.multiSelectMode)
	{
		var percentChangeInWidth = ((rect.w - templateObj.currMnFrmObjProp.w) * 100)/templateObj.currMnFrmObjProp.w;
		var percentChangeInHeight = ((rect.h - templateObj.currMnFrmObjProp.h) * 100)/templateObj.currMnFrmObjProp.h;
		templateObj.multiSelMainFrameCpTouchMove(evtElmIndex,percentChangeInWidth, percentChangeInHeight, groupId);
	}
};

/*This function iterates recursively and resizes all the elements inside the sub groups within a given group. This function is called only when multiselect mode is enabled.*/
Group.prototype.multiSelectResizeGroup=function(rect, originalGrpObj, groupId, refGroupObj)
{
	var group = groupHandler.groupMap[groupId];
	var result = groupHandler.multiSelChkElmMnFrmBdryForGrpResize(group, originalGrpObj, rect, group.rotation);
	log.debug("refGroupObj groupId = " + groupId + " result = " + result + " x = " + refGroupObj.x + " y = " + refGroupObj.y + " w = " + refGroupObj.w + " h = " + refGroupObj.h + " rotation = " + group.rotation, "multiSelectResizeGroup");
	if(result)
	{
		groupHandler.multiSelectResizeGrpElm(group, originalGrpObj, rect, group.rotation);
		this.setAndUpdateGroupPosition(groupId, rect);
		templateObj.updateObjXYHWFromObj(refGroupObj, rect);
	}
};

/*This function ungroup a given group and adds all the elements to the mainFrmElmLayer and pushes them in the multiSelElmArr*/
Group.prototype.unGroupElms=function(group, zIndex)
{
	var elmIndx, elmObj, elmID;
	log.debug("unGroup mainFrmElmLayer :: Before Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer), "unGroupElms");
	var elmLen=group.elements.length;
	for (var i = 0; i < elmLen; i++) 
	{
		elmObj = group.elements[i];
		elmID = elmObj.id;
		log.debug("elmID = " + elmID, " unGroupElms");
		if(TemplateUtils.isElementTypeGroup(elmID))
		{
			elmIndx=elmID;
			groupHandler.groupMap[elmID].parentId = "";
			this.calOuterRect(groupHandler.groupMap[elmID]);
			groupHandler.resizeGrpOnElmResize(elmID);
		}
		else
		{
			elmIndx = TemplateUtils.getElementIndexFromID(elmID);
			if(elmObj.ref.groupId == group.id)
			{
				log.debug("Reset the groupId for elements id = " + elmID, " unGroupElms");
				elmObj.ref.groupId = null;
			}
		}
		if(group.elementType==MAIN_FRAME_ELM)
		{
			templateObj.mainFrmElmLayer.splice(zIndex+i, 0, elmIndx);
		}
		else
		{
			templateObj.innerFrameZOrderArr.splice(zIndex+i, 0, elmIndx);
		}		
		templateObj.pushAndSelGroupOrElmOnMultiSelect(elmID);
		templateObj.updateMainFrameCpPosition(elmID);
	}
	log.debug("unGroup mainFrmElmLayer :: After Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer), "unGroupElms");
};
Group.prototype.handleUnGroup=function(groupId)
{
	log.debug("handleUnGroup mainFrmElmLayer :: Before Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer), "handleUnGroup");
	var group=groupHandler.groupMap[groupId];
	var zIndex;
	if(group.elementType==MAIN_FRAME_ELM)
	{
		zIndex = templateObj.getMnFrmLayerArrIndex(group.id);	
	}
	else
	{
		zIndex = templateObj.getInnerFrmLayerArrIndex(group.id);
	}
	log.debug("zIndex :" +zIndex + " group.id = " + group.id, " handleUnGroup");
	//ungroup elements and add to multiselect array and update the main frame layer holding elements
	this.unGroupElms(group, zIndex);
	//remove the group from main frame layer
	zIndex = zIndex + group.elements.length;
	if(group.elementType==MAIN_FRAME_ELM)
	{
		templateObj.mainFrmElmLayer.splice(zIndex,1);
	}
	else
	{
		templateObj.innerFrameZOrderArr.splice(zIndex,1);
	}
	delete groupHandler.groupMap[group.id];
	this.removeGroupDiv(group.id);
	log.debug("handleUnGroup mainFrmElmLayer :: AFTER Group Modifications:" +JSON.stringify(this.mainFrmElmLayer), "handleUnGroup");
};
Group.prototype.alignGroupElements=function(elmID, deltaX, deltaY, updateDeltaX, updateDeltaY)
{
	groupHandler.multiSelectDragGrpElm(elmID, deltaX,0, true, false);
	groupHandler.multiSelectUpdateGrpElmObj(elmID, 0, true);
	var group = groupHandler.groupMap[elmID];
	$("#"+elmID).css({
		'left':group.x+'px',
		'top':group.y+'px'
	});
};

/*align the left boundary of all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupLeftAlign=function(elmID, deltaX)
{
	log.debug("elmID = " + elmID + " deltaX = " +  deltaX, "groupLeftAlign");
	this.alignGroupElements(elmID, deltaX,0, true, false);
};

/*align the right boundary of all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupRightAlign=function(elmID, deltaX)
{
	log.debug("elmID = " + elmID + " deltaX = " +  deltaX, "groupRightAlign");
	this.alignGroupElements(elmID, deltaX,0, true, false);
};

/*align the top boundary of all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupTopAlign=function(elmID, deltaY)
{
	log.debug("elmID = " + elmID + " deltaY = " +  deltaY, "groupTopAlign");
	this.alignGroupElements(elmID, 0,deltaY, false, true);
};

/*align the bottom boundary of all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupBottomAlign=function(elmID, deltaY)
{
	log.debug("elmID = " + elmID + " deltaY = " +  deltaY, "groupBottomAlign");
	this.alignGroupElements(elmID, 0,deltaY, false, true);
};

/*align the group center horizontally of all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupCenterAlignHorizontally=function(elmID, deltaY)
{
	log.debug("elmID = " + elmID + " deltaY = " +  deltaY, "groupCenterAlignHorizontally");
	this.alignGroupElements(elmID, 0,deltaY, false, true);
};

/*align the group center vertically of all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupCenterAlignVertically=function(elmID, deltaX)
{
	log.debug("elmID = " + elmID + " deltaX = " +  deltaX, "groupCenterAlignVertically");
	this.alignGroupElements(elmID, deltaX,0, true, false);
};

/*align the group center horizontally by dividing the distance between extreme end groups equally among all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupDistributeHorizontally=function(elmID, deltaX)
{
	log.debug("elmID = " + elmID + " deltaX = " +  deltaX, "groupDistributeHorizontally");
	this.alignGroupElements(elmID, deltaX,0, true, false);
};

/*align the group center vertically by dividing the distance between extreme end groups equally among all the groups. It is called only when multiselect mode is enabled.*/
Group.prototype.groupDistributeVertically=function(elmID, deltaY)
{
	log.debug("elmID = " + elmID + " deltaY = " +  deltaY, "groupDistributeVertically");
	this.alignGroupElements(elmID, 0,deltaY, false, true);
};

/*Delete all the child groups and its elements for a given group id*/
Group.prototype.deleteChildGroupsAndElementsFromCurrentGroup=function(groupId)
{
	var group = groupHandler.groupMap[groupId];
	var len = group.elements.length;
	for (var i = 0; i < len; i++) 
	{
		var id = group.elements[i].id;
		if(TemplateUtils.isElementTypeGroup(id))
		{
			this.deleteChildGroupsAndElementsFromCurrentGroup(id);
			group.elements.splice(i,1);
			this.removeGroupDiv(id);
			delete groupHandler.groupMap[id];
		}
		else
		{
			this.removeElementFromUI(group.id, id);
			group.elements.splice(i,1);
		}
			i = i-1;
			len = len-1;
	}
};

/*Delete the child from parent and if after deletion the parent has only one child,
then search for the parent in parentsParent and replace the parent entry with the only child entry.
 This is required as the group with a single child is not a group, hence move the child up the hierachy
 and replace the parent with a group*/
Group.prototype.deleteCurrentGroupOrElementFromParentGroup=function(parentId, childId)
{
	var parentGroup = groupHandler.groupMap[parentId];
	var numOfChild = parentGroup.elements.length;
	var rootId = null;
	log.debug("deleteCurrentGroupOrElementFromParentGroup mainFrmElmLayer :: BEFORE Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer),"deleteCurrentGroupOrElementFromParentGroup");
	for (var i = 0; i < numOfChild; i++) 
	{
		var element = parentGroup.elements[i];
		if(element.id == childId)
		{
			parentGroup.elements.splice(i,1);
			var currentLen = parentGroup.elements.length;
			var isRoot = this.isRoot(parentId);
			if(currentLen <= 1)
			{
				rootId = this.updateParentGroupForOneOrLessChild(parentId);
			}
			else
			{
				rootId = parentId;
			}
			log.debug("parentId = " + parentId + " child Id = " + childId + " Child found at Index = " + i + " remaining Children = " + currentLen + " isRoot = " + isRoot + " rootId = " + rootId, "deleteCurrentGroupOrElementFromParentGroup");
			break;
		}

	}
	log.debug("deleteCurrentGroupOrElementFromParentGroup mainFrmElmLayer :: AFTER Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer),"deleteCurrentGroupOrElementFromParentGroup");
	return rootId;
};

Group.prototype.deleteGroupOrElementFromTemplate=function(groupId)
{
	var groupRef=groupHandler.groupMap[groupId];
	if(groupRef == undefined || groupRef==null)
	{
		return;
	}
	var elementType = groupRef.elementType;
	var groupIndex;
	if(elementType == MAIN_FRAME_ELM)
	{
		groupIndex = templateObj.getMnFrmLayerArrIndex(groupId);
		if(groupIndex != -1)
		{
			templateObj.mainFrmElmLayer.splice(groupIndex,1);
		}
	}
	else if(elementType == BLANK_INNER_FRAME)
	{
		groupIndex= templateObj.getInnerFrmLayerArrIndex(groupId);
		if(groupIndex != -1)
		{
			templateObj.innerFrameZOrderArr.splice(groupIndex,1);
		}
	}
};

Group.prototype.replaceParentGroupWithChildGroupOrElement=function(parentId, childId)
{
	var elementType = groupHandler.groupMap[parentId].elementType;
	var groupIndex;
	if(elementType == MAIN_FRAME_ELM)
	{
		groupIndex = templateObj.getMnFrmLayerArrIndex(parentId);
		if(groupIndex != -1)
		{
			templateObj.mainFrmElmLayer.splice(groupIndex,1,childId);
		}
	}
	else if(elementType == BLANK_INNER_FRAME)
	{
		groupIndex= templateObj.getInnerFrmLayerArrIndex(parentId);
		if(groupIndex != -1)
		{
			templateObj.innerFrameZOrderArr.splice(groupIndex,1,childId);
		}
	}
};


/*Move the child up the hierarchy if the parent has only one child, then search for the parent in parentsParent and replace the parent entry with the only child entry.
This is required as the group with a single child is not a group, hence move the child up the hierachy and replace the parent with a group*/
Group.prototype.updateParentGroupForOneOrLessChild=function(parentId)
{
	var parentGroup = groupHandler.groupMap[parentId];
	var numOfChild = parentGroup.elements.length;
	var parentsParentId = parentGroup.parentId;
	var childRef = parentGroup.elements[0].ref;
	var child = parentGroup.elements[0];
	var childId = parentGroup.elements[0].id;
	var rootId = null;
	var isRoot = this.isRoot(parentId);
	log.debug("updateParentGroupForOneOrLessChild parentId = " + parentId + " numOfChild = " + numOfChild + " childId = " + childId + " parentsParentId = " + parentsParentId + " isRoot = " + isRoot, "updateParentGroupForOneOrLessChild");
	if(numOfChild == 1 && !isRoot)
	{
		var parentsParentGroup = groupHandler.groupMap[parentsParentId];
		var len = parentsParentGroup.elements.length;
		log.debug("updateParentGroupForOneOrLessChild initial length = " + len, " updateParentGroupForOneOrLessChild");
		log.debug("updateParentGroupForOneOrLessChild INITIAL parentsParentGroup:" +JSON.stringify(parentsParentGroup),"updateParentGroupForOneOrLessChild");
		for (var i = 0; i < len; i++) 
		{
			if(parentId == parentsParentGroup.elements[i].id)
			{
				parentsParentGroup.elements.splice(i,1,child);
				if(TemplateUtils.isElementTypeGroup(childId))
				{
					childRef.parentId = parentsParentGroup.id;
				}
				else
				{
					childRef.groupId = parentsParentGroup.id;
				}
				break;
			}
		}
		len = parentsParentGroup.elements.length;
		log.debug("updateParentGroupForOneOrLessChild AFTER MODIFICATIONS parentsParentGroup:" +JSON.stringify(parentsParentGroup),"updateParentGroupForOneOrLessChild");
		log.debug("updateParentGroupForOneOrLessChild final parentsParentGroup.elements.length = " + len, " updateParentGroupForOneOrLessChild");
		if(len <= 1)
		{
			rootId = this.updateParentGroupForOneOrLessChild(parentsParentId);

			this.deleteGroupOrElementFromTemplate(parentId);

			log.debug("updateParentGroupForOneOrLessChild REMOVING GROUP parentId = " + parentId, "updateParentGroupForOneOrLessChild");
			this.removeGroupDiv(parentId);
			delete groupHandler.groupMap[parentId];
		}
		else
		{
			rootId = parentsParentId;
		}
	}
	else
	{
		if(TemplateUtils.isElementTypeGroup(childId))
		{
			childRef.parentId = parentsParentId;
			this.replaceParentGroupWithChildGroupOrElement(parentId, childId);	
		}
		else
		{
			childRef.groupId = null;
			var elmIndx =TemplateUtils.getElementIndexFromID(childId);
			this.replaceParentGroupWithChildGroupOrElement(parentId, elmIndx);
		}

		rootId = childId;
		this.removeGroupDiv(parentId);
		delete groupHandler.groupMap[parentId];
	}

	log.debug("updateParentGroupForOneOrLessChild RETURNING FINAL rootId = " + rootId + " parentId = " + parentId + " childId = " + childId + " parentsParentId = " + parentsParentId + " isRoot = " + isRoot, " updateParentGroupForOneOrLessChild");
	return rootId;
};

/*The utility function to check if the group is a root or not*/
Group.prototype.isRoot=function(groupId)
{
	var parentId = groupHandler.groupMap[groupId].parentId;
	var isRoot = true;
	if(parentId.length > 0)
	{ 
		isRoot = false;
	}
	return isRoot;
};

/*The utility function to check if the id is a group or element*/
Group.prototype.isGroup=function(id)
{
	return TemplateUtils.isElementTypeGroup(id);
};

/*Delete a group and all its sub group and elements. If after deletion of the given group id, if the parent of this group is left with only one child then the child is moved up the herachy and the child replaces the parent
 in the parents parent element list*/
Group.prototype.deleteGroup=function(groupId)
{
	this.deleteChildGroupsAndElementsFromCurrentGroup(groupId);	//deletes all the children from a given group
	var isRoot = this.isRoot(groupId);
	var rootId;
	if(!isRoot)
	{
		rootId = this.deleteCurrentGroupOrElementFromParentGroup(groupId.parentId, groupId);	// deletes itself from its parent and updating above hierarchy
	}
	else
	{
		rootId = groupId;
	}
	this.deleteGroupOrElementFromTemplate(groupId); 
	/*TODO: check if required or not - deletes groupid from template array*/
	
	/*Updating UI reminder of the group hierarchy*/
	rootId = groupHandler.findRoot(rootId);
	var isGroup = this.isGroup(rootId);
	if(isGroup)
	{
		this.updateGroupUI(rootId);
	}
	else
	{
		log.debug("deleteGroup NOT EXPECTED CASE finally groupId = " + groupId,"deleteGroup");
		this.removeGroupDiv(groupId);
		delete groupHandler.groupMap[groupId];
	}
};

Group.prototype.removeElementFromUI=function(groupId, divID)
{
	var elementType = groupHandler.groupMap[groupId].elementType;
	if(elementType == MAIN_FRAME_ELM)
	{
		var index = divID.split("-elm_")[1].split("_")[0];
		templateObj.mainFrame.element[index]=null;
		$("#ElmCover-"+divID).remove();
		$("#"+divID).remove();
	}
	else
	{
		$("#"+divID).remove();
		$("#frameCover-"+divID).remove();
	//	templateObj.removeLnkdTxtOfFramFrmScrn(divID);
		templateObj.curSelFrameIndx=-1;	//TODO: check if required
		delete templateObj.innerFrames[divID];
	}
};

/*Delete the selected group element . If after deletion the group is left with a single child.
Then move the child up the hierachy and replace the parent entry with a child entry in the elements
list of the parent parent*/
Group.prototype.deleteGroupElement=function(elmObj, divID)
{
	log.debug("START","deleteGroupElement");
    if(elmObj.groupId==null || elmObj.groupId=="")
    {
        return;
    }
	var groupId = elmObj.groupId;
	this.removeElementFromUI(groupId, divID);
	var rootId = this.deleteCurrentGroupOrElementFromParentGroup(groupId, divID);
	var isGroup = this.isGroup(rootId);
	if(rootId != null && isGroup)
	{
		rootId = groupHandler.findRoot(rootId);
		isGroup = this.isGroup(rootId);
	}
	log.debug("deleteGroupElement divID = " + divID + " elmObj.groupId = " + elmObj.groupId + " rootId = " + rootId + " isGroup = " + isGroup, "deleteGroupElement");
	//updating group UI
	if(isGroup)
	{
		this.updateGroupUI(rootId);
		templateObj.addBoxShadowOnFrame(rootId,"#3196ff","");
		showAuthorMenu(rootId);
	}
	else
	{
		this.deleteGroupOrElementFromTemplate(groupId);
		this.removeGroupDiv(groupId);
		delete groupHandler.groupMap[groupId];
		if(TemplateUtils.isElementTypeMainFrame(rootId))
		{
			templateObj.showMainFrameElmCp(rootId);
			templateObj.setDragElmFrame(rootId);
			showAuthorMenu("ElmCover-"+rootId);
		}
		else if(rootId.indexOf("tplFrameId")!=-1)
		{
			templateObj.selFrameOrItsElmTap(rootId);
			showAuthorMenu("frameCover-"+rootId);
		}
	}
	elmObj.groupId = null;
	log.debug("deleteGroupElement mainFrmElmLayer :: AFTER Group Modifications:" +JSON.stringify(templateObj.mainFrmElmLayer),"deleteGroupElement");
};
Group.prototype.updateGroupUI=function(rootId)
{
	var rootGroup = groupHandler.groupMap[rootId];
	var len = rootGroup.elements.length;
	if(len > 0)
	{
		this.calOuterRect(rootGroup);
		groupHandler.resizeGrpOnElmResize(rootId);
		this.updateRotationHandlerForGroupById(rootId);
		if($("#"+rootId).hasClass("groupDivSelCls"))
		{
			log.debug("updateGroupUI  group id is existing , hence update it", "updateGroupUI");
			this.setAndUpdateGroupPosition(rootId, rootGroup);
		}
		else
		{
			log.debug("updateGroupUI  create new group dev id for group id = " + rootId, "updateGroupUI");
			this.removeGroupDiv(rootId);
			this.createGroupDiv(rootId);
		}
	}
	else
	{
		this.deleteGroupOrElementFromTemplate(rootId);
		this.removeGroupDiv(rootId);
		delete groupHandler.groupMap[rootId];
	}
};
Group.prototype.arrangeGroupElements=function(command,elmId)
{
	var elmObj = templateObj.mainFrameSelElmObj;
	var groupId = elmObj.groupId;
	var group = groupHandler.groupMap[groupId];
	var len = group.elements.length,obj,flag=false;	
	for (var i = 0; i < len; i++)
	{
		obj = group.elements[i];
		if(elmId == obj.id)
		{			
			switch(command)
			 {
				 case "bring-front":
					 if(i < len-1)
					 {
						 group.elements.splice(i,1);
						 group.elements.splice(group.elements.length,0,obj);
						 flag=true;
					}
				 break;
				 case "bring-forward":
					 if(i < len-1)
					 {
						 group.elements[i]=group.elements[i+1];
						 group.elements[i+1]=obj;
						 flag=true;
					 }
				 break;
				 case "send-back":
					 if(i>0)
					{
					 group.elements.splice(i,1);
					 group.elements.splice(0,0,obj);
					 flag=true;
					}
				 break;
				 case "send-backward":
					 if(i>0)
					{
						 group.elements[i]=group.elements[i-1];
						 group.elements[i-1]=obj;
						 flag=true;
					}
				 break;
				 default:
				 break;
			 }
			if(flag)
			{
				if(TemplateUtils.isElementTypeMainFrame(elmId))
				{
					templateObj.resetZIndexMnFrmElm();
				}
				else
				{
					templateObj.reorderZIndexBlkFrames();
				}
			}
			break;
		}
	}
};
/*A utility function to print group cordinates*/
Group.prototype.printGroupInfo=function(groupId)
{
	var group = groupHandler.groupMap[groupId];
	log.debug("GroupInfo id = " + groupId + " x = " +  group.x + " y = " + group.y + " w = " + group.w + " h = " + group.h, "printGroupInfo");
};

/*A utility function to print group elements cordinates*/
Group.prototype.printGroupElementsInfo=function(groupId)
{
	var str = "";
	var group = groupHandler.groupMap[groupId];
	var elmLen=group.elements.length;
	for (var i = 0; i < elmLen; i++) 
	{
		var element = group.elements[i];
		str = str + "[id = " + element.id + " ,x = " +  element.x + " ,y = " + element.y + " ,w = " + element.w + " ,h = " + element.h + "],";
	}
	log.debug("GroupElementsInfo = " + str, "printGroupElementsInfo");
};

/*A utility function to print printMultiSelElmArr. This will print the cordinates information for all the multiselected elements*/
Group.prototype.printMultiSelElmArr=function()
{
	var elmLen=templateObj.multiSelElmArr.length;
	for (var i = 0; i < elmLen; i++) 
	{
		var element = templateObj.multiSelElmArr[i];
		log.debug("MultiSelElmArr Original Object id = " + element.id + " x = " +  element.x + " y = " + element.y + " w = " + element.w + " h = " + element.h, "printMultiSelElmArr");
		log.debug("MultiSelElmArr Refrence Object id = " + element.id + " x = " +  element.ref.x + " y = " + element.ref.y + " w = " + element.ref.w + " h = " + element.ref.h, "printMultiSelElmArr");
	}
};

/*A utility function to print mainframe layer which hold the z index of all the main frame elements*/
Group.prototype.printMainFrameLayer=function()
{
	log.debug("MainFrmElmLayer = " + JSON.stringify(templateObj.mainFrmElmLayer), "printMainFrameLayer");
};

Group.prototype.setAndUpdateGroupPosition=function(id, group)
{
	templateObj.setDimXYWH(id,group.x-GROUP_OFFSET,group.y-GROUP_OFFSET,group.w+2*GROUP_OFFSET,group.h+2*GROUP_OFFSET);
	templateObj.updateMainFrameCpPosition(id);
};


