/**
 * @filename LfdContent.js
 * 
 * Modified by r.k.pandey 31-01-2015
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

var obj = null;

var LFDGenerator = {
	// Save XML Data
	saveXMLData : function() {
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, createFSLFDGenerator, failCreateFSLFDGenerator);
	}
};
function createFSLFDGenerator(fileSystem) {
	var LfdWritePath;
	if(templateFlag == UPLOAD_TEMPLATE){
		LfdWritePath = pathToWriteLFD;
	}else{
		LfdWritePath = SaveTemplate.lfdFilePathAfterRoot;
	}
	fileSystem.root.getFile(LfdWritePath, {
		create : true,
		exclusive : false
	}, gotLFDGeneratorEntry, failLFDGeneratorEntry);
}
function failCreateFSLFDGenerator(){
	console.log("failLFDGenerator");
}
function gotLFDGeneratorEntry(fileEntry) {
	fileEntry.createWriter(gotLFDGeneratorFileWriter, failLLFDGeneratorFileWriter);
}
function gotLFDGeneratorFileWriter(writer) {	
	writer.write(obj);	
	if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
		SaveTemplate.successLfdFileCreation();
				
	}else{/* UPLOAD_TEMPLATE case*/
	    if(LOWER_PLAYER_TYPE_SUPPORT){
            uploadJsonCount--;
            if(uploadJsonCount < uploadJsonLastIndex){
                templateIndex++;
                /*Starting index 6 */
                uploadJsonCount = TIZEN_S6;/*reset uploadJsonCount flag*/
            }
        }else{
            templateIndex++;
        }
		templateParser();			
	}
}
function failLFDGeneratorEntry(){
	console.log("failLFDGeneratorEntry");
}
function failLLFDGeneratorFileWriter(){
	console.log("failLLFDGeneratorFileWriter");
}

var LfdContent = {

	sendContent : function(ContentObj) {
	//	setTimeout(function() {
			var LfdCreator = new LFDCreator();
			var CreateLFDFlage = LfdCreator.CreateLFD(ContentObj);
			if (CreateLFDFlage == true){
				obj = (new XMLSerializer()).serializeToString(LFDString);
			}
			obj = obj.replace(/<\/FileItem>/g, "</FileItem>\n");
			obj = obj.replace(/<\/Name>/g, "</Name>\n");
			obj = obj.replace(/FileItem\s[\s"=a-zA-Z0-9\-]*>/g, "FileItem FileID=\"BB7534F3-4889-4A2A-8A1E-BECCBC4B9279\" FileSize=\"2210\" FileHashValue=\"1A0D4230-FB9A-CB2B-6033-5812569AF443-17CE595A\">");
			var objCount = 0;
			while (obj.indexOf("BB7534F3-4889-4A2A-8A1E-BECCBC4B9279") > 0) {
				obj = obj.replace("BB7534F3-4889-4A2A-8A1E-BECCBC4B9279", "E4A4A18E-6141-494F-A307-0F8D1CEAEA" + ((objCount < 10) ? ("0" + objCount) : objCount));
				objCount++;
			}
			obj = obj.replace(/<\/BGColor>/g, "</BGColor>\n");
			obj = obj.replace(/<\/MotionPathPoints>/g, "</MotionPathPoints>\n");
			obj = obj.replace(/<\/BGImageFilePath>/g, "</BGImageFilePath>\n");
			obj = obj.replace(/<\/BGRatio>/g, "</BGRatio>\n");
			obj = obj.replace(/<\/OrginalWidth>/g, "</OrginalWidth>\n");
			obj = obj.replace(/<\/OriginalHeight>/g, "</OriginalHeight>\n");
			obj = obj.replace(/<\/DurationPolicy>/g, "</DurationPolicy>\n");
			obj = obj.replace(/<\/Duration>/g, "</Duration>\n");
			obj = obj.replace(/<\/IsVisible>/g, "</IsVisible>\n");
			obj = obj.replace(/<\/InterpolationType>/g, "</InterpolationType>\n");
			obj = obj.replace(/<\/EventEnable>/g, "</EventEnable>\n");
			obj = obj.replace(/<\/EffectInName>/g, "</EffectInName>\n");
			obj = obj.replace(/<\/EffectInDuration>/g, "</EffectInDuration>\n");
			obj = obj.replace(/<\/EffectInDirection>/g, "</EffectInDirection>\n");
			obj = obj.replace(/<\/EffectInRepeatPolicy>/g, "</EffectInRepeatPolicy>\n");
			obj = obj.replace(/<\/EffectInRepeatPeriod>/g, "</EffectInRepeatPeriod>\n");
			obj = obj.replace(/<\/EffectInRepeatCount>/g, "</EffectInRepeatCount>\n");
			obj = obj.replace(/<\/EventItems>/g, "</EventItems>\n");
			obj = obj.replace(/Global">/g, "Global\">\n");
			obj = obj.replace(/String">/g, "String\">\n");
			obj = obj.replace(/File">/g, "File\">\n");
			obj = obj.replace(/Number">/g, "Number\">\n");
			obj = obj.replace(/List">/g, "List\">\n");
			obj = obj.replace(/Time">/g, "Time\">\n");
			obj = obj.replace(/Boolean">/g, "Boolean\">\n");
			obj = obj.replace(/Global">/g, "Global\">\n");
			//obj=obj.replace(/<\FileItem type=\"File\">/g,"<\FileItem type=\"File\">\n");
			obj = obj.replace(/<\/PureFileItem>/g, "</PureFileItem>\n");
			obj = obj.replace(/<\/RealFullPath>/g, "</RealFullPath>\n");
			obj = obj.replace(/<\/FileSize>/g, "</FileSize>\n");
			obj = obj.replace(/<\/FileID>/g, "</FileID>\n");
			obj = obj.replace(/<\/FileHashValue>/g, "</FileHashValue>\n");
			obj = obj.replace(/<\/KeyPathLocation>/g, "</KeyPathLocation>\n");
			obj = obj.replace(/FileItem1\s[\s"=a-zA-Z0-9\-]*>/g, "FileItem type=\"File\">");
			obj = obj.replace(/<\/FileItem1>/g, "</FileItem>\n");

			obj = obj.replace(/([::])?Spin1/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_3D::Spin1';
			});
			obj = obj.replace(/([::])?3D-AMSpinFade/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_3D2::AMSpinFad';
			});
			obj = obj.replace(/([::])?Erosion/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Alpha::Erosion';
			});
			obj = obj.replace(/([::])?Vortex/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Alpha::Vortex';
			});
			obj = obj.replace(/([::])?Dissolve/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_FlyOn::Dissolve';
			});
			obj = obj.replace(/([::])?FlyZoom/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_FlyOn::FlyZoom';
			});
			obj = obj.replace(/([::])?FadeWave/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_FlyOn::FadeWave';
			});
			obj = obj.replace(/([::])?PushMoreStrips/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Push2::PushMoreStrips';
			});
			obj = obj.replace(/([::])?PushStrips/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Push2::PushStrips';
			});
			obj = obj.replace(/([::])?ScrollIn/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Push2::ScrollIn';
			});
			obj = obj.replace(/([::])?RandomBlocks/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Reveal2::RandomBlocks';
			});
			obj = obj.replace(/([::])?TimeSlice/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Reveal2::TimeSlice';
			});
			obj = obj.replace(/([::])?Wipe/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Reveal::Wipe';
			});
			obj = obj.replace(/([::])?ZoomUp/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_Zoom::ZoomUp';
			});
			obj = obj.replace(/([::])?FlyFade/g, function($0, $1) {
				return $1 ? $0 : 'Ext_Eff_FlyOn::FlyFade';
			});

			//alert("saveXMLData "+obj);
			LFDGenerator.saveXMLData(obj);
	//	}, 100);
	}
};
