/**
 * @filename LfdCreator.js
 * 
 * Modified by p.menaria 26-01-2015
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */
function VisibleCanvasArray(){
	
	this.index=-1,
	this.canvasPageStackIndex=-1;
	
}
var LFDString=null;
var MediaSlideArray=new Array();

function LFDCreator() {
		
		printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","LFD Creation");
		this.CreateLFD = function(ContentObj) {
		log.debug("FunctionIn: CreateLFD");
		var pageIndex = 0;
		
		//To retrieve player type
		var PlayerType = ContentObj.PlayerType;
		// Used to store Content information
		var selectedLFDContentId = ContentObj.ContentID;
		var selectedLFDFileID = ContentObj.ContentFileID;
		var LFDName = ContentObj.ContentFileName;
		var CanvasWidth = ContentObj.DisplayWidth;
		var CanvasHeight = ContentObj.DisplayHeight;
		var DisplayPolicy = ContentObj.DisplayPolicy;
		var BGMusicFilePath = ContentObj.BGMusicFilePath;
		var BGMusicFileFullPath = ContentObj.BGMusicFileFullPath;
		var DataLinkFlag = ContentObj.DataLinkFlag;

		//Step1 - LFD content variable
		LFDString = LFD.createLFD(selectedLFDContentId, DataLinkFlag, selectedLFDFileID, LFDName, CanvasWidth, CanvasHeight, DisplayPolicy, BGMusicFilePath, BGMusicFileFullPath, PlayerType);

		// Step2 -  Adding page 0 info
		LFD.addPage(LFDString, ContentObj.Page[pageIndex]);

		pageIndex = 1;
		// Step3 -
		// Sound  Data
		
	/*
		var soundArr = new Sound_Array();
		soundIndex = 0;
		if (ContentObj.Page[PageIndex].Sound.length > 0) {
			soundArr.Name = ContentObj.Page[PageIndex].Sound[soundIndex].Name;
			soundArr.SoundVolume = ContentObj.Page[PageIndex].Sound[soundIndex].SoundVolume;
			soundArr.FilePath = ContentObj.Page[PageIndex].Sound[soundIndex].FilePath;
			soundArr.TypeID = ContentObj.Page[PageIndex].Sound[soundIndex].TypeID;
			soundArr.SoundMute = ContentObj.Page[PageIndex].Sound[soundIndex].SoundMute;
			soundArr.Duration = ContentObj.Page[PageIndex].Sound[soundIndex].Duration;
			soundArr.OriginalLength = ContentObj.Page[PageIndex].Sound[soundIndex].OriginalLength;
			soundArr.ClipEnd = ContentObj.Page[PageIndex].Sound[soundIndex].ClipEnd;
			soundArr.SoundAfterPlay = ContentObj.Page[PageIndex].Sound[soundIndex].SoundAfterPlay;
			soundArr.DurationPolicy = ContentObj.Page[PageIndex].Sound[soundIndex].DurationPolicy;
			soundArr.RepeatPeriod = ContentObj.Page[PageIndex].Sound[soundIndex].RepeatPeriod;
			soundArr.RepeatEnd = ContentObj.Page[PageIndex].Sound[soundIndex].RepeatEnd;
			LFD.addSound(LFDString, 0, soundArr);
		}
     */
    
		// STEP-4 Adding Page 1 Info
		var PagePropertiesObj = ContentObj.Page[pageIndex];
       
        var groupCreated;
        var indxForLfdGroupTag = -1;
        
		LFD.addPage(LFDString, PagePropertiesObj);
		var PageGrpLength = PagePropertiesObj.Group.length;
		for (var grpIndx = 0; grpIndx < PageGrpLength; grpIndx++) {
			groupCreated = false;//reset flag
			
			var GroupObj = PagePropertiesObj.Group[grpIndx];
			if(GroupObj.GroupMap.length > 0)
			{
				LFD.addGroup(LFDString, pageIndex, GroupObj);
				//GroupObj = GroupObj.GroupMap[0];
				indxForLfdGroupTag++;
				for(var itr=0;itr<GroupObj.GroupMap.length;itr++)
				{	
					indxForLfdGroupTag = ContentObjToLfd(GroupObj.GroupMap[itr],indxForLfdGroupTag,LFDString,pageIndex,true,groupCreated,grpIndx);
				}
			}
			else
			indxForLfdGroupTag = ContentObjToLfd(GroupObj,indxForLfdGroupTag,LFDString,pageIndex,false,groupCreated,grpIndx);
		}
		printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","LFD Creation");
		log.debug("FunctionOut: CreateLFD");
		return true;
	};
}
function ContentObjToLfd(ContntGrpObj,indxForLfdGroupTag,LFDString,pageIndex,addtoGroup,groupCreated,grpIndx)
{	
		// [IMAGE]
			// Inserting images from object
	
		if(typeof ContntGrpObj != 'object')
			return -1;
		var i,cotntElementArrLen;			
		cotntElementArrLen = ContntGrpObj.Image.length;
		for (i = 0; i < cotntElementArrLen; i++) {
			/*if(groupCreated == false && ContntGrpObj.Image[i].isGroupMember == true){
				indxForLfdGroupTag++;
				LFD.addGroup(LFDString, pageIndex, ContntGrpObj);
				groupCreated = true;
			}*/
			if(globlePlayerType != RMD_MODEL || templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE || (templateFlag ==UPLOAD_TEMPLATE && ContntGrpObj.Image[i].OriginalPath!=undefined && ContntGrpObj.Image[i].OriginalPath!=""))
			{
				LFD.addImage(LFDString, pageIndex,ContntGrpObj.Image[i],addtoGroup,indxForLfdGroupTag);
			}
		}
		
		// [VIDEO]
		// Inserting Videos from object
		cotntElementArrLen = ContntGrpObj.Video.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			if(ContntGrpObj.Video[i].IsNewFile != undefined )
			{
				ContntGrpObj.Video[i].IsNewFile="False";	
			}
			LFD.addVideo(LFDString, pageIndex, ContntGrpObj.Video[i],addtoGroup,indxForLfdGroupTag);
		}
		
		// [INPUT SOURCE]
		// Inserting InputSource from object
		cotntElementArrLen = ContntGrpObj.InputSource.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addInputSource(LFDString, pageIndex, ContntGrpObj.InputSource[i],addtoGroup,indxForLfdGroupTag);
		}
		
		// [SIMPLE_TEXT]
		cotntElementArrLen = ContntGrpObj.Text.length;
		for ( i = 0; i < cotntElementArrLen; i++){
			if(!groupCreated && ContntGrpObj.Text[i].isGroupMember){
				 indxForLfdGroupTag++;
				LFD.addGroup(LFDString, pageIndex, ContntGrpObj);
				groupCreated = true;
			}
			LFD.addText(LFDString, pageIndex,ContntGrpObj.Text[i],addtoGroup || groupCreated,indxForLfdGroupTag);
		}	                      
		// [STICKER]
		cotntElementArrLen = ContntGrpObj.Sticker.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addSticker(LFDString, pageIndex, ContntGrpObj.Sticker[0],addtoGroup,indxForLfdGroupTag);
		}					
			                         
		// [OFFICE]
		cotntElementArrLen = ContntGrpObj.Office.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addOffice(LFDString, pageIndex, ContntGrpObj.Office[i],addtoGroup,indxForLfdGroupTag);
		}	
		// [PDF]
		cotntElementArrLen = ContntGrpObj.Pdf.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addPDF(LFDString, pageIndex, ContntGrpObj.Pdf[i],addtoGroup,indxForLfdGroupTag);
		}		
		// [SOUND]
		cotntElementArrLen = ContntGrpObj.Sound.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addSound(LFDString, pageIndex, ContntGrpObj.Sound[i],addtoGroup,indxForLfdGroupTag);
		}
		//[DIGITAL CLOCK]	
		cotntElementArrLen = ContntGrpObj.DigitalClock.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addDigitalClock(LFDString, pageIndex, ContntGrpObj.DigitalClock[i],addtoGroup,indxForLfdGroupTag);
		}	
		//[ANALOG CLOCK]	
		cotntElementArrLen = ContntGrpObj.AnalogClock.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addAnalogClock(LFDString, pageIndex, ContntGrpObj.AnalogClock[i],addtoGroup,indxForLfdGroupTag);
		}
		//[RSS]	
		cotntElementArrLen = ContntGrpObj.RSS.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addRSS(LFDString, pageIndex, ContntGrpObj.RSS[i],addtoGroup,indxForLfdGroupTag);
		}	
		
		//[Web]	
		cotntElementArrLen = ContntGrpObj.Web.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addWeb(LFDString, pageIndex, ContntGrpObj.Web[i],addtoGroup,indxForLfdGroupTag);
		}
		//[MediaRss]	
		cotntElementArrLen = ContntGrpObj.MediaRss.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addMediaRss(LFDString, pageIndex, ContntGrpObj.MediaRss[i],addtoGroup,indxForLfdGroupTag);
		}	
		//[WEATHER HOURLY]	
		cotntElementArrLen = ContntGrpObj.WeatherHourly.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addWeatherHourly(LFDString, pageIndex, ContntGrpObj.WeatherHourly[i],addtoGroup,indxForLfdGroupTag);
		}	
		//[WEATHER 1DAY]
		cotntElementArrLen = ContntGrpObj.Weather1Day.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addWeather1Day(LFDString, pageIndex, ContntGrpObj.Weather1Day[i],addtoGroup,indxForLfdGroupTag);
		}	
		//[WEATHER 7DAY]
		cotntElementArrLen = ContntGrpObj.Weather7Day.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			LFD.addWeather7Day(LFDString, pageIndex, ContntGrpObj.Weather7Day[i],addtoGroup,indxForLfdGroupTag);
		}	
		
		cotntElementArrLen = ContntGrpObj.Shapes.length;
		for ( i = 0; i < cotntElementArrLen; i++) {
			var shapeContObj = ContntGrpObj.Shapes[i];
			var shapetype;
			shapetype  = getShapeTypeOfSameCategory(shapeContObj.typeName,shapeContObj.elementName);
			LFD.addShapes(shapetype,LFDString, pageIndex, ContntGrpObj.Shapes[i],addtoGroup,indxForLfdGroupTag);
		}	
		return indxForLfdGroupTag;
}