/**
 * @filename LfdParser.js
 *
 * Created by p.menaria 14-01-2015
 * 
 * Modified by p.menaria 26-01-2015
 *
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */
function CommonTypeNId()
{
	this.Type="";
	this.TypeID=-1;
}
function CommonPropForElments(durationPolicyVal,repeatPeriodVal,durationVal)
{
	this.Name="";
	this.PositionX=0;
	this.PositionY=0;
	this.Width=0;
	this.Height=0;
	this.EventEnable=true;
	this.DurationPolicy=durationPolicyVal;
	this.Duration=durationVal;
	this.Start="00:00:00.00";
	this.RepeatPeriod=repeatPeriodVal;
	this.RepeatEnd="00:01:00.00";
	this.MotionPathPoints="";
	this.Layer=0;
	this.PinnedPointNameList="";
	this.IsVisible=true;
	this.GlobalDisplayPriority=0;
	this.GlobalPlayPolicy=0;
	this.InterpolationType=1;
	this.GlobalElement=false;
	this.AuthorAreaFix=false;
	this.DesignCanvasVisible=true;
}
function CommonEffectPropForElements()
{
	this.EffectInName="";
	this.EffectInDuration="00:00:00.00";
	this.EffectInDirection=0;
	this.EffectInRepeatPolicy=0;
	this.EffectInRepeatPeriod="00:00:00.00";
	this.EffectInRepeatCount=1;
	this.EffectOutName="";
	this.EffectOutDuration="00:00:00.00";
	this.EffectOutDirection=0;
	this.AuthorPreView=true;
}
function CommonWeatherWidProp()
{
	CommonPropForElments.call(this,0,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	this.TypeID=-1;
	this.WeatherType=0;
	this.Country=235;
	this.City=0;
	this.LocationKey="331108";
	this.Language=4;
	this.LanguageCode="en-us";
	this.Background=0;
	this.Opacity=100;
	this.Date=3;
	this.Refresh=2;
	this.Unit=0;
	this.WindowMode=false;	
}
function CommonTextProp()
{
	this.TextStrikeOut=false;
	this.TextBold=false;
	this.TextUnderLine=false;
	this.TextFontSize=24;
	this.TextItalic=false;
	this.TextFontFile="";
	this.TextHAlign=0;
	this.TextVAlign=0;
	this.FillOpacity=0;
	this.FillColor="255;255;255";
	this.TextColor="0;0;0";
	this.TextFontName="SamsungSmart_Latin_Medium";
}
function CommonDataLinkProp()
{
	this.DataLinkUse=false;
	this.DataLinkDisplayOrder=1;
	this.DataLinkDuration="00:00:00.00";
	this.DataLinkSlpit=false;
	this.DataLinkCurrent=true;
	this.DataLinkGroupID=0;
	this.DataLinkSplitGroupID=0;
	this.DataLinkSplitGroupName="";
}
function CommonImgVidProp()
{
	this.IsMutable=false;
	this.IsEditable=false;
	this.FilePath="";
	this.OriginalPath="";
	this.ThumbPath="";
	this.IsNewFile=false;
	this.GlobalIndex=0;
	this.Rotation=0;
	this.OrginalWidth=0;
	this.OriginalHeight=0;
	this.ClipLeft=0;
	this.ClipRight=0;
	this.ClipTop=0;
	this.ClipBottom=0;
	this.Opacity=100;
	this.WindowMode=false;
	this.isLastItem=false;
	this.PlaceHolder="";
	this.frameId="";
}
 function ContentList()
 {
	this.ContentID=-1;
	this.ContentFileID=-1;
	this.ContentFileName="";
	this.PlayerType="EPLAYER";
	this.DisplayWidth=0;
	this.DisplayHeight=0;
	this.DisplayPolicy=2;
	this.BGMusicFilePath="";
	this.BGMusicFileFullPath="";
	this.SelectedAudioVideo="";
	this.AudioMute="";
	this.DataLinkFlag=false;
	this.Page = [];
	this.FileItems = [];
 }
 function FileItem_Array()
 {	
	this.FileID="";
	this.FileHashValue="";
	this.FileItem="";
 }
 function Page_Array()
{
	this.Name="";
	this.Index=-1;
	this.BGColor="255;255;255";
	this.FrameLayout="";
	this.MotionPathPoints="";
	this.BGImageFilePath="";
	this.BGImageOriginalPath="";
	this.NT14_BGImageFilePath="";
	this.IsMutable=false;
	this.BGRatio=1;
	this.OrginalWidth=0;
	this.OriginalHeight=0;
	this.IsVisible=true;
	this.DurationPolicy=0;
	this.Duration="00:01:00.00";
	this.InterpolationType=1;
	this.EventEnable=true;
	this.EffectInName="";
	this.EffectInDuration="00:00:00.00";
	this.EffectInDirection=0;
	this.EffectInRepeatPolicy=0;
	this.EffectInRepeatPeriod="00:00:00.00";
	this.EffectInRepeatCount=1;
	this.LastElementDuration="00:01:00.00";/*Will be used in Page Duration Policy under Duration Policy: Finish in last element time*/
	this.Group = [];	
}
function Group_Array()
{
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	this.Rotation=0;
	this.Image = [];
	this.Video = [];
	this.Sound = [];
	this.Office = [];
	this.Pdf = [];
	this.InputSource = [];
	this.Text = [];
	this.DigitalClock =  [];
	this.AnalogClock =  [];
	this.WeatherHourly = [];
	this.Weather1Day = [];
	this.Weather7Day = [];
	this.RSS = [];	
	this.Sticker = [];
	this.Web = [];
	this.Shapes = [];
	this.MediaRss=[];
	this.GroupMap=[];
}
function Image_Array()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,0,"00:00:10.00","00:01:00.00");
	CommonEffectPropForElements.call(this);
	CommonDataLinkProp.call(this);
	CommonImgVidProp.call(this);
	this.IsRemove=true;
	this.NT14_FilePath="";
	this.CroppedImagePath="";
	this.ModifiedPath="";
    this.ModifiedImageAngle=0;
	this.CropCoordinateX=0;
    this.CropCoordinateY=0;
    this.CropCoordinateX2=0;
    this.CropCoordinateY2=0;
	this.Interval="00:00:10.00";
	this.ButtonMode=0;
	this.ZIndex=0;
	this.EventItemPage="";
	this.scale=0;
	this.ImageRatio=0;
	this.Reflection=0;
	this.ButtonPath1="";
	this.ButtonPath2="";
	this.isGroupMember=false;
}
function Video_Array()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,0,"00:00:10.00","00:01:00.00");
	CommonEffectPropForElements.call(this);
	CommonDataLinkProp.call(this);
	CommonImgVidProp.call(this);
	this.FileName="";
    this.assetInfo="";
	this.MovieMute=false;
	this.MovieVolume=100;
	this.OutputMode="";
	this.OriginalLength="00:00:00.00";
	this.MMS="";
	this.MovieRatio=0;
	this.MovieAfterPlay=0;
	this.Overlay="";
	this.descriptionTextHAlign=0;
	this.ClipStart="00:00:00.00";
	this.ClipEnd="23:59:59.00";
}
function Sound_Array()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,1,"23:59:59.00","23:59:59.00");
	this.FilePath="";
	this.OriginalPath="";
	this.SoundAfterPlay=0;
	this.SoundMute=false;
	this.SoundVolume=100;
	this.OriginalLength="00:00:00.00";
	this.descriptionTextHAlign=0;
	this.ClipStart="00:00:00.00";
	this.ClipEnd="23:59:59.00";
}
function OfficePdf_Array()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,1,"23:59:59.00","23:59:59.00");
	this.FilePath="";
	this.OriginalPath="";
	this.IsEditable=false;
	this.OfficeViewerPath="";
	this.WindowMode=false;
	this.PdfGotoPage = 1;
}
function Inputsource_Array()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,1,"23:59:59.00","23:59:59.00");
	this.IsMutable=false;
	this.IsEditable=false;
	this.InputSourceType=1;
	this.Region="";
	this.MovieMute=false;
	this.Analog_Digital=0;
	this.Channel=0;
	this.Minor_Channel=0;
	this.AirCable=0;
	this.Sound=0;
}
function Text_Array()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	CommonTextProp.call(this);
	CommonDataLinkProp.call(this);
	this.IsRemove=true;
	this.TextXML="";
	this.TextCaption="";
	this.Rotation=0;
	this.TextFile="";
	this.SelectOpacity=0;
	this.Opacity=100;
	this.TextWordWrap=false;
	this.TextDisplayDirection=0;
	this.TextDirection=0;
	this.TextSpeed=0;
	this.TextEffect=0;
	this.WindowMode=false;
	this.TextHTML="";
	this.TextValue="";
	this.Textface="";
	this.Textcharset="";
	this.TextColor="0;0;0";
	this.TextRTF="";
	this.TextImage="";
	this.TextImageFile="";
	this.NT14_TextImage="";
	this.isGroupMember=false;
	this.TextFormat="";
	this.TextFormatCopy="";
} 
function DigitalClock_Array ()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	CommonTextProp.call(this);
	this.TimeFormat=0;
	this.TextDirection=0;
	this.DigitalUseLocale = true;
	this.DigitalClockGMT="";
	this.DigitalClockSeperator="India Standard Time";
	this.DigitalClockDaylight=0;
	this.WindowMode=false;
	this.DisplayLanguage=1;
}
function AnalogClock_Array(){
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	this.TypeID=-1;
	this.ClockType=0;
	this.ClockBackImage="";
	this.AnalogUseLocale = true;
	this.AnalogClockGMT="";
	this.ClockHourImage="";
	this.ClockMinuteImage="";
	this.ClockSecondImage="";
	this.AnalogClockSeperator="India Standard Time";
	this.AnalogClockDaylight=0;
	this.WindowMode=false;
	this.ClockDisplayType=0;
}
function WeatherWid_Array(){
	CommonWeatherWidProp.call(this);
}
function RSS_Array ()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	this.FillColor="255;255;255";
	this.RssReloadDuration=60;
	this.RssServerUrl="";
	this.RssServerWorkTarget="";
	this.RssServerPort=80;
	this.FillOpacity=0;
	this.TextDirection=0;
	this.TextSpeed=0;
	this.Rotation=0;
	this.titleTextFontName="SamsungSmart_Latin_Medium";
	this.titleTextFontFile="";
	this.titleTextFontSize=24;
	this.titleTextItalic=false;
	this.titleTextBold=false;
	this.titleTextUnderLine=false;
	this.titleTextStrikeOut=false;
	this.titleTextColor="0;128;192";
	this.titleTextHAlign=1;
	this.pubDateTextFontName="SamsungSmart_Latin_Medium";
	this.pubDateTextFontFile="";
	this.pubDateTextFontSize=18;
	this.pubDateTextItalic=false;
	this.pubDateTextBold=false;
	this.pubDateTextUnderLine=false;
	this.pubDateTextStrikeOut=false;
	this.pubDateTextColor="128;128;128";
	this.pubDateTextHAlign=2;
	this.descriptionTextFontName="SamsungSmart_Latin_Medium";
	this.descriptionTextFontFile="";
	this.descriptionTextFontSize=20;
	this.descriptionTextItalic=false;
	this.descriptionTextBold=false;
	this.descriptionTextUnderLine=false;
	this.descriptionTextStrikeOut=false;
	this.descriptionTextColor="0;0;0";
	this.descriptionTextHAlign=0;
	this.WindowMode=false;
	this.NewsDisplayOption=3;
	this.RSS_URL="";
	this.DISPLAY_CYCLE=0;
}
function Sticker_Array()
{
	CommonPropForElments.call(this,1,"23:59:59.00","23:59:59.00");
	CommonEffectPropForElements.call(this);
	this.OriginalPath="";
	this.ConfigName="";
	this.EndStateXML="";
	this.EndStateBitmap="";	
	this.Rotation=0;
}
function Web_Array ()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	this.WebURL="";
	this.WebAuthorizationID="";
	this.FilePath="";
	this.WebOutputMode=0;
	this.WebRefresh=1;
	this.WebRefreshNew="00:01:00.00";
	this.WebInputEnable=false;
	this.WebScrollShow=false;
	this.WebVScrollPos=0;
	this.WebHScrollPos=0;
	this.WebAuthorizationPassWd="";
	this.WindowMode=false;
	this.IsEditable=false;
}
function MediaRss_Array ()
{
	CommonTypeNId.call(this);
	CommonPropForElments.call(this,3,"23:59:59.00","23:59:59.00");
	this.MrssURL="";
	this.MrssDuration="00:00:05.00";
	this.WindowMode=false;
	this.IsEditable=false;
	this.AspectFill = 0;
}
function findValueOfKeyInXml(xmlObj,key)
 {
	var keyValue = Utils.getCdataKeyFrameValue(xmlObj.find(key));
	return keyValue == ""?0:keyValue;
 }
function addCommonPropertiesToContObjFrmLfd(contentElmObj,LfdObj,addAdditionPropSet1OfEffects)
{
	contentElmObj.Name = Utils.getCdataKeyFrameValue(LfdObj.find('Name'));	
	contentElmObj.PositionX = getParseIntInDec(Utils.getCdataKeyFrameValue(LfdObj.find('PositionX')),10);
	contentElmObj.PositionY = getParseIntInDec(Utils.getCdataKeyFrameValue(LfdObj.find('PositionY')),10);
	contentElmObj.Width = getParseIntInDec(Utils.getCdataKeyFrameValue(LfdObj.find('Width')),10);	
	contentElmObj.Height = getParseIntInDec(Utils.getCdataKeyFrameValue(LfdObj.find('Height')),10);
	contentElmObj.EventEnable = Utils.getCdataKeyFrameValue(LfdObj.find('EventEnable'));
	contentElmObj.Duration = Utils.getCdataKeyFrameValue(LfdObj.find('Duration'));
	contentElmObj.DurationPolicy = Utils.getCdataKeyFrameValue(LfdObj.find('DurationPolicy'));	
	contentElmObj.Start = Utils.getCdataKeyFrameValue(LfdObj.find('Start'));	
	contentElmObj.RepeatPeriod = Utils.getCdataKeyFrameValue(LfdObj.find('RepeatPeriod'));	
	contentElmObj.RepeatEnd = Utils.getCdataKeyFrameValue(LfdObj.find('RepeatEnd'));	
	contentElmObj.MotionPathPoints = Utils.getCdataKeyFrameValue(LfdObj.find('MotionPathPoints'));	
	contentElmObj.Layer = Utils.getCdataKeyFrameValue(LfdObj.find('Layer'));	
	contentElmObj.PinnedPointNameList = Utils.getCdataKeyFrameValue(LfdObj.find('PinnedPointNameList'));	
	contentElmObj.IsVisible = Utils.getCdataKeyFrameValue(LfdObj.find('IsVisible'));	
	contentElmObj.GlobalDisplayPriority = Utils.getCdataKeyFrameValue(LfdObj.find('GlobalDisplayPriority'));	
	contentElmObj.GlobalPlayPolicy = Utils.getCdataKeyFrameValue(LfdObj.find('GlobalPlayPolicy'));	
	contentElmObj.InterpolationType = Utils.getCdataKeyFrameValue(LfdObj.find('InterpolationType'));	
	contentElmObj.GlobalElement = Utils.getCdataKeyFrameValue(LfdObj.find('GlobalElement'));
	contentElmObj.AuthorAreaFix = Utils.getCdataKeyFrameValue(LfdObj.find('AuthorAreaFix'));	
	contentElmObj.DesignCanvasVisible = Utils.getCdataKeyFrameValue(LfdObj.find('DesignCanvasVisible'));	
	if(addAdditionPropSet1OfEffects)
	{
		contentElmObj.EffectInName = Utils.getCdataKeyFrameValue(LfdObj.find('EffectInName'));	
		contentElmObj.EffectInDuration = Utils.getCdataKeyFrameValue(LfdObj.find('EffectInDuration'));	
		contentElmObj.EffectInDirection = Utils.getCdataKeyFrameValue(LfdObj.find('EffectInDirection'));
		contentElmObj.EffectInRepeatPolicy = Utils.getCdataKeyFrameValue(LfdObj.find('EffectInRepeatPolicy'));	
		contentElmObj.EffectInRepeatPeriod = Utils.getCdataKeyFrameValue(LfdObj.find('EffectInRepeatPeriod'));	
		contentElmObj.EffectInRepeatCount = Utils.getCdataKeyFrameValue(LfdObj.find('EffectInRepeatCount'));	
		contentElmObj.EffectOutName = Utils.getCdataKeyFrameValue(LfdObj.find('EffectOutName'));	
		contentElmObj.EffectOutDuration = Utils.getCdataKeyFrameValue(LfdObj.find('EffectOutDuration'));
		contentElmObj.EffectOutDirection = Utils.getCdataKeyFrameValue(LfdObj.find('EffectOutDirection'));	
		contentElmObj.AuthorPreView = Utils.getCdataKeyFrameValue(LfdObj.find('AuthorPreView'));
	}
}
function addCommonPropOfText(contTxtbj,contentElmObj)
{
	contTxtbj.TextStrikeOut = Utils.getCdataKeyFrameValue(contentElmObj.find('TextStrikeOut'));
	contTxtbj.TextBold = Utils.getCdataKeyFrameValue(contentElmObj.find('TextBold'));
	contTxtbj.TextUnderLine = Utils.getCdataKeyFrameValue(contentElmObj.find('TextUnderLine'));
	contTxtbj.TextFontSize = Utils.getCdataKeyFrameValue(contentElmObj.find('TextFontSize'));
	contTxtbj.TextItalic = Utils.getCdataKeyFrameValue(contentElmObj.find('TextItalic'));
	contTxtbj.TextFontFile = Utils.getCdataKeyFrameValue(contentElmObj.find('TextFontFile'));
	contTxtbj.TextHAlign = Utils.getCdataKeyFrameValue(contentElmObj.find('TextHAlign'));
	contTxtbj.TextVAlign = Utils.getCdataKeyFrameValue(contentElmObj.find('TextVAlign'));
	contTxtbj.FillOpacity = Utils.getCdataKeyFrameValue(contentElmObj.find('FillOpacity'));
	contTxtbj.FillColor = Utils.getCdataKeyFrameValue(contentElmObj.find('FillColor'));
	contTxtbj.TextColor = Utils.getCdataKeyFrameValue(contentElmObj.find('TextColor'));
	contTxtbj.TextFontName = Utils.getCdataKeyFrameValue(contentElmObj.find('TextFontName'));
}
function addCommonImgVidPropFrmLfdToCont (ContntObj,contentLfdElmObj)
{
	ContntObj.IsMutable = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('IsMutable'));	
	ContntObj.IsEditable = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('IsEditable'));
	ContntObj.FilePath = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('FilePath'));
	ContntObj.OriginalPath = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('OriginalPath'));
	ContntObj.ThumbPath = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('ThumbPath'));
	ContntObj.IsNewFile="False";
	ContntObj.Rotation = parseInt(Utils.getCdataKeyFrameValue(contentLfdElmObj.find('Rotation')),10);
	ContntObj.OrginalWidth = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('OrginalWidth'));
	ContntObj.OriginalHeight = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('OriginalHeight'));
	ContntObj.ClipLeft = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('ClipLeft'));
	ContntObj.ClipRight = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('ClipRight'));
	ContntObj.ClipTop = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('ClipTop'));
	ContntObj.ClipBottom = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('ClipBottom'));
	ContntObj.Opacity = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('Opacity'));
	ContntObj.WindowMode = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('WindowMode'));
	ContntObj.frameId = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('frameId'));
}
function addCommonDataLinkPropfrmLfdToCont (ContntObj,contentLfdElmObj)
{
	ContntObj.DataLinkUse = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkUse'));
	ContntObj.DataLinkDisplayOrder = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkDisplayOrder'));
	ContntObj.DataLinkDuration = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkDuration'));
	ContntObj.DataLinkSlpit = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkSlpit'));
	ContntObj.DataLinkCurrent = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkCurrent'));
	ContntObj.DataLinkGroupID = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkGroupID'));
	ContntObj.DataLinkSplitGroupID = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkSplitGroupID'));
	ContntObj.DataLinkSplitGroupName = Utils.getCdataKeyFrameValue(contentLfdElmObj.find('DataLinkSplitGroupName'));
}
  var Content = {};var ContentObj;var groupIndex;
 Content.init = function(textOfLFDFile)
 {
 	printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","LFD Parsing");
 		ContentObj = new ContentList();
		groupIndex = -1;
		if(textOfLFDFile!="" && textOfLFDFile!=null && textOfLFDFile!=undefined)
		{
			textOfLFDFile = textOfLFDFile.replace(/<\/font>/g,"</p></font>");			
		}
		textOfLFDFile = $.parseXML(textOfLFDFile);
		var textOfLFDFileObj = $(textOfLFDFile);
		var locContentID = textOfLFDFileObj.find('FileID').parent().attr('id');
		ContentObj.DataLinkFlag =  textOfLFDFileObj.find('FileID').parent().attr('datalinkTemplate');
		ContentObj.ContentID = locContentID;
		if(textOfLFDFileObj.find('PlayerType') == null){
			ContentObj.PlayerType = "SPLAYER";
		}		
		ContentObj.PlayerType = textOfLFDFileObj.find('PlayerType').text();
		ContentObj.ContentFileID = textOfLFDFileObj.find('FileID').text();
		ContentObj.ContentFileName = Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('Name'));
		ContentObj.DisplayWidth = getParseIntInDec(Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('DisplayWidth')),10); 
		ContentObj.DisplayHeight = getParseIntInDec(Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('DisplayHeight')),10);
		ContentObj.DisplayPolicy = Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('DisplayPolicy'));
		ContentObj.BGMusicFilePath = Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('BGMusicFilePath'));
		ContentObj.BGMusicFileFullPath = Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('BGMusicFileFullPath'));
		ContentObj.SelectedAudioVideo = Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('SelectedAudioVideo'));			
		ContentObj.AudioMute = Utils.getCdataKeyFrameValue(textOfLFDFileObj.find('AudioMute'));	
		/*Get PAGE node values from xml 
		/Also we will start from page number 1(not 0 as this will be used for global settings for all pages)*/
		var Pages = textOfLFDFileObj.find('Page');
		var pageLength = Pages.length;
		var textLines,txtArrLen,finalTextStr;
		var contPageObj;var pageCount;
		for(pageCount = 0; pageCount<pageLength; pageCount++)
		{	
			var PageCountXmlObj = $(Pages[pageCount]);
			if(PageCountXmlObj.attr('index') != undefined)
			{
				var pageArr = new Page_Array();
				ContentObj.Page.push(pageArr);
				var pageIndex = ContentObj.Page.length - 1;   
				contPageObj = ContentObj.Page[pageIndex];
				contPageObj.Name = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('Name')[0]);
				contPageObj.BGColor = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('BGColor')[0]);
				contPageObj.FrameLayout = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('FrameLayout')[0]);				
				contPageObj.BGImageFilePath = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('BGImageFilePath')[0]);
				contPageObj.BGImageOriginalPath = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('BGImageOriginalPath')[0]);
				contPageObj.NT14_BGImageFilePath = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('NT14_BGImageFilePath')[0]);				
                /* specific to condition when user updates existing iOS app*/
                if(isIOS())
                {
                   contPageObj.BGImageFilePath = Utils.getUpdatedFilePath(contPageObj.BGImageFilePath);
                   contPageObj.BGImageOriginalPath = Utils.getUpdatedFilePath(contPageObj.BGImageOriginalPath);
                   contPageObj.NT14_BGImageFilePath = Utils.getUpdatedFilePath(contPageObj.NT14_BGImageFilePath);
                }
				contPageObj.IsMutable = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('IsMutable')[0]);							
				contPageObj.BGRatio = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('BGRatio')[0]);							
				contPageObj.OrginalWidth = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('OrginalWidth')[0]);
				contPageObj.OrginalHeight = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('OrginalHeight')[0]);
				contPageObj.IsVisible = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('IsVisible')[0]);
				contPageObj.DurationPolicy = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('DurationPolicy')[0]);
				contPageObj.Duration = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('Duration')[0]);
				contPageObj.EventEnable = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EventEnable')[0]);
				contPageObj.EffectInName = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EffectInName')[0]);
				contPageObj.EffectInDuration = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EffectInDuration')[0]);
				contPageObj.EffectInDirection = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EffectInDirection')[0]);
        		contPageObj.EffectInRepeatPolicy = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EffectInRepeatPolicy')[0]);
        		contPageObj.EffectInRepeatPeriod = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EffectInRepeatPeriod')[0]);
				contPageObj.EffectInRepeatCount = Utils.getCdataKeyFrameValue(PageCountXmlObj.find('EffectInRepeatCount')[0]);
				var contentGroups = PageCountXmlObj.find('Group');
				var groupCount;							
				for(groupCount=0; groupCount<contentGroups.length; groupCount++)
				{		
					var groupArr = new Group_Array();
					contPageObj.Group.push(groupArr);groupIndex++;
					var contGrpObj = contPageObj.Group[groupIndex];
					var groupContentXmlObj = $(contentGroups[groupCount]);
					contGrpObj.Name = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Name'));	
					contGrpObj.MotionPathPoints = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('MotionPathPoints'));							
					contGrpObj.Layer = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Layer'));
					contGrpObj.PinnedPointNameList = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('PinnedPointNameList'));
					contGrpObj.GlobalElement = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('GlobalElement'));
					contGrpObj.PositionX = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('PositionX'));
					contGrpObj.PositionY = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('PositionY'));
					contGrpObj.Width = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Width'));
					contGrpObj.Height = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Height'));
					contGrpObj.IsVisible = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('IsVisible'));							
					contGrpObj.Rotation = parseInt(Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Rotation')),10);
					contGrpObj.GlobalDisplayPriority = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('GlobalDisplayPriority'));
					contGrpObj.GlobalPlayPolicy = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('GlobalPlayPolicy'));
					contGrpObj.DurationPolicy =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('DurationPolicy'));
					contGrpObj.Start =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Start'));
					contGrpObj.Duration =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Duration'));
					contGrpObj.RepeatPeriod =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('RepeatPeriod'));
					contGrpObj.RepeatEnd =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('RepeatEnd'));
					contGrpObj.InterpolationType = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('InterpolationType'));
					contGrpObj.EventEnable = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EventEnable'));
					contGrpObj.EffectInName =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectInName'));
					contGrpObj.EffectInDuration = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectInDuration'));
					contGrpObj.EffectInDirection = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectInDirection'));
					contGrpObj.EffectInRepeatPeriod = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectInRepeatPeriod'));
					contGrpObj.EffectInRepeatCount = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectInRepeatCount'));
					contGrpObj.EffectInRepeatPolicy = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectInRepeatPolicy'));
					contGrpObj.EffectOutName =  Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectOutName'));
					contGrpObj.EffectOutDuration = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectOutDuration'));
					contGrpObj.EffectOutDirection = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('EffectOutDirection'));
					contGrpObj.AuthorAreaFix = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('AuthorAreaFix'));
					contGrpObj.AuthorPreView = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('AuthorPreView'));
					contGrpObj.DesignCanvasVisible = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('DesignCanvasVisible'));
					var isMenuBoardGrp = Utils.getCdataKeyFrameValue(groupContentXmlObj.children('Name'));
					addElementToGroup(groupContentXmlObj.find('Element'),pageIndex,true,(isMenuBoardGrp.substring(0,5) != "GMenu"));	
				}	
				if(pageCount==1){
					addElementToGroup(PageCountXmlObj.children('Element'),pageIndex,false,false);
				}
			}
		}
		var FileItems = textOfLFDFileObj.find('FileItem');
		var fileItemLength = FileItems.length;
		var fileItemObj ;
		if(fileItemLength>0)
		{
			var fileItemCount;
			for(fileItemCount=0;fileItemCount<fileItemLength;fileItemCount++)
			{
				var fileItemArr = new FileItem_Array();
				ContentObj.FileItems.push(fileItemArr);
				fileItemObj = $(FileItems[fileItemCount]);
				ContentObj.FileItems[fileItemCount].FileID = fileItemObj.attr('FileID')==undefined?'':fileItemObj.attr('FileID');
				ContentObj.FileItems[fileItemCount].FileHashValue = fileItemObj.attr('FileHashValue')==undefined?'':fileItemObj.attr('FileHashValue');
				var cdataText_name = fileItemObj.html();
				var pattern = /<!\-\-\[CDATA\[(.*)\]\]\-\->/;
				if(pattern.exec(cdataText_name))
				{
					var resultPattern = pattern.exec(cdataText_name);
					var fileItemName = resultPattern[1];
				}
				else
				{
					var fileItemName = fileItemObj.text();
				 }
				var filename = fileItemName.replace(/^.*[\\\/]/, '');
				ContentObj.FileItems[fileItemCount].FileItem = filename;
			}
		}
		printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","LFD Parsing");
		return ContentObj;
 };
function addElementToGroup(contentElements,pageIndex,groupFlag,ElmGrpMapFlag){	
	log.debug("FunctionIn: addElementToGroup");
	var elemLength = contentElements.length;	
	var contentGrpObj;	
	var ContentPageGrpObj = ContentObj.Page[pageIndex].Group;
	var elemCount;
	var selectedContntObj; 
	for(elemCount=0; elemCount<elemLength; elemCount++)
	{ 	
		selectedContntObj =$(contentElements[elemCount]);
		if(!groupFlag || ElmGrpMapFlag){
			var groupArr = new Group_Array();
			if(!groupFlag)
			{
				ContentPageGrpObj.push(groupArr);++groupIndex;
				contentGrpObj = ContentPageGrpObj[groupIndex];
			}
			else if(ElmGrpMapFlag)
			{
				ContentPageGrpObj[groupIndex].GroupMap.push(groupArr);
				contentGrpObj = ContentPageGrpObj[groupIndex].GroupMap[elemCount];
			}
			contentGrpObj.PositionX = Utils.getCdataKeyFrameValue(selectedContntObj.find('PositionX'));
			contentGrpObj.PositionY = Utils.getCdataKeyFrameValue(selectedContntObj.find('PositionY'));
			contentGrpObj.Width = Utils.getCdataKeyFrameValue(selectedContntObj.find('Width'));
			contentGrpObj.Height = Utils.getCdataKeyFrameValue(selectedContntObj.find('Height'));
		}
		else if(!ElmGrpMapFlag)
		{
			contentGrpObj = ContentObj.Page[pageIndex].Group[groupIndex];
		}
		var zIndex = 0;
		if(elemCount==elemLength-1)
		{
			ContentObj.Page[pageIndex].LastElementDuration = selectedContntObj.find('Duration');
		}
		var elementType = selectedContntObj.attr('type');
		var shapeType;
		if(elementType.substr(0,7)=="Figure ")
		{
			shapeType = elementType;
			elementType  = 'SHAPE';
		}
		switch(elementType)
		{							
			case 'Image':
				var imageArr = new Image_Array();
				contentGrpObj.Image.push(imageArr);
				if(groupFlag==false || ElmGrpMapFlag){
					imageArr.isGroupMember = false;
				}else{
					imageArr.isGroupMember = true;
				}	
				Content.addImageToGroup(imageArr,selectedContntObj,zIndex);
				if(selectedContntObj.find('EventItem').length > 0)
				{
					var cntevenitem;
					for(cntevenitem = 0; cntevenitem < selectedContntObj.find('EventItem').length ; cntevenitem++)
					{
						var funtype = selectedContntObj.find('EventItem').attr('type');
						if(funtype == 'AM_EVT_KEY_DOWN')
						{
							var funname = selectedContntObj.find('EventItem').attr('functionName');
							imageArr.EventItemPage = Content.EventItem(funname,textOfLFDFile);
							break;
						}
						else
						{
							imageArr.EventItemPage = -1;
						}
					}
				}
				else
				{
					imageArr.EventItemPage = -1;
				}
				zIndex++;
				break;
			case 'Video':
				var videoArr = new Video_Array();
				contentGrpObj.Video.push(videoArr);
				Content.addVideoToGroup(videoArr,selectedContntObj);				
				break;
			case 'Sound':
				var soundArr = new Sound_Array();
				contentGrpObj.Sound.push(soundArr);				
				Content.addSoundToGroup(soundArr,selectedContntObj);
				break;
			case 'Text':
				var textArr = new Text_Array();
				contentGrpObj.Text.push(textArr);
				Content.addTxtToGroup(textArr,selectedContntObj);				
				if(groupFlag==false || ElmGrpMapFlag){
					textArr.isGroupMember = false;
				}else{
					textArr.isGroupMember = true;
				}
				zIndex++;
				break;
			case 'Digital Clock':		
				var digitalClockArr = new DigitalClock_Array();				
				contentGrpObj.DigitalClock.push(digitalClockArr);				
				Content.addDigClkToGroup(digitalClockArr,selectedContntObj);	
				break;
			case 'Analog Clock':
				var analogClockArr = new AnalogClock_Array();
				contentGrpObj.AnalogClock.push(analogClockArr);
				Content.addAnalogClkToGroup(analogClockArr,selectedContntObj);
				break;
			case 'Hourly':
				var weatherHourlyArr = new WeatherWid_Array();
				contentGrpObj.WeatherHourly.push(weatherHourlyArr);
				Content.addWeatherWidToGroup(weatherHourlyArr,selectedContntObj);	
				break;	
			case '1Day':
				var weather1DayArr = new WeatherWid_Array();
				contentGrpObj.Weather1Day.push(weather1DayArr);
				Content.addWeatherWidToGroup(weather1DayArr,selectedContntObj);
				break;	
			case '7Day':
				var weather7DayArr = new WeatherWid_Array();
				contentGrpObj.Weather7Day.push(weather7DayArr);
				Content.addWeatherWidToGroup(weather7DayArr,selectedContntObj);
				break;			
			case 'RSS':
				var rssArr = new RSS_Array();
				contentGrpObj.RSS.push(rssArr);					
				Content.addRssToGroup(rssArr,selectedContntObj);
				break;
			case 'Office':			
				var officeArr = new OfficePdf_Array();
				contentGrpObj.Office.push(officeArr);
				Content.addOfficePdfToGroup(officeArr,selectedContntObj);
				break;
			case 'Pdf':			
				var pdfArr = new OfficePdf_Array();
				contentGrpObj.Pdf.push(pdfArr);
				Content.addOfficePdfToGroup(pdfArr,selectedContntObj);
				break;
			case 'InputSource':			
				var inputSourceArr = new Inputsource_Array();
				contentGrpObj.InputSource.push(inputSourceArr);					
				Content.addInputSourceToGroup(inputSourceArr,selectedContntObj);
				break;
			case 'Web':
				var WebArr = new Web_Array();
				contentGrpObj.Web.push(WebArr);
				Content.addWebToGroup(WebArr,selectedContntObj);				
				break;
			case 'Media RSS':
				var MediaRssArr = new MediaRss_Array();
				contentGrpObj.MediaRss.push(MediaRssArr);
				Content.addMediaRssToGroup(MediaRssArr,selectedContntObj);				
				break;
			case 'SHAPE':
				var shapeArr = new Shapes_Array();
				var elmntName =getParseIntInDec(selectedContntObj.find('elementName').find("keyframe ").html());
				var type = getShapeTypeOfSameCategory(shapeType,elmntName);
				addSpecificParaToShape(shapeArr,type);
				contentGrpObj.Shapes.push(shapeArr);
				shapeArr.typeName = shapeType;
				Content.addShapesToGroup(type,shapeArr,selectedContntObj);				
			break;
			default:
				if(elementType.indexOf("sticker") >-1){
					var stickertArr = new Sticker_Array();
					contentGrpObj.Sticker.push(stickertArr);
					Content.addStickerToGroup(stickertArr,selectedContntObj);	
				}
				break;
		}
	}
	log.debug("FunctionOut: addElementToGroup");
 }
 
 Content.addImageToGroup = function(contImgObj,contentElmObj, zIndex){
 		addCommonPropertiesToContObjFrmLfd(contImgObj,contentElmObj,true);
		addCommonDataLinkPropfrmLfdToCont (contImgObj,contentElmObj);
		addCommonImgVidPropFrmLfdToCont (contImgObj,contentElmObj);
		contImgObj.ModifiedPath = Utils.getCdataKeyFrameValue(contentElmObj.find('ModifiedPath'));
        /* specific to condition when user updates existing iOS app*/
        if(isIOS())
        {
          contImgObj.OriginalPath = Utils.getUpdatedFilePath(contImgObj.OriginalPath);
          contImgObj.ThumbPath = Utils.getUpdatedFilePath(contImgObj.ThumbPath);
          contImgObj.ModifiedPath = Utils.getUpdatedFilePath(contImgObj.ModifiedPath);
        }
     	contImgObj.ModifiedImageAngle = findValueOfKeyInXml(contentElmObj,'ModifiedImageAngle');
     	contImgObj.CropCoordinateX = findValueOfKeyInXml(contentElmObj,'CropCoordinateX');
     	contImgObj.CropCoordinateY = findValueOfKeyInXml(contentElmObj,'CropCoordinateY');
     	contImgObj.CropCoordinateX2 = findValueOfKeyInXml(contentElmObj,'CropCoordinateX2');
     	contImgObj.CropCoordinateY2 = findValueOfKeyInXml(contentElmObj,'CropCoordinateY2');
     	contImgObj.NT14_FilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('NT14_FilePath'));
		contImgObj.CroppedImagePath = Utils.getCdataKeyFrameValue(contentElmObj.find('CroppedImagePath'));
		        /* specific to condition when user updates existing iOS app*/
                if(isIOS())
                {
                  contImgObj.FilePath = Utils.getUpdatedFilePath(contImgObj.FilePath);
                  contImgObj.NT14_FilePath = Utils.getUpdatedFilePath(contImgObj.NT14_FilePath);
                  contImgObj.CroppedImagePath = Utils.getUpdatedFilePath(contImgObj.CroppedImagePath);
                }
     	contImgObj.IsRemove = Utils.getCdataKeyFrameValue(contentElmObj.find('IsRemove'));	
		contImgObj.Type = contentElmObj.attr('type');
		contImgObj.TypeID = contentElmObj.attr('typeid');
		contImgObj.Interval =  Utils.getCdataKeyFrameValue(contentElmObj.find('Interval'));
		contImgObj.ButtonMode =  Utils.getCdataKeyFrameValue(contentElmObj.find('ButtonMode'));
		contImgObj.ZIndex =  zIndex;
		contImgObj.scale = Utils.getCdataKeyFrameValue(contentElmObj.find('scale'));
		contImgObj.ImageRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('ImageRatio'));
		contImgObj.Reflection = Utils.getCdataKeyFrameValue(contentElmObj.find('Reflection'));
		contImgObj.ButtonPath1 = Utils.getCdataKeyFrameValue(contentElmObj.find('ButtonPath1'));
		contImgObj.ButtonPath2 = Utils.getCdataKeyFrameValue(contentElmObj.find('ButtonPath2'));
};
 
 Content.addVideoToGroup = function(contVidObj,contentElmObj){
 		addCommonPropertiesToContObjFrmLfd(contVidObj,contentElmObj,true);
		addCommonDataLinkPropfrmLfdToCont (contVidObj,contentElmObj);
		addCommonImgVidPropFrmLfdToCont (contVidObj,contentElmObj);
		contVidObj.FileName = Utils.getCdataKeyFrameValue(contentElmObj.find('FileName'));
		/* specific to condition when user updates existing iOS app*/
        if(isIOS())
        {
          contVidObj.FileName = Utils.getUpdatedFilePath(contVidObj.FileName);
          contVidObj.OriginalPath = Utils.getUpdatedFilePath(contVidObj.OriginalPath);
          contVidObj.ThumbPath = Utils.getUpdatedFilePath(contVidObj.ThumbPath);
        }
        contVidObj.assetInfo="";        
		contVidObj.Type = contentElmObj.attr('type');
		contVidObj.TypeID = contentElmObj.attr('typeid');
		contVidObj.MovieMute = Utils.getCdataKeyFrameValue(contentElmObj.find('MovieMute'));
		contVidObj.MovieVolume = Utils.getCdataKeyFrameValue(contentElmObj.find('MovieVolume'));
		contVidObj.OutputMode = Utils.getCdataKeyFrameValue(contentElmObj.find('OutputMode'));
		contVidObj.OriginalLength = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalLength'));
		contVidObj.MMS = Utils.getCdataKeyFrameValue(contentElmObj.find('MMS'));
		contVidObj.MovieRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('MovieRatio'));
		contVidObj.MovieAfterPlay = Utils.getCdataKeyFrameValue(contentElmObj.find('MovieAfterPlay'));
		contVidObj.Overlay = Utils.getCdataKeyFrameValue(contentElmObj.find('Overlay'));
		contVidObj.ClipStart = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipStart'));
		contVidObj.ClipEnd = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipEnd'));
};
Content.addSoundToGroup = function(contSoundObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contSoundObj,contentElmObj,false);
		contSoundObj.FilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('FilePath'));
		contSoundObj.OriginalPath = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalPath'));				
		contSoundObj.Type = contentElmObj.attr('type');
		contSoundObj.TypeID = contentElmObj.attr('typeid');
		contSoundObj.SoundAfterPlay = Utils.getCdataKeyFrameValue(contentElmObj.find('SoundAfterPlay'));
		contSoundObj.SoundMute = Utils.getCdataKeyFrameValue(contentElmObj.find('SoundMute'));
		contSoundObj.SoundVolume = Utils.getCdataKeyFrameValue(contentElmObj.find('SoundVolume'));
		contSoundObj.OriginalLength = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalLength'));
		contSoundObj.ClipStart = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipStart'));
		contSoundObj.ClipEnd = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipEnd'));
};
Content.addTxtToGroup = function(contTxtbj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contTxtbj,contentElmObj,true);
		addCommonPropOfText(contTxtbj,contentElmObj);
		addCommonDataLinkPropfrmLfdToCont (contTxtbj,contentElmObj);
		contTxtbj.Type = 'Text';
		contTxtbj.TypeID = contentElmObj.attr('typeid');
		contTxtbj.IsRemove = Utils.getCdataKeyFrameValue(contentElmObj.find('IsRemove'));	
		contTxtbj.TextXML = Utils.getCdataKeyFrameValue(contentElmObj.find('TextXML'));
		contTxtbj.TextCaption = Utils.getCdataKeyFrameValue(contentElmObj.find('TextCaption'));
		contTxtbj.Rotation = parseInt(Utils.getCdataKeyFrameValue(contentElmObj.find('Rotation')),10);
		contTxtbj.TextFile = Utils.getCdataKeyFrameValue(contentElmObj.find('TextFile'));
		contTxtbj.SelectOpacity = Utils.getCdataKeyFrameValue(contentElmObj.find('SelectOpacity'));
		contTxtbj.Opacity = Utils.getCdataKeyFrameValue(contentElmObj.find('Opacity'));
		contTxtbj.TextWordWrap = Utils.getCdataKeyFrameValue(contentElmObj.find('TextWordWrap'));
		contTxtbj.TextDisplayDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('TextDisplayDirection'));
		contTxtbj.TextDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('TextDirection'));
		contTxtbj.TextSpeed = Utils.getCdataKeyFrameValue(contentElmObj.find('TextSpeed'));
		contTxtbj.TextEffect = Utils.getCdataKeyFrameValue(contentElmObj.find('TextEffect'));
		contTxtbj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		if(Utils.isHighEndModel(globlePlayerType))
		{
			contTxtbj.TextFormatCopy = contTxtbj.TextFormat = Utils.getCdataKeyFrameValue(contentElmObj.find('TextFormatCopy'));
	        contTxtbj.TextFormat = ((contTxtbj.TextFormat).replace(/&lt;/g,"<")).replace(/&gt;/g,">");
       	}
        var tempText = contentElmObj.find('TextHTML').children('keyFrame').text();
        var finalText="";
		tempText = $(tempText.trim());
        tempText.find('p').each(function(){
        	finalText=finalText+$(this).html()+"<br>";
        });
        finalText=finalText.replace(/<br>$/,"");
        textLines=finalText.split("<br>");
		txtArrLen=textLines.length;
		finalTextStr='';
        var textFace= tempText.attr('face');
        var textFontSize=tempText.attr('size');
        var charSet= tempText.attr('charset');
        var fontColor=tempText.attr('color');
        var fontAlignment=tempText.find('p').attr('align');
        if(fontColor==undefined || fontColor.length==0)
        {                            	
        	fontColor="#000000";
        }                                             
        contTxtbj.TextValue = finalText;
		contTxtbj.Textcharset = charSet;
		contTxtbj.Textface = textFace;
		contTxtbj.TextColor = Utils.getCdataKeyFrameValue(contentElmObj.find('TextColor'));				  
		var i;
		for(i=0;i<txtArrLen;i++)
		{
			finalTextStr+='<p align="'+fontAlignment+'">'+textLines[i];				
		}	
		contTxtbj.TextHTML = '<font face="'+textFace+'" color="'+fontColor+'" size="'+textFontSize+'" >'+finalTextStr+'</font>';
		contTxtbj.TextImage  = Utils.getCdataKeyFrameValue(contentElmObj.find('TextImage'));
		contTxtbj.NT14_TextImage = Utils.getCdataKeyFrameValue(contentElmObj.find('NT14_TextImage'));
		contTxtbj.TextImageFile  = Utils.getCdataKeyFrameValue(contentElmObj.find('TextImageFile'));
		        /* specific to condition when user updates existing iOS app*/
                if(isIOS())
                {
                  contTxtbj.TextFile = Utils.getUpdatedFilePath(contTxtbj.TextFile);
                  contTxtbj.TextFontName = Utils.getUpdatedFilePath(contTxtbj.TextFontName);
                  contTxtbj.TextFontFile = Utils.getUpdatedFilePath(contTxtbj.TextFontFile);
                  contTxtbj.TextImage = Utils.getUpdatedFilePath(contTxtbj.TextImage);
                  contTxtbj.NT14_TextImage = Utils.getUpdatedFilePath(contTxtbj.NT14_TextImage);
                  contTxtbj.TextImageFile = Utils.getUpdatedFilePath(contTxtbj.TextImageFile);
               }
};
Content.addDigClkToGroup = function(contDigClkbj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contDigClkbj,contentElmObj,true);	
		addCommonPropOfText(contDigClkbj,contentElmObj);							
		contDigClkbj.TimeFormat = Utils.getCdataKeyFrameValue(contentElmObj.find('TimeFormat'));			
		contDigClkbj.TypeID = contentElmObj.attr('typeid');
		contDigClkbj.Rotation = parseInt(Utils.getCdataKeyFrameValue(contentElmObj.find('Rotation')),10);
		contDigClkbj.Opacity = Utils.getCdataKeyFrameValue(contentElmObj.find('Opacity'));
		contDigClkbj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		contDigClkbj.DigitalUseLocale = Utils.getCdataKeyFrameValue(contentElmObj.find('DigitalUseLocale'));
		contDigClkbj.DigitalClockGMT = Utils.getCdataKeyFrameValue(contentElmObj.find('DigitalClockGMT'));
		contDigClkbj.TextDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('TextDirection'));
		contDigClkbj.DigitalClockSeperator = Utils.getCdataKeyFrameValue(contentElmObj.find('DigitalClockSeperator'));
		contDigClkbj.DigitalClockDaylight = Utils.getCdataKeyFrameValue(contentElmObj.find('DigitalClockDaylight'));
		contDigClkbj.DisplayLanguage=Utils.getCdataKeyFrameValue(contentElmObj.find('DisplayLanguage'));
};
Content.addAnalogClkToGroup = function(contAnalogClkbj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contAnalogClkbj,contentElmObj,true);
		contAnalogClkbj.TypeID = contentElmObj.attr('typeid');
		contAnalogClkbj.ClockType = Utils.getCdataKeyFrameValue(contentElmObj.find('ClockType'));
		contAnalogClkbj.ClockBackImage = Utils.getCdataKeyFrameValue(contentElmObj.find('ClockBackImage'));
		contAnalogClkbj.AnalogClockGMT = Utils.getCdataKeyFrameValue(contentElmObj.find('AnalogClockGMT'));
		contAnalogClkbj.AnalogUseLocale = Utils.getCdataKeyFrameValue(contentElmObj.find('AnalogUseLocale'));
		contAnalogClkbj.ClockHourImage = Utils.getCdataKeyFrameValue(contentElmObj.find('ClockHourImage'));
		contAnalogClkbj.ClockMinuteImage = Utils.getCdataKeyFrameValue(contentElmObj.find('ClockMinuteImage'));
		contAnalogClkbj.ClockSecondImage = Utils.getCdataKeyFrameValue(contentElmObj.find('ClockSecondImage'));
		contAnalogClkbj.AnalogClockSeperator = Utils.getCdataKeyFrameValue(contentElmObj.find('AnalogClockSeperator'));
		contAnalogClkbj.AnalogClockDaylight = Utils.getCdataKeyFrameValue(contentElmObj.find('AnalogClockDaylight'));
		contAnalogClkbj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		contAnalogClkbj.ClockDisplayType = Utils.getCdataKeyFrameValue(contentElmObj.find('ClockDisplayType'));	
                /* specific to condition when user updates existing iOS app*/
                if(isIOS())
                {
                  contAnalogClkbj.ClockBackImage = Utils.getUpdatedFilePath(contAnalogClkbj.ClockBackImage);
                  contAnalogClkbj.ClockHourImage = Utils.getUpdatedFilePath(contAnalogClkbj.ClockHourImage);
                  contAnalogClkbj.ClockMinuteImage = Utils.getUpdatedFilePath(contAnalogClkbj.ClockMinuteImage);
                  contAnalogClkbj.ClockSecondImage = Utils.getUpdatedFilePath(contAnalogClkbj.ClockSecondImage);
                }
};
Content.addWeatherWidToGroup = function(contWeatherHrlyObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contWeatherHrlyObj,contentElmObj,true);
		contWeatherHrlyObj.TypeID = contentElmObj.attr('typeid');
		contWeatherHrlyObj.WeatherType = Utils.getCdataKeyFrameValue(contentElmObj.find('WeatherType'));
		contWeatherHrlyObj.Country = Utils.getCdataKeyFrameValue(contentElmObj.find('Country'));
		contWeatherHrlyObj.City = Utils.getCdataKeyFrameValue(contentElmObj.find('City'));
		contWeatherHrlyObj.LocationKey = Utils.getCdataKeyFrameValue(contentElmObj.find('LocationKey'));
		contWeatherHrlyObj.Language = Utils.getCdataKeyFrameValue(contentElmObj.find('Language'));
		contWeatherHrlyObj.LanguageCode = Utils.getCdataKeyFrameValue(contentElmObj.find('LanguageCode'));
		contWeatherHrlyObj.Background = Utils.getCdataKeyFrameValue(contentElmObj.find('Background'));
		contWeatherHrlyObj.Opacity = Utils.getCdataKeyFrameValue(contentElmObj.find('Opacity'));
		contWeatherHrlyObj.Date = Utils.getCdataKeyFrameValue(contentElmObj.find('Date'));
		contWeatherHrlyObj.Refresh = Utils.getCdataKeyFrameValue(contentElmObj.find('Refresh'));
		contWeatherHrlyObj.Unit = Utils.getCdataKeyFrameValue(contentElmObj.find('Unit'));					
		contWeatherHrlyObj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
};
Content.addRssToGroup = function(contRssObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contRssObj,contentElmObj,true);
		contRssObj.Type = contentElmObj.attr('type');
		contRssObj.TypeID = contentElmObj.attr('typeid');
		contRssObj.FillColor = Utils.getCdataKeyFrameValue(contentElmObj.find('FillColor'));
		contRssObj.RssReloadDuration = Utils.getCdataKeyFrameValue(contentElmObj.find('RssReloadDuration'));
		contRssObj.RssServerUrl = Utils.getCdataKeyFrameValue(contentElmObj.find('RssServerUrl'));
		contRssObj.RssServerWorkTarget = Utils.getCdataKeyFrameValue(contentElmObj.find('RssServerWorkTarget'));
		contRssObj.RssServerPort = Utils.getCdataKeyFrameValue(contentElmObj.find('RssServerPort'));
		contRssObj.FillOpacity = Utils.getCdataKeyFrameValue(contentElmObj.find('FillOpacity'));
		contRssObj.TextDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('TextDirection'));
		contRssObj.TextSpeed = Utils.getCdataKeyFrameValue(contentElmObj.find('TextSpeed'));
		contRssObj.Rotation = parseInt(Utils.getCdataKeyFrameValue(contentElmObj.find('Rotation')),10);
		contRssObj.titleTextFontName = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextFontName'));
		contRssObj.titleTextFontFile = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextFontFile'));
		contRssObj.titleTextFontSize = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextFontSize'));
		contRssObj.titleTextItalic = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextItalic'));
		contRssObj.titleTextBold = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextBold'));
		contRssObj.titleTextUnderLine = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextUnderLine'));
		contRssObj.titleTextStrikeOut = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextStrikeOut'));
		contRssObj.titleTextColor = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextColor'));
		contRssObj.titleTextHAlign = Utils.getCdataKeyFrameValue(contentElmObj.find('titleTextHAlign'));
		contRssObj.pubDateTextFontName = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextFontName'));
		contRssObj.pubDateTextFontFile = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextFontFile'));
		contRssObj.pubDateTextFontSize = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextFontSize'));
		contRssObj.pubDateTextItalic = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextItalic'));
		contRssObj.pubDateTextBold = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextBold'));
		contRssObj.pubDateTextUnderLine = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextUnderLine'));
		contRssObj.pubDateTextStrikeOut = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextStrikeOut'));
		contRssObj.pubDateTextColor = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextColor'));
		contRssObj.pubDateTextHAlign = Utils.getCdataKeyFrameValue(contentElmObj.find('pubDateTextHAlign'));
		contRssObj.descriptionTextFontName = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextFontName'));
		contRssObj.descriptionTextFontFile = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextFontFile'));
		contRssObj.descriptionTextFontSize = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextFontSize'));
		contRssObj.descriptionTextItalic = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextItalic'));
		contRssObj.descriptionTextBold = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextBold'));
		contRssObj.descriptionTextUnderLine = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextUnderLine'));
		contRssObj.descriptionTextStrikeOut = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextStrikeOut'));
		contRssObj.descriptionTextColor = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextColor'));
		contRssObj.descriptionTextHAlign = Utils.getCdataKeyFrameValue(contentElmObj.find('descriptionTextHAlign'));
		contRssObj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		contRssObj.NewsDisplayOption = Utils.getCdataKeyFrameValue(contentElmObj.find('NewsDisplayOption'));
		contRssObj.RSS_URL = Utils.getCdataKeyFrameValue(contentElmObj.find('RSS_URL'));
		contRssObj.DISPLAY_CYCLE = Utils.getCdataKeyFrameValue(contentElmObj.find('DISPLAY_CYCLE'));
		
};
Content.addOfficePdfToGroup = function(contOfficePdfObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contOfficePdfObj,contentElmObj,false);
		contOfficePdfObj.Type = 'Office';
		contOfficePdfObj.TypeID = contentElmObj.attr('typeid');
		contOfficePdfObj.IsEditable = Utils.getCdataKeyFrameValue(contentElmObj.find('IsEditable'));							
		contOfficePdfObj.FilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('FilePath'));
		contOfficePdfObj.OriginalPath = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalPath'));
		contOfficePdfObj.OfficeViewerPath = Utils.getCdataKeyFrameValue(contentElmObj.find('OfficeViewerPath'));
		contOfficePdfObj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		contOfficePdfObj.PdfGotoPage = Utils.getCdataKeyFrameValue(contentElmObj.find('PdfGotoPage'));
};
Content.addInputSourceToGroup = function(contInputSourceObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contInputSourceObj,contentElmObj,false);
		contInputSourceObj.IsMutable = Utils.getCdataKeyFrameValue(contentElmObj.find('IsMutable'));					
		contInputSourceObj.IsEditable = Utils.getCdataKeyFrameValue(contentElmObj.find('IsEditable'));
		contInputSourceObj.FilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('FilePath'));
		contInputSourceObj.Type = contentElmObj.attr('type');
		contInputSourceObj.TypeID = contentElmObj.attr('typeid');
		contInputSourceObj.MovieMute = Utils.getCdataKeyFrameValue(contentElmObj.find('MovieMute'));
		contInputSourceObj.InputSourceType = Utils.getCdataKeyFrameValue(contentElmObj.find('InputSourceType'));
		contInputSourceObj.Region = Utils.getCdataKeyFrameValue(contentElmObj.find('Region'));
		contInputSourceObj.Analog_Digital = Utils.getCdataKeyFrameValue(contentElmObj.find('Analog_Digital'));
		contInputSourceObj.Channel = Utils.getCdataKeyFrameValue(contentElmObj.find('Channel'));
		contInputSourceObj.Minor_Channel = Utils.getCdataKeyFrameValue(contentElmObj.find('Minor_Channel'));
		contInputSourceObj.AirCable = Utils.getCdataKeyFrameValue(contentElmObj.find('AirCable'));
		contInputSourceObj.Sound = Utils.getCdataKeyFrameValue(contentElmObj.find('Sound'));
};
Content.addWebToGroup = function(contWebObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contWebObj,contentElmObj,false);
		contWebObj.TypeID = contentElmObj.attr('typeid');
		contWebObj.WebURL = Utils.getCdataKeyFrameValue(contentElmObj.find('WebURL'));
		contWebObj.WebAuthorizationID = Utils.getCdataKeyFrameValue(contentElmObj.find('WebAuthorizationID'));				
		contWebObj.IsEditable = Utils.getCdataKeyFrameValue(contentElmObj.find('IsEditable'));				
		contWebObj.FilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('FilePath'));
		contWebObj.WebOutputMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WebOutputMode'));
		contWebObj.WebRefresh = Utils.getCdataKeyFrameValue(contentElmObj.find('WebRefresh'));
		contWebObj.WebRefreshNew = Utils.getCdataKeyFrameValue(contentElmObj.find('WebRefreshNew'));
		contWebObj.WebInputEnable = Utils.getCdataKeyFrameValue(contentElmObj.find('WebInputEnable'));
		contWebObj.WebScrollShow = Utils.getCdataKeyFrameValue(contentElmObj.find('WebScrollShow'));
		contWebObj.WebVScrollPos = Utils.getCdataKeyFrameValue(contentElmObj.find('WebVScrollPos'));
		contWebObj.WebHScrollPos = Utils.getCdataKeyFrameValue(contentElmObj.find('WebHScrollPos'));
		contWebObj.WebAuthorizationPassWd = Utils.getCdataKeyFrameValue(contentElmObj.find('WebAuthorizationPassWd'));
		contWebObj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
};
Content.addMediaRssToGroup = function(contMediaRssObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contMediaRssObj,contentElmObj,true);
		contMediaRssObj.TypeID = contentElmObj.attr('typeid');
		contMediaRssObj.MrssURL = Utils.getCdataKeyFrameValue(contentElmObj.find('MrssURL'));
		contMediaRssObj.MrssDuration = Utils.getCdataKeyFrameValue(contentElmObj.find('MrssDuration'));				
		contMediaRssObj.IsEditable = Utils.getCdataKeyFrameValue(contentElmObj.find('IsEditable'));				
		contMediaRssObj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		contMediaRssObj.AspectFill = Utils.getCdataKeyFrameValue(contentElmObj.find('AspectFill'));
};
Content.addStickerToGroup = function(contStickerObj,contentElmObj){
		addCommonPropertiesToContObjFrmLfd(contStickerObj,contentElmObj,true);
		contStickerObj.OriginalPath = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalPath'));					
		contStickerObj.ConfigName = Utils.getCdataKeyFrameValue(contentElmObj.find('ConfigName'));
		contStickerObj.EndStateXML = Utils.getCdataKeyFrameValue(contentElmObj.find('EndStateXML'));
		contStickerObj.EndStateBitmap = Utils.getCdataKeyFrameValue(contentElmObj.find('EndStateBitmap'));
		contStickerObj.Rotation = parseInt(Utils.getCdataKeyFrameValue(contentElmObj.find('Rotation')),10);						
	   /* specific to condition when user updates existing iOS app*/
	   if(isIOS())
	   {
		 contStickerObj.OriginalPath = Utils.getUpdatedFilePath(contStickerObj.OriginalPath);
	   }
};
Content.addShapesToGroup = function(shapetype,contShapeObj,contentElmObj){
 		log.debug("FunctionIn: Content.addShapesToGroup");
 		addCommonPropertiesToContObjFrmLfd(contShapeObj,contentElmObj,true);
		addSpecificParaToContFromLFD(shapetype,contShapeObj,contentElmObj);
		contShapeObj.Type = contentElmObj.attr('type');
		contShapeObj.TypeID = contentElmObj.attr('typeid');
		contShapeObj.Rotation = parseInt(Utils.getCdataKeyFrameValue(contentElmObj.find('Rotation')),10);
		contShapeObj.FillOpacity = Utils.getCdataKeyFrameValue(contentElmObj.find('FillOpacity'));
		contShapeObj.WindowMode = Utils.getCdataKeyFrameValue(contentElmObj.find('WindowMode'));
		contShapeObj.OrginalWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('OrginalWidth'));
		contShapeObj.OriginalHeight = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalHeight'));
		contShapeObj.ClipLeft = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipLeft'));
		contShapeObj.ClipRight = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipRight'));
		contShapeObj.ClipTop = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipTop'));
		contShapeObj.ClipBottom = Utils.getCdataKeyFrameValue(contentElmObj.find('ClipBottom'));
		contShapeObj.scale = Utils.getCdataKeyFrameValue(contentElmObj.find('scale'));
		contShapeObj.IsNewFile="False";
		contShapeObj.frameId = Utils.getCdataKeyFrameValue(contentElmObj.find('frameId'));
		contShapeObj.LineColor = Utils.getCdataKeyFrameValue(contentElmObj.find('LineColor'));
		contShapeObj.FigureStrokeOpacity = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureStrokeOpacity'));
		contShapeObj.FigureStrokeWidth = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureStrokeWidth'));
		contShapeObj.FigureStrokePattern = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureStrokePattern'));
		contShapeObj.FigureGrFillMode = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureGrFillMode'));
		contShapeObj.FigureGrLineDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureGrLineDirection'));
		contShapeObj.FigureGrPathDirection = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureGrPathDirection'));
		contShapeObj.OriginalHeight = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalHeight'));
		contShapeObj.FillColor = Utils.getCdataKeyFrameValue(contentElmObj.find('FillColor'));
		contShapeObj.FigureGrStartColor = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureGrStartColor'));
		contShapeObj.FigureGrEndColor = Utils.getCdataKeyFrameValue(contentElmObj.find('FigureGrEndColor'));
		contShapeObj.FillRange = Utils.getCdataKeyFrameValue(contentElmObj.find('FillRange'));
		contShapeObj.OffsetLeft = Utils.getCdataKeyFrameValue(contentElmObj.find('OffsetLeft'));
		contShapeObj.OffsetRight = Utils.getCdataKeyFrameValue(contentElmObj.find('OffsetRight'));
		contShapeObj.OffsetTop = Utils.getCdataKeyFrameValue(contentElmObj.find('OffsetTop'));
		contShapeObj.OffsetBottom = Utils.getCdataKeyFrameValue(contentElmObj.find('OffsetBottom'));
		contShapeObj.ImageFilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('ImageFilePath'));
		contShapeObj.ImageRatio = Utils.getCdataKeyFrameValue(contentElmObj.find('ImageRatio'));
		contShapeObj.FillRange = Utils.getCdataKeyFrameValue(contentElmObj.find('FillRange'));
		contShapeObj.ImageFilePath = Utils.getCdataKeyFrameValue(contentElmObj.find('ImageFilePath'));
		contShapeObj.thumbPath = Utils.getCdataKeyFrameValue(contentElmObj.find('thumbPath'));
		contShapeObj.OriginalImage = Utils.getCdataKeyFrameValue(contentElmObj.find('OriginalImage'));
		contShapeObj.thumbOrgW = Utils.getCdataKeyFrameValue(contentElmObj.find('thumbOrgW'));
		contShapeObj.thumbOrgH = Utils.getCdataKeyFrameValue(contentElmObj.find('thumbOrgH'));
		/* specific to condition when user updates existing iOS app*/
                if(isIOS())
                {
                  contShapeObj.ImageFilePath = Utils.getUpdatedFilePath(contShapeObj.ImageFilePath);
                  contShapeObj.thumbPath = Utils.getUpdatedFilePath(contShapeObj.thumbPath);
                  contShapeObj.OriginalImage = Utils.getUpdatedFilePath(contShapeObj.OriginalImage);
                }
		log.debug("FunctionOut: Content.addShapesToGroup");
};
Content.EventItem = function(fnname,textOfLFDFile)
{
	var Scriptfuntion = $(textOfLFDFile).find('Function');
	var totalfunctions = Scriptfuntion.length;
	var num = 0;var cntfn;
	for( cntfn = 0; cntfn < totalfunctions; cntfn++)
	{
		var fn = $(Scriptfuntion[cntfn]).attr('functionName');
		if(fn == fnname)
		{
			var code = $(Scriptfuntion[cntfn]).find('Code');
			var val = Utils.getCdataValue(code);
			var arr = val.split('"');
			num = getParseIntInDec(arr[1].match(/\d+$/)[0]);
			break;		
		}
	}
	return (getParseIntInDec(num));
 };
