/**
 * @filename SaveTemplate.js
 *
 * Created by p.menaria 24-01-2015
 *
 * Modified by p.menaria 16-02-2015
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

var templateFlag;
var templateImageCount = 2;
var stillImageFlag=true;
var filesToRotateJson = {};
var filesToRotateArr = [];
filesToRotateJson.filesToRotateArrs = filesToRotateArr;
var filesToCropJson = {};
var filesToCropArr = [];
filesToCropJson.filesToCropArrs = filesToCropArr;
var SaveTemplate = {
	lfdFilePathAfterRoot : null,
	lfdImagePath : null,
	sdcardFullPath : "",
	myTemplatePath : Utils.getContentsRootPath() +"/MyTemplate/",
	contentsFolderpath : "",
	spenOuterFolderPath: Utils.getContentsRootPath() +"/MyTemplate/Spen",
	spenInnerFolderName: "Spen",
	spenInnerFolderPath:"",
	saveCount:0,
	tableCount:0,
	customClick : false,
	customNewTplClick:false,
	customTemplateNameClicked:null,
	shuffleTemplate:false,
	templateName:"",
	overWriteFlag:false,
	templateDuration:null,
	scheduleName : "",
    schedulePath : "",
    isNewSchedule : "",
    privateKey:"#VX#VEY#VXXR#"
};
var frameWithSelectedAudioTizen="";
var hwPathArr = [];
SaveTemplate.saveTemplate = function() {
    log.debug("START","saveTemplate");
    printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Proccessed before template saving");
    printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","Template saving");
    
    templateImageCount = 2;/*It is used to create two template thumnbnail images of high and low resolution.*/
    SaveTemplate.sdcardFullPath = Utils.getSystemRootPath();
    hwPathArr = [];
       
	if(SaveTemplate.saveCount > 0){ 
		SaveTemplate.lfdFilePathAfterRoot = SaveTemplate.myTemplatePath + SaveTemplate.templateName + "/" + SaveTemplate.templateName + ".LFD";
		SaveTemplate.lfdImagePath = SaveTemplate.sdcardFullPath + SaveTemplate.lfdFilePathAfterRoot + ".PNG";
		SaveTemplate.setContentsFolderPath();
		if(!isIOS()){
			SaveTemplate.setSpenInnerFolderPath();	
		}
		if(SaveTemplate.overWriteFlag){
			setTemplateInfo("insert");
		}else{
			setTemplateInfo("update");
		}		
		SaveTemplate.overWriteFlag = false;
		SaveTemplate.readEmptyLfdFile();
	}else{ 
		SaveTemplate.saveCount++;
		/*Creating new template*/
		if(SaveTemplate.templateName==""){			
			SaveTemplate.templateName = createNewTemplate();
		}		
		SaveTemplate.lfdFilePathAfterRoot = SaveTemplate.myTemplatePath + SaveTemplate.templateName + "/" + SaveTemplate.templateName + ".LFD";
		SaveTemplate.lfdImagePath = SaveTemplate.sdcardFullPath + SaveTemplate.lfdFilePathAfterRoot + ".PNG";
		SaveTemplate.setContentsFolderPath(); /* contents folder path should always be set before createMyTemplateFolder and after createNewTemplate call*/
		if(!isIOS()){
			SaveTemplate.setSpenInnerFolderPath();
		}
		createMyTemplateFolder();
		setTemplateInfo("insert");
	}
	printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Template saving");
	log.debug("COMPLETED","saveTemplate");
};
SaveTemplate.setContentsFolderPath=function(){
	SaveTemplate.contentsFolderpath = SaveTemplate.sdcardFullPath + SaveTemplate.lfdFilePathAfterRoot.slice(0, SaveTemplate.lfdFilePathAfterRoot.lastIndexOf("/") + 1);
};
SaveTemplate.setSpenInnerFolderPath=function(){
	SaveTemplate.spenInnerFolderPath = SaveTemplate.myTemplatePath + SaveTemplate.templateName + "/" + SaveTemplate.spenInnerFolderName; 
};

SaveTemplate.readEmptyLfdFile = function() {
    log.debug("START","readEmptyLfdFile");
	$.ajax({
		type : "GET",
		url : "../resource/XML/SampleLfd.xml",
		dataType : "text",
		async : false,
		success : function(textOfLFDFile) {
           log.debug("SUCESS","readEmptyLfdFile");
			Content.init(textOfLFDFile);
			SaveTemplate.addTempObjToContentObj();
		},
		error : function(jqXHR, textStatus, errorThrown) {
			alert(textStatus + " :: " + errorThrown);
		}
	});
};
SaveTemplate.addTempObjToContentObj = function() {
    log.debug("START","addTempObjToContentObj");
    var contentPageObj = ContentObj.Page[1];
    var tempText = "";
    var tempTextSrc = null;
    var txtElmObj = null;
    SaveTemplate.templateDuration = null;
    filesToCropJson.filesToCropArrs = [];
    filesToRotateJson.filesToRotateArrs = [];
    var filesToRotateInfo={};
    stillImageFlag = true;
    setStillImageFlag();
	if(SaveTemplate.templateName == ""){
		$("#tplHeaderStoreNameId").html(langObj.template.MIS_SID_UNTITLED);
	}else{
		$("#tplHeaderStoreNameId").html(SaveTemplate.templateName);	
	}	
	contentPageObj.Group = [];
        contentPageObj.FrameLayout = templateObj.frameLayout;
	
	ContentObj.DisplayWidth = templateObj.lfdSize.w; 
	ContentObj.DisplayHeight = templateObj.lfdSize.h;	
		
	if (templateObj.bgImage!=undefined && templateObj.bgImage != ""){
		ContentObj.Page[0].BGImageFilePath = retrieveFileName(templateObj.bgImage);
		contentPageObj.BGImageFilePath = retrieveFileName(templateObj.bgImage);
		contentPageObj.BGImageOriginalPath = templateObj.bgImage;
		if (globlePlayerType == RMD_MODEL && templateObj.orientation == PORTRAIT) {
			ContentObj.Page[0].NT14_BGImageFilePath = contentPageObj.BGImageFilePath;
			contentPageObj.NT14_BGImageFilePath = contentPageObj.BGImageFilePath;
			var destinationPath = SaveTemplate.contentsFolderpath + "ImageOp/" + contentPageObj.BGImageFilePath;
			var sourcePath = contentPageObj.BGImageOriginalPath;
			filesToRotateInfo.SrcPath = sourcePath;
		        filesToRotateInfo.DestPath = destinationPath;
		        filesToRotateInfo.Rotation = 270;
		        filesToRotateJson.filesToRotateArrs.push(filesToRotateInfo);
		}
		/* If bg image is from free templates then copy them from assets folder to contents folder same as stickers*/
		if(templateObj.bgImage.indexOf("FreeTemplates/Embedded") != -1){
			stickersList.push(templateObj.bgImage);
		}	
		contentPageObj.BGColor = "241;241;241";
	} else {
		if(templateObj.bgColor!=undefined && templateObj.bgColor!=""){
	    	contentPageObj.BGColor = SaveTemplate.changeColorFormat(templateObj.bgColor);
		}else{
			contentPageObj.BGColor = "241;241;241";
		}	    
	}
	ContentObj.Page[0].BGColor = contentPageObj.BGColor;
	contentPageObj.IsMutable = "false";
	if(templateObj.canModifiedBg){
		contentPageObj.IsMutable = "true";
	}
	
	var firstFrameIdWithVideo = templateObj.selAudioFrm;
	var firstFrameIdWithVideoGrp="";
	if(firstFrameIdWithVideo==""){
    		firstFrameIdWithVideo = SaveTemplate.getFirstFrameIdWithVideoOrInpSrc();	
 	}
	
	var audioframeObj = templateObj.getInnerFrameForId(firstFrameIdWithVideo);
	if(firstFrameIdWithVideo!="" && audioframeObj!=undefined && audioframeObj.groupId!="" && audioframeObj.groupId!=null)
	{
		firstFrameIdWithVideoGrp = audioframeObj.groupId;
	}
	
	frameWithSelectedAudioTizen =  templateObj.audioFlag?firstFrameIdWithVideo:"";   	
	SaveTemplate.setSelectedAudioVideoType(firstFrameIdWithVideo);
	
	if(!(firstFrameIdWithVideo =="" || templateObj.selAudioFrm == templateObj.mainFrame.id) && !Utils.isHighEndModel(globlePlayerType))
	{
		if(TemplateUtils.isElementTypeGroup(firstFrameIdWithVideoGrp))
		{
			SaveTemplate.addInnerFrameElements(firstFrameIdWithVideo,contentPageObj.Group);
		}
		else
		{
			addInnerFrameToContUtil(firstFrameIdWithVideo,firstFrameIdWithVideoGrp);
		}
	}
	if(templateObj.frameLayout == BLANK_LAYOUT)
	{
			SaveTemplate.addInnerFrameElmToCont(firstFrameIdWithVideo,firstFrameIdWithVideoGrp);
			if(templateObj.audioFileName!=undefined && templateObj.audioFileName!=""){
				SaveTemplate.addSoundElement();
			}	
	}
	else
	{
		if(templateObj.audioFileName!=undefined && templateObj.audioFileName!=""){
				SaveTemplate.addSoundElement();
			}
		for (var frameId in templateObj.innerFrames) {			
			if(Utils.isHighEndModel(globlePlayerType) || frameId != firstFrameIdWithVideo){
				SaveTemplate.addInnerFrameElements(frameId,contentPageObj.Group);
			}				
		}
	}
	ContentObj.AudioMute = "false";
	if(!templateObj.audioFlag){
		ContentObj.AudioMute = "true";	
	}
	/*Add mainframe elements*/
	var mainFrameElmLyrLen = templateObj.mainFrmElmLayer.length;
	var i, contentGrpSize, m, grpArr, contentObjGrp, temObjType, groupContent, grpElmLen, elmentId,itr;
	for (i = 0; i < mainFrameElmLyrLen; i++) {
		m = templateObj.mainFrmElmLayer[i];
		contentGrpSize = contentPageObj.Group.length;
		grpArr = new Group_Array();
		contentPageObj.Group.push(grpArr);
		contentObjGrp=contentPageObj.Group[contentGrpSize];
		temObjType=templateObj.mainFrame.element[m];
		if(isNaN(m) && TemplateUtils.isElementTypeGroup(m))
		{
			groupContent = groupHandler.groupMap[m];
			grpElmLen = groupContent.elements.length;
			saveDimensionsInfoToContObj(contentObjGrp,groupContent);
			contentObjGrp.Rotation = groupContent.rotation;
			for(itr=0;itr<grpElmLen;itr++)
			{	
				contentObjGrp.GroupMap.push(new Group_Array());
				if(groupContent.elements[itr].ref.elementType == undefined)
				{
					elmentId = groupContent.elements[itr].id;
					ContentObjFrmMainFrameElm(templateObj.mainFrame.element[elmentId.split('_')[2]],contentObjGrp.GroupMap[contentObjGrp.GroupMap.length-1]);
				}
				else
				{
					ContentObjFrmMainFrameElm(groupContent.elements[itr].ref,contentObjGrp.GroupMap[contentObjGrp.GroupMap.length-1]);	
				}
				
			}
		}
		else
			ContentObjFrmMainFrameElm(temObjType,contentObjGrp);
	}

	if(globlePlayerType==RMD_MODEL){
		cropAndRotateImages();
	}
	LfdContent.sendContent(ContentObj);
	if(SaveTemplate.templateDuration==undefined){
		SaveTemplate.templateDuration = TEMPLATE_DEFAULT_DURATION;
	}
	setTimeout(function() {
		if(SaveTemplate.templateDuration<5){
			SaveTemplate.templateDuration = 5;
		}
		setTemplateDurationInDb(SaveTemplate.templateName+".LFD", SaveTemplate.templateDuration, globlePlayerType);
	},100);		
	
    log.debug("COMPLETED","addTempObjToContentObj");
};

function saveDimensionsInfoToContObj(contentObjELm,relRectObj)
{
	contentObjELm.PositionX = relRectObj.x;
	contentObjELm.PositionY = relRectObj.y;
	contentObjELm.Width = relRectObj.w;
	contentObjELm.Height = relRectObj.h;
}
function ContentObjFrmMainFrameElm (temObjType,contentObjGrp)
{	
	    var elmType = temObjType.elementType;
		var shapeType;
		if(TemplateUtils.isShape(elmType))
		{
			shapeType = elmType;
			elmType  = 500;
		}
		switch(elmType) {
			case TEXT:
				tempText = "";
	            tempTextSrc = null;
				var txtArr = new Text_Array();
				contentObjGrp.Text.push(txtArr);
	            txtElmObj = temObjType.textElms[0];
	            if(txtElmObj.text == MIA_SID_DOUBLE_TAP_TO_EDIT){
	                tempText = MIA_SID_DOUBLE_TAP_TO_EDIT;
	                txtElmObj.text = "";
	                tempTextSrc = txtElmObj.textImageSrc;	                
	                /*create image only if required as floating elements image is already created so only need to create if
	                user has not updated the default text*/
	                createUpdatedImage(txtElmObj);
	            }
				saveText(txtElmObj);
				/* saveText should be called always before addTxtPropToContObj*/
	            			
	            txtArr.Rotation = txtElmObj.rotation;
				SaveTemplate.addTxtPropToContObj(txtArr, txtElmObj,"");
				txtArr.isGroupMember = false;
				if(tempText != ""){
	                txtElmObj.text = tempText;
	                txtElmObj.textImageSrc = tempTextSrc;
	            }
			break;
			case STICKER:
				log.debug("FunctionIn: For shapes only addTempObjToContentObj");

				var stickerArr = new Sticker_Array();
				contentObjGrp.Sticker.push(stickerArr);
				if(temObjType.timeZoneOffset!="")
				{
					saveText({"textImageName":temObjType.fileName,"textImageSrc":temObjType.imageSrc});	
				}
				SaveTemplate.addStickerPropToContObj(stickerArr, temObjType);
				log.debug("FunctionOut: For shapes only addTempObjToContentObj");
			break;
			case DECO_IMAGE:
				var imgArr = new Image_Array();
				contentObjGrp.Image.push(imgArr);
				SaveTemplate.addDecoImgPropToContObj(imgArr, temObjType);
			break;
			case HANDWRITING:
				if(globlePlayerType!=RMD_MODEL){
					/*For non RMD model add HANDWRITING as STICKER*/
					var stickerArr = new Sticker_Array();
					contentObjGrp.Sticker.push(stickerArr);
					SaveTemplate.addStickerPropToContObj(stickerArr, temObjType);
				}else{	
					/*For RMD model add HANDWRITING as DECO IMAGE*/
					var imgArr = new Image_Array();
					contentObjGrp.Image.push(imgArr);
					SaveTemplate.addDecoImgPropToContObj(imgArr, temObjType);
				}				
			break;
			case widgetInfo.DIGITAL_CLOCK:
				var digClkArr = new DigitalClock_Array();			
				contentObjGrp.DigitalClock.push(digClkArr);			
	           	digClkElmObj = temObjType.textElms[0];
				SaveTemplate.addDigClkPropToContObj(digClkArr, digClkElmObj);
			break;
			case widgetInfo.ANALOG_CLOCK_1:
			case widgetInfo.ANALOG_CLOCK_2:
			case widgetInfo.ANALOG_CLOCK_3:
			case widgetInfo.ANALOG_CLOCK_4:
			case widgetInfo.ANALOG_CLOCK_5:
				var analogClkArr = new AnalogClock_Array();			
				contentObjGrp.AnalogClock.push(analogClkArr);			
	            SaveTemplate.addAnalogClkPropToContObj(analogClkArr, temObjType);
			break;
			case widgetInfo.RSS:
				var rssArr = new RSS_Array();			
				contentObjGrp.RSS.push(rssArr);			
	            SaveTemplate.addRssPropToContObj(rssArr, temObjType.textElms[0]);
			break;
			case widgetInfo.WEATHER_HOUR:
				var weatherHrlyArr = new WeatherWid_Array();			
				contentObjGrp.WeatherHourly.push(weatherHrlyArr);			
	         	SaveTemplate.addWeatherPropToContObj(weatherHrlyArr, temObjType);
			break;
			case widgetInfo.WEATHER_TODAY:
				var weather1DayArr = new WeatherWid_Array();			
				contentObjGrp.Weather1Day.push(weather1DayArr);			
	           	SaveTemplate.addWeatherPropToContObj(weather1DayArr, temObjType);
			break;
			case widgetInfo.WEATHER_WEEK:
				var weather7DayArr = new WeatherWid_Array();			
				contentObjGrp.Weather7Day.push(weather7DayArr);			
	            SaveTemplate.addWeatherPropToContObj(weather7DayArr, temObjType);
			break;
			case SHAPE:
				var shapeArr = new Shapes_Array();
				addSpecificParaToShape(shapeArr,shapeType);
				contentObjGrp.Shapes.push(shapeArr);
				SaveTemplate.addShapesPropToContObj(shapeType,shapeArr, temObjType);
			break;
			default:				
			break;
		}	
}

SaveTemplate.getFirstFrameIdWithVideoOrInpSrc = function(){
	var firstFrameIdWithVideo = templateObj.selAudioFrm;
	var frameObj;
	for (var frameId in templateObj.innerFrames) {
		
        frameObj = templateObj.getInnerFrameForId(frameId);
		if(firstFrameIdWithVideo == "" && frameObj.element.length > 0 && ((frameObj.element[0].elementType == VIDEO) || frameObj.element[0].elementType == INPUT_SOURCE)){
        		firstFrameIdWithVideo = frameId;
        	break;      
       		}			 
	}
	return firstFrameIdWithVideo;
};

SaveTemplate.addInnerFrameElmToCont =  function (firstFrameIdWithVideo,firstGroupIdWithVideo)
{
	var innerFrameZorderArrayLen = templateObj.innerFrameZOrderArr.length;
	firstFrameIdWithVideo = firstGroupIdWithVideo!=""?firstGroupIdWithVideo:firstFrameIdWithVideo;
	var frameIden;
	for (var i = 0; i < innerFrameZorderArrayLen ; i++) {
		frameIden = templateObj.innerFrameZOrderArr[i];
		if(Utils.isHighEndModel(globlePlayerType) || ((((isNaN(frameIden) && TemplateUtils.isElementTypeGroup(frameIden))?"":"tplFrameId_")+frameIden) != firstFrameIdWithVideo))
		{
			addInnerFrameToContUtil(frameIden,"");	
		}
		
		/*var ContentPageGrpObj = ContentObj.Page[1].Group;
		if(isNaN(frameIden) && frameIden.indexOf("grp_")!=-1)
		{
			ContentPageGrpObj.push(new Group_Array());
			var contentObjGrp=ContentPageGrpObj[ContentPageGrpObj.length - 1];
			var groupContent = groupHandler.groupMap[frameIden];
			var grpElmLen = groupContent.elements.length;
			contentObjGrp.Rotation = groupContent.rotation; 
			for(var itr=0;itr<grpElmLen;itr++)
			{	
				SaveTemplate.addInnerFrameElements(groupContent.elements[itr].id,false,contentObjGrp.GroupMap);
			}
				
		}
		else
		{
			SaveTemplate.addInnerFrameElements(frameIden,isBlank_lay,ContentPageGrpObj);
		}*/
	}
};

function addInnerFrameToContUtil(frameIden,audioFrameId)
{
	var ContentPageGrpObj = ContentObj.Page[1].Group;
	if(audioFrameId!="" && audioFrameId!=undefined)
	{
			var temp = audioFrameId;
			audioFrameId =  frameIden;
			frameIden = temp;
		
	}
	if(isNaN(frameIden) && TemplateUtils.isElementTypeGroup(frameIden))
	{
		ContentPageGrpObj.push(new Group_Array());
		var contentObjGrp=ContentPageGrpObj[ContentPageGrpObj.length - 1];
		var groupContent = groupHandler.groupMap[frameIden];
		var grpElmLen = groupContent.elements.length;
		saveDimensionsInfoToContObj(contentObjGrp,groupContent);
		contentObjGrp.Rotation = groupContent.rotation;

		if(audioFrameId!="" && audioFrameId!=undefined)
		{
			SaveTemplate.addInnerFrameElements(audioFrameId,contentObjGrp.GroupMap);
		}
		var itr;
		for(itr=0;itr<grpElmLen;itr++)
		{	
			if(groupContent.elements[itr].id!=audioFrameId)
			    SaveTemplate.addInnerFrameElements(groupContent.elements[itr].id,contentObjGrp.GroupMap);
		}
			
	}
	else
	{
		SaveTemplate.addInnerFrameElements(frameIden,ContentPageGrpObj);
	}
}	

SaveTemplate.addInnerFrameElements = function(frameIndx,contentGrpMapObj){
	var contentGrpSize;
    var contentGrpObj;
    var timeLinePosImg = 0;
    var timeLinePosVid = 0;
    var tempText = "";
    var tempTextSrc = null;
    var txtElmObj = null;
    var elmType;
	var currInnerFrame ;
	var frameId=frameIndx;
	var contPageObj = ContentObj.Page[1];
	if(!(isNaN(frameIndx) && frameIndx.indexOf(FRAME_ID_PREFIX)!=-1))
	{
		frameId = FRAME_ID_PREFIX+frameIndx;
	}
	var currInnerFrame = templateObj.getInnerFrameForId(frameId);
    var currInnerFrameLength = currInnerFrame.element.length;
    var grpArr;
	for (var j = 0; j < currInnerFrameLength; j++) {
        grpArr = new Group_Array();
        contentGrpMapObj.push(grpArr);
        currInnerFrameElmObj = currInnerFrame.element[j];
        elmType = currInnerFrameElmObj.elementType;
        contentGrpObj = contentGrpMapObj[contentGrpMapObj.length-1];

        switch(elmType) {
            case GROUP:
            case IMAGE:
            if (elmType == GROUP){
                var relRectGroup = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(currInnerFrame.x, currInnerFrame.y, currInnerFrame.w, currInnerFrame.h));
                saveDimensionsInfoToContObj(contentGrpObj,relRectGroup);
            }
            /*Add image for group*/
            if (currInnerFrameElmObj.imageSrc != "") {
                var imgArr = new Image_Array();
                contentGrpObj.Image.push(imgArr);

                timeLinePosImg = SaveTemplate.addImgPropToContObj(contentGrpObj, contentGrpObj.Image[0], currInnerFrame, currInnerFrameElmObj, timeLinePosImg, currInnerFrameLength);
                            contentGrpObj.Image[0].isGroupMember = false;
                if (elmType == GROUP) {
                    contentGrpObj.Image[0].isGroupMember = true;
                }
                if(stillImageFlag==false){
                    if((SaveTemplate.templateDuration==undefined) || (timeLinePosImg != 0 && SaveTemplate.templateDuration < timeLinePosImg)){
                        SaveTemplate.templateDuration = timeLinePosImg;
                    }
                }else{
                    SaveTemplate.templateDuration = TEMPLATE_DEFAULT_DURATION;
                }
            }
            /*Add text for group*/
            var textElmsLength = currInnerFrameElmObj.textElms.length;
            var txtArr;
            for (var k = 0; k < textElmsLength; k++) {
                        tempText = "";
                        txtElmObj = null;
                        tempTextSrc = null;
                txtArr = new Text_Array();
                contentGrpObj.Text.push(txtArr);
                            txtElmObj = currInnerFrameElmObj.textElms[k];
                txtElmObj.textImageName = currInnerFrame.id+"-elm_"+j+"_"+k+"_InrElm.png";
                        if(txtElmObj.text == MIA_SID_DOUBLE_TAP_TO_EDIT){
                            tempText = MIA_SID_DOUBLE_TAP_TO_EDIT;
                            txtElmObj.text = "";
                            tempTextSrc = txtElmObj.textImageSrc;
                        }
                createUpdatedImage(txtElmObj);
                /*in case of group text we need to create image everytime*/
                                saveText(txtElmObj);
                /* saveText should be called always before addTxtPropToContObj*/

                 txtArr.Rotation = txtElmObj.rotation;
                SaveTemplate.addTxtPropToContObj(txtArr, txtElmObj,"");
                txtArr.isGroupMember = true;
                txtArr.Duration = contentGrpObj.Duration;
                txtArr.Start = contentGrpObj.Start;
                txtArr.DurationPolicy = contentGrpObj.DurationPolicy;
                txtArr.RepeatPeriod = contentGrpObj.RepeatPeriod;
                 if(tempText != ""){
                            txtElmObj.text = tempText;
                            txtElmObj.textImageSrc = tempTextSrc;
                        }
            }
            break;

            case VIDEO:
                var vidArr = new Video_Array();
                contentGrpObj.Video.push(vidArr);
                timeLinePosVid = SaveTemplate.addVidPropToContObj(contentGrpObj.Video[0], currInnerFrame, currInnerFrameElmObj,timeLinePosVid, currInnerFrameLength);
                if((SaveTemplate.templateDuration==undefined) || (timeLinePosVid != 0 && SaveTemplate.templateDuration < timeLinePosVid)){
                        SaveTemplate.templateDuration = timeLinePosVid;
                }
            break;
            case INPUT_SOURCE:
                var inptSrcArr = new Inputsource_Array();
                contentGrpObj.InputSource.push(inptSrcArr);
                SaveTemplate.addInptSrcPropToContObj(contentGrpObj.InputSource[0], currInnerFrame, currInnerFrameElmObj);
            break;

            case PPT:
                var pptArr = new OfficePdf_Array();
                contentGrpObj.Office.push(pptArr);
                SaveTemplate.addPptPropToContObj(contentGrpObj.Office[0], currInnerFrame, currInnerFrameElmObj, false);
            break;

            case PDF:
                var pdfArr = new OfficePdf_Array();
                contentGrpObj.Pdf.push(pdfArr);
                SaveTemplate.addPptPropToContObj(contentGrpObj.Pdf[0], currInnerFrame, currInnerFrameElmObj, true);
            break;

            case widgetInfo.WEB:
                var WebArr = new Web_Array();
                contentGrpObj.Web.push(WebArr);
                SaveTemplate.addWebPropToContObj(contentGrpObj.Web[0], currInnerFrame, currInnerFrameElmObj);
            break;

            case widgetInfo.MEDIARSS:
                var MediaRssArr = new MediaRss_Array();
                contentGrpObj.MediaRss.push(MediaRssArr);
                SaveTemplate.addMediaRssPropToContObj(contentGrpObj.MediaRss[0], currInnerFrame, currInnerFrameElmObj);
            break;

            default:
            break;
        }
	}
    /*Add Table elements - MenuBoard*/
    if(currInnerFrame.table!=null){
        contentGrpSize = contPageObj.Group.length;
        SaveTemplate.tableCount++;
        var grpArr = new Group_Array();
        contPageObj.Group.push(grpArr);
        contentGrpObj = contPageObj.Group[contentGrpSize];
        contentGrpObj.Name = "GMenu_"+SaveTemplate.tableCount;
        var relRectGroup = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(currInnerFrame.x, currInnerFrame.y, currInnerFrame.w, currInnerFrame.h));
        saveDimensionsInfoToContObj(contentGrpObj,relRectGroup);
        var tableColCount = currInnerFrame.table.col.length;
        /*Add Menu board table text to group*/
        var tableRowCnt;
        var txtArr;
        for (var i = 0; i < tableColCount; i++) {
            tableRowCnt = currInnerFrame.table.col[i].length;
            for (var j = 0; j < tableRowCnt; j++) {
                tempText = "";
                txtElmObj = null;
                tempTextSrc = null;

                txtArr = new Text_Array();
                contentGrpObj.Text.push(txtArr);
                if(i==0){
                    textName = "Menu1_"+(j+1);
                }else{
                    textName = "Price1_"+(i)+"_"+(j+1);
                }
                txtElmObj = currInnerFrame.table.col[i][j];
                    /*
                    if((txtElmObj.text == COM_TV_PRICE || txtElmObj.text ==  IDS_DOCKINGPANE_MENU) && !txtElmObj.bMenuOrPrice){
                                            tempText = txtElmObj.text;
                                            txtElmObj.text = "";
                                            tempTextSrc = txtElmObj.textImageSrc;
                                            createUpdatedImage(txtElmObj);
                                        }*/
                    
                saveText(txtElmObj);
                /* saveText should be called always before addTxtPropToContObj*/
                SaveTemplate.addTxtPropToContObj(txtArr, txtElmObj,textName);
                txtArr.isGroupMember = true;
                if(tempText != ""){
                    txtElmObj.text = tempText;
                    txtElmObj.textImageSrc = tempTextSrc;
                }
            }
        }
    }
    /*Empty frame should be added only if there is neither a element nor a table*/
    if((currInnerFrameLength == 0) && (currInnerFrame.table==null)){
            SaveTemplate.addEmptyFrame(currInnerFrame);
    }
    log.debug("COMPLETES id - "+currInnerFrame.id,"addInnerFrameElements");
};
SaveTemplate.addEmptyFrame =function(currInnerFrame){
    log.debug("START","addEmptyFrame");
    var contPageObj = ContentObj.Page[1];
	var contentGrpSize = contPageObj.Group.length;
	var grpArr = new Group_Array();
	contPageObj.Group.push(grpArr);
	var imgArr = new Image_Array();
	contPageObj.Group[contentGrpSize].Image.push(imgArr);

	var contGrpObj = contPageObj.Group[contentGrpSize];
	SaveTemplate.addImgPropToContObj(contGrpObj, contGrpObj.Image[0], currInnerFrame, null, 0, 0);
	contGrpObj.Image[0].isGroupMember = false;
    log.debug("COMPLETED","addEmptyFrame");
};
SaveTemplate.addImgPropToContObj = function(contGroupObj, contImgObj, tmpFrameObj, tmpImgObj, timeLinePosImg, imageCount) {
    log.debug("START","addImgPropToContObj");
	var relRectImage = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpFrameObj.x, tmpFrameObj.y, tmpFrameObj.w, tmpFrameObj.h));
	saveDimensionsInfoToContObj(contImgObj, relRectImage);

	contImgObj.IsMutable = "true";
	setEditableProperty(contImgObj, tmpFrameObj);

	
	if(tmpImgObj != null){		
		var duration = tmpFrameObj.duration;
		contImgObj.FilePath = retrieveFileName(Utils.decodeThumbPath(tmpImgObj.imageSrc));
		contImgObj.OriginalPath = tmpImgObj.OriginalPath;
		contImgObj.ThumbPath = tmpImgObj.thumbPath;
		contImgObj.ImageRatio = 0;
		/*For Fit to Screen (0 : Fit to Screen / 1 : aspect ratio)*/
		
		contImgObj.Duration = SaveTemplate.getDurationInHrMinSec(duration)+".00";
		contImgObj.Start = SaveTemplate.getDurationInHrMinSec(timeLinePosImg)+".00";
		timeLinePosImg = timeLinePosImg + getParseIntInDec(duration);	
		contImgObj.DurationPolicy = "3";
		contImgObj.RepeatPeriod = SaveTemplate.getDurationInHrMinSec(duration*imageCount)+".00";
		
		contGroupObj.Duration = contImgObj.Duration;
		contGroupObj.Start = contImgObj.Start;
		contGroupObj.DurationPolicy = contImgObj.DurationPolicy;
		contGroupObj.RepeatPeriod = contImgObj.RepeatPeriod;	
		
		contImgObj.OrginalWidth = tmpImgObj.orgW;
		contImgObj.OriginalHeight = tmpImgObj.orgH;
		var cropCord = templateObj.getImgElmCropCoord(tmpImgObj,tmpFrameObj);
		contImgObj.ClipLeft = cropCord.l;
		contImgObj.ClipRight = contImgObj.OrginalWidth - cropCord.r;
		contImgObj.ClipTop = cropCord.t;
		contImgObj.ClipBottom = contImgObj.OriginalHeight - cropCord.b;
		contImgObj.scale = tmpImgObj.scale;
		contImgObj.Opacity = tmpImgObj.opacity;
		
		if(FREE_ROTATION_ALLOWED && tmpFrameObj.bSlideshow == false && templateObj.frameLayout == BLANK_LAYOUT && Utils.isHighEndModel(globlePlayerType))
		{
			contImgObj.Rotation = getParseIntInDec(tmpFrameObj.rotation);	
		}
		else
		{
			contImgObj.Rotation = getParseIntInDec(tmpImgObj.rotation);
		}
		
        
        if(globlePlayerType==RMD_MODEL){        	
        	var filesToCropInfo = {}; 	
        	var filesToRotateInfo = {}; 
        	var srcPath = contImgObj.OriginalPath;
        	var destPath = "";
        	var rotation = contImgObj.Rotation;
	        if(isIOS()){
	    		destPath = SaveTemplate.contentsFolderpath +"ImageOp/"+ renameImageOpFiles(contImgObj.FilePath,contImgObj);
	        }else{
        		contImgObj.CroppedImagePath = "TEST";
				destPath = SaveTemplate.contentsFolderpath +"ImageOp/"+ renameImageOpFiles(contImgObj.OriginalPath,contImgObj);
	        }
	        if (templateObj.orientation == PORTRAIT) {
	        	contImgObj.NT14_FilePath = contImgObj.FilePath;
	        	rotation = rotation +270;
	        }
        	if(contImgObj.ClipLeft!=0 || contImgObj.ClipRight!=0 || contImgObj.ClipTop!=0 || contImgObj.ClipBottom!=0){
		        	filesToCropInfo.SrcPath = srcPath;
			        filesToCropInfo.DestPath = destPath;
			        filesToCropInfo.Rotation = rotation;
			        filesToCropInfo.ClipLeft = cropCord.l;
			        filesToCropInfo.ClipRight = cropCord.t;
			        filesToCropInfo.ClipTop = cropCord.r-cropCord.l;
			        filesToCropInfo.ClipBottom = cropCord.b-cropCord.t;
			        filesToCropJson.filesToCropArrs.push(filesToCropInfo);
			} else if (rotation > 0) {
					filesToRotateInfo.SrcPath = srcPath;
			        filesToRotateInfo.DestPath = destPath;
			        filesToRotateInfo.Rotation = rotation;
			        
			        filesToRotateJson.filesToRotateArrs.push(filesToRotateInfo);	
			}else{
				console.log("No operation required");
			}
        }
		if(tmpFrameObj.transitionEffect !=undefined && tmpFrameObj.transitionEffect!=="" && tmpFrameObj.transitionEffect!="None"){
			contImgObj.EffectInName = SaveTemplate.getEffectForLFD(tmpFrameObj.transitionEffect,contImgObj);
			contImgObj.EffectInDuration = "00:00:01.00";	
		}	
		if(Utils.decodeThumbPath(tmpImgObj.imageSrc).indexOf(SaveTemplate.contentsFolderpath) == -1){
			filesToCopy.push(Utils.decodeThumbPath(tmpImgObj.imageSrc));
		}	
	}
    log.debug("COMPLETED","addImgPropToContObj");
	return 	timeLinePosImg;
};
function renameImageOpFiles(filePath,contImgObj){
	var fileName = retrieveFileName(filePath);
	if(fileName==undefined || fileName==""){
		return "";
	}
    var fileExt = fileName.substring(fileName.lastIndexOf('.'));
	var randomNo = Math.floor((Math.random() * 1000) + 1);
	fileName = fileName.replace(fileExt,"") + "_" + randomNo +fileExt;
	contImgObj.CroppedImagePath = fileName;    	
    	return fileName;
}
function cropAndRotateImages(){
	console.log("filesToCropJson : "+filesToCropJson);
	if(filesToCropJson!= null && filesToCropJson.filesToCropArrs.length>0){
		mUtilityManager.imageCrop(JSON.stringify(filesToCropJson),function(responseImageSave) {							
				console.log("Cropped ::"+JSON.stringify(filesToRotateJson) );
		}, function(){
			console.log("Fail to crop");
		});
	}
	if(filesToRotateJson!= null && filesToRotateJson.filesToRotateArrs.length>0){
		mUtilityManager.imageRotate(JSON.stringify(filesToRotateJson), function(responseImageSave) {							
			console.log("Rotated ");
		}, function(){
			console.log("Fail to rotate");
		});	
	}	          
}
function addCommonTextPropForSaveTemp(ContntObj,tmpltObj)
{
	ContntObj.TextStrikeOut = 0;
	ContntObj.TextBold = tmpltObj.fontBold;
	ContntObj.TextUnderLine = tmpltObj.fontUnderLine;
	ContntObj.TextFontSize = tmpltObj.fontSize;
	ContntObj.TextItalic = tmpltObj.fontItalic;
	ContntObj.TextHAlign = SaveTemplate.setAlignFrmTempObjToContentObj(tmpltObj.hAlign,true);
	ContntObj.TextVAlign = SaveTemplate.setAlignFrmTempObjToContentObj(tmpltObj.vAlign,false);
	ContntObj.FillColor = "241;241;241";
	ContntObj.TextColor = "0:0:0";
	ContntObj.TextFontName = tmpltObj.fontFamily;
}
SaveTemplate.addTxtPropToContObj = function(contTxtObj, tmpTxtObj, textName) {
	var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
	
	var relRectTxt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpTxtObj.x, tmpTxtObj.y, tmpTxtObj.w, tmpTxtObj.h));
	saveDimensionsInfoToContObj(contTxtObj, relRectTxt);
	addCommonTextPropForSaveTemp(contTxtObj,tmpTxtObj);
	contTxtObj.Name = textName;
	contTxtObj.TextValue = tmpTxtObj.text;
	contTxtObj.TextImage = tmpTxtObj.textImageName;	
	if(globlePlayerType==RMD_MODEL && templateObj.orientation == PORTRAIT) {
		contTxtObj.NT14_TextImage = contTxtObj.TextImage;
	}
	contTxtObj.TextImageFile = tmpTxtObj.textImageName;	
	if(tmpTxtObj.bgColor != undefined){		
		contTxtObj.FillColor = SaveTemplate.changeColorFormat(tmpTxtObj.bgColor);		
	}
	if(tmpTxtObj.bgAlpha == undefined){
		contTxtObj.FillOpacity = 100;
	}else{
		contTxtObj.FillOpacity = tmpTxtObj.bgAlpha;
	}	
	contTxtObj.Opacity = 100;
	contTxtObj.SelectOpacity = 0;
	contTxtObj.TextEffect = 0;
	var textFontName = contTxtObj.TextFontName + ".ttf";
	if(fontListIsDownloadedFlags[textFontName]){
		contTxtObj.TextFontFile = SaveTemplate.sdcardFullPath + ENGLISH_FONT_PATH + "/" + textFontName;
	}else{
		contTxtObj.TextFontFile = FONT_RES_ITEMS +"/" + textFontName;	
	}		
	
	if(tmpTxtObj.fontColor != 'undefined' && tmpTxtObj.fontColor != ""){		
		contTxtObj.TextColor = SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(tmpTxtObj.fontColor));		
	}
	contTxtObj.Textface = tmpTxtObj.fontFamily;
	contTxtObj.TextWordWrap = "False";
	contTxtObj.TextHTML =  SaveTemplate.getTextHtml(tmpTxtObj);
	contTxtObj.TextDirection = 0;
	if(tmpTxtObj.bTextSlide ){
		contTxtObj.TextDirection = tmpTxtObj.slideType;		
	}
	contTxtObj.TextSpeed = tmpTxtObj.slideSpeed;
	contTxtObj.TextDisplayDirection = 0;		
	contTxtObj.TextEffect = 0;
	if(Utils.isHighEndModel(globlePlayerType))
	{
		contTxtObj.TextFormat =  SaveTemplate.getTextFormat(tmpTxtObj);
		contTxtObj.TextFormatCopy = (((contTxtObj.TextFormat).replace(/(\r\n|\n|\r)/g,"")).replace(/</g,"&lt;")).replace(/>/g,"&gt;");	
	}
};
SaveTemplate.setAlignFrmTempObjToContentObj = function(alignId,isHor)
{
	var retStr="";
	if(isHor)
	{
		retStr = alignId=='center'?1:(alignId == 'right'?2:0);				
	}
	else
	{
		retStr = alignId=='middle'?1:(alignId == 'bottom'?2:0);
	}
	return retStr;
};
SaveTemplate.getTextHtml=function(tmpTxtObj){	
	text= $.trim(tmpTxtObj.text.replace(/&nbsp;/ig,""));
	//text=rmvHtmlFromStr(text);
	//text=text.replace(/&amp;/ig,"&");
	text=Utils.replaceLastBrOfText(text);
	textLines=text.split("<br>");	
	var txtArrLen=textLines.length;
	var finalTextStr='';
	var tempStr = '', hexFirstPart,hex,i;
	for(i=0;i<txtArrLen;i++)
	{
	    tempStr = textLines[i];
	    //Commented following code and added method getTextHtml in UploadTemplate.js to fix template not re-rendering issue on having more than one "enter" in text
		/*if(i==0){
			tempStr = textLines[i];
		}else{
		    hexFirstPart  = Number(textLines[i].charCodeAt(0)).toString(16);
			if(hexFirstPart != "a"){
			    hex = Utils.ascii_to_hexa(textLines[i]);
				tempStr = Utils.hex_to_ascii("0D"+this.privateKey+"0A"+this.privateKey+ hex);
			}else{
				tempStr = textLines[i]; *//* Fixed Re-render text issue DF161024-00054 fixed*//*
			}			
		}	*/
		finalTextStr = finalTextStr + '<p align="'+tmpTxtObj.hAlign+'">'+ tempStr; 
	}	
	finalTextStr = '<font face="'+tmpTxtObj.fontFamily+'" color="'+tmpTxtObj.fontColor+'" size="'+ tmpTxtObj.fontSize+'">'+finalTextStr+'</font>';
	return finalTextStr;
};
SaveTemplate.getTextFormat=function(tmpTxtObj){	
	var textFormatObj = {range_start:"0",range_length:"5",font_name:tmpTxtObj.fontFamily,font_size:"148.8",char_spacing:"0.0",bold:(tmpTxtObj.fontBold?"1":"0"),
						 italic:(tmpTxtObj.fontItalic?"1":"0"),underline:"0",strike:(tmpTxtObj.fontUnderLine?"1":"0"),font_color:get8hexFrmRgba(tmpTxtObj.fontColor,tmpTxtObj.alpha),shadow:(tmpTxtObj.isShdwApplied==false?"0":"1"),
						 shadow_offs:"3",shadow_angle:"45",shadow_blur:"0",shadow_color: get8hexFrmRgba(tmpTxtObj.shdwClr,tmpTxtObj.shdwOpc),outline:(tmpTxtObj.isStrkApplied==false?"0":"1"),outline_thick:"3.0",
						 outline_color: get8hexFrmRgba(tmpTxtObj.strkClr,tmpTxtObj.strkOpc),line_spacing:"0.0"};
	var textFormatStr = '';						 
	for (var key in textFormatObj) {
	  if (textFormatObj.hasOwnProperty(key)) {
	  	textFormatStr+=(key +'="' + textFormatObj[key] + '" ');
	  }
	}	
	textFormatStr = '<TEXT_FORMAT><format '+textFormatStr+'/></TEXT_FORMAT>';
	 
	return 	 textFormatStr;
};
SaveTemplate.addDigClkPropToContObj = function(contDigClkObj, tmpDigClkObj) {
	var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
	var relRectTxt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpDigClkObj.x, tmpDigClkObj.y, tmpDigClkObj.w, tmpDigClkObj.h));
	saveDimensionsInfoToContObj(contDigClkObj, relRectTxt);
	addCommonTextPropForSaveTemp(contDigClkObj,tmpDigClkObj);
	contDigClkObj.TimeFormat = tmpDigClkObj.format;	
	contDigClkObj.DigitalClockGMT = "(GMT) Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London";
	contDigClkObj.DigitalClockSeperator = "Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London";
	contDigClkObj.DigitalClockDaylight = 0;
	contDigClkObj.FillOpacity = 0;
	contDigClkObj.DisplayLanguage = digitalClockLanguage[tmpDigClkObj.DisplayLanguage].index;
	if(tmpDigClkObj.bgColor != 'undefined' && tmpDigClkObj.bgColor != ""){
		contDigClkObj.FillColor = SaveTemplate.changeColorFormat(tmpDigClkObj.bgColor);
		contDigClkObj.FillOpacity = tmpDigClkObj.bgAlpha;
	}
	if(tmpDigClkObj.fontColor != 'undefined' && tmpDigClkObj.fontColor != ""){		
		contDigClkObj.TextColor = SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(tmpDigClkObj.fontColor));		
	}
	contDigClkObj.TextDirection = 0;
    contDigClkObj.TextSpeed = 0;
	if(tmpDigClkObj.bTextSlide ){
		contDigClkObj.TextDirection = tmpDigClkObj.slideType;		
		contDigClkObj.TextSpeed = tmpDigClkObj.slideSpeed;
	}
	contDigClkObj.TextDisplayDirection = 0;
	contDigClkObj.TextEffect = 0;
};

SaveTemplate.addShapesPropToContObj  = function(type,contShapesObj, tmpShapesObj){
	
	var relRectShapes = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpShapesObj.x, tmpShapesObj.y, tmpShapesObj.w, tmpShapesObj.h));
	saveDimensionsInfoToContObj(contShapesObj, relRectShapes);
	
	contShapesObj.Start = "00:00:00.00";							
	contShapesObj.Duration = "23:59:59.00";		
	contShapesObj.DurationPolicy = "1";  
	contShapesObj.RepeatPeriod = "23:59:59.00";
	contShapesObj.IsMutable = "false";
	contShapesObj.Opacity = tmpShapesObj.opacity;
	contShapesObj.Rotation = tmpShapesObj.rotation;
	contShapesObj.typeName = tmpShapesObj.shapeDetails.typeName;
	contShapesObj.elementName = tmpShapesObj.shapeDetails.elementName;
	var shapeObj = tmpShapesObj.shapeDetails;
	contShapesObj.LineColor = SaveTemplate.changeColorFormat(shapeObj.LineColor);
	contShapesObj.FigureStrokeWidth = shapeObj.FigureStrokeWidth;
	contShapesObj.FigureStrokePattern = shapeObj.FigureStrokePattern;
	contShapesObj.FigureStrokeOpacity = shapeObj.FigureStrokeOpacity;
	contShapesObj.FillOpacity = shapeObj.FillOpacity;
	contShapesObj.FillRange = shapeObj.FillRange;
	contShapesObj.OriginalImage = tmpShapesObj.OriginalPath;
	contShapesObj.ImageFilePath = retrieveFileName(tmpShapesObj.OriginalPath);
	contShapesObj.thumbPath = retrieveFileName(Utils.decodeThumbPath(tmpShapesObj.thumbPath));
    if(isIOS()){
        contShapesObj.ImageFilePath = contShapesObj.thumbPath;
    }
	contShapesObj.FillColor = SaveTemplate.changeColorFormat(shapeObj.FillColor == "rgb()"?"":shapeObj.FillColor);	
	fillSpecificParaToShapeContObj(type,contShapesObj,tmpShapesObj.shapeDetails);
	contShapesObj.OrginalWidth = tmpShapesObj.orgW;
	contShapesObj.OriginalHeight = tmpShapesObj.orgH;
	contShapesObj.thumbOrgW = shapeObj.thumbOrgW;
	contShapesObj.thumbOrgH = shapeObj.thumbOrgH;
	if(contShapesObj.OriginalImage!="")
	{
		var cropCord = templateObj.getShapeImgElmCropCoord(tmpShapesObj,true);
		contShapesObj.ClipLeft = cropCord.l;
		contShapesObj.ClipRight = contShapesObj.OrginalWidth - cropCord.r;
		contShapesObj.ClipTop = cropCord.t;
		contShapesObj.ClipBottom = contShapesObj.OriginalHeight - cropCord.b;
		contShapesObj.scale = tmpShapesObj.scale;	
	}
	
	if(tmpShapesObj.thumbPath!=undefined && tmpShapesObj.thumbPath!="" && Utils.decodeThumbPath(tmpShapesObj.thumbPath).indexOf(SaveTemplate.contentsFolderpath) == -1){
			filesToCopy.push(Utils.decodeThumbPath(tmpShapesObj.thumbPath));
	}	
};


SaveTemplate.addAnalogClkPropToContObj = function(contAnalogClkObj, tmpAnalogClkObj) {
	var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
	var relRectTxt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpAnalogClkObj.x, tmpAnalogClkObj.y, tmpAnalogClkObj.w, tmpAnalogClkObj.h));
	saveDimensionsInfoToContObj(contAnalogClkObj, relRectTxt);

	var icons = getAnlgClokIcnsByType(tmpAnalogClkObj.elementType);        
	contAnalogClkObj.ClockBackImage = retrieveFileName(icons.ClockBackImage);
	contAnalogClkObj.ClockHourImage = retrieveFileName(icons.ClockHourImage);
	contAnalogClkObj.ClockMinuteImage = retrieveFileName(icons.ClockMinuteImage);
	contAnalogClkObj.ClockSecondImage = retrieveFileName(icons.ClockSecondImage);
	contAnalogClkObj.ClockType = "2";
	contAnalogClkObj.ClockDisplayType = tmpAnalogClkObj.elementType;
	contAnalogClkObj.Name = "Analog Clock";
	
	contAnalogClkObj.AnalogClockGMT = "(GMT) Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London";
	contAnalogClkObj.AnalogClockSeperator = "Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London";
	contAnalogClkObj.AnalogClockDaylight = 0;

	/* Added images to sticker list to copy them to content folder from assets folder*/
	stickersList.push(icons.ClockBackImage);	
	stickersList.push(icons.ClockHourImage);	
	stickersList.push(icons.ClockMinuteImage);	
	stickersList.push(icons.ClockSecondImage);
};
SaveTemplate.setNewsDisplayFormat = function(contRssObj,tmpRssObj)
{
	var rssElement = tmpRssObj.rssInfo;
	contRssObj.titleTextFontSize = rssElement.title.fontSize;
	contRssObj.titleTextHAlign = SaveTemplate.setAlignFrmTempObjToContentObj(rssElement.title.hAlign,true);
        contRssObj.titleTextColor = "0:0:0";
	if(rssElement.title.color != 'undefined' && rssElement.title.color != ""){		
		contRssObj.titleTextColor = SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(rssElement.title.color));		
	}
	contRssObj.pubDateTextFontSize = rssElement.date.fontSize;
	contRssObj.pubDateTextHAlign = SaveTemplate.setAlignFrmTempObjToContentObj(rssElement.date.hAlign,true);
    	contRssObj.pubDateTextColor = "0:0:0";
	if(rssElement.date.color != 'undefined' && rssElement.date.color != ""){		
		contRssObj.pubDateTextColor = SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(rssElement.date.color));		
	}
	contRssObj.descriptionTextFontSize = rssElement.description.fontSize;
	contRssObj.descriptionTextHAlign = SaveTemplate.setAlignFrmTempObjToContentObj(rssElement.description.hAlign,true);
    	contRssObj.descriptionTextColor = "0:0:0";
	if(rssElement.description.color != 'undefined' && rssElement.description.color != ""){		
		contRssObj.descriptionTextColor = SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(rssElement.description.color));		
	}
	if(rssElement.title.visible && rssElement.date.visible && rssElement.description.visible)
	{
		contRssObj.NewsDisplayOption = "3";		
	}
	else if(rssElement.title.visible && rssElement.description.visible)
	{
		contRssObj.NewsDisplayOption = "2";
	}
	else if(rssElement.title.visible && rssElement.date.visible)
	{
		contRssObj.NewsDisplayOption = "1";
	}
	else if(rssElement.title.visible)
	{
		contRssObj.NewsDisplayOption = "0";
	}
};
SaveTemplate.addRssPropToContObj = function(contRssObj, tmpRssObj) {
	var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
	var relRectTxt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpRssObj.x, tmpRssObj.y, tmpRssObj.w, tmpRssObj.h));
	saveDimensionsInfoToContObj(contRssObj, relRectTxt);

	contRssObj.RSS_URL = tmpRssObj.rssInfo.url;
	contRssObj.RssReloadDuration = tmpRssObj.rssInfo.reloadDuration;
	SaveTemplate.setNewsDisplayFormat(contRssObj,tmpRssObj);
	contRssObj.Name = "RSS";
	contRssObj.FillOpacity = 0;
	if(tmpRssObj.bgColor != 'undefined' && tmpRssObj.bgColor != ""){		
		contRssObj.FillColor = SaveTemplate.changeColorFormat(tmpRssObj.bgColor);
		contRssObj.FillOpacity = tmpRssObj.bgAlpha;
	}
	contRssObj.TextDirection = 0;
        contRssObj.TextSpeed = 0;
    	contRssObj.DISPLAY_CYCLE = tmpRssObj.rssInfo.flipSpeed;
	if(tmpRssObj.bTextSlide){
		contRssObj.TextDirection = tmpRssObj.slideType;		
		contRssObj.TextSpeed = tmpRssObj.slideSpeed;
		contRssObj.DISPLAY_CYCLE = 0;
	}
};

SaveTemplate.addWeatherPropToContObj = function(contWeatherObj, tmpWeatherObj) {
	var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
	var relRectWeather = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpWeatherObj.x, tmpWeatherObj.y, tmpWeatherObj.w, tmpWeatherObj.h));
	saveDimensionsInfoToContObj(contWeatherObj, relRectWeather);

	contWeatherObj.WeatherType = 0;
	if(tmpWeatherObj.elementType == widgetInfo.WEATHER_TODAY){
		contWeatherObj.WeatherType = 1;	
	}else if(tmpWeatherObj.elementType == widgetInfo.WEATHER_WEEK){
		contWeatherObj.WeatherType = 2;	
	}	
	contWeatherObj.Country = tmpWeatherObj.weather.country;
	contWeatherObj.City = tmpWeatherObj.weather.city;
	contWeatherObj.LocationKey = tmpWeatherObj.weather.cityId;
	contWeatherObj.Language = "4";
	contWeatherObj.LanguageCode = Utils.getLocaleSessionValue();
	//contWeatherObj.LanguageCode = validateLanguageForWeatherWidget(contWeatherObj.LanguageCode)?contWeatherObj.LanguageCode:"en";
	contWeatherObj.Background = tmpWeatherObj.weather.bgType;
	contWeatherObj.Opacity = tmpWeatherObj.opacity;
	contWeatherObj.Date = tmpWeatherObj.weather.dateTimeformat;
	contWeatherObj.Refresh = tmpWeatherObj.weather.refrshIntrvl;
	contWeatherObj.Unit = tmpWeatherObj.weather.unit;
};
SaveTemplate.addVidPropToContObj = function(contVidObj,tmpFrameObj, tmpVidObj, timeLinePosVid, vidCount) {
	var relRectVideo = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpFrameObj.x, tmpFrameObj.y, tmpFrameObj.w, tmpFrameObj.h));
	saveDimensionsInfoToContObj(contVidObj, relRectVideo);

	contVidObj.OrginalWidth = tmpVidObj.orgW;	
	contVidObj.OriginalHeight = tmpVidObj.orgH;
	contVidObj.FilePath = retrieveFileName(Utils.decodeThumbPath(tmpVidObj.imageSrc));
	contVidObj.FileName = tmpVidObj.fileName;
	contVidObj.OriginalPath = tmpVidObj.OriginalPath;
	contVidObj.ThumbPath = tmpVidObj.thumbPath;
	contVidObj.MovieRatio = 1;
	/*For aspect ratio (0 : Fit to Screen / 1 : aspect ratio)*/
	var duration = tmpVidObj.duration;	
	contVidObj.Duration = SaveTemplate.getDurationInHrMinSec(duration)+".00";
	contVidObj.Start = SaveTemplate.getDurationInHrMinSec(timeLinePosVid)+".00";
	timeLinePosVid = timeLinePosVid + getParseIntInDec(duration);	
	contVidObj.DurationPolicy = "3";
	/*Duration policy - 3 stands for LOOP*/
	contVidObj.Opacity = "100";
	contVidObj.MovieVolume = "100";	
	if(vidCount == 1){
		contVidObj.RepeatPeriod =  contVidObj.Duration;	
	}else{
		contVidObj.RepeatPeriod =  SaveTemplate.getDurationInHrMinSec(tmpFrameObj.duration)+".00";	
	}
	contVidObj.MovieMute = "True";
    if(Utils.isHighEndModel(globlePlayerType)){
        if(frameWithSelectedAudioTizen == tmpFrameObj.id){
            contVidObj.MovieMute = "False";
        }
    }else if(templateObj.audioFlag){
        if(ContentObj.SelectedAudioVideo =="VIDEO" || ContentObj.SelectedAudioVideo =="NONE"){
            contVidObj.MovieMute = "False";
        }
    }
	setEditableProperty(contVidObj, tmpFrameObj);
	if(Utils.decodeThumbPath(tmpVidObj.imageSrc).indexOf(SaveTemplate.contentsFolderpath) == -1){
		filesToCopy.push(Utils.decodeThumbPath(tmpVidObj.imageSrc));
	}
	return timeLinePosVid;
};
SaveTemplate.addInptSrcPropToContObj = function(contInptSrcObj, tmpFrameObj, tmpInptSrcObj) {
	var relRectInptSrc = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpFrameObj.x, tmpFrameObj.y, tmpFrameObj.w, tmpFrameObj.h));
        saveDimensionsInfoToContObj(contInptSrcObj, relRectInptSrc);
			
	contInptSrcObj.InputSourceType = tmpInptSrcObj.OriginalPath;
	if (globlePlayerType== RMD_MODEL){
		contInptSrcObj.Region = templateObj.inputSrcRegion;
	}
    contInptSrcObj.Sound = 0;
	if(Utils.isHighEndModel(globlePlayerType)){
        if(frameWithSelectedAudioTizen == tmpFrameObj.id){
            contInptSrcObj.Sound = 1;
        }
    }else if(templateObj.audioFlag == true && ContentObj.SelectedAudioVideo =="INPUTSOURCE"){
        contInptSrcObj.Sound = 1;
    }
	setEditableProperty(contInptSrcObj, tmpFrameObj);
};

SaveTemplate.addWebPropToContObj = function(contWebObj,tmpFrameObj, tmpWebObj) {
	var relRectTxt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpFrameObj.x, tmpFrameObj.y, tmpFrameObj.w, tmpFrameObj.h));
	saveDimensionsInfoToContObj(contWebObj, relRectTxt);
	contWebObj.WebURL = tmpWebObj.OriginalPath;
	contWebObj.WebRefreshNew = tmpWebObj.webRefreshInterval + ".00";
	setEditableProperty(contWebObj, tmpFrameObj);
};

SaveTemplate.addMediaRssPropToContObj = function(contMediaObj,tmpFrameObj, tmpMediaRssObj) {
	
	var relRectTxt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpFrameObj.x, tmpFrameObj.y, tmpFrameObj.w, tmpFrameObj.h));
	saveDimensionsInfoToContObj(contMediaObj, relRectTxt);
	contMediaObj.MrssURL = tmpMediaRssObj.mediaRssInfo.url;
	contMediaObj.MrssDuration = tmpMediaRssObj.mediaRssInfo.reloadDuration;
	contMediaObj.AspectFill = tmpMediaRssObj.mediaRssInfo.aspectFill;
	setEditableProperty(contMediaObj, tmpFrameObj);
};

SaveTemplate.addPptPropToContObj = function(contOfficeObj, tmpFrameObj, tmpPptObj, isPDF) {
	var relRectPpt = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpFrameObj.x, tmpFrameObj.y, tmpFrameObj.w, tmpFrameObj.h));
	saveDimensionsInfoToContObj(contOfficeObj, relRectPpt);
	contOfficeObj.FilePath = retrieveFileName(tmpPptObj.OriginalPath);
	contOfficeObj.OriginalPath = tmpPptObj.OriginalPath;
	if(isPDF){
        contOfficeObj.PdfGotoPage = 1;
	}
	setEditableProperty(contOfficeObj, tmpFrameObj);
};
SaveTemplate.addStickerPropToContObj = function(contStickerObj, tmpStickerObj) {	
	log.debug("FunctionIn: addStickerPropToContObj");
	var relRectSticker = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpStickerObj.x, tmpStickerObj.y, tmpStickerObj.w, tmpStickerObj.h));
    	saveDimensionsInfoToContObj(contStickerObj, relRectSticker);
	contStickerObj.Rotation = tmpStickerObj.rotation;
	if(tmpStickerObj.elementType == STICKER && tmpStickerObj.timeZoneOffset!="")
	{
		contStickerObj.EndStateBitmap = tmpStickerObj.fileName;
		contStickerObj.EndStateXML =  tmpStickerObj.timeZoneOffset;
		contStickerObj.EndStateXML = (((contStickerObj.EndStateXML).replace(/(\r\n|\n|\r)/g,"")).replace(/</g,"&lt;")).replace(/>/g,"&gt;");
	}
	else
	{
		contStickerObj.EndStateBitmap = retrieveFileName(tmpStickerObj.imageSrc);
		if(tmpStickerObj.imageSrc.indexOf(SaveTemplate.contentsFolderpath) == -1 && tmpStickerObj.elementType == STICKER)
		{
			stickersList.push(tmpStickerObj.imageSrc);
		}
		if(tmpStickerObj.elementType == HANDWRITING){
			//if(tmpStickerObj.imageSrc.indexOf(SaveTemplate.spenOuterFolderPath) != -1){// Commented to fix DF181008-00333
				var tempPath = tmpStickerObj.imageSrc;
				filesToCopy.push(tempPath);/*Add handwriting files path(outer folder path) to be copied*/
				filesToCopy.push(tempPath.substring(0,tempPath.indexOf("_SPEN")) + ".png"); /* Add handwriting files ending without "_SPEN"*/
			//}
			updteHwPathInTempOjAndHwPathArr(tmpStickerObj);
		}
		/*For handwriting element path(inner spen folder path) should be saved in LFD object only after changing imageSrc(inner spen folder path) in template object*/
		contStickerObj.OriginalPath = tmpStickerObj.imageSrc;
	}
	log.debug("FunctionOut: addStickerPropToContObj");
};
SaveTemplate.addDecoImgPropToContObj  = function(contDecoImgObj, tmpDecoImgObj){
	var relRectDecoImg = templateObj.orgRectFrmRelRect(templateObj.mainFrame, new rect(tmpDecoImgObj.x, tmpDecoImgObj.y, tmpDecoImgObj.w, tmpDecoImgObj.h));
        saveDimensionsInfoToContObj(contDecoImgObj, relRectDecoImg);	
	contDecoImgObj.Width = contDecoImgObj.Width<1?1:contDecoImgObj.Width;
	contDecoImgObj.Height = contDecoImgObj.Height<1?1:contDecoImgObj.Height;
	
	contDecoImgObj.FilePath = retrieveFileName(Utils.decodeThumbPath(tmpDecoImgObj.imageSrc));
	contDecoImgObj.OriginalPath = Utils.decodeThumbPath(tmpDecoImgObj.imageSrc);
	contDecoImgObj.IsMutable = "false";
	contDecoImgObj.Opacity = "100";
	if(contDecoImgObj.OriginalPath.indexOf("FreeTemplates/Embedded") != -1){
		stickersList.push(contDecoImgObj.OriginalPath);
	}
	if(globlePlayerType == RMD_MODEL && templateObj.orientation == PORTRAIT){
		var filesToRotateInfo = {};
		var srcPath = contDecoImgObj.OriginalPath;
		var rotation = contDecoImgObj.Rotation;
		console.log("srcPath ::"+srcPath);
		var destPath = SaveTemplate.contentsFolderpath +"ImageOp/"+ retrieveFileName(srcPath);				
		console.log("destPath ::"+destPath);
		filesToRotateInfo.SrcPath = srcPath;
		filesToRotateInfo.DestPath = destPath;
        filesToRotateInfo.Rotation = 270;    
        filesToRotateJson.filesToRotateArrs.push(filesToRotateInfo);	
   	}		
	if(tmpDecoImgObj.elementType == HANDWRITING){
		//if(tmpDecoImgObj.imageSrc.indexOf(SaveTemplate.spenOuterFolderPath) != -1){//Commented to fix DF181008-00333
			var tempPath = tmpDecoImgObj.imageSrc;
			filesToCopy.push(tempPath); /*Add handwriting files path(outer folder path) to be copied*/
			filesToCopy.push(tempPath.substring(0,tempPath.indexOf("_SPEN")) + ".png"); /* Add handwriting files ending without "_SPEN"*/
		//}
		updteHwPathInTempOjAndHwPathArr(tmpDecoImgObj);
		/* For handwriting element path(inner spen folder path) should be saved in LFD object only after changing imageSrc(inner spen folder path) in template object*/
		contDecoImgObj.OriginalPath = tmpDecoImgObj.imageSrc;
	}	
};
SaveTemplate.addSoundElement = function(){
    var contPageObj = ContentObj.Page[1];
	var contentGrpSize = contPageObj.Group.length;
	var grpArr = new Group_Array();
	contPageObj.Group.push(grpArr);
	var soundArr = new Sound_Array();
	contPageObj.Group[contentGrpSize].Sound.push(soundArr);
	var contSoundObj = contPageObj.Group[contentGrpSize].Sound[0];
	contSoundObj.FilePath = templateObj.audioFileName;
	contSoundObj.OriginalPath = templateObj.audioPath;
	contSoundObj.SoundMute = "True";
	if(templateObj.audioFlag && ContentObj.SelectedAudioVideo=="AUDIO"){
		contSoundObj.SoundMute = "False";	
	}
	contSoundObj.SoundVolume = "100";
};
SaveTemplate.successLfdFileCreation = function() {
    log.debug("START","successLfdFileCreation");
	addFilesToCopyArray();
    
    log.debug("COMPLETED","successLfdFileCreation");
};

/*Will change "rgb(255,0,255)" to "255;0;255"*/
SaveTemplate.changeColorFormat = function(rgbColor){
	if (rgbColor != undefined && rgbColor != "") {
	   rgbColor = rgbColor.match(/\d+/g);
	   if(rgbColor!=""){
	   		rgbColor = rgbColor.join(";");	
	   }	
	}
	return rgbColor;
};
/*Will change "255;0;255;1" to "255;0;255"*/
SaveTemplate.removeAlpha = function(rgbaColor){
	var str = rgbaColor.split(";");
	return str[0]+";"+str[1]+";"+str[2]; 
};
function saveText(textElemObj){
    log.debug("START","saveText");
	var textImagePath;
					
	textImagePath = SaveTemplate.contentsFolderpath + textElemObj.textImageName;
	
	saveImageDataToLibrary(textImagePath,"TEXT_IMAGE",textElemObj.textImageSrc);
    log.debug("COMPLETED","saveText");
}
	
	
/************************* COPY FILES TO CONTENTS FOLDER*****************************/
var srcPath = null;
var destFolder = null;
var filesToCopy = [];
var stickersList = [];
var fileIndex = 0;

function addFilesToCopyArray() {
    log.debug("START","addFilesToCopyArray");
	/*Copy stickers*/
	if(stickersList != null){
		var i;
		for(i=0;i < stickersList.length;i++){
		    if(stickersList[i].indexOf("/.ETabletAuthor/FreeTemplates") != -1){
                filesToCopy.push(stickersList[i]);
		    }else{
		        stickerCopy(stickersList[i].replace("/android_asset/",""),SaveTemplate.contentsFolderpath);
		    }						
		}		
	}
	/*Copy other files*/
	if (filesToCopy != null && filesToCopy.length > 0) {
		filesToCopy[fileIndex] = filesToCopy[fileIndex].replace("file://", "");
		copyFile(filesToCopy[fileIndex]);
	} else {
		navigateFrmTemplate();
	}
    log.debug("COMPLETED","addFilesToCopyArray");
}

function copyFile(src){
	srcPath = src;
    var srcFolder = retrieveFileFullPath(srcPath);
	if(srcPath.indexOf("/Spen") != -1){
		/* Copy handwriting files from outer spen folder to inner spen folder*/
		destFolder = SaveTemplate.contentsFolderpath + SaveTemplate.spenInnerFolderName;
	}else{
		/* Copy files to content folders path*/
		destFolder = SaveTemplate.contentsFolderpath;
	}
	if(srcFolder == destFolder){//Fixed DF181008-00333
        onCopyToSuccess();
    }else{
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotNewFS, failCopy);
    }
}

function gotNewFS(fileSystem) {
    
    srcPath = srcPath.replace(Utils.getSystemRootPath(), "");
    destFolder = destFolder.replace(Utils.getSystemRootPath(), "");
    
    
    
   if(deviceType == "iPad" || deviceType == "iPhone"){
        
      console.log("@ ******* Copy Thumnail Image ******* "+destFolder);
       cordova.exec(function(){
                 onCopyToSuccess();
                 console.log("@Success");
                 }, function(){
                 
                 console.log("@Fail");
                 }, "StickerCopyPlugin", "fsOperationTemplate", [srcPath,destFolder]);
 
    }else{

        fileSystem.root.getFile(srcPath, null, function(file) {
		fileSystem.root.getDirectory(destFolder, {}, function(directory) {

			file.copyTo(directory, file.name, onCopyToSuccess, failCopy);

		}, function(error) {
			console.log(error, "Directory Error ");
		});

	  }, function(error) {
		console.log(error, "File Error ");
	});
   
    }
    
    
}

function onCopyToSuccess(file) {
	log.debug("START","onCopyToSuccess");
	if (fileIndex < filesToCopy.length - 1) {
		fileIndex++;
		filesToCopy[fileIndex] = filesToCopy[fileIndex].replace("file://", "");
		copyFile(filesToCopy[fileIndex]);
	} else {
		/*reset files to copy array and stickers list array*/
		filesToCopy = [];
		stickersList = [];
		fileIndex = 0;				
		navigateFrmTemplate();
	}
    log.debug("COMPLETED","onCopyToSuccess");
};

function failCopy(evt) {
	console.log("fail not able to call copyFile ");
	if(isIOS()){
	 	onCopyToSuccess();
	}
}
function updteHwPathInTempOjAndHwPathArr(elm){
	var hwTempPath = elm.imageSrc;			
	hwTempPath = SaveTemplate.spenInnerFolderPath + "/" + retrieveFileName(hwTempPath);
	elm.imageSrc = Utils.getSystemRootPath() + hwTempPath;
	hwPathArr.push("/"+hwTempPath);/*Push all used handwriting files in hwPathArr array*/
	
	/*Add handwriting files without "_SPEN" in hwPathArr array*/
	hwTempPath = hwTempPath.substring(0,hwTempPath.indexOf("_SPEN")) + ".png";
	hwPathArr.push("/"+hwTempPath);	
}
template.prototype.deleteUnUsedHandWritingFiles=function(goToHomeWithoutSaveFlag){
	var currObj=this;
	if(isIOS() || hwPathArr.length == 0){
		currObj.goToHomeWithoutSave(goToHomeWithoutSaveFlag);
		return;
	}
	if (templateFlag == SAVE_AND_SCHEDULE_TEMPLATE || goToHomeFlag  || goToStep1Flag  || goToHomeWithoutSaveFlag ){
		var folderPath ="";		
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
			function(fileSystem) {
				folderPath = SaveTemplate.spenInnerFolderPath;
				
				console.log("folderPath "+folderPath);
				fileSystem.root.getDirectory(folderPath, {create : false},	
					function(directoryEntry) {
						var directoryReader = directoryEntry.createReader();
				        /* Get a list of all the entries in the directory*/
				        directoryReader.readEntries(
				        		function (entries){
				        	        var i,len;
				        	        len = entries.length;
				        	        for (i=0; i<len; i++) {			        	            
				        	            if(entries[i].isFile && hwPathArr.indexOf(entries[i].fullPath)==-1){
				        	            	entries[i].remove(function(file){ 
												console.log("Removal succeeded ");															
											},function(error){ 	
												console.log("Error removing file");
												currObj.goToHomeWithoutSave(goToHomeWithoutSaveFlag);
											});
				        	            }
				        	        }
				        	        currObj.goToHomeWithoutSave(goToHomeWithoutSaveFlag);
				        	    }, function(evt) {
									console.log( "Error: readEntries FAILURE");
									currObj.goToHomeWithoutSave(goToHomeWithoutSaveFlag);
								});			        
					}, function(evt) {
						console.log( "Error: getDirectory FAILURE");
						currObj.goToHomeWithoutSave(goToHomeWithoutSaveFlag);
					});
			},function (evt) {
		    	console.log( "Error: FILE SYSTEM FAILURE");	  
		    	currObj.goToHomeWithoutSave(goToHomeWithoutSaveFlag);
	    });
	}
};
template.prototype.goToHomeWithoutSave=function(goToHomeWithoutSaveFlag){
	if(goToHomeWithoutSaveFlag){
	    document.location.href = "../quickstart/QuickStart.html";
	}
};
function gotoQuickStartPage(){
	if(templateObj){
    	templateObj.deleteUnUsedHandWritingFiles(true);	
    }else{
    	document.location.href = "../quickstart/QuickStart.html";
    }  
}

/**********************CREATE TEMPLATE FOLDERS**********************************/
function createMyTemplateFolder() {
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, successMTCreateFolder, failMTCreateFolder);
};
function successMTCreateFolder(fileSystem) {
	var folderPath = SaveTemplate.myTemplatePath + SaveTemplate.templateName;
	fileSystem.root.getDirectory(folderPath, {
		create : true,
		exclusive : false
	}, onMTDirCreate, onMTDirCreateFail);
}

function failMTCreateFolder() {
	console.log("Unable to create folder");
}

function onMTDirCreate() {
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, successCreateImageOpFolder, function() {
		console.log("Fail");
	});
}

function onMTDirCreateFail() {
	console.log("Unable to create directory");
}
function successCreateImageOpFolder(fileSystem){
	var imageOpFolderPath = SaveTemplate.myTemplatePath + SaveTemplate.templateName +"/ImageOp" ;	
	fileSystem.root.getDirectory(imageOpFolderPath, {
			create: true, 
			exclusive: false
		}, onMTImageOpDirCreate, onMTImageOpDirCreateFail);
}
function onMTImageOpDirCreate(){
	console.log("ImageOp created");		
	/* Create spen folder inside template folder*/
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, successCreateSpenFolder, function() {
		console.log("Fail");
	});		
}
function successCreateSpenFolder(fileSystem){
	fileSystem.root.getDirectory(SaveTemplate.spenInnerFolderPath, {
		create: true, 
		exclusive: false
	}, onMTSpenDirCreate, onMTSpenDirCreateFail);	
}
function onMTImageOpDirCreateFail() {
	console.log("Unable to create imageOp dir");
}
function onMTSpenDirCreate(){
	console.log("Spen folder created");	
	SaveTemplate.readEmptyLfdFile();
}
function onMTSpenDirCreateFail() {
	console.log("Unable to create spen dir");
}

function setTemplateInfo(insertOrUpdate) {
    log.debug("START","setTemplateInfo");
	var orientationType = "landscape";
	if (templateObj.orientation == PORTRAIT) {
		orientationType = "portrait";
	}
	if(SaveTemplate.lfdFilePathAfterRoot == undefined || SaveTemplate.lfdFilePathAfterRoot == ""){
		SaveTemplate.lfdFilePathAfterRoot = SaveTemplate.myTemplatePath + SaveTemplate.templateName + "/" + SaveTemplate.templateName + ".LFD";
	}	
        var templateThumPath = SaveTemplate.lfdFilePathAfterRoot + ".PNG";
	if (insertOrUpdate == 'insert') {
		/*Delete is always required before insert because in some cases template id needs to be changed.
		Eg - defect DF150527-00862 wrong schedule is created (overwrite issue) - There is no portrait template, but portrait time bar exists.*/
		deleteTemplateFromDBByName(SaveTemplate.templateName+".LFD", globlePlayerType);
		insertTemplateInfo(retrieveFileName(SaveTemplate.lfdFilePathAfterRoot), SaveTemplate.lfdFilePathAfterRoot, templateThumPath, templateObj.selCategory, orientationType,globlePlayerType, TEMPLATE_DEFAULT_DURATION);
	} else {
		var currTemplateDuration = getTemplateDurationFrmTemplateName(retrieveFileName(SaveTemplate.lfdFilePathAfterRoot));		
		updateTemplateFromDB(retrieveFileName(SaveTemplate.lfdFilePathAfterRoot), SaveTemplate.lfdFilePathAfterRoot, templateThumPath, templateObj.selCategory, orientationType, globlePlayerType,currTemplateDuration);
	}	
	log.debug("COMPLETED","setTemplateInfo");
}

function createNewTemplate() {	
	var idx = 1;
	var tempName = "";
	var templateNameList = getTemplateNameList();
	do{
		tempName = langObj.template.COM_TEXT_TEMPLATE_P + ((idx < 10)? ' 0' :' ') + idx;
  		idx++;
	} while (templateNameList.indexOf(tempName) != -1);	
  	return tempName;
}

/***************************TEMPLATE UTILS METHODS********************************************/
function setEditableProperty(contElmObj, tmpFrameObj){
    contElmObj.IsEditable = "false";
    if(tmpFrameObj.isEditable ){
		contElmObj.IsEditable = "true";
	}
}

function retrieveFileName(path) {
	var temp;
	if(path!=undefined && path!=""){
		temp = path.substring(path.lastIndexOf('/') + 1);
		return temp;
	}else{
		return path;
	}	
}

function retrieveFileFullPath(path) {
	var temp;
	if(path!=undefined && path!=""){
		temp = path.substring(0, path.lastIndexOf('/'));
		return temp;
	}else{	 
		return path;		
	}
}
var saveRect = function (x, y, w, h) {
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
};
SaveTemplate.getDurationInHrMinSec = function(durationSecs){
	if (durationSecs == undefined || durationSecs == "") { durationSecs;
	}
	var hrs = Math.floor(durationSecs/3600);
	durationSecs = durationSecs % 3600;
	var mins = Math.floor(durationSecs/60);	
	var secs = durationSecs % 60;
	if(secs<10){
		secs = "0"+secs;
	}
	if (mins < 10) {
		mins = "0"+mins;
	}
	if (hrs < 10) {
		hrs = "0"+hrs;
	}
	var finalDuration = hrs+":"+mins+":"+secs;
	return finalDuration;
};
SaveTemplate.getEffectForLFD=function(effect,contImgObj){		
	var selEffect;
	switch(effect) {
		case "None":
			selEffect="";
		break;
		case "Cut_Black_Fade":
			selEffect="Ext_Eff_Fade::CutBlackFade";
		break;
		case "ShortFade_East":
			selEffect="Ext_Eff_FlyOn::ShortFadeEast";
		break;
		case "ShortFade_West":
			selEffect="Ext_Eff_FlyOn::ShortFadeWest";
		break;
		case "ShortFade_North":
			selEffect="Ext_Eff_FlyOn::ShortFadeNorth";
		break;
		case "ShortFade_South":
			selEffect="Ext_Eff_FlyOn::ShortFadeSouth";
		break;
		case "Wipe_North":
			selEffect="Ext_Eff_Reveal::Wipe";
			contImgObj.EffectInDirection = 0;
		break;
		case "Wipe_East":
			selEffect="Ext_Eff_Reveal::Wipe";
			contImgObj.EffectInDirection = 1;
		break;
		case "Wipe_South":
			selEffect="Ext_Eff_Reveal::Wipe";
			contImgObj.EffectInDirection = 2;
		break;
		case "Wipe_West":
			selEffect="Ext_Eff_Reveal::Wipe";
			contImgObj.EffectInDirection = 3;
		break;
		case "Curtain":
			selEffect="Ext_Eff_Reveal2::Curtain";
			contImgObj.EffectInDirection = 1;
		break;
		case "Quadrant":
			selEffect="Ext_Eff_Reveal::Quadrant";
		break;
		case "Zoom_up":
			selEffect="Ext_Eff_Zoom::ZoomUp";
		break;
		case "Swiss":
			selEffect="Ext_Eff_Reveal2::Swiss";
		break;
		case "Uncover":
			selEffect="Ext_Eff_3D2::Uncover";
		break;
		default:
			selEffect="";
		break;
	}
	return selEffect;	
};
SaveTemplate.setSelectedAudioVideoType = function(firstFrameIdWithVideo){
	var selectedAudioFrameElementType = "";
	if(firstFrameIdWithVideo==""){
		ContentObj.SelectedAudioVideo = "NONE";
	}else if(firstFrameIdWithVideo == templateObj.mainFrame.id){
		ContentObj.SelectedAudioVideo = "AUDIO";	
	}else{
		var frameIdElmGrp = firstFrameIdWithVideo;
		if(TemplateUtils.isElementTypeGroup(frameIdElmGrp))
		{
			frameIdElmGrp = groupHandler.groupMap[frameIdElmGrp].elements[0].id;
		}
		if(templateObj.getInnerFrameForId(frameIdElmGrp).element[0] != undefined ){
			selectedAudioFrameElementType = templateObj.getInnerFrameForId(frameIdElmGrp).element[0].elementType; 
		}
		if(selectedAudioFrameElementType == VIDEO){
			ContentObj.SelectedAudioVideo = "VIDEO";	
		}else if(selectedAudioFrameElementType == INPUT_SOURCE){
			ContentObj.SelectedAudioVideo = "INPUTSOURCE";
		}else{
			ContentObj.SelectedAudioVideo = "NONE";
		}		
	}
};
function navigateFrmTemplate() {
	templateObj.deleteUnUsedHandWritingFiles(false);
	showAnimationLoader(langObj.Schedule.COM_TV_SID_SAVING);
    if(Utils.isGalleryOpen){
        mUiHandler.addOverLay(true);
    }
	moveTemplateImage();
}
function navigate(){
	if (templateFlag == SAVE_AND_SCHEDULE_TEMPLATE) {
		setTimeout(function() {
			loaderObj.hideLoader();
            if(Utils.isGalleryOpen){
                mUiHandler.addOverLay(false);
            }
			Utils.showToast(langObj.Schedule.COM_MIV_SCHEDULE_SUCCESS_SAVE);
			window.sessionStorage.setItem('orientationType', templateObj.orientation);
			if (getSchListLength() > 29) {
				Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
			} else {
				hideBottomMenu();
				if (templateObj.orientation == 1000) {
					localStorage.setItem("isLandScape", true);
				} else {
					localStorage.setItem("isLandScape", false);
				}
				var getEdited = localStorage.getItem("isEditedTemplate");
				if (tplCategory == Category.CUSTOM || getEdited == 'true') {
					localStorage.setItem("isEditedTemplate", false);
					getScheduleByOrientation(templateObj.orientation);
				} else {
					window.location.href = "../schedule/Schedule.html?category=" + tplCategory + "&schedulePath=" + SaveTemplate.schedulePath + "&scheduleName=" + SaveTemplate.scheduleName + "&isNewSchedule=" + SaveTemplate.isNewSchedule + "&navigateFromTemplate=true";
				}
			}
		}, 1000);
	} else if (goToHomeFlag) {
		setTimeout(function() {
			hideBottomMenu();
			loaderObj.hideLoader();
			Utils.showToast(langObj.Schedule.COM_MIV_SCHEDULE_SUCCESS_SAVE);
			document.location.href = "../quickstart/QuickStart.html";
		}, 1000);
	} else if (goToStep1Flag == true) {
		setTimeout(function() {
			hideBottomMenu();
			loaderObj.hideLoader();
			Utils.showToast(langObj.Schedule.COM_MIV_SCHEDULE_SUCCESS_SAVE);			
			if ((tplCategory == Category.CUSTOM))// schedule back then step2 then save > should go to step 1
			{
				document.location.href = "../quickstart/QuickStart.html";
			} else {
				SaveTemplate.saveCount = 0;
				//Since on going to step1 and again coming to step 2, new template should be created.
				tplUIObj.rndrStepOne();
			}
		}, 1000);
	} else {
		if (SaveTemplate.customClick == true) {		
			tplUIObj.renderTmpltForID(SaveTemplate.customTemplateNameClicked);
			//callTemplateFunc(constForTmpl.SHIFTFORMENU, UP);
			SaveTemplate.customClick = false;
			$("#templateNameDiv").html(langObj.template.MIS_SID_UNTITLED); 
		} else if (SaveTemplate.customNewTplClick == true) {
			tplUIObj.renderNewCstmTmplt();
			SaveTemplate.customNewTplClick = false;
			$("#templateNameDiv").html(langObj.template.MIS_SID_UNTITLED); 
		} else if (SaveTemplate.shuffleTemplate) {
			templateObj.shuffleData();
			SaveTemplate.shuffleTemplate = false;
			SaveTemplate.templateName = "";
			SaveTemplate.saveCount = 0;
			$("#templateNameDiv").html(langObj.template.MIS_SID_UNTITLED); 
		}else{
			$("#templateNameDiv").html(SaveTemplate.templateName);
		}
		setTimeout(function() {
			templateObj.hideShowAllDefaultText(false);
			loaderObj.hideLoader();
			Utils.showToast(langObj.Schedule.COM_MIV_SCHEDULE_SUCCESS_SAVE);
			templateObj.isEdited = false;
			templateObj.addClassOnEmptyFrames();
			if(Utils.isGalleryOpen==true){
		        mUiHandler.addOverLay(false);
		    }
		}, 1000);
	}
}
function moveTemplateImage() {	
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotNewMoveFS, failMove);
}
function gotNewMoveFS(fileSystem) {
	var srcPath = SaveTemplate.myTemplatePath + SaveTemplate.templateName+".LFD.PNG";
	var desFoldr = SaveTemplate.contentsFolderpath.replace(Utils.getSystemRootPath(), "");
	if(templateImageCount == 1){
		srcPath = srcPath +".PNG";
	}
	console.log("srcPath "+srcPath +" desFoldr "+desFoldr);
	fileSystem.root.getFile(srcPath, null, function(file) {
		fileSystem.root.getDirectory(desFoldr, {}, function(directory) {
			file.moveTo(directory, file.name, onMoveSuccess, failMove);
		}, function(error) {
			console.log(error, "Directory Error ");
		});
	}, function(error) {
		console.log(error, "File Error ");
	});
}
function onMoveSuccess(file) {
	
	templateImageCount--;
	if(templateImageCount>1){
		moveTemplateImage();
	}else{
		navigate();
	}
	log.debug("COMPLETED", "onCopyToSuccess");
};
function failMove(evt) {
	console.log("fail not able to call copyFile ");
}
function setStillImageFlag(){
    var currInnerFrame;
	for (var frameId in templateObj.innerFrames) {
		currInnerFrame = templateObj.getInnerFrameForId(frameId);
		if(currInnerFrame.element.length>0){
			if((currInnerFrame.element[0].elementType == VIDEO) || (currInnerFrame.element.length > 1)){				
				 stillImageFlag=false;
				 break;
			}
		}		
	}
}
function stickerCopy(stickerPath,contentsFolderPath) {
	return cordova.exec(function(){
		console.log("Success");		
	}, function(){
		console.log("Fail ");
	}, "StickerCopyPlugin", "StickerCopyAction", [stickerPath,contentsFolderPath]);
}
SaveTemplate.saveCustomTemplate = function(){
	templateFlag = SAVE_TEMPLATE;
    //templateObj.isEdited=false;
    if (( typeof templatePathFrUrl == 'undefined') && SaveTemplate.saveCount == 0) {
        saveAndSaveAsTemplate();
    } else {
        doTempltProcessForSave();
    }
};
SaveTemplate.saveAsCustomTemplate = function(){
	if (!Utils.isAddTemplateAllowed()) {
        return false;
    }
    templateFlag = SAVE_TEMPLATE;
    saveAsFlag = true;
    //SaveTemplate.saveCount = 0;
    saveAndSaveAsTemplate();
};
function deleteOuterSpenFolderContents(){
	 deleteFolder(SaveTemplate.spenOuterFolderPath, function(bStatus) {
         console.log("Outer Spen Folder deleted " + bStatus);
	 }); 
}
SaveTemplate.scheduleCustomTemplate = function(){
	templateFlag = SAVE_AND_SCHEDULE_TEMPLATE;
    if (SaveTemplate.saveCount == 0) {
        if (Utils.isAddTemplateAllowed()) {
            saveAndSaveAsTemplate();
        }
    } else {
        if (templateObj.isEdited) {
            genericPopUpObj.createPopUp("", "Type1");
            genericPopUpObj.appendHTMLData([MSG_WARN_PAGE_MOVE]);
            genericPopUpObj.addFooterBtns([{
                "btntxt" : COM_SID_CANCEL,
                "callback" : "closeGenericPopUp"
            }, {
                "btntxt" : COM_TV_SID_NO,
                "callback" : function() {
                    if (getSchListLength() > 29) {
                        Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
                    } else {
                        hideBottomMenu();
                        setTemplateInfo("update");
                        // Update is needed to bring the latest template in top of the list
                        window.sessionStorage.setItem('orientationType', templateObj.orientation);
                      //  if (typeof templatePathFrmUrl != 'undefined') {//Added check to fix DF151230-01260
                        	setTimeout(function() {
                            	getScheduleByOrientation(templateObj.orientation);
                        	}, 100);
                      /*  }else{
                        	window.location.href = "../schedule/Schedule.html?category=" + tplCategory + "&schedulePath=" + SaveTemplate.schedulePath + "&scheduleName=" + SaveTemplate.scheduleName + "&isNewSchedule=" + SaveTemplate.isNewSchedule + "&navigateFromTemplate=true";
                        }*/                        
                    }
                }
            }, {
                "btntxt" : COM_TV_SID_YES,
                "callback" : function() {
                	//if (typeof templatePathFrmUrl != 'undefined') {//Added check to fix DF151230-01260
                		localStorage.setItem("isEditedTemplate", true);	
                	//}                                        
                    doTempltProcessForSave();
                }
            }]);
            genericPopUpObj.showPopUp();
        } else {
            if (getSchListLength() > 29) {
                Utils.showToast(MIA_SID_MIX_SAVE_UP_SCHEDULES);
            } else {
                hideBottomMenu();
                setTemplateInfo("update");
                // Update is needed to bring the latest template in top of the list
                window.sessionStorage.setItem('orientationType', templateObj.orientation);
                setTimeout(function() {
                	//if (typeof templatePathFrmUrl != 'undefined') {//Added check to fix DF151230-01260
                		getScheduleByOrientation(templateObj.orientation);	
                	/*}else{
                		window.location.href = "../schedule/Schedule.html?category=" + tplCategory + "&schedulePath=" + SaveTemplate.schedulePath + "&scheduleName=" + SaveTemplate.scheduleName + "&isNewSchedule=" + SaveTemplate.isNewSchedule + "&navigateFromTemplate=true";
                	} */                   
                }, 100);
            }
        }
    }    
};
