
var Stack = function(){
  this.top = null;
  this.bottom = null;
  this.size = 0;
  this.MAX_LIMIT = 20;
};

var Node = function(data){
  this.data = data;
  this.previous = null;
  this.next = null;
};

Stack.prototype.push = function(data, isRedo) {
    /* If UNDO/REDO stack is empty, then corresponding undo/redo icon should be enabled on push action*/
    if(this.top == null){
        if(isRedo){
            /*Enable redo icon*/
            templateObj.enableUndoRedoIcon(false, true);
        }else{
            /*Enable undo icon*/
            templateObj.enableUndoRedoIcon(true, true);
        }
    }
    if(this.size == this.MAX_LIMIT){ /*Deleting bottom element on max limit reach*/
        var n = this.bottom;
        this.bottom = this.bottom.next;
        this.bottom.previous = null;
        n.previous = null;
        n.next = null;
        n = null;
        this.size -= 1;
    }
    var node = new Node(data);
    node.previous = this.top;
    if(this.top == null){
        this.top = node;
        this.bottom = node;
    }else{
        this.top.next = node;
    }
    this.top = node;
    this.size += 1;
};

Stack.prototype.pop = function(isRedo){
    var temp = this.top;
    if(this.top != null){
        this.top = this.top.previous;
        this.size -= 1;
        /*Resetting prev next links of temp element*/
        temp.previous = null;
        temp.next = null;
    }else{
        this.bottom = this.top;/*when stack is empty*/
    }
    if(this.top == null){
        /* If after removing the top element from UNDO/REDO stack, it becomes empty then corresponding undo/redo icon should be disabled*/
        if(isRedo){
            /*Disable redo icon*/
            templateObj.enableUndoRedoIcon(false, false);
        }else{
            /*Disable undo icon*/
            templateObj.enableUndoRedoIcon(true, false);
        }
    }
    return temp;
};

Stack.prototype.clearStack = function(isUndo){
	this.top = null;
	this.bottom = null;
	this.size = 0;
	if(isUndo){
	    templateObj.enableUndoRedoIcon(true, false);
	}else{
	    templateObj.enableUndoRedoIcon(false, false);
	}
};
