/*
 * Created by amber.m 27-11-2015
 * Created handle copy of sticker element and other events related to sticker element
 * functions are extension of template object only
 */

var TStickerCopyDir = {
NONE:333,
DOWN:444,
RIGHT:555,
UP:666,
LEFT:777
};
var COPY_LOC_DIFF_XY = 10;

template.prototype.getNextCopyLocation=function(ele, copyInfo){
    log.debug("STARTED","getNextCopyLocation");
    copyInfo.direction = this.calculateNextCopyDirection(ele, copyInfo);
    var rect = this.getRectForDirection(copyInfo.direction, ele, copyInfo);
    copyInfo.x = rect.x;
    copyInfo.y = rect.y;
    log.debug("COMPLETED"+JSON.stringify(copyInfo),"getNextCopyLocation");
    return rect;
};

template.prototype.calculateNextCopyDirection=function(ele, copyInfo){
    log.debug("STARTED","calculateNextCopyDirection");
    var iCopyDir = TStickerCopyDir.NONE;
    switch(copyInfo.direction)
    {
        case TStickerCopyDir.NONE:
        case TStickerCopyDir.DOWN:
            if(this.isCopyPossibleAtRect(this.getRectForDirection(TStickerCopyDir.DOWN, ele, copyInfo))){ //DOWN RECT
                iCopyDir = TStickerCopyDir.DOWN;
                break;
            }
        case TStickerCopyDir.RIGHT:
            if(this.isCopyPossibleAtRect(this.getRectForDirection(TStickerCopyDir.RIGHT, ele, copyInfo))){ //RIGHT RECT
                iCopyDir = TStickerCopyDir.RIGHT;
                break;
            }
        case TStickerCopyDir.UP:
            if(this.isCopyPossibleAtRect(this.getRectForDirection(TStickerCopyDir.UP, ele, copyInfo))){ //UP RECT
                iCopyDir = TStickerCopyDir.UP;
                break;
            }
        case TStickerCopyDir.LEFT:
            if(this.isCopyPossibleAtRect(this.getRectForDirection(TStickerCopyDir.LEFT, ele, copyInfo))){ //LEFT RECT
                iCopyDir = TStickerCopyDir.LEFT;
                break;
            }
        default:
            log.debug("COPY DIRECTION DEFAULT RESET", "calculateNextCopyDirection");
            iCopyDir = TStickerCopyDir.DOWN;
            break;
    }
    log.debug("COMPLETED iCopyDir = "+iCopyDir,"calculateNextCopyDirection");
    return iCopyDir;
};
template.prototype.isCopyPossibleAtRect=function(rect){
    var bRect=TemplateUtils.createBoundingRectangle(rect);
    var lt = {x:bRect.x,y:bRect.y};
    var lb = {x:bRect.x,y:(bRect.y+bRect.h)};
    var rt = {x:(bRect.x + bRect.w),y:bRect.y};
    var rb = {x:(bRect.x + bRect.w),y:(bRect.y+bRect.h)};
    var mainFrameRect = {x:0,y:0,w:this.mainFrame.w,h:this.mainFrame.h};
    if(isPointInsideRect(lt, mainFrameRect) && isPointInsideRect(lb, mainFrameRect)
       && isPointInsideRect(rt, mainFrameRect) && isPointInsideRect(rb, mainFrameRect))
    {
        log.debug("COMPLETED,"+JSON.stringify(mainFrameRect),"isCopyPossibleAtRect");
        return true;
    }
    return false;
};

template.prototype.getRectForDirection=function(direction , ele, copyInfo){
    var rect = {x:copyInfo.x, y:copyInfo.y, w:ele.w, h:ele.h,rotation:ele.rotation};
    switch(direction)
    {
        case TStickerCopyDir.DOWN:
            rect.x=rect.x+COPY_LOC_DIFF_XY;
            rect.y=rect.y+COPY_LOC_DIFF_XY;
            break;
        case TStickerCopyDir.RIGHT:
            rect.x=rect.x+COPY_LOC_DIFF_XY;
            rect.y=rect.y-COPY_LOC_DIFF_XY;
            break;
        case TStickerCopyDir.UP:
            rect.x=rect.x-COPY_LOC_DIFF_XY;
            rect.y=rect.y-COPY_LOC_DIFF_XY;
            break;
        case TStickerCopyDir.LEFT:
            rect.x=rect.x-COPY_LOC_DIFF_XY;
            rect.y=rect.y+COPY_LOC_DIFF_XY;
            break;
        default:
            log.debug("WRONG COPY DIRECTION", "getRectForDirection");
            break;
    }
    log.debug("COMPLETED"+JSON.stringify(rect),"getRectForDirection");
    return rect;
};
