/* 
 * Created by amber.m 27-07-2015
 * Created to handle Megnetic Effect related functionality
 * Note :: Not supporting Group/Linked Element currently
 * Dependent Files : templateFrames.js, Template.js
 *
 */
var ALINE_NONE = 6666;
var ALINE_LEFT_TOP = 8888;
var ALINE_RIGHT_BTM = 9999;
var ALINE_CENTER = 7777;
var MAGNET_PRIORITY_NONE = 1111;
var MAGNET_PRIORITY_LEFT = 1122;
var MAGNET_PRIORITY_RIGHT = 1133;
var MAGNET_PRIORITY_TOP = 1144;
var MAGNET_PRIORITY_BOTTOM = 1155;
var bPointResetDone = true;

/*var MagnetEffect=function(){
    this.xCountMap={};
    this.yCountMap={};
    this.xMagnetArr=[];
    this.yMagnetArr=[];
    this.xMagnetRange=MAGNET_RANGE_FOR_MOVE;
    this.yMagnetRange=MAGNET_RANGE_FOR_MOVE;
};

var MagnetPoint=function(){
    this.xPoint=-1;
    this.yPoint=-1;
    this.xAline=-1;
    this.yAline=-1;
};*/
/*MAGNET EFFECT OBJECT UPDATE FUNCTIONS*/
MagnetEffect.prototype.setXMagnetRange=function(val){
    if(val>0 && val <10){
        this.xMagnetRange = val;
    }else{
        this.xMagnetRange = MAGNET_RANGE_FOR_MOVE;
    }
};
MagnetEffect.prototype.setYMagnetRange=function(val){
    if(val>0 && val <10){
        this.yMagnetRange = val;
    }else{
        this.yMagnetRange = MAGNET_RANGE_FOR_MOVE;
    }
};

MagnetEffect.prototype.setInXMap=function(val){
    if(this.xCountMap[val] == undefined){
        this.xCountMap[val] = 1;
    }else{
        this.xCountMap[val]++;
    }
};

MagnetEffect.prototype.setInYMap=function(val){
    if(this.yCountMap[val] == undefined){
        this.yCountMap[val] = 1;
    }else{
        this.yCountMap[val]++;
    }
};

MagnetEffect.prototype.delFromXMap=function(val){
    if(this.xCountMap[val] != undefined){
        if(this.xCountMap[val]>1){
            this.xCountMap[val]--;
        }else{
            delete this.xCountMap[val];
        }
    }
};

MagnetEffect.prototype.delFromYMap=function(val){
    if(this.yCountMap[val] != undefined){
        if(this.yCountMap[val]>1){
            this.yCountMap[val]--;
        }else{
            delete this.yCountMap[val];
        }
    }
};

MagnetEffect.prototype.resetMagnetObj=function(){
    this.xCountMap={};
    this.yCountMap={};
    this.xMagnetRange=MAGNET_RANGE_FOR_MOVE;
    this.yMagnetRange=MAGNET_RANGE_FOR_MOVE;
};

MagnetEffect.prototype.reloadXYMagnetArr=function(){
    if(this.xMagnetArr.length > 0 || this.yMagnetArr.length > 0){
        this.xMagnetArr=[];
        this.yMagnetArr=[];
    }
    //putting unique magnet points in to magnet point array
    for(var key in this.xCountMap){
        this.xMagnetArr.push(getParseIntInDec(key));
    }
    for(var key in this.yCountMap){
        this.yMagnetArr.push(getParseIntInDec(key));
    }
    this.xMagnetArr.sort(function(a,b){return a-b;});
    this.yMagnetArr.sort(function(a,b){return a-b;});
};
/*Finding magnet point in the Magnet array for given magnet range using binary search in sorted array*/
MagnetEffect.prototype.searchElementInNumberRange=function(arrType, number) {
    var min = 0;
    var currIndex;
    var currEle;
    var arr = null;
    var mRange = 0;
    if(arrType == "X"){
        arr = this.xMagnetArr;
        mRange = this.xMagnetRange;
    }else{
        arr = this.yMagnetArr;
        mRange = this.yMagnetRange;
    }
    var max = arr.length - 1;
    var diff = 9999;
    var ele = -1;
    while (min <= max) {
        currIndex = (min + max) / 2 | 0;
        currEle = arr[currIndex];
        if (currEle < number) {
            if((currEle + mRange)>= number){
                //return currEle;
            	ele = -1;
            	diff = 9999;
            	for(var index = currIndex; index<=max ;index++){
            		if(arr[index] <= number && diff > (number - arr[index])){
            			diff = number - arr[index];
            			ele = arr[index];
            		}else{
            			break;
            		}
            	}
            	return ele;
            }
            min = currIndex + 1;
        }
        else if (currEle > number) {
            if((currEle - mRange)<= number){
               // return currEle;
            	ele = -1;
            	diff = 9999;
            	for(var index = currIndex; index>=min ;index--){
            		if(arr[index] >= number && diff > (arr[index] - number )){
            			diff = arr[index] - number;
            			ele = arr[index];
            		}else{
            			break;
            		}
            	}
            	return ele;
            }
            max = currIndex - 1;
        }
        else {
            return currEle;
        }
    }
    
    return -1;
};

MagnetEffect.prototype.toString=function(){
    log.debug(JSON.stringify(this),"MAGNET POINTS MAP AND ARRAY OBJ");
};

/*----TEMPLATE INTERFACE FUNCTION-----*/
/*template.prototype.createMagnetEffectObj=function(){
    this.magnetEffectObj = new MagnetEffect();
    if(this.magnetPointObj == null){
        this.magnetPointObj = new MagnetPoint();
    }
};*/

template.prototype.loadMagnetPointMap=function(){
    log.debug(" STARTED ", "createMagnetEffectObj");
    var frameId = null;
    var frame = null;
    var magnetObj = this.magnetEffectObj;
    magnetObj.resetMagnetObj();
    this.magnetPointObj.xPoint = -1;
    this.magnetPointObj.yPoint = -1;
    //push main frame pts in to Magnet Point Map
    
    magnetObj.setInXMap(0);
    magnetObj.setInXMap(getParseIntInDec(this.mainFrame.w/2));
    magnetObj.setInXMap(this.mainFrame.w);
    magnetObj.setInYMap(0);
    magnetObj.setInYMap(getParseIntInDec(this.mainFrame.h/2));
    magnetObj.setInYMap(this.mainFrame.h);
    
    //Put all inner frame magnet points into map
    var innerFrameZorderArray = this.getInnerFrameGroupZorderArray();
    for(var index=0;index<=innerFrameZorderArray.length-1;index++){
        frameId = FRAME_ID_PREFIX+innerFrameZorderArray[index];
        frame = this.getInnerFrameForId(frameId);
        this.addMagnetPtsForObj(frame);
    }
    
    //Put all floating element magnet points into map
    var elmCount=this.mainFrame.element.length;
    var elmnt;
    for(var i=0;i<elmCount;i++)
    {
        elmnt=this.mainFrame.element[i];
        if(elmnt != null){
            if(this.isTxtTypeElm(elmnt.elementType)){
                elmnt = elmnt.textElms[0];
            }
            this.addMagnetPtsForObj(elmnt);
        }
    }
};

template.prototype.loadMagnetPointArray=function(){
    var magnetObj = this.magnetEffectObj;
    if(magnetObj != null){
        magnetObj.reloadXYMagnetArr();
        magnetObj.toString();
    }
};

/*Magnet line Add/Show/Hide/Update functions*/
/*template.prototype.addMagnetLines=function()
{
    $("#"+this.mainFrame.id).append('<div id="tplMagnetHLine">&nbsp;</div><div id="tplMagnetVLine">&nbsp;</div>');
     $("#tplMagnetHLine").css({
        'width':this.mainFrame.w+'px'
    });
    $("#tplMagnetVLine").css({
        'height':this.mainFrame.h+'px'
    });
};
*/
template.prototype.hideMagnetLines=function(){
    $("#tplMagnetVLine").hide();
    $("#tplMagnetHLine").hide();
};

template.prototype.updtMgntLinePos=function(xPos,yPos)
{
    $("#tplMagnetVLine").hide();
    $("#tplMagnetHLine").hide();
    if(xPos != -1){
        $("#tplMagnetVLine").show();
        $("#tplMagnetVLine").css({
            'left':xPos+'px'            
        });
    }
    if(yPos != -1){
        $("#tplMagnetHLine").show();
        $("#tplMagnetHLine").css({
         'top':yPos+'px'         
         });
    } 
};

/*Magnet Effect object  Map update functions*/
template.prototype.removeMagnetPtsForObj=function(obj){
    var magnetObj = this.magnetEffectObj;
    if(obj != null){
        log.debug("OBJ REMOVED = "+obj.x+" "+obj.y+" "+obj.w+" "+obj.h,"removeMagnetPtsForObj");
        var temp = TemplateUtils.createBoundingRectangle(obj);        
        magnetObj.delFromXMap(Math.round(temp.x));
        magnetObj.delFromXMap(getParseIntInDec(temp.x+((temp.w/2)<1?1:(temp.w/2))));
        magnetObj.delFromXMap(Math.round(temp.x+(temp.w<1?1:temp.w)));
        magnetObj.delFromYMap(Math.round(temp.y));
        magnetObj.delFromYMap(getParseIntInDec(temp.y+((temp.h/2)<1?1:(temp.h/2))));
        magnetObj.delFromYMap(Math.round(temp.y+(temp.h<1?1:temp.h)));
    }
};

/*Magnet Effect object  Map update functions*/
template.prototype.removeMagnetPtsOnTouchStartForGroup=function(group, range){
	this.magnetEffectObj.setXMagnetRange(range);
    this.magnetEffectObj.setYMagnetRange(range);
    var magnetObj = this.magnetEffectObj;
    if(group != null){
    	// remove all elements of the group
        var all_objects = group.elements;
	    for(var i = 0;i < all_objects.length;i++)
	    {
	    	this.removeMagnetPtsForObj(all_objects[i].ref);
	    }
    }
};



template.prototype.removeMagnetPtsOnTouchStart=function(obj, range){
    this.magnetEffectObj.setXMagnetRange(range);
    this.magnetEffectObj.setYMagnetRange(range);
    this.removeMagnetPtsForObj(obj);
};





template.prototype.addMagnetPtsForObj=function(obj){
    var magnetObj = this.magnetEffectObj;
    if(obj != null){
        log.debug("OBJ ADDED = "+obj.x+" "+obj.y+" "+obj.w+" "+obj.h,"addMagnetPtsForObj");
        var temp = TemplateUtils.createBoundingRectangle(obj);        
        magnetObj.setInXMap(Math.round(temp.x));
        magnetObj.setInXMap(getParseIntInDec(temp.x+((temp.w/2)<1?1:(temp.w/2))));
        magnetObj.setInXMap(Math.round(temp.x+(temp.w<1?1:temp.w)));
        magnetObj.setInYMap(Math.round(temp.y));
        magnetObj.setInYMap(getParseIntInDec(temp.y+((temp.h/2)<1?1:(temp.h/2))));
        magnetObj.setInYMap(Math.round(temp.y+(temp.h<1?1:temp.h)));
       // log.debug("xCountMap:"+JSON.stringify(magnetObj.xCountMap)+",yCountMap"+JSON.stringify(magnetObj.yCountMap),"addMagnetPtsForObj");
    }
};
/*Magnet Point find functions according to MAGNET_PRIORITY*/
template.prototype.findMagnetPointForObj=function(obj, priorityX, priorityY){
    var magnetObj = this.magnetEffectObj;
    var magnetPt = this.magnetPointObj;
    var pt = 0, temp= 0;
    var xMinDiff = 9999;
    var yMinDiff = 9999;
    var diff = 0;
    magnetPt.xPoint = -1;
    magnetPt.yPoint = -1;
    pt = obj.x;
    temp = magnetObj.searchElementInNumberRange("X", pt);
    if(temp != -1){
        diff = this.getPositiveDiff(pt, temp);
        if(xMinDiff> diff){
            magnetPt.xPoint = temp;
            magnetPt.xAline = ALINE_LEFT_TOP;
            xMinDiff = diff;
        }
    }
    if(xMinDiff > MAGNET_RANGE_FOR_RESIZE || priorityX == MAGNET_PRIORITY_RIGHT){
        pt = obj.x+obj.w;
        temp = magnetObj.searchElementInNumberRange("X", pt);
        if(temp != -1){
            diff = this.getPositiveDiff(pt, temp);
            if(xMinDiff> diff || priorityX == MAGNET_PRIORITY_RIGHT){
                magnetPt.xPoint = temp;
                magnetPt.xAline = ALINE_RIGHT_BTM;
                xMinDiff = diff;
            }
        }
        if(xMinDiff > MAGNET_RANGE_FOR_RESIZE){
            pt = getParseIntInDec(obj.x+obj.w/2);
            temp = magnetObj.searchElementInNumberRange("X", pt);
            if(temp != -1){
                diff = this.getPositiveDiff(pt, temp);
                if(xMinDiff> diff){
                    magnetPt.xPoint = temp;
                    magnetPt.xAline = ALINE_CENTER;
                    xMinDiff = diff;
                }
            }
        }
    }
    
    pt = obj.y;
    temp = magnetObj.searchElementInNumberRange("Y", pt);
    if(temp != -1){
        diff = this.getPositiveDiff(pt, temp);
        if(yMinDiff> diff){
            magnetPt.yPoint = temp;
            magnetPt.yAline = ALINE_LEFT_TOP;
            yMinDiff = diff;
        }
    }
    if(yMinDiff > MAGNET_RANGE_FOR_RESIZE || priorityY == MAGNET_PRIORITY_BOTTOM){
        pt = obj.y+obj.h;
        temp = magnetObj.searchElementInNumberRange("Y", pt);
        if(temp != -1){
            diff = this.getPositiveDiff(pt, temp);
            if(yMinDiff> diff  || priorityY == MAGNET_PRIORITY_BOTTOM){
                magnetPt.yPoint = temp;
                magnetPt.yAline = ALINE_RIGHT_BTM;
                yMinDiff = diff;
            }
        }
        if(yMinDiff > MAGNET_RANGE_FOR_RESIZE){
            pt = getParseIntInDec(obj.y+obj.h/2);
            temp = magnetObj.searchElementInNumberRange("Y", pt);
            if(temp != -1){
                diff = this.getPositiveDiff(pt, temp);
                if(yMinDiff> diff){
                    magnetPt.yPoint = temp;
                    magnetPt.yAline = ALINE_CENTER;
                    yMinDiff = diff;
                }
            }
        }
    }
    this.updtMgntLinePos(magnetPt.xPoint,magnetPt.yPoint);
};
/* modified function for reposition of rotated object */
/*
template.prototype.repositionRotatedObjAccToMagnetPt=function(obj){
	var magnetPt = this.magnetPointObj;
    var magnetObj = this.magnetEffectObj;
    var x = 0, y = 0;
   
    if(magnetPt.xPoint == -1 && magnetPt.yPoint == -1){
        if(bPointResetDone){
            setTimeout(function(){
                   magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   bPointResetDone = true;
                   },200);
            bPointResetDone = false;
        }
        
        return;
    }
    var diff = 0.00;
	var bndRect = TemplateUtils.createBoundingRectangle(obj);
 	if(magnetPt.xPoint != -1){
 	
	 	switch(magnetPt.xAline)
        {
            case ALINE_LEFT_TOP:
                diff = magnetPt.xPoint - bndRect.x;
                obj.x += diff;
                break;
            case ALINE_CENTER:
                 diff =(magnetPt.xPoint - (bndRect.x + bndRect.w/2.0) );
                obj.x += diff;
                break;
            case ALINE_RIGHT_BTM:
                diff =(magnetPt.xPoint - (bndRect.x + bndRect.w) );
                obj.x += diff;
                break;
            default:
                break;
        }
        if(obj.x<0){
            obj.x = 0;
        }else if(obj.x+obj.w>this.mainFrame.w){
            obj.x = this.mainFrame.w - obj.w;
        }
    	magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
    
 	}
	
   diff = 0.00;     
   if(magnetPt.yPoint != -1){
        switch(magnetPt.yAline)
        {
            case ALINE_LEFT_TOP:
            	diff = magnetPt.yPoint - bndRect.y;
             	obj.y += diff;
            break;
            case ALINE_CENTER:
                diff =(magnetPt.yPoint - (bndRect.y + bndRect.h/2.0) );
                obj.y += diff;
                break;
            case ALINE_RIGHT_BTM:
                diff =(magnetPt.yPoint - (bndRect.y + bndRect.h) );
                obj.y += diff;
                break;
            default:
                break;
        }
        if(obj.y<0){
            obj.y = 0;
        }else if(obj.y+obj.h>this.mainFrame.h){
            obj.y = this.mainFrame.h - obj.h;
        }
        magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
	}

	return;
};
*/
template.prototype.repositionObjAccToMagnetPt = function(obj)
{
	var magnetPt = this.magnetPointObj;
	var magnetObj = this.magnetEffectObj;
	var x = 0, y = 0;

	if(magnetPt.xPoint == -1 && magnetPt.yPoint == -1)
	{
		if(bPointResetDone)
		{
			setTimeout(function()
			{
				magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_MOVE);
				magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_MOVE);
				bPointResetDone = true;
			}, 200);
			bPointResetDone = false;
		}

		return;
	}
	var diff = 0.00;
	var bndRect = TemplateUtils.createBoundingRectangle(obj);
	if(magnetPt.xPoint != -1)
	{

		switch(magnetPt.xAline)
		{
		case ALINE_LEFT_TOP:
			diff = magnetPt.xPoint - bndRect.x;
			break;
		case ALINE_CENTER:
			diff = (magnetPt.xPoint - (bndRect.x + bndRect.w / 2.0));
			break;
		case ALINE_RIGHT_BTM:
			diff = (magnetPt.xPoint - (bndRect.x + bndRect.w));
			break;
		default:
			break;
		}

        /*Resetting diff if element will go outside canvas area*/
		if(bndRect.x + diff < 0)
		{
			diff = -bndRect.x;
		}
		else if(bndRect.x + bndRect.w + diff > this.mainFrame.w)
		{
			diff = this.mainFrame.w - bndRect.x - bndRect.w;
		}
		obj.x += diff;

		magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_ATTACHED);

	}

	diff = 0.00;
	if(magnetPt.yPoint != -1)
	{
		switch(magnetPt.yAline)
		{
		case ALINE_LEFT_TOP:
			diff = magnetPt.yPoint - bndRect.y;
			break;
		case ALINE_CENTER:
			diff = (magnetPt.yPoint - (bndRect.y + bndRect.h / 2.0));
			break;
		case ALINE_RIGHT_BTM:
			diff = (magnetPt.yPoint - (bndRect.y + bndRect.h));
			break;
		default:
			break;
		}

		/*Resetting diff if element will go outside canvas area*/
		if(bndRect.y + diff < 0)
		{
			diff = -bndRect.y;
		}
		else if(bndRect.y + bndRect.h + diff > this.mainFrame.h)
		{
			diff = this.mainFrame.h - bndRect.y - bndRect.h;
		}
		obj.y += diff;

		magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
	}

	return;
};


/*Repositioning/Resize object according to magnet point*/
/*
template.prototype.repositionObjAccToMagnetPt=function(obj){
    var magnetPt = this.magnetPointObj;
    var magnetObj = this.magnetEffectObj;
    var x = 0, y = 0;
    if(obj.rotation != 0){
    	this.repositionRotatedObjAccToMagnetPt(obj);
    	return;
    }
    if(magnetPt.xPoint == -1 && magnetPt.yPoint == -1){
        if(bPointResetDone){
            setTimeout(function(){
                   magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   bPointResetDone = true;
                   },200);
            bPointResetDone = false;
        }
        
        return;
    }

    if(magnetPt.xPoint != -1){
        switch(magnetPt.xAline)
        {
            case ALINE_LEFT_TOP:
                obj.x = magnetPt.xPoint;
                break;
            case ALINE_CENTER:
                obj.x = magnetPt.xPoint - getParseIntInDec(obj.w/2);
                break;
            case ALINE_RIGHT_BTM:
                x =(magnetPt.xPoint - obj.w);
                obj.x = (x<=0)?0:x;
                obj.x = (magnetPt.xPoint == this.mainFrame.w)?x:obj.x;
                break;
            default:
                break;
        }
        if(obj.x<0){
            obj.x = 0;
        }else if(obj.x+obj.w>this.mainFrame.w){
            obj.x = this.mainFrame.w - obj.w;
        }
        magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
    }
    if(magnetPt.yPoint != -1){
        switch(magnetPt.yAline)
        {
            case ALINE_LEFT_TOP:
                obj.y = magnetPt.yPoint;
                break;
            case ALINE_CENTER:
                obj.y = magnetPt.yPoint - getParseIntInDec(obj.h/2);
                break;
            case ALINE_RIGHT_BTM:
                y =(magnetPt.yPoint - obj.h);
                obj.y = (y<=0)?0:y;
                obj.y = (magnetPt.yPoint == this.mainFrame.h)?y:obj.y;
                break;
            default:
                break;
        }
        if(obj.y<0){
            obj.y = 0;
        }else if(obj.y+obj.h>this.mainFrame.h){
            obj.y = this.mainFrame.h - obj.h;
        }
        magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
    }
};
*/

/* modified function for reposition of group object */

template.prototype.repositionGroupAccToMagnetPt=function(group){
	var magnetPt = this.magnetPointObj;
    var magnetObj = this.magnetEffectObj;
    var x = 0, y = 0;
   
    if(magnetPt.xPoint == -1 && magnetPt.yPoint == -1){
        if(bPointResetDone){
            setTimeout(function(){
                   magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   bPointResetDone = true;
                   },200);
            bPointResetDone = false;
        }
        
        return;
    }
    var deltaX = 0.00;
    var deltaY = 0.00;
	var bndRect = groupHandler.boundingRectForGroup(group);
	 	if(magnetPt.xPoint != -1){
	 	
		 	switch(magnetPt.xAline)
	        {
	            case ALINE_LEFT_TOP:
	                var diff = magnetPt.xPoint - bndRect.x;
	                break;
	            case ALINE_CENTER:
	                 var diff =(magnetPt.xPoint - (bndRect.x + bndRect.w/2.0) );
	                break;
	            case ALINE_RIGHT_BTM:
	                var diff =(magnetPt.xPoint - (bndRect.x + bndRect.w) );
	                break;
	            default:
	                break;
	        }
	        deltaX = diff;
	        
        	magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
        
	 	}
	   
       if(magnetPt.yPoint != -1){
	        switch(magnetPt.yAline)
	        {
                case ALINE_LEFT_TOP:
                     var diff = magnetPt.yPoint - bndRect.y;
                break;
	            case ALINE_CENTER:
	              var diff =(magnetPt.yPoint - (bndRect.y + bndRect.h/2.0) );
	                break;
	            case ALINE_RIGHT_BTM:
	                var diff =(magnetPt.yPoint - (bndRect.y + bndRect.h) );	                
	                break;
	            default:
	                break;
	        }
	        deltaY = diff;
	        magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
		}
	
  groupHandler.dragGrpElm(deltaX,deltaY);
  var grpId = group.id;    
  group.x = group.x + deltaX;
  group.y = group.y + deltaY;

	return;
};

/* resize of rotated object */
/*
template.prototype.resizeOfRotatedObjAccToMagnetPointsOnTouchEnd=function(obj){
    log.debug("STARTED","resizeOfRotatedObjAccToMagnetPointsOnTouchEnd");
    var magnetPt = this.magnetPointObj;
    var diffX = 0, diffY = 0;
    var x = 0, y = 0;
    var bndRect = TemplateUtils.createBoundingRectangle(obj);
    
    if(magnetPt.xPoint != -1){
        switch(magnetPt.xAline)
        {
            case ALINE_LEFT_TOP:
                if(bndRect.x != magnetPt.xPoint){
                    if(bndRect.x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - bndRect.x;
                        obj.w = obj.w - diffX;
                        obj.x += diffX;
                    }else{
                        diffX = bndRect.x - magnetPt.xPoint;
                        obj.w = obj.w + diffX;
                        obj.x -= diffX;
                    }
                    
                }
                
                break;
            case ALINE_CENTER:
                x = getParseIntInDec(bndRect.w/2)+bndRect.x;
                if(x != magnetPt.xPoint){
                    if(x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - x;
                        obj.w = obj.w + diffX*2;
                    }else{
                        diffX = x - magnetPt.xPoint;
                        obj.w = obj.w - 2*diffX;
                    }
                }
                break;
            case ALINE_RIGHT_BTM:
                 x = bndRect.x + bndRect.w;
                if(x != magnetPt.xPoint){
                    if(x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - x;
                        obj.w = obj.w + diffX;
                    }else{
                        diffX = x - magnetPt.xPoint;
                        obj.w = obj.w - diffX;
                    }
                }
                break;
            default:
                break;
        }
        if(obj.x<0){
            obj.x = 0;
        }else if(obj.x+obj.w>this.mainFrame.w){
            obj.x = this.mainFrame.w - obj.w;
        }
    }
    if(magnetPt.yPoint != -1){
        switch(magnetPt.yAline)
        {
            case ALINE_LEFT_TOP:
                if(bndRect.y != magnetPt.yPoint){
                    if(bndRect.y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - bndRect.y;
                        obj.h = obj.h - diffY;
                        obj.y += diffY;
                    }else{
                        diffY = bndRect.y - magnetPt.yPoint;
                        obj.h = obj.h + diffY;
                        obj.y += diffY;
                    }
                    
                }
                break;
            case ALINE_CENTER:
                y = getParseIntInDec(bndRect.h/2)+bndRect.y;
                if(y != magnetPt.yPoint){
                    if(y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - y;
                        obj.h = obj.h + diffY*2;
                    }else{
                        diffY = y - magnetPt.yPoint;
                        obj.h = obj.h - 2*diffY;
                    }
                }
                break;
            case ALINE_RIGHT_BTM:
                y = bndRect.y + bndRect.h;
                if(y != magnetPt.yPoint){
                    if(y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - y;
                        obj.h = obj.h + diffY;
                    }else{
                        diffY = y - magnetPt.yPoint;
                        obj.h = obj.h - diffY;
                    }
                }

                break;
            default:
                break;
        }
        if(obj.y<0){
            obj.y = 0;
        }else if(obj.y+obj.h>this.mainFrame.h){
            obj.y = this.mainFrame.h - obj.h;
        }
    }
    log.debug("COMPLETED","resizeOfRotatedObjAccToMagnetPointsOnTouchEnd");

};
*/
template.prototype.resizeObjAccToMagnetPointsOnTouchEnd=function(obj){
   log.debug("STARTED","resizeObjAccToMagnetPointsOnTouchEnd");
    var magnetPt = this.magnetPointObj;
    var diffX = 0, diffY = 0;
    var x = 0, y = 0;
    var bndRect = TemplateUtils.createBoundingRectangle(obj);
    
    if(magnetPt.xPoint != -1){
        switch(magnetPt.xAline)
        {
            case ALINE_LEFT_TOP:
                if(bndRect.x != magnetPt.xPoint){
                    if(bndRect.x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - bndRect.x;
                        obj.w = obj.w - diffX;
                        obj.x += diffX;
                    }else{
                        diffX = bndRect.x - magnetPt.xPoint;
                        obj.w = obj.w + diffX;
                        obj.x -= diffX;
                    }
                    
                }
                
                break;
            case ALINE_CENTER:
                x = getParseIntInDec(bndRect.w/2)+bndRect.x;
                if(x != magnetPt.xPoint){
                    if(x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - x;
                        obj.w = obj.w + diffX*2;
                    }else{
                        diffX = x - magnetPt.xPoint;
                        obj.w = obj.w - 2*diffX;
                    }
                }
                break;
            case ALINE_RIGHT_BTM:
                 x = bndRect.x + bndRect.w;
                if(x != magnetPt.xPoint){
                    if(x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - x;
                        obj.w = obj.w + diffX;
                    }else{
                        diffX = x - magnetPt.xPoint;
                        obj.w = obj.w - diffX;
                    }
                }
                break;
            default:
                break;
        }
        if(obj.x<0){
            obj.x = 0;
        }else if(obj.x+obj.w>this.mainFrame.w){
            obj.x = this.mainFrame.w - obj.w;
        }
    }
    if(magnetPt.yPoint != -1){
        switch(magnetPt.yAline)
        {
            case ALINE_LEFT_TOP:
                if(bndRect.y != magnetPt.yPoint){
                    if(bndRect.y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - bndRect.y;
                        obj.h = obj.h - diffY;
                        obj.y += diffY;
                    }else{
                        diffY = bndRect.y - magnetPt.yPoint;
                        obj.h = obj.h + diffY;
                        obj.y += diffY;
                    }
                    
                }
                break;
            case ALINE_CENTER:
                y = getParseIntInDec(bndRect.h/2)+bndRect.y;
                if(y != magnetPt.yPoint){
                    if(y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - y;
                        obj.h = obj.h + diffY*2;
                    }else{
                        diffY = y - magnetPt.yPoint;
                        obj.h = obj.h - 2*diffY;
                    }
                }
                break;
            case ALINE_RIGHT_BTM:
                y = bndRect.y + bndRect.h;
                if(y != magnetPt.yPoint){
                    if(y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - y;
                        obj.h = obj.h + diffY;
                    }else{
                        diffY = y - magnetPt.yPoint;
                        obj.h = obj.h - diffY;
                    }
                }

                break;
            default:
                break;
        }
        if(obj.y<0){
            obj.y = 0;
        }else if(obj.y+obj.h>this.mainFrame.h){
            obj.y = this.mainFrame.h - obj.h;
        }
    }
    log.debug("COMPLETED","resizeObjAccToMagnetPointsOnTouchEnd");

};
/*
template.prototype.resizeObjAccToMagnetPointsOnTouchEnd=function(obj){
    log.debug("STARTED","resizeObjAccToMagnetPointsOnTouchEnd");
    var magnetPt = this.magnetPointObj;
    var diffX = 0, diffY = 0;
    var x = 0, y = 0;
    if(obj.rotation != 0){
    	this.resizeOfRotatedObjAccToMagnetPointsOnTouchEnd(obj);
    	return;
    }
    	
    if(magnetPt.xPoint != -1){
        switch(magnetPt.xAline)
        {
            case ALINE_LEFT_TOP:
                if(obj.x != magnetPt.xPoint){
                    if(obj.x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - obj.x;
                        obj.w = obj.w - diffX;
                    }else{
                        diffX = obj.x - magnetPt.xPoint;
                        obj.w = obj.w + diffX;
                    }
                    obj.x = magnetPt.xPoint;
                }
                
                break;
            case ALINE_CENTER:
                x = getParseIntInDec(obj.w/2)+obj.x;
                if(x != magnetPt.xPoint){
                    if(x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - x;
                        obj.w = obj.w + diffX*2;
                    }else{
                        diffX = x - magnetPt.xPoint;
                        obj.w = obj.w - 2*diffX;
                    }
                }
                break;
            case ALINE_RIGHT_BTM:
                x = obj.x + obj.w;
                if(x != magnetPt.xPoint){
                    if(x<magnetPt.xPoint){
                        diffX = magnetPt.xPoint - x;
                        obj.w = obj.w + diffX;
                    }else{
                        diffX = x - magnetPt.xPoint;
                        obj.w = obj.w - diffX;
                    }
                }
                break;
            default:
                break;
        }
        if(obj.x<0){
            obj.x = 0;
        }else if(obj.x+obj.w>this.mainFrame.w){
            obj.x = this.mainFrame.w - obj.w;
        }
    }
    if(magnetPt.yPoint != -1){
        switch(magnetPt.yAline)
        {
            case ALINE_LEFT_TOP:
                if(obj.y != magnetPt.yPoint){
                    if(obj.y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - obj.y;
                        obj.h = obj.h - diffY;
                    }else{
                        diffY = obj.y - magnetPt.yPoint;
                        obj.h = obj.h + diffY;
                    }
                    obj.y = magnetPt.yPoint;
                }
                break;
            case ALINE_CENTER:
                y = getParseIntInDec(obj.h/2)+obj.y;
                if(y != magnetPt.yPoint){
                    if(y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - y;
                        obj.h = obj.h + diffY*2;
                    }else{
                        diffY = y - magnetPt.yPoint;
                        obj.h = obj.h - 2*diffY;
                    }
                }
                break;
            case ALINE_RIGHT_BTM:
                y = obj.y + obj.h;
                if(y != magnetPt.yPoint){
                    if(y<magnetPt.yPoint){
                        diffY = magnetPt.yPoint - y;
                        obj.h = obj.h + diffY;
                    }else{
                        diffY = y - magnetPt.yPoint;
                        obj.h = obj.h - diffY;
                    }
                }

                break;
            default:
                break;
        }
        if(obj.y<0){
            obj.y = 0;
        }else if(obj.y+obj.h>this.mainFrame.h){
            obj.y = this.mainFrame.h - obj.h;
        }
    }
    log.debug("COMPLETED","resizeObjAccToMagnetPointsOnTouchEnd");

};
*/

template.prototype.resizeGroupAccToMagnetPointsOnTouchEnd=function(group){
     log.debug("STARTED","resizeGroupAccToMagnetPointsOnTouchEnd");
    var magnetPt = this.magnetPointObj;
    var magnetObj = this.magnetEffectObj;
    var x = 0, y = 0;
   
    if(magnetPt.xPoint == -1 && magnetPt.yPoint == -1){
        if(bPointResetDone){
            setTimeout(function(){
                   magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_MOVE);
                   bPointResetDone = true;
                   },200);
            bPointResetDone = false;
        }
        
        return {delX: 0.00, delY: 0.00};
    }
    var deltaX = 0.00;
    var deltaY = 0.00;
	
    var bndRect =  groupHandler.boundingRectForGroup(group);
    var diff = 0.00;
 	if(magnetPt.xPoint != -1){
 	
	 	switch(magnetPt.xAline)
        {
            case ALINE_LEFT_TOP:
                diff = magnetPt.xPoint - bndRect.x;
                break;
            case ALINE_CENTER:
                diff =(magnetPt.xPoint - (bndRect.x + bndRect.w/2.0) );
                break;
            case ALINE_RIGHT_BTM:
                diff =(magnetPt.xPoint - (bndRect.x + bndRect.w) );
                break;
            default:
                break;
        }
        deltaX = diff;	        
    	magnetObj.setXMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
    
 	}
 	
 	
	
   diff = 0.00;
   if(magnetPt.yPoint != -1){
        switch(magnetPt.yAline)
        {
            case ALINE_LEFT_TOP:
               diff = magnetPt.yPoint - bndRect.y;	             
            	break;
            case ALINE_CENTER:
              	diff =(magnetPt.yPoint - (bndRect.y + bndRect.h/2.0) );	             
                break;
            case ALINE_RIGHT_BTM:
                diff =(magnetPt.yPoint - (bndRect.y + bndRect.h) );	             
                break;
            default:
                break;
        }
        deltaY = diff;
        magnetObj.setYMagnetRange(MAGNET_RANGE_FOR_ATTACHED);
	}
	
	
	
	
	
	var diff = {delX: deltaX, delY: deltaY};
	
    log.debug("COMPLETED","resizeGroupAccToMagnetPointsOnTouchEnd");
    return diff;


};



/*Function for finding MAGNET_PRIORITY for control point*/
template.prototype.getMagnetPriorityForCPIndex=function(index){
    var prio = {xPrio:MAGNET_PRIORITY_NONE, yPrio:MAGNET_PRIORITY_NONE};
    switch(index)
    {
        case 0:
        case 1:
            prio.xPrio = MAGNET_PRIORITY_LEFT;
            prio.yPrio = MAGNET_PRIORITY_TOP;
            break;
        case 2:
        case 3:
            prio.xPrio = MAGNET_PRIORITY_RIGHT;
            prio.yPrio = MAGNET_PRIORITY_TOP;
            break;
        case 4:
        case 5:
            prio.xPrio = MAGNET_PRIORITY_RIGHT;
            prio.yPrio = MAGNET_PRIORITY_BOTTOM;
            break;
        case 6:
        case 7:
            prio.xPrio = MAGNET_PRIORITY_LEFT;
            prio.yPrio = MAGNET_PRIORITY_BOTTOM;
            break;
        default:
            break;
    }
    return prio;
};

template.prototype.getMagnetPriorityFixedFrameCPIndex=function(index){
    var prio = {xPrio:MAGNET_PRIORITY_NONE, yPrio:MAGNET_PRIORITY_NONE};
    switch(index)
    {
        case TOP_SIDE:
        case LEFT_SIDE:
            prio.xPrio = MAGNET_PRIORITY_LEFT;
            prio.yPrio = MAGNET_PRIORITY_TOP;
            break;
        case BOTTOM_SIDE:
        case RIGHT_SIDE:
            prio.xPrio = MAGNET_PRIORITY_RIGHT;
            prio.yPrio = MAGNET_PRIORITY_BOTTOM;
            break;
        default:
            break;
    }
    return prio;
};

template.prototype.getPositiveDiff=function(a, b){
    var temp = a - b;
    return (temp>=0)?temp:((-1)*temp);
};
