template.prototype.getPercentageForDelta=function(obj1,obj2)
{
    var newObj={dxP:0,dyP:0};
    newObj.dxP=obj1.w/obj2.w;
    newObj.dyP=obj1.h/obj2.h;
    return newObj;
};

/*A utilty function to find index in multiSelElmArr based on element id */
template.prototype.findIndexUsingId=function(elmID){
    var len = this.multiSelElmArr.length;
    var i;
    for(i=0;i<len;i++){
        if(elmID == this.multiSelElmArr[i].id){
            return i;
            }
        }
    return -1;
};
/*This function will return the groupid from element id,frame id  or cover Id*/
template.prototype.getGroupIdFromElementOrCoverId=function(inputId)
{
    var groupId=null;
    if(TemplateUtils.isElementTypeGroup(inputId))
    {
        groupId=inputId;
    }
    else
    {
        inputId=TemplateUtils.getElementIdFromCoverId(inputId);
        if(TemplateUtils.isElementTypeMainFrame(inputId))
        {
            groupId=this.getTextObjectFromId(inputId).groupId;
        }
        else
        {
            groupId=this.getInnerFrameForId(inputId).groupId;
        }
    }
    return groupId;
};
/*This function adds the element to multiselect array and highlights it on tap event if the multiselect mode is enabled. If the element is already selected it removes it from the multiSelElmArr*/
template.prototype.multiSelMainFrameCoverTapEvent = function()
{
    var elmSel = this.getMainElmOrFrameElmExistOnPoint(this.cpDragStartPt);
    log.debug("elmSel:" + elmSel, "multiSelMainFrameCoverTapEvent");
    var flag = true;
    if(elmSel != null)
    {
        if(TemplateUtils.isElementTypeGroup(elmSel))
        {
            if($("#" + elmSel).hasClass("groupDivSelCls"))
            {
                this.removeElementFromMultiSelectArray(elmSel);
                group.removeGroupDiv(elmSel);
                flag = false;
            }
        }
        else if(!TemplateUtils.isElementTypeMainFrame(elmSel))
        {
            if($("#frameCover-" + elmSel).hasClass("coverDivSelCls"))
            {
                this.hideFrameCp(elmSel);
                this.showFrameCover(elmSel, false);
                this.removeElementFromMultiSelectArray(elmSel);
                flag = false;
            }
        }
        else if($("#ElmCover-" + elmSel).hasClass("mainFrameElmSelCls"))
        {
            this.removeMainFrameCp(elmSel);
            this.removeElementFromMultiSelectArray(elmSel);
            flag = false;
        }

        if(flag)
        {
            this.pushAndSelGroupOrElmOnMultiSelect(elmSel);
            this.addBoxShadowForMultiselect();
        }
    }
};

/*A utility function to remove an element from the multiSelElmArr*/
template.prototype.removeElementFromMultiSelectArray=function(elmSel)
{
    var a = this.findIndexUsingId(elmSel);
    log.debug("elmSel = " + elmSel + " index = "+ a,"removeElementFromMultiSelectArray");
    this.multiSelElmArr.splice(a,1);  ///////removing the element from the array !
    if(this.multiSelElmArr.length == 0){
        this.showMainFrame();
    }
    else
    {
        this.addBoxShadowForMultiselect();
    }
};
/*This function is invoked when rotation touch end event happens. In this we update all the references for all the multiselected elements*/
template.prototype.multiSelRotationTchEnd=function()
{
    log.debug("START" ,"multiSelRotationTchEnd");
    var lenofarr = this.multiSelElmArr.length;
    var elmObj,preRotation,rotation,curElmObjPoints, elmID;
    var isGroup, isMainFrame;
    var undoRotationArr = [], preXArr = [], preYArr = [], currXArr = [], currYArr = [];

    for(var i=0;i<lenofarr;i++){
        preXArr = [];
        preYArr = [];
        currXArr = [];
        currYArr = [];

        elmObj=this.multiSelElmArr[i];
        preRotation=elmObj.ref.rotation;
        elmID = elmObj.id;

        isGroup = TemplateUtils.isElementTypeGroup(elmID);
        isMainFrame = TemplateUtils.isElementTypeMainFrame(elmID);

        log.debug("elmID = " + elmID + " preRotation = " + preRotation + " rotation = " + rotation,"multiSelRotationTchEnd");

        if(isGroup)
        {
	    rotation=getParseIntInDec($("#"+elmID).attr("angle"));
            var group = groupHandler.groupMap[elmID];
            var angleDiff = rotation - preRotation;
            this.pushXYPosToArr(group,preXArr,preYArr);
            group.multiSelectUpdateGroupAfterRotation(elmID, rotation, preRotation, angleDiff);
            this.pushXYPosToArr(group,currXArr,currYArr);
            // since all elements of the group will have same rotation so rotation of first element can be used group.elements[0].ref.rotation
            if(UNDO_REDO_ALLOWED){
                this.addMultiSelDataFrUndoRedo(undoRotationArr, preRotation, group.elements[0].ref.rotation, preXArr, preYArr, currXArr, currYArr);
            }
        }
        else
        {
            preXArr.push(elmObj.x);
            preYArr.push(elmObj.y);
			rotation=preRotation;
            if(isMainFrame)
            {
				rotation=getParseIntInDec($("#"+elmID).attr("angle"));
            }
			else if(this.isRotationSuppotedForElmType(this.getFrameType(elmID)) && elmObj.ref.element.length==1)
            {
				rotation=getParseIntInDec($("#frameCover-"+elmID).attr("angle"));
            }

            elmObj.ref.rotation=rotation;
            curElmObjPoints ={mainFrameSelElmObj:{x:elmObj.ref.x,y:elmObj.ref.y,w:elmObj.ref.w,h:elmObj.ref.h,rotation:elmObj.ref.rotation},mainFrame:this.mainFrame};
            if(!this.isFloatingElmAddAllowed(elmObj.ref) || !TemplateUtils.isElmInsideMainFrame(curElmObjPoints))
            {
                elmObj.ref.rotation=preRotation;
                if(isMainFrame)
                {
                    this.setMainFrmElmAngle(elmID, preRotation);
                }
                else
                {
                    this.setAngleForFrameHtml(elmID, preRotation);
                }
                rotation = preRotation;// reset rotation value when rotation not performed
            }
            currXArr.push(elmObj.x);
            currYArr.push(elmObj.y);
            if(UNDO_REDO_ALLOWED){
                this.addMultiSelDataFrUndoRedo(undoRotationArr, preRotation, rotation, preXArr, preYArr, currXArr, currYArr);
            }
        }
    }
    if(UNDO_REDO_ALLOWED && undoRotationArr.length > 0){
        this.createUndoRedoDataFrMultiSelRotate(undoRotationArr);
    }
};
template.prototype.pushXYPosToArr = function(group, xArr, yArr){
    var grpElmLen = group.elements.length;
    for (var j = 0; j < grpElmLen; j++) {
        xArr.push(group.elements[j].x);
        yArr.push(group.elements[j].y);
    }
};

/*This function is invoked when rotation touch move event happens. In this we update the rotation angle for all the multiselected elements*/
template.prototype.multiSelSetRotationAngle=function(degree)
{
    log.debug("START- Degree:: " + degree,"multiSelSetRotationAngle");
    var lenofarr = this.multiSelElmArr.length;
    var elmObj,deg,elmType,elmID,groupObj;
    for(var i=0;i<lenofarr;i++){
        elmObj=this.multiSelElmArr[i];
        elmID = elmObj.id;
        elmType=this.getElementTypeFromId(elmID);
        if(this.isRotationSuppotedForElmType(elmType))
        {
            if(TemplateUtils.isElementTypeGroup(elmID))
            {
               groupObj=groupHandler.groupMap[elmID];
                if(groupObj.isRotationSupported)
                {
                    group.multiSelectRotateGroup(elmID, degree);
                }
            }
            else if(TemplateUtils.isElementTypeMainFrame(elmID))
            {
                if(elmType!=TEXT || (elmType==TEXT && !elmObj.ref.bTextSlide))
                {
                    var deg=degree+elmObj.ref.rotation;
                    deg = TemplateUtils.convertAngleMoreThan360(deg);
                    this.setMainFrmElmAngle(elmObj.id,deg);
                }
            }
            else
            {
                if(elmObj.ref.element.length==1)
                {
                    var deg=degree+elmObj.ref.rotation;
                    deg = TemplateUtils.convertAngleMoreThan360(deg);
                    this.setAngleForFrameHtml(elmID, deg);
                }
            }
        }
    }
    log.debug("End","multiSelSetRotationAngle");
};
/*This function is invoked when control point touch end event happens. In this we update all the references for all the multiselected elements*/
template.prototype.multiSelectElementsTouchendEvent=function(isFromCP)
{
    if(this.checkForMultiModeEnd(isFromCP)){
        var lenofarr = this.multiSelElmArr.length;
        var elmID;
        var currActiveElm,currElmType;
        var elmObj;
        var undoRedoResizeArr = [];
        var isElmMoved = false;
        var isAnyShape=false;
        var currObj=this;
        var shapeObjArr=[];
        for(var i=0;i<lenofarr;i++){
            elmObj = this.multiSelElmArr[i];
            currActiveElm=elmObj.ref;
            isElmMoved = this.isPosModified(elmObj,currActiveElm);
            undoRedoResizeArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
            this.updateObjXYHWFromObj(undoRedoResizeArr[i].start, elmObj);
            elmID=elmObj.id;
            currElmType=getParseIntInDec($("#"+elmID).attr("type"));//currActiveElm.elementType;
            log.debug("currActiveElm elmID = " + elmID + " x = " + currActiveElm.x + " y = " + currActiveElm.y + " w = " + currActiveElm.w + " h = " + currActiveElm.h,"multiSelectElementsTouchendEvent");
            this.updateObjXYHWFromObj(elmObj, currActiveElm);
            elmObj.leftpos = currActiveElm.x;
            elmObj.toppos = currActiveElm.y;
            if(TemplateUtils.isElementTypeGroup(elmID))
            {
                group.multiSelUpdateGroupElms(elmID, shapeObjArr);
            }
            else if(currElmType==TEXT)
            {
               this.textImageUpdate(elmID);
            }
            else if(TemplateUtils.isShape(currElmType) && isFromCP)
            {
                isAnyShape=true;
                var tmpShapeObj = {};
                tmpShapeObj.shapeType = shapeInfoMapping[currActiveElm.elementType].Id;
                tmpShapeObj.prop = currActiveElm;
                tmpShapeObj.divID = elmID;
                shapeObjArr.push(tmpShapeObj);
            }
            if(isElmMoved){
                if(isFromCP && !TemplateUtils.isElementTypeMainFrame(elmID) && !TemplateUtils.isElementTypeGroup(elmID))
                {
                    this.aspectFillAllElementOfFrame(elmID);
                }
            }
            this.updateObjXYHWFromObj(undoRedoResizeArr[i].end, elmObj);
        }
        if(isAnyShape || shapeObjArr.length > 0)
        {
            this.renderShapes(shapeObjArr);
        }
        this.createFrameCordInfo("mainFrame");
        if(UNDO_REDO_ALLOWED && undoRedoResizeArr.length > 0){
            this.createUndoRedoDataFrMultiSelResize(undoRedoResizeArr);
        }
    }
    else
    {
        this.updateObjInMultiSelArray(this.multiSelElmArr);
    }
};
/*This function is invoked when control points touch move event happens. In this we update the references(x,y,w,h) for all the multi selected elements*/
template.prototype.multiSelMainFrameCpTouchMove=function(evtElmIndex,percentChangeInWidth, percentChangeInHeight, elementId)
{
    var multiElmLen=this.multiSelElmArr.length-1;
    var curObj;
    var elmID;
    var shapeDrawFlag=[];
    for(var i = 0; i <= multiElmLen; i++)
    {
         shapeDrawFlag[i]=true;
    }
    for(var i = 0; i <= multiElmLen; i++)
    {
        curObj=this.multiSelElmArr[i];
        var rect = this.getRectForElmInMultiSelMode(evtElmIndex,percentChangeInWidth, percentChangeInHeight,curObj, curObj.ref.rotation);
        elmID = curObj.id;
        log.debug("elmID = " + elmID + " percentChangeInWidth = " + percentChangeInWidth + " percentChangeInHeight = " + percentChangeInHeight + " data provider elementId = " + elementId,"multiSelMainFrameCpTouchMove");
        if(TemplateUtils.isElementTypeGroup(elmID))
        {
            if(this.isValidCpForElement(curObj.ref.childElementType,evtElmIndex))
            {
                group.multiSelectResizeGroup(rect, curObj, elmID, curObj.ref);
            }
        }
        else
        {
            var elmObj = curObj.ref;
            if(this.isValidCpForElement(elmObj.elementType,evtElmIndex))
            {
                this.checkElmResizeForMnFrmBoundary(rect.x, rect.y, rect.w, rect.h, elmObj, evtElmIndex, elmID);
                if(TemplateUtils.isShape(elmObj.elementType)){
                    var currentShape = shapeInfoMapping[elmObj.elementType].Id;
                    if(shapeDrawFlag[i]){
                          shapeDrawFlag[i] = false;
                          this.reDrawShapeOnTouchMove(elmObj,elmID,currentShape,shapeDrawFlag,i);
                    }
                }
            }
        }
    }
};
template.prototype.isValidCpForElement=function(iElmType,controlPointIndx)
{
    var flag=true;
    switch(iElmType)
    {
        case widgetInfo.WEATHER_TODAY:
        case widgetInfo.WEATHER_WEEK:
        case widgetInfo.WEATHER_HOUR:
        case widgetInfo.ANALOG_CLOCK_1:
        case widgetInfo.ANALOG_CLOCK_2:
        case widgetInfo.ANALOG_CLOCK_3:
        case widgetInfo.ANALOG_CLOCK_4:
        case widgetInfo.ANALOG_CLOCK_5:
            if(controlPointIndx==1 || controlPointIndx==3 || controlPointIndx==5 || controlPointIndx==7)
            {
                flag=false;
            }
        break;
        default:
        break;
    }
    return flag;
};
template.prototype.isPosModified=function(elmObj,currActiveElm){
    if(elmObj.x != currActiveElm.x || elmObj.y != currActiveElm.y || elmObj.w != currActiveElm.w || elmObj.h != currActiveElm.h){
        return true;
    }
    return false;
}

/*This function is invoked when drag touch move event happens. In this we update the references left top(x,y) of all the multiselected elements*/
template.prototype.multiSelMainFrameDragTouchMove=function(deltaX, deltaY)
{
     var multiElmLen=this.multiSelElmArr.length-1;
     for( var i = 0; i <= multiElmLen; i++)
     {
        curObj=this.multiSelElmArr[i];
        var elmID = curObj.id;
        if(TemplateUtils.isElementTypeGroup(elmID))
        {
            group.multiSelectDragGroup(deltaX, deltaY, curObj);
        }
        else if(TemplateUtils.isElementTypeMainFrame(elmID))
        {
            this.DragElement(curObj,deltaX,deltaY,curObj.id);
        }
        else
        {
            this.multiSelDragBlkLayoutFrame(curObj,deltaX,deltaY,curObj.id);
        }
     }
};

template.prototype.getRotatedTranslatedFixedPoint=function(centerPoint, fixedPoint, rotation)
{
    var rotatedFixedPoint = utilR.doTransformation(centerPoint, fixedPoint, rotation, true);
    var trRotFxPoint = {
            x:rotatedFixedPoint.x - centerPoint.x ,
            y:rotatedFixedPoint.y - centerPoint.y
    };
    return trRotFxPoint;
};
/*This function is get the rect for the elements when the element is resized in multiselect mode. We get the percentage change in width and height and all the elements has to be updated based
on the change in percent width and height. Parameter evtElmIndex points to the control point selected*/
template.prototype.getRectForElmInMultiSelMode=function(evtElmIndex,percentChangeInWidth, percentChangeInHeight, elmObj, rotation)
{
    var rect, updatedCenterPoint;
    var nw = ((percentChangeInWidth * elmObj.w) / 100) + elmObj.w;
    var nh = ((percentChangeInHeight * elmObj.h) / 100) + elmObj.h;
    var centerPoint = {
            x:elmObj.x + elmObj.w/2,
            y:elmObj.y + elmObj.h/2
    };
    var origin = {
            x:0,
            y:0
    };

    switch(evtElmIndex)
    {
        case 3:
        {
            var fixedPoint = {
                    x:elmObj.x,
                    y:elmObj.y + elmObj.h/2
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x + nw/2,
                    y:unrotatedTranslatedRotatedFixedPoint.y
            };
            break;
        }
        case 7:
        {
            var fixedPoint = {
                    x:elmObj.x + elmObj.w,
                    y:elmObj.y + elmObj.h/2
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x - nw/2,
                    y:unrotatedTranslatedRotatedFixedPoint.y
            };
            break;
        }
        case 5:
        {
            var fixedPoint = {
                    x:elmObj.x + elmObj.w/2,
                    y:elmObj.y
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x,
                    y:unrotatedTranslatedRotatedFixedPoint.y + nh/2
            };
            break;
        }
        case 1:
        {
            var fixedPoint = {
                    x:elmObj.x + elmObj.w/2,
                    y:elmObj.y + elmObj.h
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x,
                    y:unrotatedTranslatedRotatedFixedPoint.y - nh/2
            };
            break;
        }
        case 6:
        {
            var fixedPoint = {
                    x:elmObj.x + elmObj.w,
                    y:elmObj.y
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x - nw/2,
                    y:unrotatedTranslatedRotatedFixedPoint.y + nh/2
            } ;
            break;
        }
        case 2:
        {
            var fixedPoint = {
                    x:elmObj.x,
                    y:elmObj.y + elmObj.h
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x + nw/2,
                    y:unrotatedTranslatedRotatedFixedPoint.y - nh/2
            } ;
            break;
        }
        case 4:
        {
            var fixedPoint = {
                    x:elmObj.x,
                    y:elmObj.y
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x + nw/2,
                    y:unrotatedTranslatedRotatedFixedPoint.y + nh/2
            } ;
            break;
        }
        case 0:
        {
            var fixedPoint = {
                    x:elmObj.x + elmObj.w,
                    y:elmObj.y + elmObj.h
            };
            var translatedRotatedFixedPoint = this.getRotatedTranslatedFixedPoint(centerPoint, fixedPoint, rotation);
            var unrotatedTranslatedRotatedFixedPoint = utilR.doTransformation(origin, translatedRotatedFixedPoint, -rotation, true);
            updatedCenterPoint = {
                    x:unrotatedTranslatedRotatedFixedPoint.x - nw/2,
                    y:unrotatedTranslatedRotatedFixedPoint.y - nh/2
            } ;
            break;
        }
    }
    var rotatedCenterPoint = utilR.doTransformation(origin, updatedCenterPoint, rotation, true);
    var translatedRotatedCenterPoint = {
            x:rotatedCenterPoint.x + centerPoint.x ,
            y:rotatedCenterPoint.y + centerPoint.y
    };
    rect = {
            x:translatedRotatedCenterPoint.x-nw/2,
            y:translatedRotatedCenterPoint.y-nh/2,
            w:nw,
            h:nh
    };
    log.debug("CP = " + evtElmIndex + " currLeft="+rect.x + " currTop=" + rect.y + " currWidth = " + nw + " currHeight = " + nh + " rotation= "+ rotation + " percentChangeInWidth = " +
            percentChangeInWidth + " percentChangeInHeight = " + percentChangeInHeight, "getRectForElmInMultiSelMode");
    return rect;
};

/*Push the object in multiSelElmArr and hightlight the selected element by creating div for it*/
template.prototype.pushObjInMultiSelArray=function(elmID)
{
    var elmObj;
    var newObj={id:elmID,x:0,y:0,w:0,h:0,leftpos:0,toppos:0,ref:null};
    log.debug("elmID : " +JSON.stringify(elmID), "pushObjInMultiSelArray");
    if(TemplateUtils.isElementTypeGroup(elmID))
    {
        elmObj = groupHandler.groupMap[elmID];
    }
    else if(TemplateUtils.isElementTypeMainFrame(elmID))
    {
        var elmIndx=elmID.split("-elm_")[1].split("_")[0];
        elmObj=this.mainFrame.element[elmIndx];
        if(this.isTxtTypeElm(elmObj.elementType))
        {
            elmObj=elmObj.textElms[0];
        }
    }
    else
    {
        elmObj = this.getInnerFrameForId(elmID);
        log.debug("elmID : " +JSON.stringify(elmObj), "pushObjInMultiSelArray");
    }

    newObj.ref=elmObj;
    this.updateObjXYHWFromObj(newObj,elmObj);
    newObj.leftpos=elmObj.x;
    newObj.toppos=elmObj.y;
    this.multiSelElmArr.push(newObj);
};
template.prototype.updateObjInMultiSelArray=function(multiSelElmArrLocal)
{
    log.debug("START - 1flag:","updateObjInMultiSelArray");

    var multilength = multiSelElmArrLocal.length;
    var elmObj,elmID,multiSelElm,multiSelGrpElm,j;
    for(var i=0 ; i<multilength ; i++){
        multiSelElm = multiSelElmArrLocal[i];
        elmID=multiSelElm.id;
        elmObj=multiSelElm.ref;
        this.copyDataFromMultiSelElmToAcutalObj(multiSelElm);
        if(TemplateUtils.isElementTypeGroup(elmID))
        {
            group.setAndUpdateGroupPosition(elmID,groupHandler.groupMap[elmID]);
            groupHandler.selGrpElmList = [];
            groupHandler.getGroupElements(elmID, groupHandler.selGrpElmList);
            groupHandler.drag=[];
            var elmLen=groupHandler.selGrpElmList.length;
            for(j=0;j<elmLen;j++)
            {
                multiSelGrpElm=groupHandler.selGrpElmList[j];
                this.copyDataFromMultiSelElmToAcutalObj(multiSelGrpElm);
                this.resetMultiSelectElementsPosition(multiSelGrpElm.ref,multiSelGrpElm.id);
            }
        }
        else
        {
            this.resetMultiSelectElementsPosition(elmObj,elmID);
        }
    }
    log.debug("COMPLETED","updateObjInMultiSelArray");
};
template.prototype.resetMultiSelectElementsPosition=function(elmObj,elmID)
{
    if(TemplateUtils.isElementTypeMainFrame(elmID))
    {
        this.resetMnFrmElementPos(elmID,elmObj);
        this.updateMainFrameCpPosition(elmID);
    }
    else
    {
        this.updateBlkFrameDimention(elmID, elmObj.x, elmObj.y, elmObj.w, elmObj.h);
    }
};
template.prototype.copyDataFromMultiSelElmToAcutalObj=function(multiSelElm)
{
    var elmObj=multiSelElm.ref;
    this.updateObjXYHWFromObj(elmObj,multiSelElm);
    multiSelElm.leftpos = elmObj.x;
    multiSelElm.toppos = elmObj.y;
};
template.prototype.checkForMultiModeEnd=function(isFromCP){

    var len = this.multiSelElmArr.length;
    var flag=true,multiSelElm,multiSelGrpElm,j;
    for(var i=0;i<len;i++){
        multiSelElm=this.multiSelElmArr[i];
        if(TemplateUtils.isElementTypeGroup(multiSelElm.id))
        {
            groupHandler.selGrpElmList = [];
            groupHandler.getGroupElements(multiSelElm.id, groupHandler.selGrpElmList);
            var elmLen=groupHandler.selGrpElmList.length;
            for(j=0;j<elmLen;j++)
            {
                multiSelGrpElm=groupHandler.selGrpElmList[j];
                if(!this.isValidMoveForMultiSelectElement(multiSelGrpElm,isFromCP))
                {
                    flag=false;
                    break;
                 }
            }
            if(!flag)
            {
                break;
            }
        }
        else if(!this.isValidMoveForMultiSelectElement(multiSelElm,isFromCP))
        {
            flag=false;
            break;
        }
    }
    log.debug("flag = "+flag,"checkForMultiModeEnd");
    return flag;
};
template.prototype.isValidMoveForMultiSelectElement=function(multiSelElm,isFromCP)
{
    var flag=true;
    if(TemplateUtils.isElementTypeMainFrame(multiSelElm.id))
    {
        if(!this.isValidMoveForMultiSelectMainFrameElement(multiSelElm.ref))
        {
            flag=false;
        }
    }
    else if (!this.isValidMoveForMultiSelectInnerFrameElement(multiSelElm.ref,isFromCP))
    {
        flag=false;
    }
    return flag;
};
template.prototype.isValidMoveForMultiSelectMainFrameElement=function(element)
{
    if(this.isFloatingElmAddAllowed(element) && this.isFloatingElmAddAllowedRMD(element))
    {
        return true;
    }
    this.showElementOverlapToast();
    return false;
};
template.prototype.isValidMoveForMultiSelectInnerFrameElement=function(frame,isFromCP)
{
    var isValid=true,frame,type;
    type = this.getFrameType(frame.id);
    switch(this.modelType)
    {
        case RHE_MODEL:
        case TIZEN_MODEL:
        case STRETCH_MODEL:
        case TIZEN_S5:
        case TIZEN_S6:
            if(this.isVideoTypeElm(type))
            {
                if(this.isFloatingElmOverFrameExist(frame,type) || this.isV_IS_DocFrameExistOverFrame(frame)){
                    isValid = false;
                    this.showElementOverlapToast();
                }
                if(isFromCP && type == INPUT_SOURCE  && this.checkInputSrcSizeLimit(frame)){
                    isValid = false;
                }
            }
        break;
        case RMD_MODEL:
            isValid = !this.checkOverlapConditionRMD(frame, type);
        break;
        default:
        break;
    }
    return isValid;
};
template.prototype.getMainElmOrFrameElmExistOnPoint=function(point)
{
    var divID=this.getMainFrameElmExistOnPoint(point);
    if(divID==null && this.frameLayout==BLANK_LAYOUT)
    {
        divID=this.getFrameElmExistOnPoint(point);
    }
    log.debug("divID = "+divID,"getMainElmOrFrameElmExistOnPoint");
    return divID;
};
template.prototype.getFrameElmExistOnPoint=function(point)
{
    var frameId,divID=null,frame;
    var innerFrameZorderArray = this.getInnerFrameGroupZorderArray();
    for(var index=innerFrameZorderArray.length-1;index>=0;index--){
        frameId = FRAME_ID_PREFIX+ innerFrameZorderArray[index];
        frame=this.getInnerFrameForId(frameId);
        if(utilR.pointInsideRect(frame,point))
        {
            if(frame.groupId != null)
            {
                divID = groupHandler.findRoot(frame.groupId);
            }
            else
            {
                divID=frameId;
            }
            break;
        }
    }
    return divID;
};

/*Add element/group to multi select array and set selection on group/element div*/
template.prototype.pushAndSelGroupOrElmOnMultiSelect = function(elmID)
{
	log.debug("elmID : " + elmID, "pushAndSelGroupOrElmOnMultiSelect");
	this.pushObjInMultiSelArray(elmID);
	this.selGroupOrElmOnMultiSelect(elmID);
};

/*Add selection to multi select item*/
template.prototype.selGroupOrElmOnMultiSelect = function(elmID)
{
    if(TemplateUtils.isElementTypeGroup(elmID))
    {
        group.createGroupDiv(elmID);
    }
    else if(TemplateUtils.isElementTypeMainFrame(elmID))
    {
        this.showMainFrameElmCp(elmID);
    }
    else
    {
        log.debug("frameId : " + elmID, "pushAndSelGroupOrElmOnMultiSelect");
        if(!$("#frameCover-" + elmID).hasClass("coverDivSelCls"))
        {
            this.showBlankLayoutFrameCP(elmID);
        }
    }
};
template.prototype.deleteMultiselectedElements=function(isFromUndoRedo, multiSelElmArrLocal)
{
    var length = multiSelElmArrLocal.length;
    var multiSelElmArrCopy = multiSelElmArrLocal.slice();// create copy of array
    var undoRedoDelArr = [];
    var mnFrmIndx = 0;
    var innerFrameZOrder  = 0, frameObj;
    for (var i = 0; i < length; i++)
    {
        elmId = multiSelElmArrLocal[i].id;
        if(TemplateUtils.isElementTypeGroup(elmId))
        {
            group.deleteGroup(elmId);
        }
        else
        {
            if(TemplateUtils.isElementTypeMainFrame(elmId))
            {
                mnFrmIndx = TemplateUtils.getIndexOfMainFrameElementFromID(elmId);
                    undoRedoDelArr.push({isMainFrame: true, elementObj:this.mainFrame.element[mnFrmIndx], mainFrameIndex:mnFrmIndx, zIndex:this.getMnFrmLayerArrIndex(mnFrmIndx)});
                this.deleteElement(mnFrmIndx);
            }
            else
            {
                frameObj = this.getInnerFrameForId(elmId);
                innerFrameZOrder = this.getCurrZPosOfFrm(elmId);
                undoRedoDelArr.push({isMainFrame: false, frameObj:frameObj,innerFrameZOrder:innerFrameZOrder});
                this.delAllDataFromFrame(elmId);
            }
        }
    }
    if(UNDO_REDO_ALLOWED && !isFromUndoRedo){
        if(undoRedoDelArr.length > 0){
           this.createUndoRedoDataFrMultiSelDel(undoRedoDelArr, multiSelElmArrCopy);
        }
    }
    this.showMainFrame();
    this.createFrameCordInfo("");
    this.enableMultiSelect(false);
};
/*Ungroup all the selected groups which are present in multiSelElmArr*/
template.prototype.multiSelectUnGroup=function()
{
    var length = templateObj.multiSelElmArr.length;
    for (var i = 0; i < length; i++)
    {
        var elmId = templateObj.multiSelElmArr[i].id;
        if(TemplateUtils.isElementTypeGroup(elmId))
        {
            group.handleUnGroup(elmId);
            this.multiSelElmArr.splice(i,1);
            length = length-1;
            i=i-1;
        }
    }
    this.addBoxShadowForMultiselect();
};
/*This is a utility function to move the given element id to last position in the multi select element array holding all the selected elements*/
template.prototype.moveElmToLastPosInMulSelArr=function(elmId)
{
    log.debug("elmId:" +elmId, " moveElmToLastPosInMulSelArr");
    var length = this.multiSelElmArr.length;
    var elmObj = null;
    for (var i = 0; i < length; i++)
    {
        if(this.multiSelElmArr[i].id == elmId)
        {
            elmObj = this.multiSelElmArr[i];
            this.multiSelElmArr.splice(i,1);
            log.debug("removing element ID = " + elmId, " moveElmToLastPosInMulSelArr");
            break;
        }
    }
    if(elmObj != null)
    {
        this.multiSelElmArr.splice(length,0, elmObj);
    }
};
/*getting the selected main frame element on tap event*/
template.prototype.getMainFrameElmExistOnPoint=function(point)
{
    var elmType,ele,divID,flag=false;
    var elmArray = this.getGroupZorderArray();
    var elmLength=elmArray.length;
    for(var index=(elmLength-1);index>=0;index--)
    {
        ele = this.mainFrame.element[elmArray[index]];
        if(ele != null){
            elmType=ele.elementType;
            if(this.isTxtTypeElm(elmType))
            {
                ele=ele.textElms[0];
            }
            if(elmType!=DECO_IMAGE && utilR.pointInsideRect(ele,point))
            {
                if(ele.groupId != null)
                {
                    divID = groupHandler.findRoot(ele.groupId);
                }
                else
                {
                    divID=this.mainFrame.id+"-elm_"+elmArray[index]+"_0";
                }
                this.hideMainFrame();
                flag=true;
                break;
            }
        }
    }
    if(flag)
    {
        return divID;
    }
    else
    {
        return null;
    }
};

/*iterate over all the groups and sub groups and populate an array of elements. The array holds the index of the elements. This index is used to retrieve the element object in mainFrame.element list*/
template.prototype.getGroupElementsIndex=function(group, elementArray)
{
//	log.debug("Group Info : " +JSON.stringify(group), "getGroupElementsIndex");
    var elmIndx, id;
    var numOfElements = group.elements.length;
    for (var i = 0; i < numOfElements; i++) {
        id =  group.elements[i].id;
        if(TemplateUtils.isElementTypeGroup(id))
        {
            this.getGroupElementsIndex(group.elements[i].ref, elementArray);
        }
        else
        {
            elmIndx = TemplateUtils.getElementIndexFromID(id);
            elementArray.push(elmIndx);
        }
    }
};
/*iterate over all the groups and sub groups and populate an array of elements. The array holds the index of the elements. This index is used to retrieve the element object in mainFrame.element list*/
template.prototype.getInnerFrameGroupElementsIndex=function(group, elementArray)
{
    var numOfElements = group.elements.length;
    for (var i = 0; i < numOfElements; i++) {
        var id =  group.elements[i].id;
        if(TemplateUtils.isElementTypeGroup(id))
        {
            this.getInnerFrameGroupElementsIndex(group.elements[i].ref, elementArray);
        }
        else
        {
            log.debug("id : " + id, "getInnerFrameGroupElementsIndex");
            var elmIndx = getParseIntInDec(id.split("_")[1]);
            log.debug("elmIndx : " + elmIndx, "getInnerFrameGroupElementsIndex");
            elementArray.push(elmIndx);
        }
    }
};
/*left align all the multiselected elements*/
template.prototype.leftAlignMultiSel=function(){
    log.debug("START","leftAlignMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var undoRedoLeftAlignArr = [];
    var lastElement;
    if(length == 1){
        lastElement = {x:0,y:0,w:currObj.mainFrame.w,h:currObj.mainFrame.h,rotation:0};
    }else{
        lastElement = currObj.multiSelElmArr[length-1].ref;
    }
    var elmObj,refObj;
    lastElement = TemplateUtils.createBoundingRectangle(lastElement);
    for(var i= 0;i<length;i++)
    {
        elmObj=currObj.multiSelElmArr[i];
        refObj = elmObj.ref;
        /*Creating a backup before changing values*/
        var elmLocationBackup = {x:0,y:0,w:0,h:0};
        this.updateObjXYHWFromObj(elmLocationBackup, elmObj);
        /*Undo/Redo adding initial state*/
        undoRedoLeftAlignArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
        this.updateObjXYHWFromObj(undoRedoLeftAlignArr[i].start, elmLocationBackup);

        var boundingRectForElement = TemplateUtils.createBoundingRectangle(refObj);
        if(lastElement.x + boundingRectForElement.w <= currObj.mainFrame.w)
        {
            var elmID = elmObj.id;
            var deltaX = lastElement.x - boundingRectForElement.x;

            /*Doing changes for the alignment*/
            elmObj.x = elmObj.x + deltaX;
            elmObj.leftpos = elmObj.x;
            elmObj.toppos = elmObj.y;
            refObj.x = elmObj.x;

            if(this.isValidMoveForMultiSelectElement(elmObj, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupLeftAlign(elmID, deltaX);
                }
                else
                {
                    this.resetMnFrmElementPos(elmObj.id,refObj);
                }
            }
            else
            {
               /*Reverting as the move is invalid*/
               this.updateObjXYHWFromObj(elmObj,elmLocationBackup);
               elmObj.leftpos = elmObj.x;
               elmObj.toppos = elmObj.y;
               refObj.x = elmObj.x;
            }
        }

        /*Undo/Redo adding end state*/
        this.updateObjXYHWFromObj(undoRedoLeftAlignArr[i].end, elmObj);
    }
    if(UNDO_REDO_ALLOWED && undoRedoLeftAlignArr.length > 0){
        this.createUndoRedoDataFrMultiSelResize(undoRedoLeftAlignArr);
    }
    log.debug("COMPLETED","leftAlignMultiSel");
};
/*right align all the multiselected elements*/
template.prototype.rightAlignMultiSel=function(){
    log.debug("START","rightAlignMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var undoRedoRightAlignArr = [];
    var lastElement;
    if(length == 1){
        lastElement = {x:0,y:0,w:currObj.mainFrame.w,h:currObj.mainFrame.h,rotation:0};
    }else{
        lastElement = currObj.multiSelElmArr[length-1].ref;
    }
    var elmObj,refObj;
    lastElement = TemplateUtils.createBoundingRectangle(lastElement);
    for(var i= 0;i<length;i++){

        elmObj=currObj.multiSelElmArr[i];
        refObj =elmObj.ref;

        /*Creating a backup before changing values*/
        var elmLocationBackup = {x:0,y:0,w:0,h:0};
        this.updateObjXYHWFromObj(elmLocationBackup, elmObj);

        /*Undo/Redo adding initial state*/
        undoRedoRightAlignArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
        this.updateObjXYHWFromObj(undoRedoRightAlignArr[i].start, elmLocationBackup);

        var boundingRectForElement = TemplateUtils.createBoundingRectangle(refObj);
        if(lastElement.x + lastElement.w - boundingRectForElement.w >=0)
        {
            var elmID = elmObj.id;
            var deltaX = lastElement.x + lastElement.w - boundingRectForElement.w - boundingRectForElement.x;

            /*Doing changes for the alignment*/
            elmObj.x = elmObj.x + deltaX;
            elmObj.leftpos = elmObj.x;
            elmObj.toppos = elmObj.y;
            refObj.x = elmObj.x;

            if(this.isValidMoveForMultiSelectElement(elmObj, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupRightAlign(elmID, deltaX);
                }
                else
                {
                    this.resetMnFrmElementPos(elmObj.id,refObj);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(elmObj,elmLocationBackup);
                elmObj.leftpos = elmObj.x;
                elmObj.toppos = elmObj.y;
                refObj.x = elmObj.x;
            }
        }

        /*Undo/Redo adding end state*/
        this.updateObjXYHWFromObj(undoRedoRightAlignArr[i].end, elmObj);
    }
    if(UNDO_REDO_ALLOWED && undoRedoRightAlignArr.length > 0){
        this.createUndoRedoDataFrMultiSelResize(undoRedoRightAlignArr);
    }
    log.debug("COMPLETED","rightAlignMultiSel");
};
/*top align all the multiselected elements*/
template.prototype.topAlignMultiSel=function(){
    log.debug("START","topAlignMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var undoRedoTopAlignArr = [];
    var lastElement;
    if(length == 1){
        lastElement = {x:0,y:0,w:currObj.mainFrame.w,h:currObj.mainFrame.h,rotation:0};
    }else{
        lastElement = currObj.multiSelElmArr[length-1].ref;
    }
    var elmObj,refObj;
    lastElement = TemplateUtils.createBoundingRectangle(lastElement);
    for(var i= 0;i<length;i++){
        elmObj=currObj.multiSelElmArr[i];
        refObj = elmObj.ref;

        /*Creating a backup before changing values*/
        var elmLocationBackup = {x:0,y:0,w:0,h:0};
        this.updateObjXYHWFromObj(elmLocationBackup, elmObj);

        /*Undo/Redo adding initial state*/
        undoRedoTopAlignArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
        this.updateObjXYHWFromObj(undoRedoTopAlignArr[i].start, elmLocationBackup);

        var boundingRectForElement = TemplateUtils.createBoundingRectangle(refObj);
        if(lastElement.y +  boundingRectForElement.h <= currObj.mainFrame.h)
        {
            var elmID = elmObj.id;
            var deltaY = lastElement.y - boundingRectForElement.y;

            /*Doing changes for the alignment*/
            elmObj.y = elmObj.y + deltaY;
            elmObj.leftpos = elmObj.x;
            elmObj.toppos = elmObj.y;
            refObj.y = elmObj.y;

            if(this.isValidMoveForMultiSelectElement(elmObj, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupTopAlign(elmID, deltaY);
                }
                else
                {
                    this.resetMnFrmElementPos(elmObj.id,refObj);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(elmObj,elmLocationBackup);
                elmObj.leftpos = elmObj.x;
                elmObj.toppos = elmObj.y;
                refObj.y = elmObj.y;
            }
        }

        /*Undo/Redo adding end state*/
        this.updateObjXYHWFromObj(undoRedoTopAlignArr[i].end, elmObj);
    }
    if(UNDO_REDO_ALLOWED && undoRedoTopAlignArr.length > 0){
        this.createUndoRedoDataFrMultiSelResize(undoRedoTopAlignArr);
    }
    log.debug("COMPLETED","topAlignMultiSel");
};
/*bottom align all the multiselected elements*/
template.prototype.bottomAlignMultiSel=function(){
    log.debug("START","bottomAlignMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var undoRedoBottomAlignArr = [];
    var lastElement;
    if(length == 1){
        lastElement = {x:0,y:0,w:currObj.mainFrame.w,h:currObj.mainFrame.h,rotation:0};
    }else{
        lastElement = currObj.multiSelElmArr[length-1].ref;
    }
    var elmObj,refObj;
    lastElement = TemplateUtils.createBoundingRectangle(lastElement);
    for(var i= 0;i<length;i++){
        elmObj=this.multiSelElmArr[i];
        refObj=elmObj.ref;

        /*Creating a backup before changing values*/
        var elmLocationBackup = {x:0,y:0,w:0,h:0};
        this.updateObjXYHWFromObj(elmLocationBackup, elmObj);

        /*Undo/Redo adding initial state*/
        undoRedoBottomAlignArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
        this.updateObjXYHWFromObj(undoRedoBottomAlignArr[i].start, elmLocationBackup);

        var boundingRectForElement = TemplateUtils.createBoundingRectangle(refObj);
        if(lastElement.y + lastElement.h - boundingRectForElement.h>=0)
        {
            var elmID = elmObj.id;
            var deltaY = lastElement.y + lastElement.h - boundingRectForElement.h - boundingRectForElement.y;

            /*Doing changes for the alignment*/
            elmObj.y = elmObj.y+deltaY;
            elmObj.leftpos = elmObj.x;
            elmObj.toppos = elmObj.y;
            refObj.y = elmObj.y;

            if(this.isValidMoveForMultiSelectElement(elmObj, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupBottomAlign(elmID, deltaY);
                }
                else
                {
                    this.resetMnFrmElementPos(elmObj.id,refObj);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(elmObj,elmLocationBackup);
                elmObj.leftpos = elmObj.x;
                elmObj.toppos = elmObj.y;
                refObj.y = elmObj.y;
            }
        }

        /*Undo/Redo adding end state*/
        this.updateObjXYHWFromObj(undoRedoBottomAlignArr[i].end, elmObj);
    }
    if(UNDO_REDO_ALLOWED && undoRedoBottomAlignArr.length > 0){
        this.createUndoRedoDataFrMultiSelResize(undoRedoBottomAlignArr);
    }
    log.debug("COMPLETED","bottomAlignMultiSel");
};
/*Vertically align the center of all the multiselected elements*/
template.prototype.centerAlignVerticallyMultiSel=function(){
    log.debug("START","centerAlignVerticallyMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var undoRedoCenterAlignHorArr = [];
    var lastElement;
    if(length == 1){
        lastElement = {x:0,y:0,w:currObj.mainFrame.w,h:currObj.mainFrame.h,rotation:0};
    }else{
        lastElement = currObj.multiSelElmArr[length-1].ref;
    }
    var elmObj, refObj;
    lastElement = TemplateUtils.createBoundingRectangle(lastElement);
    for(var i= 0;i<length;i++){

        elmObj=this.multiSelElmArr[i];
        refObj = elmObj.ref;

        /*Creating a backup before changing values*/
        var elmLocationBackup = {x:0,y:0,w:0,h:0};
        this.updateObjXYHWFromObj(elmLocationBackup, elmObj);

        /*Undo/Redo adding initial state*/
        undoRedoCenterAlignHorArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
        this.updateObjXYHWFromObj(undoRedoCenterAlignHorArr[i].start, elmObj);

        var boundingRectForElement = TemplateUtils.createBoundingRectangle(refObj);
        if(lastElement.y + (lastElement.h)/2 - (boundingRectForElement.h)/2>=0   &&  lastElement.y + (lastElement.h)/2 + (boundingRectForElement.h)/2 <= currObj.mainFrame.h)
        {
            var elmID = elmObj.id;
            var deltaY = lastElement.y + (lastElement.h)/2 - (boundingRectForElement.h)/2 - boundingRectForElement.y;

            /*Doing changes for the alignment*/
            elmObj.y = elmObj.y + deltaY;
            elmObj.leftpos = elmObj.x;
            elmObj.toppos = elmObj.y;
            refObj.y = elmObj.y;

            if(this.isValidMoveForMultiSelectElement(elmObj, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupCenterAlignHorizontally(elmID, deltaY);
                }
                else
                {
                    this.resetMnFrmElementPos(elmObj.id,refObj);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(elmObj,elmLocationBackup);
                elmObj.leftpos = elmObj.x;
                elmObj.toppos = elmObj.y;
                refObj.y = elmObj.y;
            }
        }

        /*Undo/Redo adding end state*/
        this.updateObjXYHWFromObj(undoRedoCenterAlignHorArr[i].end, elmObj);
    }
    if(UNDO_REDO_ALLOWED && undoRedoCenterAlignHorArr.length > 0){
        this.createUndoRedoDataFrMultiSelResize(undoRedoCenterAlignHorArr);
    }
    log.debug("COMPLETED","centerAlignVerticallyMultiSel");
};

/*Horizontally align the center of all the multiselected elements*/
template.prototype.centerAlignHorizontalyMultiSel=function(){
    log.debug("START","centerAlignHorizontalyMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var undoRedoCenterAlignVerArr = [];
    var lastElement;
    if(length == 1){
        lastElement = {x:0,y:0,w:currObj.mainFrame.w,h:currObj.mainFrame.h,rotation:0};
    }else{
        lastElement = currObj.multiSelElmArr[length-1].ref;
    }
    var elmObj,refObj;
    lastElement = TemplateUtils.createBoundingRectangle(lastElement);
    for(var i= 0;i<length;i++){
        elmObj=this.multiSelElmArr[i];
        refObj=elmObj.ref;

        /*Creating a backup before changing values*/
        var elmLocationBackup = {x:0,y:0,w:0,h:0};
        this.updateObjXYHWFromObj(elmLocationBackup, elmObj);

        /*Undo/Redo adding initial state*/
        undoRedoCenterAlignVerArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});
        this.updateObjXYHWFromObj(undoRedoCenterAlignVerArr[i].start, elmObj);

        var boundingRectForElement = TemplateUtils.createBoundingRectangle(refObj);
        if(lastElement.x + (lastElement.w)/2 - (boundingRectForElement.w)/2>=0   &&  lastElement.x + (lastElement.w)/2 + (boundingRectForElement.w)/2 <= currObj.mainFrame.w)
        {
            var elmID = elmObj.id;
            var deltaX = lastElement.x + (lastElement.w)/2 - (boundingRectForElement.w)/2 - boundingRectForElement.x;

            /*Doing changes for the alignment*/
            elmObj.x = elmObj.x + deltaX;
            elmObj.leftpos = elmObj.x;
            elmObj.toppos = elmObj.y;
            refObj.x = elmObj.x;

            if(this.isValidMoveForMultiSelectElement(elmObj, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupCenterAlignVertically(elmID, deltaX);
                }
                else
                {
                    this.resetMnFrmElementPos(elmObj.id,refObj);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(elmObj,elmLocationBackup);
                elmObj.leftpos = elmObj.x;
                elmObj.toppos = elmObj.y;
                refObj.x = elmObj.x;
            }
        }

        /*Undo/Redo adding end state*/
        this.updateObjXYHWFromObj(undoRedoCenterAlignVerArr[i].end, elmObj);
    }
    if(UNDO_REDO_ALLOWED && undoRedoCenterAlignVerArr.length > 0){
        this.createUndoRedoDataFrMultiSelResize(undoRedoCenterAlignVerArr);
    }
    log.debug("COMPLETED","centerAlignHorizontalyMultiSel");
};
/*align the elements center horizontally by dividing the distance between extreme end elements equally among all the multi selected elements*/
template.prototype.distributeHorizontallyMultiSel=function(){
    log.debug("START","distributeHorizontallyMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var elementPositionArr=[];
    var undoRedoDistHorArr = [];
    if(length > 2)
    {
        /*Making an element array to store the index and the x position, it is done to sort element based on position while keeping the actual array untouched.*/
        for(var i=0;i<length;i++)
        {
            var dummyObj={elementIndex:i, x:currObj.multiSelElmArr[i].x};
            elementPositionArr.push(dummyObj);
        }
        elementPositionArr.sort(function(a, b){return a.x - b.x});
        var firstElementBoundingRect = TemplateUtils.createBoundingRectangle(currObj.multiSelElmArr[elementPositionArr[0].elementIndex].ref);
        var lastElementBoundingRect = TemplateUtils.createBoundingRectangle(currObj.multiSelElmArr[elementPositionArr[elementPositionArr.length-1].elementIndex].ref);

        var totalDistance = lastElementBoundingRect.x - firstElementBoundingRect.x + lastElementBoundingRect.w;
        var widthSum = 0;

        for(var i=0;i<currObj.multiSelElmArr.length;i++){
            widthSum = widthSum + TemplateUtils.createBoundingRectangle(currObj.multiSelElmArr[i].ref).w;
            undoRedoDistHorArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});//created empty array of length same as multiSelElmArr
        }
        var d = (totalDistance - widthSum)/(currObj.multiSelElmArr.length-1);
        var start = firstElementBoundingRect.x;
        var obj1;
        var currentElementIndex; /*Stores the current index of the element in the actual multi select array*/
        for(var i=0;i<length;i++){
            currentElementIndex = elementPositionArr[i].elementIndex;
            obj1 = currObj.multiSelElmArr[currentElementIndex];
            var boundingRectForElement = TemplateUtils.createBoundingRectangle(obj1.ref);


            var elmID = obj1.id;
            var deltaX = start - boundingRectForElement.x;

            /*Adding check so that delta doesn't causes element to go outside main frame*/
            if(boundingRectForElement.x + deltaX + boundingRectForElement.w > currObj.mainFrame.w )
            {
               deltaX = currObj.mainFrame.w - boundingRectForElement.w - boundingRectForElement.x;
            }
            else if(boundingRectForElement.x + deltaX < 0)
            {
               deltaX =  -boundingRectForElement.x;
            }

            /*Creating a backup before changing values*/
            var elmLocationBackup = {x:0,y:0,w:0,h:0};
            this.updateObjXYHWFromObj(elmLocationBackup, obj1);

            /*UndoRedo adding initial state*/
            this.updateObjXYHWFromObj(undoRedoDistHorArr[currentElementIndex].start, elmLocationBackup);

            obj1.x = obj1.x + deltaX;
            obj1.ref.x = obj1.x;
            obj1.leftpos = obj1.x ;
            log.debug("elmID = " + elmID,"distributeHorizontallyMultiSel");

            if(this.isValidMoveForMultiSelectElement(obj1, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupDistributeHorizontally(elmID, deltaX);
                }
                else
                {
                    this.resetMnFrmElementPos(obj1.id,obj1.ref);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(obj1,elmLocationBackup);
                obj1.ref.x = obj1.x;
                obj1.leftpos = obj1.x ;
            }

            /*UndoRedo adding end state*/
            this.updateObjXYHWFromObj(undoRedoDistHorArr[currentElementIndex].end, obj1);

            start = start + boundingRectForElement.w + d;
        }
        if(UNDO_REDO_ALLOWED && undoRedoDistHorArr.length > 0){
            this.createUndoRedoDataFrMultiSelResize(undoRedoDistHorArr);
        }
    }
    log.debug("COMPLETED","distributeHorizontallyMultiSel");
};
/*align the elements center vertically by dividing the distance between extreme end elements equally among all the multi selected elements*/
template.prototype.distributeVerticallyMultiSel=function(){
    log.debug("START","distributeVerticallyMultiSel");
    var currObj = this;
    var length = currObj.multiSelElmArr.length;
    var elementPositionArr=[];
    var undoRedoDistVertArr = [];
    if(length > 2)
    {
        /*Making an element array to store the index and the y position, it is done to sort element based on position while keeping the actual array untouched.*/
        for(var i=0;i<length;i++)
        {
            var dummyObj={elementIndex:i, x:currObj.multiSelElmArr[i].y};
            elementPositionArr.push(dummyObj);
        }
        elementPositionArr.sort(function(a, b){return a.y - b.y;});
        var firstElementBoundingRect = TemplateUtils.createBoundingRectangle(currObj.multiSelElmArr[elementPositionArr[0].elementIndex].ref);
        var lastElementBoundingRect = TemplateUtils.createBoundingRectangle(currObj.multiSelElmArr[elementPositionArr[elementPositionArr.length-1].elementIndex].ref);

        var totalDistance = lastElementBoundingRect.y - firstElementBoundingRect.y + lastElementBoundingRect.h;
        var heightSum = 0;

        for(var i=0;i<currObj.multiSelElmArr.length;i++){
            heightSum = heightSum + TemplateUtils.createBoundingRectangle(currObj.multiSelElmArr[i].ref).h;
            undoRedoDistVertArr.push({start:{x:0,y:0,w:0,h:0}, end:{x:0,y:0,w:0,h:0}});//created empty array of length same as multiSelElmArr
        }
        var d = (totalDistance - heightSum)/(currObj.multiSelElmArr.length-1);
        var start = firstElementBoundingRect.y;
        var obj1;
        var currentElementIndex; /*Stores the current index of the element in the actual multi select array*/
        for(var i=0;i<length;i++){
            currentElementIndex = elementPositionArr[i].elementIndex;
            obj1 = currObj.multiSelElmArr[currentElementIndex];
            var boundingRectForElement = TemplateUtils.createBoundingRectangle(obj1.ref);

            var elmID = obj1.id;
            var deltaY = start - boundingRectForElement.y;

            /*Adding check so that delta doesn't causes element to go outside main frame*/
            if(boundingRectForElement.y + deltaY + boundingRectForElement.h > currObj.mainFrame.h )
            {
               deltaY = currObj.mainFrame.h - boundingRectForElement.h - boundingRectForElement.y;
            }
            else if(boundingRectForElement.y + deltaY < 0)
            {
               deltaY =  -boundingRectForElement.y;
            }

            /*Creating a backup before changing values*/
            var elmLocationBackup = {x:0,y:0,w:0,h:0};
            this.updateObjXYHWFromObj(elmLocationBackup, obj1);

            /*UndoRedo adding initial state*/
            this.updateObjXYHWFromObj(undoRedoDistVertArr[currentElementIndex].start, elmLocationBackup);

            obj1.y = obj1.y + deltaY;
            obj1.ref.y = obj1.y;
            obj1.toppos = obj1.y ;

            if(this.isValidMoveForMultiSelectElement(obj1, false))
            {
                if(TemplateUtils.isElementTypeGroup(elmID))
                {
                    group.groupDistributeVertically(elmID, deltaY);
                }
                else
                {
                    this.resetMnFrmElementPos(obj1.id,obj1.ref);
                }
            }
            else
            {
                /*Reverting as the move is invalid*/
                this.updateObjXYHWFromObj(obj1,elmLocationBackup);
                obj1.ref.y = obj1.y;
                obj1.toppos = obj1.y;
            }

            /*UndoRedo adding end state*/
            this.updateObjXYHWFromObj(undoRedoDistVertArr[currentElementIndex].end, obj1);

            start = start + boundingRectForElement.h + d;
        }
        if(UNDO_REDO_ALLOWED && undoRedoDistVertArr.length > 0){
            this.createUndoRedoDataFrMultiSelResize(undoRedoDistVertArr);
        }
    }
    log.debug("COMPLETED","distributeVerticallyMultiSel");
};
