/*
 * Created by amber.m 15-11-2015
 *  Dependent Files : templateFrames.js, templatePageDesign.js, Template.js
 *  Last Update BY: Sailender Singh(sailender.s) - 29th Mar 16
 */

var previewImageStartTime = 0;
var previewVideoStartTime = 0;
var tableElmHtmlStr = "";

var templatePreview=function(tempObj){
    this.tObj = tempObj;
    this.stickerTextPreviewObj = new previewTextSticker();
};

templatePreview.prototype.createPreviewObj=function(){
    log.debug("STARTED","createPreviewObj");
    
    var defaultBGColor = SaveTemplate.changeColorFormat(this.tObj.bgColor);
    if (defaultBGColor == undefined || defaultBGColor.length <1)
    {
        defaultBGColor = "214;214;214";
    }
    if(this.tObj != null){
        this.stickerTextPreviewObj.orientation=this.tObj.orientation;
        this.stickerTextPreviewObj.lfdSize.w=this.tObj.lfdSize.w;
        this.stickerTextPreviewObj.lfdSize.h=this.tObj.lfdSize.h;
        this.stickerTextPreviewObj.updateCanvasPreviewWidthHeight();
        var lfdContent = {
            DisplayWidth:this.tObj.lfdSize.w,
            DisplayHeight:this.tObj.lfdSize.h,
            orientation:this.tObj.orientation,
            frameLayout:getParseIntInDec(this.tObj.frameLayout),
            BGImageFilePath:this.tObj.bgImage,
            BGColor:defaultBGColor,
            mainFrame:null,
            innerFrameArr:[],
            audioPath:this.tObj.audioPath,
            audioFileName:this.tObj.audioFileName,
            selAudioFrm:this.tObj.selAudioFrm,
            audioFlag:this.tObj.audioFlag
        };
        lfdContent.mainFrame = this.createFrameObj(this.tObj.mainFrame,false);
        lfdContent.mainFrame.x = 0;
        lfdContent.mainFrame.y = 0;
        lfdContent.mainFrame.w = this.tObj.lfdSize.w;
        lfdContent.mainFrame.h = this.tObj.lfdSize.h;
        
        var frameObj = null;
        var innerFrameZorderArray = this.tObj.getInnerFrameGroupZorderArray();
        for(var index in innerFrameZorderArray){
            var frameIndex = innerFrameZorderArray[index];
            var frameId = FRAME_ID_PREFIX+frameIndex;
            frameObj = this.tObj.innerFrames[frameId];
            previewVideoStartTime = 0;
            previewImageStartTime = 0;
            var previewFrameObj = this.createFrameObj(frameObj,false);
            if(previewFrameObj.elementArr.length > 0)
            lfdContent.innerFrameArr.push(previewFrameObj);
        }
         if(tableElmHtmlStr !="")
         {
            lfdContent.innerFrameArr.push(this.createFrameObj(this.tObj.mainFrame,true));
            tableElmHtmlStr = "";
         }

        if(this.tObj.selAudioFrm ==""){
        	lfdContent.selAudioFrm = SaveTemplate.getFirstFrameIdWithVideoOrInpSrc();
        }

        var lfdObj = JSON.stringify(lfdContent);
        this.showLFDPreview(lfdObj);
        log.debug("PLAYER OBJECT JSON DATA = "+lfdObj,"createPreviewObj");
    }
};

templatePreview.prototype.createFrameObj=function(frame,menuBoardHtml){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, frame);

    var frameObj = {
	    frameId:frame.id,
	    PositionX:rect.x,
		PositionY:rect.y,
		Width:rect.w,
		Height:rect.h,
	    elementArr:[],
	    tableElmArr:[],
	    Rotation:getParseIntInDec(frame.rotation),
	    transitionEffect:this.tObj.getEffectTypeFromStr(frame.transitionEffect)
    };
    if(menuBoardHtml)
    {
        var bodyHtmlStr = this.stickerTextPreviewObj.getModifiedBodyHTMLPreview();
        bodyHtmlStr +=(tableElmHtmlStr + "</div>");
        bodyHtmlStr = bodyHtmlStr.replace(/"/g ,"'");
        frameObj.elementArr.push(this.stickerTextPreviewObj.getFinalObjForPreview(bodyHtmlStr,false));
        return frameObj;
    }
    log.debug("Element Type =  "+frame.element.length,"createFrameObj");
    var isTizenAndriodModel = false;
     if(Utils.isHighEndModel(templateObj.modelType) && (!(isIOS())))
     {
        isTizenAndriodModel = true;
     }
    var hiddenElmArr=[];
    if(this.tObj.mainFrame.id == frame.id){
        var elmIndex = -1;
        var ele = null;
        var eleObj = null;
        var zOrderArray = this.tObj.getGroupZorderArray();
        var loopLen=zOrderArray.length;

        for (var eleLayer = 0; eleLayer < loopLen; eleLayer++) {
            elmIndex = zOrderArray[eleLayer];
            ele = frame.element[elmIndex];
            if(isTizenAndriodModel && this.stickerTextPreviewObj.stickerOrTextWithOutSlideEle(ele))
            {
                if(ele.elementType == STICKER || ele.elementType==HANDWRITING)
                {
                    var fileName= ele.fileName;
                    var stickerElmId = fileName.substring(0,fileName.indexOf("_InrElm"));
                    hiddenElmArr.push({id:"#"+stickerElmId,type:ele.elementType});
                }
                else if(ele.elementType == TEXT)
                {
                    this.stickerTextPreviewObj.addTextElementToHiddenArr(false,hiddenElmArr,ele.textElms[0]);
                }
            }
            else
            {
                eleObj = this.createElement(ele, frame, rect);
                if(eleObj != null){
                    frameObj.elementArr.push(eleObj);
                }
            }
        }
    }else{
        for(var index = 0;index<frame.element.length;index++){
            var ele = frame.element[index];
            eleObj = this.createElement(ele, frame, rect);
            if(eleObj != null){
                frameObj.elementArr.push(eleObj);
            }
        }
    }
     if(hiddenElmArr.length > 0)
     {
        frameObj.elementArr.push(this.stickerTextPreviewObj.getPreviewElmObjOfDiffLayers(true,hiddenElmArr));
     }
    if(frame.table != null){
        log.debug("frame.table.col.length = "+frame.table.col.length,"createFrameObj");
        var nOfCols = frame.table.col.length;
        var len=frame.table.col[0].length;
        var txtElem = null;
        var tableHtmlStr="";
        var hiddenElmArr=[];
        var tableHtmlPresent = false;
        for(var colIndex =0;colIndex < nOfCols;colIndex++){
            for(var i=0;i<len;i++){
               txtElem = frame.table.col[colIndex][i];
               if(isTizenAndriodModel)
               {
                   tableHtmlPresent = true;
                   this.stickerTextPreviewObj.addTextElementToHiddenArr(true,hiddenElmArr,txtElem);
               }
               else
               {
                frameObj.tableElmArr.push(this.createTextElementObj(txtElem, {
                                                                        duration:0,
                                                                        rotation:0,
                                                                        elementType:TEXT
                                                                        }));
               }

            }
        }
        if(tableHtmlPresent)
        {
            this.stickerTextPreviewObj.convertCanvasDimToPrevOfHtml({id:"#"+frame.id},true);
            this.stickerTextPreviewObj.setResetMenuBoardItemsforPreview(hiddenElmArr,true);
            tableElmHtmlStr+=this.stickerTextPreviewObj.getPreviewElmObjOfDiffLayers(false,frame.id);
            this.stickerTextPreviewObj.convertCanvasDimToPrevOfHtml({id:"#"+frame.id},false);
            this.stickerTextPreviewObj.setResetMenuBoardItemsforPreview(hiddenElmArr,false);
        }
    }
    return frameObj;
};

templatePreview.prototype.createElement=function(ele, frame, rect){
    var eleObj = null;
    var eleType = ele.elementType;
    if(eleType >= shapeInfo.CIRCLE && eleType <= SHAPE)
    {
        eleType = SHAPE;
    }
    
    switch(eleType)
    {
        case STICKER:
        case HANDWRITING:
        case DECO_IMAGE:
        case SHAPE:
            eleObj = this.createElementObj(ele);
            break;
        case VIDEO:
            eleObj = this.createVideoElementObj(ele, rect);
            break;
        case INPUT_SOURCE:
        case PPT:
        case PDF:
            eleObj = this.createDefaultElementObj(ele, rect);
            break;
        case IMAGE:
            eleObj = this.createImageElementObj(ele, frame, rect);
            break;
        case TEXT:
            if(!(ele.textElms[0].text == MIA_SID_DOUBLE_TAP_TO_EDIT && ele.textElms[0].bgAlpha==0)){
                eleObj = this.createTextElementObj(ele.textElms[0], ele);
            }
            break;
        case GROUP:
            eleObj = this.createGroupElementObj(ele, frame, rect);
            break;
        case widgetInfo.WEB:
            eleObj = this.createWebElementObj(ele, rect);
            break;
        case widgetInfo.DIGITAL_CLOCK:
            eleObj = this.createDigitalClockElementObj(ele.textElms[0], ele);
            break;
        case widgetInfo.WEATHER_WEEK:
        case widgetInfo.WEATHER_HOUR:
        case widgetInfo.WEATHER_TODAY:
            eleObj = this.createWeatherElementObj(ele);
            break;
        case widgetInfo.ANALOG_CLOCK_1:
        case widgetInfo.ANALOG_CLOCK_2:
        case widgetInfo.ANALOG_CLOCK_3:
        case widgetInfo.ANALOG_CLOCK_4:
        case widgetInfo.ANALOG_CLOCK_5:
            eleObj = this.createAnalogClockElementObj(ele);
            break;
        case widgetInfo.RSS:
            eleObj = this.createRSSElementObj(ele.textElms[0], ele);
            break;
        case widgetInfo.MEDIARSS:
            eleObj = this.createMediaRSSElementObj(ele, frame, rect);
            break;
        default:
            break;
    }
    return eleObj;
};

templatePreview.prototype.createMediaRSSElementObj=function(ele,frame, parent){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, frame);
    
    var MediaRSSObj = {
    type:ele.elementType,
    PositionX:rect.x,                      
    PositionY:rect.y,
    Width:rect.w,
    Height:rect.h,
    FrameId:frame.id,
    MediaRssReloadDuration:getParseIntInDec(ele.mediaRssInfo.reloadDuration),
    MediaRSS_URL:this.replaceSpecialChar(ele.mediaRssInfo.url),
    MediaRSSFillInType:ele.mediaRssInfo.aspectFill
    };
    log.debug("MediaRSSObj::::"+JSON.stringify(MediaRSSObj), "media rss");
    return MediaRSSObj;
};


templatePreview.prototype.createRSSElementObj=function(ele, parent){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);
        
    var hAlignmtTitleVal = this.hAlignFromString(ele.rssInfo.title.hAlign);
    var hAlignmtDateVal = this.hAlignFromString(ele.rssInfo.date.hAlign);
    var hAlignmtDescVal = this.hAlignFromString(ele.rssInfo.description.hAlign);
    var NewsDisplayOption = 0;
    var textDirection = 0;
    var textSpeed = 0;
    var displayCycle = 0;
   	
   	if(ele.rssInfo.title.visible && ele.rssInfo.date.visible && ele.rssInfo.description.visible)
	{
		NewsDisplayOption = 3;		
	}
	else if(ele.rssInfo.title.visible && ele.rssInfo.description.visible)
	{
		NewsDisplayOption = 2;		
	}
	else if(ele.rssInfo.title.visible && ele.rssInfo.date.visible)
	{
		NewsDisplayOption = 1;			
	}
	else if(ele.rssInfo.title.visible)
	{
		NewsDisplayOption = 0;
	}
	if(ele.bTextSlide){
		textDirection =  getParseIntInDec(ele.slideType);		
		textSpeed = getParseIntInDec(ele.slideSpeed);
		displayCycle = 0;
	}else{
		textDirection = 0;
		textSpeed = 0;
		displayCycle = getParseIntInDec(ele.rssInfo.flipSpeed);		
	}	
	var RSSObj = {
	    type:parent.elementType,
	    PositionX:rect.x,
	    PositionY:rect.y,
	    Width:rect.w,
	    Height:rect.h,
	    Rotation:getParseIntInDec(parent.rotation),
	    Duration:getParseIntInDec(parent.duration),
	    FillOpacity:getParseIntInDec(ele.bgAlpha),
	    TextDirection:textDirection,
	    TextSpeed:textSpeed,
	    titleTextFontSize:getParseIntInDec(ele.rssInfo.title.fontSize),
	    pubDateTextFontSize:getParseIntInDec(ele.rssInfo.date.fontSize),
	    descriptionTextFontSize:getParseIntInDec(ele.rssInfo.description.fontSize),
	    RssReloadDuration:getParseIntInDec(ele.rssInfo.reloadDuration),
	    FilePath:"",
	    Start:"00:00:00.00",//HH:MM:SS
	    RSS_URL:this.replaceSpecialChar(ele.rssInfo.url),
	    DISPLAY_CYCLE:displayCycle,
	    FillColor:SaveTemplate.changeColorFormat(ele.bgColor),
	    TextFontName:ele.fontFamily,
	    
	    titleTextColor:SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(ele.rssInfo.title.color)),
	    titleTextHAlign:hAlignmtTitleVal,
	    
	    pubDateTextColor:SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(ele.rssInfo.date.color)),
	    pubDateTextHAlign:hAlignmtDateVal,
	    
	    descriptionTextColor:SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(ele.rssInfo.description.color)),
	    descriptionTextHAlign:hAlignmtDescVal,
	    
	    NewsDisplayOption:NewsDisplayOption
	};
    
    return RSSObj;
};

templatePreview.prototype.createWeatherElementObj=function(ele){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);
    var curLang = Utils.getWeatherLangSessionValue();
    var weatherObj = {
        type:ele.elementType,
	    PositionX:rect.x,
	    PositionY:rect.y,
	    Width:rect.w,
	    Height:rect.h,
	    WeatherType:ele.elementType,
	    Unit:getParseIntInDec(ele.weather.unit),
	    LocationKey:getParseIntInDec(ele.weather.cityId),
	    Date:getParseIntInDec(ele.weather.dateTimeformat),
	    Refresh:getParseIntInDec(ele.weather.refrshIntrvl),
	    Background:getParseIntInDec(ele.weather.bgType),
	    Rotation:getParseIntInDec(ele.rotation),
	    Duration:getParseIntInDec(ele.duration),
	    Opacity:getParseIntInDec(ele.opacity),
	    LanguageCode:curLang,
	    FilePath:"",
	    Start:"00:00:00.00"//HH:MM:SS
    };
   
    return weatherObj;
};

templatePreview.prototype.createDigitalClockElementObj=function(ele, parent){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);    
    
    var hAlignValue = this.hAlignFromString(ele.hAlign);
    var vAlignValue = this.vAlignFromString(ele.vAlign);
    var digClkFillColor = "241;241;241";
    var digClkFillOpacity = 0;
    
    if(ele.bgColor != 'undefined' && ele.bgColor != ""){		
		digClkFillColor = SaveTemplate.changeColorFormat(ele.bgColor);
		digClkFillOpacity = ele.bgAlpha;
	}
	
	var offSet = getTimeZoneOffsetHrMin();	
	var timeZoneOffset = getGMTTimeZoneList(0,offSet);// DF160803-00194 fixed
	
    var digiClockObj = {
        type:parent.elementType,
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,        
        Rotation:getParseIntInDec(parent.rotation),
        Duration:getParseIntInDec(parent.duration),
        TextFontSize:getParseIntInDec(ele.fontSize),
        FillOpacity:getParseIntInDec(digClkFillOpacity), // Its alpha of clock background        
        DigitalClockGMT :timeZoneOffset,
        TimeFormat:getParseIntInDec(ele.format),
	    DisplayLanguage:digitalClockLanguage[ele.DisplayLanguage].index,
        DigitalClockDaylight:0,
        TextColor:SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(ele.fontColor)),
        FillColor:digClkFillColor,
        TextFontName:ele.fontFamily,
        TextHAlign:getParseIntInDec(hAlignValue),
        TextVAlign:getParseIntInDec(vAlignValue),
        Start:"00:00:00.00"//HH:MM:SS
    };    
    return digiClockObj;
};

templatePreview.prototype.createAnalogClockElementObj=function(ele){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);
    
    var offSet = getTimeZoneOffsetHrMin();	
	var timeZoneOffset = getGMTTimeZoneList(0,offSet);
	
    var analogClockObj = {
        type:ele.elementType,
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,        
        Rotation:getParseIntInDec(ele.rotation),
        Duration:getParseIntInDec(ele.duration),
        AnalogClockGMT :timeZoneOffset,
        AnalogClockDaylight:0,
        iconsList:getAnlgClokIcnsByType(ele.elementType),
        FilePath:"",
        Start:"00:00:00.00"//HH:MM:SS
    };
    
    return analogClockObj;
};

templatePreview.prototype.createWebElementObj=function(ele, rect){
    var dur = getParseIntInDec(ele.duration);
    if (dur <= 0) {
        dur = 60; //Its in seconds. Denotes reload time interval of web element
    }
    
    var webObj = {
        type:ele.elementType,
        WebURL:this.replaceSpecialChar(ele.OriginalPath),
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,
        Rotation:getParseIntInDec(ele.rotation),
        Duration:dur,
        Start:"00:00:00.00",//HH:MM:SS        
    };
    
    return webObj;
};

templatePreview.prototype.createTextElementObj=function(ele, parent){
    
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);
    var imgSrc = ele.textImageSrc.replace(/data:image\/png;base64,/, '');
    var direction = getParseIntInDec(ele.slideType);
    var hAlignmt = ele.hAlign;
    var vAlignmt = ele.vAlign;
    
    var eleText = ele.text;
    if(eleText == MIA_SID_DOUBLE_TAP_TO_EDIT) {
        eleText = "";
        imgSrc = "";
    }
    var hAlignValue = this.hAlignFromString(hAlignmt);
    var vAlignValue = this.vAlignFromString(vAlignmt);
     
    if (ele.bTextSlide) {
        imgSrc = "";
        if(direction<2) {
            hAlignmt = "";
        } else {
            vAlignmt = "";
        }
        textDirection = direction;		
		textSpeed = getParseIntInDec(ele.slideSpeed);
   }else{
		textDirection = 0;
		textSpeed = 0;
   }
    var defaultBGColorTex = SaveTemplate.changeColorFormat(ele.bgColor);
    if (defaultBGColorTex == undefined || defaultBGColorTex.length <1)
    {
        defaultBGColorTex = "214;214;214";
    }
    var textObj = {
        type:parent.elementType,
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,
        TextValue:this.replaceSpecialChar(eleText),
        TextColor:SaveTemplate.removeAlpha(SaveTemplate.changeColorFormat(ele.fontColor)),
        FillColor:defaultBGColorTex,
        TextHTML:this.replaceSpecialChar(eleText), 
        TextFontName:ele.fontFamily,
        TextHAlign:hAlignValue,
        TextVAlign:vAlignValue,
        TextItalic:ele.fontItalic,
        TextBold:ele.fontBold,
        TextUnderLine:ele.fontUnderLine,
        FillOpacity:getParseIntInDec(ele.bgAlpha),
        alpha:getParseIntInDec(ele.alpha),
        TextDirection:textDirection,
        TextSpeed:textSpeed,
        Rotation:getParseIntInDec(ele.rotation),
        Duration:getParseIntInDec(parent.duration),
        TextFontSize:getParseIntInDec(ele.fontSize),
        textImageSrc:imgSrc,
        FilePath:"",
        Start:"00:00:00.00",//HH:MM:SS
        StrokeColor:SaveTemplate.changeColorFormat(ele.strkClr),
        StrokeOpacity:getParseIntInDec(ele.strkOpc),
        StrokeDepth:getParseIntInDec(ele.strkDpt),
        ShadowColor:SaveTemplate.changeColorFormat(ele.shdwClr),
        ShadowOpacity:getParseIntInDec(ele.shdwOpc),
        ShadowDepth:getParseIntInDec(ele.shdwDpt),
        ShadowDirection:getParseIntInDec(ele.shdwDir),
        IsDownloadedFont:fontListIsDownloadedFlags[ele.fontFamily+".ttf"],
        IsStrokeApplied:ele.isStrkApplied,
        IsShadowApplied:ele.isShdwApplied
    };
    
    return textObj;
};
// Replace double quotes & braces with there asscii value for preview
templatePreview.prototype.replaceSpecialChar=function(iString)
{
	return iString.replace(/"/ig,'&quot;').replace(/\[/ig,'&#91;').replace(/\]/ig,'&#93;').replace(/\\/ig,'&#92;');
};
templatePreview.prototype.createImageElementObj=function(ele, frame, rect) {
    
    var orgImgSize = {
        w:getParseIntInDec(ele.orgW),
        h:getParseIntInDec(ele.orgH)
    };
    
    var modifiedSize = this.smallImageSizeFromOrgSize(orgImgSize);
    var modifiedEle = $.extend(true, {}, ele);
    modifiedEle.orgW = modifiedSize.w;
    modifiedEle.orgH = modifiedSize.h;
    var cropCord = this.tObj.getImgElmCropCoord(modifiedEle,frame);
    
    var eleObj = {
        type:ele.elementType,
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,
        Rotation:getParseIntInDec(ele.rotation) + getParseIntInDec(frame.rotation),
        Opacity:getParseIntInDec(ele.opacity),
        Duration:getParseIntInDec(frame.duration),
        FilePath:ele.imageSrc,
        ClipLeft:getParseIntInDec(cropCord.l),
        ClipRight:getParseIntInDec(cropCord.r),
        ClipBottom:getParseIntInDec(cropCord.b),
        ClipTop:getParseIntInDec(cropCord.t),
        Start:SaveTemplate.getDurationInHrMinSec(previewImageStartTime)+".00",//HH:MM:SS
        textElementArr:[]
    };
    
    if(ele.textElms != null && ele.textElms.length > 0) {
        for(var index in ele.textElms) {
            eleObj.textElementArr.push(this.createLinkedTextObj(ele.textElms[index]));
        }
    }
    
    previewImageStartTime = previewImageStartTime + getParseIntInDec(frame.duration);
    if(!isIOS())	//temporary check. will be removed once Sailender will update his code accordingly
    {
    	this.recalculateSizeBeforePreview(eleObj);
    }
    
    return eleObj;
};
templatePreview.prototype.recalculateSizeBeforePreview=function(eleObj){
	var rotation = eleObj.Rotation;
	if (rotation == 90 || rotation == 270) {
	    var tmpVal = eleObj.Width;
	    eleObj.Width = parseInt(eleObj.Height);
	    eleObj.Height = parseInt(tmpVal);
	    var w = parseInt(eleObj.Width);
	    var h = parseInt(eleObj.Height);
	    var x = parseInt(eleObj.PositionX);
	    var y = parseInt(eleObj.PositionY);
	    var diffRatio = (w - h) / 2;
	    eleObj.PositionX  = x - diffRatio;
	    eleObj.PositionY  = y + diffRatio;	    
	}
};

templatePreview.prototype.createGroupElementObj=function(ele, frame, rect){
    var eleObj = this.createImageElementObj(ele, frame, rect);
    for(var index = 0; index<ele.textElms.length;index++){
        eleObj.textElementArr.push(this.createTextElementObj(ele.textElms[index], ele));
    }
    return eleObj;    
};

templatePreview.prototype.createVideoElementObj=function(ele, rect){
    
    var eleObj = {
        type:ele.elementType,
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,
        Rotation:getParseIntInDec(ele.rotation),
        Duration:getParseIntInDec(ele.duration),
        FilePath:ele.OriginalPath,
        Start:SaveTemplate.getDurationInHrMinSec(previewVideoStartTime)+".00"//HH:MM:SS
    };
    
    previewVideoStartTime = previewVideoStartTime + getParseIntInDec(ele.duration);
    
    return eleObj;
};

templatePreview.prototype.createDefaultElementObj=function(ele, rect){
    var inptSrcType ="";
    if(ele.elementType == 19){
    	inptSrcType = ele.OriginalPath;
    }    
    var eleObj = {
        type:ele.elementType,
        PositionX:rect.x,
        PositionY:rect.y,
        Width:rect.w,
        Height:rect.h,
        Rotation:getParseIntInDec(ele.rotation),
        Duration:getParseIntInDec(ele.duration),
        Start:"00:00:00.00",//HH:MM:SS
        FilePath:ele.OriginalPath,
        InputSourceType:inptSrcType
    };    
    return eleObj;
};


templatePreview.prototype.createElementObj=function(ele){
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);
    var elType = ele.elementType;
    var imgSrc = ele.imageSrc;
    // textlen is the number of text elements in Editable Sticker. This is used to distinguish between Editable & non-Editable Stickers
    var textLen=ele.textElms.length;
    
    if(elType==STICKER && textLen>0){
    	imgSrc = ele.imageSrc.replace(/data:image\/png;base64,/, '');
        
    } else if(elType >= shapeInfo.CIRCLE && elType <= SHAPE) {
        elType = SHAPE;
        imgSrc = ele.imageSrc.replace(/data:image\/png;base64,/, '');
    }
    
    var eleObj = {
        type:elType,
        PositionX:(elType==SHAPE?rect.x - SHAPE_CANVAS_MARGIN:rect.x),
        PositionY:(elType==SHAPE?rect.y - SHAPE_CANVAS_MARGIN:rect.y),
        Width:(elType==SHAPE?rect.w + 2*SHAPE_CANVAS_MARGIN:rect.w),
        Height:(elType==SHAPE?rect.h + 2*SHAPE_CANVAS_MARGIN:rect.h),
        Rotation:getParseIntInDec(ele.rotation),
        Duration:getParseIntInDec(ele.duration),
        Start:"00:00:00.00",//HH:MM:SS
        TextLen:textLen,
        FilePath:imgSrc
    };
    
    return eleObj;
};

templatePreview.prototype.createLinkedTextObj=function(ele){
    
    var rect = this.tObj.orgRectFrmRelRect(this.tObj.mainFrame, ele);
    var imgSrc = ele.textImageSrc.replace(/data:image\/png;base64,/, '');
    
    var eleObj = {
    type:TEXT,
    TextValue:ele.text,
    PositionX:rect.x,
    PositionY:rect.y,
    Width:rect.w,
    Height:rect.h,
    Rotation:getParseIntInDec(ele.rotation),
    Duration:0,
    Start:"00:00:00.00",//HH:MM:SS
    FilePath:imgSrc
    };
    
    return eleObj;
};

templatePreview.prototype.showLFDPreview=function(lfdObj){
    var success = function(result) {
        
    };
    var error = function(message) {
        
    };
    mUtilityManager.showPreview(success, error, lfdObj);
};
templatePreview.prototype.hAlignFromString=function(hAlignmt){
    
    var mHAlgn = 0;
    switch(hAlignmt) {
        case "center":
            mHAlgn = 1;
            break;
        case "right":
            mHAlgn = 2;
            break;
        default:
            break;
	}	
    return mHAlgn;
};
templatePreview.prototype.vAlignFromString=function(vAlignmt){
    var mVAlgn = 0;
    switch(vAlignmt) {
        case "middle":
            mVAlgn = 1;
            break;
        case "bottom":
            mVAlgn = 2;
            break;
        default:
            break;
	}
    return mVAlgn;
};

templatePreview.prototype.smallImageSizeFromOrgSize=function(size){
    
    var imgWd = 0;
    var imgHt = 0;
    
    var rqWd = 960;
    var rqHt = 540;
    
    if(isIOS()) {
        rqHt = 1000;
        rqWd = 1000;
        if (size.w < rqWd && size.h < rqHt) {
            return size;
        }
    } else {
    	 if(size.w < rqWd && size.h < rqHt) {
               return size;
    	  }
        /*if (size.w*size.h < rqHt*rqWd){
            return size;
        }*/
    }
    
    var ratio = size.w/size.h;
    
    if (size.w > size.h) {
        imgWd = rqWd;
        imgHt = getParseIntInDec(imgWd/ratio);
    } else {
        imgHt = rqHt;
        imgWd = getParseIntInDec(imgHt*ratio);
    }
    
    var modSize = {
    w:imgWd,
    h:imgHt
    };
    
    return modSize;
    
};
