/* 
 * Created by amber.m 07-15-2015
 * Created to handle RMD LFD related functionality
 *  Dependent Files : templateFrames.js, Template.js
 *
 */

template.prototype.isFrameExistOverBlkFrameRMD=function(frame){
    var bExist = false;
    if(this.frameLayout == BLANK_LAYOUT){
        var frameObj = null;
        var frameId = "";
        var innerFrameZorderArray = this.getInnerFrameGroupZorderArray();
        for(var index=innerFrameZorderArray.length-1;index>=0;index--){
            frameId = FRAME_ID_PREFIX+innerFrameZorderArray[index];
            frameObj = this.getInnerFrameForId(frameId);
            if(frameObj != frame){
                if(isRectIntersectExceptBoundary(frameObj, frame))
                {
                    bExist = true;
                    log.debug(" "+frameObj.x+" "+frameObj.y+" "+frameObj.w+" "+frameObj.h,"isFrameExistOverBlkFrameRMD");
                    log.debug(" "+frame.x+" "+frame.y+" "+frame.w+" "+frame.h,"isFrameExistOverBlkFrameRMD");
                    log.debug("VIDEO/INPUT SOURCE/DOC FRAME EXIST OVER FRAME ID = "+frameObj.id,"isFrameExistOverBlkFrameRMD");
                    break;
                }
            }
        }
    }
    log.debug(""+bExist,"isFrameExistOverBlkFrameRMD");
    return bExist;
};

template.prototype.checkOverlapConditionRMD=function(frame, type){
    if(type != EMPTY){
        if(this.isFloatingElmOverFrameExistRMD(frame) || this.isFrameExistOverBlkFrameRMD(frame)){
            Utils.showToast(MIA_SID_ELEMENTS_CANNOT_OVERLAPPED);
            log.debug("TRUE","checkOverlapConditionRMD");
            return true;
        }
    }
    log.debug("FALSE","checkOverlapConditionRMD");
    return false;
};

template.prototype.isFloatingElmAddAllowedRMD=function(elmnt){
    var bAllowed = true;
    if(this.modelType == RMD_MODEL){
        var countObj = this.getAllTypeFrmCount(null);
        //imageFrmCnt:0,videoFrmCnt:0,inptSrcFrmCount:0,docFrmCnt:0,groupFrmCnt:0, emptyFrmCnt:0
        var count = countObj.imageFrmCnt+countObj.videoFrmCnt + countObj.inptSrcFrmCount + countObj.docFrmCnt+countObj.pdfFrmCnt+countObj.groupFrmCnt+countObj.menuBoardCnt+countObj.webFrmCnt;
        log.debug("Non empty frame count  = "+count+" empty frm count = "+countObj.emptyFrmCnt+" menu board frame cnt "+countObj.menuBoardCnt,"isFloatingElmAddAllowedRMD");
        if(count != 0){
            if(this.isTxtTypeElm(elmnt.elementType)){
                elmnt = elmnt.textElms[0];
            }
            var innerFrameZorderArray = this.getInnerFrameGroupZorderArray();
            for(var index=innerFrameZorderArray.length-1;index>=0;index--){
                var frameId = FRAME_ID_PREFIX+innerFrameZorderArray[index];
                frame = this.getInnerFrameForId(frameId);
                var len = frame.element.length;
                if(len>0){
                    if(isRectIntersectExceptBoundary(elmnt, frame))
                    {
                        bAllowed = false;
                    }
                }else if(frame.table != null){
                    bAllowed = this.isTableMenuElmOverlapAllowed(frame, elmnt);
                }
                if(!bAllowed){
                    break;
                }
            }
        }
        if(bAllowed){
            bAllowed = this.isFloatingElmOverFlotingElmRMD(elmnt)?false:true;
        }
    }
    return bAllowed;
};

template.prototype.isFloatingElmOverFrameExistRMD=function(frame){
    var elmCount=this.mainFrame.element.length;
	var elmnt;
    var bExist = false;
	for(var i=0;i<elmCount;i++)
	{
		elmnt=this.mainFrame.element[i];
        if(elmnt != null){
            if(this.isTxtTypeElm(elmnt.elementType)){
                elmnt = elmnt.textElms[0];
            }
            log.debug(elmnt.x+" "+elmnt.y+" "+elmnt.w+" "+elmnt.h ,"isFloatingElmOverFrameExistRMD");
            if(frame.table != null){
                if(isRectIntersectExceptBoundary(elmnt, frame) && !this.isTableMenuElmOverlapAllowed(frame, elmnt)){
                    bExist = true;
                    log.debug("FLOATING ELEMENT EXIST OVER TABLE ELEMENTS= "+frame.id+" "+frame.x+" "+frame.y+" "+frame.w+" "+frame.h,"isFloatingElmOverFrameExistRMD");
                    break;
                }
            }
            else if(isRectIntersectExceptBoundary(elmnt, frame))
            {
                bExist = true;
                log.debug("FLOATING ELEMENT EXIST OVER FRAME ID = "+frame.id+" "+frame.x+" "+frame.y+" "+frame.w+" "+frame.h,"isFloatingElmOverFrameExistRMD");
                break;
            }
        }
	}
    
    return bExist;
};

template.prototype.isFloatingElmOverFlotingElmRMD=function(elm){
    if(this.isTxtTypeElm(elm.elementType)){
        elm = elm.textElms[0];
    }
    //log.debug("15 Input Element- x="+elm.x+",y="+elm.y+",w="+elm.w+",h="+elm.h ,"isFloatingElmOverFlotingElmRMD");
    var elmCount=this.mainFrame.element.length;
	var elmnt;
    var bExist = false;
	for(var i=0;i<elmCount;i++)
	{
		elmnt=this.mainFrame.element[i];
        if(elmnt != null){
            if(this.isTxtTypeElm(elmnt.elementType)){
                elmnt = elmnt.textElms[0];
            }
           // log.debug("Matching Element- x="+elmnt.x+",y="+elmnt.y+",w="+elmnt.w+",h="+elmnt.h ,"isFloatingElmOverFlotingElmRMD");
            
            if(elmnt != elm && isRectIntersectExceptBoundary(elmnt, elm))
            {
                bExist = true;
                log.debug("FLOATING ELEMENT EXIST OVER OTHER FLOATING ELEMNT","isFloatingElmOverFlotingElmRMD");
                break;
            }
        }
	}
    
    return bExist;
};

template.prototype.isTableMenuElmOverlapAllowed=function(frame, elmnt){
    var bAllowed = true;
    var nOfCols = frame.table.col.length;
    var len=frame.table.col[0].length;
    var divID;
    var txtElem;
    for(var colIndex =0;colIndex < nOfCols;colIndex++){
        for(var i=0;i<len;i++)
        {
            divID=frame.id+"_Col-"+colIndex+"_"+i;
            txtElem =frame.table.col[colIndex][i];
            if(isRectIntersectExceptBoundary(elmnt, txtElem))
            {
                bAllowed = false;
                break;
            }
        }
        if(!bAllowed){
            break;
        }
    }
    return bAllowed;
};

template.prototype.getHandWritingElementPosRMD=function(eleW, eleH){
    var rect = this.getBestEmptyRectRMD();
    if(rect.w>eleW){
        rect.x = rect.x + (rect.w - eleW)/2;
        rect.w = eleW;
    }
    if(rect.h>eleH){
        rect.y = rect.y + (rect.h - eleH)/2;
        rect.h = eleH;
    }
    return rect;
};