/**
* @filename TemplateRenderer.js
*
* Created by p.menaria 19-01-2015
* 
* Modified by k.chainani 6th feb
* 
* Copyright 2014 by Samsung Electronics, Inc.,
* 
* This software is the confidential and proprietary information
* of Samsung Electronics, Inc. ("Confidential Information"). You
* shall not disclose such Confidential Information and shall use
* it only in accordance with the terms of the license agreement
* you entered into with Samsung.
*/
var templateFontFamily=[];
var groupElmRenderMap = {};
var templateRenderer = {
    lfdPath: null,
    contentsFolderpath: null,
    sdcardFullPath: null,
    setIsEdit:false,

    initialize: function (flag) {
    	showAnimationLoader("");
        readLFDFile(templateRenderer.lfdPath);
        this.setIsEdit=flag;
    }
};

function readLFDFile(LFDfilePath) {

    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,
	 function (fileSystem) {
	     templateRenderer.sdcardFullPath = Utils.getSystemRootPath();  
	     templateRenderer.contentsFolderpath = templateRenderer.sdcardFullPath + LFDfilePath.slice(0, LFDfilePath.lastIndexOf("/"));
	     templateRenderer.lfdPath = LFDfilePath;
	     fileSystem.root.getFile(templateRenderer.lfdPath, null, gotLfdFileEntry, failLfdFileEntry);
	 },
	 failrequestFileSystem);
}
function gotLfdFileEntry(fileEntry) {
    console.log("gotLfdFileEntry ");
    fileEntry.file(gotLfdFile, failLfdfile);
}

function gotLfdFile(file) {
    readFileAsText(file);
}

function readFileAsText(file) {
    var reader = new FileReader();
    reader.onloadend = function (evt) {
        Content.init(evt.target.result);
        if (ContentObj.DisplayWidth > ContentObj.DisplayHeight) {
            templateObj.initTemplate(LANDSCAPE, ContentObj.Page[1].FrameLayout);
        } else {
            templateObj.initTemplate(PORTRAIT, ContentObj.Page[1].FrameLayout);
        }
        addContentToTemplate();
    };
    reader.readAsText(file);
}

function failrequestFileSystem(evt) {
    console.log("failrequestFileSystem");
    returnToHome();
}
function failLfdFileEntry(evt) {
    console.log("failLfdFileEntry");
    returnToHome();
}
function failLfdfile(evt) {
    console.log("failLfdfile");
    returnToHome();
}

function addContentToTemplate() {
	printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","ContentObj To TemplateObj Conversion ");
	templateObj.frameLayout = ContentObj.Page[1].FrameLayout;
	templateObj.bgImage = ContentObj.Page[1].BGImageOriginalPath;
	if(templateObj.bgImage==undefined || templateObj.bgImage == ""){
		templateObj.bgImage = ContentObj.Page[0].BGImageOriginalPath; /*If BG image not found in page[1] tag search in page[0]*/
    }
    templateObj.bgColor = templateRenderer.changeToRgb(ContentObj.Page[1].BGColor);
    if(ContentObj.Page[1].IsMutable == "true"){
    	templateObj.canModifiedBg = true;	
    }else{
    	templateObj.canModifiedBg = false;
    }    
	/*if(ContentObj.BGMusicFilePath!=undefined && ContentObj.BGMusicFilePath!=""){
		templateObj.audioFileName = ContentObj.BGMusicFilePath;
		templateObj.audioPath = ContentObj.BGMusicFileFullPath;
	}*/
	if(ContentObj.SelectedAudioVideo == "AUDIO"){
		templateObj.selAudioFrm = templateObj.mainFrame.id;
	}
	if(ContentObj.AudioMute == "true"){
		templateObj.audioFlag = false;
	}else{
		templateObj.audioFlag = true;
	}
	var newFrameContentObjMapping ={};
	
	var groupInd=0;
	var innerFrameId;
	var mainframeElmArray = templateObj.mainFrame.element;
	var innerFrameZorderArr = templateObj.innerFrameZOrderArr;
    for (var i = 0; i < ContentObj.Page[1].Group.length; i++) {
    	 var contentGrpObj = ContentObj.Page[1].Group[i];
    	 if(contentGrpObj.GroupMap.length>0)
    	 {
    	 	groupElmRenderMap['grp_'+groupInd] ={"groupInfo":{"rotation":parseFloat(contentGrpObj.Rotation),"x":parseFloat(contentGrpObj.PositionX),"y":parseFloat(contentGrpObj.PositionY),"w":parseFloat(contentGrpObj.Width),"h":parseFloat(contentGrpObj.Height)},"elmArray":[],"elementsTyp":""};
    	 	var groupElmRenderArray =groupElmRenderMap['grp_'+groupInd].elmArray;
    	 	for(var itr=0;itr<contentGrpObj.GroupMap.length;itr++)
    	 	{
    	 		innerFrameId = ContentToTemplteObjHelper(contentGrpObj.GroupMap[itr],newFrameContentObjMapping);
    	 		if(innerFrameId.indexOf("tplFrameId_")!=-1)
    	 		{
    	 			if(!groupElmRenderArray.includes(innerFrameZorderArr.length-1) && innerFrameZorderArr.length>0)
	    	 		{
	    	 			groupElmRenderArray.push(innerFrameZorderArr.length-1);
	    	 		}
	    	 		if(groupElmRenderMap['grp_'+groupInd].elementsTyp=="")
	    	 		{
	    	 			groupElmRenderMap['grp_'+groupInd].elementsTyp = "InnerFrame";
	    	 		}	
    	 		}
    	 		else if(innerFrameId == "")
    	 		{
    	 			if(!groupElmRenderArray.includes(mainframeElmArray.length-1) && mainframeElmArray.length>0)
	    	 		{
	    	 			groupElmRenderArray.push(mainframeElmArray.length-1);
	    	 		}
	    	 		if(groupElmRenderMap['grp_'+groupInd].elementsTyp=="")
	    	 		{
	    	 			groupElmRenderMap['grp_'+groupInd].elementsTyp = "MainFrame";
	    	 		}	
    	 		}
    	 		
    	 	}
    	 	groupInd++;	
    	 }
    	 else
    		ContentToTemplteObjHelper(contentGrpObj,newFrameContentObjMapping);
    } 
    
    printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","ContentObj To TemplateObj Conversion ");

    proceedRenderingTemplate();
}
function updateElementCordinatesAsPerGrpInfo(element,parentGroup)
{
	var rect = getUnRotatedCorAsPerGrpForTemplateRendering(parentGroup, -parentGroup.rotation, element);
	element.x = rect.x;
	element.y = rect.y;
	element.w = rect.w;
	element.h = rect.h;
	element.rotation -= parentGroup.rotation;
	
}
function createGroupingOfElm()
{
	for (var groupId in groupElmRenderMap) {
	templateObj.multiSelElmArr = [];
	var grpRotationAng = groupElmRenderMap[groupId].groupInfo.rotation;
	  if (groupElmRenderMap.hasOwnProperty(groupId)) {
	  	var elmIdArr = groupElmRenderMap[groupId].elmArray;
	  	for(var i = 0 ;i<elmIdArr.length;i++)
	    {
	    	if(groupElmRenderMap[groupId].elementsTyp == "InnerFrame")
	    	{
	    		templateObj.pushObjInMultiSelArray("tplFrameId_"+elmIdArr[i]);	
	    	}
	    	else if(groupElmRenderMap[groupId].elementsTyp == "MainFrame")
	    	{
	    		templateObj.pushObjInMultiSelArray(templateObj.mainFrame.id+"-elm_"+elmIdArr[i]+"_0");
	    	}
	    	
	    }
	    
	  }
	  setGroupInfoRotForTemplateRendering(groupId,groupElmRenderMap[groupId].groupInfo);
	}
}
function setGroupInfoRotForTemplateRendering(groupId,grouplfdobj)
{
	 group.createGroup(true,grouplfdobj);
}
function getUnRotatedCorAsPerGrpForTemplateRendering(parentGroup, angle, element)
{
	var mainFrmOffset=$("#"+FRAME_ID_PREFIX+"Main").offset();
	var groupCenter = 
	{
		x:parentGroup.x + parentGroup.w/2 + mainFrmOffset.left,
		y:parentGroup.y + parentGroup.h/2 + mainFrmOffset.top
	};
	var elementCenterPoint = 
	{
		x:element.x + element.w/2 + mainFrmOffset.left,
		y:element.y + element.h/2 + mainFrmOffset.top
	};
	var newElementCenter = groupHandler.rotationUtil.doTransformation(groupCenter, elementCenterPoint,angle, true);
	var rect =
	{
		x:newElementCenter.x - element.w/2 - mainFrmOffset.left,
		y:newElementCenter.y - element.h/2 - mainFrmOffset.top,
		w:element.w,
		h:element.h
	};
	log.debug("rect x = " + rect.x + " y = " + rect.y + " w = " + rect.w + " h = " + rect.h ,"getRectForGrpElmRotation");
	return rect;
};
function ContentToTemplteObjHelper(contentGrpObj,newFrameContentObjMapping)
{
		var frameX;
	    var frameY;
	    var frameW;
	    var frameH;
	    var relRectGroup;
	    var frameExisted = false;
	    var newInnerFrame = null;
	    if(contentGrpObj.Sound.length > 0){
			templateObj.audioFileName = contentGrpObj.Sound[0].FilePath;
    		templateObj.audioPath = contentGrpObj.Sound[0].OriginalPath;
        	return;
        }
        frameExisted = false;
        elemType = "NONE";

        relRectGroup = templateObj.relRectForFrmOrgRect(templateObj.mainFrame,
							new rect(contentGrpObj.PositionX, contentGrpObj.PositionY,
							contentGrpObj.Width, contentGrpObj.Height));
        frameX = relRectGroup.x;
        frameY = relRectGroup.y;
        frameW = relRectGroup.w;
        frameH = relRectGroup.h;
		var relRectObj;
        if (contentGrpObj.Image.length > 0) {
			relRectObj = contentGrpObj.Image[0];
        }
        else if (contentGrpObj.Video.length > 0) {
			relRectObj  = contentGrpObj.Video[0];
        }
        else if (contentGrpObj.InputSource.length > 0) {
			relRectObj  = contentGrpObj.InputSource[0];
        }
        else if (contentGrpObj.Office.length > 0) {
			relRectObj  = contentGrpObj.Office[0];
        }
        else if (contentGrpObj.Pdf.length > 0) {
			relRectObj  = contentGrpObj.Pdf[0];
        }
        
		var frameDimenObj = {frameX:frameX,frameY:frameY,frameW:frameW,frameH:frameH};
		if(relRectObj!= undefined && relRectObj !=null)
		{
			relRectObj = templateObj.relRectForFrmOrgRect(templateObj.mainFrame,
						new rect(relRectObj.PositionX, relRectObj.PositionY,
						relRectObj.Width, relRectObj.Height));	
		}
						
        var frameDimenObj = {frameX:frameX,frameY:frameY,frameW:frameW,frameH:frameH};
		if(relRectObj!= undefined && relRectObj !=null)
		{
			relRectObj = templateObj.relRectForFrmOrgRect(templateObj.mainFrame,
						new rect(relRectObj.PositionX, relRectObj.PositionY,
						relRectObj.Width, relRectObj.Height));	
		}
        for (var frameId in templateObj.innerFrames) {
            var existingInnerFrame = templateObj.getInnerFrameForId(frameId);

            if (frameX == existingInnerFrame.x && frameY == existingInnerFrame.y) {
                frameExisted = true;
			    addFramesToTemplate(existingInnerFrame,contentGrpObj,frameDimenObj,relRectObj,frameExisted);

                break;
            }
        }
        if (frameExisted == false) {				
            newInnerFrame = new frameInfo(frameX, frameY, frameW, frameH, false);
	    addFramesToTemplate(newInnerFrame,contentGrpObj,frameDimenObj,relRectObj,frameExisted);
        }
        return (newInnerFrame == null || newInnerFrame == undefined) ?"": newInnerFrame.id;
 } 
function proceedRenderingTemplate()
{
	printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","START","Created template Rendering on canvas");
	templateObj.renderTemplate();
    if(templateRenderer.setIsEdit)
    {
        templateObj.isEdited=true;
    }
    else
    {
       templateObj.isEdited=false; 
    }
    
    createGroupingOfElm();
    //loaderObj.hideLoader();
    printGetTimeWithMiliSecTemp("CUSTOM DESIGN","CUSTOM DESIGN","END","Created template Rendering on canvas");
}
function getNewElmFrmFrame(width,height,filePath,elmType,rectFrameObj,isFrame)
{
	var newElement = new elementInfo(width,height, filePath, elmType);
	newElement.x = isFrame?rectFrameObj.frameX:rectFrameObj.x;
	newElement.y = isFrame?rectFrameObj.frameY:rectFrameObj.y;
	newElement.w = isFrame?rectFrameObj.frameW:rectFrameObj.w;
	newElement.h = isFrame?rectFrameObj.frameH:rectFrameObj.h;
	return newElement;
}
function setHorVerAlignFrmContentToTemp(alignId,isHor)
{
	var retStr="";
	if(isHor)
	{	
		retStr = "left";
		if(alignId == 1){
			retStr = "center";
		}else if(alignId == 2){
			retStr = "right";
		}
	}
	else
	{
		retStr = "top";
		if(alignId == 1){
			retStr = "middle";
		}else if(alignId == 2){
			retStr = "bottom";
		}
	}
	return retStr;
}
function setIsEditableAddInnerFrame(innerFrame,frameExistedFlag,contentObj)
{
	if (innerFrame!=null && frameExistedFlag==false) {
        	if(contentObj.IsEditable == "true"){
	        	innerFrame.isEditable = true;
	        }else{
	        	innerFrame.isEditable = false;
	        }
            templateObj.addInnerFrame(innerFrame);
        }
}
function addFramesToTemplate(innerFrame,contentGrpObj,frameDimenObj,relRectObj,frameExistedFlag){	
	log.debug("FunctionIn: addFramesToTemplate");
    var newElement;
    var newTextElement;
    var elemType = "NONE";
    var filePath = "";
    if (contentGrpObj.Image.length > 0) {
    	var contImgObj = contentGrpObj.Image[0];
    	if(contImgObj.IsMutable == "true"){
			if(contImgObj.FilePath != ""){
				innerFrame.duration = templateRenderer.getDurationInSecs(contImgObj.Duration);
				
				if (contImgObj.isGroupMember == true) {
					elemType = GROUP;
				} else {
					elemType = IMAGE;
				}
				filePath = contImgObj.FilePath;
				filePath = filePath.substring(filePath.lastIndexOf("/") + 1);
				filePath = filePath.substring(filePath.lastIndexOf("\\") + 1);
				filePath = templateRenderer.contentsFolderpath + "/" + filePath;
				
				filePath = Utils.encodeThumbPath(filePath);
				
				newElement = getNewElmFrmFrame(contImgObj.OrginalWidth, contImgObj.OriginalHeight, filePath, elemType,relRectObj,false);
				newElement.OriginalPath = contImgObj.OriginalPath;
				newElement.thumbPath = contImgObj.ThumbPath;
				newElement.scale = contImgObj.scale;
				newElement.opacity = contImgObj.Opacity;
				var cropCord = {
					l:contImgObj.ClipLeft,
					t:contImgObj.ClipTop,
					r:contImgObj.OrginalWidth - contImgObj.ClipRight,
					b:contImgObj.OriginalHeight - contImgObj.ClipBottom
				};
				
				if(FREE_ROTATION_ALLOWED && frameExistedFlag && templateObj.frameLayout == BLANK_LAYOUT && Utils.isHighEndModel(globlePlayerType))
				{
					if(innerFrame.element.length == 1)
					{
						innerFrame.element[0].rotation =innerFrame.rotation; 
						innerFrame.rotation= 0;
						innerFrame.bSlideshow = true;	
					}
					newElement.rotation = contImgObj.Rotation;
				}
				else if(FREE_ROTATION_ALLOWED && !frameExistedFlag && templateObj.frameLayout == BLANK_LAYOUT && Utils.isHighEndModel(globlePlayerType))
				{
					innerFrame.rotation = contImgObj.Rotation;
				}
				else
				{
					newElement.rotation = contImgObj.Rotation;
				}
				templateObj.setElmOffsetFrmCropCoord(newElement,innerFrame, cropCord);
				
				if(contImgObj.EffectInName!=undefined || contImgObj.EffectInName!=""){
					innerFrame.transitionEffect = templateRenderer.getEffectForTemplate(contImgObj);	
				}else{
					innerFrame.transitionEffect = "None";
				}     
				innerFrame.setElement(newElement);
		    }else{
		    	elemType = EMPTY;
		    }
	        if (innerFrame!=null && frameExistedFlag==false) {
	        	if(contImgObj.IsEditable == "true"){
		        		innerFrame.isEditable = true;
		        	}else{
		        		innerFrame.isEditable = false;
		        	}
	            templateObj.addInnerFrame(innerFrame);
	        }
    	}else{			
    		filePath = contImgObj.OriginalPath;
			
    		if(contImgObj.OriginalPath.indexOf("/Spen/") != -1){
    			if(globlePlayerType==RMD_MODEL){/* Since only for RMD model HANDWRITING is added as DECO IMAGE*/
    				elemType = HANDWRITING;
    			}    			
    		}else{
    			elemType = DECO_IMAGE;
    			filePath = Utils.encodeThumbPath(filePath);
    		}	
			newElement = getNewElmFrmFrame(0, 0, filePath, elemType,frameDimenObj,true);
    		templateObj.mainFrame.setElement(newElement);
        }
    }

    else if (contentGrpObj.Video.length > 0) {
    	var contVidObj = contentGrpObj.Video[0];
        filePath = contVidObj.FilePath;
        filePath = filePath.substring(filePath.lastIndexOf("/") + 1);
        filePath = templateRenderer.contentsFolderpath + "/" + filePath;
		newElement = getNewElmFrmFrame(contVidObj.OrginalWidth, contVidObj.OriginalHeight, filePath, VIDEO,relRectObj,false);
        newElement.fileName = contVidObj.FileName;
        newElement.OriginalPath = contVidObj.OriginalPath;
        newElement.thumbPath = contVidObj.ThumbPath;
        newElement.duration = templateRenderer.getDurationInSecs(contVidObj.Duration);
        innerFrame.setElement(newElement);
        setIsEditableAddInnerFrame(innerFrame,frameExistedFlag,contVidObj);
        if (innerFrame!=null && frameExistedFlag==false) {
        	if(Utils.isHighEndModel(globlePlayerType) && contVidObj.MovieMute =="False")
            {
            	templateObj.selAudioFrm = innerFrame.id;
            }
            else
            {
            	if(ContentObj.SelectedAudioVideo == "VIDEO" && templateObj.selAudioFrm==""){	    		
		        	templateObj.selAudioFrm = innerFrame.id;
		        }
            }
	    	
        }
    }
   else if (contentGrpObj.InputSource.length > 0) {
    	var contInpSrcObj = contentGrpObj.InputSource[0];
        newElement = getNewElmFrmFrame(0, 0,"", INPUT_SOURCE,relRectObj,false);
        newElement.OriginalPath = contInpSrcObj.InputSourceType;        
        newElement.fileName=getIpSrcName(newElement.OriginalPath);
        newElement.imageSrc=getIpSrcIconPath(newElement.OriginalPath);
        newElement.thumbPath=getIpSrcIconPath(newElement.OriginalPath);
        if (globlePlayerType== RMD_MODEL){
       		templateObj.inputSrcRegion = contInpSrcObj.Region;
       		currRegion = templateObj.inputSrcRegion;
        }
        innerFrame.setElement(newElement);
        setIsEditableAddInnerFrame(innerFrame,frameExistedFlag,contInpSrcObj);
        if (innerFrame!=null && frameExistedFlag==false) {
        	if(Utils.isHighEndModel(globlePlayerType) && contInpSrcObj.Sound =="1")
            {
            	templateObj.selAudioFrm = innerFrame.id;
            }
            else
            {
            	if(ContentObj.SelectedAudioVideo == "INPUTSOURCE" && templateObj.selAudioFrm==""){	    		
		        	templateObj.selAudioFrm = innerFrame.id;
		        }
            }
        }
    }
    else if (contentGrpObj.Office.length > 0) {
        var contOfficeObj = contentGrpObj.Office[0];
        addDocumentToContObj(innerFrame,frameExistedFlag, contOfficeObj, relRectObj, PPT);
    }
    else if (contentGrpObj.Pdf.length > 0) {
        var contPdfObj = contentGrpObj.Pdf[0];
        addDocumentToContObj(innerFrame,frameExistedFlag, contPdfObj, relRectObj, PDF);
    }
    else if (contentGrpObj.Web.length > 0) {
        newElement = getNewElmFrmFrame(0, 0, "", widgetInfo.WEB,frameDimenObj,true);
        newElement.OriginalPath = contentGrpObj.Web[0].WebURL;
        var webRef =  contentGrpObj.Web[0].WebRefreshNew;
        newElement.webRefreshInterval = webRef.substring(0, webRef.lastIndexOf('.'));
        innerFrame.setElement(newElement);
        setIsEditableAddInnerFrame(innerFrame,frameExistedFlag,contentGrpObj.Web[0]);
    }
	else if (contentGrpObj.MediaRss.length > 0) {
	        newElement = getNewElmFrmFrame(0, 0, "", widgetInfo.MEDIARSS,frameDimenObj,true);
	        newElement.mediaRssInfo = new mediaRssInfo();
	        newElement.mediaRssInfo.url = contentGrpObj.MediaRss[0].MrssURL;
	        newElement.mediaRssInfo.reloadDuration = contentGrpObj.MediaRss[0].MrssDuration;
	        newElement.mediaRssInfo.aspectFill = contentGrpObj.MediaRss[0].AspectFill;
	        innerFrame.setElement(newElement);
	        setIsEditableAddInnerFrame(innerFrame,frameExistedFlag,contentGrpObj.MediaRss[0]);
	        
	}

    var stkrLength = contentGrpObj.Sticker.length;
    var contStkrObj;
    for (var j = 0; j < stkrLength; j++) {    	
    	contStkrObj = contentGrpObj.Sticker[j];
    	if(contStkrObj.OriginalPath.indexOf("/Spen/") == -1){
			elemType = STICKER;
			filePath = templateRenderer.contentsFolderpath + "/" + contStkrObj.EndStateBitmap;
    	}else{
    		if(globlePlayerType != RMD_MODEL){/*Since for RHE and TIZEN model and above models HANDWRITING is added as STICKER*/
    			elemType = HANDWRITING;
    			filePath = contStkrObj.OriginalPath;	
    		}    		
    	}
		newElement = getNewElmFrmFrame(contStkrObj.OrginalWidth, contStkrObj.OriginalHeight, filePath, elemType,frameDimenObj,true);	
    	newElement.rotation = contStkrObj.Rotation;
    	/* remove the below code for editable sticker implementation*/
        /*var StickerXmlstring = contStkrObj.EndStateXML;
        if(StickerXmlstring!="" && StickerXmlstring!=undefined)
        {
        		newElement.timeZoneOffset = ((StickerXmlstring).replace(/&lt;/g,"<")).replace(/&gt;/g,">");
        		newElement.timeZoneOffset = $.parseXML(newElement.timeZoneOffset);
        		var stickername = (($(newElement.timeZoneOffset).find('image'))[0]).innerHTML;
        	    var imgPath="../resource/img/sticker/"+stickername;
                var stkrImage=new Image();
                stkrImage.src = imgPath;
                newElement.imageSrc = imgPath;
            	populateEditableSticTextArr(newElement,xmlToJson(newElement.timeZoneOffset)["sticker"]);
				newElement.timeZoneOffset = new XMLSerializer().serializeToString(newElement.timeZoneOffset);
		}*/
        
        templateObj.mainFrame.setElement(newElement);
    }
    var txtLength = contentGrpObj.Text.length;
    var contTxtObj;
    for (var j = 0; j < txtLength; j++) {
        contTxtObj = contentGrpObj.Text[j];
        var relRectText = templateObj.relRectForFrmOrgRect(templateObj.mainFrame,
						new rect(contTxtObj.PositionX, contTxtObj.PositionY,
						contTxtObj.Width, contTxtObj.Height));
        var currElementSize = innerFrame.element.length;
        newTextElement = new textInfo(relRectText.x, relRectText.y, relRectText.w, relRectText.h);
        addTextPropertiesToTemplate(newTextElement, contTxtObj,false);
		newTextElement.rotation = contTxtObj.Rotation;
        if (contTxtObj.isGroupMember == true) {
        		
        	if(contentGrpObj.Name.indexOf("GMenu") >-1){
        		elemType = "TABLE";
        		if(innerFrame.table == null){
        			var newTable = new tableInfo();
        			addTextToTable(newTable,contTxtObj,newTextElement);
	        		innerFrame.table = newTable;
        		} else{
        			addTextToTable(innerFrame.table,contTxtObj,newTextElement);        			    			
        		}
        	} else{
        		
	            if (elemType == GROUP) {
	                /*If element type is already set to GROUP, it means current element is already created, so no need to create new element,just add text to current element*/
	                innerFrame.element[currElementSize - 1].textElms.push(newTextElement);
	            } else {
	                /*If element type is not set to GROUP, it means there is no current element created, so it is required to create new element and add text to new element*/
	                elemType = GROUP;
					newElement = getNewElmFrmFrame(0, 0, "", elemType,frameDimenObj,true);
	                newElement.textElms.push(newTextElement);
	                innerFrame.setElement(newElement);
	            }
            }
	    if (innerFrame!=null && frameExistedFlag==false && innerFrame.id=="") {
	        templateObj.addInnerFrame(innerFrame);	           
	    }
        } else {
            elemType = TEXT;
			newElement = getNewElmFrmFrame(0, 0, "", elemType,frameDimenObj,true);
            newElement.textElms.push(newTextElement);
            newElement.textElms[0].rotation = contTxtObj.Rotation;
            templateObj.mainFrame.setElement(newElement);
        }
    }
    var digClkLength = contentGrpObj.DigitalClock.length;
    var contDigClkObj;
    for (var j = 0; j < digClkLength; j++) {     
    	contDigClkObj = contentGrpObj.DigitalClock[j];
        var relRectText = templateObj.relRectForFrmOrgRect(templateObj.mainFrame,
						new rect(contDigClkObj.PositionX, contDigClkObj.PositionY,
						contDigClkObj.Width, contDigClkObj.Height));
        var currElementSize = innerFrame.element.length;
        var newDigClkTextElement = new textInfo(relRectText.x, relRectText.y, relRectText.w, relRectText.h);
        addDigClkPropsToTemplt(newDigClkTextElement, contDigClkObj);        
        newElement = getNewElmFrmFrame(0, 0, "", widgetInfo.DIGITAL_CLOCK,frameDimenObj,true);
        newElement.textElms.push(newDigClkTextElement);
        templateObj.mainFrame.setElement(newElement);        
    }
    var analogClkLength = contentGrpObj.AnalogClock.length;
    var contanalogClkObj; 
    for (var j = 0; j < analogClkLength; j++) {   
    	contanalogClkObj = contentGrpObj.AnalogClock[j];
        newElement = getNewElmFrmFrame(0, 0, "", getParseIntInDec(contanalogClkObj.ClockDisplayType),frameDimenObj,true);
		templateObj.mainFrame.setElement(newElement);    
    }
    var rssLength = contentGrpObj.RSS.length;
    var contRssObj; 
    for (var j = 0; j < rssLength; j++) {     
    	contRssObj = contentGrpObj.RSS[j];   
        var relRectText = templateObj.relRectForFrmOrgRect(templateObj.mainFrame,
						new rect(contRssObj.PositionX, contRssObj.PositionY,
						contRssObj.Width, contRssObj.Height));
        var newRSSTextElement = new textInfo(relRectText.x, relRectText.y, relRectText.w, relRectText.h);
        addTextPropertiesToTemplate(newRSSTextElement, contRssObj,true);
        newElement = getNewElmFrmFrame(0, 0, "", widgetInfo.RSS,frameDimenObj,true);
        newElement.textElms.push(newRSSTextElement);
        templateObj.mainFrame.setElement(newElement);        
    }

    var weatherHourlyLen = contentGrpObj.WeatherHourly.length;
    for (var j = 0; j < weatherHourlyLen; j++) { 
        addWeatherPropertiesToTemplate(contentGrpObj.WeatherHourly,  widgetInfo.WEATHER_HOUR,frameDimenObj);         
    }
    var weather1DayLen = contentGrpObj.Weather1Day.length;
    for (var j = 0; j < weather1DayLen; j++) { 
        addWeatherPropertiesToTemplate(contentGrpObj.Weather1Day,  widgetInfo.WEATHER_TODAY,frameDimenObj); 
    }
    var weather7DayLen = contentGrpObj.Weather7Day.length;
    for (var j = 0; j < weather7DayLen; j++) { 
        addWeatherPropertiesToTemplate(contentGrpObj.Weather7Day,widgetInfo.WEATHER_WEEK,frameDimenObj);   
    }

    var shapeLength = contentGrpObj.Shapes.length;
    var contShapeObj;
    for (var j = 0; j < shapeLength; j++) {    	
    	contShapeObj = contentGrpObj.Shapes[j];
    	addShapesPropertiesToTemplate(contShapeObj, getShapeTypeOfSameCategory(contShapeObj.typeName,contShapeObj.elementName),frameDimenObj);   
    }
     log.debug("FunctionOut: addFramesToTemplate");
    return innerFrame;
}
function addDocumentToContObj(innerFrame,frameExistedFlag, contDocObj, relRectObj, elmType){
    var	newElement = getNewElmFrmFrame(0, 0, contDocObj.OriginalPath, elmType,relRectObj,false);
    newElement.OriginalPath = contDocObj.OriginalPath;
    newElement.fileName = contDocObj.FilePath;
    innerFrame.setElement(newElement);
    setIsEditableAddInnerFrame(innerFrame,frameExistedFlag,contDocObj);
}

var rect = function (x, y, w, h) {
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
};
function addShapesPropertiesToTemplate(contShapeObj, elemType,frameDimenObj){
    log.debug("FunctionIn: addShapesPropertiesToTemplate");
    var newShapeElement = new shapeInfoTempObj();    
    if(elemType == shapeInfo.ONESDEARROW || elemType == shapeInfo.TWOSDEARROW)
    {
    	fillSpecificParaToShapeTemObj(elemType,contShapeObj,newShapeElement);
    }
    else
    {
    	fillSpecificParaToShapeContObj(elemType,newShapeElement,contShapeObj);	
    }
	                           
    newShapeElement.LineColor="rgb(" + contShapeObj.LineColor.replace(/;/g,",")+")";
    newShapeElement.FigureStrokeOpacity=getParseIntInDec(contShapeObj.FigureStrokeOpacity);
    newShapeElement.FigureStrokeWidth=getParseIntInDec(contShapeObj.FigureStrokeWidth);
    newShapeElement.FigureStrokePattern=getParseIntInDec(contShapeObj.FigureStrokePattern);
    newShapeElement.FillColor="rgb(" +contShapeObj.FillColor.replace(/;/g,",")+")";
    newShapeElement.typeName = contShapeObj.typeName;
    newShapeElement.FillRange = contShapeObj.FillRange;
    newShapeElement.FillOpacity=contShapeObj.FillOpacity != ""?getParseIntInDec(contShapeObj.FillOpacity):newShapeElement.FillOpacity;
    newShapeElement.elementName=contShapeObj.elementName != ""?getParseIntInDec(contShapeObj.elementName):newShapeElement.elementName;
    newShapeElement.FillRange=contShapeObj.FillRange != ""?getParseIntInDec(contShapeObj.FillRange):newShapeElement.FillRange;
    var newElement = getNewElmFrmFrame(contShapeObj.OrginalWidth, contShapeObj.OriginalHeight, "", elemType,frameDimenObj,true);
    newElement.opacity = contShapeObj.Opacity;
    newElement.OriginalPath = contShapeObj.OriginalImage;
    newElement.thumbPath = templateRenderer.contentsFolderpath + "/" + contShapeObj.thumbPath;
    if (contShapeObj.thumbPath == null || contShapeObj.thumbPath == "") {
        newElement.thumbPath = "";
    }
    newElement.rotation = contShapeObj.Rotation;
    newElement.shapeDetails = newShapeElement;
    newShapeElement.thumbOrgW = contShapeObj.thumbOrgW;
    newShapeElement.thumbOrgH = contShapeObj.thumbOrgH;
    if(newElement.OriginalPath!="")
    {
    	newElement.scale = contShapeObj.scale;
		var cropCord = {
			l:contShapeObj.ClipLeft,
			t:contShapeObj.ClipTop,
			r:contShapeObj.OrginalWidth - contShapeObj.ClipRight,
			b:contShapeObj.OriginalHeight - contShapeObj.ClipBottom
		};
		templateObj.setShapeImgOffsetFromCropCoord(newElement,cropCord);
	}
    
    templateObj.mainFrame.setElement(newElement);
    log.debug("FunctionOut: addShapesPropertiesToTemplate"); 
}

function addWeatherPropertiesToTemplate(weatherContentObj, elemType,frameDimenObj){
    
    var newWeatherElement = new weatherInfo();    
    newWeatherElement.city = weatherContentObj[0].City;
    newWeatherElement.country = weatherContentObj[0].Country;
    newWeatherElement.cityId = weatherContentObj[0].LocationKey;
    newWeatherElement.dateTimeformat = getParseIntInDec(weatherContentObj[0].Date);    
    newWeatherElement.bgType = weatherContentObj[0].Background;
    newWeatherElement.refrshIntrvl = weatherContentObj[0].Refresh;
    newWeatherElement.unit = getParseIntInDec(weatherContentObj[0].Unit);
    var newElement = getNewElmFrmFrame(0, 0, "", elemType,frameDimenObj,true);
    newElement.opacity = weatherContentObj[0].Opacity;
    newElement.weather = newWeatherElement;
    templateObj.mainFrame.setElement(newElement); 
} 
function addTextPropertiesToTemplate(textTemplateObj, textContentObj,isRssElement) {
    var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
    textTemplateObj.Name = textContentObj.Name;
    textTemplateObj.text = textContentObj.TextValue;
    textTemplateObj.textImageName = textContentObj.TextImage;

	if(textContentObj.FillColor!= 'undefined' && textContentObj.FillColor!=""){
		textTemplateObj.bgColor = templateRenderer.changeToRgb(textContentObj.FillColor);
	}
	textTemplateObj.fontFamily = textContentObj.Textface;
	templateFontFamily.push(textTemplateObj.fontFamily);

	addTextAndDigClkCommonProps(textTemplateObj, textContentObj);


	if(textContentObj.TextDirection == '0'){/*Flip*/
		textTemplateObj.bTextSlide = false;
		if(!isRssElement){
			textTemplateObj.slideSpeed = textContentObj.TextSpeed;
		}			
	}else{/*Slide*/
		textTemplateObj.bTextSlide = true;
		textTemplateObj.slideType = textContentObj.TextDirection;	
		textTemplateObj.slideSpeed = (textContentObj.TextSpeed!=0?textContentObj.TextSpeed:20);
	}
    if(isRssElement)
    {
    	var rssElementInfo = {};
    	rssElementInfo["url"] = textContentObj.RSS_URL;
    	rssElementInfo.reloadDuration = textContentObj.RssReloadDuration;
    	rssElementInfo.title ={
    		color:templateRenderer.changeToRgb(textContentObj.titleTextColor),
    		fontSize:textContentObj.titleTextFontSize
   		 };
	    rssElementInfo["title"].hAlign = setHorVerAlignFrmContentToTemp(textContentObj.titleTextHAlign,true);
	    rssElementInfo.date ={
			color:templateRenderer.changeToRgb(textContentObj.pubDateTextColor),    		
			fontSize:textContentObj.pubDateTextFontSize
		};
		rssElementInfo["date"].hAlign = setHorVerAlignFrmContentToTemp(textContentObj.pubDateTextHAlign,true);
		rssElementInfo.description ={
			color:templateRenderer.changeToRgb(textContentObj.descriptionTextColor),    		
			fontSize:textContentObj.descriptionTextFontSize
		};
		rssElementInfo["description"].hAlign = setHorVerAlignFrmContentToTemp(textContentObj.descriptionTextHAlign,true);
		
		rssElementInfo["title"].visible = true;rssElementInfo["date"].visible = true;rssElementInfo["description"].visible = true;
		
    	if(textContentObj.NewsDisplayOption == "2")
    	{
    		rssElementInfo["date"].visible = false;
    	}
    	else if(textContentObj.NewsDisplayOption == "1")
    	{
    		rssElementInfo["description"].visible = false;
    	}
    	else if(textContentObj.NewsDisplayOption == "0")
    	{
    		rssElementInfo["date"].visible = false;rssElementInfo["description"].visible = false;
    	}
    	rssElementInfo["flipSpeed"] = textContentObj.TextDirection == 0 ?textContentObj.DISPLAY_CYCLE:5; 
    	textTemplateObj.rssInfo = rssElementInfo;
    }
    /* for tizen change stroke and shadow properties*/
    if(Utils.isHighEndModel(globlePlayerType) && !isRssElement)
    {
    	setShadowOutlinePropForTempObj(textContentObj,textTemplateObj);	
    }
}
function addTextAndDigClkCommonProps(textTemplateObj, textContentObj){
    textTemplateObj.bgAlpha = textContentObj.FillOpacity;
    textTemplateObj.fontSize = textContentObj.TextFontSize;
    textTemplateObj.fontColor = templateRenderer.changeToRgb(textContentObj.TextColor);

	textTemplateObj.hAlign = setHorVerAlignFrmContentToTemp(textContentObj.TextHAlign,true);
	textTemplateObj.vAlign = setHorVerAlignFrmContentToTemp(textContentObj.TextVAlign,false);
	textTemplateObj.fontItalic = textContentObj.TextItalic == "true"?true:false;
    textTemplateObj.fontBold = textContentObj.TextBold == "true"?true:false;
    textTemplateObj.fontUnderLine = textContentObj.TextUnderLine == "true" ? true:false;
}
function addDigClkPropsToTemplt(digClkTemplateObj, digClkContentObj) {
    var heightRatio = templateObj.mainFrame.h / templateObj.lfdSize.h;
    digClkTemplateObj.format = getParseIntInDec(digClkContentObj.TimeFormat);
    digClkTemplateObj.DisplayLanguage = getDigClkIndex(getParseIntInDec(digClkContentObj.DisplayLanguage));
	if(digClkContentObj.FillColor!= 'undefined' && digClkContentObj.FillColor!=""){
		digClkTemplateObj.bgColor = templateRenderer.changeToRgb(digClkContentObj.FillColor);
	}
	digClkTemplateObj.fontFamily = digClkContentObj.TextFontName;
    templateFontFamily.push(digClkTemplateObj.fontFamily);

	addTextAndDigClkCommonProps(digClkTemplateObj, digClkContentObj);

    if(digClkContentObj.TextDirection == '0'){
		digClkTemplateObj.bTextSlide = false;
	}else{
		digClkTemplateObj.bTextSlide = true;
		digClkTemplateObj.slideType = digClkContentObj.TextDirection;
	}
	digClkTemplateObj.slideSpeed = digClkContentObj.TextSpeed;
}
function getDigClkIndex(langIndexFrmLfd){
    for(var i=0,len = digitalClockLanguage.length;i<len;i++){
        if(digitalClockLanguage[i].index == langIndexFrmLfd){
            return i;
        }
    }
    return langIndexFrmLfd;
}
function addTextToTable(tableElement,textObj,newTextElement){
    /*
    if(newTextElement.text == COM_TV_PRICE || newTextElement.text ==  IDS_DOCKINGPANE_MENU){
            newTextElement.bMenuOrPrice = true;
        }*/
    
	if(textObj.Name.indexOf("Menu") >-1){
		if(tableElement.col[0] == null){
			var menuArr = [];
			menuArr.push(newTextElement);
			tableElement.col.push(menuArr);
		}else{
			tableElement.col[0].push(newTextElement);
		} 		
	}else{
		var priceIndx = textObj.Name.split("_")[1];/*Since name is denoted by Price1_1_1,Price1_1_2*/
		if(tableElement.col[priceIndx] == null){
			var priceArr = [];
			priceArr.push(newTextElement);
			tableElement.col.push(priceArr);
		}else{
			tableElement.col[priceIndx].push(newTextElement);
		}		 	
	}
}
/*Will change "255;0;255" to "rgb(255,0,255)"*/
templateRenderer.changeToRgb = function(bgColor){
	if(bgColor == undefined || bgColor == ""){
		return bgColor;
	}
	bgColor = bgColor.replace(/;/g, ","); 
	bgColor = "rgb("+bgColor+")";
	return bgColor;
};
/*Will change "255;0;255;1" to "rgba(255,0,255,1)"*/
templateRenderer.changeToRgba = function(bgColor){
	if(bgColor == undefined || bgColor == ""){
		return bgColor;
	}
	bgColor = bgColor.replace(/;/g, ","); 
	bgColor = "rgba("+bgColor+")";

	return bgColor;
};

templateRenderer.getDurationInSecs =function(duration){
	if(duration == undefined || duration == ""){
		return duration;
	}
	var durationArray = duration.split(':');
	durationArray[0] = getParseIntInDec(durationArray[0]);
	durationArray[1] = getParseIntInDec(durationArray[1]);
	durationArray[2] = getParseIntInDec(durationArray[2]);
	return (durationArray[0] *3600 + durationArray[1] *60 + durationArray[2]);
};
templateRenderer.getEffectForTemplate=function(imgObj){	
	var effect = imgObj.EffectInName;
	var selEffect;	
	switch(effect)
	{
		case "":
			selEffect="None";
		break;
		case "Ext_Eff_Fade::CutBlackFade":
			selEffect="Cut_Black_Fade";
		break;
		case "Ext_Eff_FlyOn::ShortFadeEast":
			selEffect="ShortFade_East";
		break;
		case "Ext_Eff_FlyOn::ShortFadeWest":
			selEffect="ShortFade_West";
		break;
		case "Ext_Eff_FlyOn::ShortFadeNorth":
			selEffect="ShortFade_North";
		break;
		case "Ext_Eff_FlyOn::ShortFadeSouth":
			selEffect="ShortFade_South";
		break;
		case "Ext_Eff_Reveal::Wipe":
			if(imgObj.EffectInDirection == 0){
				selEffect="Wipe_North";
			}else if(imgObj.EffectInDirection == 1){
			selEffect="Wipe_East";
			}else if(imgObj.EffectInDirection == 2){
				selEffect="Wipe_South";
			}else{
			selEffect="Wipe_West";
			}
		break;
		case "Ext_Eff_Reveal2::Curtain":
			selEffect="Curtain";
		break;
		case "Ext_Eff_Reveal::Quadrant":
			selEffect="Quadrant";
		break;
		case "Ext_Eff_Zoom::ZoomUp":
			selEffect="Zoom_up";
		break;
		case "Ext_Eff_Reveal2::Swiss":
			selEffect="Swiss";
		break;
		case "Ext_Eff_3D2::Uncover":
			selEffect="Uncover";
		break;
		default:
			selEffect="None";
		break;
	}
	return selEffect;	
};
