
template.prototype.undo = function()
{
	var poppedFrmUndo = undoStackObj.pop(false);
	//log.debug("poppedFrmUndo "+ JSON.stringify(poppedFrmUndo));
	if(poppedFrmUndo == null)
	{
		return;
	}
	this.preUndoCheck();/*Checking for Shape and Image crop mode if enable*/
	var undoData = poppedFrmUndo.data;
	var undoOperationType = undoData.operation;
	var undoObj = undoData.obj;

	/*hide any selection from all the elements*/
	this.hideSelectionForAllElement();

	/*Setting multi select mode by default false*/
	this.multiSelectMode = false;

	/*Setting template is changed once undo is called*/
	this.isEdited=true;

	switch(undoOperationType)
	{
	case UndoRedo.ADD_INNERFRAME_ELEMENT:
		this.undoRedoDelInrFrameElm(undoObj);
		break;
	case UndoRedo.DEL_INNERFRAME_ELEMENT:
		this.undoRedoAddInrFrameElm(undoObj);
		break;
	case UndoRedo.DEL_FRAME:
		this.undoRedoDelFrame(undoObj, true);
		break;
	case UndoRedo.ADD_BLANKFRAME:
		this.undoRedoDelBlankFrame(undoObj);
		break;
	case UndoRedo.DEL_BLANKFRAME:
		this.undoRedoAddBlankFrame(undoObj);
		break;
	case UndoRedo.REPLACE_INNERFRAME_ELEMENT:
		this.undoRedoReplaceInrFrameElm(undoObj, true);
		break;
	case UndoRedo.ARRANGE_INNERFRAME_ELEMENT:
		this.undoRedoArrangeInrFrameElm(undoObj, true);
		break;
	case UndoRedo.RESIZE_FRAME:
		this.undoRedoResizeFrm(undoObj, true);
		break;
	case UndoRedo.SWP_FRM:
		this.undoRedoSwapFrm(undoObj, true);
		break;
	case UndoRedo.EDIT_FRAME:
		this.undoRedoEditFrame(undoObj, true);
		break;
	case UndoRedo.IMG_OPACITY:
		this.undoRedoImgOpcty(undoObj, true);
		break;
	case UndoRedo.DRAG_BLANKFRAME:
		this.undoRedoResizeBlnkFrm(undoObj, true, true);
		break;
	case UndoRedo.RESIZE_BLANKFRAME:
		this.undoRedoResizeBlnkFrm(undoObj, false, true);
		break;
	case UndoRedo.ARRANGE_BLANKFRAME:
		this.undoRedoArrngBlnkFrm(undoObj, true);
		break;
	case UndoRedo.ROTATE_INNERFRAME_ELEMENT:
		this.undoRedoRotateInrFrmElm(undoObj, true);
		break;
	case UndoRedo.ROTATE_MAINFRAME_ELEMENT:
		this.undoRedoRotateMnOrBlnkFrmElm(undoObj, true);
		break;
	case UndoRedo.CROP:
		this.undoRedoCropElm(undoObj, true);
		break;
	case UndoRedo.CROP_SHAPES:
		this.undoRedoCropShapes(undoObj, true);
		break;
	case UndoRedo.ADD:
		this.undoRedoDelMnFrameElm(undoObj.mainFrameIndex);
		break;
	case UndoRedo.DELETE:
		this.undoRedoAddMnFrameElm(undoObj);
		break;
	case UndoRedo.ARRANGE:
		this.undoRedoArrangeMnFrameElm(undoObj.mnFrmIndex, undoObj.prevMnFrmLyrArr);
		break;
	case UndoRedo.RESIZE:
	case UndoRedo.DRAG:
		this.undoRedoDragMnFrameElm(true, undoObj, undoOperationType);
		break;
	case UndoRedo.TEXT_EDIT:
		this.undoRedoTextEdit(true, undoObj);
		break;
	case UndoRedo.WEATHER_EDIT:
		this.undoRedoWeatherEdit(true, undoObj);
		break;
	case UndoRedo.ADD_AUDIO:
		this.undoRedoDelAudio(true, undoObj);
		break;
	case UndoRedo.DEL_AUDIO:
		this.undoRedoAddAudio(true, undoObj);
		break;
	case UndoRedo.REPLACE_AUDIO:
		this.undoRedoReplaceAudio(true, undoObj);
		break;
	case UndoRedo.MUTE_AUDIO:
        this.undoRedoMuteUnmuteAudio(true, undoObj);
        break;
	case UndoRedo.TEMPLATE_BG:
		this.undoRedoTemplateBg(true, undoObj);
		break;
	case UndoRedo.HW_UPDATE:
		this.undoRedoHndWritingUpdate(true, undoObj);
		break;
	case UndoRedo.SHAPES_EDIT:
		this.undoRedoShapesEdit(true, undoObj);
		break;
	case UndoRedo.SHAPES_BG:
		this.undoRedoShapesBG(true, undoObj);
		break;
	case UndoRedo.ZOOM_TEMPLATE:
		this.undoRedoZoomTemplate(true, undoObj);
		break;
	case UndoRedo.RSS_WEB_URL:
		this.undoRedoRssWeburl(true, undoObj);
		break;
	case UndoRedo.MEDIA_RSS_RELOAD_DUR:
        this.undoRedoMediaRssDur(true, undoObj);
        break;
	case UndoRedo.INPUT_SRC:
		this.undoRedoInpSrcType(true, undoObj);
		break;
	case UndoRedo.MULTI_SEL_ROT:
		this.undoRedoMultiSelRot(true, undoObj);
		break;
	case UndoRedo.MULTI_SEL_RESIZE:
		this.undoRedoMultiSelResize(true, undoObj);
		break;
	case UndoRedo.MULTI_SEL_DEL:
		this.undoRedoDelMultiSel(true, undoObj);
		break;
	default:
		//Left blank intentionally
		break;
	}

	/*Selecting item if it is single element*/
	this.selectElement(this.getValidId(undoObj));

	redoStackObj.push(undoData, true);

};

template.prototype.redo = function()
{
	var poppedFrmRedo = redoStackObj.pop(true);
	if(poppedFrmRedo == null)
	{
		return;
	}
	var redoData = poppedFrmRedo.data;
	var redoOperationType = redoData.operation;
	var redoObj = redoData.obj;

    /*hide any selection from all the elements*/
    this.hideSelectionForAllElement();

    /*Setting multi select mode by default false*/
    this.multiSelectMode = false;

	switch(redoOperationType)
	{
	case UndoRedo.ADD_INNERFRAME_ELEMENT:
		this.undoRedoAddInrFrameElm(redoObj);
		break;
	case UndoRedo.DEL_INNERFRAME_ELEMENT:
		this.undoRedoDelInrFrameElm(redoObj);
		break;
	case UndoRedo.DEL_FRAME:
		this.undoRedoDelFrame(redoObj, false);
		break;
	case UndoRedo.ADD_BLANKFRAME:
		this.undoRedoAddBlankFrame(redoObj);
		break;
	case UndoRedo.DEL_BLANKFRAME:
		this.undoRedoDelBlankFrame(redoObj);
		break;
	case UndoRedo.REPLACE_INNERFRAME_ELEMENT:
		this.undoRedoReplaceInrFrameElm(redoObj, false);
		break;
	case UndoRedo.ARRANGE_INNERFRAME_ELEMENT:
		this.undoRedoArrangeInrFrameElm(redoObj, false);
		break;
	case UndoRedo.RESIZE_FRAME:
		this.undoRedoResizeFrm(redoObj, false);
		break;
	case UndoRedo.SWP_FRM:
		this.undoRedoSwapFrm(redoObj, false);
		break;
	case UndoRedo.EDIT_FRAME:
		this.undoRedoEditFrame(redoObj, false);
		break;
	case UndoRedo.IMG_OPACITY:
		this.undoRedoImgOpcty(redoObj, false);
		break;
	case UndoRedo.DRAG_BLANKFRAME:
		this.undoRedoResizeBlnkFrm(redoObj, true, false);
		break;
	case UndoRedo.RESIZE_BLANKFRAME:
		this.undoRedoResizeBlnkFrm(redoObj, false, false);
		break;
	case UndoRedo.ARRANGE_BLANKFRAME:
		this.undoRedoArrngBlnkFrm(redoObj, false);
		break;
	case UndoRedo.ROTATE_INNERFRAME_ELEMENT:
		this.undoRedoRotateInrFrmElm(redoObj, false);
		break;
	case UndoRedo.ROTATE_MAINFRAME_ELEMENT:
		this.undoRedoRotateMnOrBlnkFrmElm(redoObj, false);
		break;
	case UndoRedo.CROP:
		this.undoRedoCropElm(redoObj, false);
		break;
	case UndoRedo.CROP_SHAPES:
		this.undoRedoCropShapes(redoObj, false);
		break;
	case UndoRedo.ADD:
		this.undoRedoAddMnFrameElm(redoObj);
		break;
	case UndoRedo.DELETE:
		this.undoRedoDelMnFrameElm(redoObj.mainFrameIndex);
		break;
	case UndoRedo.ARRANGE:
		this.undoRedoArrangeMnFrameElm(redoObj.mnFrmIndex, redoObj.currMnFrmLyrArr);
		break;
	case UndoRedo.RESIZE:
	case UndoRedo.DRAG:
		this.undoRedoDragMnFrameElm(false, redoObj, redoOperationType);
		break;
	case UndoRedo.TEXT_EDIT:
		this.undoRedoTextEdit(false, redoObj);
		break;
	case UndoRedo.WEATHER_EDIT:
		this.undoRedoWeatherEdit(false, redoObj);
		break;
	case UndoRedo.ADD_AUDIO:
		this.undoRedoAddAudio(false, redoObj);
		break;
	case UndoRedo.DEL_AUDIO:
		this.undoRedoDelAudio(false, redoObj);
		break;
	case UndoRedo.REPLACE_AUDIO:
		this.undoRedoReplaceAudio(false, redoObj);
		break;
	case UndoRedo.MUTE_AUDIO:
        this.undoRedoMuteUnmuteAudio(false, redoObj);
        break;
	case UndoRedo.TEMPLATE_BG:
		this.undoRedoTemplateBg(false, redoObj);
		break;
	case UndoRedo.HW_UPDATE:
		this.undoRedoHndWritingUpdate(false, redoObj);
		break;
	case UndoRedo.SHAPES_EDIT:
		this.undoRedoShapesEdit(false, redoObj);
		break;
	case UndoRedo.SHAPES_BG:
		this.undoRedoShapesBG(false, redoObj);
		break;
	case UndoRedo.ZOOM_TEMPLATE:
		this.undoRedoZoomTemplate(false, redoObj);
		break;
	case UndoRedo.RSS_WEB_URL:
		this.undoRedoRssWeburl(false, redoObj);
		break;
    case UndoRedo.MEDIA_RSS_RELOAD_DUR:
        this.undoRedoMediaRssDur(false, redoObj);
        break;
	case UndoRedo.INPUT_SRC:
		this.undoRedoInpSrcType(false, redoObj);
		break;
	case UndoRedo.MULTI_SEL_ROT:
		this.undoRedoMultiSelRot(false, redoObj);
		break;
	case UndoRedo.MULTI_SEL_RESIZE:
		this.undoRedoMultiSelResize(false, redoObj);
		break;
	case UndoRedo.MULTI_SEL_DEL:
		this.undoRedoDelMultiSel(false, redoObj);
		break;
	default:
		//Left blank intentionally
		break;
	}

	/*Selecting item if it is single element*/
	this.selectElement(this.getValidId(redoObj));

	undoStackObj.push(redoData);

};

/*Method to get a valid id from the undo/redo object */
/*TODO: Pulkit will be updating id so that we dont require checks.*/
template.prototype.getValidId = function(undoRedoObj)
{
	var Id;
	if(this.isValidObject(undoRedoObj.elmId))
	{
		Id = undoRedoObj.elmId;
	}
	else if(this.isValidObject(undoRedoObj.frameId))
	{
		Id = undoRedoObj.frameId;
	}
	else if(this.isValidObject(undoRedoObj.textElmId))
	{
		Id = undoRedoObj.textElmId;
	}
	else if(this.isValidObject(undoRedoObj.eleId))
	{
		Id = undoRedoObj.eleId;
	}
	else if((undoRedoObj.undoCropDim != undefined) && this.isValidObject(undoRedoObj.undoCropDim.id))
	{
		Id = undoRedoObj.undoCropDim.id;
	}
	else if((undoRedoObj.frameObj != undefined)&& this.isValidObject(undoRedoObj.frameObj.id))
	{
        Id = undoRedoObj.frameObj.id;
	}
	else if(undoRedoObj.event != undefined && this.isValidObject(undoRedoObj.event.target.id.split("_CP")[0]))
	{
	    Id = undoRedoObj.event.target.id.split("_CP")[0];
	}
	return Id;
};

/*Simple utility method to check if item is valid*/
template.prototype.isValidObject = function(Id)
{
	return((Id != undefined) && Id != null);
};

/*Method to hide the control points in the frame*/
template.prototype.hideFrameControlPoints=function()
{
    $(".tpl_CtrlPtCls").hide();
    $('.rotateHandlerCls').hide();
};

/*Method to hide any selected element*/
template.prototype.hideSelectionForAllElement=function()
{
    this.hideBlankLayoutFrameCP();
    this.hideMainFrameAllElmCp();
    this.hideFrameControlPoints();
};

/*Method to show selection on the current element*/
template.prototype.selectElement = function(Id)
{
	if((Id != undefined) && TemplateUtils.isElementExistInDOM(Id) && !TemplateUtils.isElementTypeGroup(Id))
	{
		$("#mainFrameCoverID").hide();
		if(TemplateUtils.isElementTypeMainFrame(Id))
		{
			this.snglTapOnMnFrmElm($("#" + Id));
			showAuthorMenu("ElmCover-" + Id);
			this.showMainFrameElmCp(Id);
			this.mainFrame.activeEleIndex = getParseIntInDec(Id.split("-elm_")[1].split("_")[0]);
		}
		else
		{
		    showAuthorMenu("frameCover-" + Id);
            	    if(this.frameLayout == BLANK_LAYOUT){
	                this.showBlankLayoutFrameCP(Id);
	            }else{
	                this.showCtrlPtsForFrameID(Id);
	            }
		    this.getInnerFrameForId(Id).active = true;
		}
	}
};
/*This function check if the Shape is in crop mode while undo is pressed first time
* handleCropUndoForShapes called to undo the crop mode for shape
*/
template.prototype.preUndoCheck=function(){
    if(this.isCroppedMode){
        var elmObj = this.mainFrame.getActiveElement();
        if(elmObj != null){
            var selElmId=this.mainFrame.id+"-elm_"+this.mainFrame.activeEleIndex+"_0";
            if(TemplateUtils.isShape(elmObj.elementType)){
                this.handleCropUndoForShapes(elmObj, selElmId, this.cropInfoFrUndo);
            }
        }
    }
};
/************ Inner Frame Elements**********/

template.prototype.undoRedoAddInrFrameElm = function(obj){	
	var frameObj = obj.frameObj;
	var elmObj = obj.elementObj;
	var index = obj.index;
	this.addElmToFrame(frameObj,elmObj, index);	
	this.renderActvElmOfFrame(frameObj.id);
};
template.prototype.undoRedoDelInrFrameElm = function(obj){		
	var frameObj = obj.frameObj;
	var index = obj.index;
	var frameId = frameObj.id;
	frameObj.element.splice(index, 1);
	this.showElmTypeIconOnFrame(frameId);
};
template.prototype.undoRedoDelFrame = function(obj, isUndo){	
	var frameId = obj.frameId;
	var isThisSelAudioFrm = obj.isThisSelAudioFrm;
	var elmArr = obj.elmArr;	
	var frame=this.getInnerFrameForId(frameId);	
	if(isUndo){
		frame.element = obj.elmArr.slice();
		frame.duration = obj.duration;
		this.renderActvElmOfFrame(frameId);
		if(isThisSelAudioFrm){
			this.selAudioFrm = frameId;
		}
	}else{
		this.delAllDataFromFrame(frameId);
	}
};
template.prototype.undoRedoAddBlankFrame = function(obj){
	var frameObj = obj.frameObj;
	var innerFrameZOrder = obj.innerFrameZOrder;
	var frameId = frameObj.id;		
	var count = frameId.replace(FRAME_ID_PREFIX,"");
	this.innerFrames[frameId] = frameObj;
	this.innerFrameZOrderArr.splice(innerFrameZOrder, 0, count);
	this.frameCount++;
	this.addFrameToMainDiv(frameObj);
	var actvFrmId = this.getActiveFrame().id;
	if(actvFrmId != this.mainFrame.id){		
		this.hideCtrlPtsForFrameID(actvFrmId, true);	
	}
	this.setAngleForFrameHtml(frameId,frameObj.rotation);
	this.triggerTapForFrame(frameObj);
};
template.prototype.undoRedoDelBlankFrame = function(obj){
	var frameObj = obj.frameObj;
	if(this.multiSelectMode){
	    this.enableMultiSelect(false);
            closeAuthorMenu();
            this.hideMainFrameAllElmCp();
	}
	this.deleteBlkFrame(frameObj.id);
};
template.prototype.undoRedoReplaceInrFrameElm = function(obj, isUndo){	
	var frameObj = obj.frameObj;
	var newElm = obj.newElmObj;
	var elementArr = obj.elmArr;
	var replaceAllFlag = obj.replaceAllFlag;
	var prevElm = elementArr[0];
	
	var modifiedElm = prevElm;
	if(!isUndo){
		modifiedElm = newElm;
	}
		
	if(replaceAllFlag){
	    this.hideAllControlPoints();
		if(isUndo){
			this.undoReplaceAllFrameContent(frameObj,elementArr);
		}else{
			this.replaceAllFrameContent(frameObj,modifiedElm);
			this.triggerTapForFrame(frameObj);
		}
		//TODO: please check if this is required or not
		//closeAuthorMenu();
	}else{		
		this.replaceCurrElmOfFrame(frameObj,modifiedElm);			
	}
};
template.prototype.undoRedoArrangeInrFrameElm = function(obj,isUndo){
	var frameObj = obj.frameObj;
	var elmArr = obj.currElmArr;
	if(isUndo){
		elmArr = obj.prevElmArr;
	}
	frameObj.element = elmArr.slice();
	this.renderActvElmOfFrame(frameObj.id);
};
template.prototype.undoRedoResizeFrm = function(obj,isUndo){		
	var eventObj =  jQuery.extend({}, obj.event);	
	var startPtObj =  jQuery.extend({}, obj.startPt);
	this.curLineOfCntl =  jQuery.extend({}, obj.lineOfCtrl);
	this.curGridLineRange =  jQuery.extend({}, obj.gridLineRange);	
	if(isUndo){
		this.onCPDragUndo(eventObj, startPtObj);	
	}else{
		this.cpDragStartPt = startPtObj;
		this.onCPDragEvent(eventObj);
	}
	var frames = this.curLineOfCntl.affectedFrameIds;
	for(var index in frames){
	    this.aspectFillAllElementOfFrame(frames[index]);
	}
	/*Reset magnet lines and line of control*/
	this.hideMagnetLines();
	this.curLineOfCntl = null;
};
template.prototype.undoRedoSwapFrm = function(obj,isUndo){	     
	if(isUndo){
		this.swapFramesData(obj.frameId1, obj.frameId2);
	}else{
		this.swapFramesData(obj.frameId2, obj.frameId1);
	}      
};
template.prototype.undoRedoEditFrame = function(obj,isUndo){		     
	var frameObj = this.getInnerFrameForId(obj.frameId);
	var durValue = obj.newDuration;
	frameObj.transitionEffect=obj.newTransEffect;    
	if(isUndo){
		frameObj.transitionEffect=obj.oldTransEffect;
		durValue = obj.prevDuration;		
	} 
	updateTime(frameObj,durValue);

	this.renderFrameThumbs(frameObj.id);
};
template.prototype.undoRedoImgOpcty = function(obj,isUndo){		     
	var frameObj = this.getInnerFrameForId(obj.frameId);
	var opacityValue = obj.newOpacity;	
	if(isUndo){
		opacityValue = obj.prevOpacity;		
	} 
	this.handleOpacityEvent(frameObj.id, obj.eleIndx, opacityValue);
	
	this.renderFrameThumbs(frameObj.id);
};
template.prototype.undoRedoResizeBlnkFrm = function(obj,isDrag,isUndo){
	var frameId = obj.frameId;	    
	var startOrEndPt = obj.startPtObj; 
	if(!isUndo){
		startOrEndPt = obj.endPtObj;
	}
	if(isDrag){
		this.updateBlkFrameOrigin(frameId, startOrEndPt.x, startOrEndPt.y);
	}else{
		this.updateBlkFrameDimention(frameId, startOrEndPt.x, startOrEndPt.y, startOrEndPt.w, startOrEndPt.h);
		this.aspectFillAllElementOfFrame(frameId);
	}      
	/*Reset magnet lines and line of control*/
	this.hideMagnetLines();
};
template.prototype.undoRedoArrngBlnkFrm = function(obj,isUndo){
	var frameId = obj.frameId;
	if(isUndo){
		this.innerFrameZOrderArr = obj.prevBlnkFrmArr.slice();	
	}else{
		this.innerFrameZOrderArr = obj.currBlnkFrmArr.slice();	
	}	
    this.reorderZIndexBlkFrames();
};
template.prototype.undoRedoRotateInrFrmElm = function(obj,isUndo){	
	var frameId = obj.frameId;	
	var angle = obj.angle;	
	if(isUndo){
		angle = obj.startAngle;
	}	
	obj.elmObj.rotation = angle;
	this.renderActvElmOfFrame(frameId);
};
template.prototype.undoRedoRotateMnOrBlnkFrmElm = function(obj,isUndo){	
	var elmId = obj.elmId;
	var elmObj = obj.elmObj;
	var angle = obj.angle;	
	if(isUndo){
		angle = obj.startAngle;
	}		
	elmObj.rotation=angle;
	if(obj.isBlnkFrmRotate){
		this.setAngleForFrameHtml(elmId,angle);		
	}else{
		this.setMainFrmElmAngle(elmId,angle);	
	}			
};
template.prototype.undoRedoCropElm = function(obj,isUndo){	
	var  cropInfo = obj.redoCropDim;
	var frameId = cropInfo.id;	
	if(isUndo){
		cropInfo = obj.undoCropDim;
	}
	this.handleUndoEvent(frameId, cropInfo, obj.elmIndx);
	this.handleDoneEvent(frameId);
	
	this.bCanvasAnyElmSel = false;
	
};
template.prototype.undoRedoCropShapes = function(obj,isUndo){	
	var  cropInfo = obj.redoCropDim;
	if(isUndo){
		cropInfo = obj.undoCropDim;
	}
	this.handleCropUndoForShapes(obj.elmObj, obj.selElmId, cropInfo);
	this.handleCropDoneForShapes(obj.elmObj, obj.selElmId);
		
};
/************ Main Frame Elements**********/
template.prototype.undoRedoAddMnFrameElm = function(obj){
	var ele = obj.elementObj;	
    var mainFrameIndex = obj.mainFrameIndex;
	var zIndex = obj.zIndex;
	var elmId = this.mainFrame.id+"-elm_"+ mainFrameIndex +"_0"; //create element id from mainFrame index
	
	this.mainFrame.element[mainFrameIndex] = ele;
	this.addIndxToMnFrmLyerArr(mainFrameIndex, zIndex);
	
	this.renderElmntOnMnFrm(ele, mainFrameIndex);
	this.resetZIndexMnFrmElm();
	
	if(this.isTxtTypeElm(ele.elementType)){
		ele = ele.textElms[0];
	}
};
template.prototype.undoRedoDelMnFrameElm = function(mnFrmIndx){
	this.deleteElmFromMainFrame(mnFrmIndx);   
   	closeAuthorMenu();		 
   	this.hideMainFrameAllElmCp();  	
};

template.prototype.undoRedoArrangeMnFrameElm = function(mnFrmIndex, layerArr){
	var ele = this.mainFrame.element[mnFrmIndex];
	var elmId = this.mainFrame.id+"-elm_"+ mnFrmIndex +"_0";
	this.mainFrmElmLayer = layerArr.slice();// to create a new copy of array
    this.resetZIndexMnFrmElm();
  	if(this.isTxtTypeElm(ele.elementType)){
		ele = ele.textElms[0];
	}
};
template.prototype.undoRedoDragMnFrameElm = function(isUndo, obj, operationType){
	var elmObj = obj.ele;
	var elmId = obj.eleId;
	var startOrEnd = obj.end;
	if(isUndo){
		startOrEnd = obj.start; 
	}
	this.updateObjXYHWFromObj(elmObj, startOrEnd);			
	this.resetMnFrmElementPos(elmId, elmObj);
	if(operationType == UndoRedo.RESIZE && obj.isTextOrGroup){
		this.textImageUpdate(elmId);
	}
	var type = elmObj.elementType;
	if(operationType == UndoRedo.RESIZE && TemplateUtils.isShape(type)){
	    this.updateShapeElements(elmId, elmObj);
		if(this.isShapeWithYlowCp(type)){
        	this.addYellowCpOnElm(elmId);
		}
	}
};

template.prototype.undoRedoTextEdit=function(isUndo, textEditObj){
	var elmId = textEditObj.textElmId;
	var propName = textEditObj.propertyName;
	var type = $("#"+elmId).attr("type");
		
	var modifiedValue="";
	if(isUndo){
		modifiedValue = textEditObj.prevValue;
	}else{
		modifiedValue = textEditObj.newValue;
	}
	
	var tmpArr = propName.split("_");
	if(tmpArr[0] == 'title' || tmpArr[0] == 'date' || tmpArr[0] == 'desc'){
		this.setRssObjProp(textEditObj.textEle, tmpArr, modifiedValue);
	}else if(propName == 'reloadDuration' || propName == 'flipSpeed'){
		textEditObj.textEle.rssInfo[propName] = modifiedValue;
	}else{		
		if(propName == 'bgColor'){
			this.setBGColorandAlpha(textEditObj.textEle, modifiedValue);
		}
		else if(propName == 'shdwClr')
        {
            TemplateUtils.setColorandAlphaForElement(textEditObj.textEle, modifiedValue,propName,"shdwOpc");
        }
        else if(propName == 'strkClr')
        {
            TemplateUtils.setColorandAlphaForElement(textEditObj.textEle, modifiedValue,propName,"strkOpc");
        }
		else{
			textEditObj.textEle[propName] = modifiedValue;				
			if(propName == "fontFamily"){
				this.setBoldItalicInTxtElm(textEditObj.textEle);    
			}	
			if(propName == 'bTextSlide' && modifiedValue == false){
				// In case of text slide off, values of hAlign and vAlign need to be reset
				textEditObj.textEle.hAlign = textEditObj.prevValue2;
				textEditObj.textEle.vAlign = textEditObj.prevValue3;
			}
		}			
		if((type==TEXT) ||(type==GROUP)){
			this.textImageUpdate(elmId);
		}		
	}
	var name = textEditObj.name;	
	this.applyTextProperties(elmId, type, name, modifiedValue, false);
	if(propName == 'text'){
	     $("#"+elmId+"_InrElm").html(modifiedValue);
	}  
};
template.prototype.undoRedoWeatherEdit=function(isUndo, obj){
	var elmId = obj.elmId;
	var elmObj = obj.ele;
	var propName = obj.property;
	var modifiedValue="";
	if(isUndo){
		modifiedValue = obj.prevValue;
	}else{
		modifiedValue = obj.newValue;
	}
	if(propName == "timeZoneOffset"){
		elmObj.timeZoneOffset = modifiedValue;
	}else if(propName == "cityId"){
		elmObj.weather.cityId = modifiedValue;
		if(isUndo){
			elmObj.weather.country = obj.prevValue2;
			elmObj.weather.city = obj.prevValue3;
		}else{
			elmObj.weather.country = obj.newValue2;
			elmObj.weather.city = obj.newValue3
		}
        var completionCallback = function() {
            //For location changes it appends _InrElm to the element ID. So while adding selected removing this substring to get actual ele id
            var tempEleId = elmId.replace("_InrElm", "");
            templateObj.selectElement(tempEleId);
        };
		getWeatherJsonData(modifiedValue, elmId, elmObj.elementType, completionCallback);
	}else{
		this.updtWthrInfo(elmId,modifiedValue,propName);
	}
};
template.prototype.undoRedoAddAudio=function(isUndo, obj){
	this.audioFileName = obj.audioFileName;
    this.audioPath = obj.audioPath;
    this.selAudioFrm = obj.newSelAudioFrm;
    if(isUndo){
        this.selAudioFrm = obj.prvSelAudioFrm;
    }
    this.showAudioList();
};
template.prototype.undoRedoDelAudio=function(isUndo, obj){	
	this.simAudioDoneBtn();
	this.selAudioFrm = obj.newSelAudioFrm;
	if(isUndo){
	    this.selAudioFrm = obj.prvSelAudioFrm;
	}
	this.showAudioList(); 	
};
template.prototype.undoRedoReplaceAudio=function(isUndo, obj){	
	var audioFileName = obj.currAudioFileName;
	var audioPath = obj.currAudioPath;
	if(isUndo){
		audioFileName = obj.prevAudioFileName;
		audioPath = obj.prevAudioPath;
	}
	this.audioFileName = audioFileName;
    this.audioPath = audioPath;
    this.showAudioList(); 	
};
template.prototype.undoRedoMuteUnmuteAudio=function(isUndo, obj){
	var audioMuteFlag = obj.currAudioMuteFlag;
    if(isUndo){
        audioMuteFlag = obj.prevAudioMuteFlag;
    }
    this.audioFlag = audioMuteFlag;
    this.setAudioPlayStatus(this.audioFlag);
};
template.prototype.undoRedoTemplateBg=function(isUndo, obj){	
	var bgColor = obj.currBgColor;
	var bgImage = obj.currBgImage;
	if(isUndo){
		bgColor = obj.prevBgColor;
		bgImage = obj.prevBgImage;
	}
	this.setBGofTemplate(bgColor,bgImage);
};
template.prototype.undoRedoHndWritingUpdate=function(isUndo, obj){	 
	var imageSrcpath = obj.currPath;
	if(isUndo){
		imageSrcpath = obj.prevPath;
	}
	var elmObj = this.mainFrame.element[obj.elmIndex];
	elmObj.imageSrc = imageSrcpath;
        $("#"+ obj.elmId +"_InrElm").attr("src",imageSrcpath);
};
template.prototype.undoRedoShapesEdit=function(isUndo, obj){	 
	var elmId = obj.elmId;
	var elmObj = obj.ele;
	var propName = obj.property;
	var modifiedValue="";
	if(isUndo){
		modifiedValue = obj.prevValue;
	}else{
		modifiedValue = obj.newValue;
	}
	switch (propName) {
		case "shape-opacity":
			elmObj.shapeDetails.FillOpacity = modifiedValue;
		break;
		case "shape-line-opacity":
            elmObj.shapeDetails.FigureStrokeOpacity = modifiedValue;
        break;
		case "color":
        case "shape-linecolor":
			elmObj.shapeDetails.LineColor = modifiedValue;
		break;
		case "shape-linethickness":
			elmObj.shapeDetails.FigureStrokeWidth = modifiedValue;
		break;
		case "shape-linestyle":
			elmObj.shapeDetails.FigureStrokePattern = modifiedValue;
		break;
		case "shape-fillrange":
			elmObj.shapeDetails.FillRange = modifiedValue;
		break;
		//Yellow point properties
		case "ApexRatio":
			elmObj.shapeDetails.ApexRatio = modifiedValue;
		break;	
		case "FigureRoundRatio":
			elmObj.shapeDetails.FigureRoundRatio = modifiedValue;
		break;
		case "FrameWidth":
			elmObj.shapeDetails.FrameWidth = modifiedValue;
		break;
		case "DonutWidth":
			elmObj.shapeDetails.DonutWidth = modifiedValue;
		break;
		case "PolygonWidth":
			elmObj.shapeDetails.PolygonWidth = modifiedValue;
		break;
		case "BarWidth":
			elmObj.shapeDetails.BarWidth = modifiedValue;
		break;
		case "Slope":
			elmObj.shapeDetails.Slope = modifiedValue;
		break;
		case "StartWidth":
			elmObj.shapeDetails.StartWidth = modifiedValue;
		break;
		case "EllipseSize":
			elmObj.shapeDetails.EllipseSize = modifiedValue;
		break;
		case "FoldedRatio":
			elmObj.shapeDetails.FoldedRatio = modifiedValue;
		break;
		case "ArrowHeadLength":
			elmObj.shapeDetails.ArrowHeadLength = modifiedValue;
			if(isUndo){
				elmObj.shapeDetails.ArrowBodyWidth = obj.prevValue2;
			}else{
				elmObj.shapeDetails.ArrowBodyWidth = obj.newValue2;
			}
		break;
		case "VertexPosition":
			elmObj.shapeDetails.VertexPosition = modifiedValue;
		break;
		case "RoundCornerRatio":
			elmObj.shapeDetails.RoundCornerRatio = modifiedValue;
		break;
		case "CurvedRatio":
			elmObj.shapeDetails.CurvedRatio = modifiedValue;
		break;
		case "HorizontalSlope":
			elmObj.shapeDetails.HorizontalSlope = modifiedValue;
		break;
		case "StartAngle":
		    elmObj.shapeDetails.StartAngle = modifiedValue;
        break;
        case "EndAngle":
            elmObj.shapeDetails.EndAngle = modifiedValue;
        break;
       case "CalloutPoint":
            elmObj.x = modifiedValue.elmX;
            elmObj.y = modifiedValue.elmY;
            elmObj.w = modifiedValue.elmW;
            elmObj.h = modifiedValue.elmH;
            elmObj.shapeDetails.CalloutPoint = jQuery.extend({}, modifiedValue.CalloutPoint);// need to create a copy of object
            elmObj.shapeDetails.InnerRect = jQuery.extend({}, modifiedValue.InnerRect);
            this.resetMnFrmElementPos(elmId, elmObj);
            this.updateMainFrameCpPosition(elmId);
        break
		default:
			break;
	}
	var type = obj.type;
	this.updateShapeElements(elmId, elmObj);
	this.addYellowCpOnElm(elmId);
};
template.prototype.undoRedoShapesBG = function(isUndo, obj){	
		
	var elmObj = obj.elmObj;
	var elmId = obj.elmId;
	var iObj;
	
	if(isUndo){
		iObj = obj.previObj;			
	}else{
		iObj = obj.curriObj;
	}	
	var bgColor = iObj.FillColor;
	
	if(bgColor == ""){
		this.updateShapeElmObjForBgImage(elmObj, iObj, elmId);
	}else{
		elmObj.shapeDetails.FillColor = bgColor;
		elmObj.shapeDetails.FillOpacity = iObj.FillOpacity;
		elmObj.thumbPath ="";
		elmObj.OriginalPath ="";
		this.redrawShape(elmObj, elmId);
	}
};
template.prototype.undoRedoZoomTemplate = function(isUndo, obj){	
	var scale;	
	if(isUndo){
		scale = obj.prevScale;			
	}else{
		scale = obj.currScale;
	}
	this.onMainFrameDoubleTap(scale);
};
template.prototype.undoRedoRssWeburl = function(isUndo, obj){	
	var elmObj = obj.elmObj;
	var elmId = obj.elmId;
	var modifiedUrl;
	if(isUndo){
		modifiedUrl = obj.prevUrl;
	}else{
		modifiedUrl = obj.currUrl;
	}
	switch (obj.elmType) {
		case widgetInfo.WEB:
			elmObj.OriginalPath = modifiedUrl;
			$("#"+elmId+"_webDivId").html(modifiedUrl);
		break;
		case widgetInfo.MEDIARSS:
			elmObj.mediaRssInfo.url = modifiedUrl;
			 $("#"+elmId+"_webDivId").html(modifiedUrl);
		break;
		case TEXT:
			elmObj.rssInfo.url = modifiedUrl;
		break;	
		default:
			break;
	}	
}; 
template.prototype.undoRedoMediaRssDur = function(isUndo, obj){
	var duration;
	var elmObj = obj.elmObj;
	if(isUndo){
		duration = obj.prevDur;
	}else{
		duration = obj.currDur;
	}
    elmObj.mediaRssInfo.reloadDuration = duration;
};
template.prototype.undoRedoInpSrcType = function(isUndo, obj){
	var inpSrcType;
	if(isUndo){
		inpSrcType = obj.prevInpSrcType;
	}else{
		inpSrcType = obj.currInpSrcType;
	}	
	this.selectInputSrc(obj.frameId,inpSrcType);
};

template.prototype.undoRedoMultiSelRot = function(isUndo, obj)
{
	var len = obj.multiSelElmArr.length;
	var elmObj, elmID;
	this.multiSelectMode = true;
	for (var i = 0; i < len; i++)
	{
		elmObj = obj.multiSelElmArr[i];
		elmID = elmObj.id;
		isGroup = TemplateUtils.isElementTypeGroup(elmID);
		isMainFrame = TemplateUtils.isElementTypeMainFrame(elmID);
        var undoRedoRotArr = obj.undoRotationArr[i];
        if(undoRedoRotArr == undefined || undoRedoRotArr.currRotation == undoRedoRotArr.preRotation)
        {
          if(!isGroup){
          this.selGroupOrElmOnMultiSelect(elmID);
          }
          continue;
        }
		if(isUndo)
		{
			rotation = undoRedoRotArr.preRotation;
			preRotation = undoRedoRotArr.currRotation;
		}
		else
		{
			rotation = undoRedoRotArr.currRotation;
			preRotation = undoRedoRotArr.preRotation;
		}
		if(isGroup)
		{
			var angleDiff = rotation - preRotation;
			group.multiSelectRotateGroup(elmID, angleDiff);
			var groupObj = groupHandler.groupMap[elmID];
			groupObj.rotation = rotation;

			var grpLength = groupObj.elements.length;
			for (var j = 0; j < grpLength; j++)
			{
				var element = groupObj.elements[j];
				element.ref.rotation = rotation;
				if(isUndo)
				{
					element.x = undoRedoRotArr.preXArr[j];
					element.ref.x = element.x;
					element.y = undoRedoRotArr.preYArr[j];
					element.ref.y = element.y;
				}
				else
				{
					element.x = undoRedoRotArr.currXArr[j];
					element.ref.x = element.x;
					element.y = undoRedoRotArr.currYArr[j];
					element.ref.y = element.y;
				}
			}
		}
		else
		{
			elmObj.ref.rotation = rotation;
			if(isMainFrame)
			{
				this.setMainFrmElmAngle(elmID, rotation);
			}
			else
			{
				this.setAngleForFrameHtml(elmID, rotation);
			}
			this.selGroupOrElmOnMultiSelect(elmID);
			this.updateShapeElements(elmID, elmObj.ref);
		}
	}

	showAuthorMenu(elmID);
	this.multiSelElmArr = obj.multiSelElmArr.slice();

	this.addBoxShadowForMultiselect();
	$("#mainFrameCoverID").hide();
};
/*Update shape elements*/
template.prototype.updateShapeElements = function(elmID, elmObj){
    var elmType = elmObj.elementType;
    if(TemplateUtils.isShape(elmType)){
        if(elmObj.thumbPath!="")
        {
            this.aspectFillShape(elmObj,elmID);
        }
        this.redrawShape(elmObj, elmID);
        if(this.isShapeWithYlowCp(elmType)){
            this.setYCpLocationForShape(elmType, elmObj);
        }
    }
};
template.prototype.undoRedoMultiSelResize = function(isUndo, obj)
{
	var len = obj.multiSelElmArr.length;
	var elmObj, elmID;
	var undoRedoResizeObj;
	this.multiSelectMode = true;
	for (var i = 0; i < len; i++)
	{
		elmObj = obj.multiSelElmArr[i];
		elmID = elmObj.id;
		undoRedoResizeObj = obj.undoRedoResizeArr[i];
		if(isUndo)
		{
			this.updateObjXYHWFromObj(elmObj, undoRedoResizeObj.start);
		}
		else
		{
			this.updateObjXYHWFromObj(elmObj, undoRedoResizeObj.end);
		}
		this.updateObjXYHWFromObj(elmObj.ref, elmObj);
		this.selGroupOrElmOnMultiSelect(elmID);
		if(!TemplateUtils.isElementTypeMainFrame(elmID) && !TemplateUtils.isElementTypeGroup(elmID))
        {
            this.aspectFillAllElementOfFrame(elmID);
        }
        if(getParseIntInDec($("#"+elmID).attr('type')) == TEXT){
            this.textImageUpdate(elmID);
        }
        this.updateShapeElements(elmID, elmObj.ref);
	}
	showAuthorMenu(elmID);
	this.multiSelElmArr = obj.multiSelElmArr.slice();
	this.addBoxShadowForMultiselect();
	$("#mainFrameCoverID").hide();
	this.updateObjInMultiSelArray(obj.multiSelElmArr);
};
template.prototype.undoRedoDelMultiSel = function(isUndo, obj)
{
	var len = obj.multiSelElmArr.length;
	var undoRedoDelObj;
	var ele, mainFrameIndex, zIndex, elementId;
	var frameObj, innerFrameZOrder, count;

	if(isUndo)
	{
		this.multiSelectMode = true;

		for (var i = 0; i < len; i++)
		{
			undoRedoDelObj = obj.undoRedoDelArr[i];
			if(undoRedoDelObj.isMainFrame)
			{
				ele = undoRedoDelObj.elementObj;
				mainFrameIndex = undoRedoDelObj.mainFrameIndex;
				zIndex = undoRedoDelObj.zIndex;
				elementId = this.mainFrame.id + "-elm_" + mainFrameIndex + "_0";

				this.mainFrame.element[mainFrameIndex] = ele;
				this.addIndxToMnFrmLyerArr(mainFrameIndex, zIndex);

				this.renderElmntOnMnFrm(ele, mainFrameIndex);
				this.resetZIndexMnFrmElm();

				this.setMainFrmElmAngle(elementId, ele.rotation);

			}
			else
			{
				frameObj = undoRedoDelObj.frameObj;
				innerFrameZOrder = undoRedoDelObj.innerFrameZOrder;
				elementId = frameObj.id;
				count = elementId.replace(FRAME_ID_PREFIX, "");
				this.innerFrames[elementId] = frameObj;
				this.innerFrameZOrderArr.splice(innerFrameZOrder, 0, count);
				this.frameCount++;
				this.addFrameToMainDiv(frameObj);

				this.setAngleForFrameHtml(elementId, frameObj.rotation);
			}
			this.selGroupOrElmOnMultiSelect(elementId);
		}
		showAuthorMenu(elementId);
		this.multiSelElmArr = obj.multiSelElmArr.slice();
		this.addBoxShadowForMultiselect();
		$("#mainFrameCoverID").hide();
	}
	else
	{
		this.deleteMultiselectedElements(true, obj.multiSelElmArr);
	}
};
/*********Create undo redo object for Inner frame elements *********/
template.prototype.createUndoRedoData = function(operation, obj){
	var undoRedoData = {};
	undoRedoData.operation = operation;
	undoRedoData.obj = obj;
	return undoRedoData;
};

template.prototype.createAddDelInrFrmElmURObj = function(frame, ele,index) { 
	var addDelObj = {};
	addDelObj.frameObj = frame;	
	addDelObj.elementObj = ele;
	addDelObj.index = index;
	return addDelObj;
};
template.prototype.createAddDelBlnkFrmURObj = function(frame, innerFrameZOrder) { 
	var addDelObj = {};
	addDelObj.frameObj = frame;	
	addDelObj.innerFrameZOrder = innerFrameZOrder;		
	return addDelObj;
};

template.prototype.createDelFrameURObj = function(frameId,isThisSelAudioFrm){ 
	var delFrameObj = {};
	delFrameObj.frameId = frameId;
	delFrameObj.isThisSelAudioFrm = isThisSelAudioFrm;
	
	var frame=this.getInnerFrameForId(frameId);
	delFrameObj.elmArr = frame.element.slice();// create copy of array
	delFrameObj.duration = frame.duration;
	return delFrameObj;
};

template.prototype.createReplaceInrFrmElmURObj = function(frame, newElm, elmArr, replaceAllFlag) { 
	var addRplaceObj = {};
	addRplaceObj.frameObj = frame;	
	addRplaceObj.newElmObj = newElm;
	addRplaceObj.elmArr = elmArr;	
	addRplaceObj.replaceAllFlag = replaceAllFlag;		
	return addRplaceObj;
};

template.prototype.createArrangeInrFrmElmURObj = function(frame, currElmArr, prevElmArr) { 
	var arngObj = {};
	arngObj.frameObj = frame;	
	arngObj.currElmArr = currElmArr;
	arngObj.prevElmArr = prevElmArr;
	return arngObj;
};
template.prototype.createResizeFrmURObj = function(event, startPt, lineOfCtrl,gridLineRange) { 
	var resizeObj = {};
	resizeObj.event = event;
	resizeObj.startPt = startPt;
	resizeObj.lineOfCtrl = lineOfCtrl;	
	resizeObj.gridLineRange = gridLineRange;
	return resizeObj;
};
template.prototype.createSwapFrmURObj = function(frameId1, frameId2) { 
	var swapObj = {};
	swapObj.frameId1 = frameId1;
	swapObj.frameId2 = frameId2;
	return swapObj;
};
template.prototype.createEditFrmURObj = function(frameId, newTransEffect, oldTransEffect, newDuration, prevDuration) { 
	var editFrmObj = {};
	editFrmObj.frameId = frameId;
	editFrmObj.newTransEffect = newTransEffect;
	editFrmObj.oldTransEffect = oldTransEffect;
	editFrmObj.newDuration = newDuration;
	editFrmObj.prevDuration = prevDuration;
	return editFrmObj;
};
template.prototype.createImgOpctyURObj = function(frameId,eleIndx,newOpacity,prevOpacity) { 
	var imgOpctuObj = {};
	imgOpctuObj.frameId = frameId;
	imgOpctuObj.eleIndx = eleIndx;
	imgOpctuObj.newOpacity = newOpacity;
	imgOpctuObj.prevOpacity = prevOpacity;
	return imgOpctuObj;
};
template.prototype.createResizeBlnkFrmURObj = function(frameId, startPtObj, endPtObj) { 
	var resizeBlnkObj = {};
	resizeBlnkObj.frameId = frameId;
	resizeBlnkObj.startPtObj = startPtObj;
	resizeBlnkObj.endPtObj = endPtObj;	
	return resizeBlnkObj;
};
template.prototype.createArrangeBlankFrmURObj = function(frameId,prevBlnkFrmArr, currBlnkFrmArr) {
	var arrangeObj = {};	
	arrangeObj.frameId = frameId;
	arrangeObj.prevBlnkFrmArr = prevBlnkFrmArr;
	arrangeObj.currBlnkFrmArr = currBlnkFrmArr;	
	return arrangeObj;
};
template.prototype.createRotateInrFrmElmURObj = function(frameId, elmObj,startAngle,angle) {
	var rotateObjInrFrm = {};
	rotateObjInrFrm.frameId = frameId;
	rotateObjInrFrm.elmObj = elmObj;	
	rotateObjInrFrm.angle = angle;
	rotateObjInrFrm.startAngle = startAngle;	
	return rotateObjInrFrm;
};
template.prototype.createRotateMnOrBlnkFrmElmURObj = function(elmId, elmObj, startAngle,angle,isBlnkFrmRotate) {
	var rotateObjMnFrm = {};
	rotateObjMnFrm.elmId = elmId;
	rotateObjMnFrm.elmObj = elmObj;
	rotateObjMnFrm.angle = angle;
	rotateObjMnFrm.startAngle = startAngle;
	rotateObjMnFrm.isBlnkFrmRotate = isBlnkFrmRotate;
	return rotateObjMnFrm;
};
template.prototype.createCropElmURObj = function(redoCropDim, undoCropDim, elmIndx) {
	var cropObj = {};
	cropObj.undoCropDim = undoCropDim;
	cropObj.redoCropDim = redoCropDim;
	cropObj.elmIndx = elmIndx;		
	return cropObj;
};
template.prototype.createCropShapesURObj = function(redoCropDim, undoCropDim, elmObj, selElmId) {
	var cropShapesObj = {};
	cropShapesObj.undoCropDim = undoCropDim;
	cropShapesObj.redoCropDim = redoCropDim;
	cropShapesObj.elmObj = elmObj;
	cropShapesObj.selElmId = selElmId;
	return cropShapesObj;
};
/***********Create undo redo object for Main Frame elements**************/
template.prototype.createAddDelMnFrmElmURObj = function(ele, mainFrameIndex, zIndex) {
	var addDelObj = {};
	addDelObj.elmId = this.mainFrame.id+"-elm_"+ mainFrameIndex +"_0";
	addDelObj.elementObj = ele;
	addDelObj.mainFrameIndex = mainFrameIndex;
	addDelObj.zIndex = zIndex;
	return addDelObj;
};

template.prototype.createArrangeMnFrmElmURObj = function(mnFrmIndex, prevMnFrmLyrArr, currMnFrmLyrArr, elmId) {
	var arrangeObj = {};
	arrangeObj.elmId = elmId;
	arrangeObj.mnFrmIndex = mnFrmIndex; 
	arrangeObj.prevMnFrmLyrArr = prevMnFrmLyrArr;
	arrangeObj.currMnFrmLyrArr = currMnFrmLyrArr;	
	return arrangeObj;
};
template.prototype.isArrModified=function(prevArr, currArr){
	var len = currArr.length;
	for (var i = 0; i < len; i++) {
		if(currArr[i] != prevArr[i]){
			return true;
		}
	}
	return false;
};

template.prototype.createDragMnFrmElmURObj = function(eleId, startPosAndDimObj, ele, isTextOrGroup){
	var dragObj = {};	
	dragObj.ele = ele;
	dragObj.eleId = eleId;	
	dragObj.start = {};
	dragObj.end = {};
	this.updateObjXYHWFromObj(dragObj.start, startPosAndDimObj);   
	this.updateObjXYHWFromObj(dragObj.end, ele);
	dragObj.isTextOrGroup = isTextOrGroup;			
	return dragObj;
};
template.prototype.createTextEditURObj = function(elmId, ele, property, prevValue, newValue, name, prevValue2, prevValue3) {
	var textEditObj = {};
	textEditObj.textElmId = elmId;
	textEditObj.textEle = ele;
	textEditObj.propertyName = property;
	textEditObj.prevValue = prevValue;
	textEditObj.newValue = newValue;
	textEditObj.name = name;
	textEditObj.prevValue2 = prevValue2;
	textEditObj.prevValue3 = prevValue3;	
	return textEditObj;
};
template.prototype.createWthrEditURObj = function(elmId, ele, property, prevValue, newValue, prevValue2, prevValue3) {
	var wthrEditObj = {};
	wthrEditObj.elmId = elmId;
	wthrEditObj.ele = ele;
	wthrEditObj.property = property;
	wthrEditObj.prevValue = prevValue;
	wthrEditObj.newValue = newValue;
	wthrEditObj.prevValue2 = prevValue2;
	wthrEditObj.prevValue3 = prevValue3;
	if(property == "cityId"){
		wthrEditObj.newValue2 = ele.weather.country;
		wthrEditObj.newValue3 = ele.weather.city;
	}
	return wthrEditObj;
};
template.prototype.createAddDelAudioURObj = function(audioPath, audioFileName, prvSelAudioFrm) {
	var audioObj = {};
	audioObj.audioPath = audioPath;
	audioObj.audioFileName = audioFileName;
	audioObj.prvSelAudioFrm = prvSelAudioFrm;
	audioObj.newSelAudioFrm = this.selAudioFrm;
	return audioObj;
};
template.prototype.createReplaceAudioURObj = function(prevAudioPath, prevAudioFileName, currAudioPath, currAudioFileName) {
	var audioRplaceObj = {};
	audioRplaceObj.prevAudioPath = prevAudioPath;
	audioRplaceObj.prevAudioFileName = prevAudioFileName;
	audioRplaceObj.currAudioPath = currAudioPath;
	audioRplaceObj.currAudioFileName = currAudioFileName;	
	return audioRplaceObj;
};
template.prototype.createMuteAudioURObj = function(prevAudioMuteFlag, currAudioMuteFlag) {
	var audioMuteObj = {};
	audioMuteObj.prevAudioMuteFlag = prevAudioMuteFlag;
	audioMuteObj.currAudioMuteFlag = currAudioMuteFlag;
	return audioMuteObj;
};
template.prototype.createTemplateBGURObj = function(prevBgColor,prevBgImage,currBgColor,currBgImage){
	var tmpltBGObj = {};
	tmpltBGObj.prevBgColor = prevBgColor;
	tmpltBGObj.prevBgImage = prevBgImage;
	tmpltBGObj.currBgColor = currBgColor;
	tmpltBGObj.currBgImage = currBgImage;	
	return tmpltBGObj;
};
template.prototype.createHndWrtgUpdateURObj = function(elmIndex, divId, currPath, prevPath){
	var hwUpdateObj = {};
	hwUpdateObj.elmIndex = elmIndex;
	hwUpdateObj.elmId = divId;
	hwUpdateObj.currPath = currPath;
	hwUpdateObj.prevPath = prevPath;
	return hwUpdateObj;
};
template.prototype.createShapeEditURObj = function(elmId, ele, type, property, prevValue, newValue, prevValue2, newValue2) {
	var shapeEditObj = {};
	shapeEditObj.elmId = elmId;
	shapeEditObj.ele = ele;
	shapeEditObj.type = type;
	shapeEditObj.property = property;
	shapeEditObj.prevValue = prevValue;
	shapeEditObj.newValue = newValue;
	shapeEditObj.prevValue2 = prevValue2;
	shapeEditObj.newValue2 = newValue2;
	return shapeEditObj;
};
template.prototype.createShapeBGImgURObj = function(elmObj,curriObj,previObj,elmId){
	var shapeBGObj = {};
	shapeBGObj.elmObj = elmObj;
	shapeBGObj.curriObj = curriObj;
	shapeBGObj.previObj = previObj;	
	shapeBGObj.elmId = elmId;
	return shapeBGObj;
};
template.prototype.createZoomTempURObj = function(currScale, prevScale){
	var zoomTempObj = {};
	zoomTempObj.currScale = currScale;
	zoomTempObj.prevScale = prevScale;
	return zoomTempObj;
};	
template.prototype.createRssOrWebUrlURObj = function(elmObj, currUrl, prevUrl, elmId, elmType){
	var rssOrWebUrlObj = {};
	rssOrWebUrlObj.elmObj = elmObj;
	rssOrWebUrlObj.currUrl = currUrl;
	rssOrWebUrlObj.prevUrl = prevUrl;
	rssOrWebUrlObj.elmId = elmId;
	rssOrWebUrlObj.elmType = elmType;	
	return rssOrWebUrlObj;
};
template.prototype.createMedRssDurURObj = function(elmObj, frameId, prevDur, currDur){
	var medRssDurObj = {};
	medRssDurObj.elmObj = elmObj;
	medRssDurObj.frameId = frameId;
	medRssDurObj.prevDur = prevDur;
	medRssDurObj.currDur = currDur;
	return medRssDurObj;
}
template.prototype.createInpSrcURObj = function(frameId, currInpSrcType, prevInpSrcType){
	var inpSrcObj = {};
	inpSrcObj.frameId = frameId;
	inpSrcObj.currInpSrcType = currInpSrcType;
	inpSrcObj.prevInpSrcType = prevInpSrcType;
	return inpSrcObj;
};
template.prototype.createMultiSelRotateURObj = function(undoRotationArr){
	var multiSelRotateObj = {};		
	multiSelRotateObj.multiSelElmArr = this.multiSelElmArr.slice();// create copy of array
	multiSelRotateObj.undoRotationArr = undoRotationArr;
	return multiSelRotateObj;
};
template.prototype.createMultiSelResizeURObj = function(undoRedoResizeArr){
	var multiSelResizeObj = {};
	multiSelResizeObj.multiSelElmArr = this.multiSelElmArr.slice();// create copy of array
	multiSelResizeObj.undoRedoResizeArr = undoRedoResizeArr;
	return multiSelResizeObj;
};
template.prototype.createMultiSelDeleteURObj = function(undoRedoDelArr, multiSelElmArr){
	var multiSelDelObj = {};
	multiSelDelObj.undoRedoDelArr = undoRedoDelArr;
	multiSelDelObj.multiSelElmArr = multiSelElmArr;
	return multiSelDelObj;
};

/*************** Push action and data in undo stack and redo stack **************************/
template.prototype.createUndoDataForAddElmOnMnFrm = function(elem){	
	var elmIndx = this.mainFrame.element.length-1;
	undoStackObj.push(this.createUndoRedoData(UndoRedo.ADD, this.createAddDelMnFrmElmURObj(elem, elmIndx, this.getMnFrmLayerArrIndex(elmIndx))));
    redoStackObj.clearStack();
};
template.prototype.createUndoRedoDataForTxtEdit = function(elmID, textObj, property, prevValue, currValue, name, prevValue2, prevValue3){
	if(prevValue==undefined || currValue==undefined || currValue == prevValue){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.TEXT_EDIT, this.createTextEditURObj(elmID, textObj, property, prevValue, currValue, name, prevValue2, prevValue3)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataForWthrEdit = function(selElmId, elmObj, name, prevValue, val, prevValue2, prevValue3){
	if(prevValue==undefined || val==undefined || val == prevValue){
		return;
	}    
    undoStackObj.push(this.createUndoRedoData(UndoRedo.WEATHER_EDIT, this.createWthrEditURObj(selElmId, elmObj, name, prevValue, val, prevValue2, prevValue3)));
	redoStackObj.clearStack();
};
template.prototype.createUndoDataForAddElmOnInrFrm = function(frame,elm,frameLen){	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.ADD_INNERFRAME_ELEMENT, this.createAddDelInrFrmElmURObj(frame,elm,frameLen)));
  	redoStackObj.clearStack();
};
template.prototype.createUndoDataForDelElmOnInrFrm=function(frame,elm,deletedIndex)
{
	undoStackObj.push(this.createUndoRedoData(UndoRedo.DEL_INNERFRAME_ELEMENT, this.createAddDelInrFrmElmURObj(frame,elm,deletedIndex)));
	redoStackObj.clearStack();
};
template.prototype.createUndoDataForReplcElmOnInrFrm = function(frame,newElm,replaceAllFlag){	
	var elmArr = frame.element.slice();// create copy of array
	undoStackObj.push(this.createUndoRedoData(UndoRedo.REPLACE_INNERFRAME_ELEMENT, this.createReplaceInrFrmElmURObj(frame,newElm,elmArr,replaceAllFlag)));
  	redoStackObj.clearStack();
};
template.prototype.createUndoDataForDelFrm = function(frameId){
	var isThisSelAudioFrm = false;
	if(frameId == this.selAudioFrm){
		isThisSelAudioFrm = true;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.DEL_FRAME, this.createDelFrameURObj(frameId,isThisSelAudioFrm)));
  	redoStackObj.clearStack();
};
template.prototype.createUndoDataForArrangFrm=function(frame,prevElmArr)
{
	var currElmArr = frame.element.slice();
	undoStackObj.push(this.createUndoRedoData(UndoRedo.ARRANGE_INNERFRAME_ELEMENT, this.createArrangeInrFrmElmURObj(frame,currElmArr, prevElmArr.slice())));
	redoStackObj.clearStack();
};
template.prototype.createUndoDataForAddDelBlnkFrm = function(frame,isAdd){	
	var innerFrameZOrder = this.getCurrZPosOfFrm(frame.id);		
	if(isAdd){
		undoStackObj.push(this.createUndoRedoData(UndoRedo.ADD_BLANKFRAME, this.createAddDelBlnkFrmURObj(frame,innerFrameZOrder)));	
	}else{
		undoStackObj.push(this.createUndoRedoData(UndoRedo.DEL_BLANKFRAME, this.createAddDelBlnkFrmURObj(frame,innerFrameZOrder)));	
	}	
  	redoStackObj.clearStack();
};
template.prototype.createUndoRedoDataForSwapFrames = function(frameId1, frameId2){	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.SWP_FRM, this.createSwapFrmURObj(frameId1, frameId2)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataForEditFrame = function(frame, newTransEffect, newDuration){	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.EDIT_FRAME, this.createEditFrmURObj(frame.id, newTransEffect, frame.transitionEffect, newDuration, frame.duration)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataForImageOpacity = function(frame, newOpacity){	
	if(newOpacity == this.prevOpacityValFrUndo){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.IMG_OPACITY, this.createImgOpctyURObj(frame.id, frame.activeEleIndex, newOpacity, this.prevOpacityValFrUndo)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataForResizeFrm = function(evnt, startPt,lineOfCtrl,gridLineRange){	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.RESIZE_FRAME, this.createResizeFrmURObj(evnt, startPt, lineOfCtrl,gridLineRange)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataForResizeBlankFrm=function(frameId, startPtObj,endPtObj, isDrag){
	var operation = UndoRedo.RESIZE_BLANKFRAME;
	if(isDrag){
		operation = UndoRedo.DRAG_BLANKFRAME;
	}
	undoStackObj.push(this.createUndoRedoData(operation, this.createResizeBlnkFrmURObj(frameId, startPtObj, endPtObj)));
    redoStackObj.clearStack();
};
template.prototype.createUndoRedoDataFrRotateInrFrmElm = function(frameId, elmObj,startAngle,angle){	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.ROTATE_INNERFRAME_ELEMENT, this.createRotateInrFrmElmURObj(frameId, elmObj,startAngle,angle)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataFrRotateMnOrBlnkFrmElm = function(elmId,elmObj,startAngle,angle,isBlnkFrmRotate){	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.ROTATE_MAINFRAME_ELEMENT, this.createRotateMnOrBlnkFrmElmURObj(elmId,elmObj,startAngle,angle,isBlnkFrmRotate)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataCropElm = function(redoCropDim, undoCropDim, elmIndx){	
	if(redoCropDim.xOffset == undoCropDim.xOffset && redoCropDim.yOffset == undoCropDim.yOffset && redoCropDim.scale == undoCropDim.scale){
		return;
	}	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.CROP, this.createCropElmURObj(redoCropDim, undoCropDim, elmIndx)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataCropShapes = function(redoCropDim, undoCropDim, elmObj, selElmId){	
	if(redoCropDim.xOffset == undoCropDim.xOffset && redoCropDim.yOffset == undoCropDim.yOffset && redoCropDim.scale == undoCropDim.scale){
		return;
	}	
	undoStackObj.push(this.createUndoRedoData(UndoRedo.CROP_SHAPES, this.createCropShapesURObj(redoCropDim, undoCropDim, elmObj, selElmId)));
    redoStackObj.clearStack(); 
};
template.prototype.createUndoRedoDataFrTmpltBg = function(bgColor, bgImage, isClrChanged){    
    bgColor = this.removeAllSpaces(bgColor);
    var prevBgColor = this.removeAllSpaces(templateObj.bgColor);
    if(isClrChanged && prevBgColor == bgColor){
        return;
    }
    if(!isClrChanged && templateObj.bgImage == bgImage){
        return;
    }
    undoStackObj.push(templateObj.createUndoRedoData(UndoRedo.TEMPLATE_BG, templateObj.createTemplateBGURObj(prevBgColor,templateObj.bgImage,bgColor,bgImage)));
	redoStackObj.clearStack();
};
template.prototype.removeAllSpaces = function(val){
    if(val == null || val == ""){
        return val;
    }
    return val.trim().replace(/ /g,"");
}
template.prototype.createUndoRedoDataFrHndWrtgUpdate = function(elmIndex, divId, currPath, prevPath){    
	if(currPath == prevPath){
		return;
	}
    undoStackObj.push(templateObj.createUndoRedoData(UndoRedo.HW_UPDATE, templateObj.createHndWrtgUpdateURObj(elmIndex, divId, currPath, prevPath)));                     
	redoStackObj.clearStack();
};
template.prototype.createUndoRedoDataFrEditShapes = function(selElmId, elmObj, type, name, prevValue, val, prevValue2, newValue2){
	if(prevValue == val){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.SHAPES_EDIT, this.createShapeEditURObj(selElmId, elmObj, type, name, prevValue, val, prevValue2, newValue2)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrShapeBGImg = function(elmObj,curriObj,previObj,elmId){
	undoStackObj.push(this.createUndoRedoData(UndoRedo.SHAPES_BG, this.createShapeBGImgURObj(elmObj,curriObj,previObj,elmId)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrZoom = function(currScale, prevScale){
	if(currScale == prevScale){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.ZOOM_TEMPLATE, this.createZoomTempURObj(currScale, prevScale)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrRssOrWebUrl = function(elmObj, currUrl, prevUrl, elmId, elmType){
	if(currUrl == prevUrl){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.RSS_WEB_URL, this.createRssOrWebUrlURObj(elmObj, currUrl, prevUrl, elmId, elmType)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataForMedRssDur = function(elmObj, frameId, prevDur, currDur){
	if(prevDur == currDur){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.MEDIA_RSS_RELOAD_DUR, this.createMedRssDurURObj(elmObj, frameId, prevDur, currDur)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrInpSrc = function(frameId, currInpSrcType, prevInpSrcType){
	if(currInpSrcType == prevInpSrcType){
		return;
	}
	undoStackObj.push(this.createUndoRedoData(UndoRedo.INPUT_SRC, this.createInpSrcURObj(frameId, currInpSrcType, prevInpSrcType)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrMultiSelRotate = function(undoRotationArr){
	undoStackObj.push(this.createUndoRedoData(UndoRedo.MULTI_SEL_ROT, this.createMultiSelRotateURObj(undoRotationArr)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrMultiSelResize = function(undoRedoResizeArr){
	undoStackObj.push(this.createUndoRedoData(UndoRedo.MULTI_SEL_RESIZE, this.createMultiSelResizeURObj(undoRedoResizeArr)));
	redoStackObj.clearStack();
}
template.prototype.createUndoRedoDataFrMultiSelDel = function(undoRedoDelArr, multiSelElmArr){
    undoStackObj.push(this.createUndoRedoData(UndoRedo.MULTI_SEL_DEL, this.createMultiSelDeleteURObj(undoRedoDelArr, multiSelElmArr)));
    redoStackObj.clearStack();
}

/*******************************************************/
var prevShapeValue="";
var prevShapeValue2="";
template.prototype.getShapeYcpDetailsFrUndo=function(isTouchStart,elmID,ypIndx){
	var elmType=this.mainFrameSelElmObj.elementType;
	switch(elmType)
	{
		case shapeInfo.TRI:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.ApexRatio;	
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "ApexRatio", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.ApexRatio);
			}			         
		break;
		case shapeInfo.RECT:			
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.FigureRoundRatio;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "FigureRoundRatio", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.FigureRoundRatio);
			}
		break;
		case shapeInfo.FRAME:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.FrameWidth;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "FrameWidth", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.FrameWidth);
			}
		break;
		case shapeInfo.DONUT:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.DonutWidth;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "DonutWidth", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.DonutWidth);
			}			
		break;
		case shapeInfo.HEXAGN:
		case shapeInfo.OCTAGN:	
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.PolygonWidth;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "PolygonWidth", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.PolygonWidth);
			}
		break;		
		case shapeInfo.CROSS:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.BarWidth;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "BarWidth", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.BarWidth);
			}
		break;
		case shapeInfo.TRPZOID:
		case shapeInfo.PARLGRM:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.Slope;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "Slope", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.Slope);
			}
		break;
		case shapeInfo.STAR:
		case shapeInfo.STAR24P:	
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.StartWidth;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "StartWidth", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.StartWidth);
			}
		break;
		case shapeInfo.SUN:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.EllipseSize;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "EllipseSize", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.EllipseSize);
			}
		break;
		case shapeInfo.FOLDEDCOR:
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.FoldedRatio;
			}else{
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "FoldedRatio", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.FoldedRatio);
			}
		break;
		case shapeInfo.ONESDEARROW:
		case shapeInfo.TWOSDEARROW:			
			if(isTouchStart){
				prevShapeValue = this.mainFrameSelElmObj.shapeDetails.ArrowHeadLength;
				prevShapeValue2 = this.mainFrameSelElmObj.shapeDetails.ArrowBodyWidth;
			}else{
				var currShapeValue = this.mainFrameSelElmObj.shapeDetails.ArrowHeadLength;
				var currShapeValue2 = this.mainFrameSelElmObj.shapeDetails.ArrowBodyWidth;
				this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "ArrowHeadLength", prevShapeValue, currShapeValue,prevShapeValue2, currShapeValue2);
			}
		break;
		case shapeInfo.LEFTBRACE:
		case shapeInfo.RIGHTBRACE:
			if(isTouchStart){
				if(ypIndx==0){
					prevShapeValue = this.mainFrameSelElmObj.shapeDetails.VertexPosition;
				}else{
					prevShapeValue = this.mainFrameSelElmObj.shapeDetails.RoundCornerRatio;
				}
			}else{
				if(ypIndx==0){
					this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "VertexPosition", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.VertexPosition);					
				}else{
					this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "RoundCornerRatio", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.RoundCornerRatio);
				}				
			}
		break;		
		case shapeInfo.WAVE:
			if(isTouchStart){
				if(ypIndx==0){
					prevShapeValue = this.mainFrameSelElmObj.shapeDetails.CurvedRatio;
				}else{
					prevShapeValue = this.mainFrameSelElmObj.shapeDetails.HorizontalSlope;
				}
			}else{
				if(ypIndx==0){				
					this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "CurvedRatio", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.CurvedRatio);					
				}else{
					this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "HorizontalSlope", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.HorizontalSlope);
				}				
			}		
		break;
		case shapeInfo.ARC:
            if(isTouchStart){
				if(ypIndx==0){
					prevShapeValue = this.mainFrameSelElmObj.shapeDetails.StartAngle;
				}else{
					prevShapeValue = this.mainFrameSelElmObj.shapeDetails.EndAngle;
				}
			}else{
                if(ypIndx==0){
                    this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "StartAngle", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.StartAngle);
                }else{
                    this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "EndAngle", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.EndAngle);
                }
            }
		break;
		case shapeInfo.RECTCAL:
            if(isTouchStart){
                if(ypIndx==1){
                    prevShapeValue = this.getRectCalObjFrUndo();
                }else{
                    prevShapeValue = this.mainFrameSelElmObj.shapeDetails.FigureRoundRatio;
                }
            }else{
                if(ypIndx==1){
                    var currShapeValue = this.getRectCalObjFrUndo();
                    this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "CalloutPoint", prevShapeValue, currShapeValue);
                }else{
                    this.createUndoRedoDataFrEditShapes(elmID, this.mainFrameSelElmObj, elmType, "FigureRoundRatio", prevShapeValue, this.mainFrameSelElmObj.shapeDetails.FigureRoundRatio);
                }
            }
        break;
		default:
		break;
	}
};
template.prototype.getRectCalObjFrUndo=function(){
    var tempObj = this.mainFrameSelElmObj;
    var shapeDetailsObj = tempObj.shapeDetails;
    var calloutPoint = jQuery.extend({},tempObj.shapeDetails.CalloutPoint);// need to create a copy of object
    var innerRect = jQuery.extend({},tempObj.shapeDetails.InnerRect);// need to create a copy of object
    var rectCalObj = {elmX:tempObj.x, elmY:tempObj.y, elmW:tempObj.w, elmH:tempObj.h, CalloutPoint:calloutPoint, InnerRect:innerRect};
    return rectCalObj;
};
template.prototype.addMultiSelDataFrUndoRedo = function(undoRedoMultiSelDataArr, preRotation, rotation, preXArr, preYArr, currXArr, currYArr){
	undoRedoMultiSelDataArr.push({
            preRotation: preRotation,
            currRotation: rotation,
	        preXArr:preXArr,
    		preYArr:preYArr,
    		currXArr:currXArr,
    		currYArr:currYArr
		});
};
template.prototype.enableUndoRedoIcon=function(isUndo, enable){
    var iconDiv = $('#redoBtnId');
    if(isUndo){
        iconDiv = $('#undoBtnId');
    }
    if(enable){
        iconDiv.removeClass('icon-disabled');
    }else{
        iconDiv.addClass('icon-disabled');
    }
};
