define('Arc', ['Shape'], function (Shape) {/* define module names 'RectangularCallout' with the dependency shape[AMD]*/
	'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {},Shape.default, options);  /* adds default properties of shapes*/    
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails);
                var context = Shape.context;
                this.drawOutline(prop);
                var $this = this;   
                Shape.fillImage(prop,true).done(function(value) {/*fills background image for shape*/
                    $this.drawOutline(prop,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/
                });    
                return d.promise();
            },
         drawOutline : function (prop, composite){/*to draw shape*/
                var context = Shape.context;
                var w = Shape.width,
                h = Shape.height,
                context = Shape.context,
                centreX=w/2, centreY=h/2,
		        radius = centreX,
		        radiusH = centreY,
			    yellwPerstart = 50, yellwPerEnd = 270,/*defaults*/
		        startAngle = prop.shapeDetails.StartAngle * (Math.PI / 180),//Converted to radian
		        endAngle = prop.shapeDetails.EndAngle * (Math.PI / 180),
		        canvasMargin = Shape.canvasMargin/2,
		        counterClockwise = false;
		        if (startAngle == endAngle) {
                    startAngle = 0;
                    endAngle = 2 * Math.PI;
                }
		        Shape.resetAlpha(composite);
		        context.beginPath();
		        context.ellipse(centreX+canvasMargin, centreY+canvasMargin, radius,radiusH,2*Math.PI, startAngle, endAngle,counterClockwise );
                Shape.drawStroke(prop);/* draws above lines/paths on canvas*/
               
         }
     };
});