define('Arrow', ['Shape'], function (Shape) {
    'use strict';
    var prop = {};
    return {
        draw: function (options) {
            prop = $.extend(true, {}, Shape.default, options);
            Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
            var context = Shape.context;
            var d = new $.Deferred();
            var $this = this;
            switch (prop.shapeDetails.elementName) {
            case 0:
                var callback = this.drawOneWayArrow(context, false);
                Shape.fillImage(prop).done(function (value) {
                    $this.drawOneWayArrow(context, true);
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });
                return d.promise();
            case 4:
                var callback = this.drawTwoWayArrow(context, false);
                Shape.fillImage(prop).done(function (value) {
                    $this.drawTwoWayArrow(context, true);
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });
                return d.promise();
            default:
                break;
            }
        },
        drawOneWayArrow: function (context, composite) {
	       
	        var canvasMargin = Shape.canvasMargin/2;
            var width = Shape.width;
            var height = Shape.height;
            var cnvsHhlf = (height / 2);
            var headerlength = prop.shapeDetails.ArrowHeadLength;
            var bodyWidth = prop.shapeDetails.ArrowBodyWidth;
            var pX = (width - ((width) * (headerlength / 100)));
            var pY = (cnvsHhlf - ((height/2) * (bodyWidth / 100))) ;
            Shape.resetAlpha(composite);
            width+=canvasMargin;
            pX+=canvasMargin;
            pY+=canvasMargin;
		    context.beginPath();
            context.moveTo(width, height/2+canvasMargin);
            context.lineTo(pX, canvasMargin);
            context.lineTo(pX, pY);
		    context.lineTo(canvasMargin, pY);
            context.lineTo(canvasMargin, height - pY+2*canvasMargin);
            context.lineTo(pX, height - pY+2*canvasMargin);
            context.lineTo(pX, height+canvasMargin);
            context.closePath();
			Shape.drawStroke(prop, composite);
        },
        drawTwoWayArrow: function (context, composite) {
            var canvasMargin = Shape.canvasMargin/2;
            var width = Shape.width;
            var height = Shape.height;
            var cnvsHhlf = (height / 2);
            var headerlength = prop.shapeDetails.ArrowHeadLength;
            var bodyWidth = prop.shapeDetails.ArrowBodyWidth;
            var pX = (((width / 2) * (headerlength / 100)));
            var pY =cnvsHhlf-((((height) * (bodyWidth / 100)) / 2) ) ;
            Shape.resetAlpha(composite);
            context.beginPath();
            context.moveTo(canvasMargin, height/2+canvasMargin);
            context.lineTo(pX+canvasMargin,canvasMargin);
            context.lineTo(pX+canvasMargin, pY+canvasMargin);
            context.lineTo(width - pX+canvasMargin, pY+canvasMargin);
            context.lineTo(width - pX+canvasMargin, canvasMargin);
            context.lineTo(width+canvasMargin, cnvsHhlf+canvasMargin);
            context.lineTo(width - pX+canvasMargin, height+canvasMargin);
            context.lineTo(width - pX+canvasMargin, height - pY+canvasMargin);
            context.lineTo(pX+canvasMargin, height - pY+canvasMargin);
            context.lineTo(pX+canvasMargin, height+canvasMargin);
			context.closePath();
          
            Shape.drawStroke(prop, composite);
        }
    };
});