/* var shape="Brace";
   
     var elemObj={w:500,h:500,shapeDetails:{typeName:"Figure brace",LineColor : "rgba(178,111,111,1)",FigureStrokeWidth :3,FigureStrokePattern :0,imgSrc:'', FillColor:'rgba(0,0,0,0)',elementName:0,VertexPosition:0,RoundCornerRatio:100}};*/
define('Brace', ['Shape'], function (Shape) {
    'use strict';
    var prop = {};
    return {
        draw: function (options) {
            prop = $.extend(true, {}, Shape.default, options);
            Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
            var context = Shape.context;
            var d = new $.Deferred();
            var $this = this;
            switch (prop.shapeDetails.elementName) {
            case 0:
                var callback = this.drawRightBrace(context, false);
                Shape.fillImage(prop).done(function (value) {
                    $this.drawRightBrace(context, true);
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });
                return d.promise();
                break;
            case 1:
             var callback = this.drawLeftBrace(context, false);
                Shape.fillImage(prop).done(function (value) {
                    $this.drawLeftBrace(context, true);
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });
                return d.promise();
                break;
               
            default:
                break;
            }
        }
        , drawRightBrace: function (context, composite) {
			var width = Shape.width;
            var height = Shape.height;
            var rRatio = prop.shapeDetails.RoundCornerRatio;
            var vPos = prop.shapeDetails.VertexPosition;
            var pX = width / 4;
            var shX = width / 2;
            var qcendPoint1 = height / 4;
            var qcendPointPerc1 = (qcendPoint1 * (rRatio / 100));
            var lendPoint1 = (height / 4) + (qcendPoint1 - qcendPointPerc1);
            var qcendPoint2 = height / 4;
            var qcendPointPerc2 = (qcendPoint2 * (rRatio / 100));
            var lendPoint2 = (height - qcendPointPerc2);
            var shY = height * (vPos / 100);
            
           if (vPos < 50) {
                shY = height * (vPos / 100);
                var temprRatio = 2 * vPos;
                var roundRatio = rRatio < temprRatio ? rRatio : temprRatio;
                qcendPointPerc1 = (qcendPoint1 * (roundRatio / 100));
                if (rRatio <= temprRatio) lendPoint1 = (shY) - (qcendPointPerc1);
                else lendPoint1 = qcendPointPerc1;
                qcendPointPerc2 = (qcendPoint2 * (roundRatio / 100));
                lendPoint2 = (height - qcendPointPerc2);
            }
            else {
                if (vPos > 50) {
                    var temprRatio = 100 - vPos;
                    var roundRatio = rRatio < temprRatio ? rRatio : temprRatio;
                    qcendPointPerc2 = (qcendPoint2 * (roundRatio / 100));
                    if (rRatio <= temprRatio) lendPoint2 = height - (qcendPointPerc2);
                    else lendPoint2 = (shY + qcendPointPerc2);
                    qcendPointPerc1 = (qcendPoint1 * (roundRatio / 100));
                    lendPoint1 = shY - qcendPointPerc1;
                }
            }

            Shape.resetAlpha(composite);
			var canvasMargin = Shape.canvasMargin/2;
            context.beginPath();
            context.lineJoin = "round";
			
            context.moveTo(canvasMargin, canvasMargin);
			shX = shX + canvasMargin;
			shY = shY + canvasMargin;
			width = width + canvasMargin;
			height = height + canvasMargin;
			
            context.quadraticCurveTo(shX, canvasMargin, shX, qcendPointPerc1 + canvasMargin );						
            context.lineTo(shX, lendPoint1 + canvasMargin);
						
           context.quadraticCurveTo(shX, shY, width, shY);
          
           context.quadraticCurveTo(shX, shY , shX, (shY + qcendPointPerc2));
           context.lineTo(shX, lendPoint2 + canvasMargin);
           context.quadraticCurveTo(shX, height, canvasMargin, height);
           Shape.drawStroke(prop, composite);
        }
        , drawLeftBrace: function (context, composite) {
            var width = Shape.width;
            var height = Shape.height;
            var rRatio = prop.shapeDetails.RoundCornerRatio;
            var vPos = prop.shapeDetails.VertexPosition;
            var pX = width / 4;
            var shX = width / 2;
            var qcendPoint1 = height / 4;
            var qcendPointPerc1 = (qcendPoint1 * (rRatio / 100));
            var lendPoint1 = (height / 4) + (qcendPoint1 - qcendPointPerc1);
            var qcendPoint2 = height / 4;
            var qcendPointPerc2 = (qcendPoint2 * (rRatio / 100));
            var lendPoint2 = (height - qcendPointPerc2);
            var shY = height * (vPos / 100);
            if (vPos == 50) qcendPointPerc1 = qcendPointPerc1;
            if (vPos < 50) {
                shY = height * (vPos / 100);
                var temprRatio = 2 * vPos;
                var roundRatio = rRatio < temprRatio ? rRatio : temprRatio;
                qcendPointPerc1 = (qcendPoint1 * (roundRatio / 100));
                if (rRatio <= temprRatio) lendPoint1 = (shY) - (qcendPointPerc1);
                else lendPoint1 = qcendPointPerc1;
                qcendPointPerc2 = (qcendPoint2 * (roundRatio / 100));
                lendPoint2 = (height - qcendPointPerc2);
            }
            else {
                if (vPos > 50) {
                    var temprRatio = 100 - vPos;
                    var roundRatio = rRatio < temprRatio ? rRatio : temprRatio;
                    qcendPointPerc2 = (qcendPoint2 * (roundRatio / 100));
                    if (rRatio <= temprRatio) lendPoint2 = height - (qcendPointPerc2);
                    else lendPoint2 = (shY + qcendPointPerc2);
                    qcendPointPerc1 = (qcendPoint1 * (roundRatio / 100));
                    lendPoint1 = shY - qcendPointPerc1;
                }
            }

			var canvasMargin = Shape.canvasMargin/2;
			shX = shX + canvasMargin;
			shY = shY + canvasMargin;
			width = width+canvasMargin;
			height = height+canvasMargin;
			Shape.resetAlpha(composite);
            context.beginPath();
            context.lineJoin = "round";
            context.moveTo(width, canvasMargin);
            context.quadraticCurveTo(shX, canvasMargin, shX, qcendPointPerc1+canvasMargin);
            context.lineTo(shX, lendPoint1+canvasMargin);
            context.quadraticCurveTo(shX, shY, canvasMargin, shY);
            context.quadraticCurveTo(canvasMargin, shY, canvasMargin, shY);
            context.quadraticCurveTo(shX, shY, shX, (shY + qcendPointPerc2));
            context.lineTo(shX, lendPoint2+canvasMargin);
            context.quadraticCurveTo(shX, height, width, height);
            //context.closePath();
            Shape.drawStroke(prop, composite);
        }
    };
});