define('Cross', ['Shape'], function (Shape) {/* define module names 'cross' with the dependency shape[AMD]*/
	'use strict'; /* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {},Shape.default, options); /* adds default properties of shapes*/ 
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                this.drawOutline(prop);
                var $this = this;   
                
                 Shape.fillImage(prop).done(function(value) {/*fills background image for shape*/
                     
                    $this.drawOutline(prop,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/
                     
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/
                });    
                return d.promise();
            },
         drawOutline : function (prop, composite){ /*draws shape*/
                var context = Shape.context;                
                var w = Shape.width;
                var h = Shape.height;
                var context = Shape.context;
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
                var lineWidthCalc=borderWidth*50/100;
                Shape.resetAlpha(composite);
                context.beginPath();//starts canvas drawing
                var canvasMargin = Shape.canvasMargin/2;
				var perc = 100-prop.shapeDetails.BarWidth, perc1 = w/2, perc2 = h/2; //yellow point for shape
				var ratio;
				var ratioH;
				if (w >= h) {
				    ratio  = perc1 - ((perc / 100) * (h * 0.5));

                    ratioH = perc2 - ((perc / 100) * (h * 0.5));
				} else {
                    ratio  = perc1 - ((perc / 100) * (w * 0.5));

                    ratioH = perc2 - ((perc / 100) * (w * 0.5));
				}
				var val = w/2+canvasMargin;
				var valH = h/2+canvasMargin;
			    context.moveTo(val-ratio,canvasMargin);//1
				context.lineTo(val+ratio,canvasMargin);//2
				context.lineTo(val+ratio,valH-ratioH);//3
				context.lineTo(w+canvasMargin,valH-ratioH);//4
				context.lineTo(w+canvasMargin,valH+ratioH);//5
				context.lineTo(val+ratio,valH+ratioH);//6
				context.lineTo(val+ratio,h+canvasMargin);//7
				context.lineTo(val-ratio,h+canvasMargin);//8
				context.lineTo(val-ratio,valH+ratioH);//9
				context.lineTo(canvasMargin,valH+ratioH);//10
				context.lineTo(canvasMargin,valH-ratioH);//11
				context.lineTo( val-ratio,valH-ratioH);//12
				context.lineTo( val-ratio,canvasMargin);//13
                context.closePath();
                Shape.drawStroke(prop);/*draws above lines/paths on canvas*/
               
         }
     };
});