define('Diamond', ['Shape'], function (Shape) {/* define module names 'diamond' with the dependency shape[AMD]*/
	'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {},Shape.default, options);   /* adds default properties of shapes*/ 
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                this.drawOutline(prop);
                var $this = this;   
                 Shape.fillImage(prop).done(function(value) {/*fills background image for shape*/
                    $this.drawOutline(prop,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/
                });    
                return d.promise();
            },
         drawOutline : function (prop, composite){/*draws shape*/
                var context = Shape.context;
                context.globalAlpha=1;
                if(composite){
                    context.globalCompositeOperation = "source-over"; 
                 }
                var w = Shape.width;
                var h = Shape.height;
                var context = Shape.context;
				var canvasMargin = Shape.canvasMargin/2;
				context.beginPath();
				context.moveTo(w / 2+canvasMargin, canvasMargin);
				context.lineTo(w+canvasMargin, h/2+canvasMargin);
				context.lineTo(w/2+canvasMargin, h+canvasMargin);
				context.lineTo(canvasMargin, h / 2+canvasMargin);
				context.closePath();
			    Shape.drawStroke(prop);// draws above lines/paths on canvas
         }
     };
});