define('Donut', ['Shape'], function (Shape) {
     var prop ={};
     return {
         draw : function (options){
                prop = $.extend(true, {},Shape.default, options);
                arcWidth = arcWidth<=0?1:(arcWidth>50?50:arcWidth);
                var d = $.Deferred();
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                var context = Shape.context,
					width = Shape.width,
					height = Shape.height,
					r = Shape.width/2,
					arcWidth = Math.round(width*(prop.shapeDetails.DonutWidth)/100),
					arcHeight = Math.round(height*(prop.shapeDetails.DonutWidth)/100),
					radiusX = (width)/2-arcWidth,
					radiusY = (height)/2-arcHeight,
					canvasMargin = Shape.canvasMargin/2;
					
				radiusX = radiusX<0?0:radiusX;
				radiusY = radiusY<0?0:radiusY;
				context.beginPath();
                context.ellipse(width/2+canvasMargin, height/2+canvasMargin, (width)/2, (height)/2, 0 * Math.PI/180, 0, 2 * Math.PI, false);
                context.ellipse(width/2+canvasMargin, height/2+canvasMargin, radiusX, radiusY, 0 * Math.PI/180, 0, 2 * Math.PI, true);
                var $this = this;
                Shape.fillImage(prop).done(function(value) {
                    context.globalAlpha=1;
                    context.globalCompositeOperation = "source-over"; 
                    context.beginPath();
                   	context.ellipse(width/2+canvasMargin, height/2+canvasMargin, (width-0)/2, (height-0)/2, 0 * Math.PI/180, 0, 2 * Math.PI, false);
                    Shape.drawStroke(prop);
                    context.closePath();
					//context.globalCompositeOperation = "source-over"; 
                    var majorAxisRadius =  width/2-arcWidth < 0 ? 0:width/2-arcWidth;
                    var minorAxisRadius =  height/2-arcHeight < 0 ? 0:height/2-arcHeight;
                    context.beginPath();
                    context.ellipse(width/2+canvasMargin, height/2+canvasMargin, majorAxisRadius, minorAxisRadius, 0 * Math.PI/180, 0, 2 * Math.PI, false);

                    context.closePath();
                    Shape.drawStroke(prop);
					
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                }).fail(function() {
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });    
                
             return d.promise();
        }
     };
});