/*
      var shape="FoldedCorner";
   
      var elemObj={w:500,h:480,shapeDetails:{typeName:"Figure FoldedCorner",LineColor : "rgba(178,111,111,1)",FigureStrokeWidth :3,FigureStrokePattern : 0,imgSrc:'image.jpg', FillColor:'#EEFFFF',FoldedRatio:88}};
       require([shape],function(shape)
           {
        shape.draw(elemObj).then(function(val){
             $('#strImg').css({'width':'500px', 'height':'480px'}).attr('src', val);
        });
    });   */
define('FoldedCorner', ['Shape'], function (Shape) {
    'use strict';
    var prop = {};
    return {
        draw: function (options) {
            prop = $.extend(true, {}, Shape.default, options);
            var d = $.Deferred();
            Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
            var context = Shape.context;
            var $this = this;
            this.drawFolderCorner(context, false);
            Shape.fillImage(prop).done(function (value) {
                $this.drawFolderCorner(context, true);
                d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
            }).fail(function () {
                console.error("Drawing failed");
            });
            return d.promise();
        }
        , drawFolderCorner: function (context, composite) {
              Shape.context.globalAlpha = 1;
			var canvasMargin = Shape.canvasMargin/2;
            var width = Shape.width;
            var height = Shape.height;
            if(prop.shapeDetails.FoldedRatio>100){
                prop.shapeDetails.FoldedRatio = 100;
            }
            prop.shapeDetails.FoldedRatio = Math.round(prop.shapeDetails.FoldedRatio);
            var scale = height > width ? width : height;

            var fRatio = (scale / 2) * ((100-prop.shapeDetails.FoldedRatio) / 100);

            var slope=Math.round(fRatio*0.20);
            if (composite) {
                context.globalCompositeOperation = "source-over";
            }
            context.beginPath();
            context.lineJoin='square';
			width+=canvasMargin;
			height+=canvasMargin;

            context.moveTo(width - fRatio, height);
            context.lineTo(width - fRatio+slope, height - fRatio+slope);
            context.lineTo(width, height - fRatio);
            context.lineTo(width - fRatio, height);
            context.lineTo(canvasMargin, height);
            context.lineTo(canvasMargin, canvasMargin);
            context.lineTo(width, canvasMargin);
            context.lineTo(width, height - fRatio);
            context.closePath();
            context.lineJoin='bevel';
            Shape.drawStroke(prop, composite);
        }
    };
});