define('Frame', ['Shape'], function (Shape) {
    'use strict';
     var prop = {};
     return {
         draw : function (options){
                prop = $.extend(true, {},Shape.default, options);
                var d = new $.Deferred();
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                if(prop.shapeDetails.FillRange==0 ){
                    this.drawOutline(prop,true,'');
                }
               	var context = Shape.context;
                var frameWidth = (prop.shapeDetails.FrameWidth<=0 ? 1 : (prop.shapeDetails.FrameWidth>100 ? 100:prop.shapeDetails.FrameWidth));
				var canvasMargin = Shape.canvasMargin/2;
                var $this = this;
                Shape.fillImage(prop).done(function(value) {
                    var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth)/2;
                    var height = Shape.height;
                    var width = Shape.width;
					
                    if(Shape.width>Shape.height){
                        frameWidth =   Shape.height/2*frameWidth/100;
                    }else{
                        frameWidth =   Shape.width/2*frameWidth/100;
                    }
					frameWidth = Math.round(frameWidth);
                    if(prop.shapeDetails.FillRange==1 ){
                        if(prop.thumbPath!=""){
                            context.globalAlpha = 1;
                        }
                        Shape.context.globalCompositeOperation = "destination-in";
                        Shape.context.fillRect(frameWidth+canvasMargin, frameWidth+canvasMargin,width-2*frameWidth, height-2*frameWidth);
                        Shape.context.fill();
                    }else{
                        Shape.context.clearRect(frameWidth+canvasMargin,frameWidth+canvasMargin,Shape.width-frameWidth*2,Shape.height-frameWidth*2);
                    }
                    $this.drawRectOutline(context,width,height,canvasMargin,'source-over',canvasMargin);
                    $this.drawRectOutline(context,Shape.width-frameWidth*2,Shape.height-frameWidth*2,canvasMargin,'source-over', frameWidth+canvasMargin);
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                  
                }).fail(function() {
                    console.log( "Drawing failed" );
                });  
                return d.promise();
            },
         	drawOutline : function (prop, borderFlag, composite){
				var canvasMargin = Shape.canvasMargin/2;
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth)/2;
                var height = Shape.height;
                var width = Shape.width;
                var frameWidth;
                if(Shape.width>Shape.height){
                    frameWidth =   height/2*(prop.shapeDetails.FrameWidth)/100;
                }else{
                    frameWidth =   width/2*(prop.shapeDetails.FrameWidth)/100;
                }
                var context = Shape.context;
                Shape.resetAlpha(composite);
              if(prop.shapeDetails.FillRange==1 ){
              	this.drawRectOutline(context,width,height,borderWidth,'source-in',canvasMargin);
              }else{
              	this.drawRectOutline(context,width,height,borderWidth,'', canvasMargin);
              }
          },
         drawRectOutline:function(context,width,height,borderWidth,composite, margin){
            Shape.resetAlpha(composite); 
		    context.beginPath();
            context.moveTo(margin,margin);
            context.lineTo(margin,height+margin);
            context.lineTo(width+margin,height+margin);
            context.lineTo(width+margin,margin);
            context.closePath();
            Shape.drawStroke(prop); 
         }
     };
});