define('ParallGram', ['Shape'], function (Shape) {
     var prop ={};
     return {
         draw : function (options){
                prop = $.extend(true, {},Shape.default, options);
                var d = new $.Deferred();
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                this.drawOutline(prop, false);
                var $this = this;
                Shape.fillImage(prop).done(function(value) {
                    if(prop.shapeDetails.FillRange==1){
                        $this.drawOutline(prop,true,'source-over');    
                    }else{
                        $this.drawOutline(prop,true,'');    
                    }
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                }); 
                return d.promise();
            },
          drawOutline : function (prop, drawBorder,composite){
                var context = Shape.context;
                context.globalAlpha = 1;
                if(composite){
                    context.globalCompositeOperation = "source-over"; 
                 }
                var borderWidth = 0;
				if(drawBorder){
					borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth)/2;
				}else{
					borderWidth = 2;
				}
								
                context.beginPath();
                slope = Shape.width*prop.shapeDetails.Slope/100;
                var canvasMargin = Shape.canvasMargin/2;
                var width = Shape.width+canvasMargin;
				var height = Shape.height+canvasMargin;
				
				context.moveTo(slope+canvasMargin, canvasMargin);    
                context.lineTo(canvasMargin, height);
                context.lineTo(width-slope, height);   
                context.lineTo(width, canvasMargin);
                context.closePath();
                //context.stroke();
				if(drawBorder){
					Shape.drawStroke(prop);	
				}
                
         }
     };
});
