define('Polygons', ['Shape'], function (Shape) {/* define module names 'Polygons' with the dependency shape[AMD]*/
	'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
   
                prop = $.extend(true, {},Shape.default, options); /* adds default properties of shapes*/   
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                var type = prop.shapeDetails.elementName;
                this.drawOutline(prop,'',type);
                var $this = this;   
                 Shape.fillImage(prop).done(function(value) {/*fills background image for shape*/
                     
                    $this.drawOutline(prop,'source-over',type);/*for drawing border separately over shape to get rid of opacity issue with border*/
                     
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/
                });    
                return d.promise();
            },
         drawOutline : function (prop, composite,type){ /*draws shape*/
         	//to draw shape
                var context = Shape.context;
                var w = Shape.width;
                var h = Shape.height;
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
                var canvasMargin = Shape.canvasMargin/2;
                var lineWCalc=borderWidth*50/100;
                var lineWCalc1=borderWidth*52/100;
                var yellowPoint=Math.round(prop.shapeDetails.PolygonWidth);
                Shape.resetAlpha(composite);
                context.beginPath();
				  switch(type){
				    case 0:/*pentagon*/
						 context.moveTo(w/2+canvasMargin,canvasMargin);// 
						 context.lineTo(w+canvasMargin,h*5/12+canvasMargin);//2 
						 context.lineTo(w*11/14+w/28+canvasMargin,h+canvasMargin);//3 
						 context.lineTo(w*3/14-w/28+canvasMargin,h+canvasMargin);//4
						 context.lineTo(canvasMargin,h*5/12+canvasMargin);//5
						 context.lineTo(w/2+canvasMargin,canvasMargin);
						
				     break;
					
				  case 1: /*hexagon*/
				          
						  var val=(w/2);
						  var ratio=yellowPoint/100*val;
						  context.moveTo(w/2-ratio+canvasMargin,canvasMargin); //1
						  context.lineTo(w/2+ratio+canvasMargin,canvasMargin);//2 
						  context.lineTo(w+canvasMargin,h/2+canvasMargin);//3 
						  context.lineTo(w/2+ratio+canvasMargin,h+canvasMargin);//4
						  context.lineTo(w/2-ratio+canvasMargin,h+canvasMargin);//5 
						  context.lineTo(canvasMargin,h/2+canvasMargin);//6	
						  context.lineTo(w/2+canvasMargin-ratio,canvasMargin); //1//7
						 
				     break;
				    case 3: /*octagon*/
				          var val=w/2;var valH=h/2;
						  var ratio=(yellowPoint/100)*val; 
						  var ratioH=(yellowPoint/100)*valH;
						  context.moveTo(w/2-ratio+canvasMargin,canvasMargin); //1 
						  context.lineTo(w/2+ratio+canvasMargin,canvasMargin);//2
						  context.lineTo(w+canvasMargin,h/2-ratioH+canvasMargin);//3
						  context.lineTo(w+canvasMargin,h/2+ratioH+canvasMargin);//4 
						  context.lineTo(w/2+ratio+canvasMargin,h+canvasMargin);//5
						  context.lineTo(w/2-ratio+canvasMargin,h+canvasMargin);//6
						  context.lineTo(canvasMargin,h/2+ratioH+canvasMargin);//7
						  context.lineTo(canvasMargin,h/2-ratioH+canvasMargin);//8
						  context.lineTo(w/2-ratio+canvasMargin,canvasMargin);//9

				  break;
				  default:
				  //Do nothing
				  break;
	  
	      }

                context.closePath();
                Shape.drawStroke(prop);// draws above lines/paths on canvas
               
         }
     };
});