define('Rectangle', ['Shape'], function (Shape) {/* define module names 'Rectangle' with the dependency shape[AMD]*/
    'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {}, Shape.default, options);/* adds default properties of shapes*/
                var d = $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                this.drawOutline(prop,true,'');
            
                var $this = this;
                Shape.fillImage(prop).done(function(value) {/*fills background image for shape*/
                    if(prop.shapeDetails.FillRange==1 || templateObj.isCroppedMode){
                        $this.drawOutline(prop,true,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/    
                    }else{
                        $this.drawOutline(prop,true,'');
                    }
                    
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/
                });    
                return d.promise();
         },

         drawOutline : function (prop, borderFlag, composite){ /*draws shape*/
                
                var context = Shape.context;
                context.save();
                if(composite){
                    context.globalCompositeOperation = "source-over"; 
                 }
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth)/2;
                var radius=0;
                var width=Shape.width;
                var height=Shape.height;
                var w=Shape.width;var h=Shape.height;
                radius=(h>w)?(w/2):h/2;
               	var r = radius*prop.shapeDetails.FigureRoundRatio/100;
				var x=Shape.canvasMargin/2;
				var y=Shape.canvasMargin/2;
				context.beginPath();
				context.moveTo(x+r, y);
				context.arcTo(x+w, y,   x+w, y+h, r);
				context.arcTo(x+w, y+h, x,   y+h, r);
				context.arcTo(x,   y+h, x,   y,   r);
				context.arcTo(x,   y,   x+w, y,   r);
				context.closePath();
				
                if(borderFlag){
                    Shape.drawStroke(prop);   //draws above lines/paths on canvas 
                }
                
         }
     };
});