define('Star', ['Shape'], function (Shape) {/* define module names 'RectangularCallout' with the dependency shape[AMD]*/
	'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {},Shape.default, options);/* adds default properties of shapes*/    
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                this.drawOutline(prop);
                var $this = this;   
                
                 Shape.fillImage(prop).done(function(value) {/*fills background image for shape*/
                     
                    $this.drawOutline(prop,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/
                     
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/
                });  
                return d.promise();
            },
         drawOutline : function (prop, composite){/*draws shape*/
                var context = Shape.context;
                var w = Shape.width;
                var h = Shape.height;
                var w1 = Shape.newWidth;
                var h1 = Shape.newHeight;
                context.beginPath();
			  	var canvasMargin = Shape.canvasMargin/2;
				var centreX = w1/2;
				var centreY = h1/2+h1/25;
				var outerRadius = w/2;
				var outerRadiusH = h/2;
				var type=prop.shapeDetails.elementName;
                var spikes=5;var cx=centreX;var cy=centreY;
                /*to work yellow point in proper direction*/
                var yellowPoint1=Math.round(prop.shapeDetails.StartWidth);
                var innerRadius=outerRadius*yellowPoint1/100;//temp
                var innerRadiusH=outerRadiusH*yellowPoint1/100;//temp
				if(type==1){
				 	spikes=5;
				  outerRadius = w/2+w*5/100;
				 outerRadiusH = h/2+h*5/100;
				 	
				 }else if(type==4){
				 	cx=w1/2;cy=h1/2;
				 	spikes=24;
				 	outerRadius=w/2;
				 	outerRadiusH=h/2;
				    innerRadius=outerRadius*yellowPoint1/100;
				    innerRadiusH=outerRadiusH*yellowPoint1/100;
				 }
				var rot = Math.PI / 2 * 3;
				var x = cx;
				var y = cy;
				var step = Math.PI / spikes;
                Shape.resetAlpha(composite);
				context.beginPath();

				context.moveTo(cx, cy - outerRadiusH);
				for ( var i = 0; i < spikes; i++) {
					x = cx + Math.cos(rot) * outerRadius;
					y = cy + Math.sin(rot) * outerRadiusH;
					if(type==1){
						if(i==1||i==4){
						   x = cx + Math.cos(rot) * (outerRadius-outerRadius*5/100);
					       y = cy + Math.sin(rot) * (outerRadiusH-outerRadiusH*5/100);
						}
						
					}
					context.lineTo(x, y);
					rot += step;
					x = cx + Math.cos(rot) * innerRadius;
					y = cy + Math.sin(rot) * innerRadiusH;
					context.lineTo(x, y);
					rot += step;
				}
				context.lineTo(cx, cy - outerRadiusH);
				context.closePath();
                Shape.drawStroke(prop);/*draws above lines/paths on canvas*/   
               
         }
     };
});