define('Sun', ['Shape'], function (Shape) {/* define module names 'RectangularCallout' with the dependency shape[AMD]*/
	'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {},Shape.default, options); /* adds default properties of shapes*/      
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                this.drawOutline(prop);
                var $this = this;
                Shape.fillImage(prop).done(function(value)/*fills background image for shape*/
                 {
                     
                    $this.drawOutline(prop,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/ 
                });    
                return d.promise();
            },
         drawOutline : function (prop, composite){ /*to draw shape*/
                var context = Shape.context;
               	
                var w = Shape.width;
                var h = Shape.height;  
                var w1 = Shape.newWidth;
                var h1 = Shape.newHeight;  
                var canvasMargin = Shape.canvasMargin/2;
                var centreX=w1/2;
				var centreY=h1/2;
				var yellowPoint=100-prop.shapeDetails.EllipseSize;
				var outerRadius=w/2;
				var outerRadius1=h/2;
				var resizeVal=3;
				var maxInnerRadius=55*outerRadius/100;
				var maxInnerRadius1=55*outerRadius1/100;
				var innerRadius=maxInnerRadius*yellowPoint/100;  
				var innerRadius1=maxInnerRadius1*yellowPoint/100;
				var rot = Math.PI / 2 * 3;
				var spikes=16;/*number of spikes of star*/
				var cx=centreX;var x = cx;
				var cy=centreY;var y = cy;
				var step = Math.PI / spikes;
				var tempX, tempY,tempX15,tempY15,tempX1,tempY1;
                innerRadius=innerRadius+w/6.6;
                innerRadius1=innerRadius1+h/6.6;
                Shape.resetAlpha(composite);
				context.beginPath();
				context.moveTo(cx, cy - outerRadius1);
	
				for (var i = 0; i < spikes; i++)
				 {
					x = cx + Math.cos(rot) * outerRadius;
					y = cy + Math.sin(rot) * outerRadius1;
					if (i % 2 == 0) {
						context.lineTo(x, y);
					}
					rot += step;
					x = cx + Math.cos(rot) * innerRadius;
					y = cy + Math.sin(rot) * innerRadius1;
					if (i == 0) {
						tempX1 = x;
						tempY1 = y;
					}
					if (i % 2 != 0) {
						context.moveTo(x, y);
						tempX = x;
						tempY = y;
						if (i == 15) {
							tempX15 = x;
							tempY15 = y;
							context.lineTo(cx, cy - outerRadius1);
							context.lineTo(tempX1, tempY1);
						}
					} else {
						if(i!=0){
						context.lineTo(x, y);
						context.lineTo(tempX, tempY);
						}
						context.closePath();
					}
					rot += step;
				}
                context.closePath();
                var value1 = 20;

                /*if (yellowPoint < 20) {
                    value1 = 40;
                }*/
                value1 = (100 - yellowPoint) * value1 / 100;

                if (innerRadius > value1) {
                    innerRadius = innerRadius - value1;
                } else {
                    innerRadius = innerRadius * 5 / 100;
                }
                if (innerRadius1 > value1) {
                    innerRadius1 = innerRadius1 - value1;
                } else {
                    innerRadius1 = innerRadius1 * 5 / 100;
                }

                var tempX1 = cx + Math.cos(rot) * (innerRadius);
                var tempY1 = cy + Math.sin(rot) * (innerRadius1);
                context.moveTo(tempX1, tempY1);
                //console.log("cx" + cx + "cy" + cy + "innerRadius" + innerRadius + "innerRadius1" + innerRadius1 + "yellowPoint" + yellowPoint);
                context.ellipse(cx, cy, innerRadius, innerRadius1, 2 * Math.PI, 1.5 * Math.PI, 1.499 * Math.PI, false);
                context.closePath();
                Shape.drawStroke(prop); /* draws above lines/paths shape on above canvas*/

               
         }
     };
});