define('Trapezoid', ['Shape'], function (Shape) {
     var prop ={};
     return {
         draw : function (options){
                prop = $.extend(true, {},Shape.default, options);
                var d = new $.Deferred();
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);
                this.drawOutline(prop, true,'');  
                var $this = this;
                Shape.fillImage(prop).done(function(value) {
                    if(prop.shapeDetails.FillRange==1){
                        $this.drawOutline(prop, true, 'source-over');    
                    }else{
                        $this.drawOutline(prop, true, '');    
                    }
                    
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                }); 
                return d.promise();
            },
          drawOutline : function (prop, borderFlag, composite){
                var context = Shape.context;
                
                if(composite){
                    context.globalCompositeOperation = "source-over"; 
                 }
                var canvasMargin = Shape.canvasMargin/2;
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
                context.globalAlpha = 1;
                context.beginPath();
                slope = (Shape.width/2)*Math.round(prop.shapeDetails.Slope)/100;
                context.moveTo(slope+canvasMargin, canvasMargin);    
                context.lineTo(canvasMargin, Shape.height+canvasMargin);
                context.lineTo(Shape.width+canvasMargin, Shape.height+canvasMargin);   
                context.lineTo(Shape.width+canvasMargin-slope, canvasMargin);
                context.closePath();
              
               // if(borderFlag){
                    Shape.drawStroke(prop);   
                //}
          }
     };
});
