define('Triangle', ['Shape'], function (Shape) {
     var prop ={};
     return {
         draw : function (options){
                prop = $.extend(true, {},Shape.default, options);   
                var d = new $.Deferred();
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails);
                var context = Shape.context;
                this.drawOutline(prop,true,'');
             
                 var $this = this;   
                
                 Shape.fillImage(prop).done(function(value) {
                 	
                 	if(!prop.shapeDetails.previewMode){
                 		if(prop.shapeDetails.FillRange==1){
                        $this.drawOutline(prop,true,'source-over');
                      }else{
                          $this.drawOutline(prop,true,'');
                      }
                 	}
                      
                    //context.save();
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));
                });    
                return d.promise();
            },
         drawOutline : function (prop, borderFlag, composite){
                var context = Shape.context;
                context.save();
                
                var borderWidth = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
             	if(prop.shapeDetails.previewMode){
             		borderWidth=0;
             	}
                context.beginPath();
                var ratio = prop.shapeDetails.ApexRatio;
                var triangleStart;
           		var height =  Shape.height;
           		var width =  Shape.width; 
				triangleStart = (width)*ratio/100;
				Shape.resetAlpha(composite);
              	var canvasMargin = Shape.canvasMargin/2;
				triangleStart += canvasMargin;
				height += canvasMargin;
				width += canvasMargin;
				context.moveTo(triangleStart, canvasMargin);        
                context.lineTo(canvasMargin, height);
			    context.lineTo(width , height);  
                context.closePath();
                Shape.drawStroke(prop);    
		 }
     };
});