define('Wave', ['Shape'], function (Shape) {/* define module names 'RectangularCallout' with the dependency shape[AMD]*/
	'use strict';/* enables code execution in strict mode which shows script errors(bad syntax to real errors)*/
     var prop ={};
     return {
         draw : function (options){/* initializes canvas and draw shape*/
                prop = $.extend(true, {},Shape.default, options);  /* adds default properties of shapes*/      
                var d = new $.Deferred();/*creating new deferred object to return promise*/
                Shape.initCanvas(prop.w, prop.h, prop.shapeDetails.FillColor);/* initializes canvas*/
                var context = Shape.context;
                this.drawOutline(prop);
                var $this = this;   
                
                 Shape.fillImage(prop).done(function(value) {/*fills background image for shape*/
                     
                    $this.drawOutline(prop,'source-over');/*for drawing border separately over shape to get rid of opacity issue with border*/
                     
                    d.resolve(Shape.canvas.toDataURL('data:image/jpg;'));/*returns an object of shape drawn on canvas*/ 
                });    
                return d.promise();
            },
         drawOutline : function (prop, composite){/*to draw shape*/
                var context = Shape.context;
                var canvasMargin = Shape.canvasMargin/2;
                 context.globalAlpha = 1;
                if(composite){
                    context.globalCompositeOperation = "source-over"; 
                 }
                var yellowPoint=prop.shapeDetails.CurvedRatio;
                var yellowPoint1=prop.shapeDetails.HorizontalSlope;
                 var stroke = Shape.getFigureStrokeWidth(prop.shapeDetails.FigureStrokeWidth);
                var width = Shape.width;
                var height = Shape.height;
                var context = Shape.context; 
                var curvedRatio=80;/*max 110 to min 1*/
                var heightDivider=5;
                var sineWaveHeight=((yellowPoint/100) * height)/heightDivider;
                var slope=35;//10 was fixed
                var widthDivider=100;
                var widthAdjustment = width - (((Math.abs(slope-50))/50) * width)/widthDivider;
                var canvasMargin = Shape.canvasMargin/2;
                var handleSharpEdge=1.5;
                if(stroke>15){
                	handleSharpEdge=2;
                }else{
					
					handleSharpEdge=1;
				}
                if(yellowPoint1 <= 50)
                {
                	var value1=20;var value2=10;
				    value1=value1*(50-yellowPoint1)/50;
					value2=value1+3;
                    if(value1<1){
					value2=0;
                    }		

                    context.beginPath();
                    context.moveTo(width-widthAdjustment+value1+canvasMargin,sineWaveHeight+canvasMargin);//1
                    //value1 is added to move  top left corner point to show slope change effect
				    context.bezierCurveTo(width-widthAdjustment+sineWaveHeight+value1+canvasMargin, -2.2*sineWaveHeight+canvasMargin, 4*width/6+canvasMargin, sineWaveHeight*4+canvasMargin, width+canvasMargin, sineWaveHeight+canvasMargin);//2
					//value2 is added to move  bottom right corner point to show slope change effect
					context.lineTo(widthAdjustment-value2+canvasMargin, height-sineWaveHeight+canvasMargin); //4
                    context.bezierCurveTo(4*width/6+canvasMargin, height+sineWaveHeight*2.3+canvasMargin,sineWaveHeight+(width-widthAdjustment)+canvasMargin, height-sineWaveHeight-3*sineWaveHeight+canvasMargin ,canvasMargin,height-sineWaveHeight+canvasMargin/handleSharpEdge);//6
					 //value1 is added to join changed top left corner point
					context.lineTo(width-widthAdjustment+value1+canvasMargin,sineWaveHeight+canvasMargin); //6 and last
                   
                }
                else
                {
                    var value=1+yellowPoint1/1000;
                    var value1=10*(10-(yellowPoint1/10));
                    if(value1<10){
                    	value1=10;
                    }
				    context.beginPath();
                    context.moveTo(width-widthAdjustment+canvasMargin,sineWaveHeight+canvasMargin);//1
                    //value is added to move  top right corner point to show slope change effect
				    context.bezierCurveTo(width-widthAdjustment+sineWaveHeight+canvasMargin, -2.2*sineWaveHeight+canvasMargin, 4*width/6+canvasMargin, sineWaveHeight*4+canvasMargin, (width/value)+canvasMargin, sineWaveHeight+canvasMargin);//2
					context.lineTo(widthAdjustment+canvasMargin, height-sineWaveHeight+canvasMargin); //4
                    //value1 is added to move  left bottom corner point to show slope change effect
                    context.bezierCurveTo(4*width/6+canvasMargin, height+sineWaveHeight*2.3+canvasMargin,sineWaveHeight+(width-widthAdjustment)+canvasMargin, height-sineWaveHeight-3*sineWaveHeight+canvasMargin ,(width/value1)+canvasMargin,height-sineWaveHeight+canvasMargin/handleSharpEdge);//6
					context.lineTo(width-widthAdjustment+canvasMargin,sineWaveHeight+canvasMargin); //6 and last
                   
                }
                Shape.drawStroke(prop);/* draws above lines/paths on canvas*/
               
         }
     };
});