/* 
 * Created by amber.m 22-12-2014
 *  Dependent Files : templateFrames.js
 *  Last Update BY: Veer Pratap Singh - 12th Jan 16
 */

/* ------ CONSTANTS ------- */
'use strict';
var currentTime;
var valueTotimer=0;
var DEFAULT_VALUE=-1;
var LEFT_SIDE = 1;
var TOP_SIDE = 2;
var BOTTOM_SIDE = 3;
var RIGHT_SIDE = 4;
var DIRECTION_VERTICAL = 5;
var FIXED_LAYOUT = 6;
var FREE_LAYOUT = 7;
var VERTICAL = 9;
var HORIZONTAL = 10;
var DIRECTION_HORIZONTAL = 11;
var MAIN_FRAME_ELM_CP=14;
var INNER_FRAME_CP=15;
var MAIN_FRAME_ELM=17;
var IMAGE=18;
var GROUP=20;
var TEXT=21;
var STICKER=22;
var VIDEO = 24;
var CENTER_SIDE = 25;
var HANDWRITING=27;
var MN_FRM_ELM_ROT=28;
var MENUBOARD=29;
var EMPTY=30;
var MNFRM_ROT_ELMCP=31;
var BLANK_INNER_FRAME_CP=32;
var BLANK_INNER_FRAME=33;
var DECO_IMAGE=34;
var BLK_FRM_ROT_CP=35;
var PPT=36;
var PDF=39;
var AUDIO=37;
var TABLE_TEXT=38;
var FRAME_ROTATION=39; 
var SNAP_VALUE = 45;
var FRAME_ID_PREFIX="tplFrameId_";
var ACTIVE_FRAME=FRAME_ID_PREFIX+"0";
var MIN_FRAME_W_PERC = 5;
var MIN_FRAME_H_PERC = 5;
var rotateMode = false;
var currRotateObj = null;
var ANGLE_DIFF = 0;
var rotateControlObj = null;
var W_GT_H=201;
var W_LT_H=202;
var W_EQ_H=203;
var W_6tn9n_H=204;
var W_N6tn9n_H=205;
var INITZINDEX=99999;
var MAX_COVER_DIV_Z_INDEX=999999;
var MIN_INNER_FRAME_ZINDEX=100;
var MIN_COVER_FRAME_ZINDEX=9999;
var BORDER_WIDTH = 2;
var COVERIDSHADOW="0px 0px 0px "+BORDER_WIDTH+"px";
var CPoint_HW=19;
var ROTATE_HANDLER_HW = 40;
var slideShowScroll=null;
var MAX_MAIN_FRAME_ELEMENTS = 40;
var MAX_INPUT_SRC_FRAMES = 1;
var MAX_VIDEO_FRAMES = 2;
var MAX_IMG_IN_FRAME=100;
var MAX_VDO_IN_FRAME=10;
var MAX_MEDIA_ITEMS=2;
var MAX_DSGN_ELM_PORT_WTH_IPSRC=2;
var STANDARD_VIDEO_HEIGHT=1080;
var VIDEO_LIMIT={W:1920,H:1920,RW:1920,RH:1080};
var MAGNET_RANGE_FOR_MOVE = 5;
var MAGNET_RANGE_FOR_RESIZE = 3;
var MAGNET_RANGE_FOR_ATTACHED = 1;
var MAX_HEAVY_ELM_CNT = 10;
var MIN_HW_MAIN_FRM_ELM=5;
var tranListScroll=null;
var screenWidth = 0;
var screenHeight = 0;
var isAudioDragStart=false;
var tchEvnt=null;
var evntSeq="";
var highLghtTime=1000;
var moveCursorTimeout = 0;
var tapholdTimeout = null;
var TAPHOLDTIME = 500;
var elem_center_x;
var elem_center_y;
var isDblTapped=false;
var updtSlotCallObj={callCnt:0,successCnt:0};
var isListRendrOnce=false;
var cpRotationAngle=[-45,0,45,90,-45,0,45,90];
var UNDO_REDO_ALLOWED = false;
var constForTmpl = {
		SHUFFLE : "shuffle",		
		SHIFTFORMENU : "shiftformenu",
		SHIFTFORTEXT : "shiftfortxt",
		SHOWMAINFRAME : "showmainframe",
		KEYBOARDCLOSE : "keybclose",
		HIDEITEMLIST : "hideitmlist",		
		OUTSIDETAP : "outsidetap",
		RNDR_FRAME_THUMB : "rndrframethumb",
		CLOSE_TXT_EDIT : "closetxtedit",
		SHOW_HIDE_FRAME_CTRLS : "showhideframecntrls",		
		SHOW_HIDE_ELEMENT_CONTROLS : "showhideelementctrls",		
		ARRANGE_LAYER_ELM_CNT : "arrangeLayerElmCount",
		IS_HEAVY_ELM_LMIT_XCD:"HeavyElementLimitExceeded"
	};
/* ------ TEMPLATE OBJECT ------- */
var template = function(){
    this.mainFrame = null;
    this.innerFrames = {};
    this.frameCount = 0;
    this.lfdSize = {w:1920, h:1080};
    this.orientation = LANDSCAPE;
    this.frameLayout = FIXED_LAYOUT;
    this.imageUrls=[];
    this.videoIsArray=[];
    this.rects=[];
    this.gridLines=[];
    this.curSelFrameIndx=0;   
  	this.curLineOfCntl=null;
    this.bCPDragEnable=false;
    this.loadImgCount=0;
    this.currSelRect=0;
    this.dragLocation=DEFAULT_VALUE;
    this.mainElmDragBtnID="";
    this.mainFrameSelElmObj = null;
    this.cpDragStartPt=null;
    this.cpDragStartPtForUndo=null;
    this.mainCpCount=8;
    this.clickTimer=null;
    this.frameDropLocation=-1;
    this.curGridLineRange=null;
    this.listTapHold=false;
    this.listStatus="imgThumb";    
    this.isListVisible=false;
    this.tempSelTran="None";
    this.dragElmFrame=null;    
    this.isEdited=false;
    this.isCroppedMode=false;
    this.selCategory="";
    this.bTableMenuVisible = false;
    this.mainFrmElmLayer=[];
    this.bgImage="";
    this.bgColor="";
    this.canModifiedBg=true;
    this.imageX = 0;
    this.imageY = 0;
    this.currRotationAngle = 0;
    this.audioPath="";
    this.audioFileName="";
    this.selAudioFrm="";
    this.audioFlag=true;
    this.currSelTxtDivId = "";
    this.innerFrameZOrder="";
    this.innerFrameZOrderArr=[];
    this.tmplXmlObj=null;
    this.cropInfoFrUndo = null;
    this.bListViewVisible = false;
    this.currMnFrmObjProp={};
    this.swapDivXYWH = null;
    this.modelType=RHE_MODEL;
    this.magnetEffectObj=null;
    this.magnetPointObj=null;    
    this.inputSrcRegion = "Others";
    this.initialTop=0;
    this.bCanvasAnyElmSel = false;/*true on Canvas element selection or on any bottom menu show*/    
    this.isAdClipMode=false;
    this.stickerCopyInfoObj = null;
};

template.prototype.initTemplate=function(orientation,layoutType)
{
    log.debug("orientation = "+orientation+" layoutType "+layoutType, "initTemplate");    
    this.curGridLineRange=new gridLineRange(null, null);
    this.cropInfoFrUndo = new cropInfo("",0,0,1,0);
    this.stickerCopyInfoObj = new stickerCopyInfo(TStickerCopyDir.NONE, 0, 0);
	//this.setModelType(Utils.getActivePlayerType());
	this.setLfdOrientation(orientation);	
	this.frameLayout = layoutType;
	this.attachOneTimeEvent();	
	log.debug("COMPLETE", "initTemplate");
};
template.prototype.setModelType=function(value)
{
    if(value!=null)
    {
        this.modelType=value;
        this.resetLimitsForModelType();
    }    
};
template.prototype.attachOneTimeEvent=function()
{
    this.renderSlideShowList(); 
    this.addEventForMnFrmCP();
    this.addEventForFrame();
    handleDragEvent('stickerMenuDiv', STICKER);
    handleDragEvent('textMenuDivP', TEXT);
};
template.prototype.setLfdOrientation=function(iOrientation)
{
    log.debug("iOrientation = "+iOrientation, "setLfdOrientation");
	this.orientation = iOrientation;
	if(this.orientation==LANDSCAPE)
    {
        this.lfdSize = {w:1920, h:1080};
    }
    else
    {
        this.lfdSize = {w:1080,h:1920};
    }   	
	$("#tpl_ContainerId").empty();
	var rect = this.calculateMainFrameRect();
	this.initialTop=rect.y;
	var frame = new frameInfo(rect.x, rect.y, rect.w, rect.h, true);
    frame.active = true;
    frame.id=FRAME_ID_PREFIX+"Main";	
	this.mainFrame=frame;
	this.addMainFrameToContainer();
    log.debug("COMPLETE", "setLfdOrientation");
};
template.prototype.resetLimitsForModelType = function() {
    switch(this.modelType) {
    case RHE_MODEL:
    case TIZEN_MODEL:
    case STRETCH_MODEL:
        MAX_VIDEO_FRAMES = 2;
        MAX_INPUT_SRC_FRAMES = 1;
        MAX_IMG_IN_FRAME = 100;
        MAX_MEDIA_ITEMS=2;        
        if(this.modelType==TIZEN_MODEL)
        {
            VIDEO_LIMIT={W:2048,H:1920,RW:1920,RH:1088};
            MAX_MAIN_FRAME_ELEMENTS = 100;
        }        
        break;
    case RMD_MODEL:
        MAX_VIDEO_FRAMES = 1;
        MAX_INPUT_SRC_FRAMES = 1;
        MAX_IMG_IN_FRAME = 20;
        MAX_MEDIA_ITEMS=1;
        break;
    default:
        break;
    }
}; 
template.prototype.getArrangeInfoForElementByType=function(elmType)
{
	log.debug("START - elmType:"+elmType,"getArrangeInfoForElementByType");
	var infoObj={isVisible:false,isEnable:false};
	if(this.isTopLayerElement(elmType))
	{
		var arrLen=this.mainFrmElmLayer.length;
		infoObj.isVisible=true;
		if(arrLen>1)
		{
			infoObj.isEnable=true;
		}
	}
	return infoObj;	
};
template.prototype.isTopLayerElement=function(elmType)
{
	if(elmType==STICKER || elmType==TEXT || elmType==HANDWRITING)
	{
		return true;
	}
	return false;
};
template.prototype.makeStickerCopy=function()
{
    log.debug("START", "makeStickerCopy");
    if(!this.isAddLayerPossible())
    {         
        return;      
    }    
    var actvFrame=this.getActiveFrame();
    var currElm=actvFrame.element[actvFrame.activeEleIndex];
	var iStckrElm=currElm.textElms[currElm.actvTxtElmIndx];
	var newObject = jQuery.extend(true,{}, iStckrElm);	
    var rect = this.getNextCopyLocation(iStckrElm, this.stickerCopyInfoObj);
    newObject.x = rect.x;
    newObject.y = rect.y;
    this.updateXYtoLmt(newObject);
    this.addDsgnElmToFrame(newObject);
    log.debug("COMPLETE", "makeStickerCopy");
};

template.prototype.getHandWritingElementPos=function(eleW, eleH, dropPt){
	     var frameOffset=$("#"+FRAME_ID_PREFIX+"Main").offset();
	var centX = (dropPt.x - frameOffset.left)/this.mainFrame.scale;
	var centY = (dropPt.y  - frameOffset.top)/this.mainFrame.scale; 
	    var elmRect = {
	        x:centX-eleW/2,
	        y:centY-eleH/2,
	        w:eleW,
	        h:eleH
	    };
	    this.updateXYtoLmt(elmRect);
	    return elmRect;
};

template.prototype.deleteElmFromMainFrame=function()
{
    log.debug("START this.mainFrame.activeEleIndex== "+this.mainFrame.activeEleIndex, "deleteElmFromMainFrame");
    /*Remove magnet point for deleted element*/
    var ele = this.mainFrame.element[this.mainFrame.activeEleIndex];
    if(ele.elementType == TEXT){
        ele = ele.textElms[0];
    }    
	this.mainFrame.element[this.mainFrame.activeEleIndex]=null;
	this.showMainFrame();
    log.debug("COMPLETE", "deleteElmFromMainFrame");
};
template.prototype.isAnyTxtSlideTxtExist=function()
{
    var flag=false;
    var elmLen=this.mainFrmElmLayer.length;
    var txtObj;
   for (var eleLayer = 0; eleLayer < elmLen; eleLayer++) {
        elmIndex = this.mainFrmElmLayer[eleLayer];
        ele = this.mainFrame.element[elmIndex];
        if (ele.elementType == TEXT) {
            txtObj=ele.textElms[0];
            if(txtObj.bTextSlide)
            {
                flag=true;
                break;
            }
        }
    }
    return flag;
};
template.prototype.addElmOnMainFrame=function(newElm)
{
    log.debug("newElm ="+newElm.elementType, "addElmOnMainFrame");
    var bLimit = this.isWithinMaxLimit();
    if(bLimit){
        if(this.isHeavyElementLimitExceeded(this.mainFrame, newElm.elementType)){
            Utils.showToast(MIA_SID_ADD_UP_10_DESIGN_ELEMENTS_TEXT_BOX);
            return false;
        }
    }
    
    if(bLimit)
    {    
    	this.mainFrame.setElement(newElm);
    	var index=this.mainFrame.element.length-1;
    	this.renderElmntOnMnFrm(newElm,index);
    	return true;
	}
	else
	{
	   this.addElmErrorPopup("","");
	   return false;
	}
	log.debug("COMPLETE", "addElmOnMainFrame");
};
template.prototype.isWithinMaxLimit=function()
{
   if(this.getTextStickerHandWElmCount() < MAX_MAIN_FRAME_ELEMENTS)
   {
       return true;
   }
   return false;  
};
template.prototype.isHeavyElementLimitExceeded=function(contFrame, eleType){
    var elmLength = this.mainFrmElmLayer.length;
    var textElmCount = 0;
    var frame = null;
    var len = 0;
    var nonEmptyFrmCount = 0;
    for(var frameId in this.innerFrames){
        frame = this.innerFrames[frameId];
        len = frame.element.length;
        if(len>0){
            nonEmptyFrmCount++;
            if(frame.element[0].elementType == GROUP){
                textElmCount += frame.element[0].textElms.length;
            }
        }
        if(frame.table != null){
            textElmCount += frame.table.col.length * frame.table.col[0].length;
        }
    }
    var elmIndex = 0;
    var ele = null;
    for (var eleLayer = 0; eleLayer < this.mainFrmElmLayer.length; eleLayer++) {
		elmIndex = this.mainFrmElmLayer[eleLayer];
        ele = this.mainFrame.element[elmIndex];
		if (ele.elementType == TEXT) {
            elmLength--;
            textElmCount++;
        }
    }
    var heavyElmCnt = elmLength + nonEmptyFrmCount;
    log.debug("heavyElmCnt="+heavyElmCnt+" eleType="+eleType,"isHeavyElementLimitExceeded");
    if(contFrame == null){
        if(heavyElmCnt >= MAX_HEAVY_ELM_CNT){
            return true;
        }
    }else{
        log.debug("case 1 frame= "+frame+ " "+MAX_HEAVY_ELM_CNT,"isHeavyElementLimitExceeded");
        if(contFrame == this.mainFrame && eleType != TEXT && heavyElmCnt >= MAX_HEAVY_ELM_CNT){
            log.debug("case 1 ","isHeavyElementLimitExceeded");
            return true;
        }else if(contFrame != this.mainFrame && contFrame.element.length == 0 && heavyElmCnt >= MAX_HEAVY_ELM_CNT){
            log.debug("case 2 ","isHeavyElementLimitExceeded");
            return true;
        }
    }
    return false;
};
template.prototype.showMaxMediaToast=function()
{
   Utils.showToast(MIA_SID_MIX_ADD_MEDIA_FILES_EX.replace("<<A>>",MAX_MEDIA_ITEMS)); 
};
template.prototype.showMaxElmPortToast=function()
{   
   Utils.showToast(MIA_SID_MIX_CAN_ADD_DESIGN_ELEMENTS_SOURCE.replace("<<A>>",MAX_DSGN_ELM_PORT_WTH_IPSRC));  
};
template.prototype.showTxtSlidePortToast=function()
{
   Utils.showToast(MIA_SID_INPUT_SOURCE_SLIDING_NOT_SUPPORTED_PORTRAIT); 
};
template.prototype.showOneDsgnElmTost=function()
{
	Utils.showToast(MIA_SID_ONLY_ADD_ITEM_DESIGN_ELEMENT);
};
template.prototype.addElmErrorPopup=function(eleType,msgTxt){
    switch(eleType){
        case VIDEO:
            if(msgTxt!="")
            {
               genericOkPopUP("Type1","",COM_SID_OK,[msgTxt]); 
            }
            else
            {
                if (this.modelType == RMD_MODEL) {
                Utils.showToast(MIS_SID_ONLY_ADD_ON_VIDEO_INPUT);
                }
                else
                {
                    this.showMaxMediaToast();
                }
            }
            break;      
        case IMAGE:            
            Utils.showToast(MIA_SID_MIX_ADD_IMAGES_PLAYED_SLIDESHOW.replace("100",MAX_IMG_IN_FRAME));
        break;
     default:        
        break;
    }
};
template.prototype.getArrangeLayerElmCount=function()
{
    var elmLength = this.mainFrmElmLayer.length;
    return elmLength;
};
template.prototype.getTextStickerHandWElmCount=function(){
    var elmLength = this.mainFrmElmLayer.length;
    var likdElmCount = 0;
    var frame = null;
    var len = 0;
    for(var frameId in this.innerFrames){
        frame = this.innerFrames[frameId];
        len = frame.element.length;
        if(len>0){            
            likdElmCount++;
            if(frame.element[0].elementType == GROUP){
                likdElmCount += frame.element[0].textElms.length;
            }            
        }
        if(frame.table != null){
            likdElmCount += frame.table.col.length * frame.table.col[0].length;
        }
    }
    return (elmLength + likdElmCount);
};
template.prototype.renderElmntOnMnFrm=function(elmnt,indx)
{
    log.debug("elmnt ="+elmnt+" indx = "+indx, "renderElmntOnMnFrm");
	var divID;
	var currObj=this;	
	if(elmnt!=null)
	{			
		currObj.mainFrmElmLayer.push(indx);
		divID=currObj.mainFrame.id+"-elm_"+indx+"_0";
		elmType=elmnt.elementType;        
        $("#"+currObj.mainFrame.id).append('<div id="'+divID+'" class="mainFrameElmCls" type="'+elmType+'" angle="'+elmnt.rotation+'"></div>'
                                           +'<div id="ElmCover-'+divID+'" class="mainFrameElmCoverCls" type="'+elmType+'"></div>'
                                          );				
		switch(elmType)
		{
		   case STICKER:
		   case HANDWRITING:
		      $("#"+divID).html('<img id="'+divID+'_InrElm" src="'+elmnt.imageSrc+'" class="mainFrameInnerElmCls"/>');
                if(elmType==HANDWRITING)
                {
                   $("#"+divID).css({                    
                    'transform':'rotate('+elmnt.rotation+')'
                   });
                    $("#ElmCover-"+divID).css({
                        'transform':'rotate('+elmnt.rotation+')'
                    });
                }
		   break;
		   case DECO_IMAGE:
		       $("#"+divID).html('<img id="'+divID+'_InrElm" src="'+elmnt.imageSrc+'" class="dcoImgInnerCls"/>');
               $("#ElmCover-"+divID).remove(); 
               $("#"+divID).css({
                    'z-index':INITZINDEX-10
                    ,'transform':'rotate('+elmnt.rotation+')'
                });
		   break;
		  
		   case TEXT:
    		    elmnt=elmnt.textElms[0];
    		   if($.trim(elmnt.text)=="")
    		   {
    		       elmnt.text=MIA_SID_DOUBLE_TAP_TO_EDIT;
    		   }    		        		    
                createUpdatedImage(elmnt);
                $("#"+divID).html('<div class="overflowTextDivCls">'    
                                    +'<img id="'+divID+'_InrElm_Img" src="'+elmnt.textImageSrc+'" class="mainFrameInnerElmCls"/>'                                                      
                                    +'<div id="'+divID+'_SlideElm" class="mainFrameInnerElmCls">'
                                    + '<table class="slideElmTblCls"><tr><td class="slidElmTdCls">'
                                    + elmnt.text
                                    +'</td></tr></table>'
                                    +'</div>'
                                   +'</div>');                                    
              $("#"+currObj.mainFrame.id).append('<div id="'+divID+'_InrElm" isPad="yes" class="mainFrmInrElmCls tmpltTxtCls">'
                                    +elmnt.text
                            +'</div>');
		        currObj.setTextPropToDiv(divID+"_InrElm",elmnt);
                elmnt.textImageName = divID+"_InrElm.png";
                currObj.textImageShow(divID, true);                             
                $(".mainFrmInrElmCls").off("tap").on("tap",function(e){                    
                    e.stopPropagation();                                       
                });
                currObj.setDimXYWH(divID+"_InrElm",elmnt.x,elmnt.y,elmnt.w,elmnt.h);
		   break;
		   default:
		      $("#"+divID).remove();
		   break; 
		}
		if(elmType!=DECO_IMAGE)
        {
            currObj.setZIndexForMnFrmElm(divID,indx);
        }			
		elmnt.minW=Math.round(elmnt.w*0.10);
		elmnt.minH=Math.round(elmnt.h*0.10);	
		currObj.setDimXYWH(divID,elmnt.x,elmnt.y,elmnt.w,elmnt.h);
        if($("#ElmCover-"+divID).length > 0){
            currObj.setDimXYWH("ElmCover-"+divID,elmnt.x,elmnt.y,elmnt.w,elmnt.h);            
        }
	}
	currObj.isEdited=true;    	
	log.debug("COMPLETE", "renderElmntOnMnFrm");
};

template.prototype.setZIndexForMnFrmElm=function(divID,indx)
{
    $("#"+divID).css({
        'z-index':INITZINDEX+(indx*5)
    });
    $("#ElmCover-"+divID).css({
        'z-index':INITZINDEX+(indx*5)+2
    });
};
template.prototype.getMinHW=function(attr)
{
  return  attr<1?1:attr; 
};
template.prototype.setTextPropToDiv = function(divID,elmnt){
	$("#"+divID).css({
        'font-size':this.resizeTextToTabSize(elmnt.fontSize)+'px'
        ,'color':elmnt.fontColor			
        ,'font-family':elmnt.fontFamily
        ,'background-color':getRGBColorInRGBA(elmnt.bgColor,elmnt.bgAlpha)				
    });    			
	if(elmnt.fontItalic){
        $("#"+divID).css({'font-style':'italic'});
    }
	if(elmnt.fontBold){
        $("#"+divID).css({'font-weight':'bold'});
    }
	if(elmnt.fontUnderLine){
        $("#"+divID).css({'text-decoration':'underline'});
    }
    $("#"+divID).removeClass("hAligncenter hAlignleft hAlignright");    
    $("#"+divID).addClass("hAlign"+elmnt.hAlign);   
    $("#"+divID).removeClass("vAlignmiddle vAligntop vAlignbottom");
    $("#"+divID).addClass("vAlign"+elmnt.vAlign);	
};
template.prototype.getActvElmofActvFrm=function()
{
    var currFrame=this.getActiveFrame();
   return currFrame.getActiveElement();
};
template.prototype.rmIndxFrmMnFrmLyerArr=function(iValue)
{
    log.debug("iValue ="+iValue, "rmIndxFrmMnFrmLyerArr");
	var currElm=this.getActvElmofActvFrm();
    var selIndx=this.getMnFrmLayerArrIndex(iValue,currElm);
    currElm.elmLyrArr.splice(selIndx,1);
    log.debug("COMPLETED", "rmIndxFrmMnFrmLyerArr");
};
template.prototype.getMnFrmLayerArrIndex=function(iValue,currElm)
{
    log.debug("iValue ="+iValue, "getMnFrmLayerArrIndex");
	var elmLength=currElm.elmLyrArr.length;
    for(var i=0;i<elmLength;i++)
    {
        if(currElm.elmLyrArr[i]==iValue)
        {
            log.debug("return indexVal: "+ i,"getMnFrmLayerArrIndex");
            return i;
        }
    }
    log.debug("COMPLETED", "getMnFrmLayerArrIndex");
};
template.prototype.resetZIndexMnFrmElm=function()
{
    log.debug("START", "resetZIndexMnFrmElm");
	 var currFrame=this.getActiveFrame();
    var currElm=currFrame.getActiveElement();
    var elmLength=currElm.elmLyrArr.length;
    var divID;
    var elmType;
    for(var i=0;i<elmLength;i++)
    {
        divID=currFrame.id+"-elm_"+currFrame.activeEleIndex+"_"+currElm.elmLyrArr[i];       
        elmType=getParseIntInDec($("#"+divID).attr("type"));
        if(elmType==DECO_IMAGE)
        {
           $("#"+divID).css({
                'z-index':INITZINDEX-10
            }); 
        }
        else
        {
            $("#ElmCover-"+divID).css({
                'z-index':INITZINDEX+(i*5)+2
            });
            $("#"+divID).css({
                'z-index':INITZINDEX+(i*5)
            });            
        }
    }
    log.debug("COMPLETED", "resetZIndexMnFrmElm");
};
template.prototype.sendToBack=function(index,currElm)
{
    log.debug("1index = "+index, "sendToBack"); 
    var indexVal=this.getMnFrmLayerArrIndex(index,currElm); 
    if(indexVal>0)
    {       
        var tempValue=  currElm.elmLyrArr[indexVal];
        currElm.elmLyrArr.splice(indexVal,1);
        currElm.elmLyrArr.splice(1,0,tempValue);
        this.resetZIndexMnFrmElm();
    }
    log.debug("COMPLETED", "sendToBack");
};
template.prototype.sendBackward=function(index,currElm)
{
    log.debug("index = "+index, "sendBackward");    
    var indexVal=this.getMnFrmLayerArrIndex(index,currElm); 
    if(indexVal>1)
    {       
        var tempValue=  currElm.elmLyrArr[indexVal];
        currElm.elmLyrArr[indexVal]=currElm.elmLyrArr[indexVal-1];
        currElm.elmLyrArr[indexVal-1]=tempValue;
        this.resetZIndexMnFrmElm();
    }
    log.debug("COMPLETED", "sendBackward");
};
template.prototype.sendToFront=function(index,currElm)
{
    log.debug("index = "+index, "sendToFront");  
    var indexVal=this.getMnFrmLayerArrIndex(index,currElm);    
    if(indexVal<(currElm.elmLyrArr.length-1))
    {
        var tempValue=  currElm.elmLyrArr[indexVal];
        currElm.elmLyrArr.splice(indexVal,1);
        currElm.elmLyrArr.splice(currElm.elmLyrArr.length,0,tempValue);
        this.resetZIndexMnFrmElm();
    }
    log.debug("COMPLETED", "sendToFront");
};
template.prototype.sendForward=function(index,currElm)
{
    log.debug("1index = "+index, "sendForward");    
    var indexVal=this.getMnFrmLayerArrIndex(index,currElm);
    if(indexVal<(currElm.elmLyrArr.length-1))
    {
        var tempValue=  currElm.elmLyrArr[indexVal];
        currElm.elmLyrArr[indexVal]=currElm.elmLyrArr[indexVal+1];
        currElm.elmLyrArr[indexVal+1]=tempValue;
        this.resetZIndexMnFrmElm();
    }
    log.debug("COMPLETED", "sendForward");
};
function setCursorToEnd(el)
{    
    log.debug("ele = "+el, "setCursorToEnd");    
    try
    {        
        el.focus();
        if (typeof window.getSelection != "undefined"
                && typeof document.createRange != "undefined") {
            var range = document.createRange();
            range.selectNodeContents(el);
            range.collapse(false);
            var sel = window.getSelection();
            sel.removeAllRanges();
            sel.addRange(range);
        } else if (typeof document.body.createTextRange != "undefined") {
            var textRange = document.body.createTextRange();
            textRange.moveToElementText(el);
            textRange.collapse(false);
            textRange.select();
        } 
    }
    catch(ex)
    {
        log.debug("Error: " + ex.message, "setCursorToEnd");    
    }
    log.debug("COMPLETED", "setCursorToEnd");
}

template.prototype.shiftTemplateForMenu=function(iToken)
{
    log.debug("iToken = "+iToken,"shiftTemplateForMenu");    
    var totalShift=0;
    var leftShift=this.mainFrame.x;
    var value=1;       
    if(iToken==UP)
    {        
       var ttlArea=0;
       if(this.orientation==PORTRAIT)
       {
            ttlArea=0.73;            
            value=0.7; 
            leftShift=Math.round(leftShift-(this.mainFrame.w-(this.mainFrame.w*value))/2);         
       }
       else
       {
           ttlArea=0.72;
       }
       totalShift=Math.round(((WIN_INNER_H*ttlArea)-(this.mainFrame.h/value))/2);       
    }
    else
    {
        totalShift=Math.round((WIN_INNER_H-this.mainFrame.h)/2);              
    }
    this.mainFrame.xOffset=0;
    this.mainFrame.yOffset=0;
    this.resetTemplateZoom(value);       
    $("#"+FRAME_ID_PREFIX+"Main,#mainFrameCoverID").css({
        'top':totalShift+'px'
        ,'left':leftShift+'px'
    }); 
    log.debug("COMPLETED", "shiftTemplateForMenu");
};
template.prototype.processKeyBoardClose=function()
{    
    if(this.currSelTxtDivId != ""){
        $("#enterText").hide();
        onTextBlur($("#"+this.currSelTxtDivId+"_InrElm")[0]);        
    }        
};
template.prototype.setDragElmFrame=function(tapDivID)
{
    log.debug("tapDivID = "+tapDivID, "setDragElmFrame");
	var evtElm=tapDivID.split("-elm_")[1].split("_");
	var elmIndex=getParseIntInDec(evtElm[0]);
	var txtIndex=getParseIntInDec(evtElm[1]);
	if(tapDivID.match("_Main"))
	{
		this.dragElmFrame=this.mainFrame;				
	}
	else
	{
		this.dragElmFrame=this.getInnerFrameForId(tapDivID.split("-")[0]);					
	}
	this.dragElmFrame.element[elmIndex].actvTxtElmIndx=txtIndex;
    var currActiveElm=this.dragElmFrame.element[elmIndex].textElms[txtIndex];    
     if(currActiveElm.elmType==STICKER){
        this.stickerCopyInfoObj.setStickerCopyInfo(TStickerCopyDir.NONE, currActiveElm.x, currActiveElm.y);
    }
    this.mainFrameSelElmObj = currActiveElm;
    this.currMnFrmObjProp={x:currActiveElm.x,y:currActiveElm.y
                           ,h:currActiveElm.h,w:currActiveElm.w};   
    log.debug("COMPLETED", "setDragElmFrame");
};
template.prototype.addEventForFrame=function()
{
    log.debug("START", "addEventForFrame");
    var currObj=this;
    currObj.unbindEvent('.tpl_frameCls',"tap touchstart");
    $(document).on("tap",".tpl_frameCls",function(e){
        e.preventDefault();
        if(log.bDebug){
            log.debug("TAP EVENT CALLED frame id = "+$(this).attr("id"), ".tpl_frameCls");
        }
        $("#frameCover-"+$(this).attr("id")).trigger("tap");
        return false;
    }).on("touchstart",".tpl_frameCls",function(e){
        e.preventDefault();
        if(log.bDebug){
            log.debug("TOUCHSTART EVENT EVENT CALLED - frame id ="+$(this).attr("id"), ".tpl_frameCls");
        }
        currObj.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX
        ,y:e.originalEvent.changedTouches[0].clientY};
    });
	currObj.unbindEvent('.coverDivCls',"tap touchstart touchcancel touchend taphold");	
	$(document).on("tap",".coverDivCls",function(e){
			e.preventDefault();
			e.stopPropagation();           
            log.debug("TAP EVENT CALLED id = "+$(this).attr("id"), ".coverDivCls");
            if(!$('#stepId_4').hasClass("step4-on"))
            {                        
                var selFrmId = $(this).attr("id").split("-")[1];
                if(currObj.bCanvasAnyElmSel){
                    currObj.callOutSideTap();
                }else{
                        currObj.onTapEvent(selFrmId);             
               }
    			currObj.isEdited=true;
			}
	        return false;
	}).on("touchstart",".coverDivCls",function(e){
        e.preventDefault();
        if(log.bDebug){
            log.debug("TOUCHSTART EVENT EVENT CALLED1", ".coverDivCls");
        }
        currObj.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX
                                                ,y:e.originalEvent.changedTouches[0].clientY};

    }).on("touchend touchcancel",".coverDivCls",function(e){
        e.preventDefault();
        if(log.bDebug){
            log.debug("TOUCHEND & TOUCH CANCEL EVENT CALLED", ".coverDivCls");
        }        
        currObj.dragLocation=DEFAULT_VALUE;
    });
    log.debug("COMPLETED", "addEventForFrame");
};
template.prototype.snglTapOnMnFrmElm=function(elmObj)
{
    log.debug("Start ID: "+elmObj.attr("id"),"snglTapOnMnFrmElm"); 
    var tapDivID=elmObj.attr("id");   
    this.showMainFrameElmCp(tapDivID);    
    this.setDragElmFrame(tapDivID);      
    log.debug("End","snglTapOnMnFrmElm");  
};
template.prototype.dblTapOnMnFrmElm=function(elmObj)
{
    log.debug("Start- ID:"+elmObj.attr("id"),"dblTapOnMnFrmElm");    
    if(elmObj.attr("type")==TEXT){
        var tapDivID=elmObj.attr("id"); 
        if($("#"+tapDivID+"_InrElm").html()==MIA_SID_DOUBLE_TAP_TO_EDIT)
        {            
           $("#"+tapDivID+"_InrElm").html('');         
        }
        this.openTxtEditScreen(tapDivID);      
    } 
   log.debug("END","dblTapOnMnFrmElm");       
};
template.prototype.openTxtEditScreen=function(tapDivID)
{
    log.debug("For DivID1: "+ tapDivID,"openTxtEditScreen");
    this.isEdited=true;
    this.currSelTxtDivId = tapDivID;
    var text=$("#"+tapDivID+"_InrElm").html().replace(/<br>/g,"\r").replace(/<br\/>/g,"\r");
    text=text.replace(/&nbsp;/ig,"");
    text=text.replace(/&amp;/ig,"&");
    $("#txtEditAreaId").val(text);    
    $("#enterText").show();    
    $("#txtEditAreaId").focus();    
    log.debug("Complete","openTxtEditScreen");
};
template.prototype.closeTxtEditScreen=function(iText)
{
    log.debug("For Text: "+ iText+",currSelTxtDivId: "+this.currSelTxtDivId,"closeTxtEditScreen");
    $("#"+this.currSelTxtDivId+"_InrElm").html(iText);
    $("#enterText").hide();    
    onTextBlur($("#"+this.currSelTxtDivId+"_InrElm")[0]);        
    log.debug("Complete","closeTxtEditScreen");
};
template.prototype.setFocusonTextElm=function(tapDivID)
{
    this.currSelTxtDivId = tapDivID;
    this.textImageShow(tapDivID, false);
    $("#"+tapDivID+"_InrElm").focus();
    $("#"+tapDivID+"_InrElm").css({'z-index':'9999999'});        
    setCursorToEnd($("#"+tapDivID+"_InrElm")[0]);
};
template.prototype.resizeTextToTabSize=function(lfdFontSize)
{
     var fontSize=10;
     try
     { 
         fontSize=getParseIntInDec(lfdFontSize);
         var heightRatio = this.mainFrame.h / this.lfdSize.h;
         fontSize=Math.round(fontSize*heightRatio);
     }
     catch(ex)
     {         
         log.debug("Exception: "+ex,"resizeTextToTabSize");
     }       
     return fontSize;
};
template.prototype.rePosMnFrmElmnt=function(elmID)
{  
    this.mainFrameSelElmObj.x = this.currMnFrmObjProp.x;
    this.mainFrameSelElmObj.y = this.currMnFrmObjProp.y;
    this.mainFrameSelElmObj.h = this.currMnFrmObjProp.h;
    this.mainFrameSelElmObj.w = this.currMnFrmObjProp.w; 
    this.resetMnFrmElementPos(elmID,this.mainFrameSelElmObj);   
};
template.prototype.resetMnFrmElementPos=function(elmID, ele){
    log.debug("START","resetMnFrmElementPos");
    this.setDimXYWH(elmID,ele.x,ele.y,ele.w,ele.h);
    this.setDimXYWH("ElmCover-"+elmID,ele.x,ele.y,ele.w,ele.h);
    this.setDimXYWH(elmID+"_InrElm",ele.x,ele.y,ele.w,ele.h);
    log.debug("COMPLETED","resetMnFrmElementPos");
};
template.prototype.addEventForMnFrmCP=function()
{
    log.debug("-1---START---","addEventForMnFrmCP");
	var currObj=this;
	currObj.unbindEvent('.mainFrameElmCoverCls',"tap touchstart touchcancel touchend");
    $(document).on("tap",".mainFrameElmCoverCls",function(e){
        e.preventDefault();
        e.stopPropagation();
        log.debug("1ON TAP EVENT  MAIN_FRAME_ELM",".mainFrameElmCoverCls");
        var tapDivID=($(this).attr("id")).replace("ElmCover-","");
        if (currObj.clickTimer == null) {
            currObj.clickTimer = setTimeout(function () {
                if(currObj.bCanvasAnyElmSel){
                    currObj.callOutSideTap();
                }else{
                    currObj.onMainFrameTap();
              }
                currObj.clickTimer = null;
            }, 200);
        } else {
            clearTimeout(currObj.clickTimer);
            currObj.clickTimer = null;
            currObj.onMainFrameTap();
            currObj.dblTapOnMnFrmElm($("#"+tapDivID));
        }
        return false;
    }).on("touchstart",".mainFrameElmCoverCls",function(e){
        e.preventDefault();
        var coverId =$(this).attr("id");
        var tapDivID=coverId.replace("ElmCover-","");
        currObj.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX
          ,y:e.originalEvent.changedTouches[0].clientY};          
        if($("#"+coverId).hasClass("mainFrameElmSelCls"))
        {	
            if(log.bDebug){
                log.debug("ON TOUCHSTART EVENT  MAIN_FRAME_ELM",".mainFrameElmCoverCls");
            }
            currObj.dragLocation=MAIN_FRAME_ELM;
            currObj.mainElmDragBtnID=tapDivID;
            currObj.setDragElmFrame(tapDivID);			
            currObj.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX,
                y:e.originalEvent.changedTouches[0].clientY
            };      
        }
    }).on("touchend touchcancel",".mainFrameElmCoverCls",function(e){
        e.preventDefault();
        if(log.bDebug){
            log.debug("ON TOUCHEND EVENT  MAIN_FRAME_ELM",".mainFrameElmCoverCls");
        }
        var coverId =$(this).attr("id");
        var tapDivID=coverId.replace("ElmCover-","");
        if(currObj.mainElmDragBtnID != tapDivID){            
            log.debug("WRONG ELEMENT TOUCHEND EVENT  MAIN_FRAME_ELM",".mainFrameElmCoverCls");
            return;
        }
        currObj.dragLocation=DEFAULT_VALUE;
        if(currObj.dragElmFrame!=null && $("#ElmCover-"+currObj.mainElmDragBtnID).hasClass("mainFrameElmSelCls"))
        {					
            
                var currActiveElm=currObj.dragElmFrame.getActiveElement();
                currActiveElm=currActiveElm.textElms[currActiveElm.actvTxtElmIndx];                            
                currActiveElm.x=getParseIntInDec($("#"+currObj.mainElmDragBtnID).css("left"));
                currActiveElm.y=getParseIntInDec($("#"+currObj.mainElmDragBtnID).css("top"));
                if(currObj.dragElmFrame.id.indexOf("_Main")==-1)
                {
                    currActiveElm.x=currActiveElm.x+currObj.dragElmFrame.x;
                    currActiveElm.y=currActiveElm.y+currObj.dragElmFrame.y;                    
                }
                 if(currActiveElm.elmType==STICKER){
                    currObj.stickerCopyInfoObj.setStickerCopyInfo(TStickerCopyDir.NONE, currActiveElm.x, currActiveElm.y);
                }
        }
        currObj.mainElmDragBtnID="";
    });
    
    currObj.unbindEvent('.mainFrameElmCpCLs',"touchstart touchcancel touchend");
    $(document).on("touchstart",".mainFrameElmCpCLs",function(e){
        e.preventDefault();
        e.stopPropagation();        
        if(log.bDebug){
            log.debug("ON TOUCHSTART EVENT  MAIN_FRAME_ELM_CP",".mainFrameElmCpCLs");
        }
        currObj.dragLocation=MAIN_FRAME_ELM_CP;
        currObj.mainElmDragBtnID=$(this).attr("id");
        var tapDivID=$(this).attr("id").split("-CP_")[0];
        $(this).addClass("mainFrameElmCpSelCLs");	
        currObj.cpDragStartPt = {x:e.originalEvent.changedTouches[0].clientX,y:e.originalEvent.changedTouches[0].clientY};
        currObj.setDragElmFrame(tapDivID);    
        if (currObj.clickTimer == null) {            
            currObj.clickTimer = setTimeout(function () {                
                currObj.clickTimer = null;
                isDblTapped=false;
            }, 350);
        } else {            
            clearTimeout(currObj.clickTimer);
            currObj.clickTimer = null;
            isDblTapped=true;            
            currObj.dblTapOnMnFrmElm($("#"+tapDivID));
        }
    }).on("touchend touchcancel",".mainFrameElmCpCLs",function(e){
        e.preventDefault();
        e.stopPropagation();
        $(this).removeClass("mainFrameElmCpSelCLs");
        if(currObj.mainElmDragBtnID!=$(this).attr("id")){
            log.debug("WRONG ELEMENT TOUCHEND EVENT  MAIN_FRAME_ELM_CP",".mainFrameElmCpCLs");
            return;
        }
        currObj.dragLocation=DEFAULT_VALUE;        
        if(currObj.dragElmFrame!=null  && !isDblTapped)
        {
            var elmID=currObj.mainElmDragBtnID.split("-CP_")[0];
            var isText=false;
            var currActiveElm=currObj.dragElmFrame.getActiveElement();                           
            currActiveElm=currActiveElm.textElms[currActiveElm.actvTxtElmIndx];
            var currElmType=currActiveElm.elmType;                                        
            if(currElmType==TEXT)
            {
                isText=true;
            }  
            var $elm=$("#"+elmID);
            currActiveElm.x=getParseIntInDec($elm.css("left"));
            currActiveElm.y=getParseIntInDec($elm.css("top"));
            currActiveElm.w=getParseIntInDec($elm.css("width"));
            currActiveElm.h=getParseIntInDec($elm.css("height"));
            if(currObj.dragElmFrame.id.indexOf("_Main")==-1)
            {
                currActiveElm.x=currActiveElm.x+currObj.dragElmFrame.x;
                currActiveElm.y=currActiveElm.y+currObj.dragElmFrame.y;                                            
            }
            if(isText)
            {
                currObj.textImageUpdate(elmID);
            }        
            var cord=currObj.gtRelPosOfFrmOrElm(currActiveElm);           
            currObj.cpDragStartPt.x = cord.x1;
            currObj.cpDragStartPt.y = cord.y1;
            currObj.snglTapOnMnFrmElm($elm);
        }
        currObj.mainElmDragBtnID="";	
    });
    currObj.unbindEvent("#"+currObj.mainFrame.id,"touchmove");
    $(document).on('touchmove',"#"+currObj.mainFrame.id,function(e){
        e.preventDefault();
        var t = e.originalEvent.changedTouches;        
        if (t.length > 1)
        {
            return;
        }
        switch(currObj.dragLocation)
        {
            case MAIN_FRAME_ELM_CP:
                currObj.onMnFrmElmCpDrag(e);
            break;
            case MAIN_FRAME_ELM:
                currObj.onMainFrameElmDrag(e);
            break;                
            case MNFRM_ROT_ELMCP:
               currObj.rotateElmFreeAngle(e);
            break; 
            case BLANK_INNER_FRAME_CP:
                  /*Same function is used for dragging of BLANK FRAME CP & Main frame ele's*/
                   currObj.onMnFrmElmCpDrag(e);
             break;           
            case FRAME_ROTATION:
                if(rotateMode)
                {       
                    currObj.rotateElement(e, currRotateObj, elem_center_x, elem_center_y);
                }
            break;   
            default:
            break;
        }
    });  
    /*handling outside tap event to unselected any selected element*/
    currObj.unbindEvent('#tplMainContainer',"tap");  
    $(document).on('tap',"#tplMainContainer", function(e)
    {   
        log.debug("tplMainContainer TAP EVENT CALLED", "tplMainContainer");
        if(currObj.isTmpltListVisible()){            
            currObj.shiftTemplateForMenu(DOWN);
        } 
        closeAuthorMenu();
        hideBottomMenu();
        currObj.cpDragStartPt={x:-20,y:-20};
        currObj.handleUndoEvent(ACTIVE_FRAME);      
        currObj.hideCtrlPtsForFrameID(ACTIVE_FRAME,false);
        currObj.showMainFrame();        
        currObj.hideMainFrameAllElmCp();             
        $("#frameResDivID").hide();
    });
};
template.prototype.unbindEvent=function(classOrId,eventList)
{
    $(document).off(eventList, classOrId);
};
template.prototype.hideItemList=function(iFlag)
{    
    if(iFlag)
    {
        $("#frameImagesDivId").hide();            
        this.isListVisible=false;
    }
    else
    {
        $("#frameImagesDivId").show();            
        this.isListVisible=true;
    }  
};

template.prototype.rotateElmFreeAngle = function(e){
    var mouse_x = pointerEventToXY(e).x; 
    var mouse_y = pointerEventToXY(e).y;        
    var radians = Math.atan2(mouse_x - this.cpDragStartPt.x, mouse_y - this.cpDragStartPt.y);
    var degree = (radians * (180 / Math.PI) * -1) + 180;
    var divID=this.mainElmDragBtnID.split("-CP_")[0];
    this.setMainFrmElmAngle(divID,degree);         
};
template.prototype.setMainFrmElmAngle=function(divID,angle)
{
    $("#"+divID+",#ElmCover-"+divID).css('transform', 'rotate('+angle+'deg)');
    $("#"+divID).attr("angle",angle); 
};

template.prototype.updtPosOfAllTextOfSsElm=function(frame)
{
	var currActiveElm=frame.getActiveElement();
	var textIndex=currActiveElm.actvTxtElmIndx;
	currActiveElm=currActiveElm.textElms[textIndex];		
	var eleLength=frame.element.length;
	for(var i=0;i<eleLength;i++)
	{
		if(i!=frame.activeEleIndex)
		{
			var elm=frame.element[i].textElms[textIndex];
			elm.x=currActiveElm.x;
			elm.y=currActiveElm.y;
			elm.h=currActiveElm.h;
			elm.w=currActiveElm.w;				
		}
	}		
};
template.prototype.renderMnFrmElmnts=function()
{
	var elmCount=this.mainFrame.element.length;
	var elmnt;
	for(var i=0;i<elmCount;i++)
	{
		elmnt=this.mainFrame.element[i];
		this.renderElmntOnMnFrm(elmnt,i);		
	}	
};
template.prototype.onMainFrameElmDrag=function(e)
{	
	if($("#ElmCover-"+this.mainElmDragBtnID).hasClass("mainFrameElmSelCls"))
	{		
		var touches = e.originalEvent.changedTouches;
	    var deltaX = (touches[0].clientX - this.cpDragStartPt.x)/this.mainFrame.scale;
	    var deltaY = (touches[0].clientY- this.cpDragStartPt.y)/this.mainFrame.scale;
	    this.cpDragStartPt.x = touches[0].clientX;
	    this.cpDragStartPt.y = touches[0].clientY;
	    var currLeft=this.mainFrameSelElmObj.x+deltaX;
	    var currTop=this.mainFrameSelElmObj.y+deltaY;
	    var currWidth=this.mainFrameSelElmObj.w;
	    var currHeight=this.mainFrameSelElmObj.h;
	    if(currLeft<0)
	    {
	       currLeft=0; 
	    }
	    if(currTop<0)
	    {
	        currTop=0;
	    }
	    if(currLeft+currWidth>this.dragElmFrame.w)
	    {
	        currLeft=this.dragElmFrame.w-currWidth;
	    }
	    if(currTop+currHeight>this.dragElmFrame.h)
	    {
	        currTop= this.dragElmFrame.h-currHeight;
	    }
	 
		    this.mainFrameSelElmObj.x = currLeft;
            this.mainFrameSelElmObj.y = currTop;
         
            $("#"+this.mainElmDragBtnID).css({
                'left':this.mainFrameSelElmObj.x+'px'
                ,'top':this.mainFrameSelElmObj.y+'px'
            });
            $("#ElmCover-"+this.mainElmDragBtnID).css({
                'left':this.mainFrameSelElmObj.x+'px'
                ,'top':this.mainFrameSelElmObj.y+'px'
            });
            $("#"+this.mainElmDragBtnID+"_InrElm").css({
                'left':this.mainFrameSelElmObj.x+'px'
                ,'top':this.mainFrameSelElmObj.y+'px'
            });
   }
};
template.prototype.onMnFrmElmCpDrag=function(e)
{
	var evtElmIndex=getParseIntInDec(this.mainElmDragBtnID.split("-CP_")[1]);	
    this.isCroppedMode = false;
	var touches = e.originalEvent.changedTouches;
    var deltaX = (touches[0].clientX - this.cpDragStartPt.x)/this.mainFrame.scale;
    var deltaY = (touches[0].clientY - this.cpDragStartPt.y)/this.mainFrame.scale;
     this.cpDragStartPt.x = touches[0].clientX;
    this.cpDragStartPt.y = touches[0].clientY;
    var elmID=this.mainElmDragBtnID.split("-CP_")[0];
    var currLeft=this.mainFrameSelElmObj.x;
    var currTop=this.mainFrameSelElmObj.y;
    var currWidth=this.mainFrameSelElmObj.w;
    var currHeight=this.mainFrameSelElmObj.h;
    switch(evtElmIndex)
    {
        case 0:
            deltaX=deltaY=(deltaX+deltaY)/2;            
            deltaY=deltaX/(currWidth/currHeight);            
            currLeft=currLeft+deltaX;
            currTop=currTop+deltaY;
            currWidth=currWidth-deltaX;
            currHeight=currHeight-deltaY;
        break;
        case 1:
            currTop=currTop+deltaY;
            currHeight=currHeight-deltaY;
        break;
        case 2:
            if(deltaY>=0 && deltaX<=0)
            {
                deltaX=deltaY=-((deltaX*-1)+deltaY)/2;
            }
            else
            {
                deltaX=deltaY=(deltaX+(deltaY*-1))/2;
            }
            deltaY=deltaX/(currWidth/currHeight);
            currTop=currTop-deltaY;
            currWidth=currWidth+deltaX;
            currHeight=currHeight+deltaY;
        break;
        case 3:
            currWidth=currWidth+deltaX;
        break;
        case 4:
            deltaX=deltaY=(deltaX+deltaY)/2;
            deltaY=deltaX/(currWidth/currHeight);
            currWidth=currWidth+deltaX;
            currHeight=currHeight+deltaY;
        break;
        case 5:
            currHeight=currHeight+deltaY;
        break;
        case 6:
            if(deltaY>=0 && deltaX<=0)
            {
                deltaX=deltaY=-((deltaX*-1)+deltaY)/2;
            }
            else
            {
                deltaX=deltaY=(deltaX+(deltaY*-1))/2;
            }
            deltaY=deltaX/(currWidth/currHeight);
            currLeft=currLeft+deltaX;
            currWidth=currWidth-deltaX;
            currHeight=currHeight-deltaY;
        break;
        case 7:
            currLeft=currLeft+deltaX;
            currWidth=currWidth-deltaX;
        break;
        default:
        break;
    }	  
    
    if(currLeft>=0
        && currTop>=0 
        && (currLeft+currWidth)<=this.dragElmFrame.w 
        && (currTop+currHeight)<=this.dragElmFrame.h)
    {
        if(currWidth >= MIN_HW_MAIN_FRM_ELM && currHeight>=MIN_HW_MAIN_FRM_ELM)
        { 
                this.setDimXYWH(elmID,currLeft,currTop,currWidth,currHeight);
                this.setDimXYWH("ElmCover-"+elmID,currLeft,currTop,currWidth,currHeight);
                this.setDimXYWH(elmID+"_InrElm",currLeft,currTop,currWidth,currHeight);
                this.updateMainFrameCpPosition(elmID);                   
                this.mainFrameSelElmObj.x = currLeft;
                this.mainFrameSelElmObj.y = currTop;
                this.mainFrameSelElmObj.w = currWidth;
                this.mainFrameSelElmObj.h = currHeight;         
        }
    }
};
template.prototype.hideMainFrameAllElmCp=function()
{    
   this.processKeyBoardClose();
   this.resetZIndexMnFrmElm();
	$(".mainFrameElmCpCLs").remove();
	$(".mnFrmElmRotCpCls").remove();
    $(".mainFrameElmSelCls").css({
        'box-shadow': '0px 0px 0px 0px #3196ff'
        ,'-webkit-box-shadow':  '0px 0px 0px 0px #3196ff'
    });
	$(".mainFrameElmCoverCls").removeClass("mainFrameElmSelCls");
    this.bCanvasAnyElmSel = false;
};
template.prototype.showMainFrameElmCp=function(divID)
{
	this.hideMainFrameAllElmCp();	
	$("#ElmCover-"+divID).addClass("mainFrameElmSelCls");
	var elmType=getParseIntInDec($("#"+divID).attr("type"));
	if(elmType==HANDWRITING)
    {
        $("#ElmCover-"+divID).append('<div id="'+divID+'-CP_'+this.mainCpCount+'" class="mnFrmElmRotCpCls"></div>');
    }	
	for(var j=0;j<this.mainCpCount;j++)
	{
		$("#ElmCover-"+divID).append('<div id="'+divID+'-CP_'+j+'" class="mainFrameElmCpCLs"></div>');
		$("#"+divID+'-CP_'+j).css({
			'-webkit-transform':'rotate('+cpRotationAngle[j]+'deg)',
    		'transform':'rotate('+cpRotationAngle[j]+'deg)'	
    	});
	}	
	$("#ElmCover-"+divID).css({
        'z-index':MAX_COVER_DIV_Z_INDEX
    });
    this.bCanvasAnyElmSel = true;    
	this.updateMainFrameCpPosition(divID);		
};
template.prototype.updateMainFrameCpPosition=function(iDivId)
{
    log.debug("This.mainFrame.scale="+this.mainFrame.scale+" "+$(".mainFrameElmCpCLs").width(),"updateMainFrameCpPosition");
    var zmObj=this.getZmdHWofCpBdr();
    var boxBdrHlfW=(zmObj.border/2);
    $(".mainFrameElmCpCLs").css({
        'height':zmObj.hw+'px'
        ,'width':zmObj.hw+'px'
    });
    if($(".mainFrameElmSelCls").length!= -1){
        $(".mainFrameElmSelCls").css({
            'box-shadow': '0px 0px 0px '+zmObj.border+'px #3196ff'
            ,'-webkit-box-shadow':  '0px 0px 0px '+zmObj.border+'px #3196ff'
        });
    }    
	var rectW=$("#"+iDivId).width();
    var rectH=$("#"+iDivId).height();
    var hlfCpHW=zmObj.hw/2; 
    var hlfRectH=Math.round(rectH/2);
    var hlfRectW=Math.round(rectW/2);	
	var cpArray=[[0-hlfCpHW-boxBdrHlfW,0-hlfCpHW-boxBdrHlfW]
                ,[hlfRectW-hlfCpHW,0-hlfCpHW-boxBdrHlfW]
                ,[rectW-hlfCpHW+boxBdrHlfW,0-hlfCpHW-boxBdrHlfW]
                ,[rectW-hlfCpHW+boxBdrHlfW,hlfRectH-hlfCpHW]
                ,[rectW-hlfCpHW+boxBdrHlfW,rectH-hlfCpHW+boxBdrHlfW]
                ,[hlfRectW-hlfCpHW,rectH-hlfCpHW+boxBdrHlfW]
                ,[0-hlfCpHW-boxBdrHlfW,rectH-hlfCpHW+boxBdrHlfW]
                ,[0-hlfCpHW-boxBdrHlfW,hlfRectH-hlfCpHW]
                ];
	var i;						
	for(i=0;i<this.mainCpCount;i++)
	{
		$("#"+iDivId+"-CP_"+i).css({
			'left':cpArray[i][0]+'px'
			,'top':cpArray[i][1]+'px'
		});
	}
	var widthType = $("#"+iDivId).attr("type");
	if(widthType==HANDWRITING)
	{
	    var iCpHW=Math.round(ROTATE_HANDLER_HW/this.mainFrame.scale);
        $("#"+iDivId+"-CP_"+i).css({
            'width':iCpHW+'px'
            ,'height':iCpHW+'px'
            ,'left':Math.round((rectW-iCpHW)/2)+'px'
            ,'top':'-'+iCpHW+'px'
        });
	}	
};
template.prototype.getCurrModeStr=function()
{
    var mode;
    if(this.orientation==LANDSCAPE)
    {
        mode="landscape";
    }
    else
    {
        mode="portrait";
    }
    return mode;
};
template.prototype.fillFramesFromImageUrl=function(imageURLs,vIsArray,iCat)
{
	this.imageUrls=imageURLs;
    this.videoIsArray=vIsArray;
    this.selCategory=iCat;  
    this.renderAdClip();  
};
template.prototype.createElmFromObjData=function(iObj,type)
{
    var element = new elementInfo( 0, 0, iObj.imgPath,type);
    element.thumbPath= Utils.encodeThumbPath(iObj.thumbPath);
    element.OriginalPath=iObj.orgImgPath;
    element.orgW=iObj.orgW;
    element.orgH=iObj.orgH;
    element.fileName=iObj.fileName;
    element.duration=iObj.duration;
    return element;	   
};

template.prototype.adjustFrameRects = function(){
    var xPtsArray = [];
    var yPtsArray = [];
    if(xPtsArray.length == 0){
        xPtsArray.push(0);
        xPtsArray.push(this.mainFrame.w);
    }
    if(yPtsArray.length == 0){
        yPtsArray.push(0);
        yPtsArray.push(this.mainFrame.h);
    }
    for(var frameId in this.innerFrames){
        var frame = this.getInnerFrameForId(frameId);
        if($.inArray(frame.x, xPtsArray) == -1){
            xPtsArray.push(frame.x);
        }
        if($.inArray(frame.y, yPtsArray) == -1){
            yPtsArray.push(frame.y);
        }
    }   
    for(var frameId in this.innerFrames){
        var frame = this.getInnerFrameForId(frameId);
        var w = frame.x + frame.w;
        if($.inArray(w, xPtsArray) == -1){
            if($.inArray(w+1, xPtsArray) == -1){
                if($.inArray(w-1, xPtsArray) != -1){
                    frame.w -= 1;
                }
            }else{
                frame.w += 1;
            }
        }
        var h = frame.y + frame.h;
        if($.inArray(h, yPtsArray) == -1){
            if($.inArray(h+1, yPtsArray) == -1){
                if($.inArray(h-1, yPtsArray) != -1){
                    frame.h -= 1;
                }
            }else{
                frame.h += 1;
            }
        }
    }
};
template.prototype.simTapActviveElmnt=function()
{
   log.debug("START","simTapActviveElmnt");
   var frame= this.getActiveFrame();
   $("#"+frame.id+"_chkBox-"+frame.activeEleIndex+".chkBoxDivCls").trigger("tap");
   log.debug("COMPLETE","simTapActviveElmnt"); 
};
template.prototype.setThumbBgImg=function(frameID,index,thumbPath)
{
    log.debug("START","setThumbBgImg");
    $("#"+frameID+"_thumbImg-"+index).css({
            "background-image":"url('"+thumbPath+"?ts="+getTimeWithMiliSec()+"')"
    });
};
template.prototype.replaceElmOfFrame=function(frame,elm,indx,iToken)
{   
    var currFrmElm=frame.element[indx];
    currFrmElm.imageSrc=elm.imageSrc;
    currFrmElm.smallSizeImg=elm.smallSizeImg;
    currFrmElm.thumbPath=elm.thumbPath;
    currFrmElm.OriginalPath=elm.OriginalPath;
    currFrmElm.orgW=elm.orgW;
    currFrmElm.orgH=elm.orgH;
    currFrmElm.fileName=elm.fileName;
    currFrmElm.duration=elm.duration;
    currFrmElm.scale = 1;
    currFrmElm.xOffset = 0;
    currFrmElm.yOffset = 0;    
    currFrmElm.margin={t:0,r:0,b:0,l:0};
    currFrmElm.initXOffset = 0;
    currFrmElm.initYOffset = 0;
    currFrmElm.x = 0;
    currFrmElm.y = 0;
    currFrmElm.w = 0;
    currFrmElm.h = 0;    
    this.setImageElmAspectFillByDefault(frame.id, currFrmElm);    
    this.setThumbBgImg(frame.id,indx,currFrmElm.thumbPath);
    this.isAdClipMode=true;
    this.createCroppedImage(iToken,indx);
};
template.prototype.getNewElmFromOldElm=function(elm)
{
    var element = new elementInfo( 0, 0,elm.smallSizeImg,elm.elementType);
    element.thumbPath= elm.thumbPath;
    element.OriginalPath=elm.OriginalPath;
    element.orgW=elm.orgW;
    element.orgH=elm.orgH;
    element.fileName=elm.fileName;
    element.duration= elm.duration;
    return element;
};
template.prototype.swapSlotData=function(slot1,slot2)
{
    log.debug("START 16-Swap for slot1:"+slot1+"---slot2:"+slot2,"swapSlotData");
    this.resetUpdtSlotCallObj();
    var slot1Indx=getParseIntInDec(slot1.split("-")[1]);
    var slot2Indx=getParseIntInDec(slot2.split("-")[1]);
    var frame=this.getActiveFrame();
    var elm1=frame.element[slot1Indx];
    var elm2=frame.element[slot2Indx];        
    if(this.isRplcableSlot(elm1) && this.isRplcableSlot(elm2)){        
        var newElm1=this.getNewElmFromOldElm(elm1);
        var newElm2=this.getNewElmFromOldElm(elm2);
        frame.activeEleIndex=slot1Indx; 
        this.replaceElmOfFrame(frame,newElm1,slot2Indx,0);
        this.replaceElmOfFrame(frame,newElm2,slot1Indx,0);
    }
    else
    {        
        this.unReplcbleSlotTost();
    }
    this.simTapActviveElmnt();
    log.debug("COMPLETED","swapSlotData");
};
template.prototype.swapElementData=function(elm1,elm2)
{
    this.swapElmProp(elm1,elm2,"orgW");
    this.swapElmProp(elm1,elm2,"orgH");
    this.swapElmProp(elm1,elm2,"imageSrc");
    this.swapElmProp(elm1,elm2,"thumbPath");
    this.swapElmProp(elm1,elm2,"OriginalPath");
    this.swapElmProp(elm1,elm2,"fileName");
    this.swapElmProp(elm1,elm2,"x");
    this.swapElmProp(elm1,elm2,"y");
    this.swapElmProp(elm1,elm2,"w");
    this.swapElmProp(elm1,elm2,"h");
    this.swapElmProp(elm1,elm2,"xOffset");
    this.swapElmProp(elm1,elm2,"yOffset");
    this.swapElmProp(elm1,elm2,"margin");
    this.swapElmProp(elm1,elm2,"initXOffset");
    this.swapElmProp(elm1,elm2,"initYOffset");
    this.swapElmProp(elm1,elm2,"scale");
};
template.prototype.swapElmProp=function(elm1,elm2,prop)
{
    var temp=elm1[prop];
    elm1[prop]=elm2[prop];
    elm2[prop]=temp;
};
template.prototype.isRplcableSlot=function(elmObj)
{
    if(elmObj.slotType==slotType.SLOT_IMAGE || elmObj.slotType==slotType.SLOT_IMAGE_SEPARATOR)
    {
        return true;
    }
    return false;
};
template.prototype.setDummyDivPos=function(event)
{
     var pageX=event.originalEvent.changedTouches[0].clientX;
     var pageY=event.originalEvent.changedTouches[0].clientY;
     var $dummyDiv=$("#dummyDivID");
     var calW=Math.round($dummyDiv.width()/2);
     var calH=Math.round($dummyDiv.height()/2);                        
     $dummyDiv.css({
        'top':pageY-calH+'px'
        ,'left':pageX-calW+'px' 
    });
};
template.prototype.replaceCurrElmOfFrame=function(frame,elm)
{
	this.resetUpdtSlotCallObj();
    this.replaceElmOfFrame(frame,elm,frame.activeEleIndex,1);   
    this.renderActvElmOfFrame(frame.id);
};
template.prototype.triggerTapForFrame=function(frame)
{
    $("#frameCover-"+frame.id+".coverDivCls").trigger("tap");
};
template.prototype.getFrameAtDropPoint=function(dropPt){
    log.debug("START ","getFrameAtDropPoint");
    var frameId = "";
    var frame1 = null,frame = null;
    for(var index=this.innerFrameZOrderArr.length-1;index>=0;index--){
        frameId = FRAME_ID_PREFIX+this.innerFrameZOrderArr[index];
        frame = this.getInnerFrameForId(frameId);
        if(this.isPointInsideFrame( dropPt, frame))
        {
        	frame1=frame;
        	break;
        }
    }
    log.debug("COMPLETED FRAME ID= ","getFrameAtDropPoint");
    return frame1;
};

template.prototype.getElementType=function(strType){
    var eleType = EMPTY;
    switch(strType){
        case "image":
            eleType = IMAGE;
            break;
        case "video":
            eleType = VIDEO;
            break;     
        default:
            break;
    }
    return eleType;
};
template.prototype.openMenuAftrDrop=function(eleType)
{
    switch(eleType)
    {      
        case TEXT:
        case STICKER:
            showBtmMenuDtaDv(eleType);
        break;       
        default:
            showBtmMenuDtaDv(GALLERY);         
        break;
    }   
};
template.prototype.isTxtTypeElm=function(elmType)
{
    if(elmType==TEXT)
    {
        return true;
    }
    return false;
};
template.prototype.addElementInFrame=function(elmObj,dropX,dropY,flag)
{	
	var currObj=this;
	var frame = null;
	var foundFlag=false;
	var eleType = this.getElementType(elmObj.type);
    var dropPt = {x:dropX,y:dropY};
    if(!this.isPointInsideMainFrame({x:dropX,y:dropY}))
    {
        Utils.showToast(MIA_SID_DESIGN_ELEMENTS_ADDED_INSID_CANVAS);
        return;
    }     
     /*finding frame at drop location*/
    frame = this.getFrameAtDropPoint(dropPt);
    if(frame == null){
        Utils.showToast(MIA_SID_DESIGN_ELEMENTS_ADDED_INSID_CANVAS);
        return;
    }   
    var currElm=frame.element[frame.activeEleIndex];
    if(!this.isRplcableSlot(currElm))
    {
        this.unReplcbleSlotTost();
        return;
    }
   
	genericPopUpObj.createPopUp("","Type1");
	var elm=currObj.createElmFromObjData(elmObj,eleType);
	switch(eleType)
	{
		case IMAGE:
			var img=new Image();
			img.onload=function(){
                if(elmObj.orgW==0 || elmObj.orgH==0)
                {
                    elmObj.orgW=this.width;
                    elmObj.orgH=this.height;
                }
				elm = currObj.createElmFromObjData(elmObj,eleType);
				currObj.replaceCurrElmOfFrame(frame,elm);
			};
            elmObj.imgPath = Utils.encodeThumbPath(elmObj.imgPath);
			img.src=elmObj.imgPath;		
		break;		
		default:
		break;				
	}	
};
template.prototype.renderTemplate=function()
{
      var currObj=this;
    $("#"+currObj.mainFrame.id).empty();    
    currObj.adjustFrameRects();
    currObj.showMainFrame();    
    var frame,cpIndx;
    for(var count = 0;count<currObj.frameCount;count++){
        frame = currObj.getInnerFrameForId(FRAME_ID_PREFIX+count);
        currObj.addFrameToMainDiv(frame);   
    }     
    currObj.isEdited=true;
    isListRendrOnce=false;        
    log.debug("COMPLETED2","renderTemplate");  
};
template.prototype.addFrameToMainDiv=function(frame)
{        
   $("#"+this.mainFrame.id).append('<div id="'+frame.id+'" class="tpl_frameCls"></div>');
   this.setDimXYWH(frame.id,frame.x,frame.y,frame.w,frame.h);  
   this.renderActvElmOfFrame(frame.id);  
};
template.prototype.getImgElmCropCoord=function(elmInfo, frame){
    var cropCord;
    if(elmInfo.rotation == 90 || elmInfo.rotation == 270){
        cropCord = this.getImgElmCropCoord90270(elmInfo, frame);
    }else{
        cropCord = this.getImgElmCropCoord0180(elmInfo, frame);
    }
    return cropCord;
};

template.prototype.getImgElmCropCoord0180=function(elmInfo, frame){    
    log.debug("complete elmInfo = "+elmInfo.orgW+" elmInfo.orgH "+elmInfo.orgH+" elmInfo.x ="+elmInfo.x+" elmInfo.y "+elmInfo.y+" elmInfo.w "+elmInfo.w+" elmInfo.h "+elmInfo.h+" elmInfo.xOffset "+elmInfo.xOffset+" elmInfo.yOffset "+elmInfo.yOffset+" scale = "+elmInfo.scale+" initXOffset "+elmInfo.initXOffset+" initYOffset "+elmInfo.initYOffset,"getImgElmCropCoord");
    var widthRatio = elmInfo.orgW/elmInfo.w;
    var heightRatio = elmInfo.orgH/elmInfo.h;
    var scaledW = elmInfo.w * elmInfo.scale;
    var scaledH = elmInfo.h * elmInfo.scale;
    var cropX = 0;
    var cropY = 0;
    cropX = (scaledW - frame.w)/2;
    cropY = (scaledH - frame.h)/2;
    var offX = 0;
    var offY = 0;
    offX = elmInfo.xOffset - elmInfo.initXOffset;
    offY = elmInfo.yOffset - elmInfo.initYOffset;
    var cenX = (scaledW - frame.w)/2;
    var cenY = (scaledH - frame.h)/2;
    var l = 0;
    var t = 0;
    if(elmInfo.rotation == 180){
        l = cenX + offX;
        t = cenY + offY;
    }else{
        l = cenX - offX;
        t = cenY - offY;
    }
    var r = l + frame.w;
    var b = t + frame.h;
    
    var orgl = (l*widthRatio)/elmInfo.scale;
    var orgt = (t*heightRatio)/elmInfo.scale;
    var orgr = (r*widthRatio)/elmInfo.scale;
    var orgb = (b*heightRatio)/elmInfo.scale;
    if(orgl < 0){
        orgl = 0;
    }
    if(orgt < 0){
        orgt = 0;
    }
    if(orgr > elmInfo.orgW){
        orgr = elmInfo.orgW;
    }
    if(orgb > elmInfo.orgH){
        orgb = elmInfo.orgH;
    }
    log.debug("complete orgl = "+orgl+" orgt "+orgt+" orgb = "+orgb+" orgr "+orgr,"getImgElmCropCoord");
    var cropRect = {l:orgl,t:orgt,r:orgr,b:orgb};  
    return cropRect;
};

template.prototype.getImgElmCropCoord90270=function(elmInfo, frame){    
    log.debug("complete elmInfo = "+elmInfo.orgW+" elmInfo.orgH "+elmInfo.orgH+" elmInfo.x ="+elmInfo.x+" elmInfo.y "+elmInfo.y+" elmInfo.w "+elmInfo.w+" elmInfo.h "+elmInfo.h+" elmInfo.xOffset "+elmInfo.xOffset+" elmInfo.yOffset "+elmInfo.yOffset+" scale = "+elmInfo.scale+" initXOffset "+elmInfo.initXOffset+" initYOffset "+elmInfo.initYOffset,"getImgElmCropCoord90");
    var widthRatio = elmInfo.orgW/elmInfo.w;
    var heightRatio = elmInfo.orgH/elmInfo.h;
    var scaledW = elmInfo.w * elmInfo.scale;
    var scaledH = elmInfo.h * elmInfo.scale;
    var cropX = 0;
    var cropY = 0;
    cropX = (scaledW - frame.h)/2;
    cropY = (scaledH - frame.w)/2;
    var offX = 0;
    var offY = 0;
    offX = elmInfo.xOffset - elmInfo.initXOffset;
    offY = elmInfo.yOffset - elmInfo.initYOffset;
    var cenX = (scaledW - frame.h)/2;
    var cenY = (scaledH - frame.w)/2;
    var l = 0;
    var t = 0;
    if(elmInfo.rotation == 90){
        l = cenX - offY;
        t = cenY + offX;
    }else{
        l = cenX + offY;
        t = cenY - offX;
    }
    
    var r = l + frame.h;
    var b = t + frame.w;
    
    var orgl = (l*widthRatio)/elmInfo.scale;
    var orgt = (t*heightRatio)/elmInfo.scale;
    var orgr = (r*widthRatio)/elmInfo.scale;
    var orgb = (b*heightRatio)/elmInfo.scale;
    if(orgl < 0){
        orgl = 0;
    }
    if(orgt < 0){
        orgt = 0;
    }
    if(orgr > elmInfo.orgW){
        orgr = elmInfo.orgW;
    }
    if(orgb > elmInfo.orgH){
        orgb = elmInfo.orgH;
    }
    log.debug("complete orgl = "+orgl+" orgt "+orgt+" orgb = "+orgb+" orgr "+orgr,"getImgElmCropCoord90");
    var cropRect = {l:orgl,t:orgt,r:orgr,b:orgb};   
    return cropRect;
};
template.prototype.setElmOffsetFrmCropCoord=function(elmInfo, frame, cropRect){
    var cropCord;
    log.debug("elmInfo.rotation = "+elmInfo.rotation,"setElmOffsetFrmCropCoord");
    if(elmInfo.rotation == 90 || elmInfo.rotation == 270){
        cropCord = this.setElmOffsetFrmCropCoord90270(elmInfo, frame, cropRect);
    }else{
        cropCord = this.setElmOffsetFrmCropCoord0180(elmInfo, frame, cropRect);
    }
};
template.prototype.setElmOffsetFrmCropCoord90270=function(elmInfo, frame, cropRect){    
    log.debug("complete elmInfo = "+elmInfo.orgW+" elmInfo.orgH "+elmInfo.orgH+" elmInfo.x ="+elmInfo.x+" elmInfo.y "+elmInfo.y+" elmInfo.w "+elmInfo.w+" elmInfo.h "+elmInfo.h+" elmInfo.xOffset "+elmInfo.xOffset+" elmInfo.yOffset "+elmInfo.yOffset+" scale = "+elmInfo.scale+" initXOffset "+elmInfo.initXOffset+" initYOffset "+elmInfo.initYOffset,"setElmOffsetFrmCropCoord90270");
    var hRatio = 0,wRatio = 0,newW = 0,newH = 0,margin = 0;
    elmInfo.x=0;
    elmInfo.y=0;
    if(elmInfo.rotation==90 || elmInfo.rotation==270)
    {
        hRatio=frame.w/elmInfo.orgH;
        wRatio=frame.h/elmInfo.orgW;
        if(wRatio > hRatio)
        {
            newW=wRatio*elmInfo.orgW;
            newH=wRatio*elmInfo.orgH;
            margin=getParseIntInDec((newH-frame.w)/2);
            if(margin<0)
            {
                margin=margin*-1;
            }
            elmInfo.y=0;
            elmInfo.initXOffset = -margin;
            elmInfo.initYOffset = 0;
        }else{
            newW=hRatio*elmInfo.orgW;
            newH=hRatio*elmInfo.orgH;
            margin=getParseIntInDec((newW-frame.h)/2);
            if(margin<0)
            {
                margin=margin*-1;
            }
            elmInfo.x=0;
            elmInfo.initXOffset = 0;
            elmInfo.initYOffset = -margin;
        }
        elmInfo.w=newW;
        elmInfo.h=newH;

    }
    var scaledW = elmInfo.w * elmInfo.scale;
    var scaledH = elmInfo.h * elmInfo.scale;
    var widthRatio = elmInfo.orgW/elmInfo.w;
    var heightRatio = elmInfo.orgH/elmInfo.h;
    var l = (cropRect.l * elmInfo.scale)/widthRatio;
    var t = (cropRect.t * elmInfo.scale)/heightRatio;
    var r = (cropRect.r * elmInfo.scale)/widthRatio;
    var b = (cropRect.b * elmInfo.scale)/heightRatio;
    var cenX = (scaledW - frame.h)/2;
    var cenY = (scaledH - frame.w)/2;
    var offX = 0;
    var offY = 0;
    if(elmInfo.rotation==90){
        offX = t - cenY;
        offY = cenX - l;
    }else{
        offX = cenY - t;
        offY = l - cenX;
    }
    elmInfo.xOffset = offX + elmInfo.initXOffset;
    elmInfo.yOffset = offY + elmInfo.initYOffset;
    log.debug("complete offsetX = "+elmInfo.xOffset+" offsetY "+elmInfo.yOffset,"setElmOffsetFrmCropCoord90270");
};
template.prototype.setElmOffsetFrmCropCoord0180=function(elmInfo, frame, cropRect){    
    log.debug("complete elmInfo = "+elmInfo.orgW+" elmInfo.orgH "+elmInfo.orgH+" elmInfo.x ="+elmInfo.x+" elmInfo.y "+elmInfo.y+" elmInfo.w "+elmInfo.w+" elmInfo.h "+elmInfo.h+" elmInfo.xOffset "+elmInfo.xOffset+" elmInfo.yOffset "+elmInfo.yOffset+" scale = "+elmInfo.scale+" initXOffset "+elmInfo.initXOffset+" initYOffset "+elmInfo.initYOffset,"setElmOffsetFrmCropCoord0180");
    var hRatio = 0,wRatio = 0,newW = 0,newH = 0;
    elmInfo.x=0;
    elmInfo.y=0;
    var margin = 0;
    {
        wRatio=frame.w/elmInfo.orgW;
        hRatio=frame.h/elmInfo.orgH;
        if(wRatio > hRatio)
        {
            newW=wRatio*elmInfo.orgW;
            newH=wRatio*elmInfo.orgH;
            margin=getParseIntInDec((newH-frame.h)/2);
            elmInfo.initXOffset = 0;
            elmInfo.initYOffset = -margin;
        }
        else
        {
            newW=hRatio*elmInfo.orgW;
            newH=hRatio*elmInfo.orgH;
            margin=getParseIntInDec((newW-frame.w)/2);
            elmInfo.initXOffset = -margin;
            elmInfo.initYOffset = 0;
        }
        elmInfo.w=newW;
        elmInfo.h=newH;
    }
    var scaledW = elmInfo.w * elmInfo.scale;
    var scaledH = elmInfo.h * elmInfo.scale;
    var widthRatio = elmInfo.orgW/elmInfo.w;
    var heightRatio = elmInfo.orgH/elmInfo.h;
    var l = (cropRect.l * elmInfo.scale)/widthRatio;
    var t = (cropRect.t * elmInfo.scale)/heightRatio;
    var r = (cropRect.r * elmInfo.scale)/widthRatio;
    var b = (cropRect.b * elmInfo.scale)/heightRatio;
    var cenX = (scaledW - frame.w)/2;
    var cenY = (scaledH - frame.h)/2;
    var offX = 0;
    var offY = 0;
    if(elmInfo.rotation==180){
        offX = l - cenX;
        offY = t - cenY;
    }else{
        offX = cenX - l;
        offY = cenY - t;
    }
    elmInfo.xOffset = offX + elmInfo.initXOffset;
    elmInfo.yOffset = offY + elmInfo.initYOffset;
    log.debug("complete offsetX = "+elmInfo.xOffset+" offsetY "+elmInfo.yOffset,"setElmOffsetFrmCropCoord0180");
};
template.prototype.setCropOverlayDivPos=function(frameId, imageOrDiv)
{
    log.debug("START "+imageOrDiv,"setCropOverlayDivPos");
    var frame = this.getInnerFrameForId(frameId);
    var ele = frame.element[frame.activeEleIndex];
    var imgOffset = $("#"+frameId+imageOrDiv).offset();
    var frmOffset = $("#"+frameId).offset();
    var w1 = (frmOffset.left - imgOffset.left)/this.mainFrame.scale;
    var h1 = (frmOffset.top - imgOffset.top)/this.mainFrame.scale;    
    var w2 = $("#"+frameId+imageOrDiv).width()*ele.scale - (w1 + frame.w);
    var h2 = $("#"+frameId+imageOrDiv).height()*ele.scale - (h1 + frame.h);    
    $("#leftShadowId-"+frameId).css({
        'left':'-'+w1+'px'
        ,'width':(w1-BORDER_WIDTH)+'px'
        ,'top':'-'+BORDER_WIDTH+'px'
        ,'height':(frame.h+2*BORDER_WIDTH)+'px'
    });
    $("#rightShadowId-"+frameId).css({
        'right':'-'+w2+'px'
        ,'width':(w2-BORDER_WIDTH)+'px'
        ,'top':'-'+BORDER_WIDTH+'px'
        ,'height':(frame.h+2*BORDER_WIDTH)+'px'
    });
    $("#topShadowId-"+frameId).css({
        'left':'-'+w1+'px'
        ,'width':(w1+frame.w+w2)+'px'
        ,'top':'-'+h1+'px'
        ,'height':(h1-BORDER_WIDTH)+'px'
    });
    $("#bottomShadowId-"+frameId).css({
        'left':'-'+w1+'px'
        ,'width':(w1+frame.w+w2)+'px'
        ,'bottom':'-'+h2+'px'
        ,'height':(h2-BORDER_WIDTH)+'px'
    });
    log.debug("COMPLETED","setCropOverlayDivPos");
};
template.prototype.showCropOverlay=function(frameId,flag)
{
    log.debug("adding shadow on frame: "+frameId+",flag:"+flag,"showCropOverlay");        
    $(".tpl_frameCls").css({
        'overflow':'hidden'
        ,'z-index':'999'
    });
    $(".boxShadowCls").remove();
    if(flag)
    {        
        $("#frameCover-"+frameId).append('<div id="leftShadowId-'+frameId+'" class="boxShadowCls"></div>'
                                        +'<div id="rightShadowId-'+frameId+'" class="boxShadowCls"></div>'
                                        +'<div id="topShadowId-'+frameId+'" class="boxShadowCls"></div>'
                                        +'<div id="bottomShadowId-'+frameId+'" class="boxShadowCls"></div>');        
        $("#"+frameId).css({
            'overflow':'visible'
            ,'z-index':'9999'
        });       
        this.setCropOverlayDivPos(frameId, "_ImgDiv");
    }
    log.debug("COMPLETED1","showCropOverlay");
};
template.prototype.showMoveCursor=function(frameId){
    var frame = this.getInnerFrameForId(frameId);
    $("#frameCover-"+frameId).append('<div id="moveCursorId-'+frameId+'" class="tplMoveCursorCls"></div>');
    $("#moveCursorId-"+frameId).css({
        'left':Math.round((frame.w - 34)/2)+'px'
        ,'top':Math.round((frame.h - 34)/2)+'px'
    });    
    setTimeout(function(){
        if($("#moveCursorId-"+frameId).length >0){
            $("#moveCursorId-"+frameId).css({
                'opacity':0,
                'transition':'opacity 1s ease-in-out'
            });
        }
    }, 1000);
    moveCursorTimeout = setTimeout(function(){
        if($("#moveCursorId-"+frameId).length >0){
               $("#moveCursorId-"+frameId).remove();
        }
    }, 2000);
};
template.prototype.handleDoneEvent=function(frameId)
{  
   this.hideCtrlPtsForFrameID(frameId, false);
   this.showMainFrame(); 
   this.resetUpdtSlotCallObj();     
   this.createCroppedImage(0,-1); 
};
template.prototype.handleCropEvent=function(frameId)
{    
    log.debug("handleCropEvent for frameId: "+frameId+",this.isCroppedMode:"+this.isCroppedMode,"handleCropEvent");
    if(!this.isCroppedMode)
    {
        this.isCroppedMode=true;
        this.isAdClipMode=true;    
        var frame = this.getInnerFrameForId(frameId);
        this.showCropOverlay(frameId,true);
        this.showMoveCursor(frameId);
        if(frame.element.length>0){
            var ele = frame.element[frame.activeEleIndex];
            this.cropInfoFrUndo.setCropInfo(frameId, ele.xOffset, ele.yOffset, ele.scale, ele.rotation);
        }
    }
};
template.prototype.createCroppedImage=function(iToken,elmIndx)
{
    log.debug("START3","createCroppedImage");
    if(this.isAdClipMode)
    {
        log.debug("In If1","createCroppedImage");
        adClipUtils.showUpdtSlotLoader();
        this.isAdClipMode=false;
        cropJson.filesToCropArrs=[];
        var actvFrame=this.getActiveFrame();
        if(elmIndx==-1)
        {
            elmIndx=actvFrame.activeEleIndex;
        }
        var elm=actvFrame.element[elmIndx];
        var nxtElm=null;
        if(elmIndx+1<actvFrame.element.length)
        {
            nxtElm=actvFrame.element[elmIndx+1];
        }
        this.updateFiletoCropArr(actvFrame,elm,elmIndx);        
        if(elm.slotType==slotType.SLOT_IMAGE_SEPARATOR || (nxtElm!=null && nxtElm.slotType==slotType.SLOT_SEPARATOR))
        {  
            adClipUtils.cropAndRotateImages(2,elmIndx,iToken);
        }
        else
        {
            adClipUtils.cropAndRotateImages(3,elmIndx,iToken);
        }
    }
    log.debug("COMPLETE","createCroppedImage");
};
template.prototype.updateNextSlot=function(frame,currSlot)
{   
    var nxtSlot=currSlot+1;
    if(nxtSlot<frame.element.length)
    {   
        var elm=frame.element[nxtSlot];
        this.setThumbBgImg(frame.id,nxtSlot,elm.thumbPath);
        elm.timeStamp=getTimeWithMiliSec();
    } 
};
template.prototype.getUpdtSlotSeprtor=function(slotNo,iToken)
{
   log.debug("START2 for slot:"+slotNo,"getUpdtSlotSeprtor");
   var currObj=this;
   var actvFrame=this.getActiveFrame();
   var elm=actvFrame.element[slotNo];   
      adClipUtils.showUpdtSlotLoader();
       var success=function(jsonData){
           log.debug("COMPLETE with data-"+jsonData,"getUpdtSlotSeprtor");           
           var jsnObj=JSON.parse(jsonData);          
           if(elm.slotType==slotType.SLOT_IMAGE_SEPARATOR && slotNo==actvFrame.activeEleIndex)
           {
              elm.timeStamp=getTimeWithMiliSec();
              var divID=actvFrame.id+"-elm_"+slotNo+"_0";                      
              $("#"+divID+"_InrElm").attr("src",elm.textElms[0].textImageSrc+"?ts="+elm.timeStamp);
              log.debug("Curr Seperator image:"+$("#"+divID+"_InrElm").attr("src"),"getUpdtSlotSeprtor");                         
           }           
           if(jsnObj[0].sepPath!="")
           {
            currObj.updateNextSlot(actvFrame,slotNo);
           }
             currObj.hideUpdateSlotLoader();
       }; 
       var error=function()
       {            
          adClipUtils.hidePageLoader();
          currObj.resetUpdtSlotCallObj();
          log.debug("Error in getting updated seperator","getUpdtSlotSeprtor"); 
       };
       log.debug("slotNo:"+slotNo+",elm.imageSrc:"+elm.imageSrc,"getUpdtSlotSeprtor");
       mAdclipManager.updateSlot(success,error,[slotNo,elm.imageSrc]);  
};
template.prototype.hideUpdateSlotLoader=function()
{    
    if(updtSlotCallObj.successCnt==updtSlotCallObj.callCnt)
      { 
        this.resetUpdtSlotCallObj();
        adClipUtils.hidePageLoader();
      }    
};
template.prototype.resetUpdtSlotCallObj=function()
{
     updtSlotCallObj.successCnt=0;
     updtSlotCallObj.callCnt=0;    
};
template.prototype.handleUndoEvent=function(frameId)
{    
    if($("#moveCursorId-"+frameId).length >0){
        clearTimeout(moveCursorTimeout);
        $("#moveCursorId-"+frameId).remove();
    }
    this.isCroppedMode=false;
    var frame = this.getInnerFrameForId(frameId);
    this.showCropOverlay(frameId,false);
    if(frame.element.length>0){        
        var ele = frame.element[frame.activeEleIndex];
        if(this.cropInfoFrUndo.id == frame.id){            
            ele.xOffset = this.cropInfoFrUndo.xOffset;
            ele.yOffset = this.cropInfoFrUndo.yOffset;
            ele.scale = this.cropInfoFrUndo.scale;
            ele.rotation = this.cropInfoFrUndo.rotation;
            this.transformActvFrameElm(frame, false);
            $("#frameCover-"+frame.id).attr("zoom",ele.scale);
            log.debug("undo event complete for frame id = "+frameId, "handleUndoEvent");
        }
    }
    this.showMainFrame(); 
};
template.prototype.handleZoomEvent=function(frameId,iVal)
{    
    if(!this.isCroppedMode || rotateMode)
    {
        return false;
    }
    var frame = this.getInnerFrameForId(frameId);   
    var ele = frame.element[frame.activeEleIndex];       
    if(ele.orgW == 0 || ele.orgH == 0){
        this.getElementPosInFrame(frame.id);
    }
    ele.scale=iVal;        
    this.chkElmOfstForFrameId(frame.id);       
    this.transformActvFrameElm(frame, false);
    this.setCropOverlayDivPos(frame.id, "_ImgDiv");
    $("#frameCover-"+frame.id).attr("zoom",ele.scale);    
};
template.prototype.handleOpacityEvent=function(frameId,iVal)
{
   var frame = this.getInnerFrameForId(frameId);
   var ele = frame.element[frame.activeEleIndex];
   ele.opacity=getParseIntInDec(iVal);   
   $("#"+frameId + "_ImgDiv").css("opacity",opctyToPrsntNvisVrsa(ele.opacity,true));
   $("#frameCover-"+frame.id).attr("opacity",iVal);    
};
template.prototype.showAuthorMenuForFrame = function(frameCoverId) {
    var currObj = this;
    menuObj.displayEditMenu({
        elemObj : $('#' + frameCoverId),
        onSelect : function(obj, type, name, val) {
            log.debug("obj=" + obj + " type = " + type + " name = " + name + " val= " + val, "BLANK TEMPLATE FRAMECOVER AUTHORMENU");
            if (name != "zoom") {
                currObj.isCroppedMode = false;
            }
            var frameId = obj.attr("id").split("-")[1];
            switch(name) {
            case "done":
                currObj.handleDoneEvent(frameId);
                break;          
            case "crop":
                currObj.handleCropEvent(frameId);
                break;
            case "zoom":
                currObj.handleZoomEvent(frameId, val);
                break;
            case "opacity":
                currObj.handleOpacityEvent(frameId, val);
                break;
            case "arrange":
                if (val == "bring-front") {
                    currObj.sendToFrontBlkFrm(frameId);
                } else if (val == "send-back") {
                    currObj.sendToBackBlkFrm(frameId);
                } else if (val == "bring-forward") {
                    currObj.sendForwardBlkFrm(frameId);
                } else {
                    currObj.sendBackwardBlkFrm(frameId);
                }
                currObj.setSelFrameCoverZIndex(frameId);
                break;
            case "undo":
                currObj.handleUndoEvent(frameId);
                break;
            default:
                break;
            }
        }
    });    
};
template.prototype.showAuthorMenuForMnFrmElm=function(divID){
  try
  {    
    var currObj=this;
     menuObj.displayEditMenu({	
        elemObj:$('#'+divID),
        onSelect:function(obj, type, name, val){
            type=getParseIntInDec(type);
            var selElmId= obj.attr("id");
            selElmId=getMnFrmElmDvId(selElmId);           
            if(name=="arrange")
            {                
                var indx=selElmId.split("-elm_")[1].split("_")[1];
                var currElm=currObj.getActvElmofActvFrm();
                switch(val)
                {
                    case "bring-front":
                        currObj.sendToFront(indx,currElm);
                    break;
                    case "bring-forward":
                        currObj.sendForward(indx,currElm);
                    break;
                    case "send-back":
                        currObj.sendToBack(indx,currElm);
                    break;
                    case "send-backward":
                        currObj.sendBackward(indx,currElm);
                    break;
                    default:
                    break;
                }
                /*Element cover z index setting to max after reorder*/
                $("#ElmCover-"+selElmId).css({
                    'z-index':MAX_COVER_DIV_Z_INDEX
                });
            }
            else if (name=="copy")
            {
                currObj.makeStickerCopy(); 
            } 
            else if (name=="edit")
            {                 
                currObj.updateHandWrittenText(selElmId);              
            }           
            else
            {
                if(name == 'font-family'){
                    loaderObj.showLoader();
                    fontUtils.isFontLoadedInMemory(val,function(){
                         loaderObj.hideLoader();
			 setTimeout(function(){
                         	currObj.applyAndUpdateAdClipText(currObj, selElmId, type, name, val);
	 		},100);
                    });
                }else{
                    currObj.applyAndUpdateAdClipText(currObj, selElmId, type, name, val);
                }
            }
        }
    });
  }
  catch(ex)
  {
      log.debug("Exception: "+ex,"showAuthorMenuForMnFrmElm");
  }
};
template.prototype.applyAndUpdateAdClipText=function(currObj, selElmId, type, name, val){
    currObj.applyTextProperties(selElmId, type, name, val, false);
    if(name!="delete" )
    {
        var textObj = currObj.getTextObjectFromId(selElmId);
        currObj.updateTextObj(textObj, type, name, val,selElmId);
    }
};
template.prototype.relRectForFrmOrgRect=function(mainFrameRect, rect){
    var widthRatio = mainFrameRect.w/this.lfdSize.w;
    var heightRatio = mainFrameRect.h/this.lfdSize.h;
    return this.getRectWithRatio(widthRatio,heightRatio,rect);
};
template.prototype.orgRectFrmRelRect=function(mainFrameRect, rect){
    var widthRatio = this.lfdSize.w/mainFrameRect.w;
    var heightRatio = this.lfdSize.h/mainFrameRect.h;        
    return this.getRectWithRatio(widthRatio,heightRatio,rect);
};
template.prototype.getRectWithRatio=function(widthRatio,heightRatio,rect)
{
	 var x = Math.round(widthRatio*rect.x);
	 var y = Math.round(heightRatio*rect.y);
	 var w = Math.round(widthRatio*rect.w);
	 var h = Math.round(heightRatio*rect.h);    
	 return { x:x,y:y,w:w,h:h};
};
template.prototype.setDimXYWH=function(id,x,y,w,h)
{
	 $("#"+id).css({
     	'left':x+'px'
     	,'top':y+'px'
     	,'width':this.getMinHW(w)+'px'
     	,'height':this.getMinHW(h)+'px'
     });     
     var padAttr=$("#"+id).attr("isPad");
     if(padAttr=="yes")
     {
         var padLR=Math.round(w*0.02);
         w=w-(2*padLR);
         $("#"+id).css({       
            'width':this.getMinHW(w)+'px'
            ,'padding-left':padLR+'px'
            ,'padding-right':padLR+'px'        
         });
     }
};
template.prototype.setBGofTemplate=function(bgColor,bgImage)
{
    log.debug("-1-Set BG color: "+bgColor, "setBGofTemplate");
    if(this.canModifiedBg)
    {
       this.bgImage=bgImage;
       this.bgColor=bgColor;
       this.setBackgroundOfDiv(this.mainFrame.id,this.bgColor,this.bgImage);
    }    
    log.debug("Done Setting BG", "setBGofTemplate");
};
template.prototype.setBackgroundOfDiv=function(divID,bgColor,bgImage)
{    
    $(".tpl_frameEmptyCls").removeClass("offWhiteBoxShadow");
    if(bgColor=="")
    {
        bgColor="#F1F1F1";        
    }
    else if((bgColor.match(/255/g)|| []).length==3)
    {
        $(".tpl_frameEmptyCls").addClass("offWhiteBoxShadow");
    }               
    $("#"+divID).css({
        'background-color':bgColor
       ,"background-image":"url('"+bgImage+"')"
    });
};
template.prototype.renderActvElmOfFrame=function(frameId){
   log.debug("Rendering1-------------------frameId:"+frameId, "renderActvElmOfFrame");
    var currObj=this;
    var frame = currObj.getInnerFrameForId(frameId);
    var eleHTML = "";
    $("#"+frameId).empty();
    var coverID="frameCover-"+frame.id;
    $("#"+frame.id).html('<div id="'+coverID+'" angle="0" class="coverDivCls" type="'+IMAGE+'"></div>');  
    this.setDimXYWH(coverID,0,0,frame.w,frame.h);     
    var myEle = document.getElementById(coverID);
    var mc = new Hammer(myEle);     
    mc.on('panstart panmove panend', function(e){         
        currObj.onPanEvent(e);
    });
    $("#"+coverID).css({
                'box-shadow':COVERIDSHADOW+' rgba(0,0,0,0)'
                ,'-webkit-box-shadow':COVERIDSHADOW+' rgba(0,0,0,0)'   
    });
   var ele = frame.element[frame.activeEleIndex];
   $("#"+frame.id).removeClass("tpl_frameEmptyCls");
    if(typeof(ele) !="undefined" && ele != null)
    {
        $("#frameCover-"+frame.id).attr("type",ele.elementType);
        var orgPath=adClipUtils.getEncodedPath(ele.smallSizeImg);
        log.debug("orgPath: "+orgPath,"renderActvElmOfFrame");
        switch(ele.elementType)
        {                   
            case VIDEO:
                $("#"+frameId).append('<img id="' + frameId + '_Img" src="' +orgPath + '"  type="'+ele.elementType+'"></img>');
            break;
            case IMAGE:
                $("#"+frameId).append('<div id="' + frameId + '_ImgDiv" class="tpl_frameImgDivCls" style="opacity:'+opctyToPrsntNvisVrsa(ele.opacity,true)+'">'
                                    +'<img id="' + frameId + '_Img" src="' + orgPath + '"  type="'+ele.elementType+'"></img>'
                                    +'</div>');
                $("#frameCover-"+frame.id).attr({                       
                    "zoom":ele.scale
                    ,"opacity":ele.opacity
                });                                 
            break;          
            default:
                $("#frameCover-"+frame.id).attr("type",EMPTY);
                $("#"+frame.id).addClass("tpl_frameEmptyCls");
            break;
        }
        if(orgPath=="")
        {
            $("#"+frameId + "_Img").hide();
        }
        currObj.rndrLnkdElmntOnFrame(ele,frame);        
        $("#frameCover-"+frame.id).attr("angle",ele.rotation);          
        currObj.aspectFillFrame(frame.id);          
    } 
    else
    {
        $("#frameCover-"+frame.id).attr("type",EMPTY);
         $("#"+frame.id).addClass("tpl_frameEmptyCls");
    }  
    currObj.isEdited=true;
    log.debug("COMPLETED","renderActvElmOfFrame");
 };
template.prototype.rndrLnkdElmntOnFrame=function(ele,frame)
{
        var elmLength=ele.elmLyrArr.length;
        var inrElmnt;
        log.debug("ele.elmLyrArr:"+JSON.toString(ele.elmLyrArr),"rndrLnkdElmntOnFrame");        
        for(var indx=0;indx<elmLength;indx++)
        {
            inrElmnt=ele.textElms[ele.elmLyrArr[indx]];
            this.renderFrameLnkElm(inrElmnt,ele.elmLyrArr[indx],frame,indx);
        }                  
};
template.prototype.renderFrameLnkElm=function(txtEle,indx,frame,forZindx)
{
    if(txtEle==null)
    {
        return;
    }
    var currObj=this;
    var addClass="";
    var divID=frame.id+"-elm_"+frame.activeEleIndex+"_"+indx;
   var currElm=frame.element[frame.activeEleIndex];
    var subElmType=txtEle.elmType;
    log.debug("subElmType1: "+subElmType);
    if(subElmType!=DECO_IMAGE)
    {
        addClass="frameElmCls";
    }
    $("#"+frame.id).append('<div id="'+divID+'" class="mainFrameElmCls '+addClass+'" type="'+subElmType+'"></div>'
                            +'<div id="ElmCover-'+divID+'" class="mainFrameElmCoverCls '+addClass+'" type="'+subElmType+'"></div>');
    switch(subElmType)
    {
        case TEXT:
            if($.trim(txtEle.text)=="")
            {
               txtEle.text=MIA_SID_DOUBLE_TAP_TO_EDIT;
            }
            txtEle.textImageName = divID+"_InrElm.png";  
            createUpdatedImage(txtEle);
            $("#"+divID).html('<div class="overflowTextDivCls">'                                                                             
                    +'<img id="'+divID+'_InrElm_Img" src="'+txtEle.textImageSrc+'" class="mainFrameInnerElmCls innerFrmLinkedTxtCls"/>'
                    +'<div id="'+divID+'_InrElm" class="mainFrameInnerElmCls tmpltTxtCls"  onblur="onTextBlur(this)" onkeyup="textKeyUp(this)"  contentEditable="true">'
                        +txtEle.text
                    +'</div>'
                 +'</div>');
            currObj.setTextPropToDiv(divID+"_InrElm",txtEle);                                  
            currObj.textImageShow(divID, true);                
        break;
        case STICKER:
        case HANDWRITING:                 
               $("#"+divID).html('<img id="'+divID+'_InrElm" src="'+txtEle.textImageSrc+'" class="mainFrameInnerElmCls"/>');
        break;
         case DECO_IMAGE:
           if(txtEle.textImageSrc!="")
            {
                log.debug("DECO_IMAGE txtEle.textImageSrc: "+txtEle.textImageSrc+",currElm.timeStamp:"+currElm.timeStamp,"renderFrameLnkElm");               
                $("#"+divID).html('<img id="'+divID+'_InrElm" src="'+txtEle.textImageSrc+'?ts='+currElm.timeStamp+'" class="dcoImgInnerCls"/>');                
           }
           $("#ElmCover-"+divID).remove();
       break;
        default:
        break;
    }
    if(subElmType!=DECO_IMAGE)
    {
        currObj.setZIndexForMnFrmElm(divID,forZindx);
    }
    currObj.setDimXYWH(divID,txtEle.x-frame.x,txtEle.y-frame.y,txtEle.w,txtEle.h);
    currObj.setDimXYWH("ElmCover-"+divID,txtEle.x-frame.x,txtEle.y-frame.y,txtEle.w,txtEle.h);
    currObj.isEdited=true;
};
template.prototype.calculateMainFrameRect=function(){
    var aspectRatioLFD = this.lfdSize.w/this.lfdSize.h;
    var rect = {x:0,y:0,w:0,h:0};
    if(this.orientation==LANDSCAPE)
	{
        rect.w = Math.round(WIN_INNER_W * 0.853);
        rect.w = adClipUtils.shiftValue(rect.w);      
        rect.h = Math.round(rect.w/aspectRatioLFD);
        rect.h = adClipUtils.shiftValue(rect.h);           
    }else{
    	rect.h = Math.round(WIN_INNER_H*0.51);
    	rect.h = adClipUtils.shiftValue(rect.h); 
        rect.w = Math.round(rect.h * aspectRatioLFD);
        rect.w = adClipUtils.shiftValue(rect.w);
    }
    rect.x = Math.round((WIN_INNER_W- rect.w)/2);
    rect.x = adClipUtils.shiftValue(rect.x);
    rect.y = Math.round((WIN_INNER_H-rect.h)/2);
    rect.y = adClipUtils.shiftValue(rect.y);
    return rect;
};
template.prototype.getUpdtdHWforStkr=function(iH,iW,maxW,maxH)
{    
    var newH,newW,orgRatio; 
    newW=maxW;
    if(iH==0 || iW==0)
    {        
        return {w:maxW,h:maxW};
    }
    orgRatio=iW/iH;
    if(iW>iH)
    {
        newW=maxW;                
        newH=Math.round(newW/orgRatio);
    }
    else
    {
        newH=maxH;        
        newW=Math.round(newH*orgRatio);
    }   
    return {w:newW,h:newH};
};
template.prototype.isAddLayerPossible=function()
{
    var frame=this.getActiveFrame();
    var actvElm=frame.activeEleIndex;
    var frmSubElms=frame.element[actvElm].textElms;
    var subElmLen=frmSubElms.length;
    var count=0;
    for(var i=0;i<subElmLen;i++)
    {
        if(frmSubElms[i]!=null)
        {
            count++;
        }
    }
    if(count<11)
    {
        return true;
    }
    Utils.showToast(langObj.Adclip.MIA_SID_MIX_CAN_UP_TO_DESIGN_ELEMENTS_FRAME.replace("<<A>>",10));
    return false;
    
};
template.prototype.addElmToTemplate=function(elem,iTop,iLeft,type)
{    
    log.debug("type: "+ type + ",iTop: "+ iTop + ",iLeft:"+iLeft, "addElmToTemplate");
     
    if(!this.isAddLayerPossible())
    {        
        return;
    }    
    type=getParseIntInDec(type);
    var left,top;
    var width=elem.width();
    var height=elem.height();
    left=iLeft+Math.round(elem.width()/2);
    top=iTop+Math.round(elem.height()/2);
    var ele,updHW;                
    if(!this.isPointInsideMainFrame({x:left,y:top}))
    {
        Utils.showToast(MIA_SID_DESIGN_ELEMENTS_ADDED_INSID_CANVAS);
        return;
    } 
    var currObj=this;
    var frameOffset=$("#"+FRAME_ID_PREFIX+"Main").offset();
    left = (iLeft - frameOffset.left)/this.mainFrame.scale;
    top = (iTop - frameOffset.top)/this.mainFrame.scale;
    ele = new textInfo(0,0,0,0);
    ele.elmType=type;                      
    switch(type)
    {
        case STICKER:             
            var stkrName=elem.attr("stickerName");
            var imgPath="../resource/img/sticker/"+stkrName;
            var stkrImage=new Image();
            ele.textImageSrc=imgPath;
            ele.textImageName=stkrName;                           
            stkrImage.onload=function()
            {                     
                updHW=currObj.getUpdtdHWforStkr(this.height,this.width,width,height);
                var hlfW=Math.round(updHW.w/2);
                var hlfH=Math.round(updHW.h/2);
                ele.w=  hlfW;
                ele.h=  hlfH;               
                ele.x=getParseIntInDec(left+Math.abs((width-hlfW)/2));
                ele.y=getParseIntInDec(top+Math.abs((height-hlfH)/2));
                currObj.updateXYtoLmt(ele);                
                currObj.addDsgnElmToFrame(ele);
                currObj.openMenuAftrDrop(type);
            };
            stkrImage.src=imgPath;
        break;
        case TEXT: 
            loaderObj.showLoader();
            fontUtils.isFontLoadedInMemory(elem.attr("fontFamily"),function(){
            	loaderObj.hideLoader();
                var flag=currObj.addTxtElmOnMnFrm(elem,left,top,false);
                if(flag)
                {
                    var frame=currObj.getActiveFrame();
                    currObj.autoSelectTxtElm(frame.id+"-elm_"+frame.activeEleIndex+"_"+(frame.element[frame.activeEleIndex].textElms.length-1));
                    currObj.shiftFrameCoverDiv("DOWN");
                }
	        });
        break;         
        default:
        break;
    }        
};
template.prototype.addDsgnElmToFrame=function(ele)
{
    log.debug("START 10","addDsgnElmToFrame");
    var frame=this.getActiveFrame();
    var actvElm=frame.getActiveElement();
    var frmSubElms=actvElm.textElms;
    frmSubElms.push(ele);
    var indx=frmSubElms.length-1;
   actvElm.elmLyrArr.push(indx);
    this.renderFrameLnkElm(frmSubElms[indx],indx,frame,indx);
    log.debug("COMPLETE","addDsgnElmToFrame");
    return true;    
};
template.prototype.addMainFrameToContainer=function()
{
       log.debug("1CALLED","addMainFrameToContainer");
    var currObj=this; 
    currObj.setDimXYWH("tplMainContainer",0,0,WIN_INNER_W,WIN_INNER_H);  
    $("#tpl_ContainerId").append('<div id="'+currObj.mainFrame.id+'" style="visibility:hidden" class="tpl_frameMainCls">&nbsp;</div>');
    currObj.setDimXYWH(currObj.mainFrame.id,currObj.mainFrame.x,currObj.mainFrame.y,currObj.mainFrame.w,currObj.mainFrame.h);
};
template.prototype.isTmpltListVisible=function()
{
  return $('#tmpltIcnsParID').hasClass('animateContentMenu'); 
};
template.prototype.updateXYtoLmt=function(elm)
{
     if((elm.x+elm.w)>this.mainFrame.w)
     {
        var diff=  (elm.x+elm.w)-  this.mainFrame.w;
        elm.x=elm.x-diff;
     }
     if((elm.y+elm.h)>this.mainFrame.h)
     {
        var diff=  (elm.y+elm.h)-  this.mainFrame.h;
        elm.y=elm.y-diff;
     }
     if(elm.x<0)
     {
       elm.x=0;  
     }
     if(elm.y<0)
     {
       elm.y=0;
     }
};
template.prototype.addTxtElmOnMnFrm=function(elmObj,left,top,needCenter, dropPt)
{
    var heightRatio = this.lfdSize.h/this.mainFrame.h;
    var txtElm=new textInfo(getParseIntInDec(left),getParseIntInDec(top),50,50);
    txtElm.elmType=TEXT;
    txtElm.text=MIA_SID_DOUBLE_TAP_TO_EDIT;
    txtElm.fontSize=Math.round((getParseIntInDec(elmObj.css("font-size"))*heightRatio)/2);     
    txtElm.fontColor="rgb(0,0,0)";
    txtElm.hAlign="center";
    txtElm.vAlign="middle";
    txtElm.fontFamily=elmObj.attr("fontFamily");     
    txtElm.h=Math.round(elmObj.height()/2);
    txtElm.w=Math.round(getTextWidth(txtElm.text,txtElm.fontSize,txtElm.fontFamily)/heightRatio); 
    if(txtElm.w>this.mainFrame.w)
    {
        txtElm.w = this.mainFrame.w-2;
    }
    if(needCenter)
    {
        txtElm.x=Math.round((this.mainFrame.w-txtElm.w)/2);
        txtElm.y=Math.round((this.mainFrame.h-txtElm.h)/2);
    }
    this.updateXYtoLmt(txtElm);
    if(txtElm.fontFamily.toLowerCase().indexOf("bold")!=-1)
    {
        txtElm.fontBold=true;
    }
    if(txtElm.fontFamily.toLowerCase().indexOf("italic")!=-1)
    {
        txtElm.fontItalic=true;
    }
    return this.addDsgnElmToFrame(txtElm);
};
template.prototype.addHandWrittenText=function(imagePath)
{		
	 var currObj=this;
	 var img=new Image();
	 img.onload = function(){           
         currObj.setHWElementPosition(this,imagePath);
    };    
     img.src = imagePath; 
	 
};
template.prototype.createHWElmFromImgObj=function(imgObj,rect,imagePath)
{    
    var ele = new textInfo(0,0,0,0);        
    ele.textImageSrc=imagePath;
    ele.elmType=HANDWRITING;
    ele.w=rect.w-2;
    ele.h=rect.h-2;
    ele.x=rect.x+1;
    ele.y=rect.y+1;
   return ele;   
};
template.prototype.setHWElementPosition=function(imgObj,imagePath){
    var currObj = this;
    var newWH=this.getDimForHandWrtngImg(imgObj.width,imgObj.height); 
        $("#tplFullScrDivId").show();
        $("#pasteMsgDivId").html(langObj.Schedule.MIA_SID_SELECT_A_PASTE_LOCATION);
        var fontSize=Math.round(WIN_INNER_H*0.025);
        $("#pasteMsgDivId").css({
             'top': Math.round((WIN_INNER_H-fontSize)/2)+'px'
             ,'left':Math.round((WIN_INNER_W-$("#pasteMsgDivId").outerWidth())/2)+'px'         
            ,'font-size':fontSize+'px'
            ,'line-height':fontSize+'px'            
        });        
        $("#tplFullScrDivId").off("touchstart").on("touchstart", function(e){
            e.stopPropagation();
            e.preventDefault();
            var dropPt = {x:e.originalEvent.changedTouches[0].clientX,y:e.originalEvent.changedTouches[0].clientY};
            var rect=null;
            if(currObj.isPointInsideMainFrame(dropPt))
            {
                rect=currObj.getHandWritingElementPos(newWH.w,newWH.h, dropPt);
            } 
            if(rect != null){
                currObj.addDsgnElmToFrame(currObj.createHWElmFromImgObj(imgObj,rect,imagePath)); 
                $("#tplFullScrDivId").hide();                
            }else{
                genericPopUpObj.createPopUp("","Type1");
                genericPopUpObj.appendHTMLData([MIA_SID_ELEMENTS_CANNOT_OVERLAPPED+" "+MIA_SID_CANCELED_HANDWRITING_INPUT_DISCARED]);
                genericPopUpObj.addFooterBtns([{"btntxt":COM_SID_CANCEL,"callback":function(){
                    $("#tplFullScrDivId").hide();
                }}
                ,{"btntxt":COM_SID_RETRY_ABBR_7,"callback":function(){
                    currObj.setHWElementPosition(imgObj,imagePath);
                }}    													
                ]);
                genericPopUpObj.showPopUp();
            }
        });
};

template.prototype.getDimForHandWrtngImg=function(orgW,orgH)
{
    var whRatio;
    var state=W_GT_H;
    var maxH=Math.round(this.mainFrame.h*0.25);
    var maxW=Math.round(this.mainFrame.w*0.25);    
    var newH=90,newW=160;
    if(orgW>=orgH)
    {
       whRatio =orgW/orgH;                               
    }
    else
    {
       whRatio =orgH/orgW;
       state=W_LT_H;  
    }
    if(state==W_GT_H)
    {
        if(orgW>=maxW)
        {
            newW=maxW;                   
        }
        else
        {
            newW=orgW;                    
        }
        newH=Math.round(newW/whRatio);
    }
    else
    {
       if(orgH>=maxH)
        {
            newH=maxH;                   
        }
        else
        {
            newH=orgH;                    
        }
        newW=Math.round(newH/whRatio); 
    }    
    return {w:newW,h:newH};
};

template.prototype.updateHandWrittenText=function(tapDivID)
{	
	var currObj=this;
	var imgSrc=$("#"+tapDivID+"_InrElm").attr("src");
	var elmIndex=tapDivID.split("-elm_")[1].split("_")[0];	
	var error = function(result) {
	  Utils.isHandwritingOpen=false;	
	};
	var success = function(result) {
	    var actvFrame=currObj.getActiveFrame();
        var currElm=actvFrame.element[actvFrame.activeEleIndex];
        var obj=currElm.textElms[currElm.actvTxtElmIndx];       
        obj.textImageSrc=result;       
        $("#"+tapDivID+"_InrElm").attr("src",result);        
        Utils.isHandwritingOpen=false;        	
	};
	Utils.isHandwritingOpen=true;	
	mUiHandler.addHandwriting(imgSrc,success, error);
};
template.prototype.gtRelPosOfFrmOrElm=function(frame)
{
    var scale = this.mainFrame.scale;
    var mainFrmOffset=$("#"+FRAME_ID_PREFIX+"Main").offset();
    var xOne = mainFrmOffset.left + frame.x*scale;
    var yOne = mainFrmOffset.top + frame.y*scale;
    var xTwo = xOne + frame.w*scale;
    var yTwo = yOne + frame.h*scale;
    return {x1:xOne,y1:yOne,x2:xTwo,y2:yTwo};
};
template.prototype.isPointInsideFrame=function(pt, frame){
    var frameCord=this.gtRelPosOfFrmOrElm(frame);       
    return pt.x>=frameCord.x1 && pt.x <= frameCord.x2 && pt.y>=frameCord.y1 && pt.y <= frameCord.y2;
};
template.prototype.isPointInsideMainFrame=function(pt){
    var scale = this.mainFrame.scale;
    var frame = this.mainFrame;
    var x1 = frame.x - (frame.w*scale - frame.w)/2 + this.mainFrame.xOffset;
    var y1 = frame.y - (frame.h*scale - frame.h)/2 + this.mainFrame.yOffset;
    var x2 = x1 + frame.w*scale;
    var y2 = y1 + frame.h*scale;
    return pt.x>=x1 && pt.x <= x2 && pt.y>=y1 && pt.y <= y2;
};
template.prototype.selNonFrameElement=function(actvFrame)
{
    var selflag=false;     
    var elmLength=actvFrame.element.length;
    log.debug("length----:"+ elmLength,"selNonFrameElement");
    var elmType,ele,divID,activeElm;
    if(elmLength>0)
    {
        activeElm=actvFrame.getActiveElement();
        elmLength=activeElm.elmLyrArr.length;        
        for(var indx=elmLength-1;indx>=0;indx--)
        {
            ele=activeElm.textElms[activeElm.elmLyrArr[indx]];
            if(ele!=null)
            {
                elmType=ele.elmType;
                divID=actvFrame.id+"-elm_"+actvFrame.activeEleIndex+"_"+activeElm.elmLyrArr[indx];
                if(elmType!=DECO_IMAGE && this.isPointInsideFrame(this.cpDragStartPt, ele) && $("#"+divID).is(":visible")){                                        
                    this.snglTapOnMnFrmElm($("#"+divID));
                    showAuthorMenu("ElmCover-"+divID);
                    this.shiftFrameCoverDiv("DOWN");                   
                    selflag=true;
                    break;                                    
                }
           } 
        }
        this.hideItemList(true);
    }    
    return selflag;
};
template.prototype.selFrameOrItsElmTap=function(frameId)
{  
    var actvFrame = this.getInnerFrameForId(frameId);
    var bText = this.selNonFrameElement(actvFrame);   
    if(!bText){
         log.debug("Select frame "+ actvFrame.id);       
        actvFrame.active = true;               
        closeAuthorMenu();        
        this.shiftFrameCoverDiv("UP");        
        this.showCtrlPtsForFrameID(actvFrame.id);        
    }       
    log.debug("COMPLETED", "selFrameOrItsElmTap");
};
template.prototype.shiftFrameCoverDiv=function(token)
{  
  log.debug("SHIFT - "+token+"mainFrameElmCoverCls","shiftFrameCoverDiv");
  if(token=="UP")
  {      
      $("#frameCover-"+ACTIVE_FRAME).css({
            "z-index":"9999999"
       });
  }
  else
  {
      $("#frameCover-"+ACTIVE_FRAME).css({
            "z-index":"9999"
       });
  }
  log.debug("COMPLETE","shiftFrameCoverDiv");  
};
template.prototype.autoSelectTxtElm=function(divID)
{  
   showAuthorMenu("ElmCover-"+divID);
   this.snglTapOnMnFrmElm($("#"+divID));                       
   this.hideMainFrame();
   this.dblTapOnMnFrmElm($("#"+divID));  
};
template.prototype.onMainFrameTap=function()
{   
    var actvFrame=this.getActiveFrame();
    /*Checking all sticker and text elements first*/
    var bSticker = this.selNonFrameElement(actvFrame);
    if(!bSticker)
    {
       actvFrame.active = true;               
       closeAuthorMenu();
       this.triggerTapForFrame(actvFrame);         
    }
    this.isEdited=true;
    log.debug("COMPLETED","onMainFrameTap");    
};
template.prototype.resetTemplateZoom=function(iValue)
{
   this.mainFrame.scale=iValue;
   this.chkMainFrameOffSet(); 
   this.transformMainFrame();
   this.updateMainFrameBoxSOnZoom(); 
};
template.prototype.onMainFrameDoubleTap=function()
{		
	this.resetTemplateZoom(1);
};
template.prototype.hideMainFrame=function()
{    
	$("#mainFrameCoverID").hide();	
	refreshScreen();		
};
template.prototype.showMainFrame=function()
{    
    this.bCanvasAnyElmSel = false;
	this.hideItemList(true);	
	if(this.curSelFrameIndx!=-1)
	{
		closeAuthorMenu();
	}
	this.curSelFrameIndx=0;
	$(".frameElmCls").show();
    this.showFrameCover(ACTIVE_FRAME,false);
    this.shiftFrameCoverDiv("UP");        
    this.cropInfoFrUndo.clearCropInfo();
    this.processKeyBoardClose();   		
	log.debug("-------2222 ----successfully showing frame -----------------", "showMainFrame");
};
template.prototype.doProcessForSnapShot=function()
{   
    this.hideCtrlPtsForFrameID(this.getActiveFrame().id,true);  
    this.hideMainFrameAllElmCp();
    $(".tpl_SepDashedLineCls").hide();
    closeAuthorMenu();
    $(".tpl_frameEmptyCls").removeClass("tpl_frameEmptyCls offWhiteBoxShadow");
    this.shiftTemplateForMenu(DOWN);
    hideBottomMenu();    
};
template.prototype.hideCtrlPtsForFrameID=function(frameId,resetFlag)
{
    if(frameId.indexOf("_Main")!=-1)
    {
        return false;
    }
    var frame = this.getInnerFrameForId(frameId);
    this.showCropOverlay(frameId,false);
    if(resetFlag)
    {
       this.resetFrameContent(frame); 
    }
  if(frame.isEditable){
        for(var count =0; count<frame.ctrlPtCount;count++){
            var cp = frame.controlPoints[count];
            var id = frameId+"_CP"+cp.side;
            $("#"+id).hide();
        }
    }
    frame.active=false;   
   $('#frameCover-'+frameId).css('z-index','999');   
    this.showFrameCover(frame.id,false);  
    this.bCanvasAnyElmSel = false;
    this.isCroppedMode=false;      
};

template.prototype.showHideFrameControls=function(frame, bCtrlPt, bRotation){
    log.debug("STARTED", "showHideFrameControls");
    if(frame.id.indexOf("_Main")!=-1)
    {
        return false;
    }
    if(frame.isEditable){
        for(var count =0; count<frame.ctrlPtCount;count++){
            var cp = frame.controlPoints[count];
            var id = frame.id+"_CP"+cp.side;
            if(bCtrlPt){
                $("#"+id).show();
                log.debug("show", "showHideFrameControls");
            }else{
                log.debug("hide", "showHideFrameControls");
                $("#"+id).hide();
            }
        }
        if(bRotation){
            $("#"+frame.id+"_rotateHandler").show();
        }else{
            $("#"+frame.id+"_rotateHandler").hide();
        }
    }
    log.debug("COMPLETED", "showHideFrameControls");
    return true;
};

template.prototype.showhideMainFrameElmControls=function(bCtrlPt){
    var frame = this.mainFrame;
    var divID=frame.id+"-elm_"+frame.activeEleIndex+"_"+frame.element[frame.activeEleIndex].actvTxtElmIndx;
    var j;
    for(j=0;j<this.mainCpCount;j++)
    {
        if(bCtrlPt){
            $("#"+divID+"-CP_"+j).show();
        }else{
            $("#"+divID+"-CP_"+j).hide();
        }
    }    
};
template.prototype.addBoxShadowOnFrame=function(frameId,colorCode,shdwArea)
{
    var zmObj=this.getZmdHWofCpBdr();
    var coverS = COVERIDSHADOW.replace(''+BORDER_WIDTH,''+zmObj.border);
    $("#frameCover-"+frameId).css({
        'box-shadow':shdwArea+' '+coverS+' '+colorCode
        ,'-webkit-box-shadow': shdwArea+' '+coverS+' '+colorCode
     });    
};
template.prototype.showFrameCover=function(iFrameId,iFlag)
{
	log.debug("START","showFrameCover");
	if(!iFlag)
	{		
		this.addBoxShadowOnFrame(iFrameId,"rgba(0,0,0,0)","");		
	}
	else
	{		
		this.addBoxShadowOnFrame(iFrameId,"#3196ff","");
	}	
	if(this.currSelTxtDivId != ""){
        $("#"+this.currSelTxtDivId+"_InrElm").blur();
    }
	log.debug("COMPLETE","showFrameCover");		
};
template.prototype.getFrameType=function(frameId)
{    
    return getParseIntInDec($("#frameCover-"+frameId).attr("type"));
};
template.prototype.showCtrlPtsForFrameID=function(frameId)
{       
    this.curSelFrameIndx=0;
    this.hideMainFrameAllElmCp();
    var frame=this.getInnerFrameForId(frameId);
    var len=frame.element.length;    
    if(len>0)
    {
        var actvElmSlot=frame.element[frame.activeEleIndex].slotType;
        log.debug("actvElmSlot: "+actvElmSlot,"showCtrlPtsForFrameID");
        if(this.isCropableSlot(actvElmSlot))
        {
            log.debug("Slot is croppable ","showCtrlPtsForFrameID");
            $(".frameElmCls").hide();
            this.showFrameCover(frameId,true); 
            showAuthorMenu("frameCover-"+frameId);
        }
    }
};
template.prototype.isCropableSlot=function(slotTyp)
{
    if(slotTyp==slotType.SLOT_IMAGE || slotTyp==slotType.SLOT_IMAGE_SEPARATOR)
    {
        return true;
    }
    return false;
};
template.prototype.getZmdHWofCpBdr=function()
{
   var iborder = Math.ceil(BORDER_WIDTH/this.mainFrame.scale);   
   var icpHW=Math.ceil(CPoint_HW/this.mainFrame.scale);
    iborder=iborder<1?1:iborder;
    icpHW = icpHW<8?8:icpHW;
    if((icpHW-iborder)%2!=0)
    {
       icpHW=icpHW+1; 
    }
    log.debug(JSON.stringify({hw:icpHW,border:iborder}),"getZmdHWofCpBdr");
    return {hw:icpHW,border:iborder}; 
};
template.prototype.showHideFrameRotateHandler=function(frame)
{
	if(frame.id==this.getActiveFrame().id)
	{
		$('#'+frame.id+'_rotateHandler').show();  
	}
	if(!frame.isEditable || frame.table!=null || frame.element.length==0 || (frame.element[0].elementType!=IMAGE && frame.element[0].elementType!=GROUP))
	{ 
		$('#'+frame.id+'_rotateHandler').hide();
	}
};
/* ------ TEMPLATE OBJECT MODIFICATION FUNCTIONS -------*/
template.prototype.addInnerFrame = function(frame){
    frame.id=FRAME_ID_PREFIX+this.frameCount;
    this.innerFrames[frame.id] = frame;
    this.innerFrameZOrderArr.push(this.frameCount);
    this.frameCount++;
};
template.prototype.getInnerFrameForId = function(id){
    return this.innerFrames[id];
};
template.prototype.setFrameLayout = function(layout){
    this.frameLayout = layout;
};
template.prototype.getElementPosInFrame = function(id){
    var frame = this.innerFrames[id];
    var ele = frame.element[frame.activeEleIndex];    
    var scale = Math.min(frame.w/ele.orgW,frame.h/ele.orgH);
    ele.h = (scale<1.0)? scale * ele.orgH: ele.orgH;
    ele.w = (scale<1.0)? scale * ele.orgW: ele.orgW;
    ele.x = (frame.w - ele.w)/2;
    ele.y = (frame.h - ele.h)/2;
    return ele;
};
template.prototype.chkElmOfstForFrameId = function(id){	
    var frame = this.innerFrames[id];
    var ele = frame.element[frame.activeEleIndex];    
    if(ele.rotation==90 || ele.rotation==270)
    {
        var scaledW = ele.h*ele.scale;
        var scaledH = ele.w*ele.scale;
        var x1 = ele.xOffset - (scaledW-ele.h)/2;
        var y1 = ele.yOffset - (scaledH-ele.w)/2;
        
        var x2 = x1 + scaledW;
        var y2 = y1 + scaledH;        
        if(x1 > 0){
            ele.xOffset = (scaledW - ele.h)/2;
        }
        if(y1 > 0){
            ele.yOffset = (scaledH - ele.w)/2;
        }        
        if(x2 <frame.w){
            ele.xOffset = Math.floor(frame.w - (ele.h + scaledW)/2);
        }
        if(y2 < frame.h){
            ele.yOffset = Math.floor(frame.h - (ele.w + scaledH)/2);
        }        
    }else{
        var scaledW = ele.w*ele.scale;
        var scaledH = ele.h*ele.scale;
        var x1 = ele.xOffset - (scaledW-ele.w)/2;
        var y1 = ele.yOffset - (scaledH-ele.h)/2;

        var x2 = x1 + scaledW;
        var y2 = y1 + scaledH;        
        if(x1 > 0){
            ele.xOffset = (scaledW - ele.w)/2;
        }
        if(y1 > 0){
            ele.yOffset = (scaledH - ele.h)/2;
        }        
        if(x2 <frame.w){
            ele.xOffset = Math.floor(frame.w - (ele.w + scaledW)/2);
        }
        if(y2 < frame.h){
            ele.yOffset = Math.floor(frame.h - (ele.h + scaledH)/2);
        }
    }    
    return ele;
};
/* ------- FRAME EVENT HANDLING FUNCTIONS *pinchzoom, pan, tap, dbltap, rotate * --------- */
template.prototype.onPinchInOutEvent = function(e){
	if(!this.isCroppedMode || rotateMode )
	{
		return false;
	}
	var eventIndex=getParseIntInDec(e.target.id.split("_")[1]);	
	var parentID=FRAME_ID_PREFIX+this.curSelFrameIndx;
    var frame = this.getInnerFrameForId(parentID);    
    var ele = frame.element[frame.activeEleIndex];
    if(eventIndex==this.curSelFrameIndx && frame.active){
        if(e.scale >= 1){
            ele.scale += frame.common.scaleFactor + (e.scale - ele.scale);
        }else{
            ele.scale -=  ele.scale*e.scale/20;
        }
        
        /*In case image is not loaded initially*/
        if(ele.orgW == 0 || ele.orgH == 0){
            this.getElementPosInFrame(parentID);
        }        
        if(ele.scale>1 && ele.scale <= 4){
            if(e.scale < 1.0){
                this.chkElmOfstForFrameId(parentID);
            }
            this.transformActvFrameElm(frame, false);
        }else if(ele.scale >= 4){
            ele.scale = 4;
            this.transformActvFrameElm(frame, false);
        }else{
            ele.scale = 1;
        }
        if(e.eventType == Hammer.INPUT_END){
            frame.common.scaleFactor = ele.scale-1;
        }
    }
    this.setCropOverlayDivPos(frame.id, "_ImgDiv");
};
template.prototype.onPanEvent = function(e){
	try{
		if(!this.isCroppedMode || rotateMode)
		{
			return false;
		}
		var eventIndex=getParseIntInDec(e.target.id.split("_")[1]);
		var parentID=FRAME_ID_PREFIX+this.curSelFrameIndx;
	    var frame = this.getInnerFrameForId(parentID);
	    var ele = frame.element[frame.activeEleIndex];
	    if(eventIndex==this.curSelFrameIndx && frame.active){
	        if(ele.scale < 1){
	            return;
	        }
	        /*In case image is not loaded initially*/
	        if(ele.orgW == 0 || ele.orgH == 0){
	            this.getElementPosInFrame(parentID);
	        }
	        if(e.type == 'panstart'){        	
	            frame.common.prevPoint = e.center;
	        }	        
	        ele.xOffset += e.center.x - frame.common.prevPoint.x;
	        ele.yOffset += e.center.y - frame.common.prevPoint.y;	        
	        this.chkElmOfstForFrameId(parentID);	       
	        this.transformActvFrameElm(frame, false);	     
	        frame.common.prevPoint = e.center;
	    }
	    this.setCropOverlayDivPos(frame.id, "_ImgDiv");
   }
   catch(ex)
   {
   	    log.debug("============================Handeled error : "+ ex);
   }
};

template.prototype.transformActvFrameElm=function(frame, bShiftOrigin)
{    
    var ele = frame.element[frame.activeEleIndex];    
    if(bShiftOrigin){
        if(this.currRotationAngle == 90 || this.currRotationAngle == 270){
            var originX = (frame.w/2) - this.imageX;
            var originY = (frame.h/2) - this.imageY;            
            var rotation = ele.rotation - this.currRotationAngle;            
            var transFormStr='translate('+ ele.initXOffset+'px,'+ele.initYOffset+'px) scale('+ele.scale+','+ele.scale+') rotate('+rotation+'deg)';            
            this.applyCenterTransformOnId(frame.id+"_ImgDiv", transFormStr, ele.h, ele.w);
            $("#"+frame.id+"_Img").css({
                'width':ele.w+'px'
                ,'height':ele.h+'px'
            });            
        }else{           
            var originX = (frame.w/2) - this.imageX;
            var originY = (frame.h/2) - this.imageY;                
                var transFormStr='translate('+ ele.initXOffset+'px,'+ele.initYOffset+'px) scale('+ele.scale+','+ele.scale+') rotate('+ele.rotation+'deg)';
                var transFormStr1='translate( 0px,0px) scale(1, 1) rotate(0deg)';
            this.applyCenterTransformOnId(frame.id+"_ImgDiv", transFormStr1, ele.w, ele.h);
            this.applyCenterTransformOnId(frame.id+"_Img", transFormStr, ele.w, ele.h);                        
        }
    }else{
        log.debug("ele.rotation = "+ele.rotation, "transformActvFrameElm");
        var transFormStr='translate('+ (ele.xOffset)+'px,'+(ele.yOffset)+'px) scale('+ ele.scale+','+ele.scale+') rotate(0deg)';
         if(ele.rotation == 90 || ele.rotation == 270){
            var offsetX = -(ele.w - ele.h)/2;
            var offsetY = (ele.w - ele.h)/2;
            var transFormStr1='translate( '+offsetX+ 'px,'+offsetY+ 'px) scale(1, 1) rotate('+ele.rotation+'deg)';
            this.applyCenterTransformOnId(frame.id+"_Img", transFormStr1, ele.w, ele.h);
            this.applyCenterTransformOnId(frame.id+"_ImgDiv", transFormStr, ele.h, ele.w);
        }else{
            var transFormStr1='translate( 0px,0px) scale(1, 1) rotate('+ele.rotation+'deg)';
            this.applyCenterTransformOnId(frame.id+"_Img", transFormStr1, ele.w, ele.h);
            this.applyCenterTransformOnId(frame.id+"_ImgDiv", transFormStr, ele.w, ele.h);
        }
    }
};

template.prototype.applyCenterTransformOnId = function(id, tranStr, w, h){
    $("#"+id).css({
        '-webkit-transform': tranStr
        ,'-webkit-transform-origin': 'center center'
        ,'transform':tranStr
        ,'transform-origin': 'center center'
        ,'width':w+'px'
        ,'height':h+'px'
    });
};

template.prototype.setCurrRotationAngle=function(frame){
    if(frame.element.length >0){
        this.currRotationAngle = frame.element[frame.activeEleIndex].rotation;
    }
};
template.prototype.onTapEvent = function(frameId){    
    this.selFrameOrItsElmTap(frameId); 
};
template.prototype.hideAllControlPoints=function()
{
    var frame;
    for(var frameId in this.innerFrames){        
        frame = this.getInnerFrameForId(frameId);
        this.hideCtrlPtsForFrameID(frameId,false);
    }
    this.curSelFrameIndx=0;
};
template.prototype.resetFrameContent=function(frame)
{
    if(frame.element.length>0 && frame.activeEleIndex!=0)
    {
        frame.activeEleIndex=0;
        this.renderActvElmOfFrame(frame.id);
    }
};
template.prototype.updateCurrAreaDim=function(frame)
{
    var frmType=this.getFrameType(frame.id);
    if(frmType!=EMPTY)
    {
        var widthRatio = this.lfdSize.w/this.mainFrame.w;
        var heightRatio = this.lfdSize.h/this.mainFrame.h;
        var w = Math.round(widthRatio*frame.w);
        var h = Math.round(heightRatio*frame.h);
        $("#frameResDivID").html(w +" x "+h);
        $("#frameResDivID").show();
    }
};
template.prototype.resetRotateHandler=function(frameId){
    var tmpAngle = 0;
 	var rotateElem = frameId+'_rotateHandler';
	var coverObj = $('#frameCover-'+frameId);
	if(coverObj.attr('angle')!=undefined || coverObj.attr('angle')!='undefined')
    {
        tmpAngle = coverObj.attr('angle');
    }
	var frame = this.innerFrames[frameId];
    var angleInDeg = getRotationDegrees($('#'+frameId+'_rotateHandler'));
    $('#'+frameId+'_rotateHandler').css('transform','rotate('+getParseIntInDec(tmpAngle)+'deg)');
    var rh_HW = Math.ceil(ROTATE_HANDLER_HW/this.mainFrame.scale);
    rh_HW = rh_HW<16?16:rh_HW;
		switch(getParseIntInDec(tmpAngle))
		{	
			case 90:				
				this.setDimXYWH(rotateElem,getParseIntInDec(frame.w),(getParseIntInDec(frame.h)/2)+rh_HW/2,rh_HW,rh_HW);
			break;			
			case 180:
				this.setDimXYWH(rotateElem,getParseIntInDec(frame.w)/2-rh_HW/2,getParseIntInDec(frame.h)+rh_HW,rh_HW,rh_HW);
			break;
			case 270:
				this.setDimXYWH(rotateElem,-1*rh_HW,(getParseIntInDec(frame.h)/2)+rh_HW/2,rh_HW,rh_HW);
			break;
			case 0:
			case 360:
				this.setDimXYWH(rotateElem,getParseIntInDec(frame.w)/2-rh_HW/2,0,rh_HW,rh_HW);
			break;
			default:				
			break;					
		}
    $("#"+rotateElem).css({
        'margin-top':'-'+rh_HW+'px'
    });    
};
template.prototype.setImageElmAspectFillByDefault=function(frameId, ele)
{
    log.debug("START frame id  ="+frameId+" ele "+ele, "setImageElmAspectFillVal");
	var frame = this.getInnerFrameForId(frameId);
	if(frame.element.length>0)
	{
        if(ele.orgH==0 || ele.orgW==0)
        {
            ele.orgW=frame.w;
            ele.orgH=Math.round(ele.orgW/1.778*(this.modelType==STRETCH_MODEL?2:1));
        }
      	var calH=ele.orgH,calW=ele.orgW;
	    var wRatio;
		var hRatio;
		var marginStr;
		var newH,newW;
		var margin=0;
		switch(ele.elementType)
		{
			case GROUP:
			case IMAGE:
				if(ele.rotation==90 || ele.rotation==270)
			    {
			    	hRatio=frame.w/calH;
					wRatio=frame.h/calW;
					if(wRatio > hRatio)
					{
						newW=wRatio*calW;
						newH=wRatio*calH;
						margin=getParseIntInDec((newH-frame.w)/2);
						if(margin<0)
						{
							margin=margin*-1;
						}
						ele.y=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = -margin;
                        ele.initYOffset = 0;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}
					else
					{
						newW=hRatio*calW;
						newH=hRatio*calH;
						margin=getParseIntInDec((newW-frame.h)/2);
 						if(margin<0)
						{
							margin=margin*-1;
						}
						ele.x=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = 0;
                        ele.initYOffset = -margin;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}
                    ele.w=newW;
                    ele.h=newH;
			    }
			    else
                {
			   		wRatio=frame.w/calW;
					hRatio=frame.h/calH;
					if(wRatio > hRatio)
					{
						newW=wRatio*calW;
						newH=wRatio*calH;
						margin=getParseIntInDec((newH-frame.h)/2);
						ele.y=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = 0;
                        ele.initYOffset = -margin;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}
					else
					{
						newW=hRatio*calW;
						newH=hRatio*calH;
						margin=getParseIntInDec((newW-frame.w)/2);
						ele.x=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = -margin;
                        ele.initYOffset = 0;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}
                    ele.w=newW;
                    ele.h=newH;
                }			  	
                this.chkElmOfstForFrameId(frame.id);
                break;
			default:
                break;
		}
	}
    log.debug("COMPLETED", "setImageElmAspectFillVal");
};

template.prototype.aspectFillFrame=function(frameId)
{
	log.debug("frameId: "+ frameId,"aspectFillFrame");
	var frame = this.getInnerFrameForId(frameId);
	var ele = frame.element[frame.activeEleIndex]; 
	if(frame.element.length>0)
	{  
	    var imgObj=$("#"+frameId+"_Img");
        var imgDivObj=$("#"+frameId+"_ImgDiv");
        if(ele.orgH==0 || ele.orgW==0)
        {
           ele.orgW=frame.w;
           ele.orgH=Math.round(ele.orgW/1.778*(this.modelType==STRETCH_MODEL?2:1)); 
        }
      	var calH=ele.orgH,calW=ele.orgW;
	    var wRatio;
		var hRatio;
		var marginStr;
		var newH,newW; 
		var margin=0;
		var rotationFlag=false;
		switch(ele.elementType)
		{
			case GROUP:
			case IMAGE:
				if(ele.rotation==90 || ele.rotation==270)
			    {
			    	hRatio=frame.w/calH;
					wRatio=frame.h/calW;
					if(wRatio > hRatio)
					{		
						newW=wRatio*calW;
						newH=wRatio*calH;
						margin=getParseIntInDec((newH-frame.w)/2);                        
						if(margin<0)
						{
							margin=margin*-1;
						}				
						ele.y=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = -margin;
                        ele.initYOffset = 0;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}
					else
					{
						newW=hRatio*calW;
						newH=hRatio*calH;
						margin=getParseIntInDec((newW-frame.h)/2);
 						if(margin<0)
						{
							margin=margin*-1;
						}						
						ele.x=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = 0;
                        ele.initYOffset = -margin;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}		
                    ele.w=newW;
                    ele.h=newH;
                    imgObj.css({
                        'width':newW+'px'
                        ,'height':newH+'px'
                     });
                    imgDivObj.css({
                        'width':newH+'px'
                        ,'height':newW+'px'
                    });
			    }
			    else
			   {
			   		wRatio=frame.w/calW;
					hRatio=frame.h/calH;
					if(wRatio > hRatio)
					{		
						newW=wRatio*calW;
						newH=wRatio*calH;
						margin=getParseIntInDec((newH-frame.h)/2);
						ele.y=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = 0;
                        ele.initYOffset = -margin;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}
					else
					{
						newW=hRatio*calW;
						newH=hRatio*calH;
						margin=getParseIntInDec((newW-frame.w)/2);		
						ele.x=0;
                        ele.xOffset -= ele.initXOffset;
                        ele.yOffset -= ele.initYOffset;
                        ele.initXOffset = -margin;
                        ele.initYOffset = 0;
                        ele.xOffset += ele.initXOffset;
                        ele.yOffset += ele.initYOffset;
					}		
                    ele.w=newW;
                    ele.h=newH;
                    imgObj.css({
                        'width':newW+'px'
                        ,'height':newH+'px'                        
                    });
                    imgDivObj.css({
                        'width':newW+'px'
                        ,'height':newH+'px'
                    });
			   }
			  	
                this.chkElmOfstForFrameId(frame.id);
                this.transformActvFrameElm(frame, false);
			break;
			case VIDEO:			
				hRatio=frame.h/ele.orgH;
				wRatio=frame.w/ele.orgW;
				if(hRatio<wRatio)
				{
					newW=Math.round(hRatio*ele.orgW);
					newH=Math.round(hRatio*ele.orgH);
					margin=getParseIntInDec((frame.w-newW)/2);		
					marginStr="0px "+margin+"px 0px "+margin+"px";
				}
				else
				{
					newW=Math.round(wRatio*ele.orgW);
					newH=Math.round(wRatio*ele.orgH);
					margin=getParseIntInDec((frame.h-newH)/2);		
					marginStr=margin+"px 0px "+margin+"px 0px";
				}			
    				imgObj.css({
    					'width':newW+'px'
    					,'height':newH+'px'
    					,'margin':	marginStr			
    				});				
			break;			
			default:
			break;
		}
	}
log.debug("Completed","aspectFillFrame");
};
template.prototype.chkMainFrameOffSet = function(){    
	var scaledW = this.mainFrame.w*this.mainFrame.scale;
	var scaledH = this.mainFrame.h*this.mainFrame.scale;   
    var x1 = this.mainFrame.x + this.mainFrame.xOffset - (scaledW-this.mainFrame.w)/2;
    var y1 = this.mainFrame.y + this.mainFrame.yOffset - (scaledH-this.mainFrame.h)/2;    
    var x2 = x1 + scaledW;
    var y2 = y1 + scaledH;    
    if(x1 > (this.mainFrame.x)){
        this.mainFrame.xOffset = (scaledW - this.mainFrame.w)/2;
    }
    if(y1 > (this.mainFrame.y)){
        this.mainFrame.yOffset = (scaledH - this.mainFrame.h)/2;
    }    
    if(x2 < (this.mainFrame.x + this.mainFrame.w)){
        this.mainFrame.xOffset = (this.mainFrame.w - scaledW)/2;
    }
    if(y2 < (this.mainFrame.y + this.mainFrame.h)){
        this.mainFrame.yOffset = (this.mainFrame.h - scaledH)/2;
    }        
};
template.prototype.onPinchInOutMainFrame = function(e){    
    var ele = this.mainFrame;
    if(e.scale >= 1){
        ele.scale += ele.common.scaleFactor + (e.scale - ele.scale);
    }else{
        ele.scale -=  ele.scale*e.scale/20;
    }   
    if(ele.scale>1 && ele.scale <= 4){
        if(e.scale < 1.0){
            this.chkMainFrameOffSet();
        }
        this.transformMainFrame();
    }else if(ele.scale>=4){
        ele.scale = 4;
        this.transformMainFrame();
    }else{
        ele.scale = 1;
    }
    if(e.eventType == Hammer.INPUT_END){
        ele.common.scaleFactor = ele.scale-1;
    }
    this.updateMainFrameBoxSOnZoom();
};
template.prototype.updateMainFrameBoxSOnZoom=function(){
    log.debug("Started","updateMainFrameBoxSOnZoom");
    var borderWElm;
    if(this.mainFrame.scale<1)
    {
        borderWElm = Math.ceil(5*this.mainFrame.scale);
    }
    else
    {
        borderWElm = Math.ceil(5/this.mainFrame.scale);
    }
    $(".tpl_frameMainCls").css({
        'box-shadow': '0px 0px 0px '+ borderWElm +'px white',
        '-webkit-box-shadow':  '0px 0px 0px '+ borderWElm +'px white'
    });
    $("#mainFrameCoverID").css({
       'box-shadow': '0px 0px 0px '+ borderWElm +'px white',
       '-webkit-box-shadow':  '0px 0px 0px '+ borderWElm +'px white'
    });
    log.debug("Completed = "+borderWElm,"updateMainFrameBoxSOnZoom");
};
template.prototype.onPanMainFrame = function(e){
    try{
        if(this.mainFrame.active){
            if(e.type == 'panstart'){
                this.mainFrame.common.prevPoint = e.center;
            }            
            this.mainFrame.xOffset += e.center.x - this.mainFrame.common.prevPoint.x;
            this.mainFrame.yOffset += e.center.y - this.mainFrame.common.prevPoint.y;            
            this.chkMainFrameOffSet();
            this.transformMainFrame();         
            this.mainFrame.common.prevPoint = e.center;
        }
    }
    catch(ex)
    {
        log.debug("Error in onPanMainFrame: "+ ex);
    }
};
template.prototype.transformMainFrame=function()
{
    jq_ScaleFactor = this.mainFrame.scale;
	var tranStr='translate('+ this.mainFrame.xOffset+'px,'+this.mainFrame.yOffset+'px) scale('+ this.mainFrame.scale+','+this.mainFrame.scale+')';
	$("#mainFrameCoverID,#"+this.mainFrame.id).css({
         '-webkit-transform': tranStr
        ,'transform':tranStr
     });
};
template.prototype.rotationInitialize = function()
{	
	var currObj = this;	
	currObj.unbindEvent(".rotateHandlerCls","touchstart touchcancel touchend");
	$(document).on('touchstart','.rotateHandlerCls',function(e){	    		
		rotateMode = true;
		currObj.dragLocation=FRAME_ROTATION;
		currRotateObj = $(this).parent();
		rotateControlObj = $(this);
		var offset = currRotateObj.offset();
		elem_center_x = (offset.left) + ( currRotateObj.width() / 2 );
		elem_center_y = (offset.top) + ( currRotateObj.height() / 2 );
		$(this).removeClass('rotateHandlerCls-nor').addClass('rotateHandlerCls-active');
        var frameID = currRotateObj.attr('id').split("-")[1];
        var tmpFrame = currObj.getInnerFrameForId(frameID);                
        currObj.imageX = $("#"+tmpFrame.id+"_ImgDiv").offset().left - currObj.mainFrame.x - tmpFrame.x;
        currObj.imageY = $("#"+tmpFrame.id+"_ImgDiv").offset().top - currObj.mainFrame.y - tmpFrame.y;        
        currObj.transformActvFrameElm(tmpFrame, true);        
        if(currObj.isCroppedMode)
        {
            currObj.showCropOverlay(frameID,true);
            var ele = tmpFrame.element[tmpFrame.activeEleIndex];
            if(ele.rotation == 90 || ele.rotation == 270){
                currObj.setCropOverlayDivPos(frameID, "_ImgDiv");
            }else{
                currObj.setCropOverlayDivPos(frameID, "_Img");
            }
        }
	}).on('touchend touchcancel','.rotateHandlerCls', function(e){
	    if(rotateMode && ANGLE_DIFF > 0)
        {
            var angle = parseFloat(currRotateObj.attr('angle'));            
            angle = angle%90 <= SNAP_VALUE ? angle - angle % 90 : ((90 - angle % 90) <= SNAP_VALUE ? angle + (90 - angle % 90) : angle);
            angle = angle + getParseIntInDec(getRotationDegrees(rotateControlObj));
            currObj.setAngleOnTouchEnd(currRotateObj,angle);                                             
        }        
        rotateMode = false;
        currRotateObj =  null;
        ANGLE_DIFF = 0;        
        if(currObj.isCroppedMode)
        {
            var frameID = currObj.getActiveFrame().id;
            if(frameID.indexOf("_Main")==-1)
            {
                currObj.showCropOverlay(frameID,true);
            }
        }
        currObj.dragLocation=DEFAULT_VALUE;
        $('.rotateHandlerCls-active').removeClass('rotateHandlerCls-active').addClass('rotateHandlerCls-nor');        
	});
};
template.prototype.rotateElement = function(e, elemID, center_x, center_y){	
    var offset = elemID.offset();
    var mouse_x = pointerEventToXY(e).x;
    var mouse_y = pointerEventToXY(e).y;
    var radians = Math.atan2(mouse_x - center_x, mouse_y - center_y);
    var degree = (radians * (180 / Math.PI) * -1) + 180; 
    this.setAngle(elemID,degree);
    ANGLE_DIFF = degree;
};
template.prototype.setAngle = function(elemID,degree){    
    var actAngle = degree;
    degree = degree - getParseIntInDec(getRotationDegrees(rotateControlObj));
    elemID.css('transform', 'rotate('+degree+'deg) translateZ(0)');
    var frameID = elemID.attr('id').split("-")[1];
    elemID.attr('angle', degree);    
    var tmpFrame = this.getInnerFrameForId(frameID);   
    var  tmpActiveElement = tmpFrame.getActiveElement();
    tmpActiveElement.rotation=actAngle;
    var originX = elemID.width()/2-tmpActiveElement.xOffset;
    var originY = elemID.height()/2-tmpActiveElement.yOffset;
    this.transformActvFrameElm(tmpFrame, true);	
};
template.prototype.setAngleOnTouchEnd = function(elemID,degree)
{
    log.debug("degree: "+ degree,"setAngleOnTouchEnd");  
    var frameID = elemID.attr('id').split("-")[1];
    elemID.css('transform', 'rotate(0deg)');
    elemID.attr('angle', degree);
    rotateControlObj.css('transform', 'rotate('+degree+'deg)');
    var tmpFrame = this.getInnerFrameForId(frameID);
    var  tmpActiveElement = tmpFrame.getActiveElement();    
    if(this.currRotationAngle != degree){
        tmpActiveElement.xOffset = 0;
        tmpActiveElement.yOffset = 0;
        tmpActiveElement.initXOffset = 0;
        tmpActiveElement.initYOffset = 0;        
        tmpActiveElement.rotation=degree;
        this.aspectFillFrame(frameID);
    }
    tmpActiveElement.rotation=degree;
    this.currRotationAngle = degree;
    this.resetRotateHandler(frameID);
    this.transformActvFrameElm(tmpFrame, false);  
    log.debug("Complete ","setAngleOnTouchEnd");   
};
template.prototype.getTextObjectFromId = function(elmID){
    var textObj = null;
    try{
        if(elmID.indexOf("_Main") != -1){
            var arr = elmID.split("-elm_");
            var frameId = arr[0];
            var indexArr = arr[1].split("_");
            textObj = this.mainFrame.element[getParseIntInDec(indexArr[0])];
            if(textObj!=null && this.isTxtTypeElm(textObj.elementType))
            {
                textObj=textObj.textElms[getParseIntInDec(indexArr[1])];
            }
        }else if(elmID.indexOf("-elm_") != -1){
            var arr = elmID.split("-elm_");
            var frameId = arr[0];
            var indexArr = arr[1].split("_");
            var frame = this.getInnerFrameForId(frameId);
            textObj = frame.element[getParseIntInDec(indexArr[0])].textElms[getParseIntInDec(indexArr[1])];
        }else if(elmID.indexOf("_Col-") != -1){
            var arr = elmID.split("_Col-");
            var frameId = arr[0];
            var indexArr = arr[1].split("_");
            var frame = this.getInnerFrameForId(frameId);
            textObj = frame.table.col[getParseIntInDec(indexArr[0])][getParseIntInDec(indexArr[1])];
        }else{
           log.debug("THE TEXT OBJECT ID INCORRECT. ID = "+elmID);
        }
    }
    catch(e){
    	textObj = null;
    };    
    return textObj;
};
template.prototype.updateTextObj = function(textObj, type, name, val,elmID)
{
    log.debug("elmID = "+elmID +" name = "+name+" val = "+val, "updateTextObj");
    var currObj=this;
    switch(name)
    {
        case 'timezone':
    		textObj.timeZoneOffset = val;
    	break;    
        case 'time-format':
            textObj.format=getParseIntInDec(val);
        break;
        case 'text-align':
            textObj.hAlign = val;
            break;            
        case 'vertical-align':
            textObj.vAlign = val;
            break;
        case 'font-size':
            textObj.fontSize = getParseIntInDec(val);            
            break;            
        case 'font-family':
            textObj.fontFamily = val;           
         break;            
        case 'font-weight':
            if(val =='bold'){
                textObj.fontBold = true;
            }else{
                textObj.fontBold = false;
            }
            break;
            
        case 'color':
            textObj.fontColor = val;
            break;
        case 'text-decoration':
            if(val == 'underline'){
                textObj.fontUnderLine = true;
            }else{
                textObj.fontUnderLine = false;
            }
            break;
        case 'font-style':
            if(val == 'italic'){
                textObj.fontItalic = true;
            }else{
                textObj.fontItalic = false;
            }
            break;
        case 'background-color':
            currObj.setBGColorandAlpha(textObj,val);            
            break;
        case 'opacity':
            textObj.bgAlpha= getParseIntInDec(val);          
        break;
        case 'text-slide':
            if(val == true || val == "true"){
                textObj.bTextSlide = true;
            }else{
                textObj.bTextSlide = false;
            }
            break;
        case 'slide':
            textObj.slideType = getParseIntInDec(val);
            break;
       case 'slide-speed':
        	if(textObj.bTextSlide == true || textObj.bTextSlide == "true"){
                textObj.slideSpeed = val;
            }else{
                textObj.rssInfo.flipSpeed = val;
            }
            break;
      case 'reload-duration':
        	    textObj.rssInfo.reloadDuration = val;
            break;
        case 'done': 
            if($("#"+elmID+"_InrElm").length >0){         
                textObj.text = $("#"+elmID+"_InrElm").html();            
                if($.trim(textObj.text)=="")
                {
                    textObj.text=MIA_SID_DOUBLE_TAP_TO_EDIT;
                }
            }
            break;       
        default:
            break;
    }
    
    if($("#"+elmID+"_InrElm_Img").length >0){
        this.textImageUpdate(elmID);
    }
    log.debug("COMPLETED", "updateTextObj");
};
template.prototype.setBGColorandAlpha=function(txtObj,val)
{
    if(val)
    {
        if(val.indexOf("rgba(")!=-1)
        {
            val=val.replace("rgba(","").replace(")","").split(",");
            txtObj.bgColor='rgb('+val[0]+','+val[1]+','+val[2]+')';
            txtObj.bgAlpha=getParseIntInDec(parseFloat(val[3])*100);
        }
        else
        {
            txtObj.bgColor=val;         
        }
    }
};
template.prototype.applyTextProperties = function(elmID, type, name, val, bTable)
{
    log.debug("elmID = "+elmID, "applyTextProperties");
    log.debug("2type = "+type+" name = "+name+" val = "+val, "applyTextProperties");
    var currObj=this;
    var textDiv = null;
    type=getParseIntInDec(type);
    if(bTable){
        var arr = elmID.split("_Col-");
        var frameId = arr[0];
        var indexArr = arr[1].split("_");
        if(name == 'vertical-align' || name == 'font-family'){
            textDiv = $("#"+frameId +" .tblTxtCls");
        }else{
            var colIndex = getParseIntInDec(indexArr[0]);
            if(colIndex == 0){
                textDiv = $("#"+frameId +" .tmplTxtMenuEleCls");
            }else{
                textDiv = $("#"+frameId +" .tmplTxtPriceEleCls");
            }
        }
    }else{
        textDiv = $("#"+elmID+"_InrElm");
    }
    switch(name)
    {    
    	case'timezone':
	    	var x = currObj.getTextObjectFromId(elmID);
	    	$("#"+elmID+"_InrElm").text(getDateTime(currObj.getTextObjectFromId(elmID).format, type, val));
    	break;   
       case 'time-format':       
          textDiv.html(getDateTime(getParseIntInDec(val), type, currObj.getTextObjectFromId(elmID).timeZoneOffset));
       break;
       case 'text-align':            
           textDiv.removeClass("hAligncenter hAlignleft hAlignright");    
           textDiv.addClass("hAlign"+val);           
       break;                     
       case 'vertical-align':
           textDiv.removeClass("vAlignmiddle vAligntop vAlignbottom");
           textDiv.addClass("vAlign"+val);           
       break;       
        case 'delete':                    
           currObj.deleteTxtElmFrmTemplate(elmID);
        break;     
        case 'font-size':       
            textDiv.css(name,currObj.resizeTextToTabSize(val)+"px");
        break;
        case 'background-color':
        case 'opacity':
            var textObj = currObj.getTextObjectFromId(elmID);
            if(textObj!=null)
            {
                if(name=="background-color")
                {
                    textDiv.css({
                        'background-color':getRGBColorInRGBA(val,textObj.bgAlpha)
                    });
                }
                else
                {
                    textDiv.css({
                        'background-color':getRGBColorInRGBA(textObj.bgColor,val)
                    });                    
                }
            }
        break;        
        case 'font-family': 
        case 'font-weight':
        case 'color':
        case 'text-decoration':
        case 'font-style':        
       default:
            textDiv.css(name,val);
       break;
    }
    if(type==TEXT)
    {
   	 textDiv.hide();
    }    
};
template.prototype.deleteTxtElmFrmTemplate = function(elmID){
    $("#"+elmID).remove();
    if($("#ElmCover-"+elmID).length>0){
        $("#ElmCover-"+elmID).remove();
    }
    if(elmID.indexOf("_Main")!=-1)
    {
        this.deleteElmFromMainFrame();
    }else if(elmID.indexOf("-elm_") != -1){
        var arr = elmID.split("-elm_");
        var frameId = arr[0];
        var indexArr = arr[1].split("_");
        var frame = this.getInnerFrameForId(frameId);
        var itmIndex = getParseIntInDec(indexArr[1]);
        var actvElmIndx=getParseIntInDec(indexArr[0]);
        frame.element[actvElmIndx].textElms[itmIndex]=null; 
        this.rmIndxFrmMnFrmLyerArr(itmIndex);               
        this.showMainFrame();
    }
};
template.prototype.getActiveFrame=function()
{
	if(this.curSelFrameIndx!=-1)
	{
		return this.innerFrames[FRAME_ID_PREFIX+this.curSelFrameIndx];
	}
	else
	{
		return this.mainFrame;
	}
};
/* template object functions related to thumbnail and transition list : Start*/
template.prototype.renderSlideShowList=function()
{
	var currObj=this;
	var mainAreaW=WIN_INNER_W;
	var mainAreaH=Math.round(WIN_INNER_H*0.1821);
	var hdrHeight=Math.round(WIN_INNER_H*0.0758);
	var thumbH=Math.round(mainAreaH*0.6547);	
	var marginLR=Math.round((mainAreaW*0.0314)/2);
	var marginTop=Math.round((mainAreaH-thumbH)/2);
	var thumbBorder=Math.round(thumbH*0.040);
	var thumbDelHW=Math.round((thumbH*0.24)/2);	
	var tranAreaHeight=Math.round(mainAreaH*0.815);
	var tranAreaPadTop=Math.round((mainAreaH-tranAreaHeight)/2);
	var textSize=Math.round(mainAreaH*0.0926);
	var tranAreaPadL=Math.round((mainAreaH-thumbH)/2)-marginLR;
	var txtPad=Math.round(mainAreaH*0.042);
	var txtFontSize=Math.round(hdrHeight*0.35);
	var tranSmallBtn=Math.round(hdrHeight*0.7);
	var mTop=Math.round((hdrHeight-tranSmallBtn)/2);
	var mRight=Math.round(mainAreaW*0.0416);
	var hlfWidth=getParseIntInDec(mainAreaW/2);
	var secNFont=Math.round(hdrHeight*0.55);
	$("#btmListHdrDvId,.durTdCls").css({
	    'height':hdrHeight+'px'
	});
	$("#btmListDataDvId").css({
	    'height':mainAreaH+'px'
	});
	$("#durBtnParId").css({
	    'width':hlfWidth+'px'
	});
	$("#tranBtnParId").css({
	    'width':(hlfWidth-1)+'px'
	});
	$("#frameImagesDivId").css({
        'height':mainAreaH+hdrHeight+'px'
        ,'width':mainAreaW+'px'
    });
    $("#dividerParId").css({
        'height':tranSmallBtn+'px'
        ,'margin-top':mTop+'px'
    });
    $(".tranBtnIconCls,.hdrAudioIconCls").css({
         'width':tranSmallBtn+'px'
        ,'height':tranSmallBtn+'px'
        ,'margin-top':mTop+'px'       
        ,'margin-right':mRight+'px'        
    });
    $(".tranBtnIconCls").css({
         'font-size':Math.round(hdrHeight*0.15)+'px'
          ,'box-shadow':'0px 0px 0px 1px #FFFFFF'
    });
    $(".tranBtnTxtCls,.hdrAudioTxtCls").css({
        'width':(hlfWidth-1-tranSmallBtn-mRight)+'px'
        ,'font-size':txtFontSize+'px'
        ,'line-height':hdrHeight+'px'
        ,'height':hdrHeight+'px'
    });    
    $("#audioEmptyDivId").css({
        'font-size':txtFontSize+'px'
    });
    $(".hdrAudioTxtCls").css({
        'width':(mainAreaW-tranSmallBtn-(2*mRight))+'px'
    });
        
	$(".transImgMainCls").css({
	    'margin':Math.round((mainAreaH-thumbH)/2)+'px '+'0px 0px '+(2*marginLR)+'px'
        ,'width':thumbH+'px'
        ,'height':thumbH+'px'
        ,'float':'left'     
	});
	$(".tranArwCls").css({
	    'width':hdrHeight+'px'
	    ,'height':hdrHeight+'px'
	});
	$("#transHdrTxtId").css({
	    'width':(mainAreaW-hdrHeight)+'px'
	});
	$("#transHdrTxtId,.hdrAudioTxtCls").css({
	    'font-size':txtFontSize+'px'
        ,'line-height':hdrHeight+'px'
        ,'height':hdrHeight+'px'
	});
	$(".secTxtCls,.durTxtCls,.playTimeTxtCls").css({
	    'font-size':txtFontSize+'px'
	    ,'line-height':txtFontSize+'px'
        ,'height':txtFontSize+'px'          	         
	});
	 $("#durTxtSecId,.playTimeCls").css({
	     'font-size':secNFont+'px'
	     ,'line-height':secNFont+'px'
        ,'height':secNFont+'px'                
	 });
	 
	 $(".secTxtCls").css({
	     'margin-top':Math.round(secNFont-txtFontSize)/2+'px'
	 });
	 
	$(".durTxtCls,.playTimeTxtCls,.playTimeCls").css({	     
	    'margin-left':mRight+'px'  	    	    	  	   	   	    	   
	});
	$(".durTxtCls").css({
	    'margin-right':mRight+'px'
	});
    $("#tmpltThumbParID").attr("brdrW",thumbBorder);
	$(".transImgMainCls").attr("brdrW",thumbBorder);
	$(".thumbTranImgCls").css({
		'height':thumbH+'px'
		,'width':thumbH+'px'		
		,'font-size':textSize+'px'
	});
	$(".thumbTranTxtCls").css({
		'height':textSize+'px'
		,'line-height':textSize+'px'
		,'font-size':textSize+'px'
		,'width':thumbH+'px'	
		,'margin-top':Math.round(mainAreaH*0.07)+'px'
	});
	$("#imgThumbParId").attr("cssStyle",mainAreaH+"|"
                                        +thumbH+"|"
                                        +marginLR+"|"
                                        +marginTop+"|"
                                        +thumbBorder+"|");
                                        
	$("#audioThumbParId").attr("cssStyle",tranAreaPadTop+"|"
    +marginLR+"|"
    +tranAreaHeight+"|"
    +thumbH+"|"
    +thumbBorder+"|"
    +textSize+"|"
    +Math.round(tranAreaHeight*0.083));	
		
	$("#recycleDivID").css({
	    'height':hdrHeight+'px'
	    ,'top':'-'+hdrHeight+'px'
	    ,'width':mainAreaW+'px'
	    ,'background-size':Math.round(hdrHeight)+'px '+Math.round(hdrHeight*0.50)+'px'
	    ,'background-position':'center center'	    
	});
	var recycleSelH=Math.round(WIN_INNER_H*0.106);
	$("#recycleBinIcon").css({
	    'bottom':Math.round(recycleSelH*0.25)+'px'
	    ,'font-size':Math.round(recycleSelH*0.185)+'px'
	    ,'line-height':Math.round(recycleSelH*0.125)+'px'
	    ,'height':Math.round(recycleSelH*0.125)+'px'	    
	});
	$("#tmpltInnerDivId,#tmpltTranInnerDivId,#audioListDivId").css({
		'height':mainAreaH+'px'
		,'width':mainAreaW+'px'		
	});		
	
	/*--------------Audio List Calculation: Start------------*/
	var audioIconH=Math.round(mainAreaH*0.3148);
	var fntSize=Math.round(mainAreaH*0.1018);	
	$("#audioListParId").css({
	   'height':(mainAreaH-8)+'px' 
	});	
	/*--------------Audio List Calculation: End------------*/	
	var tranCount=$("#tranThumbDataId").children().length;
	$("#tranThumbDataId").append('<div style="margin-left:'+(2*marginLR)+'height:30pxwidth:1px;float:left;border:1px solid transparent;"></div>');
	$("#tranThumbDataId").width((tranCount*$(".transImgMainCls").outerWidth(true))+4+(2*marginLR));
	currObj.unbindEvent(".overflowDivCls","tap");	
	$(document).on("tap",".overflowDivCls",function(e){
	    e.preventDefault();
        e.stopPropagation();        
        return false;
	});
};
template.prototype.showHideTransBtn=function(flag)
{    
    $("#tranBtnParId").hide();       
};
template.prototype.renderFrameThumbs=function(iFrameId)
{	
	log.debug("iFrameId6:"+iFrameId,"renderFrameThumbs");
	if(isListRendrOnce)
	{
		this.hideItemList(false);
		if(slideShowScroll!=null)
		{
		  Utils.refreshScrollbar(slideShowScroll);
		}
		return true;
	}
	var frame=this.getInnerFrameForId(iFrameId);
	var elmLength=frame.element.length;
	var frmType=this.getFrameType(iFrameId);
	if(elmLength<2)
	{
		$("#imgSubHrdId").addClass("icon-disabled");
	}
	else
	{
	    $("#imgSubHrdId").removeClass("icon-disabled");
	}	
	this.showList("img");
	$(".overflowDivCls").scrollLeft(0);		
	$("#tmpltThumbParID").empty();		
	this.showHideTransBtn(true);
	$("#tranBtnParId").removeClass("icon-disabled");	
	$("#durTxtSecId").html(frame.duration);		
	$("#TimePicker").remove();	
	var currObj=this,elm,elmCount=0,thumbList = "",classR="notReplaceableCls";
	var timeInMiliSec=getTimeWithMiliSec();
	for(var i=0;i<elmLength;i++)
	{
		elm=frame.element[i];
		if(elm!=null)
		{
			classR="notReplaceableCls"
            if(currObj.isRplcableSlot(elm))
            {
                classR="replaceableCls";
            }
			elmCount++;
			thumbList+='<li id="'+frame.id+'_thumb-'+i+'" class="tmpltImgThumbCls '+classR+'">'
                +'<div class="thumbImgContCls" id="'+frame.id+'_thumbImg-'+i+'" style="background-image:url(\''+elm.thumbPath+'?ts='+timeInMiliSec+'\');"></div>'               
                +'<div class="sepImgDivCls" id="'+frame.id+'_sepBox-'+i+'" style="display:'+(this.isSepSlot(elm.slotType)?"block":"none")+';background-image:url(\''+elm.thumbSepImg+'?ts='+timeInMiliSec+'\');"></div>'
                +'<div class="thumbVdoIconcls" style="display:'+(elm.elementType==VIDEO?"block":"none")+';"></div>'
                +'<div class="chkBoxDivCls" id="'+frame.id+'_chkBox-'+i+'"></div>'
            +'</li>';
			/*Preload Image*/
			$('<img src="'+elm.thumbPath+'"/>');				
		}
	}
	$(".thumbVdoIconcls").hide();
	$("#tmpltThumbParID").append(thumbList);
	currObj.tempSelTran=frame.transitionEffect;		
	currObj.calTempltThumbDim(elmCount);	
	currObj.selectThumbItem(frame.id+"_chkBox-"+frame.activeEleIndex);
	currObj.addEventOnListThumb();
	$("#tmpltThumbParID").append('<li id="sortableStoperLi" class="disbaleAddButton" style="width:1px;height:1px;float:left;margin-left:'+Math.round(WIN_INNER_W*0.0314)+'"></li>');
	initHorizontalSwap("tmpltInnerDivId");
	currObj.onOffScrollOnList(true);
	refreshScreen();
	isListRendrOnce=true;
};
template.prototype.isSepSlot=function(slotTyp)
{
   if(slotTyp==slotType.SLOT_IMAGE_SEPARATOR || slotTyp==slotType.SLOT_VIDEO_SEPARATOR || slotTyp==slotType.SLOT_SEPARATOR)
   {
       return true;
   } 
   return false;
};
template.prototype.addEventOnListThumb=function()
{
   var currObj=this;
    currObj.unbindEvent(".chkBoxDivCls","tap touchstart touchmove touchend touchcancel taphold");        
    $(document).on("tap",".chkBoxDivCls",function(e){
        e.preventDefault();
        e.stopPropagation();
        if(!currObj.listTapHold)
        {                      
            var frame=currObj.getActiveFrame();         
            currObj.showCropOverlay(frame.id,false);
            currObj.selectThumbItem($(this).attr("id"));
            frame.activeEleIndex=getParseIntInDec($(this).attr("id").split("-")[1]);
            currObj.renderActvElmOfFrame(frame.id);                       
        }
        return false;
    });
     $(".chkBoxDivCls").on("touchstart",function(e){
        if(currObj.listTapHold && evntSeq=="tapHold->")
        {   
            evntSeq=evntSeq+"tchStart->";
            $("#dummyDivID").remove();
            var elm=$(this);             
            elm=elm.parent().find("div.thumbImgContCls");            
            $("body").append('<div id="dummyDivID"></div>');
            $("#dummyDivID").attr("style",elm.attr("style"));
            elm.parent().addClass("icon-disabled");            
            $("#dummyDivID").css({
                'position':'fixed'                             
                ,'z-index':'9999999990'                                                                                     
            });
            currObj.setDummyDivPos(e);                        
        }        
        tchEvnt=e;
    }).on("touchmove",function(e){        
        if(currObj.listTapHold)
        {  
            evntSeq="";
            currObj.setDummyDivPos(e);   
        }        
    }).on("touchcancel touchend",function(e){        
        if(currObj.listTapHold)
        { 
          $(this).parent().removeClass("icon-disabled");
          evntSeq=evntSeq+"tchEnd";          
          $("#dummyDivID").remove();
          clearAllIntervals();
          log.debug("isItemDropped: "+isItemDropped);
          currObj.listTapHold=false;        
          tchEvnt=null;          
          if($(this).hasClass("chkBoxDivCls"))
          {             
            setTimeout(function(){
                disableDragDrop("tmpltInnerDivId");
                currObj.onOffScrollOnList(true);
                if(!isItemDropped)
                {
                   currObj.simTapActviveElmnt(); 
                }       
            },500);                     
          }
        }               
    });        
    $(".chkBoxDivCls").on("taphold",function(){
        if(!currObj.listTapHold && evntSeq!="tapHold->tchStart->tchEnd")
        {   
            var slotIndx=getParseIntInDec($(this).attr("id").split("-")[1]);
            var frame=currObj.getActiveFrame();
            var elm1=frame.element[slotIndx];            
            if(currObj.isRplcableSlot(elm1))
            {  
                isItemDropped=false;
                $(".chkBoxDivCls").css({
                    '-webkit-box-shadow':''    
                    ,'box-shadow':''
                });                
                evntSeq="tapHold->";            
                currObj.listTapHold=true;
                closeAuthorMenu();            
                currObj.onOffScrollOnList(false);            
                enableDragDrop("tmpltInnerDivId");                                
                $(this).trigger(tchEvnt);
            }
            else
            {
                currObj.unReplcbleSlotTost();
            }                                           
        }
        else
        {
            evntSeq="";
        }
        return false;         
    });
   log.debug("COMPLETE","attachEventToThumbnails");        
};
template.prototype.callOutSideTap=function()
{
    $("#tplMainContainer").trigger("tap");
};
template.prototype.unReplcbleSlotTost=function()
{
    Utils.showToast(langObj.Adclip.MIA_SID_CAN_REPLACE_CHANGE_POSITONS_IMAGES);
};
template.prototype.showVideoDuration=function(frame)
{        
    var elmnt=frame.element[frame.activeEleIndex];    
    if(elmnt.elementType==VIDEO)
    {
       this.setVideoDuration(frame);
    }   
};
template.prototype.setVideoDuration=function(frame)
{
   var totalDuration=0;
   var totalElement=frame.element.length;
   for(var i=0;i<totalElement;i++)
   {           
       totalDuration+=getParseIntInDec(frame.element[i].duration);
   }
   frame.duration=totalDuration;   
};
template.prototype.onOffScrollOnList=function(iFlag)
{
  try
  {   
    log.debug("Iscroll flag: "+ iFlag + ",slideShowScroll: "+slideShowScroll,"onOffScrollOnList");   
    if(slideShowScroll==null)
    {     
        slideShowScroll = new IScroll('#tmpltInnerDivId',{
                scrollX: true,
                scrollY: false,                
                interactiveScrollbars: true,
                shrinkScrollbars: 'scale',
                fadeScrollbars: true,
                scrollbars: true,
                disablePointer: true,
				disableTouch: false
                });
        slideShowScroll.refresh();
     }         
      var currX=slideShowScroll.x*-1;          
     if(iFlag)
     {          
        $(".overflowDivCls").css("overflow-x","hidden");  
        $("#tmpltInnerDivId").scrollLeft(0);        
        slideShowScroll.enable();
        slideShowScroll.scrollTo(scrollLft*-1,0,0);                       
        Utils.refreshScrollbar(slideShowScroll);         
     }
     else
     {  
        slideShowScroll.scrollTo(0,0,0);
        $(".overflowDivCls").css("overflow-x","auto");
        slideShowScroll.disable();       
        $("#tmpltInnerDivId").scrollLeft(currX);        
     }   
  }  
  catch(ex)
  {
      log.debug("Error"+ex,"onOffScrollOnList");
  }
};
template.prototype.selectThumbItem=function(selItemID)
{		
	var thumbBorder=$("#tmpltThumbParID").attr("brdrW");   
    $(".chkBoxDivCls").css({
        '-webkit-box-shadow':''    
        ,'box-shadow':''
    });    
    $("#"+selItemID).css({
        '-webkit-box-shadow':'0px 0px 0px '+thumbBorder+'px #3196ff'    
        ,'box-shadow':'0px 0px 0px '+thumbBorder+'px #3196ff'
    });
};
template.prototype.calTempltThumbDim=function(iCount)
{
	var cssStyle=$("#imgThumbParId").attr("cssStyle");
	cssStyle=cssStyle.split("|");	
    var mainAreaH=getParseIntInDec(cssStyle[0]);    
    var thumbH=getParseIntInDec(cssStyle[1]);    
    var marginLR=getParseIntInDec(cssStyle[2]);
    var marginTop=getParseIntInDec(cssStyle[3]);
    var thumbBorder=getParseIntInDec(cssStyle[4]);
   
	$(".tmpltImgThumbCls").css({
		'height':thumbH+'px'
		,'width':thumbH+'px'
		,'margin':marginTop+'px 0px 0px '+(2*marginLR)+'px'		
	});
	$(".chkBoxDivCls").css({
	    'height':thumbH+'px'
        ,'width':thumbH+'px'
	});
	$(".thumbVdoIconcls").css({
	    'height':Math.round(thumbH*0.20)+'px'
        ,'width':Math.round(thumbH*0.20)+'px'
        ,'top':(thumbBorder+2)+'px'
        ,'right':(thumbBorder+2)+'px'
	});	
	$(".thumbImgContCls,.sepImgDivCls").css({
		'height':thumbH-(2*thumbBorder)+'px'
		,'width':thumbH-(2*thumbBorder)+'px'
		,'border':thumbBorder+'px solid #FFFFFF'
	});	
	var totalWidth=(iCount*$(".tmpltImgThumbCls").outerWidth(true))+1;
	$("#tmpltThumbParID").css({
		'height':(mainAreaH-8)+'px'
		,'width':totalWidth+(2*marginLR)+'px'
	});
};
template.prototype.showList=function(iToken)
{
    $(".listHrdDivCls").hide();
    $(".btmListDataCls").hide();
    $("#frameImagesDivId").show();
    $("#recycleDivID").hide();       
    this.isListVisible=true;
    this.listTapHold=false;
    $("#"+iToken+"HrdDivId").show();
    $("#"+iToken+"ThumbParId").show();
    $("#frameImagesDivId").css({
         'bottom':'0%'
     });     
    switch(iToken)
    {        
        case 'tran':            
            this.listStatus="transThumb";
        break;
        case 'img':            
             this.listStatus="imgThumb";      
               $("#imgSubHrdId").hide();   
                $("#vdoSubHrdId").show();
                this.showHideTransBtn(false);          
        break;
        default:
        break;
    }
};
template.prototype.textImageShow=function(txtDivId, bShow){
    log.debug("txtDivId = "+txtDivId+" bShow = "+bShow, "textImageShow");
    var txtObj = this.getTextObjectFromId(txtDivId);
    if(txtObj != null){
        if(txtObj.bTextSlide && bShow){
            $("#"+txtDivId+"_InrElm").hide();
            $("#"+txtDivId+"_InrElm_Img").hide();
            this.textSlideShow(txtDivId, txtObj);
        }else{
            if(bShow){
                $("#"+txtDivId+"_InrElm").hide();
                $("#"+txtDivId+"_InrElm_Img").show();
            }else{
                $("#"+txtDivId+"_InrElm").show();
                $("#"+txtDivId+"_InrElm_Img").hide();
            }
            
            $("#"+txtDivId+"_InrElm_Img").css({
                'height':txtObj.h+'px'
                ,'width':txtObj.w+'px'
            });
            if($("#"+txtDivId+"_SlideElm").length >0){
                $("#"+txtDivId+"_SlideElm").hide();
            }           
        }
    }
    log.debug("COMPLETED", "textImageShow");
};
template.prototype.textSlideShow=function(txtDivId, txtObj){
     var txtDiv = $("#" + txtDivId + "_SlideElm");
    var txtInrDiv=$("#" + txtDivId + "_SlideElm .slidElmTdCls");    
    txtDiv.show();   
        var sldTyp = getSlidTypFrMarq(txtObj.slideType);
        log.debug("2sldTyp: "+sldTyp+",txtObj.vAlign: "+txtObj.vAlign+",txtObj.hAlign:"+txtObj.hAlign+",txtObj.text:"+txtObj.text,"textSlideShow");
        txtInrDiv.html(txtObj.text);        
        txtDiv.css({
            'height' : txtObj.h + 'px',
            'width' : txtObj.w + 'px',
            'font-family' : "NotoSans-Regular",
            'font-size' : this.resizeTextToTabSize(txtObj.fontSize) + 'px',
            'color' : txtObj.fontColor
        });     
        if (txtObj.bgColor != "") {
            txtDiv.css({
                'background-color' : getRGBColorInRGBA(txtObj.bgColor, txtObj.bgAlpha)
            });
        }
        txtInrDiv.removeClass("tdHalignleft tdHalignright tdHaligncenter tdValigntop tdValignmiddle tdValignbottom");
        var txtDivIdInrElm = $("#"+txtDivId+"_InrElm");
        var txtObjHandler = this.getTextObjectFromId(txtDivId);
        var slideTypeVer="bottom";
        if (sldTyp == "up" || sldTyp == "down") {             
            txtInrDiv.addClass("tdHalign" + txtObj.hAlign);
            txtDivIdInrElm.removeClass("vAlignmiddle vAligntop vAlignbottom");
            if(sldTyp == "up")
            {
               slideTypeVer="top";               
            }          
          txtInrDiv.addClass("tdValign"+slideTypeVer);
          txtObjHandler.vAlign = slideTypeVer;  
          txtDivIdInrElm.addClass("vAlign"+slideTypeVer); 
        }
        else if (sldTyp == "left" || sldTyp == "right") {            
            txtInrDiv.addClass("tdValign" + txtObj.vAlign);            
            txtInrDiv.addClass("tdHalign"+sldTyp);
            txtDivIdInrElm.removeClass("hAligncenter hAlignleft hAlignright");   
            txtObjHandler.hAlign = sldTyp;  
            txtDivIdInrElm.addClass("hAlign"+sldTyp); 
        }    
};

template.prototype.textImageUpdate=function(txtDivId){    
    var txtObj = this.getTextObjectFromId(txtDivId);
    if(txtObj != null){
        if(txtObj.bTextSlide){
            $("#"+txtDivId+"_InrElm").hide();
            $("#"+txtDivId+"_InrElm_Img").hide();
            this.textSlideShow(txtDivId, txtObj);
        }else{
            $("#"+txtDivId+"_InrElm").hide();
            $("#"+txtDivId+"_InrElm_Img").hide();            
            if(Utils.isIOSDvice())
            {
                $("#"+txtDivId+"_InrElm_Img").show();
            }            
            $("#"+txtDivId+"_InrElm_Img").css({
                'width':txtObj.w+'px',
                'height':txtObj.h+'px'
            });
            createUpdatedImage(txtObj);
            $("#"+txtDivId+"_InrElm_Img").attr("src",txtObj.textImageSrc);
            $("#"+txtDivId+"_InrElm_Img").show();
            if($("#"+txtDivId+"_SlideElm").length >0){
                $("#"+txtDivId+"_SlideElm").hide();
            }
        }
    }     
};
template.prototype.showTemplatePreview=function(){
    var tempPreview = new templatePreview(this);
    tempPreview.createPreviewObj();
};
template.prototype.textKeyUp = function(curObj){	
	var textObj = this.getTextObjectFromId(curObj.id);	
    log.debug("curObj.innerHTML="+curObj.innerHTML,"textKeyUp");
    if(textObj != null){     
        textObj.text = curObj.innerHTML;	
        if(deviceType == "iPad" || deviceType == "iPhone") {
            if(curObj.innerHTML == "" || curObj.innerHTML == "&nbsp;"){
                curObj.innerHTML = "&nbsp;";
                setCursorToEnd($("#"+curObj.id)[0]);                
            }
        }       
    }
};
/*--Template Adclip functionality: START--*/
template.prototype.renderAdClip=function()
{   
   this.resetUpdtSlotCallObj();
   locLangCode=sessionStorage.getItem('locale');   
   adClipUtils.loadFontXMLObj();
   this.setFrameLayout(FIXED_LAYOUT);
   var relRect;
   var innerframe;   
   var count=0;
   relRect = this.relRectForFrmOrgRect(this.mainFrame, {h:this.lfdSize.h,w:this.lfdSize.w,x:0,y:0});
   innerframe = new frameInfo(relRect.x, relRect.y, relRect.w, relRect.h,false);
   this.addInnerFrame(innerframe);      
  var slotLen=themeSlotObj.length;
  var layerLen,i,j;
  var elm,arrLayer,elmRect,inrElm,elmType;  
  cropJson.filesToCropArrs=[];  
  for(i=0;i<slotLen;i++)
  {      
      log.debug("Slot  index-"+i+ "-Step1-"+JSON.stringify(themeSlotObj[i]));
      arrLayer=themeSlotObj[i].arrLayer;
      layerLen=arrLayer.length;      
      elmRect=adClipUtils.getElmRect(arrLayer[0]);
      elmType=adClipUtils.getElmTypFrmLyrTyp(arrLayer[0].nLayerType,0);      
      elm=new elementInfo(elmRect.w,elmRect.h,arrLayer[0].layerSourcePath,elmType);
      elm.imageSrc=arrLayer[0].layerSourcePath;
      elm.OriginalPath=$.trim(arrLayer[0].layerSourcePath);
      innerframe.setElement(elm);      
      elm.slotType=themeSlotObj[i].N_SLOT_TYPE;      
      if(elm.OriginalPath!="" && this.isCropableSlot(elm.slotType))
      {
        this.imageUrls.push(i);        
      }         
      if(elmType==IMAGE)
      {
        if(elm.OriginalPath!="")
        {
            if(isIOS()){
                elm.assetsPath=themeSlotObj[i].thumbnailPath;
                elm.thumbPath=selCntntMap[elm.assetsPath].thumbPath;
                elm.smallSizeImg=selCntntMap[elm.assetsPath].imgPath;
                if(elm.thumbPath == undefined || elm.thumbPath == ""){
                    elm.thumbPath = elm.assetsPath;
                    elm.smallSizeImg=elm.assetsPath;
                }
            }
            else
            {
                elm.assetsPath=elm.OriginalPath;
                elm.thumbPath=selCntntMap[elm.OriginalPath].thumbPath;
                elm.smallSizeImg=selCntntMap[elm.OriginalPath].imgPath;
            }
        }
        else
        {
            elm.thumbPath=arrLayer[1].layerSourcePath;
        }
      }
      else
      {
          elm.thumbPath=elm.OriginalPath;          
      }
      if(this.isSepSlot(elm.slotType))
      {
      	elm.thumbSepImg=adClipUtils.getThumbSeperatorImg(arrLayer[1].layerSourcePath);
      }
      for(j=1;j<layerLen;j++)
      {
          elmRect=adClipUtils.getElmRect(arrLayer[j]);
          relRect=this.relRectForFrmOrgRect(this.mainFrame,elmRect);
          inrElm=new textInfo(relRect.x,relRect.y,relRect.w,relRect.h);
          inrElm.textImageSrc=arrLayer[j].layerSourcePath;
          this.updateXYtoLmt(inrElm);
          inrElm.elmType=adClipUtils.getElmTypFrmLyrTyp(arrLayer[j].nLayerType,j);
          this.updtTxtObjFrmThemeData(inrElm,arrLayer[j].textInformation, i, j-1, fontIncludedArray);
          elm.elmLyrArr.push(j-1);
          elm.textElms.push(inrElm);         
      }      
  }  
  log.debug("1Curr Time: "+getTimeWithMiliSec(),"renderAdClip");
  this.loadAdClipImages(innerframe);      
   
};
template.prototype.proceedWithRendering=function()
{
   log.debug("1Curr Time: "+getTimeWithMiliSec(),"proceedWithRendering"); 
   if(!isFontLoded)
   {   
	this.addFontListOnPage();
	showFontList();
	   fontIncludedArray = Utils.getUniqueArray(fontIncludedArray);
       Utils.uploadAllFontsToMemory(fontIncludedArray);
       fontIncludedArray = [];
	   isFontLoded=true;
    }
   callbackDesignTemplate.apply();
   $("#"+this.mainFrame.id).css("visibility","visible");
   this.renderTemplate();   
   this.hideItemsForAdClip();   
   adClipUtils.getEstimatedTime();
   isAdClipAnalysingStart=false;         
   adClipUtils.hidePageLoader();   
};
template.prototype.updateFiletoCropArr=function(frame,elm,slotNo)
{    
    var cropObj=adClipUtils.getCropObj();
    var cropCord=this.getImgElmCropCoord(elm,frame);          
    cropObj.SrcPath=elm.OriginalPath;
    cropObj.DestPath=systemRootPath + '.ETabletAuthor/ADClip/CropImage/SlotCropedImg_'+slotNo+'.png';
    cropObj.ClipLeft = cropCord.l;
    cropObj.ClipRight = cropCord.t;
    cropObj.ClipTop = cropCord.r-cropCord.l;
    cropObj.ClipBottom = cropCord.b-cropCord.t;        
    elm.imageSrc=cropObj.DestPath;
    cropJson.filesToCropArrs.push(cropObj);
};

template.prototype.addFontListOnPage = function(){
	try
    {   
      var fontList = "";
      var dFontListArry = [];
      var downFontItems = Utils.getDownloadedFont();      
          
      if(downFontItems!=null && downFontItems!=""){
      		var downFontItemsArr = downFontItems.split(",");
            dFontListArry = this.getFontListForLang().concat(downFontItemsArr);
      }else{
            dFontListArry = this.getFontListForLang();
      }
      
       if(dFontListArry!=null)
       {
            fontListArr = [];
            $("#allFontListStylID").remove();
            var length = dFontListArry.length;        
            var tempStr="";
            var fontFileName="";
            var strToken="";
            for(var i=0;i<length;i++)
            {            
                fontFileName = Utils.retrieveFileName(dFontListArry[i]);
                fontFileName= fontFileName.substring(0, fontFileName.lastIndexOf('.'));/* remove ".ttf"*/                 
                fontFileName=$.trim(fontFileName);
                if(fontFileName!="")
                {
	                if(dFontListArry[i].indexOfInsensitive(".EtabletAuthor")!=-1)
	                 {                     
	                     strToken=Utils.getSystemRootPath();
	                     strToken=strToken.substring(0,strToken.length-1);
	                 }
	                 else
	                 {
	                     strToken=isIOS()?"":"../../";
	                 }
	               tempStr+= "@font-face {font-family: " + fontFileName + ";  src: url("+strToken + dFontListArry[i] + ");}";
	               fontListArr.push(fontFileName);
                }
            }
            fontListArr=Utils.getUniqueArray(fontListArr);
            Utils.addCSSStrInPage(tempStr,"allFontListStylID"); 
           /* Utils.uploadAllFontsToMemory(fontListArr);*/
            fontListArr.sort(Comparator);            
       }       
   }
   catch(ex)
   {
      console.log("2Error: in addFontListOnPage::"+ex.message); 
   }
};
template.prototype.getFontListForLang = function(){
	var fontListWithFullPath = [];
	var len = fontListArrDefault.length;
	var initialpath = Utils.getDirectoryPathUptoWww() + FONT_RES_ITEMS;
	for(var i=0; i < fontListArrDefault.length; i++) {
		fontListWithFullPath.push(initialpath+ "/" + fontListArrDefault[i]);	
	}	
	switch(locLangCode)
    {                
        case 'pl':
        case 'ru':
        case 'tr':        
            fontListWithFullPath = fontListWithFullPath.concat(this.addFontListABC());
            fontListWithFullPath = fontListWithFullPath.concat(this.addFontList("N"));
        break;
        case 'ko':        
            fontListWithFullPath = fontListWithFullPath.concat(this.addFontList("E"));
        break;
        case 'th':        
            fontListWithFullPath = fontListWithFullPath.concat(this.addFontList("R"));
        break;
        default:           
        	fontListWithFullPath = fontListWithFullPath.concat(this.addFontListABC());
        break;
    }	
    console.log(" %%%%%%%%%%%%%%% fontListWithFullPath -- "+fontListWithFullPath);
	return fontListWithFullPath;
};
template.prototype.addFontList = function(type){
	var fontList = [];
	var initialpath = Utils.getDirectoryPathUptoWww() + FONT_RES_ITEMS;
	var len = fontListArrLang[type].length;
	for(var i=0; i < len; i++) {
		fontList.push(initialpath+ "/" + fontListArrLang[type][i]);	
	}
	return fontList;
	
};
template.prototype.addFontListABC = function(){
	var fontListABC = [];	
	fontListABC = this.addFontList("A").concat(this.addFontList("B"));
	fontListABC = fontListABC.concat(this.addFontList("C"));
	
	return fontListABC;
};

template.prototype.loadAdClipImages=function(frame)
{
    var currObj=this;
    var arrLength=currObj.imageUrls.length;
    var elm;
    var slotNo=0;
    var elmObj=null;
    if(arrLength>0)
    {
        for(var i=0;i<arrLength;i++)
        {        
            slotNo=currObj.imageUrls[i];
            elm=frame.element[slotNo];
            elmObj=selCntntMap[elm.assetsPath];            
            elm.orgW=elmObj.orgW;
            elm.orgH=elmObj.orgH;
            currObj.setImageElmAspectFillByDefault(frame.id,elm);
            currObj.updateFiletoCropArr(frame,elm,slotNo);            
        }
        adClipUtils.cropAndRotateImages(1);
    }
    else
    {
         currObj.proceedWithRendering();  
    }  
};
template.prototype.updtThmSlotFrmTmplObj=function()
{
  var slotLen=themeSlotObj.length;
  var layerLen,i,j;
  var elm,arrLayer,inrElm;
  var frame=this.getActiveFrame();
  for(i=0;i<slotLen;i++)
  {        
      arrLayer=themeSlotObj[i].arrLayer;
      elm=frame.element[i];
      layerLen=arrLayer.length;
      arrLayer[0].layerSourcePath=elm.imageSrc;
      arrLayer.splice(2,layerLen);
      this.addArrLayrFromTmpltObj(arrLayer,elm);
      themeSlotObj[i].N_LAYER_NUM=arrLayer.length;      
      log.debug("After Update index"+i+"--"+JSON.stringify(themeSlotObj[i]));        
  }
};
template.prototype.addArrLayrFromTmpltObj=function(arrLayer,elm)
{
    var layerObj;
    var subElms=elm.textElms;
    var subElm;
    var elmLen=elm.elmLyrArr.length;    
    var tmpltElmType;
    for(var i=1;i<elmLen;i++)
    {
        subElm=subElms[elm.elmLyrArr[i]];
        
        if(subElm!=null)
        {            
            layerObj=adClipUtils.getLayerStruct();
            tmpltElmType=subElm.elmType;
            layerObj.nLayerType=adClipUtils.getLayrTypFromTmpltTyp(tmpltElmType);
            this.updtThemeSlotFrmTmpltObj(subElm,layerObj);
            arrLayer.push(layerObj);
        }
    }    
};
template.prototype.updtThemeSlotFrmTmpltObj=function(elm,themeSlotObj)
{
    var color;    
    var orgRect=this.orgRectFrmRelRect(this.mainFrame,{x:elm.x,y:elm.y,w:elm.w,h:elm.h});    
    themeSlotObj.layerSourcePosition.nWidth=orgRect.w;
    themeSlotObj.layerSourcePosition.nHeight=orgRect.h;
    themeSlotObj.layerSourcePosition.leftTopPosition.xPos=orgRect.x;
    themeSlotObj.layerSourcePosition.leftTopPosition.yPos=orgRect.y;
    var text;    
    switch(elm.elmType)
    {
        case TEXT:        
            themeSlotObj.layerSourcePath=systemRootPath + '.ETabletAuthor/ADClip/TextImage/'+ elm.textImageName;
            themeSlotObj=themeSlotObj.textInformation;
            themeSlotObj.nTextFontSize=elm.fontSize;
            themeSlotObj.FillColor=getRGBColorInRGBA(elm.bgColor,elm.bgAlpha*100).replace("rgba","");        
            themeSlotObj.TextColor=getRGBColorInRGBA(elm.fontColor,elm.alpha*100).replace("rgba","");        
            themeSlotObj.TextFontname=elm.fontFamily;
            themeSlotObj.TextHAlign=elm.hAlign;        
            text=$.trim(elm.text.replace(/&nbsp;/ig,""));
            if(text==MIA_SID_DOUBLE_TAP_TO_EDIT)
            {
                text="";
                elm.text="";                
            }

            if(elm.textImageSrc=="" || elm.text=="")
            {            
                createUpdatedImage(elm);
            }           
            themeSlotObj.TextHTML=text;
            themeSlotObj.TextVAlign=elm.vAlign;                        
            tmpltTxtImgArr.push({name:elm.textImageName,imgsrc:adClipUtils.rplacBase64Txt(elm.textImageSrc)});            
            break;
        case STICKER:
        case HANDWRITING:
            themeSlotObj.layerSourcePath=elm.textImageSrc;
        break;
        default:
        break;        
    }    
};
template.prototype.updtTxtObjFrmThemeData=function(elm,propObj,i,j,fontIncludedArray)
{
    var color;
    if(elm.elmType==TEXT)
    {
        elm.fontSize=propObj.nTextFontSize;
        var propColor=$.trim(propObj.FillColor);
        if(propColor!="")
        {
            color=getRgbaClrInRgbnAlpha(propColor);
            elm.bgColor=color.rgb;
            elm.bgAlpha=color.alpha;
        }
        propColor=$.trim(propObj.TextColor);
        if(propColor!="")
        {
            color=getRgbaClrInRgbnAlpha(propColor);
            elm.fontColor=color.rgb;
            elm.alpha=color.alpha;
        }
        elm.fontFamily=adClipUtils.getMappedFont(propObj.TextFontname);
        fontIncludedArray.push(elm.fontFamily);
        elm.hAlign=propObj.TextHAlign;
        elm.text=propObj.TextHTML;
        elm.vAlign=propObj.TextVAlign;
        elm.textImageName = FRAME_ID_PREFIX+"0-elm_"+i+"_"+j+"_InrElm.png";        
    }
};
template.prototype.hideItemsForAdClip=function()
{
    log.debug("hide controls for ad clip","hideItemsForAdClip");    
    setTimeout(function(){
        $("#tpl_shuffleBtnId").hide();
    },400);      
};
/*----------------------Template addclip functionality: END-----------------*/
var textKeyUp = function(curObj){	
	templateObj.textKeyUp(curObj);
};
var onTextBlur = function(curObj){
    curObj.innerHTML=rmvHtmlFromStr(curObj.innerHTML);    
    var textObj = templateObj.getTextObjectFromId(curObj.id);
    if(curObj.innerHTML == "" || curObj.innerHTML == "&nbsp;"|| curObj.innerHTML == "&nbsp;&nbsp;" || curObj.innerHTML == "<br>"){
           curObj.innerHTML = MIA_SID_DOUBLE_TAP_TO_EDIT;	   
        if(textObj != null){
            textObj.bMenuOrPrice = false;
        }
    }    
    if(textObj != null){
        textObj.text = curObj.innerHTML;
    }
    var textId = curObj.id.replace("_InrElm", "");
    templateObj.textImageUpdate(textId);
    templateObj.currSelTxtDivId = "";
};
function uploadAllTemplateRelatedJS()
{	
	var filArr=["../common/utils/LoaderUtils.js","../js/iscroll.js","../js/hammer.min.js","../js/jquery/jquery.ui.sortable.min.js","../template/js/StickerCopyHandler.js"
	            		,"js/adClipHorizontalScroll.js","js/adClipTemplateMenu.js","js/adClipContentMenuCreator.js"
	            		,"../js/jquery.authorColorPicker.js","../template/js/ConvertTextToImage.js"
	            		,"../common/utils/fontUtils.js"];	
		var len=filArr.length;
		for(var i=0;i<len;i++)
		{
				loadjscssfile(filArr[i],"js");
		}
		printGetTimeWithMiliSecTemp("Adclip","Adclip- Step2","END","JS dynamic Loading");
};
uploadAllTemplateRelatedJS();