/**
 * @filename Lfd.js
 * 
 * Modified by p.menaria 23-01-2015
 *
 * Copyright 2014 by Samsung Electronics, Inc.,
 * 
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information"). You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 */

var LFD = {
	StickerCount : 0
};
//Function to create LFD xml tag
LFD.createLFD = function(ContentID, DataLink, FileID, FileName, DisplayWidth, DisplayHeight, DisplayPolicy, BGMusicFile,BGMusicFileFullPath,_PLAYER)
{	
	//var BgSound ="";
	BGMusicFile = ""; // No background music file allowed
	var audioVideoFlag = "";
	var SelectedAudioVideo =  ContentObj.SelectedAudioVideo;
	var AudioMute = ContentObj.AudioMute;
	var audioMute = "";
	var _PlayerTypeVersion = "2.0";
	DataLink = typeof DataLink !== 'undefined' ? DataLink : false;
	switch(globlePlayerType){
        case TIZEN_MODEL:
            _PlayerTypeVersion = "4.0";
        break;
        case TIZEN_S5:
            _PlayerTypeVersion = "5.0";
        break;
        case TIZEN_S6:
            _PlayerTypeVersion = "6.0";
        break;
        default:
            _PlayerTypeVersion = "2.0";
        break;
	}
	if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
		//BgSound = '<BGMusicFileFullPath type="File">\
		//		<KeyFrame time="0"><![CDATA['+BGMusicFileFullPath+']]></KeyFrame></BGMusicFileFullPath>\n';			
		audioVideoFlag = '<SelectedAudioVideo type="File">\
				<KeyFrame time="0"><![CDATA['+SelectedAudioVideo+']]></KeyFrame></SelectedAudioVideo>\n';
		audioMute = '<AudioMute type="File">\
				<KeyFrame time="0"><![CDATA['+AudioMute+']]></KeyFrame></AudioMute>\n';
	} 	
	var xmlData = '<?xml version="1.0" encoding="utf-8"?>\n\
		<Content id="'+ContentID+'" version="3.000" packaged="true" datalinkTemplate="'+DataLink+'">\n\
		<PlayerType>'+_PLAYER+'</PlayerType>\n\
		<PlayerTypeVersion>'+_PlayerTypeVersion+'</PlayerTypeVersion>\n\
			<FileID>'+FileID+'</FileID>\
			<Name type="String">\
				<KeyFrame time="0"><![CDATA['+FileName+']]></KeyFrame></Name>\
			<DisplayWidth type="Number">\
				<KeyFrame time="0">'+DisplayWidth+'</KeyFrame></DisplayWidth>\n\
			<DisplayHeight type="Number">\
				<KeyFrame time="0">'+DisplayHeight+'</KeyFrame></DisplayHeight>\n\
			<DisplayPolicy type="List">\
				<KeyFrame time="0">'+DisplayPolicy+'</KeyFrame></DisplayPolicy>\n\
			<BGMusicFilePath type="File">\
				<KeyFrame time="0"><![CDATA['+BGMusicFile+']]></KeyFrame></BGMusicFilePath>\n'
			+audioVideoFlag
			+audioMute+
			'<EventItems>\n</EventItems>\
			<FileItems>\n</FileItems>\n\
			<SupportFileItems>\n</SupportFileItems>\n</Content>\n';	


	if (window.DOMParser)
	  {
	  parser=new DOMParser();
	  xmlDoc=parser.parseFromString(xmlData,"text/xml");
	  }
	else // Internet Explorer
	  {
	  xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
	  xmlDoc.async=false;
	  xmlDoc.loadXML(xmlData);
	  }
	  
	return xmlDoc;
};


LFD.addPage = function(LFDObject, PagePropertiesObj)
{
	if(typeof(LFDObject) == 'object')
	{
		var pageCount = LFDObject.getElementsByTagName("Page").length;
		var pageTitle = "";
		var pageType = ""; 
		if(0==pageCount)
		{
			pageType = 'Global';
			pageTitle = "Page for Global Elements";
		}
		else
		{
			pageType = 'Local';
			pageTitle = "Page"+pageCount;
		}
		var Page = LFDObject.createElement("Page");
		PageAttr1 = LFDObject.createAttribute("index");
		PageAttr1.nodeValue = pageCount;
		Page.setAttributeNode(PageAttr1);
		PageAttr2 = LFDObject.createAttribute("type");
		PageAttr2.nodeValue = pageType;
		Page.setAttributeNode(PageAttr2);
		
		
		var name = LFD.addNode(LFDObject,'Name', true, pageTitle, true, 'type', 'String', 'time', '0');
		if(name)
		{
			Page.appendChild(name);
		}
		var BGColor = LFD.addNode(LFDObject,'BGColor', true, PagePropertiesObj.BGColor, true, 'type', 'Color', 'time', '0');
		Page.appendChild(BGColor);
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var FrameLayout = LFD.addNode(LFDObject,'FrameLayout', true, PagePropertiesObj.FrameLayout, true, 'type', 'String', 'time', '0');
			Page.appendChild(FrameLayout);
		}

		var motionPath = LFD.addNode(LFDObject,'MotionPathPoints', true, PagePropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Page.appendChild(motionPath);

		var bgImageFilePath = LFD.addNode(LFDObject,'BGImageFilePath', true, PagePropertiesObj.BGImageFilePath, true, 'type', 'File', 'time', '0');
		Page.appendChild(bgImageFilePath);
		
		if(globlePlayerType==RMD_MODEL){
			var NT14_BGImageFilePath = LFD.addNode(LFDObject,'NT14_BGImageFilePath', true, PagePropertiesObj.NT14_BGImageFilePath, true, 'type', 'File', 'time', '0');
			Page.appendChild(NT14_BGImageFilePath);
		}
		var isMutable = LFD.addNode(LFDObject,'IsMutable', true, PagePropertiesObj.IsMutable, true, 'type', 'File', 'time', '0');
		Page.appendChild(isMutable);
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var bgImageOriginalPath = LFD.addNode(LFDObject,'BGImageOriginalPath', true, PagePropertiesObj.BGImageOriginalPath, true, 'type', 'File', 'time', '0');
			Page.appendChild(bgImageOriginalPath);
		}

		var BGRatio = LFD.addNode(LFDObject,'BGRatio', false, PagePropertiesObj.BGRatio, true, 'type', 'List', 'time', '0');
		Page.appendChild(BGRatio);

		var OrginalWidth = LFD.addNode(LFDObject,'OrginalWidth', false, PagePropertiesObj.OrginalWidth, true, 'type', 'Number', 'time', '0');
		Page.appendChild(OrginalWidth);

		var OriginalHeight = LFD.addNode(LFDObject,'OriginalHeight', false, PagePropertiesObj.OriginalHeight, true, 'type', 'Number', 'time', '0');
		Page.appendChild(OriginalHeight);
	
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, PagePropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Page.appendChild(IsVisible);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, PagePropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Page.appendChild(DurationPolicy);

		var Duration = LFD.addNode(LFDObject,'Duration', false, PagePropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Page.appendChild(Duration);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, PagePropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Page.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, PagePropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Page.appendChild(EventEnable);

		if(0==pageCount)
		{
			var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, "", true, 'type', 'List', 'time', '0');
			Page.appendChild(EffectInName);
		}
		else
		{
			var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, PagePropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
			Page.appendChild(EffectInName);
		}
      
		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, PagePropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Page.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, PagePropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Page.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, PagePropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Page.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, PagePropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Page.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, PagePropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Page.appendChild(EffectInRepeatCount);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Page.appendChild(EventItems);
		
		LFDObject.documentElement.appendChild(Page); 

		return LFDObject;
	}	
};
/*
*	This function creates xml file for all properties of any page element in LFD.
*	Note: Page can be either Global or Local
*/
LFD.addNode = function(LFDObject,nodeName, cdata, value, keyFrame, attrName, attrValue, keyFrameAttrName, keyFrameAttrValue)
{
	//console.log("Inside addNode");
	/*
	*	Argument Details
	*
	*	LFDObject - Pass on Complete LFD object to add node on(Value: XML object)
	*	nodeName - Name of the node to be created (Value: String)
	*	cdata - Is it a CDATA node (Value: Boolean)
	*	value - Value of the node
	*	keyFrame - Node inside KeyFrame Node(Value Boolean)
	*	attrName - Attribute name if any(String)
	*	attrValue - Value of the attribute for the node(String)
	*	keyFrameAttrName - Attribute for keyframe node
	*	keyFrameAttrValue - Attribute value for keyframe node
	*/

	value = (value==undefined?'':value);
	if(value == ''){
		if((attrValue == 'Number' || attrValue == 'RealNumber')){			
			if(nodeName !="Opacity"){//To fix application upgarding issue.
				value = "0";
			}				
		}		
	}
	//Check if nodeName provided is valid
	if(nodeName!="" && nodeName!= undefined)
	{
		var NewNode = LFDObject.createElement(nodeName);
		//Check if Keyframe Node exists
		if(keyFrame)
		{
			var KeyFrame = LFDObject.createElement("KeyFrame");
			//Check if value is CDATA
			if(cdata==true)
			{
				newCDATA=LFDObject.createCDATASection(value);
				KeyFrame.appendChild(newCDATA);
			}
			else
			{
				nameText = LFDObject.createTextNode(value);
				KeyFrame.appendChild(nameText);
			}
			
			if(keyFrameAttrName!="" && keyFrameAttrName!=undefined)
			{
				KeyFrameAttr = LFDObject.createAttribute(keyFrameAttrName);
				KeyFrameAttr.nodeValue = keyFrameAttrValue;
				KeyFrame.setAttributeNode(KeyFrameAttr);
			}

			NewNode.appendChild(KeyFrame);
		}
		else
		{
			//Check if value is CDATA
			if(cdata==true)
			{
				newCDATA=LFDObject.createCDATASection(value);
				NewNode.appendChild(newCDATA);
			}
			else
			{
				nameText = LFDObject.createTextNode(value);
				NewNode.appendChild(nameText);
			}
		}
		//Check if attribute exists for node
		if(attrName!='' && attrName!=undefined)
		{
			NodeAttr = LFDObject.createAttribute(attrName);
			NodeAttr.nodeValue = attrValue;
			NewNode.setAttributeNode(NodeAttr);
		}
		return NewNode;
	}
	else
	{
		console.log("Invalid node name '"+nodeName+"'");
		return false;
	}
	
};

LFD.addFiles = function(LFDObject, cdata, value, keyFrame, attrName, attrValue, keyFrameAttrName, keyFrameAttrValue)
{
	//console.log("Inside addFiles");
		var NewNode = LFDObject.getElementsByTagName("FileItems")[0];
	
			var Fileitem = LFDObject.createElement("FileItem");
			
			KeyFrameAttr = LFDObject.createAttribute("FileID");
			KeyFrameAttr.nodeValue = "BB7534F3-4889-4A2A-8A1E-BECCBC4B9279";
			Fileitem.setAttributeNode(KeyFrameAttr);
		     if(cdata==true){
				KeyFrameAttr1 = LFDObject.createAttribute("FileSize");
				KeyFrameAttr1.nodeValue = "2210";
				Fileitem.setAttributeNode(KeyFrameAttr1);
				
				KeyFrameAttr12 = LFDObject.createAttribute("FileHashValue");
				KeyFrameAttr12.nodeValue = "1A0D4230-FB9A-CB2B-6033-5812569AF443-17CE595A";
				Fileitem.setAttributeNode(KeyFrameAttr12);
		     }
              newCDATA=LFDObject.createCDATASection("C:\\"+value);
				Fileitem.appendChild(newCDATA);
				NewNode.appendChild(Fileitem);
	return NewNode;
};
LFD.addSupportFileItems= function(LFDObject, cdata, value, keyFrame, attrName, attrValue, keyFrameAttrName, keyFrameAttrValue,PureFileItem1,RealFullPath1,KeyPathLocation1)
{
	//console.log("Inside addSupportFileItems");
	var node=LFDObject.getElementsByTagName("SupportFileItems")[0];
	var FileItem1 = LFDObject.createElement("FileItem1");
	var typeAttr=LFDObject.createAttribute("type");
	typeAttr.nodeValue="File";
	FileItem1.setAttributeNode(typeAttr);
	var PureFileItem = LFD.addNode(LFDObject,'PureFileItem', true ,PureFileItem1, false, '', '', '', '');
	FileItem1.appendChild(PureFileItem);
	var RealFullPath = LFD.addNode(LFDObject,'RealFullPath', true ,RealFullPath1, false, '', '', '', '');
	FileItem1.appendChild(RealFullPath);
	var FileSize = LFD.addNode(LFDObject,'FileSize', false, "2222", false, '', '', '', '');
	FileItem1.appendChild(FileSize);
	var FileID = LFD.addNode(LFDObject,'FileID', false, "BB7534F3-4889-4A2A-8A1E-BECCBC4B9279", false, '', '', '', '');
	FileItem1.appendChild(FileID);
	var FileHashValue = LFD.addNode(LFDObject,'FileHashValue', false, "65CFABE4-959A-A2AE-6469-93D99D9F28B4-AD1411D8", false, '', '', '', '');
	FileItem1.appendChild(FileHashValue);
	var KeyPathLocation = LFD.addNode(LFDObject,'KeyPathLocation', true ,KeyPathLocation1, false, '', '', '', '');
	FileItem1.appendChild(KeyPathLocation);
	
	node.appendChild(FileItem1);
};

/*
*	Function to add Group Elements
*/
LFD.addGroup = function(LFDObject, PageNum, GroupPropertiesObj)
{	
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Group");
				
		var Name = LFD.addNode(LFDObject,'Name', true, GroupPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);			
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, GroupPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var Layer = LFD.addNode(LFDObject,'Layer', true, GroupPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, GroupPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);

		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, GroupPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, GroupPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, GroupPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, GroupPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, GroupPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, GroupPropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);

		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, GroupPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, GroupPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, GroupPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, GroupPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, GroupPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, GroupPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, GroupPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, GroupPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, GroupPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, GroupPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, GroupPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, GroupPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, GroupPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, GroupPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, GroupPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, GroupPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, GroupPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, GroupPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, GroupPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, GroupPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, GroupPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, GroupPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		LFDObject.getElementsByTagName("Page")[PageNum].appendChild(Element);		
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};


function addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element)
{
	if(addToGrp == true){
		LFDObject.getElementsByTagName("Group")[GrpCount].appendChild(Element);
		
	}else{
		LFDObject.getElementsByTagName("Page")[PageNum].appendChild(Element);
	}
};

/*
*	Function to add Image Elementsf
*/
LFD.addImage = function(LFDObject, PageNum,ImagePropertiesObj,addToGrp,GrpCount)
{	
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	var defaultTypeIdImage = "07B2ABF8-40E0-42FC-B360-866F63E8D1EB";
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element")
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Image";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		if(ImagePropertiesObj.TypeID == undefined || ImagePropertiesObj.TypeID ==""){
			ElemAttr2.nodeValue = defaultTypeIdImage;
		}else{
			ElemAttr2.nodeValue = ImagePropertiesObj.TypeID;
		}		
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, ImagePropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, ImagePropertiesObj.OriginalPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(OriginalPath);
			var ThumbPath = LFD.addNode(LFDObject,'ThumbPath', true, ImagePropertiesObj.ThumbPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(ThumbPath);
			var CroppedImagePath = LFD.addNode(LFDObject,'CroppedImagePath', true, ImagePropertiesObj.CroppedImagePath, true, 'type', 'String', 'time', '0');
			Element.appendChild(CroppedImagePath);
			var frameId = LFD.addNode(LFDObject,'frameId', true, ImagePropertiesObj.frameId, true, 'type', 'Number', 'time', '0');
			Element.appendChild(frameId);
		}
		
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, ImagePropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);
		
		 if(globlePlayerType==RMD_MODEL){ 
			var NT14_FilePath = LFD.addNode(LFDObject,'NT14_FilePath', true, ImagePropertiesObj.NT14_FilePath, true, 'type', 'File', 'time', '0');
			Element.appendChild(NT14_FilePath);
		}				
        	
		var isMutable = LFD.addNode(LFDObject,'IsMutable', false, ImagePropertiesObj.IsMutable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isMutable);	
		var isEditable = LFD.addNode(LFDObject,'IsEditable', false, ImagePropertiesObj.IsEditable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isEditable);
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, ImagePropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var Layer = LFD.addNode(LFDObject,'Layer', true, ImagePropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, ImagePropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);


		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, ImagePropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, ImagePropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);


		var PositionY = LFD.addNode(LFDObject,'PositionY', false, ImagePropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, ImagePropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);


		var Height = LFD.addNode(LFDObject,'Height', false, ImagePropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, ImagePropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);

		var OrginalWidth = LFD.addNode(LFDObject,'OrginalWidth', false, ImagePropertiesObj.OrginalWidth, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OrginalWidth);

		var OriginalHeight = LFD.addNode(LFDObject,'OriginalHeight', false, ImagePropertiesObj.OriginalHeight, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OriginalHeight);

		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
		var scale = LFD.addNode(LFDObject,'scale', false, ImagePropertiesObj.scale, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(scale);
		}
		var ClipLeft = LFD.addNode(LFDObject,'ClipLeft', false, ImagePropertiesObj.ClipLeft, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipLeft);

		var ClipRight = LFD.addNode(LFDObject,'ClipRight', false, ImagePropertiesObj.ClipRight, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipRight);

		var Interval = LFD.addNode(LFDObject,'Interval', false, ImagePropertiesObj.Interval, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Interval);

		var ClipTop = LFD.addNode(LFDObject,'ClipTop', false, ImagePropertiesObj.ClipTop, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipTop);

		var ClipBottom = LFD.addNode(LFDObject,'ClipBottom', false, ImagePropertiesObj.ClipBottom, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipBottom);

		var ImageRatio = LFD.addNode(LFDObject,'ImageRatio', false, ImagePropertiesObj.ImageRatio, true, 'type', 'List', 'time', '0');
		Element.appendChild(ImageRatio);

		var Reflection = LFD.addNode(LFDObject,'Reflection', false, ImagePropertiesObj.Reflection, true, 'type', 'List', 'time', '0');
		Element.appendChild(Reflection);

		var Opacity = LFD.addNode(LFDObject,'Opacity', false, ImagePropertiesObj.Opacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Opacity);

		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, ImagePropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, ImagePropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, ImagePropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, ImagePropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, ImagePropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, ImagePropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var ButtonMode = LFD.addNode(LFDObject,'ButtonMode', false, ImagePropertiesObj.ButtonMode, true, 'type', 'List', 'time', '0');
		Element.appendChild(ButtonMode);

		var Duration = LFD.addNode(LFDObject,'Duration', false, ImagePropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var ButtonPath1 = LFD.addNode(LFDObject,'ButtonPath1', true, ImagePropertiesObj.ButtonPath1, true, 'type', 'File', 'time', '0');
		Element.appendChild(ButtonPath1);

		var ButtonPath2 = LFD.addNode(LFDObject,'ButtonPath2', true, ImagePropertiesObj.ButtonPath2, true, 'type', 'File', 'time', '0');
		Element.appendChild(ButtonPath2);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, ImagePropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, ImagePropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, ImagePropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, ImagePropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);

		//var PositionY = LFD.addNode(LFDObject,'PositionY', false, ImagePropertiesObj.PositionY, true, 'type', 'Number', 'time', '0');
		//Element.appendChild(PositionY);

		var DataLinkUse = LFD.addNode(LFDObject,'DataLinkUse', false, ImagePropertiesObj.DataLinkUse, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkUse);

		var DataLinkDisplayOrder = LFD.addNode(LFDObject,'DataLinkDisplayOrder', false, ImagePropertiesObj.DataLinkDisplayOrder, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkDisplayOrder);

		var DataLinkDuration = LFD.addNode(LFDObject,'DataLinkDuration', false, ImagePropertiesObj.DataLinkDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(DataLinkDuration);

		var DataLinkSlpit = LFD.addNode(LFDObject,'DataLinkSlpit', false, ImagePropertiesObj.DataLinkSlpit, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkSlpit);

		var DataLinkCurrent = LFD.addNode(LFDObject,'DataLinkCurrent', false, ImagePropertiesObj.DataLinkCurrent, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkCurrent);

		var DataLinkGroupID = LFD.addNode(LFDObject,'DataLinkGroupID', false, ImagePropertiesObj.DataLinkGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkGroupID);

		var DataLinkSplitGroupID = LFD.addNode(LFDObject,'DataLinkSplitGroupID', false, ImagePropertiesObj.DataLinkSplitGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkSplitGroupID);

		var DataLinkSplitGroupName = LFD.addNode(LFDObject,'DataLinkSplitGroupName', true, ImagePropertiesObj.DataLinkSplitGroupName, true, 'type', 'String', 'time', '0');
		Element.appendChild(DataLinkSplitGroupName);

		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, ImagePropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, ImagePropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, ImagePropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, ImagePropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, ImagePropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, ImagePropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, ImagePropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, ImagePropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, ImagePropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, ImagePropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, ImagePropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, ImagePropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
	
	
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);	
		if(ImagePropertiesObj.FilePath!==''){
			LFD.addFiles(LFDObject,true,ImagePropertiesObj.FilePath,true,'','','','');
		}
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};


//*********** Added Input Source*******************

LFD.addInputSource = function(LFDObject, PageNum, InputSourceObj,addToGrp,GrpCount)
{	
	//console.log("Inside addInputSource");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "InputSource";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = InputSourceObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, InputSourceObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);

		
		var isMutable = LFD.addNode(LFDObject,'IsMutable', false, InputSourceObj.IsMutable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isMutable);
		var isEditable = LFD.addNode(LFDObject,'IsEditable', false, InputSourceObj.IsEditable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isEditable);
		var inputSourceType = LFD.addNode(LFDObject,'InputSourceType', false, InputSourceObj.InputSourceType, true, 'type', 'List', 'time', '0');
		Element.appendChild(inputSourceType);
		
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var region = LFD.addNode(LFDObject,'Region', false, InputSourceObj.Region, true, 'type', 'List', 'time', '0');
			Element.appendChild(region);	
		}	
		var MovieMute = LFD.addNode(LFDObject,'MovieMute', false, InputSourceObj.MovieMute, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(MovieMute);
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, InputSourceObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, InputSourceObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, InputSourceObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);

		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, InputSourceObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
				
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, InputSourceObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, InputSourceObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);
		
		var Width = LFD.addNode(LFDObject,'Width', false, InputSourceObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, InputSourceObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
		
		var channel = LFD.addNode(LFDObject,'Channel', false, InputSourceObj.Channel, true, 'type', 'Number', 'time', '0');
		Element.appendChild(channel);
		
		var minor_Channel = LFD.addNode(LFDObject,'Minor_Channel', false, InputSourceObj.Minor_Channel, true, 'type', 'Number', 'time', '0');
		Element.appendChild(minor_Channel);
		
		var airCable = LFD.addNode(LFDObject,'AirCable', false, InputSourceObj.AirCable, true, 'type', 'List', 'time', '0');
		Element.appendChild(airCable);
		
		var analog_Digital = LFD.addNode(LFDObject,'Analog_Digital', false, InputSourceObj.Analog_Digital, true, 'type', 'List', 'time', '0');
		Element.appendChild(analog_Digital);
		
		var sound = LFD.addNode(LFDObject,'Sound', false, InputSourceObj.Sound, true, 'type', 'List', 'time', '0');
		Element.appendChild(sound);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, InputSourceObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, InputSourceObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, InputSourceObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, InputSourceObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, InputSourceObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, InputSourceObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, InputSourceObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, InputSourceObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, InputSourceObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, InputSourceObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
	
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, InputSourceObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);
			
		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, InputSourceObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);		
	
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);	
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

//*********** Added Sticker*******************

LFD.addSticker = function(LFDObject, PageNum, StickerObj,addToGrp,GrpCount)
{	
	//console.log("Inside addSticker");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	var defaultTypeIdSticker = "7B168548-2707-491C-AC4A-F3E388E47CB5";
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		if(StickerObj.Name == "" || StickerObj.Name==undefined){
			LFD.StickerCount++;
			if(LFD.StickerCount < 10){
				ElemAttr1.nodeValue = "sticker_"+"00"+ LFD.StickerCount;
			}else{
				ElemAttr1.nodeValue = "sticker_"+"0"+ LFD.StickerCount;	
			}						
		}else{
			ElemAttr1.nodeValue = StickerObj.Name;
		}				
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		
		if(StickerObj.TypeID == undefined || StickerObj.TypeID ==""){
			ElemAttr2.nodeValue = defaultTypeIdSticker;
		}else{
			ElemAttr2.nodeValue = StickerObj.TypeID;
		}	
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, StickerObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, StickerObj.OriginalPath, true, 'type', 'String', 'time', '0');
		Element.appendChild(OriginalPath);
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, StickerObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, StickerObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, StickerObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);

		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, StickerObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
				
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, StickerObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, StickerObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);
		
		var Width = LFD.addNode(LFDObject,'Width', false, StickerObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, StickerObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
		
		var ConfigName = LFD.addNode(LFDObject,'ConfigName', true, StickerObj.ConfigName, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ConfigName);
		
		var Rotation = LFD.addNode(LFDObject,'Rotation', true, StickerObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);
		
		
		var EndStateXML = LFD.addNode(LFDObject,'EndStateXML', true, StickerObj.EndStateXML, true, 'type', 'String', 'time', '0');
		if(templateFlag == UPLOAD_TEMPLATE)
		{
			EndStateXML.children[0].innerHTML = ((EndStateXML.children[0].innerHTML).replace(/&lt;/g,"<")).replace(/&gt;/g,">");
		}
		Element.appendChild(EndStateXML);
		
		var EndStateBitmap = LFD.addNode(LFDObject,'EndStateBitmap', true, StickerObj.EndStateBitmap, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(EndStateBitmap);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, StickerObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, StickerObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, StickerObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, StickerObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, StickerObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, StickerObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, StickerObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, StickerObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, StickerObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, StickerObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, StickerObj.EffectInName, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectInName);
		
		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, StickerObj.EffectInDuration, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectInDuration);
		
		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, StickerObj.EffectInDirection, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectInDirection);
		
		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, StickerObj.EffectInRepeatPolicy, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);
		
		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, StickerObj.EffectInRepeatPeriod, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);
		
		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, StickerObj.EffectInRepeatCount, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectInRepeatCount);
		
		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, StickerObj.EffectOutName, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectOutName);
		
		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, StickerObj.EffectOutDuration, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectOutDuration);
		
		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, StickerObj.EffectOutDirection, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EffectOutDirection);
		
		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, StickerObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, StickerObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);
			
		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, StickerObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
		
			
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

//**************************   END    *******************************



/*
*	Function to add video Elements
*/
/*LFD.addMediaSlide = function(LFDObject, PageNum, MediaSlidePropertiesObj)
{	
	//console.log("Inside addMediaSlide");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "MediaSlide";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = MediaSlidePropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		var Name = LFD.addNode(LFDObject,'Name', true, MediaSlidePropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, MediaSlidePropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var Layer = LFD.addNode(LFDObject,'Layer', false, MediaSlidePropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, MediaSlidePropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);


		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, MediaSlidePropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, MediaSlidePropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);


		var PositionY = LFD.addNode(LFDObject,'PositionY', false, MediaSlidePropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, MediaSlidePropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);


		var Height = LFD.addNode(LFDObject,'Height', false, MediaSlidePropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
		

		var MediaSlideFile = LFD.addNode(LFDObject,'MediaSlideFile', true, MediaSlidePropertiesObj.MediaSlideFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(MediaSlideFile);
		
		var SelectedFolder = LFD.addNode(LFDObject,'SelectedFolder', true, MediaSlidePropertiesObj.SelectedFolder, true, 'type', 'Folder', 'time', '0');
		Element.appendChild(SelectedFolder);
		
		var SlideTime = LFD.addNode(LFDObject,'SlideTime', false, MediaSlidePropertiesObj.SlideTime, true, 'type', 'Time', 'time', '0');
		Element.appendChild(SlideTime);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, MediaSlidePropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, MediaSlidePropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, MediaSlidePropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, MediaSlidePropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, MediaSlidePropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, MediaSlidePropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, MediaSlidePropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, MediaSlidePropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, MediaSlidePropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, MediaSlidePropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, MediaSlidePropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);

		var DataLinkUse = LFD.addNode(LFDObject,'DataLinkUse', false, MediaSlidePropertiesObj.DataLinkUse, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkUse);

		var DataLinkDisplayOrder = LFD.addNode(LFDObject,'DataLinkDisplayOrder', false, MediaSlidePropertiesObj.DataLinkDisplayOrder, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkDisplayOrder);

		var DataLinkDuration = LFD.addNode(LFDObject,'DataLinkDuration', false, MediaSlidePropertiesObj.DataLinkDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(DataLinkDuration);

		var DataLinkSlpit = LFD.addNode(LFDObject,'DataLinkSlpit', false, MediaSlidePropertiesObj.DataLinkSlpit, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkSlpit);

		var DataLinkCurrent = LFD.addNode(LFDObject,'DataLinkCurrent', false, MediaSlidePropertiesObj.DataLinkCurrent, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkCurrent);

		var DataLinkGroupID = LFD.addNode(LFDObject,'DataLinkGroupID', false, MediaSlidePropertiesObj.DataLinkGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkGroupID);

		var DataLinkSplitGroupID = LFD.addNode(LFDObject,'DataLinkSplitGroupID', false, MediaSlidePropertiesObj.DataLinkSplitGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkSplitGroupID);

		var DataLinkSplitGroupName = LFD.addNode(LFDObject,'DataLinkSplitGroupName', true, MediaSlidePropertiesObj.DataLinkSplitGroupName, true, 'type', 'String', 'time', '0');
		Element.appendChild(DataLinkSplitGroupName);

		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, MediaSlidePropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, MediaSlidePropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, MediaSlidePropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, MediaSlidePropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, MediaSlidePropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, MediaSlidePropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, MediaSlidePropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, MediaSlidePropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, MediaSlidePropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, MediaSlidePropertiesObj.DesignCanvasVisible, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		LFDObject.getElementsByTagName("Page")[PageNum].appendChild(Element);	
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};*/

LFD.addVideo = function(LFDObject, PageNum, VideoPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addVideo");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{

		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Video";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = VideoPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);

		var Name = LFD.addNode(LFDObject,'Name', true, VideoPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
        
		var isMutable = LFD.addNode(LFDObject,'IsMutable', false, VideoPropertiesObj.IsMutable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isMutable);
		var isEditable = LFD.addNode(LFDObject,'IsEditable', false, VideoPropertiesObj.IsEditable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isEditable);
		
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, VideoPropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);
		
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var FileName = LFD.addNode(LFDObject,'FileName', true, VideoPropertiesObj.FileName, true, 'type', 'String', 'time', '0');
			Element.appendChild(FileName);
			var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, VideoPropertiesObj.OriginalPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(OriginalPath);
			var ThumbPath = LFD.addNode(LFDObject,'ThumbPath', true, VideoPropertiesObj.ThumbPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(ThumbPath);
		}
		/*if(deviceType == "iPhone" || deviceType == "iPad"){
			if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
				var assetInfo = LFD.addNode(LFDObject,'assetInfo', true, VideoPropertiesObj.assetInfo, true, 'type', 'String', 'time', '0');
				Element.appendChild(assetInfo);
			}
        }*/
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, VideoPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var Layer = LFD.addNode(LFDObject,'Layer', true, VideoPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, VideoPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);


		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, VideoPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);


		var PositionX = LFD.addNode(LFDObject,'PositionX', false, VideoPropertiesObj.PositionX, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionX);


		var PositionY = LFD.addNode(LFDObject,'PositionY', false, VideoPropertiesObj.PositionY, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, VideoPropertiesObj.Width, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Width);


		var Height = LFD.addNode(LFDObject,'Height', false, VideoPropertiesObj.Height, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, VideoPropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);

		var OrginalWidth = LFD.addNode(LFDObject,'OrginalWidth', false, VideoPropertiesObj.OrginalWidth, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OrginalWidth);

		var OriginalHeight = LFD.addNode(LFDObject,'OriginalHeight', false, VideoPropertiesObj.OriginalHeight, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OriginalHeight);

		var ClipLeft = LFD.addNode(LFDObject,'ClipLeft', false, VideoPropertiesObj.ClipLeft, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipLeft);

		var ClipRight = LFD.addNode(LFDObject,'ClipRight', false, VideoPropertiesObj.ClipRight, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipRight);

		var ClipTop = LFD.addNode(LFDObject,'ClipTop', false, VideoPropertiesObj.ClipTop, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipTop);

		var MMS = LFD.addNode(LFDObject,'MMS', true, VideoPropertiesObj.MMS, true, 'type', 'String', 'time', '0');
		Element.appendChild(MMS);
	
		var ClipBottom = LFD.addNode(LFDObject,'ClipBottom', false, VideoPropertiesObj.ClipBottom, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipBottom);

		var MovieRatio = LFD.addNode(LFDObject,'MovieRatio', false, VideoPropertiesObj.MovieRatio, true, 'type', 'List', 'time', '0');
		Element.appendChild(MovieRatio);

        
		var MovieAfterPlay = LFD.addNode(LFDObject,'MovieAfterPlay', false, VideoPropertiesObj.MovieAfterPlay, true, 'type', 'List', 'time', '0');
		Element.appendChild(MovieAfterPlay);

		var MovieMute = LFD.addNode(LFDObject,'MovieMute', false, VideoPropertiesObj.MovieMute, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(MovieMute);

		var MovieVolume = LFD.addNode(LFDObject,'MovieVolume', false, VideoPropertiesObj.MovieVolume, true, 'type', 'Number', 'time', '0');
		Element.appendChild(MovieVolume);

		var OutputMode = LFD.addNode(LFDObject,'OutputMode', false, VideoPropertiesObj.MovieRatio, true, 'type', 'List', 'time', '0');
		Element.appendChild(OutputMode);

		var Opacity = LFD.addNode(LFDObject,'Opacity', false, VideoPropertiesObj.Opacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Opacity);

		var Overlay = LFD.addNode(LFDObject,'Overlay', false, VideoPropertiesObj.Overlay, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(Overlay);

		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, VideoPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, VideoPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, VideoPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, VideoPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, VideoPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, VideoPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, VideoPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, VideoPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, VideoPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, VideoPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, VideoPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);

		var OriginalLength = LFD.addNode(LFDObject,'OriginalLength', false, VideoPropertiesObj.MovieRatio, true, 'type', 'Time', 'time', '0');
		Element.appendChild(OriginalLength);

		var ClipStart = LFD.addNode(LFDObject,'ClipStart', false, VideoPropertiesObj.ClipStart, true, 'type', 'Time', 'time', '0');
		Element.appendChild(ClipStart);

		var ClipEnd = LFD.addNode(LFDObject,'ClipEnd', false, VideoPropertiesObj.ClipEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(ClipEnd);

		var DataLinkUse = LFD.addNode(LFDObject,'DataLinkUse', false, VideoPropertiesObj.DataLinkUse, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkUse);

		var DataLinkDisplayOrder = LFD.addNode(LFDObject,'DataLinkDisplayOrder', false, VideoPropertiesObj.DataLinkDisplayOrder, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkDisplayOrder);

		var DataLinkDuration = LFD.addNode(LFDObject,'DataLinkDuration', false, VideoPropertiesObj.DataLinkDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(DataLinkDuration);

		var DataLinkSlpit = LFD.addNode(LFDObject,'DataLinkSlpit', false, VideoPropertiesObj.DataLinkSlpit, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkSlpit);

		var DataLinkCurrent = LFD.addNode(LFDObject,'DataLinkCurrent', false, VideoPropertiesObj.DataLinkCurrent, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkCurrent);

		var DataLinkGroupID = LFD.addNode(LFDObject,'DataLinkGroupID', false, VideoPropertiesObj.DataLinkGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkGroupID);

		var DataLinkSplitGroupID = LFD.addNode(LFDObject,'DataLinkSplitGroupID', false, VideoPropertiesObj.DataLinkSplitGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkSplitGroupID);

		var DataLinkSplitGroupName = LFD.addNode(LFDObject,'DataLinkSplitGroupName', false, VideoPropertiesObj.DataLinkSplitGroupName, true, 'type', 'String', 'time', '0');
		Element.appendChild(DataLinkSplitGroupName);

		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, VideoPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, VideoPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, VideoPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'ClipBottom', false, VideoPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, VideoPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, VideoPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, VideoPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, VideoPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, VideoPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, VideoPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, VideoPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, VideoPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		if(VideoPropertiesObj.FilePath!==''){
			LFD.addFiles(LFDObject,true,VideoPropertiesObj.FilePath,true,'','','','');
		}
		
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
		
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

/*
*	Function to add Text Elements
*/

LFD.addText = function(LFDObject, PageNum,TextPropertiesObj,addToGrp,GrpCount)
{
	//console.log("Inside addText");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	var defaultTypeIdText = "6BD0D55A-6D0C-48B0-91CB-2DB4D530C632";
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Text";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		if(TextPropertiesObj.TypeID == undefined || TextPropertiesObj.TypeID ==""){
			ElemAttr2.nodeValue = defaultTypeIdText;
		}else{
			ElemAttr2.nodeValue = TextPropertiesObj.TypeID;
		}
		Element.setAttributeNode(ElemAttr2);

		var Name = LFD.addNode(LFDObject,'Name', true, TextPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);	
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, TextPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);			 
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, TextPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);
		
		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, TextPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, TextPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, TextPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, TextPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, TextPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, TextPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, TextPropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);
		
		var TextHTML = LFD.addNode(LFDObject,'TextHTML', true, TextPropertiesObj.TextHTML, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(TextHTML);
		
		var TextRTF = LFD.addNode(LFDObject,'TextRTF', true, TextPropertiesObj.TextRTF, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(TextRTF);
		
		var TextFontName = LFD.addNode(LFDObject,'TextFontName', false, TextPropertiesObj.TextFontName, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextFontName);
		
		var TextFontSize = LFD.addNode(LFDObject,'TextFontSize', false, TextPropertiesObj.TextFontSize, true, 'type', 'Number', 'time', '0');
		Element.appendChild(TextFontSize);
		
		var TextColor = LFD.addNode(LFDObject,'TextColor', false, TextPropertiesObj.TextColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(TextColor);
		
		var TextBold = LFD.addNode(LFDObject,'TextBold', false, TextPropertiesObj.TextBold, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextBold);
		
		var TextItalic = LFD.addNode(LFDObject,'TextItalic', false, TextPropertiesObj.TextItalic, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextItalic);
		
		var TextUnderLine = LFD.addNode(LFDObject,'TextUnderLine', false, TextPropertiesObj.TextUnderLine, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextUnderLine);
		
		var TextStrikeOut = LFD.addNode(LFDObject,'TextStrikeOut', false, TextPropertiesObj.TextStrikeOut, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextStrikeOut);
		
		
		if(Utils.isHighEndModel(globlePlayerType))
		{
			var TextFormat = LFD.addNode(LFDObject,'TextFormat', true, TextPropertiesObj.TextFormat, true, 'type', 'MultilineString', 'time', '0');
			Element.appendChild(TextFormat);
			
			if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
				var TextFormatCopy = LFD.addNode(LFDObject,'TextFormatCopy', true, TextPropertiesObj.TextFormatCopy, true, 'type', 'MultilineString', 'time', '0');
				Element.appendChild(TextFormatCopy);
			}
		}
		
		var TextFile = LFD.addNode(LFDObject,'TextFile', true, TextPropertiesObj.TextFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(TextFile);
		
		var FillColor = LFD.addNode(LFDObject,'FillColor', false, TextPropertiesObj.FillColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FillColor);
		
		var SelectOpacity = LFD.addNode(LFDObject,'SelectOpacity', false, TextPropertiesObj.SelectOpacity, true, 'type', 'List', 'time', '0');
		Element.appendChild(SelectOpacity);
		
		var FillOpacity = LFD.addNode(LFDObject,'FillOpacity', false, TextPropertiesObj.FillOpacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FillOpacity);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, TextPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var Opacity = LFD.addNode(LFDObject,'Opacity', false, TextPropertiesObj.Opacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Opacity);
		
		var TextHAlign = LFD.addNode(LFDObject,'TextHAlign', false, TextPropertiesObj.TextHAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextHAlign);
		
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, TextPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, TextPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, TextPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var TextVAlign = LFD.addNode(LFDObject,'TextVAlign', false, TextPropertiesObj.TextVAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextVAlign);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, TextPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var TextWordWrap = LFD.addNode(LFDObject,'TextWordWrap', false, TextPropertiesObj.TextWordWrap, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextWordWrap);

		var TextDisplayDirection = LFD.addNode(LFDObject,'TextDisplayDirection', false, TextPropertiesObj.TextDisplayDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextDisplayDirection);
		
		var Start = LFD.addNode(LFDObject,'Start', false, TextPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var TextDirection = LFD.addNode(LFDObject,'TextDirection', false, TextPropertiesObj.TextDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextDirection);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, TextPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var TextSpeed = LFD.addNode(LFDObject,'TextSpeed', false, TextPropertiesObj.TextSpeed, true, 'type', 'Number', 'time', '0');
		Element.appendChild(TextSpeed);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, TextPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);
		
		var TextImageFile = LFD.addNode(LFDObject,'TextImageFile', true, TextPropertiesObj.TextImageFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(TextImageFile);
		
		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, TextPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var TextFontFile = LFD.addNode(LFDObject,'TextFontFile', true, TextPropertiesObj.TextFontFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(TextFontFile);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, TextPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);		
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, TextPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
						
		var DataLinkUse = LFD.addNode(LFDObject,'DataLinkUse', false, 'False', true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkUse);
		
		
		var DataLinkDisplayOrder = LFD.addNode(LFDObject,'DataLinkDisplayOrder', false, TextPropertiesObj.DataLinkDisplayOrder, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkDisplayOrder);

		var DataLinkDuration = LFD.addNode(LFDObject,'DataLinkDuration', false, TextPropertiesObj.DataLinkDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(DataLinkDuration);

		var DataLinkSlpit = LFD.addNode(LFDObject,'DataLinkSlpit', false, TextPropertiesObj.DataLinkSlpit, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkSlpit);

		var DataLinkCurrent = LFD.addNode(LFDObject,'DataLinkCurrent', false, TextPropertiesObj.DataLinkCurrent, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkCurrent);

		var DataLinkGroupID = LFD.addNode(LFDObject,'DataLinkGroupID', false, TextPropertiesObj.DataLinkGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkGroupID);

		var DataLinkSplitGroupID = LFD.addNode(LFDObject,'DataLinkSplitGroupID', false, TextPropertiesObj.DataLinkSplitGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkSplitGroupID);

		var DataLinkSplitGroupName = LFD.addNode(LFDObject,'DataLinkSplitGroupName', true, TextPropertiesObj.DataLinkSplitGroupName, true, 'type', 'String', 'time', '0');
		Element.appendChild(DataLinkSplitGroupName);
		var defaltVal = null;
		var DataSource = LFD.addNode(LFDObject,'DataSource', true, defaltVal, true, 'type', 'String', 'time', '0');
		Element.appendChild(DataSource);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, TextPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, TextPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, TextPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, TextPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, TextPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, TextPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, TextPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, TextPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, TextPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, TextPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, TextPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, TextPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		var TextXML = LFD.addNode(LFDObject,'TextXML', true, TextPropertiesObj.TextXML, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(TextXML);
		
		var TextCaption = LFD.addNode(LFDObject,'TextCaption', true, TextPropertiesObj.TextCaption, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(TextCaption);

		var TextImage = LFD.addNode(LFDObject,'TextImage', true, TextPropertiesObj.TextImage, true, 'type', 'File', 'time', '0');
		Element.appendChild(TextImage);
		
		if(globlePlayerType==RMD_MODEL){
			var NT14_TextImage = LFD.addNode(LFDObject,'NT14_TextImage', true, TextPropertiesObj.NT14_TextImage, true, 'type', 'File', 'time', '0');
			Element.appendChild(NT14_TextImage);
		}
		
		var TextEffect = LFD.addNode(LFDObject,'TextEffect', false, TextPropertiesObj.TextEffect, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextEffect);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		
		//alert("Length "+LFDObject.getElementsByTagName("Group").length);
		//alert("indxForLfdGroupTag "+indxForLfdGroupTag);
		//alert("TextPropertiesObj.isGroupMember "+TextPropertiesObj.isGroupMember);
		//alert("xyx ert "+LFDObject.getElementsByTagName("Group")[indxForLfdGroupTag]);
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

/*
*	Function to add Office Elements
*/

LFD.addOffice = function(LFDObject, PageNum, OfficePropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addOffice");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Office";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = OfficePropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, OfficePropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, OfficePropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
		var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, OfficePropertiesObj.OriginalPath, true, 'type', 'File', 'time', '0');
		Element.appendChild(OriginalPath);
		}
		var OfficeViewerPath = LFD.addNode(LFDObject,'OfficeViewerPath', true, OfficePropertiesObj.OfficeViewerPath, true, 'type', 'File', 'time', '0');
		Element.appendChild(OfficeViewerPath);
		var isEditable = LFD.addNode(LFDObject,'IsEditable', false, OfficePropertiesObj.IsEditable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isEditable);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, OfficePropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, OfficePropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);
		
		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, OfficePropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
				
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, OfficePropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
				
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, OfficePropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);
				
		var PositionY = LFD.addNode(LFDObject,'PositionY', false, OfficePropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);
				
		var Width = LFD.addNode(LFDObject,'Width', false, OfficePropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);
				
		var Height = LFD.addNode(LFDObject,'Height', false, OfficePropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
				
				
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, OfficePropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, OfficePropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);
		
		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, OfficePropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
		
		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, OfficePropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, OfficePropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, OfficePropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, OfficePropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, OfficePropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);
		
		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, OfficePropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, OfficePropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, OfficePropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, OfficePropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);
		
		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, OfficePropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		//LFD.addFiles(LFDObject,true,OfficePropertiesObj.Name,true,'','','','');
		if(OfficePropertiesObj.FilePath!==''){
			LFD.addFiles(LFDObject,true,OfficePropertiesObj.FilePath,true,'','','','');
		}
		
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

/*
*	Function to add Flash Elements
*/
//===================================================================================================================//
//Adding PDF
LFD.addPDF = function(LFDObject, PageNum, PdfPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addPDF");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Pdf";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = PdfPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, PdfPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, PdfPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, PdfPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);
		
		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, PdfPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
				
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, PdfPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
				
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, PdfPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);
				
		var PositionY = LFD.addNode(LFDObject,'PositionY', false, PdfPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);
		
		var PdfGotoPage = LFD.addNode(LFDObject,'PdfGotoPage', false, PdfPropertiesObj.PdfGotoPage, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PdfGotoPage);
			
		var PdfOutputMode = LFD.addNode(LFDObject,'PdfOutputMode', false, PdfPropertiesObj.Layer, true, 'type', 'List', 'time', '0');
		Element.appendChild(PdfOutputMode);
				
		var Width = LFD.addNode(LFDObject,'Width', false, PdfPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);
				
		var Height = LFD.addNode(LFDObject,'Height', false, PdfPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
				
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, PdfPropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);
				
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, PdfPropertiesObj.OriginalPath, true, 'type', 'File', 'time', '0');
			Element.appendChild(OriginalPath);
		}
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, PdfPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, PdfPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);
		
		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, PdfPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
		
		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, PdfPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, PdfPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, PdfPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, PdfPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, PdfPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);
		
		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, PdfPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, PdfPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, PdfPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, PdfPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);
		
		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, PdfPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		if(PdfPropertiesObj.Name!=='pdf.png'){
			LFD.addFiles(LFDObject,true,PdfPropertiesObj.FilePath,true,'','','','');
			}
		
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};


//====================================================================================================================//

LFD.addFlash = function(LFDObject, PageNum, FlashPropertiesObj)
{	
	//console.log("Inside addFlash");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Flash";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = FlashPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, FlashPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var URLAddress = LFD.addNode(LFDObject,'URLAddress', true, FlashPropertiesObj.URLAddress, true, 'type', 'File', 'time', '0');
		Element.appendChild(URLAddress);		
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, FlashPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, FlashPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);
		
		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, FlashPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
				
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, FlashPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
				
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, FlashPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);
				
		var PositionY = LFD.addNode(LFDObject,'PositionY', false, FlashPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);
				
		var Width = LFD.addNode(LFDObject,'Width', false, FlashPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);
				
		var Height = LFD.addNode(LFDObject,'Height', false, FlashPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
				
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, FlashPropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);
		
		var FlashRepeat = LFD.addNode(LFDObject,'FlashRepeat', false, FlashPropertiesObj.FlashRepeat, true, 'type', 'List', 'time', '0');
		Element.appendChild(FlashRepeat);
		
		var FlashInputEnable = LFD.addNode(LFDObject,'FlashInputEnable', false, FlashPropertiesObj.FlashInputEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(FlashInputEnable);
		
		var FlashTotalFrames = LFD.addNode(LFDObject,'FlashTotalFrames', false, FlashPropertiesObj.FlashTotalFrames, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FlashTotalFrames);
		
		var FlashFrameRate = LFD.addNode(LFDObject,'FlashFrameRate', false, FlashPropertiesObj.FlashFrameRate, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(FlashFrameRate);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, FlashPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, FlashPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);
		
		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, FlashPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
		
		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, FlashPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, FlashPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, FlashPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, FlashPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, FlashPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);
		
		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, FlashPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, FlashPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, FlashPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, FlashPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);
		
		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, FlashPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);
		
		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, FlashPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);
		
		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, FlashPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);
		
		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, FlashPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);
		
		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, FlashPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);
		
		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, FlashPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);
		
		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, FlashPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);
		
		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, FlashPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, FlashPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);
		
		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, FlashPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);
		
		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, FlashPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		if(FlashPropertiesObj.FilePath!==''){
		LFD.addFiles(LFDObject,true,FlashPropertiesObj.FilePath,true,'','','','');
		}
		
		LFDObject.getElementsByTagName("Page")[PageNum].appendChild(Element);
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

/*
*	Function to add Sound Elements
*/
LFD.addSound = function(LFDObject, PageNum, SoundPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addSound");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Sound";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = SoundPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, SoundPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
				
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, SoundPropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);
		
		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, SoundPropertiesObj.OriginalPath, true, 'type', 'File', 'time', '0');
			Element.appendChild(OriginalPath);
		}
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, SoundPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, SoundPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);
		
		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, SoundPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
				
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, SoundPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var SoundAfterPlay = LFD.addNode(LFDObject,'SoundAfterPlay', false, SoundPropertiesObj.SoundAfterPlay, true, 'type', 'List', 'time', '0');
		Element.appendChild(SoundAfterPlay);		
		
		var SoundMute = LFD.addNode(LFDObject,'SoundMute', false, SoundPropertiesObj.SoundMute, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(SoundMute);		
		
		var SoundVolume = LFD.addNode(LFDObject,'SoundVolume', false, SoundPropertiesObj.SoundVolume, true, 'type', 'Number', 'time', '0');
		Element.appendChild(SoundVolume);		
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, SoundPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, SoundPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);
		
		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, SoundPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, SoundPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, SoundPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, SoundPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, SoundPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);
		
		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, SoundPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, SoundPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, SoundPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var OriginalLength = LFD.addNode(LFDObject,'OriginalLength', false, SoundPropertiesObj.OriginalLength, true, 'type', 'Time', 'time', '0');
		Element.appendChild(OriginalLength);
		
		var ClipStart = LFD.addNode(LFDObject,'ClipStart', false, SoundPropertiesObj.ClipStart, true, 'type', 'Time', 'time', '0');
		Element.appendChild(ClipStart);
		
		var ClipEnd = LFD.addNode(LFDObject,'ClipEnd', false, SoundPropertiesObj.ClipEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(ClipEnd);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, SoundPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);
		
		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
		if(SoundPropertiesObj.FilePath!==''){
			LFD.addFiles(LFDObject,true,SoundPropertiesObj.FilePath,true,'','','','');
			}
		
		
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};


/*
*	Function to add Digital Clock Elements
*/

LFD.addDigitalClock = function(LFDObject, PageNum, DigitalClockPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addDigitalClock");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Digital Clock";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = DigitalClockPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);

		var Name = LFD.addNode(LFDObject,'Name', true, DigitalClockPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);

		
		
		var TimeFormat = LFD.addNode(LFDObject,'TimeFormat', false, DigitalClockPropertiesObj.TimeFormat, true, 'type', 'Number', 'time', '0');
		Element.appendChild(TimeFormat);

		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, DigitalClockPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var Layer = LFD.addNode(LFDObject,'Layer', false, DigitalClockPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, DigitalClockPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);

		var TextCaption = LFD.addNode(LFDObject,'TextCaption', true, DigitalClockPropertiesObj.TextCaption, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(TextCaption);

		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, DigitalClockPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);

		var PositionX = LFD.addNode(LFDObject,'PositionX', false, DigitalClockPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, DigitalClockPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, DigitalClockPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, DigitalClockPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, DigitalClockPropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);

		var TextFile = LFD.addNode(LFDObject,'TextFile', true, DigitalClockPropertiesObj.TextFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(TextFile);

		var FillColor = LFD.addNode(LFDObject,'FillColor', false, DigitalClockPropertiesObj.FillColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FillColor);

		var SelectOpacity = LFD.addNode(LFDObject,'SelectOpacity', false, DigitalClockPropertiesObj.SelectOpacity, true, 'type', 'List', 'time', '0');
		Element.appendChild(SelectOpacity);

		var FillOpacity = LFD.addNode(LFDObject,'FillOpacity', false, DigitalClockPropertiesObj.FillOpacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FillOpacity);

		var Opacity = LFD.addNode(LFDObject,'Opacity', false, DigitalClockPropertiesObj.Opacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Opacity);

		var TextHAlign = LFD.addNode(LFDObject,'TextHAlign', false, DigitalClockPropertiesObj.TextHAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextHAlign);

		var TextVAlign = LFD.addNode(LFDObject,'TextVAlign', false, DigitalClockPropertiesObj.TextVAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextVAlign);

		var TextWordWrap = LFD.addNode(LFDObject,'TextWordWrap', false, DigitalClockPropertiesObj.TextWordWrap, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextWordWrap);

		var TextDisplayDirection = LFD.addNode(LFDObject,'TextDisplayDirection', false, DigitalClockPropertiesObj.TextDisplayDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextDisplayDirection);

		var TextDirection = LFD.addNode(LFDObject,'TextDirection', false, DigitalClockPropertiesObj.TextDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextDirection);

		var TextSpeed = LFD.addNode(LFDObject,'TextSpeed', false, DigitalClockPropertiesObj.TextSpeed, true, 'type', 'Number', 'time', '0');
		Element.appendChild(TextSpeed);

		var TextEffect = LFD.addNode(LFDObject,'TextEffect', false, DigitalClockPropertiesObj.TextEffect, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextEffect);

		var TextFontName = LFD.addNode(LFDObject,'TextFontName', false, DigitalClockPropertiesObj.TextFontName, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextFontName);

		var TextFontFile = LFD.addNode(LFDObject,'TextFontFile', true, DigitalClockPropertiesObj.TextFontFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(TextFontFile);

		var TextColor = LFD.addNode(LFDObject,'TextColor', false, DigitalClockPropertiesObj.TextColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(TextColor);

		var TextFontSize = LFD.addNode(LFDObject,'TextFontSize', false, DigitalClockPropertiesObj.TextFontSize, true, 'type', 'Number', 'time', '0');
		Element.appendChild(TextFontSize);

		var TextItalic = LFD.addNode(LFDObject,'TextItalic', false, DigitalClockPropertiesObj.TextItalic, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextItalic);

		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, DigitalClockPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, DigitalClockPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var TextBold = LFD.addNode(LFDObject,'TextBold', false, DigitalClockPropertiesObj.TextBold, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextBold);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, DigitalClockPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var TextUnderLine = LFD.addNode(LFDObject,'TextUnderLine', false, DigitalClockPropertiesObj.TextUnderLine, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextUnderLine);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, DigitalClockPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var TextStrikeOut = LFD.addNode(LFDObject,'TextStrikeOut', false, DigitalClockPropertiesObj.TextStrikeOut, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(TextStrikeOut);

		var DigitalUseLocale = LFD.addNode(LFDObject,'DigitalUseLocale', false, DigitalClockPropertiesObj.DigitalUseLocale, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DigitalUseLocale);

		var DigitalClockGMT = LFD.addNode(LFDObject,'DigitalClockGMT', false, DigitalClockPropertiesObj.DigitalClockGMT, true, 'type', 'List', 'time', '0');
		Element.appendChild(DigitalClockGMT);

		var DigitalClockSeperator = LFD.addNode(LFDObject,'DigitalClockSeperator', true, DigitalClockPropertiesObj.DigitalClockSeperator, true, 'type', 'String', 'time', '0');
		Element.appendChild(DigitalClockSeperator);

		var DigitalClockDaylight = LFD.addNode(LFDObject,'DigitalClockDaylight', false, DigitalClockPropertiesObj.DigitalClockDaylight, true, 'type', 'List', 'time', '0');
		Element.appendChild(DigitalClockDaylight);

		var DisplayLanguage = LFD.addNode(LFDObject,'DisplayLanguage', false, DigitalClockPropertiesObj.DisplayLanguage, true, 'type', 'List', 'time', '0');
        Element.appendChild(DisplayLanguage);

		//var Name = LFD.addNode(LFDObject,'Name', false, DigitalClockPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		//Element.appendChild(Name);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, DigitalClockPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, DigitalClockPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, DigitalClockPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, DigitalClockPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, DigitalClockPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, DigitalClockPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, DigitalClockPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);

	
		var DataLinkUse = LFD.addNode(LFDObject,'DataLinkUse', false, DigitalClockPropertiesObj.DataLinkUse, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkUse);

		var DataLinkDisplayOrder = LFD.addNode(LFDObject,'DataLinkDisplayOrder', false, DigitalClockPropertiesObj.DataLinkDisplayOrder, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkDisplayOrder);

		var DataLinkDuration = LFD.addNode(LFDObject,'DataLinkDuration', false, DigitalClockPropertiesObj.DataLinkDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(DataLinkDuration);

		var DataLinkSlpit = LFD.addNode(LFDObject,'DataLinkSlpit', false, DigitalClockPropertiesObj.DataLinkSlpit, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkSlpit);

		var DataLinkCurrent = LFD.addNode(LFDObject,'DataLinkCurrent', false, DigitalClockPropertiesObj.DataLinkCurrent, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DataLinkCurrent);

		var DataLinkGroupID = LFD.addNode(LFDObject,'DataLinkGroupID', false, DigitalClockPropertiesObj.DataLinkGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkGroupID);

		var DataLinkSplitGroupID = LFD.addNode(LFDObject,'DataLinkSplitGroupID', false, DigitalClockPropertiesObj.DataLinkSplitGroupID, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DataLinkSplitGroupID);

		var DataLinkSplitGroupName = LFD.addNode(LFDObject,'DataLinkSplitGroupName', true, DigitalClockPropertiesObj.DataLinkSplitGroupName, true, 'type', 'String', 'time', '0');
		Element.appendChild(DataLinkSplitGroupName);

		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, DigitalClockPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, DigitalClockPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, DigitalClockPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, DigitalClockPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, DigitalClockPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, DigitalClockPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, DigitalClockPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, DigitalClockPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, DigitalClockPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, DigitalClockPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, DigitalClockPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, DigitalClockPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};
/*
*	Function to add Analog Clock Elements
*/
LFD.addAnalogClock = function(LFDObject, PageNum, AnalogClockPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addAnalogClock");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Analog Clock";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = AnalogClockPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		var Name = LFD.addNode(LFDObject,'Name', true, AnalogClockPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var ClockType = LFD.addNode(LFDObject,'ClockType', false, AnalogClockPropertiesObj.ClockType, true, 'type', 'List', 'time', '0');
		Element.appendChild(ClockType);

		var ClockBackImage = LFD.addNode(LFDObject,'ClockBackImage', true, AnalogClockPropertiesObj.ClockBackImage, true, 'type', 'File', 'time', '0');
		Element.appendChild(ClockBackImage);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, AnalogClockPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var AnalogClockGMT = LFD.addNode(LFDObject,'AnalogClockGMT', false, AnalogClockPropertiesObj.AnalogClockGMT, true, 'type', 'List', 'time', '0');
		Element.appendChild(AnalogClockGMT);

		var AnalogUseLocale = LFD.addNode(LFDObject,'AnalogUseLocale', false, AnalogClockPropertiesObj.AnalogUseLocale, true, 'type', 'List', 'time', '0');
        Element.appendChild(AnalogUseLocale);

		var Layer = LFD.addNode(LFDObject,'Layer', false, AnalogClockPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, AnalogClockPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);

		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, AnalogClockPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, AnalogClockPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, AnalogClockPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, AnalogClockPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, AnalogClockPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
		
		var ClockHourImage = LFD.addNode(LFDObject,'ClockHourImage', true, AnalogClockPropertiesObj.ClockHourImage, true, 'type', 'File', 'time', '0');
		Element.appendChild(ClockHourImage);

		var ClockMinuteImage = LFD.addNode(LFDObject,'ClockMinuteImage', true, AnalogClockPropertiesObj.ClockMinuteImage, true, 'type', 'File', 'time', '0');
		Element.appendChild(ClockMinuteImage);

		var ClockSecondImage = LFD.addNode(LFDObject,'ClockSecondImage', true, AnalogClockPropertiesObj.ClockSecondImage, true, 'type', 'File', 'time', '0');
		Element.appendChild(ClockSecondImage);
		
		var AnalogClockSeperator = LFD.addNode(LFDObject,'AnalogClockSeperator', true, AnalogClockPropertiesObj.AnalogClockSeperator, true, 'type', 'String', 'time', '0');
		Element.appendChild(AnalogClockSeperator);

		var AnalogClockDaylight = LFD.addNode(LFDObject,'AnalogClockDaylight', false, AnalogClockPropertiesObj.AnalogClockDaylight, true, 'type', 'List', 'time', '0');
		Element.appendChild(AnalogClockDaylight);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, AnalogClockPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, AnalogClockPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
	
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, AnalogClockPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, AnalogClockPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, AnalogClockPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, AnalogClockPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, AnalogClockPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, AnalogClockPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, AnalogClockPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, AnalogClockPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, AnalogClockPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, AnalogClockPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, AnalogClockPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, AnalogClockPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, AnalogClockPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, AnalogClockPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, AnalogClockPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, AnalogClockPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, AnalogClockPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, AnalogClockPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, AnalogClockPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, AnalogClockPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, AnalogClockPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
			var ClockDisplayType = LFD.addNode(LFDObject,'ClockDisplayType', true, AnalogClockPropertiesObj.ClockDisplayType, true, 'type', Number, 'time', '0');
			Element.appendChild(ClockDisplayType);
		}

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

/*
*	Function to Web Element
*/

LFD.addWeb = function(LFDObject, PageNum, WebPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addWeb");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	var defaultTypeIdWeb = "909736CD-5688-49D5-89B0-1DEB6E65962D";
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Web";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		if(WebPropertiesObj.TypeID == undefined || WebPropertiesObj.TypeID ==""){
			ElemAttr2.nodeValue = defaultTypeIdWeb;
		}else{
			ElemAttr2.nodeValue = WebPropertiesObj.TypeID;
		}	
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, WebPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var WebURL = LFD.addNode(LFDObject,'WebURL', true, WebPropertiesObj.WebURL, true, 'type', 'String', 'time', '0');
		Element.appendChild(WebURL);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, WebPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var isEditable = LFD.addNode(LFDObject,'IsEditable', false, WebPropertiesObj.IsEditable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isEditable);
		var WebAuthorizationID = LFD.addNode(LFDObject,'WebAuthorizationID', true, WebPropertiesObj.WebAuthorizationID, true, 'type', 'String', 'time', '0');
		Element.appendChild(WebAuthorizationID);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, WebPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, WebPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, WebPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, WebPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, WebPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, WebPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, WebPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
		
		var FilePath = LFD.addNode(LFDObject,'FilePath', true, WebPropertiesObj.FilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(FilePath);

		var WebOutputMode = LFD.addNode(LFDObject,'WebOutputMode', false, WebPropertiesObj.WebOutputMode, true, 'type', 'List', 'time', '0');
		Element.appendChild(WebOutputMode);

		var WebRefresh = LFD.addNode(LFDObject,'WebRefresh', false, WebPropertiesObj.WebRefresh, true, 'type', 'Number', 'time', '0');
		Element.appendChild(WebRefresh);
		
		var WebRefreshNew = LFD.addNode(LFDObject,'WebRefreshNew', false, WebPropertiesObj.WebRefreshNew, true, 'type', 'Time', 'time', '0');
		Element.appendChild(WebRefreshNew);
		
		var WebInputEnable = LFD.addNode(LFDObject,'WebInputEnable', false, WebPropertiesObj.WebInputEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WebInputEnable);
		
		var WebScrollShow = LFD.addNode(LFDObject,'WebScrollShow', false, WebPropertiesObj.WebScrollShow, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WebScrollShow);

		var WebVScrollPos = LFD.addNode(LFDObject,'WebVScrollPos', false, WebPropertiesObj.WebVScrollPos, true, 'type', 'Number', 'time', '0');
		Element.appendChild(WebVScrollPos);
		
		var WebHScrollPos = LFD.addNode(LFDObject,'WebHScrollPos', false, WebPropertiesObj.WebHScrollPos, true, 'type', 'Number', 'time', '0');
		Element.appendChild(WebHScrollPos);
		
		var WebAuthorizationPassWd = LFD.addNode(LFDObject,'WebAuthorizationPassWd', true, WebPropertiesObj.WebAuthorizationPassWd, true, 'type', 'String', 'time', '0');
		Element.appendChild(WebAuthorizationPassWd);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, WebPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, WebPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);
	
		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, WebPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
	
		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, WebPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, WebPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, WebPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, WebPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, WebPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, WebPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, WebPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, WebPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, WebPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, WebPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};
LFD.addMediaRss = function(LFDObject, PageNum, MediaRssPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addWeb");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	var defaultTypeIdWeb = "909736CD-5688-49D5-89B0-1DEB6E65962D";
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Media RSS";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		if(MediaRssPropertiesObj.TypeID == undefined || MediaRssPropertiesObj.TypeID ==""){
			ElemAttr2.nodeValue = defaultTypeIdWeb;
		}else{
			ElemAttr2.nodeValue = MediaRssPropertiesObj.TypeID;
		}	
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, MediaRssPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var MrssURL = LFD.addNode(LFDObject,'MrssURL', true, MediaRssPropertiesObj.MrssURL, true, 'type', 'String', 'time', '0');
		Element.appendChild(MrssURL);

		if(templateFlag == UPLOAD_TEMPLATE)
        {
            /*change mins to seconds while upload*/
            MediaRssPropertiesObj.MrssDuration = getParseIntInDec(MediaRssPropertiesObj.MrssDuration) * 60;
        }
		
		var MrssDuration = LFD.addNode(LFDObject,'MrssDuration', false, MediaRssPropertiesObj.MrssDuration, true, 'type', 'Number', 'time', '0');
		Element.appendChild(MrssDuration);

		var AspectFill = LFD.addNode(LFDObject,'AspectFill', false, MediaRssPropertiesObj.AspectFill, true, 'type', 'Number', 'time', '0');
        Element.appendChild(AspectFill);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, MediaRssPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);

		var isEditable = LFD.addNode(LFDObject,'IsEditable', false, MediaRssPropertiesObj.IsEditable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isEditable);
		
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, MediaRssPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, MediaRssPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, MediaRssPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, MediaRssPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, MediaRssPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, MediaRssPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, MediaRssPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
		
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, MediaRssPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, MediaRssPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);
	
		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, MediaRssPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
	
		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, MediaRssPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, MediaRssPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, MediaRssPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, MediaRssPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, MediaRssPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, MediaRssPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, MediaRssPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, MediaRssPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, MediaRssPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, MediaRssPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};

/*
*	Function to add Weather Hourly Elements
*/
LFD.addWeatherHourly = function(LFDObject, PageNum, WeatherHoulryPropertiesObj,addToGrp,GrpCount)
{	
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Hourly";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = WeatherHoulryPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		var Name = LFD.addNode(LFDObject,'Name', true, WeatherHoulryPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		var WeatherType = LFD.addNode(LFDObject,'WeatherType', false, WeatherHoulryPropertiesObj.WeatherType, true, 'type', 'List', 'time', '0');
		Element.appendChild(WeatherType);
		var Country = LFD.addNode(LFDObject,'Country', false, WeatherHoulryPropertiesObj.Country, true, 'type', 'List', 'time', '0');
		Element.appendChild(Country);
		
		var City = LFD.addNode(LFDObject,'City', false, WeatherHoulryPropertiesObj.City, true, 'type', 'List', 'time', '0');
		Element.appendChild(City);
		
		var LocationKey = LFD.addNode(LFDObject,'LocationKey', true, WeatherHoulryPropertiesObj.LocationKey, true, 'type', 'List', 'time', '0');
		Element.appendChild(LocationKey);
		
		var Language = LFD.addNode(LFDObject,'Language', false, WeatherHoulryPropertiesObj.Language, true, 'type', 'List', 'time', '0');
		Element.appendChild(Language);
		
		var LanguageCode = LFD.addNode(LFDObject,'LanguageCode', true, WeatherHoulryPropertiesObj.LanguageCode, true, 'type', 'File', 'time', '0');
		Element.appendChild(LanguageCode);
		
		var Background = LFD.addNode(LFDObject,'Background', false, WeatherHoulryPropertiesObj.Background, true, 'type', 'List', 'time', '0');
		Element.appendChild(Background);
		
		var Opacity = LFD.addNode(LFDObject,'Opacity', false, WeatherHoulryPropertiesObj.Opacity, true, 'type', 'List', 'time', '0');
		Element.appendChild(Opacity);
		
		var Date = LFD.addNode(LFDObject,'Date', false, WeatherHoulryPropertiesObj.Date, true, 'type', 'List', 'time', '0');
		Element.appendChild(Date);
		
		var Refresh = LFD.addNode(LFDObject,'Refresh', false, WeatherHoulryPropertiesObj.Refresh, true, 'type', 'List', 'time', '0');
		Element.appendChild(Refresh);
		
		var Unit = LFD.addNode(LFDObject,'Unit', false, WeatherHoulryPropertiesObj.Unit, true, 'type', 'List', 'time', '0');
		Element.appendChild(Unit);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, WeatherHoulryPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);		
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, WeatherHoulryPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, WeatherHoulryPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, WeatherHoulryPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, WeatherHoulryPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, WeatherHoulryPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, WeatherHoulryPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, WeatherHoulryPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
				
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, WeatherHoulryPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, WeatherHoulryPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
	
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, WeatherHoulryPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, WeatherHoulryPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, WeatherHoulryPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, WeatherHoulryPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, WeatherHoulryPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, WeatherHoulryPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, WeatherHoulryPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, WeatherHoulryPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, WeatherHoulryPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, WeatherHoulryPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, WeatherHoulryPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, WeatherHoulryPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, WeatherHoulryPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, WeatherHoulryPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, WeatherHoulryPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, WeatherHoulryPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, WeatherHoulryPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, WeatherHoulryPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, WeatherHoulryPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, WeatherHoulryPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, WeatherHoulryPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};
/*
*	Function to add Weather 1Day Elements
*/
LFD.addWeather1Day = function(LFDObject, PageNum, Weather1DayPropertiesObj,addToGrp,GrpCount)
{	
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "1Day";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = Weather1DayPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, Weather1DayPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var WeatherType = LFD.addNode(LFDObject,'WeatherType', false, Weather1DayPropertiesObj.WeatherType, true, 'type', 'List', 'time', '0');
		Element.appendChild(WeatherType);
		
		var Country = LFD.addNode(LFDObject,'Country', false, Weather1DayPropertiesObj.Country, true, 'type', 'List', 'time', '0');
		Element.appendChild(Country);
		
		var City = LFD.addNode(LFDObject,'City', false, Weather1DayPropertiesObj.City, true, 'type', 'List', 'time', '0');
		Element.appendChild(City);
		
		var LocationKey = LFD.addNode(LFDObject,'LocationKey', true, Weather1DayPropertiesObj.LocationKey, true, 'type', 'List', 'time', '0');
		Element.appendChild(LocationKey);
		
		var Language = LFD.addNode(LFDObject,'Language', false, Weather1DayPropertiesObj.Language, true, 'type', 'List', 'time', '0');
		Element.appendChild(Language);
		
		var LanguageCode = LFD.addNode(LFDObject,'LanguageCode', true, Weather1DayPropertiesObj.LanguageCode, true, 'type', 'File', 'time', '0');
		Element.appendChild(LanguageCode);
		
		var Background = LFD.addNode(LFDObject,'Background', false, Weather1DayPropertiesObj.Background, true, 'type', 'List', 'time', '0');
		Element.appendChild(Background);
		
		var Opacity = LFD.addNode(LFDObject,'Opacity', false, Weather1DayPropertiesObj.Opacity, true, 'type', 'List', 'time', '0');
		Element.appendChild(Opacity);
		
		var Date = LFD.addNode(LFDObject,'Date', false, Weather1DayPropertiesObj.Date, true, 'type', 'List', 'time', '0');
		Element.appendChild(Date);
		
		var Refresh = LFD.addNode(LFDObject,'Refresh', false, Weather1DayPropertiesObj.Refresh, true, 'type', 'List', 'time', '0');
		Element.appendChild(Refresh);
		
		var Unit = LFD.addNode(LFDObject,'Unit', false, Weather1DayPropertiesObj.Unit, true, 'type', 'List', 'time', '0');
		Element.appendChild(Unit);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, Weather1DayPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);		
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, Weather1DayPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, Weather1DayPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, Weather1DayPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, Weather1DayPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, Weather1DayPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, Weather1DayPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, Weather1DayPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
				
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, Weather1DayPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, Weather1DayPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
	
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, Weather1DayPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, Weather1DayPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, Weather1DayPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, Weather1DayPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, Weather1DayPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, Weather1DayPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, Weather1DayPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, Weather1DayPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, Weather1DayPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, Weather1DayPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, Weather1DayPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, Weather1DayPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, Weather1DayPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, Weather1DayPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, Weather1DayPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, Weather1DayPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, Weather1DayPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, Weather1DayPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, Weather1DayPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, Weather1DayPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, Weather1DayPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};
/*
*	Function to add Weather 7Day Elements
*/
LFD.addWeather7Day = function(LFDObject, PageNum, Weather7DayPropertiesObj,addToGrp,GrpCount)
{	
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "7Day";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = Weather7DayPropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);
		
		var Name = LFD.addNode(LFDObject,'Name', true, Weather7DayPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
		
		var WeatherType = LFD.addNode(LFDObject,'WeatherType', false, Weather7DayPropertiesObj.WeatherType, true, 'type', 'List', 'time', '0');
		Element.appendChild(WeatherType);
		
		var Country = LFD.addNode(LFDObject,'Country', false, Weather7DayPropertiesObj.Country, true, 'type', 'List', 'time', '0');
		Element.appendChild(Country);
		
		var City = LFD.addNode(LFDObject,'City', false, Weather7DayPropertiesObj.City, true, 'type', 'List', 'time', '0');
		Element.appendChild(City);
		
		var LocationKey = LFD.addNode(LFDObject,'LocationKey', true, Weather7DayPropertiesObj.LocationKey, true, 'type', 'List', 'time', '0');
		Element.appendChild(LocationKey);
		
		var Language = LFD.addNode(LFDObject,'Language', false, Weather7DayPropertiesObj.Language, true, 'type', 'List', 'time', '0');
		Element.appendChild(Language);
		
		var LanguageCode = LFD.addNode(LFDObject,'LanguageCode', true, Weather7DayPropertiesObj.LanguageCode, true, 'type', 'File', 'time', '0');
		Element.appendChild(LanguageCode);
		
		var Background = LFD.addNode(LFDObject,'Background', false, Weather7DayPropertiesObj.Background, true, 'type', 'List', 'time', '0');
		Element.appendChild(Background);
		
		var Opacity = LFD.addNode(LFDObject,'Opacity', false, Weather7DayPropertiesObj.Opacity, true, 'type', 'List', 'time', '0');
		Element.appendChild(Opacity);
		
		var Date = LFD.addNode(LFDObject,'Date', false, Weather7DayPropertiesObj.Date, true, 'type', 'List', 'time', '0');
		Element.appendChild(Date);
		
		var Refresh = LFD.addNode(LFDObject,'Refresh', false, Weather7DayPropertiesObj.Refresh, true, 'type', 'List', 'time', '0');
		Element.appendChild(Refresh);
		
		var Unit = LFD.addNode(LFDObject,'Unit', false, Weather7DayPropertiesObj.Unit, true, 'type', 'List', 'time', '0');
		Element.appendChild(Unit);
		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, Weather7DayPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);		
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, Weather7DayPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, Weather7DayPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
		
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, Weather7DayPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, Weather7DayPropertiesObj.PositionX, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, Weather7DayPropertiesObj.PositionY, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, Weather7DayPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, Weather7DayPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);
				
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, Weather7DayPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, Weather7DayPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);
	
		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, Weather7DayPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, Weather7DayPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);
		
		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, Weather7DayPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);
		
		var Start = LFD.addNode(LFDObject,'Start', false, Weather7DayPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);
		
		var Duration = LFD.addNode(LFDObject,'Duration', false, Weather7DayPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);
		
		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, Weather7DayPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, Weather7DayPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);
		
		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, Weather7DayPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);
		
		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, Weather7DayPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, Weather7DayPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, Weather7DayPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, Weather7DayPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, Weather7DayPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, Weather7DayPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, Weather7DayPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, Weather7DayPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, Weather7DayPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, Weather7DayPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, Weather7DayPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, Weather7DayPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, Weather7DayPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);

		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);

		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);

	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
};
/*
*	Function to add line
*/
LFD.addLine = function(LFDObject, PageNum, LinePropertiesObj)
{
	//console.log("Inside addLine");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "Figure Line";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = LinePropertiesObj.TypeID;
		Element.setAttributeNode(ElemAttr2);

		var Name = LFD.addNode(LFDObject,'Name', true, LinePropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);

		var LineColor = LFD.addNode(LFDObject,'LineColor', false, LinePropertiesObj.LineColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(LineColor);

		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, LinePropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
	
		var Layer = LFD.addNode(LFDObject,'Layer', false, LinePropertiesObj.Layer, true, 'type', 'Number', 'Number', '0');
		Element.appendChild(Layer);
	
         
	   var PointList = LFD.addNode(LFDObject,'PointList', true, LinePropertiesObj.PointList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PointList);
	   
		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, LinePropertiesObj.PinnedPointNameList, true, 'type', 'MultiString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
	
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, LinePropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		var FillColor = LFD.addNode(LFDObject,'FillColor', false, LinePropertiesObj.FillColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FillColor);
	
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, LinePropertiesObj.PositionX, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, LinePropertiesObj.PositionY, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionY);
	
		var FillOpacity = LFD.addNode(LFDObject,'FillOpacity', false, LinePropertiesObj.FillOpacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FillOpacity);

		var Width = LFD.addNode(LFDObject,'Width', false, LinePropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);
	
		var Height = LFD.addNode(LFDObject,'Height', false, LinePropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, LinePropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);

		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, LinePropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, LinePropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, LinePropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, LinePropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, LinePropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, LinePropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, LinePropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, LinePropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, LinePropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, LinePropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, LinePropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);

	

		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, LinePropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, LinePropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, LinePropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, LinePropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, LinePropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);
		var BendingType = LFD.addNode(LFDObject,'BendingType', false, LinePropertiesObj.BendingType, true, 'type', 'List', 'time', '0');
		Element.appendChild(BendingType);		
		var FigureStrokeWidth = LFD.addNode(LFDObject,'FigureStrokeWidth', false, LinePropertiesObj.FigureStrokeWidth, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FigureStrokeWidth);			

		var FigureStrokePattern = LFD.addNode(LFDObject,'FigureStrokePattern', false, LinePropertiesObj.FigureStrokePattern, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FigureStrokePattern);
		
		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, LinePropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, LinePropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, LinePropertiesObj.EffectOutDuration, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, LinePropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, LinePropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, LinePropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);


		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		
		LFDObject.getElementsByTagName("Page")[PageNum].appendChild(Element);
	}
};
/*
*	Function to add RSS feed Elements
*/

LFD.addRSS = function(LFDObject, PageNum, RSSPropertiesObj,addToGrp,GrpCount)
{	
	console.log("Inside addRSS");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	var defaultTypeIdRss = "D3B014C8-02E3-4C5D-98AF-3A0A618BC522";
	if(pageCount>0 && PageNum<pageCount)
	{
		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = "RSS";
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
	//	ElemAttr2.nodeValue = RSSPropertiesObj.TypeID;
		if(RSSPropertiesObj.TypeID == undefined || RSSPropertiesObj.TypeID ==""){
			ElemAttr2.nodeValue = defaultTypeIdRss;
		}else{
			ElemAttr2.nodeValue = RSSPropertiesObj.TypeID;
		}	
		Element.setAttributeNode(ElemAttr2);

		var Name = LFD.addNode(LFDObject,'Name', true, RSSPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);

		var FillColor = LFD.addNode(LFDObject,'FillColor', false, RSSPropertiesObj.FillColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FillColor);

		
		var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, RSSPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
	
		var Layer = LFD.addNode(LFDObject,'Layer', false, RSSPropertiesObj.Layer, true, 'type', 'Number', 'Number', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, RSSPropertiesObj.PinnedPointNameList, true, 'type', 'MultiString', 'time', '0');
		Element.appendChild(PinnedPointNameList);
	
		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, RSSPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);
		/*var isTitleVisible = LFD.addNode(LFDObject,'isTitleVisible', false, RSSPropertiesObj.isTitleVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isTitleVisible);
		var isDateVisible = LFD.addNode(LFDObject,'isDateVisible', false, RSSPropertiesObj.isDateVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isDateVisible);
		var isBodyVisible = LFD.addNode(LFDObject,'isBodyVisible', false, RSSPropertiesObj.isBodyVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(isBodyVisible);*/
	
		var RssReloadDuration = LFD.addNode(LFDObject,'RssReloadDuration', false, RSSPropertiesObj.RssReloadDuration, true, 'type', 'Number', 'time', '0');
		Element.appendChild(RssReloadDuration);

	//	var RSS_URL = LFD.addNode(LFDObject,'RSS_URL', true, RSSPropertiesObj.RSS_URL, true, 'type', 'String', 'time', '0');
		//Element.appendChild(RSS_URL);
		var RssServerUrl = LFD.addNode(LFDObject,'RssServerUrl', true, RSSPropertiesObj.RssServerUrl, true, 'type', 'String', 'time', '0');
		Element.appendChild(RssServerUrl);
	
		var RssServerWorkTarget = LFD.addNode(LFDObject,'RssServerWorkTarget', false, RSSPropertiesObj.RssServerWorkTarget, true, 'type', 'String', 'time', '0');
		Element.appendChild(RssServerWorkTarget);

		var RssServerPort = LFD.addNode(LFDObject,'RssServerPort', false, RSSPropertiesObj.RssServerPort, true, 'type', 'Number', 'time', '0');
		Element.appendChild(RssServerPort);
	
		var PositionX = LFD.addNode(LFDObject,'PositionX', false, RSSPropertiesObj.PositionX, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionX);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, RSSPropertiesObj.PositionY, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionY);
	
		var FillOpacity = LFD.addNode(LFDObject,'FillOpacity', false, RSSPropertiesObj.FillOpacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FillOpacity);

		var Width = LFD.addNode(LFDObject,'Width', false, RSSPropertiesObj.Width, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Width);
	
		var TextDirection = LFD.addNode(LFDObject,'TextDirection', false, RSSPropertiesObj.TextDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(TextDirection);

		var TextSpeed = LFD.addNode(LFDObject,'TextSpeed', false, RSSPropertiesObj.TextSpeed, true, 'type', 'Number', 'time', '0');
		Element.appendChild(TextSpeed);
	
		var Height = LFD.addNode(LFDObject,'Height', false, RSSPropertiesObj.Height, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, RSSPropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);
	
		var titleTextFontName = LFD.addNode(LFDObject,'titleTextFontName', false, RSSPropertiesObj.titleTextFontName, true, 'type', 'List', 'time', '0');
		Element.appendChild(titleTextFontName);

		var titleTextFontFile = LFD.addNode(LFDObject,'titleTextFontFile', true, RSSPropertiesObj.titleTextFontFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(titleTextFontFile);

		var titleTextFontSize = LFD.addNode(LFDObject,'titleTextFontSize', false, RSSPropertiesObj.titleTextFontSize, true, 'type', 'Number', 'time', '0');
		Element.appendChild(titleTextFontSize);

		var titleTextItalic = LFD.addNode(LFDObject,'titleTextItalic', false, RSSPropertiesObj.titleTextItalic, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(titleTextItalic);

		var titleTextBold = LFD.addNode(LFDObject,'titleTextBold', false, RSSPropertiesObj.titleTextBold, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(titleTextBold);

		var titleTextUnderLine = LFD.addNode(LFDObject,'titleTextUnderLine', false, RSSPropertiesObj.titleTextUnderLine, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(titleTextUnderLine);

		var titleTextStrikeOut = LFD.addNode(LFDObject,'titleTextStrikeOut', false, RSSPropertiesObj.titleTextStrikeOut, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(titleTextStrikeOut);

		var titleTextColor = LFD.addNode(LFDObject,'titleTextColor', false, RSSPropertiesObj.titleTextColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(titleTextColor);

		var titleTextHAlign = LFD.addNode(LFDObject,'titleTextHAlign', false, RSSPropertiesObj.titleTextHAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(titleTextHAlign);

		var pubDateTextFontName = LFD.addNode(LFDObject,'pubDateTextFontName', false, RSSPropertiesObj.pubDateTextFontName, true, 'type', 'List', 'time', '0');
		Element.appendChild(pubDateTextFontName);

		var pubDateTextFontFile = LFD.addNode(LFDObject,'pubDateTextFontFile', true, RSSPropertiesObj.pubDateTextFontFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(pubDateTextFontFile);

		var pubDateTextFontSize = LFD.addNode(LFDObject,'pubDateTextFontSize', false, RSSPropertiesObj.pubDateTextFontSize, true, 'type', 'Number', 'time', '0');
		Element.appendChild(pubDateTextFontSize);

		var pubDateTextItalic = LFD.addNode(LFDObject,'pubDateTextItalic', false, RSSPropertiesObj.pubDateTextItalic, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(pubDateTextItalic);

		var pubDateTextBold = LFD.addNode(LFDObject,'pubDateTextBold', false, RSSPropertiesObj.pubDateTextBold, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(pubDateTextBold);

		var pubDateTextUnderLine = LFD.addNode(LFDObject,'pubDateTextUnderLine', false, RSSPropertiesObj.pubDateTextUnderLine, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(pubDateTextUnderLine);

		var pubDateTextStrikeOut = LFD.addNode(LFDObject,'pubDateTextStrikeOut', false, RSSPropertiesObj.pubDateTextStrikeOut, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(pubDateTextStrikeOut);

		var pubDateTextColor = LFD.addNode(LFDObject,'pubDateTextColor', false, RSSPropertiesObj.pubDateTextColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(pubDateTextColor);

		var pubDateTextHAlign = LFD.addNode(LFDObject,'pubDateTextHAlign', false, RSSPropertiesObj.pubDateTextHAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(pubDateTextHAlign);

		var descriptionTextFontName = LFD.addNode(LFDObject,'descriptionTextFontName', false, RSSPropertiesObj.descriptionTextFontName, true, 'type', 'List', 'time', '0');
		Element.appendChild(descriptionTextFontName);

		var descriptionTextFontFile = LFD.addNode(LFDObject,'descriptionTextFontFile', true, RSSPropertiesObj.descriptionTextFontFile, true, 'type', 'File', 'time', '0');
		Element.appendChild(descriptionTextFontFile);

		var descriptionTextFontSize = LFD.addNode(LFDObject,'descriptionTextFontSize', false, RSSPropertiesObj.descriptionTextFontSize, true, 'type', 'Number', 'time', '0');
		Element.appendChild(descriptionTextFontSize);

		var descriptionTextItalic = LFD.addNode(LFDObject,'descriptionTextItalic', false, RSSPropertiesObj.descriptionTextItalic, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(descriptionTextItalic);

		var descriptionTextBold = LFD.addNode(LFDObject,'descriptionTextBold', false, RSSPropertiesObj.descriptionTextBold, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(descriptionTextBold);

		var descriptionTextUnderLine = LFD.addNode(LFDObject,'descriptionTextUnderLine', false, RSSPropertiesObj.descriptionTextUnderLine, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(descriptionTextUnderLine);

		var descriptionTextStrikeOut = LFD.addNode(LFDObject,'descriptionTextStrikeOut', false, RSSPropertiesObj.descriptionTextStrikeOut, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(descriptionTextStrikeOut);

		var descriptionTextColor = LFD.addNode(LFDObject,'descriptionTextColor', false, RSSPropertiesObj.descriptionTextColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(descriptionTextColor);

		var descriptionTextHAlign = LFD.addNode(LFDObject,'descriptionTextHAlign', false, RSSPropertiesObj.descriptionTextHAlign, true, 'type', 'List', 'time', '0');
		Element.appendChild(descriptionTextHAlign);

		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, RSSPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, RSSPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, RSSPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, RSSPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, RSSPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, RSSPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, RSSPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, RSSPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, RSSPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, RSSPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, RSSPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);

		var NewsDisplayOption = LFD.addNode(LFDObject,'NewsDisplayOption', false, RSSPropertiesObj.NewsDisplayOption, true, 'type', 'List', 'time', '0');
		Element.appendChild(NewsDisplayOption);

		var RSS_URL = LFD.addNode(LFDObject,'RSS_URL', true, RSSPropertiesObj.RSS_URL, true, 'type', 'String', 'time', '0');
		Element.appendChild(RSS_URL);

		var DISPLAY_CYCLE = LFD.addNode(LFDObject,'DISPLAY_CYCLE', false, RSSPropertiesObj.DISPLAY_CYCLE, true, 'type', 'Number', 'time', '0');
		Element.appendChild(DISPLAY_CYCLE);

		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, RSSPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, RSSPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, RSSPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, RSSPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, RSSPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, RSSPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, RSSPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, RSSPropertiesObj.EffectOutDuration, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, RSSPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, RSSPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, RSSPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);


		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
		
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
	}
};






/*
*	Function to Delete Element
*/

LFD.deleteElement = function(LFDObject, PageNum, ElementType, TypeID, ElementName)
{
	xmlElem = LFDObject.getElementsByTagName("Page")[PageNum];
	elem =  xmlElem.getElementsByTagName('Element');
	for(var count = 0; count < elem.length; count++)
	{
		if(elem[count].getAttribute('type')==ElementType && elem[count].getAttribute('typeid')==TypeID)
		{
			var y = elem[count];
			var x = y.getElementsByTagName("Name")[0];
			var t = x.getElementsByTagName("KeyFrame")[0];
			var	u=t.childNodes[0];
			if(ElementName != "" && u.nodeValue == ElementName)
			{
				//console.log("Wanakam!!!");
				var z=elem[count].parentNode;
				//delete the node from the parent.
				z.removeChild(elem[count]);
				break;
			}
			
		}
		
	}	
};

LFD.deletePage = function(LFDObject, PageNum)
{/*
	//Note: Page 0 is not allowed to delete as observed in the MagicInfo Author
	if(PageNum>0 && PageNum!=undefined)
	{
              // Anubhav Code START
		var pageLength = LFDObject.getElementsByTagName("Page").length;
		for(var i=0;i<pageLength;i++)
		{
			xmlPage = LFDObject.getElementsByTagName("Page")[i];
			if(getParseIntInDec(xmlPage.getAttribute('index')) == PageNum)
			{
				console.log("pageLength"+getParseIntInDec(xmlPage.getAttribute('index')));

				var z=xmlPage.parentNode;
				//delete the node from the parent.
				z.removeChild(xmlPage);
				break;
			}
		}
               // Anubhav Code END
	}
*/},

LFD.modifyContent = function(LFDObject, ElementObj, Type, PageNum, ElementName)
{
	console.log("Inside modifyContent");
	var xmlElem = LFDObject.getElementsByTagName("Page")[PageNum];
	if(xmlElem != undefined)
	{
		elem =  xmlElem.getElementsByTagName('Element');
		for(var count = 0; count < elem.length; count++)
		{
			if(elem[count].getAttribute('type')!="" && elem[count].getAttribute('type')!=undefined)
			{
				var tempNode = elem[count];
				
				x=tempNode.getElementsByTagName("Name")[0];
				y=x.getElementsByTagName("KeyFrame")[0];
				z=y.childNodes[0];
				if(z.nodeValue==ElementName)
				{
					$.each(ElementObj, function(key, value){
						x=tempNode.getElementsByTagName(key)[0];
						if(x!=undefined)
						{
							//Node exists
							y=x.getElementsByTagName("KeyFrame")[0];
							z=y.childNodes[0];
							z.nodeValue = value;
						}
						
					});
					break;
				}
				
			}		
		}
	}
};
//Function to Modify LFD 
LFD.modifyLFD = function(LFDObject, LFDPropertiesObj){
	console.log("Inside modifyLFD");
	$.each(LFDPropertiesObj, function(key, value){
		
		if(key=='FileID')
		{
			x = LFDObject.getElementsByTagName('FileID')[0];
			p = x.childNodes[0];
			p.nodeValue = value;
		}
		else
		{
			x = LFDObject.getElementsByTagName(key)[0];
			if(x!=undefined)
			{
				y=x.childNodes[0];
				t=x.getElementsByTagName("KeyFrame")[0];
				if(t!=undefined)
				{
			
					z=t.childNodes[0];
					z.nodeValue = value;
				}
				else
				{
					x.nodeValue = value;
				}
			}
			else
			{
				q =LFDObject.getElementsByTagName("Content")[0];
				var o = q.getAttribute(key);
				if(o!="" && o!=undefined)
				{
					q.setAttribute(key, value);
				}
			}
		}
	});
};
LFD.modifyPage = function(LFDObject, PageObj, PageNum)
{
	console.log("Inside modifyPage");
	var xmlElem = LFDObject.getElementsByTagName("Page")[PageNum];
	$.each(PageObj, function(key, value){
		
		
		x=xmlElem.getElementsByTagName(key)[0];
		
		if(x!=undefined)
		{
			//Node exists
			y=x.getElementsByTagName("KeyFrame")[0];
			if(y!=undefined)
			{
				z=y.childNodes[0];
				z.nodeValue = value;
			}
			
		
		}
	});
};
/*

LFD.modifyContent = function(LFDObject, ElementObj, Type, PageNum, ElementName)
{
	
	if(LFDObject!=undefined && typeof(LFDObject)=='object')
	{
		xmlElem = LFDObject.getElementsByTagName("Page")[PageNum];
		elem =  xmlElem.getElementsByTagName('Element');

		switch(Type)
		{
			case 'Image':
			{
			
				for(var count = 0; count < elem.length; count++)
				{
					console.log("Modify Element Type:"+elem[count].getAttribute('type'));
					//if(elem[count].getAttribute('type')==ElementObj.Type && elem[count].getAttribute('typeid')==ElementObj.TypeID)
					if(elem[count].getAttribute('type')=='Image')
					{
						var tempNode = elem[count];
						
						x=tempNode.getElementsByTagName("Name")[0];
						y=x.getElementsByTagName("KeyFrame")[0];
						z=y.childNodes[0];
						//z.nodeValue = 800;
						txt=z.nodeValue;
						//console.log("txt======="+txt+"=="+ElementName);
						////console.log("y"+(new XMLSerializer()).serializeToString(x)+"txt"+txt);
				
						$.each(ElementObj, function(key, value){
							x=tempNode.getElementsByTagName(key)[0];
							if(x!=undefined)
							{
								//Node exists
								y=x.getElementsByTagName("KeyFrame")[0];
								z=y.childNodes[0];
								z.nodeValue = value;
								//txt=z.nodeValue;
								////console.log("key==value::"+key+"=="+value+"=="+txt);
							}
							else
							{
								//Check for attribute
								////console.log("tempNode"+(new XMLSerializer()).serializeToString(tempNode));
								//a = tempNode.getAttribute(key);
								////console.log("Attribute=="+key+"=="+a+"=="+(new XMLSerializer()).serializeToString(x));
								////console.log("Attribute=="+key+"=="+a+"=="+x);
							}
							
						});
						break;
					}		
				}	
				break;
			}
			case 'Video':
			{
				for(var count = 0; count < elem.length; count++)
				{
					console.log("Modify Element Type:"+elem[count].getAttribute('type'));
					//if(elem[count].getAttribute('type')==ElementObj.Type && elem[count].getAttribute('typeid')==ElementObj.TypeID)
					if(elem[count].getAttribute('type')=='Video')
					{
						var tempNode = elem[count];
									
						$.each(ElementObj, function(key, value){
							x=tempNode.getElementsByTagName(key)[0];
							if(x!=undefined)
							{
								//Node exists
								y=x.getElementsByTagName("KeyFrame")[0];
								z=y.childNodes[0];
								z.nodeValue = value;
								
							}
							else
							{
								
							}
							
						});
						break;
					}		
				}	
				break;
			}
			case 'Text':
			{
				for(var count = 0; count < elem.length; count++)
				{
					console.log("Modify Element Type:"+elem[count].getAttribute('type'));
					if(elem[count].getAttribute('type')=='Text')
					{
						var tempNode = elem[count];
						$.each(ElementObj, function(key, value){
							x=tempNode.getElementsByTagName(key)[0];
							if(x!=undefined)
							{
								//Node exists
								y=x.getElementsByTagName("KeyFrame")[0];
								z=y.childNodes[0];
								z.nodeValue = value;
							}
							else
							{
								
							}
							
						});
						break;
					}		
				}	
				break;
			}
			case 'Office':
			{
				for(var count = 0; count < elem.length; count++)
				{
					console.log("Modify Element Type:"+elem[count].getAttribute('type'));
					if(elem[count].getAttribute('type')=='Office')
					{
						var tempNode = elem[count];
						$.each(ElementObj, function(key, value){
							x=tempNode.getElementsByTagName(key)[0];
							if(x!=undefined)
							{
								//Node exists
								y=x.getElementsByTagName("KeyFrame")[0];
								z=y.childNodes[0];
								z.nodeValue = value;
							}
							else
							{
								
							}
							
						});
						break;
					}		
				}	
				break;
			}
			case 'Flash':
			{
				for(var count = 0; count < elem.length; count++)
				{
					console.log("Modify Element Type:"+elem[count].getAttribute('type'));
					if(elem[count].getAttribute('type')=='Flash')
					{
						var tempNode = elem[count];
						$.each(ElementObj, function(key, value){
							x=tempNode.getElementsByTagName(key)[0];
							if(x!=undefined)
							{
								//Node exists
								y=x.getElementsByTagName("KeyFrame")[0];
								z=y.childNodes[0];
								z.nodeValue = value;
								
							}
							else
							{
								
							}
							
						});
						break;
					}		
				}	
				break;
			}
			case 'Sound':
			{
				for(var count = 0; count < elem.length; count++)
				{
					if(elem[count].getAttribute('type')=='Sound')
					{
						var tempNode = elem[count];
									
						$.each(ElementObj, function(key, value){
							x=tempNode.getElementsByTagName(key)[0];
							if(x!=undefined)
							{
								//Node exists
								y=x.getElementsByTagName("KeyFrame")[0];
								z=y.childNodes[0];
								z.nodeValue = value;
								
							}
							else
							{
								
							}
							
						});
						break;
					}		
				}	
				break;
			}
			default:
			{
				//Do nothing
				break;
			}
		}
	}
}
*/
// Add Shapes

LFD.addShapes = function(shapetype,LFDObject, PageNum, ShapesPropertiesObj,addToGrp,GrpCount)
{	
	//console.log("Inside addShape");
	log.debug("FunctionIn: LFD.addShapes");
	var pageCount = LFDObject.getElementsByTagName("Page").length;
	if(pageCount>0 && PageNum<pageCount)
	{

		var Element = LFDObject.createElement("Element");
		ElemAttr1 = LFDObject.createAttribute("type");
		ElemAttr1.nodeValue = ShapesPropertiesObj.typeName;
		Element.setAttributeNode(ElemAttr1);
		ElemAttr2 = LFDObject.createAttribute("typeid");
		ElemAttr2.nodeValue = shapeInfoMapping[shapetype].typeid;
		Element.setAttributeNode(ElemAttr2);
		var Name = LFD.addNode(LFDObject,'Name', true, ShapesPropertiesObj.Name, true, 'type', 'String', 'time', '0');
		Element.appendChild(Name);
	
	if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
	/*		var FileName = LFD.addNode(LFDObject,'FileName', true, ShapesPropertiesObj.FileName, true, 'type', 'String', 'time', '0');
			Element.appendChild(FileName);
			var OriginalPath = LFD.addNode(LFDObject,'OriginalPath', true, ShapesPropertiesObj.OriginalPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(OriginalPath);
			var ThumbPath = LFD.addNode(LFDObject,'ThumbPath', true, ShapesPropertiesObj.ThumbPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(ThumbPath);*/
			var frameId = LFD.addNode(LFDObject,'frameId', true, ShapesPropertiesObj.frameId, true, 'type', 'Number', 'time', '0');
			Element.appendChild(frameId);
			var thumbPath = LFD.addNode(LFDObject,'thumbPath', true, ShapesPropertiesObj.thumbPath, true, 'type', 'String', 'time', '0');
			Element.appendChild(thumbPath);
			var OriginalImage = LFD.addNode(LFDObject,'OriginalImage', true, ShapesPropertiesObj.OriginalImage, true, 'type', 'String', 'time', '0');
			Element.appendChild(OriginalImage);
			var scale = LFD.addNode(LFDObject,'scale', false, ShapesPropertiesObj.scale, true, 'type', 'RealNumber', 'time', '0');
			Element.appendChild(scale);
			var thumbOrgH = LFD.addNode(LFDObject,'thumbOrgH', false, ShapesPropertiesObj.thumbOrgH, true, 'type', 'RealNumber', 'time', '0');
			Element.appendChild(thumbOrgH);
			var thumbOrgW = LFD.addNode(LFDObject,'thumbOrgW', false, ShapesPropertiesObj.thumbOrgW, true, 'type', 'RealNumber', 'time', '0');
			Element.appendChild(thumbOrgW);
			
			
		}
		/*if(deviceType == "iPhone" || deviceType == "iPad"){
			if(templateFlag == SAVE_TEMPLATE || templateFlag == SAVE_AND_SCHEDULE_TEMPLATE){
				var assetInfo = LFD.addNode(LFDObject,'assetInfo', true, ShapesPropertiesObj.assetInfo, true, 'type', 'String', 'time', '0');
				Element.appendChild(assetInfo);
			}
        }*/
       
        addSpecificParaToLFDfromCont (shapetype,Element,LFDObject,ShapesPropertiesObj);
       
       	var MotionPathPoints = LFD.addNode(LFDObject,'MotionPathPoints', true, ShapesPropertiesObj.MotionPathPoints, true, 'type', 'String', 'time', '0');
		Element.appendChild(MotionPathPoints);
		
		var Layer = LFD.addNode(LFDObject,'Layer', false, ShapesPropertiesObj.Layer, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Layer);

		var PinnedPointNameList = LFD.addNode(LFDObject,'PinnedPointNameList', true, ShapesPropertiesObj.PinnedPointNameList, true, 'type', 'MultilineString', 'time', '0');
		Element.appendChild(PinnedPointNameList);

		var GlobalElement = LFD.addNode(LFDObject,'GlobalElement', false, ShapesPropertiesObj.GlobalElement, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(GlobalElement);

		var PositionX = LFD.addNode(LFDObject,'PositionX', false, ShapesPropertiesObj.PositionX, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionX);
		
		var FigureStrokeOpacity = LFD.addNode(LFDObject,'FigureStrokeOpacity', false, ShapesPropertiesObj.FigureStrokeOpacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FigureStrokeOpacity);

		var PositionY = LFD.addNode(LFDObject,'PositionY', false, ShapesPropertiesObj.PositionY, true, 'type', 'Number', 'time', '0');
		Element.appendChild(PositionY);

		var Width = LFD.addNode(LFDObject,'Width', false, ShapesPropertiesObj.Width, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Width);

		var Height = LFD.addNode(LFDObject,'Height', false, ShapesPropertiesObj.Height, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Height);

		var Rotation = LFD.addNode(LFDObject,'Rotation', false, ShapesPropertiesObj.Rotation, true, 'type', 'Number', 'time', '0');
		Element.appendChild(Rotation);
		
		var LineColor = LFD.addNode(LFDObject,'LineColor', false, ShapesPropertiesObj.LineColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(LineColor);
		
		var FigureStrokeWidth = LFD.addNode(LFDObject,'FigureStrokeWidth', false, ShapesPropertiesObj.FigureStrokeWidth, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FigureStrokeWidth);
		
		var FigureStrokePattern = LFD.addNode(LFDObject,'FigureStrokePattern', false, ShapesPropertiesObj.FigureStrokePattern, true, 'type', 'List', 'time', '0');
		Element.appendChild(FigureStrokePattern);
		
		var FigureGrFillMode = LFD.addNode(LFDObject,'FigureGrFillMode', false, ShapesPropertiesObj.FigureGrFillMode, true, 'type', 'List', 'time', '0');
		Element.appendChild(FigureGrFillMode);
		
		var FigureGrLineDirection = LFD.addNode(LFDObject,'FigureGrLineDirection', false, ShapesPropertiesObj.FigureGrLineDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(FigureGrLineDirection);

		var OrginalWidth = LFD.addNode(LFDObject,'OrginalWidth', false, ShapesPropertiesObj.OrginalWidth, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OrginalWidth);
		
		var FigureGrPathDirection = LFD.addNode(LFDObject,'FigureGrPathDirection', false, ShapesPropertiesObj.FigureGrPathDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(FigureGrPathDirection);

		var OriginalHeight = LFD.addNode(LFDObject,'OriginalHeight', false, ShapesPropertiesObj.OriginalHeight, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OriginalHeight);
		
		var FillColor = LFD.addNode(LFDObject,'FillColor', false, ShapesPropertiesObj.FillColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FillColor);
		
		var FigureGrStartColor = LFD.addNode(LFDObject,'FigureGrStartColor', false, ShapesPropertiesObj.FigureGrStartColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FigureGrStartColor);

		var ClipLeft = LFD.addNode(LFDObject,'ClipLeft', false, ShapesPropertiesObj.ClipLeft, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipLeft);

		var ClipRight = LFD.addNode(LFDObject,'ClipRight', false, ShapesPropertiesObj.ClipRight, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipRight);
		
		var FigureGrEndColor = LFD.addNode(LFDObject,'FigureGrEndColor', false, ShapesPropertiesObj.FigureGrEndColor, true, 'type', 'Color', 'time', '0');
		Element.appendChild(FigureGrEndColor);

		var ClipTop = LFD.addNode(LFDObject,'ClipTop', false, ShapesPropertiesObj.ClipTop, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipTop);
		
		var FillOpacity = LFD.addNode(LFDObject,'FillOpacity', false, ShapesPropertiesObj.FillOpacity, true, 'type', 'Number', 'time', '0');
		Element.appendChild(FillOpacity);
	
		var ClipBottom = LFD.addNode(LFDObject,'ClipBottom', false, ShapesPropertiesObj.ClipBottom, true, 'type', 'RealNumber', 'time', '0');
		Element.appendChild(ClipBottom);
		
		var FillRange = LFD.addNode(LFDObject,'FillRange', false, ShapesPropertiesObj.FillRange, true, 'type', 'List', 'time', '0');
		Element.appendChild(FillRange);
		
		var OffsetLeft = LFD.addNode(LFDObject,'OffsetLeft', false, ShapesPropertiesObj.OffsetLeft, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OffsetLeft);
		
		var OffsetRight = LFD.addNode(LFDObject,'OffsetRight', false, ShapesPropertiesObj.OffsetRight, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OffsetRight);
		
		var OffsetTop = LFD.addNode(LFDObject,'OffsetTop', false, ShapesPropertiesObj.OffsetTop, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OffsetTop);
		
		var OffsetBottom = LFD.addNode(LFDObject,'OffsetBottom', false, ShapesPropertiesObj.OffsetBottom, true, 'type', 'Number', 'time', '0');
		Element.appendChild(OffsetBottom);
		
		var ImageFilePath = LFD.addNode(LFDObject,'ImageFilePath', true, ShapesPropertiesObj.ImageFilePath, true, 'type', 'File', 'time', '0');
		Element.appendChild(ImageFilePath);
		
		var ImageRatio = LFD.addNode(LFDObject,'ImageRatio', false, 0, true, 'type', 'List', 'time', '0');
		Element.appendChild(ImageRatio);
		
		var Reflection = LFD.addNode(LFDObject,'Reflection', false, ShapesPropertiesObj.Reflection, true, 'type', 'List', 'time', '0');
		Element.appendChild(Reflection);
		
		var IsVisible = LFD.addNode(LFDObject,'IsVisible', false, ShapesPropertiesObj.IsVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(IsVisible);
		
		var WindowMode = LFD.addNode(LFDObject,'WindowMode', false, ShapesPropertiesObj.WindowMode, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(WindowMode);

		var GlobalDisplayPriority = LFD.addNode(LFDObject,'GlobalDisplayPriority', false, ShapesPropertiesObj.GlobalDisplayPriority, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalDisplayPriority);

		var GlobalPlayPolicy = LFD.addNode(LFDObject,'GlobalPlayPolicy', false, ShapesPropertiesObj.GlobalPlayPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(GlobalPlayPolicy);

		var DurationPolicy = LFD.addNode(LFDObject,'DurationPolicy', false, ShapesPropertiesObj.DurationPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(DurationPolicy);

		var Start = LFD.addNode(LFDObject,'Start', false, ShapesPropertiesObj.Start, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Start);

		var Duration = LFD.addNode(LFDObject,'Duration', false, ShapesPropertiesObj.Duration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(Duration);

		var RepeatPeriod = LFD.addNode(LFDObject,'RepeatPeriod', false, ShapesPropertiesObj.RepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatPeriod);

		var RepeatEnd = LFD.addNode(LFDObject,'RepeatEnd', false, ShapesPropertiesObj.RepeatEnd, true, 'type', 'Time', 'time', '0');
		Element.appendChild(RepeatEnd);

		var InterpolationType = LFD.addNode(LFDObject,'InterpolationType', false, ShapesPropertiesObj.InterpolationType, true, 'type', 'List', 'time', '0');
		Element.appendChild(InterpolationType);

		var EventEnable = LFD.addNode(LFDObject,'EventEnable', false, ShapesPropertiesObj.EventEnable, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(EventEnable);
		
		var EffectInName = LFD.addNode(LFDObject,'EffectInName', false, ShapesPropertiesObj.EffectInName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInName);

		var EffectInDuration = LFD.addNode(LFDObject,'EffectInDuration', false, ShapesPropertiesObj.EffectInDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInDuration);

		var EffectInDirection = LFD.addNode(LFDObject,'EffectInDirection', false, ShapesPropertiesObj.EffectInDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInDirection);

		var EffectInRepeatPolicy = LFD.addNode(LFDObject,'EffectInRepeatPolicy', false, ShapesPropertiesObj.EffectInRepeatPolicy, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectInRepeatPolicy);

		var EffectInRepeatPeriod = LFD.addNode(LFDObject,'EffectInRepeatPeriod', false, ShapesPropertiesObj.EffectInRepeatPeriod, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectInRepeatPeriod);

		var EffectInRepeatCount = LFD.addNode(LFDObject,'EffectInRepeatCount', false, ShapesPropertiesObj.EffectInRepeatCount, true, 'type', 'Number', 'time', '0');
		Element.appendChild(EffectInRepeatCount);

		var EffectOutName = LFD.addNode(LFDObject,'EffectOutName', false, ShapesPropertiesObj.EffectOutName, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutName);

		var EffectOutDuration = LFD.addNode(LFDObject,'EffectOutDuration', false, ShapesPropertiesObj.EffectOutDuration, true, 'type', 'Time', 'time', '0');
		Element.appendChild(EffectOutDuration);

		var EffectOutDirection = LFD.addNode(LFDObject,'EffectOutDirection', false, ShapesPropertiesObj.EffectOutDirection, true, 'type', 'List', 'time', '0');
		Element.appendChild(EffectOutDirection);

		var AuthorAreaFix = LFD.addNode(LFDObject,'AuthorAreaFix', false, ShapesPropertiesObj.AuthorAreaFix, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorAreaFix);

		var AuthorPreView = LFD.addNode(LFDObject,'AuthorPreView', false, ShapesPropertiesObj.AuthorPreView, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(AuthorPreView);

		var DesignCanvasVisible = LFD.addNode(LFDObject,'DesignCanvasVisible', false, ShapesPropertiesObj.DesignCanvasVisible, true, 'type', 'Boolean', 'time', '0');
		Element.appendChild(DesignCanvasVisible);
		
		var EventItems = LFD.addNode(LFDObject,'EventItems', false, '', false, '', '', '', '');
		Element.appendChild(EventItems);
	
		addElementToGrpPage(LFDObject,addToGrp,GrpCount,PageNum,Element);
	}
	else
	{
		console.log("Invalid Page Number provided.");
		return false;
	}
	log.debug("FunctionOut: LFD.addShapes");
};